/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 92;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 64,
  Feature_HasRCPC_IMMOBit = 84,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 63,
  Feature_HasSHA3Bit = 62,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 91,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 81,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 75,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 44,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 41,
  Feature_HasSVE2SHA3Bit = 90,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 56,
  Feature_HasSMEBit = 50,
  Feature_HasSMEF64F64Bit = 52,
  Feature_HasSMEI16I64Bit = 55,
  Feature_HasSME2andIsNonStreamingSafeBit = 59,
  Feature_HasSME2Bit = 58,
  Feature_HasSME2p1Bit = 61,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 47,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 42,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 48,
  Feature_HasLUTBit = 49,
  Feature_HasSME_LUTv2Bit = 60,
  Feature_HasSMEF8F16Bit = 53,
  Feature_HasSMEF8F32Bit = 51,
  Feature_HasCMPBRBit = 82,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 46,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 57,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 45,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 54,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 72,
  Feature_HasRCPCBit = 83,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 89,
  Feature_HasMatMulFP64Bit = 43,
  Feature_HasLS64Bit = 79,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 80,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 70,
  Feature_IsBEBit = 76,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 74,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 87,
  Feature_UseSVEFPLD1RBit = 86,
  Feature_UseLDAPURBit = 85,
  Feature_AllowMisalignedMemAccessesBit = 88,
  Feature_NotForCodeSizeBit = 73,
  Feature_UseSTRQroBit = 71,
  Feature_TailCallX16X17Bit = 66,
  Feature_TailCallX17Bit = 77,
  Feature_TailCallNotX16Bit = 78,
  Feature_TailCallAnyBit = 65,
  Feature_SLSBLRMitigationBit = 69,
  Feature_NoSLSBLRMitigationBit = 68,
  Feature_OptimizedGISelOrOtherSelectorBit = 67,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(841), /*)*//*default:*//*Label 157*/ GIMT_Encode4(405420),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3162),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(34665),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(48013),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(49842),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(49924), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(50006),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(57752),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(69799), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(75738), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(83262), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(93206),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(93697),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(94188),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(94456),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(94606),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(95097), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(95130),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(103940),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(104990), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(107959), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(121485),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(122836),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(123828),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(124820),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(126312), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(127804),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(128796),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(129788),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(130780),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(131772),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(132764),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(133756), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(134461),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(135166), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(135871), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 35*/ GIMT_Encode4(135922),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 36*/ GIMT_Encode4(245655), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 37*/ GIMT_Encode4(255911),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 38*/ GIMT_Encode4(256201),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 39*/ GIMT_Encode4(257638),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 40*/ GIMT_Encode4(257758), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 41*/ GIMT_Encode4(257999),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 42*/ GIMT_Encode4(259897),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 43*/ GIMT_Encode4(261551),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 44*/ GIMT_Encode4(264330),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 45*/ GIMT_Encode4(265110),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 46*/ GIMT_Encode4(265503), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 47*/ GIMT_Encode4(266279),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 48*/ GIMT_Encode4(266409), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 49*/ GIMT_Encode4(266902), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(271478), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(272523),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(273007),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(273491),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(273921),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(274351),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(274781), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(275211),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(277009),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(277747),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(281843), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(298116), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(298732),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(302239),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(302487),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(302675),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(303738),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(304801),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(309198),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 69*/ GIMT_Encode4(312973),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 70*/ GIMT_Encode4(313293),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(313613), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 72*/ GIMT_Encode4(314470),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 73*/ GIMT_Encode4(314752),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 74*/ GIMT_Encode4(315130),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 75*/ GIMT_Encode4(315508),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 76*/ GIMT_Encode4(315858),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 77*/ GIMT_Encode4(316208),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 78*/ GIMT_Encode4(316911), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 79*/ GIMT_Encode4(317614),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 80*/ GIMT_Encode4(318018),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 81*/ GIMT_Encode4(318422),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 82*/ GIMT_Encode4(318826),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 83*/ GIMT_Encode4(319230),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 84*/ GIMT_Encode4(320045),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 85*/ GIMT_Encode4(320211),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 86*/ GIMT_Encode4(320310), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 87*/ GIMT_Encode4(320326),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 88*/ GIMT_Encode4(325338),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 89*/ GIMT_Encode4(352735), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 90*/ GIMT_Encode4(355653), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 91*/ GIMT_Encode4(357359), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 92*/ GIMT_Encode4(357511), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 93*/ GIMT_Encode4(358185),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 94*/ GIMT_Encode4(358345),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(358659),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 96*/ GIMT_Encode4(358813), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 97*/ GIMT_Encode4(359304),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 98*/ GIMT_Encode4(359604),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 99*/ GIMT_Encode4(360095),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 100*/ GIMT_Encode4(360586), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 101*/ GIMT_Encode4(361077),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 102*/ GIMT_Encode4(362203),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 103*/ GIMT_Encode4(362819),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 104*/ GIMT_Encode4(366541), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(367157),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 106*/ GIMT_Encode4(382764), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 107*/ GIMT_Encode4(383064),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 108*/ GIMT_Encode4(383078),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 109*/ GIMT_Encode4(383099), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 110*/ GIMT_Encode4(383124), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 111*/ GIMT_Encode4(383434),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 112*/ GIMT_Encode4(383605),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 113*/ GIMT_Encode4(383776),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 114*/ GIMT_Encode4(383947),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 115*/ GIMT_Encode4(384118), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 116*/ GIMT_Encode4(385247),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 117*/ GIMT_Encode4(385450),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 118*/ GIMT_Encode4(385653),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 119*/ GIMT_Encode4(385856), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3010 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 120*/ GIMT_Encode4(386059), GIMT_Encode4(0),
     /*   3018 */ /*AArch64::G_BSP*//*Label 121*/ GIMT_Encode4(386199),
     /*   3022 */ /*AArch64::G_DUP*//*Label 122*/ GIMT_Encode4(386739),
     /*   3026 */ /*AArch64::G_DUPLANE16*//*Label 123*/ GIMT_Encode4(388562),
     /*   3030 */ /*AArch64::G_DUPLANE32*//*Label 124*/ GIMT_Encode4(388817),
     /*   3034 */ /*AArch64::G_DUPLANE64*//*Label 125*/ GIMT_Encode4(389072),
     /*   3038 */ /*AArch64::G_DUPLANE8*//*Label 126*/ GIMT_Encode4(389218),
     /*   3042 */ /*AArch64::G_EXT*//*Label 127*/ GIMT_Encode4(389397),
     /*   3046 */ /*AArch64::G_FCMEQ*//*Label 128*/ GIMT_Encode4(391047),
     /*   3050 */ /*AArch64::G_FCMEQZ*//*Label 129*/ GIMT_Encode4(391386),
     /*   3054 */ /*AArch64::G_FCMGE*//*Label 130*/ GIMT_Encode4(391616),
     /*   3058 */ /*AArch64::G_FCMGEZ*//*Label 131*/ GIMT_Encode4(392280),
     /*   3062 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(392510),
     /*   3066 */ /*AArch64::G_FCMGTZ*//*Label 133*/ GIMT_Encode4(393174),
     /*   3070 */ /*AArch64::G_FCMLEZ*//*Label 134*/ GIMT_Encode4(393404),
     /*   3074 */ /*AArch64::G_FCMLTZ*//*Label 135*/ GIMT_Encode4(393634),
     /*   3078 */ /*AArch64::G_REV16*//*Label 136*/ GIMT_Encode4(393864),
     /*   3082 */ /*AArch64::G_REV32*//*Label 137*/ GIMT_Encode4(394018),
     /*   3086 */ /*AArch64::G_REV64*//*Label 138*/ GIMT_Encode4(394194),
     /*   3090 */ /*AArch64::G_SADDLP*//*Label 139*/ GIMT_Encode4(394468),
     /*   3094 */ /*AArch64::G_SADDLV*//*Label 140*/ GIMT_Encode4(394674),
     /*   3098 */ /*AArch64::G_SDOT*//*Label 141*/ GIMT_Encode4(395073),
     /*   3102 */ /*AArch64::G_SITOF*//*Label 142*/ GIMT_Encode4(395443),
     /*   3106 */ /*AArch64::G_SMULL*//*Label 143*/ GIMT_Encode4(395560),
     /*   3110 */ /*AArch64::G_TRN1*//*Label 144*/ GIMT_Encode4(396793),
     /*   3114 */ /*AArch64::G_TRN2*//*Label 145*/ GIMT_Encode4(397573),
     /*   3118 */ /*AArch64::G_UADDLP*//*Label 146*/ GIMT_Encode4(398353),
     /*   3122 */ /*AArch64::G_UADDLV*//*Label 147*/ GIMT_Encode4(398559),
     /*   3126 */ /*AArch64::G_UDOT*//*Label 148*/ GIMT_Encode4(399426),
     /*   3130 */ /*AArch64::G_UITOF*//*Label 149*/ GIMT_Encode4(399796),
     /*   3134 */ /*AArch64::G_UMULL*//*Label 150*/ GIMT_Encode4(399913),
     /*   3138 */ /*AArch64::G_UZP1*//*Label 151*/ GIMT_Encode4(401146),
     /*   3142 */ /*AArch64::G_UZP2*//*Label 152*/ GIMT_Encode4(401926),
     /*   3146 */ /*AArch64::G_VASHR*//*Label 153*/ GIMT_Encode4(402706),
     /*   3150 */ /*AArch64::G_VLSHR*//*Label 154*/ GIMT_Encode4(403404),
     /*   3154 */ /*AArch64::G_ZIP1*//*Label 155*/ GIMT_Encode4(403860),
     /*   3158 */ /*AArch64::G_ZIP2*//*Label 156*/ GIMT_Encode4(404640),
     /*   3162 */ // Label 0: @3162
     /*   3162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 171*/ GIMT_Encode4(34664),
     /*   3173 */ /*GILLT_s32*//*Label 158*/ GIMT_Encode4(3261),
     /*   3177 */ /*GILLT_s64*//*Label 159*/ GIMT_Encode4(4784), GIMT_Encode4(0),
     /*   3185 */ /*GILLT_v2s32*//*Label 160*/ GIMT_Encode4(9876),
     /*   3189 */ /*GILLT_v2s64*//*Label 161*/ GIMT_Encode4(13484),
     /*   3193 */ /*GILLT_v4s16*//*Label 162*/ GIMT_Encode4(19386),
     /*   3197 */ /*GILLT_v4s32*//*Label 163*/ GIMT_Encode4(22884),
     /*   3201 */ /*GILLT_v8s8*//*Label 164*/ GIMT_Encode4(29062),
     /*   3205 */ /*GILLT_v8s16*//*Label 165*/ GIMT_Encode4(29912),
     /*   3209 */ /*GILLT_v16s8*//*Label 166*/ GIMT_Encode4(33490), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3229 */ /*GILLT_nxv2s64*//*Label 167*/ GIMT_Encode4(34214), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3241 */ /*GILLT_nxv4s32*//*Label 168*/ GIMT_Encode4(34586), GIMT_Encode4(0),
     /*   3249 */ /*GILLT_nxv8s16*//*Label 169*/ GIMT_Encode4(34612), GIMT_Encode4(0),
     /*   3257 */ /*GILLT_nxv16s8*//*Label 170*/ GIMT_Encode4(34638),
     /*   3261 */ // Label 158: @3261
     /*   3261 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4783),
     /*   3266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3272 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3305), // Rule ID 12999 //
     /*   3277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3292 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3303 */     GIR_RootConstrainSelectedInstOperands,
     /*   3304 */     // GIR_Coverage, 12999,
     /*   3304 */     GIR_EraseRootFromParent_Done,
     /*   3305 */   // Label 173: @3305
     /*   3305 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3457), // Rule ID 13426 //
     /*   3310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3337 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3340 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3345 */     // MIs[2] pattern
     /*   3345 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3348 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3359 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3429 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3439 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3456 */     // GIR_Coverage, 13426,
     /*   3456 */     GIR_EraseRootFromParent_Done,
     /*   3457 */   // Label 174: @3457
     /*   3457 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3609), // Rule ID 15283 //
     /*   3462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3489 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3492 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3497 */     // MIs[2] pattern
     /*   3497 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3500 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3511 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3511 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3514 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3518 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3525 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3528 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3532 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3537 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3540 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3544 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3547 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3591 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3608 */     // GIR_Coverage, 15283,
     /*   3608 */     GIR_EraseRootFromParent_Done,
     /*   3609 */   // Label 175: @3609
     /*   3609 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(3761), // Rule ID 15295 //
     /*   3614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3641 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3644 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3649 */     // MIs[2] pattern
     /*   3649 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3652 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3663 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3663 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3666 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3670 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3689 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3692 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3696 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3704 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3709 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3743 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3760 */     // GIR_Coverage, 15295,
     /*   3760 */     GIR_EraseRootFromParent_Done,
     /*   3761 */   // Label 176: @3761
     /*   3761 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(3913), // Rule ID 15307 //
     /*   3766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3793 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3796 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   3801 */     // MIs[2] pattern
     /*   3801 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3804 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3815 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3815 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3818 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3822 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3841 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3848 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   3873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3912 */     // GIR_Coverage, 15307,
     /*   3912 */     GIR_EraseRootFromParent_Done,
     /*   3913 */   // Label 177: @3913
     /*   3913 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(3946), // Rule ID 91 //
     /*   3918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3933 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3944 */     GIR_RootConstrainSelectedInstOperands,
     /*   3945 */     // GIR_Coverage, 91,
     /*   3945 */     GIR_EraseRootFromParent_Done,
     /*   3946 */   // Label 178: @3946
     /*   3946 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4098), // Rule ID 2647 //
     /*   3951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3982 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3985 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3990 */     // MIs[2] pattern
     /*   3990 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3993 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4000 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4080 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4097 */     // GIR_Coverage, 2647,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 179: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4250), // Rule ID 9842 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4134 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4137 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4142 */     // MIs[2] pattern
     /*   4142 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4145 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4152 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4178 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4185 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4232 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4249 */     // GIR_Coverage, 9842,
     /*   4249 */     GIR_EraseRootFromParent_Done,
     /*   4250 */   // Label 180: @4250
     /*   4250 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4402), // Rule ID 9854 //
     /*   4255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4286 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4289 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4294 */     // MIs[2] pattern
     /*   4294 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4297 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4304 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4304 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4307 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4311 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4330 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4337 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4384 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4401 */     // GIR_Coverage, 9854,
     /*   4401 */     GIR_EraseRootFromParent_Done,
     /*   4402 */   // Label 181: @4402
     /*   4402 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4554), // Rule ID 9866 //
     /*   4407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4438 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4441 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4446 */     // MIs[2] pattern
     /*   4446 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4449 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4456 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4456 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4459 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4463 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4482 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4485 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4489 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4536 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4553 */     // GIR_Coverage, 9866,
     /*   4553 */     GIR_EraseRootFromParent_Done,
     /*   4554 */   // Label 182: @4554
     /*   4554 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4587), // Rule ID 13003 //
     /*   4559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   4574 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   4574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   4577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   4585 */     GIR_RootConstrainSelectedInstOperands,
     /*   4586 */     // GIR_Coverage, 13003,
     /*   4586 */     GIR_EraseRootFromParent_Done,
     /*   4587 */   // Label 183: @4587
     /*   4587 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4623), // Rule ID 13566 //
     /*   4592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   4607 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   4610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   4621 */     GIR_RootConstrainSelectedInstOperands,
     /*   4622 */     // GIR_Coverage, 13566,
     /*   4622 */     GIR_EraseRootFromParent_Done,
     /*   4623 */   // Label 184: @4623
     /*   4623 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4656), // Rule ID 97 //
     /*   4628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   4643 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   4643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   4646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   4654 */     GIR_RootConstrainSelectedInstOperands,
     /*   4655 */     // GIR_Coverage, 97,
     /*   4655 */     GIR_EraseRootFromParent_Done,
     /*   4656 */   // Label 185: @4656
     /*   4656 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4692), // Rule ID 3874 //
     /*   4661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   4676 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   4679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   4690 */     GIR_RootConstrainSelectedInstOperands,
     /*   4691 */     // GIR_Coverage, 3874,
     /*   4691 */     GIR_EraseRootFromParent_Done,
     /*   4692 */   // Label 186: @4692
     /*   4692 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(4725), // Rule ID 13001 //
     /*   4697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   4712 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   4712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4719 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   4723 */     GIR_RootConstrainSelectedInstOperands,
     /*   4724 */     // GIR_Coverage, 13001,
     /*   4724 */     GIR_EraseRootFromParent_Done,
     /*   4725 */   // Label 187: @4725
     /*   4725 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(4758), // Rule ID 95 //
     /*   4730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   4745 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   4745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   4748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   4756 */     GIR_RootConstrainSelectedInstOperands,
     /*   4757 */     // GIR_Coverage, 95,
     /*   4757 */     GIR_EraseRootFromParent_Done,
     /*   4758 */   // Label 188: @4758
     /*   4758 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(4782), // Rule ID 93 //
     /*   4763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4775 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   4775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   4780 */     GIR_RootConstrainSelectedInstOperands,
     /*   4781 */     // GIR_Coverage, 93,
     /*   4781 */     GIR_Done,
     /*   4782 */   // Label 189: @4782
     /*   4782 */   GIM_Reject,
     /*   4783 */ // Label 172: @4783
     /*   4783 */ GIM_Reject,
     /*   4784 */ // Label 159: @4784
     /*   4784 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(9875),
     /*   4789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   4792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   4795 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(4931), // Rule ID 5324 //
     /*   4800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4833 */     // MIs[1] Operand 2
     /*   4833 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   4844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   4860 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4864 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4868 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4873 */     // MIs[3] Operand 2
     /*   4873 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   4886 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   4886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   4889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   4893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   4906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4913 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   4920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   4930 */     // GIR_Coverage, 5324,
     /*   4930 */     GIR_EraseRootFromParent_Done,
     /*   4931 */   // Label 191: @4931
     /*   4931 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5067), // Rule ID 5323 //
     /*   4936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4969 */     // MIs[1] Operand 2
     /*   4969 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   4980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   4996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5000 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5004 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5009 */     // MIs[3] Operand 2
     /*   5009 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5022 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5066 */     // GIR_Coverage, 5323,
     /*   5066 */     GIR_EraseRootFromParent_Done,
     /*   5067 */   // Label 192: @5067
     /*   5067 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5203), // Rule ID 5333 //
     /*   5072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5105 */     // MIs[1] Operand 2
     /*   5105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5136 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5140 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5145 */     // MIs[3] Operand 2
     /*   5145 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5156 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5158 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   5165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5185 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5202 */     // GIR_Coverage, 5333,
     /*   5202 */     GIR_EraseRootFromParent_Done,
     /*   5203 */   // Label 193: @5203
     /*   5203 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5339), // Rule ID 5322 //
     /*   5208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5241 */     // MIs[1] Operand 2
     /*   5241 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5268 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   5272 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5276 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5281 */     // MIs[3] Operand 2
     /*   5281 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5292 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5294 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5338 */     // GIR_Coverage, 5322,
     /*   5338 */     GIR_EraseRootFromParent_Done,
     /*   5339 */   // Label 194: @5339
     /*   5339 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5475), // Rule ID 5321 //
     /*   5344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5377 */     // MIs[1] Operand 2
     /*   5377 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5408 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5412 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5417 */     // MIs[3] Operand 2
     /*   5417 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5428 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5430 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5457 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5474 */     // GIR_Coverage, 5321,
     /*   5474 */     GIR_EraseRootFromParent_Done,
     /*   5475 */   // Label 195: @5475
     /*   5475 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5543), // Rule ID 6830 //
     /*   5480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   5509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   5513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   5521 */     // MIs[2] Rn
     /*   5521 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   5526 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   5530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5532 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   5532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   5535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5541 */     GIR_RootConstrainSelectedInstOperands,
     /*   5542 */     // GIR_Coverage, 6830,
     /*   5542 */     GIR_EraseRootFromParent_Done,
     /*   5543 */   // Label 196: @5543
     /*   5543 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5611), // Rule ID 13727 //
     /*   5548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   5577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   5581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   5589 */     // MIs[2] Rn
     /*   5589 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   5594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   5598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5600 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   5600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   5603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5609 */     GIR_RootConstrainSelectedInstOperands,
     /*   5610 */     // GIR_Coverage, 13727,
     /*   5610 */     GIR_EraseRootFromParent_Done,
     /*   5611 */   // Label 197: @5611
     /*   5611 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5644), // Rule ID 13000 //
     /*   5616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   5631 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   5631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   5634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   5642 */     GIR_RootConstrainSelectedInstOperands,
     /*   5643 */     // GIR_Coverage, 13000,
     /*   5643 */     GIR_EraseRootFromParent_Done,
     /*   5644 */   // Label 198: @5644
     /*   5644 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5777), // Rule ID 3926 //
     /*   5649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   5681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5686 */     // MIs[2] Operand 2
     /*   5686 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   5697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5705 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   5709 */     // MIs[3] Operand 1
     /*   5709 */     // No operand predicates
     /*   5709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5715 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   5718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5727 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   5734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5746 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   5752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   5765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   5773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5775 */     GIR_RootConstrainSelectedInstOperands,
     /*   5776 */     // GIR_Coverage, 3926,
     /*   5776 */     GIR_EraseRootFromParent_Done,
     /*   5777 */   // Label 199: @5777
     /*   5777 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(5872), // Rule ID 3924 //
     /*   5782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   5814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5827 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   5831 */     // MIs[3] Operand 1
     /*   5831 */     // No operand predicates
     /*   5831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5837 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5849 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   5859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5870 */     GIR_RootConstrainSelectedInstOperands,
     /*   5871 */     // GIR_Coverage, 3924,
     /*   5871 */     GIR_EraseRootFromParent_Done,
     /*   5872 */   // Label 200: @5872
     /*   5872 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(5967), // Rule ID 3925 //
     /*   5877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   5909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   5926 */     // MIs[3] Operand 1
     /*   5926 */     // No operand predicates
     /*   5926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5932 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5944 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   5954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5965 */     GIR_RootConstrainSelectedInstOperands,
     /*   5966 */     // GIR_Coverage, 3925,
     /*   5966 */     GIR_EraseRootFromParent_Done,
     /*   5967 */   // Label 201: @5967
     /*   5967 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6000), // Rule ID 92 //
     /*   5972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   5987 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   5987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   5990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   5998 */     GIR_RootConstrainSelectedInstOperands,
     /*   5999 */     // GIR_Coverage, 92,
     /*   5999 */     GIR_EraseRootFromParent_Done,
     /*   6000 */   // Label 202: @6000
     /*   6000 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6133), // Rule ID 13576 //
     /*   6005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   6041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6046 */     // MIs[2] Operand 2
     /*   6046 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   6057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6065 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   6069 */     // MIs[3] Operand 1
     /*   6069 */     // No operand predicates
     /*   6069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6071 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   6074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6083 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   6090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6102 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   6108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6131 */     GIR_RootConstrainSelectedInstOperands,
     /*   6132 */     // GIR_Coverage, 13576,
     /*   6132 */     GIR_EraseRootFromParent_Done,
     /*   6133 */   // Label 203: @6133
     /*   6133 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6228), // Rule ID 13574 //
     /*   6138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6187 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   6191 */     // MIs[3] Operand 1
     /*   6191 */     // No operand predicates
     /*   6191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6193 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6205 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6226 */     GIR_RootConstrainSelectedInstOperands,
     /*   6227 */     // GIR_Coverage, 13574,
     /*   6227 */     GIR_EraseRootFromParent_Done,
     /*   6228 */   // Label 204: @6228
     /*   6228 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6323), // Rule ID 13575 //
     /*   6233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   6286 */     // MIs[3] Operand 1
     /*   6286 */     // No operand predicates
     /*   6286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6288 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6300 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6321 */     GIR_RootConstrainSelectedInstOperands,
     /*   6322 */     // GIR_Coverage, 13575,
     /*   6322 */     GIR_EraseRootFromParent_Done,
     /*   6323 */   // Label 205: @6323
     /*   6323 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(6405), // Rule ID 13011 //
     /*   6328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6388 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   6403 */     GIR_RootConstrainSelectedInstOperands,
     /*   6404 */     // GIR_Coverage, 13011,
     /*   6404 */     GIR_EraseRootFromParent_Done,
     /*   6405 */   // Label 206: @6405
     /*   6405 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(6487), // Rule ID 13012 //
     /*   6410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6470 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   6485 */     GIR_RootConstrainSelectedInstOperands,
     /*   6486 */     // GIR_Coverage, 13012,
     /*   6486 */     GIR_EraseRootFromParent_Done,
     /*   6487 */   // Label 207: @6487
     /*   6487 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6569), // Rule ID 123 //
     /*   6492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6541 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6552 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6567 */     GIR_RootConstrainSelectedInstOperands,
     /*   6568 */     // GIR_Coverage, 123,
     /*   6568 */     GIR_EraseRootFromParent_Done,
     /*   6569 */   // Label 208: @6569
     /*   6569 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6651), // Rule ID 125 //
     /*   6574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6634 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6649 */     GIR_RootConstrainSelectedInstOperands,
     /*   6650 */     // GIR_Coverage, 125,
     /*   6650 */     GIR_EraseRootFromParent_Done,
     /*   6651 */   // Label 209: @6651
     /*   6651 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6709), // Rule ID 13421 //
     /*   6656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6671 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6674 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   6679 */     // MIs[1] pattern
     /*   6679 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6682 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6693 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   6696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6707 */     GIR_RootConstrainSelectedInstOperands,
     /*   6708 */     // GIR_Coverage, 13421,
     /*   6708 */     GIR_EraseRootFromParent_Done,
     /*   6709 */   // Label 210: @6709
     /*   6709 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6767), // Rule ID 15278 //
     /*   6714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6729 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6732 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   6737 */     // MIs[1] pattern
     /*   6737 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6740 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6751 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   6754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6765 */     GIR_RootConstrainSelectedInstOperands,
     /*   6766 */     // GIR_Coverage, 15278,
     /*   6766 */     GIR_EraseRootFromParent_Done,
     /*   6767 */   // Label 211: @6767
     /*   6767 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6825), // Rule ID 15290 //
     /*   6772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6787 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6790 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   6795 */     // MIs[1] pattern
     /*   6795 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6798 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6809 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   6812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6823 */     GIR_RootConstrainSelectedInstOperands,
     /*   6824 */     // GIR_Coverage, 15290,
     /*   6824 */     GIR_EraseRootFromParent_Done,
     /*   6825 */   // Label 212: @6825
     /*   6825 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(6883), // Rule ID 15302 //
     /*   6830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6845 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6848 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   6853 */     // MIs[1] pattern
     /*   6853 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6856 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6867 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   6870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6881 */     GIR_RootConstrainSelectedInstOperands,
     /*   6882 */     // GIR_Coverage, 15302,
     /*   6882 */     GIR_EraseRootFromParent_Done,
     /*   6883 */   // Label 213: @6883
     /*   6883 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(6941), // Rule ID 2644 //
     /*   6888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6907 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6910 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   6915 */     // MIs[1] pattern
     /*   6915 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6918 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6925 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   6928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   6932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6939 */     GIR_RootConstrainSelectedInstOperands,
     /*   6940 */     // GIR_Coverage, 2644,
     /*   6940 */     GIR_EraseRootFromParent_Done,
     /*   6941 */   // Label 214: @6941
     /*   6941 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(6999), // Rule ID 9839 //
     /*   6946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6965 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6968 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   6973 */     // MIs[1] pattern
     /*   6973 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6976 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6983 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   6986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6997 */     GIR_RootConstrainSelectedInstOperands,
     /*   6998 */     // GIR_Coverage, 9839,
     /*   6998 */     GIR_EraseRootFromParent_Done,
     /*   6999 */   // Label 215: @6999
     /*   6999 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(7057), // Rule ID 9851 //
     /*   7004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   7007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   7023 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   7026 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   7031 */     // MIs[1] pattern
     /*   7031 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   7034 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   7039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7041 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   7041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   7044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   7046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   7048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   7052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   7055 */     GIR_RootConstrainSelectedInstOperands,
     /*   7056 */     // GIR_Coverage, 9851,
     /*   7056 */     GIR_EraseRootFromParent_Done,
     /*   7057 */   // Label 216: @7057
     /*   7057 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(7115), // Rule ID 9863 //
     /*   7062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   7065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   7081 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   7084 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   7089 */     // MIs[1] pattern
     /*   7089 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   7092 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   7097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7099 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   7099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   7102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   7104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   7106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   7110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 9863,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 217: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(7278), // Rule ID 13693 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   7144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7162 */     // MIs[1] Operand 2
     /*   7162 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7179 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7205 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   7212 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   7237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7242 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   7253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7260 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7277 */     // GIR_Coverage, 13693,
     /*   7277 */     GIR_EraseRootFromParent_Done,
     /*   7278 */   // Label 218: @7278
     /*   7278 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(7441), // Rule ID 13690 //
     /*   7283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   7307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7325 */     // MIs[1] Operand 2
     /*   7325 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7342 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7342 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7345 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7349 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7368 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   7375 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7383 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   7400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7405 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   7416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7440 */     // GIR_Coverage, 13690,
     /*   7440 */     GIR_EraseRootFromParent_Done,
     /*   7441 */   // Label 219: @7441
     /*   7441 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(7591), // Rule ID 13699 //
     /*   7446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7479 */     // MIs[1] Operand 2
     /*   7479 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7496 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   7554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7590 */     // GIR_Coverage, 13699,
     /*   7590 */     GIR_EraseRootFromParent_Done,
     /*   7591 */   // Label 220: @7591
     /*   7591 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(7741), // Rule ID 13702 //
     /*   7596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7629 */     // MIs[1] Operand 2
     /*   7629 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7646 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7740 */     // GIR_Coverage, 13702,
     /*   7740 */     GIR_EraseRootFromParent_Done,
     /*   7741 */   // Label 221: @7741
     /*   7741 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(7891), // Rule ID 13698 //
     /*   7746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7779 */     // MIs[1] Operand 2
     /*   7779 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7796 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7796 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7799 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7803 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7810 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7817 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7822 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7825 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7829 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   7854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7873 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7890 */     // GIR_Coverage, 13698,
     /*   7890 */     GIR_EraseRootFromParent_Done,
     /*   7891 */   // Label 222: @7891
     /*   7891 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8054), // Rule ID 5306 //
     /*   7896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   7924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7942 */     // MIs[1] Operand 2
     /*   7942 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7955 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7955 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7958 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7962 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7969 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7972 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7976 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7981 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7984 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   7988 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8036 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8053 */     // GIR_Coverage, 5306,
     /*   8053 */     GIR_EraseRootFromParent_Done,
     /*   8054 */   // Label 223: @8054
     /*   8054 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8217), // Rule ID 5303 //
     /*   8059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8105 */     // MIs[1] Operand 2
     /*   8105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8118 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8118 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8121 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8125 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8144 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8147 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   8151 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8181 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8216 */     // GIR_Coverage, 5303,
     /*   8216 */     GIR_EraseRootFromParent_Done,
     /*   8217 */   // Label 224: @8217
     /*   8217 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8367), // Rule ID 5330 //
     /*   8222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8259 */     // MIs[1] Operand 2
     /*   8259 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8272 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8272 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8275 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8279 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8298 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8301 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8305 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8313 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   8330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8366 */     // GIR_Coverage, 5330,
     /*   8366 */     GIR_EraseRootFromParent_Done,
     /*   8367 */   // Label 225: @8367
     /*   8367 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8517), // Rule ID 5336 //
     /*   8372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8409 */     // MIs[1] Operand 2
     /*   8409 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8422 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8422 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8425 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8429 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8436 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8439 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8443 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8448 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8458 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8463 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   8480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8499 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8516 */     // GIR_Coverage, 5336,
     /*   8516 */     GIR_EraseRootFromParent_Done,
     /*   8517 */   // Label 226: @8517
     /*   8517 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8667), // Rule ID 5329 //
     /*   8522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8559 */     // MIs[1] Operand 2
     /*   8559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8572 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8572 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8575 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8579 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8586 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8589 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8593 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8598 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8601 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8605 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8608 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8618 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   8630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8666 */     // GIR_Coverage, 5329,
     /*   8666 */     GIR_EraseRootFromParent_Done,
     /*   8667 */   // Label 227: @8667
     /*   8667 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(8700), // Rule ID 13004 //
     /*   8672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*   8687 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*   8687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*   8690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   8698 */     GIR_RootConstrainSelectedInstOperands,
     /*   8699 */     // GIR_Coverage, 13004,
     /*   8699 */     GIR_EraseRootFromParent_Done,
     /*   8700 */   // Label 228: @8700
     /*   8700 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(8736), // Rule ID 13567 //
     /*   8705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*   8720 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   8720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*   8723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   8731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   8734 */     GIR_RootConstrainSelectedInstOperands,
     /*   8735 */     // GIR_Coverage, 13567,
     /*   8735 */     GIR_EraseRootFromParent_Done,
     /*   8736 */   // Label 229: @8736
     /*   8736 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(8769), // Rule ID 98 //
     /*   8741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*   8756 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*   8756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*   8759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   8767 */     GIR_RootConstrainSelectedInstOperands,
     /*   8768 */     // GIR_Coverage, 98,
     /*   8768 */     GIR_EraseRootFromParent_Done,
     /*   8769 */   // Label 230: @8769
     /*   8769 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(8805), // Rule ID 3875 //
     /*   8774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*   8789 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   8789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*   8792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   8800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   8803 */     GIR_RootConstrainSelectedInstOperands,
     /*   8804 */     // GIR_Coverage, 3875,
     /*   8804 */     GIR_EraseRootFromParent_Done,
     /*   8805 */   // Label 231: @8805
     /*   8805 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(8838), // Rule ID 13002 //
     /*   8810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*   8825 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*   8825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*   8828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   8836 */     GIR_RootConstrainSelectedInstOperands,
     /*   8837 */     // GIR_Coverage, 13002,
     /*   8837 */     GIR_EraseRootFromParent_Done,
     /*   8838 */   // Label 232: @8838
     /*   8838 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(8871), // Rule ID 96 //
     /*   8843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*   8858 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*   8858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*   8861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   8869 */     GIR_RootConstrainSelectedInstOperands,
     /*   8870 */     // GIR_Coverage, 96,
     /*   8870 */     GIR_EraseRootFromParent_Done,
     /*   8871 */   // Label 233: @8871
     /*   8871 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(8927), // Rule ID 13110 //
     /*   8876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8891 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8894 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*   8899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8914 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   8914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   8917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   8921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   8925 */     GIR_RootConstrainSelectedInstOperands,
     /*   8926 */     // GIR_Coverage, 13110,
     /*   8926 */     GIR_EraseRootFromParent_Done,
     /*   8927 */   // Label 234: @8927
     /*   8927 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(8983), // Rule ID 13122 //
     /*   8932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8947 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8950 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*   8955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8970 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   8970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   8973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   8977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   8981 */     GIR_RootConstrainSelectedInstOperands,
     /*   8982 */     // GIR_Coverage, 13122,
     /*   8982 */     GIR_EraseRootFromParent_Done,
     /*   8983 */   // Label 235: @8983
     /*   8983 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(9050), // Rule ID 13328 //
     /*   8988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9012 */     // MIs[1] imm
     /*   9012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9024 */     // MIs[2] Operand 1
     /*   9024 */     // No operand predicates
     /*   9024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9034 */     // (add:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9048 */     GIR_RootConstrainSelectedInstOperands,
     /*   9049 */     // GIR_Coverage, 13328,
     /*   9049 */     GIR_EraseRootFromParent_Done,
     /*   9050 */   // Label 236: @9050
     /*   9050 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(9117), // Rule ID 13716 //
     /*   9055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9079 */     // MIs[1] imm
     /*   9079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9091 */     // MIs[2] Operand 1
     /*   9091 */     // No operand predicates
     /*   9091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9101 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9115 */     GIR_RootConstrainSelectedInstOperands,
     /*   9116 */     // GIR_Coverage, 13716,
     /*   9116 */     GIR_EraseRootFromParent_Done,
     /*   9117 */   // Label 237: @9117
     /*   9117 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(9184), // Rule ID 13331 //
     /*   9122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9146 */     // MIs[1] imm
     /*   9146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9158 */     // MIs[2] Operand 1
     /*   9158 */     // No operand predicates
     /*   9158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9168 */     // (add:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9182 */     GIR_RootConstrainSelectedInstOperands,
     /*   9183 */     // GIR_Coverage, 13331,
     /*   9183 */     GIR_EraseRootFromParent_Done,
     /*   9184 */   // Label 238: @9184
     /*   9184 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(9251), // Rule ID 13719 //
     /*   9189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9213 */     // MIs[1] imm
     /*   9213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9225 */     // MIs[2] Operand 1
     /*   9225 */     // No operand predicates
     /*   9225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9235 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9249 */     GIR_RootConstrainSelectedInstOperands,
     /*   9250 */     // GIR_Coverage, 13719,
     /*   9250 */     GIR_EraseRootFromParent_Done,
     /*   9251 */   // Label 239: @9251
     /*   9251 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(9307), // Rule ID 990 //
     /*   9256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   9275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   9278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*   9283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9294 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   9305 */     GIR_RootConstrainSelectedInstOperands,
     /*   9306 */     // GIR_Coverage, 990,
     /*   9306 */     GIR_EraseRootFromParent_Done,
     /*   9307 */   // Label 240: @9307
     /*   9307 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(9363), // Rule ID 1051 //
     /*   9312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   9331 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   9334 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*   9339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9350 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   9361 */     GIR_RootConstrainSelectedInstOperands,
     /*   9362 */     // GIR_Coverage, 1051,
     /*   9362 */     GIR_EraseRootFromParent_Done,
     /*   9363 */   // Label 241: @9363
     /*   9363 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(9430), // Rule ID 2112 //
     /*   9368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9396 */     // MIs[1] imm
     /*   9396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9408 */     // MIs[2] Operand 1
     /*   9408 */     // No operand predicates
     /*   9408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9414 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9428 */     GIR_RootConstrainSelectedInstOperands,
     /*   9429 */     // GIR_Coverage, 2112,
     /*   9429 */     GIR_EraseRootFromParent_Done,
     /*   9430 */   // Label 242: @9430
     /*   9430 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(9497), // Rule ID 6208 //
     /*   9435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9463 */     // MIs[1] imm
     /*   9463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9475 */     // MIs[2] Operand 1
     /*   9475 */     // No operand predicates
     /*   9475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9481 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9495 */     GIR_RootConstrainSelectedInstOperands,
     /*   9496 */     // GIR_Coverage, 6208,
     /*   9496 */     GIR_EraseRootFromParent_Done,
     /*   9497 */   // Label 243: @9497
     /*   9497 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(9564), // Rule ID 2121 //
     /*   9502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9530 */     // MIs[1] imm
     /*   9530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9542 */     // MIs[2] Operand 1
     /*   9542 */     // No operand predicates
     /*   9542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9548 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9562 */     GIR_RootConstrainSelectedInstOperands,
     /*   9563 */     // GIR_Coverage, 2121,
     /*   9563 */     GIR_EraseRootFromParent_Done,
     /*   9564 */   // Label 244: @9564
     /*   9564 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(9631), // Rule ID 6214 //
     /*   9569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9597 */     // MIs[1] imm
     /*   9597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9609 */     // MIs[2] Operand 1
     /*   9609 */     // No operand predicates
     /*   9609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9615 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9629 */     GIR_RootConstrainSelectedInstOperands,
     /*   9630 */     // GIR_Coverage, 6214,
     /*   9630 */     GIR_EraseRootFromParent_Done,
     /*   9631 */   // Label 245: @9631
     /*   9631 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(9679), // Rule ID 13109 //
     /*   9636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*   9651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9666 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9677 */     GIR_RootConstrainSelectedInstOperands,
     /*   9678 */     // GIR_Coverage, 13109,
     /*   9678 */     GIR_EraseRootFromParent_Done,
     /*   9679 */   // Label 246: @9679
     /*   9679 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(9727), // Rule ID 13121 //
     /*   9684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*   9699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9714 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9725 */     GIR_RootConstrainSelectedInstOperands,
     /*   9726 */     // GIR_Coverage, 13121,
     /*   9726 */     GIR_EraseRootFromParent_Done,
     /*   9727 */   // Label 247: @9727
     /*   9727 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(9775), // Rule ID 989 //
     /*   9732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*   9751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9762 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9773 */     GIR_RootConstrainSelectedInstOperands,
     /*   9774 */     // GIR_Coverage, 989,
     /*   9774 */     GIR_EraseRootFromParent_Done,
     /*   9775 */   // Label 248: @9775
     /*   9775 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(9823), // Rule ID 1050 //
     /*   9780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*   9799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9810 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9821 */     GIR_RootConstrainSelectedInstOperands,
     /*   9822 */     // GIR_Coverage, 1050,
     /*   9822 */     GIR_EraseRootFromParent_Done,
     /*   9823 */   // Label 249: @9823
     /*   9823 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(9847), // Rule ID 94 //
     /*   9828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9840 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*   9840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*   9845 */     GIR_RootConstrainSelectedInstOperands,
     /*   9846 */     // GIR_Coverage, 94,
     /*   9846 */     GIR_Done,
     /*   9847 */   // Label 250: @9847
     /*   9847 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(9874), // Rule ID 1600 //
     /*   9852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9867 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*   9867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*   9872 */     GIR_RootConstrainSelectedInstOperands,
     /*   9873 */     // GIR_Coverage, 1600,
     /*   9873 */     GIR_Done,
     /*   9874 */   // Label 251: @9874
     /*   9874 */   GIM_Reject,
     /*   9875 */ // Label 190: @9875
     /*   9875 */ GIM_Reject,
     /*   9876 */ // Label 160: @9876
     /*   9876 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(13483),
     /*   9881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9887 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(10075), // Rule ID 6851 //
     /*   9892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*   9904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9929 */     // MIs[2] Operand 2
     /*   9929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*   9940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   9944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9948 */     // MIs[3] Rn
     /*   9948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9953 */     // MIs[3] Operand 2
     /*   9953 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*   9964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   9968 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*   9972 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9976 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9980 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9984 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9988 */     // MIs[5] Rn
     /*   9988 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9993 */     // MIs[5] Operand 2
     /*   9993 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  10004 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  10008 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10012 */     // MIs[6] Rn
     /*  10012 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10017 */     // MIs[6] Operand 2
     /*  10017 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  10028 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10030 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  10030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  10033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  10037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10074 */     // GIR_Coverage, 6851,
     /*  10074 */     GIR_EraseRootFromParent_Done,
     /*  10075 */   // Label 253: @10075
     /*  10075 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(10263), // Rule ID 13738 //
     /*  10080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  10092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10117 */     // MIs[2] Operand 2
     /*  10117 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  10128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  10132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10136 */     // MIs[3] Rn
     /*  10136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10141 */     // MIs[3] Operand 2
     /*  10141 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  10152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  10156 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  10160 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10164 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10168 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10172 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10176 */     // MIs[5] Rn
     /*  10176 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10181 */     // MIs[5] Operand 2
     /*  10181 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  10192 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  10196 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10200 */     // MIs[6] Rn
     /*  10200 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10205 */     // MIs[6] Operand 2
     /*  10205 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  10216 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10218 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  10218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  10221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  10225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10245 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10262 */     // GIR_Coverage, 13738,
     /*  10262 */     GIR_EraseRootFromParent_Done,
     /*  10263 */   // Label 254: @10263
     /*  10263 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(10399), // Rule ID 5320 //
     /*  10268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10301 */     // MIs[1] Operand 2
     /*  10301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10324 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10328 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10332 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10336 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10341 */     // MIs[3] Operand 2
     /*  10341 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10354 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10398 */     // GIR_Coverage, 5320,
     /*  10398 */     GIR_EraseRootFromParent_Done,
     /*  10399 */   // Label 255: @10399
     /*  10399 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(10535), // Rule ID 5319 //
     /*  10404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10437 */     // MIs[1] Operand 2
     /*  10437 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10456 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10460 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10464 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10468 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10472 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10477 */     // MIs[3] Operand 2
     /*  10477 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10490 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10517 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10534 */     // GIR_Coverage, 5319,
     /*  10534 */     GIR_EraseRootFromParent_Done,
     /*  10535 */   // Label 256: @10535
     /*  10535 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(10671), // Rule ID 5332 //
     /*  10540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10573 */     // MIs[1] Operand 2
     /*  10573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10592 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10596 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10600 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10604 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10608 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10613 */     // MIs[3] Operand 2
     /*  10613 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10624 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10626 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  10633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10670 */     // GIR_Coverage, 5332,
     /*  10670 */     GIR_EraseRootFromParent_Done,
     /*  10671 */   // Label 257: @10671
     /*  10671 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(10807), // Rule ID 5318 //
     /*  10676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10709 */     // MIs[1] Operand 2
     /*  10709 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10740 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10744 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10749 */     // MIs[3] Operand 2
     /*  10749 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10760 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10762 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10806 */     // GIR_Coverage, 5318,
     /*  10806 */     GIR_EraseRootFromParent_Done,
     /*  10807 */   // Label 258: @10807
     /*  10807 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(10943), // Rule ID 5317 //
     /*  10812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10845 */     // MIs[1] Operand 2
     /*  10845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10880 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10885 */     // MIs[3] Operand 2
     /*  10885 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10898 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10942 */     // GIR_Coverage, 5317,
     /*  10942 */     GIR_EraseRootFromParent_Done,
     /*  10943 */   // Label 259: @10943
     /*  10943 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11106), // Rule ID 13692 //
     /*  10948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  10972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  10980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10990 */     // MIs[1] Operand 2
     /*  10990 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11007 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11007 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11010 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11014 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11033 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  11040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  11065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11088 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11105 */     // GIR_Coverage, 13692,
     /*  11105 */     GIR_EraseRootFromParent_Done,
     /*  11106 */   // Label 260: @11106
     /*  11106 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11269), // Rule ID 13689 //
     /*  11111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  11135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11153 */     // MIs[1] Operand 2
     /*  11153 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11170 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11184 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11187 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11191 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11196 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  11203 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11206 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  11228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11268 */     // GIR_Coverage, 13689,
     /*  11268 */     GIR_EraseRootFromParent_Done,
     /*  11269 */   // Label 261: @11269
     /*  11269 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11419), // Rule ID 13697 //
     /*  11274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11307 */     // MIs[1] Operand 2
     /*  11307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11324 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11324 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11327 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11331 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11338 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11341 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11345 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11350 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11353 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11357 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  11382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11418 */     // GIR_Coverage, 13697,
     /*  11418 */     GIR_EraseRootFromParent_Done,
     /*  11419 */   // Label 262: @11419
     /*  11419 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11569), // Rule ID 13701 //
     /*  11424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11457 */     // MIs[1] Operand 2
     /*  11457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11474 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11474 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11477 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11481 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11488 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11491 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11495 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11500 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11507 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11515 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  11532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11551 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11568 */     // GIR_Coverage, 13701,
     /*  11568 */     GIR_EraseRootFromParent_Done,
     /*  11569 */   // Label 263: @11569
     /*  11569 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(11719), // Rule ID 13696 //
     /*  11574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11607 */     // MIs[1] Operand 2
     /*  11607 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11624 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11624 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11627 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11631 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11650 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11653 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11657 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11670 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  11682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11718 */     // GIR_Coverage, 13696,
     /*  11718 */     GIR_EraseRootFromParent_Done,
     /*  11719 */   // Label 264: @11719
     /*  11719 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(11882), // Rule ID 5305 //
     /*  11724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  11752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11770 */     // MIs[1] Operand 2
     /*  11770 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11783 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11783 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11786 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11790 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11809 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  11816 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11829 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  11841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11864 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11881 */     // GIR_Coverage, 5305,
     /*  11881 */     GIR_EraseRootFromParent_Done,
     /*  11882 */   // Label 265: @11882
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12045), // Rule ID 5302 //
     /*  11887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  11915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11933 */     // MIs[1] Operand 2
     /*  11933 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11946 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11972 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  11979 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11992 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12027 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12044 */     // GIR_Coverage, 5302,
     /*  12044 */     GIR_EraseRootFromParent_Done,
     /*  12045 */   // Label 266: @12045
     /*  12045 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12195), // Rule ID 5328 //
     /*  12050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12087 */     // MIs[1] Operand 2
     /*  12087 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12100 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12100 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12103 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12107 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12126 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12133 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12141 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12146 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  12158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12194 */     // GIR_Coverage, 5328,
     /*  12194 */     GIR_EraseRootFromParent_Done,
     /*  12195 */   // Label 267: @12195
     /*  12195 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12345), // Rule ID 5335 //
     /*  12200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12237 */     // MIs[1] Operand 2
     /*  12237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12250 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12276 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12283 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12296 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  12308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12327 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12344 */     // GIR_Coverage, 5335,
     /*  12344 */     GIR_EraseRootFromParent_Done,
     /*  12345 */   // Label 268: @12345
     /*  12345 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12495), // Rule ID 5327 //
     /*  12350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12387 */     // MIs[1] Operand 2
     /*  12387 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12400 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  12458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12477 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12494 */     // GIR_Coverage, 5327,
     /*  12494 */     GIR_EraseRootFromParent_Done,
     /*  12495 */   // Label 269: @12495
     /*  12495 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12564), // Rule ID 13144 //
     /*  12500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12515 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12518 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  12523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12527 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12547 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  12550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12562 */     GIR_RootConstrainSelectedInstOperands,
     /*  12563 */     // GIR_Coverage, 13144,
     /*  12563 */     GIR_EraseRootFromParent_Done,
     /*  12564 */   // Label 270: @12564
     /*  12564 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12633), // Rule ID 13156 //
     /*  12569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12584 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12587 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  12592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12596 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12616 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  12619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12631 */     GIR_RootConstrainSelectedInstOperands,
     /*  12632 */     // GIR_Coverage, 13156,
     /*  12632 */     GIR_EraseRootFromParent_Done,
     /*  12633 */   // Label 271: @12633
     /*  12633 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12689), // Rule ID 13106 //
     /*  12638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12653 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  12656 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  12661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12676 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  12676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  12679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12687 */     GIR_RootConstrainSelectedInstOperands,
     /*  12688 */     // GIR_Coverage, 13106,
     /*  12688 */     GIR_EraseRootFromParent_Done,
     /*  12689 */   // Label 272: @12689
     /*  12689 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12745), // Rule ID 13118 //
     /*  12694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12709 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  12712 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  12717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12732 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  12732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  12735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12743 */     GIR_RootConstrainSelectedInstOperands,
     /*  12744 */     // GIR_Coverage, 13118,
     /*  12744 */     GIR_EraseRootFromParent_Done,
     /*  12745 */   // Label 273: @12745
     /*  12745 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12812), // Rule ID 13348 //
     /*  12750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  12765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12774 */     // MIs[1] imm
     /*  12774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  12778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  12786 */     // MIs[2] Operand 1
     /*  12786 */     // No operand predicates
     /*  12786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  12794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12796 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  12796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  12799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  12810 */     GIR_RootConstrainSelectedInstOperands,
     /*  12811 */     // GIR_Coverage, 13348,
     /*  12811 */     GIR_EraseRootFromParent_Done,
     /*  12812 */   // Label 274: @12812
     /*  12812 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12879), // Rule ID 13369 //
     /*  12817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  12832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12841 */     // MIs[1] imm
     /*  12841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  12845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12849 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  12853 */     // MIs[2] Operand 1
     /*  12853 */     // No operand predicates
     /*  12853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  12861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12863 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  12863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  12866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  12877 */     GIR_RootConstrainSelectedInstOperands,
     /*  12878 */     // GIR_Coverage, 13369,
     /*  12878 */     GIR_EraseRootFromParent_Done,
     /*  12879 */   // Label 275: @12879
     /*  12879 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12948), // Rule ID 1358 //
     /*  12884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12903 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12906 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  12911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12915 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12931 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  12934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12946 */     GIR_RootConstrainSelectedInstOperands,
     /*  12947 */     // GIR_Coverage, 1358,
     /*  12947 */     GIR_EraseRootFromParent_Done,
     /*  12948 */   // Label 276: @12948
     /*  12948 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13017), // Rule ID 1481 //
     /*  12953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12972 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12975 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  12980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12984 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13000 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  13000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  13003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  13015 */     GIR_RootConstrainSelectedInstOperands,
     /*  13016 */     // GIR_Coverage, 1481,
     /*  13016 */     GIR_EraseRootFromParent_Done,
     /*  13017 */   // Label 277: @13017
     /*  13017 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13073), // Rule ID 986 //
     /*  13022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  13041 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  13044 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  13049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13060 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13071 */     GIR_RootConstrainSelectedInstOperands,
     /*  13072 */     // GIR_Coverage, 986,
     /*  13072 */     GIR_EraseRootFromParent_Done,
     /*  13073 */   // Label 278: @13073
     /*  13073 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13129), // Rule ID 1047 //
     /*  13078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  13097 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  13100 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  13105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13127 */     GIR_RootConstrainSelectedInstOperands,
     /*  13128 */     // GIR_Coverage, 1047,
     /*  13128 */     GIR_EraseRootFromParent_Done,
     /*  13129 */   // Label 279: @13129
     /*  13129 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(13196), // Rule ID 2229 //
     /*  13134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  13153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13162 */     // MIs[1] imm
     /*  13162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  13174 */     // MIs[2] Operand 1
     /*  13174 */     // No operand predicates
     /*  13174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  13178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13180 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  13180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  13183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  13194 */     GIR_RootConstrainSelectedInstOperands,
     /*  13195 */     // GIR_Coverage, 2229,
     /*  13195 */     GIR_EraseRootFromParent_Done,
     /*  13196 */   // Label 280: @13196
     /*  13196 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13263), // Rule ID 2288 //
     /*  13201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  13220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13229 */     // MIs[1] imm
     /*  13229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  13241 */     // MIs[2] Operand 1
     /*  13241 */     // No operand predicates
     /*  13241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  13245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13247 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  13247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  13250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  13261 */     GIR_RootConstrainSelectedInstOperands,
     /*  13262 */     // GIR_Coverage, 2288,
     /*  13262 */     GIR_EraseRootFromParent_Done,
     /*  13263 */   // Label 281: @13263
     /*  13263 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13311), // Rule ID 13105 //
     /*  13268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  13283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13298 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13309 */     GIR_RootConstrainSelectedInstOperands,
     /*  13310 */     // GIR_Coverage, 13105,
     /*  13310 */     GIR_EraseRootFromParent_Done,
     /*  13311 */   // Label 282: @13311
     /*  13311 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13359), // Rule ID 13117 //
     /*  13316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  13331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13346 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13357 */     GIR_RootConstrainSelectedInstOperands,
     /*  13358 */     // GIR_Coverage, 13117,
     /*  13358 */     GIR_EraseRootFromParent_Done,
     /*  13359 */   // Label 283: @13359
     /*  13359 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13407), // Rule ID 985 //
     /*  13364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  13383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13394 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13405 */     GIR_RootConstrainSelectedInstOperands,
     /*  13406 */     // GIR_Coverage, 985,
     /*  13406 */     GIR_EraseRootFromParent_Done,
     /*  13407 */   // Label 284: @13407
     /*  13407 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13455), // Rule ID 1046 //
     /*  13412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  13431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13442 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13453 */     GIR_RootConstrainSelectedInstOperands,
     /*  13454 */     // GIR_Coverage, 1046,
     /*  13454 */     GIR_EraseRootFromParent_Done,
     /*  13455 */   // Label 285: @13455
     /*  13455 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13482), // Rule ID 1097 //
     /*  13460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13475 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  13475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  13480 */     GIR_RootConstrainSelectedInstOperands,
     /*  13481 */     // GIR_Coverage, 1097,
     /*  13481 */     GIR_Done,
     /*  13482 */   // Label 286: @13482
     /*  13482 */   GIM_Reject,
     /*  13483 */ // Label 252: @13483
     /*  13483 */ GIM_Reject,
     /*  13484 */ // Label 161: @13484
     /*  13484 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(19385),
     /*  13489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  13492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  13495 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13613), // Rule ID 13283 //
     /*  13500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13543 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13547 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13551 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13560 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13564 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13568 */     // MIs[4] Operand 1
     /*  13568 */     // No operand predicates
     /*  13568 */     // MIs[2] Operand 2
     /*  13568 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13592 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  13595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13611 */     GIR_RootConstrainSelectedInstOperands,
     /*  13612 */     // GIR_Coverage, 13283,
     /*  13612 */     GIR_EraseRootFromParent_Done,
     /*  13613 */   // Label 288: @13613
     /*  13613 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13731), // Rule ID 13284 //
     /*  13618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13661 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13665 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13682 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13686 */     // MIs[4] Operand 1
     /*  13686 */     // No operand predicates
     /*  13686 */     // MIs[2] Operand 2
     /*  13686 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13710 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  13713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13729 */     GIR_RootConstrainSelectedInstOperands,
     /*  13730 */     // GIR_Coverage, 13284,
     /*  13730 */     GIR_EraseRootFromParent_Done,
     /*  13731 */   // Label 289: @13731
     /*  13731 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13849), // Rule ID 13313 //
     /*  13736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  13751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13783 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13792 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13796 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13800 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13804 */     // MIs[4] Operand 1
     /*  13804 */     // No operand predicates
     /*  13804 */     // MIs[2] Operand 2
     /*  13804 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13828 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  13831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13847 */     GIR_RootConstrainSelectedInstOperands,
     /*  13848 */     // GIR_Coverage, 13313,
     /*  13848 */     GIR_EraseRootFromParent_Done,
     /*  13849 */   // Label 290: @13849
     /*  13849 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13967), // Rule ID 13314 //
     /*  13854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  13869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13901 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13914 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13918 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13922 */     // MIs[4] Operand 1
     /*  13922 */     // No operand predicates
     /*  13922 */     // MIs[2] Operand 2
     /*  13922 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13937 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13946 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  13949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13965 */     GIR_RootConstrainSelectedInstOperands,
     /*  13966 */     // GIR_Coverage, 13314,
     /*  13966 */     GIR_EraseRootFromParent_Done,
     /*  13967 */   // Label 291: @13967
     /*  13967 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14085), // Rule ID 2035 //
     /*  13972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14036 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14040 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14044 */     // MIs[4] Operand 1
     /*  14044 */     // No operand predicates
     /*  14044 */     // MIs[2] Operand 2
     /*  14044 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14064 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  14067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14083 */     GIR_RootConstrainSelectedInstOperands,
     /*  14084 */     // GIR_Coverage, 2035,
     /*  14084 */     GIR_EraseRootFromParent_Done,
     /*  14085 */   // Label 292: @14085
     /*  14085 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14203), // Rule ID 13282 //
     /*  14090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14141 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14158 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14162 */     // MIs[4] Operand 1
     /*  14162 */     // No operand predicates
     /*  14162 */     // MIs[2] Operand 2
     /*  14162 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14173 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14182 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  14185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14201 */     GIR_RootConstrainSelectedInstOperands,
     /*  14202 */     // GIR_Coverage, 13282,
     /*  14202 */     GIR_EraseRootFromParent_Done,
     /*  14203 */   // Label 293: @14203
     /*  14203 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(14321), // Rule ID 2087 //
     /*  14208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  14227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14263 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14272 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14276 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14280 */     // MIs[4] Operand 1
     /*  14280 */     // No operand predicates
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14300 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  14303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14319 */     GIR_RootConstrainSelectedInstOperands,
     /*  14320 */     // GIR_Coverage, 2087,
     /*  14320 */     GIR_EraseRootFromParent_Done,
     /*  14321 */   // Label 294: @14321
     /*  14321 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(14439), // Rule ID 13312 //
     /*  14326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  14345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14377 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14381 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14390 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14394 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14398 */     // MIs[4] Operand 1
     /*  14398 */     // No operand predicates
     /*  14398 */     // MIs[2] Operand 2
     /*  14398 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14409 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14418 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14437 */     GIR_RootConstrainSelectedInstOperands,
     /*  14438 */     // GIR_Coverage, 13312,
     /*  14438 */     GIR_EraseRootFromParent_Done,
     /*  14439 */   // Label 295: @14439
     /*  14439 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(14526), // Rule ID 13188 //
     /*  14444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14471 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14474 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14483 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14507 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  14510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14524 */     GIR_RootConstrainSelectedInstOperands,
     /*  14525 */     // GIR_Coverage, 13188,
     /*  14525 */     GIR_EraseRootFromParent_Done,
     /*  14526 */   // Label 296: @14526
     /*  14526 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(14613), // Rule ID 13212 //
     /*  14531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14558 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14561 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14570 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14594 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  14597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14611 */     GIR_RootConstrainSelectedInstOperands,
     /*  14612 */     // GIR_Coverage, 13212,
     /*  14612 */     GIR_EraseRootFromParent_Done,
     /*  14613 */   // Label 297: @14613
     /*  14613 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(14700), // Rule ID 1692 //
     /*  14618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14649 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14652 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14661 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14681 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  14684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14698 */     GIR_RootConstrainSelectedInstOperands,
     /*  14699 */     // GIR_Coverage, 1692,
     /*  14699 */     GIR_EraseRootFromParent_Done,
     /*  14700 */   // Label 298: @14700
     /*  14700 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(14787), // Rule ID 1770 //
     /*  14705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14736 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14739 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14748 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14768 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  14771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14785 */     GIR_RootConstrainSelectedInstOperands,
     /*  14786 */     // GIR_Coverage, 1770,
     /*  14786 */     GIR_EraseRootFromParent_Done,
     /*  14787 */   // Label 299: @14787
     /*  14787 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(14902), // Rule ID 13278 //
     /*  14792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14835 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14839 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14843 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14856 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14860 */     // MIs[4] Operand 1
     /*  14860 */     // No operand predicates
     /*  14860 */     // MIs[2] Operand 2
     /*  14860 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  14871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14882 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  14885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14900 */     GIR_RootConstrainSelectedInstOperands,
     /*  14901 */     // GIR_Coverage, 13278,
     /*  14901 */     GIR_EraseRootFromParent_Done,
     /*  14902 */   // Label 300: @14902
     /*  14902 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15017), // Rule ID 13277 //
     /*  14907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14976 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14980 */     // MIs[4] Operand 1
     /*  14980 */     // No operand predicates
     /*  14980 */     // MIs[2] Operand 2
     /*  14980 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  14991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14995 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14997 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15015 */     GIR_RootConstrainSelectedInstOperands,
     /*  15016 */     // GIR_Coverage, 13277,
     /*  15016 */     GIR_EraseRootFromParent_Done,
     /*  15017 */   // Label 301: @15017
     /*  15017 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15132), // Rule ID 13308 //
     /*  15022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15065 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15069 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15086 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15090 */     // MIs[4] Operand 1
     /*  15090 */     // No operand predicates
     /*  15090 */     // MIs[2] Operand 2
     /*  15090 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15112 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15130 */     GIR_RootConstrainSelectedInstOperands,
     /*  15131 */     // GIR_Coverage, 13308,
     /*  15131 */     GIR_EraseRootFromParent_Done,
     /*  15132 */   // Label 302: @15132
     /*  15132 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15247), // Rule ID 13307 //
     /*  15137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15189 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15193 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15206 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15210 */     // MIs[4] Operand 1
     /*  15210 */     // No operand predicates
     /*  15210 */     // MIs[2] Operand 2
     /*  15210 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15225 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15227 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15245 */     GIR_RootConstrainSelectedInstOperands,
     /*  15246 */     // GIR_Coverage, 13307,
     /*  15246 */     GIR_EraseRootFromParent_Done,
     /*  15247 */   // Label 303: @15247
     /*  15247 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15316), // Rule ID 1794 //
     /*  15252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15299 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15314 */     GIR_RootConstrainSelectedInstOperands,
     /*  15315 */     // GIR_Coverage, 1794,
     /*  15315 */     GIR_EraseRootFromParent_Done,
     /*  15316 */   // Label 304: @15316
     /*  15316 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15385), // Rule ID 1793 //
     /*  15321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15368 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15383 */     GIR_RootConstrainSelectedInstOperands,
     /*  15384 */     // GIR_Coverage, 1793,
     /*  15384 */     GIR_EraseRootFromParent_Done,
     /*  15385 */   // Label 305: @15385
     /*  15385 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(15454), // Rule ID 1710 //
     /*  15390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  15405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  15417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15437 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15452 */     GIR_RootConstrainSelectedInstOperands,
     /*  15453 */     // GIR_Coverage, 1710,
     /*  15453 */     GIR_EraseRootFromParent_Done,
     /*  15454 */   // Label 306: @15454
     /*  15454 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(15523), // Rule ID 1792 //
     /*  15459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15506 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15521 */     GIR_RootConstrainSelectedInstOperands,
     /*  15522 */     // GIR_Coverage, 1792,
     /*  15522 */     GIR_EraseRootFromParent_Done,
     /*  15523 */   // Label 307: @15523
     /*  15523 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(15592), // Rule ID 1791 //
     /*  15528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15575 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15590 */     GIR_RootConstrainSelectedInstOperands,
     /*  15591 */     // GIR_Coverage, 1791,
     /*  15591 */     GIR_EraseRootFromParent_Done,
     /*  15592 */   // Label 308: @15592
     /*  15592 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(15707), // Rule ID 13276 //
     /*  15597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15644 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15648 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15652 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15657 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15661 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15665 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15669 */     // MIs[4] Operand 1
     /*  15669 */     // No operand predicates
     /*  15669 */     // MIs[2] Operand 2
     /*  15669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15685 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15687 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15705 */     GIR_RootConstrainSelectedInstOperands,
     /*  15706 */     // GIR_Coverage, 13276,
     /*  15706 */     GIR_EraseRootFromParent_Done,
     /*  15707 */   // Label 309: @15707
     /*  15707 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(15822), // Rule ID 2033 //
     /*  15712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15768 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15772 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15785 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15789 */     // MIs[4] Operand 1
     /*  15789 */     // No operand predicates
     /*  15789 */     // MIs[2] Operand 2
     /*  15789 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15800 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15802 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15820 */     GIR_RootConstrainSelectedInstOperands,
     /*  15821 */     // GIR_Coverage, 2033,
     /*  15821 */     GIR_EraseRootFromParent_Done,
     /*  15822 */   // Label 310: @15822
     /*  15822 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(15937), // Rule ID 13306 //
     /*  15827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15878 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15882 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15887 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15891 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15895 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15899 */     // MIs[4] Operand 1
     /*  15899 */     // No operand predicates
     /*  15899 */     // MIs[2] Operand 2
     /*  15899 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15915 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15917 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15935 */     GIR_RootConstrainSelectedInstOperands,
     /*  15936 */     // GIR_Coverage, 13306,
     /*  15936 */     GIR_EraseRootFromParent_Done,
     /*  15937 */   // Label 311: @15937
     /*  15937 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16052), // Rule ID 2085 //
     /*  15942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15998 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16002 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16015 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16019 */     // MIs[4] Operand 1
     /*  16019 */     // No operand predicates
     /*  16019 */     // MIs[2] Operand 2
     /*  16019 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16030 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16032 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16050 */     GIR_RootConstrainSelectedInstOperands,
     /*  16051 */     // GIR_Coverage, 2085,
     /*  16051 */     GIR_EraseRootFromParent_Done,
     /*  16052 */   // Label 312: @16052
     /*  16052 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16119), // Rule ID 13200 //
     /*  16057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16100 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  16103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16117 */     GIR_RootConstrainSelectedInstOperands,
     /*  16118 */     // GIR_Coverage, 13200,
     /*  16118 */     GIR_EraseRootFromParent_Done,
     /*  16119 */   // Label 313: @16119
     /*  16119 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16186), // Rule ID 13230 //
     /*  16124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16167 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  16170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16184 */     GIR_RootConstrainSelectedInstOperands,
     /*  16185 */     // GIR_Coverage, 13230,
     /*  16185 */     GIR_EraseRootFromParent_Done,
     /*  16186 */   // Label 314: @16186
     /*  16186 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16253), // Rule ID 1722 //
     /*  16191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16234 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  16237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16251 */     GIR_RootConstrainSelectedInstOperands,
     /*  16252 */     // GIR_Coverage, 1722,
     /*  16252 */     GIR_EraseRootFromParent_Done,
     /*  16253 */   // Label 315: @16253
     /*  16253 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(16320), // Rule ID 1812 //
     /*  16258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16301 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  16304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16318 */     GIR_RootConstrainSelectedInstOperands,
     /*  16319 */     // GIR_Coverage, 1812,
     /*  16319 */     GIR_EraseRootFromParent_Done,
     /*  16320 */   // Label 316: @16320
     /*  16320 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(16401), // Rule ID 13186 //
     /*  16325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16352 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16355 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16364 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16384 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  16387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16399 */     GIR_RootConstrainSelectedInstOperands,
     /*  16400 */     // GIR_Coverage, 13186,
     /*  16400 */     GIR_EraseRootFromParent_Done,
     /*  16401 */   // Label 317: @16401
     /*  16401 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(16482), // Rule ID 13210 //
     /*  16406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16433 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16436 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16445 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16465 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  16468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16480 */     GIR_RootConstrainSelectedInstOperands,
     /*  16481 */     // GIR_Coverage, 13210,
     /*  16481 */     GIR_EraseRootFromParent_Done,
     /*  16482 */   // Label 318: @16482
     /*  16482 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(16563), // Rule ID 1690 //
     /*  16487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16518 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16521 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16530 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16546 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  16549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16561 */     GIR_RootConstrainSelectedInstOperands,
     /*  16562 */     // GIR_Coverage, 1690,
     /*  16562 */     GIR_EraseRootFromParent_Done,
     /*  16563 */   // Label 319: @16563
     /*  16563 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(16644), // Rule ID 1768 //
     /*  16568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16599 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16602 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16611 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16627 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  16630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16642 */     GIR_RootConstrainSelectedInstOperands,
     /*  16643 */     // GIR_Coverage, 1768,
     /*  16643 */     GIR_EraseRootFromParent_Done,
     /*  16644 */   // Label 320: @16644
     /*  16644 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(16736), // Rule ID 13281 //
     /*  16649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16701 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16705 */     // MIs[3] Operand 1
     /*  16705 */     // No operand predicates
     /*  16705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16716 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16734 */     GIR_RootConstrainSelectedInstOperands,
     /*  16735 */     // GIR_Coverage, 13281,
     /*  16735 */     GIR_EraseRootFromParent_Done,
     /*  16736 */   // Label 321: @16736
     /*  16736 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(16828), // Rule ID 13280 //
     /*  16741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16802 */     // MIs[3] Operand 1
     /*  16802 */     // No operand predicates
     /*  16802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16808 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16826 */     GIR_RootConstrainSelectedInstOperands,
     /*  16827 */     // GIR_Coverage, 13280,
     /*  16827 */     GIR_EraseRootFromParent_Done,
     /*  16828 */   // Label 322: @16828
     /*  16828 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(16920), // Rule ID 13311 //
     /*  16833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16885 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16889 */     // MIs[3] Operand 1
     /*  16889 */     // No operand predicates
     /*  16889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16900 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16918 */     GIR_RootConstrainSelectedInstOperands,
     /*  16919 */     // GIR_Coverage, 13311,
     /*  16919 */     GIR_EraseRootFromParent_Done,
     /*  16920 */   // Label 323: @16920
     /*  16920 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17012), // Rule ID 13310 //
     /*  16925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16982 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16986 */     // MIs[3] Operand 1
     /*  16986 */     // No operand predicates
     /*  16986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16992 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17010 */     GIR_RootConstrainSelectedInstOperands,
     /*  17011 */     // GIR_Coverage, 13310,
     /*  17011 */     GIR_EraseRootFromParent_Done,
     /*  17012 */   // Label 324: @17012
     /*  17012 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17104), // Rule ID 13279 //
     /*  17017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17073 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17077 */     // MIs[3] Operand 1
     /*  17077 */     // No operand predicates
     /*  17077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17102 */     GIR_RootConstrainSelectedInstOperands,
     /*  17103 */     // GIR_Coverage, 13279,
     /*  17103 */     GIR_EraseRootFromParent_Done,
     /*  17104 */   // Label 325: @17104
     /*  17104 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17196), // Rule ID 2034 //
     /*  17109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17170 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17174 */     // MIs[3] Operand 1
     /*  17174 */     // No operand predicates
     /*  17174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17176 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17194 */     GIR_RootConstrainSelectedInstOperands,
     /*  17195 */     // GIR_Coverage, 2034,
     /*  17195 */     GIR_EraseRootFromParent_Done,
     /*  17196 */   // Label 326: @17196
     /*  17196 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17288), // Rule ID 13309 //
     /*  17201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17261 */     // MIs[3] Operand 1
     /*  17261 */     // No operand predicates
     /*  17261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17268 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17286 */     GIR_RootConstrainSelectedInstOperands,
     /*  17287 */     // GIR_Coverage, 13309,
     /*  17287 */     GIR_EraseRootFromParent_Done,
     /*  17288 */   // Label 327: @17288
     /*  17288 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(17380), // Rule ID 2086 //
     /*  17293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17358 */     // MIs[3] Operand 1
     /*  17358 */     // No operand predicates
     /*  17358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17360 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17378 */     GIR_RootConstrainSelectedInstOperands,
     /*  17379 */     // GIR_Coverage, 2086,
     /*  17379 */     GIR_EraseRootFromParent_Done,
     /*  17380 */   // Label 328: @17380
     /*  17380 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(17431), // Rule ID 13224 //
     /*  17385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17417 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17429 */     GIR_RootConstrainSelectedInstOperands,
     /*  17430 */     // GIR_Coverage, 13224,
     /*  17430 */     GIR_EraseRootFromParent_Done,
     /*  17431 */   // Label 329: @17431
     /*  17431 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(17482), // Rule ID 13194 //
     /*  17436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17468 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  17471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17480 */     GIR_RootConstrainSelectedInstOperands,
     /*  17481 */     // GIR_Coverage, 13194,
     /*  17481 */     GIR_EraseRootFromParent_Done,
     /*  17482 */   // Label 330: @17482
     /*  17482 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(17533), // Rule ID 13223 //
     /*  17487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17519 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17531 */     GIR_RootConstrainSelectedInstOperands,
     /*  17532 */     // GIR_Coverage, 13223,
     /*  17532 */     GIR_EraseRootFromParent_Done,
     /*  17533 */   // Label 331: @17533
     /*  17533 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(17584), // Rule ID 1806 //
     /*  17538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17570 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17582 */     GIR_RootConstrainSelectedInstOperands,
     /*  17583 */     // GIR_Coverage, 1806,
     /*  17583 */     GIR_EraseRootFromParent_Done,
     /*  17584 */   // Label 332: @17584
     /*  17584 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(17635), // Rule ID 1716 //
     /*  17589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17621 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  17624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17633 */     GIR_RootConstrainSelectedInstOperands,
     /*  17634 */     // GIR_Coverage, 1716,
     /*  17634 */     GIR_EraseRootFromParent_Done,
     /*  17635 */   // Label 333: @17635
     /*  17635 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(17686), // Rule ID 1805 //
     /*  17640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17672 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17684 */     GIR_RootConstrainSelectedInstOperands,
     /*  17685 */     // GIR_Coverage, 1805,
     /*  17685 */     GIR_EraseRootFromParent_Done,
     /*  17686 */   // Label 334: @17686
     /*  17686 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(17742), // Rule ID 13112 //
     /*  17691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17706 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17709 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  17714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17729 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  17732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17740 */     GIR_RootConstrainSelectedInstOperands,
     /*  17741 */     // GIR_Coverage, 13112,
     /*  17741 */     GIR_EraseRootFromParent_Done,
     /*  17742 */   // Label 335: @17742
     /*  17742 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(17798), // Rule ID 13124 //
     /*  17747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17762 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17765 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  17770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17785 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  17788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17796 */     GIR_RootConstrainSelectedInstOperands,
     /*  17797 */     // GIR_Coverage, 13124,
     /*  17797 */     GIR_EraseRootFromParent_Done,
     /*  17798 */   // Label 336: @17798
     /*  17798 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(17865), // Rule ID 13352 //
     /*  17803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  17818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17827 */     // MIs[1] imm
     /*  17827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17835 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  17839 */     // MIs[2] Operand 1
     /*  17839 */     // No operand predicates
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  17847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17849 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  17852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  17863 */     GIR_RootConstrainSelectedInstOperands,
     /*  17864 */     // GIR_Coverage, 13352,
     /*  17864 */     GIR_EraseRootFromParent_Done,
     /*  17865 */   // Label 337: @17865
     /*  17865 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(17932), // Rule ID 13373 //
     /*  17870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  17885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17894 */     // MIs[1] imm
     /*  17894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  17906 */     // MIs[2] Operand 1
     /*  17906 */     // No operand predicates
     /*  17906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  17914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17916 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  17919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  17930 */     GIR_RootConstrainSelectedInstOperands,
     /*  17931 */     // GIR_Coverage, 13373,
     /*  17931 */     GIR_EraseRootFromParent_Done,
     /*  17932 */   // Label 338: @17932
     /*  17932 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(17988), // Rule ID 992 //
     /*  17937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17956 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17959 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  17964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17975 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  17978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17986 */     GIR_RootConstrainSelectedInstOperands,
     /*  17987 */     // GIR_Coverage, 992,
     /*  17987 */     GIR_EraseRootFromParent_Done,
     /*  17988 */   // Label 339: @17988
     /*  17988 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18044), // Rule ID 1053 //
     /*  17993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  18015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  18020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18031 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  18034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18042 */     GIR_RootConstrainSelectedInstOperands,
     /*  18043 */     // GIR_Coverage, 1053,
     /*  18043 */     GIR_EraseRootFromParent_Done,
     /*  18044 */   // Label 340: @18044
     /*  18044 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(18111), // Rule ID 2233 //
     /*  18049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  18068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18077 */     // MIs[1] imm
     /*  18077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18085 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  18089 */     // MIs[2] Operand 1
     /*  18089 */     // No operand predicates
     /*  18089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  18093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18095 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  18095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  18098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  18109 */     GIR_RootConstrainSelectedInstOperands,
     /*  18110 */     // GIR_Coverage, 2233,
     /*  18110 */     GIR_EraseRootFromParent_Done,
     /*  18111 */   // Label 341: @18111
     /*  18111 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(18178), // Rule ID 2292 //
     /*  18116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  18135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18144 */     // MIs[1] imm
     /*  18144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  18156 */     // MIs[2] Operand 1
     /*  18156 */     // No operand predicates
     /*  18156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  18160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18162 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  18162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  18165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  18176 */     GIR_RootConstrainSelectedInstOperands,
     /*  18177 */     // GIR_Coverage, 2292,
     /*  18177 */     GIR_EraseRootFromParent_Done,
     /*  18178 */   // Label 342: @18178
     /*  18178 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(18248), // Rule ID 6847 //
     /*  18183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  18195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  18203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  18221 */     // MIs[2] Rn
     /*  18221 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18226 */     // MIs[2] Rm
     /*  18226 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  18231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18233 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  18233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  18236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18246 */     GIR_RootConstrainSelectedInstOperands,
     /*  18247 */     // GIR_Coverage, 6847,
     /*  18247 */     GIR_EraseRootFromParent_Done,
     /*  18248 */   // Label 343: @18248
     /*  18248 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(18318), // Rule ID 13734 //
     /*  18253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  18265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  18273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  18291 */     // MIs[2] Rn
     /*  18291 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18296 */     // MIs[2] Rm
     /*  18296 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  18301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18303 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  18303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  18306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18316 */     GIR_RootConstrainSelectedInstOperands,
     /*  18317 */     // GIR_Coverage, 13734,
     /*  18317 */     GIR_EraseRootFromParent_Done,
     /*  18318 */   // Label 344: @18318
     /*  18318 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(18381), // Rule ID 1790 //
     /*  18323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18366 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 1790,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 345: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(18444), // Rule ID 1789 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18429 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18442 */     GIR_RootConstrainSelectedInstOperands,
     /*  18443 */     // GIR_Coverage, 1789,
     /*  18443 */     GIR_EraseRootFromParent_Done,
     /*  18444 */   // Label 346: @18444
     /*  18444 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(18507), // Rule ID 1709 //
     /*  18449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18492 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  18495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18505 */     GIR_RootConstrainSelectedInstOperands,
     /*  18506 */     // GIR_Coverage, 1709,
     /*  18506 */     GIR_EraseRootFromParent_Done,
     /*  18507 */   // Label 347: @18507
     /*  18507 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18570), // Rule ID 1788 //
     /*  18512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18555 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18568 */     GIR_RootConstrainSelectedInstOperands,
     /*  18569 */     // GIR_Coverage, 1788,
     /*  18569 */     GIR_EraseRootFromParent_Done,
     /*  18570 */   // Label 348: @18570
     /*  18570 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(18633), // Rule ID 1787 //
     /*  18575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18618 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18631 */     GIR_RootConstrainSelectedInstOperands,
     /*  18632 */     // GIR_Coverage, 1787,
     /*  18632 */     GIR_EraseRootFromParent_Done,
     /*  18633 */   // Label 349: @18633
     /*  18633 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(18694), // Rule ID 13199 //
     /*  18638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18677 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  18680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18692 */     GIR_RootConstrainSelectedInstOperands,
     /*  18693 */     // GIR_Coverage, 13199,
     /*  18693 */     GIR_EraseRootFromParent_Done,
     /*  18694 */   // Label 350: @18694
     /*  18694 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(18755), // Rule ID 13229 //
     /*  18699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18738 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  18741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18753 */     GIR_RootConstrainSelectedInstOperands,
     /*  18754 */     // GIR_Coverage, 13229,
     /*  18754 */     GIR_EraseRootFromParent_Done,
     /*  18755 */   // Label 351: @18755
     /*  18755 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(18803), // Rule ID 13222 //
     /*  18760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18790 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  18793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18801 */     GIR_RootConstrainSelectedInstOperands,
     /*  18802 */     // GIR_Coverage, 13222,
     /*  18802 */     GIR_EraseRootFromParent_Done,
     /*  18803 */   // Label 352: @18803
     /*  18803 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(18851), // Rule ID 13111 //
     /*  18808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  18823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18838 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  18841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18849 */     GIR_RootConstrainSelectedInstOperands,
     /*  18850 */     // GIR_Coverage, 13111,
     /*  18850 */     GIR_EraseRootFromParent_Done,
     /*  18851 */   // Label 353: @18851
     /*  18851 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18899), // Rule ID 13193 //
     /*  18856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18886 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  18889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18897 */     GIR_RootConstrainSelectedInstOperands,
     /*  18898 */     // GIR_Coverage, 13193,
     /*  18898 */     GIR_EraseRootFromParent_Done,
     /*  18899 */   // Label 354: @18899
     /*  18899 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(18947), // Rule ID 13123 //
     /*  18904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  18919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18934 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  18937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18945 */     GIR_RootConstrainSelectedInstOperands,
     /*  18946 */     // GIR_Coverage, 13123,
     /*  18946 */     GIR_EraseRootFromParent_Done,
     /*  18947 */   // Label 355: @18947
     /*  18947 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(18995), // Rule ID 13221 //
     /*  18952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18982 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  18985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18993 */     GIR_RootConstrainSelectedInstOperands,
     /*  18994 */     // GIR_Coverage, 13221,
     /*  18994 */     GIR_EraseRootFromParent_Done,
     /*  18995 */   // Label 356: @18995
     /*  18995 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(19056), // Rule ID 1721 //
     /*  19000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19039 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  19042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19054 */     GIR_RootConstrainSelectedInstOperands,
     /*  19055 */     // GIR_Coverage, 1721,
     /*  19055 */     GIR_EraseRootFromParent_Done,
     /*  19056 */   // Label 357: @19056
     /*  19056 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(19117), // Rule ID 1811 //
     /*  19061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19100 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  19103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19115 */     GIR_RootConstrainSelectedInstOperands,
     /*  19116 */     // GIR_Coverage, 1811,
     /*  19116 */     GIR_EraseRootFromParent_Done,
     /*  19117 */   // Label 358: @19117
     /*  19117 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(19165), // Rule ID 1804 //
     /*  19122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19152 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  19155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19163 */     GIR_RootConstrainSelectedInstOperands,
     /*  19164 */     // GIR_Coverage, 1804,
     /*  19164 */     GIR_EraseRootFromParent_Done,
     /*  19165 */   // Label 359: @19165
     /*  19165 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19213), // Rule ID 991 //
     /*  19170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  19189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19200 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19211 */     GIR_RootConstrainSelectedInstOperands,
     /*  19212 */     // GIR_Coverage, 991,
     /*  19212 */     GIR_EraseRootFromParent_Done,
     /*  19213 */   // Label 360: @19213
     /*  19213 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19261), // Rule ID 1715 //
     /*  19218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19248 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  19251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19259 */     GIR_RootConstrainSelectedInstOperands,
     /*  19260 */     // GIR_Coverage, 1715,
     /*  19260 */     GIR_EraseRootFromParent_Done,
     /*  19261 */   // Label 361: @19261
     /*  19261 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19309), // Rule ID 1052 //
     /*  19266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  19285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19296 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19307 */     GIR_RootConstrainSelectedInstOperands,
     /*  19308 */     // GIR_Coverage, 1052,
     /*  19308 */     GIR_EraseRootFromParent_Done,
     /*  19309 */   // Label 362: @19309
     /*  19309 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19357), // Rule ID 1803 //
     /*  19314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19344 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  19347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19355 */     GIR_RootConstrainSelectedInstOperands,
     /*  19356 */     // GIR_Coverage, 1803,
     /*  19356 */     GIR_EraseRootFromParent_Done,
     /*  19357 */   // Label 363: @19357
     /*  19357 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19384), // Rule ID 1099 //
     /*  19362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19377 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  19377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  19382 */     GIR_RootConstrainSelectedInstOperands,
     /*  19383 */     // GIR_Coverage, 1099,
     /*  19383 */     GIR_Done,
     /*  19384 */   // Label 364: @19384
     /*  19384 */   GIM_Reject,
     /*  19385 */ // Label 287: @19385
     /*  19385 */ GIM_Reject,
     /*  19386 */ // Label 162: @19386
     /*  19386 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(22883),
     /*  19391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  19394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  19397 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19533), // Rule ID 5316 //
     /*  19402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19435 */     // MIs[1] Operand 2
     /*  19435 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19454 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19462 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19466 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19470 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19475 */     // MIs[3] Operand 2
     /*  19475 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19488 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19515 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19532 */     // GIR_Coverage, 5316,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 366: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19669), // Rule ID 5315 //
     /*  19538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19571 */     // MIs[1] Operand 2
     /*  19571 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19594 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19598 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19602 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19606 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19611 */     // MIs[3] Operand 2
     /*  19611 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19624 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19668 */     // GIR_Coverage, 5315,
     /*  19668 */     GIR_EraseRootFromParent_Done,
     /*  19669 */   // Label 367: @19669
     /*  19669 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(19805), // Rule ID 5331 //
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19707 */     // MIs[1] Operand 2
     /*  19707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19738 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19742 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19747 */     // MIs[3] Operand 2
     /*  19747 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19758 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19760 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  19767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19787 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19804 */     // GIR_Coverage, 5331,
     /*  19804 */     GIR_EraseRootFromParent_Done,
     /*  19805 */   // Label 368: @19805
     /*  19805 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(19941), // Rule ID 5314 //
     /*  19810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19843 */     // MIs[1] Operand 2
     /*  19843 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19866 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19870 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19874 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19878 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19883 */     // MIs[3] Operand 2
     /*  19883 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19894 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19896 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19923 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19940 */     // GIR_Coverage, 5314,
     /*  19940 */     GIR_EraseRootFromParent_Done,
     /*  19941 */   // Label 369: @19941
     /*  19941 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20077), // Rule ID 5313 //
     /*  19946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19979 */     // MIs[1] Operand 2
     /*  19979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20006 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20010 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20014 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20019 */     // MIs[3] Operand 2
     /*  20019 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  20030 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20032 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  20039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  20052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20059 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20076 */     // GIR_Coverage, 5313,
     /*  20076 */     GIR_EraseRootFromParent_Done,
     /*  20077 */   // Label 370: @20077
     /*  20077 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20210), // Rule ID 13739 //
     /*  20082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  20106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  20114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  20127 */     // MIs[1] Operand 2
     /*  20127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  20146 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20154 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  20158 */     // MIs[5] Rn
     /*  20158 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20163 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  20165 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  20165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  20168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  20172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20192 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20209 */     // GIR_Coverage, 13739,
     /*  20209 */     GIR_EraseRootFromParent_Done,
     /*  20210 */   // Label 371: @20210
     /*  20210 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20343), // Rule ID 6852 //
     /*  20215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  20227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  20239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20260 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20264 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  20268 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  20272 */     // MIs[4] Rn
     /*  20272 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20277 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20281 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  20285 */     // MIs[3] Operand 2
     /*  20285 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  20296 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  20298 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  20298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  20301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  20305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20325 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20342 */     // GIR_Coverage, 6852,
     /*  20342 */     GIR_EraseRootFromParent_Done,
     /*  20343 */   // Label 372: @20343
     /*  20343 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20506), // Rule ID 13691 //
     /*  20348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  20372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  20380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20390 */     // MIs[1] Operand 2
     /*  20390 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20407 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20407 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20410 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20414 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20421 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20424 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20428 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20433 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20436 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  20440 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20448 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20453 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  20465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  20481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20488 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20505 */     // GIR_Coverage, 13691,
     /*  20505 */     GIR_EraseRootFromParent_Done,
     /*  20506 */   // Label 373: @20506
     /*  20506 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(20669), // Rule ID 13688 //
     /*  20511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  20535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  20543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20553 */     // MIs[1] Operand 2
     /*  20553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20570 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20570 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20573 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20577 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20596 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  20603 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20606 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20616 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  20628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20633 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  20644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20668 */     // GIR_Coverage, 13688,
     /*  20668 */     GIR_EraseRootFromParent_Done,
     /*  20669 */   // Label 374: @20669
     /*  20669 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(20819), // Rule ID 13695 //
     /*  20674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20707 */     // MIs[1] Operand 2
     /*  20707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20724 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20724 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20727 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20731 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20750 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20753 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  20757 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20765 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20770 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  20782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20818 */     // GIR_Coverage, 13695,
     /*  20818 */     GIR_EraseRootFromParent_Done,
     /*  20819 */   // Label 375: @20819
     /*  20819 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(20969), // Rule ID 13700 //
     /*  20824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20857 */     // MIs[1] Operand 2
     /*  20857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20874 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20874 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20877 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20881 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20900 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20903 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  20907 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20915 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20920 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  20932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20937 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20951 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20968 */     // GIR_Coverage, 13700,
     /*  20968 */     GIR_EraseRootFromParent_Done,
     /*  20969 */   // Label 376: @20969
     /*  20969 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21119), // Rule ID 13694 //
     /*  20974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21007 */     // MIs[1] Operand 2
     /*  21007 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21024 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21050 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  21057 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21060 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21101 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21118 */     // GIR_Coverage, 13694,
     /*  21118 */     GIR_EraseRootFromParent_Done,
     /*  21119 */   // Label 377: @21119
     /*  21119 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21282), // Rule ID 5304 //
     /*  21124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  21152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  21160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21170 */     // MIs[1] Operand 2
     /*  21170 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21183 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21183 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21186 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21190 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21209 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  21216 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  21241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  21257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21264 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21281 */     // GIR_Coverage, 5304,
     /*  21281 */     GIR_EraseRootFromParent_Done,
     /*  21282 */   // Label 378: @21282
     /*  21282 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21445), // Rule ID 5301 //
     /*  21287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  21315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  21323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21333 */     // MIs[1] Operand 2
     /*  21333 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21346 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  21379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  21404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  21420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21444 */     // GIR_Coverage, 5301,
     /*  21444 */     GIR_EraseRootFromParent_Done,
     /*  21445 */   // Label 379: @21445
     /*  21445 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21595), // Rule ID 5326 //
     /*  21450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21487 */     // MIs[1] Operand 2
     /*  21487 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21500 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21500 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21503 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21507 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21526 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21529 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21533 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21563 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21577 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21594 */     // GIR_Coverage, 5326,
     /*  21594 */     GIR_EraseRootFromParent_Done,
     /*  21595 */   // Label 380: @21595
     /*  21595 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21745), // Rule ID 5334 //
     /*  21600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21637 */     // MIs[1] Operand 2
     /*  21637 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21650 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21650 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21653 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21657 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21676 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21683 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21696 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  21708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21713 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21727 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21744 */     // GIR_Coverage, 5334,
     /*  21744 */     GIR_EraseRootFromParent_Done,
     /*  21745 */   // Label 381: @21745
     /*  21745 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21895), // Rule ID 5325 //
     /*  21750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21787 */     // MIs[1] Operand 2
     /*  21787 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21800 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21800 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21803 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21807 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21814 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21817 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21821 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21826 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21829 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21833 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21877 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21894 */     // GIR_Coverage, 5325,
     /*  21894 */     GIR_EraseRootFromParent_Done,
     /*  21895 */   // Label 382: @21895
     /*  21895 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(21964), // Rule ID 13140 //
     /*  21900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  21918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  21923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  21931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21947 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  21947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  21950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  21958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  21962 */     GIR_RootConstrainSelectedInstOperands,
     /*  21963 */     // GIR_Coverage, 13140,
     /*  21963 */     GIR_EraseRootFromParent_Done,
     /*  21964 */   // Label 383: @21964
     /*  21964 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22033), // Rule ID 13152 //
     /*  21969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  21987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  21992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21996 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22016 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  22019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22031 */     GIR_RootConstrainSelectedInstOperands,
     /*  22032 */     // GIR_Coverage, 13152,
     /*  22032 */     GIR_EraseRootFromParent_Done,
     /*  22033 */   // Label 384: @22033
     /*  22033 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22089), // Rule ID 13102 //
     /*  22038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22053 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22056 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  22061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22076 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22087 */     GIR_RootConstrainSelectedInstOperands,
     /*  22088 */     // GIR_Coverage, 13102,
     /*  22088 */     GIR_EraseRootFromParent_Done,
     /*  22089 */   // Label 385: @22089
     /*  22089 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22145), // Rule ID 13114 //
     /*  22094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22109 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22112 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  22117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22132 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22143 */     GIR_RootConstrainSelectedInstOperands,
     /*  22144 */     // GIR_Coverage, 13114,
     /*  22144 */     GIR_EraseRootFromParent_Done,
     /*  22145 */   // Label 386: @22145
     /*  22145 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22212), // Rule ID 13344 //
     /*  22150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  22165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22174 */     // MIs[1] imm
     /*  22174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22182 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22186 */     // MIs[2] Operand 1
     /*  22186 */     // No operand predicates
     /*  22186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22196 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  22199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22210 */     GIR_RootConstrainSelectedInstOperands,
     /*  22211 */     // GIR_Coverage, 13344,
     /*  22211 */     GIR_EraseRootFromParent_Done,
     /*  22212 */   // Label 387: @22212
     /*  22212 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22279), // Rule ID 13365 //
     /*  22217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  22232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22241 */     // MIs[1] imm
     /*  22241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22253 */     // MIs[2] Operand 1
     /*  22253 */     // No operand predicates
     /*  22253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22263 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  22266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22277 */     GIR_RootConstrainSelectedInstOperands,
     /*  22278 */     // GIR_Coverage, 13365,
     /*  22278 */     GIR_EraseRootFromParent_Done,
     /*  22279 */   // Label 388: @22279
     /*  22279 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22348), // Rule ID 1354 //
     /*  22284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  22306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  22311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22331 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  22334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22346 */     GIR_RootConstrainSelectedInstOperands,
     /*  22347 */     // GIR_Coverage, 1354,
     /*  22347 */     GIR_EraseRootFromParent_Done,
     /*  22348 */   // Label 389: @22348
     /*  22348 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22417), // Rule ID 1477 //
     /*  22353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  22375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  22380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22384 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22400 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  22403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22415 */     GIR_RootConstrainSelectedInstOperands,
     /*  22416 */     // GIR_Coverage, 1477,
     /*  22416 */     GIR_EraseRootFromParent_Done,
     /*  22417 */   // Label 390: @22417
     /*  22417 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(22473), // Rule ID 982 //
     /*  22422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22441 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22444 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  22449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22460 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22471 */     GIR_RootConstrainSelectedInstOperands,
     /*  22472 */     // GIR_Coverage, 982,
     /*  22472 */     GIR_EraseRootFromParent_Done,
     /*  22473 */   // Label 391: @22473
     /*  22473 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(22529), // Rule ID 1043 //
     /*  22478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22497 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22500 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  22505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22516 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22527 */     GIR_RootConstrainSelectedInstOperands,
     /*  22528 */     // GIR_Coverage, 1043,
     /*  22528 */     GIR_EraseRootFromParent_Done,
     /*  22529 */   // Label 392: @22529
     /*  22529 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(22596), // Rule ID 2225 //
     /*  22534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  22553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22562 */     // MIs[1] imm
     /*  22562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22570 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22574 */     // MIs[2] Operand 1
     /*  22574 */     // No operand predicates
     /*  22574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22580 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  22583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22594 */     GIR_RootConstrainSelectedInstOperands,
     /*  22595 */     // GIR_Coverage, 2225,
     /*  22595 */     GIR_EraseRootFromParent_Done,
     /*  22596 */   // Label 393: @22596
     /*  22596 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(22663), // Rule ID 2284 //
     /*  22601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  22620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22629 */     // MIs[1] imm
     /*  22629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22637 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22641 */     // MIs[2] Operand 1
     /*  22641 */     // No operand predicates
     /*  22641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22647 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  22650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22661 */     GIR_RootConstrainSelectedInstOperands,
     /*  22662 */     // GIR_Coverage, 2284,
     /*  22662 */     GIR_EraseRootFromParent_Done,
     /*  22663 */   // Label 394: @22663
     /*  22663 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(22711), // Rule ID 13101 //
     /*  22668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  22683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22698 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22709 */     GIR_RootConstrainSelectedInstOperands,
     /*  22710 */     // GIR_Coverage, 13101,
     /*  22710 */     GIR_EraseRootFromParent_Done,
     /*  22711 */   // Label 395: @22711
     /*  22711 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(22759), // Rule ID 13113 //
     /*  22716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  22731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22746 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22757 */     GIR_RootConstrainSelectedInstOperands,
     /*  22758 */     // GIR_Coverage, 13113,
     /*  22758 */     GIR_EraseRootFromParent_Done,
     /*  22759 */   // Label 396: @22759
     /*  22759 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(22807), // Rule ID 981 //
     /*  22764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  22783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22794 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22805 */     GIR_RootConstrainSelectedInstOperands,
     /*  22806 */     // GIR_Coverage, 981,
     /*  22806 */     GIR_EraseRootFromParent_Done,
     /*  22807 */   // Label 397: @22807
     /*  22807 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(22855), // Rule ID 1042 //
     /*  22812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  22831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22842 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22853 */     GIR_RootConstrainSelectedInstOperands,
     /*  22854 */     // GIR_Coverage, 1042,
     /*  22854 */     GIR_EraseRootFromParent_Done,
     /*  22855 */   // Label 398: @22855
     /*  22855 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(22882), // Rule ID 1095 //
     /*  22860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22875 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  22880 */     GIR_RootConstrainSelectedInstOperands,
     /*  22881 */     // GIR_Coverage, 1095,
     /*  22881 */     GIR_Done,
     /*  22882 */   // Label 399: @22882
     /*  22882 */   GIM_Reject,
     /*  22883 */ // Label 365: @22883
     /*  22883 */ GIM_Reject,
     /*  22884 */ // Label 163: @22884
     /*  22884 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(29061),
     /*  22889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22895 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(23013), // Rule ID 13274 //
     /*  22900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  22915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  22943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22947 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  22951 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  22956 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  22960 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22964 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  22968 */     // MIs[4] Operand 1
     /*  22968 */     // No operand predicates
     /*  22968 */     // MIs[2] Operand 2
     /*  22968 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  22979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22983 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  22992 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  22992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  22995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23011 */     GIR_RootConstrainSelectedInstOperands,
     /*  23012 */     // GIR_Coverage, 13274,
     /*  23012 */     GIR_EraseRootFromParent_Done,
     /*  23013 */   // Label 401: @23013
     /*  23013 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(23131), // Rule ID 13275 //
     /*  23018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23069 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23078 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23082 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23086 */     // MIs[4] Operand 1
     /*  23086 */     // No operand predicates
     /*  23086 */     // MIs[2] Operand 2
     /*  23086 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23101 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23110 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23129 */     GIR_RootConstrainSelectedInstOperands,
     /*  23130 */     // GIR_Coverage, 13275,
     /*  23130 */     GIR_EraseRootFromParent_Done,
     /*  23131 */   // Label 402: @23131
     /*  23131 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(23249), // Rule ID 13304 //
     /*  23136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23200 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23204 */     // MIs[4] Operand 1
     /*  23204 */     // No operand predicates
     /*  23204 */     // MIs[2] Operand 2
     /*  23204 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23228 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23247 */     GIR_RootConstrainSelectedInstOperands,
     /*  23248 */     // GIR_Coverage, 13304,
     /*  23248 */     GIR_EraseRootFromParent_Done,
     /*  23249 */   // Label 403: @23249
     /*  23249 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(23367), // Rule ID 13305 //
     /*  23254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23310 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23314 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23318 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23322 */     // MIs[4] Operand 1
     /*  23322 */     // No operand predicates
     /*  23322 */     // MIs[2] Operand 2
     /*  23322 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23337 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23346 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 13305,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 404: @23367
     /*  23367 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(23485), // Rule ID 2032 //
     /*  23372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23423 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23427 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23436 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23440 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23444 */     // MIs[4] Operand 1
     /*  23444 */     // No operand predicates
     /*  23444 */     // MIs[2] Operand 2
     /*  23444 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23455 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23464 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23483 */     GIR_RootConstrainSelectedInstOperands,
     /*  23484 */     // GIR_Coverage, 2032,
     /*  23484 */     GIR_EraseRootFromParent_Done,
     /*  23485 */   // Label 405: @23485
     /*  23485 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(23603), // Rule ID 13273 //
     /*  23490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23558 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23562 */     // MIs[4] Operand 1
     /*  23562 */     // No operand predicates
     /*  23562 */     // MIs[2] Operand 2
     /*  23562 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23582 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23601 */     GIR_RootConstrainSelectedInstOperands,
     /*  23602 */     // GIR_Coverage, 13273,
     /*  23602 */     GIR_EraseRootFromParent_Done,
     /*  23603 */   // Label 406: @23603
     /*  23603 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(23721), // Rule ID 2084 //
     /*  23608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23659 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23663 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23668 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23672 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23676 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23680 */     // MIs[4] Operand 1
     /*  23680 */     // No operand predicates
     /*  23680 */     // MIs[2] Operand 2
     /*  23680 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23691 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23700 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23719 */     GIR_RootConstrainSelectedInstOperands,
     /*  23720 */     // GIR_Coverage, 2084,
     /*  23720 */     GIR_EraseRootFromParent_Done,
     /*  23721 */   // Label 407: @23721
     /*  23721 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(23839), // Rule ID 13303 //
     /*  23726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23798 */     // MIs[4] Operand 1
     /*  23798 */     // No operand predicates
     /*  23798 */     // MIs[2] Operand 2
     /*  23798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23818 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23837 */     GIR_RootConstrainSelectedInstOperands,
     /*  23838 */     // GIR_Coverage, 13303,
     /*  23838 */     GIR_EraseRootFromParent_Done,
     /*  23839 */   // Label 408: @23839
     /*  23839 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(23926), // Rule ID 13184 //
     /*  23844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23871 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  23874 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23883 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23907 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  23907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  23910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  23924 */     GIR_RootConstrainSelectedInstOperands,
     /*  23925 */     // GIR_Coverage, 13184,
     /*  23925 */     GIR_EraseRootFromParent_Done,
     /*  23926 */   // Label 409: @23926
     /*  23926 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24013), // Rule ID 13208 //
     /*  23931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23958 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  23961 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23970 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23994 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  23994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  23997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24011 */     GIR_RootConstrainSelectedInstOperands,
     /*  24012 */     // GIR_Coverage, 13208,
     /*  24012 */     GIR_EraseRootFromParent_Done,
     /*  24013 */   // Label 410: @24013
     /*  24013 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24100), // Rule ID 1688 //
     /*  24018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24049 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  24052 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24061 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24081 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  24084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24098 */     GIR_RootConstrainSelectedInstOperands,
     /*  24099 */     // GIR_Coverage, 1688,
     /*  24099 */     GIR_EraseRootFromParent_Done,
     /*  24100 */   // Label 411: @24100
     /*  24100 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24187), // Rule ID 1766 //
     /*  24105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24136 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  24139 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24148 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24168 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  24171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24185 */     GIR_RootConstrainSelectedInstOperands,
     /*  24186 */     // GIR_Coverage, 1766,
     /*  24186 */     GIR_EraseRootFromParent_Done,
     /*  24187 */   // Label 412: @24187
     /*  24187 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24302), // Rule ID 13269 //
     /*  24192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24243 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24256 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24260 */     // MIs[4] Operand 1
     /*  24260 */     // No operand predicates
     /*  24260 */     // MIs[2] Operand 2
     /*  24260 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24280 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24282 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  24285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24300 */     GIR_RootConstrainSelectedInstOperands,
     /*  24301 */     // GIR_Coverage, 13269,
     /*  24301 */     GIR_EraseRootFromParent_Done,
     /*  24302 */   // Label 413: @24302
     /*  24302 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24417), // Rule ID 13268 //
     /*  24307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24355 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24372 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24376 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24380 */     // MIs[4] Operand 1
     /*  24380 */     // No operand predicates
     /*  24380 */     // MIs[2] Operand 2
     /*  24380 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24395 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24397 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  24400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24415 */     GIR_RootConstrainSelectedInstOperands,
     /*  24416 */     // GIR_Coverage, 13268,
     /*  24416 */     GIR_EraseRootFromParent_Done,
     /*  24417 */   // Label 414: @24417
     /*  24417 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24532), // Rule ID 13299 //
     /*  24422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24469 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24473 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24478 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24482 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24486 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24490 */     // MIs[4] Operand 1
     /*  24490 */     // No operand predicates
     /*  24490 */     // MIs[2] Operand 2
     /*  24490 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24512 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  24515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24530 */     GIR_RootConstrainSelectedInstOperands,
     /*  24531 */     // GIR_Coverage, 13299,
     /*  24531 */     GIR_EraseRootFromParent_Done,
     /*  24532 */   // Label 415: @24532
     /*  24532 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(24647), // Rule ID 13298 //
     /*  24537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24585 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24589 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24602 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24606 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24610 */     // MIs[4] Operand 1
     /*  24610 */     // No operand predicates
     /*  24610 */     // MIs[2] Operand 2
     /*  24610 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24625 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24627 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  24630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24645 */     GIR_RootConstrainSelectedInstOperands,
     /*  24646 */     // GIR_Coverage, 13298,
     /*  24646 */     GIR_EraseRootFromParent_Done,
     /*  24647 */   // Label 416: @24647
     /*  24647 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(24716), // Rule ID 1786 //
     /*  24652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24699 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24714 */     GIR_RootConstrainSelectedInstOperands,
     /*  24715 */     // GIR_Coverage, 1786,
     /*  24715 */     GIR_EraseRootFromParent_Done,
     /*  24716 */   // Label 417: @24716
     /*  24716 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(24785), // Rule ID 1785 //
     /*  24721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24768 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24783 */     GIR_RootConstrainSelectedInstOperands,
     /*  24784 */     // GIR_Coverage, 1785,
     /*  24784 */     GIR_EraseRootFromParent_Done,
     /*  24785 */   // Label 418: @24785
     /*  24785 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(24854), // Rule ID 1708 //
     /*  24790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  24805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  24817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24837 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  24840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24852 */     GIR_RootConstrainSelectedInstOperands,
     /*  24853 */     // GIR_Coverage, 1708,
     /*  24853 */     GIR_EraseRootFromParent_Done,
     /*  24854 */   // Label 419: @24854
     /*  24854 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(24923), // Rule ID 1784 //
     /*  24859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24906 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24921 */     GIR_RootConstrainSelectedInstOperands,
     /*  24922 */     // GIR_Coverage, 1784,
     /*  24922 */     GIR_EraseRootFromParent_Done,
     /*  24923 */   // Label 420: @24923
     /*  24923 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(24992), // Rule ID 1783 //
     /*  24928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24975 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24990 */     GIR_RootConstrainSelectedInstOperands,
     /*  24991 */     // GIR_Coverage, 1783,
     /*  24991 */     GIR_EraseRootFromParent_Done,
     /*  24992 */   // Label 421: @24992
     /*  24992 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25107), // Rule ID 13267 //
     /*  24997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25048 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25052 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25057 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25061 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25065 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25069 */     // MIs[4] Operand 1
     /*  25069 */     // No operand predicates
     /*  25069 */     // MIs[2] Operand 2
     /*  25069 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25087 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25105 */     GIR_RootConstrainSelectedInstOperands,
     /*  25106 */     // GIR_Coverage, 13267,
     /*  25106 */     GIR_EraseRootFromParent_Done,
     /*  25107 */   // Label 422: @25107
     /*  25107 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25222), // Rule ID 2030 //
     /*  25112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25185 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25189 */     // MIs[4] Operand 1
     /*  25189 */     // No operand predicates
     /*  25189 */     // MIs[2] Operand 2
     /*  25189 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25202 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25220 */     GIR_RootConstrainSelectedInstOperands,
     /*  25221 */     // GIR_Coverage, 2030,
     /*  25221 */     GIR_EraseRootFromParent_Done,
     /*  25222 */   // Label 423: @25222
     /*  25222 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25337), // Rule ID 13297 //
     /*  25227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25295 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25299 */     // MIs[4] Operand 1
     /*  25299 */     // No operand predicates
     /*  25299 */     // MIs[2] Operand 2
     /*  25299 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25315 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25317 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  25320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25335 */     GIR_RootConstrainSelectedInstOperands,
     /*  25336 */     // GIR_Coverage, 13297,
     /*  25336 */     GIR_EraseRootFromParent_Done,
     /*  25337 */   // Label 424: @25337
     /*  25337 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25452), // Rule ID 2082 //
     /*  25342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25398 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25402 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25415 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25419 */     // MIs[4] Operand 1
     /*  25419 */     // No operand predicates
     /*  25419 */     // MIs[2] Operand 2
     /*  25419 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25430 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25432 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  25435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25450 */     GIR_RootConstrainSelectedInstOperands,
     /*  25451 */     // GIR_Coverage, 2082,
     /*  25451 */     GIR_EraseRootFromParent_Done,
     /*  25452 */   // Label 425: @25452
     /*  25452 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(25519), // Rule ID 13198 //
     /*  25457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25500 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  25503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25517 */     GIR_RootConstrainSelectedInstOperands,
     /*  25518 */     // GIR_Coverage, 13198,
     /*  25518 */     GIR_EraseRootFromParent_Done,
     /*  25519 */   // Label 426: @25519
     /*  25519 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(25586), // Rule ID 13228 //
     /*  25524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25567 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  25570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25584 */     GIR_RootConstrainSelectedInstOperands,
     /*  25585 */     // GIR_Coverage, 13228,
     /*  25585 */     GIR_EraseRootFromParent_Done,
     /*  25586 */   // Label 427: @25586
     /*  25586 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(25653), // Rule ID 1720 //
     /*  25591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25634 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  25637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25651 */     GIR_RootConstrainSelectedInstOperands,
     /*  25652 */     // GIR_Coverage, 1720,
     /*  25652 */     GIR_EraseRootFromParent_Done,
     /*  25653 */   // Label 428: @25653
     /*  25653 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(25720), // Rule ID 1810 //
     /*  25658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25701 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  25704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25718 */     GIR_RootConstrainSelectedInstOperands,
     /*  25719 */     // GIR_Coverage, 1810,
     /*  25719 */     GIR_EraseRootFromParent_Done,
     /*  25720 */   // Label 429: @25720
     /*  25720 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(25801), // Rule ID 13182 //
     /*  25725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25752 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25755 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25764 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25784 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  25787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25799 */     GIR_RootConstrainSelectedInstOperands,
     /*  25800 */     // GIR_Coverage, 13182,
     /*  25800 */     GIR_EraseRootFromParent_Done,
     /*  25801 */   // Label 430: @25801
     /*  25801 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(25882), // Rule ID 13206 //
     /*  25806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25845 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25865 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25880 */     GIR_RootConstrainSelectedInstOperands,
     /*  25881 */     // GIR_Coverage, 13206,
     /*  25881 */     GIR_EraseRootFromParent_Done,
     /*  25882 */   // Label 431: @25882
     /*  25882 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(25963), // Rule ID 1686 //
     /*  25887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25918 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25921 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25930 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25946 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  25949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25961 */     GIR_RootConstrainSelectedInstOperands,
     /*  25962 */     // GIR_Coverage, 1686,
     /*  25962 */     GIR_EraseRootFromParent_Done,
     /*  25963 */   // Label 432: @25963
     /*  25963 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26044), // Rule ID 1764 //
     /*  25968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25999 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26002 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26011 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26015 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26027 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  26027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  26030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  26038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  26042 */     GIR_RootConstrainSelectedInstOperands,
     /*  26043 */     // GIR_Coverage, 1764,
     /*  26043 */     GIR_EraseRootFromParent_Done,
     /*  26044 */   // Label 433: @26044
     /*  26044 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26136), // Rule ID 13272 //
     /*  26049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26105 */     // MIs[3] Operand 1
     /*  26105 */     // No operand predicates
     /*  26105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26116 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26134 */     GIR_RootConstrainSelectedInstOperands,
     /*  26135 */     // GIR_Coverage, 13272,
     /*  26135 */     GIR_EraseRootFromParent_Done,
     /*  26136 */   // Label 434: @26136
     /*  26136 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26228), // Rule ID 13271 //
     /*  26141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26198 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26202 */     // MIs[3] Operand 1
     /*  26202 */     // No operand predicates
     /*  26202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26208 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26226 */     GIR_RootConstrainSelectedInstOperands,
     /*  26227 */     // GIR_Coverage, 13271,
     /*  26227 */     GIR_EraseRootFromParent_Done,
     /*  26228 */   // Label 435: @26228
     /*  26228 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(26320), // Rule ID 13302 //
     /*  26233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26289 */     // MIs[3] Operand 1
     /*  26289 */     // No operand predicates
     /*  26289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26300 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26318 */     GIR_RootConstrainSelectedInstOperands,
     /*  26319 */     // GIR_Coverage, 13302,
     /*  26319 */     GIR_EraseRootFromParent_Done,
     /*  26320 */   // Label 436: @26320
     /*  26320 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(26412), // Rule ID 13301 //
     /*  26325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26382 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26386 */     // MIs[3] Operand 1
     /*  26386 */     // No operand predicates
     /*  26386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26392 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26410 */     GIR_RootConstrainSelectedInstOperands,
     /*  26411 */     // GIR_Coverage, 13301,
     /*  26411 */     GIR_EraseRootFromParent_Done,
     /*  26412 */   // Label 437: @26412
     /*  26412 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(26504), // Rule ID 13270 //
     /*  26417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26473 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26477 */     // MIs[3] Operand 1
     /*  26477 */     // No operand predicates
     /*  26477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26484 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26502 */     GIR_RootConstrainSelectedInstOperands,
     /*  26503 */     // GIR_Coverage, 13270,
     /*  26503 */     GIR_EraseRootFromParent_Done,
     /*  26504 */   // Label 438: @26504
     /*  26504 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(26596), // Rule ID 2031 //
     /*  26509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26570 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26574 */     // MIs[3] Operand 1
     /*  26574 */     // No operand predicates
     /*  26574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26576 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26594 */     GIR_RootConstrainSelectedInstOperands,
     /*  26595 */     // GIR_Coverage, 2031,
     /*  26595 */     GIR_EraseRootFromParent_Done,
     /*  26596 */   // Label 439: @26596
     /*  26596 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(26688), // Rule ID 13300 //
     /*  26601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26657 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26661 */     // MIs[3] Operand 1
     /*  26661 */     // No operand predicates
     /*  26661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26668 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26686 */     GIR_RootConstrainSelectedInstOperands,
     /*  26687 */     // GIR_Coverage, 13300,
     /*  26687 */     GIR_EraseRootFromParent_Done,
     /*  26688 */   // Label 440: @26688
     /*  26688 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(26780), // Rule ID 2083 //
     /*  26693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26754 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26758 */     // MIs[3] Operand 1
     /*  26758 */     // No operand predicates
     /*  26758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26778 */     GIR_RootConstrainSelectedInstOperands,
     /*  26779 */     // GIR_Coverage, 2083,
     /*  26779 */     GIR_EraseRootFromParent_Done,
     /*  26780 */   // Label 441: @26780
     /*  26780 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(26831), // Rule ID 13220 //
     /*  26785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26817 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26829 */     GIR_RootConstrainSelectedInstOperands,
     /*  26830 */     // GIR_Coverage, 13220,
     /*  26830 */     GIR_EraseRootFromParent_Done,
     /*  26831 */   // Label 442: @26831
     /*  26831 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(26882), // Rule ID 13192 //
     /*  26836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26868 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  26871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26880 */     GIR_RootConstrainSelectedInstOperands,
     /*  26881 */     // GIR_Coverage, 13192,
     /*  26881 */     GIR_EraseRootFromParent_Done,
     /*  26882 */   // Label 443: @26882
     /*  26882 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(26933), // Rule ID 13219 //
     /*  26887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26919 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26931 */     GIR_RootConstrainSelectedInstOperands,
     /*  26932 */     // GIR_Coverage, 13219,
     /*  26932 */     GIR_EraseRootFromParent_Done,
     /*  26933 */   // Label 444: @26933
     /*  26933 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(26984), // Rule ID 1802 //
     /*  26938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26970 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  26977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26982 */     GIR_RootConstrainSelectedInstOperands,
     /*  26983 */     // GIR_Coverage, 1802,
     /*  26983 */     GIR_EraseRootFromParent_Done,
     /*  26984 */   // Label 445: @26984
     /*  26984 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27035), // Rule ID 1714 //
     /*  26989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27021 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  27024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  27028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  27033 */     GIR_RootConstrainSelectedInstOperands,
     /*  27034 */     // GIR_Coverage, 1714,
     /*  27034 */     GIR_EraseRootFromParent_Done,
     /*  27035 */   // Label 446: @27035
     /*  27035 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27086), // Rule ID 1801 //
     /*  27040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27072 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  27075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  27079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  27084 */     GIR_RootConstrainSelectedInstOperands,
     /*  27085 */     // GIR_Coverage, 1801,
     /*  27085 */     GIR_EraseRootFromParent_Done,
     /*  27086 */   // Label 447: @27086
     /*  27086 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(27155), // Rule ID 13146 //
     /*  27091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27106 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27109 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27118 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27138 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  27141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27153 */     GIR_RootConstrainSelectedInstOperands,
     /*  27154 */     // GIR_Coverage, 13146,
     /*  27154 */     GIR_EraseRootFromParent_Done,
     /*  27155 */   // Label 448: @27155
     /*  27155 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(27224), // Rule ID 13158 //
     /*  27160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27207 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  27210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27222 */     GIR_RootConstrainSelectedInstOperands,
     /*  27223 */     // GIR_Coverage, 13158,
     /*  27223 */     GIR_EraseRootFromParent_Done,
     /*  27224 */   // Label 449: @27224
     /*  27224 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(27280), // Rule ID 13108 //
     /*  27229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27244 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27247 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  27252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27267 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  27270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27278 */     GIR_RootConstrainSelectedInstOperands,
     /*  27279 */     // GIR_Coverage, 13108,
     /*  27279 */     GIR_EraseRootFromParent_Done,
     /*  27280 */   // Label 450: @27280
     /*  27280 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(27336), // Rule ID 13120 //
     /*  27285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27300 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27303 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  27308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27323 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  27326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27334 */     GIR_RootConstrainSelectedInstOperands,
     /*  27335 */     // GIR_Coverage, 13120,
     /*  27335 */     GIR_EraseRootFromParent_Done,
     /*  27336 */   // Label 451: @27336
     /*  27336 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(27403), // Rule ID 13350 //
     /*  27341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  27356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27365 */     // MIs[1] imm
     /*  27365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27377 */     // MIs[2] Operand 1
     /*  27377 */     // No operand predicates
     /*  27377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27387 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  27390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27401 */     GIR_RootConstrainSelectedInstOperands,
     /*  27402 */     // GIR_Coverage, 13350,
     /*  27402 */     GIR_EraseRootFromParent_Done,
     /*  27403 */   // Label 452: @27403
     /*  27403 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(27470), // Rule ID 13371 //
     /*  27408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  27423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27432 */     // MIs[1] imm
     /*  27432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27444 */     // MIs[2] Operand 1
     /*  27444 */     // No operand predicates
     /*  27444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27454 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  27457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27468 */     GIR_RootConstrainSelectedInstOperands,
     /*  27469 */     // GIR_Coverage, 13371,
     /*  27469 */     GIR_EraseRootFromParent_Done,
     /*  27470 */   // Label 453: @27470
     /*  27470 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(27539), // Rule ID 1360 //
     /*  27475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27494 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27497 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27506 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27522 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  27525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27537 */     GIR_RootConstrainSelectedInstOperands,
     /*  27538 */     // GIR_Coverage, 1360,
     /*  27538 */     GIR_EraseRootFromParent_Done,
     /*  27539 */   // Label 454: @27539
     /*  27539 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(27608), // Rule ID 1483 //
     /*  27544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27563 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27566 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27575 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27591 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  27594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27606 */     GIR_RootConstrainSelectedInstOperands,
     /*  27607 */     // GIR_Coverage, 1483,
     /*  27607 */     GIR_EraseRootFromParent_Done,
     /*  27608 */   // Label 455: @27608
     /*  27608 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(27664), // Rule ID 988 //
     /*  27613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27632 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27635 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  27640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27651 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  27654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27662 */     GIR_RootConstrainSelectedInstOperands,
     /*  27663 */     // GIR_Coverage, 988,
     /*  27663 */     GIR_EraseRootFromParent_Done,
     /*  27664 */   // Label 456: @27664
     /*  27664 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(27720), // Rule ID 1049 //
     /*  27669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27688 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27691 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  27696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27707 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  27710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27718 */     GIR_RootConstrainSelectedInstOperands,
     /*  27719 */     // GIR_Coverage, 1049,
     /*  27719 */     GIR_EraseRootFromParent_Done,
     /*  27720 */   // Label 457: @27720
     /*  27720 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(27787), // Rule ID 2231 //
     /*  27725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  27744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27753 */     // MIs[1] imm
     /*  27753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27761 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27765 */     // MIs[2] Operand 1
     /*  27765 */     // No operand predicates
     /*  27765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27771 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  27774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27785 */     GIR_RootConstrainSelectedInstOperands,
     /*  27786 */     // GIR_Coverage, 2231,
     /*  27786 */     GIR_EraseRootFromParent_Done,
     /*  27787 */   // Label 458: @27787
     /*  27787 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(27854), // Rule ID 2290 //
     /*  27792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  27811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27820 */     // MIs[1] imm
     /*  27820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27832 */     // MIs[2] Operand 1
     /*  27832 */     // No operand predicates
     /*  27832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27838 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  27841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27852 */     GIR_RootConstrainSelectedInstOperands,
     /*  27853 */     // GIR_Coverage, 2290,
     /*  27853 */     GIR_EraseRootFromParent_Done,
     /*  27854 */   // Label 459: @27854
     /*  27854 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(27924), // Rule ID 6848 //
     /*  27859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  27871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  27897 */     // MIs[2] Rn
     /*  27897 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27902 */     // MIs[2] Rm
     /*  27902 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27909 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  27909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  27912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  27922 */     GIR_RootConstrainSelectedInstOperands,
     /*  27923 */     // GIR_Coverage, 6848,
     /*  27923 */     GIR_EraseRootFromParent_Done,
     /*  27924 */   // Label 460: @27924
     /*  27924 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(27994), // Rule ID 13735 //
     /*  27929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  27941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  27967 */     // MIs[2] Rn
     /*  27967 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27972 */     // MIs[2] Rm
     /*  27972 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27979 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  27979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  27982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  27992 */     GIR_RootConstrainSelectedInstOperands,
     /*  27993 */     // GIR_Coverage, 13735,
     /*  27993 */     GIR_EraseRootFromParent_Done,
     /*  27994 */   // Label 461: @27994
     /*  27994 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28057), // Rule ID 1782 //
     /*  27999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28042 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28055 */     GIR_RootConstrainSelectedInstOperands,
     /*  28056 */     // GIR_Coverage, 1782,
     /*  28056 */     GIR_EraseRootFromParent_Done,
     /*  28057 */   // Label 462: @28057
     /*  28057 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(28120), // Rule ID 1781 //
     /*  28062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28105 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28118 */     GIR_RootConstrainSelectedInstOperands,
     /*  28119 */     // GIR_Coverage, 1781,
     /*  28119 */     GIR_EraseRootFromParent_Done,
     /*  28120 */   // Label 463: @28120
     /*  28120 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(28183), // Rule ID 1707 //
     /*  28125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28168 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  28171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28181 */     GIR_RootConstrainSelectedInstOperands,
     /*  28182 */     // GIR_Coverage, 1707,
     /*  28182 */     GIR_EraseRootFromParent_Done,
     /*  28183 */   // Label 464: @28183
     /*  28183 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(28246), // Rule ID 1780 //
     /*  28188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28231 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28244 */     GIR_RootConstrainSelectedInstOperands,
     /*  28245 */     // GIR_Coverage, 1780,
     /*  28245 */     GIR_EraseRootFromParent_Done,
     /*  28246 */   // Label 465: @28246
     /*  28246 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(28309), // Rule ID 1779 //
     /*  28251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28294 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28307 */     GIR_RootConstrainSelectedInstOperands,
     /*  28308 */     // GIR_Coverage, 1779,
     /*  28308 */     GIR_EraseRootFromParent_Done,
     /*  28309 */   // Label 466: @28309
     /*  28309 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(28370), // Rule ID 13197 //
     /*  28314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28353 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  28356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28368 */     GIR_RootConstrainSelectedInstOperands,
     /*  28369 */     // GIR_Coverage, 13197,
     /*  28369 */     GIR_EraseRootFromParent_Done,
     /*  28370 */   // Label 467: @28370
     /*  28370 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(28431), // Rule ID 13227 //
     /*  28375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28414 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  28417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28429 */     GIR_RootConstrainSelectedInstOperands,
     /*  28430 */     // GIR_Coverage, 13227,
     /*  28430 */     GIR_EraseRootFromParent_Done,
     /*  28431 */   // Label 468: @28431
     /*  28431 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(28479), // Rule ID 13218 //
     /*  28436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28466 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28477 */     GIR_RootConstrainSelectedInstOperands,
     /*  28478 */     // GIR_Coverage, 13218,
     /*  28478 */     GIR_EraseRootFromParent_Done,
     /*  28479 */   // Label 469: @28479
     /*  28479 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(28527), // Rule ID 13107 //
     /*  28484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  28499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28514 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28525 */     GIR_RootConstrainSelectedInstOperands,
     /*  28526 */     // GIR_Coverage, 13107,
     /*  28526 */     GIR_EraseRootFromParent_Done,
     /*  28527 */   // Label 470: @28527
     /*  28527 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(28575), // Rule ID 13191 //
     /*  28532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28562 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  28565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28573 */     GIR_RootConstrainSelectedInstOperands,
     /*  28574 */     // GIR_Coverage, 13191,
     /*  28574 */     GIR_EraseRootFromParent_Done,
     /*  28575 */   // Label 471: @28575
     /*  28575 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(28623), // Rule ID 13119 //
     /*  28580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  28595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28610 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  28613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28621 */     GIR_RootConstrainSelectedInstOperands,
     /*  28622 */     // GIR_Coverage, 13119,
     /*  28622 */     GIR_EraseRootFromParent_Done,
     /*  28623 */   // Label 472: @28623
     /*  28623 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(28671), // Rule ID 13217 //
     /*  28628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28658 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28669 */     GIR_RootConstrainSelectedInstOperands,
     /*  28670 */     // GIR_Coverage, 13217,
     /*  28670 */     GIR_EraseRootFromParent_Done,
     /*  28671 */   // Label 473: @28671
     /*  28671 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(28732), // Rule ID 1719 //
     /*  28676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28715 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  28718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28730 */     GIR_RootConstrainSelectedInstOperands,
     /*  28731 */     // GIR_Coverage, 1719,
     /*  28731 */     GIR_EraseRootFromParent_Done,
     /*  28732 */   // Label 474: @28732
     /*  28732 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(28793), // Rule ID 1809 //
     /*  28737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28776 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  28779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28791 */     GIR_RootConstrainSelectedInstOperands,
     /*  28792 */     // GIR_Coverage, 1809,
     /*  28792 */     GIR_EraseRootFromParent_Done,
     /*  28793 */   // Label 475: @28793
     /*  28793 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(28841), // Rule ID 1800 //
     /*  28798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28828 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28839 */     GIR_RootConstrainSelectedInstOperands,
     /*  28840 */     // GIR_Coverage, 1800,
     /*  28840 */     GIR_EraseRootFromParent_Done,
     /*  28841 */   // Label 476: @28841
     /*  28841 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(28889), // Rule ID 987 //
     /*  28846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  28865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28876 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28887 */     GIR_RootConstrainSelectedInstOperands,
     /*  28888 */     // GIR_Coverage, 987,
     /*  28888 */     GIR_EraseRootFromParent_Done,
     /*  28889 */   // Label 477: @28889
     /*  28889 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(28937), // Rule ID 1713 //
     /*  28894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28924 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  28927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28935 */     GIR_RootConstrainSelectedInstOperands,
     /*  28936 */     // GIR_Coverage, 1713,
     /*  28936 */     GIR_EraseRootFromParent_Done,
     /*  28937 */   // Label 478: @28937
     /*  28937 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(28985), // Rule ID 1048 //
     /*  28942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  28961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28972 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  28975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28983 */     GIR_RootConstrainSelectedInstOperands,
     /*  28984 */     // GIR_Coverage, 1048,
     /*  28984 */     GIR_EraseRootFromParent_Done,
     /*  28985 */   // Label 479: @28985
     /*  28985 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(29033), // Rule ID 1799 //
     /*  28990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29020 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  29023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  29031 */     GIR_RootConstrainSelectedInstOperands,
     /*  29032 */     // GIR_Coverage, 1799,
     /*  29032 */     GIR_EraseRootFromParent_Done,
     /*  29033 */   // Label 480: @29033
     /*  29033 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(29060), // Rule ID 1098 //
     /*  29038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29053 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  29058 */     GIR_RootConstrainSelectedInstOperands,
     /*  29059 */     // GIR_Coverage, 1098,
     /*  29059 */     GIR_Done,
     /*  29060 */   // Label 481: @29060
     /*  29060 */   GIM_Reject,
     /*  29061 */ // Label 400: @29061
     /*  29061 */ GIM_Reject,
     /*  29062 */ // Label 164: @29062
     /*  29062 */ GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(29911),
     /*  29067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29073 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(29206), // Rule ID 13740 //
     /*  29078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  29090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  29110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  29123 */     // MIs[1] Operand 2
     /*  29123 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  29134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  29138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  29142 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29146 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  29150 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  29154 */     // MIs[5] Rn
     /*  29154 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  29159 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  29161 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  29161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  29164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  29168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29188 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  29195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29205 */     // GIR_Coverage, 13740,
     /*  29205 */     GIR_EraseRootFromParent_Done,
     /*  29206 */   // Label 483: @29206
     /*  29206 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(29339), // Rule ID 6853 //
     /*  29211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  29223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  29235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  29248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  29252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29256 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  29260 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  29264 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  29268 */     // MIs[4] Rn
     /*  29268 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  29273 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  29277 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  29281 */     // MIs[3] Operand 2
     /*  29281 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  29292 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  29294 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  29294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  29297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  29301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  29328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29338 */     // GIR_Coverage, 6853,
     /*  29338 */     GIR_EraseRootFromParent_Done,
     /*  29339 */   // Label 484: @29339
     /*  29339 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(29408), // Rule ID 13136 //
     /*  29344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29359 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29362 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29406 */     GIR_RootConstrainSelectedInstOperands,
     /*  29407 */     // GIR_Coverage, 13136,
     /*  29407 */     GIR_EraseRootFromParent_Done,
     /*  29408 */   // Label 485: @29408
     /*  29408 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(29477), // Rule ID 13148 //
     /*  29413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29460 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  29463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29475 */     GIR_RootConstrainSelectedInstOperands,
     /*  29476 */     // GIR_Coverage, 13148,
     /*  29476 */     GIR_EraseRootFromParent_Done,
     /*  29477 */   // Label 486: @29477
     /*  29477 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(29544), // Rule ID 13340 //
     /*  29482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29506 */     // MIs[1] imm
     /*  29506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29518 */     // MIs[2] Operand 1
     /*  29518 */     // No operand predicates
     /*  29518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29528 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  29531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29542 */     GIR_RootConstrainSelectedInstOperands,
     /*  29543 */     // GIR_Coverage, 13340,
     /*  29543 */     GIR_EraseRootFromParent_Done,
     /*  29544 */   // Label 487: @29544
     /*  29544 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(29611), // Rule ID 13361 //
     /*  29549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29573 */     // MIs[1] imm
     /*  29573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29585 */     // MIs[2] Operand 1
     /*  29585 */     // No operand predicates
     /*  29585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29595 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  29598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29609 */     GIR_RootConstrainSelectedInstOperands,
     /*  29610 */     // GIR_Coverage, 13361,
     /*  29610 */     GIR_EraseRootFromParent_Done,
     /*  29611 */   // Label 488: @29611
     /*  29611 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(29680), // Rule ID 1350 //
     /*  29616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29635 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29638 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29663 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  29666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29678 */     GIR_RootConstrainSelectedInstOperands,
     /*  29679 */     // GIR_Coverage, 1350,
     /*  29679 */     GIR_EraseRootFromParent_Done,
     /*  29680 */   // Label 489: @29680
     /*  29680 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(29749), // Rule ID 1473 //
     /*  29685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29704 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29707 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29716 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29732 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  29735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29747 */     GIR_RootConstrainSelectedInstOperands,
     /*  29748 */     // GIR_Coverage, 1473,
     /*  29748 */     GIR_EraseRootFromParent_Done,
     /*  29749 */   // Label 490: @29749
     /*  29749 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(29816), // Rule ID 2221 //
     /*  29754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29782 */     // MIs[1] imm
     /*  29782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29794 */     // MIs[2] Operand 1
     /*  29794 */     // No operand predicates
     /*  29794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29800 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  29803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29814 */     GIR_RootConstrainSelectedInstOperands,
     /*  29815 */     // GIR_Coverage, 2221,
     /*  29815 */     GIR_EraseRootFromParent_Done,
     /*  29816 */   // Label 491: @29816
     /*  29816 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(29883), // Rule ID 2280 //
     /*  29821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29849 */     // MIs[1] imm
     /*  29849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29857 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29861 */     // MIs[2] Operand 1
     /*  29861 */     // No operand predicates
     /*  29861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29867 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  29870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29881 */     GIR_RootConstrainSelectedInstOperands,
     /*  29882 */     // GIR_Coverage, 2280,
     /*  29882 */     GIR_EraseRootFromParent_Done,
     /*  29883 */   // Label 492: @29883
     /*  29883 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(29910), // Rule ID 1093 //
     /*  29888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29903 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  29908 */     GIR_RootConstrainSelectedInstOperands,
     /*  29909 */     // GIR_Coverage, 1093,
     /*  29909 */     GIR_Done,
     /*  29910 */   // Label 493: @29910
     /*  29910 */   GIM_Reject,
     /*  29911 */ // Label 482: @29911
     /*  29911 */ GIM_Reject,
     /*  29912 */ // Label 165: @29912
     /*  29912 */ GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(33489),
     /*  29917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29923 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30010), // Rule ID 13180 //
     /*  29928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29955 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  29958 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29967 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  29984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  29991 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  29991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  29994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30008 */     GIR_RootConstrainSelectedInstOperands,
     /*  30009 */     // GIR_Coverage, 13180,
     /*  30009 */     GIR_EraseRootFromParent_Done,
     /*  30010 */   // Label 495: @30010
     /*  30010 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(30097), // Rule ID 13204 //
     /*  30015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30042 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30045 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30054 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30078 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  30081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30095 */     GIR_RootConstrainSelectedInstOperands,
     /*  30096 */     // GIR_Coverage, 13204,
     /*  30096 */     GIR_EraseRootFromParent_Done,
     /*  30097 */   // Label 496: @30097
     /*  30097 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(30184), // Rule ID 1684 //
     /*  30102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30133 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30136 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  30141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30145 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30165 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  30168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30182 */     GIR_RootConstrainSelectedInstOperands,
     /*  30183 */     // GIR_Coverage, 1684,
     /*  30183 */     GIR_EraseRootFromParent_Done,
     /*  30184 */   // Label 497: @30184
     /*  30184 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(30271), // Rule ID 1762 //
     /*  30189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30220 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30223 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30232 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30252 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  30255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30269 */     GIR_RootConstrainSelectedInstOperands,
     /*  30270 */     // GIR_Coverage, 1762,
     /*  30270 */     GIR_EraseRootFromParent_Done,
     /*  30271 */   // Label 498: @30271
     /*  30271 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(30340), // Rule ID 1778 //
     /*  30276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30323 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30338 */     GIR_RootConstrainSelectedInstOperands,
     /*  30339 */     // GIR_Coverage, 1778,
     /*  30339 */     GIR_EraseRootFromParent_Done,
     /*  30340 */   // Label 499: @30340
     /*  30340 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(30409), // Rule ID 1777 //
     /*  30345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30392 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30407 */     GIR_RootConstrainSelectedInstOperands,
     /*  30408 */     // GIR_Coverage, 1777,
     /*  30408 */     GIR_EraseRootFromParent_Done,
     /*  30409 */   // Label 500: @30409
     /*  30409 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(30478), // Rule ID 1706 //
     /*  30414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30461 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  30464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30476 */     GIR_RootConstrainSelectedInstOperands,
     /*  30477 */     // GIR_Coverage, 1706,
     /*  30477 */     GIR_EraseRootFromParent_Done,
     /*  30478 */   // Label 501: @30478
     /*  30478 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(30547), // Rule ID 1776 //
     /*  30483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30530 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30545 */     GIR_RootConstrainSelectedInstOperands,
     /*  30546 */     // GIR_Coverage, 1776,
     /*  30546 */     GIR_EraseRootFromParent_Done,
     /*  30547 */   // Label 502: @30547
     /*  30547 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(30616), // Rule ID 1775 //
     /*  30552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30599 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30614 */     GIR_RootConstrainSelectedInstOperands,
     /*  30615 */     // GIR_Coverage, 1775,
     /*  30615 */     GIR_EraseRootFromParent_Done,
     /*  30616 */   // Label 503: @30616
     /*  30616 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(30683), // Rule ID 13196 //
     /*  30621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30664 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  30667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30681 */     GIR_RootConstrainSelectedInstOperands,
     /*  30682 */     // GIR_Coverage, 13196,
     /*  30682 */     GIR_EraseRootFromParent_Done,
     /*  30683 */   // Label 504: @30683
     /*  30683 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(30750), // Rule ID 13226 //
     /*  30688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30731 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  30734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30748 */     GIR_RootConstrainSelectedInstOperands,
     /*  30749 */     // GIR_Coverage, 13226,
     /*  30749 */     GIR_EraseRootFromParent_Done,
     /*  30750 */   // Label 505: @30750
     /*  30750 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(30817), // Rule ID 1718 //
     /*  30755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30798 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  30801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30815 */     GIR_RootConstrainSelectedInstOperands,
     /*  30816 */     // GIR_Coverage, 1718,
     /*  30816 */     GIR_EraseRootFromParent_Done,
     /*  30817 */   // Label 506: @30817
     /*  30817 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(30884), // Rule ID 1808 //
     /*  30822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30865 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  30868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30882 */     GIR_RootConstrainSelectedInstOperands,
     /*  30883 */     // GIR_Coverage, 1808,
     /*  30883 */     GIR_EraseRootFromParent_Done,
     /*  30884 */   // Label 507: @30884
     /*  30884 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(30965), // Rule ID 13178 //
     /*  30889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30916 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30919 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  30924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30928 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30948 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  30948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  30951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  30959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  30963 */     GIR_RootConstrainSelectedInstOperands,
     /*  30964 */     // GIR_Coverage, 13178,
     /*  30964 */     GIR_EraseRootFromParent_Done,
     /*  30965 */   // Label 508: @30965
     /*  30965 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31046), // Rule ID 13202 //
     /*  30970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30997 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31000 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31009 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31029 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  31032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31044 */     GIR_RootConstrainSelectedInstOperands,
     /*  31045 */     // GIR_Coverage, 13202,
     /*  31045 */     GIR_EraseRootFromParent_Done,
     /*  31046 */   // Label 509: @31046
     /*  31046 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(31127), // Rule ID 1682 //
     /*  31051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31082 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31085 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31094 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31110 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  31113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31125 */     GIR_RootConstrainSelectedInstOperands,
     /*  31126 */     // GIR_Coverage, 1682,
     /*  31126 */     GIR_EraseRootFromParent_Done,
     /*  31127 */   // Label 510: @31127
     /*  31127 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(31208), // Rule ID 1760 //
     /*  31132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31163 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31166 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31175 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31191 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  31194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31206 */     GIR_RootConstrainSelectedInstOperands,
     /*  31207 */     // GIR_Coverage, 1760,
     /*  31207 */     GIR_EraseRootFromParent_Done,
     /*  31208 */   // Label 511: @31208
     /*  31208 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(31259), // Rule ID 13216 //
     /*  31213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31245 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31257 */     GIR_RootConstrainSelectedInstOperands,
     /*  31258 */     // GIR_Coverage, 13216,
     /*  31258 */     GIR_EraseRootFromParent_Done,
     /*  31259 */   // Label 512: @31259
     /*  31259 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(31310), // Rule ID 13190 //
     /*  31264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31296 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  31299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31308 */     GIR_RootConstrainSelectedInstOperands,
     /*  31309 */     // GIR_Coverage, 13190,
     /*  31309 */     GIR_EraseRootFromParent_Done,
     /*  31310 */   // Label 513: @31310
     /*  31310 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(31361), // Rule ID 13215 //
     /*  31315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31347 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31359 */     GIR_RootConstrainSelectedInstOperands,
     /*  31360 */     // GIR_Coverage, 13215,
     /*  31360 */     GIR_EraseRootFromParent_Done,
     /*  31361 */   // Label 514: @31361
     /*  31361 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(31412), // Rule ID 1798 //
     /*  31366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31398 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31410 */     GIR_RootConstrainSelectedInstOperands,
     /*  31411 */     // GIR_Coverage, 1798,
     /*  31411 */     GIR_EraseRootFromParent_Done,
     /*  31412 */   // Label 515: @31412
     /*  31412 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(31463), // Rule ID 1712 //
     /*  31417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31449 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  31452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31461 */     GIR_RootConstrainSelectedInstOperands,
     /*  31462 */     // GIR_Coverage, 1712,
     /*  31462 */     GIR_EraseRootFromParent_Done,
     /*  31463 */   // Label 516: @31463
     /*  31463 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(31514), // Rule ID 1797 //
     /*  31468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31500 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31512 */     GIR_RootConstrainSelectedInstOperands,
     /*  31513 */     // GIR_Coverage, 1797,
     /*  31513 */     GIR_EraseRootFromParent_Done,
     /*  31514 */   // Label 517: @31514
     /*  31514 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(31583), // Rule ID 13142 //
     /*  31519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31534 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31537 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31546 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31566 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  31569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31581 */     GIR_RootConstrainSelectedInstOperands,
     /*  31582 */     // GIR_Coverage, 13142,
     /*  31582 */     GIR_EraseRootFromParent_Done,
     /*  31583 */   // Label 518: @31583
     /*  31583 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(31652), // Rule ID 13154 //
     /*  31588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31603 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31606 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31615 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31635 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  31638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31650 */     GIR_RootConstrainSelectedInstOperands,
     /*  31651 */     // GIR_Coverage, 13154,
     /*  31651 */     GIR_EraseRootFromParent_Done,
     /*  31652 */   // Label 519: @31652
     /*  31652 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(31708), // Rule ID 13104 //
     /*  31657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31672 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  31675 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  31680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31695 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  31695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  31698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31706 */     GIR_RootConstrainSelectedInstOperands,
     /*  31707 */     // GIR_Coverage, 13104,
     /*  31707 */     GIR_EraseRootFromParent_Done,
     /*  31708 */   // Label 520: @31708
     /*  31708 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(31764), // Rule ID 13116 //
     /*  31713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31728 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  31731 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  31736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31751 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  31751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  31754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31762 */     GIR_RootConstrainSelectedInstOperands,
     /*  31763 */     // GIR_Coverage, 13116,
     /*  31763 */     GIR_EraseRootFromParent_Done,
     /*  31764 */   // Label 521: @31764
     /*  31764 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(31831), // Rule ID 13346 //
     /*  31769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31793 */     // MIs[1] imm
     /*  31793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  31805 */     // MIs[2] Operand 1
     /*  31805 */     // No operand predicates
     /*  31805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31815 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  31818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31829 */     GIR_RootConstrainSelectedInstOperands,
     /*  31830 */     // GIR_Coverage, 13346,
     /*  31830 */     GIR_EraseRootFromParent_Done,
     /*  31831 */   // Label 522: @31831
     /*  31831 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(31898), // Rule ID 13367 //
     /*  31836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31860 */     // MIs[1] imm
     /*  31860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  31872 */     // MIs[2] Operand 1
     /*  31872 */     // No operand predicates
     /*  31872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31882 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  31885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31896 */     GIR_RootConstrainSelectedInstOperands,
     /*  31897 */     // GIR_Coverage, 13367,
     /*  31897 */     GIR_EraseRootFromParent_Done,
     /*  31898 */   // Label 523: @31898
     /*  31898 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(31967), // Rule ID 1356 //
     /*  31903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31922 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31925 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31934 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31950 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  31953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31965 */     GIR_RootConstrainSelectedInstOperands,
     /*  31966 */     // GIR_Coverage, 1356,
     /*  31966 */     GIR_EraseRootFromParent_Done,
     /*  31967 */   // Label 524: @31967
     /*  31967 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(32036), // Rule ID 1479 //
     /*  31972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31991 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31994 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32003 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  32007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32019 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  32019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  32022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32034 */     GIR_RootConstrainSelectedInstOperands,
     /*  32035 */     // GIR_Coverage, 1479,
     /*  32035 */     GIR_EraseRootFromParent_Done,
     /*  32036 */   // Label 525: @32036
     /*  32036 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(32092), // Rule ID 984 //
     /*  32041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32060 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  32063 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  32068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  32072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32079 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  32082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32090 */     GIR_RootConstrainSelectedInstOperands,
     /*  32091 */     // GIR_Coverage, 984,
     /*  32091 */     GIR_EraseRootFromParent_Done,
     /*  32092 */   // Label 526: @32092
     /*  32092 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(32148), // Rule ID 1045 //
     /*  32097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32116 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  32119 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  32124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  32128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32135 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  32138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32146 */     GIR_RootConstrainSelectedInstOperands,
     /*  32147 */     // GIR_Coverage, 1045,
     /*  32147 */     GIR_EraseRootFromParent_Done,
     /*  32148 */   // Label 527: @32148
     /*  32148 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(32215), // Rule ID 2227 //
     /*  32153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  32172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32181 */     // MIs[1] imm
     /*  32181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  32193 */     // MIs[2] Operand 1
     /*  32193 */     // No operand predicates
     /*  32193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32199 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  32202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32213 */     GIR_RootConstrainSelectedInstOperands,
     /*  32214 */     // GIR_Coverage, 2227,
     /*  32214 */     GIR_EraseRootFromParent_Done,
     /*  32215 */   // Label 528: @32215
     /*  32215 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(32282), // Rule ID 2286 //
     /*  32220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  32239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32248 */     // MIs[1] imm
     /*  32248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32256 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  32260 */     // MIs[2] Operand 1
     /*  32260 */     // No operand predicates
     /*  32260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32266 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  32269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32280 */     GIR_RootConstrainSelectedInstOperands,
     /*  32281 */     // GIR_Coverage, 2286,
     /*  32281 */     GIR_EraseRootFromParent_Done,
     /*  32282 */   // Label 529: @32282
     /*  32282 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(32352), // Rule ID 6849 //
     /*  32287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  32299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  32325 */     // MIs[2] Rn
     /*  32325 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  32330 */     // MIs[2] Rm
     /*  32330 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  32335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32337 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  32337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  32340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32350 */     GIR_RootConstrainSelectedInstOperands,
     /*  32351 */     // GIR_Coverage, 6849,
     /*  32351 */     GIR_EraseRootFromParent_Done,
     /*  32352 */   // Label 530: @32352
     /*  32352 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(32422), // Rule ID 13736 //
     /*  32357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  32369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  32395 */     // MIs[2] Rn
     /*  32395 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  32400 */     // MIs[2] Rm
     /*  32400 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  32405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32407 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  32407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  32410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32420 */     GIR_RootConstrainSelectedInstOperands,
     /*  32421 */     // GIR_Coverage, 13736,
     /*  32421 */     GIR_EraseRootFromParent_Done,
     /*  32422 */   // Label 531: @32422
     /*  32422 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(32485), // Rule ID 1774 //
     /*  32427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32470 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32483 */     GIR_RootConstrainSelectedInstOperands,
     /*  32484 */     // GIR_Coverage, 1774,
     /*  32484 */     GIR_EraseRootFromParent_Done,
     /*  32485 */   // Label 532: @32485
     /*  32485 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(32548), // Rule ID 1773 //
     /*  32490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32533 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32546 */     GIR_RootConstrainSelectedInstOperands,
     /*  32547 */     // GIR_Coverage, 1773,
     /*  32547 */     GIR_EraseRootFromParent_Done,
     /*  32548 */   // Label 533: @32548
     /*  32548 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(32611), // Rule ID 1705 //
     /*  32553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32596 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  32599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32609 */     GIR_RootConstrainSelectedInstOperands,
     /*  32610 */     // GIR_Coverage, 1705,
     /*  32610 */     GIR_EraseRootFromParent_Done,
     /*  32611 */   // Label 534: @32611
     /*  32611 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(32674), // Rule ID 1772 //
     /*  32616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32659 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32672 */     GIR_RootConstrainSelectedInstOperands,
     /*  32673 */     // GIR_Coverage, 1772,
     /*  32673 */     GIR_EraseRootFromParent_Done,
     /*  32674 */   // Label 535: @32674
     /*  32674 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(32737), // Rule ID 1771 //
     /*  32679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32722 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32735 */     GIR_RootConstrainSelectedInstOperands,
     /*  32736 */     // GIR_Coverage, 1771,
     /*  32736 */     GIR_EraseRootFromParent_Done,
     /*  32737 */   // Label 536: @32737
     /*  32737 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(32798), // Rule ID 13195 //
     /*  32742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32781 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  32784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32796 */     GIR_RootConstrainSelectedInstOperands,
     /*  32797 */     // GIR_Coverage, 13195,
     /*  32797 */     GIR_EraseRootFromParent_Done,
     /*  32798 */   // Label 537: @32798
     /*  32798 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(32859), // Rule ID 13225 //
     /*  32803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32842 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  32845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32857 */     GIR_RootConstrainSelectedInstOperands,
     /*  32858 */     // GIR_Coverage, 13225,
     /*  32858 */     GIR_EraseRootFromParent_Done,
     /*  32859 */   // Label 538: @32859
     /*  32859 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(32907), // Rule ID 13214 //
     /*  32864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32894 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  32897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  32905 */     GIR_RootConstrainSelectedInstOperands,
     /*  32906 */     // GIR_Coverage, 13214,
     /*  32906 */     GIR_EraseRootFromParent_Done,
     /*  32907 */   // Label 539: @32907
     /*  32907 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(32955), // Rule ID 13103 //
     /*  32912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  32927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32942 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  32945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32953 */     GIR_RootConstrainSelectedInstOperands,
     /*  32954 */     // GIR_Coverage, 13103,
     /*  32954 */     GIR_EraseRootFromParent_Done,
     /*  32955 */   // Label 540: @32955
     /*  32955 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33003), // Rule ID 13189 //
     /*  32960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32990 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  32993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33001 */     GIR_RootConstrainSelectedInstOperands,
     /*  33002 */     // GIR_Coverage, 13189,
     /*  33002 */     GIR_EraseRootFromParent_Done,
     /*  33003 */   // Label 541: @33003
     /*  33003 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(33051), // Rule ID 13115 //
     /*  33008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  33023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33038 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33049 */     GIR_RootConstrainSelectedInstOperands,
     /*  33050 */     // GIR_Coverage, 13115,
     /*  33050 */     GIR_EraseRootFromParent_Done,
     /*  33051 */   // Label 542: @33051
     /*  33051 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(33099), // Rule ID 13213 //
     /*  33056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33086 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33097 */     GIR_RootConstrainSelectedInstOperands,
     /*  33098 */     // GIR_Coverage, 13213,
     /*  33098 */     GIR_EraseRootFromParent_Done,
     /*  33099 */   // Label 543: @33099
     /*  33099 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(33160), // Rule ID 1717 //
     /*  33104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33143 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  33146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  33158 */     GIR_RootConstrainSelectedInstOperands,
     /*  33159 */     // GIR_Coverage, 1717,
     /*  33159 */     GIR_EraseRootFromParent_Done,
     /*  33160 */   // Label 544: @33160
     /*  33160 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(33221), // Rule ID 1807 //
     /*  33165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33204 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  33207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  33219 */     GIR_RootConstrainSelectedInstOperands,
     /*  33220 */     // GIR_Coverage, 1807,
     /*  33220 */     GIR_EraseRootFromParent_Done,
     /*  33221 */   // Label 545: @33221
     /*  33221 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(33269), // Rule ID 1796 //
     /*  33226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33256 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33267 */     GIR_RootConstrainSelectedInstOperands,
     /*  33268 */     // GIR_Coverage, 1796,
     /*  33268 */     GIR_EraseRootFromParent_Done,
     /*  33269 */   // Label 546: @33269
     /*  33269 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(33317), // Rule ID 983 //
     /*  33274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  33293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33304 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33315 */     GIR_RootConstrainSelectedInstOperands,
     /*  33316 */     // GIR_Coverage, 983,
     /*  33316 */     GIR_EraseRootFromParent_Done,
     /*  33317 */   // Label 547: @33317
     /*  33317 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(33365), // Rule ID 1711 //
     /*  33322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33352 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  33355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33363 */     GIR_RootConstrainSelectedInstOperands,
     /*  33364 */     // GIR_Coverage, 1711,
     /*  33364 */     GIR_EraseRootFromParent_Done,
     /*  33365 */   // Label 548: @33365
     /*  33365 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(33413), // Rule ID 1044 //
     /*  33370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  33389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33400 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33411 */     GIR_RootConstrainSelectedInstOperands,
     /*  33412 */     // GIR_Coverage, 1044,
     /*  33412 */     GIR_EraseRootFromParent_Done,
     /*  33413 */   // Label 549: @33413
     /*  33413 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(33461), // Rule ID 1795 //
     /*  33418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33448 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33459 */     GIR_RootConstrainSelectedInstOperands,
     /*  33460 */     // GIR_Coverage, 1795,
     /*  33460 */     GIR_EraseRootFromParent_Done,
     /*  33461 */   // Label 550: @33461
     /*  33461 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(33488), // Rule ID 1096 //
     /*  33466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33481 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  33486 */     GIR_RootConstrainSelectedInstOperands,
     /*  33487 */     // GIR_Coverage, 1096,
     /*  33487 */     GIR_Done,
     /*  33488 */   // Label 551: @33488
     /*  33488 */   GIM_Reject,
     /*  33489 */ // Label 494: @33489
     /*  33489 */ GIM_Reject,
     /*  33490 */ // Label 166: @33490
     /*  33490 */ GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34213),
     /*  33495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33501 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(33570), // Rule ID 13138 //
     /*  33506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33521 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33524 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33533 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33553 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  33556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33568 */     GIR_RootConstrainSelectedInstOperands,
     /*  33569 */     // GIR_Coverage, 13138,
     /*  33569 */     GIR_EraseRootFromParent_Done,
     /*  33570 */   // Label 553: @33570
     /*  33570 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(33639), // Rule ID 13150 //
     /*  33575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33590 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33593 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33602 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33622 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33637 */     GIR_RootConstrainSelectedInstOperands,
     /*  33638 */     // GIR_Coverage, 13150,
     /*  33638 */     GIR_EraseRootFromParent_Done,
     /*  33639 */   // Label 554: @33639
     /*  33639 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(33706), // Rule ID 13342 //
     /*  33644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33668 */     // MIs[1] imm
     /*  33668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33680 */     // MIs[2] Operand 1
     /*  33680 */     // No operand predicates
     /*  33680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33690 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  33693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33704 */     GIR_RootConstrainSelectedInstOperands,
     /*  33705 */     // GIR_Coverage, 13342,
     /*  33705 */     GIR_EraseRootFromParent_Done,
     /*  33706 */   // Label 555: @33706
     /*  33706 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(33773), // Rule ID 13363 //
     /*  33711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33735 */     // MIs[1] imm
     /*  33735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33747 */     // MIs[2] Operand 1
     /*  33747 */     // No operand predicates
     /*  33747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33757 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  33760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33771 */     GIR_RootConstrainSelectedInstOperands,
     /*  33772 */     // GIR_Coverage, 13363,
     /*  33772 */     GIR_EraseRootFromParent_Done,
     /*  33773 */   // Label 556: @33773
     /*  33773 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(33842), // Rule ID 1352 //
     /*  33778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33797 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33800 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33809 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33825 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  33828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33840 */     GIR_RootConstrainSelectedInstOperands,
     /*  33841 */     // GIR_Coverage, 1352,
     /*  33841 */     GIR_EraseRootFromParent_Done,
     /*  33842 */   // Label 557: @33842
     /*  33842 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(33911), // Rule ID 1475 //
     /*  33847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33866 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33869 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33894 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  33897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33909 */     GIR_RootConstrainSelectedInstOperands,
     /*  33910 */     // GIR_Coverage, 1475,
     /*  33910 */     GIR_EraseRootFromParent_Done,
     /*  33911 */   // Label 558: @33911
     /*  33911 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(33978), // Rule ID 2223 //
     /*  33916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33944 */     // MIs[1] imm
     /*  33944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33952 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33956 */     // MIs[2] Operand 1
     /*  33956 */     // No operand predicates
     /*  33956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33962 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  33965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33976 */     GIR_RootConstrainSelectedInstOperands,
     /*  33977 */     // GIR_Coverage, 2223,
     /*  33977 */     GIR_EraseRootFromParent_Done,
     /*  33978 */   // Label 559: @33978
     /*  33978 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(34045), // Rule ID 2282 //
     /*  33983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34011 */     // MIs[1] imm
     /*  34011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  34023 */     // MIs[2] Operand 1
     /*  34023 */     // No operand predicates
     /*  34023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34029 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  34032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34043 */     GIR_RootConstrainSelectedInstOperands,
     /*  34044 */     // GIR_Coverage, 2282,
     /*  34044 */     GIR_EraseRootFromParent_Done,
     /*  34045 */   // Label 560: @34045
     /*  34045 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(34115), // Rule ID 6850 //
     /*  34050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34088 */     // MIs[2] Rn
     /*  34088 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34093 */     // MIs[2] Rm
     /*  34093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34100 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  34100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  34103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34113 */     GIR_RootConstrainSelectedInstOperands,
     /*  34114 */     // GIR_Coverage, 6850,
     /*  34114 */     GIR_EraseRootFromParent_Done,
     /*  34115 */   // Label 561: @34115
     /*  34115 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(34185), // Rule ID 13737 //
     /*  34120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34158 */     // MIs[2] Rn
     /*  34158 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34163 */     // MIs[2] Rm
     /*  34163 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34170 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  34170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  34173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34183 */     GIR_RootConstrainSelectedInstOperands,
     /*  34184 */     // GIR_Coverage, 13737,
     /*  34184 */     GIR_EraseRootFromParent_Done,
     /*  34185 */   // Label 562: @34185
     /*  34185 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(34212), // Rule ID 1094 //
     /*  34190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34205 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  34205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  34210 */     GIR_RootConstrainSelectedInstOperands,
     /*  34211 */     // GIR_Coverage, 1094,
     /*  34211 */     GIR_Done,
     /*  34212 */   // Label 563: @34212
     /*  34212 */   GIM_Reject,
     /*  34213 */ // Label 552: @34213
     /*  34213 */ GIM_Reject,
     /*  34214 */ // Label 167: @34214
     /*  34214 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(34585),
     /*  34219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34229 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(34291), // Rule ID 14921 //
     /*  34234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34265 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34278 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  34289 */     GIR_RootConstrainSelectedInstOperands,
     /*  34290 */     // GIR_Coverage, 14921,
     /*  34290 */     GIR_EraseRootFromParent_Done,
     /*  34291 */   // Label 565: @34291
     /*  34291 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(34353), // Rule ID 14920 //
     /*  34296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34327 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34340 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34351 */     GIR_RootConstrainSelectedInstOperands,
     /*  34352 */     // GIR_Coverage, 14920,
     /*  34352 */     GIR_EraseRootFromParent_Done,
     /*  34353 */   // Label 566: @34353
     /*  34353 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34415), // Rule ID 14919 //
     /*  34358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34389 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34402 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  34413 */     GIR_RootConstrainSelectedInstOperands,
     /*  34414 */     // GIR_Coverage, 14919,
     /*  34414 */     GIR_EraseRootFromParent_Done,
     /*  34415 */   // Label 567: @34415
     /*  34415 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(34477), // Rule ID 8789 //
     /*  34420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34451 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34464 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34475 */     GIR_RootConstrainSelectedInstOperands,
     /*  34476 */     // GIR_Coverage, 8789,
     /*  34476 */     GIR_EraseRootFromParent_Done,
     /*  34477 */   // Label 568: @34477
     /*  34477 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(34523), // Rule ID 14922 //
     /*  34482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  34493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34497 */     // MIs[1] Operand 2
     /*  34497 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  34508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34510 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  34513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34521 */     GIR_RootConstrainSelectedInstOperands,
     /*  34522 */     // GIR_Coverage, 14922,
     /*  34522 */     GIR_EraseRootFromParent_Done,
     /*  34523 */   // Label 569: @34523
     /*  34523 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(34569), // Rule ID 8790 //
     /*  34528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  34539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34543 */     // MIs[1] Operand 2
     /*  34543 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  34554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34556 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  34559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34567 */     GIR_RootConstrainSelectedInstOperands,
     /*  34568 */     // GIR_Coverage, 8790,
     /*  34568 */     GIR_EraseRootFromParent_Done,
     /*  34569 */   // Label 570: @34569
     /*  34569 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(34584), // Rule ID 2771 //
     /*  34574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34577 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  34582 */     GIR_RootConstrainSelectedInstOperands,
     /*  34583 */     // GIR_Coverage, 2771,
     /*  34583 */     GIR_Done,
     /*  34584 */   // Label 571: @34584
     /*  34584 */   GIM_Reject,
     /*  34585 */ // Label 564: @34585
     /*  34585 */ GIM_Reject,
     /*  34586 */ // Label 168: @34586
     /*  34586 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(34611), // Rule ID 2770 //
     /*  34591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  34597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  34600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34604 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  34604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  34609 */   GIR_RootConstrainSelectedInstOperands,
     /*  34610 */   // GIR_Coverage, 2770,
     /*  34610 */   GIR_Done,
     /*  34611 */ // Label 572: @34611
     /*  34611 */ GIM_Reject,
     /*  34612 */ // Label 169: @34612
     /*  34612 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(34637), // Rule ID 2769 //
     /*  34617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  34623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  34626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34630 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  34630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  34635 */   GIR_RootConstrainSelectedInstOperands,
     /*  34636 */   // GIR_Coverage, 2769,
     /*  34636 */   GIR_Done,
     /*  34637 */ // Label 573: @34637
     /*  34637 */ GIM_Reject,
     /*  34638 */ // Label 170: @34638
     /*  34638 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(34663), // Rule ID 2768 //
     /*  34643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  34649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  34652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34656 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  34656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  34661 */   GIR_RootConstrainSelectedInstOperands,
     /*  34662 */   // GIR_Coverage, 2768,
     /*  34662 */   GIR_Done,
     /*  34663 */ // Label 574: @34663
     /*  34663 */ GIM_Reject,
     /*  34664 */ // Label 171: @34664
     /*  34664 */ GIM_Reject,
     /*  34665 */ // Label 1: @34665
     /*  34665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 588*/ GIMT_Encode4(48012),
     /*  34676 */ /*GILLT_s32*//*Label 575*/ GIMT_Encode4(34764),
     /*  34680 */ /*GILLT_s64*//*Label 576*/ GIMT_Encode4(35618), GIMT_Encode4(0),
     /*  34688 */ /*GILLT_v2s32*//*Label 577*/ GIMT_Encode4(38648),
     /*  34692 */ /*GILLT_v2s64*//*Label 578*/ GIMT_Encode4(40139),
     /*  34696 */ /*GILLT_v4s16*//*Label 579*/ GIMT_Encode4(42599),
     /*  34700 */ /*GILLT_v4s32*//*Label 580*/ GIMT_Encode4(44090),
     /*  34704 */ /*GILLT_v8s8*//*Label 581*/ GIMT_Encode4(46550),
     /*  34708 */ /*GILLT_v8s16*//*Label 582*/ GIMT_Encode4(46625),
     /*  34712 */ /*GILLT_v16s8*//*Label 583*/ GIMT_Encode4(47833), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  34732 */ /*GILLT_nxv2s64*//*Label 584*/ GIMT_Encode4(47908), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  34744 */ /*GILLT_nxv4s32*//*Label 585*/ GIMT_Encode4(47934), GIMT_Encode4(0),
     /*  34752 */ /*GILLT_nxv8s16*//*Label 586*/ GIMT_Encode4(47960), GIMT_Encode4(0),
     /*  34760 */ /*GILLT_nxv16s8*//*Label 587*/ GIMT_Encode4(47986),
     /*  34764 */ // Label 575: @34764
     /*  34764 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(35617),
     /*  34769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  34772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  34775 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(34927), // Rule ID 9836 //
     /*  34780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  34783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  34799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34811 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  34814 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  34819 */     // MIs[2] pattern
     /*  34819 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  34822 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  34827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34829 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  34829 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  34832 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34836 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  34843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  34846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  34850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34855 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  34858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  34862 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  34865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  34870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  34875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  34883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  34887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  34899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  34902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  34916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  34926 */     // GIR_Coverage, 9836,
     /*  34926 */     GIR_EraseRootFromParent_Done,
     /*  34927 */   // Label 590: @34927
     /*  34927 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(35079), // Rule ID 9848 //
     /*  34932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  34935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  34951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  34955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34963 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  34966 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  34971 */     // MIs[2] pattern
     /*  34971 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  34974 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  34979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34981 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  34981 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  34984 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34988 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  34995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  34998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35007 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35010 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35014 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35027 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  35039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35078 */     // GIR_Coverage, 9848,
     /*  35078 */     GIR_EraseRootFromParent_Done,
     /*  35079 */   // Label 591: @35079
     /*  35079 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(35231), // Rule ID 9860 //
     /*  35084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  35087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  35103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  35107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35115 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  35118 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  35123 */     // MIs[2] pattern
     /*  35123 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  35126 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  35131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35133 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  35133 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35136 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35140 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  35150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35159 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35166 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35169 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  35191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35203 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35230 */     // GIR_Coverage, 9860,
     /*  35230 */     GIR_EraseRootFromParent_Done,
     /*  35231 */   // Label 592: @35231
     /*  35231 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(35383), // Rule ID 9872 //
     /*  35236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  35239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  35255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  35259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35267 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  35270 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  35275 */     // MIs[2] pattern
     /*  35275 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  35278 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  35283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35285 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  35285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  35302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35311 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35318 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  35343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35348 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35355 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35365 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35382 */     // GIR_Coverage, 9872,
     /*  35382 */     GIR_EraseRootFromParent_Done,
     /*  35383 */   // Label 593: @35383
     /*  35383 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(35445), // Rule ID 3906 //
     /*  35388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  35396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35424 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  35424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  35427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35443 */     GIR_RootConstrainSelectedInstOperands,
     /*  35444 */     // GIR_Coverage, 3906,
     /*  35444 */     GIR_EraseRootFromParent_Done,
     /*  35445 */   // Label 594: @35445
     /*  35445 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(35481), // Rule ID 3871 //
     /*  35450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  35465 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  35465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  35468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35470 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  35472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  35476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35479 */     GIR_RootConstrainSelectedInstOperands,
     /*  35480 */     // GIR_Coverage, 3871,
     /*  35480 */     GIR_EraseRootFromParent_Done,
     /*  35481 */   // Label 595: @35481
     /*  35481 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(35514), // Rule ID 3876 //
     /*  35486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  35501 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  35501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  35504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  35512 */     GIR_RootConstrainSelectedInstOperands,
     /*  35513 */     // GIR_Coverage, 3876,
     /*  35513 */     GIR_EraseRootFromParent_Done,
     /*  35514 */   // Label 596: @35514
     /*  35514 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(35550), // Rule ID 3865 //
     /*  35519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  35534 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  35534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  35537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  35545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35548 */     GIR_RootConstrainSelectedInstOperands,
     /*  35549 */     // GIR_Coverage, 3865,
     /*  35549 */     GIR_EraseRootFromParent_Done,
     /*  35550 */   // Label 597: @35550
     /*  35550 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(35586), // Rule ID 3869 //
     /*  35555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  35570 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  35570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  35573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  35581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35584 */     GIR_RootConstrainSelectedInstOperands,
     /*  35585 */     // GIR_Coverage, 3869,
     /*  35585 */     GIR_EraseRootFromParent_Done,
     /*  35586 */   // Label 598: @35586
     /*  35586 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(35616), // Rule ID 3867 //
     /*  35591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35603 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  35603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  35608 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  35614 */     GIR_RootConstrainSelectedInstOperands,
     /*  35615 */     // GIR_Coverage, 3867,
     /*  35615 */     GIR_Done,
     /*  35616 */   // Label 599: @35616
     /*  35616 */   GIM_Reject,
     /*  35617 */ // Label 589: @35617
     /*  35617 */ GIM_Reject,
     /*  35618 */ // Label 576: @35618
     /*  35618 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(38647),
     /*  35623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  35629 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(35765), // Rule ID 5348 //
     /*  35634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35667 */     // MIs[1] Operand 2
     /*  35667 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35698 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35702 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35707 */     // MIs[3] Operand 2
     /*  35707 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35718 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35720 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  35727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35747 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  35754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35764 */     // GIR_Coverage, 5348,
     /*  35764 */     GIR_EraseRootFromParent_Done,
     /*  35765 */   // Label 601: @35765
     /*  35765 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(35901), // Rule ID 5347 //
     /*  35770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35803 */     // MIs[1] Operand 2
     /*  35803 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35834 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35838 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35843 */     // MIs[3] Operand 2
     /*  35843 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35856 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  35863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  35890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35900 */     // GIR_Coverage, 5347,
     /*  35900 */     GIR_EraseRootFromParent_Done,
     /*  35901 */   // Label 602: @35901
     /*  35901 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(36037), // Rule ID 5357 //
     /*  35906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35939 */     // MIs[1] Operand 2
     /*  35939 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35966 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35970 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35974 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35979 */     // MIs[3] Operand 2
     /*  35979 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35992 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  35999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36036 */     // GIR_Coverage, 5357,
     /*  36036 */     GIR_EraseRootFromParent_Done,
     /*  36037 */   // Label 603: @36037
     /*  36037 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(36173), // Rule ID 5346 //
     /*  36042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36075 */     // MIs[1] Operand 2
     /*  36075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  36086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  36090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36094 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  36102 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  36106 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36110 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36115 */     // MIs[3] Operand 2
     /*  36115 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  36126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  36128 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  36128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  36131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  36135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36155 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36172 */     // GIR_Coverage, 5346,
     /*  36172 */     GIR_EraseRootFromParent_Done,
     /*  36173 */   // Label 604: @36173
     /*  36173 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(36309), // Rule ID 5345 //
     /*  36178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36211 */     // MIs[1] Operand 2
     /*  36211 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  36222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  36226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  36238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36246 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36251 */     // MIs[3] Operand 2
     /*  36251 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  36262 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  36264 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  36264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  36267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  36271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36308 */     // GIR_Coverage, 5345,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 605: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(36446), // Rule ID 3923 //
     /*  36314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36355 */     // MIs[2] Operand 2
     /*  36355 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  36366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36374 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36378 */     // MIs[3] Operand 1
     /*  36378 */     // No operand predicates
     /*  36378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36380 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36380 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36383 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36387 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36392 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36411 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  36417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  36438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36444 */     GIR_RootConstrainSelectedInstOperands,
     /*  36445 */     // GIR_Coverage, 3923,
     /*  36445 */     GIR_EraseRootFromParent_Done,
     /*  36446 */   // Label 606: @36446
     /*  36446 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(36545), // Rule ID 3921 //
     /*  36451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36504 */     // MIs[3] Operand 1
     /*  36504 */     // No operand predicates
     /*  36504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36506 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36518 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36543 */     GIR_RootConstrainSelectedInstOperands,
     /*  36544 */     // GIR_Coverage, 3921,
     /*  36544 */     GIR_EraseRootFromParent_Done,
     /*  36545 */   // Label 607: @36545
     /*  36545 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(36644), // Rule ID 3922 //
     /*  36550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36599 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  36603 */     // MIs[3] Operand 1
     /*  36603 */     // No operand predicates
     /*  36603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36605 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36617 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  36627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36642 */     GIR_RootConstrainSelectedInstOperands,
     /*  36643 */     // GIR_Coverage, 3922,
     /*  36643 */     GIR_EraseRootFromParent_Done,
     /*  36644 */   // Label 608: @36644
     /*  36644 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(36730), // Rule ID 3916 //
     /*  36649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36698 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  36702 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36709 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  36709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  36722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36728 */     GIR_RootConstrainSelectedInstOperands,
     /*  36729 */     // GIR_Coverage, 3916,
     /*  36729 */     GIR_EraseRootFromParent_Done,
     /*  36730 */   // Label 609: @36730
     /*  36730 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(36816), // Rule ID 3917 //
     /*  36735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  36788 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36795 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  36795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  36798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  36808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36814 */     GIR_RootConstrainSelectedInstOperands,
     /*  36815 */     // GIR_Coverage, 3917,
     /*  36815 */     GIR_EraseRootFromParent_Done,
     /*  36816 */   // Label 610: @36816
     /*  36816 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(36949), // Rule ID 3929 //
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36862 */     // MIs[2] Operand 2
     /*  36862 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  36873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36881 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36885 */     // MIs[3] Operand 1
     /*  36885 */     // No operand predicates
     /*  36885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36887 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  36887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36899 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36918 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  36924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  36945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  36947 */     GIR_RootConstrainSelectedInstOperands,
     /*  36948 */     // GIR_Coverage, 3929,
     /*  36948 */     GIR_EraseRootFromParent_Done,
     /*  36949 */   // Label 611: @36949
     /*  36949 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37044), // Rule ID 3927 //
     /*  36954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37003 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  37007 */     // MIs[3] Operand 1
     /*  37007 */     // No operand predicates
     /*  37007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37009 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  37009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  37012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  37016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37021 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  37026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  37031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37042 */     GIR_RootConstrainSelectedInstOperands,
     /*  37043 */     // GIR_Coverage, 3927,
     /*  37043 */     GIR_EraseRootFromParent_Done,
     /*  37044 */   // Label 612: @37044
     /*  37044 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37139), // Rule ID 3928 //
     /*  37049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37098 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  37102 */     // MIs[3] Operand 1
     /*  37102 */     // No operand predicates
     /*  37102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37104 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  37104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  37107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  37111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37116 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  37121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  37126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37137 */     GIR_RootConstrainSelectedInstOperands,
     /*  37138 */     // GIR_Coverage, 3928,
     /*  37138 */     GIR_EraseRootFromParent_Done,
     /*  37139 */   // Label 613: @37139
     /*  37139 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(37221), // Rule ID 124 //
     /*  37144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  37176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  37193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  37197 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37204 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  37204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  37207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  37217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37219 */     GIR_RootConstrainSelectedInstOperands,
     /*  37220 */     // GIR_Coverage, 124,
     /*  37220 */     GIR_EraseRootFromParent_Done,
     /*  37221 */   // Label 614: @37221
     /*  37221 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(37303), // Rule ID 126 //
     /*  37226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37275 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  37279 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37286 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  37286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  37289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  37299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37301 */     GIR_RootConstrainSelectedInstOperands,
     /*  37302 */     // GIR_Coverage, 126,
     /*  37302 */     GIR_EraseRootFromParent_Done,
     /*  37303 */   // Label 615: @37303
     /*  37303 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(37365), // Rule ID 3907 //
     /*  37308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37344 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  37344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  37347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37363 */     GIR_RootConstrainSelectedInstOperands,
     /*  37364 */     // GIR_Coverage, 3907,
     /*  37364 */     GIR_EraseRootFromParent_Done,
     /*  37365 */   // Label 616: @37365
     /*  37365 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(37423), // Rule ID 9833 //
     /*  37370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37389 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37392 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  37397 */     // MIs[1] pattern
     /*  37397 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37400 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37407 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  37410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37421 */     GIR_RootConstrainSelectedInstOperands,
     /*  37422 */     // GIR_Coverage, 9833,
     /*  37422 */     GIR_EraseRootFromParent_Done,
     /*  37423 */   // Label 617: @37423
     /*  37423 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(37481), // Rule ID 9845 //
     /*  37428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37447 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37450 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  37455 */     // MIs[1] pattern
     /*  37455 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37458 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37465 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  37468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37479 */     GIR_RootConstrainSelectedInstOperands,
     /*  37480 */     // GIR_Coverage, 9845,
     /*  37480 */     GIR_EraseRootFromParent_Done,
     /*  37481 */   // Label 618: @37481
     /*  37481 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(37539), // Rule ID 9857 //
     /*  37486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37505 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37508 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37513 */     // MIs[1] pattern
     /*  37513 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37516 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37523 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37537 */     GIR_RootConstrainSelectedInstOperands,
     /*  37538 */     // GIR_Coverage, 9857,
     /*  37538 */     GIR_EraseRootFromParent_Done,
     /*  37539 */   // Label 619: @37539
     /*  37539 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(37597), // Rule ID 9869 //
     /*  37544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37563 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37566 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37571 */     // MIs[1] pattern
     /*  37571 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37574 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37581 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37595 */     GIR_RootConstrainSelectedInstOperands,
     /*  37596 */     // GIR_Coverage, 9869,
     /*  37596 */     GIR_EraseRootFromParent_Done,
     /*  37597 */   // Label 620: @37597
     /*  37597 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(37760), // Rule ID 5312 //
     /*  37602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  37630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37648 */     // MIs[1] Operand 2
     /*  37648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37661 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37661 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37664 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37668 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37687 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  37694 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37702 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  37715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  37719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  37735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  37749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37759 */     // GIR_Coverage, 5312,
     /*  37759 */     GIR_EraseRootFromParent_Done,
     /*  37760 */   // Label 621: @37760
     /*  37760 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(37923), // Rule ID 5309 //
     /*  37765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  37793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37811 */     // MIs[1] Operand 2
     /*  37811 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37824 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37850 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37853 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  37857 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  37878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  37882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  37898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37905 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  37912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37922 */     // GIR_Coverage, 5309,
     /*  37922 */     GIR_EraseRootFromParent_Done,
     /*  37923 */   // Label 622: @37923
     /*  37923 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38073), // Rule ID 5354 //
     /*  37928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  37956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37965 */     // MIs[1] Operand 2
     /*  37965 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37978 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38004 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38011 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  38036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38055 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38072 */     // GIR_Coverage, 5354,
     /*  38072 */     GIR_EraseRootFromParent_Done,
     /*  38073 */   // Label 623: @38073
     /*  38073 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38223), // Rule ID 5360 //
     /*  38078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38115 */     // MIs[1] Operand 2
     /*  38115 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38128 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38128 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  38131 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38135 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  38145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38154 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38157 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38161 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38169 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  38186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38205 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38222 */     // GIR_Coverage, 5360,
     /*  38222 */     GIR_EraseRootFromParent_Done,
     /*  38223 */   // Label 624: @38223
     /*  38223 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(38373), // Rule ID 5353 //
     /*  38228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38265 */     // MIs[1] Operand 2
     /*  38265 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38278 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38278 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  38281 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38285 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38292 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  38295 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38299 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38304 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38311 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38314 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38319 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  38336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38355 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38372 */     // GIR_Coverage, 5353,
     /*  38372 */     GIR_EraseRootFromParent_Done,
     /*  38373 */   // Label 625: @38373
     /*  38373 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(38409), // Rule ID 3872 //
     /*  38378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  38393 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  38393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  38396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38398 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38407 */     GIR_RootConstrainSelectedInstOperands,
     /*  38408 */     // GIR_Coverage, 3872,
     /*  38408 */     GIR_EraseRootFromParent_Done,
     /*  38409 */   // Label 626: @38409
     /*  38409 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(38442), // Rule ID 3877 //
     /*  38414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  38429 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  38429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  38432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38440 */     GIR_RootConstrainSelectedInstOperands,
     /*  38441 */     // GIR_Coverage, 3877,
     /*  38441 */     GIR_EraseRootFromParent_Done,
     /*  38442 */   // Label 627: @38442
     /*  38442 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(38478), // Rule ID 3866 //
     /*  38447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  38462 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  38462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  38465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38476 */     GIR_RootConstrainSelectedInstOperands,
     /*  38477 */     // GIR_Coverage, 3866,
     /*  38477 */     GIR_EraseRootFromParent_Done,
     /*  38478 */   // Label 628: @38478
     /*  38478 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(38514), // Rule ID 3870 //
     /*  38483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  38498 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  38498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  38501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38512 */     GIR_RootConstrainSelectedInstOperands,
     /*  38513 */     // GIR_Coverage, 3870,
     /*  38513 */     GIR_EraseRootFromParent_Done,
     /*  38514 */   // Label 629: @38514
     /*  38514 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(38553), // Rule ID 1648 //
     /*  38519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38530 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38536 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  38538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38544 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  38544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  38547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  38551 */     GIR_RootConstrainSelectedInstOperands,
     /*  38552 */     // GIR_Coverage, 1648,
     /*  38552 */     GIR_EraseRootFromParent_Done,
     /*  38553 */   // Label 630: @38553
     /*  38553 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(38589), // Rule ID 5195 //
     /*  38558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  38574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38580 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  38580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  38583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  38587 */     GIR_RootConstrainSelectedInstOperands,
     /*  38588 */     // GIR_Coverage, 5195,
     /*  38588 */     GIR_EraseRootFromParent_Done,
     /*  38589 */   // Label 631: @38589
     /*  38589 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(38616), // Rule ID 1637 //
     /*  38594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38609 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  38609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  38614 */     GIR_RootConstrainSelectedInstOperands,
     /*  38615 */     // GIR_Coverage, 1637,
     /*  38615 */     GIR_Done,
     /*  38616 */   // Label 632: @38616
     /*  38616 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(38646), // Rule ID 3868 //
     /*  38621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38633 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  38633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  38638 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38644 */     GIR_RootConstrainSelectedInstOperands,
     /*  38645 */     // GIR_Coverage, 3868,
     /*  38645 */     GIR_Done,
     /*  38646 */   // Label 633: @38646
     /*  38646 */   GIM_Reject,
     /*  38647 */ // Label 600: @38647
     /*  38647 */ GIM_Reject,
     /*  38648 */ // Label 577: @38648
     /*  38648 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40138),
     /*  38653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38663 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(38795), // Rule ID 5344 //
     /*  38668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38697 */     // MIs[1] Operand 2
     /*  38697 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38728 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38732 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38737 */     // MIs[3] Operand 2
     /*  38737 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38750 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  38753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  38757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38777 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38794 */     // GIR_Coverage, 5344,
     /*  38794 */     GIR_EraseRootFromParent_Done,
     /*  38795 */   // Label 635: @38795
     /*  38795 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(38927), // Rule ID 5343 //
     /*  38800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38829 */     // MIs[1] Operand 2
     /*  38829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38860 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38864 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38869 */     // MIs[3] Operand 2
     /*  38869 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38882 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  38885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  38889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38926 */     // GIR_Coverage, 5343,
     /*  38926 */     GIR_EraseRootFromParent_Done,
     /*  38927 */   // Label 636: @38927
     /*  38927 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(39059), // Rule ID 5356 //
     /*  38932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38961 */     // MIs[1] Operand 2
     /*  38961 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38992 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38996 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39001 */     // MIs[3] Operand 2
     /*  39001 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39012 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39014 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  39021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39041 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39058 */     // GIR_Coverage, 5356,
     /*  39058 */     GIR_EraseRootFromParent_Done,
     /*  39059 */   // Label 637: @39059
     /*  39059 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(39191), // Rule ID 5342 //
     /*  39064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39093 */     // MIs[1] Operand 2
     /*  39093 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39112 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39124 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39128 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39133 */     // MIs[3] Operand 2
     /*  39133 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39144 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39146 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  39153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39173 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39190 */     // GIR_Coverage, 5342,
     /*  39190 */     GIR_EraseRootFromParent_Done,
     /*  39191 */   // Label 638: @39191
     /*  39191 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(39323), // Rule ID 5341 //
     /*  39196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39225 */     // MIs[1] Operand 2
     /*  39225 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39256 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39260 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39265 */     // MIs[3] Operand 2
     /*  39265 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39278 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  39285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39305 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39322 */     // GIR_Coverage, 5341,
     /*  39322 */     GIR_EraseRootFromParent_Done,
     /*  39323 */   // Label 639: @39323
     /*  39323 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(39482), // Rule ID 5311 //
     /*  39328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39370 */     // MIs[1] Operand 2
     /*  39370 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39383 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39383 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39386 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39390 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39409 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39412 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  39416 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  39441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  39457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39481 */     // GIR_Coverage, 5311,
     /*  39481 */     GIR_EraseRootFromParent_Done,
     /*  39482 */   // Label 640: @39482
     /*  39482 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(39641), // Rule ID 5308 //
     /*  39487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  39511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39529 */     // MIs[1] Operand 2
     /*  39529 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39542 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39568 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  39575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  39600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39605 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  39616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39623 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39640 */     // GIR_Coverage, 5308,
     /*  39640 */     GIR_EraseRootFromParent_Done,
     /*  39641 */   // Label 641: @39641
     /*  39641 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(39787), // Rule ID 5352 //
     /*  39646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39679 */     // MIs[1] Operand 2
     /*  39679 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39692 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39721 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  39725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  39750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39786 */     // GIR_Coverage, 5352,
     /*  39786 */     GIR_EraseRootFromParent_Done,
     /*  39787 */   // Label 642: @39787
     /*  39787 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(39933), // Rule ID 5359 //
     /*  39792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39825 */     // MIs[1] Operand 2
     /*  39825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39838 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39864 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  39871 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39874 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39879 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  39896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39915 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39932 */     // GIR_Coverage, 5359,
     /*  39932 */     GIR_EraseRootFromParent_Done,
     /*  39933 */   // Label 643: @39933
     /*  39933 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(40079), // Rule ID 5351 //
     /*  39938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39971 */     // MIs[1] Operand 2
     /*  39971 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39984 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39984 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39987 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39991 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  40001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40010 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40017 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40030 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  40038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  40042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40078 */     // GIR_Coverage, 5351,
     /*  40078 */     GIR_EraseRootFromParent_Done,
     /*  40079 */   // Label 644: @40079
     /*  40079 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40114), // Rule ID 962 //
     /*  40084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40091 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40097 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  40099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40105 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  40105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  40112 */     GIR_RootConstrainSelectedInstOperands,
     /*  40113 */     // GIR_Coverage, 962,
     /*  40113 */     GIR_EraseRootFromParent_Done,
     /*  40114 */   // Label 645: @40114
     /*  40114 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40137), // Rule ID 1469 //
     /*  40119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40130 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  40130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  40135 */     GIR_RootConstrainSelectedInstOperands,
     /*  40136 */     // GIR_Coverage, 1469,
     /*  40136 */     GIR_Done,
     /*  40137 */   // Label 646: @40137
     /*  40137 */   GIM_Reject,
     /*  40138 */ // Label 634: @40138
     /*  40138 */ GIM_Reject,
     /*  40139 */ // Label 578: @40139
     /*  40139 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(42598),
     /*  40144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  40150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40154 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(40268), // Rule ID 2041 //
     /*  40159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40202 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40206 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40210 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40215 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40219 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40223 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40227 */     // MIs[4] Operand 1
     /*  40227 */     // No operand predicates
     /*  40227 */     // MIs[2] Operand 2
     /*  40227 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40238 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40247 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  40250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40266 */     GIR_RootConstrainSelectedInstOperands,
     /*  40267 */     // GIR_Coverage, 2041,
     /*  40267 */     GIR_EraseRootFromParent_Done,
     /*  40268 */   // Label 648: @40268
     /*  40268 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40382), // Rule ID 13290 //
     /*  40273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40329 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40333 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40337 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40341 */     // MIs[4] Operand 1
     /*  40341 */     // No operand predicates
     /*  40341 */     // MIs[2] Operand 2
     /*  40341 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40361 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  40364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40380 */     GIR_RootConstrainSelectedInstOperands,
     /*  40381 */     // GIR_Coverage, 13290,
     /*  40381 */     GIR_EraseRootFromParent_Done,
     /*  40382 */   // Label 649: @40382
     /*  40382 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(40496), // Rule ID 2093 //
     /*  40387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  40402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40430 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40434 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40438 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40443 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40447 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40451 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40455 */     // MIs[4] Operand 1
     /*  40455 */     // No operand predicates
     /*  40455 */     // MIs[2] Operand 2
     /*  40455 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40466 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40475 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  40478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40494 */     GIR_RootConstrainSelectedInstOperands,
     /*  40495 */     // GIR_Coverage, 2093,
     /*  40495 */     GIR_EraseRootFromParent_Done,
     /*  40496 */   // Label 650: @40496
     /*  40496 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(40610), // Rule ID 13320 //
     /*  40501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  40516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40548 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40552 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40561 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40565 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40569 */     // MIs[4] Operand 1
     /*  40569 */     // No operand predicates
     /*  40569 */     // MIs[2] Operand 2
     /*  40569 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40580 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40589 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  40592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40608 */     GIR_RootConstrainSelectedInstOperands,
     /*  40609 */     // GIR_Coverage, 13320,
     /*  40609 */     GIR_EraseRootFromParent_Done,
     /*  40610 */   // Label 651: @40610
     /*  40610 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(40675), // Rule ID 1848 //
     /*  40615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40658 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40673 */     GIR_RootConstrainSelectedInstOperands,
     /*  40674 */     // GIR_Coverage, 1848,
     /*  40674 */     GIR_EraseRootFromParent_Done,
     /*  40675 */   // Label 652: @40675
     /*  40675 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(40740), // Rule ID 1847 //
     /*  40680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40723 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40738 */     GIR_RootConstrainSelectedInstOperands,
     /*  40739 */     // GIR_Coverage, 1847,
     /*  40739 */     GIR_EraseRootFromParent_Done,
     /*  40740 */   // Label 653: @40740
     /*  40740 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(40805), // Rule ID 1752 //
     /*  40745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40788 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  40791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40803 */     GIR_RootConstrainSelectedInstOperands,
     /*  40804 */     // GIR_Coverage, 1752,
     /*  40804 */     GIR_EraseRootFromParent_Done,
     /*  40805 */   // Label 654: @40805
     /*  40805 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(40870), // Rule ID 1846 //
     /*  40810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40853 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40868 */     GIR_RootConstrainSelectedInstOperands,
     /*  40869 */     // GIR_Coverage, 1846,
     /*  40869 */     GIR_EraseRootFromParent_Done,
     /*  40870 */   // Label 655: @40870
     /*  40870 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(40935), // Rule ID 1845 //
     /*  40875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40918 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40933 */     GIR_RootConstrainSelectedInstOperands,
     /*  40934 */     // GIR_Coverage, 1845,
     /*  40934 */     GIR_EraseRootFromParent_Done,
     /*  40935 */   // Label 656: @40935
     /*  40935 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41046), // Rule ID 13288 //
     /*  40940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40983 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40987 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40991 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41004 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41008 */     // MIs[4] Operand 1
     /*  41008 */     // No operand predicates
     /*  41008 */     // MIs[2] Operand 2
     /*  41008 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41024 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41026 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41044 */     GIR_RootConstrainSelectedInstOperands,
     /*  41045 */     // GIR_Coverage, 13288,
     /*  41045 */     GIR_EraseRootFromParent_Done,
     /*  41046 */   // Label 657: @41046
     /*  41046 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(41157), // Rule ID 2039 //
     /*  41051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41120 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41124 */     // MIs[4] Operand 1
     /*  41124 */     // No operand predicates
     /*  41124 */     // MIs[2] Operand 2
     /*  41124 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41155 */     GIR_RootConstrainSelectedInstOperands,
     /*  41156 */     // GIR_Coverage, 2039,
     /*  41156 */     GIR_EraseRootFromParent_Done,
     /*  41157 */   // Label 658: @41157
     /*  41157 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41268), // Rule ID 13318 //
     /*  41162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41230 */     // MIs[4] Operand 1
     /*  41230 */     // No operand predicates
     /*  41230 */     // MIs[2] Operand 2
     /*  41230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41248 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41266 */     GIR_RootConstrainSelectedInstOperands,
     /*  41267 */     // GIR_Coverage, 13318,
     /*  41267 */     GIR_EraseRootFromParent_Done,
     /*  41268 */   // Label 659: @41268
     /*  41268 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(41379), // Rule ID 2091 //
     /*  41273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41325 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41329 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41342 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41346 */     // MIs[4] Operand 1
     /*  41346 */     // No operand predicates
     /*  41346 */     // MIs[2] Operand 2
     /*  41346 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41357 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41359 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41377 */     GIR_RootConstrainSelectedInstOperands,
     /*  41378 */     // GIR_Coverage, 2091,
     /*  41378 */     GIR_EraseRootFromParent_Done,
     /*  41379 */   // Label 660: @41379
     /*  41379 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(41442), // Rule ID 1728 //
     /*  41384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41423 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  41426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  41435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  41440 */     GIR_RootConstrainSelectedInstOperands,
     /*  41441 */     // GIR_Coverage, 1728,
     /*  41441 */     GIR_EraseRootFromParent_Done,
     /*  41442 */   // Label 661: @41442
     /*  41442 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(41505), // Rule ID 1818 //
     /*  41447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41486 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  41489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  41498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  41503 */     GIR_RootConstrainSelectedInstOperands,
     /*  41504 */     // GIR_Coverage, 1818,
     /*  41504 */     GIR_EraseRootFromParent_Done,
     /*  41505 */   // Label 662: @41505
     /*  41505 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(41593), // Rule ID 13289 //
     /*  41510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41562 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41566 */     // MIs[3] Operand 1
     /*  41566 */     // No operand predicates
     /*  41566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41573 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41591 */     GIR_RootConstrainSelectedInstOperands,
     /*  41592 */     // GIR_Coverage, 13289,
     /*  41592 */     GIR_EraseRootFromParent_Done,
     /*  41593 */   // Label 663: @41593
     /*  41593 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(41681), // Rule ID 2040 //
     /*  41598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41655 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41659 */     // MIs[3] Operand 1
     /*  41659 */     // No operand predicates
     /*  41659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41661 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41679 */     GIR_RootConstrainSelectedInstOperands,
     /*  41680 */     // GIR_Coverage, 2040,
     /*  41680 */     GIR_EraseRootFromParent_Done,
     /*  41681 */   // Label 664: @41681
     /*  41681 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(41769), // Rule ID 13319 //
     /*  41686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41738 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41742 */     // MIs[3] Operand 1
     /*  41742 */     // No operand predicates
     /*  41742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41749 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41767 */     GIR_RootConstrainSelectedInstOperands,
     /*  41768 */     // GIR_Coverage, 13319,
     /*  41768 */     GIR_EraseRootFromParent_Done,
     /*  41769 */   // Label 665: @41769
     /*  41769 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(41857), // Rule ID 2092 //
     /*  41774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41831 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41835 */     // MIs[3] Operand 1
     /*  41835 */     // No operand predicates
     /*  41835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41837 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41855 */     GIR_RootConstrainSelectedInstOperands,
     /*  41856 */     // GIR_Coverage, 2092,
     /*  41856 */     GIR_EraseRootFromParent_Done,
     /*  41857 */   // Label 666: @41857
     /*  41857 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(41904), // Rule ID 1860 //
     /*  41862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41890 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  41893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41902 */     GIR_RootConstrainSelectedInstOperands,
     /*  41903 */     // GIR_Coverage, 1860,
     /*  41903 */     GIR_EraseRootFromParent_Done,
     /*  41904 */   // Label 667: @41904
     /*  41904 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(41951), // Rule ID 1758 //
     /*  41909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41937 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  41940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41949 */     GIR_RootConstrainSelectedInstOperands,
     /*  41950 */     // GIR_Coverage, 1758,
     /*  41950 */     GIR_EraseRootFromParent_Done,
     /*  41951 */   // Label 668: @41951
     /*  41951 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(41998), // Rule ID 1859 //
     /*  41956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41984 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  41987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41996 */     GIR_RootConstrainSelectedInstOperands,
     /*  41997 */     // GIR_Coverage, 1859,
     /*  41997 */     GIR_EraseRootFromParent_Done,
     /*  41998 */   // Label 669: @41998
     /*  41998 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(42057), // Rule ID 1844 //
     /*  42003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42042 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42055 */     GIR_RootConstrainSelectedInstOperands,
     /*  42056 */     // GIR_Coverage, 1844,
     /*  42056 */     GIR_EraseRootFromParent_Done,
     /*  42057 */   // Label 670: @42057
     /*  42057 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(42116), // Rule ID 1843 //
     /*  42062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42101 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42114 */     GIR_RootConstrainSelectedInstOperands,
     /*  42115 */     // GIR_Coverage, 1843,
     /*  42115 */     GIR_EraseRootFromParent_Done,
     /*  42116 */   // Label 671: @42116
     /*  42116 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(42175), // Rule ID 1751 //
     /*  42121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42160 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  42163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42173 */     GIR_RootConstrainSelectedInstOperands,
     /*  42174 */     // GIR_Coverage, 1751,
     /*  42174 */     GIR_EraseRootFromParent_Done,
     /*  42175 */   // Label 672: @42175
     /*  42175 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(42234), // Rule ID 1842 //
     /*  42180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42219 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42232 */     GIR_RootConstrainSelectedInstOperands,
     /*  42233 */     // GIR_Coverage, 1842,
     /*  42233 */     GIR_EraseRootFromParent_Done,
     /*  42234 */   // Label 673: @42234
     /*  42234 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(42293), // Rule ID 1841 //
     /*  42239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42278 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42291 */     GIR_RootConstrainSelectedInstOperands,
     /*  42292 */     // GIR_Coverage, 1841,
     /*  42292 */     GIR_EraseRootFromParent_Done,
     /*  42293 */   // Label 674: @42293
     /*  42293 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(42328), // Rule ID 964 //
     /*  42298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42311 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42319 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  42319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  42322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42326 */     GIR_RootConstrainSelectedInstOperands,
     /*  42327 */     // GIR_Coverage, 964,
     /*  42327 */     GIR_EraseRootFromParent_Done,
     /*  42328 */   // Label 675: @42328
     /*  42328 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(42385), // Rule ID 1727 //
     /*  42333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42368 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  42371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  42383 */     GIR_RootConstrainSelectedInstOperands,
     /*  42384 */     // GIR_Coverage, 1727,
     /*  42384 */     GIR_EraseRootFromParent_Done,
     /*  42385 */   // Label 676: @42385
     /*  42385 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(42442), // Rule ID 1817 //
     /*  42390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  42405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42425 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  42428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  42440 */     GIR_RootConstrainSelectedInstOperands,
     /*  42441 */     // GIR_Coverage, 1817,
     /*  42441 */     GIR_EraseRootFromParent_Done,
     /*  42442 */   // Label 677: @42442
     /*  42442 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(42486), // Rule ID 1858 //
     /*  42447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42473 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  42476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42484 */     GIR_RootConstrainSelectedInstOperands,
     /*  42485 */     // GIR_Coverage, 1858,
     /*  42485 */     GIR_EraseRootFromParent_Done,
     /*  42486 */   // Label 678: @42486
     /*  42486 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(42530), // Rule ID 1757 //
     /*  42491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42517 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  42520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42528 */     GIR_RootConstrainSelectedInstOperands,
     /*  42529 */     // GIR_Coverage, 1757,
     /*  42529 */     GIR_EraseRootFromParent_Done,
     /*  42530 */   // Label 679: @42530
     /*  42530 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(42574), // Rule ID 1857 //
     /*  42535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42561 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  42564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42572 */     GIR_RootConstrainSelectedInstOperands,
     /*  42573 */     // GIR_Coverage, 1857,
     /*  42573 */     GIR_EraseRootFromParent_Done,
     /*  42574 */   // Label 680: @42574
     /*  42574 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(42597), // Rule ID 1471 //
     /*  42579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42590 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  42590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  42595 */     GIR_RootConstrainSelectedInstOperands,
     /*  42596 */     // GIR_Coverage, 1471,
     /*  42596 */     GIR_Done,
     /*  42597 */   // Label 681: @42597
     /*  42597 */   GIM_Reject,
     /*  42598 */ // Label 647: @42598
     /*  42598 */ GIM_Reject,
     /*  42599 */ // Label 579: @42599
     /*  42599 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44089),
     /*  42604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42614 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(42746), // Rule ID 5340 //
     /*  42619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42648 */     // MIs[1] Operand 2
     /*  42648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42671 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42675 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42679 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42688 */     // MIs[3] Operand 2
     /*  42688 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42701 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  42708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42745 */     // GIR_Coverage, 5340,
     /*  42745 */     GIR_EraseRootFromParent_Done,
     /*  42746 */   // Label 683: @42746
     /*  42746 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(42878), // Rule ID 5339 //
     /*  42751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42780 */     // MIs[1] Operand 2
     /*  42780 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42799 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42811 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42815 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42820 */     // MIs[3] Operand 2
     /*  42820 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42833 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  42840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42877 */     // GIR_Coverage, 5339,
     /*  42877 */     GIR_EraseRootFromParent_Done,
     /*  42878 */   // Label 684: @42878
     /*  42878 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(43010), // Rule ID 5355 //
     /*  42883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42912 */     // MIs[1] Operand 2
     /*  42912 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42931 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42947 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42952 */     // MIs[3] Operand 2
     /*  42952 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42965 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  42972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42992 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43009 */     // GIR_Coverage, 5355,
     /*  43009 */     GIR_EraseRootFromParent_Done,
     /*  43010 */   // Label 685: @43010
     /*  43010 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(43142), // Rule ID 5338 //
     /*  43015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43044 */     // MIs[1] Operand 2
     /*  43044 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43067 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43071 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43075 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43079 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43084 */     // MIs[3] Operand 2
     /*  43084 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43095 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43097 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  43104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43124 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43141 */     // GIR_Coverage, 5338,
     /*  43141 */     GIR_EraseRootFromParent_Done,
     /*  43142 */   // Label 686: @43142
     /*  43142 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(43274), // Rule ID 5337 //
     /*  43147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43176 */     // MIs[1] Operand 2
     /*  43176 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43195 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43199 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43203 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43207 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43211 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43216 */     // MIs[3] Operand 2
     /*  43216 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43227 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43229 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  43236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43256 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43273 */     // GIR_Coverage, 5337,
     /*  43273 */     GIR_EraseRootFromParent_Done,
     /*  43274 */   // Label 687: @43274
     /*  43274 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(43433), // Rule ID 5310 //
     /*  43279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  43303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  43311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43321 */     // MIs[1] Operand 2
     /*  43321 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43334 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43334 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43337 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43341 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43360 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43363 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43367 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  43392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43415 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43432 */     // GIR_Coverage, 5310,
     /*  43432 */     GIR_EraseRootFromParent_Done,
     /*  43433 */   // Label 688: @43433
     /*  43433 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(43592), // Rule ID 5307 //
     /*  43438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  43462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  43470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43480 */     // MIs[1] Operand 2
     /*  43480 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43493 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43493 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43496 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43500 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43507 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43510 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43514 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43519 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43526 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43534 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43539 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  43551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43556 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43574 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43591 */     // GIR_Coverage, 5307,
     /*  43591 */     GIR_EraseRootFromParent_Done,
     /*  43592 */   // Label 689: @43592
     /*  43592 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(43738), // Rule ID 5350 //
     /*  43597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43630 */     // MIs[1] Operand 2
     /*  43630 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43643 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43643 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43646 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43650 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43657 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43660 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43664 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43669 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43672 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43676 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  43701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43720 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43737 */     // GIR_Coverage, 5350,
     /*  43737 */     GIR_EraseRootFromParent_Done,
     /*  43738 */   // Label 690: @43738
     /*  43738 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(43884), // Rule ID 5358 //
     /*  43743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43776 */     // MIs[1] Operand 2
     /*  43776 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43789 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43789 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43792 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43796 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43815 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43822 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43830 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43835 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  43847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43852 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43866 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43883 */     // GIR_Coverage, 5358,
     /*  43883 */     GIR_EraseRootFromParent_Done,
     /*  43884 */   // Label 691: @43884
     /*  43884 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44030), // Rule ID 5349 //
     /*  43889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43922 */     // MIs[1] Operand 2
     /*  43922 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43935 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43935 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43938 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43942 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43949 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43961 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43964 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43968 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  43993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44012 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  44019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44029 */     // GIR_Coverage, 5349,
     /*  44029 */     GIR_EraseRootFromParent_Done,
     /*  44030 */   // Label 692: @44030
     /*  44030 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44065), // Rule ID 960 //
     /*  44035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44042 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44048 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44056 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  44056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  44059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44063 */     GIR_RootConstrainSelectedInstOperands,
     /*  44064 */     // GIR_Coverage, 960,
     /*  44064 */     GIR_EraseRootFromParent_Done,
     /*  44065 */   // Label 693: @44065
     /*  44065 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44088), // Rule ID 1467 //
     /*  44070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44081 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  44081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  44086 */     GIR_RootConstrainSelectedInstOperands,
     /*  44087 */     // GIR_Coverage, 1467,
     /*  44087 */     GIR_Done,
     /*  44088 */   // Label 694: @44088
     /*  44088 */   GIM_Reject,
     /*  44089 */ // Label 682: @44089
     /*  44089 */ GIM_Reject,
     /*  44090 */ // Label 580: @44090
     /*  44090 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(46549),
     /*  44095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44105 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(44219), // Rule ID 2038 //
     /*  44110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44153 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44157 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44161 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44174 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44178 */     // MIs[4] Operand 1
     /*  44178 */     // No operand predicates
     /*  44178 */     // MIs[2] Operand 2
     /*  44178 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44198 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  44201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44217 */     GIR_RootConstrainSelectedInstOperands,
     /*  44218 */     // GIR_Coverage, 2038,
     /*  44218 */     GIR_EraseRootFromParent_Done,
     /*  44219 */   // Label 696: @44219
     /*  44219 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44333), // Rule ID 13287 //
     /*  44224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44267 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44271 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44275 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44284 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44288 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44292 */     // MIs[4] Operand 1
     /*  44292 */     // No operand predicates
     /*  44292 */     // MIs[2] Operand 2
     /*  44292 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44312 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  44315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44331 */     GIR_RootConstrainSelectedInstOperands,
     /*  44332 */     // GIR_Coverage, 13287,
     /*  44332 */     GIR_EraseRootFromParent_Done,
     /*  44333 */   // Label 697: @44333
     /*  44333 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(44447), // Rule ID 2090 //
     /*  44338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44385 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44389 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44394 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44398 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44402 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44406 */     // MIs[4] Operand 1
     /*  44406 */     // No operand predicates
     /*  44406 */     // MIs[2] Operand 2
     /*  44406 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44417 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44426 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  44429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44445 */     GIR_RootConstrainSelectedInstOperands,
     /*  44446 */     // GIR_Coverage, 2090,
     /*  44446 */     GIR_EraseRootFromParent_Done,
     /*  44447 */   // Label 698: @44447
     /*  44447 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(44561), // Rule ID 13317 //
     /*  44452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44499 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44503 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44508 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44512 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44516 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44520 */     // MIs[4] Operand 1
     /*  44520 */     // No operand predicates
     /*  44520 */     // MIs[2] Operand 2
     /*  44520 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44531 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44540 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  44543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44559 */     GIR_RootConstrainSelectedInstOperands,
     /*  44560 */     // GIR_Coverage, 13317,
     /*  44560 */     GIR_EraseRootFromParent_Done,
     /*  44561 */   // Label 699: @44561
     /*  44561 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(44626), // Rule ID 1840 //
     /*  44566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44609 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44624 */     GIR_RootConstrainSelectedInstOperands,
     /*  44625 */     // GIR_Coverage, 1840,
     /*  44625 */     GIR_EraseRootFromParent_Done,
     /*  44626 */   // Label 700: @44626
     /*  44626 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(44691), // Rule ID 1839 //
     /*  44631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44674 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44689 */     GIR_RootConstrainSelectedInstOperands,
     /*  44690 */     // GIR_Coverage, 1839,
     /*  44690 */     GIR_EraseRootFromParent_Done,
     /*  44691 */   // Label 701: @44691
     /*  44691 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(44756), // Rule ID 1750 //
     /*  44696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44739 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  44742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44754 */     GIR_RootConstrainSelectedInstOperands,
     /*  44755 */     // GIR_Coverage, 1750,
     /*  44755 */     GIR_EraseRootFromParent_Done,
     /*  44756 */   // Label 702: @44756
     /*  44756 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(44821), // Rule ID 1838 //
     /*  44761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44804 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44819 */     GIR_RootConstrainSelectedInstOperands,
     /*  44820 */     // GIR_Coverage, 1838,
     /*  44820 */     GIR_EraseRootFromParent_Done,
     /*  44821 */   // Label 703: @44821
     /*  44821 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(44886), // Rule ID 1837 //
     /*  44826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44869 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44884 */     GIR_RootConstrainSelectedInstOperands,
     /*  44885 */     // GIR_Coverage, 1837,
     /*  44885 */     GIR_EraseRootFromParent_Done,
     /*  44886 */   // Label 704: @44886
     /*  44886 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(44997), // Rule ID 13285 //
     /*  44891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44942 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44955 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44959 */     // MIs[4] Operand 1
     /*  44959 */     // No operand predicates
     /*  44959 */     // MIs[2] Operand 2
     /*  44959 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44975 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44977 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  44980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44995 */     GIR_RootConstrainSelectedInstOperands,
     /*  44996 */     // GIR_Coverage, 13285,
     /*  44996 */     GIR_EraseRootFromParent_Done,
     /*  44997 */   // Label 705: @44997
     /*  44997 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(45108), // Rule ID 2036 //
     /*  45002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45071 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45075 */     // MIs[4] Operand 1
     /*  45075 */     // No operand predicates
     /*  45075 */     // MIs[2] Operand 2
     /*  45075 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45106 */     GIR_RootConstrainSelectedInstOperands,
     /*  45107 */     // GIR_Coverage, 2036,
     /*  45107 */     GIR_EraseRootFromParent_Done,
     /*  45108 */   // Label 706: @45108
     /*  45108 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45219), // Rule ID 13315 //
     /*  45113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45164 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45177 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45181 */     // MIs[4] Operand 1
     /*  45181 */     // No operand predicates
     /*  45181 */     // MIs[2] Operand 2
     /*  45181 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45199 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45217 */     GIR_RootConstrainSelectedInstOperands,
     /*  45218 */     // GIR_Coverage, 13315,
     /*  45218 */     GIR_EraseRootFromParent_Done,
     /*  45219 */   // Label 707: @45219
     /*  45219 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(45330), // Rule ID 2088 //
     /*  45224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45276 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45280 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45285 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45289 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45293 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45297 */     // MIs[4] Operand 1
     /*  45297 */     // No operand predicates
     /*  45297 */     // MIs[2] Operand 2
     /*  45297 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45308 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45310 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45328 */     GIR_RootConstrainSelectedInstOperands,
     /*  45329 */     // GIR_Coverage, 2088,
     /*  45329 */     GIR_EraseRootFromParent_Done,
     /*  45330 */   // Label 708: @45330
     /*  45330 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(45393), // Rule ID 1726 //
     /*  45335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45374 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  45377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45391 */     GIR_RootConstrainSelectedInstOperands,
     /*  45392 */     // GIR_Coverage, 1726,
     /*  45392 */     GIR_EraseRootFromParent_Done,
     /*  45393 */   // Label 709: @45393
     /*  45393 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(45456), // Rule ID 1816 //
     /*  45398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45437 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  45440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45454 */     GIR_RootConstrainSelectedInstOperands,
     /*  45455 */     // GIR_Coverage, 1816,
     /*  45455 */     GIR_EraseRootFromParent_Done,
     /*  45456 */   // Label 710: @45456
     /*  45456 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(45544), // Rule ID 13286 //
     /*  45461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45517 */     // MIs[3] Operand 1
     /*  45517 */     // No operand predicates
     /*  45517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45524 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45542 */     GIR_RootConstrainSelectedInstOperands,
     /*  45543 */     // GIR_Coverage, 13286,
     /*  45543 */     GIR_EraseRootFromParent_Done,
     /*  45544 */   // Label 711: @45544
     /*  45544 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(45632), // Rule ID 2037 //
     /*  45549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45610 */     // MIs[3] Operand 1
     /*  45610 */     // No operand predicates
     /*  45610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45612 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45630 */     GIR_RootConstrainSelectedInstOperands,
     /*  45631 */     // GIR_Coverage, 2037,
     /*  45631 */     GIR_EraseRootFromParent_Done,
     /*  45632 */   // Label 712: @45632
     /*  45632 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(45720), // Rule ID 13316 //
     /*  45637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45689 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45693 */     // MIs[3] Operand 1
     /*  45693 */     // No operand predicates
     /*  45693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45700 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45718 */     GIR_RootConstrainSelectedInstOperands,
     /*  45719 */     // GIR_Coverage, 13316,
     /*  45719 */     GIR_EraseRootFromParent_Done,
     /*  45720 */   // Label 713: @45720
     /*  45720 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(45808), // Rule ID 2089 //
     /*  45725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45786 */     // MIs[3] Operand 1
     /*  45786 */     // No operand predicates
     /*  45786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45788 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45806 */     GIR_RootConstrainSelectedInstOperands,
     /*  45807 */     // GIR_Coverage, 2089,
     /*  45807 */     GIR_EraseRootFromParent_Done,
     /*  45808 */   // Label 714: @45808
     /*  45808 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(45855), // Rule ID 1856 //
     /*  45813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45841 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  45844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45853 */     GIR_RootConstrainSelectedInstOperands,
     /*  45854 */     // GIR_Coverage, 1856,
     /*  45854 */     GIR_EraseRootFromParent_Done,
     /*  45855 */   // Label 715: @45855
     /*  45855 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(45902), // Rule ID 1756 //
     /*  45860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45888 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  45891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45900 */     GIR_RootConstrainSelectedInstOperands,
     /*  45901 */     // GIR_Coverage, 1756,
     /*  45901 */     GIR_EraseRootFromParent_Done,
     /*  45902 */   // Label 716: @45902
     /*  45902 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(45949), // Rule ID 1855 //
     /*  45907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45935 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  45938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45947 */     GIR_RootConstrainSelectedInstOperands,
     /*  45948 */     // GIR_Coverage, 1855,
     /*  45948 */     GIR_EraseRootFromParent_Done,
     /*  45949 */   // Label 717: @45949
     /*  45949 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(46008), // Rule ID 1836 //
     /*  45954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45993 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  45993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  45996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46006 */     GIR_RootConstrainSelectedInstOperands,
     /*  46007 */     // GIR_Coverage, 1836,
     /*  46007 */     GIR_EraseRootFromParent_Done,
     /*  46008 */   // Label 718: @46008
     /*  46008 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(46067), // Rule ID 1835 //
     /*  46013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46052 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46065 */     GIR_RootConstrainSelectedInstOperands,
     /*  46066 */     // GIR_Coverage, 1835,
     /*  46066 */     GIR_EraseRootFromParent_Done,
     /*  46067 */   // Label 719: @46067
     /*  46067 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(46126), // Rule ID 1749 //
     /*  46072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46111 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  46114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46124 */     GIR_RootConstrainSelectedInstOperands,
     /*  46125 */     // GIR_Coverage, 1749,
     /*  46125 */     GIR_EraseRootFromParent_Done,
     /*  46126 */   // Label 720: @46126
     /*  46126 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(46185), // Rule ID 1834 //
     /*  46131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46170 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46183 */     GIR_RootConstrainSelectedInstOperands,
     /*  46184 */     // GIR_Coverage, 1834,
     /*  46184 */     GIR_EraseRootFromParent_Done,
     /*  46185 */   // Label 721: @46185
     /*  46185 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(46244), // Rule ID 1833 //
     /*  46190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46229 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46242 */     GIR_RootConstrainSelectedInstOperands,
     /*  46243 */     // GIR_Coverage, 1833,
     /*  46243 */     GIR_EraseRootFromParent_Done,
     /*  46244 */   // Label 722: @46244
     /*  46244 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(46279), // Rule ID 963 //
     /*  46249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46256 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46262 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46270 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  46270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  46273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46277 */     GIR_RootConstrainSelectedInstOperands,
     /*  46278 */     // GIR_Coverage, 963,
     /*  46278 */     GIR_EraseRootFromParent_Done,
     /*  46279 */   // Label 723: @46279
     /*  46279 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(46336), // Rule ID 1725 //
     /*  46284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46319 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  46322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46334 */     GIR_RootConstrainSelectedInstOperands,
     /*  46335 */     // GIR_Coverage, 1725,
     /*  46335 */     GIR_EraseRootFromParent_Done,
     /*  46336 */   // Label 724: @46336
     /*  46336 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(46393), // Rule ID 1815 //
     /*  46341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46376 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  46379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46391 */     GIR_RootConstrainSelectedInstOperands,
     /*  46392 */     // GIR_Coverage, 1815,
     /*  46392 */     GIR_EraseRootFromParent_Done,
     /*  46393 */   // Label 725: @46393
     /*  46393 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(46437), // Rule ID 1854 //
     /*  46398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46424 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  46427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46435 */     GIR_RootConstrainSelectedInstOperands,
     /*  46436 */     // GIR_Coverage, 1854,
     /*  46436 */     GIR_EraseRootFromParent_Done,
     /*  46437 */   // Label 726: @46437
     /*  46437 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(46481), // Rule ID 1755 //
     /*  46442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46468 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  46471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46479 */     GIR_RootConstrainSelectedInstOperands,
     /*  46480 */     // GIR_Coverage, 1755,
     /*  46480 */     GIR_EraseRootFromParent_Done,
     /*  46481 */   // Label 727: @46481
     /*  46481 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(46525), // Rule ID 1853 //
     /*  46486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46512 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  46515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46523 */     GIR_RootConstrainSelectedInstOperands,
     /*  46524 */     // GIR_Coverage, 1853,
     /*  46524 */     GIR_EraseRootFromParent_Done,
     /*  46525 */   // Label 728: @46525
     /*  46525 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(46548), // Rule ID 1470 //
     /*  46530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46541 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  46541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  46546 */     GIR_RootConstrainSelectedInstOperands,
     /*  46547 */     // GIR_Coverage, 1470,
     /*  46547 */     GIR_Done,
     /*  46548 */   // Label 729: @46548
     /*  46548 */   GIM_Reject,
     /*  46549 */ // Label 695: @46549
     /*  46549 */ GIM_Reject,
     /*  46550 */ // Label 581: @46550
     /*  46550 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(46624),
     /*  46555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46565 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(46600), // Rule ID 958 //
     /*  46570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46591 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  46591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  46594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46598 */     GIR_RootConstrainSelectedInstOperands,
     /*  46599 */     // GIR_Coverage, 958,
     /*  46599 */     GIR_EraseRootFromParent_Done,
     /*  46600 */   // Label 731: @46600
     /*  46600 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(46623), // Rule ID 1465 //
     /*  46605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46616 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  46616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  46621 */     GIR_RootConstrainSelectedInstOperands,
     /*  46622 */     // GIR_Coverage, 1465,
     /*  46622 */     GIR_Done,
     /*  46623 */   // Label 732: @46623
     /*  46623 */   GIM_Reject,
     /*  46624 */ // Label 730: @46624
     /*  46624 */ GIM_Reject,
     /*  46625 */ // Label 582: @46625
     /*  46625 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(47832),
     /*  46630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  46636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46640 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(46705), // Rule ID 1832 //
     /*  46645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46688 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46703 */     GIR_RootConstrainSelectedInstOperands,
     /*  46704 */     // GIR_Coverage, 1832,
     /*  46704 */     GIR_EraseRootFromParent_Done,
     /*  46705 */   // Label 734: @46705
     /*  46705 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(46770), // Rule ID 1831 //
     /*  46710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46753 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46768 */     GIR_RootConstrainSelectedInstOperands,
     /*  46769 */     // GIR_Coverage, 1831,
     /*  46769 */     GIR_EraseRootFromParent_Done,
     /*  46770 */   // Label 735: @46770
     /*  46770 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(46835), // Rule ID 1748 //
     /*  46775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46818 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  46821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46833 */     GIR_RootConstrainSelectedInstOperands,
     /*  46834 */     // GIR_Coverage, 1748,
     /*  46834 */     GIR_EraseRootFromParent_Done,
     /*  46835 */   // Label 736: @46835
     /*  46835 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(46900), // Rule ID 1830 //
     /*  46840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46883 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46898 */     GIR_RootConstrainSelectedInstOperands,
     /*  46899 */     // GIR_Coverage, 1830,
     /*  46899 */     GIR_EraseRootFromParent_Done,
     /*  46900 */   // Label 737: @46900
     /*  46900 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(46965), // Rule ID 1829 //
     /*  46905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46948 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46963 */     GIR_RootConstrainSelectedInstOperands,
     /*  46964 */     // GIR_Coverage, 1829,
     /*  46964 */     GIR_EraseRootFromParent_Done,
     /*  46965 */   // Label 738: @46965
     /*  46965 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(47028), // Rule ID 1724 //
     /*  46970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47009 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  47012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47026 */     GIR_RootConstrainSelectedInstOperands,
     /*  47027 */     // GIR_Coverage, 1724,
     /*  47027 */     GIR_EraseRootFromParent_Done,
     /*  47028 */   // Label 739: @47028
     /*  47028 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(47091), // Rule ID 1814 //
     /*  47033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47072 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  47075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47089 */     GIR_RootConstrainSelectedInstOperands,
     /*  47090 */     // GIR_Coverage, 1814,
     /*  47090 */     GIR_EraseRootFromParent_Done,
     /*  47091 */   // Label 740: @47091
     /*  47091 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(47138), // Rule ID 1852 //
     /*  47096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47124 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  47127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47136 */     GIR_RootConstrainSelectedInstOperands,
     /*  47137 */     // GIR_Coverage, 1852,
     /*  47137 */     GIR_EraseRootFromParent_Done,
     /*  47138 */   // Label 741: @47138
     /*  47138 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(47185), // Rule ID 1754 //
     /*  47143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47171 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  47174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47183 */     GIR_RootConstrainSelectedInstOperands,
     /*  47184 */     // GIR_Coverage, 1754,
     /*  47184 */     GIR_EraseRootFromParent_Done,
     /*  47185 */   // Label 742: @47185
     /*  47185 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(47232), // Rule ID 1851 //
     /*  47190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47218 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  47221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47230 */     GIR_RootConstrainSelectedInstOperands,
     /*  47231 */     // GIR_Coverage, 1851,
     /*  47231 */     GIR_EraseRootFromParent_Done,
     /*  47232 */   // Label 743: @47232
     /*  47232 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(47291), // Rule ID 1828 //
     /*  47237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47276 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47289 */     GIR_RootConstrainSelectedInstOperands,
     /*  47290 */     // GIR_Coverage, 1828,
     /*  47290 */     GIR_EraseRootFromParent_Done,
     /*  47291 */   // Label 744: @47291
     /*  47291 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(47350), // Rule ID 1827 //
     /*  47296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47335 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47348 */     GIR_RootConstrainSelectedInstOperands,
     /*  47349 */     // GIR_Coverage, 1827,
     /*  47349 */     GIR_EraseRootFromParent_Done,
     /*  47350 */   // Label 745: @47350
     /*  47350 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(47409), // Rule ID 1747 //
     /*  47355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47394 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  47397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47407 */     GIR_RootConstrainSelectedInstOperands,
     /*  47408 */     // GIR_Coverage, 1747,
     /*  47408 */     GIR_EraseRootFromParent_Done,
     /*  47409 */   // Label 746: @47409
     /*  47409 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(47468), // Rule ID 1826 //
     /*  47414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47453 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47466 */     GIR_RootConstrainSelectedInstOperands,
     /*  47467 */     // GIR_Coverage, 1826,
     /*  47467 */     GIR_EraseRootFromParent_Done,
     /*  47468 */   // Label 747: @47468
     /*  47468 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(47527), // Rule ID 1825 //
     /*  47473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47512 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47525 */     GIR_RootConstrainSelectedInstOperands,
     /*  47526 */     // GIR_Coverage, 1825,
     /*  47526 */     GIR_EraseRootFromParent_Done,
     /*  47527 */   // Label 748: @47527
     /*  47527 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(47562), // Rule ID 961 //
     /*  47532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47539 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47545 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47553 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  47553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  47556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47560 */     GIR_RootConstrainSelectedInstOperands,
     /*  47561 */     // GIR_Coverage, 961,
     /*  47561 */     GIR_EraseRootFromParent_Done,
     /*  47562 */   // Label 749: @47562
     /*  47562 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(47619), // Rule ID 1723 //
     /*  47567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47602 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  47605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  47617 */     GIR_RootConstrainSelectedInstOperands,
     /*  47618 */     // GIR_Coverage, 1723,
     /*  47618 */     GIR_EraseRootFromParent_Done,
     /*  47619 */   // Label 750: @47619
     /*  47619 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(47676), // Rule ID 1813 //
     /*  47624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47659 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  47662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  47674 */     GIR_RootConstrainSelectedInstOperands,
     /*  47675 */     // GIR_Coverage, 1813,
     /*  47675 */     GIR_EraseRootFromParent_Done,
     /*  47676 */   // Label 751: @47676
     /*  47676 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(47720), // Rule ID 1850 //
     /*  47681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47707 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47718 */     GIR_RootConstrainSelectedInstOperands,
     /*  47719 */     // GIR_Coverage, 1850,
     /*  47719 */     GIR_EraseRootFromParent_Done,
     /*  47720 */   // Label 752: @47720
     /*  47720 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(47764), // Rule ID 1753 //
     /*  47725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47751 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  47754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47762 */     GIR_RootConstrainSelectedInstOperands,
     /*  47763 */     // GIR_Coverage, 1753,
     /*  47763 */     GIR_EraseRootFromParent_Done,
     /*  47764 */   // Label 753: @47764
     /*  47764 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(47808), // Rule ID 1849 //
     /*  47769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47795 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47806 */     GIR_RootConstrainSelectedInstOperands,
     /*  47807 */     // GIR_Coverage, 1849,
     /*  47807 */     GIR_EraseRootFromParent_Done,
     /*  47808 */   // Label 754: @47808
     /*  47808 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(47831), // Rule ID 1468 //
     /*  47813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47824 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  47829 */     GIR_RootConstrainSelectedInstOperands,
     /*  47830 */     // GIR_Coverage, 1468,
     /*  47830 */     GIR_Done,
     /*  47831 */   // Label 755: @47831
     /*  47831 */   GIM_Reject,
     /*  47832 */ // Label 733: @47832
     /*  47832 */ GIM_Reject,
     /*  47833 */ // Label 583: @47833
     /*  47833 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(47907),
     /*  47838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  47841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  47844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47848 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(47883), // Rule ID 959 //
     /*  47853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47866 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47874 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  47874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  47877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47881 */     GIR_RootConstrainSelectedInstOperands,
     /*  47882 */     // GIR_Coverage, 959,
     /*  47882 */     GIR_EraseRootFromParent_Done,
     /*  47883 */   // Label 757: @47883
     /*  47883 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(47906), // Rule ID 1466 //
     /*  47888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47899 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  47904 */     GIR_RootConstrainSelectedInstOperands,
     /*  47905 */     // GIR_Coverage, 1466,
     /*  47905 */     GIR_Done,
     /*  47906 */   // Label 758: @47906
     /*  47906 */   GIM_Reject,
     /*  47907 */ // Label 756: @47907
     /*  47907 */ GIM_Reject,
     /*  47908 */ // Label 584: @47908
     /*  47908 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(47933), // Rule ID 7340 //
     /*  47913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  47919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  47922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47926 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  47926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  47931 */   GIR_RootConstrainSelectedInstOperands,
     /*  47932 */   // GIR_Coverage, 7340,
     /*  47932 */   GIR_Done,
     /*  47933 */ // Label 759: @47933
     /*  47933 */ GIM_Reject,
     /*  47934 */ // Label 585: @47934
     /*  47934 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(47959), // Rule ID 7339 //
     /*  47939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  47945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  47948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47952 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  47952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  47957 */   GIR_RootConstrainSelectedInstOperands,
     /*  47958 */   // GIR_Coverage, 7339,
     /*  47958 */   GIR_Done,
     /*  47959 */ // Label 760: @47959
     /*  47959 */ GIM_Reject,
     /*  47960 */ // Label 586: @47960
     /*  47960 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(47985), // Rule ID 7338 //
     /*  47965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  47971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  47974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47978 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  47978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  47983 */   GIR_RootConstrainSelectedInstOperands,
     /*  47984 */   // GIR_Coverage, 7338,
     /*  47984 */   GIR_Done,
     /*  47985 */ // Label 761: @47985
     /*  47985 */ GIM_Reject,
     /*  47986 */ // Label 587: @47986
     /*  47986 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(48011), // Rule ID 7337 //
     /*  47991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  47997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  48000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  48004 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  48004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  48009 */   GIR_RootConstrainSelectedInstOperands,
     /*  48010 */   // GIR_Coverage, 7337,
     /*  48010 */   GIR_Done,
     /*  48011 */ // Label 762: @48011
     /*  48011 */ GIM_Reject,
     /*  48012 */ // Label 588: @48012
     /*  48012 */ GIM_Reject,
     /*  48013 */ // Label 2: @48013
     /*  48013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 771*/ GIMT_Encode4(49841),
     /*  48024 */ /*GILLT_s32*//*Label 763*/ GIMT_Encode4(48064),
     /*  48028 */ /*GILLT_s64*//*Label 764*/ GIMT_Encode4(48221), GIMT_Encode4(0),
     /*  48036 */ /*GILLT_v2s32*//*Label 765*/ GIMT_Encode4(48765), GIMT_Encode4(0),
     /*  48044 */ /*GILLT_v4s16*//*Label 766*/ GIMT_Encode4(49103),
     /*  48048 */ /*GILLT_v4s32*//*Label 767*/ GIMT_Encode4(49441),
     /*  48052 */ /*GILLT_v8s8*//*Label 768*/ GIMT_Encode4(49607),
     /*  48056 */ /*GILLT_v8s16*//*Label 769*/ GIMT_Encode4(49641),
     /*  48060 */ /*GILLT_v16s8*//*Label 770*/ GIMT_Encode4(49807),
     /*  48064 */ // Label 763: @48064
     /*  48064 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(48220),
     /*  48069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48079 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(48134), // Rule ID 3908 //
     /*  48084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48100 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48115 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  48118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48132 */     GIR_RootConstrainSelectedInstOperands,
     /*  48133 */     // GIR_Coverage, 3908,
     /*  48133 */     GIR_EraseRootFromParent_Done,
     /*  48134 */   // Label 773: @48134
     /*  48134 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(48189), // Rule ID 13570 //
     /*  48139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48159 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48170 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  48173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  48181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48187 */     GIR_RootConstrainSelectedInstOperands,
     /*  48188 */     // GIR_Coverage, 13570,
     /*  48188 */     GIR_EraseRootFromParent_Done,
     /*  48189 */   // Label 774: @48189
     /*  48189 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(48219), // Rule ID 3904 //
     /*  48194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48202 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  48205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48217 */     GIR_RootConstrainSelectedInstOperands,
     /*  48218 */     // GIR_Coverage, 3904,
     /*  48218 */     GIR_EraseRootFromParent_Done,
     /*  48219 */   // Label 775: @48219
     /*  48219 */   GIM_Reject,
     /*  48220 */ // Label 772: @48220
     /*  48220 */ GIM_Reject,
     /*  48221 */ // Label 764: @48221
     /*  48221 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(48764),
     /*  48226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  48232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48236 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(48291), // Rule ID 3909 //
     /*  48241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48257 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48272 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  48275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48289 */     GIR_RootConstrainSelectedInstOperands,
     /*  48290 */     // GIR_Coverage, 3909,
     /*  48290 */     GIR_EraseRootFromParent_Done,
     /*  48291 */   // Label 777: @48291
     /*  48291 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(48346), // Rule ID 13571 //
     /*  48296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48316 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48327 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  48330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  48338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48344 */     GIR_RootConstrainSelectedInstOperands,
     /*  48345 */     // GIR_Coverage, 13571,
     /*  48345 */     GIR_EraseRootFromParent_Done,
     /*  48346 */   // Label 778: @48346
     /*  48346 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(48459), // Rule ID 3920 //
     /*  48351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  48359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48368 */     // MIs[1] Operand 2
     /*  48368 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  48379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  48391 */     // MIs[2] Operand 1
     /*  48391 */     // No operand predicates
     /*  48391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48393 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48405 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  48430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  48451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48457 */     GIR_RootConstrainSelectedInstOperands,
     /*  48458 */     // GIR_Coverage, 3920,
     /*  48458 */     GIR_EraseRootFromParent_Done,
     /*  48459 */   // Label 779: @48459
     /*  48459 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(48534), // Rule ID 3918 //
     /*  48464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48489 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  48493 */     // MIs[2] Operand 1
     /*  48493 */     // No operand predicates
     /*  48493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48495 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48507 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48532 */     GIR_RootConstrainSelectedInstOperands,
     /*  48533 */     // GIR_Coverage, 3918,
     /*  48533 */     GIR_EraseRootFromParent_Done,
     /*  48534 */   // Label 780: @48534
     /*  48534 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(48609), // Rule ID 3919 //
     /*  48539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  48568 */     // MIs[2] Operand 1
     /*  48568 */     // No operand predicates
     /*  48568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48570 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48582 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  48592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48607 */     GIR_RootConstrainSelectedInstOperands,
     /*  48608 */     // GIR_Coverage, 3919,
     /*  48608 */     GIR_EraseRootFromParent_Done,
     /*  48609 */   // Label 781: @48609
     /*  48609 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(48671), // Rule ID 3912 //
     /*  48614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  48643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48650 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  48650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48669 */     GIR_RootConstrainSelectedInstOperands,
     /*  48670 */     // GIR_Coverage, 3912,
     /*  48670 */     GIR_EraseRootFromParent_Done,
     /*  48671 */   // Label 782: @48671
     /*  48671 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(48733), // Rule ID 3915 //
     /*  48676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  48705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48712 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  48712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  48715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48731 */     GIR_RootConstrainSelectedInstOperands,
     /*  48732 */     // GIR_Coverage, 3915,
     /*  48732 */     GIR_EraseRootFromParent_Done,
     /*  48733 */   // Label 783: @48733
     /*  48733 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(48763), // Rule ID 3905 //
     /*  48738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48746 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  48749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48761 */     GIR_RootConstrainSelectedInstOperands,
     /*  48762 */     // GIR_Coverage, 3905,
     /*  48762 */     GIR_EraseRootFromParent_Done,
     /*  48763 */   // Label 784: @48763
     /*  48763 */   GIM_Reject,
     /*  48764 */ // Label 776: @48764
     /*  48764 */ GIM_Reject,
     /*  48765 */ // Label 765: @48765
     /*  48765 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(49102),
     /*  48770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  48773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  48776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48780 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(48866), // Rule ID 13264 //
     /*  48785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48829 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48833 */     // MIs[3] Operand 1
     /*  48833 */     // No operand predicates
     /*  48833 */     // MIs[1] Operand 2
     /*  48833 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  48844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48850 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48864 */     GIR_RootConstrainSelectedInstOperands,
     /*  48865 */     // GIR_Coverage, 13264,
     /*  48865 */     GIR_EraseRootFromParent_Done,
     /*  48866 */   // Label 786: @48866
     /*  48866 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48952), // Rule ID 2027 //
     /*  48871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48919 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48923 */     // MIs[3] Operand 1
     /*  48923 */     // No operand predicates
     /*  48923 */     // MIs[1] Operand 2
     /*  48923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  48934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48936 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48950 */     GIR_RootConstrainSelectedInstOperands,
     /*  48951 */     // GIR_Coverage, 2027,
     /*  48951 */     GIR_EraseRootFromParent_Done,
     /*  48952 */   // Label 787: @48952
     /*  48952 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(49015), // Rule ID 13265 //
     /*  48957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48993 */     // MIs[2] Operand 1
     /*  48993 */     // No operand predicates
     /*  48993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48999 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  49002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49013 */     GIR_RootConstrainSelectedInstOperands,
     /*  49014 */     // GIR_Coverage, 13265,
     /*  49014 */     GIR_EraseRootFromParent_Done,
     /*  49015 */   // Label 788: @49015
     /*  49015 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(49078), // Rule ID 2028 //
     /*  49020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49060 */     // MIs[2] Operand 1
     /*  49060 */     // No operand predicates
     /*  49060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49062 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  49065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49076 */     GIR_RootConstrainSelectedInstOperands,
     /*  49077 */     // GIR_Coverage, 2028,
     /*  49077 */     GIR_EraseRootFromParent_Done,
     /*  49078 */   // Label 789: @49078
     /*  49078 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(49101), // Rule ID 1345 //
     /*  49083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49094 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  49094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  49099 */     GIR_RootConstrainSelectedInstOperands,
     /*  49100 */     // GIR_Coverage, 1345,
     /*  49100 */     GIR_Done,
     /*  49101 */   // Label 790: @49101
     /*  49101 */   GIM_Reject,
     /*  49102 */ // Label 785: @49102
     /*  49102 */ GIM_Reject,
     /*  49103 */ // Label 766: @49103
     /*  49103 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(49440),
     /*  49108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49118 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(49204), // Rule ID 13261 //
     /*  49123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49167 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49171 */     // MIs[3] Operand 1
     /*  49171 */     // No operand predicates
     /*  49171 */     // MIs[1] Operand 2
     /*  49171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  49182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49188 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49202 */     GIR_RootConstrainSelectedInstOperands,
     /*  49203 */     // GIR_Coverage, 13261,
     /*  49203 */     GIR_EraseRootFromParent_Done,
     /*  49204 */   // Label 792: @49204
     /*  49204 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(49290), // Rule ID 2024 //
     /*  49209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49261 */     // MIs[3] Operand 1
     /*  49261 */     // No operand predicates
     /*  49261 */     // MIs[1] Operand 2
     /*  49261 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  49272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49274 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49288 */     GIR_RootConstrainSelectedInstOperands,
     /*  49289 */     // GIR_Coverage, 2024,
     /*  49289 */     GIR_EraseRootFromParent_Done,
     /*  49290 */   // Label 793: @49290
     /*  49290 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(49353), // Rule ID 13262 //
     /*  49295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49331 */     // MIs[2] Operand 1
     /*  49331 */     // No operand predicates
     /*  49331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49337 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49351 */     GIR_RootConstrainSelectedInstOperands,
     /*  49352 */     // GIR_Coverage, 13262,
     /*  49352 */     GIR_EraseRootFromParent_Done,
     /*  49353 */   // Label 794: @49353
     /*  49353 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(49416), // Rule ID 2025 //
     /*  49358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49398 */     // MIs[2] Operand 1
     /*  49398 */     // No operand predicates
     /*  49398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49400 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49414 */     GIR_RootConstrainSelectedInstOperands,
     /*  49415 */     // GIR_Coverage, 2025,
     /*  49415 */     GIR_EraseRootFromParent_Done,
     /*  49416 */   // Label 795: @49416
     /*  49416 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49439), // Rule ID 1343 //
     /*  49421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49432 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  49437 */     GIR_RootConstrainSelectedInstOperands,
     /*  49438 */     // GIR_Coverage, 1343,
     /*  49438 */     GIR_Done,
     /*  49439 */   // Label 796: @49439
     /*  49439 */   GIM_Reject,
     /*  49440 */ // Label 791: @49440
     /*  49440 */ GIM_Reject,
     /*  49441 */ // Label 767: @49441
     /*  49441 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49606),
     /*  49446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49456 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49519), // Rule ID 13266 //
     /*  49461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49497 */     // MIs[2] Operand 1
     /*  49497 */     // No operand predicates
     /*  49497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49503 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49517 */     GIR_RootConstrainSelectedInstOperands,
     /*  49518 */     // GIR_Coverage, 13266,
     /*  49518 */     GIR_EraseRootFromParent_Done,
     /*  49519 */   // Label 798: @49519
     /*  49519 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49582), // Rule ID 2029 //
     /*  49524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49560 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49564 */     // MIs[2] Operand 1
     /*  49564 */     // No operand predicates
     /*  49564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49566 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  49569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49580 */     GIR_RootConstrainSelectedInstOperands,
     /*  49581 */     // GIR_Coverage, 2029,
     /*  49581 */     GIR_EraseRootFromParent_Done,
     /*  49582 */   // Label 799: @49582
     /*  49582 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49605), // Rule ID 1346 //
     /*  49587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49598 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  49603 */     GIR_RootConstrainSelectedInstOperands,
     /*  49604 */     // GIR_Coverage, 1346,
     /*  49604 */     GIR_Done,
     /*  49605 */   // Label 800: @49605
     /*  49605 */   GIM_Reject,
     /*  49606 */ // Label 797: @49606
     /*  49606 */ GIM_Reject,
     /*  49607 */ // Label 768: @49607
     /*  49607 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49640), // Rule ID 1341 //
     /*  49612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49633 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  49638 */   GIR_RootConstrainSelectedInstOperands,
     /*  49639 */   // GIR_Coverage, 1341,
     /*  49639 */   GIR_Done,
     /*  49640 */ // Label 801: @49640
     /*  49640 */ GIM_Reject,
     /*  49641 */ // Label 769: @49641
     /*  49641 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49806),
     /*  49646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49656 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49719), // Rule ID 13263 //
     /*  49661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49697 */     // MIs[2] Operand 1
     /*  49697 */     // No operand predicates
     /*  49697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49703 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  49706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49717 */     GIR_RootConstrainSelectedInstOperands,
     /*  49718 */     // GIR_Coverage, 13263,
     /*  49718 */     GIR_EraseRootFromParent_Done,
     /*  49719 */   // Label 803: @49719
     /*  49719 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(49782), // Rule ID 2026 //
     /*  49724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49760 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49764 */     // MIs[2] Operand 1
     /*  49764 */     // No operand predicates
     /*  49764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49766 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  49769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49780 */     GIR_RootConstrainSelectedInstOperands,
     /*  49781 */     // GIR_Coverage, 2026,
     /*  49781 */     GIR_EraseRootFromParent_Done,
     /*  49782 */   // Label 804: @49782
     /*  49782 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(49805), // Rule ID 1344 //
     /*  49787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49798 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1344,
     /*  49804 */     GIR_Done,
     /*  49805 */   // Label 805: @49805
     /*  49805 */   GIM_Reject,
     /*  49806 */ // Label 802: @49806
     /*  49806 */ GIM_Reject,
     /*  49807 */ // Label 770: @49807
     /*  49807 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(49840), // Rule ID 1342 //
     /*  49812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  49818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49833 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  49838 */   GIR_RootConstrainSelectedInstOperands,
     /*  49839 */   // GIR_Coverage, 1342,
     /*  49839 */   GIR_Done,
     /*  49840 */ // Label 806: @49840
     /*  49840 */ GIM_Reject,
     /*  49841 */ // Label 771: @49841
     /*  49841 */ GIM_Reject,
     /*  49842 */ // Label 3: @49842
     /*  49842 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 809*/ GIMT_Encode4(49923),
     /*  49853 */ /*GILLT_s32*//*Label 807*/ GIMT_Encode4(49861),
     /*  49857 */ /*GILLT_s64*//*Label 808*/ GIMT_Encode4(49892),
     /*  49861 */ // Label 807: @49861
     /*  49861 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(49891), // Rule ID 117 //
     /*  49866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49884 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  49884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  49889 */   GIR_RootConstrainSelectedInstOperands,
     /*  49890 */   // GIR_Coverage, 117,
     /*  49890 */   GIR_Done,
     /*  49891 */ // Label 810: @49891
     /*  49891 */ GIM_Reject,
     /*  49892 */ // Label 808: @49892
     /*  49892 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(49922), // Rule ID 118 //
     /*  49897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  49903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49915 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  49915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  49920 */   GIR_RootConstrainSelectedInstOperands,
     /*  49921 */   // GIR_Coverage, 118,
     /*  49921 */   GIR_Done,
     /*  49922 */ // Label 811: @49922
     /*  49922 */ GIM_Reject,
     /*  49923 */ // Label 809: @49923
     /*  49923 */ GIM_Reject,
     /*  49924 */ // Label 4: @49924
     /*  49924 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 814*/ GIMT_Encode4(50005),
     /*  49935 */ /*GILLT_s32*//*Label 812*/ GIMT_Encode4(49943),
     /*  49939 */ /*GILLT_s64*//*Label 813*/ GIMT_Encode4(49974),
     /*  49943 */ // Label 812: @49943
     /*  49943 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(49973), // Rule ID 115 //
     /*  49948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49966 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  49966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  49971 */   GIR_RootConstrainSelectedInstOperands,
     /*  49972 */   // GIR_Coverage, 115,
     /*  49972 */   GIR_Done,
     /*  49973 */ // Label 815: @49973
     /*  49973 */ GIM_Reject,
     /*  49974 */ // Label 813: @49974
     /*  49974 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(50004), // Rule ID 116 //
     /*  49979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  49985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49997 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  49997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  50002 */   GIR_RootConstrainSelectedInstOperands,
     /*  50003 */   // GIR_Coverage, 116,
     /*  50003 */   GIR_Done,
     /*  50004 */ // Label 816: @50004
     /*  50004 */ GIM_Reject,
     /*  50005 */ // Label 814: @50005
     /*  50005 */ GIM_Reject,
     /*  50006 */ // Label 5: @50006
     /*  50006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 835*/ GIMT_Encode4(57751),
     /*  50017 */ /*GILLT_s32*//*Label 817*/ GIMT_Encode4(50105),
     /*  50021 */ /*GILLT_s64*//*Label 818*/ GIMT_Encode4(50603), GIMT_Encode4(0),
     /*  50029 */ /*GILLT_v2s32*//*Label 819*/ GIMT_Encode4(52038),
     /*  50033 */ /*GILLT_v2s64*//*Label 820*/ GIMT_Encode4(52198),
     /*  50037 */ /*GILLT_v4s16*//*Label 821*/ GIMT_Encode4(52358),
     /*  50041 */ /*GILLT_v4s32*//*Label 822*/ GIMT_Encode4(52518),
     /*  50045 */ /*GILLT_v8s8*//*Label 823*/ GIMT_Encode4(52678),
     /*  50049 */ /*GILLT_v8s16*//*Label 824*/ GIMT_Encode4(52838),
     /*  50053 */ /*GILLT_v16s8*//*Label 825*/ GIMT_Encode4(52998),
     /*  50057 */ /*GILLT_nxv1s1*//*Label 826*/ GIMT_Encode4(53158),
     /*  50061 */ /*GILLT_nxv2s1*//*Label 827*/ GIMT_Encode4(53699), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  50073 */ /*GILLT_nxv2s64*//*Label 828*/ GIMT_Encode4(54240),
     /*  50077 */ /*GILLT_nxv4s1*//*Label 829*/ GIMT_Encode4(54712), GIMT_Encode4(0),
     /*  50085 */ /*GILLT_nxv4s32*//*Label 830*/ GIMT_Encode4(55253),
     /*  50089 */ /*GILLT_nxv8s1*//*Label 831*/ GIMT_Encode4(55725),
     /*  50093 */ /*GILLT_nxv8s16*//*Label 832*/ GIMT_Encode4(56266),
     /*  50097 */ /*GILLT_nxv16s1*//*Label 833*/ GIMT_Encode4(56738),
     /*  50101 */ /*GILLT_nxv16s8*//*Label 834*/ GIMT_Encode4(57279),
     /*  50105 */ // Label 817: @50105
     /*  50105 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(50602),
     /*  50110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50116 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(50171), // Rule ID 13023 //
     /*  50121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50158 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  50161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50169 */     GIR_RootConstrainSelectedInstOperands,
     /*  50170 */     // GIR_Coverage, 13023,
     /*  50170 */     GIR_EraseRootFromParent_Done,
     /*  50171 */   // Label 837: @50171
     /*  50171 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(50226), // Rule ID 162 //
     /*  50176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50200 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50213 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  50216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50224 */     GIR_RootConstrainSelectedInstOperands,
     /*  50225 */     // GIR_Coverage, 162,
     /*  50225 */     GIR_EraseRootFromParent_Done,
     /*  50226 */   // Label 838: @50226
     /*  50226 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(50295), // Rule ID 5601 //
     /*  50231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  50268 */     // MIs[2] Operand 1
     /*  50268 */     // No operand predicates
     /*  50268 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50281 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  50281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  50293 */     GIR_RootConstrainSelectedInstOperands,
     /*  50294 */     // GIR_Coverage, 5601,
     /*  50294 */     GIR_EraseRootFromParent_Done,
     /*  50295 */   // Label 839: @50295
     /*  50295 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(50364), // Rule ID 5602 //
     /*  50300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  50337 */     // MIs[2] Operand 1
     /*  50337 */     // No operand predicates
     /*  50337 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  50348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50350 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  50350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  50353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  50362 */     GIR_RootConstrainSelectedInstOperands,
     /*  50363 */     // GIR_Coverage, 5602,
     /*  50363 */     GIR_EraseRootFromParent_Done,
     /*  50364 */   // Label 840: @50364
     /*  50364 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(50417), // Rule ID 13021 //
     /*  50369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50394 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50404 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  50407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50415 */     GIR_RootConstrainSelectedInstOperands,
     /*  50416 */     // GIR_Coverage, 13021,
     /*  50416 */     GIR_EraseRootFromParent_Done,
     /*  50417 */   // Label 841: @50417
     /*  50417 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(50470), // Rule ID 160 //
     /*  50422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50457 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  50460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50468 */     GIR_RootConstrainSelectedInstOperands,
     /*  50469 */     // GIR_Coverage, 160,
     /*  50469 */     GIR_EraseRootFromParent_Done,
     /*  50470 */   // Label 842: @50470
     /*  50470 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(50511), // Rule ID 142 //
     /*  50475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  50479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50491 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  50495 */     // MIs[1] Operand 1
     /*  50495 */     // No operand predicates
     /*  50495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50497 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  50497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  50500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50504 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  50509 */     GIR_RootConstrainSelectedInstOperands,
     /*  50510 */     // GIR_Coverage, 142,
     /*  50510 */     GIR_EraseRootFromParent_Done,
     /*  50511 */   // Label 843: @50511
     /*  50511 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(50544), // Rule ID 13019 //
     /*  50516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50531 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  50534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50542 */     GIR_RootConstrainSelectedInstOperands,
     /*  50543 */     // GIR_Coverage, 13019,
     /*  50543 */     GIR_EraseRootFromParent_Done,
     /*  50544 */   // Label 844: @50544
     /*  50544 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(50577), // Rule ID 158 //
     /*  50549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50564 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  50567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50575 */     GIR_RootConstrainSelectedInstOperands,
     /*  50576 */     // GIR_Coverage, 158,
     /*  50576 */     GIR_EraseRootFromParent_Done,
     /*  50577 */   // Label 845: @50577
     /*  50577 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(50601), // Rule ID 156 //
     /*  50582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50594 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  50599 */     GIR_RootConstrainSelectedInstOperands,
     /*  50600 */     // GIR_Coverage, 156,
     /*  50600 */     GIR_Done,
     /*  50601 */   // Label 846: @50601
     /*  50601 */   GIM_Reject,
     /*  50602 */ // Label 836: @50602
     /*  50602 */ GIM_Reject,
     /*  50603 */ // Label 818: @50603
     /*  50603 */ GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(52037),
     /*  50608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50614 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(50669), // Rule ID 13024 //
     /*  50619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50639 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  50656 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  50656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  50659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50667 */     GIR_RootConstrainSelectedInstOperands,
     /*  50668 */     // GIR_Coverage, 13024,
     /*  50668 */     GIR_EraseRootFromParent_Done,
     /*  50669 */   // Label 848: @50669
     /*  50669 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(50724), // Rule ID 163 //
     /*  50674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50698 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  50711 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  50711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  50714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50722 */     GIR_RootConstrainSelectedInstOperands,
     /*  50723 */     // GIR_Coverage, 163,
     /*  50723 */     GIR_EraseRootFromParent_Done,
     /*  50724 */   // Label 849: @50724
     /*  50724 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(50837), // Rule ID 5603 //
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  50770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50774 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  50778 */     // MIs[3] Operand 1
     /*  50778 */     // No operand predicates
     /*  50778 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50791 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  50791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  50798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  50807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  50810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  50815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  50820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  50826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50836 */     // GIR_Coverage, 5603,
     /*  50836 */     GIR_EraseRootFromParent_Done,
     /*  50837 */   // Label 850: @50837
     /*  50837 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(50950), // Rule ID 5604 //
     /*  50842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  50883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50887 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  50891 */     // MIs[3] Operand 1
     /*  50891 */     // No operand predicates
     /*  50891 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  50902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50904 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  50904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  50911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  50920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  50923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  50928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  50933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  50939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50949 */     // GIR_Coverage, 5604,
     /*  50949 */     GIR_EraseRootFromParent_Done,
     /*  50950 */   // Label 851: @50950
     /*  50950 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(51049), // Rule ID 7019 //
     /*  50955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  50967 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  50970 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  50975 */     // MIs[1] addr
     /*  50975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  50979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  50984 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  50988 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51001 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  51008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51017 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51048 */     // GIR_Coverage, 7019,
     /*  51048 */     GIR_EraseRootFromParent_Done,
     /*  51049 */   // Label 852: @51049
     /*  51049 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(51148), // Rule ID 7020 //
     /*  51054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51066 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51069 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  51074 */     // MIs[1] addr
     /*  51074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51083 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  51087 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  51098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51100 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  51107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51147 */     // GIR_Coverage, 7020,
     /*  51147 */     GIR_EraseRootFromParent_Done,
     /*  51148 */   // Label 853: @51148
     /*  51148 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(51247), // Rule ID 7021 //
     /*  51153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51165 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51168 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  51173 */     // MIs[1] addr
     /*  51173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51182 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  51186 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51199 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  51206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51246 */     // GIR_Coverage, 7021,
     /*  51246 */     GIR_EraseRootFromParent_Done,
     /*  51247 */   // Label 854: @51247
     /*  51247 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(51346), // Rule ID 7026 //
     /*  51252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51264 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51267 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51272 */     // MIs[1] addr
     /*  51272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51281 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  51285 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  51296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51298 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  51305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51345 */     // GIR_Coverage, 7026,
     /*  51345 */     GIR_EraseRootFromParent_Done,
     /*  51346 */   // Label 855: @51346
     /*  51346 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(51445), // Rule ID 7027 //
     /*  51351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51363 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51366 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51371 */     // MIs[1] addr
     /*  51371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51380 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  51384 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  51395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51397 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  51404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51413 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51444 */     // GIR_Coverage, 7027,
     /*  51444 */     GIR_EraseRootFromParent_Done,
     /*  51445 */   // Label 856: @51445
     /*  51445 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(51544), // Rule ID 7028 //
     /*  51450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51462 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51465 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51470 */     // MIs[1] addr
     /*  51470 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51479 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  51483 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51496 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  51503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51543 */     // GIR_Coverage, 7028,
     /*  51543 */     GIR_EraseRootFromParent_Done,
     /*  51544 */   // Label 857: @51544
     /*  51544 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(51597), // Rule ID 13022 //
     /*  51549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51574 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  51578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51584 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  51587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51595 */     GIR_RootConstrainSelectedInstOperands,
     /*  51596 */     // GIR_Coverage, 13022,
     /*  51596 */     GIR_EraseRootFromParent_Done,
     /*  51597 */   // Label 858: @51597
     /*  51597 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(51650), // Rule ID 161 //
     /*  51602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51631 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  51635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51637 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  51640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51648 */     GIR_RootConstrainSelectedInstOperands,
     /*  51649 */     // GIR_Coverage, 161,
     /*  51649 */     GIR_EraseRootFromParent_Done,
     /*  51650 */   // Label 859: @51650
     /*  51650 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(51750), // Rule ID 3957 //
     /*  51655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51663 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51674 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  51709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51714 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51749 */     // GIR_Coverage, 3957,
     /*  51749 */     GIR_EraseRootFromParent_Done,
     /*  51750 */   // Label 860: @51750
     /*  51750 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(51791), // Rule ID 143 //
     /*  51755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51771 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  51775 */     // MIs[1] Operand 1
     /*  51775 */     // No operand predicates
     /*  51775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51777 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  51777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  51780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51784 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  51789 */     GIR_RootConstrainSelectedInstOperands,
     /*  51790 */     // GIR_Coverage, 143,
     /*  51790 */     GIR_EraseRootFromParent_Done,
     /*  51791 */   // Label 861: @51791
     /*  51791 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(51824), // Rule ID 13020 //
     /*  51796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  51811 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  51811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  51814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  51822 */     GIR_RootConstrainSelectedInstOperands,
     /*  51823 */     // GIR_Coverage, 13020,
     /*  51823 */     GIR_EraseRootFromParent_Done,
     /*  51824 */   // Label 862: @51824
     /*  51824 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(51857), // Rule ID 159 //
     /*  51829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  51844 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  51844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  51847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  51855 */     GIR_RootConstrainSelectedInstOperands,
     /*  51856 */     // GIR_Coverage, 159,
     /*  51856 */     GIR_EraseRootFromParent_Done,
     /*  51857 */   // Label 863: @51857
     /*  51857 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(51921), // Rule ID 13675 //
     /*  51862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51894 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  51902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51908 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  51908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  51911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51913 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  51915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  51919 */     GIR_RootConstrainSelectedInstOperands,
     /*  51920 */     // GIR_Coverage, 13675,
     /*  51920 */     GIR_EraseRootFromParent_Done,
     /*  51921 */   // Label 864: @51921
     /*  51921 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(51985), // Rule ID 4992 //
     /*  51926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51962 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51968 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  51970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51972 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  51972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  51975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51977 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  51979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  51983 */     GIR_RootConstrainSelectedInstOperands,
     /*  51984 */     // GIR_Coverage, 4992,
     /*  51984 */     GIR_EraseRootFromParent_Done,
     /*  51985 */   // Label 865: @51985
     /*  51985 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(52009), // Rule ID 157 //
     /*  51990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52002 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  52007 */     GIR_RootConstrainSelectedInstOperands,
     /*  52008 */     // GIR_Coverage, 157,
     /*  52008 */     GIR_Done,
     /*  52009 */   // Label 866: @52009
     /*  52009 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(52036), // Rule ID 2475 //
     /*  52014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52029 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  52029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52034 */     GIR_RootConstrainSelectedInstOperands,
     /*  52035 */     // GIR_Coverage, 2475,
     /*  52035 */     GIR_Done,
     /*  52036 */   // Label 867: @52036
     /*  52036 */   GIM_Reject,
     /*  52037 */ // Label 847: @52037
     /*  52037 */ GIM_Reject,
     /*  52038 */ // Label 819: @52038
     /*  52038 */ GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(52197),
     /*  52043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52053 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(52113), // Rule ID 13674 //
     /*  52058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52086 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52092 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52100 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52105 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52111 */     GIR_RootConstrainSelectedInstOperands,
     /*  52112 */     // GIR_Coverage, 13674,
     /*  52112 */     GIR_EraseRootFromParent_Done,
     /*  52113 */   // Label 869: @52113
     /*  52113 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(52173), // Rule ID 4991 //
     /*  52118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52150 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52160 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52171 */     GIR_RootConstrainSelectedInstOperands,
     /*  52172 */     // GIR_Coverage, 4991,
     /*  52172 */     GIR_EraseRootFromParent_Done,
     /*  52173 */   // Label 870: @52173
     /*  52173 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(52196), // Rule ID 2474 //
     /*  52178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52189 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52194 */     GIR_RootConstrainSelectedInstOperands,
     /*  52195 */     // GIR_Coverage, 2474,
     /*  52195 */     GIR_Done,
     /*  52196 */   // Label 871: @52196
     /*  52196 */   GIM_Reject,
     /*  52197 */ // Label 868: @52197
     /*  52197 */ GIM_Reject,
     /*  52198 */ // Label 820: @52198
     /*  52198 */ GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(52357),
     /*  52203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52213 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(52273), // Rule ID 13678 //
     /*  52218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52246 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52252 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52260 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52265 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52271 */     GIR_RootConstrainSelectedInstOperands,
     /*  52272 */     // GIR_Coverage, 13678,
     /*  52272 */     GIR_EraseRootFromParent_Done,
     /*  52273 */   // Label 873: @52273
     /*  52273 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(52333), // Rule ID 4995 //
     /*  52278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52310 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52320 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52325 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52331 */     GIR_RootConstrainSelectedInstOperands,
     /*  52332 */     // GIR_Coverage, 4995,
     /*  52332 */     GIR_EraseRootFromParent_Done,
     /*  52333 */   // Label 874: @52333
     /*  52333 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(52356), // Rule ID 2478 //
     /*  52338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52349 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52354 */     GIR_RootConstrainSelectedInstOperands,
     /*  52355 */     // GIR_Coverage, 2478,
     /*  52355 */     GIR_Done,
     /*  52356 */   // Label 875: @52356
     /*  52356 */   GIM_Reject,
     /*  52357 */ // Label 872: @52357
     /*  52357 */ GIM_Reject,
     /*  52358 */ // Label 821: @52358
     /*  52358 */ GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(52517),
     /*  52363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52373 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(52433), // Rule ID 13673 //
     /*  52378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52406 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52420 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52425 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52431 */     GIR_RootConstrainSelectedInstOperands,
     /*  52432 */     // GIR_Coverage, 13673,
     /*  52432 */     GIR_EraseRootFromParent_Done,
     /*  52433 */   // Label 877: @52433
     /*  52433 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(52493), // Rule ID 4990 //
     /*  52438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52470 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52476 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52480 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52485 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52491 */     GIR_RootConstrainSelectedInstOperands,
     /*  52492 */     // GIR_Coverage, 4990,
     /*  52492 */     GIR_EraseRootFromParent_Done,
     /*  52493 */   // Label 878: @52493
     /*  52493 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(52516), // Rule ID 2473 //
     /*  52498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52509 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52514 */     GIR_RootConstrainSelectedInstOperands,
     /*  52515 */     // GIR_Coverage, 2473,
     /*  52515 */     GIR_Done,
     /*  52516 */   // Label 879: @52516
     /*  52516 */   GIM_Reject,
     /*  52517 */ // Label 876: @52517
     /*  52517 */ GIM_Reject,
     /*  52518 */ // Label 822: @52518
     /*  52518 */ GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(52677),
     /*  52523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52533 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(52593), // Rule ID 13677 //
     /*  52538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52566 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52580 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52585 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52591 */     GIR_RootConstrainSelectedInstOperands,
     /*  52592 */     // GIR_Coverage, 13677,
     /*  52592 */     GIR_EraseRootFromParent_Done,
     /*  52593 */   // Label 881: @52593
     /*  52593 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(52653), // Rule ID 4994 //
     /*  52598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52640 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52645 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52651 */     GIR_RootConstrainSelectedInstOperands,
     /*  52652 */     // GIR_Coverage, 4994,
     /*  52652 */     GIR_EraseRootFromParent_Done,
     /*  52653 */   // Label 882: @52653
     /*  52653 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(52676), // Rule ID 2477 //
     /*  52658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52669 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52674 */     GIR_RootConstrainSelectedInstOperands,
     /*  52675 */     // GIR_Coverage, 2477,
     /*  52675 */     GIR_Done,
     /*  52676 */   // Label 883: @52676
     /*  52676 */   GIM_Reject,
     /*  52677 */ // Label 880: @52677
     /*  52677 */ GIM_Reject,
     /*  52678 */ // Label 823: @52678
     /*  52678 */ GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(52837),
     /*  52683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52693 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(52753), // Rule ID 13159 //
     /*  52698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52726 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52740 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52751 */     GIR_RootConstrainSelectedInstOperands,
     /*  52752 */     // GIR_Coverage, 13159,
     /*  52752 */     GIR_EraseRootFromParent_Done,
     /*  52753 */   // Label 885: @52753
     /*  52753 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(52813), // Rule ID 1590 //
     /*  52758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52790 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52800 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52811 */     GIR_RootConstrainSelectedInstOperands,
     /*  52812 */     // GIR_Coverage, 1590,
     /*  52812 */     GIR_EraseRootFromParent_Done,
     /*  52813 */   // Label 886: @52813
     /*  52813 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(52836), // Rule ID 1588 //
     /*  52818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52829 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52834 */     GIR_RootConstrainSelectedInstOperands,
     /*  52835 */     // GIR_Coverage, 1588,
     /*  52835 */     GIR_Done,
     /*  52836 */   // Label 887: @52836
     /*  52836 */   GIM_Reject,
     /*  52837 */ // Label 884: @52837
     /*  52837 */ GIM_Reject,
     /*  52838 */ // Label 824: @52838
     /*  52838 */ GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(52997),
     /*  52843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52853 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(52913), // Rule ID 13676 //
     /*  52858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52886 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52892 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52900 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52905 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52911 */     GIR_RootConstrainSelectedInstOperands,
     /*  52912 */     // GIR_Coverage, 13676,
     /*  52912 */     GIR_EraseRootFromParent_Done,
     /*  52913 */   // Label 889: @52913
     /*  52913 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(52973), // Rule ID 4993 //
     /*  52918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52950 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52956 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52960 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52965 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52971 */     GIR_RootConstrainSelectedInstOperands,
     /*  52972 */     // GIR_Coverage, 4993,
     /*  52972 */     GIR_EraseRootFromParent_Done,
     /*  52973 */   // Label 890: @52973
     /*  52973 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(52996), // Rule ID 2476 //
     /*  52978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52989 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52994 */     GIR_RootConstrainSelectedInstOperands,
     /*  52995 */     // GIR_Coverage, 2476,
     /*  52995 */     GIR_Done,
     /*  52996 */   // Label 891: @52996
     /*  52996 */   GIM_Reject,
     /*  52997 */ // Label 888: @52997
     /*  52997 */ GIM_Reject,
     /*  52998 */ // Label 825: @52998
     /*  52998 */ GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(53157),
     /*  53003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53013 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(53073), // Rule ID 13160 //
     /*  53018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53046 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  53052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  53054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53060 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  53063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53071 */     GIR_RootConstrainSelectedInstOperands,
     /*  53072 */     // GIR_Coverage, 13160,
     /*  53072 */     GIR_EraseRootFromParent_Done,
     /*  53073 */   // Label 893: @53073
     /*  53073 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(53133), // Rule ID 1591 //
     /*  53078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53110 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  53116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  53118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53120 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  53123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53131 */     GIR_RootConstrainSelectedInstOperands,
     /*  53132 */     // GIR_Coverage, 1591,
     /*  53132 */     GIR_EraseRootFromParent_Done,
     /*  53133 */   // Label 894: @53133
     /*  53133 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(53156), // Rule ID 1589 //
     /*  53138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53149 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  53154 */     GIR_RootConstrainSelectedInstOperands,
     /*  53155 */     // GIR_Coverage, 1589,
     /*  53155 */     GIR_Done,
     /*  53156 */   // Label 895: @53156
     /*  53156 */   GIM_Reject,
     /*  53157 */ // Label 892: @53157
     /*  53157 */ GIM_Reject,
     /*  53158 */ // Label 826: @53158
     /*  53158 */ GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(53698),
     /*  53163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  53173 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(53230), // Rule ID 14876 //
     /*  53178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53209 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53215 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53228 */     GIR_RootConstrainSelectedInstOperands,
     /*  53229 */     // GIR_Coverage, 14876,
     /*  53229 */     GIR_EraseRootFromParent_Done,
     /*  53230 */   // Label 897: @53230
     /*  53230 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(53287), // Rule ID 14879 //
     /*  53235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53266 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53272 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53285 */     GIR_RootConstrainSelectedInstOperands,
     /*  53286 */     // GIR_Coverage, 14879,
     /*  53286 */     GIR_EraseRootFromParent_Done,
     /*  53287 */   // Label 898: @53287
     /*  53287 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(53344), // Rule ID 14875 //
     /*  53292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53323 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53329 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53342 */     GIR_RootConstrainSelectedInstOperands,
     /*  53343 */     // GIR_Coverage, 14875,
     /*  53343 */     GIR_EraseRootFromParent_Done,
     /*  53344 */   // Label 899: @53344
     /*  53344 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(53401), // Rule ID 14878 //
     /*  53349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53380 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53386 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53399 */     GIR_RootConstrainSelectedInstOperands,
     /*  53400 */     // GIR_Coverage, 14878,
     /*  53400 */     GIR_EraseRootFromParent_Done,
     /*  53401 */   // Label 900: @53401
     /*  53401 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(53458), // Rule ID 14874 //
     /*  53406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53437 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53443 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53456 */     GIR_RootConstrainSelectedInstOperands,
     /*  53457 */     // GIR_Coverage, 14874,
     /*  53457 */     GIR_EraseRootFromParent_Done,
     /*  53458 */   // Label 901: @53458
     /*  53458 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(53515), // Rule ID 14877 //
     /*  53463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53500 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53513 */     GIR_RootConstrainSelectedInstOperands,
     /*  53514 */     // GIR_Coverage, 14877,
     /*  53514 */     GIR_EraseRootFromParent_Done,
     /*  53515 */   // Label 902: @53515
     /*  53515 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(53572), // Rule ID 8328 //
     /*  53520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53551 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53557 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53570 */     GIR_RootConstrainSelectedInstOperands,
     /*  53571 */     // GIR_Coverage, 8328,
     /*  53571 */     GIR_EraseRootFromParent_Done,
     /*  53572 */   // Label 903: @53572
     /*  53572 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(53629), // Rule ID 8329 //
     /*  53577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53614 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53627 */     GIR_RootConstrainSelectedInstOperands,
     /*  53628 */     // GIR_Coverage, 8329,
     /*  53628 */     GIR_EraseRootFromParent_Done,
     /*  53629 */   // Label 904: @53629
     /*  53629 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(53676), // Rule ID 10580 //
     /*  53634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  53641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  53645 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  53645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  53648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  53652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  53660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  53672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 10580,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 905: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(53697), // Rule ID 2744 //
     /*  53681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53684 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  53687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  53695 */     GIR_RootConstrainSelectedInstOperands,
     /*  53696 */     // GIR_Coverage, 2744,
     /*  53696 */     GIR_EraseRootFromParent_Done,
     /*  53697 */   // Label 906: @53697
     /*  53697 */   GIM_Reject,
     /*  53698 */ // Label 896: @53698
     /*  53698 */ GIM_Reject,
     /*  53699 */ // Label 827: @53699
     /*  53699 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(54239),
     /*  53704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  53714 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(53771), // Rule ID 14867 //
     /*  53719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53750 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53756 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53769 */     GIR_RootConstrainSelectedInstOperands,
     /*  53770 */     // GIR_Coverage, 14867,
     /*  53770 */     GIR_EraseRootFromParent_Done,
     /*  53771 */   // Label 908: @53771
     /*  53771 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(53828), // Rule ID 14870 //
     /*  53776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53813 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53826 */     GIR_RootConstrainSelectedInstOperands,
     /*  53827 */     // GIR_Coverage, 14870,
     /*  53827 */     GIR_EraseRootFromParent_Done,
     /*  53828 */   // Label 909: @53828
     /*  53828 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(53885), // Rule ID 14866 //
     /*  53833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53864 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53870 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53883 */     GIR_RootConstrainSelectedInstOperands,
     /*  53884 */     // GIR_Coverage, 14866,
     /*  53884 */     GIR_EraseRootFromParent_Done,
     /*  53885 */   // Label 910: @53885
     /*  53885 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(53942), // Rule ID 14869 //
     /*  53890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53921 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53927 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53940 */     GIR_RootConstrainSelectedInstOperands,
     /*  53941 */     // GIR_Coverage, 14869,
     /*  53941 */     GIR_EraseRootFromParent_Done,
     /*  53942 */   // Label 911: @53942
     /*  53942 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(53999), // Rule ID 14865 //
     /*  53947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53978 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53984 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53997 */     GIR_RootConstrainSelectedInstOperands,
     /*  53998 */     // GIR_Coverage, 14865,
     /*  53998 */     GIR_EraseRootFromParent_Done,
     /*  53999 */   // Label 912: @53999
     /*  53999 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(54056), // Rule ID 14868 //
     /*  54004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54035 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54041 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54054 */     GIR_RootConstrainSelectedInstOperands,
     /*  54055 */     // GIR_Coverage, 14868,
     /*  54055 */     GIR_EraseRootFromParent_Done,
     /*  54056 */   // Label 913: @54056
     /*  54056 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(54113), // Rule ID 8324 //
     /*  54061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54092 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54098 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54111 */     GIR_RootConstrainSelectedInstOperands,
     /*  54112 */     // GIR_Coverage, 8324,
     /*  54112 */     GIR_EraseRootFromParent_Done,
     /*  54113 */   // Label 914: @54113
     /*  54113 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(54170), // Rule ID 8325 //
     /*  54118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54149 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54155 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54168 */     GIR_RootConstrainSelectedInstOperands,
     /*  54169 */     // GIR_Coverage, 8325,
     /*  54169 */     GIR_EraseRootFromParent_Done,
     /*  54170 */   // Label 915: @54170
     /*  54170 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(54217), // Rule ID 10579 //
     /*  54175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  54182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  54186 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  54186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  54189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  54193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  54201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  54206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  54213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  54215 */     GIR_RootConstrainSelectedInstOperands,
     /*  54216 */     // GIR_Coverage, 10579,
     /*  54216 */     GIR_EraseRootFromParent_Done,
     /*  54217 */   // Label 916: @54217
     /*  54217 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(54238), // Rule ID 2743 //
     /*  54222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54225 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  54228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  54236 */     GIR_RootConstrainSelectedInstOperands,
     /*  54237 */     // GIR_Coverage, 2743,
     /*  54237 */     GIR_EraseRootFromParent_Done,
     /*  54238 */   // Label 917: @54238
     /*  54238 */   GIM_Reject,
     /*  54239 */ // Label 907: @54239
     /*  54239 */ GIM_Reject,
     /*  54240 */ // Label 828: @54240
     /*  54240 */ GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(54711),
     /*  54245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  54255 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(54310), // Rule ID 14807 //
     /*  54260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54291 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54297 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54308 */     GIR_RootConstrainSelectedInstOperands,
     /*  54309 */     // GIR_Coverage, 14807,
     /*  54309 */     GIR_EraseRootFromParent_Done,
     /*  54310 */   // Label 919: @54310
     /*  54310 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(54365), // Rule ID 14810 //
     /*  54315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54346 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54352 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54363 */     GIR_RootConstrainSelectedInstOperands,
     /*  54364 */     // GIR_Coverage, 14810,
     /*  54364 */     GIR_EraseRootFromParent_Done,
     /*  54365 */   // Label 920: @54365
     /*  54365 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(54420), // Rule ID 14806 //
     /*  54370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54401 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54407 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54418 */     GIR_RootConstrainSelectedInstOperands,
     /*  54419 */     // GIR_Coverage, 14806,
     /*  54419 */     GIR_EraseRootFromParent_Done,
     /*  54420 */   // Label 921: @54420
     /*  54420 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(54475), // Rule ID 14809 //
     /*  54425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54456 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54462 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54473 */     GIR_RootConstrainSelectedInstOperands,
     /*  54474 */     // GIR_Coverage, 14809,
     /*  54474 */     GIR_EraseRootFromParent_Done,
     /*  54475 */   // Label 922: @54475
     /*  54475 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(54530), // Rule ID 14805 //
     /*  54480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54511 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54517 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54528 */     GIR_RootConstrainSelectedInstOperands,
     /*  54529 */     // GIR_Coverage, 14805,
     /*  54529 */     GIR_EraseRootFromParent_Done,
     /*  54530 */   // Label 923: @54530
     /*  54530 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(54585), // Rule ID 14808 //
     /*  54535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54566 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54572 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54583 */     GIR_RootConstrainSelectedInstOperands,
     /*  54584 */     // GIR_Coverage, 14808,
     /*  54584 */     GIR_EraseRootFromParent_Done,
     /*  54585 */   // Label 924: @54585
     /*  54585 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(54640), // Rule ID 7377 //
     /*  54590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54627 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54638 */     GIR_RootConstrainSelectedInstOperands,
     /*  54639 */     // GIR_Coverage, 7377,
     /*  54639 */     GIR_EraseRootFromParent_Done,
     /*  54640 */   // Label 925: @54640
     /*  54640 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(54695), // Rule ID 7378 //
     /*  54645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54676 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54682 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54693 */     GIR_RootConstrainSelectedInstOperands,
     /*  54694 */     // GIR_Coverage, 7378,
     /*  54694 */     GIR_EraseRootFromParent_Done,
     /*  54695 */   // Label 926: @54695
     /*  54695 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(54710), // Rule ID 3137 //
     /*  54700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54703 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  54708 */     GIR_RootConstrainSelectedInstOperands,
     /*  54709 */     // GIR_Coverage, 3137,
     /*  54709 */     GIR_Done,
     /*  54710 */   // Label 927: @54710
     /*  54710 */   GIM_Reject,
     /*  54711 */ // Label 918: @54711
     /*  54711 */ GIM_Reject,
     /*  54712 */ // Label 829: @54712
     /*  54712 */ GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(55252),
     /*  54717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  54727 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(54784), // Rule ID 14858 //
     /*  54732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54763 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54769 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54782 */     GIR_RootConstrainSelectedInstOperands,
     /*  54783 */     // GIR_Coverage, 14858,
     /*  54783 */     GIR_EraseRootFromParent_Done,
     /*  54784 */   // Label 929: @54784
     /*  54784 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(54841), // Rule ID 14861 //
     /*  54789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54826 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54839 */     GIR_RootConstrainSelectedInstOperands,
     /*  54840 */     // GIR_Coverage, 14861,
     /*  54840 */     GIR_EraseRootFromParent_Done,
     /*  54841 */   // Label 930: @54841
     /*  54841 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(54898), // Rule ID 14857 //
     /*  54846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54877 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54883 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54896 */     GIR_RootConstrainSelectedInstOperands,
     /*  54897 */     // GIR_Coverage, 14857,
     /*  54897 */     GIR_EraseRootFromParent_Done,
     /*  54898 */   // Label 931: @54898
     /*  54898 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(54955), // Rule ID 14860 //
     /*  54903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54940 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54953 */     GIR_RootConstrainSelectedInstOperands,
     /*  54954 */     // GIR_Coverage, 14860,
     /*  54954 */     GIR_EraseRootFromParent_Done,
     /*  54955 */   // Label 932: @54955
     /*  54955 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(55012), // Rule ID 14856 //
     /*  54960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54991 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54997 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55010 */     GIR_RootConstrainSelectedInstOperands,
     /*  55011 */     // GIR_Coverage, 14856,
     /*  55011 */     GIR_EraseRootFromParent_Done,
     /*  55012 */   // Label 933: @55012
     /*  55012 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(55069), // Rule ID 14859 //
     /*  55017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55048 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55054 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55067 */     GIR_RootConstrainSelectedInstOperands,
     /*  55068 */     // GIR_Coverage, 14859,
     /*  55068 */     GIR_EraseRootFromParent_Done,
     /*  55069 */   // Label 934: @55069
     /*  55069 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(55126), // Rule ID 8320 //
     /*  55074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55105 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55111 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55124 */     GIR_RootConstrainSelectedInstOperands,
     /*  55125 */     // GIR_Coverage, 8320,
     /*  55125 */     GIR_EraseRootFromParent_Done,
     /*  55126 */   // Label 935: @55126
     /*  55126 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(55183), // Rule ID 8321 //
     /*  55131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55162 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55168 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55181 */     GIR_RootConstrainSelectedInstOperands,
     /*  55182 */     // GIR_Coverage, 8321,
     /*  55182 */     GIR_EraseRootFromParent_Done,
     /*  55183 */   // Label 936: @55183
     /*  55183 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(55230), // Rule ID 10578 //
     /*  55188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  55195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  55199 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  55199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  55202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  55206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  55214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  55219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  55226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  55228 */     GIR_RootConstrainSelectedInstOperands,
     /*  55229 */     // GIR_Coverage, 10578,
     /*  55229 */     GIR_EraseRootFromParent_Done,
     /*  55230 */   // Label 937: @55230
     /*  55230 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(55251), // Rule ID 2742 //
     /*  55235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55238 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  55241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  55249 */     GIR_RootConstrainSelectedInstOperands,
     /*  55250 */     // GIR_Coverage, 2742,
     /*  55250 */     GIR_EraseRootFromParent_Done,
     /*  55251 */   // Label 938: @55251
     /*  55251 */   GIM_Reject,
     /*  55252 */ // Label 928: @55252
     /*  55252 */ GIM_Reject,
     /*  55253 */ // Label 830: @55253
     /*  55253 */ GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(55724),
     /*  55258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  55268 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(55323), // Rule ID 14798 //
     /*  55273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55304 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55310 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55321 */     GIR_RootConstrainSelectedInstOperands,
     /*  55322 */     // GIR_Coverage, 14798,
     /*  55322 */     GIR_EraseRootFromParent_Done,
     /*  55323 */   // Label 940: @55323
     /*  55323 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(55378), // Rule ID 14801 //
     /*  55328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55359 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55365 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55376 */     GIR_RootConstrainSelectedInstOperands,
     /*  55377 */     // GIR_Coverage, 14801,
     /*  55377 */     GIR_EraseRootFromParent_Done,
     /*  55378 */   // Label 941: @55378
     /*  55378 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(55433), // Rule ID 14797 //
     /*  55383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55414 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55420 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55431 */     GIR_RootConstrainSelectedInstOperands,
     /*  55432 */     // GIR_Coverage, 14797,
     /*  55432 */     GIR_EraseRootFromParent_Done,
     /*  55433 */   // Label 942: @55433
     /*  55433 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(55488), // Rule ID 14800 //
     /*  55438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55469 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55475 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55486 */     GIR_RootConstrainSelectedInstOperands,
     /*  55487 */     // GIR_Coverage, 14800,
     /*  55487 */     GIR_EraseRootFromParent_Done,
     /*  55488 */   // Label 943: @55488
     /*  55488 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(55543), // Rule ID 14796 //
     /*  55493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55524 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55530 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55541 */     GIR_RootConstrainSelectedInstOperands,
     /*  55542 */     // GIR_Coverage, 14796,
     /*  55542 */     GIR_EraseRootFromParent_Done,
     /*  55543 */   // Label 944: @55543
     /*  55543 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(55598), // Rule ID 14799 //
     /*  55548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55579 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55585 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55596 */     GIR_RootConstrainSelectedInstOperands,
     /*  55597 */     // GIR_Coverage, 14799,
     /*  55597 */     GIR_EraseRootFromParent_Done,
     /*  55598 */   // Label 945: @55598
     /*  55598 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(55653), // Rule ID 7373 //
     /*  55603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55634 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55640 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55651 */     GIR_RootConstrainSelectedInstOperands,
     /*  55652 */     // GIR_Coverage, 7373,
     /*  55652 */     GIR_EraseRootFromParent_Done,
     /*  55653 */   // Label 946: @55653
     /*  55653 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(55708), // Rule ID 7374 //
     /*  55658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55695 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55706 */     GIR_RootConstrainSelectedInstOperands,
     /*  55707 */     // GIR_Coverage, 7374,
     /*  55707 */     GIR_EraseRootFromParent_Done,
     /*  55708 */   // Label 947: @55708
     /*  55708 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(55723), // Rule ID 3136 //
     /*  55713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55716 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  55721 */     GIR_RootConstrainSelectedInstOperands,
     /*  55722 */     // GIR_Coverage, 3136,
     /*  55722 */     GIR_Done,
     /*  55723 */   // Label 948: @55723
     /*  55723 */   GIM_Reject,
     /*  55724 */ // Label 939: @55724
     /*  55724 */ GIM_Reject,
     /*  55725 */ // Label 831: @55725
     /*  55725 */ GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(56265),
     /*  55730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  55740 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(55797), // Rule ID 14849 //
     /*  55745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55776 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55782 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55795 */     GIR_RootConstrainSelectedInstOperands,
     /*  55796 */     // GIR_Coverage, 14849,
     /*  55796 */     GIR_EraseRootFromParent_Done,
     /*  55797 */   // Label 950: @55797
     /*  55797 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(55854), // Rule ID 14852 //
     /*  55802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55833 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55839 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55852 */     GIR_RootConstrainSelectedInstOperands,
     /*  55853 */     // GIR_Coverage, 14852,
     /*  55853 */     GIR_EraseRootFromParent_Done,
     /*  55854 */   // Label 951: @55854
     /*  55854 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(55911), // Rule ID 14848 //
     /*  55859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55890 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55896 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55909 */     GIR_RootConstrainSelectedInstOperands,
     /*  55910 */     // GIR_Coverage, 14848,
     /*  55910 */     GIR_EraseRootFromParent_Done,
     /*  55911 */   // Label 952: @55911
     /*  55911 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(55968), // Rule ID 14851 //
     /*  55916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55947 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55953 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55966 */     GIR_RootConstrainSelectedInstOperands,
     /*  55967 */     // GIR_Coverage, 14851,
     /*  55967 */     GIR_EraseRootFromParent_Done,
     /*  55968 */   // Label 953: @55968
     /*  55968 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(56025), // Rule ID 14847 //
     /*  55973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56004 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56010 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56023 */     GIR_RootConstrainSelectedInstOperands,
     /*  56024 */     // GIR_Coverage, 14847,
     /*  56024 */     GIR_EraseRootFromParent_Done,
     /*  56025 */   // Label 954: @56025
     /*  56025 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(56082), // Rule ID 14850 //
     /*  56030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56061 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56067 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56080 */     GIR_RootConstrainSelectedInstOperands,
     /*  56081 */     // GIR_Coverage, 14850,
     /*  56081 */     GIR_EraseRootFromParent_Done,
     /*  56082 */   // Label 955: @56082
     /*  56082 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(56139), // Rule ID 8316 //
     /*  56087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56118 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56124 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56137 */     GIR_RootConstrainSelectedInstOperands,
     /*  56138 */     // GIR_Coverage, 8316,
     /*  56138 */     GIR_EraseRootFromParent_Done,
     /*  56139 */   // Label 956: @56139
     /*  56139 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(56196), // Rule ID 8317 //
     /*  56144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56175 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56181 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56194 */     GIR_RootConstrainSelectedInstOperands,
     /*  56195 */     // GIR_Coverage, 8317,
     /*  56195 */     GIR_EraseRootFromParent_Done,
     /*  56196 */   // Label 957: @56196
     /*  56196 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(56243), // Rule ID 10577 //
     /*  56201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56212 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  56212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  56219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56224 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56241 */     GIR_RootConstrainSelectedInstOperands,
     /*  56242 */     // GIR_Coverage, 10577,
     /*  56242 */     GIR_EraseRootFromParent_Done,
     /*  56243 */   // Label 958: @56243
     /*  56243 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(56264), // Rule ID 2741 //
     /*  56248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56251 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56262 */     GIR_RootConstrainSelectedInstOperands,
     /*  56263 */     // GIR_Coverage, 2741,
     /*  56263 */     GIR_EraseRootFromParent_Done,
     /*  56264 */   // Label 959: @56264
     /*  56264 */   GIM_Reject,
     /*  56265 */ // Label 949: @56265
     /*  56265 */ GIM_Reject,
     /*  56266 */ // Label 832: @56266
     /*  56266 */ GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(56737),
     /*  56271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  56281 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(56336), // Rule ID 14789 //
     /*  56286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56317 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56323 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56334 */     GIR_RootConstrainSelectedInstOperands,
     /*  56335 */     // GIR_Coverage, 14789,
     /*  56335 */     GIR_EraseRootFromParent_Done,
     /*  56336 */   // Label 961: @56336
     /*  56336 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(56391), // Rule ID 14792 //
     /*  56341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56372 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56378 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56389 */     GIR_RootConstrainSelectedInstOperands,
     /*  56390 */     // GIR_Coverage, 14792,
     /*  56390 */     GIR_EraseRootFromParent_Done,
     /*  56391 */   // Label 962: @56391
     /*  56391 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(56446), // Rule ID 14788 //
     /*  56396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56427 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56433 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56444 */     GIR_RootConstrainSelectedInstOperands,
     /*  56445 */     // GIR_Coverage, 14788,
     /*  56445 */     GIR_EraseRootFromParent_Done,
     /*  56446 */   // Label 963: @56446
     /*  56446 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(56501), // Rule ID 14791 //
     /*  56451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56482 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56488 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56499 */     GIR_RootConstrainSelectedInstOperands,
     /*  56500 */     // GIR_Coverage, 14791,
     /*  56500 */     GIR_EraseRootFromParent_Done,
     /*  56501 */   // Label 964: @56501
     /*  56501 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(56556), // Rule ID 14787 //
     /*  56506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56537 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56543 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56554 */     GIR_RootConstrainSelectedInstOperands,
     /*  56555 */     // GIR_Coverage, 14787,
     /*  56555 */     GIR_EraseRootFromParent_Done,
     /*  56556 */   // Label 965: @56556
     /*  56556 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(56611), // Rule ID 14790 //
     /*  56561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56592 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56598 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56609 */     GIR_RootConstrainSelectedInstOperands,
     /*  56610 */     // GIR_Coverage, 14790,
     /*  56610 */     GIR_EraseRootFromParent_Done,
     /*  56611 */   // Label 966: @56611
     /*  56611 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(56666), // Rule ID 7369 //
     /*  56616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56653 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56664 */     GIR_RootConstrainSelectedInstOperands,
     /*  56665 */     // GIR_Coverage, 7369,
     /*  56665 */     GIR_EraseRootFromParent_Done,
     /*  56666 */   // Label 967: @56666
     /*  56666 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(56721), // Rule ID 7370 //
     /*  56671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56708 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56719 */     GIR_RootConstrainSelectedInstOperands,
     /*  56720 */     // GIR_Coverage, 7370,
     /*  56720 */     GIR_EraseRootFromParent_Done,
     /*  56721 */   // Label 968: @56721
     /*  56721 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(56736), // Rule ID 3135 //
     /*  56726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56729 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  56734 */     GIR_RootConstrainSelectedInstOperands,
     /*  56735 */     // GIR_Coverage, 3135,
     /*  56735 */     GIR_Done,
     /*  56736 */   // Label 969: @56736
     /*  56736 */   GIM_Reject,
     /*  56737 */ // Label 960: @56737
     /*  56737 */ GIM_Reject,
     /*  56738 */ // Label 833: @56738
     /*  56738 */ GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(57278),
     /*  56743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56753 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(56810), // Rule ID 14840 //
     /*  56758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56789 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56795 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56808 */     GIR_RootConstrainSelectedInstOperands,
     /*  56809 */     // GIR_Coverage, 14840,
     /*  56809 */     GIR_EraseRootFromParent_Done,
     /*  56810 */   // Label 971: @56810
     /*  56810 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(56867), // Rule ID 14843 //
     /*  56815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56846 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56852 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56865 */     GIR_RootConstrainSelectedInstOperands,
     /*  56866 */     // GIR_Coverage, 14843,
     /*  56866 */     GIR_EraseRootFromParent_Done,
     /*  56867 */   // Label 972: @56867
     /*  56867 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(56924), // Rule ID 14839 //
     /*  56872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56903 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56909 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56922 */     GIR_RootConstrainSelectedInstOperands,
     /*  56923 */     // GIR_Coverage, 14839,
     /*  56923 */     GIR_EraseRootFromParent_Done,
     /*  56924 */   // Label 973: @56924
     /*  56924 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(56981), // Rule ID 14842 //
     /*  56929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56960 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56966 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56979 */     GIR_RootConstrainSelectedInstOperands,
     /*  56980 */     // GIR_Coverage, 14842,
     /*  56980 */     GIR_EraseRootFromParent_Done,
     /*  56981 */   // Label 974: @56981
     /*  56981 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(57038), // Rule ID 14838 //
     /*  56986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57017 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57023 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57036 */     GIR_RootConstrainSelectedInstOperands,
     /*  57037 */     // GIR_Coverage, 14838,
     /*  57037 */     GIR_EraseRootFromParent_Done,
     /*  57038 */   // Label 975: @57038
     /*  57038 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(57095), // Rule ID 14841 //
     /*  57043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57074 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57080 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57093 */     GIR_RootConstrainSelectedInstOperands,
     /*  57094 */     // GIR_Coverage, 14841,
     /*  57094 */     GIR_EraseRootFromParent_Done,
     /*  57095 */   // Label 976: @57095
     /*  57095 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(57152), // Rule ID 8312 //
     /*  57100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57131 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57137 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57150 */     GIR_RootConstrainSelectedInstOperands,
     /*  57151 */     // GIR_Coverage, 8312,
     /*  57151 */     GIR_EraseRootFromParent_Done,
     /*  57152 */   // Label 977: @57152
     /*  57152 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(57209), // Rule ID 8313 //
     /*  57157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57188 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57194 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57207 */     GIR_RootConstrainSelectedInstOperands,
     /*  57208 */     // GIR_Coverage, 8313,
     /*  57208 */     GIR_EraseRootFromParent_Done,
     /*  57209 */   // Label 978: @57209
     /*  57209 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(57256), // Rule ID 10576 //
     /*  57214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57225 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  57225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  57232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57254 */     GIR_RootConstrainSelectedInstOperands,
     /*  57255 */     // GIR_Coverage, 10576,
     /*  57255 */     GIR_EraseRootFromParent_Done,
     /*  57256 */   // Label 979: @57256
     /*  57256 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(57277), // Rule ID 2740 //
     /*  57261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57264 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57275 */     GIR_RootConstrainSelectedInstOperands,
     /*  57276 */     // GIR_Coverage, 2740,
     /*  57276 */     GIR_EraseRootFromParent_Done,
     /*  57277 */   // Label 980: @57277
     /*  57277 */   GIM_Reject,
     /*  57278 */ // Label 970: @57278
     /*  57278 */ GIM_Reject,
     /*  57279 */ // Label 834: @57279
     /*  57279 */ GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(57750),
     /*  57284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57294 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(57349), // Rule ID 14780 //
     /*  57299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57330 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57336 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57347 */     GIR_RootConstrainSelectedInstOperands,
     /*  57348 */     // GIR_Coverage, 14780,
     /*  57348 */     GIR_EraseRootFromParent_Done,
     /*  57349 */   // Label 982: @57349
     /*  57349 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(57404), // Rule ID 14783 //
     /*  57354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57385 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57391 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57402 */     GIR_RootConstrainSelectedInstOperands,
     /*  57403 */     // GIR_Coverage, 14783,
     /*  57403 */     GIR_EraseRootFromParent_Done,
     /*  57404 */   // Label 983: @57404
     /*  57404 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(57459), // Rule ID 14779 //
     /*  57409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57440 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57446 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57457 */     GIR_RootConstrainSelectedInstOperands,
     /*  57458 */     // GIR_Coverage, 14779,
     /*  57458 */     GIR_EraseRootFromParent_Done,
     /*  57459 */   // Label 984: @57459
     /*  57459 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(57514), // Rule ID 14782 //
     /*  57464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57495 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57501 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57512 */     GIR_RootConstrainSelectedInstOperands,
     /*  57513 */     // GIR_Coverage, 14782,
     /*  57513 */     GIR_EraseRootFromParent_Done,
     /*  57514 */   // Label 985: @57514
     /*  57514 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(57569), // Rule ID 14778 //
     /*  57519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57550 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57556 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57567 */     GIR_RootConstrainSelectedInstOperands,
     /*  57568 */     // GIR_Coverage, 14778,
     /*  57568 */     GIR_EraseRootFromParent_Done,
     /*  57569 */   // Label 986: @57569
     /*  57569 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(57624), // Rule ID 14781 //
     /*  57574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57611 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57622 */     GIR_RootConstrainSelectedInstOperands,
     /*  57623 */     // GIR_Coverage, 14781,
     /*  57623 */     GIR_EraseRootFromParent_Done,
     /*  57624 */   // Label 987: @57624
     /*  57624 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(57679), // Rule ID 7365 //
     /*  57629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57660 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57666 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57677 */     GIR_RootConstrainSelectedInstOperands,
     /*  57678 */     // GIR_Coverage, 7365,
     /*  57678 */     GIR_EraseRootFromParent_Done,
     /*  57679 */   // Label 988: @57679
     /*  57679 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(57734), // Rule ID 7366 //
     /*  57684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57715 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57721 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57732 */     GIR_RootConstrainSelectedInstOperands,
     /*  57733 */     // GIR_Coverage, 7366,
     /*  57733 */     GIR_EraseRootFromParent_Done,
     /*  57734 */   // Label 989: @57734
     /*  57734 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(57749), // Rule ID 3134 //
     /*  57739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57742 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57747 */     GIR_RootConstrainSelectedInstOperands,
     /*  57748 */     // GIR_Coverage, 3134,
     /*  57748 */     GIR_Done,
     /*  57749 */   // Label 990: @57749
     /*  57749 */   GIM_Reject,
     /*  57750 */ // Label 981: @57750
     /*  57750 */ GIM_Reject,
     /*  57751 */ // Label 835: @57751
     /*  57751 */ GIM_Reject,
     /*  57752 */ // Label 6: @57752
     /*  57752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1009*/ GIMT_Encode4(69798),
     /*  57763 */ /*GILLT_s32*//*Label 991*/ GIMT_Encode4(57851),
     /*  57767 */ /*GILLT_s64*//*Label 992*/ GIMT_Encode4(58211), GIMT_Encode4(0),
     /*  57775 */ /*GILLT_v2s32*//*Label 993*/ GIMT_Encode4(60378),
     /*  57779 */ /*GILLT_v2s64*//*Label 994*/ GIMT_Encode4(61686),
     /*  57783 */ /*GILLT_v4s16*//*Label 995*/ GIMT_Encode4(62994),
     /*  57787 */ /*GILLT_v4s32*//*Label 996*/ GIMT_Encode4(64302),
     /*  57791 */ /*GILLT_v8s8*//*Label 997*/ GIMT_Encode4(65610),
     /*  57795 */ /*GILLT_v8s16*//*Label 998*/ GIMT_Encode4(66918),
     /*  57799 */ /*GILLT_v16s8*//*Label 999*/ GIMT_Encode4(68226),
     /*  57803 */ /*GILLT_nxv1s1*//*Label 1000*/ GIMT_Encode4(69534),
     /*  57807 */ /*GILLT_nxv2s1*//*Label 1001*/ GIMT_Encode4(69566), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  57819 */ /*GILLT_nxv2s64*//*Label 1002*/ GIMT_Encode4(69598),
     /*  57823 */ /*GILLT_nxv4s1*//*Label 1003*/ GIMT_Encode4(69624), GIMT_Encode4(0),
     /*  57831 */ /*GILLT_nxv4s32*//*Label 1004*/ GIMT_Encode4(69656),
     /*  57835 */ /*GILLT_nxv8s1*//*Label 1005*/ GIMT_Encode4(69682),
     /*  57839 */ /*GILLT_nxv8s16*//*Label 1006*/ GIMT_Encode4(69714),
     /*  57843 */ /*GILLT_nxv16s1*//*Label 1007*/ GIMT_Encode4(69740),
     /*  57847 */ /*GILLT_nxv16s8*//*Label 1008*/ GIMT_Encode4(69772),
     /*  57851 */ // Label 991: @57851
     /*  57851 */ GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(58210),
     /*  57856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57862 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(57917), // Rule ID 13043 //
     /*  57867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  57904 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  57904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  57907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  57915 */     GIR_RootConstrainSelectedInstOperands,
     /*  57916 */     // GIR_Coverage, 13043,
     /*  57916 */     GIR_EraseRootFromParent_Done,
     /*  57917 */   // Label 1011: @57917
     /*  57917 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(57972), // Rule ID 174 //
     /*  57922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57946 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  57959 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  57959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  57962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  57970 */     GIR_RootConstrainSelectedInstOperands,
     /*  57971 */     // GIR_Coverage, 174,
     /*  57971 */     GIR_EraseRootFromParent_Done,
     /*  57972 */   // Label 1012: @57972
     /*  57972 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(58013), // Rule ID 146 //
     /*  57977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  57981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57993 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  57997 */     // MIs[1] Operand 1
     /*  57997 */     // No operand predicates
     /*  57997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57999 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  57999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  58002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58006 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  58011 */     GIR_RootConstrainSelectedInstOperands,
     /*  58012 */     // GIR_Coverage, 146,
     /*  58012 */     GIR_EraseRootFromParent_Done,
     /*  58013 */   // Label 1013: @58013
     /*  58013 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(58046), // Rule ID 13045 //
     /*  58018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  58033 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  58033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  58036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58044 */     GIR_RootConstrainSelectedInstOperands,
     /*  58045 */     // GIR_Coverage, 13045,
     /*  58045 */     GIR_EraseRootFromParent_Done,
     /*  58046 */   // Label 1014: @58046
     /*  58046 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(58079), // Rule ID 178 //
     /*  58051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  58066 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  58066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  58069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58077 */     GIR_RootConstrainSelectedInstOperands,
     /*  58078 */     // GIR_Coverage, 178,
     /*  58078 */     GIR_EraseRootFromParent_Done,
     /*  58079 */   // Label 1015: @58079
     /*  58079 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(58132), // Rule ID 13041 //
     /*  58084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  58100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  58104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58109 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58119 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  58122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  58130 */     GIR_RootConstrainSelectedInstOperands,
     /*  58131 */     // GIR_Coverage, 13041,
     /*  58131 */     GIR_EraseRootFromParent_Done,
     /*  58132 */   // Label 1016: @58132
     /*  58132 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(58185), // Rule ID 172 //
     /*  58137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  58157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  58161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58166 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58172 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  58175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  58183 */     GIR_RootConstrainSelectedInstOperands,
     /*  58184 */     // GIR_Coverage, 172,
     /*  58184 */     GIR_EraseRootFromParent_Done,
     /*  58185 */   // Label 1017: @58185
     /*  58185 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(58209), // Rule ID 176 //
     /*  58190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58202 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  58207 */     GIR_RootConstrainSelectedInstOperands,
     /*  58208 */     // GIR_Coverage, 176,
     /*  58208 */     GIR_Done,
     /*  58209 */   // Label 1018: @58209
     /*  58209 */   GIM_Reject,
     /*  58210 */ // Label 1010: @58210
     /*  58210 */ GIM_Reject,
     /*  58211 */ // Label 992: @58211
     /*  58211 */ GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(60377),
     /*  58216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58222 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(58344), // Rule ID 3970 //
     /*  58227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  58255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58268 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  58272 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  58283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  58287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58291 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  58295 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  58299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  58303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  58307 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58311 */     // MIs[4] Rn
     /*  58311 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58316 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  58320 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  58331 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58333 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  58333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  58336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  58342 */     GIR_RootConstrainSelectedInstOperands,
     /*  58343 */     // GIR_Coverage, 3970,
     /*  58343 */     GIR_EraseRootFromParent_Done,
     /*  58344 */   // Label 1020: @58344
     /*  58344 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(58466), // Rule ID 13593 //
     /*  58349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  58377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58390 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  58394 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  58409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  58417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  58421 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  58425 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  58429 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58433 */     // MIs[4] Rn
     /*  58433 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58438 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  58442 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  58453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58455 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  58455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  58458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  58464 */     GIR_RootConstrainSelectedInstOperands,
     /*  58465 */     // GIR_Coverage, 13593,
     /*  58465 */     GIR_EraseRootFromParent_Done,
     /*  58466 */   // Label 1021: @58466
     /*  58466 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(58521), // Rule ID 13044 //
     /*  58471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  58508 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  58508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  58511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58519 */     GIR_RootConstrainSelectedInstOperands,
     /*  58520 */     // GIR_Coverage, 13044,
     /*  58520 */     GIR_EraseRootFromParent_Done,
     /*  58521 */   // Label 1022: @58521
     /*  58521 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(58576), // Rule ID 175 //
     /*  58526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58550 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  58563 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  58563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  58566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58574 */     GIR_RootConstrainSelectedInstOperands,
     /*  58575 */     // GIR_Coverage, 175,
     /*  58575 */     GIR_EraseRootFromParent_Done,
     /*  58576 */   // Label 1023: @58576
     /*  58576 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(58685), // Rule ID 13393 //
     /*  58581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58629 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58635 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58650 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  58654 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58659 */     // MIs[4] LHS
     /*  58659 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58664 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58666 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  58679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  58683 */     GIR_RootConstrainSelectedInstOperands,
     /*  58684 */     // GIR_Coverage, 13393,
     /*  58684 */     GIR_EraseRootFromParent_Done,
     /*  58685 */   // Label 1024: @58685
     /*  58685 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(58794), // Rule ID 13392 //
     /*  58690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58738 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58751 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58755 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58759 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58763 */     // MIs[4] LHS
     /*  58763 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58768 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58773 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58775 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  58788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  58792 */     GIR_RootConstrainSelectedInstOperands,
     /*  58793 */     // GIR_Coverage, 13392,
     /*  58793 */     GIR_EraseRootFromParent_Done,
     /*  58794 */   // Label 1025: @58794
     /*  58794 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(58903), // Rule ID 13395 //
     /*  58799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58852 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58864 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58868 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  58872 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58877 */     // MIs[4] LHS
     /*  58877 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58882 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58884 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  58897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  58901 */     GIR_RootConstrainSelectedInstOperands,
     /*  58902 */     // GIR_Coverage, 13395,
     /*  58902 */     GIR_EraseRootFromParent_Done,
     /*  58903 */   // Label 1026: @58903
     /*  58903 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(59012), // Rule ID 13394 //
     /*  58908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58961 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58973 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58977 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58981 */     // MIs[4] LHS
     /*  58981 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58986 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58993 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  59002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  59006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  59010 */     GIR_RootConstrainSelectedInstOperands,
     /*  59011 */     // GIR_Coverage, 13394,
     /*  59011 */     GIR_EraseRootFromParent_Done,
     /*  59012 */   // Label 1027: @59012
     /*  59012 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(59121), // Rule ID 2462 //
     /*  59017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  59070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59078 */     // MIs[3] LHS
     /*  59078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  59083 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59087 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59093 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59100 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59102 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  59111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  59115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  59119 */     GIR_RootConstrainSelectedInstOperands,
     /*  59120 */     // GIR_Coverage, 2462,
     /*  59120 */     GIR_EraseRootFromParent_Done,
     /*  59121 */   // Label 1028: @59121
     /*  59121 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(59230), // Rule ID 13390 //
     /*  59126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  59179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59187 */     // MIs[3] LHS
     /*  59187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  59192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59196 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59202 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59209 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59211 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  59220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  59224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  59228 */     GIR_RootConstrainSelectedInstOperands,
     /*  59229 */     // GIR_Coverage, 13390,
     /*  59229 */     GIR_EraseRootFromParent_Done,
     /*  59230 */   // Label 1029: @59230
     /*  59230 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(59339), // Rule ID 13389 //
     /*  59235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  59293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59297 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59301 */     // MIs[3] LHS
     /*  59301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  59306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59318 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59320 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  59329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  59333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  59337 */     GIR_RootConstrainSelectedInstOperands,
     /*  59338 */     // GIR_Coverage, 13389,
     /*  59338 */     GIR_EraseRootFromParent_Done,
     /*  59339 */   // Label 1030: @59339
     /*  59339 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(59448), // Rule ID 13391 //
     /*  59344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  59402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59410 */     // MIs[3] LHS
     /*  59410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  59415 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59419 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59427 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59429 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  59438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  59442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  59446 */     GIR_RootConstrainSelectedInstOperands,
     /*  59447 */     // GIR_Coverage, 13391,
     /*  59447 */     GIR_EraseRootFromParent_Done,
     /*  59448 */   // Label 1031: @59448
     /*  59448 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(59489), // Rule ID 147 //
     /*  59453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  59457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59469 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  59473 */     // MIs[1] Operand 1
     /*  59473 */     // No operand predicates
     /*  59473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59475 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  59475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  59478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  59482 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  59487 */     GIR_RootConstrainSelectedInstOperands,
     /*  59488 */     // GIR_Coverage, 147,
     /*  59488 */     GIR_EraseRootFromParent_Done,
     /*  59489 */   // Label 1032: @59489
     /*  59489 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(59522), // Rule ID 13046 //
     /*  59494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  59509 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  59509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  59512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  59520 */     GIR_RootConstrainSelectedInstOperands,
     /*  59521 */     // GIR_Coverage, 13046,
     /*  59521 */     GIR_EraseRootFromParent_Done,
     /*  59522 */   // Label 1033: @59522
     /*  59522 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(59555), // Rule ID 179 //
     /*  59527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  59542 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  59542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  59545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  59549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  59553 */     GIR_RootConstrainSelectedInstOperands,
     /*  59554 */     // GIR_Coverage, 179,
     /*  59554 */     GIR_EraseRootFromParent_Done,
     /*  59555 */   // Label 1034: @59555
     /*  59555 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(59622), // Rule ID 13329 //
     /*  59560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59584 */     // MIs[1] imm
     /*  59584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59596 */     // MIs[2] Operand 1
     /*  59596 */     // No operand predicates
     /*  59596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59606 */     // (or:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59620 */     GIR_RootConstrainSelectedInstOperands,
     /*  59621 */     // GIR_Coverage, 13329,
     /*  59621 */     GIR_EraseRootFromParent_Done,
     /*  59622 */   // Label 1035: @59622
     /*  59622 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(59689), // Rule ID 13717 //
     /*  59627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59651 */     // MIs[1] imm
     /*  59651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59663 */     // MIs[2] Operand 1
     /*  59663 */     // No operand predicates
     /*  59663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59673 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59687 */     GIR_RootConstrainSelectedInstOperands,
     /*  59688 */     // GIR_Coverage, 13717,
     /*  59688 */     GIR_EraseRootFromParent_Done,
     /*  59689 */   // Label 1036: @59689
     /*  59689 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(59756), // Rule ID 13332 //
     /*  59694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  59709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59718 */     // MIs[1] imm
     /*  59718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59726 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59730 */     // MIs[2] Operand 1
     /*  59730 */     // No operand predicates
     /*  59730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59740 */     // (or:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  59743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59754 */     GIR_RootConstrainSelectedInstOperands,
     /*  59755 */     // GIR_Coverage, 13332,
     /*  59755 */     GIR_EraseRootFromParent_Done,
     /*  59756 */   // Label 1037: @59756
     /*  59756 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(59823), // Rule ID 13720 //
     /*  59761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  59776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59785 */     // MIs[1] imm
     /*  59785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59797 */     // MIs[2] Operand 1
     /*  59797 */     // No operand predicates
     /*  59797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59807 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  59810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59821 */     GIR_RootConstrainSelectedInstOperands,
     /*  59822 */     // GIR_Coverage, 13720,
     /*  59822 */     GIR_EraseRootFromParent_Done,
     /*  59823 */   // Label 1038: @59823
     /*  59823 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(59876), // Rule ID 13042 //
     /*  59828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59853 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  59857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59863 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  59863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  59866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  59874 */     GIR_RootConstrainSelectedInstOperands,
     /*  59875 */     // GIR_Coverage, 13042,
     /*  59875 */     GIR_EraseRootFromParent_Done,
     /*  59876 */   // Label 1039: @59876
     /*  59876 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(59943), // Rule ID 2113 //
     /*  59881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59909 */     // MIs[1] imm
     /*  59909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59921 */     // MIs[2] Operand 1
     /*  59921 */     // No operand predicates
     /*  59921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59927 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  59934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59941 */     GIR_RootConstrainSelectedInstOperands,
     /*  59942 */     // GIR_Coverage, 2113,
     /*  59942 */     GIR_EraseRootFromParent_Done,
     /*  59943 */   // Label 1040: @59943
     /*  59943 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(60010), // Rule ID 6209 //
     /*  59948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59976 */     // MIs[1] imm
     /*  59976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59988 */     // MIs[2] Operand 1
     /*  59988 */     // No operand predicates
     /*  59988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59994 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60008 */     GIR_RootConstrainSelectedInstOperands,
     /*  60009 */     // GIR_Coverage, 6209,
     /*  60009 */     GIR_EraseRootFromParent_Done,
     /*  60010 */   // Label 1041: @60010
     /*  60010 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(60077), // Rule ID 2122 //
     /*  60015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  60034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60043 */     // MIs[1] imm
     /*  60043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60051 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  60055 */     // MIs[2] Operand 1
     /*  60055 */     // No operand predicates
     /*  60055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  60059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60061 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  60061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  60064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60075 */     GIR_RootConstrainSelectedInstOperands,
     /*  60076 */     // GIR_Coverage, 2122,
     /*  60076 */     GIR_EraseRootFromParent_Done,
     /*  60077 */   // Label 1042: @60077
     /*  60077 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(60144), // Rule ID 6215 //
     /*  60082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  60101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60110 */     // MIs[1] imm
     /*  60110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60118 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  60122 */     // MIs[2] Operand 1
     /*  60122 */     // No operand predicates
     /*  60122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  60126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60128 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  60128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  60131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60142 */     GIR_RootConstrainSelectedInstOperands,
     /*  60143 */     // GIR_Coverage, 6215,
     /*  60143 */     GIR_EraseRootFromParent_Done,
     /*  60144 */   // Label 1043: @60144
     /*  60144 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(60197), // Rule ID 173 //
     /*  60149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60178 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60184 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  60184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  60187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60195 */     GIR_RootConstrainSelectedInstOperands,
     /*  60196 */     // GIR_Coverage, 173,
     /*  60196 */     GIR_EraseRootFromParent_Done,
     /*  60197 */   // Label 1044: @60197
     /*  60197 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(60261), // Rule ID 13681 //
     /*  60202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60234 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60240 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  60242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60248 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  60251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60253 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  60255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60259 */     GIR_RootConstrainSelectedInstOperands,
     /*  60260 */     // GIR_Coverage, 13681,
     /*  60260 */     GIR_EraseRootFromParent_Done,
     /*  60261 */   // Label 1045: @60261
     /*  60261 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(60325), // Rule ID 5004 //
     /*  60266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60302 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  60310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60312 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  60315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60317 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  60319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60323 */     GIR_RootConstrainSelectedInstOperands,
     /*  60324 */     // GIR_Coverage, 5004,
     /*  60324 */     GIR_EraseRootFromParent_Done,
     /*  60325 */   // Label 1046: @60325
     /*  60325 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(60349), // Rule ID 177 //
     /*  60330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60342 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  60342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  60347 */     GIR_RootConstrainSelectedInstOperands,
     /*  60348 */     // GIR_Coverage, 177,
     /*  60348 */     GIR_Done,
     /*  60349 */   // Label 1047: @60349
     /*  60349 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(60376), // Rule ID 5010 //
     /*  60354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60369 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  60374 */     GIR_RootConstrainSelectedInstOperands,
     /*  60375 */     // GIR_Coverage, 5010,
     /*  60375 */     GIR_Done,
     /*  60376 */   // Label 1048: @60376
     /*  60376 */   GIM_Reject,
     /*  60377 */ // Label 1019: @60377
     /*  60377 */ GIM_Reject,
     /*  60378 */ // Label 993: @60378
     /*  60378 */ GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(61685),
     /*  60383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60389 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(60498), // Rule ID 13386 //
     /*  60394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60442 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60463 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60467 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60472 */     // MIs[4] LHS
     /*  60472 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60477 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60479 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  60492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  60496 */     GIR_RootConstrainSelectedInstOperands,
     /*  60497 */     // GIR_Coverage, 13386,
     /*  60497 */     GIR_EraseRootFromParent_Done,
     /*  60498 */   // Label 1050: @60498
     /*  60498 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(60607), // Rule ID 13385 //
     /*  60503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60564 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60568 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60572 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60576 */     // MIs[4] LHS
     /*  60576 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60581 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60586 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60588 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  60601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  60605 */     GIR_RootConstrainSelectedInstOperands,
     /*  60606 */     // GIR_Coverage, 13385,
     /*  60606 */     GIR_EraseRootFromParent_Done,
     /*  60607 */   // Label 1051: @60607
     /*  60607 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(60716), // Rule ID 13388 //
     /*  60612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60665 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60673 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60677 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60681 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60685 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60690 */     // MIs[4] LHS
     /*  60690 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60695 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60697 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  60710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60714 */     GIR_RootConstrainSelectedInstOperands,
     /*  60715 */     // GIR_Coverage, 13388,
     /*  60715 */     GIR_EraseRootFromParent_Done,
     /*  60716 */   // Label 1052: @60716
     /*  60716 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(60825), // Rule ID 13387 //
     /*  60721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60774 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60786 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60790 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60794 */     // MIs[4] LHS
     /*  60794 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60799 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60804 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60806 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  60819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60823 */     GIR_RootConstrainSelectedInstOperands,
     /*  60824 */     // GIR_Coverage, 13387,
     /*  60824 */     GIR_EraseRootFromParent_Done,
     /*  60825 */   // Label 1053: @60825
     /*  60825 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(60934), // Rule ID 2461 //
     /*  60830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  60867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60887 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60891 */     // MIs[3] LHS
     /*  60891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  60896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  60900 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60906 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  60908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60915 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  60924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  60928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  60932 */     GIR_RootConstrainSelectedInstOperands,
     /*  60933 */     // GIR_Coverage, 2461,
     /*  60933 */     GIR_EraseRootFromParent_Done,
     /*  60934 */   // Label 1054: @60934
     /*  60934 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(61043), // Rule ID 13383 //
     /*  60939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  60976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60996 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61000 */     // MIs[3] LHS
     /*  61000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61005 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61009 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61022 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61024 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61041 */     GIR_RootConstrainSelectedInstOperands,
     /*  61042 */     // GIR_Coverage, 13383,
     /*  61042 */     GIR_EraseRootFromParent_Done,
     /*  61043 */   // Label 1055: @61043
     /*  61043 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(61152), // Rule ID 13382 //
     /*  61048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61114 */     // MIs[3] LHS
     /*  61114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61119 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61123 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61131 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61133 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61150 */     GIR_RootConstrainSelectedInstOperands,
     /*  61151 */     // GIR_Coverage, 13382,
     /*  61151 */     GIR_EraseRootFromParent_Done,
     /*  61152 */   // Label 1056: @61152
     /*  61152 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(61261), // Rule ID 13384 //
     /*  61157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61223 */     // MIs[3] LHS
     /*  61223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61242 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61259 */     GIR_RootConstrainSelectedInstOperands,
     /*  61260 */     // GIR_Coverage, 13384,
     /*  61260 */     GIR_EraseRootFromParent_Done,
     /*  61261 */   // Label 1057: @61261
     /*  61261 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(61328), // Rule ID 13349 //
     /*  61266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  61281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61290 */     // MIs[1] imm
     /*  61290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61298 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61302 */     // MIs[2] Operand 1
     /*  61302 */     // No operand predicates
     /*  61302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61312 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  61315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  61319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61326 */     GIR_RootConstrainSelectedInstOperands,
     /*  61327 */     // GIR_Coverage, 13349,
     /*  61327 */     GIR_EraseRootFromParent_Done,
     /*  61328 */   // Label 1058: @61328
     /*  61328 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(61395), // Rule ID 13370 //
     /*  61333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  61348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61357 */     // MIs[1] imm
     /*  61357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61369 */     // MIs[2] Operand 1
     /*  61369 */     // No operand predicates
     /*  61369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61379 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  61382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  61386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61393 */     GIR_RootConstrainSelectedInstOperands,
     /*  61394 */     // GIR_Coverage, 13370,
     /*  61394 */     GIR_EraseRootFromParent_Done,
     /*  61395 */   // Label 1059: @61395
     /*  61395 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(61462), // Rule ID 2230 //
     /*  61400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  61419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61428 */     // MIs[1] imm
     /*  61428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61436 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61440 */     // MIs[2] Operand 1
     /*  61440 */     // No operand predicates
     /*  61440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61446 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  61449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  61453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61460 */     GIR_RootConstrainSelectedInstOperands,
     /*  61461 */     // GIR_Coverage, 2230,
     /*  61461 */     GIR_EraseRootFromParent_Done,
     /*  61462 */   // Label 1060: @61462
     /*  61462 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(61529), // Rule ID 2289 //
     /*  61467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  61486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61495 */     // MIs[1] imm
     /*  61495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61507 */     // MIs[2] Operand 1
     /*  61507 */     // No operand predicates
     /*  61507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61513 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  61516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  61520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61527 */     GIR_RootConstrainSelectedInstOperands,
     /*  61528 */     // GIR_Coverage, 2289,
     /*  61528 */     GIR_EraseRootFromParent_Done,
     /*  61529 */   // Label 1061: @61529
     /*  61529 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(61593), // Rule ID 13680 //
     /*  61534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61566 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  61574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61580 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  61583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61585 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  61587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61591 */     GIR_RootConstrainSelectedInstOperands,
     /*  61592 */     // GIR_Coverage, 13680,
     /*  61592 */     GIR_EraseRootFromParent_Done,
     /*  61593 */   // Label 1062: @61593
     /*  61593 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(61657), // Rule ID 5003 //
     /*  61598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61634 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61640 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  61642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61644 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  61647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61649 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  61651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61655 */     GIR_RootConstrainSelectedInstOperands,
     /*  61656 */     // GIR_Coverage, 5003,
     /*  61656 */     GIR_EraseRootFromParent_Done,
     /*  61657 */   // Label 1063: @61657
     /*  61657 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(61684), // Rule ID 5009 //
     /*  61662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61677 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  61682 */     GIR_RootConstrainSelectedInstOperands,
     /*  61683 */     // GIR_Coverage, 5009,
     /*  61683 */     GIR_Done,
     /*  61684 */   // Label 1064: @61684
     /*  61684 */   GIM_Reject,
     /*  61685 */ // Label 1049: @61685
     /*  61685 */ GIM_Reject,
     /*  61686 */ // Label 994: @61686
     /*  61686 */ GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(62993),
     /*  61691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61697 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(61806), // Rule ID 13414 //
     /*  61702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61750 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61763 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61767 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61771 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61775 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61780 */     // MIs[4] LHS
     /*  61780 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61785 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61787 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61804 */     GIR_RootConstrainSelectedInstOperands,
     /*  61805 */     // GIR_Coverage, 13414,
     /*  61805 */     GIR_EraseRootFromParent_Done,
     /*  61806 */   // Label 1066: @61806
     /*  61806 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(61915), // Rule ID 13413 //
     /*  61811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61859 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61876 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61880 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61884 */     // MIs[4] LHS
     /*  61884 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61889 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61894 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61896 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61913 */     GIR_RootConstrainSelectedInstOperands,
     /*  61914 */     // GIR_Coverage, 13413,
     /*  61914 */     GIR_EraseRootFromParent_Done,
     /*  61915 */   // Label 1067: @61915
     /*  61915 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(62024), // Rule ID 13416 //
     /*  61920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61973 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61979 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61981 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61985 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61989 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61993 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61998 */     // MIs[4] LHS
     /*  61998 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62003 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62005 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62022 */     GIR_RootConstrainSelectedInstOperands,
     /*  62023 */     // GIR_Coverage, 13416,
     /*  62023 */     GIR_EraseRootFromParent_Done,
     /*  62024 */   // Label 1068: @62024
     /*  62024 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(62133), // Rule ID 13415 //
     /*  62029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62082 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62094 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62098 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62102 */     // MIs[4] LHS
     /*  62102 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62107 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62112 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62114 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62131 */     GIR_RootConstrainSelectedInstOperands,
     /*  62132 */     // GIR_Coverage, 13415,
     /*  62132 */     GIR_EraseRootFromParent_Done,
     /*  62133 */   // Label 1069: @62133
     /*  62133 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(62242), // Rule ID 2465 //
     /*  62138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62195 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62199 */     // MIs[3] LHS
     /*  62199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62204 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62208 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62214 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62221 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62223 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62240 */     GIR_RootConstrainSelectedInstOperands,
     /*  62241 */     // GIR_Coverage, 2465,
     /*  62241 */     GIR_EraseRootFromParent_Done,
     /*  62242 */   // Label 1070: @62242
     /*  62242 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(62351), // Rule ID 13411 //
     /*  62247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62308 */     // MIs[3] LHS
     /*  62308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62313 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62317 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62330 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62332 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62349 */     GIR_RootConstrainSelectedInstOperands,
     /*  62350 */     // GIR_Coverage, 13411,
     /*  62350 */     GIR_EraseRootFromParent_Done,
     /*  62351 */   // Label 1071: @62351
     /*  62351 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(62460), // Rule ID 13410 //
     /*  62356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62422 */     // MIs[3] LHS
     /*  62422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62431 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62437 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62439 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62441 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62458 */     GIR_RootConstrainSelectedInstOperands,
     /*  62459 */     // GIR_Coverage, 13410,
     /*  62459 */     GIR_EraseRootFromParent_Done,
     /*  62460 */   // Label 1072: @62460
     /*  62460 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(62569), // Rule ID 13412 //
     /*  62465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62531 */     // MIs[3] LHS
     /*  62531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62540 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62546 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62548 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62550 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62567 */     GIR_RootConstrainSelectedInstOperands,
     /*  62568 */     // GIR_Coverage, 13412,
     /*  62568 */     GIR_EraseRootFromParent_Done,
     /*  62569 */   // Label 1073: @62569
     /*  62569 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(62636), // Rule ID 13353 //
     /*  62574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62598 */     // MIs[1] imm
     /*  62598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62606 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62610 */     // MIs[2] Operand 1
     /*  62610 */     // No operand predicates
     /*  62610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62620 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  62623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62634 */     GIR_RootConstrainSelectedInstOperands,
     /*  62635 */     // GIR_Coverage, 13353,
     /*  62635 */     GIR_EraseRootFromParent_Done,
     /*  62636 */   // Label 1074: @62636
     /*  62636 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(62703), // Rule ID 13374 //
     /*  62641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62665 */     // MIs[1] imm
     /*  62665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62677 */     // MIs[2] Operand 1
     /*  62677 */     // No operand predicates
     /*  62677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62687 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  62690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62701 */     GIR_RootConstrainSelectedInstOperands,
     /*  62702 */     // GIR_Coverage, 13374,
     /*  62702 */     GIR_EraseRootFromParent_Done,
     /*  62703 */   // Label 1075: @62703
     /*  62703 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(62770), // Rule ID 2234 //
     /*  62708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62736 */     // MIs[1] imm
     /*  62736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62748 */     // MIs[2] Operand 1
     /*  62748 */     // No operand predicates
     /*  62748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62754 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  62757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62768 */     GIR_RootConstrainSelectedInstOperands,
     /*  62769 */     // GIR_Coverage, 2234,
     /*  62769 */     GIR_EraseRootFromParent_Done,
     /*  62770 */   // Label 1076: @62770
     /*  62770 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(62837), // Rule ID 2293 //
     /*  62775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62803 */     // MIs[1] imm
     /*  62803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62815 */     // MIs[2] Operand 1
     /*  62815 */     // No operand predicates
     /*  62815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62821 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  62824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62835 */     GIR_RootConstrainSelectedInstOperands,
     /*  62836 */     // GIR_Coverage, 2293,
     /*  62836 */     GIR_EraseRootFromParent_Done,
     /*  62837 */   // Label 1077: @62837
     /*  62837 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(62901), // Rule ID 13684 //
     /*  62842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62874 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62888 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  62891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62893 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  62895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62899 */     GIR_RootConstrainSelectedInstOperands,
     /*  62900 */     // GIR_Coverage, 13684,
     /*  62900 */     GIR_EraseRootFromParent_Done,
     /*  62901 */   // Label 1078: @62901
     /*  62901 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(62965), // Rule ID 5007 //
     /*  62906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62952 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  62955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  62959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62963 */     GIR_RootConstrainSelectedInstOperands,
     /*  62964 */     // GIR_Coverage, 5007,
     /*  62964 */     GIR_EraseRootFromParent_Done,
     /*  62965 */   // Label 1079: @62965
     /*  62965 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(62992), // Rule ID 5013 //
     /*  62970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62985 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  62990 */     GIR_RootConstrainSelectedInstOperands,
     /*  62991 */     // GIR_Coverage, 5013,
     /*  62991 */     GIR_Done,
     /*  62992 */   // Label 1080: @62992
     /*  62992 */   GIM_Reject,
     /*  62993 */ // Label 1065: @62993
     /*  62993 */ GIM_Reject,
     /*  62994 */ // Label 995: @62994
     /*  62994 */ GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64301),
     /*  62999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63005 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(63114), // Rule ID 13379 //
     /*  63010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63058 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63064 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63075 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63079 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63083 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63088 */     // MIs[4] LHS
     /*  63088 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63093 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63095 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63112 */     GIR_RootConstrainSelectedInstOperands,
     /*  63113 */     // GIR_Coverage, 13379,
     /*  63113 */     GIR_EraseRootFromParent_Done,
     /*  63114 */   // Label 1082: @63114
     /*  63114 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(63223), // Rule ID 13378 //
     /*  63119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63167 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63184 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63188 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63192 */     // MIs[4] LHS
     /*  63192 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63197 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63202 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63204 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63221 */     GIR_RootConstrainSelectedInstOperands,
     /*  63222 */     // GIR_Coverage, 13378,
     /*  63222 */     GIR_EraseRootFromParent_Done,
     /*  63223 */   // Label 1083: @63223
     /*  63223 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(63332), // Rule ID 13381 //
     /*  63228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63281 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63289 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63293 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63297 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63301 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63306 */     // MIs[4] LHS
     /*  63306 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63311 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63313 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63330 */     GIR_RootConstrainSelectedInstOperands,
     /*  63331 */     // GIR_Coverage, 13381,
     /*  63331 */     GIR_EraseRootFromParent_Done,
     /*  63332 */   // Label 1084: @63332
     /*  63332 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(63441), // Rule ID 13380 //
     /*  63337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63390 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63398 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63402 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63406 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63410 */     // MIs[4] LHS
     /*  63410 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63415 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63420 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63422 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63439 */     GIR_RootConstrainSelectedInstOperands,
     /*  63440 */     // GIR_Coverage, 13380,
     /*  63440 */     GIR_EraseRootFromParent_Done,
     /*  63441 */   // Label 1085: @63441
     /*  63441 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(63550), // Rule ID 2460 //
     /*  63446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63503 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63507 */     // MIs[3] LHS
     /*  63507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63529 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63531 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63548 */     GIR_RootConstrainSelectedInstOperands,
     /*  63549 */     // GIR_Coverage, 2460,
     /*  63549 */     GIR_EraseRootFromParent_Done,
     /*  63550 */   // Label 1086: @63550
     /*  63550 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(63659), // Rule ID 13376 //
     /*  63555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63616 */     // MIs[3] LHS
     /*  63616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63621 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63625 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63638 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63640 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63657 */     GIR_RootConstrainSelectedInstOperands,
     /*  63658 */     // GIR_Coverage, 13376,
     /*  63658 */     GIR_EraseRootFromParent_Done,
     /*  63659 */   // Label 1087: @63659
     /*  63659 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(63768), // Rule ID 13375 //
     /*  63664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63730 */     // MIs[3] LHS
     /*  63730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63735 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63739 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63749 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63766 */     GIR_RootConstrainSelectedInstOperands,
     /*  63767 */     // GIR_Coverage, 13375,
     /*  63767 */     GIR_EraseRootFromParent_Done,
     /*  63768 */   // Label 1088: @63768
     /*  63768 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(63877), // Rule ID 13377 //
     /*  63773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63839 */     // MIs[3] LHS
     /*  63839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63844 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63848 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63854 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63856 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63858 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63875 */     GIR_RootConstrainSelectedInstOperands,
     /*  63876 */     // GIR_Coverage, 13377,
     /*  63876 */     GIR_EraseRootFromParent_Done,
     /*  63877 */   // Label 1089: @63877
     /*  63877 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(63944), // Rule ID 13345 //
     /*  63882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63906 */     // MIs[1] imm
     /*  63906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  63918 */     // MIs[2] Operand 1
     /*  63918 */     // No operand predicates
     /*  63918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63928 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  63931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63942 */     GIR_RootConstrainSelectedInstOperands,
     /*  63943 */     // GIR_Coverage, 13345,
     /*  63943 */     GIR_EraseRootFromParent_Done,
     /*  63944 */   // Label 1090: @63944
     /*  63944 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64011), // Rule ID 13366 //
     /*  63949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63973 */     // MIs[1] imm
     /*  63973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63981 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  63985 */     // MIs[2] Operand 1
     /*  63985 */     // No operand predicates
     /*  63985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63995 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  63998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64009 */     GIR_RootConstrainSelectedInstOperands,
     /*  64010 */     // GIR_Coverage, 13366,
     /*  64010 */     GIR_EraseRootFromParent_Done,
     /*  64011 */   // Label 1091: @64011
     /*  64011 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(64078), // Rule ID 2226 //
     /*  64016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64044 */     // MIs[1] imm
     /*  64044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64052 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  64056 */     // MIs[2] Operand 1
     /*  64056 */     // No operand predicates
     /*  64056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64062 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  64065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64076 */     GIR_RootConstrainSelectedInstOperands,
     /*  64077 */     // GIR_Coverage, 2226,
     /*  64077 */     GIR_EraseRootFromParent_Done,
     /*  64078 */   // Label 1092: @64078
     /*  64078 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(64145), // Rule ID 2285 //
     /*  64083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64111 */     // MIs[1] imm
     /*  64111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  64123 */     // MIs[2] Operand 1
     /*  64123 */     // No operand predicates
     /*  64123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64129 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  64132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64143 */     GIR_RootConstrainSelectedInstOperands,
     /*  64144 */     // GIR_Coverage, 2285,
     /*  64144 */     GIR_EraseRootFromParent_Done,
     /*  64145 */   // Label 1093: @64145
     /*  64145 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(64209), // Rule ID 13679 //
     /*  64150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  64173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64182 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64196 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64201 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64207 */     GIR_RootConstrainSelectedInstOperands,
     /*  64208 */     // GIR_Coverage, 13679,
     /*  64208 */     GIR_EraseRootFromParent_Done,
     /*  64209 */   // Label 1094: @64209
     /*  64209 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(64273), // Rule ID 5002 //
     /*  64214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  64241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64250 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64256 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64260 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64265 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64271 */     GIR_RootConstrainSelectedInstOperands,
     /*  64272 */     // GIR_Coverage, 5002,
     /*  64272 */     GIR_EraseRootFromParent_Done,
     /*  64273 */   // Label 1095: @64273
     /*  64273 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(64300), // Rule ID 5008 //
     /*  64278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64293 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64298 */     GIR_RootConstrainSelectedInstOperands,
     /*  64299 */     // GIR_Coverage, 5008,
     /*  64299 */     GIR_Done,
     /*  64300 */   // Label 1096: @64300
     /*  64300 */   GIM_Reject,
     /*  64301 */ // Label 1081: @64301
     /*  64301 */ GIM_Reject,
     /*  64302 */ // Label 996: @64302
     /*  64302 */ GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65609),
     /*  64307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64313 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(64422), // Rule ID 13407 //
     /*  64318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64366 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64372 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64379 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64383 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64387 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64391 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64396 */     // MIs[4] LHS
     /*  64396 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64401 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64403 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64420 */     GIR_RootConstrainSelectedInstOperands,
     /*  64421 */     // GIR_Coverage, 13407,
     /*  64421 */     GIR_EraseRootFromParent_Done,
     /*  64422 */   // Label 1098: @64422
     /*  64422 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(64531), // Rule ID 13406 //
     /*  64427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64492 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64496 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64500 */     // MIs[4] LHS
     /*  64500 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64505 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64512 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64529 */     GIR_RootConstrainSelectedInstOperands,
     /*  64530 */     // GIR_Coverage, 13406,
     /*  64530 */     GIR_EraseRootFromParent_Done,
     /*  64531 */   // Label 1099: @64531
     /*  64531 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(64640), // Rule ID 13409 //
     /*  64536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64605 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64609 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64614 */     // MIs[4] LHS
     /*  64614 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64619 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64621 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64638 */     GIR_RootConstrainSelectedInstOperands,
     /*  64639 */     // GIR_Coverage, 13409,
     /*  64639 */     GIR_EraseRootFromParent_Done,
     /*  64640 */   // Label 1100: @64640
     /*  64640 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(64749), // Rule ID 13408 //
     /*  64645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64698 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64706 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64710 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64714 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64718 */     // MIs[4] LHS
     /*  64718 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64723 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64728 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64730 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64747 */     GIR_RootConstrainSelectedInstOperands,
     /*  64748 */     // GIR_Coverage, 13408,
     /*  64748 */     GIR_EraseRootFromParent_Done,
     /*  64749 */   // Label 1101: @64749
     /*  64749 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(64858), // Rule ID 2464 //
     /*  64754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64811 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64815 */     // MIs[3] LHS
     /*  64815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64824 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64830 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64837 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64839 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64856 */     GIR_RootConstrainSelectedInstOperands,
     /*  64857 */     // GIR_Coverage, 2464,
     /*  64857 */     GIR_EraseRootFromParent_Done,
     /*  64858 */   // Label 1102: @64858
     /*  64858 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(64967), // Rule ID 13404 //
     /*  64863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64924 */     // MIs[3] LHS
     /*  64924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64929 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64933 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64946 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64948 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64965 */     GIR_RootConstrainSelectedInstOperands,
     /*  64966 */     // GIR_Coverage, 13404,
     /*  64966 */     GIR_EraseRootFromParent_Done,
     /*  64967 */   // Label 1103: @64967
     /*  64967 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(65076), // Rule ID 13403 //
     /*  64972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65038 */     // MIs[3] LHS
     /*  65038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65047 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65057 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  65057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65074 */     GIR_RootConstrainSelectedInstOperands,
     /*  65075 */     // GIR_Coverage, 13403,
     /*  65075 */     GIR_EraseRootFromParent_Done,
     /*  65076 */   // Label 1104: @65076
     /*  65076 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(65185), // Rule ID 13405 //
     /*  65081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65143 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65147 */     // MIs[3] LHS
     /*  65147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65156 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65162 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65164 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65166 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  65166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65183 */     GIR_RootConstrainSelectedInstOperands,
     /*  65184 */     // GIR_Coverage, 13405,
     /*  65184 */     GIR_EraseRootFromParent_Done,
     /*  65185 */   // Label 1105: @65185
     /*  65185 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(65252), // Rule ID 13351 //
     /*  65190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65214 */     // MIs[1] imm
     /*  65214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65226 */     // MIs[2] Operand 1
     /*  65226 */     // No operand predicates
     /*  65226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65236 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  65239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65250 */     GIR_RootConstrainSelectedInstOperands,
     /*  65251 */     // GIR_Coverage, 13351,
     /*  65251 */     GIR_EraseRootFromParent_Done,
     /*  65252 */   // Label 1106: @65252
     /*  65252 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(65319), // Rule ID 13372 //
     /*  65257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65281 */     // MIs[1] imm
     /*  65281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65293 */     // MIs[2] Operand 1
     /*  65293 */     // No operand predicates
     /*  65293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65303 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  65306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65317 */     GIR_RootConstrainSelectedInstOperands,
     /*  65318 */     // GIR_Coverage, 13372,
     /*  65318 */     GIR_EraseRootFromParent_Done,
     /*  65319 */   // Label 1107: @65319
     /*  65319 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(65386), // Rule ID 2232 //
     /*  65324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65352 */     // MIs[1] imm
     /*  65352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65364 */     // MIs[2] Operand 1
     /*  65364 */     // No operand predicates
     /*  65364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65370 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  65373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65384 */     GIR_RootConstrainSelectedInstOperands,
     /*  65385 */     // GIR_Coverage, 2232,
     /*  65385 */     GIR_EraseRootFromParent_Done,
     /*  65386 */   // Label 1108: @65386
     /*  65386 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(65453), // Rule ID 2291 //
     /*  65391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65419 */     // MIs[1] imm
     /*  65419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65427 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65431 */     // MIs[2] Operand 1
     /*  65431 */     // No operand predicates
     /*  65431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65437 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  65440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65451 */     GIR_RootConstrainSelectedInstOperands,
     /*  65452 */     // GIR_Coverage, 2291,
     /*  65452 */     GIR_EraseRootFromParent_Done,
     /*  65453 */   // Label 1109: @65453
     /*  65453 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(65517), // Rule ID 13683 //
     /*  65458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65490 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65496 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65504 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65509 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65515 */     GIR_RootConstrainSelectedInstOperands,
     /*  65516 */     // GIR_Coverage, 13683,
     /*  65516 */     GIR_EraseRootFromParent_Done,
     /*  65517 */   // Label 1110: @65517
     /*  65517 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(65581), // Rule ID 5006 //
     /*  65522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65568 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65573 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65579 */     GIR_RootConstrainSelectedInstOperands,
     /*  65580 */     // GIR_Coverage, 5006,
     /*  65580 */     GIR_EraseRootFromParent_Done,
     /*  65581 */   // Label 1111: @65581
     /*  65581 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(65608), // Rule ID 5012 //
     /*  65586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65601 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65606 */     GIR_RootConstrainSelectedInstOperands,
     /*  65607 */     // GIR_Coverage, 5012,
     /*  65607 */     GIR_Done,
     /*  65608 */   // Label 1112: @65608
     /*  65608 */   GIM_Reject,
     /*  65609 */ // Label 1097: @65609
     /*  65609 */ GIM_Reject,
     /*  65610 */ // Label 997: @65610
     /*  65610 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(66917),
     /*  65615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65621 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(65730), // Rule ID 13167 //
     /*  65626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65674 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65680 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65699 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65704 */     // MIs[4] Rd
     /*  65704 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65709 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65711 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  65724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  65728 */     GIR_RootConstrainSelectedInstOperands,
     /*  65729 */     // GIR_Coverage, 13167,
     /*  65729 */     GIR_EraseRootFromParent_Done,
     /*  65730 */   // Label 1114: @65730
     /*  65730 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(65839), // Rule ID 13166 //
     /*  65735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65800 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65804 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65808 */     // MIs[4] Rd
     /*  65808 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65813 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65818 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65820 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  65833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  65837 */     GIR_RootConstrainSelectedInstOperands,
     /*  65838 */     // GIR_Coverage, 13166,
     /*  65838 */     GIR_EraseRootFromParent_Done,
     /*  65839 */   // Label 1115: @65839
     /*  65839 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(65948), // Rule ID 13169 //
     /*  65844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65897 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65903 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65913 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65917 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65922 */     // MIs[4] Rd
     /*  65922 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65927 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65929 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  65942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  65946 */     GIR_RootConstrainSelectedInstOperands,
     /*  65947 */     // GIR_Coverage, 13169,
     /*  65947 */     GIR_EraseRootFromParent_Done,
     /*  65948 */   // Label 1116: @65948
     /*  65948 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(66057), // Rule ID 13168 //
     /*  65953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66006 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66022 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66026 */     // MIs[4] Rd
     /*  66026 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66031 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66038 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  66047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  66051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66055 */     GIR_RootConstrainSelectedInstOperands,
     /*  66056 */     // GIR_Coverage, 13168,
     /*  66056 */     GIR_EraseRootFromParent_Done,
     /*  66057 */   // Label 1117: @66057
     /*  66057 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(66166), // Rule ID 1598 //
     /*  66062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66123 */     // MIs[3] Rd
     /*  66123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66132 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66138 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66145 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66147 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  66156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  66160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  66164 */     GIR_RootConstrainSelectedInstOperands,
     /*  66165 */     // GIR_Coverage, 1598,
     /*  66165 */     GIR_EraseRootFromParent_Done,
     /*  66166 */   // Label 1118: @66166
     /*  66166 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(66275), // Rule ID 13164 //
     /*  66171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66228 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66232 */     // MIs[3] Rd
     /*  66232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66237 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66241 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66254 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66256 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  66265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  66273 */     GIR_RootConstrainSelectedInstOperands,
     /*  66274 */     // GIR_Coverage, 13164,
     /*  66274 */     GIR_EraseRootFromParent_Done,
     /*  66275 */   // Label 1119: @66275
     /*  66275 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(66384), // Rule ID 13163 //
     /*  66280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66346 */     // MIs[3] Rd
     /*  66346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66351 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66355 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66361 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66365 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  66374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  66378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  66382 */     GIR_RootConstrainSelectedInstOperands,
     /*  66383 */     // GIR_Coverage, 13163,
     /*  66383 */     GIR_EraseRootFromParent_Done,
     /*  66384 */   // Label 1120: @66384
     /*  66384 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(66493), // Rule ID 13165 //
     /*  66389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66451 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66455 */     // MIs[3] Rd
     /*  66455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66460 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66464 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66470 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66472 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66474 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  66483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  66491 */     GIR_RootConstrainSelectedInstOperands,
     /*  66492 */     // GIR_Coverage, 13165,
     /*  66492 */     GIR_EraseRootFromParent_Done,
     /*  66493 */   // Label 1121: @66493
     /*  66493 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(66560), // Rule ID 13341 //
     /*  66498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66522 */     // MIs[1] imm
     /*  66522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66534 */     // MIs[2] Operand 1
     /*  66534 */     // No operand predicates
     /*  66534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66544 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  66547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66558 */     GIR_RootConstrainSelectedInstOperands,
     /*  66559 */     // GIR_Coverage, 13341,
     /*  66559 */     GIR_EraseRootFromParent_Done,
     /*  66560 */   // Label 1122: @66560
     /*  66560 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(66627), // Rule ID 13362 //
     /*  66565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66589 */     // MIs[1] imm
     /*  66589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66601 */     // MIs[2] Operand 1
     /*  66601 */     // No operand predicates
     /*  66601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66611 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  66614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66625 */     GIR_RootConstrainSelectedInstOperands,
     /*  66626 */     // GIR_Coverage, 13362,
     /*  66626 */     GIR_EraseRootFromParent_Done,
     /*  66627 */   // Label 1123: @66627
     /*  66627 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(66694), // Rule ID 2222 //
     /*  66632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66660 */     // MIs[1] imm
     /*  66660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66672 */     // MIs[2] Operand 1
     /*  66672 */     // No operand predicates
     /*  66672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66678 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  66681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66692 */     GIR_RootConstrainSelectedInstOperands,
     /*  66693 */     // GIR_Coverage, 2222,
     /*  66693 */     GIR_EraseRootFromParent_Done,
     /*  66694 */   // Label 1124: @66694
     /*  66694 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(66761), // Rule ID 2281 //
     /*  66699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66727 */     // MIs[1] imm
     /*  66727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66739 */     // MIs[2] Operand 1
     /*  66739 */     // No operand predicates
     /*  66739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66745 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  66748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66759 */     GIR_RootConstrainSelectedInstOperands,
     /*  66760 */     // GIR_Coverage, 2281,
     /*  66760 */     GIR_EraseRootFromParent_Done,
     /*  66761 */   // Label 1125: @66761
     /*  66761 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(66825), // Rule ID 13161 //
     /*  66766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66798 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66804 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66812 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  66819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66823 */     GIR_RootConstrainSelectedInstOperands,
     /*  66824 */     // GIR_Coverage, 13161,
     /*  66824 */     GIR_EraseRootFromParent_Done,
     /*  66825 */   // Label 1126: @66825
     /*  66825 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(66889), // Rule ID 1594 //
     /*  66830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66876 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  66883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66887 */     GIR_RootConstrainSelectedInstOperands,
     /*  66888 */     // GIR_Coverage, 1594,
     /*  66888 */     GIR_EraseRootFromParent_Done,
     /*  66889 */   // Label 1127: @66889
     /*  66889 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(66916), // Rule ID 1596 //
     /*  66894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66909 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66914 */     GIR_RootConstrainSelectedInstOperands,
     /*  66915 */     // GIR_Coverage, 1596,
     /*  66915 */     GIR_Done,
     /*  66916 */   // Label 1128: @66916
     /*  66916 */   GIM_Reject,
     /*  66917 */ // Label 1113: @66917
     /*  66917 */ GIM_Reject,
     /*  66918 */ // Label 998: @66918
     /*  66918 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68225),
     /*  66923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66929 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(67038), // Rule ID 13400 //
     /*  66934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66982 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66995 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66999 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67003 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67007 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67012 */     // MIs[4] LHS
     /*  67012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67017 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67019 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67036 */     GIR_RootConstrainSelectedInstOperands,
     /*  67037 */     // GIR_Coverage, 13400,
     /*  67037 */     GIR_EraseRootFromParent_Done,
     /*  67038 */   // Label 1130: @67038
     /*  67038 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(67147), // Rule ID 13399 //
     /*  67043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67091 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67112 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67116 */     // MIs[4] LHS
     /*  67116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67121 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67128 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67145 */     GIR_RootConstrainSelectedInstOperands,
     /*  67146 */     // GIR_Coverage, 13399,
     /*  67146 */     GIR_EraseRootFromParent_Done,
     /*  67147 */   // Label 1131: @67147
     /*  67147 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(67256), // Rule ID 13402 //
     /*  67152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67205 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67221 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67225 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67230 */     // MIs[4] LHS
     /*  67230 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67235 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67237 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67254 */     GIR_RootConstrainSelectedInstOperands,
     /*  67255 */     // GIR_Coverage, 13402,
     /*  67255 */     GIR_EraseRootFromParent_Done,
     /*  67256 */   // Label 1132: @67256
     /*  67256 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(67365), // Rule ID 13401 //
     /*  67261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67314 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67320 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67330 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67334 */     // MIs[4] LHS
     /*  67334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67339 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67344 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67346 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67363 */     GIR_RootConstrainSelectedInstOperands,
     /*  67364 */     // GIR_Coverage, 13401,
     /*  67364 */     GIR_EraseRootFromParent_Done,
     /*  67365 */   // Label 1133: @67365
     /*  67365 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(67474), // Rule ID 2463 //
     /*  67370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67427 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67431 */     // MIs[3] LHS
     /*  67431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67440 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67455 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67472 */     GIR_RootConstrainSelectedInstOperands,
     /*  67473 */     // GIR_Coverage, 2463,
     /*  67473 */     GIR_EraseRootFromParent_Done,
     /*  67474 */   // Label 1134: @67474
     /*  67474 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(67583), // Rule ID 13397 //
     /*  67479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67540 */     // MIs[3] LHS
     /*  67540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67549 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67562 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67564 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67581 */     GIR_RootConstrainSelectedInstOperands,
     /*  67582 */     // GIR_Coverage, 13397,
     /*  67582 */     GIR_EraseRootFromParent_Done,
     /*  67583 */   // Label 1135: @67583
     /*  67583 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(67692), // Rule ID 13396 //
     /*  67588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67650 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67654 */     // MIs[3] LHS
     /*  67654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67663 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67671 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67673 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67690 */     GIR_RootConstrainSelectedInstOperands,
     /*  67691 */     // GIR_Coverage, 13396,
     /*  67691 */     GIR_EraseRootFromParent_Done,
     /*  67692 */   // Label 1136: @67692
     /*  67692 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(67801), // Rule ID 13398 //
     /*  67697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67759 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67763 */     // MIs[3] LHS
     /*  67763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67782 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67799 */     GIR_RootConstrainSelectedInstOperands,
     /*  67800 */     // GIR_Coverage, 13398,
     /*  67800 */     GIR_EraseRootFromParent_Done,
     /*  67801 */   // Label 1137: @67801
     /*  67801 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(67868), // Rule ID 13347 //
     /*  67806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67830 */     // MIs[1] imm
     /*  67830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67842 */     // MIs[2] Operand 1
     /*  67842 */     // No operand predicates
     /*  67842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67852 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  67855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67866 */     GIR_RootConstrainSelectedInstOperands,
     /*  67867 */     // GIR_Coverage, 13347,
     /*  67867 */     GIR_EraseRootFromParent_Done,
     /*  67868 */   // Label 1138: @67868
     /*  67868 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(67935), // Rule ID 13368 //
     /*  67873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67897 */     // MIs[1] imm
     /*  67897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67905 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67909 */     // MIs[2] Operand 1
     /*  67909 */     // No operand predicates
     /*  67909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67919 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  67922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67933 */     GIR_RootConstrainSelectedInstOperands,
     /*  67934 */     // GIR_Coverage, 13368,
     /*  67934 */     GIR_EraseRootFromParent_Done,
     /*  67935 */   // Label 1139: @67935
     /*  67935 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(68002), // Rule ID 2228 //
     /*  67940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67968 */     // MIs[1] imm
     /*  67968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67980 */     // MIs[2] Operand 1
     /*  67980 */     // No operand predicates
     /*  67980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67986 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  67989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68000 */     GIR_RootConstrainSelectedInstOperands,
     /*  68001 */     // GIR_Coverage, 2228,
     /*  68001 */     GIR_EraseRootFromParent_Done,
     /*  68002 */   // Label 1140: @68002
     /*  68002 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(68069), // Rule ID 2287 //
     /*  68007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68035 */     // MIs[1] imm
     /*  68035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68047 */     // MIs[2] Operand 1
     /*  68047 */     // No operand predicates
     /*  68047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68053 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  68056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68067 */     GIR_RootConstrainSelectedInstOperands,
     /*  68068 */     // GIR_Coverage, 2287,
     /*  68068 */     GIR_EraseRootFromParent_Done,
     /*  68069 */   // Label 1141: @68069
     /*  68069 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(68133), // Rule ID 13682 //
     /*  68074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68106 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68112 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68120 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68125 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68131 */     GIR_RootConstrainSelectedInstOperands,
     /*  68132 */     // GIR_Coverage, 13682,
     /*  68132 */     GIR_EraseRootFromParent_Done,
     /*  68133 */   // Label 1142: @68133
     /*  68133 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(68197), // Rule ID 5005 //
     /*  68138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68174 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68180 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68184 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68189 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68195 */     GIR_RootConstrainSelectedInstOperands,
     /*  68196 */     // GIR_Coverage, 5005,
     /*  68196 */     GIR_EraseRootFromParent_Done,
     /*  68197 */   // Label 1143: @68197
     /*  68197 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(68224), // Rule ID 5011 //
     /*  68202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68217 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68222 */     GIR_RootConstrainSelectedInstOperands,
     /*  68223 */     // GIR_Coverage, 5011,
     /*  68223 */     GIR_Done,
     /*  68224 */   // Label 1144: @68224
     /*  68224 */   GIM_Reject,
     /*  68225 */ // Label 1129: @68225
     /*  68225 */ GIM_Reject,
     /*  68226 */ // Label 999: @68226
     /*  68226 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69533),
     /*  68231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68237 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(68346), // Rule ID 13174 //
     /*  68242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68290 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68303 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68307 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68311 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68315 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68320 */     // MIs[4] Rd
     /*  68320 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68325 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68327 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68344 */     GIR_RootConstrainSelectedInstOperands,
     /*  68345 */     // GIR_Coverage, 13174,
     /*  68345 */     GIR_EraseRootFromParent_Done,
     /*  68346 */   // Label 1146: @68346
     /*  68346 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(68455), // Rule ID 13173 //
     /*  68351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68399 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68420 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68424 */     // MIs[4] Rd
     /*  68424 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68429 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68436 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68453 */     GIR_RootConstrainSelectedInstOperands,
     /*  68454 */     // GIR_Coverage, 13173,
     /*  68454 */     GIR_EraseRootFromParent_Done,
     /*  68455 */   // Label 1147: @68455
     /*  68455 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(68564), // Rule ID 13176 //
     /*  68460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68521 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68525 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68529 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68533 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68538 */     // MIs[4] Rd
     /*  68538 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68543 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68545 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68562 */     GIR_RootConstrainSelectedInstOperands,
     /*  68563 */     // GIR_Coverage, 13176,
     /*  68563 */     GIR_EraseRootFromParent_Done,
     /*  68564 */   // Label 1148: @68564
     /*  68564 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(68673), // Rule ID 13175 //
     /*  68569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68622 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68630 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68634 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68638 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68642 */     // MIs[4] Rd
     /*  68642 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68647 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68652 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68654 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68671 */     GIR_RootConstrainSelectedInstOperands,
     /*  68672 */     // GIR_Coverage, 13175,
     /*  68672 */     GIR_EraseRootFromParent_Done,
     /*  68673 */   // Label 1149: @68673
     /*  68673 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(68782), // Rule ID 1599 //
     /*  68678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68739 */     // MIs[3] Rd
     /*  68739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68748 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68763 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68780 */     GIR_RootConstrainSelectedInstOperands,
     /*  68781 */     // GIR_Coverage, 1599,
     /*  68781 */     GIR_EraseRootFromParent_Done,
     /*  68782 */   // Label 1150: @68782
     /*  68782 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(68891), // Rule ID 13171 //
     /*  68787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68848 */     // MIs[3] Rd
     /*  68848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68857 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68863 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68872 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68889 */     GIR_RootConstrainSelectedInstOperands,
     /*  68890 */     // GIR_Coverage, 13171,
     /*  68890 */     GIR_EraseRootFromParent_Done,
     /*  68891 */   // Label 1151: @68891
     /*  68891 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(69000), // Rule ID 13170 //
     /*  68896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68962 */     // MIs[3] Rd
     /*  68962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68967 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68971 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68979 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68981 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68998 */     GIR_RootConstrainSelectedInstOperands,
     /*  68999 */     // GIR_Coverage, 13170,
     /*  68999 */     GIR_EraseRootFromParent_Done,
     /*  69000 */   // Label 1152: @69000
     /*  69000 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(69109), // Rule ID 13172 //
     /*  69005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69067 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69071 */     // MIs[3] Rd
     /*  69071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69076 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69080 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69086 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69088 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69090 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69107 */     GIR_RootConstrainSelectedInstOperands,
     /*  69108 */     // GIR_Coverage, 13172,
     /*  69108 */     GIR_EraseRootFromParent_Done,
     /*  69109 */   // Label 1153: @69109
     /*  69109 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(69176), // Rule ID 13343 //
     /*  69114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69138 */     // MIs[1] imm
     /*  69138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69150 */     // MIs[2] Operand 1
     /*  69150 */     // No operand predicates
     /*  69150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69160 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  69163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69174 */     GIR_RootConstrainSelectedInstOperands,
     /*  69175 */     // GIR_Coverage, 13343,
     /*  69175 */     GIR_EraseRootFromParent_Done,
     /*  69176 */   // Label 1154: @69176
     /*  69176 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(69243), // Rule ID 13364 //
     /*  69181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69205 */     // MIs[1] imm
     /*  69205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69217 */     // MIs[2] Operand 1
     /*  69217 */     // No operand predicates
     /*  69217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69227 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  69230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69241 */     GIR_RootConstrainSelectedInstOperands,
     /*  69242 */     // GIR_Coverage, 13364,
     /*  69242 */     GIR_EraseRootFromParent_Done,
     /*  69243 */   // Label 1155: @69243
     /*  69243 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(69310), // Rule ID 2224 //
     /*  69248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69276 */     // MIs[1] imm
     /*  69276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69288 */     // MIs[2] Operand 1
     /*  69288 */     // No operand predicates
     /*  69288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69294 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  69297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69308 */     GIR_RootConstrainSelectedInstOperands,
     /*  69309 */     // GIR_Coverage, 2224,
     /*  69309 */     GIR_EraseRootFromParent_Done,
     /*  69310 */   // Label 1156: @69310
     /*  69310 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(69377), // Rule ID 2283 //
     /*  69315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69343 */     // MIs[1] imm
     /*  69343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69355 */     // MIs[2] Operand 1
     /*  69355 */     // No operand predicates
     /*  69355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69361 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  69364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69375 */     GIR_RootConstrainSelectedInstOperands,
     /*  69376 */     // GIR_Coverage, 2283,
     /*  69376 */     GIR_EraseRootFromParent_Done,
     /*  69377 */   // Label 1157: @69377
     /*  69377 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(69441), // Rule ID 13162 //
     /*  69382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69414 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69428 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  69431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69439 */     GIR_RootConstrainSelectedInstOperands,
     /*  69440 */     // GIR_Coverage, 13162,
     /*  69440 */     GIR_EraseRootFromParent_Done,
     /*  69441 */   // Label 1158: @69441
     /*  69441 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(69505), // Rule ID 1595 //
     /*  69446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69482 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69492 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  69495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69503 */     GIR_RootConstrainSelectedInstOperands,
     /*  69504 */     // GIR_Coverage, 1595,
     /*  69504 */     GIR_EraseRootFromParent_Done,
     /*  69505 */   // Label 1159: @69505
     /*  69505 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(69532), // Rule ID 1597 //
     /*  69510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69525 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  69530 */     GIR_RootConstrainSelectedInstOperands,
     /*  69531 */     // GIR_Coverage, 1597,
     /*  69531 */     GIR_Done,
     /*  69532 */   // Label 1160: @69532
     /*  69532 */   GIM_Reject,
     /*  69533 */ // Label 1145: @69533
     /*  69533 */ GIM_Reject,
     /*  69534 */ // Label 1000: @69534
     /*  69534 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(69565), // Rule ID 8351 //
     /*  69539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  69545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  69548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69552 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  69552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69557 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69559 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69561 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69563 */   GIR_RootConstrainSelectedInstOperands,
     /*  69564 */   // GIR_Coverage, 8351,
     /*  69564 */   GIR_EraseRootFromParent_Done,
     /*  69565 */ // Label 1161: @69565
     /*  69565 */ GIM_Reject,
     /*  69566 */ // Label 1001: @69566
     /*  69566 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(69597), // Rule ID 8350 //
     /*  69571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  69577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  69580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69584 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  69584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69589 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69591 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69593 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69595 */   GIR_RootConstrainSelectedInstOperands,
     /*  69596 */   // GIR_Coverage, 8350,
     /*  69596 */   GIR_EraseRootFromParent_Done,
     /*  69597 */ // Label 1162: @69597
     /*  69597 */ GIM_Reject,
     /*  69598 */ // Label 1002: @69598
     /*  69598 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(69623), // Rule ID 7360 //
     /*  69603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  69609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  69612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69616 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  69616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69621 */   GIR_RootConstrainSelectedInstOperands,
     /*  69622 */   // GIR_Coverage, 7360,
     /*  69622 */   GIR_Done,
     /*  69623 */ // Label 1163: @69623
     /*  69623 */ GIM_Reject,
     /*  69624 */ // Label 1003: @69624
     /*  69624 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(69655), // Rule ID 8349 //
     /*  69629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  69635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  69638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69642 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  69642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69649 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69651 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69653 */   GIR_RootConstrainSelectedInstOperands,
     /*  69654 */   // GIR_Coverage, 8349,
     /*  69654 */   GIR_EraseRootFromParent_Done,
     /*  69655 */ // Label 1164: @69655
     /*  69655 */ GIM_Reject,
     /*  69656 */ // Label 1004: @69656
     /*  69656 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(69681), // Rule ID 7359 //
     /*  69661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  69667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  69670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69674 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  69674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69679 */   GIR_RootConstrainSelectedInstOperands,
     /*  69680 */   // GIR_Coverage, 7359,
     /*  69680 */   GIR_Done,
     /*  69681 */ // Label 1165: @69681
     /*  69681 */ GIM_Reject,
     /*  69682 */ // Label 1005: @69682
     /*  69682 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(69713), // Rule ID 8348 //
     /*  69687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  69693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  69696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69700 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  69700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69707 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69709 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69711 */   GIR_RootConstrainSelectedInstOperands,
     /*  69712 */   // GIR_Coverage, 8348,
     /*  69712 */   GIR_EraseRootFromParent_Done,
     /*  69713 */ // Label 1166: @69713
     /*  69713 */ GIM_Reject,
     /*  69714 */ // Label 1006: @69714
     /*  69714 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(69739), // Rule ID 7358 //
     /*  69719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  69725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  69728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69732 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  69732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69737 */   GIR_RootConstrainSelectedInstOperands,
     /*  69738 */   // GIR_Coverage, 7358,
     /*  69738 */   GIR_Done,
     /*  69739 */ // Label 1167: @69739
     /*  69739 */ GIM_Reject,
     /*  69740 */ // Label 1007: @69740
     /*  69740 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(69771), // Rule ID 8347 //
     /*  69745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  69751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  69754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69758 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  69758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69763 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69765 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69767 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69769 */   GIR_RootConstrainSelectedInstOperands,
     /*  69770 */   // GIR_Coverage, 8347,
     /*  69770 */   GIR_EraseRootFromParent_Done,
     /*  69771 */ // Label 1168: @69771
     /*  69771 */ GIM_Reject,
     /*  69772 */ // Label 1008: @69772
     /*  69772 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(69797), // Rule ID 7357 //
     /*  69777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  69783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  69786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69790 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  69790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69795 */   GIR_RootConstrainSelectedInstOperands,
     /*  69796 */   // GIR_Coverage, 7357,
     /*  69796 */   GIR_Done,
     /*  69797 */ // Label 1169: @69797
     /*  69797 */ GIM_Reject,
     /*  69798 */ // Label 1009: @69798
     /*  69798 */ GIM_Reject,
     /*  69799 */ // Label 7: @69799
     /*  69799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1188*/ GIMT_Encode4(75737),
     /*  69810 */ /*GILLT_s32*//*Label 1170*/ GIMT_Encode4(69898),
     /*  69814 */ /*GILLT_s64*//*Label 1171*/ GIMT_Encode4(70578), GIMT_Encode4(0),
     /*  69822 */ /*GILLT_v2s32*//*Label 1172*/ GIMT_Encode4(71321),
     /*  69826 */ /*GILLT_v2s64*//*Label 1173*/ GIMT_Encode4(71389),
     /*  69830 */ /*GILLT_v4s16*//*Label 1174*/ GIMT_Encode4(71915),
     /*  69834 */ /*GILLT_v4s32*//*Label 1175*/ GIMT_Encode4(71983),
     /*  69838 */ /*GILLT_v8s8*//*Label 1176*/ GIMT_Encode4(72509),
     /*  69842 */ /*GILLT_v8s16*//*Label 1177*/ GIMT_Encode4(72580),
     /*  69846 */ /*GILLT_v16s8*//*Label 1178*/ GIMT_Encode4(73106),
     /*  69850 */ /*GILLT_nxv1s1*//*Label 1179*/ GIMT_Encode4(73635),
     /*  69854 */ /*GILLT_nxv2s1*//*Label 1180*/ GIMT_Encode4(73685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  69866 */ /*GILLT_nxv2s64*//*Label 1181*/ GIMT_Encode4(73735),
     /*  69870 */ /*GILLT_nxv4s1*//*Label 1182*/ GIMT_Encode4(74198), GIMT_Encode4(0),
     /*  69878 */ /*GILLT_nxv4s32*//*Label 1183*/ GIMT_Encode4(74248),
     /*  69882 */ /*GILLT_nxv8s1*//*Label 1184*/ GIMT_Encode4(74711),
     /*  69886 */ /*GILLT_nxv8s16*//*Label 1185*/ GIMT_Encode4(74761),
     /*  69890 */ /*GILLT_nxv16s1*//*Label 1186*/ GIMT_Encode4(75224),
     /*  69894 */ /*GILLT_nxv16s8*//*Label 1187*/ GIMT_Encode4(75274),
     /*  69898 */ // Label 1170: @69898
     /*  69898 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(70577),
     /*  69903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  69906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69909 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(69967), // Rule ID 13032 //
     /*  69914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  69930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  69934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69939 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  69943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  69952 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  69952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  69955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  69965 */     GIR_RootConstrainSelectedInstOperands,
     /*  69966 */     // GIR_Coverage, 13032,
     /*  69966 */     GIR_EraseRootFromParent_Done,
     /*  69967 */   // Label 1190: @69967
     /*  69967 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(70022), // Rule ID 13031 //
     /*  69972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  69988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  69992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  69996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70009 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70020 */     GIR_RootConstrainSelectedInstOperands,
     /*  70021 */     // GIR_Coverage, 13031,
     /*  70021 */     GIR_EraseRootFromParent_Done,
     /*  70022 */   // Label 1191: @70022
     /*  70022 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(70080), // Rule ID 13029 //
     /*  70027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70065 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70078 */     GIR_RootConstrainSelectedInstOperands,
     /*  70079 */     // GIR_Coverage, 13029,
     /*  70079 */     GIR_EraseRootFromParent_Done,
     /*  70080 */   // Label 1192: @70080
     /*  70080 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(70138), // Rule ID 166 //
     /*  70085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70123 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70136 */     GIR_RootConstrainSelectedInstOperands,
     /*  70137 */     // GIR_Coverage, 166,
     /*  70137 */     GIR_EraseRootFromParent_Done,
     /*  70138 */   // Label 1193: @70138
     /*  70138 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(70196), // Rule ID 13030 //
     /*  70143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70168 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70181 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70194 */     GIR_RootConstrainSelectedInstOperands,
     /*  70195 */     // GIR_Coverage, 13030,
     /*  70195 */     GIR_EraseRootFromParent_Done,
     /*  70196 */   // Label 1194: @70196
     /*  70196 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(70251), // Rule ID 13033 //
     /*  70201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70225 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70238 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70249 */     GIR_RootConstrainSelectedInstOperands,
     /*  70250 */     // GIR_Coverage, 13033,
     /*  70250 */     GIR_EraseRootFromParent_Done,
     /*  70251 */   // Label 1195: @70251
     /*  70251 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(70292), // Rule ID 144 //
     /*  70256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  70260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70272 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  70276 */     // MIs[1] Operand 1
     /*  70276 */     // No operand predicates
     /*  70276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70278 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  70278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  70281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70285 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  70290 */     GIR_RootConstrainSelectedInstOperands,
     /*  70291 */     // GIR_Coverage, 144,
     /*  70291 */     GIR_EraseRootFromParent_Done,
     /*  70292 */   // Label 1196: @70292
     /*  70292 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(70325), // Rule ID 13039 //
     /*  70297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70312 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  70315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70323 */     GIR_RootConstrainSelectedInstOperands,
     /*  70324 */     // GIR_Coverage, 13039,
     /*  70324 */     GIR_EraseRootFromParent_Done,
     /*  70325 */   // Label 1197: @70325
     /*  70325 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(70358), // Rule ID 170 //
     /*  70330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70345 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  70348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70356 */     GIR_RootConstrainSelectedInstOperands,
     /*  70357 */     // GIR_Coverage, 170,
     /*  70357 */     GIR_EraseRootFromParent_Done,
     /*  70358 */   // Label 1198: @70358
     /*  70358 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(70411), // Rule ID 13025 //
     /*  70363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70388 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70398 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  70409 */     GIR_RootConstrainSelectedInstOperands,
     /*  70410 */     // GIR_Coverage, 13025,
     /*  70410 */     GIR_EraseRootFromParent_Done,
     /*  70411 */   // Label 1199: @70411
     /*  70411 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(70467), // Rule ID 164 //
     /*  70416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70452 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70465 */     GIR_RootConstrainSelectedInstOperands,
     /*  70466 */     // GIR_Coverage, 164,
     /*  70466 */     GIR_EraseRootFromParent_Done,
     /*  70467 */   // Label 1200: @70467
     /*  70467 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(70520), // Rule ID 13026 //
     /*  70472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70507 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  70518 */     GIR_RootConstrainSelectedInstOperands,
     /*  70519 */     // GIR_Coverage, 13026,
     /*  70519 */     GIR_EraseRootFromParent_Done,
     /*  70520 */   // Label 1201: @70520
     /*  70520 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(70552), // Rule ID 3955 //
     /*  70525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70537 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  70537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  70540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  70550 */     GIR_RootConstrainSelectedInstOperands,
     /*  70551 */     // GIR_Coverage, 3955,
     /*  70551 */     GIR_EraseRootFromParent_Done,
     /*  70552 */   // Label 1202: @70552
     /*  70552 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(70576), // Rule ID 168 //
     /*  70557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70569 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  70574 */     GIR_RootConstrainSelectedInstOperands,
     /*  70575 */     // GIR_Coverage, 168,
     /*  70575 */     GIR_Done,
     /*  70576 */   // Label 1203: @70576
     /*  70576 */   GIM_Reject,
     /*  70577 */ // Label 1189: @70577
     /*  70577 */ GIM_Reject,
     /*  70578 */ // Label 1171: @70578
     /*  70578 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(71320),
     /*  70583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  70586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  70589 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(70647), // Rule ID 13037 //
     /*  70594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70619 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70632 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70645 */     GIR_RootConstrainSelectedInstOperands,
     /*  70646 */     // GIR_Coverage, 13037,
     /*  70646 */     GIR_EraseRootFromParent_Done,
     /*  70647 */   // Label 1205: @70647
     /*  70647 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(70702), // Rule ID 13036 //
     /*  70652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70689 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70700 */     GIR_RootConstrainSelectedInstOperands,
     /*  70701 */     // GIR_Coverage, 13036,
     /*  70701 */     GIR_EraseRootFromParent_Done,
     /*  70702 */   // Label 1206: @70702
     /*  70702 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(70760), // Rule ID 13034 //
     /*  70707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70745 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70758 */     GIR_RootConstrainSelectedInstOperands,
     /*  70759 */     // GIR_Coverage, 13034,
     /*  70759 */     GIR_EraseRootFromParent_Done,
     /*  70760 */   // Label 1207: @70760
     /*  70760 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(70818), // Rule ID 167 //
     /*  70765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70803 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70816 */     GIR_RootConstrainSelectedInstOperands,
     /*  70817 */     // GIR_Coverage, 167,
     /*  70817 */     GIR_EraseRootFromParent_Done,
     /*  70818 */   // Label 1208: @70818
     /*  70818 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(70876), // Rule ID 13035 //
     /*  70823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70848 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70861 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70874 */     GIR_RootConstrainSelectedInstOperands,
     /*  70875 */     // GIR_Coverage, 13035,
     /*  70875 */     GIR_EraseRootFromParent_Done,
     /*  70876 */   // Label 1209: @70876
     /*  70876 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(70931), // Rule ID 13038 //
     /*  70881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70905 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70918 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70929 */     GIR_RootConstrainSelectedInstOperands,
     /*  70930 */     // GIR_Coverage, 13038,
     /*  70930 */     GIR_EraseRootFromParent_Done,
     /*  70931 */   // Label 1210: @70931
     /*  70931 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(70972), // Rule ID 145 //
     /*  70936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  70940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70952 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  70956 */     // MIs[1] Operand 1
     /*  70956 */     // No operand predicates
     /*  70956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70958 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  70958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  70961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70965 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  70970 */     GIR_RootConstrainSelectedInstOperands,
     /*  70971 */     // GIR_Coverage, 145,
     /*  70971 */     GIR_EraseRootFromParent_Done,
     /*  70972 */   // Label 1211: @70972
     /*  70972 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(71005), // Rule ID 13040 //
     /*  70977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70992 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  70995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  71003 */     GIR_RootConstrainSelectedInstOperands,
     /*  71004 */     // GIR_Coverage, 13040,
     /*  71004 */     GIR_EraseRootFromParent_Done,
     /*  71005 */   // Label 1212: @71005
     /*  71005 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(71038), // Rule ID 171 //
     /*  71010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  71025 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  71025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  71028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  71036 */     GIR_RootConstrainSelectedInstOperands,
     /*  71037 */     // GIR_Coverage, 171,
     /*  71037 */     GIR_EraseRootFromParent_Done,
     /*  71038 */   // Label 1213: @71038
     /*  71038 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(71091), // Rule ID 13027 //
     /*  71043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71078 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  71089 */     GIR_RootConstrainSelectedInstOperands,
     /*  71090 */     // GIR_Coverage, 13027,
     /*  71090 */     GIR_EraseRootFromParent_Done,
     /*  71091 */   // Label 1214: @71091
     /*  71091 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(71147), // Rule ID 165 //
     /*  71096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  71130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71132 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71145 */     GIR_RootConstrainSelectedInstOperands,
     /*  71146 */     // GIR_Coverage, 165,
     /*  71146 */     GIR_EraseRootFromParent_Done,
     /*  71147 */   // Label 1215: @71147
     /*  71147 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(71200), // Rule ID 13028 //
     /*  71152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71181 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71187 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  71198 */     GIR_RootConstrainSelectedInstOperands,
     /*  71199 */     // GIR_Coverage, 13028,
     /*  71199 */     GIR_EraseRootFromParent_Done,
     /*  71200 */   // Label 1216: @71200
     /*  71200 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(71232), // Rule ID 3956 //
     /*  71205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  71217 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  71217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  71220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  71230 */     GIR_RootConstrainSelectedInstOperands,
     /*  71231 */     // GIR_Coverage, 3956,
     /*  71231 */     GIR_EraseRootFromParent_Done,
     /*  71232 */   // Label 1217: @71232
     /*  71232 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(71268), // Rule ID 4902 //
     /*  71237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71249 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71259 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  71259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71266 */     GIR_RootConstrainSelectedInstOperands,
     /*  71267 */     // GIR_Coverage, 4902,
     /*  71267 */     GIR_EraseRootFromParent_Done,
     /*  71268 */   // Label 1218: @71268
     /*  71268 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(71292), // Rule ID 169 //
     /*  71273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71285 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  71290 */     GIR_RootConstrainSelectedInstOperands,
     /*  71291 */     // GIR_Coverage, 169,
     /*  71291 */     GIR_Done,
     /*  71292 */   // Label 1219: @71292
     /*  71292 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(71319), // Rule ID 4998 //
     /*  71297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71312 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  71312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71317 */     GIR_RootConstrainSelectedInstOperands,
     /*  71318 */     // GIR_Coverage, 4998,
     /*  71318 */     GIR_Done,
     /*  71319 */   // Label 1220: @71319
     /*  71319 */   GIM_Reject,
     /*  71320 */ // Label 1204: @71320
     /*  71320 */ GIM_Reject,
     /*  71321 */ // Label 1172: @71321
     /*  71321 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(71388),
     /*  71326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  71329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71340 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(71368), // Rule ID 4900 //
     /*  71345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71349 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71359 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  71359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71366 */     GIR_RootConstrainSelectedInstOperands,
     /*  71367 */     // GIR_Coverage, 4900,
     /*  71367 */     GIR_EraseRootFromParent_Done,
     /*  71368 */   // Label 1222: @71368
     /*  71368 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(71387), // Rule ID 4997 //
     /*  71373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71380 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  71380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71385 */     GIR_RootConstrainSelectedInstOperands,
     /*  71386 */     // GIR_Coverage, 4997,
     /*  71386 */     GIR_Done,
     /*  71387 */   // Label 1223: @71387
     /*  71387 */   GIM_Reject,
     /*  71388 */ // Label 1221: @71388
     /*  71388 */ GIM_Reject,
     /*  71389 */ // Label 1173: @71389
     /*  71389 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(71914),
     /*  71394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71404 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(71489), // Rule ID 13562 //
     /*  71409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71472 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  71479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71487 */     GIR_RootConstrainSelectedInstOperands,
     /*  71488 */     // GIR_Coverage, 13562,
     /*  71488 */     GIR_EraseRootFromParent_Done,
     /*  71489 */   // Label 1225: @71489
     /*  71489 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(71574), // Rule ID 13561 //
     /*  71494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71543 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71557 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  71564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  71568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71572 */     GIR_RootConstrainSelectedInstOperands,
     /*  71573 */     // GIR_Coverage, 13561,
     /*  71573 */     GIR_EraseRootFromParent_Done,
     /*  71574 */   // Label 1226: @71574
     /*  71574 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(71659), // Rule ID 13560 //
     /*  71579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71627 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71633 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71642 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  71649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71657 */     GIR_RootConstrainSelectedInstOperands,
     /*  71658 */     // GIR_Coverage, 13560,
     /*  71658 */     GIR_EraseRootFromParent_Done,
     /*  71659 */   // Label 1227: @71659
     /*  71659 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(71744), // Rule ID 3783 //
     /*  71664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71717 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71723 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71727 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  71734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  71738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71742 */     GIR_RootConstrainSelectedInstOperands,
     /*  71743 */     // GIR_Coverage, 3783,
     /*  71743 */     GIR_EraseRootFromParent_Done,
     /*  71744 */   // Label 1228: @71744
     /*  71744 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(71776), // Rule ID 4903 //
     /*  71749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71757 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71767 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  71767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  71770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71774 */     GIR_RootConstrainSelectedInstOperands,
     /*  71775 */     // GIR_Coverage, 4903,
     /*  71775 */     GIR_EraseRootFromParent_Done,
     /*  71776 */   // Label 1229: @71776
     /*  71776 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(71833), // Rule ID 3779 //
     /*  71781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71816 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  71819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  71825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  71831 */     GIR_RootConstrainSelectedInstOperands,
     /*  71832 */     // GIR_Coverage, 3779,
     /*  71832 */     GIR_EraseRootFromParent_Done,
     /*  71833 */   // Label 1230: @71833
     /*  71833 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(71890), // Rule ID 13550 //
     /*  71838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71873 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  71876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  71882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  71888 */     GIR_RootConstrainSelectedInstOperands,
     /*  71889 */     // GIR_Coverage, 13550,
     /*  71889 */     GIR_EraseRootFromParent_Done,
     /*  71890 */   // Label 1231: @71890
     /*  71890 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(71913), // Rule ID 5001 //
     /*  71895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71906 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  71906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  71911 */     GIR_RootConstrainSelectedInstOperands,
     /*  71912 */     // GIR_Coverage, 5001,
     /*  71912 */     GIR_Done,
     /*  71913 */   // Label 1232: @71913
     /*  71913 */   GIM_Reject,
     /*  71914 */ // Label 1224: @71914
     /*  71914 */ GIM_Reject,
     /*  71915 */ // Label 1174: @71915
     /*  71915 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(71982),
     /*  71920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  71923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71934 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(71962), // Rule ID 4898 //
     /*  71939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71953 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  71953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71960 */     GIR_RootConstrainSelectedInstOperands,
     /*  71961 */     // GIR_Coverage, 4898,
     /*  71961 */     GIR_EraseRootFromParent_Done,
     /*  71962 */   // Label 1234: @71962
     /*  71962 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(71981), // Rule ID 4996 //
     /*  71967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71974 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  71974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71979 */     GIR_RootConstrainSelectedInstOperands,
     /*  71980 */     // GIR_Coverage, 4996,
     /*  71980 */     GIR_Done,
     /*  71981 */   // Label 1235: @71981
     /*  71981 */   GIM_Reject,
     /*  71982 */ // Label 1233: @71982
     /*  71982 */ GIM_Reject,
     /*  71983 */ // Label 1175: @71983
     /*  71983 */ GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(72508),
     /*  71988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  71991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71998 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(72083), // Rule ID 13559 //
     /*  72003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72047 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72066 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72081 */     GIR_RootConstrainSelectedInstOperands,
     /*  72082 */     // GIR_Coverage, 13559,
     /*  72082 */     GIR_EraseRootFromParent_Done,
     /*  72083 */   // Label 1237: @72083
     /*  72083 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(72168), // Rule ID 13558 //
     /*  72088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72137 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72143 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72151 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72166 */     GIR_RootConstrainSelectedInstOperands,
     /*  72167 */     // GIR_Coverage, 13558,
     /*  72167 */     GIR_EraseRootFromParent_Done,
     /*  72168 */   // Label 1238: @72168
     /*  72168 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(72253), // Rule ID 13557 //
     /*  72173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72221 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72236 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72251 */     GIR_RootConstrainSelectedInstOperands,
     /*  72252 */     // GIR_Coverage, 13557,
     /*  72252 */     GIR_EraseRootFromParent_Done,
     /*  72253 */   // Label 1239: @72253
     /*  72253 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(72338), // Rule ID 3782 //
     /*  72258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72311 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72321 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72336 */     GIR_RootConstrainSelectedInstOperands,
     /*  72337 */     // GIR_Coverage, 3782,
     /*  72337 */     GIR_EraseRootFromParent_Done,
     /*  72338 */   // Label 1240: @72338
     /*  72338 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(72370), // Rule ID 4901 //
     /*  72343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72351 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72357 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72361 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  72361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  72364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72368 */     GIR_RootConstrainSelectedInstOperands,
     /*  72369 */     // GIR_Coverage, 4901,
     /*  72369 */     GIR_EraseRootFromParent_Done,
     /*  72370 */   // Label 1241: @72370
     /*  72370 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(72427), // Rule ID 3778 //
     /*  72375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72410 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  72419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  72425 */     GIR_RootConstrainSelectedInstOperands,
     /*  72426 */     // GIR_Coverage, 3778,
     /*  72426 */     GIR_EraseRootFromParent_Done,
     /*  72427 */   // Label 1242: @72427
     /*  72427 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(72484), // Rule ID 13549 //
     /*  72432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72467 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  72476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  72482 */     GIR_RootConstrainSelectedInstOperands,
     /*  72483 */     // GIR_Coverage, 13549,
     /*  72483 */     GIR_EraseRootFromParent_Done,
     /*  72484 */   // Label 1243: @72484
     /*  72484 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(72507), // Rule ID 5000 //
     /*  72489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72500 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  72500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  72505 */     GIR_RootConstrainSelectedInstOperands,
     /*  72506 */     // GIR_Coverage, 5000,
     /*  72506 */     GIR_Done,
     /*  72507 */   // Label 1244: @72507
     /*  72507 */   GIM_Reject,
     /*  72508 */ // Label 1236: @72508
     /*  72508 */ GIM_Reject,
     /*  72509 */ // Label 1176: @72509
     /*  72509 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(72579),
     /*  72514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  72517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  72520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72528 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(72559), // Rule ID 965 //
     /*  72533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72546 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72550 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  72550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  72553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72557 */     GIR_RootConstrainSelectedInstOperands,
     /*  72558 */     // GIR_Coverage, 965,
     /*  72558 */     GIR_EraseRootFromParent_Done,
     /*  72559 */   // Label 1246: @72559
     /*  72559 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(72578), // Rule ID 1592 //
     /*  72564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72571 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  72571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  72576 */     GIR_RootConstrainSelectedInstOperands,
     /*  72577 */     // GIR_Coverage, 1592,
     /*  72577 */     GIR_Done,
     /*  72578 */   // Label 1247: @72578
     /*  72578 */   GIM_Reject,
     /*  72579 */ // Label 1245: @72579
     /*  72579 */ GIM_Reject,
     /*  72580 */ // Label 1177: @72580
     /*  72580 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(73105),
     /*  72585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72595 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(72680), // Rule ID 13556 //
     /*  72600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72644 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72663 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72678 */     GIR_RootConstrainSelectedInstOperands,
     /*  72679 */     // GIR_Coverage, 13556,
     /*  72679 */     GIR_EraseRootFromParent_Done,
     /*  72680 */   // Label 1249: @72680
     /*  72680 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(72765), // Rule ID 13555 //
     /*  72685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72734 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72748 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72763 */     GIR_RootConstrainSelectedInstOperands,
     /*  72764 */     // GIR_Coverage, 13555,
     /*  72764 */     GIR_EraseRootFromParent_Done,
     /*  72765 */   // Label 1250: @72765
     /*  72765 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(72850), // Rule ID 13554 //
     /*  72770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72833 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72848 */     GIR_RootConstrainSelectedInstOperands,
     /*  72849 */     // GIR_Coverage, 13554,
     /*  72849 */     GIR_EraseRootFromParent_Done,
     /*  72850 */   // Label 1251: @72850
     /*  72850 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(72935), // Rule ID 3781 //
     /*  72855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72908 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72918 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72933 */     GIR_RootConstrainSelectedInstOperands,
     /*  72934 */     // GIR_Coverage, 3781,
     /*  72934 */     GIR_EraseRootFromParent_Done,
     /*  72935 */   // Label 1252: @72935
     /*  72935 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(72967), // Rule ID 4899 //
     /*  72940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72948 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72954 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72958 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  72958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  72961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72965 */     GIR_RootConstrainSelectedInstOperands,
     /*  72966 */     // GIR_Coverage, 4899,
     /*  72966 */     GIR_EraseRootFromParent_Done,
     /*  72967 */   // Label 1253: @72967
     /*  72967 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(73024), // Rule ID 3777 //
     /*  72972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73007 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  73007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  73022 */     GIR_RootConstrainSelectedInstOperands,
     /*  73023 */     // GIR_Coverage, 3777,
     /*  73023 */     GIR_EraseRootFromParent_Done,
     /*  73024 */   // Label 1254: @73024
     /*  73024 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(73081), // Rule ID 13548 //
     /*  73029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  73048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73064 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  73064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  73079 */     GIR_RootConstrainSelectedInstOperands,
     /*  73080 */     // GIR_Coverage, 13548,
     /*  73080 */     GIR_EraseRootFromParent_Done,
     /*  73081 */   // Label 1255: @73081
     /*  73081 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(73104), // Rule ID 4999 //
     /*  73086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73097 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  73097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  73102 */     GIR_RootConstrainSelectedInstOperands,
     /*  73103 */     // GIR_Coverage, 4999,
     /*  73103 */     GIR_Done,
     /*  73104 */   // Label 1256: @73104
     /*  73104 */   GIM_Reject,
     /*  73105 */ // Label 1248: @73105
     /*  73105 */ GIM_Reject,
     /*  73106 */ // Label 1178: @73106
     /*  73106 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(73634),
     /*  73111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73121 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(73206), // Rule ID 13553 //
     /*  73126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73170 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73189 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  73196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73204 */     GIR_RootConstrainSelectedInstOperands,
     /*  73205 */     // GIR_Coverage, 13553,
     /*  73205 */     GIR_EraseRootFromParent_Done,
     /*  73206 */   // Label 1258: @73206
     /*  73206 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(73291), // Rule ID 13552 //
     /*  73211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73260 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73266 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73274 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  73281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  73285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73289 */     GIR_RootConstrainSelectedInstOperands,
     /*  73290 */     // GIR_Coverage, 13552,
     /*  73290 */     GIR_EraseRootFromParent_Done,
     /*  73291 */   // Label 1259: @73291
     /*  73291 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(73376), // Rule ID 13551 //
     /*  73296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73344 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73350 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73359 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  73366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73374 */     GIR_RootConstrainSelectedInstOperands,
     /*  73375 */     // GIR_Coverage, 13551,
     /*  73375 */     GIR_EraseRootFromParent_Done,
     /*  73376 */   // Label 1260: @73376
     /*  73376 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(73461), // Rule ID 3780 //
     /*  73381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73444 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  73451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  73455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73459 */     GIR_RootConstrainSelectedInstOperands,
     /*  73460 */     // GIR_Coverage, 3780,
     /*  73460 */     GIR_EraseRootFromParent_Done,
     /*  73461 */   // Label 1261: @73461
     /*  73461 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(73496), // Rule ID 966 //
     /*  73466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73483 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73487 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  73487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  73490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73494 */     GIR_RootConstrainSelectedInstOperands,
     /*  73495 */     // GIR_Coverage, 966,
     /*  73495 */     GIR_EraseRootFromParent_Done,
     /*  73496 */   // Label 1262: @73496
     /*  73496 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(73553), // Rule ID 3776 //
     /*  73501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73536 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  73551 */     GIR_RootConstrainSelectedInstOperands,
     /*  73552 */     // GIR_Coverage, 3776,
     /*  73552 */     GIR_EraseRootFromParent_Done,
     /*  73553 */   // Label 1263: @73553
     /*  73553 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(73610), // Rule ID 13547 //
     /*  73558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73593 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  73608 */     GIR_RootConstrainSelectedInstOperands,
     /*  73609 */     // GIR_Coverage, 13547,
     /*  73609 */     GIR_EraseRootFromParent_Done,
     /*  73610 */   // Label 1264: @73610
     /*  73610 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(73633), // Rule ID 1593 //
     /*  73615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73626 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  73631 */     GIR_RootConstrainSelectedInstOperands,
     /*  73632 */     // GIR_Coverage, 1593,
     /*  73632 */     GIR_Done,
     /*  73633 */   // Label 1265: @73633
     /*  73633 */   GIM_Reject,
     /*  73634 */ // Label 1257: @73634
     /*  73634 */ GIM_Reject,
     /*  73635 */ // Label 1179: @73635
     /*  73635 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(73684), // Rule ID 8341 //
     /*  73640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  73643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  73646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  73649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  73653 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  73653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  73656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  73660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73665 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  73668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  73670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  73673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  73675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73678 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73680 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  73682 */   GIR_RootConstrainSelectedInstOperands,
     /*  73683 */   // GIR_Coverage, 8341,
     /*  73683 */   GIR_EraseRootFromParent_Done,
     /*  73684 */ // Label 1266: @73684
     /*  73684 */ GIM_Reject,
     /*  73685 */ // Label 1180: @73685
     /*  73685 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(73734), // Rule ID 8340 //
     /*  73690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  73693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  73696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  73699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  73703 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  73703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  73706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  73710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73715 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  73718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  73720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  73723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  73725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73728 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73730 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  73732 */   GIR_RootConstrainSelectedInstOperands,
     /*  73733 */   // GIR_Coverage, 8340,
     /*  73733 */   GIR_EraseRootFromParent_Done,
     /*  73734 */ // Label 1267: @73734
     /*  73734 */ GIM_Reject,
     /*  73735 */ // Label 1181: @73735
     /*  73735 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(74197),
     /*  73740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  73750 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(73821), // Rule ID 15405 //
     /*  73755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73804 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  73811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73819 */     GIR_RootConstrainSelectedInstOperands,
     /*  73820 */     // GIR_Coverage, 15405,
     /*  73820 */     GIR_EraseRootFromParent_Done,
     /*  73821 */   // Label 1269: @73821
     /*  73821 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(73892), // Rule ID 15404 //
     /*  73826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73865 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73871 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73875 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  73882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73890 */     GIR_RootConstrainSelectedInstOperands,
     /*  73891 */     // GIR_Coverage, 15404,
     /*  73891 */     GIR_EraseRootFromParent_Done,
     /*  73892 */   // Label 1270: @73892
     /*  73892 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(73963), // Rule ID 15403 //
     /*  73897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73936 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73946 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73961 */     GIR_RootConstrainSelectedInstOperands,
     /*  73962 */     // GIR_Coverage, 15403,
     /*  73962 */     GIR_EraseRootFromParent_Done,
     /*  73963 */   // Label 1271: @73963
     /*  73963 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(74034), // Rule ID 11751 //
     /*  73968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74017 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74032 */     GIR_RootConstrainSelectedInstOperands,
     /*  74033 */     // GIR_Coverage, 11751,
     /*  74033 */     GIR_EraseRootFromParent_Done,
     /*  74034 */   // Label 1272: @74034
     /*  74034 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(74095), // Rule ID 11775 //
     /*  74039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  74050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74058 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  74062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74066 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74076 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  74079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  74089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74093 */     GIR_RootConstrainSelectedInstOperands,
     /*  74094 */     // GIR_Coverage, 11775,
     /*  74094 */     GIR_EraseRootFromParent_Done,
     /*  74095 */   // Label 1273: @74095
     /*  74095 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(74138), // Rule ID 13514 //
     /*  74100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74121 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  74136 */     GIR_RootConstrainSelectedInstOperands,
     /*  74137 */     // GIR_Coverage, 13514,
     /*  74137 */     GIR_EraseRootFromParent_Done,
     /*  74138 */   // Label 1274: @74138
     /*  74138 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(74181), // Rule ID 3145 //
     /*  74143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74164 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74179 */     GIR_RootConstrainSelectedInstOperands,
     /*  74180 */     // GIR_Coverage, 3145,
     /*  74180 */     GIR_EraseRootFromParent_Done,
     /*  74181 */   // Label 1275: @74181
     /*  74181 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(74196), // Rule ID 7364 //
     /*  74186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74189 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  74189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  74194 */     GIR_RootConstrainSelectedInstOperands,
     /*  74195 */     // GIR_Coverage, 7364,
     /*  74195 */     GIR_Done,
     /*  74196 */   // Label 1276: @74196
     /*  74196 */   GIM_Reject,
     /*  74197 */ // Label 1268: @74197
     /*  74197 */ GIM_Reject,
     /*  74198 */ // Label 1182: @74198
     /*  74198 */ GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(74247), // Rule ID 8339 //
     /*  74203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  74209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  74212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74216 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  74216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  74219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  74223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74228 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  74231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  74233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  74236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74241 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74243 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74245 */   GIR_RootConstrainSelectedInstOperands,
     /*  74246 */   // GIR_Coverage, 8339,
     /*  74246 */   GIR_EraseRootFromParent_Done,
     /*  74247 */ // Label 1277: @74247
     /*  74247 */ GIM_Reject,
     /*  74248 */ // Label 1183: @74248
     /*  74248 */ GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(74710),
     /*  74253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74263 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(74334), // Rule ID 15402 //
     /*  74268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74317 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74332 */     GIR_RootConstrainSelectedInstOperands,
     /*  74333 */     // GIR_Coverage, 15402,
     /*  74333 */     GIR_EraseRootFromParent_Done,
     /*  74334 */   // Label 1279: @74334
     /*  74334 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(74405), // Rule ID 15401 //
     /*  74339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74388 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74403 */     GIR_RootConstrainSelectedInstOperands,
     /*  74404 */     // GIR_Coverage, 15401,
     /*  74404 */     GIR_EraseRootFromParent_Done,
     /*  74405 */   // Label 1280: @74405
     /*  74405 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(74476), // Rule ID 15400 //
     /*  74410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74449 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74455 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74459 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74474 */     GIR_RootConstrainSelectedInstOperands,
     /*  74475 */     // GIR_Coverage, 15400,
     /*  74475 */     GIR_EraseRootFromParent_Done,
     /*  74476 */   // Label 1281: @74476
     /*  74476 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(74547), // Rule ID 11749 //
     /*  74481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74520 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74530 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74545 */     GIR_RootConstrainSelectedInstOperands,
     /*  74546 */     // GIR_Coverage, 11749,
     /*  74546 */     GIR_EraseRootFromParent_Done,
     /*  74547 */   // Label 1282: @74547
     /*  74547 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(74608), // Rule ID 11773 //
     /*  74552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  74563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74571 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  74575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74579 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74585 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74589 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  74592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  74602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74606 */     GIR_RootConstrainSelectedInstOperands,
     /*  74607 */     // GIR_Coverage, 11773,
     /*  74607 */     GIR_EraseRootFromParent_Done,
     /*  74608 */   // Label 1283: @74608
     /*  74608 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(74651), // Rule ID 13513 //
     /*  74613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74634 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  74649 */     GIR_RootConstrainSelectedInstOperands,
     /*  74650 */     // GIR_Coverage, 13513,
     /*  74650 */     GIR_EraseRootFromParent_Done,
     /*  74651 */   // Label 1284: @74651
     /*  74651 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(74694), // Rule ID 3143 //
     /*  74656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74677 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74692 */     GIR_RootConstrainSelectedInstOperands,
     /*  74693 */     // GIR_Coverage, 3143,
     /*  74693 */     GIR_EraseRootFromParent_Done,
     /*  74694 */   // Label 1285: @74694
     /*  74694 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(74709), // Rule ID 7363 //
     /*  74699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74702 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  74702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  74707 */     GIR_RootConstrainSelectedInstOperands,
     /*  74708 */     // GIR_Coverage, 7363,
     /*  74708 */     GIR_Done,
     /*  74709 */   // Label 1286: @74709
     /*  74709 */   GIM_Reject,
     /*  74710 */ // Label 1278: @74710
     /*  74710 */ GIM_Reject,
     /*  74711 */ // Label 1184: @74711
     /*  74711 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(74760), // Rule ID 8338 //
     /*  74716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  74722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  74725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74729 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  74729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  74732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  74736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74741 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  74744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  74746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  74749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74754 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74756 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74758 */   GIR_RootConstrainSelectedInstOperands,
     /*  74759 */   // GIR_Coverage, 8338,
     /*  74759 */   GIR_EraseRootFromParent_Done,
     /*  74760 */ // Label 1287: @74760
     /*  74760 */ GIM_Reject,
     /*  74761 */ // Label 1185: @74761
     /*  74761 */ GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(75223),
     /*  74766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74776 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(74847), // Rule ID 15399 //
     /*  74781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74820 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74826 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74830 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74845 */     GIR_RootConstrainSelectedInstOperands,
     /*  74846 */     // GIR_Coverage, 15399,
     /*  74846 */     GIR_EraseRootFromParent_Done,
     /*  74847 */   // Label 1289: @74847
     /*  74847 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(74918), // Rule ID 15398 //
     /*  74852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74891 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74897 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74901 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74916 */     GIR_RootConstrainSelectedInstOperands,
     /*  74917 */     // GIR_Coverage, 15398,
     /*  74917 */     GIR_EraseRootFromParent_Done,
     /*  74918 */   // Label 1290: @74918
     /*  74918 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(74989), // Rule ID 15397 //
     /*  74923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74962 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74968 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74972 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74987 */     GIR_RootConstrainSelectedInstOperands,
     /*  74988 */     // GIR_Coverage, 15397,
     /*  74988 */     GIR_EraseRootFromParent_Done,
     /*  74989 */   // Label 1291: @74989
     /*  74989 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(75060), // Rule ID 11747 //
     /*  74994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75033 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75043 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75058 */     GIR_RootConstrainSelectedInstOperands,
     /*  75059 */     // GIR_Coverage, 11747,
     /*  75059 */     GIR_EraseRootFromParent_Done,
     /*  75060 */   // Label 1292: @75060
     /*  75060 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(75121), // Rule ID 11771 //
     /*  75065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  75076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75084 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  75088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75092 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75098 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  75100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75102 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  75105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  75115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75119 */     GIR_RootConstrainSelectedInstOperands,
     /*  75120 */     // GIR_Coverage, 11771,
     /*  75120 */     GIR_EraseRootFromParent_Done,
     /*  75121 */   // Label 1293: @75121
     /*  75121 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(75164), // Rule ID 13512 //
     /*  75126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75147 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  75162 */     GIR_RootConstrainSelectedInstOperands,
     /*  75163 */     // GIR_Coverage, 13512,
     /*  75163 */     GIR_EraseRootFromParent_Done,
     /*  75164 */   // Label 1294: @75164
     /*  75164 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(75207), // Rule ID 3141 //
     /*  75169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75190 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75205 */     GIR_RootConstrainSelectedInstOperands,
     /*  75206 */     // GIR_Coverage, 3141,
     /*  75206 */     GIR_EraseRootFromParent_Done,
     /*  75207 */   // Label 1295: @75207
     /*  75207 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(75222), // Rule ID 7362 //
     /*  75212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75215 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  75215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  75220 */     GIR_RootConstrainSelectedInstOperands,
     /*  75221 */     // GIR_Coverage, 7362,
     /*  75221 */     GIR_Done,
     /*  75222 */   // Label 1296: @75222
     /*  75222 */   GIM_Reject,
     /*  75223 */ // Label 1288: @75223
     /*  75223 */ GIM_Reject,
     /*  75224 */ // Label 1186: @75224
     /*  75224 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(75273), // Rule ID 8337 //
     /*  75229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  75235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  75238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  75242 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  75242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  75245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  75249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75254 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  75257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  75262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  75264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75267 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75269 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  75271 */   GIR_RootConstrainSelectedInstOperands,
     /*  75272 */   // GIR_Coverage, 8337,
     /*  75272 */   GIR_EraseRootFromParent_Done,
     /*  75273 */ // Label 1297: @75273
     /*  75273 */ GIM_Reject,
     /*  75274 */ // Label 1187: @75274
     /*  75274 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(75736),
     /*  75279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  75289 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(75360), // Rule ID 15396 //
     /*  75294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75333 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75339 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75343 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  75350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75358 */     GIR_RootConstrainSelectedInstOperands,
     /*  75359 */     // GIR_Coverage, 15396,
     /*  75359 */     GIR_EraseRootFromParent_Done,
     /*  75360 */   // Label 1299: @75360
     /*  75360 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(75431), // Rule ID 15395 //
     /*  75365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75404 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75410 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75414 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  75421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75429 */     GIR_RootConstrainSelectedInstOperands,
     /*  75430 */     // GIR_Coverage, 15395,
     /*  75430 */     GIR_EraseRootFromParent_Done,
     /*  75431 */   // Label 1300: @75431
     /*  75431 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(75502), // Rule ID 15394 //
     /*  75436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75485 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75500 */     GIR_RootConstrainSelectedInstOperands,
     /*  75501 */     // GIR_Coverage, 15394,
     /*  75501 */     GIR_EraseRootFromParent_Done,
     /*  75502 */   // Label 1301: @75502
     /*  75502 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(75573), // Rule ID 11745 //
     /*  75507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75546 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75552 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75556 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75571 */     GIR_RootConstrainSelectedInstOperands,
     /*  75572 */     // GIR_Coverage, 11745,
     /*  75572 */     GIR_EraseRootFromParent_Done,
     /*  75573 */   // Label 1302: @75573
     /*  75573 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(75634), // Rule ID 11769 //
     /*  75578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  75589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75597 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  75601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75605 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75611 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  75613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75615 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  75618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  75628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75632 */     GIR_RootConstrainSelectedInstOperands,
     /*  75633 */     // GIR_Coverage, 11769,
     /*  75633 */     GIR_EraseRootFromParent_Done,
     /*  75634 */   // Label 1303: @75634
     /*  75634 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(75677), // Rule ID 13511 //
     /*  75639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75660 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  75675 */     GIR_RootConstrainSelectedInstOperands,
     /*  75676 */     // GIR_Coverage, 13511,
     /*  75676 */     GIR_EraseRootFromParent_Done,
     /*  75677 */   // Label 1304: @75677
     /*  75677 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(75720), // Rule ID 3139 //
     /*  75682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75703 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75718 */     GIR_RootConstrainSelectedInstOperands,
     /*  75719 */     // GIR_Coverage, 3139,
     /*  75719 */     GIR_EraseRootFromParent_Done,
     /*  75720 */   // Label 1305: @75720
     /*  75720 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(75735), // Rule ID 7361 //
     /*  75725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75728 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  75728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  75733 */     GIR_RootConstrainSelectedInstOperands,
     /*  75734 */     // GIR_Coverage, 7361,
     /*  75734 */     GIR_Done,
     /*  75735 */   // Label 1306: @75735
     /*  75735 */   GIM_Reject,
     /*  75736 */ // Label 1298: @75736
     /*  75736 */ GIM_Reject,
     /*  75737 */ // Label 1188: @75737
     /*  75737 */ GIM_Reject,
     /*  75738 */ // Label 8: @75738
     /*  75738 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(83261),
     /*  75743 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  75746 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1319*/ GIMT_Encode4(83260),
     /*  75757 */   /*GILLT_v2s64*//*Label 1308*/ GIMT_Encode4(75825), GIMT_Encode4(0),
     /*  75765 */   /*GILLT_v4s32*//*Label 1309*/ GIMT_Encode4(76346), GIMT_Encode4(0),
     /*  75773 */   /*GILLT_v8s16*//*Label 1310*/ GIMT_Encode4(78758),
     /*  75777 */   /*GILLT_v16s8*//*Label 1311*/ GIMT_Encode4(81167), GIMT_Encode4(0),
     /*  75785 */   /*GILLT_nxv2s1*//*Label 1312*/ GIMT_Encode4(83078), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  75801 */   /*GILLT_nxv4s1*//*Label 1313*/ GIMT_Encode4(83104),
     /*  75805 */   /*GILLT_nxv4s16*//*Label 1314*/ GIMT_Encode4(83130),
     /*  75809 */   /*GILLT_nxv4s32*//*Label 1315*/ GIMT_Encode4(83156),
     /*  75813 */   /*GILLT_nxv8s1*//*Label 1316*/ GIMT_Encode4(83182),
     /*  75817 */   /*GILLT_nxv8s16*//*Label 1317*/ GIMT_Encode4(83208),
     /*  75821 */   /*GILLT_nxv16s1*//*Label 1318*/ GIMT_Encode4(83234),
     /*  75825 */   // Label 1308: @75825
     /*  75825 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(76345),
     /*  75830 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  75833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75844 */     GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(75906), // Rule ID 5709 //
     /*  75849 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75853 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75859 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  75861 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75863 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  75863 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  75866 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  75870 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75875 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  75879 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  75884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75886 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75889 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75892 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75895 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75900 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75905 */       // GIR_Coverage, 5709,
     /*  75905 */       GIR_EraseRootFromParent_Done,
     /*  75906 */     // Label 1321: @75906
     /*  75906 */     GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(75968), // Rule ID 5713 //
     /*  75911 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75915 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75921 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  75923 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75925 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  75925 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  75928 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  75932 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75937 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  75941 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75943 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  75946 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75948 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75957 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75962 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75967 */       // GIR_Coverage, 5713,
     /*  75967 */       GIR_EraseRootFromParent_Done,
     /*  75968 */     // Label 1322: @75968
     /*  75968 */     GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(76026), // Rule ID 5710 //
     /*  75973 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75977 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  75981 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75983 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  75983 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  75986 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75990 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75995 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75997 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76000 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76002 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76005 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76007 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  76010 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76015 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76020 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76025 */       // GIR_Coverage, 5710,
     /*  76025 */       GIR_EraseRootFromParent_Done,
     /*  76026 */     // Label 1323: @76026
     /*  76026 */     GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(76084), // Rule ID 5714 //
     /*  76031 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76035 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  76039 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76041 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  76041 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  76044 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76048 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76053 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  76055 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76058 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76060 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76063 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76065 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  76068 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76073 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76078 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76083 */       // GIR_Coverage, 5714,
     /*  76083 */       GIR_EraseRootFromParent_Done,
     /*  76084 */     // Label 1324: @76084
     /*  76084 */     GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(76214), // Rule ID 5708 //
     /*  76089 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76093 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  76093 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  76096 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76100 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76105 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  76107 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  76110 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76114 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76119 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  76122 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  76126 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  76129 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76134 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76139 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76144 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76147 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76151 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76156 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76158 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76161 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76165 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76170 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76173 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76177 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76180 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76185 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76190 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76195 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76198 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76200 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76203 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76206 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76209 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76212 */       GIR_RootConstrainSelectedInstOperands,
     /*  76213 */       // GIR_Coverage, 5708,
     /*  76213 */       GIR_EraseRootFromParent_Done,
     /*  76214 */     // Label 1325: @76214
     /*  76214 */     GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(76344), // Rule ID 5712 //
     /*  76219 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76223 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  76223 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  76226 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76230 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  76237 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  76240 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76244 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76249 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  76252 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  76256 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  76259 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76264 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76269 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76274 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76277 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76281 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76286 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76288 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76291 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76295 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76300 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76303 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76307 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76310 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76325 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76328 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76330 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76333 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76336 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76339 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76342 */       GIR_RootConstrainSelectedInstOperands,
     /*  76343 */       // GIR_Coverage, 5712,
     /*  76343 */       GIR_EraseRootFromParent_Done,
     /*  76344 */     // Label 1326: @76344
     /*  76344 */     GIM_Reject,
     /*  76345 */   // Label 1320: @76345
     /*  76345 */   GIM_Reject,
     /*  76346 */   // Label 1309: @76346
     /*  76346 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(78757),
     /*  76351 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  76354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  76357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76361 */     GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(76490), // Rule ID 5378 //
     /*  76366 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76370 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76374 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76378 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76382 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76386 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76390 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76394 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76398 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76402 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76406 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76410 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76415 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76419 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76425 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76427 */       // MIs[2] Operand 2
     /*  76427 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76438 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76440 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  76440 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76443 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76447 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76452 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76455 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76459 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76462 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76467 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76472 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  76475 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76477 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76480 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76484 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76488 */       GIR_RootConstrainSelectedInstOperands,
     /*  76489 */       // GIR_Coverage, 5378,
     /*  76489 */       GIR_EraseRootFromParent_Done,
     /*  76490 */     // Label 1328: @76490
     /*  76490 */     GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(76612), // Rule ID 5374 //
     /*  76495 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76499 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76503 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76507 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76511 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76515 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76519 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76523 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76527 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76531 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76535 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76539 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76544 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76549 */       // MIs[2] Operand 2
     /*  76549 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76560 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76562 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  76562 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76565 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76569 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76574 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76577 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76581 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76584 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76594 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  76597 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76599 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76602 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76606 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76610 */       GIR_RootConstrainSelectedInstOperands,
     /*  76611 */       // GIR_Coverage, 5374,
     /*  76611 */       GIR_EraseRootFromParent_Done,
     /*  76612 */     // Label 1329: @76612
     /*  76612 */     GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(76734), // Rule ID 5376 //
     /*  76617 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76621 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76625 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76629 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76633 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76637 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76641 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76645 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76649 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76653 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76657 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76661 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76666 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76671 */       // MIs[2] Operand 2
     /*  76671 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76682 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76684 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  76684 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76687 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76691 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76696 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76699 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76703 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  76719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76724 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76728 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76732 */       GIR_RootConstrainSelectedInstOperands,
     /*  76733 */       // GIR_Coverage, 5376,
     /*  76733 */       GIR_EraseRootFromParent_Done,
     /*  76734 */     // Label 1330: @76734
     /*  76734 */     GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(76836), // Rule ID 5524 //
     /*  76739 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76743 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76747 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76751 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76755 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76759 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76763 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76768 */       // MIs[2] Operand 2
     /*  76768 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76779 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76783 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76787 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76791 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  76795 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76799 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76803 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76808 */       // MIs[4] Operand 2
     /*  76808 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  76819 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76821 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  76821 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  76824 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76826 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  76830 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  76834 */       GIR_RootConstrainSelectedInstOperands,
     /*  76835 */       // GIR_Coverage, 5524,
     /*  76835 */       GIR_EraseRootFromParent_Done,
     /*  76836 */     // Label 1331: @76836
     /*  76836 */     GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(76965), // Rule ID 6262 //
     /*  76841 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76845 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76849 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  76853 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  76856 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  76861 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76865 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  76869 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76874 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  76878 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76880 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  76880 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  76883 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  76887 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76892 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  76895 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  76897 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76900 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76904 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76909 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76911 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76914 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76918 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76923 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76926 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  76930 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76933 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76938 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76943 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76948 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  76951 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76953 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76956 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  76960 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76963 */       GIR_RootConstrainSelectedInstOperands,
     /*  76964 */       // GIR_Coverage, 6262,
     /*  76964 */       GIR_EraseRootFromParent_Done,
     /*  76965 */     // Label 1332: @76965
     /*  76965 */     GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(77007), // Rule ID 5719 //
     /*  76970 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  76977 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  76984 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  76984 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76987 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76989 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  76994 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76997 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  77002 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  77005 */       GIR_RootConstrainSelectedInstOperands,
     /*  77006 */       // GIR_Coverage, 5719,
     /*  77006 */       GIR_EraseRootFromParent_Done,
     /*  77007 */     // Label 1333: @77007
     /*  77007 */     GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(77049), // Rule ID 5723 //
     /*  77012 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  77019 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  77026 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  77026 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  77029 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77031 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  77036 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77039 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  77044 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  77047 */       GIR_RootConstrainSelectedInstOperands,
     /*  77048 */       // GIR_Coverage, 5723,
     /*  77048 */       GIR_EraseRootFromParent_Done,
     /*  77049 */     // Label 1334: @77049
     /*  77049 */     GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(77172), // Rule ID 2569 //
     /*  77054 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77057 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77061 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77065 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77069 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77072 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  77077 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77081 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  77085 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77090 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  77094 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77098 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77102 */       // MIs[2] Operand 1
     /*  77102 */       // No operand predicates
     /*  77102 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77104 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  77104 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77107 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77111 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77116 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77118 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77121 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77125 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77130 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77133 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77137 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77140 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77145 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77150 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77155 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  77158 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77160 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77163 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77167 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  77170 */       GIR_RootConstrainSelectedInstOperands,
     /*  77171 */       // GIR_Coverage, 2569,
     /*  77171 */       GIR_EraseRootFromParent_Done,
     /*  77172 */     // Label 1335: @77172
     /*  77172 */     GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(77295), // Rule ID 6230 //
     /*  77177 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77180 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77188 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77192 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77196 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77200 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  77204 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77208 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77213 */       // MIs[2] imm
     /*  77213 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77217 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77221 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77225 */       // MIs[3] Operand 1
     /*  77225 */       // No operand predicates
     /*  77225 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77227 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  77227 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77230 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77234 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77239 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77241 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77244 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77248 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77253 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77256 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77260 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77263 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77268 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77273 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77278 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  77281 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77283 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77286 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77290 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  77293 */       GIR_RootConstrainSelectedInstOperands,
     /*  77294 */       // GIR_Coverage, 6230,
     /*  77294 */       GIR_EraseRootFromParent_Done,
     /*  77295 */     // Label 1336: @77295
     /*  77295 */     GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(77415), // Rule ID 6268 //
     /*  77300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77312 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77316 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77320 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  77324 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77328 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77333 */       // MIs[2] imm
     /*  77333 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77337 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77341 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77345 */       // MIs[3] Operand 1
     /*  77345 */       // No operand predicates
     /*  77345 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77347 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  77347 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77350 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77354 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77359 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77361 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77364 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77368 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77373 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77376 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77380 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77383 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77388 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77393 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77398 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  77401 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77403 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77406 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77410 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  77413 */       GIR_RootConstrainSelectedInstOperands,
     /*  77414 */       // GIR_Coverage, 6268,
     /*  77414 */       GIR_EraseRootFromParent_Done,
     /*  77415 */     // Label 1337: @77415
     /*  77415 */     GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(77532), // Rule ID 2492 //
     /*  77420 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77423 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77427 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77431 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77435 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77438 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  77443 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77447 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77451 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77456 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77461 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77463 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77463 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77466 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77470 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77475 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77477 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77480 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77484 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77489 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77492 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77496 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77499 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77504 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77509 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77514 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  77517 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77519 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77522 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77526 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77530 */       GIR_RootConstrainSelectedInstOperands,
     /*  77531 */       // GIR_Coverage, 2492,
     /*  77531 */       GIR_EraseRootFromParent_Done,
     /*  77532 */     // Label 1338: @77532
     /*  77532 */     GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(77649), // Rule ID 5294 //
     /*  77537 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77540 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77544 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77548 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77552 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77555 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  77560 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77564 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77568 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77573 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77578 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77580 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77580 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77583 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77587 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77592 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77594 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77597 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77601 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77606 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77609 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77613 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77616 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77621 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77626 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77631 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  77634 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77636 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77639 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77643 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77647 */       GIR_RootConstrainSelectedInstOperands,
     /*  77648 */       // GIR_Coverage, 5294,
     /*  77648 */       GIR_EraseRootFromParent_Done,
     /*  77649 */     // Label 1339: @77649
     /*  77649 */     GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(77766), // Rule ID 5297 //
     /*  77654 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77657 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77661 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77665 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77669 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77672 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  77677 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77681 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77685 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77695 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77697 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77697 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77700 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77704 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77709 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77711 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77714 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77718 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77723 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77726 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77730 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77733 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77738 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  77751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77753 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77756 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77760 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77764 */       GIR_RootConstrainSelectedInstOperands,
     /*  77765 */       // GIR_Coverage, 5297,
     /*  77765 */       GIR_EraseRootFromParent_Done,
     /*  77766 */     // Label 1340: @77766
     /*  77766 */     GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(77883), // Rule ID 5300 //
     /*  77771 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77774 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77778 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77782 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77786 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77789 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  77794 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77798 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77802 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77807 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77814 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77814 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77817 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77821 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77826 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77828 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77831 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77835 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77840 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77843 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77847 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77850 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77855 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77860 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77865 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  77868 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77870 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77873 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77877 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77881 */       GIR_RootConstrainSelectedInstOperands,
     /*  77882 */       // GIR_Coverage, 5300,
     /*  77882 */       GIR_EraseRootFromParent_Done,
     /*  77883 */     // Label 1341: @77883
     /*  77883 */     GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(77987), // Rule ID 2488 //
     /*  77888 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77891 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77895 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77899 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77903 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  77906 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  77911 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77915 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77920 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77922 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  77922 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77925 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77929 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77934 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77936 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77939 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77943 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77948 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77951 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77955 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77958 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77963 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77968 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  77976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77978 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77981 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77985 */       GIR_RootConstrainSelectedInstOperands,
     /*  77986 */       // GIR_Coverage, 2488,
     /*  77986 */       GIR_EraseRootFromParent_Done,
     /*  77987 */     // Label 1342: @77987
     /*  77987 */     GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(78043), // Rule ID 5457 //
     /*  77992 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77996 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78000 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78004 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78009 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78013 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78017 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78021 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78026 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78028 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  78028 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  78031 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  78033 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  78037 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  78041 */       GIR_RootConstrainSelectedInstOperands,
     /*  78042 */       // GIR_Coverage, 5457,
     /*  78042 */       GIR_EraseRootFromParent_Done,
     /*  78043 */     // Label 1343: @78043
     /*  78043 */     GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(78109), // Rule ID 5717 //
     /*  78048 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78052 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78056 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78062 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78064 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78066 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  78066 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78069 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78073 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78078 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78082 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78084 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78087 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78089 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78092 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78095 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78098 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78103 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78108 */       // GIR_Coverage, 5717,
     /*  78108 */       GIR_EraseRootFromParent_Done,
     /*  78109 */     // Label 1344: @78109
     /*  78109 */     GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(78175), // Rule ID 5721 //
     /*  78114 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78118 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78122 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78128 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78130 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78132 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  78132 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78135 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78139 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78144 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78148 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78150 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78153 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78155 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78158 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78161 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78164 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78169 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78174 */       // GIR_Coverage, 5721,
     /*  78174 */       GIR_EraseRootFromParent_Done,
     /*  78175 */     // Label 1345: @78175
     /*  78175 */     GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(78268), // Rule ID 4865 //
     /*  78180 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78188 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  78192 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78196 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78201 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78203 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  78203 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78206 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78210 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78215 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78217 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78220 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78224 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78229 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78232 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78236 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78239 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78244 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78249 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78254 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  78257 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78259 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78262 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  78266 */       GIR_RootConstrainSelectedInstOperands,
     /*  78267 */       // GIR_Coverage, 4865,
     /*  78267 */       GIR_EraseRootFromParent_Done,
     /*  78268 */     // Label 1346: @78268
     /*  78268 */     GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(78364), // Rule ID 4912 //
     /*  78273 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  78276 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78280 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78284 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78288 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78292 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78297 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78299 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  78299 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78302 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78306 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78311 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78313 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78316 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78320 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78325 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78328 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78332 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78335 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78340 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78345 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78350 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  78353 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78355 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78358 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  78362 */       GIR_RootConstrainSelectedInstOperands,
     /*  78363 */       // GIR_Coverage, 4912,
     /*  78363 */       GIR_EraseRootFromParent_Done,
     /*  78364 */     // Label 1347: @78364
     /*  78364 */     GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(78426), // Rule ID 5718 //
     /*  78369 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78373 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78377 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78381 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78383 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  78383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78395 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78397 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78400 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78402 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78405 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78407 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78410 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78415 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78420 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78425 */       // GIR_Coverage, 5718,
     /*  78425 */       GIR_EraseRootFromParent_Done,
     /*  78426 */     // Label 1348: @78426
     /*  78426 */     GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(78488), // Rule ID 5722 //
     /*  78431 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78435 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78439 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78443 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78445 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  78445 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78448 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78452 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78457 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78464 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78467 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78469 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78472 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78477 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78482 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78487 */       // GIR_Coverage, 5722,
     /*  78487 */       GIR_EraseRootFromParent_Done,
     /*  78488 */     // Label 1349: @78488
     /*  78488 */     GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(78622), // Rule ID 5716 //
     /*  78493 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78497 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78501 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78501 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78504 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78508 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78513 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78515 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78518 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78522 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78527 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78530 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78534 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78537 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78542 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78547 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78552 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78555 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78559 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78564 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78566 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78569 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78573 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78578 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78581 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78585 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78588 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78593 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78598 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78603 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  78606 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78608 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78611 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  78614 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  78617 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78620 */       GIR_RootConstrainSelectedInstOperands,
     /*  78621 */       // GIR_Coverage, 5716,
     /*  78621 */       GIR_EraseRootFromParent_Done,
     /*  78622 */     // Label 1350: @78622
     /*  78622 */     GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(78756), // Rule ID 5720 //
     /*  78627 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78631 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78635 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78635 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78638 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78642 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78647 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78649 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78652 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78656 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78661 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78664 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78668 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78671 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78676 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78681 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78686 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78689 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78693 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78698 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78700 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78703 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78707 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78712 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78715 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78719 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78722 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78727 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78732 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78737 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  78740 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78742 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78745 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  78748 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  78751 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78754 */       GIR_RootConstrainSelectedInstOperands,
     /*  78755 */       // GIR_Coverage, 5720,
     /*  78755 */       GIR_EraseRootFromParent_Done,
     /*  78756 */     // Label 1351: @78756
     /*  78756 */     GIM_Reject,
     /*  78757 */   // Label 1327: @78757
     /*  78757 */   GIM_Reject,
     /*  78758 */   // Label 1310: @78758
     /*  78758 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(81166),
     /*  78763 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  78766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  78769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78773 */     GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(78902), // Rule ID 5372 //
     /*  78778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78790 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78794 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78798 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  78802 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78806 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78810 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78814 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78818 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78822 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78827 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78831 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78837 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78839 */       // MIs[2] Operand 2
     /*  78839 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  78850 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78852 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  78852 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78855 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78859 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78864 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  78867 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78871 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78874 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78879 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78884 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  78887 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78889 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78892 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  78896 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  78900 */       GIR_RootConstrainSelectedInstOperands,
     /*  78901 */       // GIR_Coverage, 5372,
     /*  78901 */       GIR_EraseRootFromParent_Done,
     /*  78902 */     // Label 1353: @78902
     /*  78902 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(79024), // Rule ID 5368 //
     /*  78907 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78911 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78915 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78919 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78923 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78927 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  78931 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78935 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78939 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78943 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78947 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78951 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78956 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78961 */       // MIs[2] Operand 2
     /*  78961 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  78972 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78974 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  78974 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78977 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78981 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78986 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  78989 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78993 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78996 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79001 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79006 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  79009 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79011 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79014 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79018 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79022 */       GIR_RootConstrainSelectedInstOperands,
     /*  79023 */       // GIR_Coverage, 5368,
     /*  79023 */       GIR_EraseRootFromParent_Done,
     /*  79024 */     // Label 1354: @79024
     /*  79024 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(79146), // Rule ID 5370 //
     /*  79029 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79033 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79037 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79041 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79045 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79049 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79053 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79057 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79061 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  79065 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79069 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79073 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79078 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79083 */       // MIs[2] Operand 2
     /*  79083 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  79094 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79096 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79096 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79099 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79103 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79108 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  79111 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79115 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79118 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79123 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79128 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  79131 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79133 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79136 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79140 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79144 */       GIR_RootConstrainSelectedInstOperands,
     /*  79145 */       // GIR_Coverage, 5370,
     /*  79145 */       GIR_EraseRootFromParent_Done,
     /*  79146 */     // Label 1355: @79146
     /*  79146 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(79248), // Rule ID 5523 //
     /*  79151 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79155 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79159 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79163 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79167 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79171 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79175 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79180 */       // MIs[2] Operand 2
     /*  79180 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  79191 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  79195 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79199 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79203 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  79207 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79211 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79215 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79220 */       // MIs[4] Operand 2
     /*  79220 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  79231 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79233 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  79233 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  79236 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  79238 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  79242 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  79246 */       GIR_RootConstrainSelectedInstOperands,
     /*  79247 */       // GIR_Coverage, 5523,
     /*  79247 */       GIR_EraseRootFromParent_Done,
     /*  79248 */     // Label 1356: @79248
     /*  79248 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(79377), // Rule ID 6261 //
     /*  79253 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79257 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79261 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79265 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79268 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79273 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79277 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79281 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79286 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  79290 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79292 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  79292 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  79295 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  79299 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79304 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  79307 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  79309 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79312 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79316 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79321 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79323 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79326 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79330 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79335 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79338 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  79342 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79345 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79350 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79355 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79360 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  79363 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79365 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79368 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  79372 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79375 */       GIR_RootConstrainSelectedInstOperands,
     /*  79376 */       // GIR_Coverage, 6261,
     /*  79376 */       GIR_EraseRootFromParent_Done,
     /*  79377 */     // Label 1357: @79377
     /*  79377 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(79419), // Rule ID 5727 //
     /*  79382 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  79389 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  79396 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  79396 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79399 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79401 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79406 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79409 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79414 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79417 */       GIR_RootConstrainSelectedInstOperands,
     /*  79418 */       // GIR_Coverage, 5727,
     /*  79418 */       GIR_EraseRootFromParent_Done,
     /*  79419 */     // Label 1358: @79419
     /*  79419 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(79461), // Rule ID 5731 //
     /*  79424 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  79431 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  79438 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  79438 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79441 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79443 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79448 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79451 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79456 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79459 */       GIR_RootConstrainSelectedInstOperands,
     /*  79460 */       // GIR_Coverage, 5731,
     /*  79460 */       GIR_EraseRootFromParent_Done,
     /*  79461 */     // Label 1359: @79461
     /*  79461 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(79584), // Rule ID 2567 //
     /*  79466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79469 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79473 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79477 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79481 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79484 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79489 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79493 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79497 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79502 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  79506 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79510 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79514 */       // MIs[2] Operand 1
     /*  79514 */       // No operand predicates
     /*  79514 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79516 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79516 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79519 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79523 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79528 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79530 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79533 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79537 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79542 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79545 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79549 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79552 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79557 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79562 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79567 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  79570 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79572 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79575 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79579 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  79582 */       GIR_RootConstrainSelectedInstOperands,
     /*  79583 */       // GIR_Coverage, 2567,
     /*  79583 */       GIR_EraseRootFromParent_Done,
     /*  79584 */     // Label 1360: @79584
     /*  79584 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(79707), // Rule ID 6229 //
     /*  79589 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79592 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79596 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79600 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79604 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79608 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79612 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  79616 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79620 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79625 */       // MIs[2] imm
     /*  79625 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79629 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79633 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79637 */       // MIs[3] Operand 1
     /*  79637 */       // No operand predicates
     /*  79637 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79639 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79639 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79642 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79646 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79651 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79653 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79656 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79660 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79665 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79668 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79672 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79675 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79680 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79685 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79690 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  79693 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79695 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79698 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  79702 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  79705 */       GIR_RootConstrainSelectedInstOperands,
     /*  79706 */       // GIR_Coverage, 6229,
     /*  79706 */       GIR_EraseRootFromParent_Done,
     /*  79707 */     // Label 1361: @79707
     /*  79707 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(79827), // Rule ID 6267 //
     /*  79712 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79716 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79720 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79724 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79728 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79732 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79736 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79740 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79745 */       // MIs[2] imm
     /*  79745 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79749 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79753 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79757 */       // MIs[3] Operand 1
     /*  79757 */       // No operand predicates
     /*  79757 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79759 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79759 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79762 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79766 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79771 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79773 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79776 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79780 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79785 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79788 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79792 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79795 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79805 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79810 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  79813 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79815 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79818 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  79822 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  79825 */       GIR_RootConstrainSelectedInstOperands,
     /*  79826 */       // GIR_Coverage, 6267,
     /*  79826 */       GIR_EraseRootFromParent_Done,
     /*  79827 */     // Label 1362: @79827
     /*  79827 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(79944), // Rule ID 2491 //
     /*  79832 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79835 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79839 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79843 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79847 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79850 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  79855 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79859 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79863 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79868 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79873 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79875 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79875 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79878 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79882 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79887 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79889 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79892 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79896 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79901 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79904 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79908 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79911 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79916 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79926 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  79929 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79931 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79934 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79938 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  79942 */       GIR_RootConstrainSelectedInstOperands,
     /*  79943 */       // GIR_Coverage, 2491,
     /*  79943 */       GIR_EraseRootFromParent_Done,
     /*  79944 */     // Label 1363: @79944
     /*  79944 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80061), // Rule ID 5293 //
     /*  79949 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79952 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79956 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79960 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79964 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79967 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  79972 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79976 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79980 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79985 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79990 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79992 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79992 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79995 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79999 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80004 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80006 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80009 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80013 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80018 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80021 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80025 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80028 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80033 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80043 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  80046 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80048 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80051 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80055 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80059 */       GIR_RootConstrainSelectedInstOperands,
     /*  80060 */       // GIR_Coverage, 5293,
     /*  80060 */       GIR_EraseRootFromParent_Done,
     /*  80061 */     // Label 1364: @80061
     /*  80061 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80178), // Rule ID 5296 //
     /*  80066 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80081 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80084 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  80089 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80093 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80097 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80102 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80107 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80109 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  80109 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80112 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80116 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80121 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80123 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80126 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80130 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80135 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80138 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80142 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80145 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80150 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80155 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80160 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  80163 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80165 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80168 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80172 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80176 */       GIR_RootConstrainSelectedInstOperands,
     /*  80177 */       // GIR_Coverage, 5296,
     /*  80177 */       GIR_EraseRootFromParent_Done,
     /*  80178 */     // Label 1365: @80178
     /*  80178 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(80295), // Rule ID 5299 //
     /*  80183 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80186 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80190 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80194 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80198 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80201 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  80206 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80210 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80214 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80219 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80224 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80226 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  80226 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80229 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80233 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80238 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80240 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80243 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80247 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80252 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80255 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80259 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80262 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80267 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80272 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  80280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80285 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80289 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80293 */       GIR_RootConstrainSelectedInstOperands,
     /*  80294 */       // GIR_Coverage, 5299,
     /*  80294 */       GIR_EraseRootFromParent_Done,
     /*  80295 */     // Label 1366: @80295
     /*  80295 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80396), // Rule ID 4859 //
     /*  80300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80312 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  80315 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  80320 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80324 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80329 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80331 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  80331 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80334 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80338 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80343 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80357 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80360 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80364 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  80385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80387 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80394 */       GIR_RootConstrainSelectedInstOperands,
     /*  80395 */       // GIR_Coverage, 4859,
     /*  80395 */       GIR_EraseRootFromParent_Done,
     /*  80396 */     // Label 1367: @80396
     /*  80396 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80452), // Rule ID 5448 //
     /*  80401 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80405 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80409 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80418 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80422 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80426 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80430 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80435 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80437 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  80437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  80440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80442 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  80446 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  80450 */       GIR_RootConstrainSelectedInstOperands,
     /*  80451 */       // GIR_Coverage, 5448,
     /*  80451 */       GIR_EraseRootFromParent_Done,
     /*  80452 */     // Label 1368: @80452
     /*  80452 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(80518), // Rule ID 5725 //
     /*  80457 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80461 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80465 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80471 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80473 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80475 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  80475 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80478 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80482 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80487 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80491 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80493 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80496 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80504 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80517 */       // GIR_Coverage, 5725,
     /*  80517 */       GIR_EraseRootFromParent_Done,
     /*  80518 */     // Label 1369: @80518
     /*  80518 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(80584), // Rule ID 5729 //
     /*  80523 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80527 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80531 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80537 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80539 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80541 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  80541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80557 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80564 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80570 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80573 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80578 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80583 */       // GIR_Coverage, 5729,
     /*  80583 */       GIR_EraseRootFromParent_Done,
     /*  80584 */     // Label 1370: @80584
     /*  80584 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(80677), // Rule ID 4867 //
     /*  80589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  80601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80605 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80610 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80612 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  80612 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80615 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80619 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80624 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80638 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80645 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80658 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80663 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  80666 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80668 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80671 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  80675 */       GIR_RootConstrainSelectedInstOperands,
     /*  80676 */       // GIR_Coverage, 4867,
     /*  80676 */       GIR_EraseRootFromParent_Done,
     /*  80677 */     // Label 1371: @80677
     /*  80677 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(80773), // Rule ID 4911 //
     /*  80682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80685 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80689 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80693 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80697 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80701 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80706 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80708 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  80708 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80711 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80715 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80720 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80734 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80737 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80741 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  80762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80764 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80767 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  80771 */       GIR_RootConstrainSelectedInstOperands,
     /*  80772 */       // GIR_Coverage, 4911,
     /*  80772 */       GIR_EraseRootFromParent_Done,
     /*  80773 */     // Label 1372: @80773
     /*  80773 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(80835), // Rule ID 5726 //
     /*  80778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80790 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80792 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  80792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  80795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80804 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80811 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80814 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80816 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80819 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80824 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80829 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80834 */       // GIR_Coverage, 5726,
     /*  80834 */       GIR_EraseRootFromParent_Done,
     /*  80835 */     // Label 1373: @80835
     /*  80835 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(80897), // Rule ID 5730 //
     /*  80840 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80844 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80848 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80852 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80854 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  80854 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  80857 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80861 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80866 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80876 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80878 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80881 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80886 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80891 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80896 */       // GIR_Coverage, 5730,
     /*  80896 */       GIR_EraseRootFromParent_Done,
     /*  80897 */     // Label 1374: @80897
     /*  80897 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(81031), // Rule ID 5724 //
     /*  80902 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80906 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80910 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80910 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80913 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80917 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80922 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80924 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80927 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80931 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80936 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80939 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80943 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80946 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80951 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80956 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80961 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80964 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80968 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80973 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80975 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80978 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80982 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80987 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80990 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80994 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80997 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81002 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81017 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81020 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81023 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81026 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81029 */       GIR_RootConstrainSelectedInstOperands,
     /*  81030 */       // GIR_Coverage, 5724,
     /*  81030 */       GIR_EraseRootFromParent_Done,
     /*  81031 */     // Label 1375: @81031
     /*  81031 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(81165), // Rule ID 5728 //
     /*  81036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81040 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81044 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  81044 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  81047 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81051 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81056 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  81058 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  81061 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81065 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81070 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  81073 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  81077 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  81080 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81085 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81090 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81095 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81098 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81102 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81109 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81112 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81116 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81121 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81128 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81136 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81157 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81160 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81163 */       GIR_RootConstrainSelectedInstOperands,
     /*  81164 */       // GIR_Coverage, 5728,
     /*  81164 */       GIR_EraseRootFromParent_Done,
     /*  81165 */     // Label 1376: @81165
     /*  81165 */     GIM_Reject,
     /*  81166 */   // Label 1352: @81166
     /*  81166 */   GIM_Reject,
     /*  81167 */   // Label 1311: @81167
     /*  81167 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(83077),
     /*  81172 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  81175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81182 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81311), // Rule ID 5366 //
     /*  81187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81199 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81203 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81207 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81211 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81215 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81219 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81223 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81227 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81231 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81236 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81240 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81246 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81248 */       // MIs[2] Operand 2
     /*  81248 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81259 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81261 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  81261 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81264 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81268 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81273 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81280 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  81296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81309 */       GIR_RootConstrainSelectedInstOperands,
     /*  81310 */       // GIR_Coverage, 5366,
     /*  81310 */       GIR_EraseRootFromParent_Done,
     /*  81311 */     // Label 1378: @81311
     /*  81311 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(81433), // Rule ID 5362 //
     /*  81316 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81324 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81328 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81332 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81336 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81340 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81344 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81348 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  81352 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81356 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81360 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81365 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81370 */       // MIs[2] Operand 2
     /*  81370 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81381 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81383 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  81383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81395 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81398 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81402 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  81418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81423 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81427 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81431 */       GIR_RootConstrainSelectedInstOperands,
     /*  81432 */       // GIR_Coverage, 5362,
     /*  81432 */       GIR_EraseRootFromParent_Done,
     /*  81433 */     // Label 1379: @81433
     /*  81433 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(81555), // Rule ID 5364 //
     /*  81438 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81442 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81446 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81450 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81454 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81458 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81462 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81466 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81470 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  81474 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81478 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81482 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81487 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81492 */       // MIs[2] Operand 2
     /*  81492 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81503 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81505 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  81505 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81508 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81512 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81517 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81520 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81524 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  81540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81549 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81553 */       GIR_RootConstrainSelectedInstOperands,
     /*  81554 */       // GIR_Coverage, 5364,
     /*  81554 */       GIR_EraseRootFromParent_Done,
     /*  81555 */     // Label 1380: @81555
     /*  81555 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(81657), // Rule ID 5522 //
     /*  81560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81568 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81572 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81576 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81580 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81584 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81589 */       // MIs[2] Operand 2
     /*  81589 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81600 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  81604 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81608 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81612 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  81616 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81620 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81624 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81629 */       // MIs[4] Operand 2
     /*  81629 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  81640 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81642 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  81642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  81645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81647 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  81651 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  81655 */       GIR_RootConstrainSelectedInstOperands,
     /*  81656 */       // GIR_Coverage, 5522,
     /*  81656 */       GIR_EraseRootFromParent_Done,
     /*  81657 */     // Label 1381: @81657
     /*  81657 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(81786), // Rule ID 6260 //
     /*  81662 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81666 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81670 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81674 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81677 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81682 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81686 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81695 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  81699 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81701 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  81701 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  81704 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  81708 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81713 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  81716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  81718 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81721 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81725 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81730 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81732 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81735 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81739 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81744 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81747 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  81751 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  81772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81777 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  81781 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81784 */       GIR_RootConstrainSelectedInstOperands,
     /*  81785 */       // GIR_Coverage, 6260,
     /*  81785 */       GIR_EraseRootFromParent_Done,
     /*  81786 */     // Label 1382: @81786
     /*  81786 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(81828), // Rule ID 5735 //
     /*  81791 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  81798 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  81805 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  81805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81810 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81815 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81818 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81823 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81826 */       GIR_RootConstrainSelectedInstOperands,
     /*  81827 */       // GIR_Coverage, 5735,
     /*  81827 */       GIR_EraseRootFromParent_Done,
     /*  81828 */     // Label 1383: @81828
     /*  81828 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(81951), // Rule ID 2565 //
     /*  81833 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81836 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81840 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81844 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81848 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81851 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81856 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81860 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81864 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81869 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  81873 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81877 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  81881 */       // MIs[2] Operand 1
     /*  81881 */       // No operand predicates
     /*  81881 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81883 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  81883 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81886 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81890 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81895 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81897 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81900 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81904 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81909 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81912 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81916 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81919 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81924 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81929 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81934 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  81937 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81939 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81942 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81946 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  81949 */       GIR_RootConstrainSelectedInstOperands,
     /*  81950 */       // GIR_Coverage, 2565,
     /*  81950 */       GIR_EraseRootFromParent_Done,
     /*  81951 */     // Label 1384: @81951
     /*  81951 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82074), // Rule ID 6228 //
     /*  81956 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81959 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81963 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81967 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81971 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81975 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81979 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  81983 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81987 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81992 */       // MIs[2] imm
     /*  81992 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81996 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82000 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  82004 */       // MIs[3] Operand 1
     /*  82004 */       // No operand predicates
     /*  82004 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82006 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  82006 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82009 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82013 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82018 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82020 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82023 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82027 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82032 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82035 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82039 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82042 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82047 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82052 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  82060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82062 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82065 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82069 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82072 */       GIR_RootConstrainSelectedInstOperands,
     /*  82073 */       // GIR_Coverage, 6228,
     /*  82073 */       GIR_EraseRootFromParent_Done,
     /*  82074 */     // Label 1385: @82074
     /*  82074 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82194), // Rule ID 6266 //
     /*  82079 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82083 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82087 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82091 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82095 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82099 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82103 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82107 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82112 */       // MIs[2] imm
     /*  82112 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82116 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82120 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  82124 */       // MIs[3] Operand 1
     /*  82124 */       // No operand predicates
     /*  82124 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82126 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  82126 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82129 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82133 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82138 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82140 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82143 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82147 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82152 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82155 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82159 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82162 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82167 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82177 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  82180 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82182 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82185 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82189 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82192 */       GIR_RootConstrainSelectedInstOperands,
     /*  82193 */       // GIR_Coverage, 6266,
     /*  82193 */       GIR_EraseRootFromParent_Done,
     /*  82194 */     // Label 1386: @82194
     /*  82194 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82311), // Rule ID 2490 //
     /*  82199 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82202 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82206 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82210 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82214 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82217 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  82222 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82226 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82230 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82235 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82240 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82242 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82242 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82245 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82249 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82254 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82256 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82259 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82263 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82268 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82271 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82275 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82278 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  82296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82309 */       GIR_RootConstrainSelectedInstOperands,
     /*  82310 */       // GIR_Coverage, 2490,
     /*  82310 */       GIR_EraseRootFromParent_Done,
     /*  82311 */     // Label 1387: @82311
     /*  82311 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82428), // Rule ID 5292 //
     /*  82316 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82319 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82323 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82327 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82331 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82334 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  82339 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82343 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82347 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82352 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82357 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82359 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82359 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82362 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82366 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82371 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82373 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82376 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82380 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82385 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82388 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82392 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82395 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82400 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82410 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  82413 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82415 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82418 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82422 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82426 */       GIR_RootConstrainSelectedInstOperands,
     /*  82427 */       // GIR_Coverage, 5292,
     /*  82427 */       GIR_EraseRootFromParent_Done,
     /*  82428 */     // Label 1388: @82428
     /*  82428 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(82545), // Rule ID 5295 //
     /*  82433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82436 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82440 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82444 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82448 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82451 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  82456 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82460 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82464 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82469 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82474 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82476 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82476 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82479 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82483 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82488 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82490 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82493 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82497 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82502 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82505 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82509 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82512 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82517 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82522 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82527 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  82530 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82532 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82535 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82539 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82543 */       GIR_RootConstrainSelectedInstOperands,
     /*  82544 */       // GIR_Coverage, 5295,
     /*  82544 */       GIR_EraseRootFromParent_Done,
     /*  82545 */     // Label 1389: @82545
     /*  82545 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(82662), // Rule ID 5298 //
     /*  82550 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82553 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82557 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82561 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82565 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82568 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  82573 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82577 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82581 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82586 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82591 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82593 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82593 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82596 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82600 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82607 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82610 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82614 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82619 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82622 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82626 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82629 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82634 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82639 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  82647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82649 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82652 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82656 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82660 */       GIR_RootConstrainSelectedInstOperands,
     /*  82661 */       // GIR_Coverage, 5298,
     /*  82661 */       GIR_EraseRootFromParent_Done,
     /*  82662 */     // Label 1390: @82662
     /*  82662 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(82718), // Rule ID 5439 //
     /*  82667 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82671 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82675 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82679 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82684 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82688 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82692 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82696 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82701 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82703 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  82703 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  82706 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82708 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  82712 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  82716 */       GIR_RootConstrainSelectedInstOperands,
     /*  82717 */       // GIR_Coverage, 5439,
     /*  82717 */       GIR_EraseRootFromParent_Done,
     /*  82718 */     // Label 1391: @82718
     /*  82718 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(82784), // Rule ID 5733 //
     /*  82723 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82727 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82731 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82737 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82739 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82741 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  82741 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82744 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82748 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82753 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82757 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82764 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82767 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82770 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82773 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82778 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82783 */       // GIR_Coverage, 5733,
     /*  82783 */       GIR_EraseRootFromParent_Done,
     /*  82784 */     // Label 1392: @82784
     /*  82784 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(82880), // Rule ID 4910 //
     /*  82789 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82792 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82796 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82800 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82804 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82808 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82813 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82815 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  82815 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82818 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82822 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82827 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82829 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82832 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82836 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82841 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82844 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82848 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82851 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82856 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82861 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82866 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  82869 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82871 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82874 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82878 */       GIR_RootConstrainSelectedInstOperands,
     /*  82879 */       // GIR_Coverage, 4910,
     /*  82879 */       GIR_EraseRootFromParent_Done,
     /*  82880 */     // Label 1393: @82880
     /*  82880 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(82942), // Rule ID 5734 //
     /*  82885 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82889 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82893 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82897 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82899 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  82899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  82902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82911 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82913 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82916 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82918 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82921 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82923 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82926 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82931 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82936 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82941 */       // GIR_Coverage, 5734,
     /*  82941 */       GIR_EraseRootFromParent_Done,
     /*  82942 */     // Label 1394: @82942
     /*  82942 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83076), // Rule ID 5732 //
     /*  82947 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82951 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82955 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82955 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82958 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82962 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82967 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82969 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82972 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82976 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82981 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82984 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82988 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82991 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82996 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83001 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83006 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83009 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83013 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83018 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83020 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83023 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83027 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83032 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83035 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83039 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83042 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83047 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83052 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83062 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83065 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83068 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83071 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83074 */       GIR_RootConstrainSelectedInstOperands,
     /*  83075 */       // GIR_Coverage, 5732,
     /*  83075 */       GIR_EraseRootFromParent_Done,
     /*  83076 */     // Label 1395: @83076
     /*  83076 */     GIM_Reject,
     /*  83077 */   // Label 1377: @83077
     /*  83077 */   GIM_Reject,
     /*  83078 */   // Label 1312: @83078
     /*  83078 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83103), // Rule ID 8968 //
     /*  83083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83086 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  83089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  83092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83096 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  83096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  83101 */     GIR_RootConstrainSelectedInstOperands,
     /*  83102 */     // GIR_Coverage, 8968,
     /*  83102 */     GIR_Done,
     /*  83103 */   // Label 1396: @83103
     /*  83103 */   GIM_Reject,
     /*  83104 */   // Label 1313: @83104
     /*  83104 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83129), // Rule ID 8969 //
     /*  83109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83112 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  83115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  83118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83122 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  83122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  83127 */     GIR_RootConstrainSelectedInstOperands,
     /*  83128 */     // GIR_Coverage, 8969,
     /*  83128 */     GIR_Done,
     /*  83129 */   // Label 1397: @83129
     /*  83129 */   GIM_Reject,
     /*  83130 */   // Label 1314: @83130
     /*  83130 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83155), // Rule ID 8972 //
     /*  83135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83138 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  83141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  83144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83148 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  83148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  83153 */     GIR_RootConstrainSelectedInstOperands,
     /*  83154 */     // GIR_Coverage, 8972,
     /*  83154 */     GIR_Done,
     /*  83155 */   // Label 1398: @83155
     /*  83155 */   GIM_Reject,
     /*  83156 */   // Label 1315: @83156
     /*  83156 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(83181), // Rule ID 8974 //
     /*  83161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83164 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  83167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  83170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83174 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  83174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  83179 */     GIR_RootConstrainSelectedInstOperands,
     /*  83180 */     // GIR_Coverage, 8974,
     /*  83180 */     GIR_Done,
     /*  83181 */   // Label 1399: @83181
     /*  83181 */   GIM_Reject,
     /*  83182 */   // Label 1316: @83182
     /*  83182 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(83207), // Rule ID 8970 //
     /*  83187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83190 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  83193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  83196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83200 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  83200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  83205 */     GIR_RootConstrainSelectedInstOperands,
     /*  83206 */     // GIR_Coverage, 8970,
     /*  83206 */     GIR_Done,
     /*  83207 */   // Label 1400: @83207
     /*  83207 */   GIM_Reject,
     /*  83208 */   // Label 1317: @83208
     /*  83208 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(83233), // Rule ID 8973 //
     /*  83213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83216 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  83219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  83222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83226 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  83226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  83231 */     GIR_RootConstrainSelectedInstOperands,
     /*  83232 */     // GIR_Coverage, 8973,
     /*  83232 */     GIR_Done,
     /*  83233 */   // Label 1401: @83233
     /*  83233 */   GIM_Reject,
     /*  83234 */   // Label 1318: @83234
     /*  83234 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(83259), // Rule ID 8971 //
     /*  83239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83242 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  83245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  83248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83252 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  83252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  83257 */     GIR_RootConstrainSelectedInstOperands,
     /*  83258 */     // GIR_Coverage, 8971,
     /*  83258 */     GIR_Done,
     /*  83259 */   // Label 1402: @83259
     /*  83259 */   GIM_Reject,
     /*  83260 */   // Label 1319: @83260
     /*  83260 */   GIM_Reject,
     /*  83261 */ // Label 1307: @83261
     /*  83261 */ GIM_Reject,
     /*  83262 */ // Label 9: @83262
     /*  83262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1417*/ GIMT_Encode4(93205),
     /*  83273 */ /*GILLT_s32*//*Label 1403*/ GIMT_Encode4(83361),
     /*  83277 */ /*GILLT_s64*//*Label 1404*/ GIMT_Encode4(83742),
     /*  83281 */ /*GILLT_s128*//*Label 1405*/ GIMT_Encode4(85717),
     /*  83285 */ /*GILLT_v2s32*//*Label 1406*/ GIMT_Encode4(86363),
     /*  83289 */ /*GILLT_v2s64*//*Label 1407*/ GIMT_Encode4(87278),
     /*  83293 */ /*GILLT_v4s16*//*Label 1408*/ GIMT_Encode4(88047),
     /*  83297 */ /*GILLT_v4s32*//*Label 1409*/ GIMT_Encode4(88962),
     /*  83301 */ /*GILLT_v8s8*//*Label 1410*/ GIMT_Encode4(89807),
     /*  83305 */ /*GILLT_v8s16*//*Label 1411*/ GIMT_Encode4(90368),
     /*  83309 */ /*GILLT_v16s8*//*Label 1412*/ GIMT_Encode4(91213), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  83329 */ /*GILLT_nxv2s64*//*Label 1413*/ GIMT_Encode4(91665), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  83341 */ /*GILLT_nxv4s32*//*Label 1414*/ GIMT_Encode4(92114), GIMT_Encode4(0),
     /*  83349 */ /*GILLT_nxv8s16*//*Label 1415*/ GIMT_Encode4(92563), GIMT_Encode4(0),
     /*  83357 */ /*GILLT_nxv16s8*//*Label 1416*/ GIMT_Encode4(93012),
     /*  83361 */ // Label 1403: @83361
     /*  83361 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(83741),
     /*  83366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  83369 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(83439), // Rule ID 6979 //
     /*  83374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83386 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83389 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83396 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83399 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  83412 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15730>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  83412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  83415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83437 */     GIR_RootConstrainSelectedInstOperands,
     /*  83438 */     // GIR_Coverage, 6979,
     /*  83438 */     GIR_EraseRootFromParent_Done,
     /*  83439 */   // Label 1419: @83439
     /*  83439 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(83509), // Rule ID 6980 //
     /*  83444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83456 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83459 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83466 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  83482 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15730>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  83482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  83485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83507 */     GIR_RootConstrainSelectedInstOperands,
     /*  83508 */     // GIR_Coverage, 6980,
     /*  83508 */     GIR_EraseRootFromParent_Done,
     /*  83509 */   // Label 1420: @83509
     /*  83509 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(83574), // Rule ID 6981 //
     /*  83514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83526 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83529 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83536 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  83552 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15730>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  83552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  83555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83572 */     GIR_RootConstrainSelectedInstOperands,
     /*  83573 */     // GIR_Coverage, 6981,
     /*  83573 */     GIR_EraseRootFromParent_Done,
     /*  83574 */   // Label 1421: @83574
     /*  83574 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(83639), // Rule ID 6982 //
     /*  83579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83591 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83594 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83601 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  83617 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15730>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  83617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  83620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83637 */     GIR_RootConstrainSelectedInstOperands,
     /*  83638 */     // GIR_Coverage, 6982,
     /*  83638 */     GIR_EraseRootFromParent_Done,
     /*  83639 */   // Label 1422: @83639
     /*  83639 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(83692), // Rule ID 5699 //
     /*  83644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  83656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  83664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  83668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83670 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  83670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83675 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  83681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83691 */     // GIR_Coverage, 5699,
     /*  83691 */     GIR_EraseRootFromParent_Done,
     /*  83692 */   // Label 1423: @83692
     /*  83692 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(83716), // Rule ID 6592 //
     /*  83697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83705 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  83705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83715 */     // GIR_Coverage, 6592,
     /*  83715 */     GIR_Done,
     /*  83716 */   // Label 1424: @83716
     /*  83716 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(83740), // Rule ID 6593 //
     /*  83721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83729 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  83729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83739 */     // GIR_Coverage, 6593,
     /*  83739 */     GIR_Done,
     /*  83740 */   // Label 1425: @83740
     /*  83740 */   GIM_Reject,
     /*  83741 */ // Label 1418: @83741
     /*  83741 */ GIM_Reject,
     /*  83742 */ // Label 1404: @83742
     /*  83742 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(83815), // Rule ID 6983 //
     /*  83747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83754 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83762 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83765 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83772 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83775 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83781 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  83788 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15738>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  83788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  83791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83813 */   GIR_RootConstrainSelectedInstOperands,
     /*  83814 */   // GIR_Coverage, 6983,
     /*  83814 */   GIR_EraseRootFromParent_Done,
     /*  83815 */ // Label 1426: @83815
     /*  83815 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(83888), // Rule ID 6984 //
     /*  83820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83838 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83845 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83848 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83854 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  83861 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15738>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  83861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  83864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83886 */   GIR_RootConstrainSelectedInstOperands,
     /*  83887 */   // GIR_Coverage, 6984,
     /*  83887 */   GIR_EraseRootFromParent_Done,
     /*  83888 */ // Label 1427: @83888
     /*  83888 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(83956), // Rule ID 6985 //
     /*  83893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83908 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83911 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83918 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83921 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83927 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  83934 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15738>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  83934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  83937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83954 */   GIR_RootConstrainSelectedInstOperands,
     /*  83955 */   // GIR_Coverage, 6985,
     /*  83955 */   GIR_EraseRootFromParent_Done,
     /*  83956 */ // Label 1428: @83956
     /*  83956 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(84024), // Rule ID 6986 //
     /*  83961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83976 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83979 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83986 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83989 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83995 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  84002 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15738>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  84002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  84005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  84007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  84012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  84022 */   GIR_RootConstrainSelectedInstOperands,
     /*  84023 */   // GIR_Coverage, 6986,
     /*  84023 */   GIR_EraseRootFromParent_Done,
     /*  84024 */ // Label 1429: @84024
     /*  84024 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(84080), // Rule ID 5701 //
     /*  84029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  84044 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  84048 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  84052 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  84056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84058 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  84058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84063 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  84069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84079 */   // GIR_Coverage, 5701,
     /*  84079 */   GIR_EraseRootFromParent_Done,
     /*  84080 */ // Label 1430: @84080
     /*  84080 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(84110), // Rule ID 6567 //
     /*  84085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84099 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  84099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84109 */   // GIR_Coverage, 6567,
     /*  84109 */   GIR_Done,
     /*  84110 */ // Label 1431: @84110
     /*  84110 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(84140), // Rule ID 6568 //
     /*  84115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84129 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  84129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84139 */   // GIR_Coverage, 6568,
     /*  84139 */   GIR_Done,
     /*  84140 */ // Label 1432: @84140
     /*  84140 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(84170), // Rule ID 6569 //
     /*  84145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84159 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  84159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84169 */   // GIR_Coverage, 6569,
     /*  84169 */   GIR_Done,
     /*  84170 */ // Label 1433: @84170
     /*  84170 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(84200), // Rule ID 6570 //
     /*  84175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84189 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  84189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84199 */   // GIR_Coverage, 6570,
     /*  84199 */   GIR_Done,
     /*  84200 */ // Label 1434: @84200
     /*  84200 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(84230), // Rule ID 6571 //
     /*  84205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84219 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  84219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84229 */   // GIR_Coverage, 6571,
     /*  84229 */   GIR_Done,
     /*  84230 */ // Label 1435: @84230
     /*  84230 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(84260), // Rule ID 6572 //
     /*  84235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84249 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  84249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84259 */   // GIR_Coverage, 6572,
     /*  84259 */   GIR_Done,
     /*  84260 */ // Label 1436: @84260
     /*  84260 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(84310), // Rule ID 6578 //
     /*  84265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84279 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  84279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84291 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  84303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84308 */   GIR_RootConstrainSelectedInstOperands,
     /*  84309 */   // GIR_Coverage, 6578,
     /*  84309 */   GIR_EraseRootFromParent_Done,
     /*  84310 */ // Label 1437: @84310
     /*  84310 */ GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(84360), // Rule ID 6579 //
     /*  84315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84329 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  84329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84358 */   GIR_RootConstrainSelectedInstOperands,
     /*  84359 */   // GIR_Coverage, 6579,
     /*  84359 */   GIR_EraseRootFromParent_Done,
     /*  84360 */ // Label 1438: @84360
     /*  84360 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(84410), // Rule ID 6580 //
     /*  84365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84379 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  84379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84391 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84408 */   GIR_RootConstrainSelectedInstOperands,
     /*  84409 */   // GIR_Coverage, 6580,
     /*  84409 */   GIR_EraseRootFromParent_Done,
     /*  84410 */ // Label 1439: @84410
     /*  84410 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(84460), // Rule ID 6581 //
     /*  84415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84429 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  84429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84458 */   GIR_RootConstrainSelectedInstOperands,
     /*  84459 */   // GIR_Coverage, 6581,
     /*  84459 */   GIR_EraseRootFromParent_Done,
     /*  84460 */ // Label 1440: @84460
     /*  84460 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(84510), // Rule ID 6582 //
     /*  84465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84479 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  84479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84508 */   GIR_RootConstrainSelectedInstOperands,
     /*  84509 */   // GIR_Coverage, 6582,
     /*  84509 */   GIR_EraseRootFromParent_Done,
     /*  84510 */ // Label 1441: @84510
     /*  84510 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(84537), // Rule ID 6583 //
     /*  84515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84526 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84536 */   // GIR_Coverage, 6583,
     /*  84536 */   GIR_Done,
     /*  84537 */ // Label 1442: @84537
     /*  84537 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(84564), // Rule ID 6584 //
     /*  84542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84553 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84563 */   // GIR_Coverage, 6584,
     /*  84563 */   GIR_Done,
     /*  84564 */ // Label 1443: @84564
     /*  84564 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(84591), // Rule ID 6585 //
     /*  84569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84580 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  84580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84590 */   // GIR_Coverage, 6585,
     /*  84590 */   GIR_Done,
     /*  84591 */ // Label 1444: @84591
     /*  84591 */ GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(84618), // Rule ID 6594 //
     /*  84596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84607 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84617 */   // GIR_Coverage, 6594,
     /*  84617 */   GIR_Done,
     /*  84618 */ // Label 1445: @84618
     /*  84618 */ GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(84645), // Rule ID 6595 //
     /*  84623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84634 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  84634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84644 */   // GIR_Coverage, 6595,
     /*  84644 */   GIR_Done,
     /*  84645 */ // Label 1446: @84645
     /*  84645 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(84672), // Rule ID 6596 //
     /*  84650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84661 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  84661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84671 */   // GIR_Coverage, 6596,
     /*  84671 */   GIR_Done,
     /*  84672 */ // Label 1447: @84672
     /*  84672 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(84704), // Rule ID 6597 //
     /*  84677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84691 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84694 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84696 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84703 */   // GIR_Coverage, 6597,
     /*  84703 */   GIR_EraseRootFromParent_Done,
     /*  84704 */ // Label 1448: @84704
     /*  84704 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(84736), // Rule ID 6598 //
     /*  84709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84723 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84726 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84728 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84735 */   // GIR_Coverage, 6598,
     /*  84735 */   GIR_EraseRootFromParent_Done,
     /*  84736 */ // Label 1449: @84736
     /*  84736 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(84768), // Rule ID 6599 //
     /*  84741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84755 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84758 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84762 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84767 */   // GIR_Coverage, 6599,
     /*  84767 */   GIR_EraseRootFromParent_Done,
     /*  84768 */ // Label 1450: @84768
     /*  84768 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(84800), // Rule ID 6600 //
     /*  84773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84787 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84790 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84792 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84799 */   // GIR_Coverage, 6600,
     /*  84799 */   GIR_EraseRootFromParent_Done,
     /*  84800 */ // Label 1451: @84800
     /*  84800 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(84832), // Rule ID 6601 //
     /*  84805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84819 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84822 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84824 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84826 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84831 */   // GIR_Coverage, 6601,
     /*  84831 */   GIR_EraseRootFromParent_Done,
     /*  84832 */ // Label 1452: @84832
     /*  84832 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(84858), // Rule ID 6602 //
     /*  84837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84851 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  84851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84856 */   GIR_RootConstrainSelectedInstOperands,
     /*  84857 */   // GIR_Coverage, 6602,
     /*  84857 */   GIR_Done,
     /*  84858 */ // Label 1453: @84858
     /*  84858 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(84884), // Rule ID 6603 //
     /*  84863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84877 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  84877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84882 */   GIR_RootConstrainSelectedInstOperands,
     /*  84883 */   // GIR_Coverage, 6603,
     /*  84883 */   GIR_Done,
     /*  84884 */ // Label 1454: @84884
     /*  84884 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(84910), // Rule ID 6604 //
     /*  84889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84903 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  84903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  84908 */   GIR_RootConstrainSelectedInstOperands,
     /*  84909 */   // GIR_Coverage, 6604,
     /*  84909 */   GIR_Done,
     /*  84910 */ // Label 1455: @84910
     /*  84910 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(84936), // Rule ID 6605 //
     /*  84915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84929 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  84929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84934 */   GIR_RootConstrainSelectedInstOperands,
     /*  84935 */   // GIR_Coverage, 6605,
     /*  84935 */   GIR_Done,
     /*  84936 */ // Label 1456: @84936
     /*  84936 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(84962), // Rule ID 6606 //
     /*  84941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84955 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  84955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84960 */   GIR_RootConstrainSelectedInstOperands,
     /*  84961 */   // GIR_Coverage, 6606,
     /*  84961 */   GIR_Done,
     /*  84962 */ // Label 1457: @84962
     /*  84962 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(84991), // Rule ID 6607 //
     /*  84967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84978 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84990 */   // GIR_Coverage, 6607,
     /*  84990 */   GIR_EraseRootFromParent_Done,
     /*  84991 */ // Label 1458: @84991
     /*  84991 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(85020), // Rule ID 6608 //
     /*  84996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85007 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  85007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85010 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85012 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85019 */   // GIR_Coverage, 6608,
     /*  85019 */   GIR_EraseRootFromParent_Done,
     /*  85020 */ // Label 1459: @85020
     /*  85020 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(85052), // Rule ID 6662 //
     /*  85025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85039 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85042 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85044 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85051 */   // GIR_Coverage, 6662,
     /*  85051 */   GIR_EraseRootFromParent_Done,
     /*  85052 */ // Label 1460: @85052
     /*  85052 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(85084), // Rule ID 6663 //
     /*  85057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85071 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85074 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85076 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85083 */   // GIR_Coverage, 6663,
     /*  85083 */   GIR_EraseRootFromParent_Done,
     /*  85084 */ // Label 1461: @85084
     /*  85084 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(85116), // Rule ID 6664 //
     /*  85089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85103 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85115 */   // GIR_Coverage, 6664,
     /*  85115 */   GIR_EraseRootFromParent_Done,
     /*  85116 */ // Label 1462: @85116
     /*  85116 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(85148), // Rule ID 6665 //
     /*  85121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85135 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85138 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85140 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85147 */   // GIR_Coverage, 6665,
     /*  85147 */   GIR_EraseRootFromParent_Done,
     /*  85148 */ // Label 1463: @85148
     /*  85148 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(85180), // Rule ID 6666 //
     /*  85153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85167 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85170 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85179 */   // GIR_Coverage, 6666,
     /*  85179 */   GIR_EraseRootFromParent_Done,
     /*  85180 */ // Label 1464: @85180
     /*  85180 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(85206), // Rule ID 6667 //
     /*  85185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85199 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  85199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85204 */   GIR_RootConstrainSelectedInstOperands,
     /*  85205 */   // GIR_Coverage, 6667,
     /*  85205 */   GIR_Done,
     /*  85206 */ // Label 1465: @85206
     /*  85206 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(85232), // Rule ID 6668 //
     /*  85211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85225 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  85225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85230 */   GIR_RootConstrainSelectedInstOperands,
     /*  85231 */   // GIR_Coverage, 6668,
     /*  85231 */   GIR_Done,
     /*  85232 */ // Label 1466: @85232
     /*  85232 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(85258), // Rule ID 6669 //
     /*  85237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85251 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  85251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85256 */   GIR_RootConstrainSelectedInstOperands,
     /*  85257 */   // GIR_Coverage, 6669,
     /*  85257 */   GIR_Done,
     /*  85258 */ // Label 1467: @85258
     /*  85258 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(85284), // Rule ID 6670 //
     /*  85263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85277 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  85277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  85282 */   GIR_RootConstrainSelectedInstOperands,
     /*  85283 */   // GIR_Coverage, 6670,
     /*  85283 */   GIR_Done,
     /*  85284 */ // Label 1468: @85284
     /*  85284 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(85310), // Rule ID 6671 //
     /*  85289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85303 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  85303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85308 */   GIR_RootConstrainSelectedInstOperands,
     /*  85309 */   // GIR_Coverage, 6671,
     /*  85309 */   GIR_Done,
     /*  85310 */ // Label 1469: @85310
     /*  85310 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(85339), // Rule ID 6672 //
     /*  85315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85326 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85338 */   // GIR_Coverage, 6672,
     /*  85338 */   GIR_EraseRootFromParent_Done,
     /*  85339 */ // Label 1470: @85339
     /*  85339 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(85368), // Rule ID 6673 //
     /*  85344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85355 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85367 */   // GIR_Coverage, 6673,
     /*  85367 */   GIR_EraseRootFromParent_Done,
     /*  85368 */ // Label 1471: @85368
     /*  85368 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(85400), // Rule ID 6674 //
     /*  85373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85387 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85399 */   // GIR_Coverage, 6674,
     /*  85399 */   GIR_EraseRootFromParent_Done,
     /*  85400 */ // Label 1472: @85400
     /*  85400 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(85432), // Rule ID 6675 //
     /*  85405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85419 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85431 */   // GIR_Coverage, 6675,
     /*  85431 */   GIR_EraseRootFromParent_Done,
     /*  85432 */ // Label 1473: @85432
     /*  85432 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(85464), // Rule ID 6676 //
     /*  85437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85451 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85463 */   // GIR_Coverage, 6676,
     /*  85463 */   GIR_EraseRootFromParent_Done,
     /*  85464 */ // Label 1474: @85464
     /*  85464 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(85496), // Rule ID 6677 //
     /*  85469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85483 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85495 */   // GIR_Coverage, 6677,
     /*  85495 */   GIR_EraseRootFromParent_Done,
     /*  85496 */ // Label 1475: @85496
     /*  85496 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(85528), // Rule ID 6678 //
     /*  85501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85515 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85527 */   // GIR_Coverage, 6678,
     /*  85527 */   GIR_EraseRootFromParent_Done,
     /*  85528 */ // Label 1476: @85528
     /*  85528 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(85554), // Rule ID 6679 //
     /*  85533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85547 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  85547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85552 */   GIR_RootConstrainSelectedInstOperands,
     /*  85553 */   // GIR_Coverage, 6679,
     /*  85553 */   GIR_Done,
     /*  85554 */ // Label 1477: @85554
     /*  85554 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(85580), // Rule ID 6680 //
     /*  85559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85573 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  85573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85578 */   GIR_RootConstrainSelectedInstOperands,
     /*  85579 */   // GIR_Coverage, 6680,
     /*  85579 */   GIR_Done,
     /*  85580 */ // Label 1478: @85580
     /*  85580 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(85606), // Rule ID 6681 //
     /*  85585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85599 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  85599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  85604 */   GIR_RootConstrainSelectedInstOperands,
     /*  85605 */   // GIR_Coverage, 6681,
     /*  85605 */   GIR_Done,
     /*  85606 */ // Label 1479: @85606
     /*  85606 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(85632), // Rule ID 6682 //
     /*  85611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85625 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  85625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85630 */   GIR_RootConstrainSelectedInstOperands,
     /*  85631 */   // GIR_Coverage, 6682,
     /*  85631 */   GIR_Done,
     /*  85632 */ // Label 1480: @85632
     /*  85632 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(85658), // Rule ID 6683 //
     /*  85637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85651 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  85651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85656 */   GIR_RootConstrainSelectedInstOperands,
     /*  85657 */   // GIR_Coverage, 6683,
     /*  85657 */   GIR_Done,
     /*  85658 */ // Label 1481: @85658
     /*  85658 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(85687), // Rule ID 6684 //
     /*  85663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85674 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85686 */   // GIR_Coverage, 6684,
     /*  85686 */   GIR_EraseRootFromParent_Done,
     /*  85687 */ // Label 1482: @85687
     /*  85687 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(85716), // Rule ID 6685 //
     /*  85692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85703 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85706 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85708 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85715 */   // GIR_Coverage, 6685,
     /*  85715 */   GIR_EraseRootFromParent_Done,
     /*  85716 */ // Label 1483: @85716
     /*  85716 */ GIM_Reject,
     /*  85717 */ // Label 1405: @85717
     /*  85717 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(85749), // Rule ID 6699 //
     /*  85722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85736 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85748 */   // GIR_Coverage, 6699,
     /*  85748 */   GIR_EraseRootFromParent_Done,
     /*  85749 */ // Label 1484: @85749
     /*  85749 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(85781), // Rule ID 6700 //
     /*  85754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85768 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85780 */   // GIR_Coverage, 6700,
     /*  85780 */   GIR_EraseRootFromParent_Done,
     /*  85781 */ // Label 1485: @85781
     /*  85781 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(85813), // Rule ID 6701 //
     /*  85786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85800 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85812 */   // GIR_Coverage, 6701,
     /*  85812 */   GIR_EraseRootFromParent_Done,
     /*  85813 */ // Label 1486: @85813
     /*  85813 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(85845), // Rule ID 6702 //
     /*  85818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85832 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85844 */   // GIR_Coverage, 6702,
     /*  85844 */   GIR_EraseRootFromParent_Done,
     /*  85845 */ // Label 1487: @85845
     /*  85845 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(85877), // Rule ID 6703 //
     /*  85850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85864 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85876 */   // GIR_Coverage, 6703,
     /*  85876 */   GIR_EraseRootFromParent_Done,
     /*  85877 */ // Label 1488: @85877
     /*  85877 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(85909), // Rule ID 6704 //
     /*  85882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85896 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85908 */   // GIR_Coverage, 6704,
     /*  85908 */   GIR_EraseRootFromParent_Done,
     /*  85909 */ // Label 1489: @85909
     /*  85909 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(85941), // Rule ID 6705 //
     /*  85914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  85920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85928 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85931 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85933 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85940 */   // GIR_Coverage, 6705,
     /*  85940 */   GIR_EraseRootFromParent_Done,
     /*  85941 */ // Label 1490: @85941
     /*  85941 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(85974), // Rule ID 6706 //
     /*  85946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85960 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  85960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  85963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85965 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  85972 */   GIR_RootConstrainSelectedInstOperands,
     /*  85973 */   // GIR_Coverage, 6706,
     /*  85973 */   GIR_EraseRootFromParent_Done,
     /*  85974 */ // Label 1491: @85974
     /*  85974 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(86045), // Rule ID 6707 //
     /*  85979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85993 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  85993 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85996 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86000 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86005 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86043 */   GIR_RootConstrainSelectedInstOperands,
     /*  86044 */   // GIR_Coverage, 6707,
     /*  86044 */   GIR_EraseRootFromParent_Done,
     /*  86045 */ // Label 1492: @86045
     /*  86045 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(86116), // Rule ID 6708 //
     /*  86050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86064 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  86064 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86067 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86071 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86076 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86094 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86114 */   GIR_RootConstrainSelectedInstOperands,
     /*  86115 */   // GIR_Coverage, 6708,
     /*  86115 */   GIR_EraseRootFromParent_Done,
     /*  86116 */ // Label 1493: @86116
     /*  86116 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(86187), // Rule ID 6709 //
     /*  86121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86135 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  86135 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86138 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86142 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86147 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86165 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86185 */   GIR_RootConstrainSelectedInstOperands,
     /*  86186 */   // GIR_Coverage, 6709,
     /*  86186 */   GIR_EraseRootFromParent_Done,
     /*  86187 */ // Label 1494: @86187
     /*  86187 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(86220), // Rule ID 6710 //
     /*  86192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  86198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86206 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  86206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86211 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86213 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86218 */   GIR_RootConstrainSelectedInstOperands,
     /*  86219 */   // GIR_Coverage, 6710,
     /*  86219 */   GIR_EraseRootFromParent_Done,
     /*  86220 */ // Label 1495: @86220
     /*  86220 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(86291), // Rule ID 6711 //
     /*  86225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  86231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86239 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  86239 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86242 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86246 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86251 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86269 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86289 */   GIR_RootConstrainSelectedInstOperands,
     /*  86290 */   // GIR_Coverage, 6711,
     /*  86290 */   GIR_EraseRootFromParent_Done,
     /*  86291 */ // Label 1496: @86291
     /*  86291 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(86362), // Rule ID 6712 //
     /*  86296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  86302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86310 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  86310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  86317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86322 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  86335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86340 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86360 */   GIR_RootConstrainSelectedInstOperands,
     /*  86361 */   // GIR_Coverage, 6712,
     /*  86361 */   GIR_EraseRootFromParent_Done,
     /*  86362 */ // Label 1497: @86362
     /*  86362 */ GIM_Reject,
     /*  86363 */ // Label 1406: @86363
     /*  86363 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(86393), // Rule ID 6564 //
     /*  86368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86382 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  86382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86392 */   // GIR_Coverage, 6564,
     /*  86392 */   GIR_Done,
     /*  86393 */ // Label 1498: @86393
     /*  86393 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(86423), // Rule ID 6566 //
     /*  86398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86412 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  86412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86422 */   // GIR_Coverage, 6566,
     /*  86422 */   GIR_Done,
     /*  86423 */ // Label 1499: @86423
     /*  86423 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(86473), // Rule ID 6575 //
     /*  86428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86442 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  86442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86454 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  86458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86471 */   GIR_RootConstrainSelectedInstOperands,
     /*  86472 */   // GIR_Coverage, 6575,
     /*  86472 */   GIR_EraseRootFromParent_Done,
     /*  86473 */ // Label 1500: @86473
     /*  86473 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(86523), // Rule ID 6577 //
     /*  86478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86492 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  86492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86504 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  86508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86521 */   GIR_RootConstrainSelectedInstOperands,
     /*  86522 */   // GIR_Coverage, 6577,
     /*  86522 */   GIR_EraseRootFromParent_Done,
     /*  86523 */ // Label 1501: @86523
     /*  86523 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(86555), // Rule ID 6609 //
     /*  86528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86542 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86554 */   // GIR_Coverage, 6609,
     /*  86554 */   GIR_EraseRootFromParent_Done,
     /*  86555 */ // Label 1502: @86555
     /*  86555 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(86587), // Rule ID 6610 //
     /*  86560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86574 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86586 */   // GIR_Coverage, 6610,
     /*  86586 */   GIR_EraseRootFromParent_Done,
     /*  86587 */ // Label 1503: @86587
     /*  86587 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(86619), // Rule ID 6611 //
     /*  86592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86606 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86609 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86611 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86618 */   // GIR_Coverage, 6611,
     /*  86618 */   GIR_EraseRootFromParent_Done,
     /*  86619 */ // Label 1504: @86619
     /*  86619 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(86651), // Rule ID 6612 //
     /*  86624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86638 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86641 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86643 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86650 */   // GIR_Coverage, 6612,
     /*  86650 */   GIR_EraseRootFromParent_Done,
     /*  86651 */ // Label 1505: @86651
     /*  86651 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(86683), // Rule ID 6613 //
     /*  86656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86670 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86673 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86682 */   // GIR_Coverage, 6613,
     /*  86682 */   GIR_EraseRootFromParent_Done,
     /*  86683 */ // Label 1506: @86683
     /*  86683 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(86715), // Rule ID 6614 //
     /*  86688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86702 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86705 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86707 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86714 */   // GIR_Coverage, 6614,
     /*  86714 */   GIR_EraseRootFromParent_Done,
     /*  86715 */ // Label 1507: @86715
     /*  86715 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(86741), // Rule ID 6615 //
     /*  86720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86734 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  86734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86739 */   GIR_RootConstrainSelectedInstOperands,
     /*  86740 */   // GIR_Coverage, 6615,
     /*  86740 */   GIR_Done,
     /*  86741 */ // Label 1508: @86741
     /*  86741 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(86767), // Rule ID 6616 //
     /*  86746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86760 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  86760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  86765 */   GIR_RootConstrainSelectedInstOperands,
     /*  86766 */   // GIR_Coverage, 6616,
     /*  86766 */   GIR_Done,
     /*  86767 */ // Label 1509: @86767
     /*  86767 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(86793), // Rule ID 6617 //
     /*  86772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86786 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  86786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  86791 */   GIR_RootConstrainSelectedInstOperands,
     /*  86792 */   // GIR_Coverage, 6617,
     /*  86792 */   GIR_Done,
     /*  86793 */ // Label 1510: @86793
     /*  86793 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(86819), // Rule ID 6618 //
     /*  86798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86812 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  86812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86817 */   GIR_RootConstrainSelectedInstOperands,
     /*  86818 */   // GIR_Coverage, 6618,
     /*  86818 */   GIR_Done,
     /*  86819 */ // Label 1511: @86819
     /*  86819 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(86845), // Rule ID 6619 //
     /*  86824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86838 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  86838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86843 */   GIR_RootConstrainSelectedInstOperands,
     /*  86844 */   // GIR_Coverage, 6619,
     /*  86844 */   GIR_Done,
     /*  86845 */ // Label 1512: @86845
     /*  86845 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(86871), // Rule ID 6620 //
     /*  86850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86864 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  86864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  86869 */   GIR_RootConstrainSelectedInstOperands,
     /*  86870 */   // GIR_Coverage, 6620,
     /*  86870 */   GIR_Done,
     /*  86871 */ // Label 1513: @86871
     /*  86871 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(86900), // Rule ID 6621 //
     /*  86876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  86879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86887 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86890 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86892 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86899 */   // GIR_Coverage, 6621,
     /*  86899 */   GIR_EraseRootFromParent_Done,
     /*  86900 */ // Label 1514: @86900
     /*  86900 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(86932), // Rule ID 6686 //
     /*  86905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86919 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86931 */   // GIR_Coverage, 6686,
     /*  86931 */   GIR_EraseRootFromParent_Done,
     /*  86932 */ // Label 1515: @86932
     /*  86932 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(86964), // Rule ID 6687 //
     /*  86937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86951 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86954 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86956 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86958 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86963 */   // GIR_Coverage, 6687,
     /*  86963 */   GIR_EraseRootFromParent_Done,
     /*  86964 */ // Label 1516: @86964
     /*  86964 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(86996), // Rule ID 6688 //
     /*  86969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86983 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86986 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86995 */   // GIR_Coverage, 6688,
     /*  86995 */   GIR_EraseRootFromParent_Done,
     /*  86996 */ // Label 1517: @86996
     /*  86996 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(87028), // Rule ID 6689 //
     /*  87001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87015 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87018 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87020 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87027 */   // GIR_Coverage, 6689,
     /*  87027 */   GIR_EraseRootFromParent_Done,
     /*  87028 */ // Label 1518: @87028
     /*  87028 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(87060), // Rule ID 6690 //
     /*  87033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87047 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87050 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87052 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87054 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87059 */   // GIR_Coverage, 6690,
     /*  87059 */   GIR_EraseRootFromParent_Done,
     /*  87060 */ // Label 1519: @87060
     /*  87060 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(87092), // Rule ID 6691 //
     /*  87065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87079 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87082 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87091 */   // GIR_Coverage, 6691,
     /*  87091 */   GIR_EraseRootFromParent_Done,
     /*  87092 */ // Label 1520: @87092
     /*  87092 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(87118), // Rule ID 6692 //
     /*  87097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87111 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  87111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87116 */   GIR_RootConstrainSelectedInstOperands,
     /*  87117 */   // GIR_Coverage, 6692,
     /*  87117 */   GIR_Done,
     /*  87118 */ // Label 1521: @87118
     /*  87118 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(87144), // Rule ID 6693 //
     /*  87123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87137 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  87137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  87142 */   GIR_RootConstrainSelectedInstOperands,
     /*  87143 */   // GIR_Coverage, 6693,
     /*  87143 */   GIR_Done,
     /*  87144 */ // Label 1522: @87144
     /*  87144 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(87170), // Rule ID 6694 //
     /*  87149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87163 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  87163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  87168 */   GIR_RootConstrainSelectedInstOperands,
     /*  87169 */   // GIR_Coverage, 6694,
     /*  87169 */   GIR_Done,
     /*  87170 */ // Label 1523: @87170
     /*  87170 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(87196), // Rule ID 6695 //
     /*  87175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87189 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  87189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87194 */   GIR_RootConstrainSelectedInstOperands,
     /*  87195 */   // GIR_Coverage, 6695,
     /*  87195 */   GIR_Done,
     /*  87196 */ // Label 1524: @87196
     /*  87196 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(87222), // Rule ID 6696 //
     /*  87201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87215 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  87215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87220 */   GIR_RootConstrainSelectedInstOperands,
     /*  87221 */   // GIR_Coverage, 6696,
     /*  87221 */   GIR_Done,
     /*  87222 */ // Label 1525: @87222
     /*  87222 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(87248), // Rule ID 6697 //
     /*  87227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87241 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  87241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  87246 */   GIR_RootConstrainSelectedInstOperands,
     /*  87247 */   // GIR_Coverage, 6697,
     /*  87247 */   GIR_Done,
     /*  87248 */ // Label 1526: @87248
     /*  87248 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(87277), // Rule ID 6698 //
     /*  87253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87264 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87276 */   // GIR_Coverage, 6698,
     /*  87276 */   GIR_EraseRootFromParent_Done,
     /*  87277 */ // Label 1527: @87277
     /*  87277 */ GIM_Reject,
     /*  87278 */ // Label 1407: @87278
     /*  87278 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(87310), // Rule ID 6713 //
     /*  87283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87297 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87300 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87302 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87309 */   // GIR_Coverage, 6713,
     /*  87309 */   GIR_EraseRootFromParent_Done,
     /*  87310 */ // Label 1528: @87310
     /*  87310 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(87342), // Rule ID 6714 //
     /*  87315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87329 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87332 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87334 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87336 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87341 */   // GIR_Coverage, 6714,
     /*  87341 */   GIR_EraseRootFromParent_Done,
     /*  87342 */ // Label 1529: @87342
     /*  87342 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(87374), // Rule ID 6715 //
     /*  87347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87361 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87364 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87366 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87373 */   // GIR_Coverage, 6715,
     /*  87373 */   GIR_EraseRootFromParent_Done,
     /*  87374 */ // Label 1530: @87374
     /*  87374 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(87406), // Rule ID 6716 //
     /*  87379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87393 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87396 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87398 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87405 */   // GIR_Coverage, 6716,
     /*  87405 */   GIR_EraseRootFromParent_Done,
     /*  87406 */ // Label 1531: @87406
     /*  87406 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(87438), // Rule ID 6717 //
     /*  87411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87425 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87428 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87430 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87437 */   // GIR_Coverage, 6717,
     /*  87437 */   GIR_EraseRootFromParent_Done,
     /*  87438 */ // Label 1532: @87438
     /*  87438 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(87470), // Rule ID 6718 //
     /*  87443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87457 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87460 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87462 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87469 */   // GIR_Coverage, 6718,
     /*  87469 */   GIR_EraseRootFromParent_Done,
     /*  87470 */ // Label 1533: @87470
     /*  87470 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(87503), // Rule ID 6719 //
     /*  87475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87489 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  87489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  87492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87494 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87496 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  87501 */   GIR_RootConstrainSelectedInstOperands,
     /*  87502 */   // GIR_Coverage, 6719,
     /*  87502 */   GIR_EraseRootFromParent_Done,
     /*  87503 */ // Label 1534: @87503
     /*  87503 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(87529), // Rule ID 6720 //
     /*  87508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87522 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  87522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87527 */   GIR_RootConstrainSelectedInstOperands,
     /*  87528 */   // GIR_Coverage, 6720,
     /*  87528 */   GIR_Done,
     /*  87529 */ // Label 1535: @87529
     /*  87529 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(87555), // Rule ID 6721 //
     /*  87534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87548 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  87548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87553 */   GIR_RootConstrainSelectedInstOperands,
     /*  87554 */   // GIR_Coverage, 6721,
     /*  87554 */   GIR_Done,
     /*  87555 */ // Label 1536: @87555
     /*  87555 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(87581), // Rule ID 6722 //
     /*  87560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87574 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  87574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87579 */   GIR_RootConstrainSelectedInstOperands,
     /*  87580 */   // GIR_Coverage, 6722,
     /*  87580 */   GIR_Done,
     /*  87581 */ // Label 1537: @87581
     /*  87581 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(87607), // Rule ID 6723 //
     /*  87586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87600 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  87600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  87605 */   GIR_RootConstrainSelectedInstOperands,
     /*  87606 */   // GIR_Coverage, 6723,
     /*  87606 */   GIR_Done,
     /*  87607 */ // Label 1538: @87607
     /*  87607 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(87633), // Rule ID 6724 //
     /*  87612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87626 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  87626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87631 */   GIR_RootConstrainSelectedInstOperands,
     /*  87632 */   // GIR_Coverage, 6724,
     /*  87632 */   GIR_Done,
     /*  87633 */ // Label 1539: @87633
     /*  87633 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(87662), // Rule ID 6725 //
     /*  87638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  87641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87649 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87652 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87661 */   // GIR_Coverage, 6725,
     /*  87661 */   GIR_EraseRootFromParent_Done,
     /*  87662 */ // Label 1540: @87662
     /*  87662 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(87694), // Rule ID 6739 //
     /*  87667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87681 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87684 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87686 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87693 */   // GIR_Coverage, 6739,
     /*  87693 */   GIR_EraseRootFromParent_Done,
     /*  87694 */ // Label 1541: @87694
     /*  87694 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(87726), // Rule ID 6740 //
     /*  87699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87713 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87716 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87725 */   // GIR_Coverage, 6740,
     /*  87725 */   GIR_EraseRootFromParent_Done,
     /*  87726 */ // Label 1542: @87726
     /*  87726 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(87758), // Rule ID 6741 //
     /*  87731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87745 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87750 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87757 */   // GIR_Coverage, 6741,
     /*  87757 */   GIR_EraseRootFromParent_Done,
     /*  87758 */ // Label 1543: @87758
     /*  87758 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(87790), // Rule ID 6742 //
     /*  87763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87777 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87789 */   // GIR_Coverage, 6742,
     /*  87789 */   GIR_EraseRootFromParent_Done,
     /*  87790 */ // Label 1544: @87790
     /*  87790 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(87822), // Rule ID 6743 //
     /*  87795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87809 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87821 */   // GIR_Coverage, 6743,
     /*  87821 */   GIR_EraseRootFromParent_Done,
     /*  87822 */ // Label 1545: @87822
     /*  87822 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(87854), // Rule ID 6744 //
     /*  87827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87841 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87853 */   // GIR_Coverage, 6744,
     /*  87853 */   GIR_EraseRootFromParent_Done,
     /*  87854 */ // Label 1546: @87854
     /*  87854 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(87887), // Rule ID 6745 //
     /*  87859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87873 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  87873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  87876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  87885 */   GIR_RootConstrainSelectedInstOperands,
     /*  87886 */   // GIR_Coverage, 6745,
     /*  87886 */   GIR_EraseRootFromParent_Done,
     /*  87887 */ // Label 1547: @87887
     /*  87887 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(87913), // Rule ID 6746 //
     /*  87892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87906 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  87906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87911 */   GIR_RootConstrainSelectedInstOperands,
     /*  87912 */   // GIR_Coverage, 6746,
     /*  87912 */   GIR_Done,
     /*  87913 */ // Label 1548: @87913
     /*  87913 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(87939), // Rule ID 6747 //
     /*  87918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87932 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  87932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87937 */   GIR_RootConstrainSelectedInstOperands,
     /*  87938 */   // GIR_Coverage, 6747,
     /*  87938 */   GIR_Done,
     /*  87939 */ // Label 1549: @87939
     /*  87939 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(87965), // Rule ID 6748 //
     /*  87944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87958 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  87958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  87963 */   GIR_RootConstrainSelectedInstOperands,
     /*  87964 */   // GIR_Coverage, 6748,
     /*  87964 */   GIR_Done,
     /*  87965 */ // Label 1550: @87965
     /*  87965 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(87991), // Rule ID 6749 //
     /*  87970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87984 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  87984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87989 */   GIR_RootConstrainSelectedInstOperands,
     /*  87990 */   // GIR_Coverage, 6749,
     /*  87990 */   GIR_Done,
     /*  87991 */ // Label 1551: @87991
     /*  87991 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(88017), // Rule ID 6750 //
     /*  87996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  88002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88010 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  88010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  88015 */   GIR_RootConstrainSelectedInstOperands,
     /*  88016 */   // GIR_Coverage, 6750,
     /*  88016 */   GIR_Done,
     /*  88017 */ // Label 1552: @88017
     /*  88017 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(88046), // Rule ID 6751 //
     /*  88022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88033 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  88033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88036 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88045 */   // GIR_Coverage, 6751,
     /*  88045 */   GIR_EraseRootFromParent_Done,
     /*  88046 */ // Label 1553: @88046
     /*  88046 */ GIM_Reject,
     /*  88047 */ // Label 1408: @88047
     /*  88047 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(88077), // Rule ID 6563 //
     /*  88052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88066 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88076 */   // GIR_Coverage, 6563,
     /*  88076 */   GIR_Done,
     /*  88077 */ // Label 1554: @88077
     /*  88077 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(88107), // Rule ID 6565 //
     /*  88082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88096 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88106 */   // GIR_Coverage, 6565,
     /*  88106 */   GIR_Done,
     /*  88107 */ // Label 1555: @88107
     /*  88107 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(88157), // Rule ID 6574 //
     /*  88112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88126 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  88126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88138 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  88142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88155 */   GIR_RootConstrainSelectedInstOperands,
     /*  88156 */   // GIR_Coverage, 6574,
     /*  88156 */   GIR_EraseRootFromParent_Done,
     /*  88157 */ // Label 1556: @88157
     /*  88157 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(88207), // Rule ID 6576 //
     /*  88162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88176 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  88176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88188 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  88192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88205 */   GIR_RootConstrainSelectedInstOperands,
     /*  88206 */   // GIR_Coverage, 6576,
     /*  88206 */   GIR_EraseRootFromParent_Done,
     /*  88207 */ // Label 1557: @88207
     /*  88207 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(88239), // Rule ID 6622 //
     /*  88212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88226 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88238 */   // GIR_Coverage, 6622,
     /*  88238 */   GIR_EraseRootFromParent_Done,
     /*  88239 */ // Label 1558: @88239
     /*  88239 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(88271), // Rule ID 6623 //
     /*  88244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88258 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88261 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88263 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88270 */   // GIR_Coverage, 6623,
     /*  88270 */   GIR_EraseRootFromParent_Done,
     /*  88271 */ // Label 1559: @88271
     /*  88271 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(88303), // Rule ID 6624 //
     /*  88276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88290 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88293 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88295 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88302 */   // GIR_Coverage, 6624,
     /*  88302 */   GIR_EraseRootFromParent_Done,
     /*  88303 */ // Label 1560: @88303
     /*  88303 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(88335), // Rule ID 6625 //
     /*  88308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88322 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88325 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88334 */   // GIR_Coverage, 6625,
     /*  88334 */   GIR_EraseRootFromParent_Done,
     /*  88335 */ // Label 1561: @88335
     /*  88335 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(88367), // Rule ID 6626 //
     /*  88340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88354 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88366 */   // GIR_Coverage, 6626,
     /*  88366 */   GIR_EraseRootFromParent_Done,
     /*  88367 */ // Label 1562: @88367
     /*  88367 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(88399), // Rule ID 6627 //
     /*  88372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88386 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88389 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88391 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88398 */   // GIR_Coverage, 6627,
     /*  88398 */   GIR_EraseRootFromParent_Done,
     /*  88399 */ // Label 1563: @88399
     /*  88399 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(88425), // Rule ID 6628 //
     /*  88404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88418 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  88418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88423 */   GIR_RootConstrainSelectedInstOperands,
     /*  88424 */   // GIR_Coverage, 6628,
     /*  88424 */   GIR_Done,
     /*  88425 */ // Label 1564: @88425
     /*  88425 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(88451), // Rule ID 6629 //
     /*  88430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88444 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  88444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88449 */   GIR_RootConstrainSelectedInstOperands,
     /*  88450 */   // GIR_Coverage, 6629,
     /*  88450 */   GIR_Done,
     /*  88451 */ // Label 1565: @88451
     /*  88451 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(88477), // Rule ID 6630 //
     /*  88456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88470 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  88470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  88475 */   GIR_RootConstrainSelectedInstOperands,
     /*  88476 */   // GIR_Coverage, 6630,
     /*  88476 */   GIR_Done,
     /*  88477 */ // Label 1566: @88477
     /*  88477 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(88503), // Rule ID 6631 //
     /*  88482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88496 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  88496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88501 */   GIR_RootConstrainSelectedInstOperands,
     /*  88502 */   // GIR_Coverage, 6631,
     /*  88502 */   GIR_Done,
     /*  88503 */ // Label 1567: @88503
     /*  88503 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(88529), // Rule ID 6632 //
     /*  88508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88522 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  88522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88527 */   GIR_RootConstrainSelectedInstOperands,
     /*  88528 */   // GIR_Coverage, 6632,
     /*  88528 */   GIR_Done,
     /*  88529 */ // Label 1568: @88529
     /*  88529 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(88555), // Rule ID 6633 //
     /*  88534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88548 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  88548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88553 */   GIR_RootConstrainSelectedInstOperands,
     /*  88554 */   // GIR_Coverage, 6633,
     /*  88554 */   GIR_Done,
     /*  88555 */ // Label 1569: @88555
     /*  88555 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(88584), // Rule ID 6634 //
     /*  88560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88571 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88574 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88576 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88583 */   // GIR_Coverage, 6634,
     /*  88583 */   GIR_EraseRootFromParent_Done,
     /*  88584 */ // Label 1570: @88584
     /*  88584 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(88616), // Rule ID 6635 //
     /*  88589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88603 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88606 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88608 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88615 */   // GIR_Coverage, 6635,
     /*  88615 */   GIR_EraseRootFromParent_Done,
     /*  88616 */ // Label 1571: @88616
     /*  88616 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(88648), // Rule ID 6636 //
     /*  88621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88635 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88638 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88640 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88647 */   // GIR_Coverage, 6636,
     /*  88647 */   GIR_EraseRootFromParent_Done,
     /*  88648 */ // Label 1572: @88648
     /*  88648 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(88680), // Rule ID 6637 //
     /*  88653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88667 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88670 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88679 */   // GIR_Coverage, 6637,
     /*  88679 */   GIR_EraseRootFromParent_Done,
     /*  88680 */ // Label 1573: @88680
     /*  88680 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(88712), // Rule ID 6638 //
     /*  88685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88699 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88702 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88704 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88711 */   // GIR_Coverage, 6638,
     /*  88711 */   GIR_EraseRootFromParent_Done,
     /*  88712 */ // Label 1574: @88712
     /*  88712 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(88744), // Rule ID 6639 //
     /*  88717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88731 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88734 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88736 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88743 */   // GIR_Coverage, 6639,
     /*  88743 */   GIR_EraseRootFromParent_Done,
     /*  88744 */ // Label 1575: @88744
     /*  88744 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(88776), // Rule ID 6640 //
     /*  88749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88763 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88775 */   // GIR_Coverage, 6640,
     /*  88775 */   GIR_EraseRootFromParent_Done,
     /*  88776 */ // Label 1576: @88776
     /*  88776 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(88802), // Rule ID 6641 //
     /*  88781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88795 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  88795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88800 */   GIR_RootConstrainSelectedInstOperands,
     /*  88801 */   // GIR_Coverage, 6641,
     /*  88801 */   GIR_Done,
     /*  88802 */ // Label 1577: @88802
     /*  88802 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(88828), // Rule ID 6642 //
     /*  88807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88821 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  88821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88826 */   GIR_RootConstrainSelectedInstOperands,
     /*  88827 */   // GIR_Coverage, 6642,
     /*  88827 */   GIR_Done,
     /*  88828 */ // Label 1578: @88828
     /*  88828 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(88854), // Rule ID 6643 //
     /*  88833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88847 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  88847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  88852 */   GIR_RootConstrainSelectedInstOperands,
     /*  88853 */   // GIR_Coverage, 6643,
     /*  88853 */   GIR_Done,
     /*  88854 */ // Label 1579: @88854
     /*  88854 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(88880), // Rule ID 6644 //
     /*  88859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88873 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  88873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88878 */   GIR_RootConstrainSelectedInstOperands,
     /*  88879 */   // GIR_Coverage, 6644,
     /*  88879 */   GIR_Done,
     /*  88880 */ // Label 1580: @88880
     /*  88880 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(88906), // Rule ID 6645 //
     /*  88885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88899 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  88899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88904 */   GIR_RootConstrainSelectedInstOperands,
     /*  88905 */   // GIR_Coverage, 6645,
     /*  88905 */   GIR_Done,
     /*  88906 */ // Label 1581: @88906
     /*  88906 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(88932), // Rule ID 6646 //
     /*  88911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88925 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  88925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88930 */   GIR_RootConstrainSelectedInstOperands,
     /*  88931 */   // GIR_Coverage, 6646,
     /*  88931 */   GIR_Done,
     /*  88932 */ // Label 1582: @88932
     /*  88932 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(88961), // Rule ID 6647 //
     /*  88937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88948 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88960 */   // GIR_Coverage, 6647,
     /*  88960 */   GIR_EraseRootFromParent_Done,
     /*  88961 */ // Label 1583: @88961
     /*  88961 */ GIM_Reject,
     /*  88962 */ // Label 1409: @88962
     /*  88962 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(88994), // Rule ID 6726 //
     /*  88967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  88973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88981 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  88981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88984 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88986 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88993 */   // GIR_Coverage, 6726,
     /*  88993 */   GIR_EraseRootFromParent_Done,
     /*  88994 */ // Label 1584: @88994
     /*  88994 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(89026), // Rule ID 6727 //
     /*  88999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89013 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89016 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89025 */   // GIR_Coverage, 6727,
     /*  89025 */   GIR_EraseRootFromParent_Done,
     /*  89026 */ // Label 1585: @89026
     /*  89026 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(89058), // Rule ID 6728 //
     /*  89031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89045 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89048 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89057 */   // GIR_Coverage, 6728,
     /*  89057 */   GIR_EraseRootFromParent_Done,
     /*  89058 */ // Label 1586: @89058
     /*  89058 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(89090), // Rule ID 6729 //
     /*  89063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89077 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89080 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89082 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89089 */   // GIR_Coverage, 6729,
     /*  89089 */   GIR_EraseRootFromParent_Done,
     /*  89090 */ // Label 1587: @89090
     /*  89090 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(89122), // Rule ID 6730 //
     /*  89095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89109 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89112 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89114 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89121 */   // GIR_Coverage, 6730,
     /*  89121 */   GIR_EraseRootFromParent_Done,
     /*  89122 */ // Label 1588: @89122
     /*  89122 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(89154), // Rule ID 6731 //
     /*  89127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89141 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89144 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89146 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89153 */   // GIR_Coverage, 6731,
     /*  89153 */   GIR_EraseRootFromParent_Done,
     /*  89154 */ // Label 1589: @89154
     /*  89154 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(89225), // Rule ID 6732 //
     /*  89159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89173 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  89173 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89176 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89180 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89185 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89223 */   GIR_RootConstrainSelectedInstOperands,
     /*  89224 */   // GIR_Coverage, 6732,
     /*  89224 */   GIR_EraseRootFromParent_Done,
     /*  89225 */ // Label 1590: @89225
     /*  89225 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(89251), // Rule ID 6733 //
     /*  89230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89244 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  89244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89249 */   GIR_RootConstrainSelectedInstOperands,
     /*  89250 */   // GIR_Coverage, 6733,
     /*  89250 */   GIR_Done,
     /*  89251 */ // Label 1591: @89251
     /*  89251 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(89277), // Rule ID 6734 //
     /*  89256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89270 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  89270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89275 */   GIR_RootConstrainSelectedInstOperands,
     /*  89276 */   // GIR_Coverage, 6734,
     /*  89276 */   GIR_Done,
     /*  89277 */ // Label 1592: @89277
     /*  89277 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(89303), // Rule ID 6735 //
     /*  89282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89296 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  89296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  89301 */   GIR_RootConstrainSelectedInstOperands,
     /*  89302 */   // GIR_Coverage, 6735,
     /*  89302 */   GIR_Done,
     /*  89303 */ // Label 1593: @89303
     /*  89303 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(89329), // Rule ID 6736 //
     /*  89308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89322 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  89322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89327 */   GIR_RootConstrainSelectedInstOperands,
     /*  89328 */   // GIR_Coverage, 6736,
     /*  89328 */   GIR_Done,
     /*  89329 */ // Label 1594: @89329
     /*  89329 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(89355), // Rule ID 6737 //
     /*  89334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89348 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  89348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89353 */   GIR_RootConstrainSelectedInstOperands,
     /*  89354 */   // GIR_Coverage, 6737,
     /*  89354 */   GIR_Done,
     /*  89355 */ // Label 1595: @89355
     /*  89355 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(89384), // Rule ID 6738 //
     /*  89360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89371 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89374 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89376 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89383 */   // GIR_Coverage, 6738,
     /*  89383 */   GIR_EraseRootFromParent_Done,
     /*  89384 */ // Label 1596: @89384
     /*  89384 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(89416), // Rule ID 6752 //
     /*  89389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89403 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89406 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89415 */   // GIR_Coverage, 6752,
     /*  89415 */   GIR_EraseRootFromParent_Done,
     /*  89416 */ // Label 1597: @89416
     /*  89416 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(89448), // Rule ID 6753 //
     /*  89421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89435 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89438 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89447 */   // GIR_Coverage, 6753,
     /*  89447 */   GIR_EraseRootFromParent_Done,
     /*  89448 */ // Label 1598: @89448
     /*  89448 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(89480), // Rule ID 6754 //
     /*  89453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89467 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89470 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89472 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89479 */   // GIR_Coverage, 6754,
     /*  89479 */   GIR_EraseRootFromParent_Done,
     /*  89480 */ // Label 1599: @89480
     /*  89480 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(89512), // Rule ID 6755 //
     /*  89485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89499 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89502 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89511 */   // GIR_Coverage, 6755,
     /*  89511 */   GIR_EraseRootFromParent_Done,
     /*  89512 */ // Label 1600: @89512
     /*  89512 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(89544), // Rule ID 6756 //
     /*  89517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89531 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89534 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89536 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89543 */   // GIR_Coverage, 6756,
     /*  89543 */   GIR_EraseRootFromParent_Done,
     /*  89544 */ // Label 1601: @89544
     /*  89544 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(89576), // Rule ID 6757 //
     /*  89549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89563 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89566 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89568 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89570 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89575 */   // GIR_Coverage, 6757,
     /*  89575 */   GIR_EraseRootFromParent_Done,
     /*  89576 */ // Label 1602: @89576
     /*  89576 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(89647), // Rule ID 6758 //
     /*  89581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89595 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  89595 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89598 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89602 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89607 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89625 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89645 */   GIR_RootConstrainSelectedInstOperands,
     /*  89646 */   // GIR_Coverage, 6758,
     /*  89646 */   GIR_EraseRootFromParent_Done,
     /*  89647 */ // Label 1603: @89647
     /*  89647 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(89673), // Rule ID 6759 //
     /*  89652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89666 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  89666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89671 */   GIR_RootConstrainSelectedInstOperands,
     /*  89672 */   // GIR_Coverage, 6759,
     /*  89672 */   GIR_Done,
     /*  89673 */ // Label 1604: @89673
     /*  89673 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(89699), // Rule ID 6760 //
     /*  89678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89692 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  89692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89697 */   GIR_RootConstrainSelectedInstOperands,
     /*  89698 */   // GIR_Coverage, 6760,
     /*  89698 */   GIR_Done,
     /*  89699 */ // Label 1605: @89699
     /*  89699 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(89725), // Rule ID 6761 //
     /*  89704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89718 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  89718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  89723 */   GIR_RootConstrainSelectedInstOperands,
     /*  89724 */   // GIR_Coverage, 6761,
     /*  89724 */   GIR_Done,
     /*  89725 */ // Label 1606: @89725
     /*  89725 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(89751), // Rule ID 6762 //
     /*  89730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89744 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  89744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89749 */   GIR_RootConstrainSelectedInstOperands,
     /*  89750 */   // GIR_Coverage, 6762,
     /*  89750 */   GIR_Done,
     /*  89751 */ // Label 1607: @89751
     /*  89751 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(89777), // Rule ID 6763 //
     /*  89756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89770 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  89770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89775 */   GIR_RootConstrainSelectedInstOperands,
     /*  89776 */   // GIR_Coverage, 6763,
     /*  89776 */   GIR_Done,
     /*  89777 */ // Label 1608: @89777
     /*  89777 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(89806), // Rule ID 6764 //
     /*  89782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89793 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89796 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89798 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89805 */   // GIR_Coverage, 6764,
     /*  89805 */   GIR_EraseRootFromParent_Done,
     /*  89806 */ // Label 1609: @89806
     /*  89806 */ GIM_Reject,
     /*  89807 */ // Label 1410: @89807
     /*  89807 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(89881), // Rule ID 5609 //
     /*  89812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  89827 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  89831 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  89836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89838 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  89838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  89841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  89845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89850 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  89859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  89870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  89880 */   // GIR_Coverage, 5609,
     /*  89880 */   GIR_EraseRootFromParent_Done,
     /*  89881 */ // Label 1610: @89881
     /*  89881 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(89911), // Rule ID 6562 //
     /*  89886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89900 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89910 */   // GIR_Coverage, 6562,
     /*  89910 */   GIR_Done,
     /*  89911 */ // Label 1611: @89911
     /*  89911 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(89961), // Rule ID 6573 //
     /*  89916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89930 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  89930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  89933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  89946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89959 */   GIR_RootConstrainSelectedInstOperands,
     /*  89960 */   // GIR_Coverage, 6573,
     /*  89960 */   GIR_EraseRootFromParent_Done,
     /*  89961 */ // Label 1612: @89961
     /*  89961 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(89993), // Rule ID 6648 //
     /*  89966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89980 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  89980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89983 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89985 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89992 */   // GIR_Coverage, 6648,
     /*  89992 */   GIR_EraseRootFromParent_Done,
     /*  89993 */ // Label 1613: @89993
     /*  89993 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(90025), // Rule ID 6649 //
     /*  89998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90012 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90015 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90024 */   // GIR_Coverage, 6649,
     /*  90024 */   GIR_EraseRootFromParent_Done,
     /*  90025 */ // Label 1614: @90025
     /*  90025 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(90057), // Rule ID 6650 //
     /*  90030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90044 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90056 */   // GIR_Coverage, 6650,
     /*  90056 */   GIR_EraseRootFromParent_Done,
     /*  90057 */ // Label 1615: @90057
     /*  90057 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(90089), // Rule ID 6651 //
     /*  90062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90076 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90079 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90081 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90088 */   // GIR_Coverage, 6651,
     /*  90088 */   GIR_EraseRootFromParent_Done,
     /*  90089 */ // Label 1616: @90089
     /*  90089 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(90121), // Rule ID 6652 //
     /*  90094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90108 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90120 */   // GIR_Coverage, 6652,
     /*  90120 */   GIR_EraseRootFromParent_Done,
     /*  90121 */ // Label 1617: @90121
     /*  90121 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(90153), // Rule ID 6653 //
     /*  90126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90140 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90143 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90145 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90152 */   // GIR_Coverage, 6653,
     /*  90152 */   GIR_EraseRootFromParent_Done,
     /*  90153 */ // Label 1618: @90153
     /*  90153 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(90185), // Rule ID 6654 //
     /*  90158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90172 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90175 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90179 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90184 */   // GIR_Coverage, 6654,
     /*  90184 */   GIR_EraseRootFromParent_Done,
     /*  90185 */ // Label 1619: @90185
     /*  90185 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(90211), // Rule ID 6655 //
     /*  90190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90204 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  90204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90209 */   GIR_RootConstrainSelectedInstOperands,
     /*  90210 */   // GIR_Coverage, 6655,
     /*  90210 */   GIR_Done,
     /*  90211 */ // Label 1620: @90211
     /*  90211 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(90237), // Rule ID 6656 //
     /*  90216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90230 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  90230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90235 */   GIR_RootConstrainSelectedInstOperands,
     /*  90236 */   // GIR_Coverage, 6656,
     /*  90236 */   GIR_Done,
     /*  90237 */ // Label 1621: @90237
     /*  90237 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(90263), // Rule ID 6657 //
     /*  90242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90256 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  90256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  90261 */   GIR_RootConstrainSelectedInstOperands,
     /*  90262 */   // GIR_Coverage, 6657,
     /*  90262 */   GIR_Done,
     /*  90263 */ // Label 1622: @90263
     /*  90263 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(90289), // Rule ID 6658 //
     /*  90268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90282 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  90282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90287 */   GIR_RootConstrainSelectedInstOperands,
     /*  90288 */   // GIR_Coverage, 6658,
     /*  90288 */   GIR_Done,
     /*  90289 */ // Label 1623: @90289
     /*  90289 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(90315), // Rule ID 6659 //
     /*  90294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90308 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  90308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90313 */   GIR_RootConstrainSelectedInstOperands,
     /*  90314 */   // GIR_Coverage, 6659,
     /*  90314 */   GIR_Done,
     /*  90315 */ // Label 1624: @90315
     /*  90315 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(90341), // Rule ID 6660 //
     /*  90320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90334 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  90334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90339 */   GIR_RootConstrainSelectedInstOperands,
     /*  90340 */   // GIR_Coverage, 6660,
     /*  90340 */   GIR_Done,
     /*  90341 */ // Label 1625: @90341
     /*  90341 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(90367), // Rule ID 6661 //
     /*  90346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90360 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  90360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  90365 */   GIR_RootConstrainSelectedInstOperands,
     /*  90366 */   // GIR_Coverage, 6661,
     /*  90366 */   GIR_Done,
     /*  90367 */ // Label 1626: @90367
     /*  90367 */ GIM_Reject,
     /*  90368 */ // Label 1411: @90368
     /*  90368 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(90400), // Rule ID 6765 //
     /*  90373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90387 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90399 */   // GIR_Coverage, 6765,
     /*  90399 */   GIR_EraseRootFromParent_Done,
     /*  90400 */ // Label 1627: @90400
     /*  90400 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(90432), // Rule ID 6766 //
     /*  90405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90419 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90431 */   // GIR_Coverage, 6766,
     /*  90431 */   GIR_EraseRootFromParent_Done,
     /*  90432 */ // Label 1628: @90432
     /*  90432 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(90464), // Rule ID 6767 //
     /*  90437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90451 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90463 */   // GIR_Coverage, 6767,
     /*  90463 */   GIR_EraseRootFromParent_Done,
     /*  90464 */ // Label 1629: @90464
     /*  90464 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(90496), // Rule ID 6768 //
     /*  90469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90483 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90495 */   // GIR_Coverage, 6768,
     /*  90495 */   GIR_EraseRootFromParent_Done,
     /*  90496 */ // Label 1630: @90496
     /*  90496 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(90528), // Rule ID 6769 //
     /*  90501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90515 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */   // GIR_Coverage, 6769,
     /*  90527 */   GIR_EraseRootFromParent_Done,
     /*  90528 */ // Label 1631: @90528
     /*  90528 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(90560), // Rule ID 6770 //
     /*  90533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90547 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90550 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90552 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90559 */   // GIR_Coverage, 6770,
     /*  90559 */   GIR_EraseRootFromParent_Done,
     /*  90560 */ // Label 1632: @90560
     /*  90560 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(90631), // Rule ID 6771 //
     /*  90565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90579 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  90579 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90582 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90586 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90591 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90609 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90629 */   GIR_RootConstrainSelectedInstOperands,
     /*  90630 */   // GIR_Coverage, 6771,
     /*  90630 */   GIR_EraseRootFromParent_Done,
     /*  90631 */ // Label 1633: @90631
     /*  90631 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(90657), // Rule ID 6772 //
     /*  90636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90650 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  90650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90655 */   GIR_RootConstrainSelectedInstOperands,
     /*  90656 */   // GIR_Coverage, 6772,
     /*  90656 */   GIR_Done,
     /*  90657 */ // Label 1634: @90657
     /*  90657 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(90683), // Rule ID 6773 //
     /*  90662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90676 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  90676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  90681 */   GIR_RootConstrainSelectedInstOperands,
     /*  90682 */   // GIR_Coverage, 6773,
     /*  90682 */   GIR_Done,
     /*  90683 */ // Label 1635: @90683
     /*  90683 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(90709), // Rule ID 6774 //
     /*  90688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90702 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  90702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  90707 */   GIR_RootConstrainSelectedInstOperands,
     /*  90708 */   // GIR_Coverage, 6774,
     /*  90708 */   GIR_Done,
     /*  90709 */ // Label 1636: @90709
     /*  90709 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(90735), // Rule ID 6775 //
     /*  90714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90728 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  90728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90733 */   GIR_RootConstrainSelectedInstOperands,
     /*  90734 */   // GIR_Coverage, 6775,
     /*  90734 */   GIR_Done,
     /*  90735 */ // Label 1637: @90735
     /*  90735 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(90761), // Rule ID 6776 //
     /*  90740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90754 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  90754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  90759 */   GIR_RootConstrainSelectedInstOperands,
     /*  90760 */   // GIR_Coverage, 6776,
     /*  90760 */   GIR_Done,
     /*  90761 */ // Label 1638: @90761
     /*  90761 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(90790), // Rule ID 6777 //
     /*  90766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90777 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90789 */   // GIR_Coverage, 6777,
     /*  90789 */   GIR_EraseRootFromParent_Done,
     /*  90790 */ // Label 1639: @90790
     /*  90790 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(90822), // Rule ID 6778 //
     /*  90795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90809 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90821 */   // GIR_Coverage, 6778,
     /*  90821 */   GIR_EraseRootFromParent_Done,
     /*  90822 */ // Label 1640: @90822
     /*  90822 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(90854), // Rule ID 6779 //
     /*  90827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90841 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90853 */   // GIR_Coverage, 6779,
     /*  90853 */   GIR_EraseRootFromParent_Done,
     /*  90854 */ // Label 1641: @90854
     /*  90854 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(90886), // Rule ID 6780 //
     /*  90859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90873 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90885 */   // GIR_Coverage, 6780,
     /*  90885 */   GIR_EraseRootFromParent_Done,
     /*  90886 */ // Label 1642: @90886
     /*  90886 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(90918), // Rule ID 6781 //
     /*  90891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90905 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90908 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90910 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90917 */   // GIR_Coverage, 6781,
     /*  90917 */   GIR_EraseRootFromParent_Done,
     /*  90918 */ // Label 1643: @90918
     /*  90918 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(90950), // Rule ID 6782 //
     /*  90923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90937 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90940 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90942 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90949 */   // GIR_Coverage, 6782,
     /*  90949 */   GIR_EraseRootFromParent_Done,
     /*  90950 */ // Label 1644: @90950
     /*  90950 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(90982), // Rule ID 6783 //
     /*  90955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90969 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90972 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90974 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90981 */   // GIR_Coverage, 6783,
     /*  90981 */   GIR_EraseRootFromParent_Done,
     /*  90982 */ // Label 1645: @90982
     /*  90982 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(91053), // Rule ID 6784 //
     /*  90987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91001 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  91001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  91004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91013 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  91022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91051 */   GIR_RootConstrainSelectedInstOperands,
     /*  91052 */   // GIR_Coverage, 6784,
     /*  91052 */   GIR_EraseRootFromParent_Done,
     /*  91053 */ // Label 1646: @91053
     /*  91053 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(91079), // Rule ID 6785 //
     /*  91058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91072 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  91072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91077 */   GIR_RootConstrainSelectedInstOperands,
     /*  91078 */   // GIR_Coverage, 6785,
     /*  91078 */   GIR_Done,
     /*  91079 */ // Label 1647: @91079
     /*  91079 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(91105), // Rule ID 6786 //
     /*  91084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91098 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  91098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  91103 */   GIR_RootConstrainSelectedInstOperands,
     /*  91104 */   // GIR_Coverage, 6786,
     /*  91104 */   GIR_Done,
     /*  91105 */ // Label 1648: @91105
     /*  91105 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(91131), // Rule ID 6787 //
     /*  91110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91124 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  91124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91129 */   GIR_RootConstrainSelectedInstOperands,
     /*  91130 */   // GIR_Coverage, 6787,
     /*  91130 */   GIR_Done,
     /*  91131 */ // Label 1649: @91131
     /*  91131 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(91157), // Rule ID 6788 //
     /*  91136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91150 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  91150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91155 */   GIR_RootConstrainSelectedInstOperands,
     /*  91156 */   // GIR_Coverage, 6788,
     /*  91156 */   GIR_Done,
     /*  91157 */ // Label 1650: @91157
     /*  91157 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(91183), // Rule ID 6789 //
     /*  91162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91176 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  91176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  91181 */   GIR_RootConstrainSelectedInstOperands,
     /*  91182 */   // GIR_Coverage, 6789,
     /*  91182 */   GIR_Done,
     /*  91183 */ // Label 1651: @91183
     /*  91183 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(91212), // Rule ID 6790 //
     /*  91188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91199 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  91199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91202 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91204 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91211 */   // GIR_Coverage, 6790,
     /*  91211 */   GIR_EraseRootFromParent_Done,
     /*  91212 */ // Label 1652: @91212
     /*  91212 */ GIM_Reject,
     /*  91213 */ // Label 1412: @91213
     /*  91213 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(91245), // Rule ID 6791 //
     /*  91218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91232 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91235 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91237 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91239 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91244 */   // GIR_Coverage, 6791,
     /*  91244 */   GIR_EraseRootFromParent_Done,
     /*  91245 */ // Label 1653: @91245
     /*  91245 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(91277), // Rule ID 6792 //
     /*  91250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91264 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91276 */   // GIR_Coverage, 6792,
     /*  91276 */   GIR_EraseRootFromParent_Done,
     /*  91277 */ // Label 1654: @91277
     /*  91277 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91309), // Rule ID 6793 //
     /*  91282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91296 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91299 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91301 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91308 */   // GIR_Coverage, 6793,
     /*  91308 */   GIR_EraseRootFromParent_Done,
     /*  91309 */ // Label 1655: @91309
     /*  91309 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(91341), // Rule ID 6794 //
     /*  91314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91328 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91331 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91333 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91340 */   // GIR_Coverage, 6794,
     /*  91340 */   GIR_EraseRootFromParent_Done,
     /*  91341 */ // Label 1656: @91341
     /*  91341 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91373), // Rule ID 6795 //
     /*  91346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91360 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91372 */   // GIR_Coverage, 6795,
     /*  91372 */   GIR_EraseRootFromParent_Done,
     /*  91373 */ // Label 1657: @91373
     /*  91373 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91405), // Rule ID 6796 //
     /*  91378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91392 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91404 */   // GIR_Coverage, 6796,
     /*  91404 */   GIR_EraseRootFromParent_Done,
     /*  91405 */ // Label 1658: @91405
     /*  91405 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91437), // Rule ID 6797 //
     /*  91410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91424 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91436 */   // GIR_Coverage, 6797,
     /*  91436 */   GIR_EraseRootFromParent_Done,
     /*  91437 */ // Label 1659: @91437
     /*  91437 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91508), // Rule ID 6798 //
     /*  91442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91456 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  91456 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  91459 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91463 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91468 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  91477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91486 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91506 */   GIR_RootConstrainSelectedInstOperands,
     /*  91507 */   // GIR_Coverage, 6798,
     /*  91507 */   GIR_EraseRootFromParent_Done,
     /*  91508 */ // Label 1660: @91508
     /*  91508 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91534), // Rule ID 6799 //
     /*  91513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91527 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  91527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91532 */   GIR_RootConstrainSelectedInstOperands,
     /*  91533 */   // GIR_Coverage, 6799,
     /*  91533 */   GIR_Done,
     /*  91534 */ // Label 1661: @91534
     /*  91534 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91560), // Rule ID 6800 //
     /*  91539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91553 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  91553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  91558 */   GIR_RootConstrainSelectedInstOperands,
     /*  91559 */   // GIR_Coverage, 6800,
     /*  91559 */   GIR_Done,
     /*  91560 */ // Label 1662: @91560
     /*  91560 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91586), // Rule ID 6801 //
     /*  91565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91579 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  91579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91584 */   GIR_RootConstrainSelectedInstOperands,
     /*  91585 */   // GIR_Coverage, 6801,
     /*  91585 */   GIR_Done,
     /*  91586 */ // Label 1663: @91586
     /*  91586 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91612), // Rule ID 6802 //
     /*  91591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91605 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  91605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91610 */   GIR_RootConstrainSelectedInstOperands,
     /*  91611 */   // GIR_Coverage, 6802,
     /*  91611 */   GIR_Done,
     /*  91612 */ // Label 1664: @91612
     /*  91612 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91638), // Rule ID 6803 //
     /*  91617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91631 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  91631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  91636 */   GIR_RootConstrainSelectedInstOperands,
     /*  91637 */   // GIR_Coverage, 6803,
     /*  91637 */   GIR_Done,
     /*  91638 */ // Label 1665: @91638
     /*  91638 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91664), // Rule ID 6804 //
     /*  91643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91657 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  91657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91662 */   GIR_RootConstrainSelectedInstOperands,
     /*  91663 */   // GIR_Coverage, 6804,
     /*  91663 */   GIR_Done,
     /*  91664 */ // Label 1666: @91664
     /*  91664 */ GIM_Reject,
     /*  91665 */ // Label 1413: @91665
     /*  91665 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91697), // Rule ID 10457 //
     /*  91670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  91676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91684 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91696 */   // GIR_Coverage, 10457,
     /*  91696 */   GIR_EraseRootFromParent_Done,
     /*  91697 */ // Label 1667: @91697
     /*  91697 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91729), // Rule ID 10458 //
     /*  91702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91716 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91728 */   // GIR_Coverage, 10458,
     /*  91728 */   GIR_EraseRootFromParent_Done,
     /*  91729 */ // Label 1668: @91729
     /*  91729 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91761), // Rule ID 10459 //
     /*  91734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91748 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91760 */   // GIR_Coverage, 10459,
     /*  91760 */   GIR_EraseRootFromParent_Done,
     /*  91761 */ // Label 1669: @91761
     /*  91761 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91793), // Rule ID 10460 //
     /*  91766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91780 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91792 */   // GIR_Coverage, 10460,
     /*  91792 */   GIR_EraseRootFromParent_Done,
     /*  91793 */ // Label 1670: @91793
     /*  91793 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91825), // Rule ID 10461 //
     /*  91798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91812 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91824 */   // GIR_Coverage, 10461,
     /*  91824 */   GIR_EraseRootFromParent_Done,
     /*  91825 */ // Label 1671: @91825
     /*  91825 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91857), // Rule ID 10462 //
     /*  91830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91844 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91856 */   // GIR_Coverage, 10462,
     /*  91856 */   GIR_EraseRootFromParent_Done,
     /*  91857 */ // Label 1672: @91857
     /*  91857 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91889), // Rule ID 10475 //
     /*  91862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  91868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91876 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91888 */   // GIR_Coverage, 10475,
     /*  91888 */   GIR_EraseRootFromParent_Done,
     /*  91889 */ // Label 1673: @91889
     /*  91889 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(91921), // Rule ID 10476 //
     /*  91894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91908 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91920 */   // GIR_Coverage, 10476,
     /*  91920 */   GIR_EraseRootFromParent_Done,
     /*  91921 */ // Label 1674: @91921
     /*  91921 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(91953), // Rule ID 10477 //
     /*  91926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91940 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91952 */   // GIR_Coverage, 10477,
     /*  91952 */   GIR_EraseRootFromParent_Done,
     /*  91953 */ // Label 1675: @91953
     /*  91953 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(91985), // Rule ID 10478 //
     /*  91958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91972 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91984 */   // GIR_Coverage, 10478,
     /*  91984 */   GIR_EraseRootFromParent_Done,
     /*  91985 */ // Label 1676: @91985
     /*  91985 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92017), // Rule ID 10479 //
     /*  91990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92004 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92016 */   // GIR_Coverage, 10479,
     /*  92016 */   GIR_EraseRootFromParent_Done,
     /*  92017 */ // Label 1677: @92017
     /*  92017 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92049), // Rule ID 10480 //
     /*  92022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92036 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92039 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92048 */   // GIR_Coverage, 10480,
     /*  92048 */   GIR_EraseRootFromParent_Done,
     /*  92049 */ // Label 1678: @92049
     /*  92049 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92081), // Rule ID 10485 //
     /*  92054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92068 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  92068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92071 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92080 */   // GIR_Coverage, 10485,
     /*  92080 */   GIR_EraseRootFromParent_Done,
     /*  92081 */ // Label 1679: @92081
     /*  92081 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92113), // Rule ID 10486 //
     /*  92086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92100 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92103 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92105 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92112 */   // GIR_Coverage, 10486,
     /*  92112 */   GIR_EraseRootFromParent_Done,
     /*  92113 */ // Label 1680: @92113
     /*  92113 */ GIM_Reject,
     /*  92114 */ // Label 1414: @92114
     /*  92114 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92146), // Rule ID 10451 //
     /*  92119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92133 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92136 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92145 */   // GIR_Coverage, 10451,
     /*  92145 */   GIR_EraseRootFromParent_Done,
     /*  92146 */ // Label 1681: @92146
     /*  92146 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92178), // Rule ID 10452 //
     /*  92151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92165 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92168 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92170 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92177 */   // GIR_Coverage, 10452,
     /*  92177 */   GIR_EraseRootFromParent_Done,
     /*  92178 */ // Label 1682: @92178
     /*  92178 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92210), // Rule ID 10453 //
     /*  92183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92197 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92200 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92209 */   // GIR_Coverage, 10453,
     /*  92209 */   GIR_EraseRootFromParent_Done,
     /*  92210 */ // Label 1683: @92210
     /*  92210 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92242), // Rule ID 10454 //
     /*  92215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92229 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92232 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92234 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92241 */   // GIR_Coverage, 10454,
     /*  92241 */   GIR_EraseRootFromParent_Done,
     /*  92242 */ // Label 1684: @92242
     /*  92242 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92274), // Rule ID 10455 //
     /*  92247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92261 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92264 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92273 */   // GIR_Coverage, 10455,
     /*  92273 */   GIR_EraseRootFromParent_Done,
     /*  92274 */ // Label 1685: @92274
     /*  92274 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92306), // Rule ID 10456 //
     /*  92279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92293 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92296 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92305 */   // GIR_Coverage, 10456,
     /*  92305 */   GIR_EraseRootFromParent_Done,
     /*  92306 */ // Label 1686: @92306
     /*  92306 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92338), // Rule ID 10469 //
     /*  92311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92325 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92337 */   // GIR_Coverage, 10469,
     /*  92337 */   GIR_EraseRootFromParent_Done,
     /*  92338 */ // Label 1687: @92338
     /*  92338 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92370), // Rule ID 10470 //
     /*  92343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92357 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92360 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92369 */   // GIR_Coverage, 10470,
     /*  92369 */   GIR_EraseRootFromParent_Done,
     /*  92370 */ // Label 1688: @92370
     /*  92370 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92402), // Rule ID 10471 //
     /*  92375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92389 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92401 */   // GIR_Coverage, 10471,
     /*  92401 */   GIR_EraseRootFromParent_Done,
     /*  92402 */ // Label 1689: @92402
     /*  92402 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92434), // Rule ID 10472 //
     /*  92407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92421 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92433 */   // GIR_Coverage, 10472,
     /*  92433 */   GIR_EraseRootFromParent_Done,
     /*  92434 */ // Label 1690: @92434
     /*  92434 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92466), // Rule ID 10473 //
     /*  92439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92453 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92465 */   // GIR_Coverage, 10473,
     /*  92465 */   GIR_EraseRootFromParent_Done,
     /*  92466 */ // Label 1691: @92466
     /*  92466 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92498), // Rule ID 10474 //
     /*  92471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92485 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92488 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92497 */   // GIR_Coverage, 10474,
     /*  92497 */   GIR_EraseRootFromParent_Done,
     /*  92498 */ // Label 1692: @92498
     /*  92498 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92530), // Rule ID 10483 //
     /*  92503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92517 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92520 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92522 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92529 */   // GIR_Coverage, 10483,
     /*  92529 */   GIR_EraseRootFromParent_Done,
     /*  92530 */ // Label 1693: @92530
     /*  92530 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92562), // Rule ID 10484 //
     /*  92535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92549 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92552 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92554 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92561 */   // GIR_Coverage, 10484,
     /*  92561 */   GIR_EraseRootFromParent_Done,
     /*  92562 */ // Label 1694: @92562
     /*  92562 */ GIM_Reject,
     /*  92563 */ // Label 1415: @92563
     /*  92563 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92595), // Rule ID 10445 //
     /*  92568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92582 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92585 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92594 */   // GIR_Coverage, 10445,
     /*  92594 */   GIR_EraseRootFromParent_Done,
     /*  92595 */ // Label 1695: @92595
     /*  92595 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92627), // Rule ID 10446 //
     /*  92600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92614 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92617 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92619 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92626 */   // GIR_Coverage, 10446,
     /*  92626 */   GIR_EraseRootFromParent_Done,
     /*  92627 */ // Label 1696: @92627
     /*  92627 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(92659), // Rule ID 10447 //
     /*  92632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92646 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92649 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92651 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92658 */   // GIR_Coverage, 10447,
     /*  92658 */   GIR_EraseRootFromParent_Done,
     /*  92659 */ // Label 1697: @92659
     /*  92659 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(92691), // Rule ID 10448 //
     /*  92664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92678 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92690 */   // GIR_Coverage, 10448,
     /*  92690 */   GIR_EraseRootFromParent_Done,
     /*  92691 */ // Label 1698: @92691
     /*  92691 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(92723), // Rule ID 10449 //
     /*  92696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92710 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92722 */   // GIR_Coverage, 10449,
     /*  92722 */   GIR_EraseRootFromParent_Done,
     /*  92723 */ // Label 1699: @92723
     /*  92723 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(92755), // Rule ID 10450 //
     /*  92728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92742 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92754 */   // GIR_Coverage, 10450,
     /*  92754 */   GIR_EraseRootFromParent_Done,
     /*  92755 */ // Label 1700: @92755
     /*  92755 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(92787), // Rule ID 10463 //
     /*  92760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92774 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92786 */   // GIR_Coverage, 10463,
     /*  92786 */   GIR_EraseRootFromParent_Done,
     /*  92787 */ // Label 1701: @92787
     /*  92787 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(92819), // Rule ID 10464 //
     /*  92792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92806 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92818 */   // GIR_Coverage, 10464,
     /*  92818 */   GIR_EraseRootFromParent_Done,
     /*  92819 */ // Label 1702: @92819
     /*  92819 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(92851), // Rule ID 10465 //
     /*  92824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92838 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92850 */   // GIR_Coverage, 10465,
     /*  92850 */   GIR_EraseRootFromParent_Done,
     /*  92851 */ // Label 1703: @92851
     /*  92851 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(92883), // Rule ID 10466 //
     /*  92856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92870 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92882 */   // GIR_Coverage, 10466,
     /*  92882 */   GIR_EraseRootFromParent_Done,
     /*  92883 */ // Label 1704: @92883
     /*  92883 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(92915), // Rule ID 10467 //
     /*  92888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92902 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92914 */   // GIR_Coverage, 10467,
     /*  92914 */   GIR_EraseRootFromParent_Done,
     /*  92915 */ // Label 1705: @92915
     /*  92915 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(92947), // Rule ID 10468 //
     /*  92920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92934 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92946 */   // GIR_Coverage, 10468,
     /*  92946 */   GIR_EraseRootFromParent_Done,
     /*  92947 */ // Label 1706: @92947
     /*  92947 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(92979), // Rule ID 10481 //
     /*  92952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92966 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92978 */   // GIR_Coverage, 10481,
     /*  92978 */   GIR_EraseRootFromParent_Done,
     /*  92979 */ // Label 1707: @92979
     /*  92979 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93011), // Rule ID 10482 //
     /*  92984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92998 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93010 */   // GIR_Coverage, 10482,
     /*  93010 */   GIR_EraseRootFromParent_Done,
     /*  93011 */ // Label 1708: @93011
     /*  93011 */ GIM_Reject,
     /*  93012 */ // Label 1416: @93012
     /*  93012 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93044), // Rule ID 10439 //
     /*  93017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  93023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93031 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93043 */   // GIR_Coverage, 10439,
     /*  93043 */   GIR_EraseRootFromParent_Done,
     /*  93044 */ // Label 1709: @93044
     /*  93044 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93076), // Rule ID 10440 //
     /*  93049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93063 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93075 */   // GIR_Coverage, 10440,
     /*  93075 */   GIR_EraseRootFromParent_Done,
     /*  93076 */ // Label 1710: @93076
     /*  93076 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93108), // Rule ID 10441 //
     /*  93081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93095 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93098 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93107 */   // GIR_Coverage, 10441,
     /*  93107 */   GIR_EraseRootFromParent_Done,
     /*  93108 */ // Label 1711: @93108
     /*  93108 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(93140), // Rule ID 10442 //
     /*  93113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  93119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93127 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93130 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93132 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93139 */   // GIR_Coverage, 10442,
     /*  93139 */   GIR_EraseRootFromParent_Done,
     /*  93140 */ // Label 1712: @93140
     /*  93140 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(93172), // Rule ID 10443 //
     /*  93145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93159 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93162 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93164 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93171 */   // GIR_Coverage, 10443,
     /*  93171 */   GIR_EraseRootFromParent_Done,
     /*  93172 */ // Label 1713: @93172
     /*  93172 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(93204), // Rule ID 10444 //
     /*  93177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93191 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93194 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93196 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93203 */   // GIR_Coverage, 10444,
     /*  93203 */   GIR_EraseRootFromParent_Done,
     /*  93204 */ // Label 1714: @93204
     /*  93204 */ GIM_Reject,
     /*  93205 */ // Label 1417: @93205
     /*  93205 */ GIM_Reject,
     /*  93206 */ // Label 10: @93206
     /*  93206 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1723*/ GIMT_Encode4(93696),
     /*  93217 */ /*GILLT_s16*//*Label 1715*/ GIMT_Encode4(93257),
     /*  93221 */ /*GILLT_s32*//*Label 1716*/ GIMT_Encode4(93288),
     /*  93225 */ /*GILLT_s64*//*Label 1717*/ GIMT_Encode4(93319), GIMT_Encode4(0),
     /*  93233 */ /*GILLT_v2s32*//*Label 1718*/ GIMT_Encode4(93350),
     /*  93237 */ /*GILLT_v2s64*//*Label 1719*/ GIMT_Encode4(93381),
     /*  93241 */ /*GILLT_v4s16*//*Label 1720*/ GIMT_Encode4(93412),
     /*  93245 */ /*GILLT_v4s32*//*Label 1721*/ GIMT_Encode4(93443), GIMT_Encode4(0),
     /*  93253 */ /*GILLT_v8s16*//*Label 1722*/ GIMT_Encode4(93474),
     /*  93257 */ // Label 1715: @93257
     /*  93257 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(93287), // Rule ID 564 //
     /*  93262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  93265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  93268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93276 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  93276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  93281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93285 */   GIR_RootConstrainSelectedInstOperands,
     /*  93286 */   // GIR_Coverage, 564,
     /*  93286 */   GIR_Done,
     /*  93287 */ // Label 1724: @93287
     /*  93287 */ GIM_Reject,
     /*  93288 */ // Label 1716: @93288
     /*  93288 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(93318), // Rule ID 566 //
     /*  93293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  93299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93307 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  93307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  93312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93316 */   GIR_RootConstrainSelectedInstOperands,
     /*  93317 */   // GIR_Coverage, 566,
     /*  93317 */   GIR_Done,
     /*  93318 */ // Label 1725: @93318
     /*  93318 */ GIM_Reject,
     /*  93319 */ // Label 1717: @93319
     /*  93319 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(93349), // Rule ID 568 //
     /*  93324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93338 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  93338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  93343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93347 */   GIR_RootConstrainSelectedInstOperands,
     /*  93348 */   // GIR_Coverage, 568,
     /*  93348 */   GIR_Done,
     /*  93349 */ // Label 1726: @93349
     /*  93349 */ GIM_Reject,
     /*  93350 */ // Label 1718: @93350
     /*  93350 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(93380), // Rule ID 926 //
     /*  93355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93369 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  93369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  93374 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93378 */   GIR_RootConstrainSelectedInstOperands,
     /*  93379 */   // GIR_Coverage, 926,
     /*  93379 */   GIR_Done,
     /*  93380 */ // Label 1727: @93380
     /*  93380 */ GIM_Reject,
     /*  93381 */ // Label 1719: @93381
     /*  93381 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(93411), // Rule ID 930 //
     /*  93386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93400 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  93400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  93405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93409 */   GIR_RootConstrainSelectedInstOperands,
     /*  93410 */   // GIR_Coverage, 930,
     /*  93410 */   GIR_Done,
     /*  93411 */ // Label 1728: @93411
     /*  93411 */ GIM_Reject,
     /*  93412 */ // Label 1720: @93412
     /*  93412 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(93442), // Rule ID 922 //
     /*  93417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93431 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  93431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  93436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93440 */   GIR_RootConstrainSelectedInstOperands,
     /*  93441 */   // GIR_Coverage, 922,
     /*  93441 */   GIR_Done,
     /*  93442 */ // Label 1729: @93442
     /*  93442 */ GIM_Reject,
     /*  93443 */ // Label 1721: @93443
     /*  93443 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(93473), // Rule ID 928 //
     /*  93448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93462 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  93462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93471 */   GIR_RootConstrainSelectedInstOperands,
     /*  93472 */   // GIR_Coverage, 928,
     /*  93472 */   GIR_Done,
     /*  93473 */ // Label 1730: @93473
     /*  93473 */ GIM_Reject,
     /*  93474 */ // Label 1722: @93474
     /*  93474 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(93695),
     /*  93479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93490 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(93509), // Rule ID 924 //
     /*  93495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93498 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  93498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  93503 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93507 */     GIR_RootConstrainSelectedInstOperands,
     /*  93508 */     // GIR_Coverage, 924,
     /*  93508 */     GIR_Done,
     /*  93509 */   // Label 1732: @93509
     /*  93509 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(93694), // Rule ID 6923 //
     /*  93514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  93517 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  93517 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  93520 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  93524 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93529 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  93533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  93535 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  93538 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93542 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93547 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  93550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  93552 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  93555 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93559 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93564 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  93570 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93575 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93580 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  93583 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  93587 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93592 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  93595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  93597 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  93600 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93604 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93609 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  93612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  93614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  93617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  93621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93626 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  93629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  93631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  93638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  93652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  93663 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  93666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  93684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  93692 */     GIR_RootConstrainSelectedInstOperands,
     /*  93693 */     // GIR_Coverage, 6923,
     /*  93693 */     GIR_EraseRootFromParent_Done,
     /*  93694 */   // Label 1733: @93694
     /*  93694 */   GIM_Reject,
     /*  93695 */ // Label 1731: @93695
     /*  93695 */ GIM_Reject,
     /*  93696 */ // Label 1723: @93696
     /*  93696 */ GIM_Reject,
     /*  93697 */ // Label 11: @93697
     /*  93697 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1742*/ GIMT_Encode4(94187),
     /*  93708 */ /*GILLT_s16*//*Label 1734*/ GIMT_Encode4(93748),
     /*  93712 */ /*GILLT_s32*//*Label 1735*/ GIMT_Encode4(93779),
     /*  93716 */ /*GILLT_s64*//*Label 1736*/ GIMT_Encode4(93810), GIMT_Encode4(0),
     /*  93724 */ /*GILLT_v2s32*//*Label 1737*/ GIMT_Encode4(93841),
     /*  93728 */ /*GILLT_v2s64*//*Label 1738*/ GIMT_Encode4(93872),
     /*  93732 */ /*GILLT_v4s16*//*Label 1739*/ GIMT_Encode4(93903),
     /*  93736 */ /*GILLT_v4s32*//*Label 1740*/ GIMT_Encode4(93934), GIMT_Encode4(0),
     /*  93744 */ /*GILLT_v8s16*//*Label 1741*/ GIMT_Encode4(93965),
     /*  93748 */ // Label 1734: @93748
     /*  93748 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(93778), // Rule ID 528 //
     /*  93753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  93756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  93759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93767 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  93767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  93772 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93776 */   GIR_RootConstrainSelectedInstOperands,
     /*  93777 */   // GIR_Coverage, 528,
     /*  93777 */   GIR_Done,
     /*  93778 */ // Label 1743: @93778
     /*  93778 */ GIM_Reject,
     /*  93779 */ // Label 1735: @93779
     /*  93779 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(93809), // Rule ID 530 //
     /*  93784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  93790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93798 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  93798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  93803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93807 */   GIR_RootConstrainSelectedInstOperands,
     /*  93808 */   // GIR_Coverage, 530,
     /*  93808 */   GIR_Done,
     /*  93809 */ // Label 1744: @93809
     /*  93809 */ GIM_Reject,
     /*  93810 */ // Label 1736: @93810
     /*  93810 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(93840), // Rule ID 532 //
     /*  93815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93829 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  93829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  93834 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93838 */   GIR_RootConstrainSelectedInstOperands,
     /*  93839 */   // GIR_Coverage, 532,
     /*  93839 */   GIR_Done,
     /*  93840 */ // Label 1745: @93840
     /*  93840 */ GIM_Reject,
     /*  93841 */ // Label 1737: @93841
     /*  93841 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(93871), // Rule ID 866 //
     /*  93846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93860 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  93860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  93865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93869 */   GIR_RootConstrainSelectedInstOperands,
     /*  93870 */   // GIR_Coverage, 866,
     /*  93870 */   GIR_Done,
     /*  93871 */ // Label 1746: @93871
     /*  93871 */ GIM_Reject,
     /*  93872 */ // Label 1738: @93872
     /*  93872 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(93902), // Rule ID 870 //
     /*  93877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93891 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  93891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  93896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93900 */   GIR_RootConstrainSelectedInstOperands,
     /*  93901 */   // GIR_Coverage, 870,
     /*  93901 */   GIR_Done,
     /*  93902 */ // Label 1747: @93902
     /*  93902 */ GIM_Reject,
     /*  93903 */ // Label 1739: @93903
     /*  93903 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(93933), // Rule ID 862 //
     /*  93908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93922 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  93922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  93927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93931 */   GIR_RootConstrainSelectedInstOperands,
     /*  93932 */   // GIR_Coverage, 862,
     /*  93932 */   GIR_Done,
     /*  93933 */ // Label 1748: @93933
     /*  93933 */ GIM_Reject,
     /*  93934 */ // Label 1740: @93934
     /*  93934 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(93964), // Rule ID 868 //
     /*  93939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93953 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  93953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  93958 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93962 */   GIR_RootConstrainSelectedInstOperands,
     /*  93963 */   // GIR_Coverage, 868,
     /*  93963 */   GIR_Done,
     /*  93964 */ // Label 1749: @93964
     /*  93964 */ GIM_Reject,
     /*  93965 */ // Label 1741: @93965
     /*  93965 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(94186),
     /*  93970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93981 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(94000), // Rule ID 864 //
     /*  93986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93989 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  93989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  93994 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93998 */     GIR_RootConstrainSelectedInstOperands,
     /*  93999 */     // GIR_Coverage, 864,
     /*  93999 */     GIR_Done,
     /*  94000 */   // Label 1751: @94000
     /*  94000 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(94185), // Rule ID 6917 //
     /*  94005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  94008 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  94008 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  94011 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  94015 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94020 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  94026 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  94029 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  94033 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94038 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  94041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  94043 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  94046 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94050 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94055 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  94061 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94066 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94071 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  94074 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  94078 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94083 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  94086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  94088 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  94091 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  94095 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94100 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  94103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  94105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  94108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  94112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94117 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  94120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  94129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  94143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  94157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  94175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  94183 */     GIR_RootConstrainSelectedInstOperands,
     /*  94184 */     // GIR_Coverage, 6917,
     /*  94184 */     GIR_EraseRootFromParent_Done,
     /*  94185 */   // Label 1752: @94185
     /*  94185 */   GIM_Reject,
     /*  94186 */ // Label 1750: @94186
     /*  94186 */ GIM_Reject,
     /*  94187 */ // Label 1742: @94187
     /*  94187 */ GIM_Reject,
     /*  94188 */ // Label 12: @94188
     /*  94188 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1755*/ GIMT_Encode4(94455),
     /*  94199 */ /*GILLT_s32*//*Label 1753*/ GIMT_Encode4(94207),
     /*  94203 */ /*GILLT_s64*//*Label 1754*/ GIMT_Encode4(94331),
     /*  94207 */ // Label 1753: @94207
     /*  94207 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(94250), // Rule ID 4736 //
     /*  94212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94222 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94234 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  94243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94248 */   GIR_RootConstrainSelectedInstOperands,
     /*  94249 */   // GIR_Coverage, 4736,
     /*  94249 */   GIR_EraseRootFromParent_Done,
     /*  94250 */ // Label 1756: @94250
     /*  94250 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(94290), // Rule ID 4742 //
     /*  94255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94262 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  94283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94288 */   GIR_RootConstrainSelectedInstOperands,
     /*  94289 */   // GIR_Coverage, 4742,
     /*  94289 */   GIR_EraseRootFromParent_Done,
     /*  94290 */ // Label 1757: @94290
     /*  94290 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(94330), // Rule ID 4744 //
     /*  94295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94302 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94314 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  94323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94328 */   GIR_RootConstrainSelectedInstOperands,
     /*  94329 */   // GIR_Coverage, 4744,
     /*  94329 */   GIR_EraseRootFromParent_Done,
     /*  94330 */ // Label 1758: @94330
     /*  94330 */ GIM_Reject,
     /*  94331 */ // Label 1754: @94331
     /*  94331 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(94374), // Rule ID 4738 //
     /*  94336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94346 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94358 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  94367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94372 */   GIR_RootConstrainSelectedInstOperands,
     /*  94373 */   // GIR_Coverage, 4738,
     /*  94373 */   GIR_EraseRootFromParent_Done,
     /*  94374 */ // Label 1759: @94374
     /*  94374 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(94414), // Rule ID 4746 //
     /*  94379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94386 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  94407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94412 */   GIR_RootConstrainSelectedInstOperands,
     /*  94413 */   // GIR_Coverage, 4746,
     /*  94413 */   GIR_EraseRootFromParent_Done,
     /*  94414 */ // Label 1760: @94414
     /*  94414 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(94454), // Rule ID 4748 //
     /*  94419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94426 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94438 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  94447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94452 */   GIR_RootConstrainSelectedInstOperands,
     /*  94453 */   // GIR_Coverage, 4748,
     /*  94453 */   GIR_EraseRootFromParent_Done,
     /*  94454 */ // Label 1761: @94454
     /*  94454 */ GIM_Reject,
     /*  94455 */ // Label 1755: @94455
     /*  94455 */ GIM_Reject,
     /*  94456 */ // Label 13: @94456
     /*  94456 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(94605),
     /*  94461 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  94464 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1766*/ GIMT_Encode4(94604),
     /*  94475 */   /*GILLT_s16*//*Label 1763*/ GIMT_Encode4(94487),
     /*  94479 */   /*GILLT_s32*//*Label 1764*/ GIMT_Encode4(94528),
     /*  94483 */   /*GILLT_s64*//*Label 1765*/ GIMT_Encode4(94566),
     /*  94487 */   // Label 1763: @94487
     /*  94487 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(94527), // Rule ID 4740 //
     /*  94492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94499 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  94520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94525 */     GIR_RootConstrainSelectedInstOperands,
     /*  94526 */     // GIR_Coverage, 4740,
     /*  94526 */     GIR_EraseRootFromParent_Done,
     /*  94527 */   // Label 1767: @94527
     /*  94527 */   GIM_Reject,
     /*  94528 */   // Label 1764: @94528
     /*  94528 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(94565), // Rule ID 4750 //
     /*  94533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94537 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  94558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94563 */     GIR_RootConstrainSelectedInstOperands,
     /*  94564 */     // GIR_Coverage, 4750,
     /*  94564 */     GIR_EraseRootFromParent_Done,
     /*  94565 */   // Label 1768: @94565
     /*  94565 */   GIM_Reject,
     /*  94566 */   // Label 1765: @94566
     /*  94566 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(94603), // Rule ID 4752 //
     /*  94571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94575 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  94596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94601 */     GIR_RootConstrainSelectedInstOperands,
     /*  94602 */     // GIR_Coverage, 4752,
     /*  94602 */     GIR_EraseRootFromParent_Done,
     /*  94603 */   // Label 1769: @94603
     /*  94603 */   GIM_Reject,
     /*  94604 */   // Label 1766: @94604
     /*  94604 */   GIM_Reject,
     /*  94605 */ // Label 1762: @94605
     /*  94605 */ GIM_Reject,
     /*  94606 */ // Label 14: @94606
     /*  94606 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1778*/ GIMT_Encode4(95096),
     /*  94617 */ /*GILLT_s16*//*Label 1770*/ GIMT_Encode4(94657),
     /*  94621 */ /*GILLT_s32*//*Label 1771*/ GIMT_Encode4(94688),
     /*  94625 */ /*GILLT_s64*//*Label 1772*/ GIMT_Encode4(94719), GIMT_Encode4(0),
     /*  94633 */ /*GILLT_v2s32*//*Label 1773*/ GIMT_Encode4(94750),
     /*  94637 */ /*GILLT_v2s64*//*Label 1774*/ GIMT_Encode4(94781),
     /*  94641 */ /*GILLT_v4s16*//*Label 1775*/ GIMT_Encode4(94812),
     /*  94645 */ /*GILLT_v4s32*//*Label 1776*/ GIMT_Encode4(94843), GIMT_Encode4(0),
     /*  94653 */ /*GILLT_v8s16*//*Label 1777*/ GIMT_Encode4(94874),
     /*  94657 */ // Label 1770: @94657
     /*  94657 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(94687), // Rule ID 546 //
     /*  94662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  94672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  94676 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  94676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  94681 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94685 */   GIR_RootConstrainSelectedInstOperands,
     /*  94686 */   // GIR_Coverage, 546,
     /*  94686 */   GIR_Done,
     /*  94687 */ // Label 1779: @94687
     /*  94687 */ GIM_Reject,
     /*  94688 */ // Label 1771: @94688
     /*  94688 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(94718), // Rule ID 548 //
     /*  94693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  94696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94707 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  94707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  94712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94716 */   GIR_RootConstrainSelectedInstOperands,
     /*  94717 */   // GIR_Coverage, 548,
     /*  94717 */   GIR_Done,
     /*  94718 */ // Label 1780: @94718
     /*  94718 */ GIM_Reject,
     /*  94719 */ // Label 1772: @94719
     /*  94719 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(94749), // Rule ID 550 //
     /*  94724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  94727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94738 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  94738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  94743 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94747 */   GIR_RootConstrainSelectedInstOperands,
     /*  94748 */   // GIR_Coverage, 550,
     /*  94748 */   GIR_Done,
     /*  94749 */ // Label 1781: @94749
     /*  94749 */ GIM_Reject,
     /*  94750 */ // Label 1773: @94750
     /*  94750 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(94780), // Rule ID 896 //
     /*  94755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94769 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  94769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  94774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94778 */   GIR_RootConstrainSelectedInstOperands,
     /*  94779 */   // GIR_Coverage, 896,
     /*  94779 */   GIR_Done,
     /*  94780 */ // Label 1782: @94780
     /*  94780 */ GIM_Reject,
     /*  94781 */ // Label 1774: @94781
     /*  94781 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(94811), // Rule ID 900 //
     /*  94786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94800 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  94800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  94805 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94809 */   GIR_RootConstrainSelectedInstOperands,
     /*  94810 */   // GIR_Coverage, 900,
     /*  94810 */   GIR_Done,
     /*  94811 */ // Label 1783: @94811
     /*  94811 */ GIM_Reject,
     /*  94812 */ // Label 1775: @94812
     /*  94812 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(94842), // Rule ID 892 //
     /*  94817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  94820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94831 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  94831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  94836 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94840 */   GIR_RootConstrainSelectedInstOperands,
     /*  94841 */   // GIR_Coverage, 892,
     /*  94841 */   GIR_Done,
     /*  94842 */ // Label 1784: @94842
     /*  94842 */ GIM_Reject,
     /*  94843 */ // Label 1776: @94843
     /*  94843 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(94873), // Rule ID 898 //
     /*  94848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94862 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  94862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94867 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94871 */   GIR_RootConstrainSelectedInstOperands,
     /*  94872 */   // GIR_Coverage, 898,
     /*  94872 */   GIR_Done,
     /*  94873 */ // Label 1785: @94873
     /*  94873 */ GIM_Reject,
     /*  94874 */ // Label 1777: @94874
     /*  94874 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(95095),
     /*  94879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94890 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(94909), // Rule ID 894 //
     /*  94895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  94898 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  94898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  94903 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94907 */     GIR_RootConstrainSelectedInstOperands,
     /*  94908 */     // GIR_Coverage, 894,
     /*  94908 */     GIR_Done,
     /*  94909 */   // Label 1787: @94909
     /*  94909 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(95094), // Rule ID 6919 //
     /*  94914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  94917 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  94917 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  94920 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  94924 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94929 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  94935 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  94938 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94942 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94947 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  94950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  94952 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  94955 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94959 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94964 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  94970 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94975 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94980 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  94983 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  94987 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94992 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  94995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  94997 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  95000 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  95004 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95009 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  95012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95014 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  95017 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  95021 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95026 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  95029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  95038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  95052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  95066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  95081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  95084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  95092 */     GIR_RootConstrainSelectedInstOperands,
     /*  95093 */     // GIR_Coverage, 6919,
     /*  95093 */     GIR_EraseRootFromParent_Done,
     /*  95094 */   // Label 1788: @95094
     /*  95094 */   GIM_Reject,
     /*  95095 */ // Label 1786: @95095
     /*  95095 */ GIM_Reject,
     /*  95096 */ // Label 1778: @95096
     /*  95096 */ GIM_Reject,
     /*  95097 */ // Label 15: @95097
     /*  95097 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(95129), // Rule ID 3857 //
     /*  95102 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  95105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  95109 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  95109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  95112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95114 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  95124 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  95127 */   GIR_RootConstrainSelectedInstOperands,
     /*  95128 */   // GIR_Coverage, 3857,
     /*  95128 */   GIR_EraseRootFromParent_Done,
     /*  95129 */ // Label 1789: @95129
     /*  95129 */ GIM_Reject,
     /*  95130 */ // Label 16: @95130
     /*  95130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1810*/ GIMT_Encode4(103939),
     /*  95141 */ /*GILLT_s8*//*Label 1790*/ GIMT_Encode4(95237),
     /*  95145 */ /*GILLT_s16*//*Label 1791*/ GIMT_Encode4(95413),
     /*  95149 */ /*GILLT_s32*//*Label 1792*/ GIMT_Encode4(95589),
     /*  95153 */ /*GILLT_s64*//*Label 1793*/ GIMT_Encode4(97887),
     /*  95157 */ /*GILLT_s128*//*Label 1794*/ GIMT_Encode4(100568),
     /*  95161 */ /*GILLT_v2s32*//*Label 1795*/ GIMT_Encode4(100777),
     /*  95165 */ /*GILLT_v2s64*//*Label 1796*/ GIMT_Encode4(101155),
     /*  95169 */ /*GILLT_v4s16*//*Label 1797*/ GIMT_Encode4(101533),
     /*  95173 */ /*GILLT_v4s32*//*Label 1798*/ GIMT_Encode4(101911),
     /*  95177 */ /*GILLT_v8s8*//*Label 1799*/ GIMT_Encode4(102289),
     /*  95181 */ /*GILLT_v8s16*//*Label 1800*/ GIMT_Encode4(102497),
     /*  95185 */ /*GILLT_v16s8*//*Label 1801*/ GIMT_Encode4(102875), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  95197 */ /*GILLT_nxv2s16*//*Label 1802*/ GIMT_Encode4(103083),
     /*  95201 */ /*GILLT_nxv2s32*//*Label 1803*/ GIMT_Encode4(103147),
     /*  95205 */ /*GILLT_nxv2s64*//*Label 1804*/ GIMT_Encode4(103211), GIMT_Encode4(0),
     /*  95213 */ /*GILLT_nxv4s16*//*Label 1805*/ GIMT_Encode4(103385),
     /*  95217 */ /*GILLT_nxv4s32*//*Label 1806*/ GIMT_Encode4(103449), GIMT_Encode4(0),
     /*  95225 */ /*GILLT_nxv8s16*//*Label 1807*/ GIMT_Encode4(103623),
     /*  95229 */ /*GILLT_nxv16s1*//*Label 1808*/ GIMT_Encode4(103797),
     /*  95233 */ /*GILLT_nxv16s8*//*Label 1809*/ GIMT_Encode4(103841),
     /*  95237 */ // Label 1790: @95237
     /*  95237 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(95412),
     /*  95242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95245 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  95253 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95257 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(95298), // Rule ID 237 //
     /*  95262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  95272 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  95272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  95275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95296 */     GIR_RootConstrainSelectedInstOperands,
     /*  95297 */     // GIR_Coverage, 237,
     /*  95297 */     GIR_EraseRootFromParent_Done,
     /*  95298 */   // Label 1812: @95298
     /*  95298 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(95339), // Rule ID 238 //
     /*  95303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  95313 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  95313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  95316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95337 */     GIR_RootConstrainSelectedInstOperands,
     /*  95338 */     // GIR_Coverage, 238,
     /*  95338 */     GIR_EraseRootFromParent_Done,
     /*  95339 */   // Label 1813: @95339
     /*  95339 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(95375), // Rule ID 261 //
     /*  95344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  95354 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  95354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  95357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95373 */     GIR_RootConstrainSelectedInstOperands,
     /*  95374 */     // GIR_Coverage, 261,
     /*  95374 */     GIR_EraseRootFromParent_Done,
     /*  95375 */   // Label 1814: @95375
     /*  95375 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(95411), // Rule ID 282 //
     /*  95380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  95390 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  95390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  95393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95409 */     GIR_RootConstrainSelectedInstOperands,
     /*  95410 */     // GIR_Coverage, 282,
     /*  95410 */     GIR_EraseRootFromParent_Done,
     /*  95411 */   // Label 1815: @95411
     /*  95411 */   GIM_Reject,
     /*  95412 */ // Label 1811: @95412
     /*  95412 */ GIM_Reject,
     /*  95413 */ // Label 1791: @95413
     /*  95413 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(95588),
     /*  95418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  95429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95433 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(95474), // Rule ID 239 //
     /*  95438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  95448 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  95448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  95451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95472 */     GIR_RootConstrainSelectedInstOperands,
     /*  95473 */     // GIR_Coverage, 239,
     /*  95473 */     GIR_EraseRootFromParent_Done,
     /*  95474 */   // Label 1817: @95474
     /*  95474 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(95515), // Rule ID 240 //
     /*  95479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  95489 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  95489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  95492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95513 */     GIR_RootConstrainSelectedInstOperands,
     /*  95514 */     // GIR_Coverage, 240,
     /*  95514 */     GIR_EraseRootFromParent_Done,
     /*  95515 */   // Label 1818: @95515
     /*  95515 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(95551), // Rule ID 262 //
     /*  95520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  95530 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  95530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  95533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95549 */     GIR_RootConstrainSelectedInstOperands,
     /*  95550 */     // GIR_Coverage, 262,
     /*  95550 */     GIR_EraseRootFromParent_Done,
     /*  95551 */   // Label 1819: @95551
     /*  95551 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(95587), // Rule ID 283 //
     /*  95556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  95566 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  95566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  95569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95585 */     GIR_RootConstrainSelectedInstOperands,
     /*  95586 */     // GIR_Coverage, 283,
     /*  95586 */     GIR_EraseRootFromParent_Done,
     /*  95587 */   // Label 1820: @95587
     /*  95587 */   GIM_Reject,
     /*  95588 */ // Label 1816: @95588
     /*  95588 */ GIM_Reject,
     /*  95589 */ // Label 1792: @95589
     /*  95589 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(95642), // Rule ID 233 //
     /*  95594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  95616 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  95616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  95619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95640 */   GIR_RootConstrainSelectedInstOperands,
     /*  95641 */   // GIR_Coverage, 233,
     /*  95641 */   GIR_EraseRootFromParent_Done,
     /*  95642 */ // Label 1821: @95642
     /*  95642 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(95695), // Rule ID 234 //
     /*  95647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  95669 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  95669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  95672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95693 */   GIR_RootConstrainSelectedInstOperands,
     /*  95694 */   // GIR_Coverage, 234,
     /*  95694 */   GIR_EraseRootFromParent_Done,
     /*  95695 */ // Label 1822: @95695
     /*  95695 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(95751), // Rule ID 241 //
     /*  95700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95706 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  95714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  95725 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  95725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  95728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95749 */   GIR_RootConstrainSelectedInstOperands,
     /*  95750 */   // GIR_Coverage, 241,
     /*  95750 */   GIR_EraseRootFromParent_Done,
     /*  95751 */ // Label 1823: @95751
     /*  95751 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(95807), // Rule ID 242 //
     /*  95756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  95770 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95774 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  95781 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  95781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  95784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95805 */   GIR_RootConstrainSelectedInstOperands,
     /*  95806 */   // GIR_Coverage, 242,
     /*  95806 */   GIR_EraseRootFromParent_Done,
     /*  95807 */ // Label 1824: @95807
     /*  95807 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(95867), // Rule ID 4073 //
     /*  95812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95815 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  95841 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  95841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  95844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95865 */   GIR_RootConstrainSelectedInstOperands,
     /*  95866 */   // GIR_Coverage, 4073,
     /*  95866 */   GIR_EraseRootFromParent_Done,
     /*  95867 */ // Label 1825: @95867
     /*  95867 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(95927), // Rule ID 4074 //
     /*  95872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95875 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  95901 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  95901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  95904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95925 */   GIR_RootConstrainSelectedInstOperands,
     /*  95926 */   // GIR_Coverage, 4074,
     /*  95926 */   GIR_EraseRootFromParent_Done,
     /*  95927 */ // Label 1826: @95927
     /*  95927 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(95987), // Rule ID 4075 //
     /*  95932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95935 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  95961 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  95961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  95964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95985 */   GIR_RootConstrainSelectedInstOperands,
     /*  95986 */   // GIR_Coverage, 4075,
     /*  95986 */   GIR_EraseRootFromParent_Done,
     /*  95987 */ // Label 1827: @95987
     /*  95987 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(96047), // Rule ID 4076 //
     /*  95992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95995 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96010 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  96021 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  96021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  96024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96045 */   GIR_RootConstrainSelectedInstOperands,
     /*  96046 */   // GIR_Coverage, 4076,
     /*  96046 */   GIR_EraseRootFromParent_Done,
     /*  96047 */ // Label 1828: @96047
     /*  96047 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(96107), // Rule ID 4077 //
     /*  96052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96055 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96074 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  96081 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  96081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  96084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96101 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96105 */   GIR_RootConstrainSelectedInstOperands,
     /*  96106 */   // GIR_Coverage, 4077,
     /*  96106 */   GIR_EraseRootFromParent_Done,
     /*  96107 */ // Label 1829: @96107
     /*  96107 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(96167), // Rule ID 4078 //
     /*  96112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96115 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96119 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96130 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96134 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  96141 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  96141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  96144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96165 */   GIR_RootConstrainSelectedInstOperands,
     /*  96166 */   // GIR_Coverage, 4078,
     /*  96166 */   GIR_EraseRootFromParent_Done,
     /*  96167 */ // Label 1830: @96167
     /*  96167 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(96215), // Rule ID 260 //
     /*  96172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96194 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  96197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96213 */   GIR_RootConstrainSelectedInstOperands,
     /*  96214 */   // GIR_Coverage, 260,
     /*  96214 */   GIR_EraseRootFromParent_Done,
     /*  96215 */ // Label 1831: @96215
     /*  96215 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(96266), // Rule ID 263 //
     /*  96220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96226 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96238 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96245 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  96248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96264 */   GIR_RootConstrainSelectedInstOperands,
     /*  96265 */   // GIR_Coverage, 263,
     /*  96265 */   GIR_EraseRootFromParent_Done,
     /*  96266 */ // Label 1832: @96266
     /*  96266 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(96325), // Rule ID 6947 //
     /*  96271 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96281 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96292 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  96299 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15713>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /*  96299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  96302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96323 */   GIR_RootConstrainSelectedInstOperands,
     /*  96324 */   // GIR_Coverage, 6947,
     /*  96324 */   GIR_EraseRootFromParent_Done,
     /*  96325 */ // Label 1833: @96325
     /*  96325 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(96384), // Rule ID 6949 //
     /*  96330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96340 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  96358 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15713>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /*  96358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  96361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96382 */   GIR_RootConstrainSelectedInstOperands,
     /*  96383 */   // GIR_Coverage, 6949,
     /*  96383 */   GIR_EraseRootFromParent_Done,
     /*  96384 */ // Label 1834: @96384
     /*  96384 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(96443), // Rule ID 6959 //
     /*  96389 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96399 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  96417 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15722>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  96417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  96420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96441 */   GIR_RootConstrainSelectedInstOperands,
     /*  96442 */   // GIR_Coverage, 6959,
     /*  96442 */   GIR_EraseRootFromParent_Done,
     /*  96443 */ // Label 1835: @96443
     /*  96443 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(96502), // Rule ID 6961 //
     /*  96448 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96451 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96458 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  96476 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15722>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  96476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  96479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96500 */   GIR_RootConstrainSelectedInstOperands,
     /*  96501 */   // GIR_Coverage, 6961,
     /*  96501 */   GIR_EraseRootFromParent_Done,
     /*  96502 */ // Label 1836: @96502
     /*  96502 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(96561), // Rule ID 6969 //
     /*  96507 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96517 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  96535 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15730>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  96535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  96538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96559 */   GIR_RootConstrainSelectedInstOperands,
     /*  96560 */   // GIR_Coverage, 6969,
     /*  96560 */   GIR_EraseRootFromParent_Done,
     /*  96561 */ // Label 1837: @96561
     /*  96561 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(96620), // Rule ID 6970 //
     /*  96566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96576 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  96594 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15730>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  96594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  96597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96618 */   GIR_RootConstrainSelectedInstOperands,
     /*  96619 */   // GIR_Coverage, 6970,
     /*  96619 */   GIR_EraseRootFromParent_Done,
     /*  96620 */ // Label 1838: @96620
     /*  96620 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(96668), // Rule ID 281 //
     /*  96625 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  96647 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  96647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  96650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96666 */   GIR_RootConstrainSelectedInstOperands,
     /*  96667 */   // GIR_Coverage, 281,
     /*  96667 */   GIR_EraseRootFromParent_Done,
     /*  96668 */ // Label 1839: @96668
     /*  96668 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(96719), // Rule ID 284 //
     /*  96673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  96698 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  96698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  96701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96717 */   GIR_RootConstrainSelectedInstOperands,
     /*  96718 */   // GIR_Coverage, 284,
     /*  96718 */   GIR_EraseRootFromParent_Done,
     /*  96719 */ // Label 1840: @96719
     /*  96719 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(96773), // Rule ID 6951 //
     /*  96724 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96734 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  96752 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15713>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  96752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  96755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96771 */   GIR_RootConstrainSelectedInstOperands,
     /*  96772 */   // GIR_Coverage, 6951,
     /*  96772 */   GIR_EraseRootFromParent_Done,
     /*  96773 */ // Label 1841: @96773
     /*  96773 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(96827), // Rule ID 6953 //
     /*  96778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  96806 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15713>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  96806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  96809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96825 */   GIR_RootConstrainSelectedInstOperands,
     /*  96826 */   // GIR_Coverage, 6953,
     /*  96826 */   GIR_EraseRootFromParent_Done,
     /*  96827 */ // Label 1842: @96827
     /*  96827 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(96881), // Rule ID 6963 //
     /*  96832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96842 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96849 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96853 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  96860 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15722>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  96860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  96863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96875 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96879 */   GIR_RootConstrainSelectedInstOperands,
     /*  96880 */   // GIR_Coverage, 6963,
     /*  96880 */   GIR_EraseRootFromParent_Done,
     /*  96881 */ // Label 1843: @96881
     /*  96881 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(96935), // Rule ID 6965 //
     /*  96886 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96896 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  96914 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15722>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  96914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  96917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96933 */   GIR_RootConstrainSelectedInstOperands,
     /*  96934 */   // GIR_Coverage, 6965,
     /*  96934 */   GIR_EraseRootFromParent_Done,
     /*  96935 */ // Label 1844: @96935
     /*  96935 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(96989), // Rule ID 6971 //
     /*  96940 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96943 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96950 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96968 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15730>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  96971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96987 */   GIR_RootConstrainSelectedInstOperands,
     /*  96988 */   // GIR_Coverage, 6971,
     /*  96988 */   GIR_EraseRootFromParent_Done,
     /*  96989 */ // Label 1845: @96989
     /*  96989 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(97043), // Rule ID 6972 //
     /*  96994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97004 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  97022 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15730>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  97025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97041 */   GIR_RootConstrainSelectedInstOperands,
     /*  97042 */   // GIR_Coverage, 6972,
     /*  97042 */   GIR_EraseRootFromParent_Done,
     /*  97043 */ // Label 1846: @97043
     /*  97043 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(97100), // Rule ID 7327 //
     /*  97048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97051 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97054 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97079 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15711>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /*  97082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97098 */   GIR_RootConstrainSelectedInstOperands,
     /*  97099 */   // GIR_Coverage, 7327,
     /*  97099 */   GIR_EraseRootFromParent_Done,
     /*  97100 */ // Label 1847: @97100
     /*  97100 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(97157), // Rule ID 7329 //
     /*  97105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97108 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97118 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  97136 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15720>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /*  97139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97155 */   GIR_RootConstrainSelectedInstOperands,
     /*  97156 */   // GIR_Coverage, 7329,
     /*  97156 */   GIR_EraseRootFromParent_Done,
     /*  97157 */ // Label 1848: @97157
     /*  97157 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(97214), // Rule ID 7331 //
     /*  97162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  97193 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15705>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /*  97196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97212 */   GIR_RootConstrainSelectedInstOperands,
     /*  97213 */   // GIR_Coverage, 7331,
     /*  97213 */   GIR_EraseRootFromParent_Done,
     /*  97214 */ // Label 1849: @97214
     /*  97214 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(97269), // Rule ID 4100 //
     /*  97219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97222 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  97248 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  97248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  97251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97263 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97267 */   GIR_RootConstrainSelectedInstOperands,
     /*  97268 */   // GIR_Coverage, 4100,
     /*  97268 */   GIR_EraseRootFromParent_Done,
     /*  97269 */ // Label 1850: @97269
     /*  97269 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(97324), // Rule ID 4101 //
     /*  97274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97277 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97281 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  97303 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  97303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  97306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97322 */   GIR_RootConstrainSelectedInstOperands,
     /*  97323 */   // GIR_Coverage, 4101,
     /*  97323 */   GIR_EraseRootFromParent_Done,
     /*  97324 */ // Label 1851: @97324
     /*  97324 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(97379), // Rule ID 4102 //
     /*  97329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  97358 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  97358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  97361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97373 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97377 */   GIR_RootConstrainSelectedInstOperands,
     /*  97378 */   // GIR_Coverage, 4102,
     /*  97378 */   GIR_EraseRootFromParent_Done,
     /*  97379 */ // Label 1852: @97379
     /*  97379 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(97434), // Rule ID 4123 //
     /*  97384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97387 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97391 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97406 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  97413 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  97416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97432 */   GIR_RootConstrainSelectedInstOperands,
     /*  97433 */   // GIR_Coverage, 4123,
     /*  97433 */   GIR_EraseRootFromParent_Done,
     /*  97434 */ // Label 1853: @97434
     /*  97434 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(97489), // Rule ID 4124 //
     /*  97439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97442 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97468 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  97471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97487 */   GIR_RootConstrainSelectedInstOperands,
     /*  97488 */   // GIR_Coverage, 4124,
     /*  97488 */   GIR_EraseRootFromParent_Done,
     /*  97489 */ // Label 1854: @97489
     /*  97489 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(97544), // Rule ID 4125 //
     /*  97494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97497 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97516 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97523 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  97526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97542 */   GIR_RootConstrainSelectedInstOperands,
     /*  97543 */   // GIR_Coverage, 4125,
     /*  97543 */   GIR_EraseRootFromParent_Done,
     /*  97544 */ // Label 1855: @97544
     /*  97544 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(97584), // Rule ID 6939 //
     /*  97549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97552 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97569 */   // MIs[0] ptr
     /*  97569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97577 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15701>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /*  97582 */   GIR_RootConstrainSelectedInstOperands,
     /*  97583 */   // GIR_Coverage, 6939,
     /*  97583 */   GIR_Done,
     /*  97584 */ // Label 1856: @97584
     /*  97584 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(97624), // Rule ID 6940 //
     /*  97589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97595 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97602 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97609 */   // MIs[0] ptr
     /*  97609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97617 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15703>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /*  97622 */   GIR_RootConstrainSelectedInstOperands,
     /*  97623 */   // GIR_Coverage, 6940,
     /*  97623 */   GIR_Done,
     /*  97624 */ // Label 1857: @97624
     /*  97624 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(97664), // Rule ID 6941 //
     /*  97629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97632 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97635 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97642 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97649 */   // MIs[0] ptr
     /*  97649 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97657 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15705>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /*  97662 */   GIR_RootConstrainSelectedInstOperands,
     /*  97663 */   // GIR_Coverage, 6941,
     /*  97663 */   GIR_Done,
     /*  97664 */ // Label 1858: @97664
     /*  97664 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(97701), // Rule ID 6943 //
     /*  97669 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97679 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97686 */   // MIs[0] ptr
     /*  97686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97694 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15709>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /*  97699 */   GIR_RootConstrainSelectedInstOperands,
     /*  97700 */   // GIR_Coverage, 6943,
     /*  97700 */   GIR_Done,
     /*  97701 */ // Label 1859: @97701
     /*  97701 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(97738), // Rule ID 6945 //
     /*  97706 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97709 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97723 */   // MIs[0] ptr
     /*  97723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97731 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15711>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /*  97736 */   GIR_RootConstrainSelectedInstOperands,
     /*  97737 */   // GIR_Coverage, 6945,
     /*  97737 */   GIR_Done,
     /*  97738 */ // Label 1860: @97738
     /*  97738 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(97775), // Rule ID 6955 //
     /*  97743 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97760 */   // MIs[0] ptr
     /*  97760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97768 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15718>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /*  97773 */   GIR_RootConstrainSelectedInstOperands,
     /*  97774 */   // GIR_Coverage, 6955,
     /*  97774 */   GIR_Done,
     /*  97775 */ // Label 1861: @97775
     /*  97775 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(97812), // Rule ID 6957 //
     /*  97780 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97783 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97797 */   // MIs[0] ptr
     /*  97797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97805 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15720>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /*  97810 */   GIR_RootConstrainSelectedInstOperands,
     /*  97811 */   // GIR_Coverage, 6957,
     /*  97811 */   GIR_Done,
     /*  97812 */ // Label 1862: @97812
     /*  97812 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(97849), // Rule ID 6967 //
     /*  97817 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97834 */   // MIs[0] ptr
     /*  97834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97842 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15727>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /*  97847 */   GIR_RootConstrainSelectedInstOperands,
     /*  97848 */   // GIR_Coverage, 6967,
     /*  97848 */   GIR_Done,
     /*  97849 */ // Label 1863: @97849
     /*  97849 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(97886), // Rule ID 6968 //
     /*  97854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97871 */   // MIs[0] ptr
     /*  97871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97879 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15705>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /*  97884 */   GIR_RootConstrainSelectedInstOperands,
     /*  97885 */   // GIR_Coverage, 6968,
     /*  97885 */   GIR_Done,
     /*  97886 */ // Label 1864: @97886
     /*  97886 */ GIM_Reject,
     /*  97887 */ // Label 1793: @97887
     /*  97887 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(97940), // Rule ID 235 //
     /*  97892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97895 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  97914 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  97914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /*  97917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  97929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  97934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97938 */   GIR_RootConstrainSelectedInstOperands,
     /*  97939 */   // GIR_Coverage, 235,
     /*  97939 */   GIR_EraseRootFromParent_Done,
     /*  97940 */ // Label 1865: @97940
     /*  97940 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(97993), // Rule ID 236 //
     /*  97945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97948 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97956 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  97967 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  97967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /*  97970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  97982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  97987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97991 */   GIR_RootConstrainSelectedInstOperands,
     /*  97992 */   // GIR_Coverage, 236,
     /*  97992 */   GIR_EraseRootFromParent_Done,
     /*  97993 */ // Label 1866: @97993
     /*  97993 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(98049), // Rule ID 243 //
     /*  97998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98023 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98043 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98047 */   GIR_RootConstrainSelectedInstOperands,
     /*  98048 */   // GIR_Coverage, 243,
     /*  98048 */   GIR_EraseRootFromParent_Done,
     /*  98049 */ // Label 1867: @98049
     /*  98049 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(98105), // Rule ID 244 //
     /*  98054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98079 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98103 */   GIR_RootConstrainSelectedInstOperands,
     /*  98104 */   // GIR_Coverage, 244,
     /*  98104 */   GIR_EraseRootFromParent_Done,
     /*  98105 */ // Label 1868: @98105
     /*  98105 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(98158), // Rule ID 4039 //
     /*  98110 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98113 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98121 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98125 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98132 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98156 */   GIR_RootConstrainSelectedInstOperands,
     /*  98157 */   // GIR_Coverage, 4039,
     /*  98157 */   GIR_EraseRootFromParent_Done,
     /*  98158 */ // Label 1869: @98158
     /*  98158 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(98211), // Rule ID 4040 //
     /*  98163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98185 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98209 */   GIR_RootConstrainSelectedInstOperands,
     /*  98210 */   // GIR_Coverage, 4040,
     /*  98210 */   GIR_EraseRootFromParent_Done,
     /*  98211 */ // Label 1870: @98211
     /*  98211 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(98264), // Rule ID 4041 //
     /*  98216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98238 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98262 */   GIR_RootConstrainSelectedInstOperands,
     /*  98263 */   // GIR_Coverage, 4041,
     /*  98263 */   GIR_EraseRootFromParent_Done,
     /*  98264 */ // Label 1871: @98264
     /*  98264 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(98317), // Rule ID 4042 //
     /*  98269 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98272 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98284 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98291 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98315 */   GIR_RootConstrainSelectedInstOperands,
     /*  98316 */   // GIR_Coverage, 4042,
     /*  98316 */   GIR_EraseRootFromParent_Done,
     /*  98317 */ // Label 1872: @98317
     /*  98317 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(98409), // Rule ID 4065 //
     /*  98322 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98325 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98329 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98340 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98344 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98351 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98378 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98408 */   // GIR_Coverage, 4065,
     /*  98408 */   GIR_EraseRootFromParent_Done,
     /*  98409 */ // Label 1873: @98409
     /*  98409 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(98501), // Rule ID 4066 //
     /*  98414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98417 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98421 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98443 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  98450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98470 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98500 */   // GIR_Coverage, 4066,
     /*  98500 */   GIR_EraseRootFromParent_Done,
     /*  98501 */ // Label 1874: @98501
     /*  98501 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(98593), // Rule ID 4067 //
     /*  98506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98509 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  98535 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  98542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98562 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98592 */   // GIR_Coverage, 4067,
     /*  98592 */   GIR_EraseRootFromParent_Done,
     /*  98593 */ // Label 1875: @98593
     /*  98593 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(98685), // Rule ID 4068 //
     /*  98598 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98601 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98605 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  98627 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  98634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98654 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98684 */   // GIR_Coverage, 4068,
     /*  98684 */   GIR_EraseRootFromParent_Done,
     /*  98685 */ // Label 1876: @98685
     /*  98685 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(98777), // Rule ID 4069 //
     /*  98690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98693 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  98719 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  98726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98746 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98776 */   // GIR_Coverage, 4069,
     /*  98776 */   GIR_EraseRootFromParent_Done,
     /*  98777 */ // Label 1877: @98777
     /*  98777 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(98869), // Rule ID 4070 //
     /*  98782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98785 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  98811 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  98818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98838 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98858 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98868 */   // GIR_Coverage, 4070,
     /*  98868 */   GIR_EraseRootFromParent_Done,
     /*  98869 */ // Label 1878: @98869
     /*  98869 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(98961), // Rule ID 4071 //
     /*  98874 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98877 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98881 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98903 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98930 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98960 */   // GIR_Coverage, 4071,
     /*  98960 */   GIR_EraseRootFromParent_Done,
     /*  98961 */ // Label 1879: @98961
     /*  98961 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(99053), // Rule ID 4072 //
     /*  98966 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98969 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98973 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98995 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99022 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99052 */   // GIR_Coverage, 4072,
     /*  99052 */   GIR_EraseRootFromParent_Done,
     /*  99053 */ // Label 1880: @99053
     /*  99053 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(99101), // Rule ID 259 //
     /*  99058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99061 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99080 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /*  99083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99099 */   GIR_RootConstrainSelectedInstOperands,
     /*  99100 */   // GIR_Coverage, 259,
     /*  99100 */   GIR_EraseRootFromParent_Done,
     /*  99101 */ // Label 1881: @99101
     /*  99101 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(99152), // Rule ID 264 //
     /*  99106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99124 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99131 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99150 */   GIR_RootConstrainSelectedInstOperands,
     /*  99151 */   // GIR_Coverage, 264,
     /*  99151 */   GIR_EraseRootFromParent_Done,
     /*  99152 */ // Label 1882: @99152
     /*  99152 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(99211), // Rule ID 6975 //
     /*  99157 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99160 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99167 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  99185 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15738>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  99185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /*  99188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99209 */   GIR_RootConstrainSelectedInstOperands,
     /*  99210 */   // GIR_Coverage, 6975,
     /*  99210 */   GIR_EraseRootFromParent_Done,
     /*  99211 */ // Label 1883: @99211
     /*  99211 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(99270), // Rule ID 6976 //
     /*  99216 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99226 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99233 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99237 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  99244 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15738>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  99244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /*  99247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99268 */   GIR_RootConstrainSelectedInstOperands,
     /*  99269 */   // GIR_Coverage, 6976,
     /*  99269 */   GIR_EraseRootFromParent_Done,
     /*  99270 */ // Label 1884: @99270
     /*  99270 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(99318), // Rule ID 280 //
     /*  99275 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99286 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99290 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99297 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /*  99300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99316 */   GIR_RootConstrainSelectedInstOperands,
     /*  99317 */   // GIR_Coverage, 280,
     /*  99317 */   GIR_EraseRootFromParent_Done,
     /*  99318 */ // Label 1885: @99318
     /*  99318 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(99369), // Rule ID 285 //
     /*  99323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99329 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99348 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  99351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99367 */   GIR_RootConstrainSelectedInstOperands,
     /*  99368 */   // GIR_Coverage, 285,
     /*  99368 */   GIR_EraseRootFromParent_Done,
     /*  99369 */ // Label 1886: @99369
     /*  99369 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(99423), // Rule ID 6977 //
     /*  99374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99402 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15738>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /*  99405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99421 */   GIR_RootConstrainSelectedInstOperands,
     /*  99422 */   // GIR_Coverage, 6977,
     /*  99422 */   GIR_EraseRootFromParent_Done,
     /*  99423 */ // Label 1887: @99423
     /*  99423 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(99477), // Rule ID 6978 //
     /*  99428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99456 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15738>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /*  99459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99475 */   GIR_RootConstrainSelectedInstOperands,
     /*  99476 */   // GIR_Coverage, 6978,
     /*  99476 */   GIR_EraseRootFromParent_Done,
     /*  99477 */ // Label 1888: @99477
     /*  99477 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(99534), // Rule ID 7332 //
     /*  99482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  99485 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99506 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99513 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15707>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /*  99516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99532 */   GIR_RootConstrainSelectedInstOperands,
     /*  99533 */   // GIR_Coverage, 7332,
     /*  99533 */   GIR_EraseRootFromParent_Done,
     /*  99534 */ // Label 1889: @99534
     /*  99534 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(99582), // Rule ID 4086 //
     /*  99539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99542 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99561 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99580 */   GIR_RootConstrainSelectedInstOperands,
     /*  99581 */   // GIR_Coverage, 4086,
     /*  99581 */   GIR_EraseRootFromParent_Done,
     /*  99582 */ // Label 1890: @99582
     /*  99582 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(99630), // Rule ID 4087 //
     /*  99587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99609 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99628 */   GIR_RootConstrainSelectedInstOperands,
     /*  99629 */   // GIR_Coverage, 4087,
     /*  99629 */   GIR_EraseRootFromParent_Done,
     /*  99630 */ // Label 1891: @99630
     /*  99630 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(99717), // Rule ID 4103 //
     /*  99635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99638 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99664 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99686 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99716 */   // GIR_Coverage, 4103,
     /*  99716 */   GIR_EraseRootFromParent_Done,
     /*  99717 */ // Label 1892: @99717
     /*  99717 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(99804), // Rule ID 4104 //
     /*  99722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99725 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99751 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  99758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99773 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99803 */   // GIR_Coverage, 4104,
     /*  99803 */   GIR_EraseRootFromParent_Done,
     /*  99804 */ // Label 1893: @99804
     /*  99804 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(99891), // Rule ID 4105 //
     /*  99809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99838 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99860 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99890 */   // GIR_Coverage, 4105,
     /*  99890 */   GIR_EraseRootFromParent_Done,
     /*  99891 */ // Label 1894: @99891
     /*  99891 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(99978), // Rule ID 4106 //
     /*  99896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99899 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99903 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99925 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99947 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99977 */   // GIR_Coverage, 4106,
     /*  99977 */   GIR_EraseRootFromParent_Done,
     /*  99978 */ // Label 1895: @99978
     /*  99978 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(100026), // Rule ID 4114 //
     /*  99983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99986 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 100005 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 100008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100020 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100024 */   GIR_RootConstrainSelectedInstOperands,
     /* 100025 */   // GIR_Coverage, 4114,
     /* 100025 */   GIR_EraseRootFromParent_Done,
     /* 100026 */ // Label 1896: @100026
     /* 100026 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(100074), // Rule ID 4115 //
     /* 100031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 100053 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 100056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100072 */   GIR_RootConstrainSelectedInstOperands,
     /* 100073 */   // GIR_Coverage, 4115,
     /* 100073 */   GIR_EraseRootFromParent_Done,
     /* 100074 */ // Label 1897: @100074
     /* 100074 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(100161), // Rule ID 4126 //
     /* 100079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100082 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100086 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100108 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100130 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100160 */   // GIR_Coverage, 4126,
     /* 100160 */   GIR_EraseRootFromParent_Done,
     /* 100161 */ // Label 1898: @100161
     /* 100161 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(100248), // Rule ID 4127 //
     /* 100166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100169 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100173 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100195 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100217 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100242 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100247 */   // GIR_Coverage, 4127,
     /* 100247 */   GIR_EraseRootFromParent_Done,
     /* 100248 */ // Label 1899: @100248
     /* 100248 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(100335), // Rule ID 4128 //
     /* 100253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100256 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100282 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100304 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100334 */   // GIR_Coverage, 4128,
     /* 100334 */   GIR_EraseRootFromParent_Done,
     /* 100335 */ // Label 1900: @100335
     /* 100335 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(100422), // Rule ID 4129 //
     /* 100340 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100343 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100347 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100369 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100391 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100411 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100421 */   // GIR_Coverage, 4129,
     /* 100421 */   GIR_EraseRootFromParent_Done,
     /* 100422 */ // Label 1901: @100422
     /* 100422 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(100462), // Rule ID 6942 //
     /* 100427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 100430 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100447 */   // MIs[0] ptr
     /* 100447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100455 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15707>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 100460 */   GIR_RootConstrainSelectedInstOperands,
     /* 100461 */   // GIR_Coverage, 6942,
     /* 100461 */   GIR_Done,
     /* 100462 */ // Label 1902: @100462
     /* 100462 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(100499), // Rule ID 6973 //
     /* 100467 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100477 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 100480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100484 */   // MIs[0] ptr
     /* 100484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100492 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15735>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 100497 */   GIR_RootConstrainSelectedInstOperands,
     /* 100498 */   // GIR_Coverage, 6973,
     /* 100498 */   GIR_Done,
     /* 100499 */ // Label 1903: @100499
     /* 100499 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(100536), // Rule ID 6974 //
     /* 100504 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100507 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100514 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100521 */   // MIs[0] ptr
     /* 100521 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100529 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15707>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 100534 */   GIR_RootConstrainSelectedInstOperands,
     /* 100535 */   // GIR_Coverage, 6974,
     /* 100535 */   GIR_Done,
     /* 100536 */ // Label 1904: @100536
     /* 100536 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(100567), // Rule ID 6322 //
     /* 100541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100544 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100552 */   // MIs[0] Rn
     /* 100552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100560 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 100560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 100565 */   GIR_RootConstrainSelectedInstOperands,
     /* 100566 */   // GIR_Coverage, 6322,
     /* 100566 */   GIR_Done,
     /* 100567 */ // Label 1905: @100567
     /* 100567 */ GIM_Reject,
     /* 100568 */ // Label 1794: @100568
     /* 100568 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(100776),
     /* 100573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100584 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100588 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(100629), // Rule ID 245 //
     /* 100593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 100603 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 100603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 100606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100627 */     GIR_RootConstrainSelectedInstOperands,
     /* 100628 */     // GIR_Coverage, 245,
     /* 100628 */     GIR_EraseRootFromParent_Done,
     /* 100629 */   // Label 1907: @100629
     /* 100629 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(100670), // Rule ID 246 //
     /* 100634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 100644 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 100644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 100647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100668 */     GIR_RootConstrainSelectedInstOperands,
     /* 100669 */     // GIR_Coverage, 246,
     /* 100669 */     GIR_EraseRootFromParent_Done,
     /* 100670 */   // Label 1908: @100670
     /* 100670 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(100706), // Rule ID 265 //
     /* 100675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 100685 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 100685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 100688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100704 */     GIR_RootConstrainSelectedInstOperands,
     /* 100705 */     // GIR_Coverage, 265,
     /* 100705 */     GIR_EraseRootFromParent_Done,
     /* 100706 */   // Label 1909: @100706
     /* 100706 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(100742), // Rule ID 286 //
     /* 100711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 100721 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 100724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100740 */     GIR_RootConstrainSelectedInstOperands,
     /* 100741 */     // GIR_Coverage, 286,
     /* 100741 */     GIR_EraseRootFromParent_Done,
     /* 100742 */   // Label 1910: @100742
     /* 100742 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(100775), // Rule ID 4095 //
     /* 100747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 100754 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 100754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 100757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100773 */     GIR_RootConstrainSelectedInstOperands,
     /* 100774 */     // GIR_Coverage, 4095,
     /* 100774 */     GIR_EraseRootFromParent_Done,
     /* 100775 */   // Label 1911: @100775
     /* 100775 */   GIM_Reject,
     /* 100776 */ // Label 1906: @100776
     /* 100776 */ GIM_Reject,
     /* 100777 */ // Label 1795: @100777
     /* 100777 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(101154),
     /* 100782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100793 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(100838), // Rule ID 4029 //
     /* 100798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100812 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100836 */     GIR_RootConstrainSelectedInstOperands,
     /* 100837 */     // GIR_Coverage, 4029,
     /* 100837 */     GIR_EraseRootFromParent_Done,
     /* 100838 */   // Label 1913: @100838
     /* 100838 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(100883), // Rule ID 4030 //
     /* 100843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100857 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100881 */     GIR_RootConstrainSelectedInstOperands,
     /* 100882 */     // GIR_Coverage, 4030,
     /* 100882 */     GIR_EraseRootFromParent_Done,
     /* 100883 */   // Label 1914: @100883
     /* 100883 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(100928), // Rule ID 4031 //
     /* 100888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100902 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100926 */     GIR_RootConstrainSelectedInstOperands,
     /* 100927 */     // GIR_Coverage, 4031,
     /* 100927 */     GIR_EraseRootFromParent_Done,
     /* 100928 */   // Label 1915: @100928
     /* 100928 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(100973), // Rule ID 4032 //
     /* 100933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100947 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100971 */     GIR_RootConstrainSelectedInstOperands,
     /* 100972 */     // GIR_Coverage, 4032,
     /* 100972 */     GIR_EraseRootFromParent_Done,
     /* 100973 */   // Label 1916: @100973
     /* 100973 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(101013), // Rule ID 4081 //
     /* 100978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 100992 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 100992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 100995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101011 */     GIR_RootConstrainSelectedInstOperands,
     /* 101012 */     // GIR_Coverage, 4081,
     /* 101012 */     GIR_EraseRootFromParent_Done,
     /* 101013 */   // Label 1917: @101013
     /* 101013 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(101053), // Rule ID 4084 //
     /* 101018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101032 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101051 */     GIR_RootConstrainSelectedInstOperands,
     /* 101052 */     // GIR_Coverage, 4084,
     /* 101052 */     GIR_EraseRootFromParent_Done,
     /* 101053 */   // Label 1918: @101053
     /* 101053 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(101093), // Rule ID 4109 //
     /* 101058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101072 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101091 */     GIR_RootConstrainSelectedInstOperands,
     /* 101092 */     // GIR_Coverage, 4109,
     /* 101092 */     GIR_EraseRootFromParent_Done,
     /* 101093 */   // Label 1919: @101093
     /* 101093 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(101133), // Rule ID 4110 //
     /* 101098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101112 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101131 */     GIR_RootConstrainSelectedInstOperands,
     /* 101132 */     // GIR_Coverage, 4110,
     /* 101132 */     GIR_EraseRootFromParent_Done,
     /* 101133 */   // Label 1920: @101133
     /* 101133 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(101153), // Rule ID 6321 //
     /* 101138 */     // MIs[0] Rn
     /* 101138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101146 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 101151 */     GIR_RootConstrainSelectedInstOperands,
     /* 101152 */     // GIR_Coverage, 6321,
     /* 101152 */     GIR_Done,
     /* 101153 */   // Label 1921: @101153
     /* 101153 */   GIM_Reject,
     /* 101154 */ // Label 1912: @101154
     /* 101154 */ GIM_Reject,
     /* 101155 */ // Label 1796: @101155
     /* 101155 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(101532),
     /* 101160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101163 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101171 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(101216), // Rule ID 4043 //
     /* 101176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101190 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101214 */     GIR_RootConstrainSelectedInstOperands,
     /* 101215 */     // GIR_Coverage, 4043,
     /* 101215 */     GIR_EraseRootFromParent_Done,
     /* 101216 */   // Label 1923: @101216
     /* 101216 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(101261), // Rule ID 4044 //
     /* 101221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101235 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101259 */     GIR_RootConstrainSelectedInstOperands,
     /* 101260 */     // GIR_Coverage, 4044,
     /* 101260 */     GIR_EraseRootFromParent_Done,
     /* 101261 */   // Label 1924: @101261
     /* 101261 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(101306), // Rule ID 4045 //
     /* 101266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101280 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101304 */     GIR_RootConstrainSelectedInstOperands,
     /* 101305 */     // GIR_Coverage, 4045,
     /* 101305 */     GIR_EraseRootFromParent_Done,
     /* 101306 */   // Label 1925: @101306
     /* 101306 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(101351), // Rule ID 4046 //
     /* 101311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101325 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101349 */     GIR_RootConstrainSelectedInstOperands,
     /* 101350 */     // GIR_Coverage, 4046,
     /* 101350 */     GIR_EraseRootFromParent_Done,
     /* 101351 */   // Label 1926: @101351
     /* 101351 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(101391), // Rule ID 4089 //
     /* 101356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 101370 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 101370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 101373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101389 */     GIR_RootConstrainSelectedInstOperands,
     /* 101390 */     // GIR_Coverage, 4089,
     /* 101390 */     GIR_EraseRootFromParent_Done,
     /* 101391 */   // Label 1927: @101391
     /* 101391 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(101431), // Rule ID 4093 //
     /* 101396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 101410 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 101410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 101413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101429 */     GIR_RootConstrainSelectedInstOperands,
     /* 101430 */     // GIR_Coverage, 4093,
     /* 101430 */     GIR_EraseRootFromParent_Done,
     /* 101431 */   // Label 1928: @101431
     /* 101431 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(101471), // Rule ID 4116 //
     /* 101436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 101450 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 101453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101469 */     GIR_RootConstrainSelectedInstOperands,
     /* 101470 */     // GIR_Coverage, 4116,
     /* 101470 */     GIR_EraseRootFromParent_Done,
     /* 101471 */   // Label 1929: @101471
     /* 101471 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(101511), // Rule ID 4117 //
     /* 101476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 101490 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 101493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101509 */     GIR_RootConstrainSelectedInstOperands,
     /* 101510 */     // GIR_Coverage, 4117,
     /* 101510 */     GIR_EraseRootFromParent_Done,
     /* 101511 */   // Label 1930: @101511
     /* 101511 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(101531), // Rule ID 6318 //
     /* 101516 */     // MIs[0] Rn
     /* 101516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101524 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 101529 */     GIR_RootConstrainSelectedInstOperands,
     /* 101530 */     // GIR_Coverage, 6318,
     /* 101530 */     GIR_Done,
     /* 101531 */   // Label 1931: @101531
     /* 101531 */   GIM_Reject,
     /* 101532 */ // Label 1922: @101532
     /* 101532 */ GIM_Reject,
     /* 101533 */ // Label 1797: @101533
     /* 101533 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(101910),
     /* 101538 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101541 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101549 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(101594), // Rule ID 4035 //
     /* 101554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101568 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101592 */     GIR_RootConstrainSelectedInstOperands,
     /* 101593 */     // GIR_Coverage, 4035,
     /* 101593 */     GIR_EraseRootFromParent_Done,
     /* 101594 */   // Label 1933: @101594
     /* 101594 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(101639), // Rule ID 4036 //
     /* 101599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101613 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101637 */     GIR_RootConstrainSelectedInstOperands,
     /* 101638 */     // GIR_Coverage, 4036,
     /* 101638 */     GIR_EraseRootFromParent_Done,
     /* 101639 */   // Label 1934: @101639
     /* 101639 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(101684), // Rule ID 4037 //
     /* 101644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101658 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101682 */     GIR_RootConstrainSelectedInstOperands,
     /* 101683 */     // GIR_Coverage, 4037,
     /* 101683 */     GIR_EraseRootFromParent_Done,
     /* 101684 */   // Label 1935: @101684
     /* 101684 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(101729), // Rule ID 4038 //
     /* 101689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101703 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101727 */     GIR_RootConstrainSelectedInstOperands,
     /* 101728 */     // GIR_Coverage, 4038,
     /* 101728 */     GIR_EraseRootFromParent_Done,
     /* 101729 */   // Label 1936: @101729
     /* 101729 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(101769), // Rule ID 4083 //
     /* 101734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101748 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101767 */     GIR_RootConstrainSelectedInstOperands,
     /* 101768 */     // GIR_Coverage, 4083,
     /* 101768 */     GIR_EraseRootFromParent_Done,
     /* 101769 */   // Label 1937: @101769
     /* 101769 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(101809), // Rule ID 4085 //
     /* 101774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101788 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101807 */     GIR_RootConstrainSelectedInstOperands,
     /* 101808 */     // GIR_Coverage, 4085,
     /* 101808 */     GIR_EraseRootFromParent_Done,
     /* 101809 */   // Label 1938: @101809
     /* 101809 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(101849), // Rule ID 4111 //
     /* 101814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101828 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101847 */     GIR_RootConstrainSelectedInstOperands,
     /* 101848 */     // GIR_Coverage, 4111,
     /* 101848 */     GIR_EraseRootFromParent_Done,
     /* 101849 */   // Label 1939: @101849
     /* 101849 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(101889), // Rule ID 4113 //
     /* 101854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101868 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101887 */     GIR_RootConstrainSelectedInstOperands,
     /* 101888 */     // GIR_Coverage, 4113,
     /* 101888 */     GIR_EraseRootFromParent_Done,
     /* 101889 */   // Label 1940: @101889
     /* 101889 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(101909), // Rule ID 6320 //
     /* 101894 */     // MIs[0] Rn
     /* 101894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101902 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 101907 */     GIR_RootConstrainSelectedInstOperands,
     /* 101908 */     // GIR_Coverage, 6320,
     /* 101908 */     GIR_Done,
     /* 101909 */   // Label 1941: @101909
     /* 101909 */   GIM_Reject,
     /* 101910 */ // Label 1932: @101910
     /* 101910 */ GIM_Reject,
     /* 101911 */ // Label 1798: @101911
     /* 101911 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(102288),
     /* 101916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101919 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101927 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(101972), // Rule ID 4047 //
     /* 101932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101946 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101970 */     GIR_RootConstrainSelectedInstOperands,
     /* 101971 */     // GIR_Coverage, 4047,
     /* 101971 */     GIR_EraseRootFromParent_Done,
     /* 101972 */   // Label 1943: @101972
     /* 101972 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(102017), // Rule ID 4048 //
     /* 101977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101991 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102015 */     GIR_RootConstrainSelectedInstOperands,
     /* 102016 */     // GIR_Coverage, 4048,
     /* 102016 */     GIR_EraseRootFromParent_Done,
     /* 102017 */   // Label 1944: @102017
     /* 102017 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(102062), // Rule ID 4049 //
     /* 102022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102036 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102060 */     GIR_RootConstrainSelectedInstOperands,
     /* 102061 */     // GIR_Coverage, 4049,
     /* 102061 */     GIR_EraseRootFromParent_Done,
     /* 102062 */   // Label 1945: @102062
     /* 102062 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(102107), // Rule ID 4050 //
     /* 102067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102081 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102105 */     GIR_RootConstrainSelectedInstOperands,
     /* 102106 */     // GIR_Coverage, 4050,
     /* 102106 */     GIR_EraseRootFromParent_Done,
     /* 102107 */   // Label 1946: @102107
     /* 102107 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(102147), // Rule ID 4088 //
     /* 102112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102126 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102145 */     GIR_RootConstrainSelectedInstOperands,
     /* 102146 */     // GIR_Coverage, 4088,
     /* 102146 */     GIR_EraseRootFromParent_Done,
     /* 102147 */   // Label 1947: @102147
     /* 102147 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(102187), // Rule ID 4092 //
     /* 102152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102166 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102185 */     GIR_RootConstrainSelectedInstOperands,
     /* 102186 */     // GIR_Coverage, 4092,
     /* 102186 */     GIR_EraseRootFromParent_Done,
     /* 102187 */   // Label 1948: @102187
     /* 102187 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(102227), // Rule ID 4118 //
     /* 102192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102206 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102225 */     GIR_RootConstrainSelectedInstOperands,
     /* 102226 */     // GIR_Coverage, 4118,
     /* 102226 */     GIR_EraseRootFromParent_Done,
     /* 102227 */   // Label 1949: @102227
     /* 102227 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(102267), // Rule ID 4119 //
     /* 102232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102246 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102265 */     GIR_RootConstrainSelectedInstOperands,
     /* 102266 */     // GIR_Coverage, 4119,
     /* 102266 */     GIR_EraseRootFromParent_Done,
     /* 102267 */   // Label 1950: @102267
     /* 102267 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(102287), // Rule ID 6317 //
     /* 102272 */     // MIs[0] Rn
     /* 102272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102280 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 102285 */     GIR_RootConstrainSelectedInstOperands,
     /* 102286 */     // GIR_Coverage, 6317,
     /* 102286 */     GIR_Done,
     /* 102287 */   // Label 1951: @102287
     /* 102287 */   GIM_Reject,
     /* 102288 */ // Label 1942: @102288
     /* 102288 */ GIM_Reject,
     /* 102289 */ // Label 1799: @102289
     /* 102289 */ GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(102496),
     /* 102294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102305 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(102350), // Rule ID 4033 //
     /* 102310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102324 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102348 */     GIR_RootConstrainSelectedInstOperands,
     /* 102349 */     // GIR_Coverage, 4033,
     /* 102349 */     GIR_EraseRootFromParent_Done,
     /* 102350 */   // Label 1953: @102350
     /* 102350 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(102395), // Rule ID 4034 //
     /* 102355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102369 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102393 */     GIR_RootConstrainSelectedInstOperands,
     /* 102394 */     // GIR_Coverage, 4034,
     /* 102394 */     GIR_EraseRootFromParent_Done,
     /* 102395 */   // Label 1954: @102395
     /* 102395 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(102435), // Rule ID 4082 //
     /* 102400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102414 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102433 */     GIR_RootConstrainSelectedInstOperands,
     /* 102434 */     // GIR_Coverage, 4082,
     /* 102434 */     GIR_EraseRootFromParent_Done,
     /* 102435 */   // Label 1955: @102435
     /* 102435 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(102475), // Rule ID 4112 //
     /* 102440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102454 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102473 */     GIR_RootConstrainSelectedInstOperands,
     /* 102474 */     // GIR_Coverage, 4112,
     /* 102474 */     GIR_EraseRootFromParent_Done,
     /* 102475 */   // Label 1956: @102475
     /* 102475 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(102495), // Rule ID 6319 //
     /* 102480 */     // MIs[0] Rn
     /* 102480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102488 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 102493 */     GIR_RootConstrainSelectedInstOperands,
     /* 102494 */     // GIR_Coverage, 6319,
     /* 102494 */     GIR_Done,
     /* 102495 */   // Label 1957: @102495
     /* 102495 */   GIM_Reject,
     /* 102496 */ // Label 1952: @102496
     /* 102496 */ GIM_Reject,
     /* 102497 */ // Label 1800: @102497
     /* 102497 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(102874),
     /* 102502 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102505 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102513 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(102558), // Rule ID 4051 //
     /* 102518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102532 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102556 */     GIR_RootConstrainSelectedInstOperands,
     /* 102557 */     // GIR_Coverage, 4051,
     /* 102557 */     GIR_EraseRootFromParent_Done,
     /* 102558 */   // Label 1959: @102558
     /* 102558 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(102603), // Rule ID 4052 //
     /* 102563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102577 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102601 */     GIR_RootConstrainSelectedInstOperands,
     /* 102602 */     // GIR_Coverage, 4052,
     /* 102602 */     GIR_EraseRootFromParent_Done,
     /* 102603 */   // Label 1960: @102603
     /* 102603 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(102648), // Rule ID 4053 //
     /* 102608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102622 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102646 */     GIR_RootConstrainSelectedInstOperands,
     /* 102647 */     // GIR_Coverage, 4053,
     /* 102647 */     GIR_EraseRootFromParent_Done,
     /* 102648 */   // Label 1961: @102648
     /* 102648 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(102693), // Rule ID 4054 //
     /* 102653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102667 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102691 */     GIR_RootConstrainSelectedInstOperands,
     /* 102692 */     // GIR_Coverage, 4054,
     /* 102692 */     GIR_EraseRootFromParent_Done,
     /* 102693 */   // Label 1962: @102693
     /* 102693 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(102733), // Rule ID 4091 //
     /* 102698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102712 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102731 */     GIR_RootConstrainSelectedInstOperands,
     /* 102732 */     // GIR_Coverage, 4091,
     /* 102732 */     GIR_EraseRootFromParent_Done,
     /* 102733 */   // Label 1963: @102733
     /* 102733 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(102773), // Rule ID 4094 //
     /* 102738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102752 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102771 */     GIR_RootConstrainSelectedInstOperands,
     /* 102772 */     // GIR_Coverage, 4094,
     /* 102772 */     GIR_EraseRootFromParent_Done,
     /* 102773 */   // Label 1964: @102773
     /* 102773 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(102813), // Rule ID 4120 //
     /* 102778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102792 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102811 */     GIR_RootConstrainSelectedInstOperands,
     /* 102812 */     // GIR_Coverage, 4120,
     /* 102812 */     GIR_EraseRootFromParent_Done,
     /* 102813 */   // Label 1965: @102813
     /* 102813 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(102853), // Rule ID 4122 //
     /* 102818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102832 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102851 */     GIR_RootConstrainSelectedInstOperands,
     /* 102852 */     // GIR_Coverage, 4122,
     /* 102852 */     GIR_EraseRootFromParent_Done,
     /* 102853 */   // Label 1966: @102853
     /* 102853 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(102873), // Rule ID 6316 //
     /* 102858 */     // MIs[0] Rn
     /* 102858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102866 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 102871 */     GIR_RootConstrainSelectedInstOperands,
     /* 102872 */     // GIR_Coverage, 6316,
     /* 102872 */     GIR_Done,
     /* 102873 */   // Label 1967: @102873
     /* 102873 */   GIM_Reject,
     /* 102874 */ // Label 1958: @102874
     /* 102874 */ GIM_Reject,
     /* 102875 */ // Label 1801: @102875
     /* 102875 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(103082),
     /* 102880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102883 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102891 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(102936), // Rule ID 4055 //
     /* 102896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102910 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102934 */     GIR_RootConstrainSelectedInstOperands,
     /* 102935 */     // GIR_Coverage, 4055,
     /* 102935 */     GIR_EraseRootFromParent_Done,
     /* 102936 */   // Label 1969: @102936
     /* 102936 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(102981), // Rule ID 4056 //
     /* 102941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102955 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102979 */     GIR_RootConstrainSelectedInstOperands,
     /* 102980 */     // GIR_Coverage, 4056,
     /* 102980 */     GIR_EraseRootFromParent_Done,
     /* 102981 */   // Label 1970: @102981
     /* 102981 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(103021), // Rule ID 4090 //
     /* 102986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 103000 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 103000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 103003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103019 */     GIR_RootConstrainSelectedInstOperands,
     /* 103020 */     // GIR_Coverage, 4090,
     /* 103020 */     GIR_EraseRootFromParent_Done,
     /* 103021 */   // Label 1971: @103021
     /* 103021 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(103061), // Rule ID 4121 //
     /* 103026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 103040 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 103043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103059 */     GIR_RootConstrainSelectedInstOperands,
     /* 103060 */     // GIR_Coverage, 4121,
     /* 103060 */     GIR_EraseRootFromParent_Done,
     /* 103061 */   // Label 1972: @103061
     /* 103061 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(103081), // Rule ID 6315 //
     /* 103066 */     // MIs[0] Rn
     /* 103066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103074 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 103074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 103079 */     GIR_RootConstrainSelectedInstOperands,
     /* 103080 */     // GIR_Coverage, 6315,
     /* 103080 */     GIR_Done,
     /* 103081 */   // Label 1973: @103081
     /* 103081 */   GIM_Reject,
     /* 103082 */ // Label 1968: @103082
     /* 103082 */ GIM_Reject,
     /* 103083 */ // Label 1802: @103083
     /* 103083 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(103146), // Rule ID 10841 //
     /* 103088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103102 */   // MIs[0] base
     /* 103102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103110 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103122 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 103130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103135 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103144 */   GIR_RootConstrainSelectedInstOperands,
     /* 103145 */   // GIR_Coverage, 10841,
     /* 103145 */   GIR_EraseRootFromParent_Done,
     /* 103146 */ // Label 1974: @103146
     /* 103146 */ GIM_Reject,
     /* 103147 */ // Label 1803: @103147
     /* 103147 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(103210), // Rule ID 10847 //
     /* 103152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103166 */   // MIs[0] base
     /* 103166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103174 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103186 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 103194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103199 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103208 */   GIR_RootConstrainSelectedInstOperands,
     /* 103209 */   // GIR_Coverage, 10847,
     /* 103209 */   GIR_EraseRootFromParent_Done,
     /* 103210 */ // Label 1975: @103210
     /* 103210 */ GIM_Reject,
     /* 103211 */ // Label 1804: @103211
     /* 103211 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(103384),
     /* 103216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103231 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(103279), // Rule ID 10832 //
     /* 103236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103243 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 103263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103268 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103277 */     GIR_RootConstrainSelectedInstOperands,
     /* 103278 */     // GIR_Coverage, 10832,
     /* 103278 */     GIR_EraseRootFromParent_Done,
     /* 103279 */   // Label 1977: @103279
     /* 103279 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(103327), // Rule ID 10850 //
     /* 103284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103291 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 103311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103316 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103325 */     GIR_RootConstrainSelectedInstOperands,
     /* 103326 */     // GIR_Coverage, 10850,
     /* 103326 */     GIR_EraseRootFromParent_Done,
     /* 103327 */   // Label 1978: @103327
     /* 103327 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(103355), // Rule ID 10877 //
     /* 103332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103339 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103344 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103353 */     GIR_RootConstrainSelectedInstOperands,
     /* 103354 */     // GIR_Coverage, 10877,
     /* 103354 */     GIR_EraseRootFromParent_Done,
     /* 103355 */   // Label 1979: @103355
     /* 103355 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(103383), // Rule ID 10889 //
     /* 103360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103367 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103372 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103381 */     GIR_RootConstrainSelectedInstOperands,
     /* 103382 */     // GIR_Coverage, 10889,
     /* 103382 */     GIR_EraseRootFromParent_Done,
     /* 103383 */   // Label 1980: @103383
     /* 103383 */   GIM_Reject,
     /* 103384 */ // Label 1976: @103384
     /* 103384 */ GIM_Reject,
     /* 103385 */ // Label 1805: @103385
     /* 103385 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(103448), // Rule ID 10838 //
     /* 103390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103404 */   // MIs[0] base
     /* 103404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103412 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103424 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 103432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103437 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103446 */   GIR_RootConstrainSelectedInstOperands,
     /* 103447 */   // GIR_Coverage, 10838,
     /* 103447 */   GIR_EraseRootFromParent_Done,
     /* 103448 */ // Label 1981: @103448
     /* 103448 */ GIM_Reject,
     /* 103449 */ // Label 1806: @103449
     /* 103449 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(103622),
     /* 103454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103457 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103469 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(103517), // Rule ID 10820 //
     /* 103474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103481 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103493 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 103501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103506 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103515 */     GIR_RootConstrainSelectedInstOperands,
     /* 103516 */     // GIR_Coverage, 10820,
     /* 103516 */     GIR_EraseRootFromParent_Done,
     /* 103517 */   // Label 1983: @103517
     /* 103517 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(103565), // Rule ID 10844 //
     /* 103522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103529 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103541 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 103549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103554 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103563 */     GIR_RootConstrainSelectedInstOperands,
     /* 103564 */     // GIR_Coverage, 10844,
     /* 103564 */     GIR_EraseRootFromParent_Done,
     /* 103565 */   // Label 1984: @103565
     /* 103565 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(103593), // Rule ID 10873 //
     /* 103570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103577 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103582 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103591 */     GIR_RootConstrainSelectedInstOperands,
     /* 103592 */     // GIR_Coverage, 10873,
     /* 103592 */     GIR_EraseRootFromParent_Done,
     /* 103593 */   // Label 1985: @103593
     /* 103593 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(103621), // Rule ID 10885 //
     /* 103598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103605 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103610 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103619 */     GIR_RootConstrainSelectedInstOperands,
     /* 103620 */     // GIR_Coverage, 10885,
     /* 103620 */     GIR_EraseRootFromParent_Done,
     /* 103621 */   // Label 1986: @103621
     /* 103621 */   GIM_Reject,
     /* 103622 */ // Label 1982: @103622
     /* 103622 */ GIM_Reject,
     /* 103623 */ // Label 1807: @103623
     /* 103623 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(103796),
     /* 103628 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103631 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103643 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(103691), // Rule ID 10799 //
     /* 103648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103655 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 103662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 103675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103680 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103689 */     GIR_RootConstrainSelectedInstOperands,
     /* 103690 */     // GIR_Coverage, 10799,
     /* 103690 */     GIR_EraseRootFromParent_Done,
     /* 103691 */   // Label 1988: @103691
     /* 103691 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(103739), // Rule ID 10835 //
     /* 103696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103703 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 103710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103715 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 103723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103728 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103737 */     GIR_RootConstrainSelectedInstOperands,
     /* 103738 */     // GIR_Coverage, 10835,
     /* 103738 */     GIR_EraseRootFromParent_Done,
     /* 103739 */   // Label 1989: @103739
     /* 103739 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(103767), // Rule ID 10869 //
     /* 103744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103751 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103756 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103765 */     GIR_RootConstrainSelectedInstOperands,
     /* 103766 */     // GIR_Coverage, 10869,
     /* 103766 */     GIR_EraseRootFromParent_Done,
     /* 103767 */   // Label 1990: @103767
     /* 103767 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(103795), // Rule ID 10881 //
     /* 103772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103779 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103784 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103793 */     GIR_RootConstrainSelectedInstOperands,
     /* 103794 */     // GIR_Coverage, 10881,
     /* 103794 */     GIR_EraseRootFromParent_Done,
     /* 103795 */   // Label 1991: @103795
     /* 103795 */   GIM_Reject,
     /* 103796 */ // Label 1987: @103796
     /* 103796 */ GIM_Reject,
     /* 103797 */ // Label 1808: @103797
     /* 103797 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(103840), // Rule ID 2419 //
     /* 103802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103808 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 103816 */   // MIs[0] base
     /* 103816 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103824 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 103827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 103829 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103838 */   GIR_RootConstrainSelectedInstOperands,
     /* 103839 */   // GIR_Coverage, 2419,
     /* 103839 */   GIR_EraseRootFromParent_Done,
     /* 103840 */ // Label 1992: @103840
     /* 103840 */ GIM_Reject,
     /* 103841 */ // Label 1809: @103841
     /* 103841 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(103938),
     /* 103846 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103849 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103861 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(103909), // Rule ID 10767 //
     /* 103866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103873 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 103880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 103893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103898 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103907 */     GIR_RootConstrainSelectedInstOperands,
     /* 103908 */     // GIR_Coverage, 10767,
     /* 103908 */     GIR_EraseRootFromParent_Done,
     /* 103909 */   // Label 1994: @103909
     /* 103909 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(103937), // Rule ID 10865 //
     /* 103914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103921 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103926 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103935 */     GIR_RootConstrainSelectedInstOperands,
     /* 103936 */     // GIR_Coverage, 10865,
     /* 103936 */     GIR_EraseRootFromParent_Done,
     /* 103937 */   // Label 1995: @103937
     /* 103937 */   GIM_Reject,
     /* 103938 */ // Label 1993: @103938
     /* 103938 */ GIM_Reject,
     /* 103939 */ // Label 1810: @103939
     /* 103939 */ GIM_Reject,
     /* 103940 */ // Label 17: @103940
     /* 103940 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1998*/ GIMT_Encode4(104989),
     /* 103951 */ /*GILLT_s32*//*Label 1996*/ GIMT_Encode4(103959),
     /* 103955 */ /*GILLT_s64*//*Label 1997*/ GIMT_Encode4(104373),
     /* 103959 */ // Label 1996: @103959
     /* 103959 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(104372),
     /* 103964 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103967 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(104020), // Rule ID 247 //
     /* 103972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 103994 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 103994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 103997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104018 */     GIR_RootConstrainSelectedInstOperands,
     /* 104019 */     // GIR_Coverage, 247,
     /* 104019 */     GIR_EraseRootFromParent_Done,
     /* 104020 */   // Label 2000: @104020
     /* 104020 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(104073), // Rule ID 248 //
     /* 104025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 104047 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 104047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 104050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104071 */     GIR_RootConstrainSelectedInstOperands,
     /* 104072 */     // GIR_Coverage, 248,
     /* 104072 */     GIR_EraseRootFromParent_Done,
     /* 104073 */   // Label 2001: @104073
     /* 104073 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(104126), // Rule ID 251 //
     /* 104078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 104100 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 104100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 104103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104124 */     GIR_RootConstrainSelectedInstOperands,
     /* 104125 */     // GIR_Coverage, 251,
     /* 104125 */     GIR_EraseRootFromParent_Done,
     /* 104126 */   // Label 2002: @104126
     /* 104126 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(104179), // Rule ID 252 //
     /* 104131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 104153 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 104153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 104156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104177 */     GIR_RootConstrainSelectedInstOperands,
     /* 104178 */     // GIR_Coverage, 252,
     /* 104178 */     GIR_EraseRootFromParent_Done,
     /* 104179 */   // Label 2003: @104179
     /* 104179 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(104227), // Rule ID 268 //
     /* 104184 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104206 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 104206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 104209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104225 */     GIR_RootConstrainSelectedInstOperands,
     /* 104226 */     // GIR_Coverage, 268,
     /* 104226 */     GIR_EraseRootFromParent_Done,
     /* 104227 */   // Label 2004: @104227
     /* 104227 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(104275), // Rule ID 270 //
     /* 104232 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104254 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 104254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 104257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104273 */     GIR_RootConstrainSelectedInstOperands,
     /* 104274 */     // GIR_Coverage, 270,
     /* 104274 */     GIR_EraseRootFromParent_Done,
     /* 104275 */   // Label 2005: @104275
     /* 104275 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(104323), // Rule ID 289 //
     /* 104280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104302 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 104305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104321 */     GIR_RootConstrainSelectedInstOperands,
     /* 104322 */     // GIR_Coverage, 289,
     /* 104322 */     GIR_EraseRootFromParent_Done,
     /* 104323 */   // Label 2006: @104323
     /* 104323 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(104371), // Rule ID 291 //
     /* 104328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104350 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 104353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104369 */     GIR_RootConstrainSelectedInstOperands,
     /* 104370 */     // GIR_Coverage, 291,
     /* 104370 */     GIR_EraseRootFromParent_Done,
     /* 104371 */   // Label 2007: @104371
     /* 104371 */   GIM_Reject,
     /* 104372 */ // Label 1999: @104372
     /* 104372 */ GIM_Reject,
     /* 104373 */ // Label 1997: @104373
     /* 104373 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(104988),
     /* 104378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104381 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(104434), // Rule ID 249 //
     /* 104386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 104408 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 104408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 104411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104432 */     GIR_RootConstrainSelectedInstOperands,
     /* 104433 */     // GIR_Coverage, 249,
     /* 104433 */     GIR_EraseRootFromParent_Done,
     /* 104434 */   // Label 2009: @104434
     /* 104434 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(104487), // Rule ID 250 //
     /* 104439 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 104461 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 104461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 104464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104485 */     GIR_RootConstrainSelectedInstOperands,
     /* 104486 */     // GIR_Coverage, 250,
     /* 104486 */     GIR_EraseRootFromParent_Done,
     /* 104487 */   // Label 2010: @104487
     /* 104487 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(104540), // Rule ID 253 //
     /* 104492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 104514 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 104514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 104517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104538 */     GIR_RootConstrainSelectedInstOperands,
     /* 104539 */     // GIR_Coverage, 253,
     /* 104539 */     GIR_EraseRootFromParent_Done,
     /* 104540 */   // Label 2011: @104540
     /* 104540 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(104593), // Rule ID 254 //
     /* 104545 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 104567 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 104567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 104570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104591 */     GIR_RootConstrainSelectedInstOperands,
     /* 104592 */     // GIR_Coverage, 254,
     /* 104592 */     GIR_EraseRootFromParent_Done,
     /* 104593 */   // Label 2012: @104593
     /* 104593 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(104646), // Rule ID 255 //
     /* 104598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 104620 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 104620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 104623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104644 */     GIR_RootConstrainSelectedInstOperands,
     /* 104645 */     // GIR_Coverage, 255,
     /* 104645 */     GIR_EraseRootFromParent_Done,
     /* 104646 */   // Label 2013: @104646
     /* 104646 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(104699), // Rule ID 256 //
     /* 104651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 104673 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 104673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 104676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104697 */     GIR_RootConstrainSelectedInstOperands,
     /* 104698 */     // GIR_Coverage, 256,
     /* 104698 */     GIR_EraseRootFromParent_Done,
     /* 104699 */   // Label 2014: @104699
     /* 104699 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(104747), // Rule ID 269 //
     /* 104704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104726 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 104726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 104729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104745 */     GIR_RootConstrainSelectedInstOperands,
     /* 104746 */     // GIR_Coverage, 269,
     /* 104746 */     GIR_EraseRootFromParent_Done,
     /* 104747 */   // Label 2015: @104747
     /* 104747 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(104795), // Rule ID 271 //
     /* 104752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104774 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 104774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 104777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104793 */     GIR_RootConstrainSelectedInstOperands,
     /* 104794 */     // GIR_Coverage, 271,
     /* 104794 */     GIR_EraseRootFromParent_Done,
     /* 104795 */   // Label 2016: @104795
     /* 104795 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(104843), // Rule ID 272 //
     /* 104800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104822 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 104822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 104825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104841 */     GIR_RootConstrainSelectedInstOperands,
     /* 104842 */     // GIR_Coverage, 272,
     /* 104842 */     GIR_EraseRootFromParent_Done,
     /* 104843 */   // Label 2017: @104843
     /* 104843 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(104891), // Rule ID 290 //
     /* 104848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104870 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 104873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104889 */     GIR_RootConstrainSelectedInstOperands,
     /* 104890 */     // GIR_Coverage, 290,
     /* 104890 */     GIR_EraseRootFromParent_Done,
     /* 104891 */   // Label 2018: @104891
     /* 104891 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(104939), // Rule ID 292 //
     /* 104896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104918 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 104921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104937 */     GIR_RootConstrainSelectedInstOperands,
     /* 104938 */     // GIR_Coverage, 292,
     /* 104938 */     GIR_EraseRootFromParent_Done,
     /* 104939 */   // Label 2019: @104939
     /* 104939 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(104987), // Rule ID 293 //
     /* 104944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 104966 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 104969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104985 */     GIR_RootConstrainSelectedInstOperands,
     /* 104986 */     // GIR_Coverage, 293,
     /* 104986 */     GIR_EraseRootFromParent_Done,
     /* 104987 */   // Label 2020: @104987
     /* 104987 */   GIM_Reject,
     /* 104988 */ // Label 2008: @104988
     /* 104988 */ GIM_Reject,
     /* 104989 */ // Label 1998: @104989
     /* 104989 */ GIM_Reject,
     /* 104990 */ // Label 18: @104990
     /* 104990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2023*/ GIMT_Encode4(107958),
     /* 105001 */ /*GILLT_s32*//*Label 2021*/ GIMT_Encode4(105009),
     /* 105005 */ /*GILLT_s64*//*Label 2022*/ GIMT_Encode4(106468),
     /* 105009 */ // Label 2021: @105009
     /* 105009 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(105065), // Rule ID 229 //
     /* 105014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105017 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105039 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 105039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105063 */   GIR_RootConstrainSelectedInstOperands,
     /* 105064 */   // GIR_Coverage, 229,
     /* 105064 */   GIR_EraseRootFromParent_Done,
     /* 105065 */ // Label 2024: @105065
     /* 105065 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(105121), // Rule ID 230 //
     /* 105070 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105095 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 105095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105119 */   GIR_RootConstrainSelectedInstOperands,
     /* 105120 */   // GIR_Coverage, 230,
     /* 105120 */   GIR_EraseRootFromParent_Done,
     /* 105121 */ // Label 2025: @105121
     /* 105121 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(105177), // Rule ID 231 //
     /* 105126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105129 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105144 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 105151 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 105151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 105154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105175 */   GIR_RootConstrainSelectedInstOperands,
     /* 105176 */   // GIR_Coverage, 231,
     /* 105176 */   GIR_EraseRootFromParent_Done,
     /* 105177 */ // Label 2026: @105177
     /* 105177 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(105233), // Rule ID 232 //
     /* 105182 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 105207 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 105207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 105210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105231 */   GIR_RootConstrainSelectedInstOperands,
     /* 105232 */   // GIR_Coverage, 232,
     /* 105232 */   GIR_EraseRootFromParent_Done,
     /* 105233 */ // Label 2027: @105233
     /* 105233 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(105289), // Rule ID 4079 //
     /* 105238 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105256 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105263 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 105263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105283 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105287 */   GIR_RootConstrainSelectedInstOperands,
     /* 105288 */   // GIR_Coverage, 4079,
     /* 105288 */   GIR_EraseRootFromParent_Done,
     /* 105289 */ // Label 2028: @105289
     /* 105289 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(105345), // Rule ID 4080 //
     /* 105294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105297 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105312 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105319 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 105319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105343 */   GIR_RootConstrainSelectedInstOperands,
     /* 105344 */   // GIR_Coverage, 4080,
     /* 105344 */   GIR_EraseRootFromParent_Done,
     /* 105345 */ // Label 2029: @105345
     /* 105345 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(105396), // Rule ID 266 //
     /* 105350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 105375 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 105375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 105378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105394 */   GIR_RootConstrainSelectedInstOperands,
     /* 105395 */   // GIR_Coverage, 266,
     /* 105395 */   GIR_EraseRootFromParent_Done,
     /* 105396 */ // Label 2030: @105396
     /* 105396 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(105447), // Rule ID 267 //
     /* 105401 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105426 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105445 */   GIR_RootConstrainSelectedInstOperands,
     /* 105446 */   // GIR_Coverage, 267,
     /* 105446 */   GIR_EraseRootFromParent_Done,
     /* 105447 */ // Label 2031: @105447
     /* 105447 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(105506), // Rule ID 6948 //
     /* 105452 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105462 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105469 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105480 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15713>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 105480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105500 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105504 */   GIR_RootConstrainSelectedInstOperands,
     /* 105505 */   // GIR_Coverage, 6948,
     /* 105505 */   GIR_EraseRootFromParent_Done,
     /* 105506 */ // Label 2032: @105506
     /* 105506 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(105565), // Rule ID 6950 //
     /* 105511 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105514 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105521 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105539 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15713>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 105539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105563 */   GIR_RootConstrainSelectedInstOperands,
     /* 105564 */   // GIR_Coverage, 6950,
     /* 105564 */   GIR_EraseRootFromParent_Done,
     /* 105565 */ // Label 2033: @105565
     /* 105565 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(105624), // Rule ID 6960 //
     /* 105570 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105573 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105580 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105587 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 105598 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15722>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 105598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 105601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105622 */   GIR_RootConstrainSelectedInstOperands,
     /* 105623 */   // GIR_Coverage, 6960,
     /* 105623 */   GIR_EraseRootFromParent_Done,
     /* 105624 */ // Label 2034: @105624
     /* 105624 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(105683), // Rule ID 6962 //
     /* 105629 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105632 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105639 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 105657 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15722>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 105657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 105660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105681 */   GIR_RootConstrainSelectedInstOperands,
     /* 105682 */   // GIR_Coverage, 6962,
     /* 105682 */   GIR_EraseRootFromParent_Done,
     /* 105683 */ // Label 2035: @105683
     /* 105683 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(105734), // Rule ID 287 //
     /* 105688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105691 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105706 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105713 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105732 */   GIR_RootConstrainSelectedInstOperands,
     /* 105733 */   // GIR_Coverage, 287,
     /* 105733 */   GIR_EraseRootFromParent_Done,
     /* 105734 */ // Label 2036: @105734
     /* 105734 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(105785), // Rule ID 288 //
     /* 105739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105753 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105757 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105764 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105783 */   GIR_RootConstrainSelectedInstOperands,
     /* 105784 */   // GIR_Coverage, 288,
     /* 105784 */   GIR_EraseRootFromParent_Done,
     /* 105785 */ // Label 2037: @105785
     /* 105785 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(105836), // Rule ID 4098 //
     /* 105790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105793 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105815 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105834 */   GIR_RootConstrainSelectedInstOperands,
     /* 105835 */   // GIR_Coverage, 4098,
     /* 105835 */   GIR_EraseRootFromParent_Done,
     /* 105836 */ // Label 2038: @105836
     /* 105836 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(105887), // Rule ID 4130 //
     /* 105841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105844 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105866 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105885 */   GIR_RootConstrainSelectedInstOperands,
     /* 105886 */   // GIR_Coverage, 4130,
     /* 105886 */   GIR_EraseRootFromParent_Done,
     /* 105887 */ // Label 2039: @105887
     /* 105887 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(105938), // Rule ID 4131 //
     /* 105892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105917 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105936 */   GIR_RootConstrainSelectedInstOperands,
     /* 105937 */   // GIR_Coverage, 4131,
     /* 105937 */   GIR_EraseRootFromParent_Done,
     /* 105938 */ // Label 2040: @105938
     /* 105938 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(105989), // Rule ID 4132 //
     /* 105943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105946 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105968 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105987 */   GIR_RootConstrainSelectedInstOperands,
     /* 105988 */   // GIR_Coverage, 4132,
     /* 105988 */   GIR_EraseRootFromParent_Done,
     /* 105989 */ // Label 2041: @105989
     /* 105989 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(106043), // Rule ID 6952 //
     /* 105994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106004 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 106022 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15713>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 106022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 106025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106041 */   GIR_RootConstrainSelectedInstOperands,
     /* 106042 */   // GIR_Coverage, 6952,
     /* 106042 */   GIR_EraseRootFromParent_Done,
     /* 106043 */ // Label 2042: @106043
     /* 106043 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(106097), // Rule ID 6954 //
     /* 106048 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106058 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106069 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 106076 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15713>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 106079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106095 */   GIR_RootConstrainSelectedInstOperands,
     /* 106096 */   // GIR_Coverage, 6954,
     /* 106096 */   GIR_EraseRootFromParent_Done,
     /* 106097 */ // Label 2043: @106097
     /* 106097 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(106151), // Rule ID 6964 //
     /* 106102 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106112 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 106130 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15722>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 106130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 106133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106149 */   GIR_RootConstrainSelectedInstOperands,
     /* 106150 */   // GIR_Coverage, 6964,
     /* 106150 */   GIR_EraseRootFromParent_Done,
     /* 106151 */ // Label 2044: @106151
     /* 106151 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(106205), // Rule ID 6966 //
     /* 106156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106166 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 106184 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15722>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 106187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106199 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106203 */   GIR_RootConstrainSelectedInstOperands,
     /* 106204 */   // GIR_Coverage, 6966,
     /* 106204 */   GIR_EraseRootFromParent_Done,
     /* 106205 */ // Label 2045: @106205
     /* 106205 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(106262), // Rule ID 7328 //
     /* 106210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 106213 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106216 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 106241 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15711>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 106244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106256 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106260 */   GIR_RootConstrainSelectedInstOperands,
     /* 106261 */   // GIR_Coverage, 7328,
     /* 106261 */   GIR_EraseRootFromParent_Done,
     /* 106262 */ // Label 2046: @106262
     /* 106262 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(106319), // Rule ID 7330 //
     /* 106267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 106270 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106273 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106280 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 106298 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15720>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 106301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106317 */   GIR_RootConstrainSelectedInstOperands,
     /* 106318 */   // GIR_Coverage, 7330,
     /* 106318 */   GIR_EraseRootFromParent_Done,
     /* 106319 */ // Label 2047: @106319
     /* 106319 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(106356), // Rule ID 6944 //
     /* 106324 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106327 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106334 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 106337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106341 */   // MIs[0] ptr
     /* 106341 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106349 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15709>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 106354 */   GIR_RootConstrainSelectedInstOperands,
     /* 106355 */   // GIR_Coverage, 6944,
     /* 106355 */   GIR_Done,
     /* 106356 */ // Label 2048: @106356
     /* 106356 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(106393), // Rule ID 6946 //
     /* 106361 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106364 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106378 */   // MIs[0] ptr
     /* 106378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106386 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15711>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 106391 */   GIR_RootConstrainSelectedInstOperands,
     /* 106392 */   // GIR_Coverage, 6946,
     /* 106392 */   GIR_Done,
     /* 106393 */ // Label 2049: @106393
     /* 106393 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(106430), // Rule ID 6956 //
     /* 106398 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106401 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106408 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 106411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106415 */   // MIs[0] ptr
     /* 106415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106423 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15718>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 106428 */   GIR_RootConstrainSelectedInstOperands,
     /* 106429 */   // GIR_Coverage, 6956,
     /* 106429 */   GIR_Done,
     /* 106430 */ // Label 2050: @106430
     /* 106430 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(106467), // Rule ID 6958 //
     /* 106435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106452 */   // MIs[0] ptr
     /* 106452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106460 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15720>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 106465 */   GIR_RootConstrainSelectedInstOperands,
     /* 106466 */   // GIR_Coverage, 6958,
     /* 106466 */   GIR_Done,
     /* 106467 */ // Label 2051: @106467
     /* 106467 */ GIM_Reject,
     /* 106468 */ // Label 2022: @106468
     /* 106468 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(107957),
     /* 106473 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106476 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(106561), // Rule ID 4057 //
     /* 106481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 106503 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 106510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106530 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106560 */     // GIR_Coverage, 4057,
     /* 106560 */     GIR_EraseRootFromParent_Done,
     /* 106561 */   // Label 2053: @106561
     /* 106561 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(106646), // Rule ID 4058 //
     /* 106566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 106588 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 106595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106615 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106645 */     // GIR_Coverage, 4058,
     /* 106645 */     GIR_EraseRootFromParent_Done,
     /* 106646 */   // Label 2054: @106646
     /* 106646 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(106731), // Rule ID 4059 //
     /* 106651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 106673 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 106680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106700 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106730 */     // GIR_Coverage, 4059,
     /* 106730 */     GIR_EraseRootFromParent_Done,
     /* 106731 */   // Label 2055: @106731
     /* 106731 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(106816), // Rule ID 4060 //
     /* 106736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 106758 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 106765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106815 */     // GIR_Coverage, 4060,
     /* 106815 */     GIR_EraseRootFromParent_Done,
     /* 106816 */   // Label 2056: @106816
     /* 106816 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(106901), // Rule ID 4061 //
     /* 106821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 106843 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 106850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106900 */     // GIR_Coverage, 4061,
     /* 106900 */     GIR_EraseRootFromParent_Done,
     /* 106901 */   // Label 2057: @106901
     /* 106901 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(106986), // Rule ID 4062 //
     /* 106906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 106928 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 106935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106985 */     // GIR_Coverage, 4062,
     /* 106985 */     GIR_EraseRootFromParent_Done,
     /* 106986 */   // Label 2058: @106986
     /* 106986 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(107071), // Rule ID 4063 //
     /* 106991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 107013 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 107013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 107020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107070 */     // GIR_Coverage, 4063,
     /* 107070 */     GIR_EraseRootFromParent_Done,
     /* 107071 */   // Label 2059: @107071
     /* 107071 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(107156), // Rule ID 4064 //
     /* 107076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 107098 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 107098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 107105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107155 */     // GIR_Coverage, 4064,
     /* 107155 */     GIR_EraseRootFromParent_Done,
     /* 107156 */   // Label 2060: @107156
     /* 107156 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(107236), // Rule ID 4096 //
     /* 107161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107183 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 107190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107235 */     // GIR_Coverage, 4096,
     /* 107235 */     GIR_EraseRootFromParent_Done,
     /* 107236 */   // Label 2061: @107236
     /* 107236 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(107316), // Rule ID 4097 //
     /* 107241 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107263 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 107270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107315 */     // GIR_Coverage, 4097,
     /* 107315 */     GIR_EraseRootFromParent_Done,
     /* 107316 */   // Label 2062: @107316
     /* 107316 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(107396), // Rule ID 4099 //
     /* 107321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107343 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 107350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107365 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107395 */     // GIR_Coverage, 4099,
     /* 107395 */     GIR_EraseRootFromParent_Done,
     /* 107396 */   // Label 2063: @107396
     /* 107396 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(107476), // Rule ID 4107 //
     /* 107401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 107423 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 107430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107475 */     // GIR_Coverage, 4107,
     /* 107475 */     GIR_EraseRootFromParent_Done,
     /* 107476 */   // Label 2064: @107476
     /* 107476 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(107556), // Rule ID 4133 //
     /* 107481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 107503 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 107510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107525 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107555 */     // GIR_Coverage, 4133,
     /* 107555 */     GIR_EraseRootFromParent_Done,
     /* 107556 */   // Label 2065: @107556
     /* 107556 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(107636), // Rule ID 4134 //
     /* 107561 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107583 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 107590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107605 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107635 */     // GIR_Coverage, 4134,
     /* 107635 */     GIR_EraseRootFromParent_Done,
     /* 107636 */   // Label 2066: @107636
     /* 107636 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(107716), // Rule ID 4135 //
     /* 107641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107663 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107685 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107715 */     // GIR_Coverage, 4135,
     /* 107715 */     GIR_EraseRootFromParent_Done,
     /* 107716 */   // Label 2067: @107716
     /* 107716 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(107796), // Rule ID 4136 //
     /* 107721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107743 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107765 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107795 */     // GIR_Coverage, 4136,
     /* 107795 */     GIR_EraseRootFromParent_Done,
     /* 107796 */   // Label 2068: @107796
     /* 107796 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(107876), // Rule ID 4137 //
     /* 107801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107823 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107845 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107875 */     // GIR_Coverage, 4137,
     /* 107875 */     GIR_EraseRootFromParent_Done,
     /* 107876 */   // Label 2069: @107876
     /* 107876 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(107956), // Rule ID 4138 //
     /* 107881 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107903 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 107910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107925 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107955 */     // GIR_Coverage, 4138,
     /* 107955 */     GIR_EraseRootFromParent_Done,
     /* 107956 */   // Label 2070: @107956
     /* 107956 */   GIM_Reject,
     /* 107957 */ // Label 2052: @107957
     /* 107957 */ GIM_Reject,
     /* 107958 */ // Label 2023: @107958
     /* 107958 */ GIM_Reject,
     /* 107959 */ // Label 19: @107959
     /* 107959 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2091*/ GIMT_Encode4(121484),
     /* 107970 */ /*GILLT_s8*//*Label 2071*/ GIMT_Encode4(108066),
     /* 107974 */ /*GILLT_s16*//*Label 2072*/ GIMT_Encode4(108433),
     /* 107978 */ /*GILLT_s32*//*Label 2073*/ GIMT_Encode4(109572),
     /* 107982 */ /*GILLT_s64*//*Label 2074*/ GIMT_Encode4(114167),
     /* 107986 */ /*GILLT_s128*//*Label 2075*/ GIMT_Encode4(117936),
     /* 107990 */ /*GILLT_v2s32*//*Label 2076*/ GIMT_Encode4(118142),
     /* 107994 */ /*GILLT_v2s64*//*Label 2077*/ GIMT_Encode4(118548),
     /* 107998 */ /*GILLT_v4s16*//*Label 2078*/ GIMT_Encode4(118998),
     /* 108002 */ /*GILLT_v4s32*//*Label 2079*/ GIMT_Encode4(119404),
     /* 108006 */ /*GILLT_v8s8*//*Label 2080*/ GIMT_Encode4(119810),
     /* 108010 */ /*GILLT_v8s16*//*Label 2081*/ GIMT_Encode4(120030),
     /* 108014 */ /*GILLT_v16s8*//*Label 2082*/ GIMT_Encode4(120436), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108026 */ /*GILLT_nxv2s16*//*Label 2083*/ GIMT_Encode4(120656),
     /* 108030 */ /*GILLT_nxv2s32*//*Label 2084*/ GIMT_Encode4(120716),
     /* 108034 */ /*GILLT_nxv2s64*//*Label 2085*/ GIMT_Encode4(120776), GIMT_Encode4(0),
     /* 108042 */ /*GILLT_nxv4s16*//*Label 2086*/ GIMT_Encode4(120946),
     /* 108046 */ /*GILLT_nxv4s32*//*Label 2087*/ GIMT_Encode4(121006), GIMT_Encode4(0),
     /* 108054 */ /*GILLT_nxv8s16*//*Label 2088*/ GIMT_Encode4(121176),
     /* 108058 */ /*GILLT_nxv16s1*//*Label 2089*/ GIMT_Encode4(121346),
     /* 108062 */ /*GILLT_nxv16s8*//*Label 2090*/ GIMT_Encode4(121390),
     /* 108066 */ // Label 2071: @108066
     /* 108066 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(108432),
     /* 108071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108078 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(108146), // Rule ID 12984 //
     /* 108083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 108108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 108116 */     // MIs[2] Operand 1
     /* 108116 */     // No operand predicates
     /* 108116 */     // MIs[0] Rn
     /* 108116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108126 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 108126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 108129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 108133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 108136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 108138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 108144 */     GIR_RootConstrainSelectedInstOperands,
     /* 108145 */     // GIR_Coverage, 12984,
     /* 108145 */     GIR_EraseRootFromParent_Done,
     /* 108146 */   // Label 2093: @108146
     /* 108146 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(108245), // Rule ID 12985 //
     /* 108151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 108176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 108184 */     // MIs[2] Operand 1
     /* 108184 */     // No operand predicates
     /* 108184 */     // MIs[0] Rn
     /* 108184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108194 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 108194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 108197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 108201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 108209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 108213 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 108216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 108229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 108235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 108237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 108243 */     GIR_RootConstrainSelectedInstOperands,
     /* 108244 */     // GIR_Coverage, 12985,
     /* 108244 */     GIR_EraseRootFromParent_Done,
     /* 108245 */   // Label 2094: @108245
     /* 108245 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(108294), // Rule ID 303 //
     /* 108250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108268 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 108271 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108292 */     GIR_RootConstrainSelectedInstOperands,
     /* 108293 */     // GIR_Coverage, 303,
     /* 108293 */     GIR_EraseRootFromParent_Done,
     /* 108294 */   // Label 2095: @108294
     /* 108294 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(108343), // Rule ID 304 //
     /* 108299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108317 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 108320 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108341 */     GIR_RootConstrainSelectedInstOperands,
     /* 108342 */     // GIR_Coverage, 304,
     /* 108342 */     GIR_EraseRootFromParent_Done,
     /* 108343 */   // Label 2096: @108343
     /* 108343 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(108387), // Rule ID 313 //
     /* 108348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108366 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 108369 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108385 */     GIR_RootConstrainSelectedInstOperands,
     /* 108386 */     // GIR_Coverage, 313,
     /* 108386 */     GIR_EraseRootFromParent_Done,
     /* 108387 */   // Label 2097: @108387
     /* 108387 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(108431), // Rule ID 321 //
     /* 108392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108410 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 108413 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108429 */     GIR_RootConstrainSelectedInstOperands,
     /* 108430 */     // GIR_Coverage, 321,
     /* 108430 */     GIR_EraseRootFromParent_Done,
     /* 108431 */   // Label 2098: @108431
     /* 108431 */   GIM_Reject,
     /* 108432 */ // Label 2092: @108432
     /* 108432 */ GIM_Reject,
     /* 108433 */ // Label 2072: @108433
     /* 108433 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(109571),
     /* 108438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108445 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(108544), // Rule ID 4435 //
     /* 108450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108471 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108488 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 108519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108542 */     GIR_RootConstrainSelectedInstOperands,
     /* 108543 */     // GIR_Coverage, 4435,
     /* 108543 */     GIR_EraseRootFromParent_Done,
     /* 108544 */   // Label 2100: @108544
     /* 108544 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(108643), // Rule ID 4436 //
     /* 108549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108570 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108587 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108599 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 108618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108641 */     GIR_RootConstrainSelectedInstOperands,
     /* 108642 */     // GIR_Coverage, 4436,
     /* 108642 */     GIR_EraseRootFromParent_Done,
     /* 108643 */   // Label 2101: @108643
     /* 108643 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(108742), // Rule ID 12982 //
     /* 108648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108669 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108686 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108698 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 108717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108740 */     GIR_RootConstrainSelectedInstOperands,
     /* 108741 */     // GIR_Coverage, 12982,
     /* 108741 */     GIR_EraseRootFromParent_Done,
     /* 108742 */   // Label 2102: @108742
     /* 108742 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(108841), // Rule ID 12983 //
     /* 108747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108785 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108797 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 108816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108839 */     GIR_RootConstrainSelectedInstOperands,
     /* 108840 */     // GIR_Coverage, 12983,
     /* 108840 */     GIR_EraseRootFromParent_Done,
     /* 108841 */   // Label 2103: @108841
     /* 108841 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(108935), // Rule ID 4464 //
     /* 108846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108867 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108884 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108896 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 108915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108933 */     GIR_RootConstrainSelectedInstOperands,
     /* 108934 */     // GIR_Coverage, 4464,
     /* 108934 */     GIR_EraseRootFromParent_Done,
     /* 108935 */   // Label 2104: @108935
     /* 108935 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(109029), // Rule ID 4489 //
     /* 108940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108961 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 108978 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108990 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 109009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109027 */     GIR_RootConstrainSelectedInstOperands,
     /* 109028 */     // GIR_Coverage, 4489,
     /* 109028 */     GIR_EraseRootFromParent_Done,
     /* 109029 */   // Label 2105: @109029
     /* 109029 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(109123), // Rule ID 12981 //
     /* 109034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109055 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109072 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109084 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 109103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109121 */     GIR_RootConstrainSelectedInstOperands,
     /* 109122 */     // GIR_Coverage, 12981,
     /* 109122 */     GIR_EraseRootFromParent_Done,
     /* 109123 */   // Label 2106: @109123
     /* 109123 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(109217), // Rule ID 12987 //
     /* 109128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109149 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 109166 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 109197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109215 */     GIR_RootConstrainSelectedInstOperands,
     /* 109216 */     // GIR_Coverage, 12987,
     /* 109216 */     GIR_EraseRootFromParent_Done,
     /* 109217 */   // Label 2107: @109217
     /* 109217 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(109285), // Rule ID 6382 //
     /* 109222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 109247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 109251 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 109255 */     // MIs[2] Operand 1
     /* 109255 */     // No operand predicates
     /* 109255 */     // MIs[0] Rn
     /* 109255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 109265 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 109265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 109268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 109272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 109275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 109277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 109283 */     GIR_RootConstrainSelectedInstOperands,
     /* 109284 */     // GIR_Coverage, 6382,
     /* 109284 */     GIR_EraseRootFromParent_Done,
     /* 109285 */   // Label 2108: @109285
     /* 109285 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(109384), // Rule ID 6387 //
     /* 109290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 109315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 109319 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 109323 */     // MIs[2] Operand 1
     /* 109323 */     // No operand predicates
     /* 109323 */     // MIs[0] Rn
     /* 109323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 109333 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 109333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 109348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 109352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 109355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 109368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 109374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 109376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 109382 */     GIR_RootConstrainSelectedInstOperands,
     /* 109383 */     // GIR_Coverage, 6387,
     /* 109383 */     GIR_EraseRootFromParent_Done,
     /* 109384 */   // Label 2109: @109384
     /* 109384 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(109433), // Rule ID 305 //
     /* 109389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109407 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 109410 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109431 */     GIR_RootConstrainSelectedInstOperands,
     /* 109432 */     // GIR_Coverage, 305,
     /* 109432 */     GIR_EraseRootFromParent_Done,
     /* 109433 */   // Label 2110: @109433
     /* 109433 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(109482), // Rule ID 306 //
     /* 109438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109456 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 109459 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109480 */     GIR_RootConstrainSelectedInstOperands,
     /* 109481 */     // GIR_Coverage, 306,
     /* 109481 */     GIR_EraseRootFromParent_Done,
     /* 109482 */   // Label 2111: @109482
     /* 109482 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(109526), // Rule ID 314 //
     /* 109487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109505 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 109508 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109524 */     GIR_RootConstrainSelectedInstOperands,
     /* 109525 */     // GIR_Coverage, 314,
     /* 109525 */     GIR_EraseRootFromParent_Done,
     /* 109526 */   // Label 2112: @109526
     /* 109526 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(109570), // Rule ID 322 //
     /* 109531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109549 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 109552 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109568 */     GIR_RootConstrainSelectedInstOperands,
     /* 109569 */     // GIR_Coverage, 322,
     /* 109569 */     GIR_EraseRootFromParent_Done,
     /* 109570 */   // Label 2113: @109570
     /* 109570 */   GIM_Reject,
     /* 109571 */ // Label 2099: @109571
     /* 109571 */ GIM_Reject,
     /* 109572 */ // Label 2073: @109572
     /* 109572 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(109685), // Rule ID 4433 //
     /* 109577 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109580 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109584 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109591 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109599 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109603 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109607 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109612 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109629 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109641 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109647 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 109660 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109683 */   GIR_RootConstrainSelectedInstOperands,
     /* 109684 */   // GIR_Coverage, 4433,
     /* 109684 */   GIR_EraseRootFromParent_Done,
     /* 109685 */ // Label 2114: @109685
     /* 109685 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(109798), // Rule ID 4434 //
     /* 109690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109693 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109742 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109754 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109760 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 109773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109796 */   GIR_RootConstrainSelectedInstOperands,
     /* 109797 */   // GIR_Coverage, 4434,
     /* 109797 */   GIR_EraseRootFromParent_Done,
     /* 109798 */ // Label 2115: @109798
     /* 109798 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(109904), // Rule ID 4437 //
     /* 109803 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109806 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109818 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109826 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109831 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109848 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 109848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109860 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109871 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 109879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109902 */   GIR_RootConstrainSelectedInstOperands,
     /* 109903 */   // GIR_Coverage, 4437,
     /* 109903 */   GIR_EraseRootFromParent_Done,
     /* 109904 */ // Label 2116: @109904
     /* 109904 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(110010), // Rule ID 4438 //
     /* 109909 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109912 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109916 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109920 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109924 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109928 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109932 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109937 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109947 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109954 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109966 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 109985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110003 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110008 */   GIR_RootConstrainSelectedInstOperands,
     /* 110009 */   // GIR_Coverage, 4438,
     /* 110009 */   GIR_EraseRootFromParent_Done,
     /* 110010 */ // Label 2117: @110010
     /* 110010 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(110116), // Rule ID 4439 //
     /* 110015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110022 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110026 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110030 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110034 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110043 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110047 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110053 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110060 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 110060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110072 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 110091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110114 */   GIR_RootConstrainSelectedInstOperands,
     /* 110115 */   // GIR_Coverage, 4439,
     /* 110115 */   GIR_EraseRootFromParent_Done,
     /* 110116 */ // Label 2118: @110116
     /* 110116 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(110222), // Rule ID 4440 //
     /* 110121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110136 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110140 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110144 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110149 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110159 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110166 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 110166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110178 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110184 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110189 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 110197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110220 */   GIR_RootConstrainSelectedInstOperands,
     /* 110221 */   // GIR_Coverage, 4440,
     /* 110221 */   GIR_EraseRootFromParent_Done,
     /* 110222 */ // Label 2119: @110222
     /* 110222 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(110328), // Rule ID 12989 //
     /* 110227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110242 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110246 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110250 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110255 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110263 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110272 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 110272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110284 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 110303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110326 */   GIR_RootConstrainSelectedInstOperands,
     /* 110327 */   // GIR_Coverage, 12989,
     /* 110327 */   GIR_EraseRootFromParent_Done,
     /* 110328 */ // Label 2120: @110328
     /* 110328 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(110434), // Rule ID 12990 //
     /* 110333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110336 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110348 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110352 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110356 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110361 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110371 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110378 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 110378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110390 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110396 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 110409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110432 */   GIR_RootConstrainSelectedInstOperands,
     /* 110433 */   // GIR_Coverage, 12990,
     /* 110433 */   GIR_EraseRootFromParent_Done,
     /* 110434 */ // Label 2121: @110434
     /* 110434 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(110542), // Rule ID 4463 //
     /* 110439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110442 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110461 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110465 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110469 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110474 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110491 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 110491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110503 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 110509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 110514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 110522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110540 */   GIR_RootConstrainSelectedInstOperands,
     /* 110541 */   // GIR_Coverage, 4463,
     /* 110541 */   GIR_EraseRootFromParent_Done,
     /* 110542 */ // Label 2122: @110542
     /* 110542 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(110643), // Rule ID 4465 //
     /* 110547 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110550 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110562 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110566 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110570 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110575 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110592 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110604 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110610 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110641 */   GIR_RootConstrainSelectedInstOperands,
     /* 110642 */   // GIR_Coverage, 4465,
     /* 110642 */   GIR_EraseRootFromParent_Done,
     /* 110643 */ // Label 2123: @110643
     /* 110643 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(110744), // Rule ID 4466 //
     /* 110648 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110651 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110663 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110667 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110671 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110676 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110686 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110693 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110705 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110711 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110742 */   GIR_RootConstrainSelectedInstOperands,
     /* 110743 */   // GIR_Coverage, 4466,
     /* 110743 */   GIR_EraseRootFromParent_Done,
     /* 110744 */ // Label 2124: @110744
     /* 110744 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(110852), // Rule ID 4488 //
     /* 110749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110752 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110756 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110771 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110775 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110779 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110784 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110792 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110801 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110813 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 110819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 110824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 110832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110850 */   GIR_RootConstrainSelectedInstOperands,
     /* 110851 */   // GIR_Coverage, 4488,
     /* 110851 */   GIR_EraseRootFromParent_Done,
     /* 110852 */ // Label 2125: @110852
     /* 110852 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(110953), // Rule ID 4490 //
     /* 110857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110872 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110880 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110885 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110893 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110895 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110902 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110914 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110925 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 110933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110951 */   GIR_RootConstrainSelectedInstOperands,
     /* 110952 */   // GIR_Coverage, 4490,
     /* 110952 */   GIR_EraseRootFromParent_Done,
     /* 110953 */ // Label 2126: @110953
     /* 110953 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(111054), // Rule ID 4491 //
     /* 110958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110961 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110973 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110977 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110986 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110994 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 111003 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 111003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111015 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 111021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 111034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111052 */   GIR_RootConstrainSelectedInstOperands,
     /* 111053 */   // GIR_Coverage, 4491,
     /* 111053 */   GIR_EraseRootFromParent_Done,
     /* 111054 */ // Label 2127: @111054
     /* 111054 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111155), // Rule ID 12986 //
     /* 111059 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111066 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111074 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111078 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111087 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 111104 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 111104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111116 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 111122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 111135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111153 */   GIR_RootConstrainSelectedInstOperands,
     /* 111154 */   // GIR_Coverage, 12986,
     /* 111154 */   GIR_EraseRootFromParent_Done,
     /* 111155 */ // Label 2128: @111155
     /* 111155 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(111256), // Rule ID 12988 //
     /* 111160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111163 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111175 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111179 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111188 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111192 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 111205 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 111205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111217 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 111223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 111236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111254 */   GIR_RootConstrainSelectedInstOperands,
     /* 111255 */   // GIR_Coverage, 12988,
     /* 111255 */   GIR_EraseRootFromParent_Done,
     /* 111256 */ // Label 2129: @111256
     /* 111256 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(111338), // Rule ID 6376 //
     /* 111261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111264 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111283 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111287 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111291 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111296 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111300 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111304 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111308 */   // MIs[2] Operand 1
     /* 111308 */   // No operand predicates
     /* 111308 */   // MIs[0] Rn
     /* 111308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111316 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111318 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111321 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111325 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111328 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111336 */   GIR_RootConstrainSelectedInstOperands,
     /* 111337 */   // GIR_Coverage, 6376,
     /* 111337 */   GIR_EraseRootFromParent_Done,
     /* 111338 */ // Label 2130: @111338
     /* 111338 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(111420), // Rule ID 6377 //
     /* 111343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111346 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111365 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111369 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111373 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111378 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111382 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111386 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 111390 */   // MIs[2] Operand 1
     /* 111390 */   // No operand predicates
     /* 111390 */   // MIs[0] Rn
     /* 111390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111398 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111400 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 111403 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111407 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111410 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111418 */   GIR_RootConstrainSelectedInstOperands,
     /* 111419 */   // GIR_Coverage, 6377,
     /* 111419 */   GIR_EraseRootFromParent_Done,
     /* 111420 */ // Label 2131: @111420
     /* 111420 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(111495), // Rule ID 6378 //
     /* 111425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111428 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111440 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111444 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111448 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111453 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111457 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111461 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111465 */   // MIs[2] Operand 1
     /* 111465 */   // No operand predicates
     /* 111465 */   // MIs[0] Rn
     /* 111465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111473 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111475 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111478 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111482 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111485 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111487 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111493 */   GIR_RootConstrainSelectedInstOperands,
     /* 111494 */   // GIR_Coverage, 6378,
     /* 111494 */   GIR_EraseRootFromParent_Done,
     /* 111495 */ // Label 2132: @111495
     /* 111495 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(111570), // Rule ID 6379 //
     /* 111500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111515 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111519 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111523 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111528 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111532 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111536 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111540 */   // MIs[2] Operand 1
     /* 111540 */   // No operand predicates
     /* 111540 */   // MIs[0] Rn
     /* 111540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111548 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111550 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111553 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111557 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111560 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111562 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111568 */   GIR_RootConstrainSelectedInstOperands,
     /* 111569 */   // GIR_Coverage, 6379,
     /* 111569 */   GIR_EraseRootFromParent_Done,
     /* 111570 */ // Label 2133: @111570
     /* 111570 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(111683), // Rule ID 6383 //
     /* 111575 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111578 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111582 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111597 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111605 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111610 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111614 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111618 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111622 */   // MIs[2] Operand 1
     /* 111622 */   // No operand predicates
     /* 111622 */   // MIs[0] Rn
     /* 111622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111630 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111632 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111644 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111647 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111651 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111670 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111673 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111681 */   GIR_RootConstrainSelectedInstOperands,
     /* 111682 */   // GIR_Coverage, 6383,
     /* 111682 */   GIR_EraseRootFromParent_Done,
     /* 111683 */ // Label 2134: @111683
     /* 111683 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(111796), // Rule ID 6384 //
     /* 111688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111691 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111710 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111714 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111718 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111723 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111727 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111731 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 111735 */   // MIs[2] Operand 1
     /* 111735 */   // No operand predicates
     /* 111735 */   // MIs[0] Rn
     /* 111735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111743 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111745 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111757 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111760 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111764 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 111780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111783 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111786 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111794 */   GIR_RootConstrainSelectedInstOperands,
     /* 111795 */   // GIR_Coverage, 6384,
     /* 111795 */   GIR_EraseRootFromParent_Done,
     /* 111796 */ // Label 2135: @111796
     /* 111796 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(111902), // Rule ID 6385 //
     /* 111801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111816 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111820 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111824 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111829 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111833 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111837 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111841 */   // MIs[2] Operand 1
     /* 111841 */   // No operand predicates
     /* 111841 */   // MIs[0] Rn
     /* 111841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111849 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111851 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111863 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111870 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111889 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111892 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111900 */   GIR_RootConstrainSelectedInstOperands,
     /* 111901 */   // GIR_Coverage, 6385,
     /* 111901 */   GIR_EraseRootFromParent_Done,
     /* 111902 */ // Label 2136: @111902
     /* 111902 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112008), // Rule ID 6386 //
     /* 111907 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111910 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111922 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111935 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111939 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111943 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111947 */   // MIs[2] Operand 1
     /* 111947 */   // No operand predicates
     /* 111947 */   // MIs[0] Rn
     /* 111947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111955 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111957 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111969 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111972 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111976 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111995 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111998 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112006 */   GIR_RootConstrainSelectedInstOperands,
     /* 112007 */   // GIR_Coverage, 6386,
     /* 112007 */   GIR_EraseRootFromParent_Done,
     /* 112008 */ // Label 2137: @112008
     /* 112008 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112068), // Rule ID 295 //
     /* 112013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112016 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112020 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112042 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 112045 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112066 */   GIR_RootConstrainSelectedInstOperands,
     /* 112067 */   // GIR_Coverage, 295,
     /* 112067 */   GIR_EraseRootFromParent_Done,
     /* 112068 */ // Label 2138: @112068
     /* 112068 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112128), // Rule ID 296 //
     /* 112073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112076 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112080 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112102 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 112105 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112126 */   GIR_RootConstrainSelectedInstOperands,
     /* 112127 */   // GIR_Coverage, 296,
     /* 112127 */   GIR_EraseRootFromParent_Done,
     /* 112128 */ // Label 2139: @112128
     /* 112128 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112188), // Rule ID 297 //
     /* 112133 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112136 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112162 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 112165 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112186 */   GIR_RootConstrainSelectedInstOperands,
     /* 112187 */   // GIR_Coverage, 297,
     /* 112187 */   GIR_EraseRootFromParent_Done,
     /* 112188 */ // Label 2140: @112188
     /* 112188 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112248), // Rule ID 298 //
     /* 112193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112222 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 112225 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112246 */   GIR_RootConstrainSelectedInstOperands,
     /* 112247 */   // GIR_Coverage, 298,
     /* 112247 */   GIR_EraseRootFromParent_Done,
     /* 112248 */ // Label 2141: @112248
     /* 112248 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112301), // Rule ID 299 //
     /* 112253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112275 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 112278 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112299 */   GIR_RootConstrainSelectedInstOperands,
     /* 112300 */   // GIR_Coverage, 299,
     /* 112300 */   GIR_EraseRootFromParent_Done,
     /* 112301 */ // Label 2142: @112301
     /* 112301 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(112354), // Rule ID 300 //
     /* 112306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112328 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 112331 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112352 */   GIR_RootConstrainSelectedInstOperands,
     /* 112353 */   // GIR_Coverage, 300,
     /* 112353 */   GIR_EraseRootFromParent_Done,
     /* 112354 */ // Label 2143: @112354
     /* 112354 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(112410), // Rule ID 307 //
     /* 112359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112365 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112384 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112387 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112408 */   GIR_RootConstrainSelectedInstOperands,
     /* 112409 */   // GIR_Coverage, 307,
     /* 112409 */   GIR_EraseRootFromParent_Done,
     /* 112410 */ // Label 2144: @112410
     /* 112410 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(112466), // Rule ID 308 //
     /* 112415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112440 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112443 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112464 */   GIR_RootConstrainSelectedInstOperands,
     /* 112465 */   // GIR_Coverage, 308,
     /* 112465 */   GIR_EraseRootFromParent_Done,
     /* 112466 */ // Label 2145: @112466
     /* 112466 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(112518), // Rule ID 312 //
     /* 112471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112474 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112482 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112486 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 112493 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 112493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 112496 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112516 */   GIR_RootConstrainSelectedInstOperands,
     /* 112517 */   // GIR_Coverage, 312,
     /* 112517 */   GIR_EraseRootFromParent_Done,
     /* 112518 */ // Label 2146: @112518
     /* 112518 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(112569), // Rule ID 315 //
     /* 112523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112529 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112541 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 112548 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 112548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 112551 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112567 */   GIR_RootConstrainSelectedInstOperands,
     /* 112568 */   // GIR_Coverage, 315,
     /* 112568 */   GIR_EraseRootFromParent_Done,
     /* 112569 */ // Label 2147: @112569
     /* 112569 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(112628), // Rule ID 317 //
     /* 112574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112577 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112581 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112603 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 112606 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112626 */   GIR_RootConstrainSelectedInstOperands,
     /* 112627 */   // GIR_Coverage, 317,
     /* 112627 */   GIR_EraseRootFromParent_Done,
     /* 112628 */ // Label 2148: @112628
     /* 112628 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(112687), // Rule ID 318 //
     /* 112633 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112636 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112640 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112655 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 112662 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 112662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 112665 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112685 */   GIR_RootConstrainSelectedInstOperands,
     /* 112686 */   // GIR_Coverage, 318,
     /* 112686 */   GIR_EraseRootFromParent_Done,
     /* 112687 */ // Label 2149: @112687
     /* 112687 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(112764), // Rule ID 7007 //
     /* 112692 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112702 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112705 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112709 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112713 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112717 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112728 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112735 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15767>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112738 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 112742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112762 */   GIR_RootConstrainSelectedInstOperands,
     /* 112763 */   // GIR_Coverage, 7007,
     /* 112763 */   GIR_EraseRootFromParent_Done,
     /* 112764 */ // Label 2150: @112764
     /* 112764 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(112841), // Rule ID 7008 //
     /* 112769 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112772 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112779 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112782 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112786 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112790 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112794 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112812 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15767>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112815 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 112819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112839 */   GIR_RootConstrainSelectedInstOperands,
     /* 112840 */   // GIR_Coverage, 7008,
     /* 112840 */   GIR_EraseRootFromParent_Done,
     /* 112841 */ // Label 2151: @112841
     /* 112841 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(112900), // Rule ID 6988 //
     /* 112846 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112849 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112856 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112874 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15753>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 112877 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112898 */   GIR_RootConstrainSelectedInstOperands,
     /* 112899 */   // GIR_Coverage, 6988,
     /* 112899 */   GIR_EraseRootFromParent_Done,
     /* 112900 */ // Label 2152: @112900
     /* 112900 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(112959), // Rule ID 6989 //
     /* 112905 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112908 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112915 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112933 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15753>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 112936 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112957 */   GIR_RootConstrainSelectedInstOperands,
     /* 112958 */   // GIR_Coverage, 6989,
     /* 112958 */   GIR_EraseRootFromParent_Done,
     /* 112959 */ // Label 2153: @112959
     /* 112959 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113018), // Rule ID 6993 //
     /* 112964 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112967 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112974 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112985 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112992 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15760>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 112995 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113016 */   GIR_RootConstrainSelectedInstOperands,
     /* 113017 */   // GIR_Coverage, 6993,
     /* 113017 */   GIR_EraseRootFromParent_Done,
     /* 113018 */ // Label 2154: @113018
     /* 113018 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113077), // Rule ID 6994 //
     /* 113023 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113026 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113033 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113040 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113044 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113051 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15760>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 113054 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113071 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113075 */   GIR_RootConstrainSelectedInstOperands,
     /* 113076 */   // GIR_Coverage, 6994,
     /* 113076 */   GIR_EraseRootFromParent_Done,
     /* 113077 */ // Label 2155: @113077
     /* 113077 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113136), // Rule ID 6998 //
     /* 113082 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113092 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113110 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15767>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 113113 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113134 */   GIR_RootConstrainSelectedInstOperands,
     /* 113135 */   // GIR_Coverage, 6998,
     /* 113135 */   GIR_EraseRootFromParent_Done,
     /* 113136 */ // Label 2156: @113136
     /* 113136 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113195), // Rule ID 6999 //
     /* 113141 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113144 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113151 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113169 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15767>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 113172 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113193 */   GIR_RootConstrainSelectedInstOperands,
     /* 113194 */   // GIR_Coverage, 6999,
     /* 113194 */   GIR_EraseRootFromParent_Done,
     /* 113195 */ // Label 2157: @113195
     /* 113195 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113267), // Rule ID 7009 //
     /* 113200 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113203 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113210 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113221 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113225 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113236 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113243 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15767>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 113246 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 113250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113265 */   GIR_RootConstrainSelectedInstOperands,
     /* 113266 */   // GIR_Coverage, 7009,
     /* 113266 */   GIR_EraseRootFromParent_Done,
     /* 113267 */ // Label 2158: @113267
     /* 113267 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113339), // Rule ID 7010 //
     /* 113272 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113275 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113282 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113315 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15767>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113318 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 113322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113337 */   GIR_RootConstrainSelectedInstOperands,
     /* 113338 */   // GIR_Coverage, 7010,
     /* 113338 */   GIR_EraseRootFromParent_Done,
     /* 113339 */ // Label 2159: @113339
     /* 113339 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113391), // Rule ID 320 //
     /* 113344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113359 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113366 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 113369 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113389 */   GIR_RootConstrainSelectedInstOperands,
     /* 113390 */   // GIR_Coverage, 320,
     /* 113390 */   GIR_EraseRootFromParent_Done,
     /* 113391 */ // Label 2160: @113391
     /* 113391 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113442), // Rule ID 323 //
     /* 113396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113399 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113402 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113410 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113414 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113421 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113424 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113440 */   GIR_RootConstrainSelectedInstOperands,
     /* 113441 */   // GIR_Coverage, 323,
     /* 113441 */   GIR_EraseRootFromParent_Done,
     /* 113442 */ // Label 2161: @113442
     /* 113442 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113501), // Rule ID 326 //
     /* 113447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113450 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113476 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 113479 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113499 */   GIR_RootConstrainSelectedInstOperands,
     /* 113500 */   // GIR_Coverage, 326,
     /* 113500 */   GIR_EraseRootFromParent_Done,
     /* 113501 */ // Label 2162: @113501
     /* 113501 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113560), // Rule ID 327 //
     /* 113506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113509 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113535 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 113538 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113558 */   GIR_RootConstrainSelectedInstOperands,
     /* 113559 */   // GIR_Coverage, 327,
     /* 113559 */   GIR_EraseRootFromParent_Done,
     /* 113560 */ // Label 2163: @113560
     /* 113560 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113614), // Rule ID 6990 //
     /* 113565 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113568 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113575 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113582 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113586 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 113593 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15753>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 113593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 113596 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113612 */   GIR_RootConstrainSelectedInstOperands,
     /* 113613 */   // GIR_Coverage, 6990,
     /* 113613 */   GIR_EraseRootFromParent_Done,
     /* 113614 */ // Label 2164: @113614
     /* 113614 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(113668), // Rule ID 6991 //
     /* 113619 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113629 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113647 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15753>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 113650 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113666 */   GIR_RootConstrainSelectedInstOperands,
     /* 113667 */   // GIR_Coverage, 6991,
     /* 113667 */   GIR_EraseRootFromParent_Done,
     /* 113668 */ // Label 2165: @113668
     /* 113668 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(113722), // Rule ID 6995 //
     /* 113673 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113676 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113683 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113694 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113701 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15760>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 113704 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113720 */   GIR_RootConstrainSelectedInstOperands,
     /* 113721 */   // GIR_Coverage, 6995,
     /* 113721 */   GIR_EraseRootFromParent_Done,
     /* 113722 */ // Label 2166: @113722
     /* 113722 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(113776), // Rule ID 6996 //
     /* 113727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113730 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113737 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113755 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15760>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 113758 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113774 */   GIR_RootConstrainSelectedInstOperands,
     /* 113775 */   // GIR_Coverage, 6996,
     /* 113775 */   GIR_EraseRootFromParent_Done,
     /* 113776 */ // Label 2167: @113776
     /* 113776 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(113830), // Rule ID 7000 //
     /* 113781 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113791 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113809 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15767>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 113812 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113824 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113828 */   GIR_RootConstrainSelectedInstOperands,
     /* 113829 */   // GIR_Coverage, 7000,
     /* 113829 */   GIR_EraseRootFromParent_Done,
     /* 113830 */ // Label 2168: @113830
     /* 113830 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(113884), // Rule ID 7001 //
     /* 113835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113845 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113856 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113863 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15767>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 113866 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113882 */   GIR_RootConstrainSelectedInstOperands,
     /* 113883 */   // GIR_Coverage, 7001,
     /* 113883 */   GIR_EraseRootFromParent_Done,
     /* 113884 */ // Label 2169: @113884
     /* 113884 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(113941), // Rule ID 7333 //
     /* 113889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113892 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113920 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15751>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 113923 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113939 */   GIR_RootConstrainSelectedInstOperands,
     /* 113940 */   // GIR_Coverage, 7333,
     /* 113940 */   GIR_EraseRootFromParent_Done,
     /* 113941 */ // Label 2170: @113941
     /* 113941 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(113998), // Rule ID 7334 //
     /* 113946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113949 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113959 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113977 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15758>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 113980 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113996 */   GIR_RootConstrainSelectedInstOperands,
     /* 113997 */   // GIR_Coverage, 7334,
     /* 113997 */   GIR_EraseRootFromParent_Done,
     /* 113998 */ // Label 2171: @113998
     /* 113998 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114055), // Rule ID 7335 //
     /* 114003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 114006 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 114009 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 114016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 114019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114027 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 114034 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15765>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 114037 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 114039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114053 */   GIR_RootConstrainSelectedInstOperands,
     /* 114054 */   // GIR_Coverage, 7335,
     /* 114054 */   GIR_EraseRootFromParent_Done,
     /* 114055 */ // Label 2172: @114055
     /* 114055 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114092), // Rule ID 6987 //
     /* 114060 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 114063 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 114073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114077 */   // MIs[0] ptr
     /* 114077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114085 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15751>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 114085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 114090 */   GIR_RootConstrainSelectedInstOperands,
     /* 114091 */   // GIR_Coverage, 6987,
     /* 114091 */   GIR_Done,
     /* 114092 */ // Label 2173: @114092
     /* 114092 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114129), // Rule ID 6992 //
     /* 114097 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 114100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114107 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 114110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114114 */   // MIs[0] ptr
     /* 114114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114122 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15758>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 114122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 114127 */   GIR_RootConstrainSelectedInstOperands,
     /* 114128 */   // GIR_Coverage, 6992,
     /* 114128 */   GIR_Done,
     /* 114129 */ // Label 2174: @114129
     /* 114129 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114166), // Rule ID 6997 //
     /* 114134 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 114137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 114144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 114147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114151 */   // MIs[0] ptr
     /* 114151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114159 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15765>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 114159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 114164 */   GIR_RootConstrainSelectedInstOperands,
     /* 114165 */   // GIR_Coverage, 6997,
     /* 114165 */   GIR_Done,
     /* 114166 */ // Label 2175: @114166
     /* 114166 */ GIM_Reject,
     /* 114167 */ // Label 2074: @114167
     /* 114167 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114273), // Rule ID 4441 //
     /* 114172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114187 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114191 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114195 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114200 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114204 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114208 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114217 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114229 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114240 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 114248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114271 */   GIR_RootConstrainSelectedInstOperands,
     /* 114272 */   // GIR_Coverage, 4441,
     /* 114272 */   GIR_EraseRootFromParent_Done,
     /* 114273 */ // Label 2176: @114273
     /* 114273 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114379), // Rule ID 4442 //
     /* 114278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114281 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114297 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114306 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114323 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114335 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114341 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 114354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114377 */   GIR_RootConstrainSelectedInstOperands,
     /* 114378 */   // GIR_Coverage, 4442,
     /* 114378 */   GIR_EraseRootFromParent_Done,
     /* 114379 */ // Label 2177: @114379
     /* 114379 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114485), // Rule ID 4443 //
     /* 114384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114387 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114391 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114399 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114403 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114407 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114412 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114422 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114429 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114441 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114447 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114452 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 114460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114483 */   GIR_RootConstrainSelectedInstOperands,
     /* 114484 */   // GIR_Coverage, 4443,
     /* 114484 */   GIR_EraseRootFromParent_Done,
     /* 114485 */ // Label 2178: @114485
     /* 114485 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114591), // Rule ID 4444 //
     /* 114490 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114493 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114505 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114509 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114513 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114518 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114535 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114547 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 114566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114584 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114589 */   GIR_RootConstrainSelectedInstOperands,
     /* 114590 */   // GIR_Coverage, 4444,
     /* 114590 */   GIR_EraseRootFromParent_Done,
     /* 114591 */ // Label 2179: @114591
     /* 114591 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114692), // Rule ID 4467 //
     /* 114596 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114599 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114603 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114607 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114611 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114615 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114624 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 114641 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 114641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114653 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 114672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114690 */   GIR_RootConstrainSelectedInstOperands,
     /* 114691 */   // GIR_Coverage, 4467,
     /* 114691 */   GIR_EraseRootFromParent_Done,
     /* 114692 */ // Label 2180: @114692
     /* 114692 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(114793), // Rule ID 4468 //
     /* 114697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114700 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 114742 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 114742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114754 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114760 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 114773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114791 */   GIR_RootConstrainSelectedInstOperands,
     /* 114792 */   // GIR_Coverage, 4468,
     /* 114792 */   GIR_EraseRootFromParent_Done,
     /* 114793 */ // Label 2181: @114793
     /* 114793 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(114894), // Rule ID 4492 //
     /* 114798 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114801 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114813 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114821 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114826 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114836 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114843 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114855 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114861 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 114874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114892 */   GIR_RootConstrainSelectedInstOperands,
     /* 114893 */   // GIR_Coverage, 4492,
     /* 114893 */   GIR_EraseRootFromParent_Done,
     /* 114894 */ // Label 2182: @114894
     /* 114894 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(114995), // Rule ID 4493 //
     /* 114899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114914 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114918 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114922 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114927 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114937 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114944 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114956 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114962 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 114975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114993 */   GIR_RootConstrainSelectedInstOperands,
     /* 114994 */   // GIR_Coverage, 4493,
     /* 114994 */   GIR_EraseRootFromParent_Done,
     /* 114995 */ // Label 2183: @114995
     /* 114995 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(115070), // Rule ID 6380 //
     /* 115000 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115003 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115015 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115019 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115023 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115028 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115032 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115036 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 115040 */   // MIs[2] Operand 1
     /* 115040 */   // No operand predicates
     /* 115040 */   // MIs[0] Rn
     /* 115040 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115048 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115050 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 115053 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115057 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115060 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115068 */   GIR_RootConstrainSelectedInstOperands,
     /* 115069 */   // GIR_Coverage, 6380,
     /* 115069 */   GIR_EraseRootFromParent_Done,
     /* 115070 */ // Label 2184: @115070
     /* 115070 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(115145), // Rule ID 6381 //
     /* 115075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115082 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115086 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115090 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115094 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115098 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115103 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115107 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115111 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 115115 */   // MIs[2] Operand 1
     /* 115115 */   // No operand predicates
     /* 115115 */   // MIs[0] Rn
     /* 115115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115123 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115125 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 115128 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115132 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115135 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115143 */   GIR_RootConstrainSelectedInstOperands,
     /* 115144 */   // GIR_Coverage, 6381,
     /* 115144 */   GIR_EraseRootFromParent_Done,
     /* 115145 */ // Label 2185: @115145
     /* 115145 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115198), // Rule ID 301 //
     /* 115150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115161 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115165 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115172 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 115175 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115196 */   GIR_RootConstrainSelectedInstOperands,
     /* 115197 */   // GIR_Coverage, 301,
     /* 115197 */   GIR_EraseRootFromParent_Done,
     /* 115198 */ // Label 2186: @115198
     /* 115198 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115251), // Rule ID 302 //
     /* 115203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115218 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115225 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 115228 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115245 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115249 */   GIR_RootConstrainSelectedInstOperands,
     /* 115250 */   // GIR_Coverage, 302,
     /* 115250 */   GIR_EraseRootFromParent_Done,
     /* 115251 */ // Label 2187: @115251
     /* 115251 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115307), // Rule ID 309 //
     /* 115256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115262 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115270 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115274 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115281 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115284 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115305 */   GIR_RootConstrainSelectedInstOperands,
     /* 115306 */   // GIR_Coverage, 309,
     /* 115306 */   GIR_EraseRootFromParent_Done,
     /* 115307 */ // Label 2188: @115307
     /* 115307 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(115363), // Rule ID 310 //
     /* 115312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115337 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115340 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115361 */   GIR_RootConstrainSelectedInstOperands,
     /* 115362 */   // GIR_Coverage, 310,
     /* 115362 */   GIR_EraseRootFromParent_Done,
     /* 115363 */ // Label 2189: @115363
     /* 115363 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(115452), // Rule ID 4399 //
     /* 115368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115371 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 115397 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 115397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115409 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115420 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 115428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115446 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115450 */   GIR_RootConstrainSelectedInstOperands,
     /* 115451 */   // GIR_Coverage, 4399,
     /* 115451 */   GIR_EraseRootFromParent_Done,
     /* 115452 */ // Label 2190: @115452
     /* 115452 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(115541), // Rule ID 4400 //
     /* 115457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115460 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115464 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115475 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115479 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 115486 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 115486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115498 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 115517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115539 */   GIR_RootConstrainSelectedInstOperands,
     /* 115540 */   // GIR_Coverage, 4400,
     /* 115540 */   GIR_EraseRootFromParent_Done,
     /* 115541 */ // Label 2191: @115541
     /* 115541 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(115630), // Rule ID 4401 //
     /* 115546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115549 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115553 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115564 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 115575 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 115575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115587 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115593 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 115606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115628 */   GIR_RootConstrainSelectedInstOperands,
     /* 115629 */   // GIR_Coverage, 4401,
     /* 115629 */   GIR_EraseRootFromParent_Done,
     /* 115630 */ // Label 2192: @115630
     /* 115630 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(115719), // Rule ID 4402 //
     /* 115635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115638 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115664 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115676 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115717 */   GIR_RootConstrainSelectedInstOperands,
     /* 115718 */   // GIR_Coverage, 4402,
     /* 115718 */   GIR_EraseRootFromParent_Done,
     /* 115719 */ // Label 2193: @115719
     /* 115719 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(115808), // Rule ID 4403 //
     /* 115724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115727 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115731 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115753 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115765 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115771 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115806 */   GIR_RootConstrainSelectedInstOperands,
     /* 115807 */   // GIR_Coverage, 4403,
     /* 115807 */   GIR_EraseRootFromParent_Done,
     /* 115808 */ // Label 2194: @115808
     /* 115808 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(115897), // Rule ID 4404 //
     /* 115813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115816 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115842 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115854 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115860 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115865 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 115873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115895 */   GIR_RootConstrainSelectedInstOperands,
     /* 115896 */   // GIR_Coverage, 4404,
     /* 115896 */   GIR_EraseRootFromParent_Done,
     /* 115897 */ // Label 2195: @115897
     /* 115897 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(115950), // Rule ID 4415 //
     /* 115902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115924 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115927 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115948 */   GIR_RootConstrainSelectedInstOperands,
     /* 115949 */   // GIR_Coverage, 4415,
     /* 115949 */   GIR_EraseRootFromParent_Done,
     /* 115950 */ // Label 2196: @115950
     /* 115950 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(116003), // Rule ID 4416 //
     /* 115955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115977 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115980 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116001 */   GIR_RootConstrainSelectedInstOperands,
     /* 116002 */   // GIR_Coverage, 4416,
     /* 116002 */   GIR_EraseRootFromParent_Done,
     /* 116003 */ // Label 2197: @116003
     /* 116003 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(116056), // Rule ID 4417 //
     /* 116008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116030 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 116033 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116054 */   GIR_RootConstrainSelectedInstOperands,
     /* 116055 */   // GIR_Coverage, 4417,
     /* 116055 */   GIR_EraseRootFromParent_Done,
     /* 116056 */ // Label 2198: @116056
     /* 116056 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(116109), // Rule ID 4418 //
     /* 116061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116083 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 116086 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116107 */   GIR_RootConstrainSelectedInstOperands,
     /* 116108 */   // GIR_Coverage, 4418,
     /* 116108 */   GIR_EraseRootFromParent_Done,
     /* 116109 */ // Label 2199: @116109
     /* 116109 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(116161), // Rule ID 311 //
     /* 116114 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116117 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116136 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 116139 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 116145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116155 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116159 */   GIR_RootConstrainSelectedInstOperands,
     /* 116160 */   // GIR_Coverage, 311,
     /* 116160 */   GIR_EraseRootFromParent_Done,
     /* 116161 */ // Label 2200: @116161
     /* 116161 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(116212), // Rule ID 316 //
     /* 116166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116172 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116191 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116194 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116210 */   GIR_RootConstrainSelectedInstOperands,
     /* 116211 */   // GIR_Coverage, 316,
     /* 116211 */   GIR_EraseRootFromParent_Done,
     /* 116212 */ // Label 2201: @116212
     /* 116212 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(116260), // Rule ID 4445 //
     /* 116217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116220 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116228 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116232 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116239 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116242 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116258 */   GIR_RootConstrainSelectedInstOperands,
     /* 116259 */   // GIR_Coverage, 4445,
     /* 116259 */   GIR_EraseRootFromParent_Done,
     /* 116260 */ // Label 2202: @116260
     /* 116260 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(116308), // Rule ID 4446 //
     /* 116265 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116268 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116276 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116280 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116287 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116290 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116306 */   GIR_RootConstrainSelectedInstOperands,
     /* 116307 */   // GIR_Coverage, 4446,
     /* 116307 */   GIR_EraseRootFromParent_Done,
     /* 116308 */ // Label 2203: @116308
     /* 116308 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(116392), // Rule ID 4460 //
     /* 116313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116316 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116342 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116354 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116390 */   GIR_RootConstrainSelectedInstOperands,
     /* 116391 */   // GIR_Coverage, 4460,
     /* 116391 */   GIR_EraseRootFromParent_Done,
     /* 116392 */ // Label 2204: @116392
     /* 116392 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(116476), // Rule ID 4461 //
     /* 116397 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116400 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116426 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116438 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116444 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116449 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116474 */   GIR_RootConstrainSelectedInstOperands,
     /* 116475 */   // GIR_Coverage, 4461,
     /* 116475 */   GIR_EraseRootFromParent_Done,
     /* 116476 */ // Label 2205: @116476
     /* 116476 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(116560), // Rule ID 4462 //
     /* 116481 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116484 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116510 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116522 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116528 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116558 */   GIR_RootConstrainSelectedInstOperands,
     /* 116559 */   // GIR_Coverage, 4462,
     /* 116559 */   GIR_EraseRootFromParent_Done,
     /* 116560 */ // Label 2206: @116560
     /* 116560 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(116637), // Rule ID 7011 //
     /* 116565 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116568 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116575 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116586 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116590 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116595 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116608 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15774>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 116611 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116635 */   GIR_RootConstrainSelectedInstOperands,
     /* 116636 */   // GIR_Coverage, 7011,
     /* 116636 */   GIR_EraseRootFromParent_Done,
     /* 116637 */ // Label 2207: @116637
     /* 116637 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(116714), // Rule ID 7012 //
     /* 116642 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116645 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116652 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116663 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116667 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116672 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116676 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116685 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15774>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 116688 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116712 */   GIR_RootConstrainSelectedInstOperands,
     /* 116713 */   // GIR_Coverage, 7012,
     /* 116713 */   GIR_EraseRootFromParent_Done,
     /* 116714 */ // Label 2208: @116714
     /* 116714 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(116773), // Rule ID 7003 //
     /* 116719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116729 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116747 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15774>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 116750 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116771 */   GIR_RootConstrainSelectedInstOperands,
     /* 116772 */   // GIR_Coverage, 7003,
     /* 116772 */   GIR_EraseRootFromParent_Done,
     /* 116773 */ // Label 2209: @116773
     /* 116773 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(116832), // Rule ID 7004 //
     /* 116778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116806 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15774>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 116809 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116830 */   GIR_RootConstrainSelectedInstOperands,
     /* 116831 */   // GIR_Coverage, 7004,
     /* 116831 */   GIR_EraseRootFromParent_Done,
     /* 116832 */ // Label 2210: @116832
     /* 116832 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(116904), // Rule ID 7013 //
     /* 116837 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116847 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116858 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116862 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116867 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116873 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116880 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15774>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116883 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116902 */   GIR_RootConstrainSelectedInstOperands,
     /* 116903 */   // GIR_Coverage, 7013,
     /* 116903 */   GIR_EraseRootFromParent_Done,
     /* 116904 */ // Label 2211: @116904
     /* 116904 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(116976), // Rule ID 7014 //
     /* 116909 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116919 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116934 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 116952 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15774>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 116955 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116969 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116974 */   GIR_RootConstrainSelectedInstOperands,
     /* 116975 */   // GIR_Coverage, 7014,
     /* 116975 */   GIR_EraseRootFromParent_Done,
     /* 116976 */ // Label 2212: @116976
     /* 116976 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(117073), // Rule ID 7325 //
     /* 116981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 116984 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116987 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117005 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117009 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 117013 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117017 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117021 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 117025 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117030 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 117034 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117038 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 117042 */   // MIs[3] Operand 1
     /* 117042 */   // No operand predicates
     /* 117042 */   // MIs[0] Rn
     /* 117042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117050 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 117052 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15772>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 117052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117055 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 117059 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 117062 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 117071 */   GIR_RootConstrainSelectedInstOperands,
     /* 117072 */   // GIR_Coverage, 7325,
     /* 117072 */   GIR_EraseRootFromParent_Done,
     /* 117073 */ // Label 2213: @117073
     /* 117073 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(117125), // Rule ID 319 //
     /* 117078 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117081 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117089 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117093 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117100 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 117103 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 117109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117123 */   GIR_RootConstrainSelectedInstOperands,
     /* 117124 */   // GIR_Coverage, 319,
     /* 117124 */   GIR_EraseRootFromParent_Done,
     /* 117125 */ // Label 2214: @117125
     /* 117125 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(117176), // Rule ID 324 //
     /* 117130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117133 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117136 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117155 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117158 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117174 */   GIR_RootConstrainSelectedInstOperands,
     /* 117175 */   // GIR_Coverage, 324,
     /* 117175 */   GIR_EraseRootFromParent_Done,
     /* 117176 */ // Label 2215: @117176
     /* 117176 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(117230), // Rule ID 7005 //
     /* 117181 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117184 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117191 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117198 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117202 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 117209 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15774>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 117209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 117212 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117224 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117228 */   GIR_RootConstrainSelectedInstOperands,
     /* 117229 */   // GIR_Coverage, 7005,
     /* 117229 */   GIR_EraseRootFromParent_Done,
     /* 117230 */ // Label 2216: @117230
     /* 117230 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(117284), // Rule ID 7006 //
     /* 117235 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117238 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117245 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117256 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117263 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15774>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 117266 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117282 */   GIR_RootConstrainSelectedInstOperands,
     /* 117283 */   // GIR_Coverage, 7006,
     /* 117283 */   GIR_EraseRootFromParent_Done,
     /* 117284 */ // Label 2217: @117284
     /* 117284 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(117341), // Rule ID 7336 //
     /* 117289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117292 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117302 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117313 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117320 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15772>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 117323 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117339 */   GIR_RootConstrainSelectedInstOperands,
     /* 117340 */   // GIR_Coverage, 7336,
     /* 117340 */   GIR_EraseRootFromParent_Done,
     /* 117341 */ // Label 2218: @117341
     /* 117341 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(117389), // Rule ID 4469 //
     /* 117346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117357 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117368 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117371 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117387 */   GIR_RootConstrainSelectedInstOperands,
     /* 117388 */   // GIR_Coverage, 4469,
     /* 117388 */   GIR_EraseRootFromParent_Done,
     /* 117389 */ // Label 2219: @117389
     /* 117389 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(117437), // Rule ID 4470 //
     /* 117394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117397 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117405 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117409 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117416 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117419 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117435 */   GIR_RootConstrainSelectedInstOperands,
     /* 117436 */   // GIR_Coverage, 4470,
     /* 117436 */   GIR_EraseRootFromParent_Done,
     /* 117437 */ // Label 2220: @117437
     /* 117437 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(117521), // Rule ID 4485 //
     /* 117442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117445 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117471 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117483 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117489 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117494 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117515 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117519 */   GIR_RootConstrainSelectedInstOperands,
     /* 117520 */   // GIR_Coverage, 4485,
     /* 117520 */   GIR_EraseRootFromParent_Done,
     /* 117521 */ // Label 2221: @117521
     /* 117521 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(117605), // Rule ID 4486 //
     /* 117526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117529 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117533 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117555 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117567 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117578 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117603 */   GIR_RootConstrainSelectedInstOperands,
     /* 117604 */   // GIR_Coverage, 4486,
     /* 117604 */   GIR_EraseRootFromParent_Done,
     /* 117605 */ // Label 2222: @117605
     /* 117605 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(117689), // Rule ID 4487 //
     /* 117610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117613 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117617 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117639 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117651 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117687 */   GIR_RootConstrainSelectedInstOperands,
     /* 117688 */   // GIR_Coverage, 4487,
     /* 117688 */   GIR_EraseRootFromParent_Done,
     /* 117689 */ // Label 2223: @117689
     /* 117689 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(117773), // Rule ID 7324 //
     /* 117694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 117697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117707 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117710 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117718 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117722 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117726 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117731 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 117735 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117739 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 117743 */   // MIs[2] Operand 1
     /* 117743 */   // No operand predicates
     /* 117743 */   // MIs[0] Rn
     /* 117743 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117751 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117753 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15772>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 117753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117756 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117760 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 117763 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117765 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117771 */   GIR_RootConstrainSelectedInstOperands,
     /* 117772 */   // GIR_Coverage, 7324,
     /* 117772 */   GIR_EraseRootFromParent_Done,
     /* 117773 */ // Label 2224: @117773
     /* 117773 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(117871), // Rule ID 7326 //
     /* 117778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 117781 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117791 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117794 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117802 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117806 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117811 */   // MIs[0] Rn
     /* 117811 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117819 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117821 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15772>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 117821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 117828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117833 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 117836 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117840 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117862 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117869 */   GIR_RootConstrainSelectedInstOperands,
     /* 117870 */   // GIR_Coverage, 7326,
     /* 117870 */   GIR_EraseRootFromParent_Done,
     /* 117871 */ // Label 2225: @117871
     /* 117871 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(117908), // Rule ID 7002 //
     /* 117876 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117886 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117893 */   // MIs[0] ptr
     /* 117893 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117901 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15772>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 117906 */   GIR_RootConstrainSelectedInstOperands,
     /* 117907 */   // GIR_Coverage, 7002,
     /* 117907 */   GIR_Done,
     /* 117908 */ // Label 2226: @117908
     /* 117908 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(117935), // Rule ID 6330 //
     /* 117913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117920 */   // MIs[0] Rn
     /* 117920 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117928 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 117928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 117933 */   GIR_RootConstrainSelectedInstOperands,
     /* 117934 */   // GIR_Coverage, 6330,
     /* 117934 */   GIR_Done,
     /* 117935 */ // Label 2227: @117935
     /* 117935 */ GIM_Reject,
     /* 117936 */ // Label 2075: @117936
     /* 117936 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(118141),
     /* 117941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117956 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(117997), // Rule ID 4397 //
     /* 117961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 117964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 117971 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 117971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 117974 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117995 */     GIR_RootConstrainSelectedInstOperands,
     /* 117996 */     // GIR_Coverage, 4397,
     /* 117996 */     GIR_EraseRootFromParent_Done,
     /* 117997 */   // Label 2229: @117997
     /* 117997 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(118038), // Rule ID 4398 //
     /* 118002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 118005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118012 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118015 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118036 */     GIR_RootConstrainSelectedInstOperands,
     /* 118037 */     // GIR_Coverage, 4398,
     /* 118037 */     GIR_EraseRootFromParent_Done,
     /* 118038 */   // Label 2230: @118038
     /* 118038 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(118071), // Rule ID 4452 //
     /* 118043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118050 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118053 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118069 */     GIR_RootConstrainSelectedInstOperands,
     /* 118070 */     // GIR_Coverage, 4452,
     /* 118070 */     GIR_EraseRootFromParent_Done,
     /* 118071 */   // Label 2231: @118071
     /* 118071 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(118104), // Rule ID 4476 //
     /* 118076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118083 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118086 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118102 */     GIR_RootConstrainSelectedInstOperands,
     /* 118103 */     // GIR_Coverage, 4476,
     /* 118103 */     GIR_EraseRootFromParent_Done,
     /* 118104 */   // Label 2232: @118104
     /* 118104 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(118140), // Rule ID 325 //
     /* 118109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118119 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118122 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118138 */     GIR_RootConstrainSelectedInstOperands,
     /* 118139 */     // GIR_Coverage, 325,
     /* 118139 */     GIR_EraseRootFromParent_Done,
     /* 118140 */   // Label 2233: @118140
     /* 118140 */   GIM_Reject,
     /* 118141 */ // Label 2228: @118141
     /* 118141 */ GIM_Reject,
     /* 118142 */ // Label 2076: @118142
     /* 118142 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(118547),
     /* 118147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118154 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(118203), // Rule ID 4405 //
     /* 118159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118177 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118180 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118201 */     GIR_RootConstrainSelectedInstOperands,
     /* 118202 */     // GIR_Coverage, 4405,
     /* 118202 */     GIR_EraseRootFromParent_Done,
     /* 118203 */   // Label 2235: @118203
     /* 118203 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(118252), // Rule ID 4406 //
     /* 118208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118226 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118229 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118250 */     GIR_RootConstrainSelectedInstOperands,
     /* 118251 */     // GIR_Coverage, 4406,
     /* 118251 */     GIR_EraseRootFromParent_Done,
     /* 118252 */   // Label 2236: @118252
     /* 118252 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(118301), // Rule ID 4407 //
     /* 118257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118275 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118278 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118299 */     GIR_RootConstrainSelectedInstOperands,
     /* 118300 */     // GIR_Coverage, 4407,
     /* 118300 */     GIR_EraseRootFromParent_Done,
     /* 118301 */   // Label 2237: @118301
     /* 118301 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(118350), // Rule ID 4408 //
     /* 118306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118324 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118327 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118348 */     GIR_RootConstrainSelectedInstOperands,
     /* 118349 */     // GIR_Coverage, 4408,
     /* 118349 */     GIR_EraseRootFromParent_Done,
     /* 118350 */   // Label 2238: @118350
     /* 118350 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(118394), // Rule ID 4447 //
     /* 118355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118373 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118376 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118392 */     GIR_RootConstrainSelectedInstOperands,
     /* 118393 */     // GIR_Coverage, 4447,
     /* 118393 */     GIR_EraseRootFromParent_Done,
     /* 118394 */   // Label 2239: @118394
     /* 118394 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(118438), // Rule ID 4450 //
     /* 118399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118417 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118420 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118436 */     GIR_RootConstrainSelectedInstOperands,
     /* 118437 */     // GIR_Coverage, 4450,
     /* 118437 */     GIR_EraseRootFromParent_Done,
     /* 118438 */   // Label 2240: @118438
     /* 118438 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(118482), // Rule ID 4471 //
     /* 118443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 118461 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118464 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118480 */     GIR_RootConstrainSelectedInstOperands,
     /* 118481 */     // GIR_Coverage, 4471,
     /* 118481 */     GIR_EraseRootFromParent_Done,
     /* 118482 */   // Label 2241: @118482
     /* 118482 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(118526), // Rule ID 4474 //
     /* 118487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 118505 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118508 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118524 */     GIR_RootConstrainSelectedInstOperands,
     /* 118525 */     // GIR_Coverage, 4474,
     /* 118525 */     GIR_EraseRootFromParent_Done,
     /* 118526 */   // Label 2242: @118526
     /* 118526 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(118546), // Rule ID 6329 //
     /* 118531 */     // MIs[0] Rn
     /* 118531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118539 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 118539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 118544 */     GIR_RootConstrainSelectedInstOperands,
     /* 118545 */     // GIR_Coverage, 6329,
     /* 118545 */     GIR_Done,
     /* 118546 */   // Label 2243: @118546
     /* 118546 */   GIM_Reject,
     /* 118547 */ // Label 2234: @118547
     /* 118547 */ GIM_Reject,
     /* 118548 */ // Label 2077: @118548
     /* 118548 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(118997),
     /* 118553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118560 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(118609), // Rule ID 4419 //
     /* 118565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 118583 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 118586 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118607 */     GIR_RootConstrainSelectedInstOperands,
     /* 118608 */     // GIR_Coverage, 4419,
     /* 118608 */     GIR_EraseRootFromParent_Done,
     /* 118609 */   // Label 2245: @118609
     /* 118609 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(118658), // Rule ID 4420 //
     /* 118614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118632 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 118632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118635 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118656 */     GIR_RootConstrainSelectedInstOperands,
     /* 118657 */     // GIR_Coverage, 4420,
     /* 118657 */     GIR_EraseRootFromParent_Done,
     /* 118658 */   // Label 2246: @118658
     /* 118658 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(118707), // Rule ID 4421 //
     /* 118663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 118681 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 118684 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118705 */     GIR_RootConstrainSelectedInstOperands,
     /* 118706 */     // GIR_Coverage, 4421,
     /* 118706 */     GIR_EraseRootFromParent_Done,
     /* 118707 */   // Label 2247: @118707
     /* 118707 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(118756), // Rule ID 4422 //
     /* 118712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118730 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 118730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118733 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118754 */     GIR_RootConstrainSelectedInstOperands,
     /* 118755 */     // GIR_Coverage, 4422,
     /* 118755 */     GIR_EraseRootFromParent_Done,
     /* 118756 */   // Label 2248: @118756
     /* 118756 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(118800), // Rule ID 4454 //
     /* 118761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118779 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118782 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118798 */     GIR_RootConstrainSelectedInstOperands,
     /* 118799 */     // GIR_Coverage, 4454,
     /* 118799 */     GIR_EraseRootFromParent_Done,
     /* 118800 */   // Label 2249: @118800
     /* 118800 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(118844), // Rule ID 4458 //
     /* 118805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118823 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118826 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118842 */     GIR_RootConstrainSelectedInstOperands,
     /* 118843 */     // GIR_Coverage, 4458,
     /* 118843 */     GIR_EraseRootFromParent_Done,
     /* 118844 */   // Label 2250: @118844
     /* 118844 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(118888), // Rule ID 4478 //
     /* 118849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118867 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118870 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118886 */     GIR_RootConstrainSelectedInstOperands,
     /* 118887 */     // GIR_Coverage, 4478,
     /* 118887 */     GIR_EraseRootFromParent_Done,
     /* 118888 */   // Label 2251: @118888
     /* 118888 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(118932), // Rule ID 4482 //
     /* 118893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118911 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118914 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118930 */     GIR_RootConstrainSelectedInstOperands,
     /* 118931 */     // GIR_Coverage, 4482,
     /* 118931 */     GIR_EraseRootFromParent_Done,
     /* 118932 */   // Label 2252: @118932
     /* 118932 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(118976), // Rule ID 4483 //
     /* 118937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118955 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118958 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118974 */     GIR_RootConstrainSelectedInstOperands,
     /* 118975 */     // GIR_Coverage, 4483,
     /* 118975 */     GIR_EraseRootFromParent_Done,
     /* 118976 */   // Label 2253: @118976
     /* 118976 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(118996), // Rule ID 6326 //
     /* 118981 */     // MIs[0] Rn
     /* 118981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118989 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 118989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 118994 */     GIR_RootConstrainSelectedInstOperands,
     /* 118995 */     // GIR_Coverage, 6326,
     /* 118995 */     GIR_Done,
     /* 118996 */   // Label 2254: @118996
     /* 118996 */   GIM_Reject,
     /* 118997 */ // Label 2244: @118997
     /* 118997 */ GIM_Reject,
     /* 118998 */ // Label 2078: @118998
     /* 118998 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(119403),
     /* 119003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119010 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(119059), // Rule ID 4409 //
     /* 119015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119033 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119036 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119057 */     GIR_RootConstrainSelectedInstOperands,
     /* 119058 */     // GIR_Coverage, 4409,
     /* 119058 */     GIR_EraseRootFromParent_Done,
     /* 119059 */   // Label 2256: @119059
     /* 119059 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(119108), // Rule ID 4410 //
     /* 119064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119082 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119085 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119106 */     GIR_RootConstrainSelectedInstOperands,
     /* 119107 */     // GIR_Coverage, 4410,
     /* 119107 */     GIR_EraseRootFromParent_Done,
     /* 119108 */   // Label 2257: @119108
     /* 119108 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(119157), // Rule ID 4413 //
     /* 119113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119131 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119134 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119155 */     GIR_RootConstrainSelectedInstOperands,
     /* 119156 */     // GIR_Coverage, 4413,
     /* 119156 */     GIR_EraseRootFromParent_Done,
     /* 119157 */   // Label 2258: @119157
     /* 119157 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(119206), // Rule ID 4414 //
     /* 119162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119180 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119183 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119204 */     GIR_RootConstrainSelectedInstOperands,
     /* 119205 */     // GIR_Coverage, 4414,
     /* 119205 */     GIR_EraseRootFromParent_Done,
     /* 119206 */   // Label 2259: @119206
     /* 119206 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(119250), // Rule ID 4449 //
     /* 119211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119229 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119232 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119248 */     GIR_RootConstrainSelectedInstOperands,
     /* 119249 */     // GIR_Coverage, 4449,
     /* 119249 */     GIR_EraseRootFromParent_Done,
     /* 119250 */   // Label 2260: @119250
     /* 119250 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(119294), // Rule ID 4451 //
     /* 119255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119273 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119276 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119292 */     GIR_RootConstrainSelectedInstOperands,
     /* 119293 */     // GIR_Coverage, 4451,
     /* 119293 */     GIR_EraseRootFromParent_Done,
     /* 119294 */   // Label 2261: @119294
     /* 119294 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(119338), // Rule ID 4473 //
     /* 119299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119317 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119320 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119336 */     GIR_RootConstrainSelectedInstOperands,
     /* 119337 */     // GIR_Coverage, 4473,
     /* 119337 */     GIR_EraseRootFromParent_Done,
     /* 119338 */   // Label 2262: @119338
     /* 119338 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(119382), // Rule ID 4475 //
     /* 119343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119361 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119364 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119380 */     GIR_RootConstrainSelectedInstOperands,
     /* 119381 */     // GIR_Coverage, 4475,
     /* 119381 */     GIR_EraseRootFromParent_Done,
     /* 119382 */   // Label 2263: @119382
     /* 119382 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(119402), // Rule ID 6328 //
     /* 119387 */     // MIs[0] Rn
     /* 119387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119395 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 119400 */     GIR_RootConstrainSelectedInstOperands,
     /* 119401 */     // GIR_Coverage, 6328,
     /* 119401 */     GIR_Done,
     /* 119402 */   // Label 2264: @119402
     /* 119402 */   GIM_Reject,
     /* 119403 */ // Label 2255: @119403
     /* 119403 */ GIM_Reject,
     /* 119404 */ // Label 2079: @119404
     /* 119404 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(119809),
     /* 119409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119412 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119416 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(119465), // Rule ID 4423 //
     /* 119421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119439 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119442 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119463 */     GIR_RootConstrainSelectedInstOperands,
     /* 119464 */     // GIR_Coverage, 4423,
     /* 119464 */     GIR_EraseRootFromParent_Done,
     /* 119465 */   // Label 2266: @119465
     /* 119465 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(119514), // Rule ID 4424 //
     /* 119470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119488 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119491 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119512 */     GIR_RootConstrainSelectedInstOperands,
     /* 119513 */     // GIR_Coverage, 4424,
     /* 119513 */     GIR_EraseRootFromParent_Done,
     /* 119514 */   // Label 2267: @119514
     /* 119514 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(119563), // Rule ID 4425 //
     /* 119519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119537 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119540 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119561 */     GIR_RootConstrainSelectedInstOperands,
     /* 119562 */     // GIR_Coverage, 4425,
     /* 119562 */     GIR_EraseRootFromParent_Done,
     /* 119563 */   // Label 2268: @119563
     /* 119563 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(119612), // Rule ID 4426 //
     /* 119568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119586 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119589 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119610 */     GIR_RootConstrainSelectedInstOperands,
     /* 119611 */     // GIR_Coverage, 4426,
     /* 119611 */     GIR_EraseRootFromParent_Done,
     /* 119612 */   // Label 2269: @119612
     /* 119612 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(119656), // Rule ID 4453 //
     /* 119617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 119635 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 119635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 119638 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119654 */     GIR_RootConstrainSelectedInstOperands,
     /* 119655 */     // GIR_Coverage, 4453,
     /* 119655 */     GIR_EraseRootFromParent_Done,
     /* 119656 */   // Label 2270: @119656
     /* 119656 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(119700), // Rule ID 4457 //
     /* 119661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 119679 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 119679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 119682 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119698 */     GIR_RootConstrainSelectedInstOperands,
     /* 119699 */     // GIR_Coverage, 4457,
     /* 119699 */     GIR_EraseRootFromParent_Done,
     /* 119700 */   // Label 2271: @119700
     /* 119700 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(119744), // Rule ID 4477 //
     /* 119705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119723 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 119726 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119742 */     GIR_RootConstrainSelectedInstOperands,
     /* 119743 */     // GIR_Coverage, 4477,
     /* 119743 */     GIR_EraseRootFromParent_Done,
     /* 119744 */   // Label 2272: @119744
     /* 119744 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(119788), // Rule ID 4481 //
     /* 119749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119767 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 119770 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119786 */     GIR_RootConstrainSelectedInstOperands,
     /* 119787 */     // GIR_Coverage, 4481,
     /* 119787 */     GIR_EraseRootFromParent_Done,
     /* 119788 */   // Label 2273: @119788
     /* 119788 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(119808), // Rule ID 6325 //
     /* 119793 */     // MIs[0] Rn
     /* 119793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119801 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 119806 */     GIR_RootConstrainSelectedInstOperands,
     /* 119807 */     // GIR_Coverage, 6325,
     /* 119807 */     GIR_Done,
     /* 119808 */   // Label 2274: @119808
     /* 119808 */   GIM_Reject,
     /* 119809 */ // Label 2265: @119809
     /* 119809 */ GIM_Reject,
     /* 119810 */ // Label 2080: @119810
     /* 119810 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(120029),
     /* 119815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119818 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119822 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(119871), // Rule ID 4411 //
     /* 119827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119845 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119848 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119869 */     GIR_RootConstrainSelectedInstOperands,
     /* 119870 */     // GIR_Coverage, 4411,
     /* 119870 */     GIR_EraseRootFromParent_Done,
     /* 119871 */   // Label 2276: @119871
     /* 119871 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(119920), // Rule ID 4412 //
     /* 119876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119894 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119897 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119918 */     GIR_RootConstrainSelectedInstOperands,
     /* 119919 */     // GIR_Coverage, 4412,
     /* 119919 */     GIR_EraseRootFromParent_Done,
     /* 119920 */   // Label 2277: @119920
     /* 119920 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(119964), // Rule ID 4448 //
     /* 119925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119943 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119946 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119962 */     GIR_RootConstrainSelectedInstOperands,
     /* 119963 */     // GIR_Coverage, 4448,
     /* 119963 */     GIR_EraseRootFromParent_Done,
     /* 119964 */   // Label 2278: @119964
     /* 119964 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(120008), // Rule ID 4472 //
     /* 119969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119987 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119990 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120006 */     GIR_RootConstrainSelectedInstOperands,
     /* 120007 */     // GIR_Coverage, 4472,
     /* 120007 */     GIR_EraseRootFromParent_Done,
     /* 120008 */   // Label 2279: @120008
     /* 120008 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(120028), // Rule ID 6327 //
     /* 120013 */     // MIs[0] Rn
     /* 120013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120021 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 120026 */     GIR_RootConstrainSelectedInstOperands,
     /* 120027 */     // GIR_Coverage, 6327,
     /* 120027 */     GIR_Done,
     /* 120028 */   // Label 2280: @120028
     /* 120028 */   GIM_Reject,
     /* 120029 */ // Label 2275: @120029
     /* 120029 */ GIM_Reject,
     /* 120030 */ // Label 2081: @120030
     /* 120030 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(120435),
     /* 120035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120042 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(120091), // Rule ID 4427 //
     /* 120047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120065 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120068 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120089 */     GIR_RootConstrainSelectedInstOperands,
     /* 120090 */     // GIR_Coverage, 4427,
     /* 120090 */     GIR_EraseRootFromParent_Done,
     /* 120091 */   // Label 2282: @120091
     /* 120091 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(120140), // Rule ID 4428 //
     /* 120096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120114 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 120114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120117 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120138 */     GIR_RootConstrainSelectedInstOperands,
     /* 120139 */     // GIR_Coverage, 4428,
     /* 120139 */     GIR_EraseRootFromParent_Done,
     /* 120140 */   // Label 2283: @120140
     /* 120140 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(120189), // Rule ID 4431 //
     /* 120145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120163 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120166 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120187 */     GIR_RootConstrainSelectedInstOperands,
     /* 120188 */     // GIR_Coverage, 4431,
     /* 120188 */     GIR_EraseRootFromParent_Done,
     /* 120189 */   // Label 2284: @120189
     /* 120189 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(120238), // Rule ID 4432 //
     /* 120194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120212 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 120212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120215 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120236 */     GIR_RootConstrainSelectedInstOperands,
     /* 120237 */     // GIR_Coverage, 4432,
     /* 120237 */     GIR_EraseRootFromParent_Done,
     /* 120238 */   // Label 2285: @120238
     /* 120238 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(120282), // Rule ID 4456 //
     /* 120243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120261 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120264 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120280 */     GIR_RootConstrainSelectedInstOperands,
     /* 120281 */     // GIR_Coverage, 4456,
     /* 120281 */     GIR_EraseRootFromParent_Done,
     /* 120282 */   // Label 2286: @120282
     /* 120282 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(120326), // Rule ID 4459 //
     /* 120287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120305 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120308 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120324 */     GIR_RootConstrainSelectedInstOperands,
     /* 120325 */     // GIR_Coverage, 4459,
     /* 120325 */     GIR_EraseRootFromParent_Done,
     /* 120326 */   // Label 2287: @120326
     /* 120326 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(120370), // Rule ID 4480 //
     /* 120331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120349 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120352 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120368 */     GIR_RootConstrainSelectedInstOperands,
     /* 120369 */     // GIR_Coverage, 4480,
     /* 120369 */     GIR_EraseRootFromParent_Done,
     /* 120370 */   // Label 2288: @120370
     /* 120370 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(120414), // Rule ID 4484 //
     /* 120375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120393 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120396 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120412 */     GIR_RootConstrainSelectedInstOperands,
     /* 120413 */     // GIR_Coverage, 4484,
     /* 120413 */     GIR_EraseRootFromParent_Done,
     /* 120414 */   // Label 2289: @120414
     /* 120414 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(120434), // Rule ID 6324 //
     /* 120419 */     // MIs[0] Rn
     /* 120419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120427 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 120432 */     GIR_RootConstrainSelectedInstOperands,
     /* 120433 */     // GIR_Coverage, 6324,
     /* 120433 */     GIR_Done,
     /* 120434 */   // Label 2290: @120434
     /* 120434 */   GIM_Reject,
     /* 120435 */ // Label 2281: @120435
     /* 120435 */ GIM_Reject,
     /* 120436 */ // Label 2082: @120436
     /* 120436 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(120655),
     /* 120441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120448 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(120497), // Rule ID 4429 //
     /* 120453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120471 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120474 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120495 */     GIR_RootConstrainSelectedInstOperands,
     /* 120496 */     // GIR_Coverage, 4429,
     /* 120496 */     GIR_EraseRootFromParent_Done,
     /* 120497 */   // Label 2292: @120497
     /* 120497 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(120546), // Rule ID 4430 //
     /* 120502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120520 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 120520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120523 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120544 */     GIR_RootConstrainSelectedInstOperands,
     /* 120545 */     // GIR_Coverage, 4430,
     /* 120545 */     GIR_EraseRootFromParent_Done,
     /* 120546 */   // Label 2293: @120546
     /* 120546 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(120590), // Rule ID 4455 //
     /* 120551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120569 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120572 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120588 */     GIR_RootConstrainSelectedInstOperands,
     /* 120589 */     // GIR_Coverage, 4455,
     /* 120589 */     GIR_EraseRootFromParent_Done,
     /* 120590 */   // Label 2294: @120590
     /* 120590 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(120634), // Rule ID 4479 //
     /* 120595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120613 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120616 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120632 */     GIR_RootConstrainSelectedInstOperands,
     /* 120633 */     // GIR_Coverage, 4479,
     /* 120633 */     GIR_EraseRootFromParent_Done,
     /* 120634 */   // Label 2295: @120634
     /* 120634 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(120654), // Rule ID 6323 //
     /* 120639 */     // MIs[0] Rn
     /* 120639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120647 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 120652 */     GIR_RootConstrainSelectedInstOperands,
     /* 120653 */     // GIR_Coverage, 6323,
     /* 120653 */     GIR_Done,
     /* 120654 */   // Label 2296: @120654
     /* 120654 */   GIM_Reject,
     /* 120655 */ // Label 2291: @120655
     /* 120655 */ GIM_Reject,
     /* 120656 */ // Label 2083: @120656
     /* 120656 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(120715), // Rule ID 10757 //
     /* 120661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120671 */   // MIs[0] base
     /* 120671 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120679 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120691 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 120699 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120704 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120713 */   GIR_RootConstrainSelectedInstOperands,
     /* 120714 */   // GIR_Coverage, 10757,
     /* 120714 */   GIR_EraseRootFromParent_Done,
     /* 120715 */ // Label 2297: @120715
     /* 120715 */ GIM_Reject,
     /* 120716 */ // Label 2084: @120716
     /* 120716 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(120775), // Rule ID 10763 //
     /* 120721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120727 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120731 */   // MIs[0] base
     /* 120731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120739 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120751 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 120759 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120764 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120769 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120773 */   GIR_RootConstrainSelectedInstOperands,
     /* 120774 */   // GIR_Coverage, 10763,
     /* 120774 */   GIR_EraseRootFromParent_Done,
     /* 120775 */ // Label 2298: @120775
     /* 120775 */ GIM_Reject,
     /* 120776 */ // Label 2085: @120776
     /* 120776 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(120945),
     /* 120781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120792 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(120840), // Rule ID 10748 //
     /* 120797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120804 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 120824 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120829 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120838 */     GIR_RootConstrainSelectedInstOperands,
     /* 120839 */     // GIR_Coverage, 10748,
     /* 120839 */     GIR_EraseRootFromParent_Done,
     /* 120840 */   // Label 2300: @120840
     /* 120840 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(120888), // Rule ID 10766 //
     /* 120845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120852 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 120872 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120877 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120886 */     GIR_RootConstrainSelectedInstOperands,
     /* 120887 */     // GIR_Coverage, 10766,
     /* 120887 */     GIR_EraseRootFromParent_Done,
     /* 120888 */   // Label 2301: @120888
     /* 120888 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(120916), // Rule ID 10878 //
     /* 120893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 120896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120900 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 120903 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120905 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120914 */     GIR_RootConstrainSelectedInstOperands,
     /* 120915 */     // GIR_Coverage, 10878,
     /* 120915 */     GIR_EraseRootFromParent_Done,
     /* 120916 */   // Label 2302: @120916
     /* 120916 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(120944), // Rule ID 10890 //
     /* 120921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 120924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120928 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 120931 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120933 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120942 */     GIR_RootConstrainSelectedInstOperands,
     /* 120943 */     // GIR_Coverage, 10890,
     /* 120943 */     GIR_EraseRootFromParent_Done,
     /* 120944 */   // Label 2303: @120944
     /* 120944 */   GIM_Reject,
     /* 120945 */ // Label 2299: @120945
     /* 120945 */ GIM_Reject,
     /* 120946 */ // Label 2086: @120946
     /* 120946 */ GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(121005), // Rule ID 10754 //
     /* 120951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120954 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120957 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120961 */   // MIs[0] base
     /* 120961 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120969 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 120976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120981 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 120989 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120994 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121003 */   GIR_RootConstrainSelectedInstOperands,
     /* 121004 */   // GIR_Coverage, 10754,
     /* 121004 */   GIR_EraseRootFromParent_Done,
     /* 121005 */ // Label 2304: @121005
     /* 121005 */ GIM_Reject,
     /* 121006 */ // Label 2087: @121006
     /* 121006 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(121175),
     /* 121011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121022 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(121070), // Rule ID 10742 //
     /* 121027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121034 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 121041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121046 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 121054 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121059 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121068 */     GIR_RootConstrainSelectedInstOperands,
     /* 121069 */     // GIR_Coverage, 10742,
     /* 121069 */     GIR_EraseRootFromParent_Done,
     /* 121070 */   // Label 2306: @121070
     /* 121070 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(121118), // Rule ID 10760 //
     /* 121075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121082 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 121089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 121102 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121107 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121116 */     GIR_RootConstrainSelectedInstOperands,
     /* 121117 */     // GIR_Coverage, 10760,
     /* 121117 */     GIR_EraseRootFromParent_Done,
     /* 121118 */   // Label 2307: @121118
     /* 121118 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(121146), // Rule ID 10874 //
     /* 121123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121130 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121133 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121135 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121144 */     GIR_RootConstrainSelectedInstOperands,
     /* 121145 */     // GIR_Coverage, 10874,
     /* 121145 */     GIR_EraseRootFromParent_Done,
     /* 121146 */   // Label 2308: @121146
     /* 121146 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(121174), // Rule ID 10886 //
     /* 121151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121158 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121161 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121163 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121172 */     GIR_RootConstrainSelectedInstOperands,
     /* 121173 */     // GIR_Coverage, 10886,
     /* 121173 */     GIR_EraseRootFromParent_Done,
     /* 121174 */   // Label 2309: @121174
     /* 121174 */   GIM_Reject,
     /* 121175 */ // Label 2305: @121175
     /* 121175 */ GIM_Reject,
     /* 121176 */ // Label 2088: @121176
     /* 121176 */ GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(121345),
     /* 121181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121184 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121188 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121192 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(121240), // Rule ID 10733 //
     /* 121197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121204 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 121211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 121224 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121229 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121238 */     GIR_RootConstrainSelectedInstOperands,
     /* 121239 */     // GIR_Coverage, 10733,
     /* 121239 */     GIR_EraseRootFromParent_Done,
     /* 121240 */   // Label 2311: @121240
     /* 121240 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(121288), // Rule ID 10751 //
     /* 121245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121252 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 121259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121264 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 121272 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121277 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121286 */     GIR_RootConstrainSelectedInstOperands,
     /* 121287 */     // GIR_Coverage, 10751,
     /* 121287 */     GIR_EraseRootFromParent_Done,
     /* 121288 */   // Label 2312: @121288
     /* 121288 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(121316), // Rule ID 10870 //
     /* 121293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121300 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121303 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121305 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121314 */     GIR_RootConstrainSelectedInstOperands,
     /* 121315 */     // GIR_Coverage, 10870,
     /* 121315 */     GIR_EraseRootFromParent_Done,
     /* 121316 */   // Label 2313: @121316
     /* 121316 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(121344), // Rule ID 10882 //
     /* 121321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121328 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121331 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121333 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121342 */     GIR_RootConstrainSelectedInstOperands,
     /* 121343 */     // GIR_Coverage, 10882,
     /* 121343 */     GIR_EraseRootFromParent_Done,
     /* 121344 */   // Label 2314: @121344
     /* 121344 */   GIM_Reject,
     /* 121345 */ // Label 2310: @121345
     /* 121345 */ GIM_Reject,
     /* 121346 */ // Label 2089: @121346
     /* 121346 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(121389), // Rule ID 2421 //
     /* 121351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 121365 */   // MIs[0] base
     /* 121365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121373 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 121376 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 121378 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121387 */   GIR_RootConstrainSelectedInstOperands,
     /* 121388 */   // GIR_Coverage, 2421,
     /* 121388 */   GIR_EraseRootFromParent_Done,
     /* 121389 */ // Label 2315: @121389
     /* 121389 */ GIM_Reject,
     /* 121390 */ // Label 2090: @121390
     /* 121390 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(121483),
     /* 121395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121406 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(121454), // Rule ID 10719 //
     /* 121411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121418 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 121425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 121438 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121443 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121452 */     GIR_RootConstrainSelectedInstOperands,
     /* 121453 */     // GIR_Coverage, 10719,
     /* 121453 */     GIR_EraseRootFromParent_Done,
     /* 121454 */   // Label 2317: @121454
     /* 121454 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(121482), // Rule ID 10866 //
     /* 121459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121466 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121469 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121471 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121480 */     GIR_RootConstrainSelectedInstOperands,
     /* 121481 */     // GIR_Coverage, 10866,
     /* 121481 */     GIR_EraseRootFromParent_Done,
     /* 121482 */   // Label 2318: @121482
     /* 121482 */   GIM_Reject,
     /* 121483 */ // Label 2316: @121483
     /* 121483 */ GIM_Reject,
     /* 121484 */ // Label 2091: @121484
     /* 121484 */ GIM_Reject,
     /* 121485 */ // Label 20: @121485
     /* 121485 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2321*/ GIMT_Encode4(122835),
     /* 121496 */ /*GILLT_s32*//*Label 2319*/ GIMT_Encode4(121504),
     /* 121500 */ /*GILLT_s64*//*Label 2320*/ GIMT_Encode4(122522),
     /* 121504 */ // Label 2319: @121504
     /* 121504 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(122521),
     /* 121509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 121515 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(121570), // Rule ID 7225 //
     /* 121520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121537 */     // MIs[0] Rn
     /* 121537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121553 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 121556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121568 */     GIR_RootConstrainSelectedInstOperands,
     /* 121569 */     // GIR_Coverage, 7225,
     /* 121569 */     GIR_EraseRootFromParent_Done,
     /* 121570 */   // Label 2323: @121570
     /* 121570 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(121625), // Rule ID 7226 //
     /* 121575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121592 */     // MIs[0] Rn
     /* 121592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121608 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 121611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121623 */     GIR_RootConstrainSelectedInstOperands,
     /* 121624 */     // GIR_Coverage, 7226,
     /* 121624 */     GIR_EraseRootFromParent_Done,
     /* 121625 */   // Label 2324: @121625
     /* 121625 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(121680), // Rule ID 7227 //
     /* 121630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121647 */     // MIs[0] Rn
     /* 121647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121663 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 121666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121678 */     GIR_RootConstrainSelectedInstOperands,
     /* 121679 */     // GIR_Coverage, 7227,
     /* 121679 */     GIR_EraseRootFromParent_Done,
     /* 121680 */   // Label 2325: @121680
     /* 121680 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(121735), // Rule ID 7228 //
     /* 121685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121702 */     // MIs[0] Rn
     /* 121702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121718 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 121721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121733 */     GIR_RootConstrainSelectedInstOperands,
     /* 121734 */     // GIR_Coverage, 7228,
     /* 121734 */     GIR_EraseRootFromParent_Done,
     /* 121735 */   // Label 2326: @121735
     /* 121735 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(121790), // Rule ID 7229 //
     /* 121740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121757 */     // MIs[0] Rn
     /* 121757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121773 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 121776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121788 */     GIR_RootConstrainSelectedInstOperands,
     /* 121789 */     // GIR_Coverage, 7229,
     /* 121789 */     GIR_EraseRootFromParent_Done,
     /* 121790 */   // Label 2327: @121790
     /* 121790 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(121845), // Rule ID 7230 //
     /* 121795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121812 */     // MIs[0] Rn
     /* 121812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121828 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 121831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121843 */     GIR_RootConstrainSelectedInstOperands,
     /* 121844 */     // GIR_Coverage, 7230,
     /* 121844 */     GIR_EraseRootFromParent_Done,
     /* 121845 */   // Label 2328: @121845
     /* 121845 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(121900), // Rule ID 7231 //
     /* 121850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121867 */     // MIs[0] Rn
     /* 121867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121883 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 121886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121898 */     GIR_RootConstrainSelectedInstOperands,
     /* 121899 */     // GIR_Coverage, 7231,
     /* 121899 */     GIR_EraseRootFromParent_Done,
     /* 121900 */   // Label 2329: @121900
     /* 121900 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(121955), // Rule ID 7232 //
     /* 121905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121922 */     // MIs[0] Rn
     /* 121922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121938 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 121941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121953 */     GIR_RootConstrainSelectedInstOperands,
     /* 121954 */     // GIR_Coverage, 7232,
     /* 121954 */     GIR_EraseRootFromParent_Done,
     /* 121955 */   // Label 2330: @121955
     /* 121955 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(122010), // Rule ID 7233 //
     /* 121960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121963 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121977 */     // MIs[0] Rn
     /* 121977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121993 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 121996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122008 */     GIR_RootConstrainSelectedInstOperands,
     /* 122009 */     // GIR_Coverage, 7233,
     /* 122009 */     GIR_EraseRootFromParent_Done,
     /* 122010 */   // Label 2331: @122010
     /* 122010 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(122065), // Rule ID 7234 //
     /* 122015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122032 */     // MIs[0] Rn
     /* 122032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122048 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 122051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122063 */     GIR_RootConstrainSelectedInstOperands,
     /* 122064 */     // GIR_Coverage, 7234,
     /* 122064 */     GIR_EraseRootFromParent_Done,
     /* 122065 */   // Label 2332: @122065
     /* 122065 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(122120), // Rule ID 7235 //
     /* 122070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122087 */     // MIs[0] Rn
     /* 122087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122103 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 122106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122118 */     GIR_RootConstrainSelectedInstOperands,
     /* 122119 */     // GIR_Coverage, 7235,
     /* 122119 */     GIR_EraseRootFromParent_Done,
     /* 122120 */   // Label 2333: @122120
     /* 122120 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(122175), // Rule ID 7236 //
     /* 122125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122142 */     // MIs[0] Rn
     /* 122142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122158 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 122161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122173 */     GIR_RootConstrainSelectedInstOperands,
     /* 122174 */     // GIR_Coverage, 7236,
     /* 122174 */     GIR_EraseRootFromParent_Done,
     /* 122175 */   // Label 2334: @122175
     /* 122175 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(122230), // Rule ID 7237 //
     /* 122180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122183 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122197 */     // MIs[0] Rn
     /* 122197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122213 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 122216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122228 */     GIR_RootConstrainSelectedInstOperands,
     /* 122229 */     // GIR_Coverage, 7237,
     /* 122229 */     GIR_EraseRootFromParent_Done,
     /* 122230 */   // Label 2335: @122230
     /* 122230 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(122285), // Rule ID 7238 //
     /* 122235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122252 */     // MIs[0] Rn
     /* 122252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122268 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 122271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122283 */     GIR_RootConstrainSelectedInstOperands,
     /* 122284 */     // GIR_Coverage, 7238,
     /* 122284 */     GIR_EraseRootFromParent_Done,
     /* 122285 */   // Label 2336: @122285
     /* 122285 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(122340), // Rule ID 7239 //
     /* 122290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122307 */     // MIs[0] Rn
     /* 122307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122323 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 122326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122338 */     GIR_RootConstrainSelectedInstOperands,
     /* 122339 */     // GIR_Coverage, 7239,
     /* 122339 */     GIR_EraseRootFromParent_Done,
     /* 122340 */   // Label 2337: @122340
     /* 122340 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(122400), // Rule ID 12913 //
     /* 122345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122348 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122359 */     // MIs[0] addr
     /* 122359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122375 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 122381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122383 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122388 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122390 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122392 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122398 */     GIR_RootConstrainSelectedInstOperands,
     /* 122399 */     // GIR_Coverage, 12913,
     /* 122399 */     GIR_EraseRootFromParent_Done,
     /* 122400 */   // Label 2338: @122400
     /* 122400 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(122460), // Rule ID 12914 //
     /* 122405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122419 */     // MIs[0] addr
     /* 122419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122435 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 122441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122443 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122448 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122450 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122452 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122458 */     GIR_RootConstrainSelectedInstOperands,
     /* 122459 */     // GIR_Coverage, 12914,
     /* 122459 */     GIR_EraseRootFromParent_Done,
     /* 122460 */   // Label 2339: @122460
     /* 122460 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(122520), // Rule ID 12915 //
     /* 122465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122479 */     // MIs[0] addr
     /* 122479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122495 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 122501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122503 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122508 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122510 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122512 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122518 */     GIR_RootConstrainSelectedInstOperands,
     /* 122519 */     // GIR_Coverage, 12915,
     /* 122519 */     GIR_EraseRootFromParent_Done,
     /* 122520 */   // Label 2340: @122520
     /* 122520 */   GIM_Reject,
     /* 122521 */ // Label 2322: @122521
     /* 122521 */ GIM_Reject,
     /* 122522 */ // Label 2320: @122522
     /* 122522 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(122834),
     /* 122527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 122533 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122540 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(122588), // Rule ID 2580 //
     /* 122545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122555 */     // MIs[0] Rn
     /* 122555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122571 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 122574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122586 */     GIR_RootConstrainSelectedInstOperands,
     /* 122587 */     // GIR_Coverage, 2580,
     /* 122587 */     GIR_EraseRootFromParent_Done,
     /* 122588 */   // Label 2342: @122588
     /* 122588 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(122636), // Rule ID 2581 //
     /* 122593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122603 */     // MIs[0] Rn
     /* 122603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122619 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 122622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122634 */     GIR_RootConstrainSelectedInstOperands,
     /* 122635 */     // GIR_Coverage, 2581,
     /* 122635 */     GIR_EraseRootFromParent_Done,
     /* 122636 */   // Label 2343: @122636
     /* 122636 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(122684), // Rule ID 2582 //
     /* 122641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122651 */     // MIs[0] Rn
     /* 122651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122667 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 122670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122682 */     GIR_RootConstrainSelectedInstOperands,
     /* 122683 */     // GIR_Coverage, 2582,
     /* 122683 */     GIR_EraseRootFromParent_Done,
     /* 122684 */   // Label 2344: @122684
     /* 122684 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(122732), // Rule ID 2583 //
     /* 122689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122699 */     // MIs[0] Rn
     /* 122699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122715 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 122718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122730 */     GIR_RootConstrainSelectedInstOperands,
     /* 122731 */     // GIR_Coverage, 2583,
     /* 122731 */     GIR_EraseRootFromParent_Done,
     /* 122732 */   // Label 2345: @122732
     /* 122732 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(122780), // Rule ID 2584 //
     /* 122737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122747 */     // MIs[0] Rn
     /* 122747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122763 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 122766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122778 */     GIR_RootConstrainSelectedInstOperands,
     /* 122779 */     // GIR_Coverage, 2584,
     /* 122779 */     GIR_EraseRootFromParent_Done,
     /* 122780 */   // Label 2346: @122780
     /* 122780 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(122833), // Rule ID 12916 //
     /* 122785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122792 */     // MIs[0] addr
     /* 122792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122808 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 122808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 122814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122816 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122821 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122823 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122825 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122831 */     GIR_RootConstrainSelectedInstOperands,
     /* 122832 */     // GIR_Coverage, 12916,
     /* 122832 */     GIR_EraseRootFromParent_Done,
     /* 122833 */   // Label 2347: @122833
     /* 122833 */   GIM_Reject,
     /* 122834 */ // Label 2341: @122834
     /* 122834 */ GIM_Reject,
     /* 122835 */ // Label 2321: @122835
     /* 122835 */ GIM_Reject,
     /* 122836 */ // Label 21: @122836
     /* 122836 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2350*/ GIMT_Encode4(123827),
     /* 122847 */ /*GILLT_s32*//*Label 2348*/ GIMT_Encode4(122855),
     /* 122851 */ /*GILLT_s64*//*Label 2349*/ GIMT_Encode4(123600),
     /* 122855 */ // Label 2348: @122855
     /* 122855 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(123599),
     /* 122860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122863 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(122912), // Rule ID 7210 //
     /* 122868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122885 */     // MIs[0] Rn
     /* 122885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122897 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 122900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122910 */     GIR_RootConstrainSelectedInstOperands,
     /* 122911 */     // GIR_Coverage, 7210,
     /* 122911 */     GIR_EraseRootFromParent_Done,
     /* 122912 */   // Label 2352: @122912
     /* 122912 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(122961), // Rule ID 7211 //
     /* 122917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122934 */     // MIs[0] Rn
     /* 122934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122946 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 122949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122959 */     GIR_RootConstrainSelectedInstOperands,
     /* 122960 */     // GIR_Coverage, 7211,
     /* 122960 */     GIR_EraseRootFromParent_Done,
     /* 122961 */   // Label 2353: @122961
     /* 122961 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(123010), // Rule ID 7212 //
     /* 122966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122983 */     // MIs[0] Rn
     /* 122983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122995 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 122998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123008 */     GIR_RootConstrainSelectedInstOperands,
     /* 123009 */     // GIR_Coverage, 7212,
     /* 123009 */     GIR_EraseRootFromParent_Done,
     /* 123010 */   // Label 2354: @123010
     /* 123010 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(123059), // Rule ID 7213 //
     /* 123015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123032 */     // MIs[0] Rn
     /* 123032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123044 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 123047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123057 */     GIR_RootConstrainSelectedInstOperands,
     /* 123058 */     // GIR_Coverage, 7213,
     /* 123058 */     GIR_EraseRootFromParent_Done,
     /* 123059 */   // Label 2355: @123059
     /* 123059 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(123108), // Rule ID 7214 //
     /* 123064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123081 */     // MIs[0] Rn
     /* 123081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123093 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 123096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123106 */     GIR_RootConstrainSelectedInstOperands,
     /* 123107 */     // GIR_Coverage, 7214,
     /* 123107 */     GIR_EraseRootFromParent_Done,
     /* 123108 */   // Label 2356: @123108
     /* 123108 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(123157), // Rule ID 7215 //
     /* 123113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123130 */     // MIs[0] Rn
     /* 123130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123142 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 123145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123155 */     GIR_RootConstrainSelectedInstOperands,
     /* 123156 */     // GIR_Coverage, 7215,
     /* 123156 */     GIR_EraseRootFromParent_Done,
     /* 123157 */   // Label 2357: @123157
     /* 123157 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(123206), // Rule ID 7216 //
     /* 123162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123179 */     // MIs[0] Rn
     /* 123179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123191 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 123194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123204 */     GIR_RootConstrainSelectedInstOperands,
     /* 123205 */     // GIR_Coverage, 7216,
     /* 123205 */     GIR_EraseRootFromParent_Done,
     /* 123206 */   // Label 2358: @123206
     /* 123206 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(123255), // Rule ID 7217 //
     /* 123211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123228 */     // MIs[0] Rn
     /* 123228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123240 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 123243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123253 */     GIR_RootConstrainSelectedInstOperands,
     /* 123254 */     // GIR_Coverage, 7217,
     /* 123254 */     GIR_EraseRootFromParent_Done,
     /* 123255 */   // Label 2359: @123255
     /* 123255 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(123304), // Rule ID 7218 //
     /* 123260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123277 */     // MIs[0] Rn
     /* 123277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123289 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 123292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123302 */     GIR_RootConstrainSelectedInstOperands,
     /* 123303 */     // GIR_Coverage, 7218,
     /* 123303 */     GIR_EraseRootFromParent_Done,
     /* 123304 */   // Label 2360: @123304
     /* 123304 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(123353), // Rule ID 7219 //
     /* 123309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123326 */     // MIs[0] Rn
     /* 123326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123338 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 123341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123351 */     GIR_RootConstrainSelectedInstOperands,
     /* 123352 */     // GIR_Coverage, 7219,
     /* 123352 */     GIR_EraseRootFromParent_Done,
     /* 123353 */   // Label 2361: @123353
     /* 123353 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(123402), // Rule ID 7220 //
     /* 123358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123375 */     // MIs[0] Rn
     /* 123375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123387 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 123390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123400 */     GIR_RootConstrainSelectedInstOperands,
     /* 123401 */     // GIR_Coverage, 7220,
     /* 123401 */     GIR_EraseRootFromParent_Done,
     /* 123402 */   // Label 2362: @123402
     /* 123402 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(123451), // Rule ID 7221 //
     /* 123407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123424 */     // MIs[0] Rn
     /* 123424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123436 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 123439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123449 */     GIR_RootConstrainSelectedInstOperands,
     /* 123450 */     // GIR_Coverage, 7221,
     /* 123450 */     GIR_EraseRootFromParent_Done,
     /* 123451 */   // Label 2363: @123451
     /* 123451 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(123500), // Rule ID 7222 //
     /* 123456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123459 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123466 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123473 */     // MIs[0] Rn
     /* 123473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123485 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 123488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123498 */     GIR_RootConstrainSelectedInstOperands,
     /* 123499 */     // GIR_Coverage, 7222,
     /* 123499 */     GIR_EraseRootFromParent_Done,
     /* 123500 */   // Label 2364: @123500
     /* 123500 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(123549), // Rule ID 7223 //
     /* 123505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123522 */     // MIs[0] Rn
     /* 123522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123534 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 123537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123547 */     GIR_RootConstrainSelectedInstOperands,
     /* 123548 */     // GIR_Coverage, 7223,
     /* 123548 */     GIR_EraseRootFromParent_Done,
     /* 123549 */   // Label 2365: @123549
     /* 123549 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(123598), // Rule ID 7224 //
     /* 123554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123571 */     // MIs[0] Rn
     /* 123571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123583 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 123586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123596 */     GIR_RootConstrainSelectedInstOperands,
     /* 123597 */     // GIR_Coverage, 7224,
     /* 123597 */     GIR_EraseRootFromParent_Done,
     /* 123598 */   // Label 2366: @123598
     /* 123598 */   GIM_Reject,
     /* 123599 */ // Label 2351: @123599
     /* 123599 */ GIM_Reject,
     /* 123600 */ // Label 2349: @123600
     /* 123600 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(123826),
     /* 123605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123615 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(123657), // Rule ID 7205 //
     /* 123620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123630 */     // MIs[0] Rn
     /* 123630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123642 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 123645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123655 */     GIR_RootConstrainSelectedInstOperands,
     /* 123656 */     // GIR_Coverage, 7205,
     /* 123656 */     GIR_EraseRootFromParent_Done,
     /* 123657 */   // Label 2368: @123657
     /* 123657 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(123699), // Rule ID 7206 //
     /* 123662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123672 */     // MIs[0] Rn
     /* 123672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123684 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 123687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123697 */     GIR_RootConstrainSelectedInstOperands,
     /* 123698 */     // GIR_Coverage, 7206,
     /* 123698 */     GIR_EraseRootFromParent_Done,
     /* 123699 */   // Label 2369: @123699
     /* 123699 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(123741), // Rule ID 7207 //
     /* 123704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123714 */     // MIs[0] Rn
     /* 123714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123726 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 123729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123739 */     GIR_RootConstrainSelectedInstOperands,
     /* 123740 */     // GIR_Coverage, 7207,
     /* 123740 */     GIR_EraseRootFromParent_Done,
     /* 123741 */   // Label 2370: @123741
     /* 123741 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(123783), // Rule ID 7208 //
     /* 123746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123756 */     // MIs[0] Rn
     /* 123756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123768 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 123771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123781 */     GIR_RootConstrainSelectedInstOperands,
     /* 123782 */     // GIR_Coverage, 7208,
     /* 123782 */     GIR_EraseRootFromParent_Done,
     /* 123783 */   // Label 2371: @123783
     /* 123783 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(123825), // Rule ID 7209 //
     /* 123788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123798 */     // MIs[0] Rn
     /* 123798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123810 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 123813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123823 */     GIR_RootConstrainSelectedInstOperands,
     /* 123824 */     // GIR_Coverage, 7209,
     /* 123824 */     GIR_EraseRootFromParent_Done,
     /* 123825 */   // Label 2372: @123825
     /* 123825 */   GIM_Reject,
     /* 123826 */ // Label 2367: @123826
     /* 123826 */ GIM_Reject,
     /* 123827 */ // Label 2350: @123827
     /* 123827 */ GIM_Reject,
     /* 123828 */ // Label 22: @123828
     /* 123828 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2375*/ GIMT_Encode4(124819),
     /* 123839 */ /*GILLT_s32*//*Label 2373*/ GIMT_Encode4(123847),
     /* 123843 */ /*GILLT_s64*//*Label 2374*/ GIMT_Encode4(124592),
     /* 123847 */ // Label 2373: @123847
     /* 123847 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(124591),
     /* 123852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123855 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(123904), // Rule ID 7050 //
     /* 123860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123877 */     // MIs[0] Rn
     /* 123877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123889 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 123892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123902 */     GIR_RootConstrainSelectedInstOperands,
     /* 123903 */     // GIR_Coverage, 7050,
     /* 123903 */     GIR_EraseRootFromParent_Done,
     /* 123904 */   // Label 2377: @123904
     /* 123904 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(123953), // Rule ID 7051 //
     /* 123909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123926 */     // MIs[0] Rn
     /* 123926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123938 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 123941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123951 */     GIR_RootConstrainSelectedInstOperands,
     /* 123952 */     // GIR_Coverage, 7051,
     /* 123952 */     GIR_EraseRootFromParent_Done,
     /* 123953 */   // Label 2378: @123953
     /* 123953 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(124002), // Rule ID 7052 //
     /* 123958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123975 */     // MIs[0] Rn
     /* 123975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123987 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 123990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124000 */     GIR_RootConstrainSelectedInstOperands,
     /* 124001 */     // GIR_Coverage, 7052,
     /* 124001 */     GIR_EraseRootFromParent_Done,
     /* 124002 */   // Label 2379: @124002
     /* 124002 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(124051), // Rule ID 7053 //
     /* 124007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124024 */     // MIs[0] Rn
     /* 124024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124036 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 124039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124049 */     GIR_RootConstrainSelectedInstOperands,
     /* 124050 */     // GIR_Coverage, 7053,
     /* 124050 */     GIR_EraseRootFromParent_Done,
     /* 124051 */   // Label 2380: @124051
     /* 124051 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(124100), // Rule ID 7054 //
     /* 124056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124073 */     // MIs[0] Rn
     /* 124073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124085 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 124088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124098 */     GIR_RootConstrainSelectedInstOperands,
     /* 124099 */     // GIR_Coverage, 7054,
     /* 124099 */     GIR_EraseRootFromParent_Done,
     /* 124100 */   // Label 2381: @124100
     /* 124100 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(124149), // Rule ID 7055 //
     /* 124105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124122 */     // MIs[0] Rn
     /* 124122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124134 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 124137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124147 */     GIR_RootConstrainSelectedInstOperands,
     /* 124148 */     // GIR_Coverage, 7055,
     /* 124148 */     GIR_EraseRootFromParent_Done,
     /* 124149 */   // Label 2382: @124149
     /* 124149 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(124198), // Rule ID 7056 //
     /* 124154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124171 */     // MIs[0] Rn
     /* 124171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124183 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 124186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124196 */     GIR_RootConstrainSelectedInstOperands,
     /* 124197 */     // GIR_Coverage, 7056,
     /* 124197 */     GIR_EraseRootFromParent_Done,
     /* 124198 */   // Label 2383: @124198
     /* 124198 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(124247), // Rule ID 7057 //
     /* 124203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124220 */     // MIs[0] Rn
     /* 124220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124232 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 124235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124245 */     GIR_RootConstrainSelectedInstOperands,
     /* 124246 */     // GIR_Coverage, 7057,
     /* 124246 */     GIR_EraseRootFromParent_Done,
     /* 124247 */   // Label 2384: @124247
     /* 124247 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(124296), // Rule ID 7058 //
     /* 124252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124269 */     // MIs[0] Rn
     /* 124269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124281 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 124284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124294 */     GIR_RootConstrainSelectedInstOperands,
     /* 124295 */     // GIR_Coverage, 7058,
     /* 124295 */     GIR_EraseRootFromParent_Done,
     /* 124296 */   // Label 2385: @124296
     /* 124296 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(124345), // Rule ID 7059 //
     /* 124301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124318 */     // MIs[0] Rn
     /* 124318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124330 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 124333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124343 */     GIR_RootConstrainSelectedInstOperands,
     /* 124344 */     // GIR_Coverage, 7059,
     /* 124344 */     GIR_EraseRootFromParent_Done,
     /* 124345 */   // Label 2386: @124345
     /* 124345 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(124394), // Rule ID 7060 //
     /* 124350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124367 */     // MIs[0] Rn
     /* 124367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124379 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 124382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124392 */     GIR_RootConstrainSelectedInstOperands,
     /* 124393 */     // GIR_Coverage, 7060,
     /* 124393 */     GIR_EraseRootFromParent_Done,
     /* 124394 */   // Label 2387: @124394
     /* 124394 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(124443), // Rule ID 7061 //
     /* 124399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124416 */     // MIs[0] Rn
     /* 124416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124428 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 124431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124441 */     GIR_RootConstrainSelectedInstOperands,
     /* 124442 */     // GIR_Coverage, 7061,
     /* 124442 */     GIR_EraseRootFromParent_Done,
     /* 124443 */   // Label 2388: @124443
     /* 124443 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(124492), // Rule ID 7062 //
     /* 124448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124465 */     // MIs[0] Rn
     /* 124465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124477 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 124480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124490 */     GIR_RootConstrainSelectedInstOperands,
     /* 124491 */     // GIR_Coverage, 7062,
     /* 124491 */     GIR_EraseRootFromParent_Done,
     /* 124492 */   // Label 2389: @124492
     /* 124492 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(124541), // Rule ID 7063 //
     /* 124497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124514 */     // MIs[0] Rn
     /* 124514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124526 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 124529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124539 */     GIR_RootConstrainSelectedInstOperands,
     /* 124540 */     // GIR_Coverage, 7063,
     /* 124540 */     GIR_EraseRootFromParent_Done,
     /* 124541 */   // Label 2390: @124541
     /* 124541 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(124590), // Rule ID 7064 //
     /* 124546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124563 */     // MIs[0] Rn
     /* 124563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124575 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 124578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124588 */     GIR_RootConstrainSelectedInstOperands,
     /* 124589 */     // GIR_Coverage, 7064,
     /* 124589 */     GIR_EraseRootFromParent_Done,
     /* 124590 */   // Label 2391: @124590
     /* 124590 */   GIM_Reject,
     /* 124591 */ // Label 2376: @124591
     /* 124591 */ GIM_Reject,
     /* 124592 */ // Label 2374: @124592
     /* 124592 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(124818),
     /* 124597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 124600 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 124607 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(124649), // Rule ID 2570 //
     /* 124612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124622 */     // MIs[0] Rn
     /* 124622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124634 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 124637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124647 */     GIR_RootConstrainSelectedInstOperands,
     /* 124648 */     // GIR_Coverage, 2570,
     /* 124648 */     GIR_EraseRootFromParent_Done,
     /* 124649 */   // Label 2393: @124649
     /* 124649 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(124691), // Rule ID 2571 //
     /* 124654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124664 */     // MIs[0] Rn
     /* 124664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124676 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 124679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124689 */     GIR_RootConstrainSelectedInstOperands,
     /* 124690 */     // GIR_Coverage, 2571,
     /* 124690 */     GIR_EraseRootFromParent_Done,
     /* 124691 */   // Label 2394: @124691
     /* 124691 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(124733), // Rule ID 2572 //
     /* 124696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124706 */     // MIs[0] Rn
     /* 124706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124718 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 124721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124731 */     GIR_RootConstrainSelectedInstOperands,
     /* 124732 */     // GIR_Coverage, 2572,
     /* 124732 */     GIR_EraseRootFromParent_Done,
     /* 124733 */   // Label 2395: @124733
     /* 124733 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(124775), // Rule ID 2573 //
     /* 124738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124748 */     // MIs[0] Rn
     /* 124748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124760 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 124763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124773 */     GIR_RootConstrainSelectedInstOperands,
     /* 124774 */     // GIR_Coverage, 2573,
     /* 124774 */     GIR_EraseRootFromParent_Done,
     /* 124775 */   // Label 2396: @124775
     /* 124775 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(124817), // Rule ID 2574 //
     /* 124780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124790 */     // MIs[0] Rn
     /* 124790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124802 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 124805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124815 */     GIR_RootConstrainSelectedInstOperands,
     /* 124816 */     // GIR_Coverage, 2574,
     /* 124816 */     GIR_EraseRootFromParent_Done,
     /* 124817 */   // Label 2397: @124817
     /* 124817 */   GIM_Reject,
     /* 124818 */ // Label 2392: @124818
     /* 124818 */ GIM_Reject,
     /* 124819 */ // Label 2375: @124819
     /* 124819 */ GIM_Reject,
     /* 124820 */ // Label 23: @124820
     /* 124820 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2400*/ GIMT_Encode4(126311),
     /* 124831 */ /*GILLT_s32*//*Label 2398*/ GIMT_Encode4(124839),
     /* 124835 */ /*GILLT_s64*//*Label 2399*/ GIMT_Encode4(125959),
     /* 124839 */ // Label 2398: @124839
     /* 124839 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(125958),
     /* 124844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 124847 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(124921), // Rule ID 7245 //
     /* 124852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124855 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124862 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124869 */     // MIs[0] Rn
     /* 124869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124881 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124893 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 124908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124919 */     GIR_RootConstrainSelectedInstOperands,
     /* 124920 */     // GIR_Coverage, 7245,
     /* 124920 */     GIR_EraseRootFromParent_Done,
     /* 124921 */   // Label 2402: @124921
     /* 124921 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(124995), // Rule ID 7246 //
     /* 124926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124943 */     // MIs[0] Rn
     /* 124943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124955 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124967 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 124982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124993 */     GIR_RootConstrainSelectedInstOperands,
     /* 124994 */     // GIR_Coverage, 7246,
     /* 124994 */     GIR_EraseRootFromParent_Done,
     /* 124995 */   // Label 2403: @124995
     /* 124995 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(125069), // Rule ID 7247 //
     /* 125000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125017 */     // MIs[0] Rn
     /* 125017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125029 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125041 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 125056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125067 */     GIR_RootConstrainSelectedInstOperands,
     /* 125068 */     // GIR_Coverage, 7247,
     /* 125068 */     GIR_EraseRootFromParent_Done,
     /* 125069 */   // Label 2404: @125069
     /* 125069 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(125143), // Rule ID 7248 //
     /* 125074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125091 */     // MIs[0] Rn
     /* 125091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125103 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125115 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 125130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125141 */     GIR_RootConstrainSelectedInstOperands,
     /* 125142 */     // GIR_Coverage, 7248,
     /* 125142 */     GIR_EraseRootFromParent_Done,
     /* 125143 */   // Label 2405: @125143
     /* 125143 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(125217), // Rule ID 7249 //
     /* 125148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125151 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125158 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125165 */     // MIs[0] Rn
     /* 125165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125177 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125189 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 125204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125215 */     GIR_RootConstrainSelectedInstOperands,
     /* 125216 */     // GIR_Coverage, 7249,
     /* 125216 */     GIR_EraseRootFromParent_Done,
     /* 125217 */   // Label 2406: @125217
     /* 125217 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(125291), // Rule ID 7250 //
     /* 125222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125225 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125232 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125239 */     // MIs[0] Rn
     /* 125239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125251 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125263 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 125278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125289 */     GIR_RootConstrainSelectedInstOperands,
     /* 125290 */     // GIR_Coverage, 7250,
     /* 125290 */     GIR_EraseRootFromParent_Done,
     /* 125291 */   // Label 2407: @125291
     /* 125291 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(125365), // Rule ID 7251 //
     /* 125296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125299 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125313 */     // MIs[0] Rn
     /* 125313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125325 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 125352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125363 */     GIR_RootConstrainSelectedInstOperands,
     /* 125364 */     // GIR_Coverage, 7251,
     /* 125364 */     GIR_EraseRootFromParent_Done,
     /* 125365 */   // Label 2408: @125365
     /* 125365 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(125439), // Rule ID 7252 //
     /* 125370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125373 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125387 */     // MIs[0] Rn
     /* 125387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125399 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125411 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 125426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125437 */     GIR_RootConstrainSelectedInstOperands,
     /* 125438 */     // GIR_Coverage, 7252,
     /* 125438 */     GIR_EraseRootFromParent_Done,
     /* 125439 */   // Label 2409: @125439
     /* 125439 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(125513), // Rule ID 7253 //
     /* 125444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125461 */     // MIs[0] Rn
     /* 125461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125473 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125485 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 125500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125511 */     GIR_RootConstrainSelectedInstOperands,
     /* 125512 */     // GIR_Coverage, 7253,
     /* 125512 */     GIR_EraseRootFromParent_Done,
     /* 125513 */   // Label 2410: @125513
     /* 125513 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(125587), // Rule ID 7254 //
     /* 125518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125528 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125535 */     // MIs[0] Rn
     /* 125535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125547 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125559 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 125574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125585 */     GIR_RootConstrainSelectedInstOperands,
     /* 125586 */     // GIR_Coverage, 7254,
     /* 125586 */     GIR_EraseRootFromParent_Done,
     /* 125587 */   // Label 2411: @125587
     /* 125587 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(125661), // Rule ID 7255 //
     /* 125592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125595 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125602 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125609 */     // MIs[0] Rn
     /* 125609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125621 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125633 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 125648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125659 */     GIR_RootConstrainSelectedInstOperands,
     /* 125660 */     // GIR_Coverage, 7255,
     /* 125660 */     GIR_EraseRootFromParent_Done,
     /* 125661 */   // Label 2412: @125661
     /* 125661 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(125735), // Rule ID 7256 //
     /* 125666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125669 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125683 */     // MIs[0] Rn
     /* 125683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125695 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125707 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 125722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125733 */     GIR_RootConstrainSelectedInstOperands,
     /* 125734 */     // GIR_Coverage, 7256,
     /* 125734 */     GIR_EraseRootFromParent_Done,
     /* 125735 */   // Label 2413: @125735
     /* 125735 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(125809), // Rule ID 7257 //
     /* 125740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125757 */     // MIs[0] Rn
     /* 125757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125769 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125781 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 125796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125807 */     GIR_RootConstrainSelectedInstOperands,
     /* 125808 */     // GIR_Coverage, 7257,
     /* 125808 */     GIR_EraseRootFromParent_Done,
     /* 125809 */   // Label 2414: @125809
     /* 125809 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(125883), // Rule ID 7258 //
     /* 125814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125831 */     // MIs[0] Rn
     /* 125831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125843 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125855 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 125870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125881 */     GIR_RootConstrainSelectedInstOperands,
     /* 125882 */     // GIR_Coverage, 7258,
     /* 125882 */     GIR_EraseRootFromParent_Done,
     /* 125883 */   // Label 2415: @125883
     /* 125883 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(125957), // Rule ID 7259 //
     /* 125888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125905 */     // MIs[0] Rn
     /* 125905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125917 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125929 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 125944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125955 */     GIR_RootConstrainSelectedInstOperands,
     /* 125956 */     // GIR_Coverage, 7259,
     /* 125956 */     GIR_EraseRootFromParent_Done,
     /* 125957 */   // Label 2416: @125957
     /* 125957 */   GIM_Reject,
     /* 125958 */ // Label 2401: @125958
     /* 125958 */ GIM_Reject,
     /* 125959 */ // Label 2399: @125959
     /* 125959 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(126310),
     /* 125964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 125967 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 125974 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(126041), // Rule ID 7240 //
     /* 125979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125989 */     // MIs[0] Rn
     /* 125989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126001 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126013 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 126028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126039 */     GIR_RootConstrainSelectedInstOperands,
     /* 126040 */     // GIR_Coverage, 7240,
     /* 126040 */     GIR_EraseRootFromParent_Done,
     /* 126041 */   // Label 2418: @126041
     /* 126041 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(126108), // Rule ID 7241 //
     /* 126046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126056 */     // MIs[0] Rn
     /* 126056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126068 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126080 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 126095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126106 */     GIR_RootConstrainSelectedInstOperands,
     /* 126107 */     // GIR_Coverage, 7241,
     /* 126107 */     GIR_EraseRootFromParent_Done,
     /* 126108 */   // Label 2419: @126108
     /* 126108 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(126175), // Rule ID 7242 //
     /* 126113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126123 */     // MIs[0] Rn
     /* 126123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126135 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126147 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 126162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126173 */     GIR_RootConstrainSelectedInstOperands,
     /* 126174 */     // GIR_Coverage, 7242,
     /* 126174 */     GIR_EraseRootFromParent_Done,
     /* 126175 */   // Label 2420: @126175
     /* 126175 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(126242), // Rule ID 7243 //
     /* 126180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126183 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126190 */     // MIs[0] Rn
     /* 126190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126202 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126214 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 126229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126240 */     GIR_RootConstrainSelectedInstOperands,
     /* 126241 */     // GIR_Coverage, 7243,
     /* 126241 */     GIR_EraseRootFromParent_Done,
     /* 126242 */   // Label 2421: @126242
     /* 126242 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(126309), // Rule ID 7244 //
     /* 126247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126257 */     // MIs[0] Rn
     /* 126257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126269 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126281 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 126296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126307 */     GIR_RootConstrainSelectedInstOperands,
     /* 126308 */     // GIR_Coverage, 7244,
     /* 126308 */     GIR_EraseRootFromParent_Done,
     /* 126309 */   // Label 2422: @126309
     /* 126309 */   GIM_Reject,
     /* 126310 */ // Label 2417: @126310
     /* 126310 */ GIM_Reject,
     /* 126311 */ // Label 2400: @126311
     /* 126311 */ GIM_Reject,
     /* 126312 */ // Label 24: @126312
     /* 126312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2425*/ GIMT_Encode4(127803),
     /* 126323 */ /*GILLT_s32*//*Label 2423*/ GIMT_Encode4(126331),
     /* 126327 */ /*GILLT_s64*//*Label 2424*/ GIMT_Encode4(127451),
     /* 126331 */ // Label 2423: @126331
     /* 126331 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(127450),
     /* 126336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126339 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(126413), // Rule ID 7265 //
     /* 126344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126354 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126361 */     // MIs[0] Rn
     /* 126361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126373 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126385 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 126400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126411 */     GIR_RootConstrainSelectedInstOperands,
     /* 126412 */     // GIR_Coverage, 7265,
     /* 126412 */     GIR_EraseRootFromParent_Done,
     /* 126413 */   // Label 2427: @126413
     /* 126413 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(126487), // Rule ID 7266 //
     /* 126418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126435 */     // MIs[0] Rn
     /* 126435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126447 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126459 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 126474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126485 */     GIR_RootConstrainSelectedInstOperands,
     /* 126486 */     // GIR_Coverage, 7266,
     /* 126486 */     GIR_EraseRootFromParent_Done,
     /* 126487 */   // Label 2428: @126487
     /* 126487 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(126561), // Rule ID 7267 //
     /* 126492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126502 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126509 */     // MIs[0] Rn
     /* 126509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126521 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126533 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 126548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126559 */     GIR_RootConstrainSelectedInstOperands,
     /* 126560 */     // GIR_Coverage, 7267,
     /* 126560 */     GIR_EraseRootFromParent_Done,
     /* 126561 */   // Label 2429: @126561
     /* 126561 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(126635), // Rule ID 7268 //
     /* 126566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126569 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126576 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126583 */     // MIs[0] Rn
     /* 126583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126595 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126607 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126613 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 126622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126633 */     GIR_RootConstrainSelectedInstOperands,
     /* 126634 */     // GIR_Coverage, 7268,
     /* 126634 */     GIR_EraseRootFromParent_Done,
     /* 126635 */   // Label 2430: @126635
     /* 126635 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(126709), // Rule ID 7269 //
     /* 126640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126657 */     // MIs[0] Rn
     /* 126657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126669 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126681 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 126696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126707 */     GIR_RootConstrainSelectedInstOperands,
     /* 126708 */     // GIR_Coverage, 7269,
     /* 126708 */     GIR_EraseRootFromParent_Done,
     /* 126709 */   // Label 2431: @126709
     /* 126709 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(126783), // Rule ID 7270 //
     /* 126714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126724 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126731 */     // MIs[0] Rn
     /* 126731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126743 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126755 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 126770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126781 */     GIR_RootConstrainSelectedInstOperands,
     /* 126782 */     // GIR_Coverage, 7270,
     /* 126782 */     GIR_EraseRootFromParent_Done,
     /* 126783 */   // Label 2432: @126783
     /* 126783 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(126857), // Rule ID 7271 //
     /* 126788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126805 */     // MIs[0] Rn
     /* 126805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126817 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126829 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 126844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126855 */     GIR_RootConstrainSelectedInstOperands,
     /* 126856 */     // GIR_Coverage, 7271,
     /* 126856 */     GIR_EraseRootFromParent_Done,
     /* 126857 */   // Label 2433: @126857
     /* 126857 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(126931), // Rule ID 7272 //
     /* 126862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126872 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126879 */     // MIs[0] Rn
     /* 126879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126891 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126903 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 126918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126929 */     GIR_RootConstrainSelectedInstOperands,
     /* 126930 */     // GIR_Coverage, 7272,
     /* 126930 */     GIR_EraseRootFromParent_Done,
     /* 126931 */   // Label 2434: @126931
     /* 126931 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(127005), // Rule ID 7273 //
     /* 126936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126953 */     // MIs[0] Rn
     /* 126953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126965 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126977 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 126992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127003 */     GIR_RootConstrainSelectedInstOperands,
     /* 127004 */     // GIR_Coverage, 7273,
     /* 127004 */     GIR_EraseRootFromParent_Done,
     /* 127005 */   // Label 2435: @127005
     /* 127005 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(127079), // Rule ID 7274 //
     /* 127010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127027 */     // MIs[0] Rn
     /* 127027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127039 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127051 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 127066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127077 */     GIR_RootConstrainSelectedInstOperands,
     /* 127078 */     // GIR_Coverage, 7274,
     /* 127078 */     GIR_EraseRootFromParent_Done,
     /* 127079 */   // Label 2436: @127079
     /* 127079 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(127153), // Rule ID 7275 //
     /* 127084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127094 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127101 */     // MIs[0] Rn
     /* 127101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127113 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127125 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 127140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127151 */     GIR_RootConstrainSelectedInstOperands,
     /* 127152 */     // GIR_Coverage, 7275,
     /* 127152 */     GIR_EraseRootFromParent_Done,
     /* 127153 */   // Label 2437: @127153
     /* 127153 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(127227), // Rule ID 7276 //
     /* 127158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127175 */     // MIs[0] Rn
     /* 127175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127187 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127199 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 127214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127225 */     GIR_RootConstrainSelectedInstOperands,
     /* 127226 */     // GIR_Coverage, 7276,
     /* 127226 */     GIR_EraseRootFromParent_Done,
     /* 127227 */   // Label 2438: @127227
     /* 127227 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(127301), // Rule ID 7277 //
     /* 127232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127249 */     // MIs[0] Rn
     /* 127249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127261 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127273 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 127288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127299 */     GIR_RootConstrainSelectedInstOperands,
     /* 127300 */     // GIR_Coverage, 7277,
     /* 127300 */     GIR_EraseRootFromParent_Done,
     /* 127301 */   // Label 2439: @127301
     /* 127301 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(127375), // Rule ID 7278 //
     /* 127306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127323 */     // MIs[0] Rn
     /* 127323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127335 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127347 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 127362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127373 */     GIR_RootConstrainSelectedInstOperands,
     /* 127374 */     // GIR_Coverage, 7278,
     /* 127374 */     GIR_EraseRootFromParent_Done,
     /* 127375 */   // Label 2440: @127375
     /* 127375 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(127449), // Rule ID 7279 //
     /* 127380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127397 */     // MIs[0] Rn
     /* 127397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127409 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127421 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 127436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127447 */     GIR_RootConstrainSelectedInstOperands,
     /* 127448 */     // GIR_Coverage, 7279,
     /* 127448 */     GIR_EraseRootFromParent_Done,
     /* 127449 */   // Label 2441: @127449
     /* 127449 */   GIM_Reject,
     /* 127450 */ // Label 2426: @127450
     /* 127450 */ GIM_Reject,
     /* 127451 */ // Label 2424: @127451
     /* 127451 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(127802),
     /* 127456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127459 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127466 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(127533), // Rule ID 7260 //
     /* 127471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127481 */     // MIs[0] Rn
     /* 127481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127493 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127505 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 127520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127531 */     GIR_RootConstrainSelectedInstOperands,
     /* 127532 */     // GIR_Coverage, 7260,
     /* 127532 */     GIR_EraseRootFromParent_Done,
     /* 127533 */   // Label 2443: @127533
     /* 127533 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(127600), // Rule ID 7261 //
     /* 127538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127548 */     // MIs[0] Rn
     /* 127548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127560 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127572 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 127587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127598 */     GIR_RootConstrainSelectedInstOperands,
     /* 127599 */     // GIR_Coverage, 7261,
     /* 127599 */     GIR_EraseRootFromParent_Done,
     /* 127600 */   // Label 2444: @127600
     /* 127600 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(127667), // Rule ID 7262 //
     /* 127605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127615 */     // MIs[0] Rn
     /* 127615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127627 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127639 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 127654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127665 */     GIR_RootConstrainSelectedInstOperands,
     /* 127666 */     // GIR_Coverage, 7262,
     /* 127666 */     GIR_EraseRootFromParent_Done,
     /* 127667 */   // Label 2445: @127667
     /* 127667 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(127734), // Rule ID 7263 //
     /* 127672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127682 */     // MIs[0] Rn
     /* 127682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127694 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127706 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 127721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127732 */     GIR_RootConstrainSelectedInstOperands,
     /* 127733 */     // GIR_Coverage, 7263,
     /* 127733 */     GIR_EraseRootFromParent_Done,
     /* 127734 */   // Label 2446: @127734
     /* 127734 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(127801), // Rule ID 7264 //
     /* 127739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127749 */     // MIs[0] Rn
     /* 127749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127761 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127773 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 127788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127799 */     GIR_RootConstrainSelectedInstOperands,
     /* 127800 */     // GIR_Coverage, 7264,
     /* 127800 */     GIR_EraseRootFromParent_Done,
     /* 127801 */   // Label 2447: @127801
     /* 127801 */   GIM_Reject,
     /* 127802 */ // Label 2442: @127802
     /* 127802 */ GIM_Reject,
     /* 127803 */ // Label 2425: @127803
     /* 127803 */ GIM_Reject,
     /* 127804 */ // Label 25: @127804
     /* 127804 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2450*/ GIMT_Encode4(128795),
     /* 127815 */ /*GILLT_s32*//*Label 2448*/ GIMT_Encode4(127823),
     /* 127819 */ /*GILLT_s64*//*Label 2449*/ GIMT_Encode4(128568),
     /* 127823 */ // Label 2448: @127823
     /* 127823 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(128567),
     /* 127828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127831 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(127880), // Rule ID 7070 //
     /* 127836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127853 */     // MIs[0] Rn
     /* 127853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127865 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 127868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127878 */     GIR_RootConstrainSelectedInstOperands,
     /* 127879 */     // GIR_Coverage, 7070,
     /* 127879 */     GIR_EraseRootFromParent_Done,
     /* 127880 */   // Label 2452: @127880
     /* 127880 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(127929), // Rule ID 7071 //
     /* 127885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127902 */     // MIs[0] Rn
     /* 127902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127914 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 127917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127927 */     GIR_RootConstrainSelectedInstOperands,
     /* 127928 */     // GIR_Coverage, 7071,
     /* 127928 */     GIR_EraseRootFromParent_Done,
     /* 127929 */   // Label 2453: @127929
     /* 127929 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(127978), // Rule ID 7072 //
     /* 127934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127951 */     // MIs[0] Rn
     /* 127951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127963 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 127966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127976 */     GIR_RootConstrainSelectedInstOperands,
     /* 127977 */     // GIR_Coverage, 7072,
     /* 127977 */     GIR_EraseRootFromParent_Done,
     /* 127978 */   // Label 2454: @127978
     /* 127978 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(128027), // Rule ID 7073 //
     /* 127983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128000 */     // MIs[0] Rn
     /* 128000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128012 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 128015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128025 */     GIR_RootConstrainSelectedInstOperands,
     /* 128026 */     // GIR_Coverage, 7073,
     /* 128026 */     GIR_EraseRootFromParent_Done,
     /* 128027 */   // Label 2455: @128027
     /* 128027 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(128076), // Rule ID 7074 //
     /* 128032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128049 */     // MIs[0] Rn
     /* 128049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128061 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 128064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128074 */     GIR_RootConstrainSelectedInstOperands,
     /* 128075 */     // GIR_Coverage, 7074,
     /* 128075 */     GIR_EraseRootFromParent_Done,
     /* 128076 */   // Label 2456: @128076
     /* 128076 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(128125), // Rule ID 7075 //
     /* 128081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128098 */     // MIs[0] Rn
     /* 128098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128110 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 128113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128123 */     GIR_RootConstrainSelectedInstOperands,
     /* 128124 */     // GIR_Coverage, 7075,
     /* 128124 */     GIR_EraseRootFromParent_Done,
     /* 128125 */   // Label 2457: @128125
     /* 128125 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(128174), // Rule ID 7076 //
     /* 128130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128147 */     // MIs[0] Rn
     /* 128147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128159 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 128162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128172 */     GIR_RootConstrainSelectedInstOperands,
     /* 128173 */     // GIR_Coverage, 7076,
     /* 128173 */     GIR_EraseRootFromParent_Done,
     /* 128174 */   // Label 2458: @128174
     /* 128174 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(128223), // Rule ID 7077 //
     /* 128179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128196 */     // MIs[0] Rn
     /* 128196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128208 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 128211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128221 */     GIR_RootConstrainSelectedInstOperands,
     /* 128222 */     // GIR_Coverage, 7077,
     /* 128222 */     GIR_EraseRootFromParent_Done,
     /* 128223 */   // Label 2459: @128223
     /* 128223 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(128272), // Rule ID 7078 //
     /* 128228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128245 */     // MIs[0] Rn
     /* 128245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128257 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 128260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128270 */     GIR_RootConstrainSelectedInstOperands,
     /* 128271 */     // GIR_Coverage, 7078,
     /* 128271 */     GIR_EraseRootFromParent_Done,
     /* 128272 */   // Label 2460: @128272
     /* 128272 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(128321), // Rule ID 7079 //
     /* 128277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128294 */     // MIs[0] Rn
     /* 128294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128306 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 128309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128319 */     GIR_RootConstrainSelectedInstOperands,
     /* 128320 */     // GIR_Coverage, 7079,
     /* 128320 */     GIR_EraseRootFromParent_Done,
     /* 128321 */   // Label 2461: @128321
     /* 128321 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(128370), // Rule ID 7080 //
     /* 128326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128343 */     // MIs[0] Rn
     /* 128343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128355 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 128358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128368 */     GIR_RootConstrainSelectedInstOperands,
     /* 128369 */     // GIR_Coverage, 7080,
     /* 128369 */     GIR_EraseRootFromParent_Done,
     /* 128370 */   // Label 2462: @128370
     /* 128370 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(128419), // Rule ID 7081 //
     /* 128375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128385 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128392 */     // MIs[0] Rn
     /* 128392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128404 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 128407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128417 */     GIR_RootConstrainSelectedInstOperands,
     /* 128418 */     // GIR_Coverage, 7081,
     /* 128418 */     GIR_EraseRootFromParent_Done,
     /* 128419 */   // Label 2463: @128419
     /* 128419 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(128468), // Rule ID 7082 //
     /* 128424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128441 */     // MIs[0] Rn
     /* 128441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128453 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 128456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128466 */     GIR_RootConstrainSelectedInstOperands,
     /* 128467 */     // GIR_Coverage, 7082,
     /* 128467 */     GIR_EraseRootFromParent_Done,
     /* 128468 */   // Label 2464: @128468
     /* 128468 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(128517), // Rule ID 7083 //
     /* 128473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128490 */     // MIs[0] Rn
     /* 128490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128502 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 128505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128515 */     GIR_RootConstrainSelectedInstOperands,
     /* 128516 */     // GIR_Coverage, 7083,
     /* 128516 */     GIR_EraseRootFromParent_Done,
     /* 128517 */   // Label 2465: @128517
     /* 128517 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(128566), // Rule ID 7084 //
     /* 128522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128539 */     // MIs[0] Rn
     /* 128539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128551 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 128554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128564 */     GIR_RootConstrainSelectedInstOperands,
     /* 128565 */     // GIR_Coverage, 7084,
     /* 128565 */     GIR_EraseRootFromParent_Done,
     /* 128566 */   // Label 2466: @128566
     /* 128566 */   GIM_Reject,
     /* 128567 */ // Label 2451: @128567
     /* 128567 */ GIM_Reject,
     /* 128568 */ // Label 2449: @128568
     /* 128568 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(128794),
     /* 128573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128576 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128583 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(128625), // Rule ID 7065 //
     /* 128588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128598 */     // MIs[0] Rn
     /* 128598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128610 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 128613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128623 */     GIR_RootConstrainSelectedInstOperands,
     /* 128624 */     // GIR_Coverage, 7065,
     /* 128624 */     GIR_EraseRootFromParent_Done,
     /* 128625 */   // Label 2468: @128625
     /* 128625 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(128667), // Rule ID 7066 //
     /* 128630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128640 */     // MIs[0] Rn
     /* 128640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128652 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 128655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128665 */     GIR_RootConstrainSelectedInstOperands,
     /* 128666 */     // GIR_Coverage, 7066,
     /* 128666 */     GIR_EraseRootFromParent_Done,
     /* 128667 */   // Label 2469: @128667
     /* 128667 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(128709), // Rule ID 7067 //
     /* 128672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128682 */     // MIs[0] Rn
     /* 128682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128694 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 128697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128707 */     GIR_RootConstrainSelectedInstOperands,
     /* 128708 */     // GIR_Coverage, 7067,
     /* 128708 */     GIR_EraseRootFromParent_Done,
     /* 128709 */   // Label 2470: @128709
     /* 128709 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(128751), // Rule ID 7068 //
     /* 128714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128717 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128724 */     // MIs[0] Rn
     /* 128724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128736 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 128739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128749 */     GIR_RootConstrainSelectedInstOperands,
     /* 128750 */     // GIR_Coverage, 7068,
     /* 128750 */     GIR_EraseRootFromParent_Done,
     /* 128751 */   // Label 2471: @128751
     /* 128751 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(128793), // Rule ID 7069 //
     /* 128756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128766 */     // MIs[0] Rn
     /* 128766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128778 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 128781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128791 */     GIR_RootConstrainSelectedInstOperands,
     /* 128792 */     // GIR_Coverage, 7069,
     /* 128792 */     GIR_EraseRootFromParent_Done,
     /* 128793 */   // Label 2472: @128793
     /* 128793 */   GIM_Reject,
     /* 128794 */ // Label 2467: @128794
     /* 128794 */ GIM_Reject,
     /* 128795 */ // Label 2450: @128795
     /* 128795 */ GIM_Reject,
     /* 128796 */ // Label 26: @128796
     /* 128796 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2475*/ GIMT_Encode4(129787),
     /* 128807 */ /*GILLT_s32*//*Label 2473*/ GIMT_Encode4(128815),
     /* 128811 */ /*GILLT_s64*//*Label 2474*/ GIMT_Encode4(129560),
     /* 128815 */ // Label 2473: @128815
     /* 128815 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(129559),
     /* 128820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128823 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(128872), // Rule ID 7090 //
     /* 128828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128845 */     // MIs[0] Rn
     /* 128845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128857 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 128860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128870 */     GIR_RootConstrainSelectedInstOperands,
     /* 128871 */     // GIR_Coverage, 7090,
     /* 128871 */     GIR_EraseRootFromParent_Done,
     /* 128872 */   // Label 2477: @128872
     /* 128872 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(128921), // Rule ID 7091 //
     /* 128877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128894 */     // MIs[0] Rn
     /* 128894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128906 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 128909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128919 */     GIR_RootConstrainSelectedInstOperands,
     /* 128920 */     // GIR_Coverage, 7091,
     /* 128920 */     GIR_EraseRootFromParent_Done,
     /* 128921 */   // Label 2478: @128921
     /* 128921 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(128970), // Rule ID 7092 //
     /* 128926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128943 */     // MIs[0] Rn
     /* 128943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128955 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 128958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128968 */     GIR_RootConstrainSelectedInstOperands,
     /* 128969 */     // GIR_Coverage, 7092,
     /* 128969 */     GIR_EraseRootFromParent_Done,
     /* 128970 */   // Label 2479: @128970
     /* 128970 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(129019), // Rule ID 7093 //
     /* 128975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128992 */     // MIs[0] Rn
     /* 128992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129004 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 129007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129017 */     GIR_RootConstrainSelectedInstOperands,
     /* 129018 */     // GIR_Coverage, 7093,
     /* 129018 */     GIR_EraseRootFromParent_Done,
     /* 129019 */   // Label 2480: @129019
     /* 129019 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(129068), // Rule ID 7094 //
     /* 129024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129041 */     // MIs[0] Rn
     /* 129041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129053 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 129056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129066 */     GIR_RootConstrainSelectedInstOperands,
     /* 129067 */     // GIR_Coverage, 7094,
     /* 129067 */     GIR_EraseRootFromParent_Done,
     /* 129068 */   // Label 2481: @129068
     /* 129068 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(129117), // Rule ID 7095 //
     /* 129073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129090 */     // MIs[0] Rn
     /* 129090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129102 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 129105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129115 */     GIR_RootConstrainSelectedInstOperands,
     /* 129116 */     // GIR_Coverage, 7095,
     /* 129116 */     GIR_EraseRootFromParent_Done,
     /* 129117 */   // Label 2482: @129117
     /* 129117 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(129166), // Rule ID 7096 //
     /* 129122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129139 */     // MIs[0] Rn
     /* 129139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129151 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 129154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129164 */     GIR_RootConstrainSelectedInstOperands,
     /* 129165 */     // GIR_Coverage, 7096,
     /* 129165 */     GIR_EraseRootFromParent_Done,
     /* 129166 */   // Label 2483: @129166
     /* 129166 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(129215), // Rule ID 7097 //
     /* 129171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129188 */     // MIs[0] Rn
     /* 129188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129200 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 129203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129213 */     GIR_RootConstrainSelectedInstOperands,
     /* 129214 */     // GIR_Coverage, 7097,
     /* 129214 */     GIR_EraseRootFromParent_Done,
     /* 129215 */   // Label 2484: @129215
     /* 129215 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(129264), // Rule ID 7098 //
     /* 129220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129237 */     // MIs[0] Rn
     /* 129237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129249 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 129252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129262 */     GIR_RootConstrainSelectedInstOperands,
     /* 129263 */     // GIR_Coverage, 7098,
     /* 129263 */     GIR_EraseRootFromParent_Done,
     /* 129264 */   // Label 2485: @129264
     /* 129264 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(129313), // Rule ID 7099 //
     /* 129269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129286 */     // MIs[0] Rn
     /* 129286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129298 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 129301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129311 */     GIR_RootConstrainSelectedInstOperands,
     /* 129312 */     // GIR_Coverage, 7099,
     /* 129312 */     GIR_EraseRootFromParent_Done,
     /* 129313 */   // Label 2486: @129313
     /* 129313 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(129362), // Rule ID 7100 //
     /* 129318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129335 */     // MIs[0] Rn
     /* 129335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129347 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 129350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129360 */     GIR_RootConstrainSelectedInstOperands,
     /* 129361 */     // GIR_Coverage, 7100,
     /* 129361 */     GIR_EraseRootFromParent_Done,
     /* 129362 */   // Label 2487: @129362
     /* 129362 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(129411), // Rule ID 7101 //
     /* 129367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129384 */     // MIs[0] Rn
     /* 129384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129396 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 129399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129409 */     GIR_RootConstrainSelectedInstOperands,
     /* 129410 */     // GIR_Coverage, 7101,
     /* 129410 */     GIR_EraseRootFromParent_Done,
     /* 129411 */   // Label 2488: @129411
     /* 129411 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(129460), // Rule ID 7102 //
     /* 129416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129426 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129433 */     // MIs[0] Rn
     /* 129433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129445 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 129448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129458 */     GIR_RootConstrainSelectedInstOperands,
     /* 129459 */     // GIR_Coverage, 7102,
     /* 129459 */     GIR_EraseRootFromParent_Done,
     /* 129460 */   // Label 2489: @129460
     /* 129460 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(129509), // Rule ID 7103 //
     /* 129465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129482 */     // MIs[0] Rn
     /* 129482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129494 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 129497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129507 */     GIR_RootConstrainSelectedInstOperands,
     /* 129508 */     // GIR_Coverage, 7103,
     /* 129508 */     GIR_EraseRootFromParent_Done,
     /* 129509 */   // Label 2490: @129509
     /* 129509 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(129558), // Rule ID 7104 //
     /* 129514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129517 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129524 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129531 */     // MIs[0] Rn
     /* 129531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129543 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 129546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129556 */     GIR_RootConstrainSelectedInstOperands,
     /* 129557 */     // GIR_Coverage, 7104,
     /* 129557 */     GIR_EraseRootFromParent_Done,
     /* 129558 */   // Label 2491: @129558
     /* 129558 */   GIM_Reject,
     /* 129559 */ // Label 2476: @129559
     /* 129559 */ GIM_Reject,
     /* 129560 */ // Label 2474: @129560
     /* 129560 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(129786),
     /* 129565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129568 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129575 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(129617), // Rule ID 7085 //
     /* 129580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129590 */     // MIs[0] Rn
     /* 129590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129602 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 129605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129615 */     GIR_RootConstrainSelectedInstOperands,
     /* 129616 */     // GIR_Coverage, 7085,
     /* 129616 */     GIR_EraseRootFromParent_Done,
     /* 129617 */   // Label 2493: @129617
     /* 129617 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(129659), // Rule ID 7086 //
     /* 129622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129632 */     // MIs[0] Rn
     /* 129632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129644 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 129647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129657 */     GIR_RootConstrainSelectedInstOperands,
     /* 129658 */     // GIR_Coverage, 7086,
     /* 129658 */     GIR_EraseRootFromParent_Done,
     /* 129659 */   // Label 2494: @129659
     /* 129659 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(129701), // Rule ID 7087 //
     /* 129664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129674 */     // MIs[0] Rn
     /* 129674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129686 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 129689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129699 */     GIR_RootConstrainSelectedInstOperands,
     /* 129700 */     // GIR_Coverage, 7087,
     /* 129700 */     GIR_EraseRootFromParent_Done,
     /* 129701 */   // Label 2495: @129701
     /* 129701 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(129743), // Rule ID 7088 //
     /* 129706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129716 */     // MIs[0] Rn
     /* 129716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129728 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 129731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129735 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129741 */     GIR_RootConstrainSelectedInstOperands,
     /* 129742 */     // GIR_Coverage, 7088,
     /* 129742 */     GIR_EraseRootFromParent_Done,
     /* 129743 */   // Label 2496: @129743
     /* 129743 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(129785), // Rule ID 7089 //
     /* 129748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129758 */     // MIs[0] Rn
     /* 129758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129770 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 129773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129783 */     GIR_RootConstrainSelectedInstOperands,
     /* 129784 */     // GIR_Coverage, 7089,
     /* 129784 */     GIR_EraseRootFromParent_Done,
     /* 129785 */   // Label 2497: @129785
     /* 129785 */   GIM_Reject,
     /* 129786 */ // Label 2492: @129786
     /* 129786 */ GIM_Reject,
     /* 129787 */ // Label 2475: @129787
     /* 129787 */ GIM_Reject,
     /* 129788 */ // Label 27: @129788
     /* 129788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2500*/ GIMT_Encode4(130779),
     /* 129799 */ /*GILLT_s32*//*Label 2498*/ GIMT_Encode4(129807),
     /* 129803 */ /*GILLT_s64*//*Label 2499*/ GIMT_Encode4(130552),
     /* 129807 */ // Label 2498: @129807
     /* 129807 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(130551),
     /* 129812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129815 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(129864), // Rule ID 7130 //
     /* 129820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129837 */     // MIs[0] Rn
     /* 129837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129849 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 129852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129862 */     GIR_RootConstrainSelectedInstOperands,
     /* 129863 */     // GIR_Coverage, 7130,
     /* 129863 */     GIR_EraseRootFromParent_Done,
     /* 129864 */   // Label 2502: @129864
     /* 129864 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(129913), // Rule ID 7131 //
     /* 129869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129886 */     // MIs[0] Rn
     /* 129886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129898 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 129901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129911 */     GIR_RootConstrainSelectedInstOperands,
     /* 129912 */     // GIR_Coverage, 7131,
     /* 129912 */     GIR_EraseRootFromParent_Done,
     /* 129913 */   // Label 2503: @129913
     /* 129913 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(129962), // Rule ID 7132 //
     /* 129918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129935 */     // MIs[0] Rn
     /* 129935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129947 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 129950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129960 */     GIR_RootConstrainSelectedInstOperands,
     /* 129961 */     // GIR_Coverage, 7132,
     /* 129961 */     GIR_EraseRootFromParent_Done,
     /* 129962 */   // Label 2504: @129962
     /* 129962 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(130011), // Rule ID 7133 //
     /* 129967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129984 */     // MIs[0] Rn
     /* 129984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129996 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 129999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130009 */     GIR_RootConstrainSelectedInstOperands,
     /* 130010 */     // GIR_Coverage, 7133,
     /* 130010 */     GIR_EraseRootFromParent_Done,
     /* 130011 */   // Label 2505: @130011
     /* 130011 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(130060), // Rule ID 7134 //
     /* 130016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130033 */     // MIs[0] Rn
     /* 130033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130045 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 130048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130058 */     GIR_RootConstrainSelectedInstOperands,
     /* 130059 */     // GIR_Coverage, 7134,
     /* 130059 */     GIR_EraseRootFromParent_Done,
     /* 130060 */   // Label 2506: @130060
     /* 130060 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(130109), // Rule ID 7135 //
     /* 130065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130082 */     // MIs[0] Rn
     /* 130082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130094 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 130097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130107 */     GIR_RootConstrainSelectedInstOperands,
     /* 130108 */     // GIR_Coverage, 7135,
     /* 130108 */     GIR_EraseRootFromParent_Done,
     /* 130109 */   // Label 2507: @130109
     /* 130109 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(130158), // Rule ID 7136 //
     /* 130114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130131 */     // MIs[0] Rn
     /* 130131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130143 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 130146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130156 */     GIR_RootConstrainSelectedInstOperands,
     /* 130157 */     // GIR_Coverage, 7136,
     /* 130157 */     GIR_EraseRootFromParent_Done,
     /* 130158 */   // Label 2508: @130158
     /* 130158 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(130207), // Rule ID 7137 //
     /* 130163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130180 */     // MIs[0] Rn
     /* 130180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130192 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 130195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130205 */     GIR_RootConstrainSelectedInstOperands,
     /* 130206 */     // GIR_Coverage, 7137,
     /* 130206 */     GIR_EraseRootFromParent_Done,
     /* 130207 */   // Label 2509: @130207
     /* 130207 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(130256), // Rule ID 7138 //
     /* 130212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130229 */     // MIs[0] Rn
     /* 130229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130241 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 130244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130254 */     GIR_RootConstrainSelectedInstOperands,
     /* 130255 */     // GIR_Coverage, 7138,
     /* 130255 */     GIR_EraseRootFromParent_Done,
     /* 130256 */   // Label 2510: @130256
     /* 130256 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(130305), // Rule ID 7139 //
     /* 130261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130278 */     // MIs[0] Rn
     /* 130278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130290 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 130293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130303 */     GIR_RootConstrainSelectedInstOperands,
     /* 130304 */     // GIR_Coverage, 7139,
     /* 130304 */     GIR_EraseRootFromParent_Done,
     /* 130305 */   // Label 2511: @130305
     /* 130305 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(130354), // Rule ID 7140 //
     /* 130310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130327 */     // MIs[0] Rn
     /* 130327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130339 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 130342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130352 */     GIR_RootConstrainSelectedInstOperands,
     /* 130353 */     // GIR_Coverage, 7140,
     /* 130353 */     GIR_EraseRootFromParent_Done,
     /* 130354 */   // Label 2512: @130354
     /* 130354 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(130403), // Rule ID 7141 //
     /* 130359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130376 */     // MIs[0] Rn
     /* 130376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130388 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 130391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130401 */     GIR_RootConstrainSelectedInstOperands,
     /* 130402 */     // GIR_Coverage, 7141,
     /* 130402 */     GIR_EraseRootFromParent_Done,
     /* 130403 */   // Label 2513: @130403
     /* 130403 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(130452), // Rule ID 7142 //
     /* 130408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130425 */     // MIs[0] Rn
     /* 130425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130437 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 130440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130450 */     GIR_RootConstrainSelectedInstOperands,
     /* 130451 */     // GIR_Coverage, 7142,
     /* 130451 */     GIR_EraseRootFromParent_Done,
     /* 130452 */   // Label 2514: @130452
     /* 130452 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(130501), // Rule ID 7143 //
     /* 130457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130474 */     // MIs[0] Rn
     /* 130474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130486 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 130489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130499 */     GIR_RootConstrainSelectedInstOperands,
     /* 130500 */     // GIR_Coverage, 7143,
     /* 130500 */     GIR_EraseRootFromParent_Done,
     /* 130501 */   // Label 2515: @130501
     /* 130501 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(130550), // Rule ID 7144 //
     /* 130506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130523 */     // MIs[0] Rn
     /* 130523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130535 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 130538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130548 */     GIR_RootConstrainSelectedInstOperands,
     /* 130549 */     // GIR_Coverage, 7144,
     /* 130549 */     GIR_EraseRootFromParent_Done,
     /* 130550 */   // Label 2516: @130550
     /* 130550 */   GIM_Reject,
     /* 130551 */ // Label 2501: @130551
     /* 130551 */ GIM_Reject,
     /* 130552 */ // Label 2499: @130552
     /* 130552 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(130778),
     /* 130557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130560 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130567 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(130609), // Rule ID 7125 //
     /* 130572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130582 */     // MIs[0] Rn
     /* 130582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130594 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 130597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130607 */     GIR_RootConstrainSelectedInstOperands,
     /* 130608 */     // GIR_Coverage, 7125,
     /* 130608 */     GIR_EraseRootFromParent_Done,
     /* 130609 */   // Label 2518: @130609
     /* 130609 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(130651), // Rule ID 7126 //
     /* 130614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130624 */     // MIs[0] Rn
     /* 130624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130636 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 130639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130649 */     GIR_RootConstrainSelectedInstOperands,
     /* 130650 */     // GIR_Coverage, 7126,
     /* 130650 */     GIR_EraseRootFromParent_Done,
     /* 130651 */   // Label 2519: @130651
     /* 130651 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(130693), // Rule ID 7127 //
     /* 130656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130666 */     // MIs[0] Rn
     /* 130666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130678 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 130681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130691 */     GIR_RootConstrainSelectedInstOperands,
     /* 130692 */     // GIR_Coverage, 7127,
     /* 130692 */     GIR_EraseRootFromParent_Done,
     /* 130693 */   // Label 2520: @130693
     /* 130693 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(130735), // Rule ID 7128 //
     /* 130698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130708 */     // MIs[0] Rn
     /* 130708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130720 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 130723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130733 */     GIR_RootConstrainSelectedInstOperands,
     /* 130734 */     // GIR_Coverage, 7128,
     /* 130734 */     GIR_EraseRootFromParent_Done,
     /* 130735 */   // Label 2521: @130735
     /* 130735 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(130777), // Rule ID 7129 //
     /* 130740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130750 */     // MIs[0] Rn
     /* 130750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130762 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 130765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130775 */     GIR_RootConstrainSelectedInstOperands,
     /* 130776 */     // GIR_Coverage, 7129,
     /* 130776 */     GIR_EraseRootFromParent_Done,
     /* 130777 */   // Label 2522: @130777
     /* 130777 */   GIM_Reject,
     /* 130778 */ // Label 2517: @130778
     /* 130778 */ GIM_Reject,
     /* 130779 */ // Label 2500: @130779
     /* 130779 */ GIM_Reject,
     /* 130780 */ // Label 28: @130780
     /* 130780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2525*/ GIMT_Encode4(131771),
     /* 130791 */ /*GILLT_s32*//*Label 2523*/ GIMT_Encode4(130799),
     /* 130795 */ /*GILLT_s64*//*Label 2524*/ GIMT_Encode4(131544),
     /* 130799 */ // Label 2523: @130799
     /* 130799 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(131543),
     /* 130804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130807 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(130856), // Rule ID 7150 //
     /* 130812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130829 */     // MIs[0] Rn
     /* 130829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130841 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 130844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130854 */     GIR_RootConstrainSelectedInstOperands,
     /* 130855 */     // GIR_Coverage, 7150,
     /* 130855 */     GIR_EraseRootFromParent_Done,
     /* 130856 */   // Label 2527: @130856
     /* 130856 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(130905), // Rule ID 7151 //
     /* 130861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130878 */     // MIs[0] Rn
     /* 130878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130890 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 130893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130903 */     GIR_RootConstrainSelectedInstOperands,
     /* 130904 */     // GIR_Coverage, 7151,
     /* 130904 */     GIR_EraseRootFromParent_Done,
     /* 130905 */   // Label 2528: @130905
     /* 130905 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(130954), // Rule ID 7152 //
     /* 130910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130927 */     // MIs[0] Rn
     /* 130927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130939 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 130942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130952 */     GIR_RootConstrainSelectedInstOperands,
     /* 130953 */     // GIR_Coverage, 7152,
     /* 130953 */     GIR_EraseRootFromParent_Done,
     /* 130954 */   // Label 2529: @130954
     /* 130954 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(131003), // Rule ID 7153 //
     /* 130959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130976 */     // MIs[0] Rn
     /* 130976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130988 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 130991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131001 */     GIR_RootConstrainSelectedInstOperands,
     /* 131002 */     // GIR_Coverage, 7153,
     /* 131002 */     GIR_EraseRootFromParent_Done,
     /* 131003 */   // Label 2530: @131003
     /* 131003 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(131052), // Rule ID 7154 //
     /* 131008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131025 */     // MIs[0] Rn
     /* 131025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131037 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 131040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131050 */     GIR_RootConstrainSelectedInstOperands,
     /* 131051 */     // GIR_Coverage, 7154,
     /* 131051 */     GIR_EraseRootFromParent_Done,
     /* 131052 */   // Label 2531: @131052
     /* 131052 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(131101), // Rule ID 7155 //
     /* 131057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131074 */     // MIs[0] Rn
     /* 131074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131086 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 131089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131099 */     GIR_RootConstrainSelectedInstOperands,
     /* 131100 */     // GIR_Coverage, 7155,
     /* 131100 */     GIR_EraseRootFromParent_Done,
     /* 131101 */   // Label 2532: @131101
     /* 131101 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(131150), // Rule ID 7156 //
     /* 131106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131123 */     // MIs[0] Rn
     /* 131123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131135 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 131138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131148 */     GIR_RootConstrainSelectedInstOperands,
     /* 131149 */     // GIR_Coverage, 7156,
     /* 131149 */     GIR_EraseRootFromParent_Done,
     /* 131150 */   // Label 2533: @131150
     /* 131150 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(131199), // Rule ID 7157 //
     /* 131155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131172 */     // MIs[0] Rn
     /* 131172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131184 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 131187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131197 */     GIR_RootConstrainSelectedInstOperands,
     /* 131198 */     // GIR_Coverage, 7157,
     /* 131198 */     GIR_EraseRootFromParent_Done,
     /* 131199 */   // Label 2534: @131199
     /* 131199 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(131248), // Rule ID 7158 //
     /* 131204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131221 */     // MIs[0] Rn
     /* 131221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131233 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 131236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131246 */     GIR_RootConstrainSelectedInstOperands,
     /* 131247 */     // GIR_Coverage, 7158,
     /* 131247 */     GIR_EraseRootFromParent_Done,
     /* 131248 */   // Label 2535: @131248
     /* 131248 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(131297), // Rule ID 7159 //
     /* 131253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131270 */     // MIs[0] Rn
     /* 131270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131282 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 131285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131295 */     GIR_RootConstrainSelectedInstOperands,
     /* 131296 */     // GIR_Coverage, 7159,
     /* 131296 */     GIR_EraseRootFromParent_Done,
     /* 131297 */   // Label 2536: @131297
     /* 131297 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(131346), // Rule ID 7160 //
     /* 131302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131319 */     // MIs[0] Rn
     /* 131319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131331 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 131334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131344 */     GIR_RootConstrainSelectedInstOperands,
     /* 131345 */     // GIR_Coverage, 7160,
     /* 131345 */     GIR_EraseRootFromParent_Done,
     /* 131346 */   // Label 2537: @131346
     /* 131346 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(131395), // Rule ID 7161 //
     /* 131351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131368 */     // MIs[0] Rn
     /* 131368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131380 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 131383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131393 */     GIR_RootConstrainSelectedInstOperands,
     /* 131394 */     // GIR_Coverage, 7161,
     /* 131394 */     GIR_EraseRootFromParent_Done,
     /* 131395 */   // Label 2538: @131395
     /* 131395 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(131444), // Rule ID 7162 //
     /* 131400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131417 */     // MIs[0] Rn
     /* 131417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131429 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 131432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131442 */     GIR_RootConstrainSelectedInstOperands,
     /* 131443 */     // GIR_Coverage, 7162,
     /* 131443 */     GIR_EraseRootFromParent_Done,
     /* 131444 */   // Label 2539: @131444
     /* 131444 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(131493), // Rule ID 7163 //
     /* 131449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131466 */     // MIs[0] Rn
     /* 131466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131478 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 131481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131491 */     GIR_RootConstrainSelectedInstOperands,
     /* 131492 */     // GIR_Coverage, 7163,
     /* 131492 */     GIR_EraseRootFromParent_Done,
     /* 131493 */   // Label 2540: @131493
     /* 131493 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(131542), // Rule ID 7164 //
     /* 131498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131515 */     // MIs[0] Rn
     /* 131515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131527 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 131530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131540 */     GIR_RootConstrainSelectedInstOperands,
     /* 131541 */     // GIR_Coverage, 7164,
     /* 131541 */     GIR_EraseRootFromParent_Done,
     /* 131542 */   // Label 2541: @131542
     /* 131542 */   GIM_Reject,
     /* 131543 */ // Label 2526: @131543
     /* 131543 */ GIM_Reject,
     /* 131544 */ // Label 2524: @131544
     /* 131544 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(131770),
     /* 131549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131552 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131559 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(131601), // Rule ID 7145 //
     /* 131564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131567 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131574 */     // MIs[0] Rn
     /* 131574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131586 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 131589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131599 */     GIR_RootConstrainSelectedInstOperands,
     /* 131600 */     // GIR_Coverage, 7145,
     /* 131600 */     GIR_EraseRootFromParent_Done,
     /* 131601 */   // Label 2543: @131601
     /* 131601 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(131643), // Rule ID 7146 //
     /* 131606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131616 */     // MIs[0] Rn
     /* 131616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131628 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 131631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131641 */     GIR_RootConstrainSelectedInstOperands,
     /* 131642 */     // GIR_Coverage, 7146,
     /* 131642 */     GIR_EraseRootFromParent_Done,
     /* 131643 */   // Label 2544: @131643
     /* 131643 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(131685), // Rule ID 7147 //
     /* 131648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131651 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131658 */     // MIs[0] Rn
     /* 131658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131670 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 131673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131683 */     GIR_RootConstrainSelectedInstOperands,
     /* 131684 */     // GIR_Coverage, 7147,
     /* 131684 */     GIR_EraseRootFromParent_Done,
     /* 131685 */   // Label 2545: @131685
     /* 131685 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(131727), // Rule ID 7148 //
     /* 131690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131700 */     // MIs[0] Rn
     /* 131700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131712 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 131715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131725 */     GIR_RootConstrainSelectedInstOperands,
     /* 131726 */     // GIR_Coverage, 7148,
     /* 131726 */     GIR_EraseRootFromParent_Done,
     /* 131727 */   // Label 2546: @131727
     /* 131727 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(131769), // Rule ID 7149 //
     /* 131732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131742 */     // MIs[0] Rn
     /* 131742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131754 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 131757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131767 */     GIR_RootConstrainSelectedInstOperands,
     /* 131768 */     // GIR_Coverage, 7149,
     /* 131768 */     GIR_EraseRootFromParent_Done,
     /* 131769 */   // Label 2547: @131769
     /* 131769 */   GIM_Reject,
     /* 131770 */ // Label 2542: @131770
     /* 131770 */ GIM_Reject,
     /* 131771 */ // Label 2525: @131771
     /* 131771 */ GIM_Reject,
     /* 131772 */ // Label 29: @131772
     /* 131772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2550*/ GIMT_Encode4(132763),
     /* 131783 */ /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(131791),
     /* 131787 */ /*GILLT_s64*//*Label 2549*/ GIMT_Encode4(132536),
     /* 131791 */ // Label 2548: @131791
     /* 131791 */ GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(132535),
     /* 131796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131799 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(131848), // Rule ID 7170 //
     /* 131804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131821 */     // MIs[0] Rn
     /* 131821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131833 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 131836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131846 */     GIR_RootConstrainSelectedInstOperands,
     /* 131847 */     // GIR_Coverage, 7170,
     /* 131847 */     GIR_EraseRootFromParent_Done,
     /* 131848 */   // Label 2552: @131848
     /* 131848 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(131897), // Rule ID 7171 //
     /* 131853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131870 */     // MIs[0] Rn
     /* 131870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131882 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 131885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131895 */     GIR_RootConstrainSelectedInstOperands,
     /* 131896 */     // GIR_Coverage, 7171,
     /* 131896 */     GIR_EraseRootFromParent_Done,
     /* 131897 */   // Label 2553: @131897
     /* 131897 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(131946), // Rule ID 7172 //
     /* 131902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131919 */     // MIs[0] Rn
     /* 131919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131931 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 131934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131944 */     GIR_RootConstrainSelectedInstOperands,
     /* 131945 */     // GIR_Coverage, 7172,
     /* 131945 */     GIR_EraseRootFromParent_Done,
     /* 131946 */   // Label 2554: @131946
     /* 131946 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(131995), // Rule ID 7173 //
     /* 131951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131968 */     // MIs[0] Rn
     /* 131968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131980 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 131983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131993 */     GIR_RootConstrainSelectedInstOperands,
     /* 131994 */     // GIR_Coverage, 7173,
     /* 131994 */     GIR_EraseRootFromParent_Done,
     /* 131995 */   // Label 2555: @131995
     /* 131995 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(132044), // Rule ID 7174 //
     /* 132000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132017 */     // MIs[0] Rn
     /* 132017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132029 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 132032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132042 */     GIR_RootConstrainSelectedInstOperands,
     /* 132043 */     // GIR_Coverage, 7174,
     /* 132043 */     GIR_EraseRootFromParent_Done,
     /* 132044 */   // Label 2556: @132044
     /* 132044 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(132093), // Rule ID 7175 //
     /* 132049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132066 */     // MIs[0] Rn
     /* 132066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132078 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 132081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132091 */     GIR_RootConstrainSelectedInstOperands,
     /* 132092 */     // GIR_Coverage, 7175,
     /* 132092 */     GIR_EraseRootFromParent_Done,
     /* 132093 */   // Label 2557: @132093
     /* 132093 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(132142), // Rule ID 7176 //
     /* 132098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132115 */     // MIs[0] Rn
     /* 132115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132127 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 132130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132140 */     GIR_RootConstrainSelectedInstOperands,
     /* 132141 */     // GIR_Coverage, 7176,
     /* 132141 */     GIR_EraseRootFromParent_Done,
     /* 132142 */   // Label 2558: @132142
     /* 132142 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(132191), // Rule ID 7177 //
     /* 132147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132164 */     // MIs[0] Rn
     /* 132164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132176 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 132179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132189 */     GIR_RootConstrainSelectedInstOperands,
     /* 132190 */     // GIR_Coverage, 7177,
     /* 132190 */     GIR_EraseRootFromParent_Done,
     /* 132191 */   // Label 2559: @132191
     /* 132191 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(132240), // Rule ID 7178 //
     /* 132196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132213 */     // MIs[0] Rn
     /* 132213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132225 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 132228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132238 */     GIR_RootConstrainSelectedInstOperands,
     /* 132239 */     // GIR_Coverage, 7178,
     /* 132239 */     GIR_EraseRootFromParent_Done,
     /* 132240 */   // Label 2560: @132240
     /* 132240 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(132289), // Rule ID 7179 //
     /* 132245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132262 */     // MIs[0] Rn
     /* 132262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132274 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 132277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132287 */     GIR_RootConstrainSelectedInstOperands,
     /* 132288 */     // GIR_Coverage, 7179,
     /* 132288 */     GIR_EraseRootFromParent_Done,
     /* 132289 */   // Label 2561: @132289
     /* 132289 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(132338), // Rule ID 7180 //
     /* 132294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132311 */     // MIs[0] Rn
     /* 132311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132323 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 132326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132336 */     GIR_RootConstrainSelectedInstOperands,
     /* 132337 */     // GIR_Coverage, 7180,
     /* 132337 */     GIR_EraseRootFromParent_Done,
     /* 132338 */   // Label 2562: @132338
     /* 132338 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(132387), // Rule ID 7181 //
     /* 132343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132360 */     // MIs[0] Rn
     /* 132360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132372 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 132375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132385 */     GIR_RootConstrainSelectedInstOperands,
     /* 132386 */     // GIR_Coverage, 7181,
     /* 132386 */     GIR_EraseRootFromParent_Done,
     /* 132387 */   // Label 2563: @132387
     /* 132387 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(132436), // Rule ID 7182 //
     /* 132392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132409 */     // MIs[0] Rn
     /* 132409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132421 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 132424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132434 */     GIR_RootConstrainSelectedInstOperands,
     /* 132435 */     // GIR_Coverage, 7182,
     /* 132435 */     GIR_EraseRootFromParent_Done,
     /* 132436 */   // Label 2564: @132436
     /* 132436 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(132485), // Rule ID 7183 //
     /* 132441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132458 */     // MIs[0] Rn
     /* 132458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132470 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 132473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132483 */     GIR_RootConstrainSelectedInstOperands,
     /* 132484 */     // GIR_Coverage, 7183,
     /* 132484 */     GIR_EraseRootFromParent_Done,
     /* 132485 */   // Label 2565: @132485
     /* 132485 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(132534), // Rule ID 7184 //
     /* 132490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132507 */     // MIs[0] Rn
     /* 132507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132519 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 132522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132532 */     GIR_RootConstrainSelectedInstOperands,
     /* 132533 */     // GIR_Coverage, 7184,
     /* 132533 */     GIR_EraseRootFromParent_Done,
     /* 132534 */   // Label 2566: @132534
     /* 132534 */   GIM_Reject,
     /* 132535 */ // Label 2551: @132535
     /* 132535 */ GIM_Reject,
     /* 132536 */ // Label 2549: @132536
     /* 132536 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(132762),
     /* 132541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132551 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(132593), // Rule ID 7165 //
     /* 132556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132566 */     // MIs[0] Rn
     /* 132566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132578 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 132581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132591 */     GIR_RootConstrainSelectedInstOperands,
     /* 132592 */     // GIR_Coverage, 7165,
     /* 132592 */     GIR_EraseRootFromParent_Done,
     /* 132593 */   // Label 2568: @132593
     /* 132593 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(132635), // Rule ID 7166 //
     /* 132598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132601 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132608 */     // MIs[0] Rn
     /* 132608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132620 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 132623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132633 */     GIR_RootConstrainSelectedInstOperands,
     /* 132634 */     // GIR_Coverage, 7166,
     /* 132634 */     GIR_EraseRootFromParent_Done,
     /* 132635 */   // Label 2569: @132635
     /* 132635 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(132677), // Rule ID 7167 //
     /* 132640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132650 */     // MIs[0] Rn
     /* 132650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132662 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 132665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132675 */     GIR_RootConstrainSelectedInstOperands,
     /* 132676 */     // GIR_Coverage, 7167,
     /* 132676 */     GIR_EraseRootFromParent_Done,
     /* 132677 */   // Label 2570: @132677
     /* 132677 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(132719), // Rule ID 7168 //
     /* 132682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132692 */     // MIs[0] Rn
     /* 132692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132704 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 132707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132717 */     GIR_RootConstrainSelectedInstOperands,
     /* 132718 */     // GIR_Coverage, 7168,
     /* 132718 */     GIR_EraseRootFromParent_Done,
     /* 132719 */   // Label 2571: @132719
     /* 132719 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(132761), // Rule ID 7169 //
     /* 132724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132734 */     // MIs[0] Rn
     /* 132734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132746 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 132749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132759 */     GIR_RootConstrainSelectedInstOperands,
     /* 132760 */     // GIR_Coverage, 7169,
     /* 132760 */     GIR_EraseRootFromParent_Done,
     /* 132761 */   // Label 2572: @132761
     /* 132761 */   GIM_Reject,
     /* 132762 */ // Label 2567: @132762
     /* 132762 */ GIM_Reject,
     /* 132763 */ // Label 2550: @132763
     /* 132763 */ GIM_Reject,
     /* 132764 */ // Label 30: @132764
     /* 132764 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2575*/ GIMT_Encode4(133755),
     /* 132775 */ /*GILLT_s32*//*Label 2573*/ GIMT_Encode4(132783),
     /* 132779 */ /*GILLT_s64*//*Label 2574*/ GIMT_Encode4(133528),
     /* 132783 */ // Label 2573: @132783
     /* 132783 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(133527),
     /* 132788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132791 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(132840), // Rule ID 7190 //
     /* 132796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132799 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132806 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132813 */     // MIs[0] Rn
     /* 132813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132825 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 132828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132838 */     GIR_RootConstrainSelectedInstOperands,
     /* 132839 */     // GIR_Coverage, 7190,
     /* 132839 */     GIR_EraseRootFromParent_Done,
     /* 132840 */   // Label 2577: @132840
     /* 132840 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(132889), // Rule ID 7191 //
     /* 132845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132862 */     // MIs[0] Rn
     /* 132862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132874 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 132877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132887 */     GIR_RootConstrainSelectedInstOperands,
     /* 132888 */     // GIR_Coverage, 7191,
     /* 132888 */     GIR_EraseRootFromParent_Done,
     /* 132889 */   // Label 2578: @132889
     /* 132889 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(132938), // Rule ID 7192 //
     /* 132894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132911 */     // MIs[0] Rn
     /* 132911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132923 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 132926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132936 */     GIR_RootConstrainSelectedInstOperands,
     /* 132937 */     // GIR_Coverage, 7192,
     /* 132937 */     GIR_EraseRootFromParent_Done,
     /* 132938 */   // Label 2579: @132938
     /* 132938 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(132987), // Rule ID 7193 //
     /* 132943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132960 */     // MIs[0] Rn
     /* 132960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132972 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 132975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132985 */     GIR_RootConstrainSelectedInstOperands,
     /* 132986 */     // GIR_Coverage, 7193,
     /* 132986 */     GIR_EraseRootFromParent_Done,
     /* 132987 */   // Label 2580: @132987
     /* 132987 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(133036), // Rule ID 7194 //
     /* 132992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133009 */     // MIs[0] Rn
     /* 133009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133021 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 133024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133034 */     GIR_RootConstrainSelectedInstOperands,
     /* 133035 */     // GIR_Coverage, 7194,
     /* 133035 */     GIR_EraseRootFromParent_Done,
     /* 133036 */   // Label 2581: @133036
     /* 133036 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(133085), // Rule ID 7195 //
     /* 133041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133058 */     // MIs[0] Rn
     /* 133058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133070 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 133073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133083 */     GIR_RootConstrainSelectedInstOperands,
     /* 133084 */     // GIR_Coverage, 7195,
     /* 133084 */     GIR_EraseRootFromParent_Done,
     /* 133085 */   // Label 2582: @133085
     /* 133085 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(133134), // Rule ID 7196 //
     /* 133090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133107 */     // MIs[0] Rn
     /* 133107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133119 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 133122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133132 */     GIR_RootConstrainSelectedInstOperands,
     /* 133133 */     // GIR_Coverage, 7196,
     /* 133133 */     GIR_EraseRootFromParent_Done,
     /* 133134 */   // Label 2583: @133134
     /* 133134 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(133183), // Rule ID 7197 //
     /* 133139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133156 */     // MIs[0] Rn
     /* 133156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133168 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 133171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133181 */     GIR_RootConstrainSelectedInstOperands,
     /* 133182 */     // GIR_Coverage, 7197,
     /* 133182 */     GIR_EraseRootFromParent_Done,
     /* 133183 */   // Label 2584: @133183
     /* 133183 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(133232), // Rule ID 7198 //
     /* 133188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133205 */     // MIs[0] Rn
     /* 133205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133217 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 133220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133230 */     GIR_RootConstrainSelectedInstOperands,
     /* 133231 */     // GIR_Coverage, 7198,
     /* 133231 */     GIR_EraseRootFromParent_Done,
     /* 133232 */   // Label 2585: @133232
     /* 133232 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(133281), // Rule ID 7199 //
     /* 133237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133254 */     // MIs[0] Rn
     /* 133254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133266 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 133269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133279 */     GIR_RootConstrainSelectedInstOperands,
     /* 133280 */     // GIR_Coverage, 7199,
     /* 133280 */     GIR_EraseRootFromParent_Done,
     /* 133281 */   // Label 2586: @133281
     /* 133281 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(133330), // Rule ID 7200 //
     /* 133286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133303 */     // MIs[0] Rn
     /* 133303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133315 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 133318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133328 */     GIR_RootConstrainSelectedInstOperands,
     /* 133329 */     // GIR_Coverage, 7200,
     /* 133329 */     GIR_EraseRootFromParent_Done,
     /* 133330 */   // Label 2587: @133330
     /* 133330 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(133379), // Rule ID 7201 //
     /* 133335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133352 */     // MIs[0] Rn
     /* 133352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133364 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 133367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133377 */     GIR_RootConstrainSelectedInstOperands,
     /* 133378 */     // GIR_Coverage, 7201,
     /* 133378 */     GIR_EraseRootFromParent_Done,
     /* 133379 */   // Label 2588: @133379
     /* 133379 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(133428), // Rule ID 7202 //
     /* 133384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133401 */     // MIs[0] Rn
     /* 133401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133413 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 133416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133426 */     GIR_RootConstrainSelectedInstOperands,
     /* 133427 */     // GIR_Coverage, 7202,
     /* 133427 */     GIR_EraseRootFromParent_Done,
     /* 133428 */   // Label 2589: @133428
     /* 133428 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(133477), // Rule ID 7203 //
     /* 133433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133450 */     // MIs[0] Rn
     /* 133450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133462 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 133465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133475 */     GIR_RootConstrainSelectedInstOperands,
     /* 133476 */     // GIR_Coverage, 7203,
     /* 133476 */     GIR_EraseRootFromParent_Done,
     /* 133477 */   // Label 2590: @133477
     /* 133477 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(133526), // Rule ID 7204 //
     /* 133482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133499 */     // MIs[0] Rn
     /* 133499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133511 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 133514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133524 */     GIR_RootConstrainSelectedInstOperands,
     /* 133525 */     // GIR_Coverage, 7204,
     /* 133525 */     GIR_EraseRootFromParent_Done,
     /* 133526 */   // Label 2591: @133526
     /* 133526 */   GIM_Reject,
     /* 133527 */ // Label 2576: @133527
     /* 133527 */ GIM_Reject,
     /* 133528 */ // Label 2574: @133528
     /* 133528 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(133754),
     /* 133533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133543 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(133585), // Rule ID 7185 //
     /* 133548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133558 */     // MIs[0] Rn
     /* 133558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133570 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 133573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133583 */     GIR_RootConstrainSelectedInstOperands,
     /* 133584 */     // GIR_Coverage, 7185,
     /* 133584 */     GIR_EraseRootFromParent_Done,
     /* 133585 */   // Label 2593: @133585
     /* 133585 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(133627), // Rule ID 7186 //
     /* 133590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133600 */     // MIs[0] Rn
     /* 133600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133612 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 133615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133625 */     GIR_RootConstrainSelectedInstOperands,
     /* 133626 */     // GIR_Coverage, 7186,
     /* 133626 */     GIR_EraseRootFromParent_Done,
     /* 133627 */   // Label 2594: @133627
     /* 133627 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(133669), // Rule ID 7187 //
     /* 133632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133635 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133642 */     // MIs[0] Rn
     /* 133642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133654 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 133657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133667 */     GIR_RootConstrainSelectedInstOperands,
     /* 133668 */     // GIR_Coverage, 7187,
     /* 133668 */     GIR_EraseRootFromParent_Done,
     /* 133669 */   // Label 2595: @133669
     /* 133669 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(133711), // Rule ID 7188 //
     /* 133674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133677 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133684 */     // MIs[0] Rn
     /* 133684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133696 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 133699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133709 */     GIR_RootConstrainSelectedInstOperands,
     /* 133710 */     // GIR_Coverage, 7188,
     /* 133710 */     GIR_EraseRootFromParent_Done,
     /* 133711 */   // Label 2596: @133711
     /* 133711 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(133753), // Rule ID 7189 //
     /* 133716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133726 */     // MIs[0] Rn
     /* 133726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133738 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 133741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133751 */     GIR_RootConstrainSelectedInstOperands,
     /* 133752 */     // GIR_Coverage, 7189,
     /* 133752 */     GIR_EraseRootFromParent_Done,
     /* 133753 */   // Label 2597: @133753
     /* 133753 */   GIM_Reject,
     /* 133754 */ // Label 2592: @133754
     /* 133754 */ GIM_Reject,
     /* 133755 */ // Label 2575: @133755
     /* 133755 */ GIM_Reject,
     /* 133756 */ // Label 31: @133756
     /* 133756 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2601*/ GIMT_Encode4(134460),
     /* 133767 */ /*GILLT_s16*//*Label 2598*/ GIMT_Encode4(133779),
     /* 133771 */ /*GILLT_s32*//*Label 2599*/ GIMT_Encode4(134006),
     /* 133775 */ /*GILLT_s64*//*Label 2600*/ GIMT_Encode4(134233),
     /* 133779 */ // Label 2598: @133779
     /* 133779 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(134005),
     /* 133784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 133787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133794 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(133836), // Rule ID 2575 //
     /* 133799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 133802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133809 */     // MIs[0] Rn
     /* 133809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133821 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 133821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 133824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133834 */     GIR_RootConstrainSelectedInstOperands,
     /* 133835 */     // GIR_Coverage, 2575,
     /* 133835 */     GIR_EraseRootFromParent_Done,
     /* 133836 */   // Label 2603: @133836
     /* 133836 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(133878), // Rule ID 2576 //
     /* 133841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 133844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133851 */     // MIs[0] Rn
     /* 133851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133863 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 133863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 133866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133876 */     GIR_RootConstrainSelectedInstOperands,
     /* 133877 */     // GIR_Coverage, 2576,
     /* 133877 */     GIR_EraseRootFromParent_Done,
     /* 133878 */   // Label 2604: @133878
     /* 133878 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(133920), // Rule ID 2577 //
     /* 133883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 133886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133893 */     // MIs[0] Rn
     /* 133893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133905 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 133905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 133908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133918 */     GIR_RootConstrainSelectedInstOperands,
     /* 133919 */     // GIR_Coverage, 2577,
     /* 133919 */     GIR_EraseRootFromParent_Done,
     /* 133920 */   // Label 2605: @133920
     /* 133920 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(133962), // Rule ID 2578 //
     /* 133925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 133928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133935 */     // MIs[0] Rn
     /* 133935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133947 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 133947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 133950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133960 */     GIR_RootConstrainSelectedInstOperands,
     /* 133961 */     // GIR_Coverage, 2578,
     /* 133961 */     GIR_EraseRootFromParent_Done,
     /* 133962 */   // Label 2606: @133962
     /* 133962 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(134004), // Rule ID 2579 //
     /* 133967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 133970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133977 */     // MIs[0] Rn
     /* 133977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133989 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 133989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 133992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134002 */     GIR_RootConstrainSelectedInstOperands,
     /* 134003 */     // GIR_Coverage, 2579,
     /* 134003 */     GIR_EraseRootFromParent_Done,
     /* 134004 */   // Label 2607: @134004
     /* 134004 */   GIM_Reject,
     /* 134005 */ // Label 2602: @134005
     /* 134005 */ GIM_Reject,
     /* 134006 */ // Label 2599: @134006
     /* 134006 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(134232),
     /* 134011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134021 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(134063), // Rule ID 7280 //
     /* 134026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134036 */     // MIs[0] Rn
     /* 134036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134048 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 134051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134061 */     GIR_RootConstrainSelectedInstOperands,
     /* 134062 */     // GIR_Coverage, 7280,
     /* 134062 */     GIR_EraseRootFromParent_Done,
     /* 134063 */   // Label 2609: @134063
     /* 134063 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(134105), // Rule ID 7281 //
     /* 134068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134078 */     // MIs[0] Rn
     /* 134078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134090 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 134093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134103 */     GIR_RootConstrainSelectedInstOperands,
     /* 134104 */     // GIR_Coverage, 7281,
     /* 134104 */     GIR_EraseRootFromParent_Done,
     /* 134105 */   // Label 2610: @134105
     /* 134105 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(134147), // Rule ID 7282 //
     /* 134110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134120 */     // MIs[0] Rn
     /* 134120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134132 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 134135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134145 */     GIR_RootConstrainSelectedInstOperands,
     /* 134146 */     // GIR_Coverage, 7282,
     /* 134146 */     GIR_EraseRootFromParent_Done,
     /* 134147 */   // Label 2611: @134147
     /* 134147 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(134189), // Rule ID 7283 //
     /* 134152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134162 */     // MIs[0] Rn
     /* 134162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134174 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 134177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134187 */     GIR_RootConstrainSelectedInstOperands,
     /* 134188 */     // GIR_Coverage, 7283,
     /* 134188 */     GIR_EraseRootFromParent_Done,
     /* 134189 */   // Label 2612: @134189
     /* 134189 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(134231), // Rule ID 7284 //
     /* 134194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134204 */     // MIs[0] Rn
     /* 134204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134216 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 134219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134229 */     GIR_RootConstrainSelectedInstOperands,
     /* 134230 */     // GIR_Coverage, 7284,
     /* 134230 */     GIR_EraseRootFromParent_Done,
     /* 134231 */   // Label 2613: @134231
     /* 134231 */   GIM_Reject,
     /* 134232 */ // Label 2608: @134232
     /* 134232 */ GIM_Reject,
     /* 134233 */ // Label 2600: @134233
     /* 134233 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(134459),
     /* 134238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134248 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(134290), // Rule ID 7285 //
     /* 134253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134263 */     // MIs[0] Rn
     /* 134263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134275 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 134278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134288 */     GIR_RootConstrainSelectedInstOperands,
     /* 134289 */     // GIR_Coverage, 7285,
     /* 134289 */     GIR_EraseRootFromParent_Done,
     /* 134290 */   // Label 2615: @134290
     /* 134290 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(134332), // Rule ID 7286 //
     /* 134295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134305 */     // MIs[0] Rn
     /* 134305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134317 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 134320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134330 */     GIR_RootConstrainSelectedInstOperands,
     /* 134331 */     // GIR_Coverage, 7286,
     /* 134331 */     GIR_EraseRootFromParent_Done,
     /* 134332 */   // Label 2616: @134332
     /* 134332 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(134374), // Rule ID 7287 //
     /* 134337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134347 */     // MIs[0] Rn
     /* 134347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134359 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 134362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134372 */     GIR_RootConstrainSelectedInstOperands,
     /* 134373 */     // GIR_Coverage, 7287,
     /* 134373 */     GIR_EraseRootFromParent_Done,
     /* 134374 */   // Label 2617: @134374
     /* 134374 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(134416), // Rule ID 7288 //
     /* 134379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134389 */     // MIs[0] Rn
     /* 134389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134401 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 134404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134414 */     GIR_RootConstrainSelectedInstOperands,
     /* 134415 */     // GIR_Coverage, 7288,
     /* 134415 */     GIR_EraseRootFromParent_Done,
     /* 134416 */   // Label 2618: @134416
     /* 134416 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(134458), // Rule ID 7289 //
     /* 134421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134431 */     // MIs[0] Rn
     /* 134431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134443 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 134446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134456 */     GIR_RootConstrainSelectedInstOperands,
     /* 134457 */     // GIR_Coverage, 7289,
     /* 134457 */     GIR_EraseRootFromParent_Done,
     /* 134458 */   // Label 2619: @134458
     /* 134458 */   GIM_Reject,
     /* 134459 */ // Label 2614: @134459
     /* 134459 */ GIM_Reject,
     /* 134460 */ // Label 2601: @134460
     /* 134460 */ GIM_Reject,
     /* 134461 */ // Label 32: @134461
     /* 134461 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2623*/ GIMT_Encode4(135165),
     /* 134472 */ /*GILLT_s16*//*Label 2620*/ GIMT_Encode4(134484),
     /* 134476 */ /*GILLT_s32*//*Label 2621*/ GIMT_Encode4(134711),
     /* 134480 */ /*GILLT_s64*//*Label 2622*/ GIMT_Encode4(134938),
     /* 134484 */ // Label 2620: @134484
     /* 134484 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(134710),
     /* 134489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134499 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(134541), // Rule ID 7290 //
     /* 134504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134514 */     // MIs[0] Rn
     /* 134514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134526 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 134529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134539 */     GIR_RootConstrainSelectedInstOperands,
     /* 134540 */     // GIR_Coverage, 7290,
     /* 134540 */     GIR_EraseRootFromParent_Done,
     /* 134541 */   // Label 2625: @134541
     /* 134541 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(134583), // Rule ID 7291 //
     /* 134546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134556 */     // MIs[0] Rn
     /* 134556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134568 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 134571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134581 */     GIR_RootConstrainSelectedInstOperands,
     /* 134582 */     // GIR_Coverage, 7291,
     /* 134582 */     GIR_EraseRootFromParent_Done,
     /* 134583 */   // Label 2626: @134583
     /* 134583 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(134625), // Rule ID 7292 //
     /* 134588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134598 */     // MIs[0] Rn
     /* 134598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134610 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 134613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134623 */     GIR_RootConstrainSelectedInstOperands,
     /* 134624 */     // GIR_Coverage, 7292,
     /* 134624 */     GIR_EraseRootFromParent_Done,
     /* 134625 */   // Label 2627: @134625
     /* 134625 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(134667), // Rule ID 7293 //
     /* 134630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134640 */     // MIs[0] Rn
     /* 134640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134652 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 134655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134665 */     GIR_RootConstrainSelectedInstOperands,
     /* 134666 */     // GIR_Coverage, 7293,
     /* 134666 */     GIR_EraseRootFromParent_Done,
     /* 134667 */   // Label 2628: @134667
     /* 134667 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(134709), // Rule ID 7294 //
     /* 134672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134682 */     // MIs[0] Rn
     /* 134682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134694 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 134697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134707 */     GIR_RootConstrainSelectedInstOperands,
     /* 134708 */     // GIR_Coverage, 7294,
     /* 134708 */     GIR_EraseRootFromParent_Done,
     /* 134709 */   // Label 2629: @134709
     /* 134709 */   GIM_Reject,
     /* 134710 */ // Label 2624: @134710
     /* 134710 */ GIM_Reject,
     /* 134711 */ // Label 2621: @134711
     /* 134711 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(134937),
     /* 134716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134719 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134726 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(134768), // Rule ID 7295 //
     /* 134731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134741 */     // MIs[0] Rn
     /* 134741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134753 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 134756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134766 */     GIR_RootConstrainSelectedInstOperands,
     /* 134767 */     // GIR_Coverage, 7295,
     /* 134767 */     GIR_EraseRootFromParent_Done,
     /* 134768 */   // Label 2631: @134768
     /* 134768 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(134810), // Rule ID 7296 //
     /* 134773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134783 */     // MIs[0] Rn
     /* 134783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134795 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 134798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134808 */     GIR_RootConstrainSelectedInstOperands,
     /* 134809 */     // GIR_Coverage, 7296,
     /* 134809 */     GIR_EraseRootFromParent_Done,
     /* 134810 */   // Label 2632: @134810
     /* 134810 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(134852), // Rule ID 7297 //
     /* 134815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134825 */     // MIs[0] Rn
     /* 134825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134837 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 134840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134850 */     GIR_RootConstrainSelectedInstOperands,
     /* 134851 */     // GIR_Coverage, 7297,
     /* 134851 */     GIR_EraseRootFromParent_Done,
     /* 134852 */   // Label 2633: @134852
     /* 134852 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(134894), // Rule ID 7298 //
     /* 134857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134867 */     // MIs[0] Rn
     /* 134867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134879 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 134882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134892 */     GIR_RootConstrainSelectedInstOperands,
     /* 134893 */     // GIR_Coverage, 7298,
     /* 134893 */     GIR_EraseRootFromParent_Done,
     /* 134894 */   // Label 2634: @134894
     /* 134894 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(134936), // Rule ID 7299 //
     /* 134899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134909 */     // MIs[0] Rn
     /* 134909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134921 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 134924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134934 */     GIR_RootConstrainSelectedInstOperands,
     /* 134935 */     // GIR_Coverage, 7299,
     /* 134935 */     GIR_EraseRootFromParent_Done,
     /* 134936 */   // Label 2635: @134936
     /* 134936 */   GIM_Reject,
     /* 134937 */ // Label 2630: @134937
     /* 134937 */ GIM_Reject,
     /* 134938 */ // Label 2622: @134938
     /* 134938 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(135164),
     /* 134943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134946 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134953 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(134995), // Rule ID 7300 //
     /* 134958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 134961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134968 */     // MIs[0] Rn
     /* 134968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134980 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 134980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 134983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134993 */     GIR_RootConstrainSelectedInstOperands,
     /* 134994 */     // GIR_Coverage, 7300,
     /* 134994 */     GIR_EraseRootFromParent_Done,
     /* 134995 */   // Label 2637: @134995
     /* 134995 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(135037), // Rule ID 7301 //
     /* 135000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135010 */     // MIs[0] Rn
     /* 135010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135022 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 135025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135035 */     GIR_RootConstrainSelectedInstOperands,
     /* 135036 */     // GIR_Coverage, 7301,
     /* 135036 */     GIR_EraseRootFromParent_Done,
     /* 135037 */   // Label 2638: @135037
     /* 135037 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(135079), // Rule ID 7302 //
     /* 135042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135052 */     // MIs[0] Rn
     /* 135052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135064 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 135067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135077 */     GIR_RootConstrainSelectedInstOperands,
     /* 135078 */     // GIR_Coverage, 7302,
     /* 135078 */     GIR_EraseRootFromParent_Done,
     /* 135079 */   // Label 2639: @135079
     /* 135079 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(135121), // Rule ID 7303 //
     /* 135084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135094 */     // MIs[0] Rn
     /* 135094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135106 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 135109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135119 */     GIR_RootConstrainSelectedInstOperands,
     /* 135120 */     // GIR_Coverage, 7303,
     /* 135120 */     GIR_EraseRootFromParent_Done,
     /* 135121 */   // Label 2640: @135121
     /* 135121 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(135163), // Rule ID 7304 //
     /* 135126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135136 */     // MIs[0] Rn
     /* 135136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135148 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 135151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135161 */     GIR_RootConstrainSelectedInstOperands,
     /* 135162 */     // GIR_Coverage, 7304,
     /* 135162 */     GIR_EraseRootFromParent_Done,
     /* 135163 */   // Label 2641: @135163
     /* 135163 */   GIM_Reject,
     /* 135164 */ // Label 2636: @135164
     /* 135164 */ GIM_Reject,
     /* 135165 */ // Label 2623: @135165
     /* 135165 */ GIM_Reject,
     /* 135166 */ // Label 33: @135166
     /* 135166 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2645*/ GIMT_Encode4(135870),
     /* 135177 */ /*GILLT_s16*//*Label 2642*/ GIMT_Encode4(135189),
     /* 135181 */ /*GILLT_s32*//*Label 2643*/ GIMT_Encode4(135416),
     /* 135185 */ /*GILLT_s64*//*Label 2644*/ GIMT_Encode4(135643),
     /* 135189 */ // Label 2642: @135189
     /* 135189 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(135415),
     /* 135194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135197 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135204 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(135246), // Rule ID 7305 //
     /* 135209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135219 */     // MIs[0] Rn
     /* 135219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135231 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 135234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135244 */     GIR_RootConstrainSelectedInstOperands,
     /* 135245 */     // GIR_Coverage, 7305,
     /* 135245 */     GIR_EraseRootFromParent_Done,
     /* 135246 */   // Label 2647: @135246
     /* 135246 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(135288), // Rule ID 7306 //
     /* 135251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135261 */     // MIs[0] Rn
     /* 135261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135273 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 135276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135286 */     GIR_RootConstrainSelectedInstOperands,
     /* 135287 */     // GIR_Coverage, 7306,
     /* 135287 */     GIR_EraseRootFromParent_Done,
     /* 135288 */   // Label 2648: @135288
     /* 135288 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(135330), // Rule ID 7307 //
     /* 135293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135303 */     // MIs[0] Rn
     /* 135303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135315 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 135318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135328 */     GIR_RootConstrainSelectedInstOperands,
     /* 135329 */     // GIR_Coverage, 7307,
     /* 135329 */     GIR_EraseRootFromParent_Done,
     /* 135330 */   // Label 2649: @135330
     /* 135330 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(135372), // Rule ID 7308 //
     /* 135335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135345 */     // MIs[0] Rn
     /* 135345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135357 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 135360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135370 */     GIR_RootConstrainSelectedInstOperands,
     /* 135371 */     // GIR_Coverage, 7308,
     /* 135371 */     GIR_EraseRootFromParent_Done,
     /* 135372 */   // Label 2650: @135372
     /* 135372 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(135414), // Rule ID 7309 //
     /* 135377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135387 */     // MIs[0] Rn
     /* 135387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135399 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 135402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135412 */     GIR_RootConstrainSelectedInstOperands,
     /* 135413 */     // GIR_Coverage, 7309,
     /* 135413 */     GIR_EraseRootFromParent_Done,
     /* 135414 */   // Label 2651: @135414
     /* 135414 */   GIM_Reject,
     /* 135415 */ // Label 2646: @135415
     /* 135415 */ GIM_Reject,
     /* 135416 */ // Label 2643: @135416
     /* 135416 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(135642),
     /* 135421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135424 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135431 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(135473), // Rule ID 7310 //
     /* 135436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135446 */     // MIs[0] Rn
     /* 135446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135458 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 135461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135471 */     GIR_RootConstrainSelectedInstOperands,
     /* 135472 */     // GIR_Coverage, 7310,
     /* 135472 */     GIR_EraseRootFromParent_Done,
     /* 135473 */   // Label 2653: @135473
     /* 135473 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(135515), // Rule ID 7311 //
     /* 135478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135488 */     // MIs[0] Rn
     /* 135488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135500 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 135503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135513 */     GIR_RootConstrainSelectedInstOperands,
     /* 135514 */     // GIR_Coverage, 7311,
     /* 135514 */     GIR_EraseRootFromParent_Done,
     /* 135515 */   // Label 2654: @135515
     /* 135515 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(135557), // Rule ID 7312 //
     /* 135520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135530 */     // MIs[0] Rn
     /* 135530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135542 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 135545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135555 */     GIR_RootConstrainSelectedInstOperands,
     /* 135556 */     // GIR_Coverage, 7312,
     /* 135556 */     GIR_EraseRootFromParent_Done,
     /* 135557 */   // Label 2655: @135557
     /* 135557 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(135599), // Rule ID 7313 //
     /* 135562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135572 */     // MIs[0] Rn
     /* 135572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135584 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 135587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135597 */     GIR_RootConstrainSelectedInstOperands,
     /* 135598 */     // GIR_Coverage, 7313,
     /* 135598 */     GIR_EraseRootFromParent_Done,
     /* 135599 */   // Label 2656: @135599
     /* 135599 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(135641), // Rule ID 7314 //
     /* 135604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135614 */     // MIs[0] Rn
     /* 135614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135626 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 135629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135639 */     GIR_RootConstrainSelectedInstOperands,
     /* 135640 */     // GIR_Coverage, 7314,
     /* 135640 */     GIR_EraseRootFromParent_Done,
     /* 135641 */   // Label 2657: @135641
     /* 135641 */   GIM_Reject,
     /* 135642 */ // Label 2652: @135642
     /* 135642 */ GIM_Reject,
     /* 135643 */ // Label 2644: @135643
     /* 135643 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(135869),
     /* 135648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135651 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135658 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(135700), // Rule ID 7315 //
     /* 135663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135673 */     // MIs[0] Rn
     /* 135673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135685 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 135688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135698 */     GIR_RootConstrainSelectedInstOperands,
     /* 135699 */     // GIR_Coverage, 7315,
     /* 135699 */     GIR_EraseRootFromParent_Done,
     /* 135700 */   // Label 2659: @135700
     /* 135700 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(135742), // Rule ID 7316 //
     /* 135705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135715 */     // MIs[0] Rn
     /* 135715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135727 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 135730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135740 */     GIR_RootConstrainSelectedInstOperands,
     /* 135741 */     // GIR_Coverage, 7316,
     /* 135741 */     GIR_EraseRootFromParent_Done,
     /* 135742 */   // Label 2660: @135742
     /* 135742 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(135784), // Rule ID 7317 //
     /* 135747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135757 */     // MIs[0] Rn
     /* 135757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135769 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 135772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135782 */     GIR_RootConstrainSelectedInstOperands,
     /* 135783 */     // GIR_Coverage, 7317,
     /* 135783 */     GIR_EraseRootFromParent_Done,
     /* 135784 */   // Label 2661: @135784
     /* 135784 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(135826), // Rule ID 7318 //
     /* 135789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135799 */     // MIs[0] Rn
     /* 135799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135811 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 135814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135824 */     GIR_RootConstrainSelectedInstOperands,
     /* 135825 */     // GIR_Coverage, 7318,
     /* 135825 */     GIR_EraseRootFromParent_Done,
     /* 135826 */   // Label 2662: @135826
     /* 135826 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(135868), // Rule ID 7319 //
     /* 135831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 135834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135841 */     // MIs[0] Rn
     /* 135841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135853 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 135853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 135856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135866 */     GIR_RootConstrainSelectedInstOperands,
     /* 135867 */     // GIR_Coverage, 7319,
     /* 135867 */     GIR_EraseRootFromParent_Done,
     /* 135868 */   // Label 2663: @135868
     /* 135868 */   GIM_Reject,
     /* 135869 */ // Label 2658: @135869
     /* 135869 */ GIM_Reject,
     /* 135870 */ // Label 2645: @135870
     /* 135870 */ GIM_Reject,
     /* 135871 */ // Label 34: @135871
     /* 135871 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(135898), // Rule ID 6937 //
     /* 135876 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135879 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 135883 */   // MIs[0] Operand 1
     /* 135883 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 135886 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 135886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 135889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 135892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135896 */   GIR_RootConstrainSelectedInstOperands,
     /* 135897 */   // GIR_Coverage, 6937,
     /* 135897 */   GIR_EraseRootFromParent_Done,
     /* 135898 */ // Label 2664: @135898
     /* 135898 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(135921), // Rule ID 6938 //
     /* 135903 */   // MIs[0] Operand 0
     /* 135903 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 135906 */   // MIs[0] Operand 1
     /* 135906 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 135909 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 135909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 135912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 135915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135919 */   GIR_RootConstrainSelectedInstOperands,
     /* 135920 */   // GIR_Coverage, 6938,
     /* 135920 */   GIR_EraseRootFromParent_Done,
     /* 135921 */ // Label 2665: @135921
     /* 135921 */ GIM_Reject,
     /* 135922 */ // Label 35: @135922
     /* 135922 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(148449),
     /* 135927 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 135930 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(136021), // Rule ID 6416 //
     /* 135935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 135938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 135943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 135946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 135949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 135961 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 135964 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 135969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 135973 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 135977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135989 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 135989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 135992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 135996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 136005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 136009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 136014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136019 */     GIR_RootConstrainSelectedInstOperands,
     /* 136020 */     // GIR_Coverage, 6416,
     /* 136020 */     GIR_EraseRootFromParent_Done,
     /* 136021 */   // Label 2667: @136021
     /* 136021 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(136112), // Rule ID 6417 //
     /* 136026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 136029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 136034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 136037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 136040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 136048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 136052 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 136055 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 136060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 136064 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 136068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136080 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 136080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 136083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 136087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 136096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 136100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 136105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136110 */     GIR_RootConstrainSelectedInstOperands,
     /* 136111 */     // GIR_Coverage, 6417,
     /* 136111 */     GIR_EraseRootFromParent_Done,
     /* 136112 */   // Label 2668: @136112
     /* 136112 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(136173), // Rule ID 4849 //
     /* 136117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 136122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 136136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 136140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 136144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136149 */     // MIs[1] Operand 2
     /* 136149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 136160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136162 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 136162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 136165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 136171 */     GIR_RootConstrainSelectedInstOperands,
     /* 136172 */     // GIR_Coverage, 4849,
     /* 136172 */     GIR_EraseRootFromParent_Done,
     /* 136173 */   // Label 2669: @136173
     /* 136173 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(136213), // Rule ID 2642 //
     /* 136178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 136181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 136186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136193 */     // MIs[0] pattern
     /* 136193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 136196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 136201 */     // (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 136201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 136204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136206 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 136208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 136211 */     GIR_RootConstrainSelectedInstOperands,
     /* 136212 */     // GIR_Coverage, 2642,
     /* 136212 */     GIR_EraseRootFromParent_Done,
     /* 136213 */   // Label 2670: @136213
     /* 136213 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(136253), // Rule ID 9822 //
     /* 136218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 136221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 136226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136233 */     // MIs[0] pattern
     /* 136233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 136236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 136241 */     // (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 136241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 136244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136246 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 136248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 136251 */     GIR_RootConstrainSelectedInstOperands,
     /* 136252 */     // GIR_Coverage, 9822,
     /* 136252 */     GIR_EraseRootFromParent_Done,
     /* 136253 */   // Label 2671: @136253
     /* 136253 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(136293), // Rule ID 9825 //
     /* 136258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 136261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 136266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136273 */     // MIs[0] pattern
     /* 136273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 136276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 136281 */     // (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 136281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 136284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136286 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 136288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 136291 */     GIR_RootConstrainSelectedInstOperands,
     /* 136292 */     // GIR_Coverage, 9825,
     /* 136292 */     GIR_EraseRootFromParent_Done,
     /* 136293 */   // Label 2672: @136293
     /* 136293 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(136333), // Rule ID 9828 //
     /* 136298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 136301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 136306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136313 */     // MIs[0] pattern
     /* 136313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 136316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 136321 */     // (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 136321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 136324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136326 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 136328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 136331 */     GIR_RootConstrainSelectedInstOperands,
     /* 136332 */     // GIR_Coverage, 9828,
     /* 136332 */     GIR_EraseRootFromParent_Done,
     /* 136333 */   // Label 2673: @136333
     /* 136333 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(136372), // Rule ID 66 //
     /* 136338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 136341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 136346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136360 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 136360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 136363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 136370 */     GIR_RootConstrainSelectedInstOperands,
     /* 136371 */     // GIR_Coverage, 66,
     /* 136371 */     GIR_EraseRootFromParent_Done,
     /* 136372 */   // Label 2674: @136372
     /* 136372 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(136408), // Rule ID 346 //
     /* 136377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 136380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 136391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136399 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 136399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 136402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136406 */     GIR_RootConstrainSelectedInstOperands,
     /* 136407 */     // GIR_Coverage, 346,
     /* 136407 */     GIR_EraseRootFromParent_Done,
     /* 136408 */   // Label 2675: @136408
     /* 136408 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(136444), // Rule ID 347 //
     /* 136413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 136416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 136427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136435 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 136435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 136438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136442 */     GIR_RootConstrainSelectedInstOperands,
     /* 136443 */     // GIR_Coverage, 347,
     /* 136443 */     GIR_EraseRootFromParent_Done,
     /* 136444 */   // Label 2676: @136444
     /* 136444 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(136480), // Rule ID 348 //
     /* 136449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136471 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 136471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 136474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136478 */     GIR_RootConstrainSelectedInstOperands,
     /* 136479 */     // GIR_Coverage, 348,
     /* 136479 */     GIR_EraseRootFromParent_Done,
     /* 136480 */   // Label 2677: @136480
     /* 136480 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(136516), // Rule ID 349 //
     /* 136485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136507 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 136507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 136510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136514 */     GIR_RootConstrainSelectedInstOperands,
     /* 136515 */     // GIR_Coverage, 349,
     /* 136515 */     GIR_EraseRootFromParent_Done,
     /* 136516 */   // Label 2678: @136516
     /* 136516 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(136552), // Rule ID 350 //
     /* 136521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136543 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 136543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 136546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136550 */     GIR_RootConstrainSelectedInstOperands,
     /* 136551 */     // GIR_Coverage, 350,
     /* 136551 */     GIR_EraseRootFromParent_Done,
     /* 136552 */   // Label 2679: @136552
     /* 136552 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(136588), // Rule ID 351 //
     /* 136557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136579 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 136579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 136582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136586 */     GIR_RootConstrainSelectedInstOperands,
     /* 136587 */     // GIR_Coverage, 351,
     /* 136587 */     GIR_EraseRootFromParent_Done,
     /* 136588 */   // Label 2680: @136588
     /* 136588 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(136624), // Rule ID 352 //
     /* 136593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 136596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 136607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136615 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 136615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 136618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136622 */     GIR_RootConstrainSelectedInstOperands,
     /* 136623 */     // GIR_Coverage, 352,
     /* 136623 */     GIR_EraseRootFromParent_Done,
     /* 136624 */   // Label 2681: @136624
     /* 136624 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(136660), // Rule ID 353 //
     /* 136629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 136632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 136643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136651 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 136651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 136654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136658 */     GIR_RootConstrainSelectedInstOperands,
     /* 136659 */     // GIR_Coverage, 353,
     /* 136659 */     GIR_EraseRootFromParent_Done,
     /* 136660 */   // Label 2682: @136660
     /* 136660 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(136696), // Rule ID 354 //
     /* 136665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136687 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 136687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 136690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136694 */     GIR_RootConstrainSelectedInstOperands,
     /* 136695 */     // GIR_Coverage, 354,
     /* 136695 */     GIR_EraseRootFromParent_Done,
     /* 136696 */   // Label 2683: @136696
     /* 136696 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(136732), // Rule ID 355 //
     /* 136701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136723 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 136723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 136726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136730 */     GIR_RootConstrainSelectedInstOperands,
     /* 136731 */     // GIR_Coverage, 355,
     /* 136731 */     GIR_EraseRootFromParent_Done,
     /* 136732 */   // Label 2684: @136732
     /* 136732 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(136768), // Rule ID 356 //
     /* 136737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136759 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 136759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 136762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136766 */     GIR_RootConstrainSelectedInstOperands,
     /* 136767 */     // GIR_Coverage, 356,
     /* 136767 */     GIR_EraseRootFromParent_Done,
     /* 136768 */   // Label 2685: @136768
     /* 136768 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(136804), // Rule ID 357 //
     /* 136773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136795 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 136795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 136798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136802 */     GIR_RootConstrainSelectedInstOperands,
     /* 136803 */     // GIR_Coverage, 357,
     /* 136803 */     GIR_EraseRootFromParent_Done,
     /* 136804 */   // Label 2686: @136804
     /* 136804 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(136840), // Rule ID 358 //
     /* 136809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 136812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 136823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136831 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 136831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 136834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136838 */     GIR_RootConstrainSelectedInstOperands,
     /* 136839 */     // GIR_Coverage, 358,
     /* 136839 */     GIR_EraseRootFromParent_Done,
     /* 136840 */   // Label 2687: @136840
     /* 136840 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(136876), // Rule ID 359 //
     /* 136845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 136848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 136859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136867 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 136867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 136870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136874 */     GIR_RootConstrainSelectedInstOperands,
     /* 136875 */     // GIR_Coverage, 359,
     /* 136875 */     GIR_EraseRootFromParent_Done,
     /* 136876 */   // Label 2688: @136876
     /* 136876 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(136912), // Rule ID 360 //
     /* 136881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136903 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 136903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 136906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136910 */     GIR_RootConstrainSelectedInstOperands,
     /* 136911 */     // GIR_Coverage, 360,
     /* 136911 */     GIR_EraseRootFromParent_Done,
     /* 136912 */   // Label 2689: @136912
     /* 136912 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(136948), // Rule ID 361 //
     /* 136917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136939 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 136939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 136942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136946 */     GIR_RootConstrainSelectedInstOperands,
     /* 136947 */     // GIR_Coverage, 361,
     /* 136947 */     GIR_EraseRootFromParent_Done,
     /* 136948 */   // Label 2690: @136948
     /* 136948 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(136984), // Rule ID 362 //
     /* 136953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136975 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 136975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 136978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136982 */     GIR_RootConstrainSelectedInstOperands,
     /* 136983 */     // GIR_Coverage, 362,
     /* 136983 */     GIR_EraseRootFromParent_Done,
     /* 136984 */   // Label 2691: @136984
     /* 136984 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(137020), // Rule ID 363 //
     /* 136989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137011 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 137011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 137014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137018 */     GIR_RootConstrainSelectedInstOperands,
     /* 137019 */     // GIR_Coverage, 363,
     /* 137019 */     GIR_EraseRootFromParent_Done,
     /* 137020 */   // Label 2692: @137020
     /* 137020 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(137056), // Rule ID 364 //
     /* 137025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137047 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 137047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 137050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137054 */     GIR_RootConstrainSelectedInstOperands,
     /* 137055 */     // GIR_Coverage, 364,
     /* 137055 */     GIR_EraseRootFromParent_Done,
     /* 137056 */   // Label 2693: @137056
     /* 137056 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(137092), // Rule ID 365 //
     /* 137061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137083 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 137083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 137086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137090 */     GIR_RootConstrainSelectedInstOperands,
     /* 137091 */     // GIR_Coverage, 365,
     /* 137091 */     GIR_EraseRootFromParent_Done,
     /* 137092 */   // Label 2694: @137092
     /* 137092 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(137128), // Rule ID 366 //
     /* 137097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137119 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 137119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 137122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137126 */     GIR_RootConstrainSelectedInstOperands,
     /* 137127 */     // GIR_Coverage, 366,
     /* 137127 */     GIR_EraseRootFromParent_Done,
     /* 137128 */   // Label 2695: @137128
     /* 137128 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(137164), // Rule ID 367 //
     /* 137133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137155 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 137155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 137158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137162 */     GIR_RootConstrainSelectedInstOperands,
     /* 137163 */     // GIR_Coverage, 367,
     /* 137163 */     GIR_EraseRootFromParent_Done,
     /* 137164 */   // Label 2696: @137164
     /* 137164 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(137200), // Rule ID 368 //
     /* 137169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137191 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 137191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 137194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137198 */     GIR_RootConstrainSelectedInstOperands,
     /* 137199 */     // GIR_Coverage, 368,
     /* 137199 */     GIR_EraseRootFromParent_Done,
     /* 137200 */   // Label 2697: @137200
     /* 137200 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(137236), // Rule ID 369 //
     /* 137205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137227 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 137227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 137230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137234 */     GIR_RootConstrainSelectedInstOperands,
     /* 137235 */     // GIR_Coverage, 369,
     /* 137235 */     GIR_EraseRootFromParent_Done,
     /* 137236 */   // Label 2698: @137236
     /* 137236 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(137272), // Rule ID 370 //
     /* 137241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137263 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 137263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 137266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137270 */     GIR_RootConstrainSelectedInstOperands,
     /* 137271 */     // GIR_Coverage, 370,
     /* 137271 */     GIR_EraseRootFromParent_Done,
     /* 137272 */   // Label 2699: @137272
     /* 137272 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(137308), // Rule ID 371 //
     /* 137277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137299 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 137299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 137302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137306 */     GIR_RootConstrainSelectedInstOperands,
     /* 137307 */     // GIR_Coverage, 371,
     /* 137307 */     GIR_EraseRootFromParent_Done,
     /* 137308 */   // Label 2700: @137308
     /* 137308 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(137344), // Rule ID 372 //
     /* 137313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137335 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 137335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 137338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137342 */     GIR_RootConstrainSelectedInstOperands,
     /* 137343 */     // GIR_Coverage, 372,
     /* 137343 */     GIR_EraseRootFromParent_Done,
     /* 137344 */   // Label 2701: @137344
     /* 137344 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(137380), // Rule ID 373 //
     /* 137349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137371 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 137371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 137374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137378 */     GIR_RootConstrainSelectedInstOperands,
     /* 137379 */     // GIR_Coverage, 373,
     /* 137379 */     GIR_EraseRootFromParent_Done,
     /* 137380 */   // Label 2702: @137380
     /* 137380 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(137416), // Rule ID 374 //
     /* 137385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137407 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 137407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 137410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137414 */     GIR_RootConstrainSelectedInstOperands,
     /* 137415 */     // GIR_Coverage, 374,
     /* 137415 */     GIR_EraseRootFromParent_Done,
     /* 137416 */   // Label 2703: @137416
     /* 137416 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(137452), // Rule ID 375 //
     /* 137421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137443 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 137443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 137446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137450 */     GIR_RootConstrainSelectedInstOperands,
     /* 137451 */     // GIR_Coverage, 375,
     /* 137451 */     GIR_EraseRootFromParent_Done,
     /* 137452 */   // Label 2704: @137452
     /* 137452 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(137488), // Rule ID 376 //
     /* 137457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137479 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 137479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 137482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137486 */     GIR_RootConstrainSelectedInstOperands,
     /* 137487 */     // GIR_Coverage, 376,
     /* 137487 */     GIR_EraseRootFromParent_Done,
     /* 137488 */   // Label 2705: @137488
     /* 137488 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(137524), // Rule ID 377 //
     /* 137493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137515 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 137515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 137518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137522 */     GIR_RootConstrainSelectedInstOperands,
     /* 137523 */     // GIR_Coverage, 377,
     /* 137523 */     GIR_EraseRootFromParent_Done,
     /* 137524 */   // Label 2706: @137524
     /* 137524 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(137560), // Rule ID 378 //
     /* 137529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137551 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 137551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 137554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137558 */     GIR_RootConstrainSelectedInstOperands,
     /* 137559 */     // GIR_Coverage, 378,
     /* 137559 */     GIR_EraseRootFromParent_Done,
     /* 137560 */   // Label 2707: @137560
     /* 137560 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(137596), // Rule ID 379 //
     /* 137565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137587 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 137587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 137590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137594 */     GIR_RootConstrainSelectedInstOperands,
     /* 137595 */     // GIR_Coverage, 379,
     /* 137595 */     GIR_EraseRootFromParent_Done,
     /* 137596 */   // Label 2708: @137596
     /* 137596 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(137632), // Rule ID 380 //
     /* 137601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137623 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 137623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 137626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137630 */     GIR_RootConstrainSelectedInstOperands,
     /* 137631 */     // GIR_Coverage, 380,
     /* 137631 */     GIR_EraseRootFromParent_Done,
     /* 137632 */   // Label 2709: @137632
     /* 137632 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(137668), // Rule ID 381 //
     /* 137637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137659 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 137659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 137662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137666 */     GIR_RootConstrainSelectedInstOperands,
     /* 137667 */     // GIR_Coverage, 381,
     /* 137667 */     GIR_EraseRootFromParent_Done,
     /* 137668 */   // Label 2710: @137668
     /* 137668 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(137704), // Rule ID 382 //
     /* 137673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137695 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 137695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 137698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137702 */     GIR_RootConstrainSelectedInstOperands,
     /* 137703 */     // GIR_Coverage, 382,
     /* 137703 */     GIR_EraseRootFromParent_Done,
     /* 137704 */   // Label 2711: @137704
     /* 137704 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(137740), // Rule ID 383 //
     /* 137709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137731 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 137731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 137734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137738 */     GIR_RootConstrainSelectedInstOperands,
     /* 137739 */     // GIR_Coverage, 383,
     /* 137739 */     GIR_EraseRootFromParent_Done,
     /* 137740 */   // Label 2712: @137740
     /* 137740 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(137776), // Rule ID 384 //
     /* 137745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137767 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 137767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 137770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137774 */     GIR_RootConstrainSelectedInstOperands,
     /* 137775 */     // GIR_Coverage, 384,
     /* 137775 */     GIR_EraseRootFromParent_Done,
     /* 137776 */   // Label 2713: @137776
     /* 137776 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(137812), // Rule ID 385 //
     /* 137781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137803 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 137803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 137806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137810 */     GIR_RootConstrainSelectedInstOperands,
     /* 137811 */     // GIR_Coverage, 385,
     /* 137811 */     GIR_EraseRootFromParent_Done,
     /* 137812 */   // Label 2714: @137812
     /* 137812 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(137848), // Rule ID 386 //
     /* 137817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137839 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 137839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 137842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137846 */     GIR_RootConstrainSelectedInstOperands,
     /* 137847 */     // GIR_Coverage, 386,
     /* 137847 */     GIR_EraseRootFromParent_Done,
     /* 137848 */   // Label 2715: @137848
     /* 137848 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(137884), // Rule ID 387 //
     /* 137853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137875 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 137875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 137878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137882 */     GIR_RootConstrainSelectedInstOperands,
     /* 137883 */     // GIR_Coverage, 387,
     /* 137883 */     GIR_EraseRootFromParent_Done,
     /* 137884 */   // Label 2716: @137884
     /* 137884 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(137920), // Rule ID 388 //
     /* 137889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137911 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 137911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 137914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137918 */     GIR_RootConstrainSelectedInstOperands,
     /* 137919 */     // GIR_Coverage, 388,
     /* 137919 */     GIR_EraseRootFromParent_Done,
     /* 137920 */   // Label 2717: @137920
     /* 137920 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(137956), // Rule ID 389 //
     /* 137925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 137928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 137936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137947 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 137947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 137950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137954 */     GIR_RootConstrainSelectedInstOperands,
     /* 137955 */     // GIR_Coverage, 389,
     /* 137955 */     GIR_EraseRootFromParent_Done,
     /* 137956 */   // Label 2718: @137956
     /* 137956 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(137992), // Rule ID 390 //
     /* 137961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 137972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137983 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 137983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 137986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137990 */     GIR_RootConstrainSelectedInstOperands,
     /* 137991 */     // GIR_Coverage, 390,
     /* 137991 */     GIR_EraseRootFromParent_Done,
     /* 137992 */   // Label 2719: @137992
     /* 137992 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(138028), // Rule ID 391 //
     /* 137997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 138005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138019 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 138019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 138022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138026 */     GIR_RootConstrainSelectedInstOperands,
     /* 138027 */     // GIR_Coverage, 391,
     /* 138027 */     GIR_EraseRootFromParent_Done,
     /* 138028 */   // Label 2720: @138028
     /* 138028 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(138064), // Rule ID 392 //
     /* 138033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 138041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 138044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138055 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 138055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 138058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138062 */     GIR_RootConstrainSelectedInstOperands,
     /* 138063 */     // GIR_Coverage, 392,
     /* 138063 */     GIR_EraseRootFromParent_Done,
     /* 138064 */   // Label 2721: @138064
     /* 138064 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(138100), // Rule ID 393 //
     /* 138069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 138077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138091 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 138091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 138094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138098 */     GIR_RootConstrainSelectedInstOperands,
     /* 138099 */     // GIR_Coverage, 393,
     /* 138099 */     GIR_EraseRootFromParent_Done,
     /* 138100 */   // Label 2722: @138100
     /* 138100 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(138136), // Rule ID 575 //
     /* 138105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 138113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 138116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138127 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 138127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 138130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138134 */     GIR_RootConstrainSelectedInstOperands,
     /* 138135 */     // GIR_Coverage, 575,
     /* 138135 */     GIR_EraseRootFromParent_Done,
     /* 138136 */   // Label 2723: @138136
     /* 138136 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(138172), // Rule ID 576 //
     /* 138141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 138149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138163 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 138163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 138166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138170 */     GIR_RootConstrainSelectedInstOperands,
     /* 138171 */     // GIR_Coverage, 576,
     /* 138171 */     GIR_EraseRootFromParent_Done,
     /* 138172 */   // Label 2724: @138172
     /* 138172 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(138208), // Rule ID 577 //
     /* 138177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 138185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 138188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138199 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 138199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 138202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138206 */     GIR_RootConstrainSelectedInstOperands,
     /* 138207 */     // GIR_Coverage, 577,
     /* 138207 */     GIR_EraseRootFromParent_Done,
     /* 138208 */   // Label 2725: @138208
     /* 138208 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(138244), // Rule ID 578 //
     /* 138213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 138221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138235 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 138235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 138238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138242 */     GIR_RootConstrainSelectedInstOperands,
     /* 138243 */     // GIR_Coverage, 578,
     /* 138243 */     GIR_EraseRootFromParent_Done,
     /* 138244 */   // Label 2726: @138244
     /* 138244 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(138280), // Rule ID 579 //
     /* 138249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 138257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 138260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138271 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 138271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 138274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138278 */     GIR_RootConstrainSelectedInstOperands,
     /* 138279 */     // GIR_Coverage, 579,
     /* 138279 */     GIR_EraseRootFromParent_Done,
     /* 138280 */   // Label 2727: @138280
     /* 138280 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(138316), // Rule ID 580 //
     /* 138285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 138293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138307 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 138307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 138310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138314 */     GIR_RootConstrainSelectedInstOperands,
     /* 138315 */     // GIR_Coverage, 580,
     /* 138315 */     GIR_EraseRootFromParent_Done,
     /* 138316 */   // Label 2728: @138316
     /* 138316 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(138352), // Rule ID 581 //
     /* 138321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 138329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 138332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138343 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 138343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 138346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138350 */     GIR_RootConstrainSelectedInstOperands,
     /* 138351 */     // GIR_Coverage, 581,
     /* 138351 */     GIR_EraseRootFromParent_Done,
     /* 138352 */   // Label 2729: @138352
     /* 138352 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(138388), // Rule ID 582 //
     /* 138357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 138365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138379 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 138379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 138382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138386 */     GIR_RootConstrainSelectedInstOperands,
     /* 138387 */     // GIR_Coverage, 582,
     /* 138387 */     GIR_EraseRootFromParent_Done,
     /* 138388 */   // Label 2730: @138388
     /* 138388 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(138424), // Rule ID 710 //
     /* 138393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 138401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 138404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138415 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 138415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 138418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138422 */     GIR_RootConstrainSelectedInstOperands,
     /* 138423 */     // GIR_Coverage, 710,
     /* 138423 */     GIR_EraseRootFromParent_Done,
     /* 138424 */   // Label 2731: @138424
     /* 138424 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(138460), // Rule ID 711 //
     /* 138429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 138437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 138440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138451 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 138451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 138454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138458 */     GIR_RootConstrainSelectedInstOperands,
     /* 138459 */     // GIR_Coverage, 711,
     /* 138459 */     GIR_EraseRootFromParent_Done,
     /* 138460 */   // Label 2732: @138460
     /* 138460 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(138496), // Rule ID 712 //
     /* 138465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 138473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138487 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 138487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 138490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138494 */     GIR_RootConstrainSelectedInstOperands,
     /* 138495 */     // GIR_Coverage, 712,
     /* 138495 */     GIR_EraseRootFromParent_Done,
     /* 138496 */   // Label 2733: @138496
     /* 138496 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(138532), // Rule ID 713 //
     /* 138501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 138509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138523 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 138523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 138526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138530 */     GIR_RootConstrainSelectedInstOperands,
     /* 138531 */     // GIR_Coverage, 713,
     /* 138531 */     GIR_EraseRootFromParent_Done,
     /* 138532 */   // Label 2734: @138532
     /* 138532 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(138568), // Rule ID 714 //
     /* 138537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 138545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138559 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 138559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 138562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138566 */     GIR_RootConstrainSelectedInstOperands,
     /* 138567 */     // GIR_Coverage, 714,
     /* 138567 */     GIR_EraseRootFromParent_Done,
     /* 138568 */   // Label 2735: @138568
     /* 138568 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(138604), // Rule ID 715 //
     /* 138573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 138581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138595 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 138595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 138598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138602 */     GIR_RootConstrainSelectedInstOperands,
     /* 138603 */     // GIR_Coverage, 715,
     /* 138603 */     GIR_EraseRootFromParent_Done,
     /* 138604 */   // Label 2736: @138604
     /* 138604 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(138640), // Rule ID 789 //
     /* 138609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 138617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138631 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 138631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 138634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138638 */     GIR_RootConstrainSelectedInstOperands,
     /* 138639 */     // GIR_Coverage, 789,
     /* 138639 */     GIR_EraseRootFromParent_Done,
     /* 138640 */   // Label 2737: @138640
     /* 138640 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(138676), // Rule ID 790 //
     /* 138645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 138653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138667 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 138667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 138670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138674 */     GIR_RootConstrainSelectedInstOperands,
     /* 138675 */     // GIR_Coverage, 790,
     /* 138675 */     GIR_EraseRootFromParent_Done,
     /* 138676 */   // Label 2738: @138676
     /* 138676 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(138712), // Rule ID 791 //
     /* 138681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 138689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138703 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 138703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 138706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138710 */     GIR_RootConstrainSelectedInstOperands,
     /* 138711 */     // GIR_Coverage, 791,
     /* 138711 */     GIR_EraseRootFromParent_Done,
     /* 138712 */   // Label 2739: @138712
     /* 138712 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(138748), // Rule ID 792 //
     /* 138717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 138725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138739 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 138739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 138742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138746 */     GIR_RootConstrainSelectedInstOperands,
     /* 138747 */     // GIR_Coverage, 792,
     /* 138747 */     GIR_EraseRootFromParent_Done,
     /* 138748 */   // Label 2740: @138748
     /* 138748 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(138784), // Rule ID 793 //
     /* 138753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 138761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138775 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 138775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 138778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138782 */     GIR_RootConstrainSelectedInstOperands,
     /* 138783 */     // GIR_Coverage, 793,
     /* 138783 */     GIR_EraseRootFromParent_Done,
     /* 138784 */   // Label 2741: @138784
     /* 138784 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(138820), // Rule ID 794 //
     /* 138789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 138797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138811 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 138811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 138814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138818 */     GIR_RootConstrainSelectedInstOperands,
     /* 138819 */     // GIR_Coverage, 794,
     /* 138819 */     GIR_EraseRootFromParent_Done,
     /* 138820 */   // Label 2742: @138820
     /* 138820 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(138856), // Rule ID 795 //
     /* 138825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 138833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138847 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 138847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 138850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138854 */     GIR_RootConstrainSelectedInstOperands,
     /* 138855 */     // GIR_Coverage, 795,
     /* 138855 */     GIR_EraseRootFromParent_Done,
     /* 138856 */   // Label 2743: @138856
     /* 138856 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(138892), // Rule ID 796 //
     /* 138861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 138869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138883 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 138883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 138886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138890 */     GIR_RootConstrainSelectedInstOperands,
     /* 138891 */     // GIR_Coverage, 796,
     /* 138891 */     GIR_EraseRootFromParent_Done,
     /* 138892 */   // Label 2744: @138892
     /* 138892 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(138928), // Rule ID 797 //
     /* 138897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 138905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138919 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 138919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 138922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138926 */     GIR_RootConstrainSelectedInstOperands,
     /* 138927 */     // GIR_Coverage, 797,
     /* 138927 */     GIR_EraseRootFromParent_Done,
     /* 138928 */   // Label 2745: @138928
     /* 138928 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(138964), // Rule ID 798 //
     /* 138933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 138941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138955 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 138955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 138958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138962 */     GIR_RootConstrainSelectedInstOperands,
     /* 138963 */     // GIR_Coverage, 798,
     /* 138963 */     GIR_EraseRootFromParent_Done,
     /* 138964 */   // Label 2746: @138964
     /* 138964 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(139000), // Rule ID 799 //
     /* 138969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 138977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138991 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 138991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 138994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138998 */     GIR_RootConstrainSelectedInstOperands,
     /* 138999 */     // GIR_Coverage, 799,
     /* 138999 */     GIR_EraseRootFromParent_Done,
     /* 139000 */   // Label 2747: @139000
     /* 139000 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(139036), // Rule ID 800 //
     /* 139005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139027 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 139027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 139030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139034 */     GIR_RootConstrainSelectedInstOperands,
     /* 139035 */     // GIR_Coverage, 800,
     /* 139035 */     GIR_EraseRootFromParent_Done,
     /* 139036 */   // Label 2748: @139036
     /* 139036 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(139072), // Rule ID 801 //
     /* 139041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139063 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 139063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 139066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139070 */     GIR_RootConstrainSelectedInstOperands,
     /* 139071 */     // GIR_Coverage, 801,
     /* 139071 */     GIR_EraseRootFromParent_Done,
     /* 139072 */   // Label 2749: @139072
     /* 139072 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(139108), // Rule ID 802 //
     /* 139077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139099 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 139099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 139102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139106 */     GIR_RootConstrainSelectedInstOperands,
     /* 139107 */     // GIR_Coverage, 802,
     /* 139107 */     GIR_EraseRootFromParent_Done,
     /* 139108 */   // Label 2750: @139108
     /* 139108 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(139144), // Rule ID 803 //
     /* 139113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139135 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 139135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 139138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139142 */     GIR_RootConstrainSelectedInstOperands,
     /* 139143 */     // GIR_Coverage, 803,
     /* 139143 */     GIR_EraseRootFromParent_Done,
     /* 139144 */   // Label 2751: @139144
     /* 139144 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(139180), // Rule ID 804 //
     /* 139149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139171 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 139171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 139174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139178 */     GIR_RootConstrainSelectedInstOperands,
     /* 139179 */     // GIR_Coverage, 804,
     /* 139179 */     GIR_EraseRootFromParent_Done,
     /* 139180 */   // Label 2752: @139180
     /* 139180 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(139216), // Rule ID 805 //
     /* 139185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139207 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 139207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 139210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139214 */     GIR_RootConstrainSelectedInstOperands,
     /* 139215 */     // GIR_Coverage, 805,
     /* 139215 */     GIR_EraseRootFromParent_Done,
     /* 139216 */   // Label 2753: @139216
     /* 139216 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(139252), // Rule ID 806 //
     /* 139221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139243 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 139243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 139246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139250 */     GIR_RootConstrainSelectedInstOperands,
     /* 139251 */     // GIR_Coverage, 806,
     /* 139251 */     GIR_EraseRootFromParent_Done,
     /* 139252 */   // Label 2754: @139252
     /* 139252 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(139288), // Rule ID 807 //
     /* 139257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139279 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 139279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 139282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139286 */     GIR_RootConstrainSelectedInstOperands,
     /* 139287 */     // GIR_Coverage, 807,
     /* 139287 */     GIR_EraseRootFromParent_Done,
     /* 139288 */   // Label 2755: @139288
     /* 139288 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(139324), // Rule ID 808 //
     /* 139293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139315 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 139315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 139318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139322 */     GIR_RootConstrainSelectedInstOperands,
     /* 139323 */     // GIR_Coverage, 808,
     /* 139323 */     GIR_EraseRootFromParent_Done,
     /* 139324 */   // Label 2756: @139324
     /* 139324 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(139360), // Rule ID 809 //
     /* 139329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 139337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139351 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 139351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 139354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139358 */     GIR_RootConstrainSelectedInstOperands,
     /* 139359 */     // GIR_Coverage, 809,
     /* 139359 */     GIR_EraseRootFromParent_Done,
     /* 139360 */   // Label 2757: @139360
     /* 139360 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(139396), // Rule ID 810 //
     /* 139365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 139373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139387 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 139387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 139390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139394 */     GIR_RootConstrainSelectedInstOperands,
     /* 139395 */     // GIR_Coverage, 810,
     /* 139395 */     GIR_EraseRootFromParent_Done,
     /* 139396 */   // Label 2758: @139396
     /* 139396 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(139432), // Rule ID 811 //
     /* 139401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 139409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139423 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 139423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 139426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139430 */     GIR_RootConstrainSelectedInstOperands,
     /* 139431 */     // GIR_Coverage, 811,
     /* 139431 */     GIR_EraseRootFromParent_Done,
     /* 139432 */   // Label 2759: @139432
     /* 139432 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(139468), // Rule ID 812 //
     /* 139437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 139445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 139459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 139462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139466 */     GIR_RootConstrainSelectedInstOperands,
     /* 139467 */     // GIR_Coverage, 812,
     /* 139467 */     GIR_EraseRootFromParent_Done,
     /* 139468 */   // Label 2760: @139468
     /* 139468 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(139504), // Rule ID 813 //
     /* 139473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 139481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139495 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 139495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 139498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139502 */     GIR_RootConstrainSelectedInstOperands,
     /* 139503 */     // GIR_Coverage, 813,
     /* 139503 */     GIR_EraseRootFromParent_Done,
     /* 139504 */   // Label 2761: @139504
     /* 139504 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(139540), // Rule ID 814 //
     /* 139509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 139517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139531 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 139531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 139534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139538 */     GIR_RootConstrainSelectedInstOperands,
     /* 139539 */     // GIR_Coverage, 814,
     /* 139539 */     GIR_EraseRootFromParent_Done,
     /* 139540 */   // Label 2762: @139540
     /* 139540 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(139576), // Rule ID 815 //
     /* 139545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 139553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139567 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 139567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 139570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139574 */     GIR_RootConstrainSelectedInstOperands,
     /* 139575 */     // GIR_Coverage, 815,
     /* 139575 */     GIR_EraseRootFromParent_Done,
     /* 139576 */   // Label 2763: @139576
     /* 139576 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(139612), // Rule ID 816 //
     /* 139581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 139589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139603 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 139603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 139606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139610 */     GIR_RootConstrainSelectedInstOperands,
     /* 139611 */     // GIR_Coverage, 816,
     /* 139611 */     GIR_EraseRootFromParent_Done,
     /* 139612 */   // Label 2764: @139612
     /* 139612 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(139648), // Rule ID 817 //
     /* 139617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 139625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139639 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 139639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 139642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139646 */     GIR_RootConstrainSelectedInstOperands,
     /* 139647 */     // GIR_Coverage, 817,
     /* 139647 */     GIR_EraseRootFromParent_Done,
     /* 139648 */   // Label 2765: @139648
     /* 139648 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(139684), // Rule ID 818 //
     /* 139653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 139661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139675 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 139675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 139678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139682 */     GIR_RootConstrainSelectedInstOperands,
     /* 139683 */     // GIR_Coverage, 818,
     /* 139683 */     GIR_EraseRootFromParent_Done,
     /* 139684 */   // Label 2766: @139684
     /* 139684 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(139720), // Rule ID 819 //
     /* 139689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 139697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139711 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 139711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 139714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139718 */     GIR_RootConstrainSelectedInstOperands,
     /* 139719 */     // GIR_Coverage, 819,
     /* 139719 */     GIR_EraseRootFromParent_Done,
     /* 139720 */   // Label 2767: @139720
     /* 139720 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(139756), // Rule ID 820 //
     /* 139725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 139733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139747 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 139747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 139750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139754 */     GIR_RootConstrainSelectedInstOperands,
     /* 139755 */     // GIR_Coverage, 820,
     /* 139755 */     GIR_EraseRootFromParent_Done,
     /* 139756 */   // Label 2768: @139756
     /* 139756 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(139792), // Rule ID 821 //
     /* 139761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 139769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139783 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 139783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 139786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139790 */     GIR_RootConstrainSelectedInstOperands,
     /* 139791 */     // GIR_Coverage, 821,
     /* 139791 */     GIR_EraseRootFromParent_Done,
     /* 139792 */   // Label 2769: @139792
     /* 139792 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(139828), // Rule ID 822 //
     /* 139797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 139805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139819 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 139819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 139822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139826 */     GIR_RootConstrainSelectedInstOperands,
     /* 139827 */     // GIR_Coverage, 822,
     /* 139827 */     GIR_EraseRootFromParent_Done,
     /* 139828 */   // Label 2770: @139828
     /* 139828 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(139864), // Rule ID 823 //
     /* 139833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 139841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139855 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 139855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 139858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139862 */     GIR_RootConstrainSelectedInstOperands,
     /* 139863 */     // GIR_Coverage, 823,
     /* 139863 */     GIR_EraseRootFromParent_Done,
     /* 139864 */   // Label 2771: @139864
     /* 139864 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(139900), // Rule ID 824 //
     /* 139869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 139877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139891 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 139891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 139894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139898 */     GIR_RootConstrainSelectedInstOperands,
     /* 139899 */     // GIR_Coverage, 824,
     /* 139899 */     GIR_EraseRootFromParent_Done,
     /* 139900 */   // Label 2772: @139900
     /* 139900 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(139936), // Rule ID 825 //
     /* 139905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 139913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139927 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 139927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 139930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139934 */     GIR_RootConstrainSelectedInstOperands,
     /* 139935 */     // GIR_Coverage, 825,
     /* 139935 */     GIR_EraseRootFromParent_Done,
     /* 139936 */   // Label 2773: @139936
     /* 139936 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(139972), // Rule ID 826 //
     /* 139941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 139949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139963 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 139963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 139966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139970 */     GIR_RootConstrainSelectedInstOperands,
     /* 139971 */     // GIR_Coverage, 826,
     /* 139971 */     GIR_EraseRootFromParent_Done,
     /* 139972 */   // Label 2774: @139972
     /* 139972 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(140008), // Rule ID 827 //
     /* 139977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 139985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139999 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 139999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 140002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140006 */     GIR_RootConstrainSelectedInstOperands,
     /* 140007 */     // GIR_Coverage, 827,
     /* 140007 */     GIR_EraseRootFromParent_Done,
     /* 140008 */   // Label 2775: @140008
     /* 140008 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(140044), // Rule ID 828 //
     /* 140013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 140021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 140024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 140027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140035 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 140035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 140038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140042 */     GIR_RootConstrainSelectedInstOperands,
     /* 140043 */     // GIR_Coverage, 828,
     /* 140043 */     GIR_EraseRootFromParent_Done,
     /* 140044 */   // Label 2776: @140044
     /* 140044 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(140080), // Rule ID 829 //
     /* 140049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 140057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 140060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 140063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140071 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 140071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 140074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140078 */     GIR_RootConstrainSelectedInstOperands,
     /* 140079 */     // GIR_Coverage, 829,
     /* 140079 */     GIR_EraseRootFromParent_Done,
     /* 140080 */   // Label 2777: @140080
     /* 140080 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(140116), // Rule ID 856 //
     /* 140085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 140093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 140096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140107 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 140107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 140110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140114 */     GIR_RootConstrainSelectedInstOperands,
     /* 140115 */     // GIR_Coverage, 856,
     /* 140115 */     GIR_EraseRootFromParent_Done,
     /* 140116 */   // Label 2778: @140116
     /* 140116 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(140152), // Rule ID 857 //
     /* 140121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 140129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 140132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140143 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 140143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 140146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140150 */     GIR_RootConstrainSelectedInstOperands,
     /* 140151 */     // GIR_Coverage, 857,
     /* 140151 */     GIR_EraseRootFromParent_Done,
     /* 140152 */   // Label 2779: @140152
     /* 140152 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(140188), // Rule ID 858 //
     /* 140157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 140165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 140168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 140171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140179 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 140179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 140182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140186 */     GIR_RootConstrainSelectedInstOperands,
     /* 140187 */     // GIR_Coverage, 858,
     /* 140187 */     GIR_EraseRootFromParent_Done,
     /* 140188 */   // Label 2780: @140188
     /* 140188 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(140224), // Rule ID 859 //
     /* 140193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 140201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140215 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 140218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140222 */     GIR_RootConstrainSelectedInstOperands,
     /* 140223 */     // GIR_Coverage, 859,
     /* 140223 */     GIR_EraseRootFromParent_Done,
     /* 140224 */   // Label 2781: @140224
     /* 140224 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(140260), // Rule ID 860 //
     /* 140229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 140237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 140240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 140243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140251 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 140251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 140254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140258 */     GIR_RootConstrainSelectedInstOperands,
     /* 140259 */     // GIR_Coverage, 860,
     /* 140259 */     GIR_EraseRootFromParent_Done,
     /* 140260 */   // Label 2782: @140260
     /* 140260 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(140296), // Rule ID 931 //
     /* 140265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 140273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 140276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 140279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140287 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 140287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 140290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140294 */     GIR_RootConstrainSelectedInstOperands,
     /* 140295 */     // GIR_Coverage, 931,
     /* 140295 */     GIR_EraseRootFromParent_Done,
     /* 140296 */   // Label 2783: @140296
     /* 140296 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(140332), // Rule ID 932 //
     /* 140301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 140309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140323 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 140326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140330 */     GIR_RootConstrainSelectedInstOperands,
     /* 140331 */     // GIR_Coverage, 932,
     /* 140331 */     GIR_EraseRootFromParent_Done,
     /* 140332 */   // Label 2784: @140332
     /* 140332 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(140368), // Rule ID 933 //
     /* 140337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 140345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 140348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 140351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140359 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 140359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 140362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140366 */     GIR_RootConstrainSelectedInstOperands,
     /* 140367 */     // GIR_Coverage, 933,
     /* 140367 */     GIR_EraseRootFromParent_Done,
     /* 140368 */   // Label 2785: @140368
     /* 140368 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(140404), // Rule ID 934 //
     /* 140373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 140381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 140384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 140387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140395 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 140395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 140398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140402 */     GIR_RootConstrainSelectedInstOperands,
     /* 140403 */     // GIR_Coverage, 934,
     /* 140403 */     GIR_EraseRootFromParent_Done,
     /* 140404 */   // Label 2786: @140404
     /* 140404 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(140440), // Rule ID 935 //
     /* 140409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 140417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140431 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 140434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140438 */     GIR_RootConstrainSelectedInstOperands,
     /* 140439 */     // GIR_Coverage, 935,
     /* 140439 */     GIR_EraseRootFromParent_Done,
     /* 140440 */   // Label 2787: @140440
     /* 140440 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(140476), // Rule ID 936 //
     /* 140445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 140453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 140456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 140459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140467 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 140467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 140470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140474 */     GIR_RootConstrainSelectedInstOperands,
     /* 140475 */     // GIR_Coverage, 936,
     /* 140475 */     GIR_EraseRootFromParent_Done,
     /* 140476 */   // Label 2788: @140476
     /* 140476 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(140512), // Rule ID 937 //
     /* 140481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 140489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 140492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 140495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140503 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 140503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 140506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140510 */     GIR_RootConstrainSelectedInstOperands,
     /* 140511 */     // GIR_Coverage, 937,
     /* 140511 */     GIR_EraseRootFromParent_Done,
     /* 140512 */   // Label 2789: @140512
     /* 140512 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(140548), // Rule ID 938 //
     /* 140517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 140525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140539 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 140542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140546 */     GIR_RootConstrainSelectedInstOperands,
     /* 140547 */     // GIR_Coverage, 938,
     /* 140547 */     GIR_EraseRootFromParent_Done,
     /* 140548 */   // Label 2790: @140548
     /* 140548 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(140584), // Rule ID 939 //
     /* 140553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 140561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 140564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 140567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140575 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 140575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 140578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140582 */     GIR_RootConstrainSelectedInstOperands,
     /* 140583 */     // GIR_Coverage, 939,
     /* 140583 */     GIR_EraseRootFromParent_Done,
     /* 140584 */   // Label 2791: @140584
     /* 140584 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(140620), // Rule ID 940 //
     /* 140589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 140597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 140600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 140603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140611 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 140611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 140614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140618 */     GIR_RootConstrainSelectedInstOperands,
     /* 140619 */     // GIR_Coverage, 940,
     /* 140619 */     GIR_EraseRootFromParent_Done,
     /* 140620 */   // Label 2792: @140620
     /* 140620 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(140656), // Rule ID 941 //
     /* 140625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 140633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140647 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 140650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140654 */     GIR_RootConstrainSelectedInstOperands,
     /* 140655 */     // GIR_Coverage, 941,
     /* 140655 */     GIR_EraseRootFromParent_Done,
     /* 140656 */   // Label 2793: @140656
     /* 140656 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(140692), // Rule ID 942 //
     /* 140661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 140669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 140672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 140675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140683 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 140683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 140686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140690 */     GIR_RootConstrainSelectedInstOperands,
     /* 140691 */     // GIR_Coverage, 942,
     /* 140691 */     GIR_EraseRootFromParent_Done,
     /* 140692 */   // Label 2794: @140692
     /* 140692 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(140728), // Rule ID 943 //
     /* 140697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 140705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 140708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140719 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 140719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 140722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140726 */     GIR_RootConstrainSelectedInstOperands,
     /* 140727 */     // GIR_Coverage, 943,
     /* 140727 */     GIR_EraseRootFromParent_Done,
     /* 140728 */   // Label 2795: @140728
     /* 140728 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(140764), // Rule ID 944 //
     /* 140733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 140741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 140744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140755 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 140755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 140758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140762 */     GIR_RootConstrainSelectedInstOperands,
     /* 140763 */     // GIR_Coverage, 944,
     /* 140763 */     GIR_EraseRootFromParent_Done,
     /* 140764 */   // Label 2796: @140764
     /* 140764 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(140800), // Rule ID 945 //
     /* 140769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 140777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 140780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 140783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140791 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 140791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 140794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140798 */     GIR_RootConstrainSelectedInstOperands,
     /* 140799 */     // GIR_Coverage, 945,
     /* 140799 */     GIR_EraseRootFromParent_Done,
     /* 140800 */   // Label 2797: @140800
     /* 140800 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(140836), // Rule ID 946 //
     /* 140805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 140813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140827 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 140830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140834 */     GIR_RootConstrainSelectedInstOperands,
     /* 140835 */     // GIR_Coverage, 946,
     /* 140835 */     GIR_EraseRootFromParent_Done,
     /* 140836 */   // Label 2798: @140836
     /* 140836 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(140872), // Rule ID 947 //
     /* 140841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 140849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 140852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 140855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140863 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 140863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 140866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140870 */     GIR_RootConstrainSelectedInstOperands,
     /* 140871 */     // GIR_Coverage, 947,
     /* 140871 */     GIR_EraseRootFromParent_Done,
     /* 140872 */   // Label 2799: @140872
     /* 140872 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(140908), // Rule ID 994 //
     /* 140877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 140885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 140888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 140891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140899 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 140899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 140902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140906 */     GIR_RootConstrainSelectedInstOperands,
     /* 140907 */     // GIR_Coverage, 994,
     /* 140907 */     GIR_EraseRootFromParent_Done,
     /* 140908 */   // Label 2800: @140908
     /* 140908 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(140944), // Rule ID 996 //
     /* 140913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 140921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 140924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140935 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 140935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 140938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140942 */     GIR_RootConstrainSelectedInstOperands,
     /* 140943 */     // GIR_Coverage, 996,
     /* 140943 */     GIR_EraseRootFromParent_Done,
     /* 140944 */   // Label 2801: @140944
     /* 140944 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(140980), // Rule ID 998 //
     /* 140949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 140957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 140960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140971 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 140971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 140974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140978 */     GIR_RootConstrainSelectedInstOperands,
     /* 140979 */     // GIR_Coverage, 998,
     /* 140979 */     GIR_EraseRootFromParent_Done,
     /* 140980 */   // Label 2802: @140980
     /* 140980 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(141016), // Rule ID 1000 //
     /* 140985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 140993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141007 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 141007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 141010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141014 */     GIR_RootConstrainSelectedInstOperands,
     /* 141015 */     // GIR_Coverage, 1000,
     /* 141015 */     GIR_EraseRootFromParent_Done,
     /* 141016 */   // Label 2803: @141016
     /* 141016 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(141052), // Rule ID 1002 //
     /* 141021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 141029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141043 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 141043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 141046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141050 */     GIR_RootConstrainSelectedInstOperands,
     /* 141051 */     // GIR_Coverage, 1002,
     /* 141051 */     GIR_EraseRootFromParent_Done,
     /* 141052 */   // Label 2804: @141052
     /* 141052 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(141088), // Rule ID 1004 //
     /* 141057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 141065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 141068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141079 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 141079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 141082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141086 */     GIR_RootConstrainSelectedInstOperands,
     /* 141087 */     // GIR_Coverage, 1004,
     /* 141087 */     GIR_EraseRootFromParent_Done,
     /* 141088 */   // Label 2805: @141088
     /* 141088 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(141124), // Rule ID 1015 //
     /* 141093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 141101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 141104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 141107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141115 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 141115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 141118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141122 */     GIR_RootConstrainSelectedInstOperands,
     /* 141123 */     // GIR_Coverage, 1015,
     /* 141123 */     GIR_EraseRootFromParent_Done,
     /* 141124 */   // Label 2806: @141124
     /* 141124 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(141160), // Rule ID 1016 //
     /* 141129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 141137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 141140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141151 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 141151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 141154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141158 */     GIR_RootConstrainSelectedInstOperands,
     /* 141159 */     // GIR_Coverage, 1016,
     /* 141159 */     GIR_EraseRootFromParent_Done,
     /* 141160 */   // Label 2807: @141160
     /* 141160 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(141196), // Rule ID 1017 //
     /* 141165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 141173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141187 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 141187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 141190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141194 */     GIR_RootConstrainSelectedInstOperands,
     /* 141195 */     // GIR_Coverage, 1017,
     /* 141195 */     GIR_EraseRootFromParent_Done,
     /* 141196 */   // Label 2808: @141196
     /* 141196 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(141232), // Rule ID 1018 //
     /* 141201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 141209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 141212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141223 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 141223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 141226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141230 */     GIR_RootConstrainSelectedInstOperands,
     /* 141231 */     // GIR_Coverage, 1018,
     /* 141231 */     GIR_EraseRootFromParent_Done,
     /* 141232 */   // Label 2809: @141232
     /* 141232 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(141268), // Rule ID 1019 //
     /* 141237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 141245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141259 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 141259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 141262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141266 */     GIR_RootConstrainSelectedInstOperands,
     /* 141267 */     // GIR_Coverage, 1019,
     /* 141267 */     GIR_EraseRootFromParent_Done,
     /* 141268 */   // Label 2810: @141268
     /* 141268 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(141304), // Rule ID 1020 //
     /* 141273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 141281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141295 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 141295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 141298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141302 */     GIR_RootConstrainSelectedInstOperands,
     /* 141303 */     // GIR_Coverage, 1020,
     /* 141303 */     GIR_EraseRootFromParent_Done,
     /* 141304 */   // Label 2811: @141304
     /* 141304 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(141340), // Rule ID 1021 //
     /* 141309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 141317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 141320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141331 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 141331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 141334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141338 */     GIR_RootConstrainSelectedInstOperands,
     /* 141339 */     // GIR_Coverage, 1021,
     /* 141339 */     GIR_EraseRootFromParent_Done,
     /* 141340 */   // Label 2812: @141340
     /* 141340 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(141376), // Rule ID 1022 //
     /* 141345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 141353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 141356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 141359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141367 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 141367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 141370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141374 */     GIR_RootConstrainSelectedInstOperands,
     /* 141375 */     // GIR_Coverage, 1022,
     /* 141375 */     GIR_EraseRootFromParent_Done,
     /* 141376 */   // Label 2813: @141376
     /* 141376 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(141412), // Rule ID 1023 //
     /* 141381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 141389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 141392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141403 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 141403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 141406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141410 */     GIR_RootConstrainSelectedInstOperands,
     /* 141411 */     // GIR_Coverage, 1023,
     /* 141411 */     GIR_EraseRootFromParent_Done,
     /* 141412 */   // Label 2814: @141412
     /* 141412 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(141448), // Rule ID 1024 //
     /* 141417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 141425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141439 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 141439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 141442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141446 */     GIR_RootConstrainSelectedInstOperands,
     /* 141447 */     // GIR_Coverage, 1024,
     /* 141447 */     GIR_EraseRootFromParent_Done,
     /* 141448 */   // Label 2815: @141448
     /* 141448 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(141484), // Rule ID 1025 //
     /* 141453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 141461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 141464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141475 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 141475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 141478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141482 */     GIR_RootConstrainSelectedInstOperands,
     /* 141483 */     // GIR_Coverage, 1025,
     /* 141483 */     GIR_EraseRootFromParent_Done,
     /* 141484 */   // Label 2816: @141484
     /* 141484 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(141520), // Rule ID 1026 //
     /* 141489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 141497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141511 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 141511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 141514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141518 */     GIR_RootConstrainSelectedInstOperands,
     /* 141519 */     // GIR_Coverage, 1026,
     /* 141519 */     GIR_EraseRootFromParent_Done,
     /* 141520 */   // Label 2817: @141520
     /* 141520 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(141556), // Rule ID 1027 //
     /* 141525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 141533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141547 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 141547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 141550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141554 */     GIR_RootConstrainSelectedInstOperands,
     /* 141555 */     // GIR_Coverage, 1027,
     /* 141555 */     GIR_EraseRootFromParent_Done,
     /* 141556 */   // Label 2818: @141556
     /* 141556 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(141592), // Rule ID 1028 //
     /* 141561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 141569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 141572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141583 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 141583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 141586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141590 */     GIR_RootConstrainSelectedInstOperands,
     /* 141591 */     // GIR_Coverage, 1028,
     /* 141591 */     GIR_EraseRootFromParent_Done,
     /* 141592 */   // Label 2819: @141592
     /* 141592 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(141628), // Rule ID 1055 //
     /* 141597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 141605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 141611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141619 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 141619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 141622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141626 */     GIR_RootConstrainSelectedInstOperands,
     /* 141627 */     // GIR_Coverage, 1055,
     /* 141627 */     GIR_EraseRootFromParent_Done,
     /* 141628 */   // Label 2820: @141628
     /* 141628 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(141664), // Rule ID 1057 //
     /* 141633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 141641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 141644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141655 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 141655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 141658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141662 */     GIR_RootConstrainSelectedInstOperands,
     /* 141663 */     // GIR_Coverage, 1057,
     /* 141663 */     GIR_EraseRootFromParent_Done,
     /* 141664 */   // Label 2821: @141664
     /* 141664 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(141700), // Rule ID 1059 //
     /* 141669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 141677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141691 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 141691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 141694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141698 */     GIR_RootConstrainSelectedInstOperands,
     /* 141699 */     // GIR_Coverage, 1059,
     /* 141699 */     GIR_EraseRootFromParent_Done,
     /* 141700 */   // Label 2822: @141700
     /* 141700 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(141736), // Rule ID 1061 //
     /* 141705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 141713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141727 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 141727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 141730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141734 */     GIR_RootConstrainSelectedInstOperands,
     /* 141735 */     // GIR_Coverage, 1061,
     /* 141735 */     GIR_EraseRootFromParent_Done,
     /* 141736 */   // Label 2823: @141736
     /* 141736 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(141772), // Rule ID 1063 //
     /* 141741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 141749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141763 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 141763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 141766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141770 */     GIR_RootConstrainSelectedInstOperands,
     /* 141771 */     // GIR_Coverage, 1063,
     /* 141771 */     GIR_EraseRootFromParent_Done,
     /* 141772 */   // Label 2824: @141772
     /* 141772 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(141808), // Rule ID 1065 //
     /* 141777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 141785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 141788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141799 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 141799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 141802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141806 */     GIR_RootConstrainSelectedInstOperands,
     /* 141807 */     // GIR_Coverage, 1065,
     /* 141807 */     GIR_EraseRootFromParent_Done,
     /* 141808 */   // Label 2825: @141808
     /* 141808 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(141844), // Rule ID 1079 //
     /* 141813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 141821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141835 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 141835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 141838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141842 */     GIR_RootConstrainSelectedInstOperands,
     /* 141843 */     // GIR_Coverage, 1079,
     /* 141843 */     GIR_EraseRootFromParent_Done,
     /* 141844 */   // Label 2826: @141844
     /* 141844 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(141880), // Rule ID 1080 //
     /* 141849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 141857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 141871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 141874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141878 */     GIR_RootConstrainSelectedInstOperands,
     /* 141879 */     // GIR_Coverage, 1080,
     /* 141879 */     GIR_EraseRootFromParent_Done,
     /* 141880 */   // Label 2827: @141880
     /* 141880 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(141916), // Rule ID 1081 //
     /* 141885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 141893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141907 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 141907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 141910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141914 */     GIR_RootConstrainSelectedInstOperands,
     /* 141915 */     // GIR_Coverage, 1081,
     /* 141915 */     GIR_EraseRootFromParent_Done,
     /* 141916 */   // Label 2828: @141916
     /* 141916 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(141952), // Rule ID 1082 //
     /* 141921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 141929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141943 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 141943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 141946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141950 */     GIR_RootConstrainSelectedInstOperands,
     /* 141951 */     // GIR_Coverage, 1082,
     /* 141951 */     GIR_EraseRootFromParent_Done,
     /* 141952 */   // Label 2829: @141952
     /* 141952 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(141988), // Rule ID 1646 //
     /* 141957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 141965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141979 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 141979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 141982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141986 */     GIR_RootConstrainSelectedInstOperands,
     /* 141987 */     // GIR_Coverage, 1646,
     /* 141987 */     GIR_EraseRootFromParent_Done,
     /* 141988 */   // Label 2830: @141988
     /* 141988 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(142024), // Rule ID 1652 //
     /* 141993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 142001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142015 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 142015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 142018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142022 */     GIR_RootConstrainSelectedInstOperands,
     /* 142023 */     // GIR_Coverage, 1652,
     /* 142023 */     GIR_EraseRootFromParent_Done,
     /* 142024 */   // Label 2831: @142024
     /* 142024 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(142060), // Rule ID 1653 //
     /* 142029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 142037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142051 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 142051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 142054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142058 */     GIR_RootConstrainSelectedInstOperands,
     /* 142059 */     // GIR_Coverage, 1653,
     /* 142059 */     GIR_EraseRootFromParent_Done,
     /* 142060 */   // Label 2832: @142060
     /* 142060 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(142096), // Rule ID 1654 //
     /* 142065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 142073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142087 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 142087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 142090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142094 */     GIR_RootConstrainSelectedInstOperands,
     /* 142095 */     // GIR_Coverage, 1654,
     /* 142095 */     GIR_EraseRootFromParent_Done,
     /* 142096 */   // Label 2833: @142096
     /* 142096 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(142132), // Rule ID 1655 //
     /* 142101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 142109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142123 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 142123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 142126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142130 */     GIR_RootConstrainSelectedInstOperands,
     /* 142131 */     // GIR_Coverage, 1655,
     /* 142131 */     GIR_EraseRootFromParent_Done,
     /* 142132 */   // Label 2834: @142132
     /* 142132 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(142168), // Rule ID 1656 //
     /* 142137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 142145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142159 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 142159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 142162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142166 */     GIR_RootConstrainSelectedInstOperands,
     /* 142167 */     // GIR_Coverage, 1656,
     /* 142167 */     GIR_EraseRootFromParent_Done,
     /* 142168 */   // Label 2835: @142168
     /* 142168 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(142204), // Rule ID 1657 //
     /* 142173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 142181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142195 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 142195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 142198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142202 */     GIR_RootConstrainSelectedInstOperands,
     /* 142203 */     // GIR_Coverage, 1657,
     /* 142203 */     GIR_EraseRootFromParent_Done,
     /* 142204 */   // Label 2836: @142204
     /* 142204 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(142240), // Rule ID 1663 //
     /* 142209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 142217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142231 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 142231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 142234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142238 */     GIR_RootConstrainSelectedInstOperands,
     /* 142239 */     // GIR_Coverage, 1663,
     /* 142239 */     GIR_EraseRootFromParent_Done,
     /* 142240 */   // Label 2837: @142240
     /* 142240 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(142276), // Rule ID 1936 //
     /* 142245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 142253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142267 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 142267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 142270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142274 */     GIR_RootConstrainSelectedInstOperands,
     /* 142275 */     // GIR_Coverage, 1936,
     /* 142275 */     GIR_EraseRootFromParent_Done,
     /* 142276 */   // Label 2838: @142276
     /* 142276 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(142312), // Rule ID 1938 //
     /* 142281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 142289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142303 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 142303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 142306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142310 */     GIR_RootConstrainSelectedInstOperands,
     /* 142311 */     // GIR_Coverage, 1938,
     /* 142311 */     GIR_EraseRootFromParent_Done,
     /* 142312 */   // Label 2839: @142312
     /* 142312 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(142348), // Rule ID 1940 //
     /* 142317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 142325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142339 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 142339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 142342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142346 */     GIR_RootConstrainSelectedInstOperands,
     /* 142347 */     // GIR_Coverage, 1940,
     /* 142347 */     GIR_EraseRootFromParent_Done,
     /* 142348 */   // Label 2840: @142348
     /* 142348 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(142384), // Rule ID 1942 //
     /* 142353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 142361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142375 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 142375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 142378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142382 */     GIR_RootConstrainSelectedInstOperands,
     /* 142383 */     // GIR_Coverage, 1942,
     /* 142383 */     GIR_EraseRootFromParent_Done,
     /* 142384 */   // Label 2841: @142384
     /* 142384 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(142420), // Rule ID 1944 //
     /* 142389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 142397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142411 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 142411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 142414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142418 */     GIR_RootConstrainSelectedInstOperands,
     /* 142419 */     // GIR_Coverage, 1944,
     /* 142419 */     GIR_EraseRootFromParent_Done,
     /* 142420 */   // Label 2842: @142420
     /* 142420 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(142456), // Rule ID 1946 //
     /* 142425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 142433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142447 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 142447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 142450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142454 */     GIR_RootConstrainSelectedInstOperands,
     /* 142455 */     // GIR_Coverage, 1946,
     /* 142455 */     GIR_EraseRootFromParent_Done,
     /* 142456 */   // Label 2843: @142456
     /* 142456 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(142492), // Rule ID 1948 //
     /* 142461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 142469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142483 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 142483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 142486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142490 */     GIR_RootConstrainSelectedInstOperands,
     /* 142491 */     // GIR_Coverage, 1948,
     /* 142491 */     GIR_EraseRootFromParent_Done,
     /* 142492 */   // Label 2844: @142492
     /* 142492 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(142528), // Rule ID 1950 //
     /* 142497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 142505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142519 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 142519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 142522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142526 */     GIR_RootConstrainSelectedInstOperands,
     /* 142527 */     // GIR_Coverage, 1950,
     /* 142527 */     GIR_EraseRootFromParent_Done,
     /* 142528 */   // Label 2845: @142528
     /* 142528 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(142564), // Rule ID 1952 //
     /* 142533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 142541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142555 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 142555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 142558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142562 */     GIR_RootConstrainSelectedInstOperands,
     /* 142563 */     // GIR_Coverage, 1952,
     /* 142563 */     GIR_EraseRootFromParent_Done,
     /* 142564 */   // Label 2846: @142564
     /* 142564 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(142600), // Rule ID 1954 //
     /* 142569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142591 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 142591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 142594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142598 */     GIR_RootConstrainSelectedInstOperands,
     /* 142599 */     // GIR_Coverage, 1954,
     /* 142599 */     GIR_EraseRootFromParent_Done,
     /* 142600 */   // Label 2847: @142600
     /* 142600 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(142636), // Rule ID 1956 //
     /* 142605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142627 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 142627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 142630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142634 */     GIR_RootConstrainSelectedInstOperands,
     /* 142635 */     // GIR_Coverage, 1956,
     /* 142635 */     GIR_EraseRootFromParent_Done,
     /* 142636 */   // Label 2848: @142636
     /* 142636 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(142672), // Rule ID 1958 //
     /* 142641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142663 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 142663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 142666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142670 */     GIR_RootConstrainSelectedInstOperands,
     /* 142671 */     // GIR_Coverage, 1958,
     /* 142671 */     GIR_EraseRootFromParent_Done,
     /* 142672 */   // Label 2849: @142672
     /* 142672 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(142708), // Rule ID 2296 //
     /* 142677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 142680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 142685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 142688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142699 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 142702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142706 */     GIR_RootConstrainSelectedInstOperands,
     /* 142707 */     // GIR_Coverage, 2296,
     /* 142707 */     GIR_EraseRootFromParent_Done,
     /* 142708 */   // Label 2850: @142708
     /* 142708 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(142744), // Rule ID 2297 //
     /* 142713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 142716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 142721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 142724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142735 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 142738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142742 */     GIR_RootConstrainSelectedInstOperands,
     /* 142743 */     // GIR_Coverage, 2297,
     /* 142743 */     GIR_EraseRootFromParent_Done,
     /* 142744 */   // Label 2851: @142744
     /* 142744 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(142780), // Rule ID 2305 //
     /* 142749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 142752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 142757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142771 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 142771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 142774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142778 */     GIR_RootConstrainSelectedInstOperands,
     /* 142779 */     // GIR_Coverage, 2305,
     /* 142779 */     GIR_EraseRootFromParent_Done,
     /* 142780 */   // Label 2852: @142780
     /* 142780 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(142816), // Rule ID 2506 //
     /* 142785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 142793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142807 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 142807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 142810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142814 */     GIR_RootConstrainSelectedInstOperands,
     /* 142815 */     // GIR_Coverage, 2506,
     /* 142815 */     GIR_EraseRootFromParent_Done,
     /* 142816 */   // Label 2853: @142816
     /* 142816 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(142855), // Rule ID 3539 //
     /* 142821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 142824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 142829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 142832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 142835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 142839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 142843 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 142843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 142846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 142848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 142850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142853 */     GIR_RootConstrainSelectedInstOperands,
     /* 142854 */     // GIR_Coverage, 3539,
     /* 142854 */     GIR_EraseRootFromParent_Done,
     /* 142855 */   // Label 2854: @142855
     /* 142855 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(142894), // Rule ID 3540 //
     /* 142860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 142863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 142868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 142871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 142874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 142878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 142882 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 142882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 142885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 142887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 142889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142892 */     GIR_RootConstrainSelectedInstOperands,
     /* 142893 */     // GIR_Coverage, 3540,
     /* 142893 */     GIR_EraseRootFromParent_Done,
     /* 142894 */   // Label 2855: @142894
     /* 142894 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(142933), // Rule ID 3541 //
     /* 142899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 142902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 142907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 142910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 142913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 142917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 142921 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 142921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 142924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 142926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 142928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142931 */     GIR_RootConstrainSelectedInstOperands,
     /* 142932 */     // GIR_Coverage, 3541,
     /* 142932 */     GIR_EraseRootFromParent_Done,
     /* 142933 */   // Label 2856: @142933
     /* 142933 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(142972), // Rule ID 3542 //
     /* 142938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 142941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 142946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 142949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 142952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 142956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 142960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 142960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 142963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 142965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 142967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142970 */     GIR_RootConstrainSelectedInstOperands,
     /* 142971 */     // GIR_Coverage, 3542,
     /* 142971 */     GIR_EraseRootFromParent_Done,
     /* 142972 */   // Label 2857: @142972
     /* 142972 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(143028), // Rule ID 3546 //
     /* 142977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 142980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 142985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 142988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 142991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 142995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 142999 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1535:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 142999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 143002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 143016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 143018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 143026 */     GIR_RootConstrainSelectedInstOperands,
     /* 143027 */     // GIR_Coverage, 3546,
     /* 143027 */     GIR_EraseRootFromParent_Done,
     /* 143028 */   // Label 2858: @143028
     /* 143028 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(143084), // Rule ID 3547 //
     /* 143033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 143036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 143041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 143044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 143047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 143051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 143055 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1535:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 143055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 143058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 143072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 143074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 143082 */     GIR_RootConstrainSelectedInstOperands,
     /* 143083 */     // GIR_Coverage, 3547,
     /* 143083 */     GIR_EraseRootFromParent_Done,
     /* 143084 */   // Label 2859: @143084
     /* 143084 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(143140), // Rule ID 3548 //
     /* 143089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 143092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 143097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 143100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 143103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 143107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 143111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1535:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 143111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 143114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 143128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 143130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 143138 */     GIR_RootConstrainSelectedInstOperands,
     /* 143139 */     // GIR_Coverage, 3548,
     /* 143139 */     GIR_EraseRootFromParent_Done,
     /* 143140 */   // Label 2860: @143140
     /* 143140 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(143196), // Rule ID 3549 //
     /* 143145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 143148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 143153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 143156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 143159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 143163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 143167 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1535:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 143167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 143170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 143184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 143186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 143194 */     GIR_RootConstrainSelectedInstOperands,
     /* 143195 */     // GIR_Coverage, 3549,
     /* 143195 */     GIR_EraseRootFromParent_Done,
     /* 143196 */   // Label 2861: @143196
     /* 143196 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(143229), // Rule ID 3962 //
     /* 143201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 143206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143220 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 143220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 143223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143227 */     GIR_RootConstrainSelectedInstOperands,
     /* 143228 */     // GIR_Coverage, 3962,
     /* 143228 */     GIR_EraseRootFromParent_Done,
     /* 143229 */   // Label 2862: @143229
     /* 143229 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(143294), // Rule ID 3963 //
     /* 143234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 143239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143253 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 143253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 143260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143265 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 143269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143276 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 143283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143293 */     // GIR_Coverage, 3963,
     /* 143293 */     GIR_EraseRootFromParent_Done,
     /* 143294 */   // Label 2863: @143294
     /* 143294 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(143327), // Rule ID 4731 //
     /* 143299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143318 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 143321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143325 */     GIR_RootConstrainSelectedInstOperands,
     /* 143326 */     // GIR_Coverage, 4731,
     /* 143326 */     GIR_EraseRootFromParent_Done,
     /* 143327 */   // Label 2864: @143327
     /* 143327 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(143360), // Rule ID 4732 //
     /* 143332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143351 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 143354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143358 */     GIR_RootConstrainSelectedInstOperands,
     /* 143359 */     // GIR_Coverage, 4732,
     /* 143359 */     GIR_EraseRootFromParent_Done,
     /* 143360 */   // Label 2865: @143360
     /* 143360 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(143393), // Rule ID 4733 //
     /* 143365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 143370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143384 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 143387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143391 */     GIR_RootConstrainSelectedInstOperands,
     /* 143392 */     // GIR_Coverage, 4733,
     /* 143392 */     GIR_EraseRootFromParent_Done,
     /* 143393 */   // Label 2866: @143393
     /* 143393 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(143426), // Rule ID 4734 //
     /* 143398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 143403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143417 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 143420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143424 */     GIR_RootConstrainSelectedInstOperands,
     /* 143425 */     // GIR_Coverage, 4734,
     /* 143425 */     GIR_EraseRootFromParent_Done,
     /* 143426 */   // Label 2867: @143426
     /* 143426 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(143459), // Rule ID 4848 //
     /* 143431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 143436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143450 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 143450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 143453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143457 */     GIR_RootConstrainSelectedInstOperands,
     /* 143458 */     // GIR_Coverage, 4848,
     /* 143458 */     GIR_EraseRootFromParent_Done,
     /* 143459 */   // Label 2868: @143459
     /* 143459 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(143492), // Rule ID 4858 //
     /* 143464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 143469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143483 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 143483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 143486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143490 */     GIR_RootConstrainSelectedInstOperands,
     /* 143491 */     // GIR_Coverage, 4858,
     /* 143491 */     GIR_EraseRootFromParent_Done,
     /* 143492 */   // Label 2869: @143492
     /* 143492 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(143528), // Rule ID 5196 //
     /* 143497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 143505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143519 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 143519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 143522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143526 */     GIR_RootConstrainSelectedInstOperands,
     /* 143527 */     // GIR_Coverage, 5196,
     /* 143527 */     GIR_EraseRootFromParent_Done,
     /* 143528 */   // Label 2870: @143528
     /* 143528 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(143561), // Rule ID 5199 //
     /* 143533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 143538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143552 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 143555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143559 */     GIR_RootConstrainSelectedInstOperands,
     /* 143560 */     // GIR_Coverage, 5199,
     /* 143560 */     GIR_EraseRootFromParent_Done,
     /* 143561 */   // Label 2871: @143561
     /* 143561 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(143594), // Rule ID 5200 //
     /* 143566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 143571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143585 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 143588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143592 */     GIR_RootConstrainSelectedInstOperands,
     /* 143593 */     // GIR_Coverage, 5200,
     /* 143593 */     GIR_EraseRootFromParent_Done,
     /* 143594 */   // Label 2872: @143594
     /* 143594 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(143627), // Rule ID 5201 //
     /* 143599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143618 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 143621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143625 */     GIR_RootConstrainSelectedInstOperands,
     /* 143626 */     // GIR_Coverage, 5201,
     /* 143626 */     GIR_EraseRootFromParent_Done,
     /* 143627 */   // Label 2873: @143627
     /* 143627 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(143660), // Rule ID 5202 //
     /* 143632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143651 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 143654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143658 */     GIR_RootConstrainSelectedInstOperands,
     /* 143659 */     // GIR_Coverage, 5202,
     /* 143659 */     GIR_EraseRootFromParent_Done,
     /* 143660 */   // Label 2874: @143660
     /* 143660 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(143693), // Rule ID 5203 //
     /* 143665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143684 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 143687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143691 */     GIR_RootConstrainSelectedInstOperands,
     /* 143692 */     // GIR_Coverage, 5203,
     /* 143692 */     GIR_EraseRootFromParent_Done,
     /* 143693 */   // Label 2875: @143693
     /* 143693 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(143726), // Rule ID 5204 //
     /* 143698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143717 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 143720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143724 */     GIR_RootConstrainSelectedInstOperands,
     /* 143725 */     // GIR_Coverage, 5204,
     /* 143725 */     GIR_EraseRootFromParent_Done,
     /* 143726 */   // Label 2876: @143726
     /* 143726 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(143759), // Rule ID 5205 //
     /* 143731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143750 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 143753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143757 */     GIR_RootConstrainSelectedInstOperands,
     /* 143758 */     // GIR_Coverage, 5205,
     /* 143758 */     GIR_EraseRootFromParent_Done,
     /* 143759 */   // Label 2877: @143759
     /* 143759 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(143792), // Rule ID 5206 //
     /* 143764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143783 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 143786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143790 */     GIR_RootConstrainSelectedInstOperands,
     /* 143791 */     // GIR_Coverage, 5206,
     /* 143791 */     GIR_EraseRootFromParent_Done,
     /* 143792 */   // Label 2878: @143792
     /* 143792 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(143825), // Rule ID 5207 //
     /* 143797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 143802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143816 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 143819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143823 */     GIR_RootConstrainSelectedInstOperands,
     /* 143824 */     // GIR_Coverage, 5207,
     /* 143824 */     GIR_EraseRootFromParent_Done,
     /* 143825 */   // Label 2879: @143825
     /* 143825 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(143858), // Rule ID 5208 //
     /* 143830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 143835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143849 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 143852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143856 */     GIR_RootConstrainSelectedInstOperands,
     /* 143857 */     // GIR_Coverage, 5208,
     /* 143857 */     GIR_EraseRootFromParent_Done,
     /* 143858 */   // Label 2880: @143858
     /* 143858 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(143891), // Rule ID 5209 //
     /* 143863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 143874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143882 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 143882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 143885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143889 */     GIR_RootConstrainSelectedInstOperands,
     /* 143890 */     // GIR_Coverage, 5209,
     /* 143890 */     GIR_EraseRootFromParent_Done,
     /* 143891 */   // Label 2881: @143891
     /* 143891 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(143924), // Rule ID 5210 //
     /* 143896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143915 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 143915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 143918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143922 */     GIR_RootConstrainSelectedInstOperands,
     /* 143923 */     // GIR_Coverage, 5210,
     /* 143923 */     GIR_EraseRootFromParent_Done,
     /* 143924 */   // Label 2882: @143924
     /* 143924 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(143957), // Rule ID 5211 //
     /* 143929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143948 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 143948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 143951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143955 */     GIR_RootConstrainSelectedInstOperands,
     /* 143956 */     // GIR_Coverage, 5211,
     /* 143956 */     GIR_EraseRootFromParent_Done,
     /* 143957 */   // Label 2883: @143957
     /* 143957 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(143990), // Rule ID 5212 //
     /* 143962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 143973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143981 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 143981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 143984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143988 */     GIR_RootConstrainSelectedInstOperands,
     /* 143989 */     // GIR_Coverage, 5212,
     /* 143989 */     GIR_EraseRootFromParent_Done,
     /* 143990 */   // Label 2884: @143990
     /* 143990 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(144023), // Rule ID 5224 //
     /* 143995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 144000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 144006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144014 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 144014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 144017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144021 */     GIR_RootConstrainSelectedInstOperands,
     /* 144022 */     // GIR_Coverage, 5224,
     /* 144022 */     GIR_EraseRootFromParent_Done,
     /* 144023 */   // Label 2885: @144023
     /* 144023 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(144056), // Rule ID 5225 //
     /* 144028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 144033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144047 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 144050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144054 */     GIR_RootConstrainSelectedInstOperands,
     /* 144055 */     // GIR_Coverage, 5225,
     /* 144055 */     GIR_EraseRootFromParent_Done,
     /* 144056 */   // Label 2886: @144056
     /* 144056 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(144089), // Rule ID 5226 //
     /* 144061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 144066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144080 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 144083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144087 */     GIR_RootConstrainSelectedInstOperands,
     /* 144088 */     // GIR_Coverage, 5226,
     /* 144088 */     GIR_EraseRootFromParent_Done,
     /* 144089 */   // Label 2887: @144089
     /* 144089 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(144122), // Rule ID 5227 //
     /* 144094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 144105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144113 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 144113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 144116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144120 */     GIR_RootConstrainSelectedInstOperands,
     /* 144121 */     // GIR_Coverage, 5227,
     /* 144121 */     GIR_EraseRootFromParent_Done,
     /* 144122 */   // Label 2888: @144122
     /* 144122 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(144155), // Rule ID 5228 //
     /* 144127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144146 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 144146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 144149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144153 */     GIR_RootConstrainSelectedInstOperands,
     /* 144154 */     // GIR_Coverage, 5228,
     /* 144154 */     GIR_EraseRootFromParent_Done,
     /* 144155 */   // Label 2889: @144155
     /* 144155 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(144188), // Rule ID 5229 //
     /* 144160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144179 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 144179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 144182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144186 */     GIR_RootConstrainSelectedInstOperands,
     /* 144187 */     // GIR_Coverage, 5229,
     /* 144187 */     GIR_EraseRootFromParent_Done,
     /* 144188 */   // Label 2890: @144188
     /* 144188 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(144221), // Rule ID 5230 //
     /* 144193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144212 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 144212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 144215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144219 */     GIR_RootConstrainSelectedInstOperands,
     /* 144220 */     // GIR_Coverage, 5230,
     /* 144220 */     GIR_EraseRootFromParent_Done,
     /* 144221 */   // Label 2891: @144221
     /* 144221 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(144254), // Rule ID 5554 //
     /* 144226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 144231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144245 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 144248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144252 */     GIR_RootConstrainSelectedInstOperands,
     /* 144253 */     // GIR_Coverage, 5554,
     /* 144253 */     GIR_EraseRootFromParent_Done,
     /* 144254 */   // Label 2892: @144254
     /* 144254 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(144339), // Rule ID 5555 //
     /* 144259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 144264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144278 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 144278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 144281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 144285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 144303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144312 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 144319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 144332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144337 */     GIR_RootConstrainSelectedInstOperands,
     /* 144338 */     // GIR_Coverage, 5555,
     /* 144338 */     GIR_EraseRootFromParent_Done,
     /* 144339 */   // Label 2893: @144339
     /* 144339 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(144372), // Rule ID 5556 //
     /* 144344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 144349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144363 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 144366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144370 */     GIR_RootConstrainSelectedInstOperands,
     /* 144371 */     // GIR_Coverage, 5556,
     /* 144371 */     GIR_EraseRootFromParent_Done,
     /* 144372 */   // Label 2894: @144372
     /* 144372 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(144405), // Rule ID 5558 //
     /* 144377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 144382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144396 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 144399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144403 */     GIR_RootConstrainSelectedInstOperands,
     /* 144404 */     // GIR_Coverage, 5558,
     /* 144404 */     GIR_EraseRootFromParent_Done,
     /* 144405 */   // Label 2895: @144405
     /* 144405 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(144438), // Rule ID 5560 //
     /* 144410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 144415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144429 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 144432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144436 */     GIR_RootConstrainSelectedInstOperands,
     /* 144437 */     // GIR_Coverage, 5560,
     /* 144437 */     GIR_EraseRootFromParent_Done,
     /* 144438 */   // Label 2896: @144438
     /* 144438 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(144471), // Rule ID 5562 //
     /* 144443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 144448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144462 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 144465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144469 */     GIR_RootConstrainSelectedInstOperands,
     /* 144470 */     // GIR_Coverage, 5562,
     /* 144470 */     GIR_EraseRootFromParent_Done,
     /* 144471 */   // Label 2897: @144471
     /* 144471 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(144504), // Rule ID 5564 //
     /* 144476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 144481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144495 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 144498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144502 */     GIR_RootConstrainSelectedInstOperands,
     /* 144503 */     // GIR_Coverage, 5564,
     /* 144503 */     GIR_EraseRootFromParent_Done,
     /* 144504 */   // Label 2898: @144504
     /* 144504 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(144537), // Rule ID 5566 //
     /* 144509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 144514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144528 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 144531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144535 */     GIR_RootConstrainSelectedInstOperands,
     /* 144536 */     // GIR_Coverage, 5566,
     /* 144536 */     GIR_EraseRootFromParent_Done,
     /* 144537 */   // Label 2899: @144537
     /* 144537 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(144570), // Rule ID 5568 //
     /* 144542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 144547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144561 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 144564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144568 */     GIR_RootConstrainSelectedInstOperands,
     /* 144569 */     // GIR_Coverage, 5568,
     /* 144569 */     GIR_EraseRootFromParent_Done,
     /* 144570 */   // Label 2900: @144570
     /* 144570 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(144603), // Rule ID 5570 //
     /* 144575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 144580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144594 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 144597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144601 */     GIR_RootConstrainSelectedInstOperands,
     /* 144602 */     // GIR_Coverage, 5570,
     /* 144602 */     GIR_EraseRootFromParent_Done,
     /* 144603 */   // Label 2901: @144603
     /* 144603 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(144636), // Rule ID 5572 //
     /* 144608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 144613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144627 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 144630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144634 */     GIR_RootConstrainSelectedInstOperands,
     /* 144635 */     // GIR_Coverage, 5572,
     /* 144635 */     GIR_EraseRootFromParent_Done,
     /* 144636 */   // Label 2902: @144636
     /* 144636 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(144669), // Rule ID 12920 //
     /* 144641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 144646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144660 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 144663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144667 */     GIR_RootConstrainSelectedInstOperands,
     /* 144668 */     // GIR_Coverage, 12920,
     /* 144668 */     GIR_EraseRootFromParent_Done,
     /* 144669 */   // Label 2903: @144669
     /* 144669 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(144702), // Rule ID 12922 //
     /* 144674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 144679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144693 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 144696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144700 */     GIR_RootConstrainSelectedInstOperands,
     /* 144701 */     // GIR_Coverage, 12922,
     /* 144701 */     GIR_EraseRootFromParent_Done,
     /* 144702 */   // Label 2904: @144702
     /* 144702 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(144735), // Rule ID 12924 //
     /* 144707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 144712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144726 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 144729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144733 */     GIR_RootConstrainSelectedInstOperands,
     /* 144734 */     // GIR_Coverage, 12924,
     /* 144734 */     GIR_EraseRootFromParent_Done,
     /* 144735 */   // Label 2905: @144735
     /* 144735 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(144768), // Rule ID 12926 //
     /* 144740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 144745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144759 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 144762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144766 */     GIR_RootConstrainSelectedInstOperands,
     /* 144767 */     // GIR_Coverage, 12926,
     /* 144767 */     GIR_EraseRootFromParent_Done,
     /* 144768 */   // Label 2906: @144768
     /* 144768 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(144883), // Rule ID 12927 //
     /* 144773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 144778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144792 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144792 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 144795 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 144799 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144804 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144810 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144817 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144836 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 144845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144865 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144882 */     // GIR_Coverage, 12927,
     /* 144882 */     GIR_EraseRootFromParent_Done,
     /* 144883 */   // Label 2907: @144883
     /* 144883 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(144916), // Rule ID 12929 //
     /* 144888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 144893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144907 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 144910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144914 */     GIR_RootConstrainSelectedInstOperands,
     /* 144915 */     // GIR_Coverage, 12929,
     /* 144915 */     GIR_EraseRootFromParent_Done,
     /* 144916 */   // Label 2908: @144916
     /* 144916 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(144949), // Rule ID 12931 //
     /* 144921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 144926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144940 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 144943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144947 */     GIR_RootConstrainSelectedInstOperands,
     /* 144948 */     // GIR_Coverage, 12931,
     /* 144948 */     GIR_EraseRootFromParent_Done,
     /* 144949 */   // Label 2909: @144949
     /* 144949 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(144982), // Rule ID 12933 //
     /* 144954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 144959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144973 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 144976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144980 */     GIR_RootConstrainSelectedInstOperands,
     /* 144981 */     // GIR_Coverage, 12933,
     /* 144981 */     GIR_EraseRootFromParent_Done,
     /* 144982 */   // Label 2910: @144982
     /* 144982 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(145015), // Rule ID 12935 //
     /* 144987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 144992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145006 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 145009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145013 */     GIR_RootConstrainSelectedInstOperands,
     /* 145014 */     // GIR_Coverage, 12935,
     /* 145014 */     GIR_EraseRootFromParent_Done,
     /* 145015 */   // Label 2911: @145015
     /* 145015 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(145130), // Rule ID 12936 //
     /* 145020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 145025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145039 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 145039 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 145042 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 145046 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145051 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145057 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 145060 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145064 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 145074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 145078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 145086 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 145089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 145092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145112 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 145119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145129 */     // GIR_Coverage, 12936,
     /* 145129 */     GIR_EraseRootFromParent_Done,
     /* 145130 */   // Label 2912: @145130
     /* 145130 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(145249), // Rule ID 12937 //
     /* 145135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 145140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145154 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 145154 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145157 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 145161 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145166 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145170 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 145179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 145193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 145197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145202 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 145205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 145208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 145211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145231 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 145238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145248 */     // GIR_Coverage, 12937,
     /* 145248 */     GIR_EraseRootFromParent_Done,
     /* 145249 */   // Label 2913: @145249
     /* 145249 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(145364), // Rule ID 12938 //
     /* 145254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 145259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145273 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 145273 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145276 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 145280 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145285 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 145294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 145308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 145312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 145320 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 145323 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 145326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145346 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 145353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145363 */     // GIR_Coverage, 12938,
     /* 145363 */     GIR_EraseRootFromParent_Done,
     /* 145364 */   // Label 2914: @145364
     /* 145364 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(145483), // Rule ID 12939 //
     /* 145369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 145374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145388 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 145388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 145395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145400 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145404 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 145413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 145427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 145431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 145439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 145442 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 145445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 145472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145482 */     // GIR_Coverage, 12939,
     /* 145482 */     GIR_EraseRootFromParent_Done,
     /* 145483 */   // Label 2915: @145483
     /* 145483 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(145598), // Rule ID 12940 //
     /* 145488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 145493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145507 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 145507 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145510 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 145514 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145519 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145525 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 145528 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145532 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 145542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 145546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145551 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 145554 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 145557 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 145560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145580 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 145587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145597 */     // GIR_Coverage, 12940,
     /* 145597 */     GIR_EraseRootFromParent_Done,
     /* 145598 */   // Label 2916: @145598
     /* 145598 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(145631), // Rule ID 12942 //
     /* 145603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 145608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 145611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 145618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145622 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 145622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 145625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145629 */     GIR_RootConstrainSelectedInstOperands,
     /* 145630 */     // GIR_Coverage, 12942,
     /* 145630 */     GIR_EraseRootFromParent_Done,
     /* 145631 */   // Label 2917: @145631
     /* 145631 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(145664), // Rule ID 12944 //
     /* 145636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 145641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 145644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 145651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145655 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 145655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 145658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145662 */     GIR_RootConstrainSelectedInstOperands,
     /* 145663 */     // GIR_Coverage, 12944,
     /* 145663 */     GIR_EraseRootFromParent_Done,
     /* 145664 */   // Label 2918: @145664
     /* 145664 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(145697), // Rule ID 12946 //
     /* 145669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 145674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145688 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 145688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 145691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145695 */     GIR_RootConstrainSelectedInstOperands,
     /* 145696 */     // GIR_Coverage, 12946,
     /* 145696 */     GIR_EraseRootFromParent_Done,
     /* 145697 */   // Label 2919: @145697
     /* 145697 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(145730), // Rule ID 12948 //
     /* 145702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 145707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145721 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 145724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145728 */     GIR_RootConstrainSelectedInstOperands,
     /* 145729 */     // GIR_Coverage, 12948,
     /* 145729 */     GIR_EraseRootFromParent_Done,
     /* 145730 */   // Label 2920: @145730
     /* 145730 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(145845), // Rule ID 12949 //
     /* 145735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 145740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145754 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 145754 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 145757 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 145761 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145766 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 145775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 145789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 145793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 145801 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 145804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 145807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145827 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 145834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145844 */     // GIR_Coverage, 12949,
     /* 145844 */     GIR_EraseRootFromParent_Done,
     /* 145845 */   // Label 2921: @145845
     /* 145845 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(145964), // Rule ID 12950 //
     /* 145850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 145855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145869 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 145869 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145872 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 145876 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145881 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145885 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 145889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145891 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 145894 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145898 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 145908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 145912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145917 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 145920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 145923 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 145926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145946 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 145953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145963 */     // GIR_Coverage, 12950,
     /* 145963 */     GIR_EraseRootFromParent_Done,
     /* 145964 */   // Label 2922: @145964
     /* 145964 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(145997), // Rule ID 12952 //
     /* 145969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 145974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 145977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 145984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145988 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 145988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 145991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145995 */     GIR_RootConstrainSelectedInstOperands,
     /* 145996 */     // GIR_Coverage, 12952,
     /* 145996 */     GIR_EraseRootFromParent_Done,
     /* 145997 */   // Label 2923: @145997
     /* 145997 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(146030), // Rule ID 12954 //
     /* 146002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 146007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 146010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 146017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146021 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 146024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146028 */     GIR_RootConstrainSelectedInstOperands,
     /* 146029 */     // GIR_Coverage, 12954,
     /* 146029 */     GIR_EraseRootFromParent_Done,
     /* 146030 */   // Label 2924: @146030
     /* 146030 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(146063), // Rule ID 12956 //
     /* 146035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 146040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146054 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 146054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 146057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146061 */     GIR_RootConstrainSelectedInstOperands,
     /* 146062 */     // GIR_Coverage, 12956,
     /* 146062 */     GIR_EraseRootFromParent_Done,
     /* 146063 */   // Label 2925: @146063
     /* 146063 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(146096), // Rule ID 12958 //
     /* 146068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 146073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146087 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 146087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 146090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146094 */     GIR_RootConstrainSelectedInstOperands,
     /* 146095 */     // GIR_Coverage, 12958,
     /* 146095 */     GIR_EraseRootFromParent_Done,
     /* 146096 */   // Label 2926: @146096
     /* 146096 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(146211), // Rule ID 12959 //
     /* 146101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 146106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146120 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 146120 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 146123 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 146127 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146132 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 146141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 146155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 146159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146164 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 146167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 146170 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 146173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146193 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 146200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146210 */     // GIR_Coverage, 12959,
     /* 146210 */     GIR_EraseRootFromParent_Done,
     /* 146211 */   // Label 2927: @146211
     /* 146211 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(146330), // Rule ID 12960 //
     /* 146216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 146221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146235 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 146235 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146238 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 146242 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146247 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146251 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146257 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 146260 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146264 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 146274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 146278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 146286 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 146289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 146292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146312 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 146319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146329 */     // GIR_Coverage, 12960,
     /* 146329 */     GIR_EraseRootFromParent_Done,
     /* 146330 */   // Label 2928: @146330
     /* 146330 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(146363), // Rule ID 12962 //
     /* 146335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 146340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 146343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 146346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 146350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146354 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 146354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 146357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146361 */     GIR_RootConstrainSelectedInstOperands,
     /* 146362 */     // GIR_Coverage, 12962,
     /* 146362 */     GIR_EraseRootFromParent_Done,
     /* 146363 */   // Label 2929: @146363
     /* 146363 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(146396), // Rule ID 12964 //
     /* 146368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 146373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 146376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 146383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146387 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 146390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146394 */     GIR_RootConstrainSelectedInstOperands,
     /* 146395 */     // GIR_Coverage, 12964,
     /* 146395 */     GIR_EraseRootFromParent_Done,
     /* 146396 */   // Label 2930: @146396
     /* 146396 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(146429), // Rule ID 12966 //
     /* 146401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 146406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146420 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 146420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 146423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146427 */     GIR_RootConstrainSelectedInstOperands,
     /* 146428 */     // GIR_Coverage, 12966,
     /* 146428 */     GIR_EraseRootFromParent_Done,
     /* 146429 */   // Label 2931: @146429
     /* 146429 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(146462), // Rule ID 12968 //
     /* 146434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 146439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146453 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 146453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 146456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146460 */     GIR_RootConstrainSelectedInstOperands,
     /* 146461 */     // GIR_Coverage, 12968,
     /* 146461 */     GIR_EraseRootFromParent_Done,
     /* 146462 */   // Label 2932: @146462
     /* 146462 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(146577), // Rule ID 12969 //
     /* 146467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 146472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146486 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 146486 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 146489 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 146493 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146498 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146504 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 146507 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146511 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 146521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 146525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146530 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 146533 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 146536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 146539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146559 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 146566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146576 */     // GIR_Coverage, 12969,
     /* 146576 */     GIR_EraseRootFromParent_Done,
     /* 146577 */   // Label 2933: @146577
     /* 146577 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(146696), // Rule ID 12970 //
     /* 146582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 146587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146601 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 146601 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146604 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 146608 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146613 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146617 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 146626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 146640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 146644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 146652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 146655 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 146658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146678 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 146685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146695 */     // GIR_Coverage, 12970,
     /* 146695 */     GIR_EraseRootFromParent_Done,
     /* 146696 */   // Label 2934: @146696
     /* 146696 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(146729), // Rule ID 12972 //
     /* 146701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 146706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 146709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 146712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 146716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146720 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 146720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 146723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146727 */     GIR_RootConstrainSelectedInstOperands,
     /* 146728 */     // GIR_Coverage, 12972,
     /* 146728 */     GIR_EraseRootFromParent_Done,
     /* 146729 */   // Label 2935: @146729
     /* 146729 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(146762), // Rule ID 12974 //
     /* 146734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 146739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 146742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 146749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146753 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 146756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146760 */     GIR_RootConstrainSelectedInstOperands,
     /* 146761 */     // GIR_Coverage, 12974,
     /* 146761 */     GIR_EraseRootFromParent_Done,
     /* 146762 */   // Label 2936: @146762
     /* 146762 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(146795), // Rule ID 12976 //
     /* 146767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 146772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146786 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 146786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 146789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146793 */     GIR_RootConstrainSelectedInstOperands,
     /* 146794 */     // GIR_Coverage, 12976,
     /* 146794 */     GIR_EraseRootFromParent_Done,
     /* 146795 */   // Label 2937: @146795
     /* 146795 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(146828), // Rule ID 12978 //
     /* 146800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 146805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146819 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 146819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 146822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146826 */     GIR_RootConstrainSelectedInstOperands,
     /* 146827 */     // GIR_Coverage, 12978,
     /* 146827 */     GIR_EraseRootFromParent_Done,
     /* 146828 */   // Label 2938: @146828
     /* 146828 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(146943), // Rule ID 12979 //
     /* 146833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 146838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146852 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 146852 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 146855 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 146859 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146864 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 146873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 146887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 146891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146896 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 146899 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 146902 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 146905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 146932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146942 */     // GIR_Coverage, 12979,
     /* 146942 */     GIR_EraseRootFromParent_Done,
     /* 146943 */   // Label 2939: @146943
     /* 146943 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(147062), // Rule ID 12980 //
     /* 146948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 146953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146967 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 146967 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 146970 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 146974 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146979 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146983 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 146987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 146989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 146992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 147006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 147010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147015 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 147018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 147021 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 147024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147044 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 147051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147061 */     // GIR_Coverage, 12980,
     /* 147061 */     GIR_EraseRootFromParent_Done,
     /* 147062 */   // Label 2940: @147062
     /* 147062 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(147094), // Rule ID 2384 //
     /* 147067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 147070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 147075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 147078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 147081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147085 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1575:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 147085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 147088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147092 */     GIR_RootConstrainSelectedInstOperands,
     /* 147093 */     // GIR_Coverage, 2384,
     /* 147093 */     GIR_EraseRootFromParent_Done,
     /* 147094 */   // Label 2941: @147094
     /* 147094 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(147126), // Rule ID 2385 //
     /* 147099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 147102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 147107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 147110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 147113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147117 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1576:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 147117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 147120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147124 */     GIR_RootConstrainSelectedInstOperands,
     /* 147125 */     // GIR_Coverage, 2385,
     /* 147125 */     GIR_EraseRootFromParent_Done,
     /* 147126 */   // Label 2942: @147126
     /* 147126 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(147158), // Rule ID 2386 //
     /* 147131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 147134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 147139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 147142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 147145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147149 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1577:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 147149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 147152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147156 */     GIR_RootConstrainSelectedInstOperands,
     /* 147157 */     // GIR_Coverage, 2386,
     /* 147157 */     GIR_EraseRootFromParent_Done,
     /* 147158 */   // Label 2943: @147158
     /* 147158 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(147190), // Rule ID 3084 //
     /* 147163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 147166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 147171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 147174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 147177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147181 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 147181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 147184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147188 */     GIR_RootConstrainSelectedInstOperands,
     /* 147189 */     // GIR_Coverage, 3084,
     /* 147189 */     GIR_EraseRootFromParent_Done,
     /* 147190 */   // Label 2944: @147190
     /* 147190 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(147222), // Rule ID 3085 //
     /* 147195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 147198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 147203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 147206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 147209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147213 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 147213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 147216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147220 */     GIR_RootConstrainSelectedInstOperands,
     /* 147221 */     // GIR_Coverage, 3085,
     /* 147221 */     GIR_EraseRootFromParent_Done,
     /* 147222 */   // Label 2945: @147222
     /* 147222 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(147254), // Rule ID 3086 //
     /* 147227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 147230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 147235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 147238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 147241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 147245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 147248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147252 */     GIR_RootConstrainSelectedInstOperands,
     /* 147253 */     // GIR_Coverage, 3086,
     /* 147253 */     GIR_EraseRootFromParent_Done,
     /* 147254 */   // Label 2946: @147254
     /* 147254 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(147286), // Rule ID 3340 //
     /* 147259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 147262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 147267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 147270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 147273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147277 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1567:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 147277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 147280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147284 */     GIR_RootConstrainSelectedInstOperands,
     /* 147285 */     // GIR_Coverage, 3340,
     /* 147285 */     GIR_EraseRootFromParent_Done,
     /* 147286 */   // Label 2947: @147286
     /* 147286 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(147318), // Rule ID 3341 //
     /* 147291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 147294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 147299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 147302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 147305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147309 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1567:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 147309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 147312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147316 */     GIR_RootConstrainSelectedInstOperands,
     /* 147317 */     // GIR_Coverage, 3341,
     /* 147317 */     GIR_EraseRootFromParent_Done,
     /* 147318 */   // Label 2948: @147318
     /* 147318 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(147350), // Rule ID 3342 //
     /* 147323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 147326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 147331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 147334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 147337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147341 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1567:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 147341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 147344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147348 */     GIR_RootConstrainSelectedInstOperands,
     /* 147349 */     // GIR_Coverage, 3342,
     /* 147349 */     GIR_EraseRootFromParent_Done,
     /* 147350 */   // Label 2949: @147350
     /* 147350 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(147382), // Rule ID 3421 //
     /* 147355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 147358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 147363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 147366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 147369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147373 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1328:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 147373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 147376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147380 */     GIR_RootConstrainSelectedInstOperands,
     /* 147381 */     // GIR_Coverage, 3421,
     /* 147381 */     GIR_EraseRootFromParent_Done,
     /* 147382 */   // Label 2950: @147382
     /* 147382 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(147414), // Rule ID 3422 //
     /* 147387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 147390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 147395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 147398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 147401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147405 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1328:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 147405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 147408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147412 */     GIR_RootConstrainSelectedInstOperands,
     /* 147413 */     // GIR_Coverage, 3422,
     /* 147413 */     GIR_EraseRootFromParent_Done,
     /* 147414 */   // Label 2951: @147414
     /* 147414 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(147446), // Rule ID 3423 //
     /* 147419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 147422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 147427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 147430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 147433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147437 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1328:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 147437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 147440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147444 */     GIR_RootConstrainSelectedInstOperands,
     /* 147445 */     // GIR_Coverage, 3423,
     /* 147445 */     GIR_EraseRootFromParent_Done,
     /* 147446 */   // Label 2952: @147446
     /* 147446 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(147478), // Rule ID 3449 //
     /* 147451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 147454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 147459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 147462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 147465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147469 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1167:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 147469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 147472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 147474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 147476 */     GIR_RootConstrainSelectedInstOperands,
     /* 147477 */     // GIR_Coverage, 3449,
     /* 147477 */     GIR_EraseRootFromParent_Done,
     /* 147478 */   // Label 2953: @147478
     /* 147478 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(147510), // Rule ID 4576 //
     /* 147483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 147486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147501 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 147501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 147504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147508 */     GIR_RootConstrainSelectedInstOperands,
     /* 147509 */     // GIR_Coverage, 4576,
     /* 147509 */     GIR_EraseRootFromParent_Done,
     /* 147510 */   // Label 2954: @147510
     /* 147510 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(147542), // Rule ID 4577 //
     /* 147515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 147518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147533 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 147533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 147536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147540 */     GIR_RootConstrainSelectedInstOperands,
     /* 147541 */     // GIR_Coverage, 4577,
     /* 147541 */     GIR_EraseRootFromParent_Done,
     /* 147542 */   // Label 2955: @147542
     /* 147542 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(147571), // Rule ID 4578 //
     /* 147547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147562 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 147562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 147565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147569 */     GIR_RootConstrainSelectedInstOperands,
     /* 147570 */     // GIR_Coverage, 4578,
     /* 147570 */     GIR_EraseRootFromParent_Done,
     /* 147571 */   // Label 2956: @147571
     /* 147571 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(147600), // Rule ID 4579 //
     /* 147576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147591 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 147591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 147594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147598 */     GIR_RootConstrainSelectedInstOperands,
     /* 147599 */     // GIR_Coverage, 4579,
     /* 147599 */     GIR_EraseRootFromParent_Done,
     /* 147600 */   // Label 2957: @147600
     /* 147600 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(147629), // Rule ID 4580 //
     /* 147605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147620 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 147620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 147623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147627 */     GIR_RootConstrainSelectedInstOperands,
     /* 147628 */     // GIR_Coverage, 4580,
     /* 147628 */     GIR_EraseRootFromParent_Done,
     /* 147629 */   // Label 2958: @147629
     /* 147629 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(147658), // Rule ID 4581 //
     /* 147634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147649 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 147649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 147652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147656 */     GIR_RootConstrainSelectedInstOperands,
     /* 147657 */     // GIR_Coverage, 4581,
     /* 147657 */     GIR_EraseRootFromParent_Done,
     /* 147658 */   // Label 2959: @147658
     /* 147658 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(147690), // Rule ID 4588 //
     /* 147663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 147666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147681 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 147681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 147684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147688 */     GIR_RootConstrainSelectedInstOperands,
     /* 147689 */     // GIR_Coverage, 4588,
     /* 147689 */     GIR_EraseRootFromParent_Done,
     /* 147690 */   // Label 2960: @147690
     /* 147690 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(147722), // Rule ID 4589 //
     /* 147695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 147698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147713 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 147713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 147716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147720 */     GIR_RootConstrainSelectedInstOperands,
     /* 147721 */     // GIR_Coverage, 4589,
     /* 147721 */     GIR_EraseRootFromParent_Done,
     /* 147722 */   // Label 2961: @147722
     /* 147722 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(147751), // Rule ID 4590 //
     /* 147727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147742 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 147742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 147745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147749 */     GIR_RootConstrainSelectedInstOperands,
     /* 147750 */     // GIR_Coverage, 4590,
     /* 147750 */     GIR_EraseRootFromParent_Done,
     /* 147751 */   // Label 2962: @147751
     /* 147751 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(147780), // Rule ID 4591 //
     /* 147756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147771 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 147771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 147774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147778 */     GIR_RootConstrainSelectedInstOperands,
     /* 147779 */     // GIR_Coverage, 4591,
     /* 147779 */     GIR_EraseRootFromParent_Done,
     /* 147780 */   // Label 2963: @147780
     /* 147780 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(147809), // Rule ID 4592 //
     /* 147785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147800 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 147800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 147803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147807 */     GIR_RootConstrainSelectedInstOperands,
     /* 147808 */     // GIR_Coverage, 4592,
     /* 147808 */     GIR_EraseRootFromParent_Done,
     /* 147809 */   // Label 2964: @147809
     /* 147809 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(147838), // Rule ID 4593 //
     /* 147814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147829 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 147829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 147832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147836 */     GIR_RootConstrainSelectedInstOperands,
     /* 147837 */     // GIR_Coverage, 4593,
     /* 147837 */     GIR_EraseRootFromParent_Done,
     /* 147838 */   // Label 2965: @147838
     /* 147838 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(147867), // Rule ID 4888 //
     /* 147843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147858 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 147858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 147861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147865 */     GIR_RootConstrainSelectedInstOperands,
     /* 147866 */     // GIR_Coverage, 4888,
     /* 147866 */     GIR_EraseRootFromParent_Done,
     /* 147867 */   // Label 2966: @147867
     /* 147867 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(147896), // Rule ID 4889 //
     /* 147872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 147880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147887 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 147887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 147890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147894 */     GIR_RootConstrainSelectedInstOperands,
     /* 147895 */     // GIR_Coverage, 4889,
     /* 147895 */     GIR_EraseRootFromParent_Done,
     /* 147896 */   // Label 2967: @147896
     /* 147896 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(147925), // Rule ID 4890 //
     /* 147901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 147909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147916 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 147916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 147919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147923 */     GIR_RootConstrainSelectedInstOperands,
     /* 147924 */     // GIR_Coverage, 4890,
     /* 147924 */     GIR_EraseRootFromParent_Done,
     /* 147925 */   // Label 2968: @147925
     /* 147925 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(147954), // Rule ID 4891 //
     /* 147930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 147945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 147948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147952 */     GIR_RootConstrainSelectedInstOperands,
     /* 147953 */     // GIR_Coverage, 4891,
     /* 147953 */     GIR_EraseRootFromParent_Done,
     /* 147954 */   // Label 2969: @147954
     /* 147954 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(147983), // Rule ID 4892 //
     /* 147959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147974 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 147974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 147977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147981 */     GIR_RootConstrainSelectedInstOperands,
     /* 147982 */     // GIR_Coverage, 4892,
     /* 147982 */     GIR_EraseRootFromParent_Done,
     /* 147983 */   // Label 2970: @147983
     /* 147983 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(148012), // Rule ID 4893 //
     /* 147988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148003 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 148003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 148006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148010 */     GIR_RootConstrainSelectedInstOperands,
     /* 148011 */     // GIR_Coverage, 4893,
     /* 148011 */     GIR_EraseRootFromParent_Done,
     /* 148012 */   // Label 2971: @148012
     /* 148012 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(148041), // Rule ID 4894 //
     /* 148017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 148022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 148025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148032 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 148032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 148035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148039 */     GIR_RootConstrainSelectedInstOperands,
     /* 148040 */     // GIR_Coverage, 4894,
     /* 148040 */     GIR_EraseRootFromParent_Done,
     /* 148041 */   // Label 2972: @148041
     /* 148041 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(148070), // Rule ID 4895 //
     /* 148046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 148051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 148054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148061 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 148061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 148064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148068 */     GIR_RootConstrainSelectedInstOperands,
     /* 148069 */     // GIR_Coverage, 4895,
     /* 148069 */     GIR_EraseRootFromParent_Done,
     /* 148070 */   // Label 2973: @148070
     /* 148070 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(148099), // Rule ID 4896 //
     /* 148075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 148080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 148083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148090 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 148090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 148093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148097 */     GIR_RootConstrainSelectedInstOperands,
     /* 148098 */     // GIR_Coverage, 4896,
     /* 148098 */     GIR_EraseRootFromParent_Done,
     /* 148099 */   // Label 2974: @148099
     /* 148099 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(148128), // Rule ID 4897 //
     /* 148104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 148109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 148112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148119 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 148119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 148122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148126 */     GIR_RootConstrainSelectedInstOperands,
     /* 148127 */     // GIR_Coverage, 4897,
     /* 148127 */     GIR_EraseRootFromParent_Done,
     /* 148128 */   // Label 2975: @148128
     /* 148128 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(148160), // Rule ID 8300 //
     /* 148133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 148136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 148141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 148144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 148147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148151 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1566:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 148151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 148154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148158 */     GIR_RootConstrainSelectedInstOperands,
     /* 148159 */     // GIR_Coverage, 8300,
     /* 148159 */     GIR_EraseRootFromParent_Done,
     /* 148160 */   // Label 2976: @148160
     /* 148160 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(148192), // Rule ID 8301 //
     /* 148165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 148168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 148173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 148176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 148179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148183 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1566:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 148183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 148186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148190 */     GIR_RootConstrainSelectedInstOperands,
     /* 148191 */     // GIR_Coverage, 8301,
     /* 148191 */     GIR_EraseRootFromParent_Done,
     /* 148192 */   // Label 2977: @148192
     /* 148192 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(148224), // Rule ID 8302 //
     /* 148197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 148200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 148205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 148208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 148211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 148215 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1566:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 148215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 148218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 148220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148222 */     GIR_RootConstrainSelectedInstOperands,
     /* 148223 */     // GIR_Coverage, 8302,
     /* 148223 */     GIR_EraseRootFromParent_Done,
     /* 148224 */   // Label 2978: @148224
     /* 148224 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(148256), // Rule ID 11691 //
     /* 148229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 148232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 148237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 148240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 148243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148247 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1950:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 148247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 148250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 148252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148254 */     GIR_RootConstrainSelectedInstOperands,
     /* 148255 */     // GIR_Coverage, 11691,
     /* 148255 */     GIR_EraseRootFromParent_Done,
     /* 148256 */   // Label 2979: @148256
     /* 148256 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(148288), // Rule ID 11692 //
     /* 148261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 148264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 148269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 148272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 148275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1950:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 148279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 148282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 148284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148286 */     GIR_RootConstrainSelectedInstOperands,
     /* 148287 */     // GIR_Coverage, 11692,
     /* 148287 */     GIR_EraseRootFromParent_Done,
     /* 148288 */   // Label 2980: @148288
     /* 148288 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(148320), // Rule ID 11693 //
     /* 148293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 148296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 148301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 148304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 148307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1950:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 148311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 148314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 148316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148318 */     GIR_RootConstrainSelectedInstOperands,
     /* 148319 */     // GIR_Coverage, 11693,
     /* 148319 */     GIR_EraseRootFromParent_Done,
     /* 148320 */   // Label 2981: @148320
     /* 148320 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(148352), // Rule ID 11694 //
     /* 148325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 148328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 148333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 148336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 148339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148343 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 148343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 148346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 148348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148350 */     GIR_RootConstrainSelectedInstOperands,
     /* 148351 */     // GIR_Coverage, 11694,
     /* 148351 */     GIR_EraseRootFromParent_Done,
     /* 148352 */   // Label 2982: @148352
     /* 148352 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(148384), // Rule ID 11695 //
     /* 148357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 148360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 148365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 148368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 148371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148375 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 148375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 148378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 148380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148382 */     GIR_RootConstrainSelectedInstOperands,
     /* 148383 */     // GIR_Coverage, 11695,
     /* 148383 */     GIR_EraseRootFromParent_Done,
     /* 148384 */   // Label 2983: @148384
     /* 148384 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(148416), // Rule ID 11696 //
     /* 148389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 148392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 148397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 148400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 148403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 148407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 148410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 148412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148414 */     GIR_RootConstrainSelectedInstOperands,
     /* 148415 */     // GIR_Coverage, 11696,
     /* 148415 */     GIR_EraseRootFromParent_Done,
     /* 148416 */   // Label 2984: @148416
     /* 148416 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(148448), // Rule ID 11851 //
     /* 148421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 148424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 148429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 148432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 148435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 148439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1166:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 148439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 148442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 148444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 148446 */     GIR_RootConstrainSelectedInstOperands,
     /* 148447 */     // GIR_Coverage, 11851,
     /* 148447 */     GIR_EraseRootFromParent_Done,
     /* 148448 */   // Label 2985: @148448
     /* 148448 */   GIM_Reject,
     /* 148449 */ // Label 2666: @148449
     /* 148449 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(194760),
     /* 148454 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 148457 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(148641), // Rule ID 2559 //
     /* 148462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 148470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 148479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 148495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148511 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 148514 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148523 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 148536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148540 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 148548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 148552 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148556 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 148560 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 148565 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 148569 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 148573 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 148577 */     // MIs[5] Operand 1
     /* 148577 */     // No operand predicates
     /* 148577 */     // MIs[3] Operand 2
     /* 148577 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 148588 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 148592 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 148594 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 148594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 148597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 148612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 148625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 148636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 148639 */     GIR_RootConstrainSelectedInstOperands,
     /* 148640 */     // GIR_Coverage, 2559,
     /* 148640 */     GIR_EraseRootFromParent_Done,
     /* 148641 */   // Label 2987: @148641
     /* 148641 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(148825), // Rule ID 6178 //
     /* 148646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 148654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 148663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 148679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148695 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 148698 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148707 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 148720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148724 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 148732 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 148736 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148740 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 148744 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 148749 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 148753 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 148757 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 148761 */     // MIs[5] Operand 1
     /* 148761 */     // No operand predicates
     /* 148761 */     // MIs[3] Operand 2
     /* 148761 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 148772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 148776 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 148778 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 148778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 148781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148790 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 148796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 148809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 148820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 148823 */     GIR_RootConstrainSelectedInstOperands,
     /* 148824 */     // GIR_Coverage, 6178,
     /* 148824 */     GIR_EraseRootFromParent_Done,
     /* 148825 */   // Label 2988: @148825
     /* 148825 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(148965), // Rule ID 2050 //
     /* 148830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 148838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 148841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 148847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148863 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148866 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148875 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 148883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 148895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 148899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148903 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 148907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 148912 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 148916 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 148920 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 148924 */     // MIs[4] Operand 1
     /* 148924 */     // No operand predicates
     /* 148924 */     // MIs[2] Operand 2
     /* 148924 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 148935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 148937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148944 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 148944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 148947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 148960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 148963 */     GIR_RootConstrainSelectedInstOperands,
     /* 148964 */     // GIR_Coverage, 2050,
     /* 148964 */     GIR_EraseRootFromParent_Done,
     /* 148965 */   // Label 2989: @148965
     /* 148965 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(149105), // Rule ID 2057 //
     /* 148970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 148978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 148981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 148987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149003 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 149006 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 149023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 149035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 149039 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149043 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149047 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 149052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 149056 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149060 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149064 */     // MIs[4] Operand 1
     /* 149064 */     // No operand predicates
     /* 149064 */     // MIs[2] Operand 2
     /* 149064 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 149075 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 149077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 149084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 149087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 149096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 149100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 149103 */     GIR_RootConstrainSelectedInstOperands,
     /* 149104 */     // GIR_Coverage, 2057,
     /* 149104 */     GIR_EraseRootFromParent_Done,
     /* 149105 */   // Label 2990: @149105
     /* 149105 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(149245), // Rule ID 2053 //
     /* 149110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 149118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 149121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 149127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149143 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 149146 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149155 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 149159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 149163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 149175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 149179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 149196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149200 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149204 */     // MIs[4] Operand 1
     /* 149204 */     // No operand predicates
     /* 149204 */     // MIs[2] Operand 2
     /* 149204 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 149215 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 149217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 149224 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 149227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 149236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 149240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 149243 */     GIR_RootConstrainSelectedInstOperands,
     /* 149244 */     // GIR_Coverage, 2053,
     /* 149244 */     GIR_EraseRootFromParent_Done,
     /* 149245 */   // Label 2991: @149245
     /* 149245 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(149385), // Rule ID 2060 //
     /* 149250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 149258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 149261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 149267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149283 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 149286 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149295 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 149299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 149303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 149315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 149319 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149323 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149332 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 149336 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149340 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149344 */     // MIs[4] Operand 1
     /* 149344 */     // No operand predicates
     /* 149344 */     // MIs[2] Operand 2
     /* 149344 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 149355 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 149357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 149364 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 149367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 149376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 149380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 149383 */     GIR_RootConstrainSelectedInstOperands,
     /* 149384 */     // GIR_Coverage, 2060,
     /* 149384 */     GIR_EraseRootFromParent_Done,
     /* 149385 */   // Label 2992: @149385
     /* 149385 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(149522), // Rule ID 2048 //
     /* 149390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 149398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 149401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 149407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149423 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 149426 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149435 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 149448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 149460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 149464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149468 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149472 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 149477 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 149481 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149485 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149489 */     // MIs[4] Operand 1
     /* 149489 */     // No operand predicates
     /* 149489 */     // MIs[2] Operand 2
     /* 149489 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 149500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 149502 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 149505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 149513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 149517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 149520 */     GIR_RootConstrainSelectedInstOperands,
     /* 149521 */     // GIR_Coverage, 2048,
     /* 149521 */     GIR_EraseRootFromParent_Done,
     /* 149522 */   // Label 2993: @149522
     /* 149522 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(149659), // Rule ID 2055 //
     /* 149527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 149535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 149538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 149544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149560 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 149563 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 149585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 149597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 149601 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149605 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149609 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 149614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 149618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149622 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149626 */     // MIs[4] Operand 1
     /* 149626 */     // No operand predicates
     /* 149626 */     // MIs[2] Operand 2
     /* 149626 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 149637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 149639 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 149642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 149650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 149654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 149657 */     GIR_RootConstrainSelectedInstOperands,
     /* 149658 */     // GIR_Coverage, 2055,
     /* 149658 */     GIR_EraseRootFromParent_Done,
     /* 149659 */   // Label 2994: @149659
     /* 149659 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(149796), // Rule ID 2051 //
     /* 149664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 149672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 149675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 149681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149697 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 149700 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149709 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 149713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 149722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 149734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 149738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149742 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149746 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149751 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 149755 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149759 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149763 */     // MIs[4] Operand 1
     /* 149763 */     // No operand predicates
     /* 149763 */     // MIs[2] Operand 2
     /* 149763 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 149774 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 149776 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 149779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 149787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 149791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 149794 */     GIR_RootConstrainSelectedInstOperands,
     /* 149795 */     // GIR_Coverage, 2051,
     /* 149795 */     GIR_EraseRootFromParent_Done,
     /* 149796 */   // Label 2995: @149796
     /* 149796 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(149933), // Rule ID 2058 //
     /* 149801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 149809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 149812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 149818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149834 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 149837 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149846 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 149850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 149859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 149871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 149875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 149892 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149896 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149900 */     // MIs[4] Operand 1
     /* 149900 */     // No operand predicates
     /* 149900 */     // MIs[2] Operand 2
     /* 149900 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 149911 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 149913 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 149916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 149924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 149928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 149931 */     GIR_RootConstrainSelectedInstOperands,
     /* 149932 */     // GIR_Coverage, 2058,
     /* 149932 */     GIR_EraseRootFromParent_Done,
     /* 149933 */   // Label 2996: @149933
     /* 149933 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(150094), // Rule ID 2560 //
     /* 149938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 149946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 149955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149987 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 149990 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149999 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 150012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150016 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150020 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150024 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150029 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 150033 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150037 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150041 */     // MIs[4] Operand 1
     /* 150041 */     // No operand predicates
     /* 150041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 150045 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 150047 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 150047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 150050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150059 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 150065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 150078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 150089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 150092 */     GIR_RootConstrainSelectedInstOperands,
     /* 150093 */     // GIR_Coverage, 2560,
     /* 150093 */     GIR_EraseRootFromParent_Done,
     /* 150094 */   // Label 2997: @150094
     /* 150094 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(150255), // Rule ID 6179 //
     /* 150099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 150116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 150144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 150151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150160 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 150173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150177 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150181 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150190 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 150194 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150198 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150202 */     // MIs[4] Operand 1
     /* 150202 */     // No operand predicates
     /* 150202 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 150206 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 150208 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 150208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 150211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150220 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 150226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 150239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 150250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 150253 */     GIR_RootConstrainSelectedInstOperands,
     /* 150254 */     // GIR_Coverage, 6179,
     /* 150254 */     GIR_EraseRootFromParent_Done,
     /* 150255 */   // Label 2998: @150255
     /* 150255 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(150365), // Rule ID 2078 //
     /* 150260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 150289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 150297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150322 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150326 */     // MIs[3] Operand 1
     /* 150326 */     // No operand predicates
     /* 150326 */     // MIs[1] Operand 2
     /* 150326 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 150337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 150346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 150349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 150356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150363 */     GIR_RootConstrainSelectedInstOperands,
     /* 150364 */     // GIR_Coverage, 2078,
     /* 150364 */     GIR_EraseRootFromParent_Done,
     /* 150365 */   // Label 2999: @150365
     /* 150365 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(150475), // Rule ID 2081 //
     /* 150370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 150399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 150407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 150411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150432 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150436 */     // MIs[3] Operand 1
     /* 150436 */     // No operand predicates
     /* 150436 */     // MIs[1] Operand 2
     /* 150436 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 150447 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 150456 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 150459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 150466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150473 */     GIR_RootConstrainSelectedInstOperands,
     /* 150474 */     // GIR_Coverage, 2081,
     /* 150474 */     GIR_EraseRootFromParent_Done,
     /* 150475 */   // Label 3000: @150475
     /* 150475 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(150564), // Rule ID 1736 //
     /* 150480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 150497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150513 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150516 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150525 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 150538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 150545 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 150545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 150548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 150557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 150562 */     GIR_RootConstrainSelectedInstOperands,
     /* 150563 */     // GIR_Coverage, 1736,
     /* 150563 */     GIR_EraseRootFromParent_Done,
     /* 150564 */   // Label 3001: @150564
     /* 150564 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(150653), // Rule ID 1738 //
     /* 150569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 150586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150602 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150605 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150614 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 150627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 150634 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 150634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 150637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 150646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 150651 */     GIR_RootConstrainSelectedInstOperands,
     /* 150652 */     // GIR_Coverage, 1738,
     /* 150652 */     GIR_EraseRootFromParent_Done,
     /* 150653 */   // Label 3002: @150653
     /* 150653 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(150742), // Rule ID 1740 //
     /* 150658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 150675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150691 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150694 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150703 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 150716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 150723 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 150723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 150726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 150735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 150740 */     GIR_RootConstrainSelectedInstOperands,
     /* 150741 */     // GIR_Coverage, 1740,
     /* 150741 */     GIR_EraseRootFromParent_Done,
     /* 150742 */   // Label 3003: @150742
     /* 150742 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(150831), // Rule ID 1742 //
     /* 150747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 150764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150780 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150783 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150792 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 150805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 150812 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 150812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 150815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 150824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 150829 */     GIR_RootConstrainSelectedInstOperands,
     /* 150830 */     // GIR_Coverage, 1742,
     /* 150830 */     GIR_EraseRootFromParent_Done,
     /* 150831 */   // Label 3004: @150831
     /* 150831 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(150953), // Rule ID 6838 //
     /* 150836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 150841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 150844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 150862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150871 */     // MIs[1] Operand 2
     /* 150871 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 150882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 150886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 150890 */     // MIs[2] Rn
     /* 150890 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 150895 */     // MIs[2] Operand 2
     /* 150895 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 150906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 150908 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 150908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 150911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 150915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 150924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 150928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 150942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150952 */     // GIR_Coverage, 6838,
     /* 150952 */     GIR_EraseRootFromParent_Done,
     /* 150953 */   // Label 3005: @150953
     /* 150953 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(151075), // Rule ID 6840 //
     /* 150958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 150963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 150966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 150984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150993 */     // MIs[1] Operand 2
     /* 150993 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 151008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151012 */     // MIs[2] Rn
     /* 151012 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 151017 */     // MIs[2] Operand 2
     /* 151017 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 151028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 151030 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 151030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 151033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 151037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 151046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 151050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 151064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151074 */     // GIR_Coverage, 6840,
     /* 151074 */     GIR_EraseRootFromParent_Done,
     /* 151075 */   // Label 3006: @151075
     /* 151075 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(151197), // Rule ID 6842 //
     /* 151080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 151085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 151088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 151091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 151094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 151110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151115 */     // MIs[1] Operand 2
     /* 151115 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 151130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151134 */     // MIs[2] Rn
     /* 151134 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 151139 */     // MIs[2] Operand 2
     /* 151139 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 151150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 151152 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 151152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 151155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 151159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 151168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 151172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151179 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 151186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151196 */     // GIR_Coverage, 6842,
     /* 151196 */     GIR_EraseRootFromParent_Done,
     /* 151197 */   // Label 3007: @151197
     /* 151197 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(151319), // Rule ID 6844 //
     /* 151202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 151207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151237 */     // MIs[1] Operand 2
     /* 151237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 151252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151256 */     // MIs[2] Rn
     /* 151256 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 151261 */     // MIs[2] Operand 2
     /* 151261 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 151272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 151274 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 151274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 151277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 151281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 151290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 151294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151301 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 151308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151318 */     // GIR_Coverage, 6844,
     /* 151318 */     GIR_EraseRootFromParent_Done,
     /* 151319 */   // Label 3008: @151319
     /* 151319 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(151441), // Rule ID 6846 //
     /* 151324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 151329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151359 */     // MIs[1] Operand 2
     /* 151359 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 151374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151378 */     // MIs[2] Rn
     /* 151378 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 151383 */     // MIs[2] Operand 2
     /* 151383 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 151394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 151396 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 151396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 151399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 151403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 151412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 151416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 151430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151440 */     // GIR_Coverage, 6846,
     /* 151440 */     GIR_EraseRootFromParent_Done,
     /* 151441 */   // Label 3009: @151441
     /* 151441 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(151624), // Rule ID 2558 //
     /* 151446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 151454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 151463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 151479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151495 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 151498 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151507 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151521 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 151525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 151527 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 151527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 151530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151541 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151544 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151548 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151553 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 151556 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 151560 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 151563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 151581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151590 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 151596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 151609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 151619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151622 */     GIR_RootConstrainSelectedInstOperands,
     /* 151623 */     // GIR_Coverage, 2558,
     /* 151623 */     GIR_EraseRootFromParent_Done,
     /* 151624 */   // Label 3010: @151624
     /* 151624 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(151807), // Rule ID 6177 //
     /* 151629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 151637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 151646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 151662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151678 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 151681 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151690 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151704 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 151708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 151710 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 151710 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 151713 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151717 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151736 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 151739 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 151743 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 151746 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 151764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151773 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 151779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 151792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 151802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151805 */     GIR_RootConstrainSelectedInstOperands,
     /* 151806 */     // GIR_Coverage, 6177,
     /* 151806 */     GIR_EraseRootFromParent_Done,
     /* 151807 */   // Label 3011: @151807
     /* 151807 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(151911), // Rule ID 13231 //
     /* 151812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 151815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 151820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151874 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151878 */     // MIs[3] Operand 1
     /* 151878 */     // No operand predicates
     /* 151878 */     // MIs[1] Operand 2
     /* 151878 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151895 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 151898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 151902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151909 */     GIR_RootConstrainSelectedInstOperands,
     /* 151910 */     // GIR_Coverage, 13231,
     /* 151910 */     GIR_EraseRootFromParent_Done,
     /* 151911 */   // Label 3012: @151911
     /* 151911 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(152015), // Rule ID 13234 //
     /* 151916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 151924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151978 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151982 */     // MIs[3] Operand 1
     /* 151982 */     // No operand predicates
     /* 151982 */     // MIs[1] Operand 2
     /* 151982 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151999 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 152002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 152010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 152013 */     GIR_RootConstrainSelectedInstOperands,
     /* 152014 */     // GIR_Coverage, 13234,
     /* 152014 */     GIR_EraseRootFromParent_Done,
     /* 152015 */   // Label 3013: @152015
     /* 152015 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(152146), // Rule ID 2515 //
     /* 152020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 152023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 152037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152062 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 152070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 152082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 152091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152095 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152099 */     // MIs[3] Operand 1
     /* 152099 */     // No operand predicates
     /* 152099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152101 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152113 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 152132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 152141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 152144 */     GIR_RootConstrainSelectedInstOperands,
     /* 152145 */     // GIR_Coverage, 2515,
     /* 152145 */     GIR_EraseRootFromParent_Done,
     /* 152146 */   // Label 3014: @152146
     /* 152146 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(152277), // Rule ID 2516 //
     /* 152151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 152201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 152213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 152222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152230 */     // MIs[3] Operand 1
     /* 152230 */     // No operand predicates
     /* 152230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152232 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 152232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152244 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 152250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 152263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 152272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 152275 */     GIR_RootConstrainSelectedInstOperands,
     /* 152276 */     // GIR_Coverage, 2516,
     /* 152276 */     GIR_EraseRootFromParent_Done,
     /* 152277 */   // Label 3015: @152277
     /* 152277 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152408), // Rule ID 2517 //
     /* 152282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 152332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 152344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 152353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152357 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 152361 */     // MIs[3] Operand 1
     /* 152361 */     // No operand predicates
     /* 152361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152363 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 152363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 152366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152375 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 152381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 152394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 152403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 152406 */     GIR_RootConstrainSelectedInstOperands,
     /* 152407 */     // GIR_Coverage, 2517,
     /* 152407 */     GIR_EraseRootFromParent_Done,
     /* 152408 */   // Label 3016: @152408
     /* 152408 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(152539), // Rule ID 13417 //
     /* 152413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 152416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 152430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 152459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152467 */     // MIs[2] Operand 1
     /* 152467 */     // No operand predicates
     /* 152467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 152471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152483 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152488 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 152492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152494 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152506 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 152525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 152534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 152537 */     GIR_RootConstrainSelectedInstOperands,
     /* 152538 */     // GIR_Coverage, 13417,
     /* 152538 */     GIR_EraseRootFromParent_Done,
     /* 152539 */   // Label 3017: @152539
     /* 152539 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152670), // Rule ID 13418 //
     /* 152544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 152590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152594 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152598 */     // MIs[2] Operand 1
     /* 152598 */     // No operand predicates
     /* 152598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 152602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152610 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152614 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152619 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 152623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152625 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 152625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152637 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 152643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 152656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 152665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 152668 */     GIR_RootConstrainSelectedInstOperands,
     /* 152669 */     // GIR_Coverage, 13418,
     /* 152669 */     GIR_EraseRootFromParent_Done,
     /* 152670 */   // Label 3018: @152670
     /* 152670 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152801), // Rule ID 13419 //
     /* 152675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 152721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152725 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 152729 */     // MIs[2] Operand 1
     /* 152729 */     // No operand predicates
     /* 152729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 152733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152737 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152741 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152745 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152750 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 152754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152756 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 152756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 152759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152768 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 152774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 152787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 152796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 152799 */     GIR_RootConstrainSelectedInstOperands,
     /* 152800 */     // GIR_Coverage, 13419,
     /* 152800 */     GIR_EraseRootFromParent_Done,
     /* 152801 */   // Label 3019: @152801
     /* 152801 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(152915), // Rule ID 2049 //
     /* 152806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152839 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152842 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 152876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 152885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152889 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152893 */     // MIs[3] Operand 1
     /* 152893 */     // No operand predicates
     /* 152893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152895 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 152898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 152910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 152913 */     GIR_RootConstrainSelectedInstOperands,
     /* 152914 */     // GIR_Coverage, 2049,
     /* 152914 */     GIR_EraseRootFromParent_Done,
     /* 152915 */   // Label 3020: @152915
     /* 152915 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(153029), // Rule ID 2056 //
     /* 152920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152953 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152956 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152965 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 152990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 152999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153003 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153007 */     // MIs[3] Operand 1
     /* 153007 */     // No operand predicates
     /* 153007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153009 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 153012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153027 */     GIR_RootConstrainSelectedInstOperands,
     /* 153028 */     // GIR_Coverage, 2056,
     /* 153028 */     GIR_EraseRootFromParent_Done,
     /* 153029 */   // Label 3021: @153029
     /* 153029 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(153143), // Rule ID 2052 //
     /* 153034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153067 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153070 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153117 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153121 */     // MIs[3] Operand 1
     /* 153121 */     // No operand predicates
     /* 153121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153123 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 153126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153141 */     GIR_RootConstrainSelectedInstOperands,
     /* 153142 */     // GIR_Coverage, 2052,
     /* 153142 */     GIR_EraseRootFromParent_Done,
     /* 153143 */   // Label 3022: @153143
     /* 153143 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(153257), // Rule ID 2059 //
     /* 153148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153193 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153231 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153235 */     // MIs[3] Operand 1
     /* 153235 */     // No operand predicates
     /* 153235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153237 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 153240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153255 */     GIR_RootConstrainSelectedInstOperands,
     /* 153256 */     // GIR_Coverage, 2059,
     /* 153256 */     GIR_EraseRootFromParent_Done,
     /* 153257 */   // Label 3023: @153257
     /* 153257 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(153371), // Rule ID 2054 //
     /* 153262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153295 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153298 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 153303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 153307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 153311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153345 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153349 */     // MIs[3] Operand 1
     /* 153349 */     // No operand predicates
     /* 153349 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153351 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 153354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153369 */     GIR_RootConstrainSelectedInstOperands,
     /* 153370 */     // GIR_Coverage, 2054,
     /* 153370 */     GIR_EraseRootFromParent_Done,
     /* 153371 */   // Label 3024: @153371
     /* 153371 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(153485), // Rule ID 2061 //
     /* 153376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153409 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153412 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 153417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 153421 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 153425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153459 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153463 */     // MIs[3] Operand 1
     /* 153463 */     // No operand predicates
     /* 153463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153465 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 153468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153483 */     GIR_RootConstrainSelectedInstOperands,
     /* 153484 */     // GIR_Coverage, 2061,
     /* 153484 */     GIR_EraseRootFromParent_Done,
     /* 153485 */   // Label 3025: @153485
     /* 153485 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(153589), // Rule ID 1980 //
     /* 153490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153556 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153560 */     // MIs[3] Operand 1
     /* 153560 */     // No operand predicates
     /* 153560 */     // MIs[1] Operand 2
     /* 153560 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 153571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153573 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 153576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153587 */     GIR_RootConstrainSelectedInstOperands,
     /* 153588 */     // GIR_Coverage, 1980,
     /* 153588 */     GIR_EraseRootFromParent_Done,
     /* 153589 */   // Label 3026: @153589
     /* 153589 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(153693), // Rule ID 2010 //
     /* 153594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 153602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153660 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153664 */     // MIs[3] Operand 1
     /* 153664 */     // No operand predicates
     /* 153664 */     // MIs[1] Operand 2
     /* 153664 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 153675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153677 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 153680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153691 */     GIR_RootConstrainSelectedInstOperands,
     /* 153692 */     // GIR_Coverage, 2010,
     /* 153692 */     GIR_EraseRootFromParent_Done,
     /* 153693 */   // Label 3027: @153693
     /* 153693 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(153797), // Rule ID 2017 //
     /* 153698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 153706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153764 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153768 */     // MIs[3] Operand 1
     /* 153768 */     // No operand predicates
     /* 153768 */     // MIs[1] Operand 2
     /* 153768 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 153779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153781 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 153784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153795 */     GIR_RootConstrainSelectedInstOperands,
     /* 153796 */     // GIR_Coverage, 2017,
     /* 153796 */     GIR_EraseRootFromParent_Done,
     /* 153797 */   // Label 3028: @153797
     /* 153797 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(153901), // Rule ID 2076 //
     /* 153802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153868 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153872 */     // MIs[3] Operand 1
     /* 153872 */     // No operand predicates
     /* 153872 */     // MIs[1] Operand 2
     /* 153872 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 153883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153885 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 153888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153899 */     GIR_RootConstrainSelectedInstOperands,
     /* 153900 */     // GIR_Coverage, 2076,
     /* 153900 */     GIR_EraseRootFromParent_Done,
     /* 153901 */   // Label 3029: @153901
     /* 153901 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(154005), // Rule ID 1983 //
     /* 153906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 153917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153972 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153976 */     // MIs[3] Operand 1
     /* 153976 */     // No operand predicates
     /* 153976 */     // MIs[1] Operand 2
     /* 153976 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 153987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153989 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 153992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154003 */     GIR_RootConstrainSelectedInstOperands,
     /* 154004 */     // GIR_Coverage, 1983,
     /* 154004 */     GIR_EraseRootFromParent_Done,
     /* 154005 */   // Label 3030: @154005
     /* 154005 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(154109), // Rule ID 2013 //
     /* 154010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154076 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154080 */     // MIs[3] Operand 1
     /* 154080 */     // No operand predicates
     /* 154080 */     // MIs[1] Operand 2
     /* 154080 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154093 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 154096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154107 */     GIR_RootConstrainSelectedInstOperands,
     /* 154108 */     // GIR_Coverage, 2013,
     /* 154108 */     GIR_EraseRootFromParent_Done,
     /* 154109 */   // Label 3031: @154109
     /* 154109 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(154213), // Rule ID 2020 //
     /* 154114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154184 */     // MIs[3] Operand 1
     /* 154184 */     // No operand predicates
     /* 154184 */     // MIs[1] Operand 2
     /* 154184 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154197 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 154200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154211 */     GIR_RootConstrainSelectedInstOperands,
     /* 154212 */     // GIR_Coverage, 2020,
     /* 154212 */     GIR_EraseRootFromParent_Done,
     /* 154213 */   // Label 3032: @154213
     /* 154213 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(154317), // Rule ID 2079 //
     /* 154218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154284 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154288 */     // MIs[3] Operand 1
     /* 154288 */     // No operand predicates
     /* 154288 */     // MIs[1] Operand 2
     /* 154288 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154301 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 154304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154315 */     GIR_RootConstrainSelectedInstOperands,
     /* 154316 */     // GIR_Coverage, 2079,
     /* 154316 */     GIR_EraseRootFromParent_Done,
     /* 154317 */   // Label 3033: @154317
     /* 154317 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(154374), // Rule ID 1744 //
     /* 154322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154357 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 154360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154372 */     GIR_RootConstrainSelectedInstOperands,
     /* 154373 */     // GIR_Coverage, 1744,
     /* 154373 */     GIR_EraseRootFromParent_Done,
     /* 154374 */   // Label 3034: @154374
     /* 154374 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(154431), // Rule ID 1746 //
     /* 154379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154414 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 154417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154429 */     GIR_RootConstrainSelectedInstOperands,
     /* 154430 */     // GIR_Coverage, 1746,
     /* 154430 */     GIR_EraseRootFromParent_Done,
     /* 154431 */   // Label 3035: @154431
     /* 154431 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(154541), // Rule ID 6196 //
     /* 154436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 154441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 154444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 154462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 154466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 154470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154475 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 154486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154494 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 154498 */     // MIs[2] Operand 1
     /* 154498 */     // No operand predicates
     /* 154498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154500 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 154500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154512 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 154531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 154539 */     GIR_RootConstrainSelectedInstOperands,
     /* 154540 */     // GIR_Coverage, 6196,
     /* 154540 */     GIR_EraseRootFromParent_Done,
     /* 154541 */   // Label 3036: @154541
     /* 154541 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(154638), // Rule ID 13685 //
     /* 154546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 154549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 154557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 154560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 154563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154588 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154598 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 154598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154610 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 154616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 154629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 154633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154636 */     GIR_RootConstrainSelectedInstOperands,
     /* 154637 */     // GIR_Coverage, 13685,
     /* 154637 */     GIR_EraseRootFromParent_Done,
     /* 154638 */   // Label 3037: @154638
     /* 154638 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(154735), // Rule ID 13686 //
     /* 154643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 154646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154695 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 154695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154707 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 154713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 154726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 154730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154733 */     GIR_RootConstrainSelectedInstOperands,
     /* 154734 */     // GIR_Coverage, 13686,
     /* 154734 */     GIR_EraseRootFromParent_Done,
     /* 154735 */   // Label 3038: @154735
     /* 154735 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(154832), // Rule ID 13687 //
     /* 154740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 154743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 154751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 154773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154792 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 154792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 154795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154804 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 154810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 154823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 154827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154830 */     GIR_RootConstrainSelectedInstOperands,
     /* 154831 */     // GIR_Coverage, 13687,
     /* 154831 */     GIR_EraseRootFromParent_Done,
     /* 154832 */   // Label 3039: @154832
     /* 154832 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(154915), // Rule ID 1735 //
     /* 154837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154870 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154873 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154882 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154898 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 154898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 154901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 154909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 154913 */     GIR_RootConstrainSelectedInstOperands,
     /* 154914 */     // GIR_Coverage, 1735,
     /* 154914 */     GIR_EraseRootFromParent_Done,
     /* 154915 */   // Label 3040: @154915
     /* 154915 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(154998), // Rule ID 1737 //
     /* 154920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154953 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154956 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154965 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154981 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 154981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 154984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 154992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 154996 */     GIR_RootConstrainSelectedInstOperands,
     /* 154997 */     // GIR_Coverage, 1737,
     /* 154997 */     GIR_EraseRootFromParent_Done,
     /* 154998 */   // Label 3041: @154998
     /* 154998 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(155081), // Rule ID 1739 //
     /* 155003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155036 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155039 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155048 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155064 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 155064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 155067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 155079 */     GIR_RootConstrainSelectedInstOperands,
     /* 155080 */     // GIR_Coverage, 1739,
     /* 155080 */     GIR_EraseRootFromParent_Done,
     /* 155081 */   // Label 3042: @155081
     /* 155081 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(155164), // Rule ID 1741 //
     /* 155086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155119 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155122 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155131 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155147 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 155147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 155150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 155162 */     GIR_RootConstrainSelectedInstOperands,
     /* 155163 */     // GIR_Coverage, 1741,
     /* 155163 */     GIR_EraseRootFromParent_Done,
     /* 155164 */   // Label 3043: @155164
     /* 155164 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(155244), // Rule ID 5185 //
     /* 155169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155199 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155202 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 155207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 155211 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 155215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155227 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 155227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 155230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 155242 */     GIR_RootConstrainSelectedInstOperands,
     /* 155243 */     // GIR_Coverage, 5185,
     /* 155243 */     GIR_EraseRootFromParent_Done,
     /* 155244 */   // Label 3044: @155244
     /* 155244 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(155324), // Rule ID 5186 //
     /* 155249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 155287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 155291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 155295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155307 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 155307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 155310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 155322 */     GIR_RootConstrainSelectedInstOperands,
     /* 155323 */     // GIR_Coverage, 5186,
     /* 155323 */     GIR_EraseRootFromParent_Done,
     /* 155324 */   // Label 3045: @155324
     /* 155324 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(155421), // Rule ID 5182 //
     /* 155329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 155332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155375 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155381 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 155381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155393 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 155399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 155412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155419 */     GIR_RootConstrainSelectedInstOperands,
     /* 155420 */     // GIR_Coverage, 5182,
     /* 155420 */     GIR_EraseRootFromParent_Done,
     /* 155421 */   // Label 3046: @155421
     /* 155421 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(155518), // Rule ID 5183 //
     /* 155426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 155429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155472 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155478 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 155478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155490 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 155496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 155509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155516 */     GIR_RootConstrainSelectedInstOperands,
     /* 155517 */     // GIR_Coverage, 5183,
     /* 155517 */     GIR_EraseRootFromParent_Done,
     /* 155518 */   // Label 3047: @155518
     /* 155518 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(155615), // Rule ID 5184 //
     /* 155523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 155526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155569 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155575 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 155575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 155578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155587 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 155593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 155606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155613 */     GIR_RootConstrainSelectedInstOperands,
     /* 155614 */     // GIR_Coverage, 5184,
     /* 155614 */     GIR_EraseRootFromParent_Done,
     /* 155615 */   // Label 3048: @155615
     /* 155615 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(155696), // Rule ID 13232 //
     /* 155620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155674 */     // MIs[2] Operand 1
     /* 155674 */     // No operand predicates
     /* 155674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155680 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 155683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155694 */     GIR_RootConstrainSelectedInstOperands,
     /* 155695 */     // GIR_Coverage, 13232,
     /* 155695 */     GIR_EraseRootFromParent_Done,
     /* 155696 */   // Label 3049: @155696
     /* 155696 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(155777), // Rule ID 13233 //
     /* 155701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 155712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 155715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 155718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155751 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155755 */     // MIs[2] Operand 1
     /* 155755 */     // No operand predicates
     /* 155755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155761 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 155764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155775 */     GIR_RootConstrainSelectedInstOperands,
     /* 155776 */     // GIR_Coverage, 13233,
     /* 155776 */     GIR_EraseRootFromParent_Done,
     /* 155777 */   // Label 3050: @155777
     /* 155777 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(155858), // Rule ID 13235 //
     /* 155782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155832 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155836 */     // MIs[2] Operand 1
     /* 155836 */     // No operand predicates
     /* 155836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155842 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 155845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155856 */     GIR_RootConstrainSelectedInstOperands,
     /* 155857 */     // GIR_Coverage, 13235,
     /* 155857 */     GIR_EraseRootFromParent_Done,
     /* 155858 */   // Label 3051: @155858
     /* 155858 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(155939), // Rule ID 13236 //
     /* 155863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155913 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155917 */     // MIs[2] Operand 1
     /* 155917 */     // No operand predicates
     /* 155917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155923 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 155926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155937 */     GIR_RootConstrainSelectedInstOperands,
     /* 155938 */     // GIR_Coverage, 13236,
     /* 155938 */     GIR_EraseRootFromParent_Done,
     /* 155939 */   // Label 3052: @155939
     /* 155939 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(156020), // Rule ID 13237 //
     /* 155944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 155973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155994 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155998 */     // MIs[2] Operand 1
     /* 155998 */     // No operand predicates
     /* 155998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156004 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 156007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 156011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156018 */     GIR_RootConstrainSelectedInstOperands,
     /* 156019 */     // GIR_Coverage, 13237,
     /* 156019 */     GIR_EraseRootFromParent_Done,
     /* 156020 */   // Label 3053: @156020
     /* 156020 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(156101), // Rule ID 13238 //
     /* 156025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 156036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 156042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156075 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156079 */     // MIs[2] Operand 1
     /* 156079 */     // No operand predicates
     /* 156079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156085 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 156088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 156092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156099 */     GIR_RootConstrainSelectedInstOperands,
     /* 156100 */     // GIR_Coverage, 13238,
     /* 156100 */     GIR_EraseRootFromParent_Done,
     /* 156101 */   // Label 3054: @156101
     /* 156101 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(156182), // Rule ID 13239 //
     /* 156106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156156 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156160 */     // MIs[2] Operand 1
     /* 156160 */     // No operand predicates
     /* 156160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156166 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 156169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 156173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156180 */     GIR_RootConstrainSelectedInstOperands,
     /* 156181 */     // GIR_Coverage, 13239,
     /* 156181 */     GIR_EraseRootFromParent_Done,
     /* 156182 */   // Label 3055: @156182
     /* 156182 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(156263), // Rule ID 13240 //
     /* 156187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 156241 */     // MIs[2] Operand 1
     /* 156241 */     // No operand predicates
     /* 156241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156247 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 156250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 156254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156261 */     GIR_RootConstrainSelectedInstOperands,
     /* 156262 */     // GIR_Coverage, 13240,
     /* 156262 */     GIR_EraseRootFromParent_Done,
     /* 156263 */   // Label 3056: @156263
     /* 156263 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(156369), // Rule ID 6193 //
     /* 156268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 156273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 156276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 156294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156303 */     // MIs[1] Operand 2
     /* 156303 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 156314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156322 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 156326 */     // MIs[2] Operand 1
     /* 156326 */     // No operand predicates
     /* 156326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156328 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 156328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156340 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 156359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 156367 */     GIR_RootConstrainSelectedInstOperands,
     /* 156368 */     // GIR_Coverage, 6193,
     /* 156368 */     GIR_EraseRootFromParent_Done,
     /* 156369 */   // Label 3057: @156369
     /* 156369 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(156450), // Rule ID 1981 //
     /* 156374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156428 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156432 */     // MIs[2] Operand 1
     /* 156432 */     // No operand predicates
     /* 156432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156434 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 156437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156448 */     GIR_RootConstrainSelectedInstOperands,
     /* 156449 */     // GIR_Coverage, 1981,
     /* 156449 */     GIR_EraseRootFromParent_Done,
     /* 156450 */   // Label 3058: @156450
     /* 156450 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(156531), // Rule ID 1982 //
     /* 156455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 156466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 156469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 156472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156509 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156513 */     // MIs[2] Operand 1
     /* 156513 */     // No operand predicates
     /* 156513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156515 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 156518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156529 */     GIR_RootConstrainSelectedInstOperands,
     /* 156530 */     // GIR_Coverage, 1982,
     /* 156530 */     GIR_EraseRootFromParent_Done,
     /* 156531 */   // Label 3059: @156531
     /* 156531 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(156612), // Rule ID 2011 //
     /* 156536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 156544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156594 */     // MIs[2] Operand 1
     /* 156594 */     // No operand predicates
     /* 156594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156596 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 156599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156610 */     GIR_RootConstrainSelectedInstOperands,
     /* 156611 */     // GIR_Coverage, 2011,
     /* 156611 */     GIR_EraseRootFromParent_Done,
     /* 156612 */   // Label 3060: @156612
     /* 156612 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(156693), // Rule ID 2012 //
     /* 156617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 156625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 156628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 156631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 156634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156671 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156675 */     // MIs[2] Operand 1
     /* 156675 */     // No operand predicates
     /* 156675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156677 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 156680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156691 */     GIR_RootConstrainSelectedInstOperands,
     /* 156692 */     // GIR_Coverage, 2012,
     /* 156692 */     GIR_EraseRootFromParent_Done,
     /* 156693 */   // Label 3061: @156693
     /* 156693 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(156774), // Rule ID 2018 //
     /* 156698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 156706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156752 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156756 */     // MIs[2] Operand 1
     /* 156756 */     // No operand predicates
     /* 156756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156758 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 156761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156772 */     GIR_RootConstrainSelectedInstOperands,
     /* 156773 */     // GIR_Coverage, 2018,
     /* 156773 */     GIR_EraseRootFromParent_Done,
     /* 156774 */   // Label 3062: @156774
     /* 156774 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(156855), // Rule ID 2019 //
     /* 156779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 156787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 156790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 156793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 156796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156837 */     // MIs[2] Operand 1
     /* 156837 */     // No operand predicates
     /* 156837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156839 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 156842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156853 */     GIR_RootConstrainSelectedInstOperands,
     /* 156854 */     // GIR_Coverage, 2019,
     /* 156854 */     GIR_EraseRootFromParent_Done,
     /* 156855 */   // Label 3063: @156855
     /* 156855 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(156936), // Rule ID 2077 //
     /* 156860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156918 */     // MIs[2] Operand 1
     /* 156918 */     // No operand predicates
     /* 156918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156920 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 156923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156934 */     GIR_RootConstrainSelectedInstOperands,
     /* 156935 */     // GIR_Coverage, 2077,
     /* 156935 */     GIR_EraseRootFromParent_Done,
     /* 156936 */   // Label 3064: @156936
     /* 156936 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(157017), // Rule ID 1984 //
     /* 156941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156995 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156999 */     // MIs[2] Operand 1
     /* 156999 */     // No operand predicates
     /* 156999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157001 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 157004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157015 */     GIR_RootConstrainSelectedInstOperands,
     /* 157016 */     // GIR_Coverage, 1984,
     /* 157016 */     GIR_EraseRootFromParent_Done,
     /* 157017 */   // Label 3065: @157017
     /* 157017 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(157098), // Rule ID 1985 //
     /* 157022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 157036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 157039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157076 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157080 */     // MIs[2] Operand 1
     /* 157080 */     // No operand predicates
     /* 157080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157082 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 157085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157096 */     GIR_RootConstrainSelectedInstOperands,
     /* 157097 */     // GIR_Coverage, 1985,
     /* 157097 */     GIR_EraseRootFromParent_Done,
     /* 157098 */   // Label 3066: @157098
     /* 157098 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(157179), // Rule ID 2014 //
     /* 157103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157157 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157161 */     // MIs[2] Operand 1
     /* 157161 */     // No operand predicates
     /* 157161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157163 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 157166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157177 */     GIR_RootConstrainSelectedInstOperands,
     /* 157178 */     // GIR_Coverage, 2014,
     /* 157178 */     GIR_EraseRootFromParent_Done,
     /* 157179 */   // Label 3067: @157179
     /* 157179 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(157260), // Rule ID 2015 //
     /* 157184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 157198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 157201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157242 */     // MIs[2] Operand 1
     /* 157242 */     // No operand predicates
     /* 157242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157244 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 157247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157258 */     GIR_RootConstrainSelectedInstOperands,
     /* 157259 */     // GIR_Coverage, 2015,
     /* 157259 */     GIR_EraseRootFromParent_Done,
     /* 157260 */   // Label 3068: @157260
     /* 157260 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(157341), // Rule ID 2021 //
     /* 157265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157319 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157323 */     // MIs[2] Operand 1
     /* 157323 */     // No operand predicates
     /* 157323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157325 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 157328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157339 */     GIR_RootConstrainSelectedInstOperands,
     /* 157340 */     // GIR_Coverage, 2021,
     /* 157340 */     GIR_EraseRootFromParent_Done,
     /* 157341 */   // Label 3069: @157341
     /* 157341 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(157422), // Rule ID 2022 //
     /* 157346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 157360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 157363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157404 */     // MIs[2] Operand 1
     /* 157404 */     // No operand predicates
     /* 157404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157406 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 157409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157420 */     GIR_RootConstrainSelectedInstOperands,
     /* 157421 */     // GIR_Coverage, 2022,
     /* 157421 */     GIR_EraseRootFromParent_Done,
     /* 157422 */   // Label 3070: @157422
     /* 157422 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(157503), // Rule ID 2080 //
     /* 157427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157481 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157485 */     // MIs[2] Operand 1
     /* 157485 */     // No operand predicates
     /* 157485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157487 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 157490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157501 */     GIR_RootConstrainSelectedInstOperands,
     /* 157502 */     // GIR_Coverage, 2080,
     /* 157502 */     GIR_EraseRootFromParent_Done,
     /* 157503 */   // Label 3071: @157503
     /* 157503 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(157584), // Rule ID 1986 //
     /* 157508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 157522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 157525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 157541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 157545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157562 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 157566 */     // MIs[2] Operand 1
     /* 157566 */     // No operand predicates
     /* 157566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157568 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 157571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157582 */     GIR_RootConstrainSelectedInstOperands,
     /* 157583 */     // GIR_Coverage, 1986,
     /* 157583 */     GIR_EraseRootFromParent_Done,
     /* 157584 */   // Label 3072: @157584
     /* 157584 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(157665), // Rule ID 1987 //
     /* 157589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 157606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157643 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157647 */     // MIs[2] Operand 1
     /* 157647 */     // No operand predicates
     /* 157647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157649 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 157652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157663 */     GIR_RootConstrainSelectedInstOperands,
     /* 157664 */     // GIR_Coverage, 1987,
     /* 157664 */     GIR_EraseRootFromParent_Done,
     /* 157665 */   // Label 3073: @157665
     /* 157665 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(157746), // Rule ID 1988 //
     /* 157670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157724 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157728 */     // MIs[2] Operand 1
     /* 157728 */     // No operand predicates
     /* 157728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157730 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 157733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157744 */     GIR_RootConstrainSelectedInstOperands,
     /* 157745 */     // GIR_Coverage, 1988,
     /* 157745 */     GIR_EraseRootFromParent_Done,
     /* 157746 */   // Label 3074: @157746
     /* 157746 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(157827), // Rule ID 1989 //
     /* 157751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 157788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 157809 */     // MIs[2] Operand 1
     /* 157809 */     // No operand predicates
     /* 157809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157811 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 157814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157825 */     GIR_RootConstrainSelectedInstOperands,
     /* 157826 */     // GIR_Coverage, 1989,
     /* 157826 */     GIR_EraseRootFromParent_Done,
     /* 157827 */   // Label 3075: @157827
     /* 157827 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(157908), // Rule ID 2016 //
     /* 157832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157886 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157890 */     // MIs[2] Operand 1
     /* 157890 */     // No operand predicates
     /* 157890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157892 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 157895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157906 */     GIR_RootConstrainSelectedInstOperands,
     /* 157907 */     // GIR_Coverage, 2016,
     /* 157907 */     GIR_EraseRootFromParent_Done,
     /* 157908 */   // Label 3076: @157908
     /* 157908 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(157989), // Rule ID 2023 //
     /* 157913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157971 */     // MIs[2] Operand 1
     /* 157971 */     // No operand predicates
     /* 157971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157973 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 157976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157987 */     GIR_RootConstrainSelectedInstOperands,
     /* 157988 */     // GIR_Coverage, 2023,
     /* 157988 */     GIR_EraseRootFromParent_Done,
     /* 157989 */   // Label 3077: @157989
     /* 157989 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(158067), // Rule ID 6180 //
     /* 157994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 157999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158049 */     // MIs[2] Operand 1
     /* 158049 */     // No operand predicates
     /* 158049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158051 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 158051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 158054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 158062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158065 */     GIR_RootConstrainSelectedInstOperands,
     /* 158066 */     // GIR_Coverage, 6180,
     /* 158066 */     GIR_EraseRootFromParent_Done,
     /* 158067 */   // Label 3078: @158067
     /* 158067 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(158127), // Rule ID 6254 //
     /* 158072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 158077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 158080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 158083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 158098 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 158098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 158101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 158105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 158113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 158118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 158122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158125 */     GIR_RootConstrainSelectedInstOperands,
     /* 158126 */     // GIR_Coverage, 6254,
     /* 158126 */     GIR_EraseRootFromParent_Done,
     /* 158127 */   // Label 3079: @158127
     /* 158127 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(158187), // Rule ID 6255 //
     /* 158132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 158137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 158140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 158158 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 158158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 158161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 158165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158170 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 158173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 158178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 158182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158185 */     GIR_RootConstrainSelectedInstOperands,
     /* 158186 */     // GIR_Coverage, 6255,
     /* 158186 */     GIR_EraseRootFromParent_Done,
     /* 158187 */   // Label 3080: @158187
     /* 158187 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(158247), // Rule ID 6256 //
     /* 158192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 158197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 158200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 158218 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 158218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 158221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 158225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 158233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 158238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 158242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158245 */     GIR_RootConstrainSelectedInstOperands,
     /* 158246 */     // GIR_Coverage, 6256,
     /* 158246 */     GIR_EraseRootFromParent_Done,
     /* 158247 */   // Label 3081: @158247
     /* 158247 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(158294), // Rule ID 3850 //
     /* 158252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 158255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 158260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158274 */     // MIs[0] Operand 3
     /* 158274 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 158285 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 158285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 158288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158292 */     GIR_RootConstrainSelectedInstOperands,
     /* 158293 */     // GIR_Coverage, 3850,
     /* 158293 */     GIR_EraseRootFromParent_Done,
     /* 158294 */   // Label 3082: @158294
     /* 158294 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(158341), // Rule ID 3851 //
     /* 158299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 158302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 158307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158321 */     // MIs[0] Operand 3
     /* 158321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 158332 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 158332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 158335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158339 */     GIR_RootConstrainSelectedInstOperands,
     /* 158340 */     // GIR_Coverage, 3851,
     /* 158340 */     GIR_EraseRootFromParent_Done,
     /* 158341 */   // Label 3083: @158341
     /* 158341 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(158388), // Rule ID 3852 //
     /* 158346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 158349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 158354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158368 */     // MIs[0] Operand 3
     /* 158368 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 158379 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 158379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 158382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158386 */     GIR_RootConstrainSelectedInstOperands,
     /* 158387 */     // GIR_Coverage, 3852,
     /* 158387 */     GIR_EraseRootFromParent_Done,
     /* 158388 */   // Label 3084: @158388
     /* 158388 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(158435), // Rule ID 3853 //
     /* 158393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 158396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 158401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158415 */     // MIs[0] Operand 3
     /* 158415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 158426 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 158426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 158429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158433 */     GIR_RootConstrainSelectedInstOperands,
     /* 158434 */     // GIR_Coverage, 3853,
     /* 158434 */     GIR_EraseRootFromParent_Done,
     /* 158435 */   // Label 3085: @158435
     /* 158435 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(158481), // Rule ID 3535 //
     /* 158440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 158448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 158451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 158454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 158458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158462 */     // MIs[0] Idx
     /* 158462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 158470 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 158470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 158473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 158475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 158477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 158479 */     GIR_RootConstrainSelectedInstOperands,
     /* 158480 */     // GIR_Coverage, 3535,
     /* 158480 */     GIR_EraseRootFromParent_Done,
     /* 158481 */   // Label 3086: @158481
     /* 158481 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(158527), // Rule ID 3536 //
     /* 158486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 158494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 158497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 158504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158508 */     // MIs[0] Idx
     /* 158508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 158516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 158516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 158519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 158521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 158523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 158525 */     GIR_RootConstrainSelectedInstOperands,
     /* 158526 */     // GIR_Coverage, 3536,
     /* 158526 */     GIR_EraseRootFromParent_Done,
     /* 158527 */   // Label 3087: @158527
     /* 158527 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(158573), // Rule ID 3537 //
     /* 158532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 158540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 158543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 158550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158554 */     // MIs[0] Idx
     /* 158554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 158562 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 158562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 158565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 158567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 158569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 158571 */     GIR_RootConstrainSelectedInstOperands,
     /* 158572 */     // GIR_Coverage, 3537,
     /* 158572 */     GIR_EraseRootFromParent_Done,
     /* 158573 */   // Label 3088: @158573
     /* 158573 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(158619), // Rule ID 3538 //
     /* 158578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 158586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 158589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 158596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158600 */     // MIs[0] Idx
     /* 158600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 158608 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 158608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 158611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 158613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 158615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 158617 */     GIR_RootConstrainSelectedInstOperands,
     /* 158618 */     // GIR_Coverage, 3538,
     /* 158618 */     GIR_EraseRootFromParent_Done,
     /* 158619 */   // Label 3089: @158619
     /* 158619 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(158675), // Rule ID 2101 //
     /* 158624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 158632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 158661 */     // MIs[1] Operand 1
     /* 158661 */     // No operand predicates
     /* 158661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158663 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 158663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 158666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 158673 */     GIR_RootConstrainSelectedInstOperands,
     /* 158674 */     // GIR_Coverage, 2101,
     /* 158674 */     GIR_EraseRootFromParent_Done,
     /* 158675 */   // Label 3090: @158675
     /* 158675 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(158731), // Rule ID 2102 //
     /* 158680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 158688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 158717 */     // MIs[1] Operand 1
     /* 158717 */     // No operand predicates
     /* 158717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158719 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 158719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 158722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 158729 */     GIR_RootConstrainSelectedInstOperands,
     /* 158730 */     // GIR_Coverage, 2102,
     /* 158730 */     GIR_EraseRootFromParent_Done,
     /* 158731 */   // Label 3091: @158731
     /* 158731 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(158787), // Rule ID 2107 //
     /* 158736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 158744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 158773 */     // MIs[1] Operand 1
     /* 158773 */     // No operand predicates
     /* 158773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158775 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 158775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 158778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 158785 */     GIR_RootConstrainSelectedInstOperands,
     /* 158786 */     // GIR_Coverage, 2107,
     /* 158786 */     GIR_EraseRootFromParent_Done,
     /* 158787 */   // Label 3092: @158787
     /* 158787 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(158843), // Rule ID 2108 //
     /* 158792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 158800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 158829 */     // MIs[1] Operand 1
     /* 158829 */     // No operand predicates
     /* 158829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158831 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 158831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 158834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 158841 */     GIR_RootConstrainSelectedInstOperands,
     /* 158842 */     // GIR_Coverage, 2108,
     /* 158842 */     GIR_EraseRootFromParent_Done,
     /* 158843 */   // Label 3093: @158843
     /* 158843 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(158899), // Rule ID 2114 //
     /* 158848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 158856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 158885 */     // MIs[1] Operand 1
     /* 158885 */     // No operand predicates
     /* 158885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158887 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 158887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 158890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 158897 */     GIR_RootConstrainSelectedInstOperands,
     /* 158898 */     // GIR_Coverage, 2114,
     /* 158898 */     GIR_EraseRootFromParent_Done,
     /* 158899 */   // Label 3094: @158899
     /* 158899 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(158955), // Rule ID 2117 //
     /* 158904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 158912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 158941 */     // MIs[1] Operand 1
     /* 158941 */     // No operand predicates
     /* 158941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158943 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 158943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 158946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 158953 */     GIR_RootConstrainSelectedInstOperands,
     /* 158954 */     // GIR_Coverage, 2117,
     /* 158954 */     GIR_EraseRootFromParent_Done,
     /* 158955 */   // Label 3095: @158955
     /* 158955 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(159011), // Rule ID 2139 //
     /* 158960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 158968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 158971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 158974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 158997 */     // MIs[1] Operand 1
     /* 158997 */     // No operand predicates
     /* 158997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158999 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 158999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 159002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159009 */     GIR_RootConstrainSelectedInstOperands,
     /* 159010 */     // GIR_Coverage, 2139,
     /* 159010 */     GIR_EraseRootFromParent_Done,
     /* 159011 */   // Label 3096: @159011
     /* 159011 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(159067), // Rule ID 2141 //
     /* 159016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 159024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 159053 */     // MIs[1] Operand 1
     /* 159053 */     // No operand predicates
     /* 159053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159055 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 159055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 159058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159065 */     GIR_RootConstrainSelectedInstOperands,
     /* 159066 */     // GIR_Coverage, 2141,
     /* 159066 */     GIR_EraseRootFromParent_Done,
     /* 159067 */   // Label 3097: @159067
     /* 159067 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(159123), // Rule ID 2143 //
     /* 159072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 159080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 159109 */     // MIs[1] Operand 1
     /* 159109 */     // No operand predicates
     /* 159109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159111 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 159111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 159114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159121 */     GIR_RootConstrainSelectedInstOperands,
     /* 159122 */     // GIR_Coverage, 2143,
     /* 159122 */     GIR_EraseRootFromParent_Done,
     /* 159123 */   // Label 3098: @159123
     /* 159123 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(159176), // Rule ID 6181 //
     /* 159128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 159162 */     // MIs[1] Operand 1
     /* 159162 */     // No operand predicates
     /* 159162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159164 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 159164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 159167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159174 */     GIR_RootConstrainSelectedInstOperands,
     /* 159175 */     // GIR_Coverage, 6181,
     /* 159175 */     GIR_EraseRootFromParent_Done,
     /* 159176 */   // Label 3099: @159176
     /* 159176 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(159229), // Rule ID 6182 //
     /* 159181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 159186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 159215 */     // MIs[1] Operand 1
     /* 159215 */     // No operand predicates
     /* 159215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159217 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 159217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 159220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159227 */     GIR_RootConstrainSelectedInstOperands,
     /* 159228 */     // GIR_Coverage, 6182,
     /* 159228 */     GIR_EraseRootFromParent_Done,
     /* 159229 */   // Label 3100: @159229
     /* 159229 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(159282), // Rule ID 6183 //
     /* 159234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 159268 */     // MIs[1] Operand 1
     /* 159268 */     // No operand predicates
     /* 159268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159270 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 159270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 159273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159280 */     GIR_RootConstrainSelectedInstOperands,
     /* 159281 */     // GIR_Coverage, 6183,
     /* 159281 */     GIR_EraseRootFromParent_Done,
     /* 159282 */   // Label 3101: @159282
     /* 159282 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(159335), // Rule ID 6184 //
     /* 159287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 159292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 159321 */     // MIs[1] Operand 1
     /* 159321 */     // No operand predicates
     /* 159321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159323 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 159323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 159326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159333 */     GIR_RootConstrainSelectedInstOperands,
     /* 159334 */     // GIR_Coverage, 6184,
     /* 159334 */     GIR_EraseRootFromParent_Done,
     /* 159335 */   // Label 3102: @159335
     /* 159335 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(159388), // Rule ID 6185 //
     /* 159340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 159374 */     // MIs[1] Operand 1
     /* 159374 */     // No operand predicates
     /* 159374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159376 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 159376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 159379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159386 */     GIR_RootConstrainSelectedInstOperands,
     /* 159387 */     // GIR_Coverage, 6185,
     /* 159387 */     GIR_EraseRootFromParent_Done,
     /* 159388 */   // Label 3103: @159388
     /* 159388 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(159441), // Rule ID 6186 //
     /* 159393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 159398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 159427 */     // MIs[1] Operand 1
     /* 159427 */     // No operand predicates
     /* 159427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159429 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 159429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 159432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159439 */     GIR_RootConstrainSelectedInstOperands,
     /* 159440 */     // GIR_Coverage, 6186,
     /* 159440 */     GIR_EraseRootFromParent_Done,
     /* 159441 */   // Label 3104: @159441
     /* 159441 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(159494), // Rule ID 6187 //
     /* 159446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 159451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 159480 */     // MIs[1] Operand 1
     /* 159480 */     // No operand predicates
     /* 159480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159482 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 159482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 159485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159492 */     GIR_RootConstrainSelectedInstOperands,
     /* 159493 */     // GIR_Coverage, 6187,
     /* 159493 */     GIR_EraseRootFromParent_Done,
     /* 159494 */   // Label 3105: @159494
     /* 159494 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(159547), // Rule ID 6188 //
     /* 159499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 159504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 159533 */     // MIs[1] Operand 1
     /* 159533 */     // No operand predicates
     /* 159533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159535 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 159535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 159538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159545 */     GIR_RootConstrainSelectedInstOperands,
     /* 159546 */     // GIR_Coverage, 6188,
     /* 159546 */     GIR_EraseRootFromParent_Done,
     /* 159547 */   // Label 3106: @159547
     /* 159547 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(159600), // Rule ID 6189 //
     /* 159552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 159586 */     // MIs[1] Operand 1
     /* 159586 */     // No operand predicates
     /* 159586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159588 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 159588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 159591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159598 */     GIR_RootConstrainSelectedInstOperands,
     /* 159599 */     // GIR_Coverage, 6189,
     /* 159599 */     GIR_EraseRootFromParent_Done,
     /* 159600 */   // Label 3107: @159600
     /* 159600 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(159653), // Rule ID 6190 //
     /* 159605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 159639 */     // MIs[1] Operand 1
     /* 159639 */     // No operand predicates
     /* 159639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159641 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 159641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 159644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159651 */     GIR_RootConstrainSelectedInstOperands,
     /* 159652 */     // GIR_Coverage, 6190,
     /* 159652 */     GIR_EraseRootFromParent_Done,
     /* 159653 */   // Label 3108: @159653
     /* 159653 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(159706), // Rule ID 6191 //
     /* 159658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 159663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 159692 */     // MIs[1] Operand 1
     /* 159692 */     // No operand predicates
     /* 159692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159694 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 159694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 159697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159704 */     GIR_RootConstrainSelectedInstOperands,
     /* 159705 */     // GIR_Coverage, 6191,
     /* 159705 */     GIR_EraseRootFromParent_Done,
     /* 159706 */   // Label 3109: @159706
     /* 159706 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(159759), // Rule ID 6192 //
     /* 159711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 159745 */     // MIs[1] Operand 1
     /* 159745 */     // No operand predicates
     /* 159745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159747 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 159747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 159750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159757 */     GIR_RootConstrainSelectedInstOperands,
     /* 159758 */     // GIR_Coverage, 6192,
     /* 159758 */     GIR_EraseRootFromParent_Done,
     /* 159759 */   // Label 3110: @159759
     /* 159759 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(159841), // Rule ID 6194 //
     /* 159764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 159798 */     // MIs[1] Operand 1
     /* 159798 */     // No operand predicates
     /* 159798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159800 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 159800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 159818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 159831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159839 */     GIR_RootConstrainSelectedInstOperands,
     /* 159840 */     // GIR_Coverage, 6194,
     /* 159840 */     GIR_EraseRootFromParent_Done,
     /* 159841 */   // Label 3111: @159841
     /* 159841 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(159923), // Rule ID 6195 //
     /* 159846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 159880 */     // MIs[1] Operand 1
     /* 159880 */     // No operand predicates
     /* 159880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159882 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 159882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159894 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 159900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 159913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159921 */     GIR_RootConstrainSelectedInstOperands,
     /* 159922 */     // GIR_Coverage, 6195,
     /* 159922 */     GIR_EraseRootFromParent_Done,
     /* 159923 */   // Label 3112: @159923
     /* 159923 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(160005), // Rule ID 6197 //
     /* 159928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 159933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 159962 */     // MIs[1] Operand 1
     /* 159962 */     // No operand predicates
     /* 159962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159964 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 159964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159976 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 159982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 159995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160003 */     GIR_RootConstrainSelectedInstOperands,
     /* 160004 */     // GIR_Coverage, 6197,
     /* 160004 */     GIR_EraseRootFromParent_Done,
     /* 160005 */   // Label 3113: @160005
     /* 160005 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(160087), // Rule ID 6198 //
     /* 160010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 160044 */     // MIs[1] Operand 1
     /* 160044 */     // No operand predicates
     /* 160044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160046 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 160046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 160049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160058 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 160064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 160077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160085 */     GIR_RootConstrainSelectedInstOperands,
     /* 160086 */     // GIR_Coverage, 6198,
     /* 160086 */     GIR_EraseRootFromParent_Done,
     /* 160087 */   // Label 3114: @160087
     /* 160087 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(160193), // Rule ID 6199 //
     /* 160092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 160126 */     // MIs[1] Operand 1
     /* 160126 */     // No operand predicates
     /* 160126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160128 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 160128 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 160131 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 160135 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160140 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 160144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 160147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 160156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 160166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 160174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 160177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160192 */     // GIR_Coverage, 6199,
     /* 160192 */     GIR_EraseRootFromParent_Done,
     /* 160193 */   // Label 3115: @160193
     /* 160193 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(160299), // Rule ID 6200 //
     /* 160198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 160232 */     // MIs[1] Operand 1
     /* 160232 */     // No operand predicates
     /* 160232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160234 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 160234 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 160237 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 160241 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160246 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 160250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 160253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 160258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 160262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 160272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 160280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 160283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160298 */     // GIR_Coverage, 6200,
     /* 160298 */     GIR_EraseRootFromParent_Done,
     /* 160299 */   // Label 3116: @160299
     /* 160299 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(160405), // Rule ID 6201 //
     /* 160304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 160338 */     // MIs[1] Operand 1
     /* 160338 */     // No operand predicates
     /* 160338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160340 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 160340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 160343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 160347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160352 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 160356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 160359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 160368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 160378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 160386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 160389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160404 */     // GIR_Coverage, 6201,
     /* 160404 */     GIR_EraseRootFromParent_Done,
     /* 160405 */   // Label 3117: @160405
     /* 160405 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(160511), // Rule ID 6202 //
     /* 160410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 160444 */     // MIs[1] Operand 1
     /* 160444 */     // No operand predicates
     /* 160444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160446 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 160446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 160449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 160453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160458 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 160462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 160465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 160470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 160474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 160484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 160492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 160495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160510 */     // GIR_Coverage, 6202,
     /* 160510 */     GIR_EraseRootFromParent_Done,
     /* 160511 */   // Label 3118: @160511
     /* 160511 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(160566), // Rule ID 6899 //
     /* 160516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 160521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 160550 */     // MIs[1] Operand 1
     /* 160550 */     // No operand predicates
     /* 160550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160552 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
     /* 160552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
     /* 160555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
     /* 160557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 160559 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 160564 */     GIR_RootConstrainSelectedInstOperands,
     /* 160565 */     // GIR_Coverage, 6899,
     /* 160565 */     GIR_EraseRootFromParent_Done,
     /* 160566 */   // Label 3119: @160566
     /* 160566 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(160608), // Rule ID 3036 //
     /* 160571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 160579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 160582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 160585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160589 */     // MIs[0] Op2
     /* 160589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 160597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1770:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 160597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 160600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160606 */     GIR_RootConstrainSelectedInstOperands,
     /* 160607 */     // GIR_Coverage, 3036,
     /* 160607 */     GIR_EraseRootFromParent_Done,
     /* 160608 */   // Label 3120: @160608
     /* 160608 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(160650), // Rule ID 3037 //
     /* 160613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 160621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 160624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 160627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160631 */     // MIs[0] Op2
     /* 160631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 160639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1770:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 160639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 160642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160648 */     GIR_RootConstrainSelectedInstOperands,
     /* 160649 */     // GIR_Coverage, 3037,
     /* 160649 */     GIR_EraseRootFromParent_Done,
     /* 160650 */   // Label 3121: @160650
     /* 160650 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(160692), // Rule ID 3038 //
     /* 160655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 160663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 160666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 160669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160673 */     // MIs[0] Op2
     /* 160673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 160681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1770:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 160681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 160684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160690 */     GIR_RootConstrainSelectedInstOperands,
     /* 160691 */     // GIR_Coverage, 3038,
     /* 160691 */     GIR_EraseRootFromParent_Done,
     /* 160692 */   // Label 3122: @160692
     /* 160692 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(160734), // Rule ID 3072 //
     /* 160697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 160705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 160708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 160711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160715 */     // MIs[0] Op2
     /* 160715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 160723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1751:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 160723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 160726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160732 */     GIR_RootConstrainSelectedInstOperands,
     /* 160733 */     // GIR_Coverage, 3072,
     /* 160733 */     GIR_EraseRootFromParent_Done,
     /* 160734 */   // Label 3123: @160734
     /* 160734 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(160776), // Rule ID 3073 //
     /* 160739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 160747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 160750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 160753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160757 */     // MIs[0] Op2
     /* 160757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 160765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 160765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 160768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160774 */     GIR_RootConstrainSelectedInstOperands,
     /* 160775 */     // GIR_Coverage, 3073,
     /* 160775 */     GIR_EraseRootFromParent_Done,
     /* 160776 */   // Label 3124: @160776
     /* 160776 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(160818), // Rule ID 3074 //
     /* 160781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 160789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 160792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 160795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160799 */     // MIs[0] Op2
     /* 160799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 160807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 160807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 160810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160816 */     GIR_RootConstrainSelectedInstOperands,
     /* 160817 */     // GIR_Coverage, 3074,
     /* 160817 */     GIR_EraseRootFromParent_Done,
     /* 160818 */   // Label 3125: @160818
     /* 160818 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(160860), // Rule ID 3521 //
     /* 160823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 160826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 160831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 160834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 160837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160841 */     // MIs[0] Op2
     /* 160841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 160849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 160849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 160852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160858 */     GIR_RootConstrainSelectedInstOperands,
     /* 160859 */     // GIR_Coverage, 3521,
     /* 160859 */     GIR_EraseRootFromParent_Done,
     /* 160860 */   // Label 3126: @160860
     /* 160860 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(160902), // Rule ID 3522 //
     /* 160865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 160868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 160873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 160876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 160879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160883 */     // MIs[0] Op2
     /* 160883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 160891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 160891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 160894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160900 */     GIR_RootConstrainSelectedInstOperands,
     /* 160901 */     // GIR_Coverage, 3522,
     /* 160901 */     GIR_EraseRootFromParent_Done,
     /* 160902 */   // Label 3127: @160902
     /* 160902 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(160944), // Rule ID 3523 //
     /* 160907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 160910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 160915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 160918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 160921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160925 */     // MIs[0] Op2
     /* 160925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 160933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 160933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 160936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160942 */     GIR_RootConstrainSelectedInstOperands,
     /* 160943 */     // GIR_Coverage, 3523,
     /* 160943 */     GIR_EraseRootFromParent_Done,
     /* 160944 */   // Label 3128: @160944
     /* 160944 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(160986), // Rule ID 3524 //
     /* 160949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 160952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 160957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 160960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 160963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160967 */     // MIs[0] Op2
     /* 160967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 160975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1251:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 160975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 160978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160984 */     GIR_RootConstrainSelectedInstOperands,
     /* 160985 */     // GIR_Coverage, 3524,
     /* 160985 */     GIR_EraseRootFromParent_Done,
     /* 160986 */   // Label 3129: @160986
     /* 160986 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(161028), // Rule ID 3525 //
     /* 160991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 160994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 160999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 161002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161009 */     // MIs[0] Op2
     /* 161009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 161017 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1251:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 161017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 161020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161026 */     GIR_RootConstrainSelectedInstOperands,
     /* 161027 */     // GIR_Coverage, 3525,
     /* 161027 */     GIR_EraseRootFromParent_Done,
     /* 161028 */   // Label 3130: @161028
     /* 161028 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(161070), // Rule ID 3526 //
     /* 161033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 161036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 161041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 161044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161051 */     // MIs[0] Op2
     /* 161051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 161059 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1251:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 161059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 161062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161068 */     GIR_RootConstrainSelectedInstOperands,
     /* 161069 */     // GIR_Coverage, 3526,
     /* 161069 */     GIR_EraseRootFromParent_Done,
     /* 161070 */   // Label 3131: @161070
     /* 161070 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(161112), // Rule ID 3527 //
     /* 161075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 161078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 161083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 161086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161093 */     // MIs[0] Op2
     /* 161093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 161101 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1251:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 161101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 161104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161110 */     GIR_RootConstrainSelectedInstOperands,
     /* 161111 */     // GIR_Coverage, 3527,
     /* 161111 */     GIR_EraseRootFromParent_Done,
     /* 161112 */   // Label 3132: @161112
     /* 161112 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(161154), // Rule ID 11628 //
     /* 161117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 161125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 161128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161135 */     // MIs[0] Op2
     /* 161135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 161143 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 161143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 161146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161152 */     GIR_RootConstrainSelectedInstOperands,
     /* 161153 */     // GIR_Coverage, 11628,
     /* 161153 */     GIR_EraseRootFromParent_Done,
     /* 161154 */   // Label 3133: @161154
     /* 161154 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(161196), // Rule ID 11629 //
     /* 161159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 161167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 161170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161177 */     // MIs[0] Op2
     /* 161177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 161185 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 161185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 161188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161194 */     GIR_RootConstrainSelectedInstOperands,
     /* 161195 */     // GIR_Coverage, 11629,
     /* 161195 */     GIR_EraseRootFromParent_Done,
     /* 161196 */   // Label 3134: @161196
     /* 161196 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(161238), // Rule ID 11630 //
     /* 161201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 161209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 161212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161219 */     // MIs[0] Op2
     /* 161219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 161227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 161227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 161230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161236 */     GIR_RootConstrainSelectedInstOperands,
     /* 161237 */     // GIR_Coverage, 11630,
     /* 161237 */     GIR_EraseRootFromParent_Done,
     /* 161238 */   // Label 3135: @161238
     /* 161238 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(161280), // Rule ID 11631 //
     /* 161243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 161251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 161254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161261 */     // MIs[0] Op2
     /* 161261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 161269 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1624:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 161269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 161272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161278 */     GIR_RootConstrainSelectedInstOperands,
     /* 161279 */     // GIR_Coverage, 11631,
     /* 161279 */     GIR_EraseRootFromParent_Done,
     /* 161280 */   // Label 3136: @161280
     /* 161280 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(161322), // Rule ID 11632 //
     /* 161285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 161293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 161296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161303 */     // MIs[0] Op2
     /* 161303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 161311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1624:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 161311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 161314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161320 */     GIR_RootConstrainSelectedInstOperands,
     /* 161321 */     // GIR_Coverage, 11632,
     /* 161321 */     GIR_EraseRootFromParent_Done,
     /* 161322 */   // Label 3137: @161322
     /* 161322 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(161364), // Rule ID 11633 //
     /* 161327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 161335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 161338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161345 */     // MIs[0] Op2
     /* 161345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 161353 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1624:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 161353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 161356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161362 */     GIR_RootConstrainSelectedInstOperands,
     /* 161363 */     // GIR_Coverage, 11633,
     /* 161363 */     GIR_EraseRootFromParent_Done,
     /* 161364 */   // Label 3138: @161364
     /* 161364 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(161406), // Rule ID 11635 //
     /* 161369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 161377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 161380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161387 */     // MIs[0] Op2
     /* 161387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 161395 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1582:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 161395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 161398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161404 */     GIR_RootConstrainSelectedInstOperands,
     /* 161405 */     // GIR_Coverage, 11635,
     /* 161405 */     GIR_EraseRootFromParent_Done,
     /* 161406 */   // Label 3139: @161406
     /* 161406 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(161448), // Rule ID 11637 //
     /* 161411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 161419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 161422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161429 */     // MIs[0] Op2
     /* 161429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 161437 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1582:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 161437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 161440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161446 */     GIR_RootConstrainSelectedInstOperands,
     /* 161447 */     // GIR_Coverage, 11637,
     /* 161447 */     GIR_EraseRootFromParent_Done,
     /* 161448 */   // Label 3140: @161448
     /* 161448 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(161490), // Rule ID 11639 //
     /* 161453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 161461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 161464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161471 */     // MIs[0] Op2
     /* 161471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 161479 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1582:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 161479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 161482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161488 */     GIR_RootConstrainSelectedInstOperands,
     /* 161489 */     // GIR_Coverage, 11639,
     /* 161489 */     GIR_EraseRootFromParent_Done,
     /* 161490 */   // Label 3141: @161490
     /* 161490 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(161532), // Rule ID 11640 //
     /* 161495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 161503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 161506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161513 */     // MIs[0] Op2
     /* 161513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 161521 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 161521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 161524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161530 */     GIR_RootConstrainSelectedInstOperands,
     /* 161531 */     // GIR_Coverage, 11640,
     /* 161531 */     GIR_EraseRootFromParent_Done,
     /* 161532 */   // Label 3142: @161532
     /* 161532 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(161574), // Rule ID 11641 //
     /* 161537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 161545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 161548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161555 */     // MIs[0] Op2
     /* 161555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 161563 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 161563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 161566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161572 */     GIR_RootConstrainSelectedInstOperands,
     /* 161573 */     // GIR_Coverage, 11641,
     /* 161573 */     GIR_EraseRootFromParent_Done,
     /* 161574 */   // Label 3143: @161574
     /* 161574 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(161616), // Rule ID 11642 //
     /* 161579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 161587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 161590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161597 */     // MIs[0] Op2
     /* 161597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 161605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 161605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 161608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161614 */     GIR_RootConstrainSelectedInstOperands,
     /* 161615 */     // GIR_Coverage, 11642,
     /* 161615 */     GIR_EraseRootFromParent_Done,
     /* 161616 */   // Label 3144: @161616
     /* 161616 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(161658), // Rule ID 11643 //
     /* 161621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 161629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 161632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161639 */     // MIs[0] Op2
     /* 161639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 161647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1739:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 161647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 161650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161656 */     GIR_RootConstrainSelectedInstOperands,
     /* 161657 */     // GIR_Coverage, 11643,
     /* 161657 */     GIR_EraseRootFromParent_Done,
     /* 161658 */   // Label 3145: @161658
     /* 161658 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(161700), // Rule ID 11644 //
     /* 161663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 161671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 161674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161681 */     // MIs[0] Op2
     /* 161681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 161689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1739:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 161689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 161692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161698 */     GIR_RootConstrainSelectedInstOperands,
     /* 161699 */     // GIR_Coverage, 11644,
     /* 161699 */     GIR_EraseRootFromParent_Done,
     /* 161700 */   // Label 3146: @161700
     /* 161700 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(161742), // Rule ID 11645 //
     /* 161705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 161713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 161716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161723 */     // MIs[0] Op2
     /* 161723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 161731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1739:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 161731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 161734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161740 */     GIR_RootConstrainSelectedInstOperands,
     /* 161741 */     // GIR_Coverage, 11645,
     /* 161741 */     GIR_EraseRootFromParent_Done,
     /* 161742 */   // Label 3147: @161742
     /* 161742 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(161784), // Rule ID 11646 //
     /* 161747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 161755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 161758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161765 */     // MIs[0] Op2
     /* 161765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 161773 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1944:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 161773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 161776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161782 */     GIR_RootConstrainSelectedInstOperands,
     /* 161783 */     // GIR_Coverage, 11646,
     /* 161783 */     GIR_EraseRootFromParent_Done,
     /* 161784 */   // Label 3148: @161784
     /* 161784 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(161826), // Rule ID 11647 //
     /* 161789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 161797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 161800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161807 */     // MIs[0] Op2
     /* 161807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 161815 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 161815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 161818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161824 */     GIR_RootConstrainSelectedInstOperands,
     /* 161825 */     // GIR_Coverage, 11647,
     /* 161825 */     GIR_EraseRootFromParent_Done,
     /* 161826 */   // Label 3149: @161826
     /* 161826 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(161868), // Rule ID 11648 //
     /* 161831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 161839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 161842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161849 */     // MIs[0] Op2
     /* 161849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 161857 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 161857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 161860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161866 */     GIR_RootConstrainSelectedInstOperands,
     /* 161867 */     // GIR_Coverage, 11648,
     /* 161867 */     GIR_EraseRootFromParent_Done,
     /* 161868 */   // Label 3150: @161868
     /* 161868 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(161910), // Rule ID 11649 //
     /* 161873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 161881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 161884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161891 */     // MIs[0] Op2
     /* 161891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 161899 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1941:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 161899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 161902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161908 */     GIR_RootConstrainSelectedInstOperands,
     /* 161909 */     // GIR_Coverage, 11649,
     /* 161909 */     GIR_EraseRootFromParent_Done,
     /* 161910 */   // Label 3151: @161910
     /* 161910 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(161952), // Rule ID 11650 //
     /* 161915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 161923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 161926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161933 */     // MIs[0] Op2
     /* 161933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 161941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1941:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 161941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 161944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161950 */     GIR_RootConstrainSelectedInstOperands,
     /* 161951 */     // GIR_Coverage, 11650,
     /* 161951 */     GIR_EraseRootFromParent_Done,
     /* 161952 */   // Label 3152: @161952
     /* 161952 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(161994), // Rule ID 11651 //
     /* 161957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 161960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 161965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 161968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161975 */     // MIs[0] Op2
     /* 161975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 161983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 161983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 161986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 161988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 161990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 161992 */     GIR_RootConstrainSelectedInstOperands,
     /* 161993 */     // GIR_Coverage, 11651,
     /* 161993 */     GIR_EraseRootFromParent_Done,
     /* 161994 */   // Label 3153: @161994
     /* 161994 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(162036), // Rule ID 11709 //
     /* 161999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 162007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 162010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 162013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162017 */     // MIs[0] Op2
     /* 162017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 162025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1771:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 162025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 162028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162034 */     GIR_RootConstrainSelectedInstOperands,
     /* 162035 */     // GIR_Coverage, 11709,
     /* 162035 */     GIR_EraseRootFromParent_Done,
     /* 162036 */   // Label 3154: @162036
     /* 162036 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(162078), // Rule ID 11710 //
     /* 162041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 162049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 162052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 162055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162059 */     // MIs[0] Op2
     /* 162059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 162067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1771:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 162067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 162070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162076 */     GIR_RootConstrainSelectedInstOperands,
     /* 162077 */     // GIR_Coverage, 11710,
     /* 162077 */     GIR_EraseRootFromParent_Done,
     /* 162078 */   // Label 3155: @162078
     /* 162078 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(162120), // Rule ID 11711 //
     /* 162083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 162091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 162094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 162097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162101 */     // MIs[0] Op2
     /* 162101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 162109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1771:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 162109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 162112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162118 */     GIR_RootConstrainSelectedInstOperands,
     /* 162119 */     // GIR_Coverage, 11711,
     /* 162119 */     GIR_EraseRootFromParent_Done,
     /* 162120 */   // Label 3156: @162120
     /* 162120 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(162162), // Rule ID 11712 //
     /* 162125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 162133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 162136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 162139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162143 */     // MIs[0] Op2
     /* 162143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 162151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1964:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 162151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 162154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162160 */     GIR_RootConstrainSelectedInstOperands,
     /* 162161 */     // GIR_Coverage, 11712,
     /* 162161 */     GIR_EraseRootFromParent_Done,
     /* 162162 */   // Label 3157: @162162
     /* 162162 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(162204), // Rule ID 11713 //
     /* 162167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 162175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 162178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 162181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162185 */     // MIs[0] Op2
     /* 162185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 162193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 162193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 162196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162202 */     GIR_RootConstrainSelectedInstOperands,
     /* 162203 */     // GIR_Coverage, 11713,
     /* 162203 */     GIR_EraseRootFromParent_Done,
     /* 162204 */   // Label 3158: @162204
     /* 162204 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(162246), // Rule ID 11714 //
     /* 162209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 162217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 162220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 162223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162227 */     // MIs[0] Op2
     /* 162227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 162235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 162235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 162238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162244 */     GIR_RootConstrainSelectedInstOperands,
     /* 162245 */     // GIR_Coverage, 11714,
     /* 162245 */     GIR_EraseRootFromParent_Done,
     /* 162246 */   // Label 3159: @162246
     /* 162246 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(162288), // Rule ID 11715 //
     /* 162251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 162259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 162262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 162265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162269 */     // MIs[0] Op2
     /* 162269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 162277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1965:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 162277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 162280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162286 */     GIR_RootConstrainSelectedInstOperands,
     /* 162287 */     // GIR_Coverage, 11715,
     /* 162287 */     GIR_EraseRootFromParent_Done,
     /* 162288 */   // Label 3160: @162288
     /* 162288 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(162330), // Rule ID 11716 //
     /* 162293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 162301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 162304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 162307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162311 */     // MIs[0] Op2
     /* 162311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 162319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 162319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 162322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162328 */     GIR_RootConstrainSelectedInstOperands,
     /* 162329 */     // GIR_Coverage, 11716,
     /* 162329 */     GIR_EraseRootFromParent_Done,
     /* 162330 */   // Label 3161: @162330
     /* 162330 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(162372), // Rule ID 11717 //
     /* 162335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 162338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 162343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 162346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 162349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162353 */     // MIs[0] Op2
     /* 162353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 162361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1965:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 162361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 162364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 162366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 162368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 162370 */     GIR_RootConstrainSelectedInstOperands,
     /* 162371 */     // GIR_Coverage, 11717,
     /* 162371 */     GIR_EraseRootFromParent_Done,
     /* 162372 */   // Label 3162: @162372
     /* 162372 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(162424), // Rule ID 2123 //
     /* 162377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162410 */     // MIs[1] Operand 1
     /* 162410 */     // No operand predicates
     /* 162410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162412 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 162415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162422 */     GIR_RootConstrainSelectedInstOperands,
     /* 162423 */     // GIR_Coverage, 2123,
     /* 162423 */     GIR_EraseRootFromParent_Done,
     /* 162424 */   // Label 3163: @162424
     /* 162424 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(162476), // Rule ID 2124 //
     /* 162429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162462 */     // MIs[1] Operand 1
     /* 162462 */     // No operand predicates
     /* 162462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 162467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162474 */     GIR_RootConstrainSelectedInstOperands,
     /* 162475 */     // GIR_Coverage, 2124,
     /* 162475 */     GIR_EraseRootFromParent_Done,
     /* 162476 */   // Label 3164: @162476
     /* 162476 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(162528), // Rule ID 2125 //
     /* 162481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162514 */     // MIs[1] Operand 1
     /* 162514 */     // No operand predicates
     /* 162514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162516 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 162519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162526 */     GIR_RootConstrainSelectedInstOperands,
     /* 162527 */     // GIR_Coverage, 2125,
     /* 162527 */     GIR_EraseRootFromParent_Done,
     /* 162528 */   // Label 3165: @162528
     /* 162528 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(162580), // Rule ID 2126 //
     /* 162533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162566 */     // MIs[1] Operand 1
     /* 162566 */     // No operand predicates
     /* 162566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162568 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 162571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162578 */     GIR_RootConstrainSelectedInstOperands,
     /* 162579 */     // GIR_Coverage, 2126,
     /* 162579 */     GIR_EraseRootFromParent_Done,
     /* 162580 */   // Label 3166: @162580
     /* 162580 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(162632), // Rule ID 2127 //
     /* 162585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162618 */     // MIs[1] Operand 1
     /* 162618 */     // No operand predicates
     /* 162618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162620 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 162623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162630 */     GIR_RootConstrainSelectedInstOperands,
     /* 162631 */     // GIR_Coverage, 2127,
     /* 162631 */     GIR_EraseRootFromParent_Done,
     /* 162632 */   // Label 3167: @162632
     /* 162632 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(162684), // Rule ID 2128 //
     /* 162637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162670 */     // MIs[1] Operand 1
     /* 162670 */     // No operand predicates
     /* 162670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162672 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 162675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162682 */     GIR_RootConstrainSelectedInstOperands,
     /* 162683 */     // GIR_Coverage, 2128,
     /* 162683 */     GIR_EraseRootFromParent_Done,
     /* 162684 */   // Label 3168: @162684
     /* 162684 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(162736), // Rule ID 2129 //
     /* 162689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162722 */     // MIs[1] Operand 1
     /* 162722 */     // No operand predicates
     /* 162722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162724 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 162727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162734 */     GIR_RootConstrainSelectedInstOperands,
     /* 162735 */     // GIR_Coverage, 2129,
     /* 162735 */     GIR_EraseRootFromParent_Done,
     /* 162736 */   // Label 3169: @162736
     /* 162736 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(162788), // Rule ID 2130 //
     /* 162741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162774 */     // MIs[1] Operand 1
     /* 162774 */     // No operand predicates
     /* 162774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162776 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 162779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162786 */     GIR_RootConstrainSelectedInstOperands,
     /* 162787 */     // GIR_Coverage, 2130,
     /* 162787 */     GIR_EraseRootFromParent_Done,
     /* 162788 */   // Label 3170: @162788
     /* 162788 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(162840), // Rule ID 2131 //
     /* 162793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162826 */     // MIs[1] Operand 1
     /* 162826 */     // No operand predicates
     /* 162826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162828 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 162831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162838 */     GIR_RootConstrainSelectedInstOperands,
     /* 162839 */     // GIR_Coverage, 2131,
     /* 162839 */     GIR_EraseRootFromParent_Done,
     /* 162840 */   // Label 3171: @162840
     /* 162840 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(162892), // Rule ID 2132 //
     /* 162845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162878 */     // MIs[1] Operand 1
     /* 162878 */     // No operand predicates
     /* 162878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162880 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 162883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162890 */     GIR_RootConstrainSelectedInstOperands,
     /* 162891 */     // GIR_Coverage, 2132,
     /* 162891 */     GIR_EraseRootFromParent_Done,
     /* 162892 */   // Label 3172: @162892
     /* 162892 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(162944), // Rule ID 2133 //
     /* 162897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162930 */     // MIs[1] Operand 1
     /* 162930 */     // No operand predicates
     /* 162930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162932 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 162935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162942 */     GIR_RootConstrainSelectedInstOperands,
     /* 162943 */     // GIR_Coverage, 2133,
     /* 162943 */     GIR_EraseRootFromParent_Done,
     /* 162944 */   // Label 3173: @162944
     /* 162944 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(162996), // Rule ID 2134 //
     /* 162949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162982 */     // MIs[1] Operand 1
     /* 162982 */     // No operand predicates
     /* 162982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162984 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 162987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162994 */     GIR_RootConstrainSelectedInstOperands,
     /* 162995 */     // GIR_Coverage, 2134,
     /* 162995 */     GIR_EraseRootFromParent_Done,
     /* 162996 */   // Label 3174: @162996
     /* 162996 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(163048), // Rule ID 2135 //
     /* 163001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163034 */     // MIs[1] Operand 1
     /* 163034 */     // No operand predicates
     /* 163034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163036 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 163039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163046 */     GIR_RootConstrainSelectedInstOperands,
     /* 163047 */     // GIR_Coverage, 2135,
     /* 163047 */     GIR_EraseRootFromParent_Done,
     /* 163048 */   // Label 3175: @163048
     /* 163048 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(163100), // Rule ID 2136 //
     /* 163053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163086 */     // MIs[1] Operand 1
     /* 163086 */     // No operand predicates
     /* 163086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163088 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 163091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163098 */     GIR_RootConstrainSelectedInstOperands,
     /* 163099 */     // GIR_Coverage, 2136,
     /* 163099 */     GIR_EraseRootFromParent_Done,
     /* 163100 */   // Label 3176: @163100
     /* 163100 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(163152), // Rule ID 2137 //
     /* 163105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163138 */     // MIs[1] Operand 1
     /* 163138 */     // No operand predicates
     /* 163138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163140 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 163143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163150 */     GIR_RootConstrainSelectedInstOperands,
     /* 163151 */     // GIR_Coverage, 2137,
     /* 163151 */     GIR_EraseRootFromParent_Done,
     /* 163152 */   // Label 3177: @163152
     /* 163152 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(163204), // Rule ID 2235 //
     /* 163157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163190 */     // MIs[1] Operand 1
     /* 163190 */     // No operand predicates
     /* 163190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163192 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 163195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163202 */     GIR_RootConstrainSelectedInstOperands,
     /* 163203 */     // GIR_Coverage, 2235,
     /* 163203 */     GIR_EraseRootFromParent_Done,
     /* 163204 */   // Label 3178: @163204
     /* 163204 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(163256), // Rule ID 2236 //
     /* 163209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163242 */     // MIs[1] Operand 1
     /* 163242 */     // No operand predicates
     /* 163242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163244 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 163247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163254 */     GIR_RootConstrainSelectedInstOperands,
     /* 163255 */     // GIR_Coverage, 2236,
     /* 163255 */     GIR_EraseRootFromParent_Done,
     /* 163256 */   // Label 3179: @163256
     /* 163256 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(163308), // Rule ID 2237 //
     /* 163261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163294 */     // MIs[1] Operand 1
     /* 163294 */     // No operand predicates
     /* 163294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163296 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 163299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163306 */     GIR_RootConstrainSelectedInstOperands,
     /* 163307 */     // GIR_Coverage, 2237,
     /* 163307 */     GIR_EraseRootFromParent_Done,
     /* 163308 */   // Label 3180: @163308
     /* 163308 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(163360), // Rule ID 2238 //
     /* 163313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163346 */     // MIs[1] Operand 1
     /* 163346 */     // No operand predicates
     /* 163346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163348 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 163351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163358 */     GIR_RootConstrainSelectedInstOperands,
     /* 163359 */     // GIR_Coverage, 2238,
     /* 163359 */     GIR_EraseRootFromParent_Done,
     /* 163360 */   // Label 3181: @163360
     /* 163360 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(163412), // Rule ID 2239 //
     /* 163365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163398 */     // MIs[1] Operand 1
     /* 163398 */     // No operand predicates
     /* 163398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163400 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 163403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163410 */     GIR_RootConstrainSelectedInstOperands,
     /* 163411 */     // GIR_Coverage, 2239,
     /* 163411 */     GIR_EraseRootFromParent_Done,
     /* 163412 */   // Label 3182: @163412
     /* 163412 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(163457), // Rule ID 63 //
     /* 163417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 163420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 163425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 163438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 163442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 163446 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 163446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 163449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163455 */     GIR_RootConstrainSelectedInstOperands,
     /* 163456 */     // GIR_Coverage, 63,
     /* 163456 */     GIR_EraseRootFromParent_Done,
     /* 163457 */   // Label 3183: @163457
     /* 163457 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(163502), // Rule ID 129 //
     /* 163462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 163465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 163470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163491 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 163491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 163494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163500 */     GIR_RootConstrainSelectedInstOperands,
     /* 163501 */     // GIR_Coverage, 129,
     /* 163501 */     GIR_EraseRootFromParent_Done,
     /* 163502 */   // Label 3184: @163502
     /* 163502 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(163547), // Rule ID 130 //
     /* 163507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 163510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 163515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163536 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 163536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 163539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163545 */     GIR_RootConstrainSelectedInstOperands,
     /* 163546 */     // GIR_Coverage, 130,
     /* 163546 */     GIR_EraseRootFromParent_Done,
     /* 163547 */   // Label 3185: @163547
     /* 163547 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(163592), // Rule ID 131 //
     /* 163552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 163555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 163560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163581 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 163581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 163584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163590 */     GIR_RootConstrainSelectedInstOperands,
     /* 163591 */     // GIR_Coverage, 131,
     /* 163591 */     GIR_EraseRootFromParent_Done,
     /* 163592 */   // Label 3186: @163592
     /* 163592 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(163637), // Rule ID 132 //
     /* 163597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 163600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 163605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 163626 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 163626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 163629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163635 */     GIR_RootConstrainSelectedInstOperands,
     /* 163636 */     // GIR_Coverage, 132,
     /* 163636 */     GIR_EraseRootFromParent_Done,
     /* 163637 */   // Label 3187: @163637
     /* 163637 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(163682), // Rule ID 133 //
     /* 163642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 163645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 163650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163671 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 163671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 163674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163680 */     GIR_RootConstrainSelectedInstOperands,
     /* 163681 */     // GIR_Coverage, 133,
     /* 163681 */     GIR_EraseRootFromParent_Done,
     /* 163682 */   // Label 3188: @163682
     /* 163682 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(163727), // Rule ID 134 //
     /* 163687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 163690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 163695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163716 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 163716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 163719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163725 */     GIR_RootConstrainSelectedInstOperands,
     /* 163726 */     // GIR_Coverage, 134,
     /* 163726 */     GIR_EraseRootFromParent_Done,
     /* 163727 */   // Label 3189: @163727
     /* 163727 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(163772), // Rule ID 135 //
     /* 163732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 163735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 163740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163761 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 163761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 163764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163770 */     GIR_RootConstrainSelectedInstOperands,
     /* 163771 */     // GIR_Coverage, 135,
     /* 163771 */     GIR_EraseRootFromParent_Done,
     /* 163772 */   // Label 3190: @163772
     /* 163772 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(163817), // Rule ID 136 //
     /* 163777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 163780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 163785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 163806 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 163806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 163809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163815 */     GIR_RootConstrainSelectedInstOperands,
     /* 163816 */     // GIR_Coverage, 136,
     /* 163816 */     GIR_EraseRootFromParent_Done,
     /* 163817 */   // Label 3191: @163817
     /* 163817 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(163862), // Rule ID 1035 //
     /* 163822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 163830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 163833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 163836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 163839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163851 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 163851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 163854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 163858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 163860 */     GIR_RootConstrainSelectedInstOperands,
     /* 163861 */     // GIR_Coverage, 1035,
     /* 163861 */     GIR_EraseRootFromParent_Done,
     /* 163862 */   // Label 3192: @163862
     /* 163862 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(163907), // Rule ID 1036 //
     /* 163867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 163875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 163878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 163881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 163884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163896 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 163896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 163899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 163903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 163905 */     GIR_RootConstrainSelectedInstOperands,
     /* 163906 */     // GIR_Coverage, 1036,
     /* 163906 */     GIR_EraseRootFromParent_Done,
     /* 163907 */   // Label 3193: @163907
     /* 163907 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(163952), // Rule ID 1037 //
     /* 163912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 163920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163941 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 163941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 163944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 163948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 163950 */     GIR_RootConstrainSelectedInstOperands,
     /* 163951 */     // GIR_Coverage, 1037,
     /* 163951 */     GIR_EraseRootFromParent_Done,
     /* 163952 */   // Label 3194: @163952
     /* 163952 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(163997), // Rule ID 1038 //
     /* 163957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 163965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163986 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 163986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 163989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 163993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 163995 */     GIR_RootConstrainSelectedInstOperands,
     /* 163996 */     // GIR_Coverage, 1038,
     /* 163996 */     GIR_EraseRootFromParent_Done,
     /* 163997 */   // Label 3195: @163997
     /* 163997 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(164042), // Rule ID 1039 //
     /* 164002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 164010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164031 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 164031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 164034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164040 */     GIR_RootConstrainSelectedInstOperands,
     /* 164041 */     // GIR_Coverage, 1039,
     /* 164041 */     GIR_EraseRootFromParent_Done,
     /* 164042 */   // Label 3196: @164042
     /* 164042 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(164087), // Rule ID 1040 //
     /* 164047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 164055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164076 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 164076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 164079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164085 */     GIR_RootConstrainSelectedInstOperands,
     /* 164086 */     // GIR_Coverage, 1040,
     /* 164086 */     GIR_EraseRootFromParent_Done,
     /* 164087 */   // Label 3197: @164087
     /* 164087 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(164132), // Rule ID 1041 //
     /* 164092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 164100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164121 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 164121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 164124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164130 */     GIR_RootConstrainSelectedInstOperands,
     /* 164131 */     // GIR_Coverage, 1041,
     /* 164131 */     GIR_EraseRootFromParent_Done,
     /* 164132 */   // Label 3198: @164132
     /* 164132 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(164177), // Rule ID 1083 //
     /* 164137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 164145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 164154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164166 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 164166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 164169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164175 */     GIR_RootConstrainSelectedInstOperands,
     /* 164176 */     // GIR_Coverage, 1083,
     /* 164176 */     GIR_EraseRootFromParent_Done,
     /* 164177 */   // Label 3199: @164177
     /* 164177 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(164222), // Rule ID 1084 //
     /* 164182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 164190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 164199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164211 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 164211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 164214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164220 */     GIR_RootConstrainSelectedInstOperands,
     /* 164221 */     // GIR_Coverage, 1084,
     /* 164221 */     GIR_EraseRootFromParent_Done,
     /* 164222 */   // Label 3200: @164222
     /* 164222 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(164267), // Rule ID 1085 //
     /* 164227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 164235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164256 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 164256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 164259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164265 */     GIR_RootConstrainSelectedInstOperands,
     /* 164266 */     // GIR_Coverage, 1085,
     /* 164266 */     GIR_EraseRootFromParent_Done,
     /* 164267 */   // Label 3201: @164267
     /* 164267 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(164312), // Rule ID 1086 //
     /* 164272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 164280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164301 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 164301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 164304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164310 */     GIR_RootConstrainSelectedInstOperands,
     /* 164311 */     // GIR_Coverage, 1086,
     /* 164311 */     GIR_EraseRootFromParent_Done,
     /* 164312 */   // Label 3202: @164312
     /* 164312 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(164357), // Rule ID 1087 //
     /* 164317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 164325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164346 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 164346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 164349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164355 */     GIR_RootConstrainSelectedInstOperands,
     /* 164356 */     // GIR_Coverage, 1087,
     /* 164356 */     GIR_EraseRootFromParent_Done,
     /* 164357 */   // Label 3203: @164357
     /* 164357 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(164402), // Rule ID 1088 //
     /* 164362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 164370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164391 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 164391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 164394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164400 */     GIR_RootConstrainSelectedInstOperands,
     /* 164401 */     // GIR_Coverage, 1088,
     /* 164401 */     GIR_EraseRootFromParent_Done,
     /* 164402 */   // Label 3204: @164402
     /* 164402 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(164447), // Rule ID 1089 //
     /* 164407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 164415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164436 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 164436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 164439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 164445 */     GIR_RootConstrainSelectedInstOperands,
     /* 164446 */     // GIR_Coverage, 1089,
     /* 164446 */     GIR_EraseRootFromParent_Done,
     /* 164447 */   // Label 3205: @164447
     /* 164447 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(164492), // Rule ID 1101 //
     /* 164452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 164460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 164469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164481 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 164481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 164484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164490 */     GIR_RootConstrainSelectedInstOperands,
     /* 164491 */     // GIR_Coverage, 1101,
     /* 164491 */     GIR_EraseRootFromParent_Done,
     /* 164492 */   // Label 3206: @164492
     /* 164492 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(164537), // Rule ID 1103 //
     /* 164497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 164505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 164514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164526 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 164526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 164529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164535 */     GIR_RootConstrainSelectedInstOperands,
     /* 164536 */     // GIR_Coverage, 1103,
     /* 164536 */     GIR_EraseRootFromParent_Done,
     /* 164537 */   // Label 3207: @164537
     /* 164537 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(164582), // Rule ID 1105 //
     /* 164542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 164550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164571 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 164571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 164574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164580 */     GIR_RootConstrainSelectedInstOperands,
     /* 164581 */     // GIR_Coverage, 1105,
     /* 164581 */     GIR_EraseRootFromParent_Done,
     /* 164582 */   // Label 3208: @164582
     /* 164582 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(164627), // Rule ID 1107 //
     /* 164587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 164595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164616 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 164616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 164619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164625 */     GIR_RootConstrainSelectedInstOperands,
     /* 164626 */     // GIR_Coverage, 1107,
     /* 164626 */     GIR_EraseRootFromParent_Done,
     /* 164627 */   // Label 3209: @164627
     /* 164627 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(164672), // Rule ID 1109 //
     /* 164632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 164640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164661 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 164661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 164664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164670 */     GIR_RootConstrainSelectedInstOperands,
     /* 164671 */     // GIR_Coverage, 1109,
     /* 164671 */     GIR_EraseRootFromParent_Done,
     /* 164672 */   // Label 3210: @164672
     /* 164672 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(164717), // Rule ID 1111 //
     /* 164677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 164685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164706 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 164706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 164709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164715 */     GIR_RootConstrainSelectedInstOperands,
     /* 164716 */     // GIR_Coverage, 1111,
     /* 164716 */     GIR_EraseRootFromParent_Done,
     /* 164717 */   // Label 3211: @164717
     /* 164717 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(164762), // Rule ID 1113 //
     /* 164722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 164730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164751 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 164751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 164754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164760 */     GIR_RootConstrainSelectedInstOperands,
     /* 164761 */     // GIR_Coverage, 1113,
     /* 164761 */     GIR_EraseRootFromParent_Done,
     /* 164762 */   // Label 3212: @164762
     /* 164762 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(164807), // Rule ID 1156 //
     /* 164767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 164775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164796 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 164799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164805 */     GIR_RootConstrainSelectedInstOperands,
     /* 164806 */     // GIR_Coverage, 1156,
     /* 164806 */     GIR_EraseRootFromParent_Done,
     /* 164807 */   // Label 3213: @164807
     /* 164807 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(164852), // Rule ID 1157 //
     /* 164812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 164820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164841 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 164844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164850 */     GIR_RootConstrainSelectedInstOperands,
     /* 164851 */     // GIR_Coverage, 1157,
     /* 164851 */     GIR_EraseRootFromParent_Done,
     /* 164852 */   // Label 3214: @164852
     /* 164852 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(164897), // Rule ID 1158 //
     /* 164857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 164865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164886 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 164889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164895 */     GIR_RootConstrainSelectedInstOperands,
     /* 164896 */     // GIR_Coverage, 1158,
     /* 164896 */     GIR_EraseRootFromParent_Done,
     /* 164897 */   // Label 3215: @164897
     /* 164897 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(164942), // Rule ID 1159 //
     /* 164902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 164910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164931 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 164934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164940 */     GIR_RootConstrainSelectedInstOperands,
     /* 164941 */     // GIR_Coverage, 1159,
     /* 164941 */     GIR_EraseRootFromParent_Done,
     /* 164942 */   // Label 3216: @164942
     /* 164942 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(164987), // Rule ID 1160 //
     /* 164947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 164955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164976 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 164979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164985 */     GIR_RootConstrainSelectedInstOperands,
     /* 164986 */     // GIR_Coverage, 1160,
     /* 164986 */     GIR_EraseRootFromParent_Done,
     /* 164987 */   // Label 3217: @164987
     /* 164987 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(165032), // Rule ID 1162 //
     /* 164992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 165000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165021 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 165021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 165024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165030 */     GIR_RootConstrainSelectedInstOperands,
     /* 165031 */     // GIR_Coverage, 1162,
     /* 165031 */     GIR_EraseRootFromParent_Done,
     /* 165032 */   // Label 3218: @165032
     /* 165032 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(165077), // Rule ID 1164 //
     /* 165037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 165045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165066 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 165066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 165069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165075 */     GIR_RootConstrainSelectedInstOperands,
     /* 165076 */     // GIR_Coverage, 1164,
     /* 165076 */     GIR_EraseRootFromParent_Done,
     /* 165077 */   // Label 3219: @165077
     /* 165077 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(165122), // Rule ID 1166 //
     /* 165082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 165090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165111 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 165111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 165114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165120 */     GIR_RootConstrainSelectedInstOperands,
     /* 165121 */     // GIR_Coverage, 1166,
     /* 165121 */     GIR_EraseRootFromParent_Done,
     /* 165122 */   // Label 3220: @165122
     /* 165122 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(165167), // Rule ID 1168 //
     /* 165127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 165135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165156 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 165156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 165159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165165 */     GIR_RootConstrainSelectedInstOperands,
     /* 165166 */     // GIR_Coverage, 1168,
     /* 165166 */     GIR_EraseRootFromParent_Done,
     /* 165167 */   // Label 3221: @165167
     /* 165167 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(165212), // Rule ID 1170 //
     /* 165172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 165180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 165189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165201 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 165201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 165204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165210 */     GIR_RootConstrainSelectedInstOperands,
     /* 165211 */     // GIR_Coverage, 1170,
     /* 165211 */     GIR_EraseRootFromParent_Done,
     /* 165212 */   // Label 3222: @165212
     /* 165212 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(165257), // Rule ID 1172 //
     /* 165217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 165225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165246 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 165246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 165249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165255 */     GIR_RootConstrainSelectedInstOperands,
     /* 165256 */     // GIR_Coverage, 1172,
     /* 165256 */     GIR_EraseRootFromParent_Done,
     /* 165257 */   // Label 3223: @165257
     /* 165257 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(165302), // Rule ID 1174 //
     /* 165262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 165270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165291 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 165291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 165294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165300 */     GIR_RootConstrainSelectedInstOperands,
     /* 165301 */     // GIR_Coverage, 1174,
     /* 165301 */     GIR_EraseRootFromParent_Done,
     /* 165302 */   // Label 3224: @165302
     /* 165302 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(165347), // Rule ID 1176 //
     /* 165307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 165315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165336 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 165336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 165339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165345 */     GIR_RootConstrainSelectedInstOperands,
     /* 165346 */     // GIR_Coverage, 1176,
     /* 165346 */     GIR_EraseRootFromParent_Done,
     /* 165347 */   // Label 3225: @165347
     /* 165347 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(165392), // Rule ID 1178 //
     /* 165352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 165360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165381 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 165381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 165384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165390 */     GIR_RootConstrainSelectedInstOperands,
     /* 165391 */     // GIR_Coverage, 1178,
     /* 165391 */     GIR_EraseRootFromParent_Done,
     /* 165392 */   // Label 3226: @165392
     /* 165392 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(165437), // Rule ID 1180 //
     /* 165397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 165405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 165414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165426 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 165426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 165429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165435 */     GIR_RootConstrainSelectedInstOperands,
     /* 165436 */     // GIR_Coverage, 1180,
     /* 165436 */     GIR_EraseRootFromParent_Done,
     /* 165437 */   // Label 3227: @165437
     /* 165437 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(165482), // Rule ID 1182 //
     /* 165442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 165450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165471 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 165471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 165474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165480 */     GIR_RootConstrainSelectedInstOperands,
     /* 165481 */     // GIR_Coverage, 1182,
     /* 165481 */     GIR_EraseRootFromParent_Done,
     /* 165482 */   // Label 3228: @165482
     /* 165482 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(165527), // Rule ID 1184 //
     /* 165487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 165495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165516 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 165516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 165519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165525 */     GIR_RootConstrainSelectedInstOperands,
     /* 165526 */     // GIR_Coverage, 1184,
     /* 165526 */     GIR_EraseRootFromParent_Done,
     /* 165527 */   // Label 3229: @165527
     /* 165527 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(165572), // Rule ID 1186 //
     /* 165532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 165540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165561 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 165561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 165564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165570 */     GIR_RootConstrainSelectedInstOperands,
     /* 165571 */     // GIR_Coverage, 1186,
     /* 165571 */     GIR_EraseRootFromParent_Done,
     /* 165572 */   // Label 3230: @165572
     /* 165572 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(165617), // Rule ID 1188 //
     /* 165577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 165585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165606 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 165606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 165609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165615 */     GIR_RootConstrainSelectedInstOperands,
     /* 165616 */     // GIR_Coverage, 1188,
     /* 165616 */     GIR_EraseRootFromParent_Done,
     /* 165617 */   // Label 3231: @165617
     /* 165617 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(165662), // Rule ID 1190 //
     /* 165622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 165630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 165639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165651 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 165651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 165654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165660 */     GIR_RootConstrainSelectedInstOperands,
     /* 165661 */     // GIR_Coverage, 1190,
     /* 165661 */     GIR_EraseRootFromParent_Done,
     /* 165662 */   // Label 3232: @165662
     /* 165662 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(165707), // Rule ID 1226 //
     /* 165667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 165675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165696 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 165696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 165699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165705 */     GIR_RootConstrainSelectedInstOperands,
     /* 165706 */     // GIR_Coverage, 1226,
     /* 165706 */     GIR_EraseRootFromParent_Done,
     /* 165707 */   // Label 3233: @165707
     /* 165707 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(165752), // Rule ID 1227 //
     /* 165712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 165720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165741 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 165741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 165744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165750 */     GIR_RootConstrainSelectedInstOperands,
     /* 165751 */     // GIR_Coverage, 1227,
     /* 165751 */     GIR_EraseRootFromParent_Done,
     /* 165752 */   // Label 3234: @165752
     /* 165752 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(165797), // Rule ID 1228 //
     /* 165757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 165765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165786 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 165786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 165789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165795 */     GIR_RootConstrainSelectedInstOperands,
     /* 165796 */     // GIR_Coverage, 1228,
     /* 165796 */     GIR_EraseRootFromParent_Done,
     /* 165797 */   // Label 3235: @165797
     /* 165797 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(165842), // Rule ID 1229 //
     /* 165802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 165810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165831 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 165831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 165834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165840 */     GIR_RootConstrainSelectedInstOperands,
     /* 165841 */     // GIR_Coverage, 1229,
     /* 165841 */     GIR_EraseRootFromParent_Done,
     /* 165842 */   // Label 3236: @165842
     /* 165842 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(165887), // Rule ID 1230 //
     /* 165847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 165855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 165864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165876 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 165876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 165879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165885 */     GIR_RootConstrainSelectedInstOperands,
     /* 165886 */     // GIR_Coverage, 1230,
     /* 165886 */     GIR_EraseRootFromParent_Done,
     /* 165887 */   // Label 3237: @165887
     /* 165887 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(165932), // Rule ID 1241 //
     /* 165892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 165900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165921 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 165921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 165924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165930 */     GIR_RootConstrainSelectedInstOperands,
     /* 165931 */     // GIR_Coverage, 1241,
     /* 165931 */     GIR_EraseRootFromParent_Done,
     /* 165932 */   // Label 3238: @165932
     /* 165932 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(165977), // Rule ID 1242 //
     /* 165937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 165945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165966 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 165966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 165969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165975 */     GIR_RootConstrainSelectedInstOperands,
     /* 165976 */     // GIR_Coverage, 1242,
     /* 165976 */     GIR_EraseRootFromParent_Done,
     /* 165977 */   // Label 3239: @165977
     /* 165977 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(166022), // Rule ID 1243 //
     /* 165982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 165990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166011 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 166011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 166014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166020 */     GIR_RootConstrainSelectedInstOperands,
     /* 166021 */     // GIR_Coverage, 1243,
     /* 166021 */     GIR_EraseRootFromParent_Done,
     /* 166022 */   // Label 3240: @166022
     /* 166022 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(166067), // Rule ID 1244 //
     /* 166027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 166035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166056 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 166056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 166059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166065 */     GIR_RootConstrainSelectedInstOperands,
     /* 166066 */     // GIR_Coverage, 1244,
     /* 166066 */     GIR_EraseRootFromParent_Done,
     /* 166067 */   // Label 3241: @166067
     /* 166067 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(166112), // Rule ID 1245 //
     /* 166072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 166080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166101 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 166101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 166104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166110 */     GIR_RootConstrainSelectedInstOperands,
     /* 166111 */     // GIR_Coverage, 1245,
     /* 166111 */     GIR_EraseRootFromParent_Done,
     /* 166112 */   // Label 3242: @166112
     /* 166112 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(166157), // Rule ID 1256 //
     /* 166117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 166125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166146 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 166146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 166149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166155 */     GIR_RootConstrainSelectedInstOperands,
     /* 166156 */     // GIR_Coverage, 1256,
     /* 166156 */     GIR_EraseRootFromParent_Done,
     /* 166157 */   // Label 3243: @166157
     /* 166157 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(166202), // Rule ID 1257 //
     /* 166162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 166170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166191 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 166191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 166194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166200 */     GIR_RootConstrainSelectedInstOperands,
     /* 166201 */     // GIR_Coverage, 1257,
     /* 166201 */     GIR_EraseRootFromParent_Done,
     /* 166202 */   // Label 3244: @166202
     /* 166202 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(166247), // Rule ID 1258 //
     /* 166207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 166215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166236 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 166236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 166239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166245 */     GIR_RootConstrainSelectedInstOperands,
     /* 166246 */     // GIR_Coverage, 1258,
     /* 166246 */     GIR_EraseRootFromParent_Done,
     /* 166247 */   // Label 3245: @166247
     /* 166247 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(166292), // Rule ID 1259 //
     /* 166252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 166260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166281 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 166281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 166284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166290 */     GIR_RootConstrainSelectedInstOperands,
     /* 166291 */     // GIR_Coverage, 1259,
     /* 166291 */     GIR_EraseRootFromParent_Done,
     /* 166292 */   // Label 3246: @166292
     /* 166292 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(166337), // Rule ID 1260 //
     /* 166297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 166305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166326 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 166326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 166329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166335 */     GIR_RootConstrainSelectedInstOperands,
     /* 166336 */     // GIR_Coverage, 1260,
     /* 166336 */     GIR_EraseRootFromParent_Done,
     /* 166337 */   // Label 3247: @166337
     /* 166337 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(166382), // Rule ID 1271 //
     /* 166342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 166350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166371 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 166371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 166374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166380 */     GIR_RootConstrainSelectedInstOperands,
     /* 166381 */     // GIR_Coverage, 1271,
     /* 166381 */     GIR_EraseRootFromParent_Done,
     /* 166382 */   // Label 3248: @166382
     /* 166382 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(166427), // Rule ID 1272 //
     /* 166387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 166395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166416 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 166416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 166419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166425 */     GIR_RootConstrainSelectedInstOperands,
     /* 166426 */     // GIR_Coverage, 1272,
     /* 166426 */     GIR_EraseRootFromParent_Done,
     /* 166427 */   // Label 3249: @166427
     /* 166427 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(166472), // Rule ID 1273 //
     /* 166432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 166440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166461 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 166461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 166464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166470 */     GIR_RootConstrainSelectedInstOperands,
     /* 166471 */     // GIR_Coverage, 1273,
     /* 166471 */     GIR_EraseRootFromParent_Done,
     /* 166472 */   // Label 3250: @166472
     /* 166472 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(166517), // Rule ID 1274 //
     /* 166477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 166485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166506 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 166506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 166509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166515 */     GIR_RootConstrainSelectedInstOperands,
     /* 166516 */     // GIR_Coverage, 1274,
     /* 166516 */     GIR_EraseRootFromParent_Done,
     /* 166517 */   // Label 3251: @166517
     /* 166517 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(166562), // Rule ID 1275 //
     /* 166522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 166530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166551 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 166551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 166554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166560 */     GIR_RootConstrainSelectedInstOperands,
     /* 166561 */     // GIR_Coverage, 1275,
     /* 166561 */     GIR_EraseRootFromParent_Done,
     /* 166562 */   // Label 3252: @166562
     /* 166562 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(166607), // Rule ID 1306 //
     /* 166567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 166575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166596 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 166596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 166599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166605 */     GIR_RootConstrainSelectedInstOperands,
     /* 166606 */     // GIR_Coverage, 1306,
     /* 166606 */     GIR_EraseRootFromParent_Done,
     /* 166607 */   // Label 3253: @166607
     /* 166607 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(166652), // Rule ID 1307 //
     /* 166612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 166620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166641 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 166641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 166644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166650 */     GIR_RootConstrainSelectedInstOperands,
     /* 166651 */     // GIR_Coverage, 1307,
     /* 166651 */     GIR_EraseRootFromParent_Done,
     /* 166652 */   // Label 3254: @166652
     /* 166652 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(166697), // Rule ID 1308 //
     /* 166657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 166665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166686 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 166686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 166689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166695 */     GIR_RootConstrainSelectedInstOperands,
     /* 166696 */     // GIR_Coverage, 1308,
     /* 166696 */     GIR_EraseRootFromParent_Done,
     /* 166697 */   // Label 3255: @166697
     /* 166697 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(166742), // Rule ID 1309 //
     /* 166702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 166710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166731 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 166731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 166734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166740 */     GIR_RootConstrainSelectedInstOperands,
     /* 166741 */     // GIR_Coverage, 1309,
     /* 166741 */     GIR_EraseRootFromParent_Done,
     /* 166742 */   // Label 3256: @166742
     /* 166742 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(166787), // Rule ID 1310 //
     /* 166747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 166755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166776 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 166776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 166779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166785 */     GIR_RootConstrainSelectedInstOperands,
     /* 166786 */     // GIR_Coverage, 1310,
     /* 166786 */     GIR_EraseRootFromParent_Done,
     /* 166787 */   // Label 3257: @166787
     /* 166787 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(166832), // Rule ID 1321 //
     /* 166792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 166800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166821 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 166821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 166824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166830 */     GIR_RootConstrainSelectedInstOperands,
     /* 166831 */     // GIR_Coverage, 1321,
     /* 166831 */     GIR_EraseRootFromParent_Done,
     /* 166832 */   // Label 3258: @166832
     /* 166832 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(166877), // Rule ID 1322 //
     /* 166837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 166845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166866 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 166866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 166869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166875 */     GIR_RootConstrainSelectedInstOperands,
     /* 166876 */     // GIR_Coverage, 1322,
     /* 166876 */     GIR_EraseRootFromParent_Done,
     /* 166877 */   // Label 3259: @166877
     /* 166877 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(166922), // Rule ID 1323 //
     /* 166882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 166890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166911 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 166911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 166914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166920 */     GIR_RootConstrainSelectedInstOperands,
     /* 166921 */     // GIR_Coverage, 1323,
     /* 166921 */     GIR_EraseRootFromParent_Done,
     /* 166922 */   // Label 3260: @166922
     /* 166922 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(166967), // Rule ID 1324 //
     /* 166927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 166935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166956 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 166956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 166959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166965 */     GIR_RootConstrainSelectedInstOperands,
     /* 166966 */     // GIR_Coverage, 1324,
     /* 166966 */     GIR_EraseRootFromParent_Done,
     /* 166967 */   // Label 3261: @166967
     /* 166967 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(167012), // Rule ID 1325 //
     /* 166972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 166980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167001 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 167001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 167004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167010 */     GIR_RootConstrainSelectedInstOperands,
     /* 167011 */     // GIR_Coverage, 1325,
     /* 167011 */     GIR_EraseRootFromParent_Done,
     /* 167012 */   // Label 3262: @167012
     /* 167012 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(167057), // Rule ID 1326 //
     /* 167017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 167025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167046 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 167046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 167049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167055 */     GIR_RootConstrainSelectedInstOperands,
     /* 167056 */     // GIR_Coverage, 1326,
     /* 167056 */     GIR_EraseRootFromParent_Done,
     /* 167057 */   // Label 3263: @167057
     /* 167057 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(167102), // Rule ID 1327 //
     /* 167062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 167070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167091 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 167091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 167094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167100 */     GIR_RootConstrainSelectedInstOperands,
     /* 167101 */     // GIR_Coverage, 1327,
     /* 167101 */     GIR_EraseRootFromParent_Done,
     /* 167102 */   // Label 3264: @167102
     /* 167102 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(167147), // Rule ID 1328 //
     /* 167107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 167115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167136 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 167136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 167139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167145 */     GIR_RootConstrainSelectedInstOperands,
     /* 167146 */     // GIR_Coverage, 1328,
     /* 167146 */     GIR_EraseRootFromParent_Done,
     /* 167147 */   // Label 3265: @167147
     /* 167147 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(167192), // Rule ID 1329 //
     /* 167152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 167160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167181 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 167181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 167184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167190 */     GIR_RootConstrainSelectedInstOperands,
     /* 167191 */     // GIR_Coverage, 1329,
     /* 167191 */     GIR_EraseRootFromParent_Done,
     /* 167192 */   // Label 3266: @167192
     /* 167192 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(167237), // Rule ID 1330 //
     /* 167197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 167205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167226 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 167226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 167229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167235 */     GIR_RootConstrainSelectedInstOperands,
     /* 167236 */     // GIR_Coverage, 1330,
     /* 167236 */     GIR_EraseRootFromParent_Done,
     /* 167237 */   // Label 3267: @167237
     /* 167237 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(167282), // Rule ID 1347 //
     /* 167242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 167250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167271 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 167274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167280 */     GIR_RootConstrainSelectedInstOperands,
     /* 167281 */     // GIR_Coverage, 1347,
     /* 167281 */     GIR_EraseRootFromParent_Done,
     /* 167282 */   // Label 3268: @167282
     /* 167282 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(167327), // Rule ID 1348 //
     /* 167287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 167295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167316 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 167319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167325 */     GIR_RootConstrainSelectedInstOperands,
     /* 167326 */     // GIR_Coverage, 1348,
     /* 167326 */     GIR_EraseRootFromParent_Done,
     /* 167327 */   // Label 3269: @167327
     /* 167327 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(167372), // Rule ID 1362 //
     /* 167332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 167340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167361 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 167364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167370 */     GIR_RootConstrainSelectedInstOperands,
     /* 167371 */     // GIR_Coverage, 1362,
     /* 167371 */     GIR_EraseRootFromParent_Done,
     /* 167372 */   // Label 3270: @167372
     /* 167372 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(167417), // Rule ID 1364 //
     /* 167377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 167385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167406 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 167409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167415 */     GIR_RootConstrainSelectedInstOperands,
     /* 167416 */     // GIR_Coverage, 1364,
     /* 167416 */     GIR_EraseRootFromParent_Done,
     /* 167417 */   // Label 3271: @167417
     /* 167417 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(167462), // Rule ID 1366 //
     /* 167422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 167430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167451 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 167454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167460 */     GIR_RootConstrainSelectedInstOperands,
     /* 167461 */     // GIR_Coverage, 1366,
     /* 167461 */     GIR_EraseRootFromParent_Done,
     /* 167462 */   // Label 3272: @167462
     /* 167462 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(167507), // Rule ID 1368 //
     /* 167467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 167475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167496 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 167499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167505 */     GIR_RootConstrainSelectedInstOperands,
     /* 167506 */     // GIR_Coverage, 1368,
     /* 167506 */     GIR_EraseRootFromParent_Done,
     /* 167507 */   // Label 3273: @167507
     /* 167507 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(167552), // Rule ID 1370 //
     /* 167512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 167520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167541 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 167544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167550 */     GIR_RootConstrainSelectedInstOperands,
     /* 167551 */     // GIR_Coverage, 1370,
     /* 167551 */     GIR_EraseRootFromParent_Done,
     /* 167552 */   // Label 3274: @167552
     /* 167552 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(167597), // Rule ID 1372 //
     /* 167557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 167565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167586 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 167589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167595 */     GIR_RootConstrainSelectedInstOperands,
     /* 167596 */     // GIR_Coverage, 1372,
     /* 167596 */     GIR_EraseRootFromParent_Done,
     /* 167597 */   // Label 3275: @167597
     /* 167597 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(167642), // Rule ID 1379 //
     /* 167602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 167610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167631 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 167634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167640 */     GIR_RootConstrainSelectedInstOperands,
     /* 167641 */     // GIR_Coverage, 1379,
     /* 167641 */     GIR_EraseRootFromParent_Done,
     /* 167642 */   // Label 3276: @167642
     /* 167642 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(167687), // Rule ID 1380 //
     /* 167647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 167655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167676 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 167679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167685 */     GIR_RootConstrainSelectedInstOperands,
     /* 167686 */     // GIR_Coverage, 1380,
     /* 167686 */     GIR_EraseRootFromParent_Done,
     /* 167687 */   // Label 3277: @167687
     /* 167687 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(167732), // Rule ID 1381 //
     /* 167692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 167700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167721 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 167724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167730 */     GIR_RootConstrainSelectedInstOperands,
     /* 167731 */     // GIR_Coverage, 1381,
     /* 167731 */     GIR_EraseRootFromParent_Done,
     /* 167732 */   // Label 3278: @167732
     /* 167732 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(167777), // Rule ID 1382 //
     /* 167737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 167745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167766 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 167769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167775 */     GIR_RootConstrainSelectedInstOperands,
     /* 167776 */     // GIR_Coverage, 1382,
     /* 167776 */     GIR_EraseRootFromParent_Done,
     /* 167777 */   // Label 3279: @167777
     /* 167777 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(167822), // Rule ID 1383 //
     /* 167782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 167790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167811 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 167814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167820 */     GIR_RootConstrainSelectedInstOperands,
     /* 167821 */     // GIR_Coverage, 1383,
     /* 167821 */     GIR_EraseRootFromParent_Done,
     /* 167822 */   // Label 3280: @167822
     /* 167822 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(167867), // Rule ID 1384 //
     /* 167827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 167835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167856 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 167859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167865 */     GIR_RootConstrainSelectedInstOperands,
     /* 167866 */     // GIR_Coverage, 1384,
     /* 167866 */     GIR_EraseRootFromParent_Done,
     /* 167867 */   // Label 3281: @167867
     /* 167867 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(167912), // Rule ID 1385 //
     /* 167872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 167880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167901 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 167904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167910 */     GIR_RootConstrainSelectedInstOperands,
     /* 167911 */     // GIR_Coverage, 1385,
     /* 167911 */     GIR_EraseRootFromParent_Done,
     /* 167912 */   // Label 3282: @167912
     /* 167912 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(167957), // Rule ID 1386 //
     /* 167917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 167925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167946 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 167949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167955 */     GIR_RootConstrainSelectedInstOperands,
     /* 167956 */     // GIR_Coverage, 1386,
     /* 167956 */     GIR_EraseRootFromParent_Done,
     /* 167957 */   // Label 3283: @167957
     /* 167957 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(168002), // Rule ID 1387 //
     /* 167962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 167970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167991 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 167994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168000 */     GIR_RootConstrainSelectedInstOperands,
     /* 168001 */     // GIR_Coverage, 1387,
     /* 168001 */     GIR_EraseRootFromParent_Done,
     /* 168002 */   // Label 3284: @168002
     /* 168002 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(168047), // Rule ID 1388 //
     /* 168007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 168015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168036 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 168039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168045 */     GIR_RootConstrainSelectedInstOperands,
     /* 168046 */     // GIR_Coverage, 1388,
     /* 168046 */     GIR_EraseRootFromParent_Done,
     /* 168047 */   // Label 3285: @168047
     /* 168047 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(168092), // Rule ID 1389 //
     /* 168052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 168060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168081 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 168084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168090 */     GIR_RootConstrainSelectedInstOperands,
     /* 168091 */     // GIR_Coverage, 1389,
     /* 168091 */     GIR_EraseRootFromParent_Done,
     /* 168092 */   // Label 3286: @168092
     /* 168092 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(168137), // Rule ID 1390 //
     /* 168097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 168105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168126 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 168129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168135 */     GIR_RootConstrainSelectedInstOperands,
     /* 168136 */     // GIR_Coverage, 1390,
     /* 168136 */     GIR_EraseRootFromParent_Done,
     /* 168137 */   // Label 3287: @168137
     /* 168137 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(168182), // Rule ID 1397 //
     /* 168142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 168150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168171 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 168174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168180 */     GIR_RootConstrainSelectedInstOperands,
     /* 168181 */     // GIR_Coverage, 1397,
     /* 168181 */     GIR_EraseRootFromParent_Done,
     /* 168182 */   // Label 3288: @168182
     /* 168182 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(168227), // Rule ID 1398 //
     /* 168187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 168195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168216 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 168219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168225 */     GIR_RootConstrainSelectedInstOperands,
     /* 168226 */     // GIR_Coverage, 1398,
     /* 168226 */     GIR_EraseRootFromParent_Done,
     /* 168227 */   // Label 3289: @168227
     /* 168227 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(168272), // Rule ID 1399 //
     /* 168232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 168240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168261 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 168264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168270 */     GIR_RootConstrainSelectedInstOperands,
     /* 168271 */     // GIR_Coverage, 1399,
     /* 168271 */     GIR_EraseRootFromParent_Done,
     /* 168272 */   // Label 3290: @168272
     /* 168272 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(168317), // Rule ID 1400 //
     /* 168277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 168285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168306 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 168309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168315 */     GIR_RootConstrainSelectedInstOperands,
     /* 168316 */     // GIR_Coverage, 1400,
     /* 168316 */     GIR_EraseRootFromParent_Done,
     /* 168317 */   // Label 3291: @168317
     /* 168317 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(168362), // Rule ID 1401 //
     /* 168322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 168330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168351 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 168354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168360 */     GIR_RootConstrainSelectedInstOperands,
     /* 168361 */     // GIR_Coverage, 1401,
     /* 168361 */     GIR_EraseRootFromParent_Done,
     /* 168362 */   // Label 3292: @168362
     /* 168362 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(168407), // Rule ID 1402 //
     /* 168367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 168375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168396 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 168399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168405 */     GIR_RootConstrainSelectedInstOperands,
     /* 168406 */     // GIR_Coverage, 1402,
     /* 168406 */     GIR_EraseRootFromParent_Done,
     /* 168407 */   // Label 3293: @168407
     /* 168407 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(168452), // Rule ID 1409 //
     /* 168412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 168420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168441 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 168444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168450 */     GIR_RootConstrainSelectedInstOperands,
     /* 168451 */     // GIR_Coverage, 1409,
     /* 168451 */     GIR_EraseRootFromParent_Done,
     /* 168452 */   // Label 3294: @168452
     /* 168452 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(168497), // Rule ID 1410 //
     /* 168457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 168465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168486 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 168489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168495 */     GIR_RootConstrainSelectedInstOperands,
     /* 168496 */     // GIR_Coverage, 1410,
     /* 168496 */     GIR_EraseRootFromParent_Done,
     /* 168497 */   // Label 3295: @168497
     /* 168497 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(168542), // Rule ID 1411 //
     /* 168502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 168510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168531 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 168534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168540 */     GIR_RootConstrainSelectedInstOperands,
     /* 168541 */     // GIR_Coverage, 1411,
     /* 168541 */     GIR_EraseRootFromParent_Done,
     /* 168542 */   // Label 3296: @168542
     /* 168542 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(168587), // Rule ID 1412 //
     /* 168547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 168555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168576 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 168579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168585 */     GIR_RootConstrainSelectedInstOperands,
     /* 168586 */     // GIR_Coverage, 1412,
     /* 168586 */     GIR_EraseRootFromParent_Done,
     /* 168587 */   // Label 3297: @168587
     /* 168587 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(168632), // Rule ID 1413 //
     /* 168592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 168600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168621 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 168624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168630 */     GIR_RootConstrainSelectedInstOperands,
     /* 168631 */     // GIR_Coverage, 1413,
     /* 168631 */     GIR_EraseRootFromParent_Done,
     /* 168632 */   // Label 3298: @168632
     /* 168632 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(168677), // Rule ID 1414 //
     /* 168637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 168645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168666 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 168669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168675 */     GIR_RootConstrainSelectedInstOperands,
     /* 168676 */     // GIR_Coverage, 1414,
     /* 168676 */     GIR_EraseRootFromParent_Done,
     /* 168677 */   // Label 3299: @168677
     /* 168677 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(168722), // Rule ID 1415 //
     /* 168682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 168690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168711 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 168714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168720 */     GIR_RootConstrainSelectedInstOperands,
     /* 168721 */     // GIR_Coverage, 1415,
     /* 168721 */     GIR_EraseRootFromParent_Done,
     /* 168722 */   // Label 3300: @168722
     /* 168722 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(168767), // Rule ID 1416 //
     /* 168727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 168735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168756 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 168759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168765 */     GIR_RootConstrainSelectedInstOperands,
     /* 168766 */     // GIR_Coverage, 1416,
     /* 168766 */     GIR_EraseRootFromParent_Done,
     /* 168767 */   // Label 3301: @168767
     /* 168767 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(168812), // Rule ID 1417 //
     /* 168772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 168780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168801 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 168804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168810 */     GIR_RootConstrainSelectedInstOperands,
     /* 168811 */     // GIR_Coverage, 1417,
     /* 168811 */     GIR_EraseRootFromParent_Done,
     /* 168812 */   // Label 3302: @168812
     /* 168812 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(168857), // Rule ID 1418 //
     /* 168817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 168825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168846 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 168849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168855 */     GIR_RootConstrainSelectedInstOperands,
     /* 168856 */     // GIR_Coverage, 1418,
     /* 168856 */     GIR_EraseRootFromParent_Done,
     /* 168857 */   // Label 3303: @168857
     /* 168857 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(168902), // Rule ID 1419 //
     /* 168862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 168870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168891 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 168894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168900 */     GIR_RootConstrainSelectedInstOperands,
     /* 168901 */     // GIR_Coverage, 1419,
     /* 168901 */     GIR_EraseRootFromParent_Done,
     /* 168902 */   // Label 3304: @168902
     /* 168902 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(168947), // Rule ID 1420 //
     /* 168907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 168915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168936 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 168939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168945 */     GIR_RootConstrainSelectedInstOperands,
     /* 168946 */     // GIR_Coverage, 1420,
     /* 168946 */     GIR_EraseRootFromParent_Done,
     /* 168947 */   // Label 3305: @168947
     /* 168947 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(168992), // Rule ID 1421 //
     /* 168952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 168960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168981 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 168984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168990 */     GIR_RootConstrainSelectedInstOperands,
     /* 168991 */     // GIR_Coverage, 1421,
     /* 168991 */     GIR_EraseRootFromParent_Done,
     /* 168992 */   // Label 3306: @168992
     /* 168992 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(169037), // Rule ID 1422 //
     /* 168997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 169005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169026 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 169029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169035 */     GIR_RootConstrainSelectedInstOperands,
     /* 169036 */     // GIR_Coverage, 1422,
     /* 169036 */     GIR_EraseRootFromParent_Done,
     /* 169037 */   // Label 3307: @169037
     /* 169037 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(169082), // Rule ID 1423 //
     /* 169042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 169050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169071 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 169074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169080 */     GIR_RootConstrainSelectedInstOperands,
     /* 169081 */     // GIR_Coverage, 1423,
     /* 169081 */     GIR_EraseRootFromParent_Done,
     /* 169082 */   // Label 3308: @169082
     /* 169082 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(169127), // Rule ID 1424 //
     /* 169087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 169095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169116 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 169119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169125 */     GIR_RootConstrainSelectedInstOperands,
     /* 169126 */     // GIR_Coverage, 1424,
     /* 169126 */     GIR_EraseRootFromParent_Done,
     /* 169127 */   // Label 3309: @169127
     /* 169127 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(169172), // Rule ID 1425 //
     /* 169132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 169140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 169164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169170 */     GIR_RootConstrainSelectedInstOperands,
     /* 169171 */     // GIR_Coverage, 1425,
     /* 169171 */     GIR_EraseRootFromParent_Done,
     /* 169172 */   // Label 3310: @169172
     /* 169172 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(169217), // Rule ID 1426 //
     /* 169177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 169185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169206 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 169209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169215 */     GIR_RootConstrainSelectedInstOperands,
     /* 169216 */     // GIR_Coverage, 1426,
     /* 169216 */     GIR_EraseRootFromParent_Done,
     /* 169217 */   // Label 3311: @169217
     /* 169217 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(169262), // Rule ID 1427 //
     /* 169222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 169230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169251 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 169254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169260 */     GIR_RootConstrainSelectedInstOperands,
     /* 169261 */     // GIR_Coverage, 1427,
     /* 169261 */     GIR_EraseRootFromParent_Done,
     /* 169262 */   // Label 3312: @169262
     /* 169262 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(169307), // Rule ID 1428 //
     /* 169267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 169275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169296 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 169299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169305 */     GIR_RootConstrainSelectedInstOperands,
     /* 169306 */     // GIR_Coverage, 1428,
     /* 169306 */     GIR_EraseRootFromParent_Done,
     /* 169307 */   // Label 3313: @169307
     /* 169307 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(169352), // Rule ID 1429 //
     /* 169312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 169320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169341 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 169344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169350 */     GIR_RootConstrainSelectedInstOperands,
     /* 169351 */     // GIR_Coverage, 1429,
     /* 169351 */     GIR_EraseRootFromParent_Done,
     /* 169352 */   // Label 3314: @169352
     /* 169352 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(169397), // Rule ID 1430 //
     /* 169357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 169365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169386 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 169386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 169389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169395 */     GIR_RootConstrainSelectedInstOperands,
     /* 169396 */     // GIR_Coverage, 1430,
     /* 169396 */     GIR_EraseRootFromParent_Done,
     /* 169397 */   // Label 3315: @169397
     /* 169397 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(169442), // Rule ID 1431 //
     /* 169402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 169410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169431 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 169434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169440 */     GIR_RootConstrainSelectedInstOperands,
     /* 169441 */     // GIR_Coverage, 1431,
     /* 169441 */     GIR_EraseRootFromParent_Done,
     /* 169442 */   // Label 3316: @169442
     /* 169442 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(169487), // Rule ID 1432 //
     /* 169447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 169455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169476 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 169479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169485 */     GIR_RootConstrainSelectedInstOperands,
     /* 169486 */     // GIR_Coverage, 1432,
     /* 169486 */     GIR_EraseRootFromParent_Done,
     /* 169487 */   // Label 3317: @169487
     /* 169487 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(169532), // Rule ID 1433 //
     /* 169492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 169500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169521 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 169524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169530 */     GIR_RootConstrainSelectedInstOperands,
     /* 169531 */     // GIR_Coverage, 1433,
     /* 169531 */     GIR_EraseRootFromParent_Done,
     /* 169532 */   // Label 3318: @169532
     /* 169532 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(169577), // Rule ID 1434 //
     /* 169537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 169545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169566 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 169569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169575 */     GIR_RootConstrainSelectedInstOperands,
     /* 169576 */     // GIR_Coverage, 1434,
     /* 169576 */     GIR_EraseRootFromParent_Done,
     /* 169577 */   // Label 3319: @169577
     /* 169577 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(169622), // Rule ID 1435 //
     /* 169582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 169590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169611 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 169614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169620 */     GIR_RootConstrainSelectedInstOperands,
     /* 169621 */     // GIR_Coverage, 1435,
     /* 169621 */     GIR_EraseRootFromParent_Done,
     /* 169622 */   // Label 3320: @169622
     /* 169622 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(169667), // Rule ID 1436 //
     /* 169627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 169635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 169659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169665 */     GIR_RootConstrainSelectedInstOperands,
     /* 169666 */     // GIR_Coverage, 1436,
     /* 169666 */     GIR_EraseRootFromParent_Done,
     /* 169667 */   // Label 3321: @169667
     /* 169667 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(169712), // Rule ID 1437 //
     /* 169672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 169680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169701 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 169701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 169704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169710 */     GIR_RootConstrainSelectedInstOperands,
     /* 169711 */     // GIR_Coverage, 1437,
     /* 169711 */     GIR_EraseRootFromParent_Done,
     /* 169712 */   // Label 3322: @169712
     /* 169712 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(169757), // Rule ID 1438 //
     /* 169717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 169725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169746 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 169749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169755 */     GIR_RootConstrainSelectedInstOperands,
     /* 169756 */     // GIR_Coverage, 1438,
     /* 169756 */     GIR_EraseRootFromParent_Done,
     /* 169757 */   // Label 3323: @169757
     /* 169757 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(169802), // Rule ID 1439 //
     /* 169762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 169770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169791 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 169794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169800 */     GIR_RootConstrainSelectedInstOperands,
     /* 169801 */     // GIR_Coverage, 1439,
     /* 169801 */     GIR_EraseRootFromParent_Done,
     /* 169802 */   // Label 3324: @169802
     /* 169802 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(169847), // Rule ID 1440 //
     /* 169807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 169815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169836 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 169839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169845 */     GIR_RootConstrainSelectedInstOperands,
     /* 169846 */     // GIR_Coverage, 1440,
     /* 169846 */     GIR_EraseRootFromParent_Done,
     /* 169847 */   // Label 3325: @169847
     /* 169847 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(169892), // Rule ID 1441 //
     /* 169852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 169860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169881 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 169884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169890 */     GIR_RootConstrainSelectedInstOperands,
     /* 169891 */     // GIR_Coverage, 1441,
     /* 169891 */     GIR_EraseRootFromParent_Done,
     /* 169892 */   // Label 3326: @169892
     /* 169892 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(169937), // Rule ID 1442 //
     /* 169897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 169905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169926 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 169929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169935 */     GIR_RootConstrainSelectedInstOperands,
     /* 169936 */     // GIR_Coverage, 1442,
     /* 169936 */     GIR_EraseRootFromParent_Done,
     /* 169937 */   // Label 3327: @169937
     /* 169937 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(169982), // Rule ID 1443 //
     /* 169942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 169950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169971 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 169974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169980 */     GIR_RootConstrainSelectedInstOperands,
     /* 169981 */     // GIR_Coverage, 1443,
     /* 169981 */     GIR_EraseRootFromParent_Done,
     /* 169982 */   // Label 3328: @169982
     /* 169982 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(170027), // Rule ID 1444 //
     /* 169987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 169995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170016 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 170019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170025 */     GIR_RootConstrainSelectedInstOperands,
     /* 170026 */     // GIR_Coverage, 1444,
     /* 170026 */     GIR_EraseRootFromParent_Done,
     /* 170027 */   // Label 3329: @170027
     /* 170027 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(170072), // Rule ID 1451 //
     /* 170032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 170040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170061 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 170064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170070 */     GIR_RootConstrainSelectedInstOperands,
     /* 170071 */     // GIR_Coverage, 1451,
     /* 170071 */     GIR_EraseRootFromParent_Done,
     /* 170072 */   // Label 3330: @170072
     /* 170072 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(170117), // Rule ID 1452 //
     /* 170077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 170085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170106 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 170109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170115 */     GIR_RootConstrainSelectedInstOperands,
     /* 170116 */     // GIR_Coverage, 1452,
     /* 170116 */     GIR_EraseRootFromParent_Done,
     /* 170117 */   // Label 3331: @170117
     /* 170117 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(170162), // Rule ID 1453 //
     /* 170122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 170130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170151 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 170154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170160 */     GIR_RootConstrainSelectedInstOperands,
     /* 170161 */     // GIR_Coverage, 1453,
     /* 170161 */     GIR_EraseRootFromParent_Done,
     /* 170162 */   // Label 3332: @170162
     /* 170162 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(170207), // Rule ID 1454 //
     /* 170167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 170175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170196 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 170199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170205 */     GIR_RootConstrainSelectedInstOperands,
     /* 170206 */     // GIR_Coverage, 1454,
     /* 170206 */     GIR_EraseRootFromParent_Done,
     /* 170207 */   // Label 3333: @170207
     /* 170207 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(170252), // Rule ID 1455 //
     /* 170212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 170220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170241 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 170244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170250 */     GIR_RootConstrainSelectedInstOperands,
     /* 170251 */     // GIR_Coverage, 1455,
     /* 170251 */     GIR_EraseRootFromParent_Done,
     /* 170252 */   // Label 3334: @170252
     /* 170252 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(170297), // Rule ID 1456 //
     /* 170257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 170265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170286 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 170289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170295 */     GIR_RootConstrainSelectedInstOperands,
     /* 170296 */     // GIR_Coverage, 1456,
     /* 170296 */     GIR_EraseRootFromParent_Done,
     /* 170297 */   // Label 3335: @170297
     /* 170297 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(170342), // Rule ID 1457 //
     /* 170302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 170310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170331 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 170334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170340 */     GIR_RootConstrainSelectedInstOperands,
     /* 170341 */     // GIR_Coverage, 1457,
     /* 170341 */     GIR_EraseRootFromParent_Done,
     /* 170342 */   // Label 3336: @170342
     /* 170342 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(170387), // Rule ID 1458 //
     /* 170347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 170355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170376 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 170379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170385 */     GIR_RootConstrainSelectedInstOperands,
     /* 170386 */     // GIR_Coverage, 1458,
     /* 170386 */     GIR_EraseRootFromParent_Done,
     /* 170387 */   // Label 3337: @170387
     /* 170387 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(170432), // Rule ID 1459 //
     /* 170392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 170400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170421 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 170424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170430 */     GIR_RootConstrainSelectedInstOperands,
     /* 170431 */     // GIR_Coverage, 1459,
     /* 170431 */     GIR_EraseRootFromParent_Done,
     /* 170432 */   // Label 3338: @170432
     /* 170432 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(170477), // Rule ID 1460 //
     /* 170437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 170445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170466 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 170469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170475 */     GIR_RootConstrainSelectedInstOperands,
     /* 170476 */     // GIR_Coverage, 1460,
     /* 170476 */     GIR_EraseRootFromParent_Done,
     /* 170477 */   // Label 3339: @170477
     /* 170477 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(170522), // Rule ID 1461 //
     /* 170482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 170490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170511 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 170514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170520 */     GIR_RootConstrainSelectedInstOperands,
     /* 170521 */     // GIR_Coverage, 1461,
     /* 170521 */     GIR_EraseRootFromParent_Done,
     /* 170522 */   // Label 3340: @170522
     /* 170522 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(170567), // Rule ID 1462 //
     /* 170527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 170535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170556 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 170559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170565 */     GIR_RootConstrainSelectedInstOperands,
     /* 170566 */     // GIR_Coverage, 1462,
     /* 170566 */     GIR_EraseRootFromParent_Done,
     /* 170567 */   // Label 3341: @170567
     /* 170567 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(170612), // Rule ID 1463 //
     /* 170572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 170580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170601 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 170604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170610 */     GIR_RootConstrainSelectedInstOperands,
     /* 170611 */     // GIR_Coverage, 1463,
     /* 170611 */     GIR_EraseRootFromParent_Done,
     /* 170612 */   // Label 3342: @170612
     /* 170612 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(170657), // Rule ID 1464 //
     /* 170617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 170625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170646 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 170649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170655 */     GIR_RootConstrainSelectedInstOperands,
     /* 170656 */     // GIR_Coverage, 1464,
     /* 170656 */     GIR_EraseRootFromParent_Done,
     /* 170657 */   // Label 3343: @170657
     /* 170657 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(170702), // Rule ID 1485 //
     /* 170662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 170670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170691 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 170694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170700 */     GIR_RootConstrainSelectedInstOperands,
     /* 170701 */     // GIR_Coverage, 1485,
     /* 170701 */     GIR_EraseRootFromParent_Done,
     /* 170702 */   // Label 3344: @170702
     /* 170702 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(170747), // Rule ID 1487 //
     /* 170707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 170715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170736 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 170739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170745 */     GIR_RootConstrainSelectedInstOperands,
     /* 170746 */     // GIR_Coverage, 1487,
     /* 170746 */     GIR_EraseRootFromParent_Done,
     /* 170747 */   // Label 3345: @170747
     /* 170747 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(170792), // Rule ID 1489 //
     /* 170752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 170760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170781 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 170784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170790 */     GIR_RootConstrainSelectedInstOperands,
     /* 170791 */     // GIR_Coverage, 1489,
     /* 170791 */     GIR_EraseRootFromParent_Done,
     /* 170792 */   // Label 3346: @170792
     /* 170792 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(170837), // Rule ID 1491 //
     /* 170797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 170805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170826 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 170829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170835 */     GIR_RootConstrainSelectedInstOperands,
     /* 170836 */     // GIR_Coverage, 1491,
     /* 170836 */     GIR_EraseRootFromParent_Done,
     /* 170837 */   // Label 3347: @170837
     /* 170837 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(170882), // Rule ID 1493 //
     /* 170842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 170850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170871 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 170874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170880 */     GIR_RootConstrainSelectedInstOperands,
     /* 170881 */     // GIR_Coverage, 1493,
     /* 170881 */     GIR_EraseRootFromParent_Done,
     /* 170882 */   // Label 3348: @170882
     /* 170882 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(170927), // Rule ID 1495 //
     /* 170887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 170895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 170919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170925 */     GIR_RootConstrainSelectedInstOperands,
     /* 170926 */     // GIR_Coverage, 1495,
     /* 170926 */     GIR_EraseRootFromParent_Done,
     /* 170927 */   // Label 3349: @170927
     /* 170927 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(170972), // Rule ID 1502 //
     /* 170932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 170940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170961 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 170964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170970 */     GIR_RootConstrainSelectedInstOperands,
     /* 170971 */     // GIR_Coverage, 1502,
     /* 170971 */     GIR_EraseRootFromParent_Done,
     /* 170972 */   // Label 3350: @170972
     /* 170972 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(171017), // Rule ID 1503 //
     /* 170977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 170985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171006 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 171009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171015 */     GIR_RootConstrainSelectedInstOperands,
     /* 171016 */     // GIR_Coverage, 1503,
     /* 171016 */     GIR_EraseRootFromParent_Done,
     /* 171017 */   // Label 3351: @171017
     /* 171017 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(171062), // Rule ID 1504 //
     /* 171022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 171030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171051 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 171054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171060 */     GIR_RootConstrainSelectedInstOperands,
     /* 171061 */     // GIR_Coverage, 1504,
     /* 171061 */     GIR_EraseRootFromParent_Done,
     /* 171062 */   // Label 3352: @171062
     /* 171062 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(171107), // Rule ID 1505 //
     /* 171067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 171075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171096 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 171099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171105 */     GIR_RootConstrainSelectedInstOperands,
     /* 171106 */     // GIR_Coverage, 1505,
     /* 171106 */     GIR_EraseRootFromParent_Done,
     /* 171107 */   // Label 3353: @171107
     /* 171107 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(171152), // Rule ID 1506 //
     /* 171112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 171120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171141 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 171144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171150 */     GIR_RootConstrainSelectedInstOperands,
     /* 171151 */     // GIR_Coverage, 1506,
     /* 171151 */     GIR_EraseRootFromParent_Done,
     /* 171152 */   // Label 3354: @171152
     /* 171152 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(171197), // Rule ID 1507 //
     /* 171157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 171165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171186 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 171189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171195 */     GIR_RootConstrainSelectedInstOperands,
     /* 171196 */     // GIR_Coverage, 1507,
     /* 171196 */     GIR_EraseRootFromParent_Done,
     /* 171197 */   // Label 3355: @171197
     /* 171197 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(171242), // Rule ID 1508 //
     /* 171202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 171210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171231 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 171234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171240 */     GIR_RootConstrainSelectedInstOperands,
     /* 171241 */     // GIR_Coverage, 1508,
     /* 171241 */     GIR_EraseRootFromParent_Done,
     /* 171242 */   // Label 3356: @171242
     /* 171242 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(171287), // Rule ID 1509 //
     /* 171247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 171255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171276 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 171279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171285 */     GIR_RootConstrainSelectedInstOperands,
     /* 171286 */     // GIR_Coverage, 1509,
     /* 171286 */     GIR_EraseRootFromParent_Done,
     /* 171287 */   // Label 3357: @171287
     /* 171287 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(171332), // Rule ID 1510 //
     /* 171292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 171300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171321 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 171324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171330 */     GIR_RootConstrainSelectedInstOperands,
     /* 171331 */     // GIR_Coverage, 1510,
     /* 171331 */     GIR_EraseRootFromParent_Done,
     /* 171332 */   // Label 3358: @171332
     /* 171332 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(171377), // Rule ID 1511 //
     /* 171337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 171345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171366 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 171369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171375 */     GIR_RootConstrainSelectedInstOperands,
     /* 171376 */     // GIR_Coverage, 1511,
     /* 171376 */     GIR_EraseRootFromParent_Done,
     /* 171377 */   // Label 3359: @171377
     /* 171377 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(171422), // Rule ID 1512 //
     /* 171382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 171390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171411 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 171414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171420 */     GIR_RootConstrainSelectedInstOperands,
     /* 171421 */     // GIR_Coverage, 1512,
     /* 171421 */     GIR_EraseRootFromParent_Done,
     /* 171422 */   // Label 3360: @171422
     /* 171422 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(171467), // Rule ID 1513 //
     /* 171427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 171435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171456 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 171459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171465 */     GIR_RootConstrainSelectedInstOperands,
     /* 171466 */     // GIR_Coverage, 1513,
     /* 171466 */     GIR_EraseRootFromParent_Done,
     /* 171467 */   // Label 3361: @171467
     /* 171467 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(171512), // Rule ID 1520 //
     /* 171472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 171480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171501 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 171504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171510 */     GIR_RootConstrainSelectedInstOperands,
     /* 171511 */     // GIR_Coverage, 1520,
     /* 171511 */     GIR_EraseRootFromParent_Done,
     /* 171512 */   // Label 3362: @171512
     /* 171512 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(171557), // Rule ID 1521 //
     /* 171517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 171525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171546 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 171549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171555 */     GIR_RootConstrainSelectedInstOperands,
     /* 171556 */     // GIR_Coverage, 1521,
     /* 171556 */     GIR_EraseRootFromParent_Done,
     /* 171557 */   // Label 3363: @171557
     /* 171557 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(171602), // Rule ID 1522 //
     /* 171562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 171570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171591 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 171594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171600 */     GIR_RootConstrainSelectedInstOperands,
     /* 171601 */     // GIR_Coverage, 1522,
     /* 171601 */     GIR_EraseRootFromParent_Done,
     /* 171602 */   // Label 3364: @171602
     /* 171602 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(171647), // Rule ID 1523 //
     /* 171607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 171615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171636 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 171639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171645 */     GIR_RootConstrainSelectedInstOperands,
     /* 171646 */     // GIR_Coverage, 1523,
     /* 171646 */     GIR_EraseRootFromParent_Done,
     /* 171647 */   // Label 3365: @171647
     /* 171647 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(171692), // Rule ID 1524 //
     /* 171652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 171660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171681 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 171684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171690 */     GIR_RootConstrainSelectedInstOperands,
     /* 171691 */     // GIR_Coverage, 1524,
     /* 171691 */     GIR_EraseRootFromParent_Done,
     /* 171692 */   // Label 3366: @171692
     /* 171692 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(171737), // Rule ID 1525 //
     /* 171697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 171705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171726 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 171729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171735 */     GIR_RootConstrainSelectedInstOperands,
     /* 171736 */     // GIR_Coverage, 1525,
     /* 171736 */     GIR_EraseRootFromParent_Done,
     /* 171737 */   // Label 3367: @171737
     /* 171737 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(171782), // Rule ID 1532 //
     /* 171742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 171750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171771 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 171774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171780 */     GIR_RootConstrainSelectedInstOperands,
     /* 171781 */     // GIR_Coverage, 1532,
     /* 171781 */     GIR_EraseRootFromParent_Done,
     /* 171782 */   // Label 3368: @171782
     /* 171782 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(171827), // Rule ID 1533 //
     /* 171787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 171795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171816 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 171819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171825 */     GIR_RootConstrainSelectedInstOperands,
     /* 171826 */     // GIR_Coverage, 1533,
     /* 171826 */     GIR_EraseRootFromParent_Done,
     /* 171827 */   // Label 3369: @171827
     /* 171827 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(171872), // Rule ID 1534 //
     /* 171832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 171840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171861 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 171864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171870 */     GIR_RootConstrainSelectedInstOperands,
     /* 171871 */     // GIR_Coverage, 1534,
     /* 171871 */     GIR_EraseRootFromParent_Done,
     /* 171872 */   // Label 3370: @171872
     /* 171872 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(171917), // Rule ID 1535 //
     /* 171877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 171885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171906 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 171909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171915 */     GIR_RootConstrainSelectedInstOperands,
     /* 171916 */     // GIR_Coverage, 1535,
     /* 171916 */     GIR_EraseRootFromParent_Done,
     /* 171917 */   // Label 3371: @171917
     /* 171917 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(171962), // Rule ID 1536 //
     /* 171922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 171930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171951 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 171954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171960 */     GIR_RootConstrainSelectedInstOperands,
     /* 171961 */     // GIR_Coverage, 1536,
     /* 171961 */     GIR_EraseRootFromParent_Done,
     /* 171962 */   // Label 3372: @171962
     /* 171962 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(172007), // Rule ID 1537 //
     /* 171967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 171975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171996 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 171999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172005 */     GIR_RootConstrainSelectedInstOperands,
     /* 172006 */     // GIR_Coverage, 1537,
     /* 172006 */     GIR_EraseRootFromParent_Done,
     /* 172007 */   // Label 3373: @172007
     /* 172007 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(172052), // Rule ID 1538 //
     /* 172012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 172020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172041 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 172044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172050 */     GIR_RootConstrainSelectedInstOperands,
     /* 172051 */     // GIR_Coverage, 1538,
     /* 172051 */     GIR_EraseRootFromParent_Done,
     /* 172052 */   // Label 3374: @172052
     /* 172052 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(172097), // Rule ID 1539 //
     /* 172057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172086 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 172089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172095 */     GIR_RootConstrainSelectedInstOperands,
     /* 172096 */     // GIR_Coverage, 1539,
     /* 172096 */     GIR_EraseRootFromParent_Done,
     /* 172097 */   // Label 3375: @172097
     /* 172097 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(172142), // Rule ID 1540 //
     /* 172102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172131 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 172134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172140 */     GIR_RootConstrainSelectedInstOperands,
     /* 172141 */     // GIR_Coverage, 1540,
     /* 172141 */     GIR_EraseRootFromParent_Done,
     /* 172142 */   // Label 3376: @172142
     /* 172142 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(172187), // Rule ID 1541 //
     /* 172147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172176 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 172179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172185 */     GIR_RootConstrainSelectedInstOperands,
     /* 172186 */     // GIR_Coverage, 1541,
     /* 172186 */     GIR_EraseRootFromParent_Done,
     /* 172187 */   // Label 3377: @172187
     /* 172187 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(172232), // Rule ID 1542 //
     /* 172192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172221 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 172224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172230 */     GIR_RootConstrainSelectedInstOperands,
     /* 172231 */     // GIR_Coverage, 1542,
     /* 172231 */     GIR_EraseRootFromParent_Done,
     /* 172232 */   // Label 3378: @172232
     /* 172232 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(172277), // Rule ID 1543 //
     /* 172237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172266 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 172269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172275 */     GIR_RootConstrainSelectedInstOperands,
     /* 172276 */     // GIR_Coverage, 1543,
     /* 172276 */     GIR_EraseRootFromParent_Done,
     /* 172277 */   // Label 3379: @172277
     /* 172277 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(172322), // Rule ID 1544 //
     /* 172282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172311 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 172314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172320 */     GIR_RootConstrainSelectedInstOperands,
     /* 172321 */     // GIR_Coverage, 1544,
     /* 172321 */     GIR_EraseRootFromParent_Done,
     /* 172322 */   // Label 3380: @172322
     /* 172322 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(172367), // Rule ID 1545 //
     /* 172327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172356 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 172359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172365 */     GIR_RootConstrainSelectedInstOperands,
     /* 172366 */     // GIR_Coverage, 1545,
     /* 172366 */     GIR_EraseRootFromParent_Done,
     /* 172367 */   // Label 3381: @172367
     /* 172367 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(172412), // Rule ID 1546 //
     /* 172372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172401 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 172404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172410 */     GIR_RootConstrainSelectedInstOperands,
     /* 172411 */     // GIR_Coverage, 1546,
     /* 172411 */     GIR_EraseRootFromParent_Done,
     /* 172412 */   // Label 3382: @172412
     /* 172412 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(172457), // Rule ID 1547 //
     /* 172417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172446 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 172449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172455 */     GIR_RootConstrainSelectedInstOperands,
     /* 172456 */     // GIR_Coverage, 1547,
     /* 172456 */     GIR_EraseRootFromParent_Done,
     /* 172457 */   // Label 3383: @172457
     /* 172457 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(172502), // Rule ID 1548 //
     /* 172462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172491 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 172494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172500 */     GIR_RootConstrainSelectedInstOperands,
     /* 172501 */     // GIR_Coverage, 1548,
     /* 172501 */     GIR_EraseRootFromParent_Done,
     /* 172502 */   // Label 3384: @172502
     /* 172502 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(172547), // Rule ID 1549 //
     /* 172507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172536 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 172539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172545 */     GIR_RootConstrainSelectedInstOperands,
     /* 172546 */     // GIR_Coverage, 1549,
     /* 172546 */     GIR_EraseRootFromParent_Done,
     /* 172547 */   // Label 3385: @172547
     /* 172547 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(172592), // Rule ID 1550 //
     /* 172552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172581 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 172584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172590 */     GIR_RootConstrainSelectedInstOperands,
     /* 172591 */     // GIR_Coverage, 1550,
     /* 172591 */     GIR_EraseRootFromParent_Done,
     /* 172592 */   // Label 3386: @172592
     /* 172592 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(172637), // Rule ID 1551 //
     /* 172597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172626 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 172629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172635 */     GIR_RootConstrainSelectedInstOperands,
     /* 172636 */     // GIR_Coverage, 1551,
     /* 172636 */     GIR_EraseRootFromParent_Done,
     /* 172637 */   // Label 3387: @172637
     /* 172637 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(172682), // Rule ID 1552 //
     /* 172642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172671 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 172674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172680 */     GIR_RootConstrainSelectedInstOperands,
     /* 172681 */     // GIR_Coverage, 1552,
     /* 172681 */     GIR_EraseRootFromParent_Done,
     /* 172682 */   // Label 3388: @172682
     /* 172682 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(172727), // Rule ID 1553 //
     /* 172687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172716 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 172719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172725 */     GIR_RootConstrainSelectedInstOperands,
     /* 172726 */     // GIR_Coverage, 1553,
     /* 172726 */     GIR_EraseRootFromParent_Done,
     /* 172727 */   // Label 3389: @172727
     /* 172727 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(172772), // Rule ID 1554 //
     /* 172732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172761 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 172764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172770 */     GIR_RootConstrainSelectedInstOperands,
     /* 172771 */     // GIR_Coverage, 1554,
     /* 172771 */     GIR_EraseRootFromParent_Done,
     /* 172772 */   // Label 3390: @172772
     /* 172772 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(172817), // Rule ID 1555 //
     /* 172777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172806 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 172809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172815 */     GIR_RootConstrainSelectedInstOperands,
     /* 172816 */     // GIR_Coverage, 1555,
     /* 172816 */     GIR_EraseRootFromParent_Done,
     /* 172817 */   // Label 3391: @172817
     /* 172817 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(172862), // Rule ID 1556 //
     /* 172822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172851 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 172854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172860 */     GIR_RootConstrainSelectedInstOperands,
     /* 172861 */     // GIR_Coverage, 1556,
     /* 172861 */     GIR_EraseRootFromParent_Done,
     /* 172862 */   // Label 3392: @172862
     /* 172862 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(172907), // Rule ID 1557 //
     /* 172867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172896 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 172899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172905 */     GIR_RootConstrainSelectedInstOperands,
     /* 172906 */     // GIR_Coverage, 1557,
     /* 172906 */     GIR_EraseRootFromParent_Done,
     /* 172907 */   // Label 3393: @172907
     /* 172907 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(172952), // Rule ID 1558 //
     /* 172912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172941 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 172944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172950 */     GIR_RootConstrainSelectedInstOperands,
     /* 172951 */     // GIR_Coverage, 1558,
     /* 172951 */     GIR_EraseRootFromParent_Done,
     /* 172952 */   // Label 3394: @172952
     /* 172952 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(172997), // Rule ID 1559 //
     /* 172957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172986 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 172989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172995 */     GIR_RootConstrainSelectedInstOperands,
     /* 172996 */     // GIR_Coverage, 1559,
     /* 172996 */     GIR_EraseRootFromParent_Done,
     /* 172997 */   // Label 3395: @172997
     /* 172997 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(173042), // Rule ID 1566 //
     /* 173002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 173010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173031 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 173034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173040 */     GIR_RootConstrainSelectedInstOperands,
     /* 173041 */     // GIR_Coverage, 1566,
     /* 173041 */     GIR_EraseRootFromParent_Done,
     /* 173042 */   // Label 3396: @173042
     /* 173042 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(173087), // Rule ID 1567 //
     /* 173047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 173055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173076 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 173079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173085 */     GIR_RootConstrainSelectedInstOperands,
     /* 173086 */     // GIR_Coverage, 1567,
     /* 173086 */     GIR_EraseRootFromParent_Done,
     /* 173087 */   // Label 3397: @173087
     /* 173087 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(173132), // Rule ID 1568 //
     /* 173092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 173100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173121 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 173124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173130 */     GIR_RootConstrainSelectedInstOperands,
     /* 173131 */     // GIR_Coverage, 1568,
     /* 173131 */     GIR_EraseRootFromParent_Done,
     /* 173132 */   // Label 3398: @173132
     /* 173132 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(173177), // Rule ID 1569 //
     /* 173137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 173145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173166 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 173169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173175 */     GIR_RootConstrainSelectedInstOperands,
     /* 173176 */     // GIR_Coverage, 1569,
     /* 173176 */     GIR_EraseRootFromParent_Done,
     /* 173177 */   // Label 3399: @173177
     /* 173177 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(173222), // Rule ID 1570 //
     /* 173182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 173190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173211 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 173214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173220 */     GIR_RootConstrainSelectedInstOperands,
     /* 173221 */     // GIR_Coverage, 1570,
     /* 173221 */     GIR_EraseRootFromParent_Done,
     /* 173222 */   // Label 3400: @173222
     /* 173222 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(173267), // Rule ID 1571 //
     /* 173227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 173235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173256 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 173259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173265 */     GIR_RootConstrainSelectedInstOperands,
     /* 173266 */     // GIR_Coverage, 1571,
     /* 173266 */     GIR_EraseRootFromParent_Done,
     /* 173267 */   // Label 3401: @173267
     /* 173267 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(173312), // Rule ID 1572 //
     /* 173272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 173280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173301 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 173304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173310 */     GIR_RootConstrainSelectedInstOperands,
     /* 173311 */     // GIR_Coverage, 1572,
     /* 173311 */     GIR_EraseRootFromParent_Done,
     /* 173312 */   // Label 3402: @173312
     /* 173312 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(173357), // Rule ID 1573 //
     /* 173317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 173325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173346 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 173349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173355 */     GIR_RootConstrainSelectedInstOperands,
     /* 173356 */     // GIR_Coverage, 1573,
     /* 173356 */     GIR_EraseRootFromParent_Done,
     /* 173357 */   // Label 3403: @173357
     /* 173357 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(173402), // Rule ID 1574 //
     /* 173362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 173370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173391 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 173394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173400 */     GIR_RootConstrainSelectedInstOperands,
     /* 173401 */     // GIR_Coverage, 1574,
     /* 173401 */     GIR_EraseRootFromParent_Done,
     /* 173402 */   // Label 3404: @173402
     /* 173402 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(173447), // Rule ID 1575 //
     /* 173407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 173415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173436 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 173439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173445 */     GIR_RootConstrainSelectedInstOperands,
     /* 173446 */     // GIR_Coverage, 1575,
     /* 173446 */     GIR_EraseRootFromParent_Done,
     /* 173447 */   // Label 3405: @173447
     /* 173447 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(173492), // Rule ID 1576 //
     /* 173452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 173460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173481 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 173484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173490 */     GIR_RootConstrainSelectedInstOperands,
     /* 173491 */     // GIR_Coverage, 1576,
     /* 173491 */     GIR_EraseRootFromParent_Done,
     /* 173492 */   // Label 3406: @173492
     /* 173492 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(173537), // Rule ID 1577 //
     /* 173497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 173505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173526 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 173529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173535 */     GIR_RootConstrainSelectedInstOperands,
     /* 173536 */     // GIR_Coverage, 1577,
     /* 173536 */     GIR_EraseRootFromParent_Done,
     /* 173537 */   // Label 3407: @173537
     /* 173537 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(173582), // Rule ID 1578 //
     /* 173542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 173550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173571 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 173574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173580 */     GIR_RootConstrainSelectedInstOperands,
     /* 173581 */     // GIR_Coverage, 1578,
     /* 173581 */     GIR_EraseRootFromParent_Done,
     /* 173582 */   // Label 3408: @173582
     /* 173582 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(173627), // Rule ID 1579 //
     /* 173587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 173595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173616 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 173619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173625 */     GIR_RootConstrainSelectedInstOperands,
     /* 173626 */     // GIR_Coverage, 1579,
     /* 173626 */     GIR_EraseRootFromParent_Done,
     /* 173627 */   // Label 3409: @173627
     /* 173627 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(173672), // Rule ID 1607 //
     /* 173632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 173640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 173643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 173646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 173649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173661 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 173661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 173664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173670 */     GIR_RootConstrainSelectedInstOperands,
     /* 173671 */     // GIR_Coverage, 1607,
     /* 173671 */     GIR_EraseRootFromParent_Done,
     /* 173672 */   // Label 3410: @173672
     /* 173672 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(173717), // Rule ID 1608 //
     /* 173677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 173685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173706 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 173706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 173709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173715 */     GIR_RootConstrainSelectedInstOperands,
     /* 173716 */     // GIR_Coverage, 1608,
     /* 173716 */     GIR_EraseRootFromParent_Done,
     /* 173717 */   // Label 3411: @173717
     /* 173717 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(173762), // Rule ID 1609 //
     /* 173722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 173725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 173730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 173733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 173736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 173739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173751 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 173751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 173754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173760 */     GIR_RootConstrainSelectedInstOperands,
     /* 173761 */     // GIR_Coverage, 1609,
     /* 173761 */     GIR_EraseRootFromParent_Done,
     /* 173762 */   // Label 3412: @173762
     /* 173762 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(173807), // Rule ID 1610 //
     /* 173767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 173775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 173778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 173781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 173784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173796 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 173796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 173799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173805 */     GIR_RootConstrainSelectedInstOperands,
     /* 173806 */     // GIR_Coverage, 1610,
     /* 173806 */     GIR_EraseRootFromParent_Done,
     /* 173807 */   // Label 3413: @173807
     /* 173807 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(173852), // Rule ID 1611 //
     /* 173812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 173820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173841 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 173841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 173844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173850 */     GIR_RootConstrainSelectedInstOperands,
     /* 173851 */     // GIR_Coverage, 1611,
     /* 173851 */     GIR_EraseRootFromParent_Done,
     /* 173852 */   // Label 3414: @173852
     /* 173852 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(173897), // Rule ID 1612 //
     /* 173857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 173865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 173868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 173871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 173874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173886 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 173886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 173889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173895 */     GIR_RootConstrainSelectedInstOperands,
     /* 173896 */     // GIR_Coverage, 1612,
     /* 173896 */     GIR_EraseRootFromParent_Done,
     /* 173897 */   // Label 3415: @173897
     /* 173897 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(173942), // Rule ID 1613 //
     /* 173902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 173910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173931 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 173931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 173934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173940 */     GIR_RootConstrainSelectedInstOperands,
     /* 173941 */     // GIR_Coverage, 1613,
     /* 173941 */     GIR_EraseRootFromParent_Done,
     /* 173942 */   // Label 3416: @173942
     /* 173942 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(173987), // Rule ID 1620 //
     /* 173947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 173950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 173958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 173961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 173964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173976 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 173976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 173979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173985 */     GIR_RootConstrainSelectedInstOperands,
     /* 173986 */     // GIR_Coverage, 1620,
     /* 173986 */     GIR_EraseRootFromParent_Done,
     /* 173987 */   // Label 3417: @173987
     /* 173987 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(174032), // Rule ID 1621 //
     /* 173992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 173995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174021 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 174021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 174024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174030 */     GIR_RootConstrainSelectedInstOperands,
     /* 174031 */     // GIR_Coverage, 1621,
     /* 174031 */     GIR_EraseRootFromParent_Done,
     /* 174032 */   // Label 3418: @174032
     /* 174032 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(174077), // Rule ID 1622 //
     /* 174037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 174040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 174048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 174051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 174054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174066 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 174066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 174069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174075 */     GIR_RootConstrainSelectedInstOperands,
     /* 174076 */     // GIR_Coverage, 1622,
     /* 174076 */     GIR_EraseRootFromParent_Done,
     /* 174077 */   // Label 3419: @174077
     /* 174077 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(174122), // Rule ID 1623 //
     /* 174082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 174085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 174090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174111 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 174111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 174114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174120 */     GIR_RootConstrainSelectedInstOperands,
     /* 174121 */     // GIR_Coverage, 1623,
     /* 174121 */     GIR_EraseRootFromParent_Done,
     /* 174122 */   // Label 3420: @174122
     /* 174122 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(174167), // Rule ID 1624 //
     /* 174127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 174130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 174135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174156 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 174156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 174159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174165 */     GIR_RootConstrainSelectedInstOperands,
     /* 174166 */     // GIR_Coverage, 1624,
     /* 174166 */     GIR_EraseRootFromParent_Done,
     /* 174167 */   // Label 3421: @174167
     /* 174167 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(174212), // Rule ID 1625 //
     /* 174172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 174175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 174180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 174183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 174186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 174189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174201 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 174201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 174204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174210 */     GIR_RootConstrainSelectedInstOperands,
     /* 174211 */     // GIR_Coverage, 1625,
     /* 174211 */     GIR_EraseRootFromParent_Done,
     /* 174212 */   // Label 3422: @174212
     /* 174212 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(174257), // Rule ID 1626 //
     /* 174217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 174220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 174225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174246 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 174246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 174249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174255 */     GIR_RootConstrainSelectedInstOperands,
     /* 174256 */     // GIR_Coverage, 1626,
     /* 174256 */     GIR_EraseRootFromParent_Done,
     /* 174257 */   // Label 3423: @174257
     /* 174257 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(174302), // Rule ID 1627 //
     /* 174262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 174265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 174270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174291 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 174291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 174294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174300 */     GIR_RootConstrainSelectedInstOperands,
     /* 174301 */     // GIR_Coverage, 1627,
     /* 174301 */     GIR_EraseRootFromParent_Done,
     /* 174302 */   // Label 3424: @174302
     /* 174302 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(174347), // Rule ID 1628 //
     /* 174307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 174310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 174315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 174318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 174321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 174324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174336 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 174336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 174339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174345 */     GIR_RootConstrainSelectedInstOperands,
     /* 174346 */     // GIR_Coverage, 1628,
     /* 174346 */     GIR_EraseRootFromParent_Done,
     /* 174347 */   // Label 3425: @174347
     /* 174347 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(174392), // Rule ID 1629 //
     /* 174352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174381 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 174384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174390 */     GIR_RootConstrainSelectedInstOperands,
     /* 174391 */     // GIR_Coverage, 1629,
     /* 174391 */     GIR_EraseRootFromParent_Done,
     /* 174392 */   // Label 3426: @174392
     /* 174392 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(174437), // Rule ID 1630 //
     /* 174397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174426 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 174426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 174429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174435 */     GIR_RootConstrainSelectedInstOperands,
     /* 174436 */     // GIR_Coverage, 1630,
     /* 174436 */     GIR_EraseRootFromParent_Done,
     /* 174437 */   // Label 3427: @174437
     /* 174437 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(174482), // Rule ID 1631 //
     /* 174442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174471 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 174471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 174474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174480 */     GIR_RootConstrainSelectedInstOperands,
     /* 174481 */     // GIR_Coverage, 1631,
     /* 174481 */     GIR_EraseRootFromParent_Done,
     /* 174482 */   // Label 3428: @174482
     /* 174482 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(174527), // Rule ID 1632 //
     /* 174487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 174495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174516 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 174519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174525 */     GIR_RootConstrainSelectedInstOperands,
     /* 174526 */     // GIR_Coverage, 1632,
     /* 174526 */     GIR_EraseRootFromParent_Done,
     /* 174527 */   // Label 3429: @174527
     /* 174527 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(174572), // Rule ID 1633 //
     /* 174532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 174540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174561 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 174564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174570 */     GIR_RootConstrainSelectedInstOperands,
     /* 174571 */     // GIR_Coverage, 1633,
     /* 174571 */     GIR_EraseRootFromParent_Done,
     /* 174572 */   // Label 3430: @174572
     /* 174572 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(174617), // Rule ID 1634 //
     /* 174577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174606 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 174609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174615 */     GIR_RootConstrainSelectedInstOperands,
     /* 174616 */     // GIR_Coverage, 1634,
     /* 174616 */     GIR_EraseRootFromParent_Done,
     /* 174617 */   // Label 3431: @174617
     /* 174617 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(174662), // Rule ID 1635 //
     /* 174622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174651 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 174654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174660 */     GIR_RootConstrainSelectedInstOperands,
     /* 174661 */     // GIR_Coverage, 1635,
     /* 174661 */     GIR_EraseRootFromParent_Done,
     /* 174662 */   // Label 3432: @174662
     /* 174662 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(174707), // Rule ID 1636 //
     /* 174667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174696 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 174699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174705 */     GIR_RootConstrainSelectedInstOperands,
     /* 174706 */     // GIR_Coverage, 1636,
     /* 174706 */     GIR_EraseRootFromParent_Done,
     /* 174707 */   // Label 3433: @174707
     /* 174707 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(174752), // Rule ID 1638 //
     /* 174712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 174720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174741 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 174744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174750 */     GIR_RootConstrainSelectedInstOperands,
     /* 174751 */     // GIR_Coverage, 1638,
     /* 174751 */     GIR_EraseRootFromParent_Done,
     /* 174752 */   // Label 3434: @174752
     /* 174752 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(174797), // Rule ID 1639 //
     /* 174757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 174765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174786 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 174789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174795 */     GIR_RootConstrainSelectedInstOperands,
     /* 174796 */     // GIR_Coverage, 1639,
     /* 174796 */     GIR_EraseRootFromParent_Done,
     /* 174797 */   // Label 3435: @174797
     /* 174797 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(174842), // Rule ID 1640 //
     /* 174802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 174810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174831 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 174834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174840 */     GIR_RootConstrainSelectedInstOperands,
     /* 174841 */     // GIR_Coverage, 1640,
     /* 174841 */     GIR_EraseRootFromParent_Done,
     /* 174842 */   // Label 3436: @174842
     /* 174842 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(174887), // Rule ID 1641 //
     /* 174847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 174855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174876 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 174879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174885 */     GIR_RootConstrainSelectedInstOperands,
     /* 174886 */     // GIR_Coverage, 1641,
     /* 174886 */     GIR_EraseRootFromParent_Done,
     /* 174887 */   // Label 3437: @174887
     /* 174887 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(174932), // Rule ID 1642 //
     /* 174892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 174900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174921 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 174924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174930 */     GIR_RootConstrainSelectedInstOperands,
     /* 174931 */     // GIR_Coverage, 1642,
     /* 174931 */     GIR_EraseRootFromParent_Done,
     /* 174932 */   // Label 3438: @174932
     /* 174932 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(174977), // Rule ID 1643 //
     /* 174937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 174945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174966 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 174966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 174969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174975 */     GIR_RootConstrainSelectedInstOperands,
     /* 174976 */     // GIR_Coverage, 1643,
     /* 174976 */     GIR_EraseRootFromParent_Done,
     /* 174977 */   // Label 3439: @174977
     /* 174977 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(175022), // Rule ID 1644 //
     /* 174982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 174990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175011 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 175011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 175014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175020 */     GIR_RootConstrainSelectedInstOperands,
     /* 175021 */     // GIR_Coverage, 1644,
     /* 175021 */     GIR_EraseRootFromParent_Done,
     /* 175022 */   // Label 3440: @175022
     /* 175022 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(175067), // Rule ID 1658 //
     /* 175027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 175035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175056 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 175056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 175059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175065 */     GIR_RootConstrainSelectedInstOperands,
     /* 175066 */     // GIR_Coverage, 1658,
     /* 175066 */     GIR_EraseRootFromParent_Done,
     /* 175067 */   // Label 3441: @175067
     /* 175067 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(175112), // Rule ID 1659 //
     /* 175072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 175080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175101 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 175101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 175104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175110 */     GIR_RootConstrainSelectedInstOperands,
     /* 175111 */     // GIR_Coverage, 1659,
     /* 175111 */     GIR_EraseRootFromParent_Done,
     /* 175112 */   // Label 3442: @175112
     /* 175112 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(175157), // Rule ID 1664 //
     /* 175117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 175125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175146 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 175146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 175149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175155 */     GIR_RootConstrainSelectedInstOperands,
     /* 175156 */     // GIR_Coverage, 1664,
     /* 175156 */     GIR_EraseRootFromParent_Done,
     /* 175157 */   // Label 3443: @175157
     /* 175157 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(175202), // Rule ID 1665 //
     /* 175162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 175170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175191 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 175191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 175194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175200 */     GIR_RootConstrainSelectedInstOperands,
     /* 175201 */     // GIR_Coverage, 1665,
     /* 175201 */     GIR_EraseRootFromParent_Done,
     /* 175202 */   // Label 3444: @175202
     /* 175202 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(175247), // Rule ID 1666 //
     /* 175207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 175215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175236 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 175239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175245 */     GIR_RootConstrainSelectedInstOperands,
     /* 175246 */     // GIR_Coverage, 1666,
     /* 175246 */     GIR_EraseRootFromParent_Done,
     /* 175247 */   // Label 3445: @175247
     /* 175247 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(175292), // Rule ID 1667 //
     /* 175252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 175260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175281 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 175284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175290 */     GIR_RootConstrainSelectedInstOperands,
     /* 175291 */     // GIR_Coverage, 1667,
     /* 175291 */     GIR_EraseRootFromParent_Done,
     /* 175292 */   // Label 3446: @175292
     /* 175292 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(175337), // Rule ID 1668 //
     /* 175297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 175305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175326 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 175329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175335 */     GIR_RootConstrainSelectedInstOperands,
     /* 175336 */     // GIR_Coverage, 1668,
     /* 175336 */     GIR_EraseRootFromParent_Done,
     /* 175337 */   // Label 3447: @175337
     /* 175337 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(175382), // Rule ID 1669 //
     /* 175342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 175350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175371 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 175374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175380 */     GIR_RootConstrainSelectedInstOperands,
     /* 175381 */     // GIR_Coverage, 1669,
     /* 175381 */     GIR_EraseRootFromParent_Done,
     /* 175382 */   // Label 3448: @175382
     /* 175382 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(175427), // Rule ID 1670 //
     /* 175387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 175395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175416 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 175419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175425 */     GIR_RootConstrainSelectedInstOperands,
     /* 175426 */     // GIR_Coverage, 1670,
     /* 175426 */     GIR_EraseRootFromParent_Done,
     /* 175427 */   // Label 3449: @175427
     /* 175427 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(175472), // Rule ID 1671 //
     /* 175432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 175440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175461 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 175464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175470 */     GIR_RootConstrainSelectedInstOperands,
     /* 175471 */     // GIR_Coverage, 1671,
     /* 175471 */     GIR_EraseRootFromParent_Done,
     /* 175472 */   // Label 3450: @175472
     /* 175472 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(175517), // Rule ID 1672 //
     /* 175477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 175485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175506 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 175509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175515 */     GIR_RootConstrainSelectedInstOperands,
     /* 175516 */     // GIR_Coverage, 1672,
     /* 175516 */     GIR_EraseRootFromParent_Done,
     /* 175517 */   // Label 3451: @175517
     /* 175517 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(175562), // Rule ID 1673 //
     /* 175522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 175530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175551 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 175554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175560 */     GIR_RootConstrainSelectedInstOperands,
     /* 175561 */     // GIR_Coverage, 1673,
     /* 175561 */     GIR_EraseRootFromParent_Done,
     /* 175562 */   // Label 3452: @175562
     /* 175562 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(175607), // Rule ID 1674 //
     /* 175567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 175575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175596 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 175599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175605 */     GIR_RootConstrainSelectedInstOperands,
     /* 175606 */     // GIR_Coverage, 1674,
     /* 175606 */     GIR_EraseRootFromParent_Done,
     /* 175607 */   // Label 3453: @175607
     /* 175607 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(175652), // Rule ID 1675 //
     /* 175612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 175620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175641 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 175644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175650 */     GIR_RootConstrainSelectedInstOperands,
     /* 175651 */     // GIR_Coverage, 1675,
     /* 175651 */     GIR_EraseRootFromParent_Done,
     /* 175652 */   // Label 3454: @175652
     /* 175652 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(175697), // Rule ID 1676 //
     /* 175657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 175665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175686 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 175689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175695 */     GIR_RootConstrainSelectedInstOperands,
     /* 175696 */     // GIR_Coverage, 1676,
     /* 175696 */     GIR_EraseRootFromParent_Done,
     /* 175697 */   // Label 3455: @175697
     /* 175697 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(175742), // Rule ID 1677 //
     /* 175702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 175710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175731 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 175734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175740 */     GIR_RootConstrainSelectedInstOperands,
     /* 175741 */     // GIR_Coverage, 1677,
     /* 175741 */     GIR_EraseRootFromParent_Done,
     /* 175742 */   // Label 3456: @175742
     /* 175742 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(175787), // Rule ID 1743 //
     /* 175747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175776 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 175779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175785 */     GIR_RootConstrainSelectedInstOperands,
     /* 175786 */     // GIR_Coverage, 1743,
     /* 175786 */     GIR_EraseRootFromParent_Done,
     /* 175787 */   // Label 3457: @175787
     /* 175787 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(175832), // Rule ID 1745 //
     /* 175792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175821 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 175824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175830 */     GIR_RootConstrainSelectedInstOperands,
     /* 175831 */     // GIR_Coverage, 1745,
     /* 175831 */     GIR_EraseRootFromParent_Done,
     /* 175832 */   // Label 3458: @175832
     /* 175832 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(175877), // Rule ID 2294 //
     /* 175837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 175840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 175845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175866 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 175866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 175869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175875 */     GIR_RootConstrainSelectedInstOperands,
     /* 175876 */     // GIR_Coverage, 2294,
     /* 175876 */     GIR_EraseRootFromParent_Done,
     /* 175877 */   // Label 3459: @175877
     /* 175877 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(175922), // Rule ID 2295 //
     /* 175882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 175885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 175890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175911 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 175911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 175914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175920 */     GIR_RootConstrainSelectedInstOperands,
     /* 175921 */     // GIR_Coverage, 2295,
     /* 175921 */     GIR_EraseRootFromParent_Done,
     /* 175922 */   // Label 3460: @175922
     /* 175922 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(175967), // Rule ID 2306 //
     /* 175927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 175930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 175935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175956 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 175956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 175959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175965 */     GIR_RootConstrainSelectedInstOperands,
     /* 175966 */     // GIR_Coverage, 2306,
     /* 175966 */     GIR_EraseRootFromParent_Done,
     /* 175967 */   // Label 3461: @175967
     /* 175967 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(176012), // Rule ID 2307 //
     /* 175972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 175975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 175980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176001 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 176001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 176004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176010 */     GIR_RootConstrainSelectedInstOperands,
     /* 176011 */     // GIR_Coverage, 2307,
     /* 176011 */     GIR_EraseRootFromParent_Done,
     /* 176012 */   // Label 3462: @176012
     /* 176012 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(176057), // Rule ID 2330 //
     /* 176017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 176020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 176025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176046 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 176049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176055 */     GIR_RootConstrainSelectedInstOperands,
     /* 176056 */     // GIR_Coverage, 2330,
     /* 176056 */     GIR_EraseRootFromParent_Done,
     /* 176057 */   // Label 3463: @176057
     /* 176057 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(176102), // Rule ID 2331 //
     /* 176062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 176065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 176070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176091 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 176094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176100 */     GIR_RootConstrainSelectedInstOperands,
     /* 176101 */     // GIR_Coverage, 2331,
     /* 176101 */     GIR_EraseRootFromParent_Done,
     /* 176102 */   // Label 3464: @176102
     /* 176102 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(176147), // Rule ID 2332 //
     /* 176107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 176110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 176115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176136 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 176139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176145 */     GIR_RootConstrainSelectedInstOperands,
     /* 176146 */     // GIR_Coverage, 2332,
     /* 176146 */     GIR_EraseRootFromParent_Done,
     /* 176147 */   // Label 3465: @176147
     /* 176147 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(176192), // Rule ID 2333 //
     /* 176152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 176155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 176160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176181 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 176184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176190 */     GIR_RootConstrainSelectedInstOperands,
     /* 176191 */     // GIR_Coverage, 2333,
     /* 176191 */     GIR_EraseRootFromParent_Done,
     /* 176192 */   // Label 3466: @176192
     /* 176192 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(176237), // Rule ID 2334 //
     /* 176197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 176200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 176205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176226 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 176229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176235 */     GIR_RootConstrainSelectedInstOperands,
     /* 176236 */     // GIR_Coverage, 2334,
     /* 176236 */     GIR_EraseRootFromParent_Done,
     /* 176237 */   // Label 3467: @176237
     /* 176237 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(176282), // Rule ID 2335 //
     /* 176242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 176250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176271 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 176271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 176274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176280 */     GIR_RootConstrainSelectedInstOperands,
     /* 176281 */     // GIR_Coverage, 2335,
     /* 176281 */     GIR_EraseRootFromParent_Done,
     /* 176282 */   // Label 3468: @176282
     /* 176282 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(176327), // Rule ID 2338 //
     /* 176287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 176295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176316 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 176316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 176319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176325 */     GIR_RootConstrainSelectedInstOperands,
     /* 176326 */     // GIR_Coverage, 2338,
     /* 176326 */     GIR_EraseRootFromParent_Done,
     /* 176327 */   // Label 3469: @176327
     /* 176327 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(176372), // Rule ID 2341 //
     /* 176332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 176340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176361 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 176361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 176364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176370 */     GIR_RootConstrainSelectedInstOperands,
     /* 176371 */     // GIR_Coverage, 2341,
     /* 176371 */     GIR_EraseRootFromParent_Done,
     /* 176372 */   // Label 3470: @176372
     /* 176372 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(176417), // Rule ID 2344 //
     /* 176377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 176385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176406 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 176406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 176409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176415 */     GIR_RootConstrainSelectedInstOperands,
     /* 176416 */     // GIR_Coverage, 2344,
     /* 176416 */     GIR_EraseRootFromParent_Done,
     /* 176417 */   // Label 3471: @176417
     /* 176417 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(176462), // Rule ID 2347 //
     /* 176422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 176430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176451 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 176451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 176454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176460 */     GIR_RootConstrainSelectedInstOperands,
     /* 176461 */     // GIR_Coverage, 2347,
     /* 176461 */     GIR_EraseRootFromParent_Done,
     /* 176462 */   // Label 3472: @176462
     /* 176462 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(176507), // Rule ID 2350 //
     /* 176467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 176475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176496 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 176496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 176499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176505 */     GIR_RootConstrainSelectedInstOperands,
     /* 176506 */     // GIR_Coverage, 2350,
     /* 176506 */     GIR_EraseRootFromParent_Done,
     /* 176507 */   // Label 3473: @176507
     /* 176507 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(176552), // Rule ID 2353 //
     /* 176512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 176520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176541 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 176541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 176544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176550 */     GIR_RootConstrainSelectedInstOperands,
     /* 176551 */     // GIR_Coverage, 2353,
     /* 176551 */     GIR_EraseRootFromParent_Done,
     /* 176552 */   // Label 3474: @176552
     /* 176552 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(176597), // Rule ID 2356 //
     /* 176557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 176565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176586 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 176586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 176589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176595 */     GIR_RootConstrainSelectedInstOperands,
     /* 176596 */     // GIR_Coverage, 2356,
     /* 176596 */     GIR_EraseRootFromParent_Done,
     /* 176597 */   // Label 3475: @176597
     /* 176597 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(176642), // Rule ID 2359 //
     /* 176602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 176610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176631 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 176631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 176634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176640 */     GIR_RootConstrainSelectedInstOperands,
     /* 176641 */     // GIR_Coverage, 2359,
     /* 176641 */     GIR_EraseRootFromParent_Done,
     /* 176642 */   // Label 3476: @176642
     /* 176642 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(176687), // Rule ID 2362 //
     /* 176647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 176650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 176655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176676 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 176676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 176679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176685 */     GIR_RootConstrainSelectedInstOperands,
     /* 176686 */     // GIR_Coverage, 2362,
     /* 176686 */     GIR_EraseRootFromParent_Done,
     /* 176687 */   // Label 3477: @176687
     /* 176687 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(176732), // Rule ID 2499 //
     /* 176692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176721 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 176724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176730 */     GIR_RootConstrainSelectedInstOperands,
     /* 176731 */     // GIR_Coverage, 2499,
     /* 176731 */     GIR_EraseRootFromParent_Done,
     /* 176732 */   // Label 3478: @176732
     /* 176732 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(176777), // Rule ID 2500 //
     /* 176737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176766 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 176769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176775 */     GIR_RootConstrainSelectedInstOperands,
     /* 176776 */     // GIR_Coverage, 2500,
     /* 176776 */     GIR_EraseRootFromParent_Done,
     /* 176777 */   // Label 3479: @176777
     /* 176777 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(176822), // Rule ID 2501 //
     /* 176782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 176790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176811 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 176811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 176814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176820 */     GIR_RootConstrainSelectedInstOperands,
     /* 176821 */     // GIR_Coverage, 2501,
     /* 176821 */     GIR_EraseRootFromParent_Done,
     /* 176822 */   // Label 3480: @176822
     /* 176822 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(176867), // Rule ID 2502 //
     /* 176827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 176835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176856 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 176856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 176859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176865 */     GIR_RootConstrainSelectedInstOperands,
     /* 176866 */     // GIR_Coverage, 2502,
     /* 176866 */     GIR_EraseRootFromParent_Done,
     /* 176867 */   // Label 3481: @176867
     /* 176867 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(176912), // Rule ID 2507 //
     /* 176872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 176880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176901 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 176901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 176904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176910 */     GIR_RootConstrainSelectedInstOperands,
     /* 176911 */     // GIR_Coverage, 2507,
     /* 176911 */     GIR_EraseRootFromParent_Done,
     /* 176912 */   // Label 3482: @176912
     /* 176912 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(176957), // Rule ID 2625 //
     /* 176917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 176920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 176925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 176934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 176938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 176942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 176946 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 176946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 176949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 176951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 176953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176955 */     GIR_RootConstrainSelectedInstOperands,
     /* 176956 */     // GIR_Coverage, 2625,
     /* 176956 */     GIR_EraseRootFromParent_Done,
     /* 176957 */   // Label 3483: @176957
     /* 176957 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(177002), // Rule ID 2626 //
     /* 176962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 176965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 176970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 176979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 176983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 176987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 176991 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 176991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 176994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 176996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 176998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177000 */     GIR_RootConstrainSelectedInstOperands,
     /* 177001 */     // GIR_Coverage, 2626,
     /* 177001 */     GIR_EraseRootFromParent_Done,
     /* 177002 */   // Label 3484: @177002
     /* 177002 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(177047), // Rule ID 2627 //
     /* 177007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 177015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177036 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 177039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177045 */     GIR_RootConstrainSelectedInstOperands,
     /* 177046 */     // GIR_Coverage, 2627,
     /* 177046 */     GIR_EraseRootFromParent_Done,
     /* 177047 */   // Label 3485: @177047
     /* 177047 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(177092), // Rule ID 2628 //
     /* 177052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 177060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177081 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 177084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177090 */     GIR_RootConstrainSelectedInstOperands,
     /* 177091 */     // GIR_Coverage, 2628,
     /* 177091 */     GIR_EraseRootFromParent_Done,
     /* 177092 */   // Label 3486: @177092
     /* 177092 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(177137), // Rule ID 2629 //
     /* 177097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 177105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177126 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 177129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177135 */     GIR_RootConstrainSelectedInstOperands,
     /* 177136 */     // GIR_Coverage, 2629,
     /* 177136 */     GIR_EraseRootFromParent_Done,
     /* 177137 */   // Label 3487: @177137
     /* 177137 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(177182), // Rule ID 2630 //
     /* 177142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 177150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177171 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 177174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177180 */     GIR_RootConstrainSelectedInstOperands,
     /* 177181 */     // GIR_Coverage, 2630,
     /* 177181 */     GIR_EraseRootFromParent_Done,
     /* 177182 */   // Label 3488: @177182
     /* 177182 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(177227), // Rule ID 2631 //
     /* 177187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 177195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177216 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 177219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177225 */     GIR_RootConstrainSelectedInstOperands,
     /* 177226 */     // GIR_Coverage, 2631,
     /* 177226 */     GIR_EraseRootFromParent_Done,
     /* 177227 */   // Label 3489: @177227
     /* 177227 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(177272), // Rule ID 2632 //
     /* 177232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 177240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177261 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 177264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177270 */     GIR_RootConstrainSelectedInstOperands,
     /* 177271 */     // GIR_Coverage, 2632,
     /* 177271 */     GIR_EraseRootFromParent_Done,
     /* 177272 */   // Label 3490: @177272
     /* 177272 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(177317), // Rule ID 3768 //
     /* 177277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 177280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 177285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177306 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 177306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 177309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 177311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 177313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 177315 */     GIR_RootConstrainSelectedInstOperands,
     /* 177316 */     // GIR_Coverage, 3768,
     /* 177316 */     GIR_EraseRootFromParent_Done,
     /* 177317 */   // Label 3491: @177317
     /* 177317 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(177362), // Rule ID 3796 //
     /* 177322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 177325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 177330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177351 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 177351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 177354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 177356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 177358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 177360 */     GIR_RootConstrainSelectedInstOperands,
     /* 177361 */     // GIR_Coverage, 3796,
     /* 177361 */     GIR_EraseRootFromParent_Done,
     /* 177362 */   // Label 3492: @177362
     /* 177362 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(177407), // Rule ID 3806 //
     /* 177367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 177370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 177375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177396 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 177396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 177399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 177401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 177403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 177405 */     GIR_RootConstrainSelectedInstOperands,
     /* 177406 */     // GIR_Coverage, 3806,
     /* 177406 */     GIR_EraseRootFromParent_Done,
     /* 177407 */   // Label 3493: @177407
     /* 177407 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(177452), // Rule ID 3807 //
     /* 177412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 177415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 177420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177441 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 177441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 177444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 177446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 177448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 177450 */     GIR_RootConstrainSelectedInstOperands,
     /* 177451 */     // GIR_Coverage, 3807,
     /* 177451 */     GIR_EraseRootFromParent_Done,
     /* 177452 */   // Label 3494: @177452
     /* 177452 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(177500), // Rule ID 3808 //
     /* 177457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 177460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 177465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177486 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 177486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 177489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177498 */     GIR_RootConstrainSelectedInstOperands,
     /* 177499 */     // GIR_Coverage, 3808,
     /* 177499 */     GIR_EraseRootFromParent_Done,
     /* 177500 */   // Label 3495: @177500
     /* 177500 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(177548), // Rule ID 3809 //
     /* 177505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 177508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 177513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177534 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 177534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 177537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 177546 */     GIR_RootConstrainSelectedInstOperands,
     /* 177547 */     // GIR_Coverage, 3809,
     /* 177547 */     GIR_EraseRootFromParent_Done,
     /* 177548 */   // Label 3496: @177548
     /* 177548 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(177596), // Rule ID 3810 //
     /* 177553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 177556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 177561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177582 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 177582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 177585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177594 */     GIR_RootConstrainSelectedInstOperands,
     /* 177595 */     // GIR_Coverage, 3810,
     /* 177595 */     GIR_EraseRootFromParent_Done,
     /* 177596 */   // Label 3497: @177596
     /* 177596 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(177644), // Rule ID 3811 //
     /* 177601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 177604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 177609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177630 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 177630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 177633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 177642 */     GIR_RootConstrainSelectedInstOperands,
     /* 177643 */     // GIR_Coverage, 3811,
     /* 177643 */     GIR_EraseRootFromParent_Done,
     /* 177644 */   // Label 3498: @177644
     /* 177644 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(177692), // Rule ID 3812 //
     /* 177649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 177652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 177657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177678 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 177678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 177681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177690 */     GIR_RootConstrainSelectedInstOperands,
     /* 177691 */     // GIR_Coverage, 3812,
     /* 177691 */     GIR_EraseRootFromParent_Done,
     /* 177692 */   // Label 3499: @177692
     /* 177692 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(177740), // Rule ID 3813 //
     /* 177697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 177700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 177705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177726 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 177726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 177729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 177738 */     GIR_RootConstrainSelectedInstOperands,
     /* 177739 */     // GIR_Coverage, 3813,
     /* 177739 */     GIR_EraseRootFromParent_Done,
     /* 177740 */   // Label 3500: @177740
     /* 177740 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(177788), // Rule ID 3814 //
     /* 177745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 177748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 177753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177774 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 177774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 177777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177786 */     GIR_RootConstrainSelectedInstOperands,
     /* 177787 */     // GIR_Coverage, 3814,
     /* 177787 */     GIR_EraseRootFromParent_Done,
     /* 177788 */   // Label 3501: @177788
     /* 177788 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(177836), // Rule ID 3815 //
     /* 177793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 177796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 177801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177822 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 177822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 177825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 177834 */     GIR_RootConstrainSelectedInstOperands,
     /* 177835 */     // GIR_Coverage, 3815,
     /* 177835 */     GIR_EraseRootFromParent_Done,
     /* 177836 */   // Label 3502: @177836
     /* 177836 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(177884), // Rule ID 3816 //
     /* 177841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 177844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 177849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177870 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 177870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 177873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177882 */     GIR_RootConstrainSelectedInstOperands,
     /* 177883 */     // GIR_Coverage, 3816,
     /* 177883 */     GIR_EraseRootFromParent_Done,
     /* 177884 */   // Label 3503: @177884
     /* 177884 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(177932), // Rule ID 3817 //
     /* 177889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 177892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 177897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177918 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 177918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 177921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 177930 */     GIR_RootConstrainSelectedInstOperands,
     /* 177931 */     // GIR_Coverage, 3817,
     /* 177931 */     GIR_EraseRootFromParent_Done,
     /* 177932 */   // Label 3504: @177932
     /* 177932 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(177974), // Rule ID 3882 //
     /* 177937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 177942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177963 */     // (intrinsic_wo_chain:{ *:[i32] } 2075:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 177963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 177966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177972 */     GIR_RootConstrainSelectedInstOperands,
     /* 177973 */     // GIR_Coverage, 3882,
     /* 177973 */     GIR_EraseRootFromParent_Done,
     /* 177974 */   // Label 3505: @177974
     /* 177974 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(178016), // Rule ID 3883 //
     /* 177979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 177984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178005 */     // (intrinsic_wo_chain:{ *:[i64] } 2075:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 178005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 178008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178014 */     GIR_RootConstrainSelectedInstOperands,
     /* 178015 */     // GIR_Coverage, 3883,
     /* 178015 */     GIR_EraseRootFromParent_Done,
     /* 178016 */   // Label 3506: @178016
     /* 178016 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(178058), // Rule ID 3884 //
     /* 178021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 178026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 178039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 178043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 178047 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 178047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 178050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178056 */     GIR_RootConstrainSelectedInstOperands,
     /* 178057 */     // GIR_Coverage, 3884,
     /* 178057 */     GIR_EraseRootFromParent_Done,
     /* 178058 */   // Label 3507: @178058
     /* 178058 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(178100), // Rule ID 3885 //
     /* 178063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 178068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178089 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 178089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 178092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178098 */     GIR_RootConstrainSelectedInstOperands,
     /* 178099 */     // GIR_Coverage, 3885,
     /* 178099 */     GIR_EraseRootFromParent_Done,
     /* 178100 */   // Label 3508: @178100
     /* 178100 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(178142), // Rule ID 5155 //
     /* 178105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 178110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178131 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 178131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 178134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178140 */     GIR_RootConstrainSelectedInstOperands,
     /* 178141 */     // GIR_Coverage, 5155,
     /* 178141 */     GIR_EraseRootFromParent_Done,
     /* 178142 */   // Label 3509: @178142
     /* 178142 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(178187), // Rule ID 5159 //
     /* 178147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 178155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178176 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 178176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 178179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178185 */     GIR_RootConstrainSelectedInstOperands,
     /* 178186 */     // GIR_Coverage, 5159,
     /* 178186 */     GIR_EraseRootFromParent_Done,
     /* 178187 */   // Label 3510: @178187
     /* 178187 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(178232), // Rule ID 5163 //
     /* 178192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178221 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 178221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 178224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178230 */     GIR_RootConstrainSelectedInstOperands,
     /* 178231 */     // GIR_Coverage, 5163,
     /* 178231 */     GIR_EraseRootFromParent_Done,
     /* 178232 */   // Label 3511: @178232
     /* 178232 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(178277), // Rule ID 5164 //
     /* 178237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 178245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178266 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 178266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 178269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178275 */     GIR_RootConstrainSelectedInstOperands,
     /* 178276 */     // GIR_Coverage, 5164,
     /* 178276 */     GIR_EraseRootFromParent_Done,
     /* 178277 */   // Label 3512: @178277
     /* 178277 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(178322), // Rule ID 5165 //
     /* 178282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 178290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178311 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 178311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 178314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178320 */     GIR_RootConstrainSelectedInstOperands,
     /* 178321 */     // GIR_Coverage, 5165,
     /* 178321 */     GIR_EraseRootFromParent_Done,
     /* 178322 */   // Label 3513: @178322
     /* 178322 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(178367), // Rule ID 5166 //
     /* 178327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 178335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178356 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 178356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 178359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178365 */     GIR_RootConstrainSelectedInstOperands,
     /* 178366 */     // GIR_Coverage, 5166,
     /* 178366 */     GIR_EraseRootFromParent_Done,
     /* 178367 */   // Label 3514: @178367
     /* 178367 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(178412), // Rule ID 5167 //
     /* 178372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 178380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178401 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 178404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178410 */     GIR_RootConstrainSelectedInstOperands,
     /* 178411 */     // GIR_Coverage, 5167,
     /* 178411 */     GIR_EraseRootFromParent_Done,
     /* 178412 */   // Label 3515: @178412
     /* 178412 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(178457), // Rule ID 5168 //
     /* 178417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 178425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178446 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 178446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 178449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178455 */     GIR_RootConstrainSelectedInstOperands,
     /* 178456 */     // GIR_Coverage, 5168,
     /* 178456 */     GIR_EraseRootFromParent_Done,
     /* 178457 */   // Label 3516: @178457
     /* 178457 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(178502), // Rule ID 5169 //
     /* 178462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 178470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178491 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 178494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178500 */     GIR_RootConstrainSelectedInstOperands,
     /* 178501 */     // GIR_Coverage, 5169,
     /* 178501 */     GIR_EraseRootFromParent_Done,
     /* 178502 */   // Label 3517: @178502
     /* 178502 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(178547), // Rule ID 5170 //
     /* 178507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178536 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 178536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 178539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178545 */     GIR_RootConstrainSelectedInstOperands,
     /* 178546 */     // GIR_Coverage, 5170,
     /* 178546 */     GIR_EraseRootFromParent_Done,
     /* 178547 */   // Label 3518: @178547
     /* 178547 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(178592), // Rule ID 5171 //
     /* 178552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178581 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 178584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178590 */     GIR_RootConstrainSelectedInstOperands,
     /* 178591 */     // GIR_Coverage, 5171,
     /* 178591 */     GIR_EraseRootFromParent_Done,
     /* 178592 */   // Label 3519: @178592
     /* 178592 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(178637), // Rule ID 5172 //
     /* 178597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 178605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178626 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 178626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 178629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178635 */     GIR_RootConstrainSelectedInstOperands,
     /* 178636 */     // GIR_Coverage, 5172,
     /* 178636 */     GIR_EraseRootFromParent_Done,
     /* 178637 */   // Label 3520: @178637
     /* 178637 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(178682), // Rule ID 5173 //
     /* 178642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 178650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178671 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 178674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178680 */     GIR_RootConstrainSelectedInstOperands,
     /* 178681 */     // GIR_Coverage, 5173,
     /* 178681 */     GIR_EraseRootFromParent_Done,
     /* 178682 */   // Label 3521: @178682
     /* 178682 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(178727), // Rule ID 5174 //
     /* 178687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178716 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 178716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 178719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178725 */     GIR_RootConstrainSelectedInstOperands,
     /* 178726 */     // GIR_Coverage, 5174,
     /* 178726 */     GIR_EraseRootFromParent_Done,
     /* 178727 */   // Label 3522: @178727
     /* 178727 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(178772), // Rule ID 5175 //
     /* 178732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178761 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 178764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178770 */     GIR_RootConstrainSelectedInstOperands,
     /* 178771 */     // GIR_Coverage, 5175,
     /* 178771 */     GIR_EraseRootFromParent_Done,
     /* 178772 */   // Label 3523: @178772
     /* 178772 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(178817), // Rule ID 5176 //
     /* 178777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178806 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 178806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 178809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178815 */     GIR_RootConstrainSelectedInstOperands,
     /* 178816 */     // GIR_Coverage, 5176,
     /* 178816 */     GIR_EraseRootFromParent_Done,
     /* 178817 */   // Label 3524: @178817
     /* 178817 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(178862), // Rule ID 5177 //
     /* 178822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178851 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 178854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178860 */     GIR_RootConstrainSelectedInstOperands,
     /* 178861 */     // GIR_Coverage, 5177,
     /* 178861 */     GIR_EraseRootFromParent_Done,
     /* 178862 */   // Label 3525: @178862
     /* 178862 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(178907), // Rule ID 5178 //
     /* 178867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178896 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 178896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 178899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178905 */     GIR_RootConstrainSelectedInstOperands,
     /* 178906 */     // GIR_Coverage, 5178,
     /* 178906 */     GIR_EraseRootFromParent_Done,
     /* 178907 */   // Label 3526: @178907
     /* 178907 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(178952), // Rule ID 5179 //
     /* 178912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178941 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 178944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178950 */     GIR_RootConstrainSelectedInstOperands,
     /* 178951 */     // GIR_Coverage, 5179,
     /* 178951 */     GIR_EraseRootFromParent_Done,
     /* 178952 */   // Label 3527: @178952
     /* 178952 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(178997), // Rule ID 5197 //
     /* 178957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 178965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178986 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 178986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 178989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178995 */     GIR_RootConstrainSelectedInstOperands,
     /* 178996 */     // GIR_Coverage, 5197,
     /* 178996 */     GIR_EraseRootFromParent_Done,
     /* 178997 */   // Label 3528: @178997
     /* 178997 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(179039), // Rule ID 5525 //
     /* 179002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 179007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 179016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179028 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 179028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 179031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 179033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 179037 */     GIR_RootConstrainSelectedInstOperands,
     /* 179038 */     // GIR_Coverage, 5525,
     /* 179038 */     GIR_EraseRootFromParent_Done,
     /* 179039 */   // Label 3529: @179039
     /* 179039 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(179081), // Rule ID 5526 //
     /* 179044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 179049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179070 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 179070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 179073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 179075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 179077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179079 */     GIR_RootConstrainSelectedInstOperands,
     /* 179080 */     // GIR_Coverage, 5526,
     /* 179080 */     GIR_EraseRootFromParent_Done,
     /* 179081 */   // Label 3530: @179081
     /* 179081 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(179178), // Rule ID 6203 //
     /* 179086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 179091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179112 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 179112 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 179115 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 179119 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179124 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 179128 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 179132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 179134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 179137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 179141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 179151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 179162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179177 */     // GIR_Coverage, 6203,
     /* 179177 */     GIR_EraseRootFromParent_Done,
     /* 179178 */   // Label 3531: @179178
     /* 179178 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(179275), // Rule ID 6204 //
     /* 179183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 179188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179209 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 179209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 179212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 179216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 179225 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 179229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 179231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 179234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 179238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 179248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 179259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179274 */     // GIR_Coverage, 6204,
     /* 179274 */     GIR_EraseRootFromParent_Done,
     /* 179275 */   // Label 3532: @179275
     /* 179275 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(179317), // Rule ID 6857 //
     /* 179280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 179285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179306 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 179306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 179309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179315 */     GIR_RootConstrainSelectedInstOperands,
     /* 179316 */     // GIR_Coverage, 6857,
     /* 179316 */     GIR_EraseRootFromParent_Done,
     /* 179317 */   // Label 3533: @179317
     /* 179317 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(179359), // Rule ID 6858 //
     /* 179322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179348 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 179348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 179351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179357 */     GIR_RootConstrainSelectedInstOperands,
     /* 179358 */     // GIR_Coverage, 6858,
     /* 179358 */     GIR_EraseRootFromParent_Done,
     /* 179359 */   // Label 3534: @179359
     /* 179359 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(179401), // Rule ID 6859 //
     /* 179364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 179369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179390 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 179390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 179393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179399 */     GIR_RootConstrainSelectedInstOperands,
     /* 179400 */     // GIR_Coverage, 6859,
     /* 179400 */     GIR_EraseRootFromParent_Done,
     /* 179401 */   // Label 3535: @179401
     /* 179401 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(179443), // Rule ID 6860 //
     /* 179406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179432 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 179432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 179435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179441 */     GIR_RootConstrainSelectedInstOperands,
     /* 179442 */     // GIR_Coverage, 6860,
     /* 179442 */     GIR_EraseRootFromParent_Done,
     /* 179443 */   // Label 3536: @179443
     /* 179443 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(179491), // Rule ID 6900 //
     /* 179448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 179453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179474 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 179474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 179477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 179486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 179489 */     GIR_RootConstrainSelectedInstOperands,
     /* 179490 */     // GIR_Coverage, 6900,
     /* 179490 */     GIR_EraseRootFromParent_Done,
     /* 179491 */   // Label 3537: @179491
     /* 179491 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(179536), // Rule ID 9922 //
     /* 179496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 179504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 179513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179525 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 179528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179534 */     GIR_RootConstrainSelectedInstOperands,
     /* 179535 */     // GIR_Coverage, 9922,
     /* 179535 */     GIR_EraseRootFromParent_Done,
     /* 179536 */   // Label 3538: @179536
     /* 179536 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(179581), // Rule ID 9923 //
     /* 179541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 179549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 179558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179570 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 179573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179579 */     GIR_RootConstrainSelectedInstOperands,
     /* 179580 */     // GIR_Coverage, 9923,
     /* 179580 */     GIR_EraseRootFromParent_Done,
     /* 179581 */   // Label 3539: @179581
     /* 179581 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(179626), // Rule ID 9924 //
     /* 179586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 179594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 179603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179615 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 179618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179624 */     GIR_RootConstrainSelectedInstOperands,
     /* 179625 */     // GIR_Coverage, 9924,
     /* 179625 */     GIR_EraseRootFromParent_Done,
     /* 179626 */   // Label 3540: @179626
     /* 179626 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(179671), // Rule ID 9925 //
     /* 179631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 179639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 179648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179660 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 179663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179669 */     GIR_RootConstrainSelectedInstOperands,
     /* 179670 */     // GIR_Coverage, 9925,
     /* 179670 */     GIR_EraseRootFromParent_Done,
     /* 179671 */   // Label 3541: @179671
     /* 179671 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(179716), // Rule ID 9934 //
     /* 179676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 179684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 179693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179705 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 179708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179714 */     GIR_RootConstrainSelectedInstOperands,
     /* 179715 */     // GIR_Coverage, 9934,
     /* 179715 */     GIR_EraseRootFromParent_Done,
     /* 179716 */   // Label 3542: @179716
     /* 179716 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(179761), // Rule ID 9935 //
     /* 179721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 179729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 179738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179750 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 179753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179759 */     GIR_RootConstrainSelectedInstOperands,
     /* 179760 */     // GIR_Coverage, 9935,
     /* 179760 */     GIR_EraseRootFromParent_Done,
     /* 179761 */   // Label 3543: @179761
     /* 179761 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(179806), // Rule ID 9936 //
     /* 179766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 179774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 179783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179795 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 179798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179804 */     GIR_RootConstrainSelectedInstOperands,
     /* 179805 */     // GIR_Coverage, 9936,
     /* 179805 */     GIR_EraseRootFromParent_Done,
     /* 179806 */   // Label 3544: @179806
     /* 179806 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(179851), // Rule ID 9937 //
     /* 179811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 179819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 179828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179840 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 179843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179849 */     GIR_RootConstrainSelectedInstOperands,
     /* 179850 */     // GIR_Coverage, 9937,
     /* 179850 */     GIR_EraseRootFromParent_Done,
     /* 179851 */   // Label 3545: @179851
     /* 179851 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(179896), // Rule ID 9938 //
     /* 179856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 179864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 179873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179885 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 179885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 179888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179894 */     GIR_RootConstrainSelectedInstOperands,
     /* 179895 */     // GIR_Coverage, 9938,
     /* 179895 */     GIR_EraseRootFromParent_Done,
     /* 179896 */   // Label 3546: @179896
     /* 179896 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(179941), // Rule ID 9939 //
     /* 179901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 179909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 179918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179930 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 179930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 179933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179939 */     GIR_RootConstrainSelectedInstOperands,
     /* 179940 */     // GIR_Coverage, 9939,
     /* 179940 */     GIR_EraseRootFromParent_Done,
     /* 179941 */   // Label 3547: @179941
     /* 179941 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(179986), // Rule ID 9940 //
     /* 179946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 179954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 179963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179975 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 179975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 179978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179984 */     GIR_RootConstrainSelectedInstOperands,
     /* 179985 */     // GIR_Coverage, 9940,
     /* 179985 */     GIR_EraseRootFromParent_Done,
     /* 179986 */   // Label 3548: @179986
     /* 179986 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(180031), // Rule ID 9941 //
     /* 179991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 179999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180020 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 180023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180029 */     GIR_RootConstrainSelectedInstOperands,
     /* 180030 */     // GIR_Coverage, 9941,
     /* 180030 */     GIR_EraseRootFromParent_Done,
     /* 180031 */   // Label 3549: @180031
     /* 180031 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(180076), // Rule ID 9942 //
     /* 180036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 180044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180065 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 180068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180074 */     GIR_RootConstrainSelectedInstOperands,
     /* 180075 */     // GIR_Coverage, 9942,
     /* 180075 */     GIR_EraseRootFromParent_Done,
     /* 180076 */   // Label 3550: @180076
     /* 180076 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(180121), // Rule ID 9943 //
     /* 180081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 180089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 180098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180110 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 180113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180119 */     GIR_RootConstrainSelectedInstOperands,
     /* 180120 */     // GIR_Coverage, 9943,
     /* 180120 */     GIR_EraseRootFromParent_Done,
     /* 180121 */   // Label 3551: @180121
     /* 180121 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(180166), // Rule ID 9944 //
     /* 180126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 180134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 180143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180155 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 180158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180164 */     GIR_RootConstrainSelectedInstOperands,
     /* 180165 */     // GIR_Coverage, 9944,
     /* 180165 */     GIR_EraseRootFromParent_Done,
     /* 180166 */   // Label 3552: @180166
     /* 180166 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(180211), // Rule ID 9945 //
     /* 180171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 180179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180200 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 180203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180209 */     GIR_RootConstrainSelectedInstOperands,
     /* 180210 */     // GIR_Coverage, 9945,
     /* 180210 */     GIR_EraseRootFromParent_Done,
     /* 180211 */   // Label 3553: @180211
     /* 180211 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(180257), // Rule ID 138 //
     /* 180216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 180219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 180224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180234 */     // MIs[0] Rn
     /* 180234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 180238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 180242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180246 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 180246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 180249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180255 */     GIR_RootConstrainSelectedInstOperands,
     /* 180256 */     // GIR_Coverage, 138,
     /* 180256 */     GIR_EraseRootFromParent_Done,
     /* 180257 */   // Label 3554: @180257
     /* 180257 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(180304), // Rule ID 139 //
     /* 180262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 180265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 180270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180277 */     // MIs[0] Rn
     /* 180277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 180281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 180285 */     // MIs[0] Rm
     /* 180285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 180289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 180293 */     // (intrinsic_wo_chain:{ *:[i64] } 1148:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 180293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 180296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180302 */     GIR_RootConstrainSelectedInstOperands,
     /* 180303 */     // GIR_Coverage, 139,
     /* 180303 */     GIR_EraseRootFromParent_Done,
     /* 180304 */   // Label 3555: @180304
     /* 180304 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(180341), // Rule ID 2390 //
     /* 180309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 180317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180330 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2057:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 180333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180339 */     GIR_RootConstrainSelectedInstOperands,
     /* 180340 */     // GIR_Coverage, 2390,
     /* 180340 */     GIR_EraseRootFromParent_Done,
     /* 180341 */   // Label 3556: @180341
     /* 180341 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(180378), // Rule ID 2391 //
     /* 180346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 180354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180367 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2058:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 180370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180376 */     GIR_RootConstrainSelectedInstOperands,
     /* 180377 */     // GIR_Coverage, 2391,
     /* 180377 */     GIR_EraseRootFromParent_Done,
     /* 180378 */   // Label 3557: @180378
     /* 180378 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(180415), // Rule ID 2392 //
     /* 180383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 180391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180404 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2059:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 180407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180413 */     GIR_RootConstrainSelectedInstOperands,
     /* 180414 */     // GIR_Coverage, 2392,
     /* 180414 */     GIR_EraseRootFromParent_Done,
     /* 180415 */   // Label 3558: @180415
     /* 180415 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(180452), // Rule ID 2394 //
     /* 180420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 180428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180441 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2062:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 180444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180450 */     GIR_RootConstrainSelectedInstOperands,
     /* 180451 */     // GIR_Coverage, 2394,
     /* 180451 */     GIR_EraseRootFromParent_Done,
     /* 180452 */   // Label 3559: @180452
     /* 180452 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(180489), // Rule ID 2395 //
     /* 180457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 180465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180478 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 180481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180487 */     GIR_RootConstrainSelectedInstOperands,
     /* 180488 */     // GIR_Coverage, 2395,
     /* 180488 */     GIR_EraseRootFromParent_Done,
     /* 180489 */   // Label 3560: @180489
     /* 180489 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(180526), // Rule ID 2396 //
     /* 180494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 180502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180515 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2064:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 180518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180524 */     GIR_RootConstrainSelectedInstOperands,
     /* 180525 */     // GIR_Coverage, 2396,
     /* 180525 */     GIR_EraseRootFromParent_Done,
     /* 180526 */   // Label 3561: @180526
     /* 180526 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(180563), // Rule ID 2398 //
     /* 180531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 180539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1983:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 180555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180561 */     GIR_RootConstrainSelectedInstOperands,
     /* 180562 */     // GIR_Coverage, 2398,
     /* 180562 */     GIR_EraseRootFromParent_Done,
     /* 180563 */   // Label 3562: @180563
     /* 180563 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(180600), // Rule ID 2399 //
     /* 180568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 180576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180589 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1984:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 180592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180598 */     GIR_RootConstrainSelectedInstOperands,
     /* 180599 */     // GIR_Coverage, 2399,
     /* 180599 */     GIR_EraseRootFromParent_Done,
     /* 180600 */   // Label 3563: @180600
     /* 180600 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(180637), // Rule ID 2400 //
     /* 180605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 180613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180626 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1985:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 180629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180635 */     GIR_RootConstrainSelectedInstOperands,
     /* 180636 */     // GIR_Coverage, 2400,
     /* 180636 */     GIR_EraseRootFromParent_Done,
     /* 180637 */   // Label 3564: @180637
     /* 180637 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(180674), // Rule ID 2402 //
     /* 180642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 180650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180663 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1988:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 180666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180672 */     GIR_RootConstrainSelectedInstOperands,
     /* 180673 */     // GIR_Coverage, 2402,
     /* 180673 */     GIR_EraseRootFromParent_Done,
     /* 180674 */   // Label 3565: @180674
     /* 180674 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(180711), // Rule ID 2403 //
     /* 180679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 180687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1989:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 180703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180709 */     GIR_RootConstrainSelectedInstOperands,
     /* 180710 */     // GIR_Coverage, 2403,
     /* 180710 */     GIR_EraseRootFromParent_Done,
     /* 180711 */   // Label 3566: @180711
     /* 180711 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(180748), // Rule ID 2404 //
     /* 180716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 180724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180737 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 180740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180746 */     GIR_RootConstrainSelectedInstOperands,
     /* 180747 */     // GIR_Coverage, 2404,
     /* 180747 */     GIR_EraseRootFromParent_Done,
     /* 180748 */   // Label 3567: @180748
     /* 180748 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(180785), // Rule ID 2406 //
     /* 180753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 180761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1827:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 180777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180783 */     GIR_RootConstrainSelectedInstOperands,
     /* 180784 */     // GIR_Coverage, 2406,
     /* 180784 */     GIR_EraseRootFromParent_Done,
     /* 180785 */   // Label 3568: @180785
     /* 180785 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(180822), // Rule ID 2407 //
     /* 180790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 180798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180811 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 180814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180820 */     GIR_RootConstrainSelectedInstOperands,
     /* 180821 */     // GIR_Coverage, 2407,
     /* 180821 */     GIR_EraseRootFromParent_Done,
     /* 180822 */   // Label 3569: @180822
     /* 180822 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(180859), // Rule ID 2408 //
     /* 180827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 180835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180848 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1829:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 180851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180857 */     GIR_RootConstrainSelectedInstOperands,
     /* 180858 */     // GIR_Coverage, 2408,
     /* 180858 */     GIR_EraseRootFromParent_Done,
     /* 180859 */   // Label 3570: @180859
     /* 180859 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(180896), // Rule ID 2410 //
     /* 180864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 180872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180885 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1832:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 180888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180894 */     GIR_RootConstrainSelectedInstOperands,
     /* 180895 */     // GIR_Coverage, 2410,
     /* 180895 */     GIR_EraseRootFromParent_Done,
     /* 180896 */   // Label 3571: @180896
     /* 180896 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(180933), // Rule ID 2411 //
     /* 180901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 180909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1833:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 180925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180931 */     GIR_RootConstrainSelectedInstOperands,
     /* 180932 */     // GIR_Coverage, 2411,
     /* 180932 */     GIR_EraseRootFromParent_Done,
     /* 180933 */   // Label 3572: @180933
     /* 180933 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(180970), // Rule ID 2412 //
     /* 180938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 180946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180959 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1834:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 180959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 180962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 180966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 180968 */     GIR_RootConstrainSelectedInstOperands,
     /* 180969 */     // GIR_Coverage, 2412,
     /* 180969 */     GIR_EraseRootFromParent_Done,
     /* 180970 */   // Label 3573: @180970
     /* 180970 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(181007), // Rule ID 2413 //
     /* 180975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 180978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 180983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 180986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 180992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1452:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 180996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 180999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 181005 */     GIR_RootConstrainSelectedInstOperands,
     /* 181006 */     // GIR_Coverage, 2413,
     /* 181006 */     GIR_EraseRootFromParent_Done,
     /* 181007 */   // Label 3574: @181007
     /* 181007 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(181047), // Rule ID 2612 //
     /* 181012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 181020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 181026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181033 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1531:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 181033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 181036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 181038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 181045 */     GIR_RootConstrainSelectedInstOperands,
     /* 181046 */     // GIR_Coverage, 2612,
     /* 181046 */     GIR_EraseRootFromParent_Done,
     /* 181047 */   // Label 3575: @181047
     /* 181047 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(181087), // Rule ID 2613 //
     /* 181052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 181060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 181066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181073 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1539:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 181073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 181076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 181078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 181085 */     GIR_RootConstrainSelectedInstOperands,
     /* 181086 */     // GIR_Coverage, 2613,
     /* 181086 */     GIR_EraseRootFromParent_Done,
     /* 181087 */   // Label 3576: @181087
     /* 181087 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(181127), // Rule ID 2614 //
     /* 181092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 181100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 181103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 181106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 181109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181113 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 181113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 181116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 181118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 181125 */     GIR_RootConstrainSelectedInstOperands,
     /* 181126 */     // GIR_Coverage, 2614,
     /* 181126 */     GIR_EraseRootFromParent_Done,
     /* 181127 */   // Label 3577: @181127
     /* 181127 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(181167), // Rule ID 2615 //
     /* 181132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 181140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 181143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 181146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 181149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181153 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 181153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 181156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 181158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 181165 */     GIR_RootConstrainSelectedInstOperands,
     /* 181166 */     // GIR_Coverage, 2615,
     /* 181166 */     GIR_EraseRootFromParent_Done,
     /* 181167 */   // Label 3578: @181167
     /* 181167 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(181207), // Rule ID 2616 //
     /* 181172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 181180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 181183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 181186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 181189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181193 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 181193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 181196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 181198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 181205 */     GIR_RootConstrainSelectedInstOperands,
     /* 181206 */     // GIR_Coverage, 2616,
     /* 181206 */     GIR_EraseRootFromParent_Done,
     /* 181207 */   // Label 3579: @181207
     /* 181207 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(181244), // Rule ID 2633 //
     /* 181212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 181220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 181229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 181233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 181236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 181238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181242 */     GIR_RootConstrainSelectedInstOperands,
     /* 181243 */     // GIR_Coverage, 2633,
     /* 181243 */     GIR_EraseRootFromParent_Done,
     /* 181244 */   // Label 3580: @181244
     /* 181244 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(181281), // Rule ID 2634 //
     /* 181249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 181257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 181266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 181270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 181273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 181275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181279 */     GIR_RootConstrainSelectedInstOperands,
     /* 181280 */     // GIR_Coverage, 2634,
     /* 181280 */     GIR_EraseRootFromParent_Done,
     /* 181281 */   // Label 3581: @181281
     /* 181281 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(181318), // Rule ID 2635 //
     /* 181286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 181294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 181303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181307 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1719:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 181307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 181310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 181312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181316 */     GIR_RootConstrainSelectedInstOperands,
     /* 181317 */     // GIR_Coverage, 2635,
     /* 181317 */     GIR_EraseRootFromParent_Done,
     /* 181318 */   // Label 3582: @181318
     /* 181318 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(181355), // Rule ID 2636 //
     /* 181323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 181331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 181337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181344 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 181344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 181347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181353 */     GIR_RootConstrainSelectedInstOperands,
     /* 181354 */     // GIR_Coverage, 2636,
     /* 181354 */     GIR_EraseRootFromParent_Done,
     /* 181355 */   // Label 3583: @181355
     /* 181355 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(181392), // Rule ID 2637 //
     /* 181360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 181368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 181374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 181377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181381 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 181381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 181384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181390 */     GIR_RootConstrainSelectedInstOperands,
     /* 181391 */     // GIR_Coverage, 2637,
     /* 181391 */     GIR_EraseRootFromParent_Done,
     /* 181392 */   // Label 3584: @181392
     /* 181392 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(181429), // Rule ID 2638 //
     /* 181397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 181405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 181411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 181414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181418 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 181418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 181421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181427 */     GIR_RootConstrainSelectedInstOperands,
     /* 181428 */     // GIR_Coverage, 2638,
     /* 181428 */     GIR_EraseRootFromParent_Done,
     /* 181429 */   // Label 3585: @181429
     /* 181429 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(181466), // Rule ID 2639 //
     /* 181434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 181442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 181448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 181451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181455 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 181455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 181458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181464 */     GIR_RootConstrainSelectedInstOperands,
     /* 181465 */     // GIR_Coverage, 2639,
     /* 181465 */     GIR_EraseRootFromParent_Done,
     /* 181466 */   // Label 3586: @181466
     /* 181466 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(181503), // Rule ID 2817 //
     /* 181471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 181479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181492 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 181495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181501 */     GIR_RootConstrainSelectedInstOperands,
     /* 181502 */     // GIR_Coverage, 2817,
     /* 181502 */     GIR_EraseRootFromParent_Done,
     /* 181503 */   // Label 3587: @181503
     /* 181503 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(181540), // Rule ID 2818 //
     /* 181508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 181516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181529 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 181532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181538 */     GIR_RootConstrainSelectedInstOperands,
     /* 181539 */     // GIR_Coverage, 2818,
     /* 181539 */     GIR_EraseRootFromParent_Done,
     /* 181540 */   // Label 3588: @181540
     /* 181540 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(181577), // Rule ID 2819 //
     /* 181545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 181553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181566 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 181569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181575 */     GIR_RootConstrainSelectedInstOperands,
     /* 181576 */     // GIR_Coverage, 2819,
     /* 181576 */     GIR_EraseRootFromParent_Done,
     /* 181577 */   // Label 3589: @181577
     /* 181577 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(181614), // Rule ID 2990 //
     /* 181582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 181590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181603 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1701:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 181606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181612 */     GIR_RootConstrainSelectedInstOperands,
     /* 181613 */     // GIR_Coverage, 2990,
     /* 181613 */     GIR_EraseRootFromParent_Done,
     /* 181614 */   // Label 3590: @181614
     /* 181614 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(181651), // Rule ID 2991 //
     /* 181619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 181627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1701:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 181643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181649 */     GIR_RootConstrainSelectedInstOperands,
     /* 181650 */     // GIR_Coverage, 2991,
     /* 181650 */     GIR_EraseRootFromParent_Done,
     /* 181651 */   // Label 3591: @181651
     /* 181651 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(181688), // Rule ID 2992 //
     /* 181656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 181664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1701:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 181680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181686 */     GIR_RootConstrainSelectedInstOperands,
     /* 181687 */     // GIR_Coverage, 2992,
     /* 181687 */     GIR_EraseRootFromParent_Done,
     /* 181688 */   // Label 3592: @181688
     /* 181688 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(181725), // Rule ID 2993 //
     /* 181693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 181701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181714 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1701:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 181717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181723 */     GIR_RootConstrainSelectedInstOperands,
     /* 181724 */     // GIR_Coverage, 2993,
     /* 181724 */     GIR_EraseRootFromParent_Done,
     /* 181725 */   // Label 3593: @181725
     /* 181725 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(181762), // Rule ID 2994 //
     /* 181730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 181738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181751 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1536:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 181754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181760 */     GIR_RootConstrainSelectedInstOperands,
     /* 181761 */     // GIR_Coverage, 2994,
     /* 181761 */     GIR_EraseRootFromParent_Done,
     /* 181762 */   // Label 3594: @181762
     /* 181762 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(181799), // Rule ID 3016 //
     /* 181767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 181775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1594:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 181791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181797 */     GIR_RootConstrainSelectedInstOperands,
     /* 181798 */     // GIR_Coverage, 3016,
     /* 181798 */     GIR_EraseRootFromParent_Done,
     /* 181799 */   // Label 3595: @181799
     /* 181799 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(181836), // Rule ID 3017 //
     /* 181804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 181812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181825 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1594:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 181828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181834 */     GIR_RootConstrainSelectedInstOperands,
     /* 181835 */     // GIR_Coverage, 3017,
     /* 181835 */     GIR_EraseRootFromParent_Done,
     /* 181836 */   // Label 3596: @181836
     /* 181836 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(181873), // Rule ID 3018 //
     /* 181841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 181849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1594:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 181865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181871 */     GIR_RootConstrainSelectedInstOperands,
     /* 181872 */     // GIR_Coverage, 3018,
     /* 181872 */     GIR_EraseRootFromParent_Done,
     /* 181873 */   // Label 3597: @181873
     /* 181873 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(181910), // Rule ID 3022 //
     /* 181878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 181881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 181886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1537:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 181902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181908 */     GIR_RootConstrainSelectedInstOperands,
     /* 181909 */     // GIR_Coverage, 3022,
     /* 181909 */     GIR_EraseRootFromParent_Done,
     /* 181910 */   // Label 3598: @181910
     /* 181910 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(181947), // Rule ID 3023 //
     /* 181915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 181923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1537:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 181939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181945 */     GIR_RootConstrainSelectedInstOperands,
     /* 181946 */     // GIR_Coverage, 3023,
     /* 181946 */     GIR_EraseRootFromParent_Done,
     /* 181947 */   // Label 3599: @181947
     /* 181947 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(181984), // Rule ID 3024 //
     /* 181952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 181960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1537:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 181976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181982 */     GIR_RootConstrainSelectedInstOperands,
     /* 181983 */     // GIR_Coverage, 3024,
     /* 181983 */     GIR_EraseRootFromParent_Done,
     /* 181984 */   // Label 3600: @181984
     /* 181984 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(182021), // Rule ID 3025 //
     /* 181989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 181992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 181997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 182003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 182006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182010 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1179:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 182010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 182013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182019 */     GIR_RootConstrainSelectedInstOperands,
     /* 182020 */     // GIR_Coverage, 3025,
     /* 182020 */     GIR_EraseRootFromParent_Done,
     /* 182021 */   // Label 3601: @182021
     /* 182021 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(182058), // Rule ID 3026 //
     /* 182026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 182029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 182034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 182043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182047 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1179:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 182047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 182050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182056 */     GIR_RootConstrainSelectedInstOperands,
     /* 182057 */     // GIR_Coverage, 3026,
     /* 182057 */     GIR_EraseRootFromParent_Done,
     /* 182058 */   // Label 3602: @182058
     /* 182058 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(182095), // Rule ID 3027 //
     /* 182063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 182066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 182071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1179:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 182087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182093 */     GIR_RootConstrainSelectedInstOperands,
     /* 182094 */     // GIR_Coverage, 3027,
     /* 182094 */     GIR_EraseRootFromParent_Done,
     /* 182095 */   // Label 3603: @182095
     /* 182095 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(182132), // Rule ID 3028 //
     /* 182100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 182103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 182108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1179:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 182124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182130 */     GIR_RootConstrainSelectedInstOperands,
     /* 182131 */     // GIR_Coverage, 3028,
     /* 182131 */     GIR_EraseRootFromParent_Done,
     /* 182132 */   // Label 3604: @182132
     /* 182132 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(182169), // Rule ID 3029 //
     /* 182137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 182145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 182151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 182154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 182158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 182161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182167 */     GIR_RootConstrainSelectedInstOperands,
     /* 182168 */     // GIR_Coverage, 3029,
     /* 182168 */     GIR_EraseRootFromParent_Done,
     /* 182169 */   // Label 3605: @182169
     /* 182169 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(182206), // Rule ID 3030 //
     /* 182174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 182182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 182191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182195 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 182195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 182198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182204 */     GIR_RootConstrainSelectedInstOperands,
     /* 182205 */     // GIR_Coverage, 3030,
     /* 182205 */     GIR_EraseRootFromParent_Done,
     /* 182206 */   // Label 3606: @182206
     /* 182206 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(182243), // Rule ID 3031 //
     /* 182211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 182219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1595:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 182235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182241 */     GIR_RootConstrainSelectedInstOperands,
     /* 182242 */     // GIR_Coverage, 3031,
     /* 182242 */     GIR_EraseRootFromParent_Done,
     /* 182243 */   // Label 3607: @182243
     /* 182243 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(182280), // Rule ID 3078 //
     /* 182248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 182256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 182265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182269 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1156:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 182269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 182272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182278 */     GIR_RootConstrainSelectedInstOperands,
     /* 182279 */     // GIR_Coverage, 3078,
     /* 182279 */     GIR_EraseRootFromParent_Done,
     /* 182280 */   // Label 3608: @182280
     /* 182280 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(182317), // Rule ID 3079 //
     /* 182285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 182293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1156:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 182309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182315 */     GIR_RootConstrainSelectedInstOperands,
     /* 182316 */     // GIR_Coverage, 3079,
     /* 182316 */     GIR_EraseRootFromParent_Done,
     /* 182317 */   // Label 3609: @182317
     /* 182317 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(182354), // Rule ID 3080 //
     /* 182322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 182330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1156:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 182346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182352 */     GIR_RootConstrainSelectedInstOperands,
     /* 182353 */     // GIR_Coverage, 3080,
     /* 182353 */     GIR_EraseRootFromParent_Done,
     /* 182354 */   // Label 3610: @182354
     /* 182354 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(182391), // Rule ID 3087 //
     /* 182359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 182367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 182373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 182376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182380 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1758:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 182380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 182383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182389 */     GIR_RootConstrainSelectedInstOperands,
     /* 182390 */     // GIR_Coverage, 3087,
     /* 182390 */     GIR_EraseRootFromParent_Done,
     /* 182391 */   // Label 3611: @182391
     /* 182391 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(182428), // Rule ID 3088 //
     /* 182396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 182404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182417 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1758:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 182420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182426 */     GIR_RootConstrainSelectedInstOperands,
     /* 182427 */     // GIR_Coverage, 3088,
     /* 182427 */     GIR_EraseRootFromParent_Done,
     /* 182428 */   // Label 3612: @182428
     /* 182428 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(182465), // Rule ID 3089 //
     /* 182433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 182441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 182457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182463 */     GIR_RootConstrainSelectedInstOperands,
     /* 182464 */     // GIR_Coverage, 3089,
     /* 182464 */     GIR_EraseRootFromParent_Done,
     /* 182465 */   // Label 3613: @182465
     /* 182465 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(182505), // Rule ID 3193 //
     /* 182470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 182478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182491 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 182494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182503 */     GIR_RootConstrainSelectedInstOperands,
     /* 182504 */     // GIR_Coverage, 3193,
     /* 182504 */     GIR_EraseRootFromParent_Done,
     /* 182505 */   // Label 3614: @182505
     /* 182505 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(182545), // Rule ID 3194 //
     /* 182510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 182518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182531 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 182534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182543 */     GIR_RootConstrainSelectedInstOperands,
     /* 182544 */     // GIR_Coverage, 3194,
     /* 182544 */     GIR_EraseRootFromParent_Done,
     /* 182545 */   // Label 3615: @182545
     /* 182545 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(182585), // Rule ID 3195 //
     /* 182550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 182558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182571 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 182574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182583 */     GIR_RootConstrainSelectedInstOperands,
     /* 182584 */     // GIR_Coverage, 3195,
     /* 182584 */     GIR_EraseRootFromParent_Done,
     /* 182585 */   // Label 3616: @182585
     /* 182585 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(182625), // Rule ID 3196 //
     /* 182590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 182598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182611 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 182614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182623 */     GIR_RootConstrainSelectedInstOperands,
     /* 182624 */     // GIR_Coverage, 3196,
     /* 182624 */     GIR_EraseRootFromParent_Done,
     /* 182625 */   // Label 3617: @182625
     /* 182625 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(182665), // Rule ID 3201 //
     /* 182630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 182638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 182654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182663 */     GIR_RootConstrainSelectedInstOperands,
     /* 182664 */     // GIR_Coverage, 3201,
     /* 182664 */     GIR_EraseRootFromParent_Done,
     /* 182665 */   // Label 3618: @182665
     /* 182665 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(182705), // Rule ID 3202 //
     /* 182670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 182678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182691 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 182694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182703 */     GIR_RootConstrainSelectedInstOperands,
     /* 182704 */     // GIR_Coverage, 3202,
     /* 182704 */     GIR_EraseRootFromParent_Done,
     /* 182705 */   // Label 3619: @182705
     /* 182705 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(182745), // Rule ID 3203 //
     /* 182710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 182718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182731 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 182734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182743 */     GIR_RootConstrainSelectedInstOperands,
     /* 182744 */     // GIR_Coverage, 3203,
     /* 182744 */     GIR_EraseRootFromParent_Done,
     /* 182745 */   // Label 3620: @182745
     /* 182745 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(182785), // Rule ID 3204 //
     /* 182750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 182758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182771 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 182774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182783 */     GIR_RootConstrainSelectedInstOperands,
     /* 182784 */     // GIR_Coverage, 3204,
     /* 182784 */     GIR_EraseRootFromParent_Done,
     /* 182785 */   // Label 3621: @182785
     /* 182785 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(182822), // Rule ID 3393 //
     /* 182790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 182793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 182798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 182804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 182814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182820 */     GIR_RootConstrainSelectedInstOperands,
     /* 182821 */     // GIR_Coverage, 3393,
     /* 182821 */     GIR_EraseRootFromParent_Done,
     /* 182822 */   // Label 3622: @182822
     /* 182822 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(182859), // Rule ID 3394 //
     /* 182827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 182830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 182835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 182841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182848 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 182848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 182851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182857 */     GIR_RootConstrainSelectedInstOperands,
     /* 182858 */     // GIR_Coverage, 3394,
     /* 182858 */     GIR_EraseRootFromParent_Done,
     /* 182859 */   // Label 3623: @182859
     /* 182859 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(182896), // Rule ID 3395 //
     /* 182864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 182867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 182872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 182878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182885 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 182888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182894 */     GIR_RootConstrainSelectedInstOperands,
     /* 182895 */     // GIR_Coverage, 3395,
     /* 182895 */     GIR_EraseRootFromParent_Done,
     /* 182896 */   // Label 3624: @182896
     /* 182896 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(182933), // Rule ID 3396 //
     /* 182901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 182904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 182909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 182915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182922 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 182922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 182925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182931 */     GIR_RootConstrainSelectedInstOperands,
     /* 182932 */     // GIR_Coverage, 3396,
     /* 182932 */     GIR_EraseRootFromParent_Done,
     /* 182933 */   // Label 3625: @182933
     /* 182933 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(182970), // Rule ID 3418 //
     /* 182938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 182946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 182955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182959 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 182959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 182962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182968 */     GIR_RootConstrainSelectedInstOperands,
     /* 182969 */     // GIR_Coverage, 3418,
     /* 182969 */     GIR_EraseRootFromParent_Done,
     /* 182970 */   // Label 3626: @182970
     /* 182970 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(183007), // Rule ID 3419 //
     /* 182975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 182983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182996 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 182999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183005 */     GIR_RootConstrainSelectedInstOperands,
     /* 183006 */     // GIR_Coverage, 3419,
     /* 183006 */     GIR_EraseRootFromParent_Done,
     /* 183007 */   // Label 3627: @183007
     /* 183007 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(183044), // Rule ID 3420 //
     /* 183012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 183015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 183020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183033 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 183036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183042 */     GIR_RootConstrainSelectedInstOperands,
     /* 183043 */     // GIR_Coverage, 3420,
     /* 183043 */     GIR_EraseRootFromParent_Done,
     /* 183044 */   // Label 3628: @183044
     /* 183044 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(183081), // Rule ID 3442 //
     /* 183049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 183057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183070 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1200:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 183070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 183073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183079 */     GIR_RootConstrainSelectedInstOperands,
     /* 183080 */     // GIR_Coverage, 3442,
     /* 183080 */     GIR_EraseRootFromParent_Done,
     /* 183081 */   // Label 3629: @183081
     /* 183081 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(183118), // Rule ID 3447 //
     /* 183086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 183089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 183094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183107 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1630:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 183110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183116 */     GIR_RootConstrainSelectedInstOperands,
     /* 183117 */     // GIR_Coverage, 3447,
     /* 183117 */     GIR_EraseRootFromParent_Done,
     /* 183118 */   // Label 3630: @183118
     /* 183118 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(183155), // Rule ID 3448 //
     /* 183123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 183126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 183131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1165:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 183147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183153 */     GIR_RootConstrainSelectedInstOperands,
     /* 183154 */     // GIR_Coverage, 3448,
     /* 183154 */     GIR_EraseRootFromParent_Done,
     /* 183155 */   // Label 3631: @183155
     /* 183155 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(183192), // Rule ID 3457 //
     /* 183160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 183168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183181 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2060:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 183184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183190 */     GIR_RootConstrainSelectedInstOperands,
     /* 183191 */     // GIR_Coverage, 3457,
     /* 183191 */     GIR_EraseRootFromParent_Done,
     /* 183192 */   // Label 3632: @183192
     /* 183192 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(183229), // Rule ID 3458 //
     /* 183197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 183205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2060:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 183221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183227 */     GIR_RootConstrainSelectedInstOperands,
     /* 183228 */     // GIR_Coverage, 3458,
     /* 183228 */     GIR_EraseRootFromParent_Done,
     /* 183229 */   // Label 3633: @183229
     /* 183229 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(183266), // Rule ID 3459 //
     /* 183234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 183242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183255 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2060:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 183258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183264 */     GIR_RootConstrainSelectedInstOperands,
     /* 183265 */     // GIR_Coverage, 3459,
     /* 183265 */     GIR_EraseRootFromParent_Done,
     /* 183266 */   // Label 3634: @183266
     /* 183266 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(183303), // Rule ID 3460 //
     /* 183271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 183279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 183295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183301 */     GIR_RootConstrainSelectedInstOperands,
     /* 183302 */     // GIR_Coverage, 3460,
     /* 183302 */     GIR_EraseRootFromParent_Done,
     /* 183303 */   // Label 3635: @183303
     /* 183303 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(183340), // Rule ID 3461 //
     /* 183308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 183316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183329 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2060:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 183332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183338 */     GIR_RootConstrainSelectedInstOperands,
     /* 183339 */     // GIR_Coverage, 3461,
     /* 183339 */     GIR_EraseRootFromParent_Done,
     /* 183340 */   // Label 3636: @183340
     /* 183340 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(183377), // Rule ID 3462 //
     /* 183345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 183353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2060:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 183369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183375 */     GIR_RootConstrainSelectedInstOperands,
     /* 183376 */     // GIR_Coverage, 3462,
     /* 183376 */     GIR_EraseRootFromParent_Done,
     /* 183377 */   // Label 3637: @183377
     /* 183377 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(183414), // Rule ID 3463 //
     /* 183382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 183390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183403 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2060:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 183403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 183406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183412 */     GIR_RootConstrainSelectedInstOperands,
     /* 183413 */     // GIR_Coverage, 3463,
     /* 183413 */     GIR_EraseRootFromParent_Done,
     /* 183414 */   // Label 3638: @183414
     /* 183414 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(183451), // Rule ID 3518 //
     /* 183419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 183427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 183433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183440 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1273:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 183443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183449 */     GIR_RootConstrainSelectedInstOperands,
     /* 183450 */     // GIR_Coverage, 3518,
     /* 183450 */     GIR_EraseRootFromParent_Done,
     /* 183451 */   // Label 3639: @183451
     /* 183451 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(183488), // Rule ID 3519 //
     /* 183456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 183464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 183470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183477 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1273:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 183480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183486 */     GIR_RootConstrainSelectedInstOperands,
     /* 183487 */     // GIR_Coverage, 3519,
     /* 183487 */     GIR_EraseRootFromParent_Done,
     /* 183488 */   // Label 3640: @183488
     /* 183488 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(183525), // Rule ID 3520 //
     /* 183493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 183501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 183507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183514 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1273:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 183514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 183517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183523 */     GIR_RootConstrainSelectedInstOperands,
     /* 183524 */     // GIR_Coverage, 3520,
     /* 183524 */     GIR_EraseRootFromParent_Done,
     /* 183525 */   // Label 3641: @183525
     /* 183525 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(183562), // Rule ID 3550 //
     /* 183530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 183538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 183541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183551 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1524:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 183554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183560 */     GIR_RootConstrainSelectedInstOperands,
     /* 183561 */     // GIR_Coverage, 3550,
     /* 183561 */     GIR_EraseRootFromParent_Done,
     /* 183562 */   // Label 3642: @183562
     /* 183562 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(183599), // Rule ID 3551 //
     /* 183567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 183575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 183581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183588 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1524:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 183591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183597 */     GIR_RootConstrainSelectedInstOperands,
     /* 183598 */     // GIR_Coverage, 3551,
     /* 183598 */     GIR_EraseRootFromParent_Done,
     /* 183599 */   // Label 3643: @183599
     /* 183599 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(183636), // Rule ID 3552 //
     /* 183604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 183612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 183618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183625 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1524:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 183628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183634 */     GIR_RootConstrainSelectedInstOperands,
     /* 183635 */     // GIR_Coverage, 3552,
     /* 183635 */     GIR_EraseRootFromParent_Done,
     /* 183636 */   // Label 3644: @183636
     /* 183636 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(183673), // Rule ID 3553 //
     /* 183641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 183649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 183655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183662 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1524:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 183665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183671 */     GIR_RootConstrainSelectedInstOperands,
     /* 183672 */     // GIR_Coverage, 3553,
     /* 183672 */     GIR_EraseRootFromParent_Done,
     /* 183673 */   // Label 3645: @183673
     /* 183673 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(183710), // Rule ID 3554 //
     /* 183678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 183686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2068:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 183702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183708 */     GIR_RootConstrainSelectedInstOperands,
     /* 183709 */     // GIR_Coverage, 3554,
     /* 183709 */     GIR_EraseRootFromParent_Done,
     /* 183710 */   // Label 3646: @183710
     /* 183710 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(183747), // Rule ID 3555 //
     /* 183715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 183723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 183739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183745 */     GIR_RootConstrainSelectedInstOperands,
     /* 183746 */     // GIR_Coverage, 3555,
     /* 183746 */     GIR_EraseRootFromParent_Done,
     /* 183747 */   // Label 3647: @183747
     /* 183747 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(183784), // Rule ID 3556 //
     /* 183752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 183760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 183776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183782 */     GIR_RootConstrainSelectedInstOperands,
     /* 183783 */     // GIR_Coverage, 3556,
     /* 183783 */     GIR_EraseRootFromParent_Done,
     /* 183784 */   // Label 3648: @183784
     /* 183784 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(183821), // Rule ID 3557 //
     /* 183789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 183797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183810 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 183813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183819 */     GIR_RootConstrainSelectedInstOperands,
     /* 183820 */     // GIR_Coverage, 3557,
     /* 183820 */     GIR_EraseRootFromParent_Done,
     /* 183821 */   // Label 3649: @183821
     /* 183821 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(183858), // Rule ID 3558 //
     /* 183826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 183834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183847 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2068:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 183850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183856 */     GIR_RootConstrainSelectedInstOperands,
     /* 183857 */     // GIR_Coverage, 3558,
     /* 183857 */     GIR_EraseRootFromParent_Done,
     /* 183858 */   // Label 3650: @183858
     /* 183858 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(183895), // Rule ID 3559 //
     /* 183863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 183871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183884 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2068:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 183887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183893 */     GIR_RootConstrainSelectedInstOperands,
     /* 183894 */     // GIR_Coverage, 3559,
     /* 183894 */     GIR_EraseRootFromParent_Done,
     /* 183895 */   // Label 3651: @183895
     /* 183895 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(183932), // Rule ID 3560 //
     /* 183900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 183908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183921 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2068:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 183921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 183924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183930 */     GIR_RootConstrainSelectedInstOperands,
     /* 183931 */     // GIR_Coverage, 3560,
     /* 183931 */     GIR_EraseRootFromParent_Done,
     /* 183932 */   // Label 3652: @183932
     /* 183932 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(183969), // Rule ID 3561 //
     /* 183937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 183945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1823:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 183961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183967 */     GIR_RootConstrainSelectedInstOperands,
     /* 183968 */     // GIR_Coverage, 3561,
     /* 183968 */     GIR_EraseRootFromParent_Done,
     /* 183969 */   // Label 3653: @183969
     /* 183969 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(184006), // Rule ID 3562 //
     /* 183974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 183982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183995 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 183998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184004 */     GIR_RootConstrainSelectedInstOperands,
     /* 184005 */     // GIR_Coverage, 3562,
     /* 184005 */     GIR_EraseRootFromParent_Done,
     /* 184006 */   // Label 3654: @184006
     /* 184006 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(184043), // Rule ID 3563 //
     /* 184011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 184019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 184035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184041 */     GIR_RootConstrainSelectedInstOperands,
     /* 184042 */     // GIR_Coverage, 3563,
     /* 184042 */     GIR_EraseRootFromParent_Done,
     /* 184043 */   // Label 3655: @184043
     /* 184043 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(184080), // Rule ID 3564 //
     /* 184048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 184056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184069 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 184072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184078 */     GIR_RootConstrainSelectedInstOperands,
     /* 184079 */     // GIR_Coverage, 3564,
     /* 184079 */     GIR_EraseRootFromParent_Done,
     /* 184080 */   // Label 3656: @184080
     /* 184080 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(184117), // Rule ID 3565 //
     /* 184085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 184093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184106 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1823:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 184109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184115 */     GIR_RootConstrainSelectedInstOperands,
     /* 184116 */     // GIR_Coverage, 3565,
     /* 184116 */     GIR_EraseRootFromParent_Done,
     /* 184117 */   // Label 3657: @184117
     /* 184117 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(184154), // Rule ID 3566 //
     /* 184122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 184130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184143 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1823:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 184146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184152 */     GIR_RootConstrainSelectedInstOperands,
     /* 184153 */     // GIR_Coverage, 3566,
     /* 184153 */     GIR_EraseRootFromParent_Done,
     /* 184154 */   // Label 3658: @184154
     /* 184154 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(184191), // Rule ID 3567 //
     /* 184159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 184167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184180 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1823:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 184183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184189 */     GIR_RootConstrainSelectedInstOperands,
     /* 184190 */     // GIR_Coverage, 3567,
     /* 184190 */     GIR_EraseRootFromParent_Done,
     /* 184191 */   // Label 3659: @184191
     /* 184191 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(184228), // Rule ID 8305 //
     /* 184196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 184204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184217 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1202:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 184220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184226 */     GIR_RootConstrainSelectedInstOperands,
     /* 184227 */     // GIR_Coverage, 8305,
     /* 184227 */     GIR_EraseRootFromParent_Done,
     /* 184228 */   // Label 3660: @184228
     /* 184228 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(184265), // Rule ID 8781 //
     /* 184233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 184241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1160:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 184257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184263 */     GIR_RootConstrainSelectedInstOperands,
     /* 184264 */     // GIR_Coverage, 8781,
     /* 184264 */     GIR_EraseRootFromParent_Done,
     /* 184265 */   // Label 3661: @184265
     /* 184265 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(184302), // Rule ID 8782 //
     /* 184270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 184278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184291 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 184294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184300 */     GIR_RootConstrainSelectedInstOperands,
     /* 184301 */     // GIR_Coverage, 8782,
     /* 184301 */     GIR_EraseRootFromParent_Done,
     /* 184302 */   // Label 3662: @184302
     /* 184302 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(184339), // Rule ID 8783 //
     /* 184307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 184315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 184331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184337 */     GIR_RootConstrainSelectedInstOperands,
     /* 184338 */     // GIR_Coverage, 8783,
     /* 184338 */     GIR_EraseRootFromParent_Done,
     /* 184339 */   // Label 3663: @184339
     /* 184339 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(184376), // Rule ID 8784 //
     /* 184344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 184352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1161:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 184368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184374 */     GIR_RootConstrainSelectedInstOperands,
     /* 184375 */     // GIR_Coverage, 8784,
     /* 184375 */     GIR_EraseRootFromParent_Done,
     /* 184376 */   // Label 3664: @184376
     /* 184376 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(184413), // Rule ID 8785 //
     /* 184381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 184389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1160:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 184405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184411 */     GIR_RootConstrainSelectedInstOperands,
     /* 184412 */     // GIR_Coverage, 8785,
     /* 184412 */     GIR_EraseRootFromParent_Done,
     /* 184413 */   // Label 3665: @184413
     /* 184413 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(184450), // Rule ID 8786 //
     /* 184418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 184426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184439 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 184442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184448 */     GIR_RootConstrainSelectedInstOperands,
     /* 184449 */     // GIR_Coverage, 8786,
     /* 184449 */     GIR_EraseRootFromParent_Done,
     /* 184450 */   // Label 3666: @184450
     /* 184450 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(184487), // Rule ID 8787 //
     /* 184455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 184463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 184479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184485 */     GIR_RootConstrainSelectedInstOperands,
     /* 184486 */     // GIR_Coverage, 8787,
     /* 184486 */     GIR_EraseRootFromParent_Done,
     /* 184487 */   // Label 3667: @184487
     /* 184487 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(184524), // Rule ID 8788 //
     /* 184492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 184500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184513 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1161:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 184516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184522 */     GIR_RootConstrainSelectedInstOperands,
     /* 184523 */     // GIR_Coverage, 8788,
     /* 184523 */     GIR_EraseRootFromParent_Done,
     /* 184524 */   // Label 3668: @184524
     /* 184524 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(184564), // Rule ID 9788 //
     /* 184529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 184537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 184553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184562 */     GIR_RootConstrainSelectedInstOperands,
     /* 184563 */     // GIR_Coverage, 9788,
     /* 184563 */     GIR_EraseRootFromParent_Done,
     /* 184564 */   // Label 3669: @184564
     /* 184564 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(184604), // Rule ID 9789 //
     /* 184569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 184577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 184580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 184593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184602 */     GIR_RootConstrainSelectedInstOperands,
     /* 184603 */     // GIR_Coverage, 9789,
     /* 184603 */     GIR_EraseRootFromParent_Done,
     /* 184604 */   // Label 3670: @184604
     /* 184604 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(184644), // Rule ID 9790 //
     /* 184609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 184617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 184620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184630 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 184633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184642 */     GIR_RootConstrainSelectedInstOperands,
     /* 184643 */     // GIR_Coverage, 9790,
     /* 184643 */     GIR_EraseRootFromParent_Done,
     /* 184644 */   // Label 3671: @184644
     /* 184644 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(184684), // Rule ID 9791 //
     /* 184649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 184657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 184660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184670 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 184673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184682 */     GIR_RootConstrainSelectedInstOperands,
     /* 184683 */     // GIR_Coverage, 9791,
     /* 184683 */     GIR_EraseRootFromParent_Done,
     /* 184684 */   // Label 3672: @184684
     /* 184684 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(184724), // Rule ID 9792 //
     /* 184689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 184697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184710 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 184713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184722 */     GIR_RootConstrainSelectedInstOperands,
     /* 184723 */     // GIR_Coverage, 9792,
     /* 184723 */     GIR_EraseRootFromParent_Done,
     /* 184724 */   // Label 3673: @184724
     /* 184724 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(184764), // Rule ID 9793 //
     /* 184729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 184737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 184740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184750 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 184753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184762 */     GIR_RootConstrainSelectedInstOperands,
     /* 184763 */     // GIR_Coverage, 9793,
     /* 184763 */     GIR_EraseRootFromParent_Done,
     /* 184764 */   // Label 3674: @184764
     /* 184764 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(184804), // Rule ID 9794 //
     /* 184769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 184777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 184780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184790 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 184793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184802 */     GIR_RootConstrainSelectedInstOperands,
     /* 184803 */     // GIR_Coverage, 9794,
     /* 184803 */     GIR_EraseRootFromParent_Done,
     /* 184804 */   // Label 3675: @184804
     /* 184804 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(184844), // Rule ID 9795 //
     /* 184809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 184817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 184820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 184833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184842 */     GIR_RootConstrainSelectedInstOperands,
     /* 184843 */     // GIR_Coverage, 9795,
     /* 184843 */     GIR_EraseRootFromParent_Done,
     /* 184844 */   // Label 3676: @184844
     /* 184844 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(184884), // Rule ID 9800 //
     /* 184849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 184857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 184873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184882 */     GIR_RootConstrainSelectedInstOperands,
     /* 184883 */     // GIR_Coverage, 9800,
     /* 184883 */     GIR_EraseRootFromParent_Done,
     /* 184884 */   // Label 3677: @184884
     /* 184884 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(184924), // Rule ID 9801 //
     /* 184889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 184897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 184900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184910 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 184913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184922 */     GIR_RootConstrainSelectedInstOperands,
     /* 184923 */     // GIR_Coverage, 9801,
     /* 184923 */     GIR_EraseRootFromParent_Done,
     /* 184924 */   // Label 3678: @184924
     /* 184924 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(184964), // Rule ID 9802 //
     /* 184929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 184937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 184940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 184953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184962 */     GIR_RootConstrainSelectedInstOperands,
     /* 184963 */     // GIR_Coverage, 9802,
     /* 184963 */     GIR_EraseRootFromParent_Done,
     /* 184964 */   // Label 3679: @184964
     /* 184964 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(185004), // Rule ID 9803 //
     /* 184969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 184977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 184980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 184990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 184993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185002 */     GIR_RootConstrainSelectedInstOperands,
     /* 185003 */     // GIR_Coverage, 9803,
     /* 185003 */     GIR_EraseRootFromParent_Done,
     /* 185004 */   // Label 3680: @185004
     /* 185004 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(185044), // Rule ID 9804 //
     /* 185009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 185017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185030 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 185033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185042 */     GIR_RootConstrainSelectedInstOperands,
     /* 185043 */     // GIR_Coverage, 9804,
     /* 185043 */     GIR_EraseRootFromParent_Done,
     /* 185044 */   // Label 3681: @185044
     /* 185044 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(185084), // Rule ID 9805 //
     /* 185049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 185057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 185060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 185073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185082 */     GIR_RootConstrainSelectedInstOperands,
     /* 185083 */     // GIR_Coverage, 9805,
     /* 185083 */     GIR_EraseRootFromParent_Done,
     /* 185084 */   // Label 3682: @185084
     /* 185084 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(185124), // Rule ID 9806 //
     /* 185089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 185097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 185100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185110 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 185113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185122 */     GIR_RootConstrainSelectedInstOperands,
     /* 185123 */     // GIR_Coverage, 9806,
     /* 185123 */     GIR_EraseRootFromParent_Done,
     /* 185124 */   // Label 3683: @185124
     /* 185124 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(185164), // Rule ID 9807 //
     /* 185129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 185137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 185140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 185153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185162 */     GIR_RootConstrainSelectedInstOperands,
     /* 185163 */     // GIR_Coverage, 9807,
     /* 185163 */     GIR_EraseRootFromParent_Done,
     /* 185164 */   // Label 3684: @185164
     /* 185164 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(185204), // Rule ID 9808 //
     /* 185169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 185177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185190 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 185193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185202 */     GIR_RootConstrainSelectedInstOperands,
     /* 185203 */     // GIR_Coverage, 9808,
     /* 185203 */     GIR_EraseRootFromParent_Done,
     /* 185204 */   // Label 3685: @185204
     /* 185204 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(185244), // Rule ID 9809 //
     /* 185209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 185217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 185220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 185233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185242 */     GIR_RootConstrainSelectedInstOperands,
     /* 185243 */     // GIR_Coverage, 9809,
     /* 185243 */     GIR_EraseRootFromParent_Done,
     /* 185244 */   // Label 3686: @185244
     /* 185244 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(185284), // Rule ID 9810 //
     /* 185249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 185257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 185260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185270 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 185273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185282 */     GIR_RootConstrainSelectedInstOperands,
     /* 185283 */     // GIR_Coverage, 9810,
     /* 185283 */     GIR_EraseRootFromParent_Done,
     /* 185284 */   // Label 3687: @185284
     /* 185284 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(185324), // Rule ID 9811 //
     /* 185289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 185297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 185300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185310 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 185313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185322 */     GIR_RootConstrainSelectedInstOperands,
     /* 185323 */     // GIR_Coverage, 9811,
     /* 185323 */     GIR_EraseRootFromParent_Done,
     /* 185324 */   // Label 3688: @185324
     /* 185324 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(185364), // Rule ID 9816 //
     /* 185329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 185337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 185353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185362 */     GIR_RootConstrainSelectedInstOperands,
     /* 185363 */     // GIR_Coverage, 9816,
     /* 185363 */     GIR_EraseRootFromParent_Done,
     /* 185364 */   // Label 3689: @185364
     /* 185364 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(185404), // Rule ID 9817 //
     /* 185369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 185377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 185380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185390 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 185393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185402 */     GIR_RootConstrainSelectedInstOperands,
     /* 185403 */     // GIR_Coverage, 9817,
     /* 185403 */     GIR_EraseRootFromParent_Done,
     /* 185404 */   // Label 3690: @185404
     /* 185404 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(185444), // Rule ID 9818 //
     /* 185409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 185417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 185420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185430 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 185433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185442 */     GIR_RootConstrainSelectedInstOperands,
     /* 185443 */     // GIR_Coverage, 9818,
     /* 185443 */     GIR_EraseRootFromParent_Done,
     /* 185444 */   // Label 3691: @185444
     /* 185444 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(185484), // Rule ID 9819 //
     /* 185449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 185457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 185460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185470 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 185473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185482 */     GIR_RootConstrainSelectedInstOperands,
     /* 185483 */     // GIR_Coverage, 9819,
     /* 185483 */     GIR_EraseRootFromParent_Done,
     /* 185484 */   // Label 3692: @185484
     /* 185484 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(185521), // Rule ID 9978 //
     /* 185489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 185497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 185513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185519 */     GIR_RootConstrainSelectedInstOperands,
     /* 185520 */     // GIR_Coverage, 9978,
     /* 185520 */     GIR_EraseRootFromParent_Done,
     /* 185521 */   // Label 3693: @185521
     /* 185521 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(185558), // Rule ID 9979 //
     /* 185526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 185534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 185550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185556 */     GIR_RootConstrainSelectedInstOperands,
     /* 185557 */     // GIR_Coverage, 9979,
     /* 185557 */     GIR_EraseRootFromParent_Done,
     /* 185558 */   // Label 3694: @185558
     /* 185558 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(185595), // Rule ID 9980 //
     /* 185563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 185571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 185587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185593 */     GIR_RootConstrainSelectedInstOperands,
     /* 185594 */     // GIR_Coverage, 9980,
     /* 185594 */     GIR_EraseRootFromParent_Done,
     /* 185595 */   // Label 3695: @185595
     /* 185595 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(185632), // Rule ID 9981 //
     /* 185600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 185608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 185624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185630 */     GIR_RootConstrainSelectedInstOperands,
     /* 185631 */     // GIR_Coverage, 9981,
     /* 185631 */     GIR_EraseRootFromParent_Done,
     /* 185632 */   // Label 3696: @185632
     /* 185632 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(185669), // Rule ID 9982 //
     /* 185637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 185645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 185661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185667 */     GIR_RootConstrainSelectedInstOperands,
     /* 185668 */     // GIR_Coverage, 9982,
     /* 185668 */     GIR_EraseRootFromParent_Done,
     /* 185669 */   // Label 3697: @185669
     /* 185669 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(185706), // Rule ID 9983 //
     /* 185674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 185682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 185698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185704 */     GIR_RootConstrainSelectedInstOperands,
     /* 185705 */     // GIR_Coverage, 9983,
     /* 185705 */     GIR_EraseRootFromParent_Done,
     /* 185706 */   // Label 3698: @185706
     /* 185706 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(185743), // Rule ID 9984 //
     /* 185711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 185719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 185735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185741 */     GIR_RootConstrainSelectedInstOperands,
     /* 185742 */     // GIR_Coverage, 9984,
     /* 185742 */     GIR_EraseRootFromParent_Done,
     /* 185743 */   // Label 3699: @185743
     /* 185743 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(185780), // Rule ID 9985 //
     /* 185748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 185756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185769 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 185772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185778 */     GIR_RootConstrainSelectedInstOperands,
     /* 185779 */     // GIR_Coverage, 9985,
     /* 185779 */     GIR_EraseRootFromParent_Done,
     /* 185780 */   // Label 3700: @185780
     /* 185780 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(185817), // Rule ID 9986 //
     /* 185785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 185793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1916:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 185809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185815 */     GIR_RootConstrainSelectedInstOperands,
     /* 185816 */     // GIR_Coverage, 9986,
     /* 185816 */     GIR_EraseRootFromParent_Done,
     /* 185817 */   // Label 3701: @185817
     /* 185817 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(185854), // Rule ID 11154 //
     /* 185822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 185825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 185830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185843 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 185846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185852 */     GIR_RootConstrainSelectedInstOperands,
     /* 185853 */     // GIR_Coverage, 11154,
     /* 185853 */     GIR_EraseRootFromParent_Done,
     /* 185854 */   // Label 3702: @185854
     /* 185854 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(185891), // Rule ID 11155 //
     /* 185859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 185862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 185867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 185883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185889 */     GIR_RootConstrainSelectedInstOperands,
     /* 185890 */     // GIR_Coverage, 11155,
     /* 185890 */     GIR_EraseRootFromParent_Done,
     /* 185891 */   // Label 3703: @185891
     /* 185891 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(185928), // Rule ID 11156 //
     /* 185896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 185899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 185904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185917 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2065:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 185917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 185920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185926 */     GIR_RootConstrainSelectedInstOperands,
     /* 185927 */     // GIR_Coverage, 11156,
     /* 185927 */     GIR_EraseRootFromParent_Done,
     /* 185928 */   // Label 3704: @185928
     /* 185928 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(185965), // Rule ID 11157 //
     /* 185933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 185936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 185941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 185957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185963 */     GIR_RootConstrainSelectedInstOperands,
     /* 185964 */     // GIR_Coverage, 11157,
     /* 185964 */     GIR_EraseRootFromParent_Done,
     /* 185965 */   // Label 3705: @185965
     /* 185965 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(186002), // Rule ID 11158 //
     /* 185970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 185973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 185978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185991 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2065:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 185991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 185994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186000 */     GIR_RootConstrainSelectedInstOperands,
     /* 186001 */     // GIR_Coverage, 11158,
     /* 186001 */     GIR_EraseRootFromParent_Done,
     /* 186002 */   // Label 3706: @186002
     /* 186002 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(186039), // Rule ID 11159 //
     /* 186007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 186015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 186031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186037 */     GIR_RootConstrainSelectedInstOperands,
     /* 186038 */     // GIR_Coverage, 11159,
     /* 186038 */     GIR_EraseRootFromParent_Done,
     /* 186039 */   // Label 3707: @186039
     /* 186039 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(186076), // Rule ID 11160 //
     /* 186044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 186052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186065 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2065:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 186068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186074 */     GIR_RootConstrainSelectedInstOperands,
     /* 186075 */     // GIR_Coverage, 11160,
     /* 186075 */     GIR_EraseRootFromParent_Done,
     /* 186076 */   // Label 3708: @186076
     /* 186076 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(186113), // Rule ID 11161 //
     /* 186081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 186089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1986:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 186105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186111 */     GIR_RootConstrainSelectedInstOperands,
     /* 186112 */     // GIR_Coverage, 11161,
     /* 186112 */     GIR_EraseRootFromParent_Done,
     /* 186113 */   // Label 3709: @186113
     /* 186113 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(186150), // Rule ID 11162 //
     /* 186118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 186126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186139 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1986:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 186142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186148 */     GIR_RootConstrainSelectedInstOperands,
     /* 186149 */     // GIR_Coverage, 11162,
     /* 186149 */     GIR_EraseRootFromParent_Done,
     /* 186150 */   // Label 3710: @186150
     /* 186150 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(186187), // Rule ID 11163 //
     /* 186155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 186163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186176 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1986:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 186179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186185 */     GIR_RootConstrainSelectedInstOperands,
     /* 186186 */     // GIR_Coverage, 11163,
     /* 186186 */     GIR_EraseRootFromParent_Done,
     /* 186187 */   // Label 3711: @186187
     /* 186187 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(186224), // Rule ID 11164 //
     /* 186192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 186200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186213 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 186216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186222 */     GIR_RootConstrainSelectedInstOperands,
     /* 186223 */     // GIR_Coverage, 11164,
     /* 186223 */     GIR_EraseRootFromParent_Done,
     /* 186224 */   // Label 3712: @186224
     /* 186224 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(186261), // Rule ID 11165 //
     /* 186229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 186237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186250 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1986:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 186253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186259 */     GIR_RootConstrainSelectedInstOperands,
     /* 186260 */     // GIR_Coverage, 11165,
     /* 186260 */     GIR_EraseRootFromParent_Done,
     /* 186261 */   // Label 3713: @186261
     /* 186261 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(186298), // Rule ID 11166 //
     /* 186266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 186274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186287 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 186290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186296 */     GIR_RootConstrainSelectedInstOperands,
     /* 186297 */     // GIR_Coverage, 11166,
     /* 186297 */     GIR_EraseRootFromParent_Done,
     /* 186298 */   // Label 3714: @186298
     /* 186298 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(186335), // Rule ID 11167 //
     /* 186303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 186311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1986:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 186327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186333 */     GIR_RootConstrainSelectedInstOperands,
     /* 186334 */     // GIR_Coverage, 11167,
     /* 186334 */     GIR_EraseRootFromParent_Done,
     /* 186335 */   // Label 3715: @186335
     /* 186335 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(186372), // Rule ID 11168 //
     /* 186340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 186348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186361 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1991:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 186364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186370 */     GIR_RootConstrainSelectedInstOperands,
     /* 186371 */     // GIR_Coverage, 11168,
     /* 186371 */     GIR_EraseRootFromParent_Done,
     /* 186372 */   // Label 3716: @186372
     /* 186372 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(186409), // Rule ID 11169 //
     /* 186377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 186385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1991:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 186401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186407 */     GIR_RootConstrainSelectedInstOperands,
     /* 186408 */     // GIR_Coverage, 11169,
     /* 186408 */     GIR_EraseRootFromParent_Done,
     /* 186409 */   // Label 3717: @186409
     /* 186409 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(186446), // Rule ID 11170 //
     /* 186414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 186422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186435 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1991:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 186438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186444 */     GIR_RootConstrainSelectedInstOperands,
     /* 186445 */     // GIR_Coverage, 11170,
     /* 186445 */     GIR_EraseRootFromParent_Done,
     /* 186446 */   // Label 3718: @186446
     /* 186446 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(186483), // Rule ID 11171 //
     /* 186451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 186459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186472 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 186475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186481 */     GIR_RootConstrainSelectedInstOperands,
     /* 186482 */     // GIR_Coverage, 11171,
     /* 186482 */     GIR_EraseRootFromParent_Done,
     /* 186483 */   // Label 3719: @186483
     /* 186483 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(186520), // Rule ID 11172 //
     /* 186488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 186496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186509 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1991:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 186512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186518 */     GIR_RootConstrainSelectedInstOperands,
     /* 186519 */     // GIR_Coverage, 11172,
     /* 186519 */     GIR_EraseRootFromParent_Done,
     /* 186520 */   // Label 3720: @186520
     /* 186520 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(186557), // Rule ID 11173 //
     /* 186525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 186533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 186549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186555 */     GIR_RootConstrainSelectedInstOperands,
     /* 186556 */     // GIR_Coverage, 11173,
     /* 186556 */     GIR_EraseRootFromParent_Done,
     /* 186557 */   // Label 3721: @186557
     /* 186557 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(186594), // Rule ID 11174 //
     /* 186562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 186570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186583 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1991:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 186586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186592 */     GIR_RootConstrainSelectedInstOperands,
     /* 186593 */     // GIR_Coverage, 11174,
     /* 186593 */     GIR_EraseRootFromParent_Done,
     /* 186594 */   // Label 3722: @186594
     /* 186594 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(186631), // Rule ID 11175 //
     /* 186599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 186607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1830:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 186623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186629 */     GIR_RootConstrainSelectedInstOperands,
     /* 186630 */     // GIR_Coverage, 11175,
     /* 186630 */     GIR_EraseRootFromParent_Done,
     /* 186631 */   // Label 3723: @186631
     /* 186631 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(186668), // Rule ID 11176 //
     /* 186636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 186644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186657 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 186660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186666 */     GIR_RootConstrainSelectedInstOperands,
     /* 186667 */     // GIR_Coverage, 11176,
     /* 186667 */     GIR_EraseRootFromParent_Done,
     /* 186668 */   // Label 3724: @186668
     /* 186668 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(186705), // Rule ID 11177 //
     /* 186673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 186681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186694 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1830:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 186697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186703 */     GIR_RootConstrainSelectedInstOperands,
     /* 186704 */     // GIR_Coverage, 11177,
     /* 186704 */     GIR_EraseRootFromParent_Done,
     /* 186705 */   // Label 3725: @186705
     /* 186705 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(186742), // Rule ID 11178 //
     /* 186710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 186718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 186734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186740 */     GIR_RootConstrainSelectedInstOperands,
     /* 186741 */     // GIR_Coverage, 11178,
     /* 186741 */     GIR_EraseRootFromParent_Done,
     /* 186742 */   // Label 3726: @186742
     /* 186742 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(186779), // Rule ID 11179 //
     /* 186747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 186755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186768 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1830:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 186771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186777 */     GIR_RootConstrainSelectedInstOperands,
     /* 186778 */     // GIR_Coverage, 11179,
     /* 186778 */     GIR_EraseRootFromParent_Done,
     /* 186779 */   // Label 3727: @186779
     /* 186779 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(186816), // Rule ID 11180 //
     /* 186784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 186792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186805 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1830:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 186808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186814 */     GIR_RootConstrainSelectedInstOperands,
     /* 186815 */     // GIR_Coverage, 11180,
     /* 186815 */     GIR_EraseRootFromParent_Done,
     /* 186816 */   // Label 3728: @186816
     /* 186816 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(186853), // Rule ID 11181 //
     /* 186821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 186829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186842 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1830:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 186845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186851 */     GIR_RootConstrainSelectedInstOperands,
     /* 186852 */     // GIR_Coverage, 11181,
     /* 186852 */     GIR_EraseRootFromParent_Done,
     /* 186853 */   // Label 3729: @186853
     /* 186853 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(186890), // Rule ID 11182 //
     /* 186858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 186866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 186882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186888 */     GIR_RootConstrainSelectedInstOperands,
     /* 186889 */     // GIR_Coverage, 11182,
     /* 186889 */     GIR_EraseRootFromParent_Done,
     /* 186890 */   // Label 3730: @186890
     /* 186890 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(186927), // Rule ID 11183 //
     /* 186895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 186903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 186919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186925 */     GIR_RootConstrainSelectedInstOperands,
     /* 186926 */     // GIR_Coverage, 11183,
     /* 186926 */     GIR_EraseRootFromParent_Done,
     /* 186927 */   // Label 3731: @186927
     /* 186927 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(186964), // Rule ID 11184 //
     /* 186932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 186940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186953 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1835:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 186956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186962 */     GIR_RootConstrainSelectedInstOperands,
     /* 186963 */     // GIR_Coverage, 11184,
     /* 186963 */     GIR_EraseRootFromParent_Done,
     /* 186964 */   // Label 3732: @186964
     /* 186964 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(187001), // Rule ID 11185 //
     /* 186969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 186977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 186993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186999 */     GIR_RootConstrainSelectedInstOperands,
     /* 187000 */     // GIR_Coverage, 11185,
     /* 187000 */     GIR_EraseRootFromParent_Done,
     /* 187001 */   // Label 3733: @187001
     /* 187001 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(187038), // Rule ID 11186 //
     /* 187006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 187014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187027 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1835:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 187030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187036 */     GIR_RootConstrainSelectedInstOperands,
     /* 187037 */     // GIR_Coverage, 11186,
     /* 187037 */     GIR_EraseRootFromParent_Done,
     /* 187038 */   // Label 3734: @187038
     /* 187038 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(187075), // Rule ID 11187 //
     /* 187043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 187051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 187067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187073 */     GIR_RootConstrainSelectedInstOperands,
     /* 187074 */     // GIR_Coverage, 11187,
     /* 187074 */     GIR_EraseRootFromParent_Done,
     /* 187075 */   // Label 3735: @187075
     /* 187075 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(187112), // Rule ID 11188 //
     /* 187080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 187088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187101 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1835:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 187104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187110 */     GIR_RootConstrainSelectedInstOperands,
     /* 187111 */     // GIR_Coverage, 11188,
     /* 187111 */     GIR_EraseRootFromParent_Done,
     /* 187112 */   // Label 3736: @187112
     /* 187112 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(187149), // Rule ID 11208 //
     /* 187117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 187125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1732:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 187141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187147 */     GIR_RootConstrainSelectedInstOperands,
     /* 187148 */     // GIR_Coverage, 11208,
     /* 187148 */     GIR_EraseRootFromParent_Done,
     /* 187149 */   // Label 3737: @187149
     /* 187149 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(187186), // Rule ID 11209 //
     /* 187154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 187162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1732:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 187178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187184 */     GIR_RootConstrainSelectedInstOperands,
     /* 187185 */     // GIR_Coverage, 11209,
     /* 187185 */     GIR_EraseRootFromParent_Done,
     /* 187186 */   // Label 3738: @187186
     /* 187186 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(187223), // Rule ID 11210 //
     /* 187191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 187199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 187215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187221 */     GIR_RootConstrainSelectedInstOperands,
     /* 187222 */     // GIR_Coverage, 11210,
     /* 187222 */     GIR_EraseRootFromParent_Done,
     /* 187223 */   // Label 3739: @187223
     /* 187223 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(187260), // Rule ID 11211 //
     /* 187228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 187236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 187252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187258 */     GIR_RootConstrainSelectedInstOperands,
     /* 187259 */     // GIR_Coverage, 11211,
     /* 187259 */     GIR_EraseRootFromParent_Done,
     /* 187260 */   // Label 3740: @187260
     /* 187260 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(187297), // Rule ID 11499 //
     /* 187265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 187273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 187289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187295 */     GIR_RootConstrainSelectedInstOperands,
     /* 187296 */     // GIR_Coverage, 11499,
     /* 187296 */     GIR_EraseRootFromParent_Done,
     /* 187297 */   // Label 3741: @187297
     /* 187297 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(187334), // Rule ID 11500 //
     /* 187302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 187310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 187326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187332 */     GIR_RootConstrainSelectedInstOperands,
     /* 187333 */     // GIR_Coverage, 11500,
     /* 187333 */     GIR_EraseRootFromParent_Done,
     /* 187334 */   // Label 3742: @187334
     /* 187334 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(187371), // Rule ID 11501 //
     /* 187339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 187347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1596:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 187363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187369 */     GIR_RootConstrainSelectedInstOperands,
     /* 187370 */     // GIR_Coverage, 11501,
     /* 187370 */     GIR_EraseRootFromParent_Done,
     /* 187371 */   // Label 3743: @187371
     /* 187371 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(187408), // Rule ID 11502 //
     /* 187376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 187384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 187400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187406 */     GIR_RootConstrainSelectedInstOperands,
     /* 187407 */     // GIR_Coverage, 11502,
     /* 187407 */     GIR_EraseRootFromParent_Done,
     /* 187408 */   // Label 3744: @187408
     /* 187408 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(187445), // Rule ID 11503 //
     /* 187413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 187421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 187437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187443 */     GIR_RootConstrainSelectedInstOperands,
     /* 187444 */     // GIR_Coverage, 11503,
     /* 187444 */     GIR_EraseRootFromParent_Done,
     /* 187445 */   // Label 3745: @187445
     /* 187445 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(187482), // Rule ID 11504 //
     /* 187450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 187458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187471 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 187474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187480 */     GIR_RootConstrainSelectedInstOperands,
     /* 187481 */     // GIR_Coverage, 11504,
     /* 187481 */     GIR_EraseRootFromParent_Done,
     /* 187482 */   // Label 3746: @187482
     /* 187482 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(187519), // Rule ID 11505 //
     /* 187487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 187495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 187511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187517 */     GIR_RootConstrainSelectedInstOperands,
     /* 187518 */     // GIR_Coverage, 11505,
     /* 187518 */     GIR_EraseRootFromParent_Done,
     /* 187519 */   // Label 3747: @187519
     /* 187519 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(187556), // Rule ID 11506 //
     /* 187524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 187532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 187548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187554 */     GIR_RootConstrainSelectedInstOperands,
     /* 187555 */     // GIR_Coverage, 11506,
     /* 187555 */     GIR_EraseRootFromParent_Done,
     /* 187556 */   // Label 3748: @187556
     /* 187556 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(187593), // Rule ID 11507 //
     /* 187561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 187569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 187585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187591 */     GIR_RootConstrainSelectedInstOperands,
     /* 187592 */     // GIR_Coverage, 11507,
     /* 187592 */     GIR_EraseRootFromParent_Done,
     /* 187593 */   // Label 3749: @187593
     /* 187593 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(187630), // Rule ID 11508 //
     /* 187598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 187606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187619 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1773:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 187622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187628 */     GIR_RootConstrainSelectedInstOperands,
     /* 187629 */     // GIR_Coverage, 11508,
     /* 187629 */     GIR_EraseRootFromParent_Done,
     /* 187630 */   // Label 3750: @187630
     /* 187630 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(187667), // Rule ID 11509 //
     /* 187635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 187643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1773:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 187659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187665 */     GIR_RootConstrainSelectedInstOperands,
     /* 187666 */     // GIR_Coverage, 11509,
     /* 187666 */     GIR_EraseRootFromParent_Done,
     /* 187667 */   // Label 3751: @187667
     /* 187667 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(187704), // Rule ID 11510 //
     /* 187672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 187680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 187696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187702 */     GIR_RootConstrainSelectedInstOperands,
     /* 187703 */     // GIR_Coverage, 11510,
     /* 187703 */     GIR_EraseRootFromParent_Done,
     /* 187704 */   // Label 3752: @187704
     /* 187704 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(187741), // Rule ID 11511 //
     /* 187709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 187717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1775:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 187733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187739 */     GIR_RootConstrainSelectedInstOperands,
     /* 187740 */     // GIR_Coverage, 11511,
     /* 187740 */     GIR_EraseRootFromParent_Done,
     /* 187741 */   // Label 3753: @187741
     /* 187741 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(187778), // Rule ID 11512 //
     /* 187746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 187754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1775:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 187770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187776 */     GIR_RootConstrainSelectedInstOperands,
     /* 187777 */     // GIR_Coverage, 11512,
     /* 187777 */     GIR_EraseRootFromParent_Done,
     /* 187778 */   // Label 3754: @187778
     /* 187778 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(187815), // Rule ID 11513 //
     /* 187783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 187791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1775:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 187807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187813 */     GIR_RootConstrainSelectedInstOperands,
     /* 187814 */     // GIR_Coverage, 11513,
     /* 187814 */     GIR_EraseRootFromParent_Done,
     /* 187815 */   // Label 3755: @187815
     /* 187815 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(187852), // Rule ID 11514 //
     /* 187820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 187828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 187844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187850 */     GIR_RootConstrainSelectedInstOperands,
     /* 187851 */     // GIR_Coverage, 11514,
     /* 187851 */     GIR_EraseRootFromParent_Done,
     /* 187852 */   // Label 3756: @187852
     /* 187852 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(187889), // Rule ID 11515 //
     /* 187857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 187865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 187881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187887 */     GIR_RootConstrainSelectedInstOperands,
     /* 187888 */     // GIR_Coverage, 11515,
     /* 187888 */     GIR_EraseRootFromParent_Done,
     /* 187889 */   // Label 3757: @187889
     /* 187889 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(187926), // Rule ID 11516 //
     /* 187894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 187902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 187918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187924 */     GIR_RootConstrainSelectedInstOperands,
     /* 187925 */     // GIR_Coverage, 11516,
     /* 187925 */     GIR_EraseRootFromParent_Done,
     /* 187926 */   // Label 3758: @187926
     /* 187926 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(187963), // Rule ID 11517 //
     /* 187931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 187939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 187955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187961 */     GIR_RootConstrainSelectedInstOperands,
     /* 187962 */     // GIR_Coverage, 11517,
     /* 187962 */     GIR_EraseRootFromParent_Done,
     /* 187963 */   // Label 3759: @187963
     /* 187963 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(188000), // Rule ID 11518 //
     /* 187968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 187976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 187992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187998 */     GIR_RootConstrainSelectedInstOperands,
     /* 187999 */     // GIR_Coverage, 11518,
     /* 187999 */     GIR_EraseRootFromParent_Done,
     /* 188000 */   // Label 3760: @188000
     /* 188000 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(188037), // Rule ID 11519 //
     /* 188005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 188013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188026 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 188029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188035 */     GIR_RootConstrainSelectedInstOperands,
     /* 188036 */     // GIR_Coverage, 11519,
     /* 188036 */     GIR_EraseRootFromParent_Done,
     /* 188037 */   // Label 3761: @188037
     /* 188037 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(188074), // Rule ID 11520 //
     /* 188042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 188050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188063 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 188066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188072 */     GIR_RootConstrainSelectedInstOperands,
     /* 188073 */     // GIR_Coverage, 11520,
     /* 188073 */     GIR_EraseRootFromParent_Done,
     /* 188074 */   // Label 3762: @188074
     /* 188074 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(188111), // Rule ID 11521 //
     /* 188079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 188087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 188103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188109 */     GIR_RootConstrainSelectedInstOperands,
     /* 188110 */     // GIR_Coverage, 11521,
     /* 188110 */     GIR_EraseRootFromParent_Done,
     /* 188111 */   // Label 3763: @188111
     /* 188111 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(188148), // Rule ID 11522 //
     /* 188116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 188124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188137 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 188140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188146 */     GIR_RootConstrainSelectedInstOperands,
     /* 188147 */     // GIR_Coverage, 11522,
     /* 188147 */     GIR_EraseRootFromParent_Done,
     /* 188148 */   // Label 3764: @188148
     /* 188148 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(188185), // Rule ID 11523 //
     /* 188153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 188161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 188177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188183 */     GIR_RootConstrainSelectedInstOperands,
     /* 188184 */     // GIR_Coverage, 11523,
     /* 188184 */     GIR_EraseRootFromParent_Done,
     /* 188185 */   // Label 3765: @188185
     /* 188185 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(188222), // Rule ID 11524 //
     /* 188190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 188198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 188214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188220 */     GIR_RootConstrainSelectedInstOperands,
     /* 188221 */     // GIR_Coverage, 11524,
     /* 188221 */     GIR_EraseRootFromParent_Done,
     /* 188222 */   // Label 3766: @188222
     /* 188222 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(188259), // Rule ID 11525 //
     /* 188227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 188235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1592:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 188251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188257 */     GIR_RootConstrainSelectedInstOperands,
     /* 188258 */     // GIR_Coverage, 11525,
     /* 188258 */     GIR_EraseRootFromParent_Done,
     /* 188259 */   // Label 3767: @188259
     /* 188259 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(188296), // Rule ID 11526 //
     /* 188264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 188272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 188288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188294 */     GIR_RootConstrainSelectedInstOperands,
     /* 188295 */     // GIR_Coverage, 11526,
     /* 188295 */     GIR_EraseRootFromParent_Done,
     /* 188296 */   // Label 3768: @188296
     /* 188296 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(188333), // Rule ID 11527 //
     /* 188301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 188309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 188325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188331 */     GIR_RootConstrainSelectedInstOperands,
     /* 188332 */     // GIR_Coverage, 11527,
     /* 188332 */     GIR_EraseRootFromParent_Done,
     /* 188333 */   // Label 3769: @188333
     /* 188333 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(188370), // Rule ID 11528 //
     /* 188338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 188346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 188362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188368 */     GIR_RootConstrainSelectedInstOperands,
     /* 188369 */     // GIR_Coverage, 11528,
     /* 188369 */     GIR_EraseRootFromParent_Done,
     /* 188370 */   // Label 3770: @188370
     /* 188370 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(188407), // Rule ID 11529 //
     /* 188375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 188383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 188399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188405 */     GIR_RootConstrainSelectedInstOperands,
     /* 188406 */     // GIR_Coverage, 11529,
     /* 188406 */     GIR_EraseRootFromParent_Done,
     /* 188407 */   // Label 3771: @188407
     /* 188407 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(188444), // Rule ID 11530 //
     /* 188412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 188420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 188436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188442 */     GIR_RootConstrainSelectedInstOperands,
     /* 188443 */     // GIR_Coverage, 11530,
     /* 188443 */     GIR_EraseRootFromParent_Done,
     /* 188444 */   // Label 3772: @188444
     /* 188444 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(188481), // Rule ID 11531 //
     /* 188449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 188457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188470 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 188473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188479 */     GIR_RootConstrainSelectedInstOperands,
     /* 188480 */     // GIR_Coverage, 11531,
     /* 188480 */     GIR_EraseRootFromParent_Done,
     /* 188481 */   // Label 3773: @188481
     /* 188481 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(188518), // Rule ID 11541 //
     /* 188486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 188494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188507 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1777:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 188510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188516 */     GIR_RootConstrainSelectedInstOperands,
     /* 188517 */     // GIR_Coverage, 11541,
     /* 188517 */     GIR_EraseRootFromParent_Done,
     /* 188518 */   // Label 3774: @188518
     /* 188518 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(188555), // Rule ID 11542 //
     /* 188523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 188531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1777:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 188547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188553 */     GIR_RootConstrainSelectedInstOperands,
     /* 188554 */     // GIR_Coverage, 11542,
     /* 188554 */     GIR_EraseRootFromParent_Done,
     /* 188555 */   // Label 3775: @188555
     /* 188555 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(188592), // Rule ID 11543 //
     /* 188560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 188568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188581 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1777:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 188584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188590 */     GIR_RootConstrainSelectedInstOperands,
     /* 188591 */     // GIR_Coverage, 11543,
     /* 188591 */     GIR_EraseRootFromParent_Done,
     /* 188592 */   // Label 3776: @188592
     /* 188592 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(188629), // Rule ID 11544 //
     /* 188597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 188605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1778:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 188621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188627 */     GIR_RootConstrainSelectedInstOperands,
     /* 188628 */     // GIR_Coverage, 11544,
     /* 188628 */     GIR_EraseRootFromParent_Done,
     /* 188629 */   // Label 3777: @188629
     /* 188629 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(188666), // Rule ID 11545 //
     /* 188634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 188642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188655 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 188658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188664 */     GIR_RootConstrainSelectedInstOperands,
     /* 188665 */     // GIR_Coverage, 11545,
     /* 188665 */     GIR_EraseRootFromParent_Done,
     /* 188666 */   // Label 3778: @188666
     /* 188666 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(188703), // Rule ID 11546 //
     /* 188671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 188679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 188695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188701 */     GIR_RootConstrainSelectedInstOperands,
     /* 188702 */     // GIR_Coverage, 11546,
     /* 188702 */     GIR_EraseRootFromParent_Done,
     /* 188703 */   // Label 3779: @188703
     /* 188703 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(188740), // Rule ID 11547 //
     /* 188708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 188716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188729 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 188732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188738 */     GIR_RootConstrainSelectedInstOperands,
     /* 188739 */     // GIR_Coverage, 11547,
     /* 188739 */     GIR_EraseRootFromParent_Done,
     /* 188740 */   // Label 3780: @188740
     /* 188740 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(188777), // Rule ID 11548 //
     /* 188745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 188753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 188769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188775 */     GIR_RootConstrainSelectedInstOperands,
     /* 188776 */     // GIR_Coverage, 11548,
     /* 188776 */     GIR_EraseRootFromParent_Done,
     /* 188777 */   // Label 3781: @188777
     /* 188777 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(188814), // Rule ID 11549 //
     /* 188782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 188790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188803 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 188806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188812 */     GIR_RootConstrainSelectedInstOperands,
     /* 188813 */     // GIR_Coverage, 11549,
     /* 188813 */     GIR_EraseRootFromParent_Done,
     /* 188814 */   // Label 3782: @188814
     /* 188814 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(188851), // Rule ID 11550 //
     /* 188819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 188827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188840 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1972:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 188843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188849 */     GIR_RootConstrainSelectedInstOperands,
     /* 188850 */     // GIR_Coverage, 11550,
     /* 188850 */     GIR_EraseRootFromParent_Done,
     /* 188851 */   // Label 3783: @188851
     /* 188851 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(188888), // Rule ID 11551 //
     /* 188856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 188864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 188880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188886 */     GIR_RootConstrainSelectedInstOperands,
     /* 188887 */     // GIR_Coverage, 11551,
     /* 188887 */     GIR_EraseRootFromParent_Done,
     /* 188888 */   // Label 3784: @188888
     /* 188888 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(188925), // Rule ID 11552 //
     /* 188893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 188901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 188917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188923 */     GIR_RootConstrainSelectedInstOperands,
     /* 188924 */     // GIR_Coverage, 11552,
     /* 188924 */     GIR_EraseRootFromParent_Done,
     /* 188925 */   // Label 3785: @188925
     /* 188925 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(188962), // Rule ID 11553 //
     /* 188930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 188938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188951 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1707:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 188954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188960 */     GIR_RootConstrainSelectedInstOperands,
     /* 188961 */     // GIR_Coverage, 11553,
     /* 188961 */     GIR_EraseRootFromParent_Done,
     /* 188962 */   // Label 3786: @188962
     /* 188962 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(188999), // Rule ID 11554 //
     /* 188967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 188975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 188991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188997 */     GIR_RootConstrainSelectedInstOperands,
     /* 188998 */     // GIR_Coverage, 11554,
     /* 188998 */     GIR_EraseRootFromParent_Done,
     /* 188999 */   // Label 3787: @188999
     /* 188999 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(189036), // Rule ID 11555 //
     /* 189004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 189012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 189028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189034 */     GIR_RootConstrainSelectedInstOperands,
     /* 189035 */     // GIR_Coverage, 11555,
     /* 189035 */     GIR_EraseRootFromParent_Done,
     /* 189036 */   // Label 3788: @189036
     /* 189036 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(189073), // Rule ID 11556 //
     /* 189041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 189049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1709:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 189065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189071 */     GIR_RootConstrainSelectedInstOperands,
     /* 189072 */     // GIR_Coverage, 11556,
     /* 189072 */     GIR_EraseRootFromParent_Done,
     /* 189073 */   // Label 3789: @189073
     /* 189073 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(189110), // Rule ID 11557 //
     /* 189078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 189086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189099 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 189102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189108 */     GIR_RootConstrainSelectedInstOperands,
     /* 189109 */     // GIR_Coverage, 11557,
     /* 189109 */     GIR_EraseRootFromParent_Done,
     /* 189110 */   // Label 3790: @189110
     /* 189110 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(189147), // Rule ID 11558 //
     /* 189115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 189123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1709:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 189139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189145 */     GIR_RootConstrainSelectedInstOperands,
     /* 189146 */     // GIR_Coverage, 11558,
     /* 189146 */     GIR_EraseRootFromParent_Done,
     /* 189147 */   // Label 3791: @189147
     /* 189147 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(189184), // Rule ID 11559 //
     /* 189152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 189160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189173 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1660:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 189176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189182 */     GIR_RootConstrainSelectedInstOperands,
     /* 189183 */     // GIR_Coverage, 11559,
     /* 189183 */     GIR_EraseRootFromParent_Done,
     /* 189184 */   // Label 3792: @189184
     /* 189184 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(189221), // Rule ID 11560 //
     /* 189189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 189197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1660:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 189213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189219 */     GIR_RootConstrainSelectedInstOperands,
     /* 189220 */     // GIR_Coverage, 11560,
     /* 189220 */     GIR_EraseRootFromParent_Done,
     /* 189221 */   // Label 3793: @189221
     /* 189221 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(189258), // Rule ID 11561 //
     /* 189226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 189234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189247 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1660:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 189250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189256 */     GIR_RootConstrainSelectedInstOperands,
     /* 189257 */     // GIR_Coverage, 11561,
     /* 189257 */     GIR_EraseRootFromParent_Done,
     /* 189258 */   // Label 3794: @189258
     /* 189258 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(189295), // Rule ID 11562 //
     /* 189263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 189271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 189287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189293 */     GIR_RootConstrainSelectedInstOperands,
     /* 189294 */     // GIR_Coverage, 11562,
     /* 189294 */     GIR_EraseRootFromParent_Done,
     /* 189295 */   // Label 3795: @189295
     /* 189295 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(189332), // Rule ID 11563 //
     /* 189300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 189308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189321 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 189324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189330 */     GIR_RootConstrainSelectedInstOperands,
     /* 189331 */     // GIR_Coverage, 11563,
     /* 189331 */     GIR_EraseRootFromParent_Done,
     /* 189332 */   // Label 3796: @189332
     /* 189332 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(189369), // Rule ID 11564 //
     /* 189337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 189345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 189361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189367 */     GIR_RootConstrainSelectedInstOperands,
     /* 189368 */     // GIR_Coverage, 11564,
     /* 189368 */     GIR_EraseRootFromParent_Done,
     /* 189369 */   // Label 3797: @189369
     /* 189369 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(189406), // Rule ID 11565 //
     /* 189374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 189382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1898:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 189398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189404 */     GIR_RootConstrainSelectedInstOperands,
     /* 189405 */     // GIR_Coverage, 11565,
     /* 189405 */     GIR_EraseRootFromParent_Done,
     /* 189406 */   // Label 3798: @189406
     /* 189406 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(189443), // Rule ID 11566 //
     /* 189411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 189419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1898:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 189435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189441 */     GIR_RootConstrainSelectedInstOperands,
     /* 189442 */     // GIR_Coverage, 11566,
     /* 189442 */     GIR_EraseRootFromParent_Done,
     /* 189443 */   // Label 3799: @189443
     /* 189443 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(189480), // Rule ID 11567 //
     /* 189448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 189456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1898:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 189472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189478 */     GIR_RootConstrainSelectedInstOperands,
     /* 189479 */     // GIR_Coverage, 11567,
     /* 189479 */     GIR_EraseRootFromParent_Done,
     /* 189480 */   // Label 3800: @189480
     /* 189480 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(189517), // Rule ID 11568 //
     /* 189485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 189493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1900:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 189509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189515 */     GIR_RootConstrainSelectedInstOperands,
     /* 189516 */     // GIR_Coverage, 11568,
     /* 189516 */     GIR_EraseRootFromParent_Done,
     /* 189517 */   // Label 3801: @189517
     /* 189517 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(189554), // Rule ID 11569 //
     /* 189522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 189530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1900:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 189546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189552 */     GIR_RootConstrainSelectedInstOperands,
     /* 189553 */     // GIR_Coverage, 11569,
     /* 189553 */     GIR_EraseRootFromParent_Done,
     /* 189554 */   // Label 3802: @189554
     /* 189554 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(189591), // Rule ID 11570 //
     /* 189559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 189567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189580 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1900:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 189583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189589 */     GIR_RootConstrainSelectedInstOperands,
     /* 189590 */     // GIR_Coverage, 11570,
     /* 189590 */     GIR_EraseRootFromParent_Done,
     /* 189591 */   // Label 3803: @189591
     /* 189591 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(189628), // Rule ID 11571 //
     /* 189596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 189604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189617 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1538:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 189620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189626 */     GIR_RootConstrainSelectedInstOperands,
     /* 189627 */     // GIR_Coverage, 11571,
     /* 189627 */     GIR_EraseRootFromParent_Done,
     /* 189628 */   // Label 3804: @189628
     /* 189628 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(189665), // Rule ID 11572 //
     /* 189633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 189641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1538:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 189657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189663 */     GIR_RootConstrainSelectedInstOperands,
     /* 189664 */     // GIR_Coverage, 11572,
     /* 189664 */     GIR_EraseRootFromParent_Done,
     /* 189665 */   // Label 3805: @189665
     /* 189665 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(189702), // Rule ID 11673 //
     /* 189670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 189678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189691 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1568:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 189694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189700 */     GIR_RootConstrainSelectedInstOperands,
     /* 189701 */     // GIR_Coverage, 11673,
     /* 189701 */     GIR_EraseRootFromParent_Done,
     /* 189702 */   // Label 3806: @189702
     /* 189702 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(189739), // Rule ID 11674 //
     /* 189707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 189715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1568:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 189731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189737 */     GIR_RootConstrainSelectedInstOperands,
     /* 189738 */     // GIR_Coverage, 11674,
     /* 189738 */     GIR_EraseRootFromParent_Done,
     /* 189739 */   // Label 3807: @189739
     /* 189739 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(189776), // Rule ID 11675 //
     /* 189744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 189752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1568:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 189768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189774 */     GIR_RootConstrainSelectedInstOperands,
     /* 189775 */     // GIR_Coverage, 11675,
     /* 189775 */     GIR_EraseRootFromParent_Done,
     /* 189776 */   // Label 3808: @189776
     /* 189776 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(189813), // Rule ID 11676 //
     /* 189781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 189789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 189805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189811 */     GIR_RootConstrainSelectedInstOperands,
     /* 189812 */     // GIR_Coverage, 11676,
     /* 189812 */     GIR_EraseRootFromParent_Done,
     /* 189813 */   // Label 3809: @189813
     /* 189813 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(189850), // Rule ID 11677 //
     /* 189818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 189826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189839 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 189842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189848 */     GIR_RootConstrainSelectedInstOperands,
     /* 189849 */     // GIR_Coverage, 11677,
     /* 189849 */     GIR_EraseRootFromParent_Done,
     /* 189850 */   // Label 3810: @189850
     /* 189850 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(189887), // Rule ID 11678 //
     /* 189855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 189863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 189879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189885 */     GIR_RootConstrainSelectedInstOperands,
     /* 189886 */     // GIR_Coverage, 11678,
     /* 189886 */     GIR_EraseRootFromParent_Done,
     /* 189887 */   // Label 3811: @189887
     /* 189887 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(189924), // Rule ID 11679 //
     /* 189892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 189900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189913 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1584:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 189916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189922 */     GIR_RootConstrainSelectedInstOperands,
     /* 189923 */     // GIR_Coverage, 11679,
     /* 189923 */     GIR_EraseRootFromParent_Done,
     /* 189924 */   // Label 3812: @189924
     /* 189924 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(189961), // Rule ID 11680 //
     /* 189929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 189937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1584:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 189953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189959 */     GIR_RootConstrainSelectedInstOperands,
     /* 189960 */     // GIR_Coverage, 11680,
     /* 189960 */     GIR_EraseRootFromParent_Done,
     /* 189961 */   // Label 3813: @189961
     /* 189961 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(189998), // Rule ID 11681 //
     /* 189966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 189974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189987 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1584:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 189990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189996 */     GIR_RootConstrainSelectedInstOperands,
     /* 189997 */     // GIR_Coverage, 11681,
     /* 189997 */     GIR_EraseRootFromParent_Done,
     /* 189998 */   // Label 3814: @189998
     /* 189998 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(190035), // Rule ID 11697 //
     /* 190003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 190011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1951:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 190027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190033 */     GIR_RootConstrainSelectedInstOperands,
     /* 190034 */     // GIR_Coverage, 11697,
     /* 190034 */     GIR_EraseRootFromParent_Done,
     /* 190035 */   // Label 3815: @190035
     /* 190035 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(190072), // Rule ID 11698 //
     /* 190040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 190048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1951:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 190064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190070 */     GIR_RootConstrainSelectedInstOperands,
     /* 190071 */     // GIR_Coverage, 11698,
     /* 190071 */     GIR_EraseRootFromParent_Done,
     /* 190072 */   // Label 3816: @190072
     /* 190072 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(190109), // Rule ID 11699 //
     /* 190077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 190085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1951:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 190101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190107 */     GIR_RootConstrainSelectedInstOperands,
     /* 190108 */     // GIR_Coverage, 11699,
     /* 190108 */     GIR_EraseRootFromParent_Done,
     /* 190109 */   // Label 3817: @190109
     /* 190109 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(190146), // Rule ID 11700 //
     /* 190114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 190122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190135 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 190138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190144 */     GIR_RootConstrainSelectedInstOperands,
     /* 190145 */     // GIR_Coverage, 11700,
     /* 190145 */     GIR_EraseRootFromParent_Done,
     /* 190146 */   // Label 3818: @190146
     /* 190146 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(190183), // Rule ID 11701 //
     /* 190151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 190159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190172 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 190175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190181 */     GIR_RootConstrainSelectedInstOperands,
     /* 190182 */     // GIR_Coverage, 11701,
     /* 190182 */     GIR_EraseRootFromParent_Done,
     /* 190183 */   // Label 3819: @190183
     /* 190183 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(190220), // Rule ID 11702 //
     /* 190188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 190196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190209 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 190212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190218 */     GIR_RootConstrainSelectedInstOperands,
     /* 190219 */     // GIR_Coverage, 11702,
     /* 190219 */     GIR_EraseRootFromParent_Done,
     /* 190220 */   // Label 3820: @190220
     /* 190220 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(190257), // Rule ID 11718 //
     /* 190225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 190233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1774:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 190249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190255 */     GIR_RootConstrainSelectedInstOperands,
     /* 190256 */     // GIR_Coverage, 11718,
     /* 190256 */     GIR_EraseRootFromParent_Done,
     /* 190257 */   // Label 3821: @190257
     /* 190257 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(190294), // Rule ID 11719 //
     /* 190262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 190270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190283 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 190286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190292 */     GIR_RootConstrainSelectedInstOperands,
     /* 190293 */     // GIR_Coverage, 11719,
     /* 190293 */     GIR_EraseRootFromParent_Done,
     /* 190294 */   // Label 3822: @190294
     /* 190294 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(190331), // Rule ID 11720 //
     /* 190299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 190307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 190323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190329 */     GIR_RootConstrainSelectedInstOperands,
     /* 190330 */     // GIR_Coverage, 11720,
     /* 190330 */     GIR_EraseRootFromParent_Done,
     /* 190331 */   // Label 3823: @190331
     /* 190331 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(190368), // Rule ID 11721 //
     /* 190336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 190344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190357 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 190360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190366 */     GIR_RootConstrainSelectedInstOperands,
     /* 190367 */     // GIR_Coverage, 11721,
     /* 190367 */     GIR_EraseRootFromParent_Done,
     /* 190368 */   // Label 3824: @190368
     /* 190368 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(190405), // Rule ID 11722 //
     /* 190373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 190381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1776:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 190397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190403 */     GIR_RootConstrainSelectedInstOperands,
     /* 190404 */     // GIR_Coverage, 11722,
     /* 190404 */     GIR_EraseRootFromParent_Done,
     /* 190405 */   // Label 3825: @190405
     /* 190405 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(190442), // Rule ID 11723 //
     /* 190410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 190418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1776:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 190434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190440 */     GIR_RootConstrainSelectedInstOperands,
     /* 190441 */     // GIR_Coverage, 11723,
     /* 190441 */     GIR_EraseRootFromParent_Done,
     /* 190442 */   // Label 3826: @190442
     /* 190442 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(190482), // Rule ID 11798 //
     /* 190447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 190455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 190471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190480 */     GIR_RootConstrainSelectedInstOperands,
     /* 190481 */     // GIR_Coverage, 11798,
     /* 190481 */     GIR_EraseRootFromParent_Done,
     /* 190482 */   // Label 3827: @190482
     /* 190482 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(190522), // Rule ID 11799 //
     /* 190487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 190495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 190511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190520 */     GIR_RootConstrainSelectedInstOperands,
     /* 190521 */     // GIR_Coverage, 11799,
     /* 190521 */     GIR_EraseRootFromParent_Done,
     /* 190522 */   // Label 3828: @190522
     /* 190522 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(190562), // Rule ID 11800 //
     /* 190527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 190535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 190551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190560 */     GIR_RootConstrainSelectedInstOperands,
     /* 190561 */     // GIR_Coverage, 11800,
     /* 190561 */     GIR_EraseRootFromParent_Done,
     /* 190562 */   // Label 3829: @190562
     /* 190562 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(190602), // Rule ID 11801 //
     /* 190567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 190575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190588 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 190591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190600 */     GIR_RootConstrainSelectedInstOperands,
     /* 190601 */     // GIR_Coverage, 11801,
     /* 190601 */     GIR_EraseRootFromParent_Done,
     /* 190602 */   // Label 3830: @190602
     /* 190602 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(190642), // Rule ID 11802 //
     /* 190607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 190615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 190631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190640 */     GIR_RootConstrainSelectedInstOperands,
     /* 190641 */     // GIR_Coverage, 11802,
     /* 190641 */     GIR_EraseRootFromParent_Done,
     /* 190642 */   // Label 3831: @190642
     /* 190642 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(190682), // Rule ID 11803 //
     /* 190647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 190655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190668 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 190671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190680 */     GIR_RootConstrainSelectedInstOperands,
     /* 190681 */     // GIR_Coverage, 11803,
     /* 190681 */     GIR_EraseRootFromParent_Done,
     /* 190682 */   // Label 3832: @190682
     /* 190682 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(190722), // Rule ID 11804 //
     /* 190687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 190695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190708 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 190711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190720 */     GIR_RootConstrainSelectedInstOperands,
     /* 190721 */     // GIR_Coverage, 11804,
     /* 190721 */     GIR_EraseRootFromParent_Done,
     /* 190722 */   // Label 3833: @190722
     /* 190722 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(190762), // Rule ID 11805 //
     /* 190727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 190735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190748 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 190751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190760 */     GIR_RootConstrainSelectedInstOperands,
     /* 190761 */     // GIR_Coverage, 11805,
     /* 190761 */     GIR_EraseRootFromParent_Done,
     /* 190762 */   // Label 3834: @190762
     /* 190762 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(190802), // Rule ID 11810 //
     /* 190767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 190775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190788 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 190791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190800 */     GIR_RootConstrainSelectedInstOperands,
     /* 190801 */     // GIR_Coverage, 11810,
     /* 190801 */     GIR_EraseRootFromParent_Done,
     /* 190802 */   // Label 3835: @190802
     /* 190802 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(190842), // Rule ID 11811 //
     /* 190807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 190815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 190831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190840 */     GIR_RootConstrainSelectedInstOperands,
     /* 190841 */     // GIR_Coverage, 11811,
     /* 190841 */     GIR_EraseRootFromParent_Done,
     /* 190842 */   // Label 3836: @190842
     /* 190842 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(190882), // Rule ID 11812 //
     /* 190847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 190855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 190858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190868 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 190871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190880 */     GIR_RootConstrainSelectedInstOperands,
     /* 190881 */     // GIR_Coverage, 11812,
     /* 190881 */     GIR_EraseRootFromParent_Done,
     /* 190882 */   // Label 3837: @190882
     /* 190882 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(190922), // Rule ID 11813 //
     /* 190887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 190895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 190898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190908 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 190911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190920 */     GIR_RootConstrainSelectedInstOperands,
     /* 190921 */     // GIR_Coverage, 11813,
     /* 190921 */     GIR_EraseRootFromParent_Done,
     /* 190922 */   // Label 3838: @190922
     /* 190922 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(190962), // Rule ID 11814 //
     /* 190927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 190935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 190938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190948 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 190951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 190960 */     GIR_RootConstrainSelectedInstOperands,
     /* 190961 */     // GIR_Coverage, 11814,
     /* 190961 */     GIR_EraseRootFromParent_Done,
     /* 190962 */   // Label 3839: @190962
     /* 190962 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(191002), // Rule ID 11815 //
     /* 190967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 190975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 190978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 190981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 190984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 190988 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 190988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 190991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 190993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191000 */     GIR_RootConstrainSelectedInstOperands,
     /* 191001 */     // GIR_Coverage, 11815,
     /* 191001 */     GIR_EraseRootFromParent_Done,
     /* 191002 */   // Label 3840: @191002
     /* 191002 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(191042), // Rule ID 11816 //
     /* 191007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 191015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 191021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 191024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 191028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 191031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191040 */     GIR_RootConstrainSelectedInstOperands,
     /* 191041 */     // GIR_Coverage, 11816,
     /* 191041 */     GIR_EraseRootFromParent_Done,
     /* 191042 */   // Label 3841: @191042
     /* 191042 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(191082), // Rule ID 11817 //
     /* 191047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 191055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 191061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 191064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 191068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 191071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191080 */     GIR_RootConstrainSelectedInstOperands,
     /* 191081 */     // GIR_Coverage, 11817,
     /* 191081 */     GIR_EraseRootFromParent_Done,
     /* 191082 */   // Label 3842: @191082
     /* 191082 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(191122), // Rule ID 11822 //
     /* 191087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 191095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191108 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 191111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191120 */     GIR_RootConstrainSelectedInstOperands,
     /* 191121 */     // GIR_Coverage, 11822,
     /* 191121 */     GIR_EraseRootFromParent_Done,
     /* 191122 */   // Label 3843: @191122
     /* 191122 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(191162), // Rule ID 11823 //
     /* 191127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 191135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 191151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191160 */     GIR_RootConstrainSelectedInstOperands,
     /* 191161 */     // GIR_Coverage, 11823,
     /* 191161 */     GIR_EraseRootFromParent_Done,
     /* 191162 */   // Label 3844: @191162
     /* 191162 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(191202), // Rule ID 11824 //
     /* 191167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 191175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191188 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 191191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191200 */     GIR_RootConstrainSelectedInstOperands,
     /* 191201 */     // GIR_Coverage, 11824,
     /* 191201 */     GIR_EraseRootFromParent_Done,
     /* 191202 */   // Label 3845: @191202
     /* 191202 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(191242), // Rule ID 11825 //
     /* 191207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 191215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 191231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191240 */     GIR_RootConstrainSelectedInstOperands,
     /* 191241 */     // GIR_Coverage, 11825,
     /* 191241 */     GIR_EraseRootFromParent_Done,
     /* 191242 */   // Label 3846: @191242
     /* 191242 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(191282), // Rule ID 11826 //
     /* 191247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 191255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191268 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 191271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191280 */     GIR_RootConstrainSelectedInstOperands,
     /* 191281 */     // GIR_Coverage, 11826,
     /* 191281 */     GIR_EraseRootFromParent_Done,
     /* 191282 */   // Label 3847: @191282
     /* 191282 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(191322), // Rule ID 11827 //
     /* 191287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 191295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191308 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 191311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191320 */     GIR_RootConstrainSelectedInstOperands,
     /* 191321 */     // GIR_Coverage, 11827,
     /* 191321 */     GIR_EraseRootFromParent_Done,
     /* 191322 */   // Label 3848: @191322
     /* 191322 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(191362), // Rule ID 11828 //
     /* 191327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 191335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 191351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191360 */     GIR_RootConstrainSelectedInstOperands,
     /* 191361 */     // GIR_Coverage, 11828,
     /* 191361 */     GIR_EraseRootFromParent_Done,
     /* 191362 */   // Label 3849: @191362
     /* 191362 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(191402), // Rule ID 11829 //
     /* 191367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 191375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191388 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 191391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191400 */     GIR_RootConstrainSelectedInstOperands,
     /* 191401 */     // GIR_Coverage, 11829,
     /* 191401 */     GIR_EraseRootFromParent_Done,
     /* 191402 */   // Label 3850: @191402
     /* 191402 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(191442), // Rule ID 11834 //
     /* 191407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 191415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191428 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 191431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191440 */     GIR_RootConstrainSelectedInstOperands,
     /* 191441 */     // GIR_Coverage, 11834,
     /* 191441 */     GIR_EraseRootFromParent_Done,
     /* 191442 */   // Label 3851: @191442
     /* 191442 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(191482), // Rule ID 11835 //
     /* 191447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 191455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 191471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191480 */     GIR_RootConstrainSelectedInstOperands,
     /* 191481 */     // GIR_Coverage, 11835,
     /* 191481 */     GIR_EraseRootFromParent_Done,
     /* 191482 */   // Label 3852: @191482
     /* 191482 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(191522), // Rule ID 11836 //
     /* 191487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 191495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 191511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191520 */     GIR_RootConstrainSelectedInstOperands,
     /* 191521 */     // GIR_Coverage, 11836,
     /* 191521 */     GIR_EraseRootFromParent_Done,
     /* 191522 */   // Label 3853: @191522
     /* 191522 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(191562), // Rule ID 11837 //
     /* 191527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 191535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191548 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 191551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191560 */     GIR_RootConstrainSelectedInstOperands,
     /* 191561 */     // GIR_Coverage, 11837,
     /* 191561 */     GIR_EraseRootFromParent_Done,
     /* 191562 */   // Label 3854: @191562
     /* 191562 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(191602), // Rule ID 11838 //
     /* 191567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 191575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 191591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191600 */     GIR_RootConstrainSelectedInstOperands,
     /* 191601 */     // GIR_Coverage, 11838,
     /* 191601 */     GIR_EraseRootFromParent_Done,
     /* 191602 */   // Label 3855: @191602
     /* 191602 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(191642), // Rule ID 11839 //
     /* 191607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 191615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 191631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191640 */     GIR_RootConstrainSelectedInstOperands,
     /* 191641 */     // GIR_Coverage, 11839,
     /* 191641 */     GIR_EraseRootFromParent_Done,
     /* 191642 */   // Label 3856: @191642
     /* 191642 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(191682), // Rule ID 11840 //
     /* 191647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 191655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 191671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191680 */     GIR_RootConstrainSelectedInstOperands,
     /* 191681 */     // GIR_Coverage, 11840,
     /* 191681 */     GIR_EraseRootFromParent_Done,
     /* 191682 */   // Label 3857: @191682
     /* 191682 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(191722), // Rule ID 11841 //
     /* 191687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 191695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 191698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 191701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 191704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191708 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 191711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191720 */     GIR_RootConstrainSelectedInstOperands,
     /* 191721 */     // GIR_Coverage, 11841,
     /* 191721 */     GIR_EraseRootFromParent_Done,
     /* 191722 */   // Label 3858: @191722
     /* 191722 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(191759), // Rule ID 11850 //
     /* 191727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 191730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 191735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1164:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 191751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191757 */     GIR_RootConstrainSelectedInstOperands,
     /* 191758 */     // GIR_Coverage, 11850,
     /* 191758 */     GIR_EraseRootFromParent_Done,
     /* 191759 */   // Label 3859: @191759
     /* 191759 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(191796), // Rule ID 11852 //
     /* 191764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 191767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 191772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191785 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1538:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 191788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191794 */     GIR_RootConstrainSelectedInstOperands,
     /* 191795 */     // GIR_Coverage, 11852,
     /* 191795 */     GIR_EraseRootFromParent_Done,
     /* 191796 */   // Label 3860: @191796
     /* 191796 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(191833), // Rule ID 11853 //
     /* 191801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 191804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 191809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 191825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 191827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191831 */     GIR_RootConstrainSelectedInstOperands,
     /* 191832 */     // GIR_Coverage, 11853,
     /* 191832 */     GIR_EraseRootFromParent_Done,
     /* 191833 */   // Label 3861: @191833
     /* 191833 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(191870), // Rule ID 11854 //
     /* 191838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 191841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 191846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1570:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 191862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191868 */     GIR_RootConstrainSelectedInstOperands,
     /* 191869 */     // GIR_Coverage, 11854,
     /* 191869 */     GIR_EraseRootFromParent_Done,
     /* 191870 */   // Label 3862: @191870
     /* 191870 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(191907), // Rule ID 11855 //
     /* 191875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 191878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 191883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1178:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 191899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191905 */     GIR_RootConstrainSelectedInstOperands,
     /* 191906 */     // GIR_Coverage, 11855,
     /* 191906 */     GIR_EraseRootFromParent_Done,
     /* 191907 */   // Label 3863: @191907
     /* 191907 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(191944), // Rule ID 11856 //
     /* 191912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 191915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 191920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1178:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 191936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191942 */     GIR_RootConstrainSelectedInstOperands,
     /* 191943 */     // GIR_Coverage, 11856,
     /* 191943 */     GIR_EraseRootFromParent_Done,
     /* 191944 */   // Label 3864: @191944
     /* 191944 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(191981), // Rule ID 11857 //
     /* 191949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 191952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 191957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1178:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 191973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191979 */     GIR_RootConstrainSelectedInstOperands,
     /* 191980 */     // GIR_Coverage, 11857,
     /* 191980 */     GIR_EraseRootFromParent_Done,
     /* 191981 */   // Label 3865: @191981
     /* 191981 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(192018), // Rule ID 11858 //
     /* 191986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 191989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 191994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192007 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1178:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 192010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192016 */     GIR_RootConstrainSelectedInstOperands,
     /* 192017 */     // GIR_Coverage, 11858,
     /* 192017 */     GIR_EraseRootFromParent_Done,
     /* 192018 */   // Label 3866: @192018
     /* 192018 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(192055), // Rule ID 11859 //
     /* 192023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 192026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 192031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1195:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 192047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192053 */     GIR_RootConstrainSelectedInstOperands,
     /* 192054 */     // GIR_Coverage, 11859,
     /* 192054 */     GIR_EraseRootFromParent_Done,
     /* 192055 */   // Label 3867: @192055
     /* 192055 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(192092), // Rule ID 11860 //
     /* 192060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 192063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 192068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1195:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 192084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192090 */     GIR_RootConstrainSelectedInstOperands,
     /* 192091 */     // GIR_Coverage, 11860,
     /* 192091 */     GIR_EraseRootFromParent_Done,
     /* 192092 */   // Label 3868: @192092
     /* 192092 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(192129), // Rule ID 11861 //
     /* 192097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 192100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 192105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1195:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 192121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192127 */     GIR_RootConstrainSelectedInstOperands,
     /* 192128 */     // GIR_Coverage, 11861,
     /* 192128 */     GIR_EraseRootFromParent_Done,
     /* 192129 */   // Label 3869: @192129
     /* 192129 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(192166), // Rule ID 11862 //
     /* 192134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 192137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 192142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192155 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1195:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 192158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192164 */     GIR_RootConstrainSelectedInstOperands,
     /* 192165 */     // GIR_Coverage, 11862,
     /* 192165 */     GIR_EraseRootFromParent_Done,
     /* 192166 */   // Label 3870: @192166
     /* 192166 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(192203), // Rule ID 11975 //
     /* 192171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 192179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 192185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192192 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1344:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 192195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192201 */     GIR_RootConstrainSelectedInstOperands,
     /* 192202 */     // GIR_Coverage, 11975,
     /* 192202 */     GIR_EraseRootFromParent_Done,
     /* 192203 */   // Label 3871: @192203
     /* 192203 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(192240), // Rule ID 11976 //
     /* 192208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 192216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 192222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192229 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1344:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 192232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192238 */     GIR_RootConstrainSelectedInstOperands,
     /* 192239 */     // GIR_Coverage, 11976,
     /* 192239 */     GIR_EraseRootFromParent_Done,
     /* 192240 */   // Label 3872: @192240
     /* 192240 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(192277), // Rule ID 11977 //
     /* 192245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 192253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 192259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192266 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1344:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 192269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192275 */     GIR_RootConstrainSelectedInstOperands,
     /* 192276 */     // GIR_Coverage, 11977,
     /* 192276 */     GIR_EraseRootFromParent_Done,
     /* 192277 */   // Label 3873: @192277
     /* 192277 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(192314), // Rule ID 11978 //
     /* 192282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 192290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 192296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192303 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 192306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192312 */     GIR_RootConstrainSelectedInstOperands,
     /* 192313 */     // GIR_Coverage, 11978,
     /* 192313 */     GIR_EraseRootFromParent_Done,
     /* 192314 */   // Label 3874: @192314
     /* 192314 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(192351), // Rule ID 11979 //
     /* 192319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 192327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 192333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192340 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 192343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192349 */     GIR_RootConstrainSelectedInstOperands,
     /* 192350 */     // GIR_Coverage, 11979,
     /* 192350 */     GIR_EraseRootFromParent_Done,
     /* 192351 */   // Label 3875: @192351
     /* 192351 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(192388), // Rule ID 11980 //
     /* 192356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 192364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 192370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192377 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 192380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192386 */     GIR_RootConstrainSelectedInstOperands,
     /* 192387 */     // GIR_Coverage, 11980,
     /* 192387 */     GIR_EraseRootFromParent_Done,
     /* 192388 */   // Label 3876: @192388
     /* 192388 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(192425), // Rule ID 11981 //
     /* 192393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 192401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 192407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192414 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1347:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 192417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192423 */     GIR_RootConstrainSelectedInstOperands,
     /* 192424 */     // GIR_Coverage, 11981,
     /* 192424 */     GIR_EraseRootFromParent_Done,
     /* 192425 */   // Label 3877: @192425
     /* 192425 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(192462), // Rule ID 11982 //
     /* 192430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 192438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 192444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192451 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1347:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 192454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192460 */     GIR_RootConstrainSelectedInstOperands,
     /* 192461 */     // GIR_Coverage, 11982,
     /* 192461 */     GIR_EraseRootFromParent_Done,
     /* 192462 */   // Label 3878: @192462
     /* 192462 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(192499), // Rule ID 11983 //
     /* 192467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 192475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 192481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192488 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1347:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 192491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192497 */     GIR_RootConstrainSelectedInstOperands,
     /* 192498 */     // GIR_Coverage, 11983,
     /* 192498 */     GIR_EraseRootFromParent_Done,
     /* 192499 */   // Label 3879: @192499
     /* 192499 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(192536), // Rule ID 11984 //
     /* 192504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 192512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 192518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192525 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1365:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 192528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192534 */     GIR_RootConstrainSelectedInstOperands,
     /* 192535 */     // GIR_Coverage, 11984,
     /* 192535 */     GIR_EraseRootFromParent_Done,
     /* 192536 */   // Label 3880: @192536
     /* 192536 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(192573), // Rule ID 11985 //
     /* 192541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 192549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 192555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192562 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 192565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192571 */     GIR_RootConstrainSelectedInstOperands,
     /* 192572 */     // GIR_Coverage, 11985,
     /* 192572 */     GIR_EraseRootFromParent_Done,
     /* 192573 */   // Label 3881: @192573
     /* 192573 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(192610), // Rule ID 11986 //
     /* 192578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 192586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 192592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192599 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 192602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192608 */     GIR_RootConstrainSelectedInstOperands,
     /* 192609 */     // GIR_Coverage, 11986,
     /* 192609 */     GIR_EraseRootFromParent_Done,
     /* 192610 */   // Label 3882: @192610
     /* 192610 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(192647), // Rule ID 11987 //
     /* 192615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 192623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 192629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192636 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1259:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 192639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192645 */     GIR_RootConstrainSelectedInstOperands,
     /* 192646 */     // GIR_Coverage, 11987,
     /* 192646 */     GIR_EraseRootFromParent_Done,
     /* 192647 */   // Label 3883: @192647
     /* 192647 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(192684), // Rule ID 11988 //
     /* 192652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 192660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 192666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192673 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1259:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 192676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192682 */     GIR_RootConstrainSelectedInstOperands,
     /* 192683 */     // GIR_Coverage, 11988,
     /* 192683 */     GIR_EraseRootFromParent_Done,
     /* 192684 */   // Label 3884: @192684
     /* 192684 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(192721), // Rule ID 11989 //
     /* 192689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 192697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 192703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192710 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1259:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 192713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192719 */     GIR_RootConstrainSelectedInstOperands,
     /* 192720 */     // GIR_Coverage, 11989,
     /* 192720 */     GIR_EraseRootFromParent_Done,
     /* 192721 */   // Label 3885: @192721
     /* 192721 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(192758), // Rule ID 11990 //
     /* 192726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 192734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 192740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192747 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1259:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 192750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192756 */     GIR_RootConstrainSelectedInstOperands,
     /* 192757 */     // GIR_Coverage, 11990,
     /* 192757 */     GIR_EraseRootFromParent_Done,
     /* 192758 */   // Label 3886: @192758
     /* 192758 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(192795), // Rule ID 11991 //
     /* 192763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 192771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 192777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192784 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1171:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 192787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192793 */     GIR_RootConstrainSelectedInstOperands,
     /* 192794 */     // GIR_Coverage, 11991,
     /* 192794 */     GIR_EraseRootFromParent_Done,
     /* 192795 */   // Label 3887: @192795
     /* 192795 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(192832), // Rule ID 11992 //
     /* 192800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 192808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 192814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192821 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1171:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 192824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192830 */     GIR_RootConstrainSelectedInstOperands,
     /* 192831 */     // GIR_Coverage, 11992,
     /* 192831 */     GIR_EraseRootFromParent_Done,
     /* 192832 */   // Label 3888: @192832
     /* 192832 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(192869), // Rule ID 11993 //
     /* 192837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 192845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 192851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192858 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1171:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 192861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192867 */     GIR_RootConstrainSelectedInstOperands,
     /* 192868 */     // GIR_Coverage, 11993,
     /* 192868 */     GIR_EraseRootFromParent_Done,
     /* 192869 */   // Label 3889: @192869
     /* 192869 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(192906), // Rule ID 11994 //
     /* 192874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 192882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 192888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192895 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1171:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 192898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192904 */     GIR_RootConstrainSelectedInstOperands,
     /* 192905 */     // GIR_Coverage, 11994,
     /* 192905 */     GIR_EraseRootFromParent_Done,
     /* 192906 */   // Label 3890: @192906
     /* 192906 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(192943), // Rule ID 11995 //
     /* 192911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 192919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 192925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192932 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1159:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 192935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192941 */     GIR_RootConstrainSelectedInstOperands,
     /* 192942 */     // GIR_Coverage, 11995,
     /* 192942 */     GIR_EraseRootFromParent_Done,
     /* 192943 */   // Label 3891: @192943
     /* 192943 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(192980), // Rule ID 11996 //
     /* 192948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 192956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 192962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192969 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1159:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 192972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 192974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192978 */     GIR_RootConstrainSelectedInstOperands,
     /* 192979 */     // GIR_Coverage, 11996,
     /* 192979 */     GIR_EraseRootFromParent_Done,
     /* 192980 */   // Label 3892: @192980
     /* 192980 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(193017), // Rule ID 11997 //
     /* 192985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 192993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 192999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193006 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1159:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 193009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193015 */     GIR_RootConstrainSelectedInstOperands,
     /* 193016 */     // GIR_Coverage, 11997,
     /* 193016 */     GIR_EraseRootFromParent_Done,
     /* 193017 */   // Label 3893: @193017
     /* 193017 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(193054), // Rule ID 11998 //
     /* 193022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 193030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 193036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193043 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1159:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 193046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193052 */     GIR_RootConstrainSelectedInstOperands,
     /* 193053 */     // GIR_Coverage, 11998,
     /* 193053 */     GIR_EraseRootFromParent_Done,
     /* 193054 */   // Label 3894: @193054
     /* 193054 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(193091), // Rule ID 11999 //
     /* 193059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 193067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 193073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193080 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1638:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 193083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193089 */     GIR_RootConstrainSelectedInstOperands,
     /* 193090 */     // GIR_Coverage, 11999,
     /* 193090 */     GIR_EraseRootFromParent_Done,
     /* 193091 */   // Label 3895: @193091
     /* 193091 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(193128), // Rule ID 12000 //
     /* 193096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 193104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 193110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193117 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1638:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 193120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193126 */     GIR_RootConstrainSelectedInstOperands,
     /* 193127 */     // GIR_Coverage, 12000,
     /* 193127 */     GIR_EraseRootFromParent_Done,
     /* 193128 */   // Label 3896: @193128
     /* 193128 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(193165), // Rule ID 12001 //
     /* 193133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 193141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 193147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193154 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1638:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 193157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193163 */     GIR_RootConstrainSelectedInstOperands,
     /* 193164 */     // GIR_Coverage, 12001,
     /* 193164 */     GIR_EraseRootFromParent_Done,
     /* 193165 */   // Label 3897: @193165
     /* 193165 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(193202), // Rule ID 12002 //
     /* 193170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 193178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 193184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193191 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1638:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 193194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193200 */     GIR_RootConstrainSelectedInstOperands,
     /* 193201 */     // GIR_Coverage, 12002,
     /* 193201 */     GIR_EraseRootFromParent_Done,
     /* 193202 */   // Label 3898: @193202
     /* 193202 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(193239), // Rule ID 12003 //
     /* 193207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 193215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 193221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193228 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1876:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 193231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193237 */     GIR_RootConstrainSelectedInstOperands,
     /* 193238 */     // GIR_Coverage, 12003,
     /* 193238 */     GIR_EraseRootFromParent_Done,
     /* 193239 */   // Label 3899: @193239
     /* 193239 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(193276), // Rule ID 12004 //
     /* 193244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 193252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 193258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193265 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1876:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 193268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193274 */     GIR_RootConstrainSelectedInstOperands,
     /* 193275 */     // GIR_Coverage, 12004,
     /* 193275 */     GIR_EraseRootFromParent_Done,
     /* 193276 */   // Label 3900: @193276
     /* 193276 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(193313), // Rule ID 12005 //
     /* 193281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 193289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 193295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193302 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1876:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 193305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193311 */     GIR_RootConstrainSelectedInstOperands,
     /* 193312 */     // GIR_Coverage, 12005,
     /* 193312 */     GIR_EraseRootFromParent_Done,
     /* 193313 */   // Label 3901: @193313
     /* 193313 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(193350), // Rule ID 12006 //
     /* 193318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 193326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 193332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193339 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1876:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 193342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193348 */     GIR_RootConstrainSelectedInstOperands,
     /* 193349 */     // GIR_Coverage, 12006,
     /* 193349 */     GIR_EraseRootFromParent_Done,
     /* 193350 */   // Label 3902: @193350
     /* 193350 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(193387), // Rule ID 12007 //
     /* 193355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 193363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 193369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193376 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1647:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 193379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193385 */     GIR_RootConstrainSelectedInstOperands,
     /* 193386 */     // GIR_Coverage, 12007,
     /* 193386 */     GIR_EraseRootFromParent_Done,
     /* 193387 */   // Label 3903: @193387
     /* 193387 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(193424), // Rule ID 12008 //
     /* 193392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 193400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 193406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193413 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1647:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 193416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193422 */     GIR_RootConstrainSelectedInstOperands,
     /* 193423 */     // GIR_Coverage, 12008,
     /* 193423 */     GIR_EraseRootFromParent_Done,
     /* 193424 */   // Label 3904: @193424
     /* 193424 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(193461), // Rule ID 12009 //
     /* 193429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 193437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 193443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193450 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1647:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 193453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193459 */     GIR_RootConstrainSelectedInstOperands,
     /* 193460 */     // GIR_Coverage, 12009,
     /* 193460 */     GIR_EraseRootFromParent_Done,
     /* 193461 */   // Label 3905: @193461
     /* 193461 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(193498), // Rule ID 12010 //
     /* 193466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 193474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 193480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193487 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1647:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 193490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193496 */     GIR_RootConstrainSelectedInstOperands,
     /* 193497 */     // GIR_Coverage, 12010,
     /* 193497 */     GIR_EraseRootFromParent_Done,
     /* 193498 */   // Label 3906: @193498
     /* 193498 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(193535), // Rule ID 12011 //
     /* 193503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 193511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 193517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193524 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1885:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 193527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193533 */     GIR_RootConstrainSelectedInstOperands,
     /* 193534 */     // GIR_Coverage, 12011,
     /* 193534 */     GIR_EraseRootFromParent_Done,
     /* 193535 */   // Label 3907: @193535
     /* 193535 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(193572), // Rule ID 12012 //
     /* 193540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 193548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 193554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193561 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1885:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 193564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193570 */     GIR_RootConstrainSelectedInstOperands,
     /* 193571 */     // GIR_Coverage, 12012,
     /* 193571 */     GIR_EraseRootFromParent_Done,
     /* 193572 */   // Label 3908: @193572
     /* 193572 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(193609), // Rule ID 12013 //
     /* 193577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 193585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 193591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193598 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1885:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 193601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193607 */     GIR_RootConstrainSelectedInstOperands,
     /* 193608 */     // GIR_Coverage, 12013,
     /* 193608 */     GIR_EraseRootFromParent_Done,
     /* 193609 */   // Label 3909: @193609
     /* 193609 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(193646), // Rule ID 12014 //
     /* 193614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 193622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 193628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193635 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1885:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 193638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 193640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193644 */     GIR_RootConstrainSelectedInstOperands,
     /* 193645 */     // GIR_Coverage, 12014,
     /* 193645 */     GIR_EraseRootFromParent_Done,
     /* 193646 */   // Label 3910: @193646
     /* 193646 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(193683), // Rule ID 12015 //
     /* 193651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 193659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 193675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193681 */     GIR_RootConstrainSelectedInstOperands,
     /* 193682 */     // GIR_Coverage, 12015,
     /* 193682 */     GIR_EraseRootFromParent_Done,
     /* 193683 */   // Label 3911: @193683
     /* 193683 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(193720), // Rule ID 12016 //
     /* 193688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 193696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 193712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193718 */     GIR_RootConstrainSelectedInstOperands,
     /* 193719 */     // GIR_Coverage, 12016,
     /* 193719 */     GIR_EraseRootFromParent_Done,
     /* 193720 */   // Label 3912: @193720
     /* 193720 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(193757), // Rule ID 12017 //
     /* 193725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 193733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 193749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193755 */     GIR_RootConstrainSelectedInstOperands,
     /* 193756 */     // GIR_Coverage, 12017,
     /* 193756 */     GIR_EraseRootFromParent_Done,
     /* 193757 */   // Label 3913: @193757
     /* 193757 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(193794), // Rule ID 12018 //
     /* 193762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 193770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193783 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 193786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193792 */     GIR_RootConstrainSelectedInstOperands,
     /* 193793 */     // GIR_Coverage, 12018,
     /* 193793 */     GIR_EraseRootFromParent_Done,
     /* 193794 */   // Label 3914: @193794
     /* 193794 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(193831), // Rule ID 12019 //
     /* 193799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 193807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193820 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2069:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 193820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 193823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193829 */     GIR_RootConstrainSelectedInstOperands,
     /* 193830 */     // GIR_Coverage, 12019,
     /* 193830 */     GIR_EraseRootFromParent_Done,
     /* 193831 */   // Label 3915: @193831
     /* 193831 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(193868), // Rule ID 12020 //
     /* 193836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 193844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193857 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2069:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 193857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 193860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193866 */     GIR_RootConstrainSelectedInstOperands,
     /* 193867 */     // GIR_Coverage, 12020,
     /* 193867 */     GIR_EraseRootFromParent_Done,
     /* 193868 */   // Label 3916: @193868
     /* 193868 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(193905), // Rule ID 12021 //
     /* 193873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 193881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193894 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2069:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 193894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 193897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193903 */     GIR_RootConstrainSelectedInstOperands,
     /* 193904 */     // GIR_Coverage, 12021,
     /* 193904 */     GIR_EraseRootFromParent_Done,
     /* 193905 */   // Label 3917: @193905
     /* 193905 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(193942), // Rule ID 12022 //
     /* 193910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 193918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193931 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 193934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193940 */     GIR_RootConstrainSelectedInstOperands,
     /* 193941 */     // GIR_Coverage, 12022,
     /* 193941 */     GIR_EraseRootFromParent_Done,
     /* 193942 */   // Label 3918: @193942
     /* 193942 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(193979), // Rule ID 12023 //
     /* 193947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 193955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 193971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193977 */     GIR_RootConstrainSelectedInstOperands,
     /* 193978 */     // GIR_Coverage, 12023,
     /* 193978 */     GIR_EraseRootFromParent_Done,
     /* 193979 */   // Label 3919: @193979
     /* 193979 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(194016), // Rule ID 12024 //
     /* 193984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 193987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 193992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194005 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 194008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194014 */     GIR_RootConstrainSelectedInstOperands,
     /* 194015 */     // GIR_Coverage, 12024,
     /* 194015 */     GIR_EraseRootFromParent_Done,
     /* 194016 */   // Label 3920: @194016
     /* 194016 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(194053), // Rule ID 12025 //
     /* 194021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 194029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 194045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194051 */     GIR_RootConstrainSelectedInstOperands,
     /* 194052 */     // GIR_Coverage, 12025,
     /* 194052 */     GIR_EraseRootFromParent_Done,
     /* 194053 */   // Label 3921: @194053
     /* 194053 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(194090), // Rule ID 12026 //
     /* 194058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 194066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194079 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1994:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 194079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 194082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194088 */     GIR_RootConstrainSelectedInstOperands,
     /* 194089 */     // GIR_Coverage, 12026,
     /* 194089 */     GIR_EraseRootFromParent_Done,
     /* 194090 */   // Label 3922: @194090
     /* 194090 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(194127), // Rule ID 12027 //
     /* 194095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 194103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194116 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1994:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 194116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 194119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194125 */     GIR_RootConstrainSelectedInstOperands,
     /* 194126 */     // GIR_Coverage, 12027,
     /* 194126 */     GIR_EraseRootFromParent_Done,
     /* 194127 */   // Label 3923: @194127
     /* 194127 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(194164), // Rule ID 12028 //
     /* 194132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 194140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194153 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1994:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 194153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 194156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194162 */     GIR_RootConstrainSelectedInstOperands,
     /* 194163 */     // GIR_Coverage, 12028,
     /* 194163 */     GIR_EraseRootFromParent_Done,
     /* 194164 */   // Label 3924: @194164
     /* 194164 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(194201), // Rule ID 12029 //
     /* 194169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 194177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1995:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 194193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194199 */     GIR_RootConstrainSelectedInstOperands,
     /* 194200 */     // GIR_Coverage, 12029,
     /* 194200 */     GIR_EraseRootFromParent_Done,
     /* 194201 */   // Label 3925: @194201
     /* 194201 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(194238), // Rule ID 12030 //
     /* 194206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 194214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 194230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194236 */     GIR_RootConstrainSelectedInstOperands,
     /* 194237 */     // GIR_Coverage, 12030,
     /* 194237 */     GIR_EraseRootFromParent_Done,
     /* 194238 */   // Label 3926: @194238
     /* 194238 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(194275), // Rule ID 12031 //
     /* 194243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 194251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 194267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194273 */     GIR_RootConstrainSelectedInstOperands,
     /* 194274 */     // GIR_Coverage, 12031,
     /* 194274 */     GIR_EraseRootFromParent_Done,
     /* 194275 */   // Label 3927: @194275
     /* 194275 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(194312), // Rule ID 12032 //
     /* 194280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 194288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194301 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 194304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194310 */     GIR_RootConstrainSelectedInstOperands,
     /* 194311 */     // GIR_Coverage, 12032,
     /* 194311 */     GIR_EraseRootFromParent_Done,
     /* 194312 */   // Label 3928: @194312
     /* 194312 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(194349), // Rule ID 12033 //
     /* 194317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 194325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194338 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1995:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 194338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 194341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194347 */     GIR_RootConstrainSelectedInstOperands,
     /* 194348 */     // GIR_Coverage, 12033,
     /* 194348 */     GIR_EraseRootFromParent_Done,
     /* 194349 */   // Label 3929: @194349
     /* 194349 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(194386), // Rule ID 12034 //
     /* 194354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 194362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194375 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1995:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 194375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 194378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194384 */     GIR_RootConstrainSelectedInstOperands,
     /* 194385 */     // GIR_Coverage, 12034,
     /* 194385 */     GIR_EraseRootFromParent_Done,
     /* 194386 */   // Label 3930: @194386
     /* 194386 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(194423), // Rule ID 12035 //
     /* 194391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 194394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 194399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194412 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1995:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 194412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 194415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194421 */     GIR_RootConstrainSelectedInstOperands,
     /* 194422 */     // GIR_Coverage, 12035,
     /* 194422 */     GIR_EraseRootFromParent_Done,
     /* 194423 */   // Label 3931: @194423
     /* 194423 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(194465), // Rule ID 3209 //
     /* 194428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 194436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194443 */     // MIs[0] Op1
     /* 194443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 194447 */     // MIs[0] Op2
     /* 194447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 194451 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2048:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 194454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194463 */     GIR_RootConstrainSelectedInstOperands,
     /* 194464 */     // GIR_Coverage, 3209,
     /* 194464 */     GIR_EraseRootFromParent_Done,
     /* 194465 */   // Label 3932: @194465
     /* 194465 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(194507), // Rule ID 3210 //
     /* 194470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 194478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194485 */     // MIs[0] Op1
     /* 194485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 194489 */     // MIs[0] Op2
     /* 194489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 194493 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2050:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 194496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194505 */     GIR_RootConstrainSelectedInstOperands,
     /* 194506 */     // GIR_Coverage, 3210,
     /* 194506 */     GIR_EraseRootFromParent_Done,
     /* 194507 */   // Label 3933: @194507
     /* 194507 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(194549), // Rule ID 3211 //
     /* 194512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 194520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194527 */     // MIs[0] Op1
     /* 194527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 194531 */     // MIs[0] Op2
     /* 194531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 194535 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2051:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 194538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194547 */     GIR_RootConstrainSelectedInstOperands,
     /* 194548 */     // GIR_Coverage, 3211,
     /* 194548 */     GIR_EraseRootFromParent_Done,
     /* 194549 */   // Label 3934: @194549
     /* 194549 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(194591), // Rule ID 3212 //
     /* 194554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 194562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194569 */     // MIs[0] Op1
     /* 194569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 194573 */     // MIs[0] Op2
     /* 194573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 194577 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2049:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 194580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194589 */     GIR_RootConstrainSelectedInstOperands,
     /* 194590 */     // GIR_Coverage, 3212,
     /* 194590 */     GIR_EraseRootFromParent_Done,
     /* 194591 */   // Label 3935: @194591
     /* 194591 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(194633), // Rule ID 11846 //
     /* 194596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 194604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194611 */     // MIs[0] Op1
     /* 194611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 194615 */     // MIs[0] Op2
     /* 194615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 194619 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2044:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 194622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194631 */     GIR_RootConstrainSelectedInstOperands,
     /* 194632 */     // GIR_Coverage, 11846,
     /* 194632 */     GIR_EraseRootFromParent_Done,
     /* 194633 */   // Label 3936: @194633
     /* 194633 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(194675), // Rule ID 11847 //
     /* 194638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 194646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194653 */     // MIs[0] Op1
     /* 194653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 194657 */     // MIs[0] Op2
     /* 194657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 194661 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2046:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 194664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194673 */     GIR_RootConstrainSelectedInstOperands,
     /* 194674 */     // GIR_Coverage, 11847,
     /* 194674 */     GIR_EraseRootFromParent_Done,
     /* 194675 */   // Label 3937: @194675
     /* 194675 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(194717), // Rule ID 11848 //
     /* 194680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 194688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194695 */     // MIs[0] Op1
     /* 194695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 194699 */     // MIs[0] Op2
     /* 194699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 194703 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2047:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 194706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194715 */     GIR_RootConstrainSelectedInstOperands,
     /* 194716 */     // GIR_Coverage, 11848,
     /* 194716 */     GIR_EraseRootFromParent_Done,
     /* 194717 */   // Label 3938: @194717
     /* 194717 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(194759), // Rule ID 11849 //
     /* 194722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 194730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194737 */     // MIs[0] Op1
     /* 194737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 194741 */     // MIs[0] Op2
     /* 194741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 194745 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2045:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 194748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194757 */     GIR_RootConstrainSelectedInstOperands,
     /* 194758 */     // GIR_Coverage, 11849,
     /* 194758 */     GIR_EraseRootFromParent_Done,
     /* 194759 */   // Label 3939: @194759
     /* 194759 */   GIM_Reject,
     /* 194760 */ // Label 2986: @194760
     /* 194760 */ GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(238543),
     /* 194765 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 194768 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(194881), // Rule ID 2062 //
     /* 194773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 194776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 194781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 194793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 194809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 194813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 194817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 194821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 194825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 194829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 194833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 194838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 194842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 194846 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 194850 */     // MIs[3] Operand 1
     /* 194850 */     // No operand predicates
     /* 194850 */     // MIs[1] Operand 2
     /* 194850 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 194861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 194863 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 194863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 194866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 194876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 194879 */     GIR_RootConstrainSelectedInstOperands,
     /* 194880 */     // GIR_Coverage, 2062,
     /* 194880 */     GIR_EraseRootFromParent_Done,
     /* 194881 */   // Label 3941: @194881
     /* 194881 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(194994), // Rule ID 2069 //
     /* 194886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 194889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 194894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 194906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 194922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 194926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 194930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 194934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 194938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 194942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 194946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 194951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 194955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 194959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 194963 */     // MIs[3] Operand 1
     /* 194963 */     // No operand predicates
     /* 194963 */     // MIs[1] Operand 2
     /* 194963 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 194974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 194976 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 194976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 194979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 194989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 194992 */     GIR_RootConstrainSelectedInstOperands,
     /* 194993 */     // GIR_Coverage, 2069,
     /* 194993 */     GIR_EraseRootFromParent_Done,
     /* 194994 */   // Label 3942: @194994
     /* 194994 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(195107), // Rule ID 2065 //
     /* 194999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 195002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 195007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 195019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 195039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195072 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 195076 */     // MIs[3] Operand 1
     /* 195076 */     // No operand predicates
     /* 195076 */     // MIs[1] Operand 2
     /* 195076 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 195087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195089 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 195089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 195092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195105 */     GIR_RootConstrainSelectedInstOperands,
     /* 195106 */     // GIR_Coverage, 2065,
     /* 195106 */     GIR_EraseRootFromParent_Done,
     /* 195107 */   // Label 3943: @195107
     /* 195107 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(195220), // Rule ID 2072 //
     /* 195112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 195115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 195120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 195132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 195152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195185 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 195189 */     // MIs[3] Operand 1
     /* 195189 */     // No operand predicates
     /* 195189 */     // MIs[1] Operand 2
     /* 195189 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 195200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195202 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 195202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 195205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195218 */     GIR_RootConstrainSelectedInstOperands,
     /* 195219 */     // GIR_Coverage, 2072,
     /* 195219 */     GIR_EraseRootFromParent_Done,
     /* 195220 */   // Label 3944: @195220
     /* 195220 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(195325), // Rule ID 3822 //
     /* 195225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 195228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 195233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 195245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 195265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 195269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195298 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 195302 */     // MIs[3] Operand 1
     /* 195302 */     // No operand predicates
     /* 195302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195304 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 195304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 195307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195323 */     GIR_RootConstrainSelectedInstOperands,
     /* 195324 */     // GIR_Coverage, 3822,
     /* 195324 */     GIR_EraseRootFromParent_Done,
     /* 195325 */   // Label 3945: @195325
     /* 195325 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(195430), // Rule ID 3823 //
     /* 195330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 195333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 195338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 195350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 195370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 195374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 195407 */     // MIs[3] Operand 1
     /* 195407 */     // No operand predicates
     /* 195407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195409 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 195409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 195412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195428 */     GIR_RootConstrainSelectedInstOperands,
     /* 195429 */     // GIR_Coverage, 3823,
     /* 195429 */     GIR_EraseRootFromParent_Done,
     /* 195430 */   // Label 3946: @195430
     /* 195430 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(195535), // Rule ID 3824 //
     /* 195435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 195438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 195443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 195455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 195475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 195479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195508 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 195512 */     // MIs[3] Operand 1
     /* 195512 */     // No operand predicates
     /* 195512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195514 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 195514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 195517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 195533 */     GIR_RootConstrainSelectedInstOperands,
     /* 195534 */     // GIR_Coverage, 3824,
     /* 195534 */     GIR_EraseRootFromParent_Done,
     /* 195535 */   // Label 3947: @195535
     /* 195535 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(195640), // Rule ID 3825 //
     /* 195540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 195543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 195548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 195560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 195580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 195584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195613 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 195617 */     // MIs[3] Operand 1
     /* 195617 */     // No operand predicates
     /* 195617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195619 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 195619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 195622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 195638 */     GIR_RootConstrainSelectedInstOperands,
     /* 195639 */     // GIR_Coverage, 3825,
     /* 195639 */     GIR_EraseRootFromParent_Done,
     /* 195640 */   // Label 3948: @195640
     /* 195640 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(195745), // Rule ID 3830 //
     /* 195645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 195648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 195653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 195665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 195685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195718 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 195722 */     // MIs[3] Operand 1
     /* 195722 */     // No operand predicates
     /* 195722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195724 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 195724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 195727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195743 */     GIR_RootConstrainSelectedInstOperands,
     /* 195744 */     // GIR_Coverage, 3830,
     /* 195744 */     GIR_EraseRootFromParent_Done,
     /* 195745 */   // Label 3949: @195745
     /* 195745 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(195850), // Rule ID 3831 //
     /* 195750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 195753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 195758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 195770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 195790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195823 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 195827 */     // MIs[3] Operand 1
     /* 195827 */     // No operand predicates
     /* 195827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195829 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 195829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 195832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195848 */     GIR_RootConstrainSelectedInstOperands,
     /* 195849 */     // GIR_Coverage, 3831,
     /* 195849 */     GIR_EraseRootFromParent_Done,
     /* 195850 */   // Label 3950: @195850
     /* 195850 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(195955), // Rule ID 3832 //
     /* 195855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 195858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 195863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 195875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 195895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 195903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 195907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 195911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 195915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 195924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 195928 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 195932 */     // MIs[3] Operand 1
     /* 195932 */     // No operand predicates
     /* 195932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 195934 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 195934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 195937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 195947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 195950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 195953 */     GIR_RootConstrainSelectedInstOperands,
     /* 195954 */     // GIR_Coverage, 3832,
     /* 195954 */     GIR_EraseRootFromParent_Done,
     /* 195955 */   // Label 3951: @195955
     /* 195955 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(196060), // Rule ID 3833 //
     /* 195960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 195963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 195968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 195980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 195996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 196000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 196004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 196008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 196012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 196016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 196020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 196029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 196037 */     // MIs[3] Operand 1
     /* 196037 */     // No operand predicates
     /* 196037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 196039 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 196039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 196042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 196052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 196055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 196058 */     GIR_RootConstrainSelectedInstOperands,
     /* 196059 */     // GIR_Coverage, 3833,
     /* 196059 */     GIR_EraseRootFromParent_Done,
     /* 196060 */   // Label 3952: @196060
     /* 196060 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(196165), // Rule ID 3846 //
     /* 196065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 196068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 196073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 196085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 196105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 196113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 196117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 196125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 196134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196138 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 196142 */     // MIs[3] Operand 1
     /* 196142 */     // No operand predicates
     /* 196142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 196144 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 196144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 196147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 196157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 196160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196163 */     GIR_RootConstrainSelectedInstOperands,
     /* 196164 */     // GIR_Coverage, 3846,
     /* 196164 */     GIR_EraseRootFromParent_Done,
     /* 196165 */   // Label 3953: @196165
     /* 196165 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(196270), // Rule ID 3847 //
     /* 196170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 196173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 196178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 196190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 196210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 196218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 196222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 196230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 196239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196243 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 196247 */     // MIs[3] Operand 1
     /* 196247 */     // No operand predicates
     /* 196247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 196249 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 196249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 196252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 196262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 196265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196268 */     GIR_RootConstrainSelectedInstOperands,
     /* 196269 */     // GIR_Coverage, 3847,
     /* 196269 */     GIR_EraseRootFromParent_Done,
     /* 196270 */   // Label 3954: @196270
     /* 196270 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(196375), // Rule ID 3848 //
     /* 196275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 196278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 196283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 196295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 196315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 196323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 196327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 196335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 196344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196348 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 196352 */     // MIs[3] Operand 1
     /* 196352 */     // No operand predicates
     /* 196352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 196354 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 196354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 196357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 196367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 196370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 196373 */     GIR_RootConstrainSelectedInstOperands,
     /* 196374 */     // GIR_Coverage, 3848,
     /* 196374 */     GIR_EraseRootFromParent_Done,
     /* 196375 */   // Label 3955: @196375
     /* 196375 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(196480), // Rule ID 3849 //
     /* 196380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 196383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 196388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 196400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 196420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 196428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 196432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 196440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 196449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196453 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 196457 */     // MIs[3] Operand 1
     /* 196457 */     // No operand predicates
     /* 196457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 196459 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 196459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 196462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 196472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 196475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 196478 */     GIR_RootConstrainSelectedInstOperands,
     /* 196479 */     // GIR_Coverage, 3849,
     /* 196479 */     GIR_EraseRootFromParent_Done,
     /* 196480 */   // Label 3956: @196480
     /* 196480 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(196534), // Rule ID 59 //
     /* 196485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 196488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 196493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 196502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196510 */     // MIs[0] Operand 3
     /* 196510 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 196521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 196525 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 196525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 196528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196532 */     GIR_RootConstrainSelectedInstOperands,
     /* 196533 */     // GIR_Coverage, 59,
     /* 196533 */     GIR_EraseRootFromParent_Done,
     /* 196534 */   // Label 3957: @196534
     /* 196534 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(196588), // Rule ID 60 //
     /* 196539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 196542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 196547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 196556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196564 */     // MIs[0] Operand 3
     /* 196564 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 196575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 196579 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 196579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 196582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196586 */     GIR_RootConstrainSelectedInstOperands,
     /* 196587 */     // GIR_Coverage, 60,
     /* 196587 */     GIR_EraseRootFromParent_Done,
     /* 196588 */   // Label 3958: @196588
     /* 196588 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(196642), // Rule ID 61 //
     /* 196593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 196596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 196601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 196610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196618 */     // MIs[0] Operand 3
     /* 196618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 196629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 196633 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 196633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 196636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196640 */     GIR_RootConstrainSelectedInstOperands,
     /* 196641 */     // GIR_Coverage, 61,
     /* 196641 */     GIR_EraseRootFromParent_Done,
     /* 196642 */   // Label 3959: @196642
     /* 196642 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(196696), // Rule ID 62 //
     /* 196647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 196650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 196655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 196664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196672 */     // MIs[0] Operand 3
     /* 196672 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 196683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 196687 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 196687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 196690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196694 */     GIR_RootConstrainSelectedInstOperands,
     /* 196695 */     // GIR_Coverage, 62,
     /* 196695 */     GIR_EraseRootFromParent_Done,
     /* 196696 */   // Label 3960: @196696
     /* 196696 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(196752), // Rule ID 2643 //
     /* 196701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 196709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196723 */     // MIs[0] pattern
     /* 196723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196731 */     // MIs[0] imm4
     /* 196731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196739 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1716:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 196742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196746 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196748 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196750 */     GIR_RootConstrainSelectedInstOperands,
     /* 196751 */     // GIR_Coverage, 2643,
     /* 196751 */     GIR_EraseRootFromParent_Done,
     /* 196752 */   // Label 3961: @196752
     /* 196752 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(196808), // Rule ID 2652 //
     /* 196757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 196765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196779 */     // MIs[0] pattern
     /* 196779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196787 */     // MIs[0] imm4
     /* 196787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196795 */     // (intrinsic_wo_chain:{ *:[i32] } 1922:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 196798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196802 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196804 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196806 */     GIR_RootConstrainSelectedInstOperands,
     /* 196807 */     // GIR_Coverage, 2652,
     /* 196807 */     GIR_EraseRootFromParent_Done,
     /* 196808 */   // Label 3962: @196808
     /* 196808 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(196864), // Rule ID 2653 //
     /* 196813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 196821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196835 */     // MIs[0] pattern
     /* 196835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196843 */     // MIs[0] imm4
     /* 196843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196851 */     // (intrinsic_wo_chain:{ *:[i64] } 1712:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 196854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196858 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196860 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196862 */     GIR_RootConstrainSelectedInstOperands,
     /* 196863 */     // GIR_Coverage, 2653,
     /* 196863 */     GIR_EraseRootFromParent_Done,
     /* 196864 */   // Label 3963: @196864
     /* 196864 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(196920), // Rule ID 9877 //
     /* 196869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 196877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196891 */     // MIs[0] pattern
     /* 196891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196899 */     // MIs[0] imm4
     /* 196899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196907 */     // (intrinsic_wo_chain:{ *:[i32] } 1908:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 196910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196914 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196916 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196918 */     GIR_RootConstrainSelectedInstOperands,
     /* 196919 */     // GIR_Coverage, 9877,
     /* 196919 */     GIR_EraseRootFromParent_Done,
     /* 196920 */   // Label 3964: @196920
     /* 196920 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(196976), // Rule ID 9878 //
     /* 196925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 196933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196947 */     // MIs[0] pattern
     /* 196947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196955 */     // MIs[0] imm4
     /* 196955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196963 */     // (intrinsic_wo_chain:{ *:[i64] } 1923:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 196966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196970 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196972 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196974 */     GIR_RootConstrainSelectedInstOperands,
     /* 196975 */     // GIR_Coverage, 9878,
     /* 196975 */     GIR_EraseRootFromParent_Done,
     /* 196976 */   // Label 3965: @196976
     /* 196976 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(197032), // Rule ID 9879 //
     /* 196981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 196989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197003 */     // MIs[0] pattern
     /* 197003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197011 */     // MIs[0] imm4
     /* 197011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197019 */     // (intrinsic_wo_chain:{ *:[i64] } 1678:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 197022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197026 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197028 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197030 */     GIR_RootConstrainSelectedInstOperands,
     /* 197031 */     // GIR_Coverage, 9879,
     /* 197031 */     GIR_EraseRootFromParent_Done,
     /* 197032 */   // Label 3966: @197032
     /* 197032 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(197088), // Rule ID 9880 //
     /* 197037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 197045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197059 */     // MIs[0] pattern
     /* 197059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197067 */     // MIs[0] imm4
     /* 197067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197075 */     // (intrinsic_wo_chain:{ *:[i64] } 1909:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 197078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197082 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197084 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197086 */     GIR_RootConstrainSelectedInstOperands,
     /* 197087 */     // GIR_Coverage, 9880,
     /* 197087 */     GIR_EraseRootFromParent_Done,
     /* 197088 */   // Label 3967: @197088
     /* 197088 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(197144), // Rule ID 9883 //
     /* 197093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 197101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197115 */     // MIs[0] pattern
     /* 197115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197123 */     // MIs[0] imm4
     /* 197123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197131 */     // (intrinsic_wo_chain:{ *:[i32] } 1928:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 197134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197138 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197140 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197142 */     GIR_RootConstrainSelectedInstOperands,
     /* 197143 */     // GIR_Coverage, 9883,
     /* 197143 */     GIR_EraseRootFromParent_Done,
     /* 197144 */   // Label 3968: @197144
     /* 197144 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(197200), // Rule ID 9886 //
     /* 197149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 197157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197171 */     // MIs[0] pattern
     /* 197171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197179 */     // MIs[0] imm4
     /* 197179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197187 */     // (intrinsic_wo_chain:{ *:[i32] } 1914:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 197190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197194 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197196 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197198 */     GIR_RootConstrainSelectedInstOperands,
     /* 197199 */     // GIR_Coverage, 9886,
     /* 197199 */     GIR_EraseRootFromParent_Done,
     /* 197200 */   // Label 3969: @197200
     /* 197200 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(197256), // Rule ID 9887 //
     /* 197205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 197213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197227 */     // MIs[0] pattern
     /* 197227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197235 */     // MIs[0] imm4
     /* 197235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197243 */     // (intrinsic_wo_chain:{ *:[i64] } 1718:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 197246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197250 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197252 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197254 */     GIR_RootConstrainSelectedInstOperands,
     /* 197255 */     // GIR_Coverage, 9887,
     /* 197255 */     GIR_EraseRootFromParent_Done,
     /* 197256 */   // Label 3970: @197256
     /* 197256 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(197312), // Rule ID 9888 //
     /* 197261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 197269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197283 */     // MIs[0] pattern
     /* 197283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197291 */     // MIs[0] imm4
     /* 197291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197299 */     // (intrinsic_wo_chain:{ *:[i64] } 1929:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 197302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197306 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197308 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197310 */     GIR_RootConstrainSelectedInstOperands,
     /* 197311 */     // GIR_Coverage, 9888,
     /* 197311 */     GIR_EraseRootFromParent_Done,
     /* 197312 */   // Label 3971: @197312
     /* 197312 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(197368), // Rule ID 9889 //
     /* 197317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 197325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197339 */     // MIs[0] pattern
     /* 197339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197347 */     // MIs[0] imm4
     /* 197347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197355 */     // (intrinsic_wo_chain:{ *:[i64] } 1684:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 197358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197362 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197364 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197366 */     GIR_RootConstrainSelectedInstOperands,
     /* 197367 */     // GIR_Coverage, 9889,
     /* 197367 */     GIR_EraseRootFromParent_Done,
     /* 197368 */   // Label 3972: @197368
     /* 197368 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(197424), // Rule ID 9890 //
     /* 197373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 197381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197395 */     // MIs[0] pattern
     /* 197395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197403 */     // MIs[0] imm4
     /* 197403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197411 */     // (intrinsic_wo_chain:{ *:[i64] } 1915:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 197414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197418 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197420 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197422 */     GIR_RootConstrainSelectedInstOperands,
     /* 197423 */     // GIR_Coverage, 9890,
     /* 197423 */     GIR_EraseRootFromParent_Done,
     /* 197424 */   // Label 3973: @197424
     /* 197424 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(197480), // Rule ID 9893 //
     /* 197429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 197437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197451 */     // MIs[0] pattern
     /* 197451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197459 */     // MIs[0] imm4
     /* 197459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197467 */     // (intrinsic_wo_chain:{ *:[i32] } 1934:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 197470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197474 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197476 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197478 */     GIR_RootConstrainSelectedInstOperands,
     /* 197479 */     // GIR_Coverage, 9893,
     /* 197479 */     GIR_EraseRootFromParent_Done,
     /* 197480 */   // Label 3974: @197480
     /* 197480 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(197536), // Rule ID 9896 //
     /* 197485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 197493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197507 */     // MIs[0] pattern
     /* 197507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197515 */     // MIs[0] imm4
     /* 197515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197523 */     // (intrinsic_wo_chain:{ *:[i32] } 1920:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 197526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197530 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197532 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197534 */     GIR_RootConstrainSelectedInstOperands,
     /* 197535 */     // GIR_Coverage, 9896,
     /* 197535 */     GIR_EraseRootFromParent_Done,
     /* 197536 */   // Label 3975: @197536
     /* 197536 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(197592), // Rule ID 9897 //
     /* 197541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 197549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197563 */     // MIs[0] pattern
     /* 197563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197571 */     // MIs[0] imm4
     /* 197571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197579 */     // (intrinsic_wo_chain:{ *:[i64] } 1724:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 197582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197586 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197588 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197590 */     GIR_RootConstrainSelectedInstOperands,
     /* 197591 */     // GIR_Coverage, 9897,
     /* 197591 */     GIR_EraseRootFromParent_Done,
     /* 197592 */   // Label 3976: @197592
     /* 197592 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(197648), // Rule ID 9898 //
     /* 197597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 197605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197619 */     // MIs[0] pattern
     /* 197619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197627 */     // MIs[0] imm4
     /* 197627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197635 */     // (intrinsic_wo_chain:{ *:[i64] } 1935:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 197638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197642 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197644 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197646 */     GIR_RootConstrainSelectedInstOperands,
     /* 197647 */     // GIR_Coverage, 9898,
     /* 197647 */     GIR_EraseRootFromParent_Done,
     /* 197648 */   // Label 3977: @197648
     /* 197648 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(197704), // Rule ID 9899 //
     /* 197653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 197661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197675 */     // MIs[0] pattern
     /* 197675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197683 */     // MIs[0] imm4
     /* 197683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197691 */     // (intrinsic_wo_chain:{ *:[i64] } 1690:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 197694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197698 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197700 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197702 */     GIR_RootConstrainSelectedInstOperands,
     /* 197703 */     // GIR_Coverage, 9899,
     /* 197703 */     GIR_EraseRootFromParent_Done,
     /* 197704 */   // Label 3978: @197704
     /* 197704 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(197760), // Rule ID 9900 //
     /* 197709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 197717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197731 */     // MIs[0] pattern
     /* 197731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197739 */     // MIs[0] imm4
     /* 197739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197747 */     // (intrinsic_wo_chain:{ *:[i64] } 1921:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 197750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197754 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197756 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197758 */     GIR_RootConstrainSelectedInstOperands,
     /* 197759 */     // GIR_Coverage, 9900,
     /* 197759 */     GIR_EraseRootFromParent_Done,
     /* 197760 */   // Label 3979: @197760
     /* 197760 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(197816), // Rule ID 9903 //
     /* 197765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 197773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197787 */     // MIs[0] pattern
     /* 197787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197795 */     // MIs[0] imm4
     /* 197795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197803 */     // (intrinsic_wo_chain:{ *:[i32] } 1925:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 197806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197810 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197812 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197814 */     GIR_RootConstrainSelectedInstOperands,
     /* 197815 */     // GIR_Coverage, 9903,
     /* 197815 */     GIR_EraseRootFromParent_Done,
     /* 197816 */   // Label 3980: @197816
     /* 197816 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(197872), // Rule ID 9906 //
     /* 197821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 197829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197843 */     // MIs[0] pattern
     /* 197843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197851 */     // MIs[0] imm4
     /* 197851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197859 */     // (intrinsic_wo_chain:{ *:[i32] } 1911:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 197862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197866 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197868 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197870 */     GIR_RootConstrainSelectedInstOperands,
     /* 197871 */     // GIR_Coverage, 9906,
     /* 197871 */     GIR_EraseRootFromParent_Done,
     /* 197872 */   // Label 3981: @197872
     /* 197872 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(197928), // Rule ID 9907 //
     /* 197877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 197885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197899 */     // MIs[0] pattern
     /* 197899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197907 */     // MIs[0] imm4
     /* 197907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197915 */     // (intrinsic_wo_chain:{ *:[i64] } 1715:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 197918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197922 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197924 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197926 */     GIR_RootConstrainSelectedInstOperands,
     /* 197927 */     // GIR_Coverage, 9907,
     /* 197927 */     GIR_EraseRootFromParent_Done,
     /* 197928 */   // Label 3982: @197928
     /* 197928 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(197984), // Rule ID 9908 //
     /* 197933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 197941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197955 */     // MIs[0] pattern
     /* 197955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 197958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 197963 */     // MIs[0] imm4
     /* 197963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 197966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 197971 */     // (intrinsic_wo_chain:{ *:[i64] } 1926:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 197971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 197974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 197976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197978 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 197980 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 197982 */     GIR_RootConstrainSelectedInstOperands,
     /* 197983 */     // GIR_Coverage, 9908,
     /* 197983 */     GIR_EraseRootFromParent_Done,
     /* 197984 */   // Label 3983: @197984
     /* 197984 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(198040), // Rule ID 9909 //
     /* 197989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 197997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198011 */     // MIs[0] pattern
     /* 198011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198019 */     // MIs[0] imm4
     /* 198019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198027 */     // (intrinsic_wo_chain:{ *:[i64] } 1681:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 198030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198034 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198036 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198038 */     GIR_RootConstrainSelectedInstOperands,
     /* 198039 */     // GIR_Coverage, 9909,
     /* 198039 */     GIR_EraseRootFromParent_Done,
     /* 198040 */   // Label 3984: @198040
     /* 198040 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(198096), // Rule ID 9910 //
     /* 198045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 198053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198067 */     // MIs[0] pattern
     /* 198067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198075 */     // MIs[0] imm4
     /* 198075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198083 */     // (intrinsic_wo_chain:{ *:[i64] } 1912:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 198086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198090 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198092 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198094 */     GIR_RootConstrainSelectedInstOperands,
     /* 198095 */     // GIR_Coverage, 9910,
     /* 198095 */     GIR_EraseRootFromParent_Done,
     /* 198096 */   // Label 3985: @198096
     /* 198096 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(198152), // Rule ID 9911 //
     /* 198101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 198109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198123 */     // MIs[0] pattern
     /* 198123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198131 */     // MIs[0] imm4
     /* 198131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198139 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 198142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198146 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198148 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198150 */     GIR_RootConstrainSelectedInstOperands,
     /* 198151 */     // GIR_Coverage, 9911,
     /* 198151 */     GIR_EraseRootFromParent_Done,
     /* 198152 */   // Label 3986: @198152
     /* 198152 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(198208), // Rule ID 9912 //
     /* 198157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 198165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198179 */     // MIs[0] pattern
     /* 198179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198187 */     // MIs[0] imm4
     /* 198187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198195 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 198198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198202 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198204 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198206 */     GIR_RootConstrainSelectedInstOperands,
     /* 198207 */     // GIR_Coverage, 9912,
     /* 198207 */     GIR_EraseRootFromParent_Done,
     /* 198208 */   // Label 3987: @198208
     /* 198208 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(198264), // Rule ID 9913 //
     /* 198213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 198221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198235 */     // MIs[0] pattern
     /* 198235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198243 */     // MIs[0] imm4
     /* 198243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1913:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 198254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198258 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198260 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198262 */     GIR_RootConstrainSelectedInstOperands,
     /* 198263 */     // GIR_Coverage, 9913,
     /* 198263 */     GIR_EraseRootFromParent_Done,
     /* 198264 */   // Label 3988: @198264
     /* 198264 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(198320), // Rule ID 9914 //
     /* 198269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 198277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198291 */     // MIs[0] pattern
     /* 198291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198299 */     // MIs[0] imm4
     /* 198299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 198310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198314 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198316 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198318 */     GIR_RootConstrainSelectedInstOperands,
     /* 198319 */     // GIR_Coverage, 9914,
     /* 198319 */     GIR_EraseRootFromParent_Done,
     /* 198320 */   // Label 3989: @198320
     /* 198320 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(198376), // Rule ID 9915 //
     /* 198325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 198333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198347 */     // MIs[0] pattern
     /* 198347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198355 */     // MIs[0] imm4
     /* 198355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198363 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 198366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198370 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198372 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198374 */     GIR_RootConstrainSelectedInstOperands,
     /* 198375 */     // GIR_Coverage, 9915,
     /* 198375 */     GIR_EraseRootFromParent_Done,
     /* 198376 */   // Label 3990: @198376
     /* 198376 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(198432), // Rule ID 9916 //
     /* 198381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 198389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198403 */     // MIs[0] pattern
     /* 198403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198411 */     // MIs[0] imm4
     /* 198411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 198422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198426 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198428 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198430 */     GIR_RootConstrainSelectedInstOperands,
     /* 198431 */     // GIR_Coverage, 9916,
     /* 198431 */     GIR_EraseRootFromParent_Done,
     /* 198432 */   // Label 3991: @198432
     /* 198432 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(198488), // Rule ID 9917 //
     /* 198437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 198445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198459 */     // MIs[0] pattern
     /* 198459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198467 */     // MIs[0] imm4
     /* 198467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 198478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198482 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198484 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198486 */     GIR_RootConstrainSelectedInstOperands,
     /* 198487 */     // GIR_Coverage, 9917,
     /* 198487 */     GIR_EraseRootFromParent_Done,
     /* 198488 */   // Label 3992: @198488
     /* 198488 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(198544), // Rule ID 9918 //
     /* 198493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 198501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198515 */     // MIs[0] pattern
     /* 198515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198523 */     // MIs[0] imm4
     /* 198523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1713:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 198534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198538 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198540 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198542 */     GIR_RootConstrainSelectedInstOperands,
     /* 198543 */     // GIR_Coverage, 9918,
     /* 198543 */     GIR_EraseRootFromParent_Done,
     /* 198544 */   // Label 3993: @198544
     /* 198544 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(198600), // Rule ID 9919 //
     /* 198549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 198557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198571 */     // MIs[0] pattern
     /* 198571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198579 */     // MIs[0] imm4
     /* 198579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198587 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 198590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198594 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198596 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198598 */     GIR_RootConstrainSelectedInstOperands,
     /* 198599 */     // GIR_Coverage, 9919,
     /* 198599 */     GIR_EraseRootFromParent_Done,
     /* 198600 */   // Label 3994: @198600
     /* 198600 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(198656), // Rule ID 9920 //
     /* 198605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 198613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198627 */     // MIs[0] pattern
     /* 198627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198635 */     // MIs[0] imm4
     /* 198635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1679:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 198646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198650 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198652 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198654 */     GIR_RootConstrainSelectedInstOperands,
     /* 198655 */     // GIR_Coverage, 9920,
     /* 198655 */     GIR_EraseRootFromParent_Done,
     /* 198656 */   // Label 3995: @198656
     /* 198656 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(198712), // Rule ID 9921 //
     /* 198661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 198669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198683 */     // MIs[0] pattern
     /* 198683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 198686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 198691 */     // MIs[0] imm4
     /* 198691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 198694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 198699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 198699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 198702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 198706 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 198708 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 198710 */     GIR_RootConstrainSelectedInstOperands,
     /* 198711 */     // GIR_Coverage, 9921,
     /* 198711 */     GIR_EraseRootFromParent_Done,
     /* 198712 */   // Label 3996: @198712
     /* 198712 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(198802), // Rule ID 47 //
     /* 198717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 198720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 198725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 198765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 198774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198778 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198782 */     // MIs[2] Operand 1
     /* 198782 */     // No operand predicates
     /* 198782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198784 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 198787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 198797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 198800 */     GIR_RootConstrainSelectedInstOperands,
     /* 198801 */     // GIR_Coverage, 47,
     /* 198801 */     GIR_EraseRootFromParent_Done,
     /* 198802 */   // Label 3997: @198802
     /* 198802 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(198892), // Rule ID 48 //
     /* 198807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 198810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 198815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 198827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 198855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 198864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198872 */     // MIs[2] Operand 1
     /* 198872 */     // No operand predicates
     /* 198872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198874 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 198877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 198887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 198890 */     GIR_RootConstrainSelectedInstOperands,
     /* 198891 */     // GIR_Coverage, 48,
     /* 198891 */     GIR_EraseRootFromParent_Done,
     /* 198892 */   // Label 3998: @198892
     /* 198892 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(198982), // Rule ID 49 //
     /* 198897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 198900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 198905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 198945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 198954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198962 */     // MIs[2] Operand 1
     /* 198962 */     // No operand predicates
     /* 198962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198964 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 198967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 198977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 198980 */     GIR_RootConstrainSelectedInstOperands,
     /* 198981 */     // GIR_Coverage, 49,
     /* 198981 */     GIR_EraseRootFromParent_Done,
     /* 198982 */   // Label 3999: @198982
     /* 198982 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(199072), // Rule ID 50 //
     /* 198987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 198990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 198995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199048 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199052 */     // MIs[2] Operand 1
     /* 199052 */     // No operand predicates
     /* 199052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199054 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 199057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199070 */     GIR_RootConstrainSelectedInstOperands,
     /* 199071 */     // GIR_Coverage, 50,
     /* 199071 */     GIR_EraseRootFromParent_Done,
     /* 199072 */   // Label 4000: @199072
     /* 199072 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(199162), // Rule ID 51 //
     /* 199077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 199080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 199085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199138 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199142 */     // MIs[2] Operand 1
     /* 199142 */     // No operand predicates
     /* 199142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199144 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 199147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199160 */     GIR_RootConstrainSelectedInstOperands,
     /* 199161 */     // GIR_Coverage, 51,
     /* 199161 */     GIR_EraseRootFromParent_Done,
     /* 199162 */   // Label 4001: @199162
     /* 199162 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(199252), // Rule ID 52 //
     /* 199167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 199170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 199175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199232 */     // MIs[2] Operand 1
     /* 199232 */     // No operand predicates
     /* 199232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199234 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 199237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199250 */     GIR_RootConstrainSelectedInstOperands,
     /* 199251 */     // GIR_Coverage, 52,
     /* 199251 */     GIR_EraseRootFromParent_Done,
     /* 199252 */   // Label 4002: @199252
     /* 199252 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(199342), // Rule ID 53 //
     /* 199257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 199260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 199265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199318 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199322 */     // MIs[2] Operand 1
     /* 199322 */     // No operand predicates
     /* 199322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199324 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 199327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199340 */     GIR_RootConstrainSelectedInstOperands,
     /* 199341 */     // GIR_Coverage, 53,
     /* 199341 */     GIR_EraseRootFromParent_Done,
     /* 199342 */   // Label 4003: @199342
     /* 199342 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(199432), // Rule ID 54 //
     /* 199347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 199350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 199355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199408 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199412 */     // MIs[2] Operand 1
     /* 199412 */     // No operand predicates
     /* 199412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199414 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 199417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199430 */     GIR_RootConstrainSelectedInstOperands,
     /* 199431 */     // GIR_Coverage, 54,
     /* 199431 */     GIR_EraseRootFromParent_Done,
     /* 199432 */   // Label 4004: @199432
     /* 199432 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(199522), // Rule ID 2063 //
     /* 199437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 199445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199498 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199502 */     // MIs[2] Operand 1
     /* 199502 */     // No operand predicates
     /* 199502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199504 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 199507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199520 */     GIR_RootConstrainSelectedInstOperands,
     /* 199521 */     // GIR_Coverage, 2063,
     /* 199521 */     GIR_EraseRootFromParent_Done,
     /* 199522 */   // Label 4005: @199522
     /* 199522 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(199612), // Rule ID 2064 //
     /* 199527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 199535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199588 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199592 */     // MIs[2] Operand 1
     /* 199592 */     // No operand predicates
     /* 199592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199594 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 199597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199610 */     GIR_RootConstrainSelectedInstOperands,
     /* 199611 */     // GIR_Coverage, 2064,
     /* 199611 */     GIR_EraseRootFromParent_Done,
     /* 199612 */   // Label 4006: @199612
     /* 199612 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(199702), // Rule ID 2070 //
     /* 199617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 199625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199678 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199682 */     // MIs[2] Operand 1
     /* 199682 */     // No operand predicates
     /* 199682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199684 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 199687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199700 */     GIR_RootConstrainSelectedInstOperands,
     /* 199701 */     // GIR_Coverage, 2070,
     /* 199701 */     GIR_EraseRootFromParent_Done,
     /* 199702 */   // Label 4007: @199702
     /* 199702 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(199792), // Rule ID 2071 //
     /* 199707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 199715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199768 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199772 */     // MIs[2] Operand 1
     /* 199772 */     // No operand predicates
     /* 199772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199774 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 199777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199790 */     GIR_RootConstrainSelectedInstOperands,
     /* 199791 */     // GIR_Coverage, 2071,
     /* 199791 */     GIR_EraseRootFromParent_Done,
     /* 199792 */   // Label 4008: @199792
     /* 199792 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(199882), // Rule ID 2066 //
     /* 199797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 199805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 199817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199858 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199862 */     // MIs[2] Operand 1
     /* 199862 */     // No operand predicates
     /* 199862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199864 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 199867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199880 */     GIR_RootConstrainSelectedInstOperands,
     /* 199881 */     // GIR_Coverage, 2066,
     /* 199881 */     GIR_EraseRootFromParent_Done,
     /* 199882 */   // Label 4009: @199882
     /* 199882 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(199972), // Rule ID 2067 //
     /* 199887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 199895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 199935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 199944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199948 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199952 */     // MIs[2] Operand 1
     /* 199952 */     // No operand predicates
     /* 199952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199954 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 199957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 199967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 199970 */     GIR_RootConstrainSelectedInstOperands,
     /* 199971 */     // GIR_Coverage, 2067,
     /* 199971 */     GIR_EraseRootFromParent_Done,
     /* 199972 */   // Label 4010: @199972
     /* 199972 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(200062), // Rule ID 2073 //
     /* 199977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 199985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 199997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 200025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 200034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200038 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200042 */     // MIs[2] Operand 1
     /* 200042 */     // No operand predicates
     /* 200042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200044 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 200044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 200047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 200057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 200060 */     GIR_RootConstrainSelectedInstOperands,
     /* 200061 */     // GIR_Coverage, 2073,
     /* 200061 */     GIR_EraseRootFromParent_Done,
     /* 200062 */   // Label 4011: @200062
     /* 200062 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(200152), // Rule ID 2074 //
     /* 200067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 200075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 200115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 200124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200128 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200132 */     // MIs[2] Operand 1
     /* 200132 */     // No operand predicates
     /* 200132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200134 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 200134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 200137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 200147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 200150 */     GIR_RootConstrainSelectedInstOperands,
     /* 200151 */     // GIR_Coverage, 2074,
     /* 200151 */     GIR_EraseRootFromParent_Done,
     /* 200152 */   // Label 4012: @200152
     /* 200152 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(200242), // Rule ID 2068 //
     /* 200157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 200165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 200177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 200197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 200205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 200214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200218 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200222 */     // MIs[2] Operand 1
     /* 200222 */     // No operand predicates
     /* 200222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200224 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 200224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 200227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 200237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 200240 */     GIR_RootConstrainSelectedInstOperands,
     /* 200241 */     // GIR_Coverage, 2068,
     /* 200241 */     GIR_EraseRootFromParent_Done,
     /* 200242 */   // Label 4013: @200242
     /* 200242 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(200332), // Rule ID 2075 //
     /* 200247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 200250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 200255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 200267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 200287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 200295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 200304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200308 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200312 */     // MIs[2] Operand 1
     /* 200312 */     // No operand predicates
     /* 200312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200314 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 200314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 200317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 200327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 200330 */     GIR_RootConstrainSelectedInstOperands,
     /* 200331 */     // GIR_Coverage, 2075,
     /* 200331 */     GIR_EraseRootFromParent_Done,
     /* 200332 */   // Label 4014: @200332
     /* 200332 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(200409), // Rule ID 2772 //
     /* 200337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 200345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200389 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 200393 */     // MIs[2] Operand 1
     /* 200393 */     // No operand predicates
     /* 200393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200395 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 200395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 200398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200407 */     GIR_RootConstrainSelectedInstOperands,
     /* 200408 */     // GIR_Coverage, 2772,
     /* 200408 */     GIR_EraseRootFromParent_Done,
     /* 200409 */   // Label 4015: @200409
     /* 200409 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(200486), // Rule ID 2773 //
     /* 200414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 200422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200466 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200470 */     // MIs[2] Operand 1
     /* 200470 */     // No operand predicates
     /* 200470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200472 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 200472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 200475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200484 */     GIR_RootConstrainSelectedInstOperands,
     /* 200485 */     // GIR_Coverage, 2773,
     /* 200485 */     GIR_EraseRootFromParent_Done,
     /* 200486 */   // Label 4016: @200486
     /* 200486 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(200563), // Rule ID 2774 //
     /* 200491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 200499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200543 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 200547 */     // MIs[2] Operand 1
     /* 200547 */     // No operand predicates
     /* 200547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200549 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 200549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 200552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200561 */     GIR_RootConstrainSelectedInstOperands,
     /* 200562 */     // GIR_Coverage, 2774,
     /* 200562 */     GIR_EraseRootFromParent_Done,
     /* 200563 */   // Label 4017: @200563
     /* 200563 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(200640), // Rule ID 2775 //
     /* 200568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 200576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200620 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200624 */     // MIs[2] Operand 1
     /* 200624 */     // No operand predicates
     /* 200624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200626 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 200626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 200629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200638 */     GIR_RootConstrainSelectedInstOperands,
     /* 200639 */     // GIR_Coverage, 2775,
     /* 200639 */     GIR_EraseRootFromParent_Done,
     /* 200640 */   // Label 4018: @200640
     /* 200640 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(200717), // Rule ID 2776 //
     /* 200645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 200653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200697 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 200701 */     // MIs[2] Operand 1
     /* 200701 */     // No operand predicates
     /* 200701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200703 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 200703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 200706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200715 */     GIR_RootConstrainSelectedInstOperands,
     /* 200716 */     // GIR_Coverage, 2776,
     /* 200716 */     GIR_EraseRootFromParent_Done,
     /* 200717 */   // Label 4019: @200717
     /* 200717 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(200794), // Rule ID 2777 //
     /* 200722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 200730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200774 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200778 */     // MIs[2] Operand 1
     /* 200778 */     // No operand predicates
     /* 200778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200780 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 200783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200792 */     GIR_RootConstrainSelectedInstOperands,
     /* 200793 */     // GIR_Coverage, 2777,
     /* 200793 */     GIR_EraseRootFromParent_Done,
     /* 200794 */   // Label 4020: @200794
     /* 200794 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(200871), // Rule ID 7764 //
     /* 200799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 200807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200851 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 200855 */     // MIs[2] Operand 1
     /* 200855 */     // No operand predicates
     /* 200855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200857 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 200857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 200860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200869 */     GIR_RootConstrainSelectedInstOperands,
     /* 200870 */     // GIR_Coverage, 7764,
     /* 200870 */     GIR_EraseRootFromParent_Done,
     /* 200871 */   // Label 4021: @200871
     /* 200871 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(200948), // Rule ID 7765 //
     /* 200876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 200884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200928 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200932 */     // MIs[2] Operand 1
     /* 200932 */     // No operand predicates
     /* 200932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200934 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 200934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 200937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200946 */     GIR_RootConstrainSelectedInstOperands,
     /* 200947 */     // GIR_Coverage, 7765,
     /* 200947 */     GIR_EraseRootFromParent_Done,
     /* 200948 */   // Label 4022: @200948
     /* 200948 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(201025), // Rule ID 7766 //
     /* 200953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 200961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201005 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 201009 */     // MIs[2] Operand 1
     /* 201009 */     // No operand predicates
     /* 201009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201011 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 201011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 201014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201023 */     GIR_RootConstrainSelectedInstOperands,
     /* 201024 */     // GIR_Coverage, 7766,
     /* 201024 */     GIR_EraseRootFromParent_Done,
     /* 201025 */   // Label 4023: @201025
     /* 201025 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(201102), // Rule ID 7767 //
     /* 201030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 201038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201082 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201086 */     // MIs[2] Operand 1
     /* 201086 */     // No operand predicates
     /* 201086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201088 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 201088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 201091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201100 */     GIR_RootConstrainSelectedInstOperands,
     /* 201101 */     // GIR_Coverage, 7767,
     /* 201101 */     GIR_EraseRootFromParent_Done,
     /* 201102 */   // Label 4024: @201102
     /* 201102 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(201179), // Rule ID 7768 //
     /* 201107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 201115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201159 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 201163 */     // MIs[2] Operand 1
     /* 201163 */     // No operand predicates
     /* 201163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201165 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 201165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 201168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201177 */     GIR_RootConstrainSelectedInstOperands,
     /* 201178 */     // GIR_Coverage, 7768,
     /* 201178 */     GIR_EraseRootFromParent_Done,
     /* 201179 */   // Label 4025: @201179
     /* 201179 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(201256), // Rule ID 7769 //
     /* 201184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 201192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201236 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201240 */     // MIs[2] Operand 1
     /* 201240 */     // No operand predicates
     /* 201240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201242 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 201242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 201245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201254 */     GIR_RootConstrainSelectedInstOperands,
     /* 201255 */     // GIR_Coverage, 7769,
     /* 201255 */     GIR_EraseRootFromParent_Done,
     /* 201256 */   // Label 4026: @201256
     /* 201256 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(201333), // Rule ID 7770 //
     /* 201261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 201269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201313 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 201317 */     // MIs[2] Operand 1
     /* 201317 */     // No operand predicates
     /* 201317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201319 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 201319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 201322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201331 */     GIR_RootConstrainSelectedInstOperands,
     /* 201332 */     // GIR_Coverage, 7770,
     /* 201332 */     GIR_EraseRootFromParent_Done,
     /* 201333 */   // Label 4027: @201333
     /* 201333 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(201410), // Rule ID 7771 //
     /* 201338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 201346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201390 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 201394 */     // MIs[2] Operand 1
     /* 201394 */     // No operand predicates
     /* 201394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201396 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 201396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 201399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201408 */     GIR_RootConstrainSelectedInstOperands,
     /* 201409 */     // GIR_Coverage, 7771,
     /* 201409 */     GIR_EraseRootFromParent_Done,
     /* 201410 */   // Label 4028: @201410
     /* 201410 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(201487), // Rule ID 7772 //
     /* 201415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 201423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201467 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 201471 */     // MIs[2] Operand 1
     /* 201471 */     // No operand predicates
     /* 201471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201473 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 201473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 201476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201485 */     GIR_RootConstrainSelectedInstOperands,
     /* 201486 */     // GIR_Coverage, 7772,
     /* 201486 */     GIR_EraseRootFromParent_Done,
     /* 201487 */   // Label 4029: @201487
     /* 201487 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(201564), // Rule ID 7773 //
     /* 201492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 201500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201544 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 201548 */     // MIs[2] Operand 1
     /* 201548 */     // No operand predicates
     /* 201548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201550 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 201550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 201553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201562 */     GIR_RootConstrainSelectedInstOperands,
     /* 201563 */     // GIR_Coverage, 7773,
     /* 201563 */     GIR_EraseRootFromParent_Done,
     /* 201564 */   // Label 4030: @201564
     /* 201564 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(201641), // Rule ID 7774 //
     /* 201569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 201577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201621 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 201625 */     // MIs[2] Operand 1
     /* 201625 */     // No operand predicates
     /* 201625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201627 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 201627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 201630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201639 */     GIR_RootConstrainSelectedInstOperands,
     /* 201640 */     // GIR_Coverage, 7774,
     /* 201640 */     GIR_EraseRootFromParent_Done,
     /* 201641 */   // Label 4031: @201641
     /* 201641 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(201718), // Rule ID 7775 //
     /* 201646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 201654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201698 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 201702 */     // MIs[2] Operand 1
     /* 201702 */     // No operand predicates
     /* 201702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201704 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 201704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 201707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201716 */     GIR_RootConstrainSelectedInstOperands,
     /* 201717 */     // GIR_Coverage, 7775,
     /* 201717 */     GIR_EraseRootFromParent_Done,
     /* 201718 */   // Label 4032: @201718
     /* 201718 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(201795), // Rule ID 7776 //
     /* 201723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 201731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201775 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 201779 */     // MIs[2] Operand 1
     /* 201779 */     // No operand predicates
     /* 201779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201781 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 201781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 201784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201793 */     GIR_RootConstrainSelectedInstOperands,
     /* 201794 */     // GIR_Coverage, 7776,
     /* 201794 */     GIR_EraseRootFromParent_Done,
     /* 201795 */   // Label 4033: @201795
     /* 201795 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(201872), // Rule ID 7777 //
     /* 201800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 201808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201852 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201856 */     // MIs[2] Operand 1
     /* 201856 */     // No operand predicates
     /* 201856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201858 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 201858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 201861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201870 */     GIR_RootConstrainSelectedInstOperands,
     /* 201871 */     // GIR_Coverage, 7777,
     /* 201871 */     GIR_EraseRootFromParent_Done,
     /* 201872 */   // Label 4034: @201872
     /* 201872 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(201949), // Rule ID 7778 //
     /* 201877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 201885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201929 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 201933 */     // MIs[2] Operand 1
     /* 201933 */     // No operand predicates
     /* 201933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201935 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 201935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 201938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201947 */     GIR_RootConstrainSelectedInstOperands,
     /* 201948 */     // GIR_Coverage, 7778,
     /* 201948 */     GIR_EraseRootFromParent_Done,
     /* 201949 */   // Label 4035: @201949
     /* 201949 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202026), // Rule ID 7779 //
     /* 201954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 201962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202006 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 202010 */     // MIs[2] Operand 1
     /* 202010 */     // No operand predicates
     /* 202010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202012 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 202012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 202015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202024 */     GIR_RootConstrainSelectedInstOperands,
     /* 202025 */     // GIR_Coverage, 7779,
     /* 202025 */     GIR_EraseRootFromParent_Done,
     /* 202026 */   // Label 4036: @202026
     /* 202026 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202103), // Rule ID 7780 //
     /* 202031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 202039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 202051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 202075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202083 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 202087 */     // MIs[2] Operand 1
     /* 202087 */     // No operand predicates
     /* 202087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202089 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 202089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 202092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202101 */     GIR_RootConstrainSelectedInstOperands,
     /* 202102 */     // GIR_Coverage, 7780,
     /* 202102 */     GIR_EraseRootFromParent_Done,
     /* 202103 */   // Label 4037: @202103
     /* 202103 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202180), // Rule ID 7781 //
     /* 202108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 202116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 202128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 202152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202160 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 202164 */     // MIs[2] Operand 1
     /* 202164 */     // No operand predicates
     /* 202164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202166 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 202166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 202169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202178 */     GIR_RootConstrainSelectedInstOperands,
     /* 202179 */     // GIR_Coverage, 7781,
     /* 202179 */     GIR_EraseRootFromParent_Done,
     /* 202180 */   // Label 4038: @202180
     /* 202180 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202257), // Rule ID 7782 //
     /* 202185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 202193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 202205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 202229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202237 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 202241 */     // MIs[2] Operand 1
     /* 202241 */     // No operand predicates
     /* 202241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 202243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 202246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202255 */     GIR_RootConstrainSelectedInstOperands,
     /* 202256 */     // GIR_Coverage, 7782,
     /* 202256 */     GIR_EraseRootFromParent_Done,
     /* 202257 */   // Label 4039: @202257
     /* 202257 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202334), // Rule ID 7783 //
     /* 202262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 202270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 202282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 202306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202314 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 202318 */     // MIs[2] Operand 1
     /* 202318 */     // No operand predicates
     /* 202318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202320 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 202320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 202323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202332 */     GIR_RootConstrainSelectedInstOperands,
     /* 202333 */     // GIR_Coverage, 7783,
     /* 202333 */     GIR_EraseRootFromParent_Done,
     /* 202334 */   // Label 4040: @202334
     /* 202334 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202411), // Rule ID 7784 //
     /* 202339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 202347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 202359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 202383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202391 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 202395 */     // MIs[2] Operand 1
     /* 202395 */     // No operand predicates
     /* 202395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202397 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 202397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 202400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202409 */     GIR_RootConstrainSelectedInstOperands,
     /* 202410 */     // GIR_Coverage, 7784,
     /* 202410 */     GIR_EraseRootFromParent_Done,
     /* 202411 */   // Label 4041: @202411
     /* 202411 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202488), // Rule ID 7785 //
     /* 202416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 202424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 202436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 202460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202468 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 202472 */     // MIs[2] Operand 1
     /* 202472 */     // No operand predicates
     /* 202472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 202474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 202477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202486 */     GIR_RootConstrainSelectedInstOperands,
     /* 202487 */     // GIR_Coverage, 7785,
     /* 202487 */     GIR_EraseRootFromParent_Done,
     /* 202488 */   // Label 4042: @202488
     /* 202488 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(202565), // Rule ID 7786 //
     /* 202493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 202501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 202513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 202537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202545 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 202549 */     // MIs[2] Operand 1
     /* 202549 */     // No operand predicates
     /* 202549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202551 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 202551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 202554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202563 */     GIR_RootConstrainSelectedInstOperands,
     /* 202564 */     // GIR_Coverage, 7786,
     /* 202564 */     GIR_EraseRootFromParent_Done,
     /* 202565 */   // Label 4043: @202565
     /* 202565 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(202642), // Rule ID 7787 //
     /* 202570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 202578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 202590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 202614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202622 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 202626 */     // MIs[2] Operand 1
     /* 202626 */     // No operand predicates
     /* 202626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202628 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 202628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 202631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202640 */     GIR_RootConstrainSelectedInstOperands,
     /* 202641 */     // GIR_Coverage, 7787,
     /* 202641 */     GIR_EraseRootFromParent_Done,
     /* 202642 */   // Label 4044: @202642
     /* 202642 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(202719), // Rule ID 7788 //
     /* 202647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 202655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 202667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 202691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202699 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 202703 */     // MIs[2] Operand 1
     /* 202703 */     // No operand predicates
     /* 202703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202705 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 202705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 202708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202717 */     GIR_RootConstrainSelectedInstOperands,
     /* 202718 */     // GIR_Coverage, 7788,
     /* 202718 */     GIR_EraseRootFromParent_Done,
     /* 202719 */   // Label 4045: @202719
     /* 202719 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(202796), // Rule ID 7789 //
     /* 202724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 202732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 202744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 202768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202776 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 202780 */     // MIs[2] Operand 1
     /* 202780 */     // No operand predicates
     /* 202780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202782 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 202782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 202785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202794 */     GIR_RootConstrainSelectedInstOperands,
     /* 202795 */     // GIR_Coverage, 7789,
     /* 202795 */     GIR_EraseRootFromParent_Done,
     /* 202796 */   // Label 4046: @202796
     /* 202796 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(202873), // Rule ID 7790 //
     /* 202801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 202809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 202821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 202845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202853 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 202857 */     // MIs[2] Operand 1
     /* 202857 */     // No operand predicates
     /* 202857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 202859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 202862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202871 */     GIR_RootConstrainSelectedInstOperands,
     /* 202872 */     // GIR_Coverage, 7790,
     /* 202872 */     GIR_EraseRootFromParent_Done,
     /* 202873 */   // Label 4047: @202873
     /* 202873 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(202950), // Rule ID 7791 //
     /* 202878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 202886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 202898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 202922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 202926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 202930 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 202934 */     // MIs[2] Operand 1
     /* 202934 */     // No operand predicates
     /* 202934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 202936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 202939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 202943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 202945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202948 */     GIR_RootConstrainSelectedInstOperands,
     /* 202949 */     // GIR_Coverage, 7791,
     /* 202949 */     GIR_EraseRootFromParent_Done,
     /* 202950 */   // Label 4048: @202950
     /* 202950 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(203027), // Rule ID 7792 //
     /* 202955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 202963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 202975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 202983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 202995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 202999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203007 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 203011 */     // MIs[2] Operand 1
     /* 203011 */     // No operand predicates
     /* 203011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 203013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 203016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203025 */     GIR_RootConstrainSelectedInstOperands,
     /* 203026 */     // GIR_Coverage, 7792,
     /* 203026 */     GIR_EraseRootFromParent_Done,
     /* 203027 */   // Label 4049: @203027
     /* 203027 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(203104), // Rule ID 7793 //
     /* 203032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 203040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 203052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 203076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203084 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203088 */     // MIs[2] Operand 1
     /* 203088 */     // No operand predicates
     /* 203088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 203090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 203093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203102 */     GIR_RootConstrainSelectedInstOperands,
     /* 203103 */     // GIR_Coverage, 7793,
     /* 203103 */     GIR_EraseRootFromParent_Done,
     /* 203104 */   // Label 4050: @203104
     /* 203104 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(203181), // Rule ID 7794 //
     /* 203109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 203117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203161 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 203165 */     // MIs[2] Operand 1
     /* 203165 */     // No operand predicates
     /* 203165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203167 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 203167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 203170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203179 */     GIR_RootConstrainSelectedInstOperands,
     /* 203180 */     // GIR_Coverage, 7794,
     /* 203180 */     GIR_EraseRootFromParent_Done,
     /* 203181 */   // Label 4051: @203181
     /* 203181 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(203258), // Rule ID 7795 //
     /* 203186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 203194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203238 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203242 */     // MIs[2] Operand 1
     /* 203242 */     // No operand predicates
     /* 203242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203244 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 203244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 203247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203256 */     GIR_RootConstrainSelectedInstOperands,
     /* 203257 */     // GIR_Coverage, 7795,
     /* 203257 */     GIR_EraseRootFromParent_Done,
     /* 203258 */   // Label 4052: @203258
     /* 203258 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(203335), // Rule ID 7796 //
     /* 203263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 203271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 203283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 203307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203315 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 203319 */     // MIs[2] Operand 1
     /* 203319 */     // No operand predicates
     /* 203319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203321 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 203321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 203324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203333 */     GIR_RootConstrainSelectedInstOperands,
     /* 203334 */     // GIR_Coverage, 7796,
     /* 203334 */     GIR_EraseRootFromParent_Done,
     /* 203335 */   // Label 4053: @203335
     /* 203335 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(203412), // Rule ID 7797 //
     /* 203340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 203348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 203360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 203384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203392 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203396 */     // MIs[2] Operand 1
     /* 203396 */     // No operand predicates
     /* 203396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203398 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 203398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 203401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203410 */     GIR_RootConstrainSelectedInstOperands,
     /* 203411 */     // GIR_Coverage, 7797,
     /* 203411 */     GIR_EraseRootFromParent_Done,
     /* 203412 */   // Label 4054: @203412
     /* 203412 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203489), // Rule ID 7798 //
     /* 203417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 203425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 203437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 203461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203469 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 203473 */     // MIs[2] Operand 1
     /* 203473 */     // No operand predicates
     /* 203473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203475 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 203475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 203478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203487 */     GIR_RootConstrainSelectedInstOperands,
     /* 203488 */     // GIR_Coverage, 7798,
     /* 203488 */     GIR_EraseRootFromParent_Done,
     /* 203489 */   // Label 4055: @203489
     /* 203489 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203566), // Rule ID 7799 //
     /* 203494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 203502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 203514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 203538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203546 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203550 */     // MIs[2] Operand 1
     /* 203550 */     // No operand predicates
     /* 203550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203552 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 203552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 203555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203564 */     GIR_RootConstrainSelectedInstOperands,
     /* 203565 */     // GIR_Coverage, 7799,
     /* 203565 */     GIR_EraseRootFromParent_Done,
     /* 203566 */   // Label 4056: @203566
     /* 203566 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203643), // Rule ID 7800 //
     /* 203571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 203579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203623 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 203627 */     // MIs[2] Operand 1
     /* 203627 */     // No operand predicates
     /* 203627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203629 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 203629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 203632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203641 */     GIR_RootConstrainSelectedInstOperands,
     /* 203642 */     // GIR_Coverage, 7800,
     /* 203642 */     GIR_EraseRootFromParent_Done,
     /* 203643 */   // Label 4057: @203643
     /* 203643 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203720), // Rule ID 7801 //
     /* 203648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 203656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203700 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203704 */     // MIs[2] Operand 1
     /* 203704 */     // No operand predicates
     /* 203704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203706 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 203706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 203709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203718 */     GIR_RootConstrainSelectedInstOperands,
     /* 203719 */     // GIR_Coverage, 7801,
     /* 203719 */     GIR_EraseRootFromParent_Done,
     /* 203720 */   // Label 4058: @203720
     /* 203720 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(203797), // Rule ID 7802 //
     /* 203725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 203733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 203745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 203769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203777 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 203781 */     // MIs[2] Operand 1
     /* 203781 */     // No operand predicates
     /* 203781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203783 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 203783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 203786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203795 */     GIR_RootConstrainSelectedInstOperands,
     /* 203796 */     // GIR_Coverage, 7802,
     /* 203796 */     GIR_EraseRootFromParent_Done,
     /* 203797 */   // Label 4059: @203797
     /* 203797 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(203874), // Rule ID 7803 //
     /* 203802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 203810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 203822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 203846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203854 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203858 */     // MIs[2] Operand 1
     /* 203858 */     // No operand predicates
     /* 203858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 203860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 203863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203872 */     GIR_RootConstrainSelectedInstOperands,
     /* 203873 */     // GIR_Coverage, 7803,
     /* 203873 */     GIR_EraseRootFromParent_Done,
     /* 203874 */   // Label 4060: @203874
     /* 203874 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(203951), // Rule ID 7804 //
     /* 203879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 203887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 203899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 203923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203931 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 203935 */     // MIs[2] Operand 1
     /* 203935 */     // No operand predicates
     /* 203935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203937 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 203937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 203940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203949 */     GIR_RootConstrainSelectedInstOperands,
     /* 203950 */     // GIR_Coverage, 7804,
     /* 203950 */     GIR_EraseRootFromParent_Done,
     /* 203951 */   // Label 4061: @203951
     /* 203951 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(204028), // Rule ID 7805 //
     /* 203956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 203964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 203976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204008 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204012 */     // MIs[2] Operand 1
     /* 204012 */     // No operand predicates
     /* 204012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 204017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204026 */     GIR_RootConstrainSelectedInstOperands,
     /* 204027 */     // GIR_Coverage, 7805,
     /* 204027 */     GIR_EraseRootFromParent_Done,
     /* 204028 */   // Label 4062: @204028
     /* 204028 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(204084), // Rule ID 55 //
     /* 204033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 204036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 204041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 204050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204058 */     // MIs[0] Operand 3
     /* 204058 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 204069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 204073 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 204073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 204076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 204082 */     GIR_RootConstrainSelectedInstOperands,
     /* 204083 */     // GIR_Coverage, 55,
     /* 204083 */     GIR_EraseRootFromParent_Done,
     /* 204084 */   // Label 4063: @204084
     /* 204084 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(204140), // Rule ID 56 //
     /* 204089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 204092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 204097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 204106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204114 */     // MIs[0] Operand 3
     /* 204114 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 204125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 204129 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 204129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 204132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 204138 */     GIR_RootConstrainSelectedInstOperands,
     /* 204139 */     // GIR_Coverage, 56,
     /* 204139 */     GIR_EraseRootFromParent_Done,
     /* 204140 */   // Label 4064: @204140
     /* 204140 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(204196), // Rule ID 57 //
     /* 204145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 204148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 204153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 204162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204170 */     // MIs[0] Operand 3
     /* 204170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 204181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 204185 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 204185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 204188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 204194 */     GIR_RootConstrainSelectedInstOperands,
     /* 204195 */     // GIR_Coverage, 57,
     /* 204195 */     GIR_EraseRootFromParent_Done,
     /* 204196 */   // Label 4065: @204196
     /* 204196 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(204252), // Rule ID 58 //
     /* 204201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 204204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 204209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 204218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204226 */     // MIs[0] Operand 3
     /* 204226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 204237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 204241 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 204241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 204244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 204250 */     GIR_RootConstrainSelectedInstOperands,
     /* 204251 */     // GIR_Coverage, 58,
     /* 204251 */     GIR_EraseRootFromParent_Done,
     /* 204252 */   // Label 4066: @204252
     /* 204252 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(204307), // Rule ID 2790 //
     /* 204257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 204265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204286 */     // MIs[0] imm
     /* 204286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 204294 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1448:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 204294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 204297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 204303 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 204305 */     GIR_RootConstrainSelectedInstOperands,
     /* 204306 */     // GIR_Coverage, 2790,
     /* 204306 */     GIR_EraseRootFromParent_Done,
     /* 204307 */   // Label 4067: @204307
     /* 204307 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(204362), // Rule ID 2791 //
     /* 204312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 204320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204341 */     // MIs[0] imm
     /* 204341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 204349 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1448:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 204349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 204352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 204358 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 204360 */     GIR_RootConstrainSelectedInstOperands,
     /* 204361 */     // GIR_Coverage, 2791,
     /* 204361 */     GIR_EraseRootFromParent_Done,
     /* 204362 */   // Label 4068: @204362
     /* 204362 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(204417), // Rule ID 2792 //
     /* 204367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 204375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204396 */     // MIs[0] imm
     /* 204396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 204404 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1448:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 204404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 204407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 204413 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 204415 */     GIR_RootConstrainSelectedInstOperands,
     /* 204416 */     // GIR_Coverage, 2792,
     /* 204416 */     GIR_EraseRootFromParent_Done,
     /* 204417 */   // Label 4069: @204417
     /* 204417 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(204472), // Rule ID 3543 //
     /* 204422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 204430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204451 */     // MIs[0] Idx
     /* 204451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 204459 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 204459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 204462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 204466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 204468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 204470 */     GIR_RootConstrainSelectedInstOperands,
     /* 204471 */     // GIR_Coverage, 3543,
     /* 204471 */     GIR_EraseRootFromParent_Done,
     /* 204472 */   // Label 4070: @204472
     /* 204472 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(204527), // Rule ID 3544 //
     /* 204477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 204485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204506 */     // MIs[0] Idx
     /* 204506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 204514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 204514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 204517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 204521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 204523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 204525 */     GIR_RootConstrainSelectedInstOperands,
     /* 204526 */     // GIR_Coverage, 3544,
     /* 204526 */     GIR_EraseRootFromParent_Done,
     /* 204527 */   // Label 4071: @204527
     /* 204527 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(204582), // Rule ID 3545 //
     /* 204532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 204540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204561 */     // MIs[0] Idx
     /* 204561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 204569 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 204569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 204572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 204576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 204578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 204580 */     GIR_RootConstrainSelectedInstOperands,
     /* 204581 */     // GIR_Coverage, 3545,
     /* 204581 */     GIR_EraseRootFromParent_Done,
     /* 204582 */   // Label 4072: @204582
     /* 204582 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(204637), // Rule ID 3797 //
     /* 204587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 204590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 204595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 204598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 204601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 204604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204616 */     // MIs[0] imm
     /* 204616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 204624 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 204624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 204627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 204631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 204633 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 204635 */     GIR_RootConstrainSelectedInstOperands,
     /* 204636 */     // GIR_Coverage, 3797,
     /* 204636 */     GIR_EraseRootFromParent_Done,
     /* 204637 */   // Label 4073: @204637
     /* 204637 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(204684), // Rule ID 2844 //
     /* 204642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 204650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204663 */     // MIs[0] idx
     /* 204663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204671 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1384:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 204671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 204674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204680 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 204682 */     GIR_RootConstrainSelectedInstOperands,
     /* 204683 */     // GIR_Coverage, 2844,
     /* 204683 */     GIR_EraseRootFromParent_Done,
     /* 204684 */   // Label 4074: @204684
     /* 204684 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(204731), // Rule ID 2845 //
     /* 204689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 204697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204710 */     // MIs[0] idx
     /* 204710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204718 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1384:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 204718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 204721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204727 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 204729 */     GIR_RootConstrainSelectedInstOperands,
     /* 204730 */     // GIR_Coverage, 2845,
     /* 204730 */     GIR_EraseRootFromParent_Done,
     /* 204731 */   // Label 4075: @204731
     /* 204731 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(204778), // Rule ID 2846 //
     /* 204736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 204744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204757 */     // MIs[0] idx
     /* 204757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 204765 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1384:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 204765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 204768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204774 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 204776 */     GIR_RootConstrainSelectedInstOperands,
     /* 204777 */     // GIR_Coverage, 2846,
     /* 204777 */     GIR_EraseRootFromParent_Done,
     /* 204778 */   // Label 4076: @204778
     /* 204778 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(204825), // Rule ID 2995 //
     /* 204783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 204791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204804 */     // MIs[0] Op3
     /* 204804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204807 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1515:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 204812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 204815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204823 */     GIR_RootConstrainSelectedInstOperands,
     /* 204824 */     // GIR_Coverage, 2995,
     /* 204824 */     GIR_EraseRootFromParent_Done,
     /* 204825 */   // Label 4077: @204825
     /* 204825 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(204872), // Rule ID 2996 //
     /* 204830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 204838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204851 */     // MIs[0] Op3
     /* 204851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1515:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 204859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 204862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204870 */     GIR_RootConstrainSelectedInstOperands,
     /* 204871 */     // GIR_Coverage, 2996,
     /* 204871 */     GIR_EraseRootFromParent_Done,
     /* 204872 */   // Label 4078: @204872
     /* 204872 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(204919), // Rule ID 2997 //
     /* 204877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 204885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204898 */     // MIs[0] Op3
     /* 204898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 204906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1515:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 204906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 204909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204917 */     GIR_RootConstrainSelectedInstOperands,
     /* 204918 */     // GIR_Coverage, 2997,
     /* 204918 */     GIR_EraseRootFromParent_Done,
     /* 204919 */   // Label 4079: @204919
     /* 204919 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(204966), // Rule ID 2998 //
     /* 204924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 204932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204945 */     // MIs[0] Op3
     /* 204945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204953 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1661:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 204953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 204956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204964 */     GIR_RootConstrainSelectedInstOperands,
     /* 204965 */     // GIR_Coverage, 2998,
     /* 204965 */     GIR_EraseRootFromParent_Done,
     /* 204966 */   // Label 4080: @204966
     /* 204966 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(205013), // Rule ID 2999 //
     /* 204971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 204979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204992 */     // MIs[0] Op3
     /* 204992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 205000 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1661:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 205000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 205003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205011 */     GIR_RootConstrainSelectedInstOperands,
     /* 205012 */     // GIR_Coverage, 2999,
     /* 205012 */     GIR_EraseRootFromParent_Done,
     /* 205013 */   // Label 4081: @205013
     /* 205013 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(205060), // Rule ID 3047 //
     /* 205018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 205026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205039 */     // MIs[0] Op3
     /* 205039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205047 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1772:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 205050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205058 */     GIR_RootConstrainSelectedInstOperands,
     /* 205059 */     // GIR_Coverage, 3047,
     /* 205059 */     GIR_EraseRootFromParent_Done,
     /* 205060 */   // Label 4082: @205060
     /* 205060 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(205107), // Rule ID 3049 //
     /* 205065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 205073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205086 */     // MIs[0] Op3
     /* 205086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1772:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 205097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205105 */     GIR_RootConstrainSelectedInstOperands,
     /* 205106 */     // GIR_Coverage, 3049,
     /* 205106 */     GIR_EraseRootFromParent_Done,
     /* 205107 */   // Label 4083: @205107
     /* 205107 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(205154), // Rule ID 3051 //
     /* 205112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 205120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205133 */     // MIs[0] Op3
     /* 205133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1772:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 205144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205152 */     GIR_RootConstrainSelectedInstOperands,
     /* 205153 */     // GIR_Coverage, 3051,
     /* 205153 */     GIR_EraseRootFromParent_Done,
     /* 205154 */   // Label 4084: @205154
     /* 205154 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(205201), // Rule ID 3053 //
     /* 205159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 205167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205180 */     // MIs[0] Op3
     /* 205180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 205188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1772:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 205188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 205191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205199 */     GIR_RootConstrainSelectedInstOperands,
     /* 205200 */     // GIR_Coverage, 3053,
     /* 205200 */     GIR_EraseRootFromParent_Done,
     /* 205201 */   // Label 4085: @205201
     /* 205201 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(205248), // Rule ID 3075 //
     /* 205206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 205214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205227 */     // MIs[0] Op3
     /* 205227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205235 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 205238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205246 */     GIR_RootConstrainSelectedInstOperands,
     /* 205247 */     // GIR_Coverage, 3075,
     /* 205247 */     GIR_EraseRootFromParent_Done,
     /* 205248 */   // Label 4086: @205248
     /* 205248 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(205295), // Rule ID 3076 //
     /* 205253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 205261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205274 */     // MIs[0] Op3
     /* 205274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 205285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205293 */     GIR_RootConstrainSelectedInstOperands,
     /* 205294 */     // GIR_Coverage, 3076,
     /* 205294 */     GIR_EraseRootFromParent_Done,
     /* 205295 */   // Label 4087: @205295
     /* 205295 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(205342), // Rule ID 3077 //
     /* 205300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 205308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205321 */     // MIs[0] Op3
     /* 205321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 205332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205340 */     GIR_RootConstrainSelectedInstOperands,
     /* 205341 */     // GIR_Coverage, 3077,
     /* 205341 */     GIR_EraseRootFromParent_Done,
     /* 205342 */   // Label 4088: @205342
     /* 205342 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(205389), // Rule ID 3146 //
     /* 205347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 205355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205368 */     // MIs[0] Op3
     /* 205368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 205379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205387 */     GIR_RootConstrainSelectedInstOperands,
     /* 205388 */     // GIR_Coverage, 3146,
     /* 205388 */     GIR_EraseRootFromParent_Done,
     /* 205389 */   // Label 4089: @205389
     /* 205389 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(205436), // Rule ID 3147 //
     /* 205394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 205402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205415 */     // MIs[0] Op3
     /* 205415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205423 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 205426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205434 */     GIR_RootConstrainSelectedInstOperands,
     /* 205435 */     // GIR_Coverage, 3147,
     /* 205435 */     GIR_EraseRootFromParent_Done,
     /* 205436 */   // Label 4090: @205436
     /* 205436 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(205483), // Rule ID 3148 //
     /* 205441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 205449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205462 */     // MIs[0] Op3
     /* 205462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205470 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 205473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205481 */     GIR_RootConstrainSelectedInstOperands,
     /* 205482 */     // GIR_Coverage, 3148,
     /* 205482 */     GIR_EraseRootFromParent_Done,
     /* 205483 */   // Label 4091: @205483
     /* 205483 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(205530), // Rule ID 3149 //
     /* 205488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 205496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205509 */     // MIs[0] Op3
     /* 205509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 205517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 205517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 205520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205528 */     GIR_RootConstrainSelectedInstOperands,
     /* 205529 */     // GIR_Coverage, 3149,
     /* 205529 */     GIR_EraseRootFromParent_Done,
     /* 205530 */   // Label 4092: @205530
     /* 205530 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(205577), // Rule ID 3528 //
     /* 205535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 205543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205556 */     // MIs[0] Op3
     /* 205556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 205564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1263:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 205564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 205567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205575 */     GIR_RootConstrainSelectedInstOperands,
     /* 205576 */     // GIR_Coverage, 3528,
     /* 205576 */     GIR_EraseRootFromParent_Done,
     /* 205577 */   // Label 4093: @205577
     /* 205577 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(205624), // Rule ID 3576 //
     /* 205582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 205585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 205590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205603 */     // MIs[0] Op3
     /* 205603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205606 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 205611 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1502:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 205611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 205614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205622 */     GIR_RootConstrainSelectedInstOperands,
     /* 205623 */     // GIR_Coverage, 3576,
     /* 205623 */     GIR_EraseRootFromParent_Done,
     /* 205624 */   // Label 4094: @205624
     /* 205624 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(205671), // Rule ID 3577 //
     /* 205629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 205632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 205637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205650 */     // MIs[0] Op3
     /* 205650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 205658 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1502:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 205658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 205661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205669 */     GIR_RootConstrainSelectedInstOperands,
     /* 205670 */     // GIR_Coverage, 3577,
     /* 205670 */     GIR_EraseRootFromParent_Done,
     /* 205671 */   // Label 4095: @205671
     /* 205671 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(205718), // Rule ID 3578 //
     /* 205676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 205679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 205684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205697 */     // MIs[0] Op3
     /* 205697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 205705 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1502:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 205705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 205708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205716 */     GIR_RootConstrainSelectedInstOperands,
     /* 205717 */     // GIR_Coverage, 3578,
     /* 205717 */     GIR_EraseRootFromParent_Done,
     /* 205718 */   // Label 4096: @205718
     /* 205718 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(205765), // Rule ID 3579 //
     /* 205723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 205726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 205731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205744 */     // MIs[0] Op3
     /* 205744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 205752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1503:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 205752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 205755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205763 */     GIR_RootConstrainSelectedInstOperands,
     /* 205764 */     // GIR_Coverage, 3579,
     /* 205764 */     GIR_EraseRootFromParent_Done,
     /* 205765 */   // Label 4097: @205765
     /* 205765 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(205812), // Rule ID 3580 //
     /* 205770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 205773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 205778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205791 */     // MIs[0] Op3
     /* 205791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 205799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1503:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 205799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 205802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205810 */     GIR_RootConstrainSelectedInstOperands,
     /* 205811 */     // GIR_Coverage, 3580,
     /* 205811 */     GIR_EraseRootFromParent_Done,
     /* 205812 */   // Label 4098: @205812
     /* 205812 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(205859), // Rule ID 3581 //
     /* 205817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 205820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 205825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205838 */     // MIs[0] Op3
     /* 205838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 205846 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 205846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 205849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205857 */     GIR_RootConstrainSelectedInstOperands,
     /* 205858 */     // GIR_Coverage, 3581,
     /* 205858 */     GIR_EraseRootFromParent_Done,
     /* 205859 */   // Label 4099: @205859
     /* 205859 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(205906), // Rule ID 11202 //
     /* 205864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 205872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205885 */     // MIs[0] Op3
     /* 205885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 205893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1702:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 205893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 205896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205904 */     GIR_RootConstrainSelectedInstOperands,
     /* 205905 */     // GIR_Coverage, 11202,
     /* 205905 */     GIR_EraseRootFromParent_Done,
     /* 205906 */   // Label 4100: @205906
     /* 205906 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(205953), // Rule ID 11203 //
     /* 205911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 205919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205932 */     // MIs[0] Op3
     /* 205932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 205940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 205940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 205943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205951 */     GIR_RootConstrainSelectedInstOperands,
     /* 205952 */     // GIR_Coverage, 11203,
     /* 205952 */     GIR_EraseRootFromParent_Done,
     /* 205953 */   // Label 4101: @205953
     /* 205953 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(206000), // Rule ID 11204 //
     /* 205958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 205966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205979 */     // MIs[0] Op3
     /* 205979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 205987 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 205987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 205990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205998 */     GIR_RootConstrainSelectedInstOperands,
     /* 205999 */     // GIR_Coverage, 11204,
     /* 205999 */     GIR_EraseRootFromParent_Done,
     /* 206000 */   // Label 4102: @206000
     /* 206000 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(206047), // Rule ID 11205 //
     /* 206005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 206013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206026 */     // MIs[0] Op3
     /* 206026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 206034 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1733:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 206034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 206037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206045 */     GIR_RootConstrainSelectedInstOperands,
     /* 206046 */     // GIR_Coverage, 11205,
     /* 206046 */     GIR_EraseRootFromParent_Done,
     /* 206047 */   // Label 4103: @206047
     /* 206047 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(206094), // Rule ID 11206 //
     /* 206052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 206060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206073 */     // MIs[0] Op3
     /* 206073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 206081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 206081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 206084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206092 */     GIR_RootConstrainSelectedInstOperands,
     /* 206093 */     // GIR_Coverage, 11206,
     /* 206093 */     GIR_EraseRootFromParent_Done,
     /* 206094 */   // Label 4104: @206094
     /* 206094 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(206141), // Rule ID 11207 //
     /* 206099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 206107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206120 */     // MIs[0] Op3
     /* 206120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 206128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1733:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 206128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 206131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206139 */     GIR_RootConstrainSelectedInstOperands,
     /* 206140 */     // GIR_Coverage, 11207,
     /* 206140 */     GIR_EraseRootFromParent_Done,
     /* 206141 */   // Label 4105: @206141
     /* 206141 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(206188), // Rule ID 11230 //
     /* 206146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 206154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206167 */     // MIs[0] Op3
     /* 206167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 206175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 206175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 206178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206186 */     GIR_RootConstrainSelectedInstOperands,
     /* 206187 */     // GIR_Coverage, 11230,
     /* 206187 */     GIR_EraseRootFromParent_Done,
     /* 206188 */   // Label 4106: @206188
     /* 206188 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(206235), // Rule ID 11231 //
     /* 206193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 206201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206214 */     // MIs[0] Op3
     /* 206214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 206222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 206222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 206225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206233 */     GIR_RootConstrainSelectedInstOperands,
     /* 206234 */     // GIR_Coverage, 11231,
     /* 206234 */     GIR_EraseRootFromParent_Done,
     /* 206235 */   // Label 4107: @206235
     /* 206235 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(206282), // Rule ID 11232 //
     /* 206240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 206248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206261 */     // MIs[0] Op3
     /* 206261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 206269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1899:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 206269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 206272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206280 */     GIR_RootConstrainSelectedInstOperands,
     /* 206281 */     // GIR_Coverage, 11232,
     /* 206281 */     GIR_EraseRootFromParent_Done,
     /* 206282 */   // Label 4108: @206282
     /* 206282 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(206329), // Rule ID 11233 //
     /* 206287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 206295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206308 */     // MIs[0] Op3
     /* 206308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 206316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1899:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 206316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 206319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206327 */     GIR_RootConstrainSelectedInstOperands,
     /* 206328 */     // GIR_Coverage, 11233,
     /* 206328 */     GIR_EraseRootFromParent_Done,
     /* 206329 */   // Label 4109: @206329
     /* 206329 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(206376), // Rule ID 11234 //
     /* 206334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 206342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206355 */     // MIs[0] Op3
     /* 206355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 206363 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1901:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 206363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 206366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206374 */     GIR_RootConstrainSelectedInstOperands,
     /* 206375 */     // GIR_Coverage, 11234,
     /* 206375 */     GIR_EraseRootFromParent_Done,
     /* 206376 */   // Label 4110: @206376
     /* 206376 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(206423), // Rule ID 11235 //
     /* 206381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 206389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206402 */     // MIs[0] Op3
     /* 206402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 206410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1901:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 206410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 206413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206421 */     GIR_RootConstrainSelectedInstOperands,
     /* 206422 */     // GIR_Coverage, 11235,
     /* 206422 */     GIR_EraseRootFromParent_Done,
     /* 206423 */   // Label 4111: @206423
     /* 206423 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(206470), // Rule ID 11236 //
     /* 206428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 206436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206449 */     // MIs[0] Op3
     /* 206449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 206457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 206457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 206460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206468 */     GIR_RootConstrainSelectedInstOperands,
     /* 206469 */     // GIR_Coverage, 11236,
     /* 206469 */     GIR_EraseRootFromParent_Done,
     /* 206470 */   // Label 4112: @206470
     /* 206470 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(206517), // Rule ID 11237 //
     /* 206475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 206483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206496 */     // MIs[0] Op3
     /* 206496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 206504 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 206504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 206507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206515 */     GIR_RootConstrainSelectedInstOperands,
     /* 206516 */     // GIR_Coverage, 11237,
     /* 206516 */     GIR_EraseRootFromParent_Done,
     /* 206517 */   // Label 4113: @206517
     /* 206517 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(206564), // Rule ID 11238 //
     /* 206522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 206530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206543 */     // MIs[0] Op3
     /* 206543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 206551 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 206551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 206554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206562 */     GIR_RootConstrainSelectedInstOperands,
     /* 206563 */     // GIR_Coverage, 11238,
     /* 206563 */     GIR_EraseRootFromParent_Done,
     /* 206564 */   // Label 4114: @206564
     /* 206564 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(206611), // Rule ID 11239 //
     /* 206569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 206577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206590 */     // MIs[0] Op3
     /* 206590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 206598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 206598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 206601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206609 */     GIR_RootConstrainSelectedInstOperands,
     /* 206610 */     // GIR_Coverage, 11239,
     /* 206610 */     GIR_EraseRootFromParent_Done,
     /* 206611 */   // Label 4115: @206611
     /* 206611 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(206658), // Rule ID 11483 //
     /* 206616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 206624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 206630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206637 */     // MIs[0] Op3
     /* 206637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 206645 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1768:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 206645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 206648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206656 */     GIR_RootConstrainSelectedInstOperands,
     /* 206657 */     // GIR_Coverage, 11483,
     /* 206657 */     GIR_EraseRootFromParent_Done,
     /* 206658 */   // Label 4116: @206658
     /* 206658 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(206705), // Rule ID 11484 //
     /* 206663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 206671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206684 */     // MIs[0] Op3
     /* 206684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 206692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1768:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 206692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 206695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206703 */     GIR_RootConstrainSelectedInstOperands,
     /* 206704 */     // GIR_Coverage, 11484,
     /* 206704 */     GIR_EraseRootFromParent_Done,
     /* 206705 */   // Label 4117: @206705
     /* 206705 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(206752), // Rule ID 11485 //
     /* 206710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 206718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206731 */     // MIs[0] Op3
     /* 206731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1768:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 206742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206750 */     GIR_RootConstrainSelectedInstOperands,
     /* 206751 */     // GIR_Coverage, 11485,
     /* 206751 */     GIR_EraseRootFromParent_Done,
     /* 206752 */   // Label 4118: @206752
     /* 206752 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(206799), // Rule ID 11486 //
     /* 206757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 206765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206778 */     // MIs[0] Op3
     /* 206778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 206786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1768:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 206786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 206789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206797 */     GIR_RootConstrainSelectedInstOperands,
     /* 206798 */     // GIR_Coverage, 11486,
     /* 206798 */     GIR_EraseRootFromParent_Done,
     /* 206799 */   // Label 4119: @206799
     /* 206799 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(206846), // Rule ID 11487 //
     /* 206804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 206812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 206818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206825 */     // MIs[0] Op3
     /* 206825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 206833 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1959:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 206833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 206836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206844 */     GIR_RootConstrainSelectedInstOperands,
     /* 206845 */     // GIR_Coverage, 11487,
     /* 206845 */     GIR_EraseRootFromParent_Done,
     /* 206846 */   // Label 4120: @206846
     /* 206846 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(206893), // Rule ID 11489 //
     /* 206851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 206859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206872 */     // MIs[0] Op3
     /* 206872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 206880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1959:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 206880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 206883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206891 */     GIR_RootConstrainSelectedInstOperands,
     /* 206892 */     // GIR_Coverage, 11489,
     /* 206892 */     GIR_EraseRootFromParent_Done,
     /* 206893 */   // Label 4121: @206893
     /* 206893 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(206940), // Rule ID 11491 //
     /* 206898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 206906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206919 */     // MIs[0] Op3
     /* 206919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 206930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206938 */     GIR_RootConstrainSelectedInstOperands,
     /* 206939 */     // GIR_Coverage, 11491,
     /* 206939 */     GIR_EraseRootFromParent_Done,
     /* 206940 */   // Label 4122: @206940
     /* 206940 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(206987), // Rule ID 11493 //
     /* 206945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 206953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206966 */     // MIs[0] Op3
     /* 206966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 206974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1959:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 206974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 206977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206985 */     GIR_RootConstrainSelectedInstOperands,
     /* 206986 */     // GIR_Coverage, 11493,
     /* 206986 */     GIR_EraseRootFromParent_Done,
     /* 206987 */   // Label 4123: @206987
     /* 206987 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(207034), // Rule ID 11495 //
     /* 206992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 207000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 207006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207013 */     // MIs[0] Op3
     /* 207013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 207021 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1748:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 207021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 207024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207032 */     GIR_RootConstrainSelectedInstOperands,
     /* 207033 */     // GIR_Coverage, 11495,
     /* 207033 */     GIR_EraseRootFromParent_Done,
     /* 207034 */   // Label 4124: @207034
     /* 207034 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(207081), // Rule ID 11496 //
     /* 207039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 207047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207060 */     // MIs[0] Op3
     /* 207060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 207068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1748:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 207068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 207071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207079 */     GIR_RootConstrainSelectedInstOperands,
     /* 207080 */     // GIR_Coverage, 11496,
     /* 207080 */     GIR_EraseRootFromParent_Done,
     /* 207081 */   // Label 4125: @207081
     /* 207081 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(207128), // Rule ID 11497 //
     /* 207086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 207094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207107 */     // MIs[0] Op3
     /* 207107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 207115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 207115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 207118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207126 */     GIR_RootConstrainSelectedInstOperands,
     /* 207127 */     // GIR_Coverage, 11497,
     /* 207127 */     GIR_EraseRootFromParent_Done,
     /* 207128 */   // Label 4126: @207128
     /* 207128 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(207175), // Rule ID 11498 //
     /* 207133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 207141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207154 */     // MIs[0] Op3
     /* 207154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 207162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 207162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 207165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207173 */     GIR_RootConstrainSelectedInstOperands,
     /* 207174 */     // GIR_Coverage, 11498,
     /* 207174 */     GIR_EraseRootFromParent_Done,
     /* 207175 */   // Label 4127: @207175
     /* 207175 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(207222), // Rule ID 11573 //
     /* 207180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 207188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207201 */     // MIs[0] Op3
     /* 207201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 207209 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 207209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 207212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207220 */     GIR_RootConstrainSelectedInstOperands,
     /* 207221 */     // GIR_Coverage, 11573,
     /* 207221 */     GIR_EraseRootFromParent_Done,
     /* 207222 */   // Label 4128: @207222
     /* 207222 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(207269), // Rule ID 11575 //
     /* 207227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 207235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207248 */     // MIs[0] Op3
     /* 207248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 207256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 207256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 207259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207267 */     GIR_RootConstrainSelectedInstOperands,
     /* 207268 */     // GIR_Coverage, 11575,
     /* 207268 */     GIR_EraseRootFromParent_Done,
     /* 207269 */   // Label 4129: @207269
     /* 207269 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(207316), // Rule ID 11577 //
     /* 207274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 207282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207295 */     // MIs[0] Op3
     /* 207295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 207303 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 207303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 207306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207314 */     GIR_RootConstrainSelectedInstOperands,
     /* 207315 */     // GIR_Coverage, 11577,
     /* 207315 */     GIR_EraseRootFromParent_Done,
     /* 207316 */   // Label 4130: @207316
     /* 207316 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(207363), // Rule ID 11579 //
     /* 207321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 207329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207342 */     // MIs[0] Op3
     /* 207342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 207350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 207350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 207353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207361 */     GIR_RootConstrainSelectedInstOperands,
     /* 207362 */     // GIR_Coverage, 11579,
     /* 207362 */     GIR_EraseRootFromParent_Done,
     /* 207363 */   // Label 4131: @207363
     /* 207363 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(207410), // Rule ID 11581 //
     /* 207368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 207376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207389 */     // MIs[0] Op3
     /* 207389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207392 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 207397 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 207397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 207400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207408 */     GIR_RootConstrainSelectedInstOperands,
     /* 207409 */     // GIR_Coverage, 11581,
     /* 207409 */     GIR_EraseRootFromParent_Done,
     /* 207410 */   // Label 4132: @207410
     /* 207410 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(207457), // Rule ID 11582 //
     /* 207415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 207423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207436 */     // MIs[0] Op3
     /* 207436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 207444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 207444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 207447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207455 */     GIR_RootConstrainSelectedInstOperands,
     /* 207456 */     // GIR_Coverage, 11582,
     /* 207456 */     GIR_EraseRootFromParent_Done,
     /* 207457 */   // Label 4133: @207457
     /* 207457 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(207504), // Rule ID 11583 //
     /* 207462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 207470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207483 */     // MIs[0] Op3
     /* 207483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 207491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 207491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 207494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207502 */     GIR_RootConstrainSelectedInstOperands,
     /* 207503 */     // GIR_Coverage, 11583,
     /* 207503 */     GIR_EraseRootFromParent_Done,
     /* 207504 */   // Label 4134: @207504
     /* 207504 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(207551), // Rule ID 11584 //
     /* 207509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 207517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207530 */     // MIs[0] Op3
     /* 207530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 207538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 207538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 207541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207549 */     GIR_RootConstrainSelectedInstOperands,
     /* 207550 */     // GIR_Coverage, 11584,
     /* 207550 */     GIR_EraseRootFromParent_Done,
     /* 207551 */   // Label 4135: @207551
     /* 207551 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(207598), // Rule ID 11589 //
     /* 207556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 207564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207577 */     // MIs[0] Op3
     /* 207577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 207585 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 207585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 207588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207596 */     GIR_RootConstrainSelectedInstOperands,
     /* 207597 */     // GIR_Coverage, 11589,
     /* 207597 */     GIR_EraseRootFromParent_Done,
     /* 207598 */   // Label 4136: @207598
     /* 207598 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(207645), // Rule ID 11590 //
     /* 207603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 207611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207624 */     // MIs[0] Op3
     /* 207624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 207632 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 207632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 207635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207643 */     GIR_RootConstrainSelectedInstOperands,
     /* 207644 */     // GIR_Coverage, 11590,
     /* 207644 */     GIR_EraseRootFromParent_Done,
     /* 207645 */   // Label 4137: @207645
     /* 207645 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(207692), // Rule ID 11591 //
     /* 207650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 207658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207671 */     // MIs[0] Op3
     /* 207671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 207679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 207679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 207682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207690 */     GIR_RootConstrainSelectedInstOperands,
     /* 207691 */     // GIR_Coverage, 11591,
     /* 207691 */     GIR_EraseRootFromParent_Done,
     /* 207692 */   // Label 4138: @207692
     /* 207692 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(207739), // Rule ID 11592 //
     /* 207697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 207705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207718 */     // MIs[0] Op3
     /* 207718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 207726 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 207726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 207729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207737 */     GIR_RootConstrainSelectedInstOperands,
     /* 207738 */     // GIR_Coverage, 11592,
     /* 207738 */     GIR_EraseRootFromParent_Done,
     /* 207739 */   // Label 4139: @207739
     /* 207739 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(207786), // Rule ID 11652 //
     /* 207744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 207752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207765 */     // MIs[0] Op3
     /* 207765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 207773 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1746:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 207773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 207776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207784 */     GIR_RootConstrainSelectedInstOperands,
     /* 207785 */     // GIR_Coverage, 11652,
     /* 207785 */     GIR_EraseRootFromParent_Done,
     /* 207786 */   // Label 4140: @207786
     /* 207786 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(207833), // Rule ID 11653 //
     /* 207791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 207799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207812 */     // MIs[0] Op3
     /* 207812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207815 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 207820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 207820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 207823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207831 */     GIR_RootConstrainSelectedInstOperands,
     /* 207832 */     // GIR_Coverage, 11653,
     /* 207832 */     GIR_EraseRootFromParent_Done,
     /* 207833 */   // Label 4141: @207833
     /* 207833 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(207880), // Rule ID 11654 //
     /* 207838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 207846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207859 */     // MIs[0] Op3
     /* 207859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 207867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 207867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 207870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207878 */     GIR_RootConstrainSelectedInstOperands,
     /* 207879 */     // GIR_Coverage, 11654,
     /* 207879 */     GIR_EraseRootFromParent_Done,
     /* 207880 */   // Label 4142: @207880
     /* 207880 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(207927), // Rule ID 11655 //
     /* 207885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 207893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207906 */     // MIs[0] Op3
     /* 207906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 207914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1625:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 207914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 207917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207925 */     GIR_RootConstrainSelectedInstOperands,
     /* 207926 */     // GIR_Coverage, 11655,
     /* 207926 */     GIR_EraseRootFromParent_Done,
     /* 207927 */   // Label 4143: @207927
     /* 207927 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(207974), // Rule ID 11656 //
     /* 207932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 207940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207953 */     // MIs[0] Op3
     /* 207953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 207961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1625:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 207961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 207964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207972 */     GIR_RootConstrainSelectedInstOperands,
     /* 207973 */     // GIR_Coverage, 11656,
     /* 207973 */     GIR_EraseRootFromParent_Done,
     /* 207974 */   // Label 4144: @207974
     /* 207974 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(208021), // Rule ID 11657 //
     /* 207979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 207987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208000 */     // MIs[0] Op3
     /* 208000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208008 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1625:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 208011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208019 */     GIR_RootConstrainSelectedInstOperands,
     /* 208020 */     // GIR_Coverage, 11657,
     /* 208020 */     GIR_EraseRootFromParent_Done,
     /* 208021 */   // Label 4145: @208021
     /* 208021 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(208068), // Rule ID 11658 //
     /* 208026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 208034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208047 */     // MIs[0] Op3
     /* 208047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208055 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1583:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 208058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208066 */     GIR_RootConstrainSelectedInstOperands,
     /* 208067 */     // GIR_Coverage, 11658,
     /* 208067 */     GIR_EraseRootFromParent_Done,
     /* 208068 */   // Label 4146: @208068
     /* 208068 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(208115), // Rule ID 11659 //
     /* 208073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 208081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208094 */     // MIs[0] Op3
     /* 208094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1583:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 208105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208113 */     GIR_RootConstrainSelectedInstOperands,
     /* 208114 */     // GIR_Coverage, 11659,
     /* 208114 */     GIR_EraseRootFromParent_Done,
     /* 208115 */   // Label 4147: @208115
     /* 208115 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(208162), // Rule ID 11660 //
     /* 208120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 208128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208141 */     // MIs[0] Op3
     /* 208141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208149 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1583:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 208152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208160 */     GIR_RootConstrainSelectedInstOperands,
     /* 208161 */     // GIR_Coverage, 11660,
     /* 208161 */     GIR_EraseRootFromParent_Done,
     /* 208162 */   // Label 4148: @208162
     /* 208162 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(208209), // Rule ID 11661 //
     /* 208167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 208175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208188 */     // MIs[0] Op3
     /* 208188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1750:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 208199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208207 */     GIR_RootConstrainSelectedInstOperands,
     /* 208208 */     // GIR_Coverage, 11661,
     /* 208208 */     GIR_EraseRootFromParent_Done,
     /* 208209 */   // Label 4149: @208209
     /* 208209 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(208256), // Rule ID 11662 //
     /* 208214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 208222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208235 */     // MIs[0] Op3
     /* 208235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 208246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208254 */     GIR_RootConstrainSelectedInstOperands,
     /* 208255 */     // GIR_Coverage, 11662,
     /* 208255 */     GIR_EraseRootFromParent_Done,
     /* 208256 */   // Label 4150: @208256
     /* 208256 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(208303), // Rule ID 11663 //
     /* 208261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 208269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208282 */     // MIs[0] Op3
     /* 208282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 208293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208301 */     GIR_RootConstrainSelectedInstOperands,
     /* 208302 */     // GIR_Coverage, 11663,
     /* 208302 */     GIR_EraseRootFromParent_Done,
     /* 208303 */   // Label 4151: @208303
     /* 208303 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(208350), // Rule ID 11664 //
     /* 208308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 208316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208329 */     // MIs[0] Op3
     /* 208329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208337 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 208340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208348 */     GIR_RootConstrainSelectedInstOperands,
     /* 208349 */     // GIR_Coverage, 11664,
     /* 208349 */     GIR_EraseRootFromParent_Done,
     /* 208350 */   // Label 4152: @208350
     /* 208350 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(208397), // Rule ID 11665 //
     /* 208355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 208363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208376 */     // MIs[0] Op3
     /* 208376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 208387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208395 */     GIR_RootConstrainSelectedInstOperands,
     /* 208396 */     // GIR_Coverage, 11665,
     /* 208396 */     GIR_EraseRootFromParent_Done,
     /* 208397 */   // Label 4153: @208397
     /* 208397 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(208444), // Rule ID 11666 //
     /* 208402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 208410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208423 */     // MIs[0] Op3
     /* 208423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 208434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208442 */     GIR_RootConstrainSelectedInstOperands,
     /* 208443 */     // GIR_Coverage, 11666,
     /* 208443 */     GIR_EraseRootFromParent_Done,
     /* 208444 */   // Label 4154: @208444
     /* 208444 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(208491), // Rule ID 11667 //
     /* 208449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 208457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208470 */     // MIs[0] Op3
     /* 208470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208478 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 208481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208489 */     GIR_RootConstrainSelectedInstOperands,
     /* 208490 */     // GIR_Coverage, 11667,
     /* 208490 */     GIR_EraseRootFromParent_Done,
     /* 208491 */   // Label 4155: @208491
     /* 208491 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(208538), // Rule ID 11668 //
     /* 208496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 208504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208517 */     // MIs[0] Op3
     /* 208517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 208528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208536 */     GIR_RootConstrainSelectedInstOperands,
     /* 208537 */     // GIR_Coverage, 11668,
     /* 208537 */     GIR_EraseRootFromParent_Done,
     /* 208538 */   // Label 4156: @208538
     /* 208538 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(208585), // Rule ID 11669 //
     /* 208543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 208551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208564 */     // MIs[0] Op3
     /* 208564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 208575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208583 */     GIR_RootConstrainSelectedInstOperands,
     /* 208584 */     // GIR_Coverage, 11669,
     /* 208584 */     GIR_EraseRootFromParent_Done,
     /* 208585 */   // Label 4157: @208585
     /* 208585 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(208632), // Rule ID 11670 //
     /* 208590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 208598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208611 */     // MIs[0] Op3
     /* 208611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208619 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1942:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 208622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208630 */     GIR_RootConstrainSelectedInstOperands,
     /* 208631 */     // GIR_Coverage, 11670,
     /* 208631 */     GIR_EraseRootFromParent_Done,
     /* 208632 */   // Label 4158: @208632
     /* 208632 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(208679), // Rule ID 11671 //
     /* 208637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 208645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208658 */     // MIs[0] Op3
     /* 208658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208666 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 208669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208677 */     GIR_RootConstrainSelectedInstOperands,
     /* 208678 */     // GIR_Coverage, 11671,
     /* 208678 */     GIR_EraseRootFromParent_Done,
     /* 208679 */   // Label 4159: @208679
     /* 208679 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(208726), // Rule ID 11672 //
     /* 208684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 208692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208705 */     // MIs[0] Op3
     /* 208705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 208716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208724 */     GIR_RootConstrainSelectedInstOperands,
     /* 208725 */     // GIR_Coverage, 11672,
     /* 208725 */     GIR_EraseRootFromParent_Done,
     /* 208726 */   // Label 4160: @208726
     /* 208726 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(208793), // Rule ID 2595 //
     /* 208731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 208739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 208763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 208768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 208782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 208789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 208791 */     GIR_RootConstrainSelectedInstOperands,
     /* 208792 */     // GIR_Coverage, 2595,
     /* 208792 */     GIR_EraseRootFromParent_Done,
     /* 208793 */   // Label 4161: @208793
     /* 208793 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(208860), // Rule ID 7603 //
     /* 208798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 208806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 208815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 208818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 208830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208832 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 208835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 208849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 208856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 208858 */     GIR_RootConstrainSelectedInstOperands,
     /* 208859 */     // GIR_Coverage, 7603,
     /* 208859 */     GIR_EraseRootFromParent_Done,
     /* 208860 */   // Label 4162: @208860
     /* 208860 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(208927), // Rule ID 7605 //
     /* 208865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 208873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 208897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208899 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 208902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 208916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 208923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 208925 */     GIR_RootConstrainSelectedInstOperands,
     /* 208926 */     // GIR_Coverage, 7605,
     /* 208926 */     GIR_EraseRootFromParent_Done,
     /* 208927 */   // Label 4163: @208927
     /* 208927 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(208994), // Rule ID 7607 //
     /* 208932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 208940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 208964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 208969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 208983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 208990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 208992 */     GIR_RootConstrainSelectedInstOperands,
     /* 208993 */     // GIR_Coverage, 7607,
     /* 208993 */     GIR_EraseRootFromParent_Done,
     /* 208994 */   // Label 4164: @208994
     /* 208994 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(209061), // Rule ID 7609 //
     /* 208999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 209007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 209016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209033 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 209050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209059 */     GIR_RootConstrainSelectedInstOperands,
     /* 209060 */     // GIR_Coverage, 7609,
     /* 209060 */     GIR_EraseRootFromParent_Done,
     /* 209061 */   // Label 4165: @209061
     /* 209061 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(209128), // Rule ID 7639 //
     /* 209066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 209074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 209083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 209086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 209117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209126 */     GIR_RootConstrainSelectedInstOperands,
     /* 209127 */     // GIR_Coverage, 7639,
     /* 209127 */     GIR_EraseRootFromParent_Done,
     /* 209128 */   // Label 4166: @209128
     /* 209128 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(209195), // Rule ID 7641 //
     /* 209133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 209141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 209150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 209184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209193 */     GIR_RootConstrainSelectedInstOperands,
     /* 209194 */     // GIR_Coverage, 7641,
     /* 209194 */     GIR_EraseRootFromParent_Done,
     /* 209195 */   // Label 4167: @209195
     /* 209195 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(209262), // Rule ID 7643 //
     /* 209200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 209208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 209217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 209251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209260 */     GIR_RootConstrainSelectedInstOperands,
     /* 209261 */     // GIR_Coverage, 7643,
     /* 209261 */     GIR_EraseRootFromParent_Done,
     /* 209262 */   // Label 4168: @209262
     /* 209262 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(209329), // Rule ID 7645 //
     /* 209267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 209275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 209284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209301 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 209318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209327 */     GIR_RootConstrainSelectedInstOperands,
     /* 209328 */     // GIR_Coverage, 7645,
     /* 209328 */     GIR_EraseRootFromParent_Done,
     /* 209329 */   // Label 4169: @209329
     /* 209329 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(209396), // Rule ID 7651 //
     /* 209334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 209342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 209351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 209354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 209385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209394 */     GIR_RootConstrainSelectedInstOperands,
     /* 209395 */     // GIR_Coverage, 7651,
     /* 209395 */     GIR_EraseRootFromParent_Done,
     /* 209396 */   // Label 4170: @209396
     /* 209396 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(209463), // Rule ID 7653 //
     /* 209401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 209409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 209418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209435 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 209452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209461 */     GIR_RootConstrainSelectedInstOperands,
     /* 209462 */     // GIR_Coverage, 7653,
     /* 209462 */     GIR_EraseRootFromParent_Done,
     /* 209463 */   // Label 4171: @209463
     /* 209463 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(209530), // Rule ID 7655 //
     /* 209468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 209476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 209485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 209519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209528 */     GIR_RootConstrainSelectedInstOperands,
     /* 209529 */     // GIR_Coverage, 7655,
     /* 209529 */     GIR_EraseRootFromParent_Done,
     /* 209530 */   // Label 4172: @209530
     /* 209530 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(209597), // Rule ID 7657 //
     /* 209535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 209543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 209552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209569 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 209586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209595 */     GIR_RootConstrainSelectedInstOperands,
     /* 209596 */     // GIR_Coverage, 7657,
     /* 209596 */     GIR_EraseRootFromParent_Done,
     /* 209597 */   // Label 4173: @209597
     /* 209597 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(209664), // Rule ID 11365 //
     /* 209602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 209610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 209619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 209653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209662 */     GIR_RootConstrainSelectedInstOperands,
     /* 209663 */     // GIR_Coverage, 11365,
     /* 209663 */     GIR_EraseRootFromParent_Done,
     /* 209664 */   // Label 4174: @209664
     /* 209664 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(209731), // Rule ID 11367 //
     /* 209669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 209677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 209686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 209689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209703 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 209720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209729 */     GIR_RootConstrainSelectedInstOperands,
     /* 209730 */     // GIR_Coverage, 11367,
     /* 209730 */     GIR_EraseRootFromParent_Done,
     /* 209731 */   // Label 4175: @209731
     /* 209731 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(209798), // Rule ID 11369 //
     /* 209736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 209744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 209753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 209756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 209787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209796 */     GIR_RootConstrainSelectedInstOperands,
     /* 209797 */     // GIR_Coverage, 11369,
     /* 209797 */     GIR_EraseRootFromParent_Done,
     /* 209798 */   // Label 4176: @209798
     /* 209798 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(209865), // Rule ID 11371 //
     /* 209803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 209811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 209820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 209823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209837 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 209854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209863 */     GIR_RootConstrainSelectedInstOperands,
     /* 209864 */     // GIR_Coverage, 11371,
     /* 209864 */     GIR_EraseRootFromParent_Done,
     /* 209865 */   // Label 4177: @209865
     /* 209865 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(209932), // Rule ID 11373 //
     /* 209870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 209878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 209887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 209890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 209921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209930 */     GIR_RootConstrainSelectedInstOperands,
     /* 209931 */     // GIR_Coverage, 11373,
     /* 209931 */     GIR_EraseRootFromParent_Done,
     /* 209932 */   // Label 4178: @209932
     /* 209932 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(209999), // Rule ID 11379 //
     /* 209937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 209945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 209954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 209957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 209969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 209974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 209978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 209988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 209995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 209997 */     GIR_RootConstrainSelectedInstOperands,
     /* 209998 */     // GIR_Coverage, 11379,
     /* 209998 */     GIR_EraseRootFromParent_Done,
     /* 209999 */   // Label 4179: @209999
     /* 209999 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(210066), // Rule ID 11381 //
     /* 210004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 210012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 210021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 210024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 210036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 210041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 210045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 210050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 210052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 210055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 210060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 210062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 210064 */     GIR_RootConstrainSelectedInstOperands,
     /* 210065 */     // GIR_Coverage, 11381,
     /* 210065 */     GIR_EraseRootFromParent_Done,
     /* 210066 */   // Label 4180: @210066
     /* 210066 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(210133), // Rule ID 11383 //
     /* 210071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 210079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 210088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 210091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 210103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 210108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 210112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 210117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 210119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 210122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 210127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 210129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 210131 */     GIR_RootConstrainSelectedInstOperands,
     /* 210132 */     // GIR_Coverage, 11383,
     /* 210132 */     GIR_EraseRootFromParent_Done,
     /* 210133 */   // Label 4181: @210133
     /* 210133 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(210200), // Rule ID 11385 //
     /* 210138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 210146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 210155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 210158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 210170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 210175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 210179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 210184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 210186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 210189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 210194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 210196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 210198 */     GIR_RootConstrainSelectedInstOperands,
     /* 210199 */     // GIR_Coverage, 11385,
     /* 210199 */     GIR_EraseRootFromParent_Done,
     /* 210200 */   // Label 4182: @210200
     /* 210200 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(210254), // Rule ID 30 //
     /* 210205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 210208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 210213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 210222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 210225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210241 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 210241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 210244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210252 */     GIR_RootConstrainSelectedInstOperands,
     /* 210253 */     // GIR_Coverage, 30,
     /* 210253 */     GIR_EraseRootFromParent_Done,
     /* 210254 */   // Label 4183: @210254
     /* 210254 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(210308), // Rule ID 31 //
     /* 210259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 210262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 210267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 210276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 210279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210295 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 210295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 210298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210306 */     GIR_RootConstrainSelectedInstOperands,
     /* 210307 */     // GIR_Coverage, 31,
     /* 210307 */     GIR_EraseRootFromParent_Done,
     /* 210308 */   // Label 4184: @210308
     /* 210308 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(210362), // Rule ID 32 //
     /* 210313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 210316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 210321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 210330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 210333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210349 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 210349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 210352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210360 */     GIR_RootConstrainSelectedInstOperands,
     /* 210361 */     // GIR_Coverage, 32,
     /* 210361 */     GIR_EraseRootFromParent_Done,
     /* 210362 */   // Label 4185: @210362
     /* 210362 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(210416), // Rule ID 39 //
     /* 210367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 210370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 210375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 210378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 210381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210403 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 210403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 210406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210414 */     GIR_RootConstrainSelectedInstOperands,
     /* 210415 */     // GIR_Coverage, 39,
     /* 210415 */     GIR_EraseRootFromParent_Done,
     /* 210416 */   // Label 4186: @210416
     /* 210416 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(210470), // Rule ID 40 //
     /* 210421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 210424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 210429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210457 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 210457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 210460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210468 */     GIR_RootConstrainSelectedInstOperands,
     /* 210469 */     // GIR_Coverage, 40,
     /* 210469 */     GIR_EraseRootFromParent_Done,
     /* 210470 */   // Label 4187: @210470
     /* 210470 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(210524), // Rule ID 41 //
     /* 210475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 210478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 210483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 210486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 210489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210511 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 210511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 210514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210522 */     GIR_RootConstrainSelectedInstOperands,
     /* 210523 */     // GIR_Coverage, 41,
     /* 210523 */     GIR_EraseRootFromParent_Done,
     /* 210524 */   // Label 4188: @210524
     /* 210524 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(210578), // Rule ID 42 //
     /* 210529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 210532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 210537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210565 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 210565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 210568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210576 */     GIR_RootConstrainSelectedInstOperands,
     /* 210577 */     // GIR_Coverage, 42,
     /* 210577 */     GIR_EraseRootFromParent_Done,
     /* 210578 */   // Label 4189: @210578
     /* 210578 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(210632), // Rule ID 43 //
     /* 210583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 210586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 210591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 210594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 210597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210619 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 210619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 210622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210630 */     GIR_RootConstrainSelectedInstOperands,
     /* 210631 */     // GIR_Coverage, 43,
     /* 210631 */     GIR_EraseRootFromParent_Done,
     /* 210632 */   // Label 4190: @210632
     /* 210632 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(210686), // Rule ID 44 //
     /* 210637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 210640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 210645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210673 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 210673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 210676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210684 */     GIR_RootConstrainSelectedInstOperands,
     /* 210685 */     // GIR_Coverage, 44,
     /* 210685 */     GIR_EraseRootFromParent_Done,
     /* 210686 */   // Label 4191: @210686
     /* 210686 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(210740), // Rule ID 45 //
     /* 210691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 210694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 210699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 210702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 210705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210727 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 210727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 210730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210738 */     GIR_RootConstrainSelectedInstOperands,
     /* 210739 */     // GIR_Coverage, 45,
     /* 210739 */     GIR_EraseRootFromParent_Done,
     /* 210740 */   // Label 4192: @210740
     /* 210740 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(210794), // Rule ID 46 //
     /* 210745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 210748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 210753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210781 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 210781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 210784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210792 */     GIR_RootConstrainSelectedInstOperands,
     /* 210793 */     // GIR_Coverage, 46,
     /* 210793 */     GIR_EraseRootFromParent_Done,
     /* 210794 */   // Label 4193: @210794
     /* 210794 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(210848), // Rule ID 1580 //
     /* 210799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 210802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 210807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210835 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 210835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 210838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210846 */     GIR_RootConstrainSelectedInstOperands,
     /* 210847 */     // GIR_Coverage, 1580,
     /* 210847 */     GIR_EraseRootFromParent_Done,
     /* 210848 */   // Label 4194: @210848
     /* 210848 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(210902), // Rule ID 1581 //
     /* 210853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 210856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 210861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210889 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 210889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 210892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210900 */     GIR_RootConstrainSelectedInstOperands,
     /* 210901 */     // GIR_Coverage, 1581,
     /* 210901 */     GIR_EraseRootFromParent_Done,
     /* 210902 */   // Label 4195: @210902
     /* 210902 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(210956), // Rule ID 1582 //
     /* 210907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 210910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 210915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 210918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 210921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 210924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 210927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210943 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 210943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 210946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210954 */     GIR_RootConstrainSelectedInstOperands,
     /* 210955 */     // GIR_Coverage, 1582,
     /* 210955 */     GIR_EraseRootFromParent_Done,
     /* 210956 */   // Label 4196: @210956
     /* 210956 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(211010), // Rule ID 1583 //
     /* 210961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 210964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 210969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210997 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 210997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 211000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211008 */     GIR_RootConstrainSelectedInstOperands,
     /* 211009 */     // GIR_Coverage, 1583,
     /* 211009 */     GIR_EraseRootFromParent_Done,
     /* 211010 */   // Label 4197: @211010
     /* 211010 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(211064), // Rule ID 1584 //
     /* 211015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 211018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 211023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 211026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 211029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 211032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 211035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211051 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 211051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 211054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211062 */     GIR_RootConstrainSelectedInstOperands,
     /* 211063 */     // GIR_Coverage, 1584,
     /* 211063 */     GIR_EraseRootFromParent_Done,
     /* 211064 */   // Label 4198: @211064
     /* 211064 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(211118), // Rule ID 1585 //
     /* 211069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 211072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 211077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 211083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 211086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 211089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211105 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 211105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 211108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211116 */     GIR_RootConstrainSelectedInstOperands,
     /* 211117 */     // GIR_Coverage, 1585,
     /* 211117 */     GIR_EraseRootFromParent_Done,
     /* 211118 */   // Label 4199: @211118
     /* 211118 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(211172), // Rule ID 1586 //
     /* 211123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 211126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 211131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211159 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 211159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 211162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211170 */     GIR_RootConstrainSelectedInstOperands,
     /* 211171 */     // GIR_Coverage, 1586,
     /* 211171 */     GIR_EraseRootFromParent_Done,
     /* 211172 */   // Label 4200: @211172
     /* 211172 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(211226), // Rule ID 1587 //
     /* 211177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 211180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 211185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211213 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 211213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 211216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211224 */     GIR_RootConstrainSelectedInstOperands,
     /* 211225 */     // GIR_Coverage, 1587,
     /* 211225 */     GIR_EraseRootFromParent_Done,
     /* 211226 */   // Label 4201: @211226
     /* 211226 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(211280), // Rule ID 2298 //
     /* 211231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 211234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 211239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211267 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 211267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 211270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211278 */     GIR_RootConstrainSelectedInstOperands,
     /* 211279 */     // GIR_Coverage, 2298,
     /* 211279 */     GIR_EraseRootFromParent_Done,
     /* 211280 */   // Label 4202: @211280
     /* 211280 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(211334), // Rule ID 2299 //
     /* 211285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 211288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 211293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211321 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 211321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 211324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211332 */     GIR_RootConstrainSelectedInstOperands,
     /* 211333 */     // GIR_Coverage, 2299,
     /* 211333 */     GIR_EraseRootFromParent_Done,
     /* 211334 */   // Label 4203: @211334
     /* 211334 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(211388), // Rule ID 2300 //
     /* 211339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 211342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 211347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211375 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 211375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 211378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211386 */     GIR_RootConstrainSelectedInstOperands,
     /* 211387 */     // GIR_Coverage, 2300,
     /* 211387 */     GIR_EraseRootFromParent_Done,
     /* 211388 */   // Label 4204: @211388
     /* 211388 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(211442), // Rule ID 2301 //
     /* 211393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 211396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 211401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211429 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 211429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 211432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211440 */     GIR_RootConstrainSelectedInstOperands,
     /* 211441 */     // GIR_Coverage, 2301,
     /* 211441 */     GIR_EraseRootFromParent_Done,
     /* 211442 */   // Label 4205: @211442
     /* 211442 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(211496), // Rule ID 2302 //
     /* 211447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 211450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 211455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211483 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 211483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 211486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211494 */     GIR_RootConstrainSelectedInstOperands,
     /* 211495 */     // GIR_Coverage, 2302,
     /* 211495 */     GIR_EraseRootFromParent_Done,
     /* 211496 */   // Label 4206: @211496
     /* 211496 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(211550), // Rule ID 2303 //
     /* 211501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 211504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 211509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211537 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 211537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 211540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211548 */     GIR_RootConstrainSelectedInstOperands,
     /* 211549 */     // GIR_Coverage, 2303,
     /* 211549 */     GIR_EraseRootFromParent_Done,
     /* 211550 */   // Label 4207: @211550
     /* 211550 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(211604), // Rule ID 2304 //
     /* 211555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 211558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 211563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211591 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 211591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 211594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211602 */     GIR_RootConstrainSelectedInstOperands,
     /* 211603 */     // GIR_Coverage, 2304,
     /* 211603 */     GIR_EraseRootFromParent_Done,
     /* 211604 */   // Label 4208: @211604
     /* 211604 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(211661), // Rule ID 3619 //
     /* 211609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 211612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 211617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 211626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 211629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 211633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 211645 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 211645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 211648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 211652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 211654 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 211656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211659 */     GIR_RootConstrainSelectedInstOperands,
     /* 211660 */     // GIR_Coverage, 3619,
     /* 211660 */     GIR_EraseRootFromParent_Done,
     /* 211661 */   // Label 4209: @211661
     /* 211661 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(211718), // Rule ID 3620 //
     /* 211666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 211669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 211674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 211683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 211686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 211690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 211702 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 211702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 211705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 211709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 211711 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 211713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211716 */     GIR_RootConstrainSelectedInstOperands,
     /* 211717 */     // GIR_Coverage, 3620,
     /* 211717 */     GIR_EraseRootFromParent_Done,
     /* 211718 */   // Label 4210: @211718
     /* 211718 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(211775), // Rule ID 3621 //
     /* 211723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 211726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 211731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 211740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 211743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 211747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 211759 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 211759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 211762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 211766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 211768 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 211770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211773 */     GIR_RootConstrainSelectedInstOperands,
     /* 211774 */     // GIR_Coverage, 3621,
     /* 211774 */     GIR_EraseRootFromParent_Done,
     /* 211775 */   // Label 4211: @211775
     /* 211775 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(211832), // Rule ID 3622 //
     /* 211780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 211783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 211788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 211797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 211800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 211804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 211816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 211816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 211819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 211823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 211825 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 211827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211830 */     GIR_RootConstrainSelectedInstOperands,
     /* 211831 */     // GIR_Coverage, 3622,
     /* 211831 */     GIR_EraseRootFromParent_Done,
     /* 211832 */   // Label 4212: @211832
     /* 211832 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(211886), // Rule ID 3769 //
     /* 211837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 211840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 211845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211873 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 211873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 211876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 211878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 211880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 211882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 211884 */     GIR_RootConstrainSelectedInstOperands,
     /* 211885 */     // GIR_Coverage, 3769,
     /* 211885 */     GIR_EraseRootFromParent_Done,
     /* 211886 */   // Label 4213: @211886
     /* 211886 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(211940), // Rule ID 3770 //
     /* 211891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 211894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 211899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211927 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 211927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 211930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 211932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 211934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 211936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 211938 */     GIR_RootConstrainSelectedInstOperands,
     /* 211939 */     // GIR_Coverage, 3770,
     /* 211939 */     GIR_EraseRootFromParent_Done,
     /* 211940 */   // Label 4214: @211940
     /* 211940 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(211994), // Rule ID 3771 //
     /* 211945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 211948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 211953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211981 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 211981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 211984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 211986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 211988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 211990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 211992 */     GIR_RootConstrainSelectedInstOperands,
     /* 211993 */     // GIR_Coverage, 3771,
     /* 211993 */     GIR_EraseRootFromParent_Done,
     /* 211994 */   // Label 4215: @211994
     /* 211994 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(212048), // Rule ID 3772 //
     /* 211999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 212007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 212013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 212016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 212019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212035 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 212035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 212038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212046 */     GIR_RootConstrainSelectedInstOperands,
     /* 212047 */     // GIR_Coverage, 3772,
     /* 212047 */     GIR_EraseRootFromParent_Done,
     /* 212048 */   // Label 4216: @212048
     /* 212048 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(212102), // Rule ID 3773 //
     /* 212053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 212061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 212067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 212070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 212073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212089 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 212089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 212092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212100 */     GIR_RootConstrainSelectedInstOperands,
     /* 212101 */     // GIR_Coverage, 3773,
     /* 212101 */     GIR_EraseRootFromParent_Done,
     /* 212102 */   // Label 4217: @212102
     /* 212102 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(212156), // Rule ID 3774 //
     /* 212107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 212115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 212124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 212127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212143 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 212143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 212146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212154 */     GIR_RootConstrainSelectedInstOperands,
     /* 212155 */     // GIR_Coverage, 3774,
     /* 212155 */     GIR_EraseRootFromParent_Done,
     /* 212156 */   // Label 4218: @212156
     /* 212156 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(212210), // Rule ID 3775 //
     /* 212161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 212169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 212178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 212181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212197 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 212197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 212200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212208 */     GIR_RootConstrainSelectedInstOperands,
     /* 212209 */     // GIR_Coverage, 3775,
     /* 212209 */     GIR_EraseRootFromParent_Done,
     /* 212210 */   // Label 4219: @212210
     /* 212210 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(212264), // Rule ID 3784 //
     /* 212215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 212223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 212229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 212232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 212235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212251 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 212251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 212254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212262 */     GIR_RootConstrainSelectedInstOperands,
     /* 212263 */     // GIR_Coverage, 3784,
     /* 212263 */     GIR_EraseRootFromParent_Done,
     /* 212264 */   // Label 4220: @212264
     /* 212264 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(212318), // Rule ID 3785 //
     /* 212269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 212277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 212283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 212286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 212289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212305 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 212305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 212308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212316 */     GIR_RootConstrainSelectedInstOperands,
     /* 212317 */     // GIR_Coverage, 3785,
     /* 212317 */     GIR_EraseRootFromParent_Done,
     /* 212318 */   // Label 4221: @212318
     /* 212318 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(212372), // Rule ID 3786 //
     /* 212323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 212331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 212340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 212343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212359 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 212359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 212362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212370 */     GIR_RootConstrainSelectedInstOperands,
     /* 212371 */     // GIR_Coverage, 3786,
     /* 212371 */     GIR_EraseRootFromParent_Done,
     /* 212372 */   // Label 4222: @212372
     /* 212372 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(212426), // Rule ID 3787 //
     /* 212377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 212385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 212394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 212397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212413 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 212413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 212416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212424 */     GIR_RootConstrainSelectedInstOperands,
     /* 212425 */     // GIR_Coverage, 3787,
     /* 212425 */     GIR_EraseRootFromParent_Done,
     /* 212426 */   // Label 4223: @212426
     /* 212426 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(212480), // Rule ID 3788 //
     /* 212431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 212439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 212445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 212448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 212451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212467 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 212467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 212470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212478 */     GIR_RootConstrainSelectedInstOperands,
     /* 212479 */     // GIR_Coverage, 3788,
     /* 212479 */     GIR_EraseRootFromParent_Done,
     /* 212480 */   // Label 4224: @212480
     /* 212480 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(212534), // Rule ID 3789 //
     /* 212485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 212493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 212499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 212502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 212505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212521 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 212521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 212524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212532 */     GIR_RootConstrainSelectedInstOperands,
     /* 212533 */     // GIR_Coverage, 3789,
     /* 212533 */     GIR_EraseRootFromParent_Done,
     /* 212534 */   // Label 4225: @212534
     /* 212534 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(212588), // Rule ID 3790 //
     /* 212539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 212547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 212556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 212559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212575 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 212575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 212578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212586 */     GIR_RootConstrainSelectedInstOperands,
     /* 212587 */     // GIR_Coverage, 3790,
     /* 212587 */     GIR_EraseRootFromParent_Done,
     /* 212588 */   // Label 4226: @212588
     /* 212588 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(212642), // Rule ID 3791 //
     /* 212593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 212601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 212610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 212613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212629 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 212629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 212632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212640 */     GIR_RootConstrainSelectedInstOperands,
     /* 212641 */     // GIR_Coverage, 3791,
     /* 212641 */     GIR_EraseRootFromParent_Done,
     /* 212642 */   // Label 4227: @212642
     /* 212642 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(212696), // Rule ID 3792 //
     /* 212647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 212655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 212661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 212664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 212667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212683 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 212683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 212686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212694 */     GIR_RootConstrainSelectedInstOperands,
     /* 212695 */     // GIR_Coverage, 3792,
     /* 212695 */     GIR_EraseRootFromParent_Done,
     /* 212696 */   // Label 4228: @212696
     /* 212696 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(212750), // Rule ID 3793 //
     /* 212701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 212709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 212715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 212718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 212721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212737 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 212737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 212740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212748 */     GIR_RootConstrainSelectedInstOperands,
     /* 212749 */     // GIR_Coverage, 3793,
     /* 212749 */     GIR_EraseRootFromParent_Done,
     /* 212750 */   // Label 4229: @212750
     /* 212750 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(212804), // Rule ID 3794 //
     /* 212755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 212763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 212772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 212775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212791 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 212791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 212794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212802 */     GIR_RootConstrainSelectedInstOperands,
     /* 212803 */     // GIR_Coverage, 3794,
     /* 212803 */     GIR_EraseRootFromParent_Done,
     /* 212804 */   // Label 4230: @212804
     /* 212804 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(212858), // Rule ID 3795 //
     /* 212809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 212812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 212817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 212826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 212829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212845 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 212845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 212848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212856 */     GIR_RootConstrainSelectedInstOperands,
     /* 212857 */     // GIR_Coverage, 3795,
     /* 212857 */     GIR_EraseRootFromParent_Done,
     /* 212858 */   // Label 4231: @212858
     /* 212858 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(212912), // Rule ID 3799 //
     /* 212863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 212866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 212871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 212880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 212883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212899 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 212899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 212902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 212906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 212908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 212910 */     GIR_RootConstrainSelectedInstOperands,
     /* 212911 */     // GIR_Coverage, 3799,
     /* 212911 */     GIR_EraseRootFromParent_Done,
     /* 212912 */   // Label 4232: @212912
     /* 212912 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(212966), // Rule ID 3800 //
     /* 212917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 212920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 212925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 212934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 212937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212953 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 212953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 212956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 212958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 212960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 212962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 212964 */     GIR_RootConstrainSelectedInstOperands,
     /* 212965 */     // GIR_Coverage, 3800,
     /* 212965 */     GIR_EraseRootFromParent_Done,
     /* 212966 */   // Label 4233: @212966
     /* 212966 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(213020), // Rule ID 3801 //
     /* 212971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 212974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 212979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 212988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 212991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213007 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 213007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 213010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 213012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 213014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 213016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 213018 */     GIR_RootConstrainSelectedInstOperands,
     /* 213019 */     // GIR_Coverage, 3801,
     /* 213019 */     GIR_EraseRootFromParent_Done,
     /* 213020 */   // Label 4234: @213020
     /* 213020 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(213077), // Rule ID 3818 //
     /* 213025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 213028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 213033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 213036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 213039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213061 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 213061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 213064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213075 */     GIR_RootConstrainSelectedInstOperands,
     /* 213076 */     // GIR_Coverage, 3818,
     /* 213076 */     GIR_EraseRootFromParent_Done,
     /* 213077 */   // Label 4235: @213077
     /* 213077 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(213134), // Rule ID 3819 //
     /* 213082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 213085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 213090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 213093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 213096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213118 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 213118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 213121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213132 */     GIR_RootConstrainSelectedInstOperands,
     /* 213133 */     // GIR_Coverage, 3819,
     /* 213133 */     GIR_EraseRootFromParent_Done,
     /* 213134 */   // Label 4236: @213134
     /* 213134 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(213191), // Rule ID 3820 //
     /* 213139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 213142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 213147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 213150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 213153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213175 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 213175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 213178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 213189 */     GIR_RootConstrainSelectedInstOperands,
     /* 213190 */     // GIR_Coverage, 3820,
     /* 213190 */     GIR_EraseRootFromParent_Done,
     /* 213191 */   // Label 4237: @213191
     /* 213191 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(213248), // Rule ID 3821 //
     /* 213196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 213199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 213204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 213207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 213210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213232 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 213232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 213235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 213246 */     GIR_RootConstrainSelectedInstOperands,
     /* 213247 */     // GIR_Coverage, 3821,
     /* 213247 */     GIR_EraseRootFromParent_Done,
     /* 213248 */   // Label 4238: @213248
     /* 213248 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(213305), // Rule ID 3826 //
     /* 213253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 213256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 213261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213289 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 213289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 213292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213303 */     GIR_RootConstrainSelectedInstOperands,
     /* 213304 */     // GIR_Coverage, 3826,
     /* 213304 */     GIR_EraseRootFromParent_Done,
     /* 213305 */   // Label 4239: @213305
     /* 213305 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(213362), // Rule ID 3827 //
     /* 213310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 213313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 213318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213346 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 213346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 213349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213360 */     GIR_RootConstrainSelectedInstOperands,
     /* 213361 */     // GIR_Coverage, 3827,
     /* 213361 */     GIR_EraseRootFromParent_Done,
     /* 213362 */   // Label 4240: @213362
     /* 213362 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(213419), // Rule ID 3828 //
     /* 213367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 213370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 213375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213403 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 213403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 213406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 213417 */     GIR_RootConstrainSelectedInstOperands,
     /* 213418 */     // GIR_Coverage, 3828,
     /* 213418 */     GIR_EraseRootFromParent_Done,
     /* 213419 */   // Label 4241: @213419
     /* 213419 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(213476), // Rule ID 3829 //
     /* 213424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 213427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 213432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213460 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 213460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 213463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 213474 */     GIR_RootConstrainSelectedInstOperands,
     /* 213475 */     // GIR_Coverage, 3829,
     /* 213475 */     GIR_EraseRootFromParent_Done,
     /* 213476 */   // Label 4242: @213476
     /* 213476 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(213533), // Rule ID 3834 //
     /* 213481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 213489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 213498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 213501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213517 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 213517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 213520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213531 */     GIR_RootConstrainSelectedInstOperands,
     /* 213532 */     // GIR_Coverage, 3834,
     /* 213532 */     GIR_EraseRootFromParent_Done,
     /* 213533 */   // Label 4243: @213533
     /* 213533 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(213590), // Rule ID 3835 //
     /* 213538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 213546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 213555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 213558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213574 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 213574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 213577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213588 */     GIR_RootConstrainSelectedInstOperands,
     /* 213589 */     // GIR_Coverage, 3835,
     /* 213589 */     GIR_EraseRootFromParent_Done,
     /* 213590 */   // Label 4244: @213590
     /* 213590 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(213647), // Rule ID 3836 //
     /* 213595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 213603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 213612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 213615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213631 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 213631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 213634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 213645 */     GIR_RootConstrainSelectedInstOperands,
     /* 213646 */     // GIR_Coverage, 3836,
     /* 213646 */     GIR_EraseRootFromParent_Done,
     /* 213647 */   // Label 4245: @213647
     /* 213647 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(213704), // Rule ID 3837 //
     /* 213652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 213660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 213669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 213672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213688 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 213688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 213691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 213702 */     GIR_RootConstrainSelectedInstOperands,
     /* 213703 */     // GIR_Coverage, 3837,
     /* 213703 */     GIR_EraseRootFromParent_Done,
     /* 213704 */   // Label 4246: @213704
     /* 213704 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(213761), // Rule ID 3838 //
     /* 213709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 213717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 213726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 213729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213745 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 213745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 213748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213759 */     GIR_RootConstrainSelectedInstOperands,
     /* 213760 */     // GIR_Coverage, 3838,
     /* 213760 */     GIR_EraseRootFromParent_Done,
     /* 213761 */   // Label 4247: @213761
     /* 213761 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(213818), // Rule ID 3839 //
     /* 213766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 213774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 213783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 213786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213802 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 213802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 213805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213816 */     GIR_RootConstrainSelectedInstOperands,
     /* 213817 */     // GIR_Coverage, 3839,
     /* 213817 */     GIR_EraseRootFromParent_Done,
     /* 213818 */   // Label 4248: @213818
     /* 213818 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(213875), // Rule ID 3840 //
     /* 213823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 213831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 213840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 213843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213859 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 213859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 213862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 213873 */     GIR_RootConstrainSelectedInstOperands,
     /* 213874 */     // GIR_Coverage, 3840,
     /* 213874 */     GIR_EraseRootFromParent_Done,
     /* 213875 */   // Label 4249: @213875
     /* 213875 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(213932), // Rule ID 3841 //
     /* 213880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 213888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 213897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 213900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213916 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 213916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 213919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 213930 */     GIR_RootConstrainSelectedInstOperands,
     /* 213931 */     // GIR_Coverage, 3841,
     /* 213931 */     GIR_EraseRootFromParent_Done,
     /* 213932 */   // Label 4250: @213932
     /* 213932 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(213989), // Rule ID 3842 //
     /* 213937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 213945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 213951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 213954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 213957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213973 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 213973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 213976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213987 */     GIR_RootConstrainSelectedInstOperands,
     /* 213988 */     // GIR_Coverage, 3842,
     /* 213988 */     GIR_EraseRootFromParent_Done,
     /* 213989 */   // Label 4251: @213989
     /* 213989 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(214046), // Rule ID 3843 //
     /* 213994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 213997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 214002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 214008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 214011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 214014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214030 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 214030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 214033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214044 */     GIR_RootConstrainSelectedInstOperands,
     /* 214045 */     // GIR_Coverage, 3843,
     /* 214045 */     GIR_EraseRootFromParent_Done,
     /* 214046 */   // Label 4252: @214046
     /* 214046 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(214103), // Rule ID 3844 //
     /* 214051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 214054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 214059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 214065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 214068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 214071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214087 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 214087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 214090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 214101 */     GIR_RootConstrainSelectedInstOperands,
     /* 214102 */     // GIR_Coverage, 3844,
     /* 214102 */     GIR_EraseRootFromParent_Done,
     /* 214103 */   // Label 4253: @214103
     /* 214103 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(214160), // Rule ID 3845 //
     /* 214108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 214111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 214116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 214122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 214125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 214128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214144 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 214144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 214147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 214158 */     GIR_RootConstrainSelectedInstOperands,
     /* 214159 */     // GIR_Coverage, 3845,
     /* 214159 */     GIR_EraseRootFromParent_Done,
     /* 214160 */   // Label 4254: @214160
     /* 214160 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(214214), // Rule ID 5180 //
     /* 214165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 214168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 214176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 214179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 214185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214201 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 214201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 214204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214212 */     GIR_RootConstrainSelectedInstOperands,
     /* 214213 */     // GIR_Coverage, 5180,
     /* 214213 */     GIR_EraseRootFromParent_Done,
     /* 214214 */   // Label 4255: @214214
     /* 214214 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(214268), // Rule ID 5181 //
     /* 214219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 214222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 214230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 214233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 214239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214255 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 214255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 214258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214266 */     GIR_RootConstrainSelectedInstOperands,
     /* 214267 */     // GIR_Coverage, 5181,
     /* 214267 */     GIR_EraseRootFromParent_Done,
     /* 214268 */   // Label 4256: @214268
     /* 214268 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(214319), // Rule ID 5527 //
     /* 214273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 214278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 214281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 214284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 214290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214306 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 214306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 214309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 214317 */     GIR_RootConstrainSelectedInstOperands,
     /* 214318 */     // GIR_Coverage, 5527,
     /* 214318 */     GIR_EraseRootFromParent_Done,
     /* 214319 */   // Label 4257: @214319
     /* 214319 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(214370), // Rule ID 5528 //
     /* 214324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 214329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 214335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 214341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214357 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 214357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 214360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 214366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 214368 */     GIR_RootConstrainSelectedInstOperands,
     /* 214369 */     // GIR_Coverage, 5528,
     /* 214369 */     GIR_EraseRootFromParent_Done,
     /* 214370 */   // Label 4258: @214370
     /* 214370 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(214412), // Rule ID 2690 //
     /* 214375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 214383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214399 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 214402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214410 */     GIR_RootConstrainSelectedInstOperands,
     /* 214411 */     // GIR_Coverage, 2690,
     /* 214411 */     GIR_EraseRootFromParent_Done,
     /* 214412 */   // Label 4259: @214412
     /* 214412 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(214454), // Rule ID 2691 //
     /* 214417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 214425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214441 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 214444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214452 */     GIR_RootConstrainSelectedInstOperands,
     /* 214453 */     // GIR_Coverage, 2691,
     /* 214453 */     GIR_EraseRootFromParent_Done,
     /* 214454 */   // Label 4260: @214454
     /* 214454 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(214496), // Rule ID 2692 //
     /* 214459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 214467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214483 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 214486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214494 */     GIR_RootConstrainSelectedInstOperands,
     /* 214495 */     // GIR_Coverage, 2692,
     /* 214495 */     GIR_EraseRootFromParent_Done,
     /* 214496 */   // Label 4261: @214496
     /* 214496 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(214538), // Rule ID 2693 //
     /* 214501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 214509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214525 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 214528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214536 */     GIR_RootConstrainSelectedInstOperands,
     /* 214537 */     // GIR_Coverage, 2693,
     /* 214537 */     GIR_EraseRootFromParent_Done,
     /* 214538 */   // Label 4262: @214538
     /* 214538 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(214580), // Rule ID 2694 //
     /* 214543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 214551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214567 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1824:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 214570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214578 */     GIR_RootConstrainSelectedInstOperands,
     /* 214579 */     // GIR_Coverage, 2694,
     /* 214579 */     GIR_EraseRootFromParent_Done,
     /* 214580 */   // Label 4263: @214580
     /* 214580 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(214622), // Rule ID 2695 //
     /* 214585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 214593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214609 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1824:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 214612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214620 */     GIR_RootConstrainSelectedInstOperands,
     /* 214621 */     // GIR_Coverage, 2695,
     /* 214621 */     GIR_EraseRootFromParent_Done,
     /* 214622 */   // Label 4264: @214622
     /* 214622 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(214664), // Rule ID 2696 //
     /* 214627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 214635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214651 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1824:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 214654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214662 */     GIR_RootConstrainSelectedInstOperands,
     /* 214663 */     // GIR_Coverage, 2696,
     /* 214663 */     GIR_EraseRootFromParent_Done,
     /* 214664 */   // Label 4265: @214664
     /* 214664 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(214706), // Rule ID 2735 //
     /* 214669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 214677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 214689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214693 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1170:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 214693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 214696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214704 */     GIR_RootConstrainSelectedInstOperands,
     /* 214705 */     // GIR_Coverage, 2735,
     /* 214705 */     GIR_EraseRootFromParent_Done,
     /* 214706 */   // Label 4266: @214706
     /* 214706 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(214748), // Rule ID 2736 //
     /* 214711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 214719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 214731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214735 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1170:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 214735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 214738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214746 */     GIR_RootConstrainSelectedInstOperands,
     /* 214747 */     // GIR_Coverage, 2736,
     /* 214747 */     GIR_EraseRootFromParent_Done,
     /* 214748 */   // Label 4267: @214748
     /* 214748 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(214790), // Rule ID 2737 //
     /* 214753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 214761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 214773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214777 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1170:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 214777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 214780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214788 */     GIR_RootConstrainSelectedInstOperands,
     /* 214789 */     // GIR_Coverage, 2737,
     /* 214789 */     GIR_EraseRootFromParent_Done,
     /* 214790 */   // Label 4268: @214790
     /* 214790 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(214832), // Rule ID 2738 //
     /* 214795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 214803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 214815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214819 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1170:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 214819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 214822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214830 */     GIR_RootConstrainSelectedInstOperands,
     /* 214831 */     // GIR_Coverage, 2738,
     /* 214831 */     GIR_EraseRootFromParent_Done,
     /* 214832 */   // Label 4269: @214832
     /* 214832 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(214874), // Rule ID 2739 //
     /* 214837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 214845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 214848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 214851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 214854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 214857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214861 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1170:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 214861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 214864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214872 */     GIR_RootConstrainSelectedInstOperands,
     /* 214873 */     // GIR_Coverage, 2739,
     /* 214873 */     GIR_EraseRootFromParent_Done,
     /* 214874 */   // Label 4270: @214874
     /* 214874 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(214916), // Rule ID 2778 //
     /* 214879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 214887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214903 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 214903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 214906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214914 */     GIR_RootConstrainSelectedInstOperands,
     /* 214915 */     // GIR_Coverage, 2778,
     /* 214915 */     GIR_EraseRootFromParent_Done,
     /* 214916 */   // Label 4271: @214916
     /* 214916 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(214958), // Rule ID 2780 //
     /* 214921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 214929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214945 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 214945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 214948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214956 */     GIR_RootConstrainSelectedInstOperands,
     /* 214957 */     // GIR_Coverage, 2780,
     /* 214957 */     GIR_EraseRootFromParent_Done,
     /* 214958 */   // Label 4272: @214958
     /* 214958 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(215000), // Rule ID 2782 //
     /* 214963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 214971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214987 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 214987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 214990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214998 */     GIR_RootConstrainSelectedInstOperands,
     /* 214999 */     // GIR_Coverage, 2782,
     /* 214999 */     GIR_EraseRootFromParent_Done,
     /* 215000 */   // Label 4273: @215000
     /* 215000 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(215042), // Rule ID 2784 //
     /* 215005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 215013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215029 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 215032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215040 */     GIR_RootConstrainSelectedInstOperands,
     /* 215041 */     // GIR_Coverage, 2784,
     /* 215041 */     GIR_EraseRootFromParent_Done,
     /* 215042 */   // Label 4274: @215042
     /* 215042 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(215084), // Rule ID 2785 //
     /* 215047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 215055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215071 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 215074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215082 */     GIR_RootConstrainSelectedInstOperands,
     /* 215083 */     // GIR_Coverage, 2785,
     /* 215083 */     GIR_EraseRootFromParent_Done,
     /* 215084 */   // Label 4275: @215084
     /* 215084 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(215126), // Rule ID 2786 //
     /* 215089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 215097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215113 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 215116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215124 */     GIR_RootConstrainSelectedInstOperands,
     /* 215125 */     // GIR_Coverage, 2786,
     /* 215125 */     GIR_EraseRootFromParent_Done,
     /* 215126 */   // Label 4276: @215126
     /* 215126 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(215168), // Rule ID 2855 //
     /* 215131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 215139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215155 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1305:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 215158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215166 */     GIR_RootConstrainSelectedInstOperands,
     /* 215167 */     // GIR_Coverage, 2855,
     /* 215167 */     GIR_EraseRootFromParent_Done,
     /* 215168 */   // Label 4277: @215168
     /* 215168 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(215210), // Rule ID 2856 //
     /* 215173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 215181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215197 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 215197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 215200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215208 */     GIR_RootConstrainSelectedInstOperands,
     /* 215209 */     // GIR_Coverage, 2856,
     /* 215209 */     GIR_EraseRootFromParent_Done,
     /* 215210 */   // Label 4278: @215210
     /* 215210 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(215252), // Rule ID 2857 //
     /* 215215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 215223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215239 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1301:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 215242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215250 */     GIR_RootConstrainSelectedInstOperands,
     /* 215251 */     // GIR_Coverage, 2857,
     /* 215251 */     GIR_EraseRootFromParent_Done,
     /* 215252 */   // Label 4279: @215252
     /* 215252 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(215294), // Rule ID 2858 //
     /* 215257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 215265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215281 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1302:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 215284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215292 */     GIR_RootConstrainSelectedInstOperands,
     /* 215293 */     // GIR_Coverage, 2858,
     /* 215293 */     GIR_EraseRootFromParent_Done,
     /* 215294 */   // Label 4280: @215294
     /* 215294 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(215336), // Rule ID 2859 //
     /* 215299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 215307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215323 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 215323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 215326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215334 */     GIR_RootConstrainSelectedInstOperands,
     /* 215335 */     // GIR_Coverage, 2859,
     /* 215335 */     GIR_EraseRootFromParent_Done,
     /* 215336 */   // Label 4281: @215336
     /* 215336 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(215378), // Rule ID 2860 //
     /* 215341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 215349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215365 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1272:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 215368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215376 */     GIR_RootConstrainSelectedInstOperands,
     /* 215377 */     // GIR_Coverage, 2860,
     /* 215377 */     GIR_EraseRootFromParent_Done,
     /* 215378 */   // Label 4282: @215378
     /* 215378 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(215420), // Rule ID 2861 //
     /* 215383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 215391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215407 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1272:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 215410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215418 */     GIR_RootConstrainSelectedInstOperands,
     /* 215419 */     // GIR_Coverage, 2861,
     /* 215419 */     GIR_EraseRootFromParent_Done,
     /* 215420 */   // Label 4283: @215420
     /* 215420 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(215462), // Rule ID 2862 //
     /* 215425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 215433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215449 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1272:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 215449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 215452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215460 */     GIR_RootConstrainSelectedInstOperands,
     /* 215461 */     // GIR_Coverage, 2862,
     /* 215461 */     GIR_EraseRootFromParent_Done,
     /* 215462 */   // Label 4284: @215462
     /* 215462 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(215504), // Rule ID 2873 //
     /* 215467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 215475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215491 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1294:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 215494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215502 */     GIR_RootConstrainSelectedInstOperands,
     /* 215503 */     // GIR_Coverage, 2873,
     /* 215503 */     GIR_EraseRootFromParent_Done,
     /* 215504 */   // Label 4285: @215504
     /* 215504 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(215546), // Rule ID 2875 //
     /* 215509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 215517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215533 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1292:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 215536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215544 */     GIR_RootConstrainSelectedInstOperands,
     /* 215545 */     // GIR_Coverage, 2875,
     /* 215545 */     GIR_EraseRootFromParent_Done,
     /* 215546 */   // Label 4286: @215546
     /* 215546 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(215588), // Rule ID 2883 //
     /* 215551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 215559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1329:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 215578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215586 */     GIR_RootConstrainSelectedInstOperands,
     /* 215587 */     // GIR_Coverage, 2883,
     /* 215587 */     GIR_EraseRootFromParent_Done,
     /* 215588 */   // Label 4287: @215588
     /* 215588 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(215630), // Rule ID 2884 //
     /* 215593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 215601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1329:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 215620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215628 */     GIR_RootConstrainSelectedInstOperands,
     /* 215629 */     // GIR_Coverage, 2884,
     /* 215629 */     GIR_EraseRootFromParent_Done,
     /* 215630 */   // Label 4288: @215630
     /* 215630 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(215672), // Rule ID 2885 //
     /* 215635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 215643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215659 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1329:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 215659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 215662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215670 */     GIR_RootConstrainSelectedInstOperands,
     /* 215671 */     // GIR_Coverage, 2885,
     /* 215671 */     GIR_EraseRootFromParent_Done,
     /* 215672 */   // Label 4289: @215672
     /* 215672 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(215714), // Rule ID 2889 //
     /* 215677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 215685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215701 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1307:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 215701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 215704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215712 */     GIR_RootConstrainSelectedInstOperands,
     /* 215713 */     // GIR_Coverage, 2889,
     /* 215713 */     GIR_EraseRootFromParent_Done,
     /* 215714 */   // Label 4290: @215714
     /* 215714 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(215756), // Rule ID 2934 //
     /* 215719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 215727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215743 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 215746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215754 */     GIR_RootConstrainSelectedInstOperands,
     /* 215755 */     // GIR_Coverage, 2934,
     /* 215755 */     GIR_EraseRootFromParent_Done,
     /* 215756 */   // Label 4291: @215756
     /* 215756 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(215798), // Rule ID 2935 //
     /* 215761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 215769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215785 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 215788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215796 */     GIR_RootConstrainSelectedInstOperands,
     /* 215797 */     // GIR_Coverage, 2935,
     /* 215797 */     GIR_EraseRootFromParent_Done,
     /* 215798 */   // Label 4292: @215798
     /* 215798 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(215840), // Rule ID 2964 //
     /* 215803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 215811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 215827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 215830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 215832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215838 */     GIR_RootConstrainSelectedInstOperands,
     /* 215839 */     // GIR_Coverage, 2964,
     /* 215839 */     GIR_EraseRootFromParent_Done,
     /* 215840 */   // Label 4293: @215840
     /* 215840 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(215882), // Rule ID 2965 //
     /* 215845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 215853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 215872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 215874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215880 */     GIR_RootConstrainSelectedInstOperands,
     /* 215881 */     // GIR_Coverage, 2965,
     /* 215881 */     GIR_EraseRootFromParent_Done,
     /* 215882 */   // Label 4294: @215882
     /* 215882 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(215924), // Rule ID 2966 //
     /* 215887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 215895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 215914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 215916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215922 */     GIR_RootConstrainSelectedInstOperands,
     /* 215923 */     // GIR_Coverage, 2966,
     /* 215923 */     GIR_EraseRootFromParent_Done,
     /* 215924 */   // Label 4295: @215924
     /* 215924 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(215966), // Rule ID 2967 //
     /* 215929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 215937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1728:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 215956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 215958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215964 */     GIR_RootConstrainSelectedInstOperands,
     /* 215965 */     // GIR_Coverage, 2967,
     /* 215965 */     GIR_EraseRootFromParent_Done,
     /* 215966 */   // Label 4296: @215966
     /* 215966 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(216008), // Rule ID 2968 //
     /* 215971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 215979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215995 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1649:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 215995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 215998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216006 */     GIR_RootConstrainSelectedInstOperands,
     /* 216007 */     // GIR_Coverage, 2968,
     /* 216007 */     GIR_EraseRootFromParent_Done,
     /* 216008 */   // Label 4297: @216008
     /* 216008 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(216050), // Rule ID 2969 //
     /* 216013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 216021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1649:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 216040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216048 */     GIR_RootConstrainSelectedInstOperands,
     /* 216049 */     // GIR_Coverage, 2969,
     /* 216049 */     GIR_EraseRootFromParent_Done,
     /* 216050 */   // Label 4298: @216050
     /* 216050 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(216092), // Rule ID 2970 //
     /* 216055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 216063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216079 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1649:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 216082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216090 */     GIR_RootConstrainSelectedInstOperands,
     /* 216091 */     // GIR_Coverage, 2970,
     /* 216091 */     GIR_EraseRootFromParent_Done,
     /* 216092 */   // Label 4299: @216092
     /* 216092 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(216134), // Rule ID 3000 //
     /* 216097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 216105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216121 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 216124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216132 */     GIR_RootConstrainSelectedInstOperands,
     /* 216133 */     // GIR_Coverage, 3000,
     /* 216133 */     GIR_EraseRootFromParent_Done,
     /* 216134 */   // Label 4300: @216134
     /* 216134 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(216176), // Rule ID 3002 //
     /* 216139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 216147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216163 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 216166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216174 */     GIR_RootConstrainSelectedInstOperands,
     /* 216175 */     // GIR_Coverage, 3002,
     /* 216175 */     GIR_EraseRootFromParent_Done,
     /* 216176 */   // Label 4301: @216176
     /* 216176 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(216218), // Rule ID 3004 //
     /* 216181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 216189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216205 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 216208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216216 */     GIR_RootConstrainSelectedInstOperands,
     /* 216217 */     // GIR_Coverage, 3004,
     /* 216217 */     GIR_EraseRootFromParent_Done,
     /* 216218 */   // Label 4302: @216218
     /* 216218 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(216260), // Rule ID 3006 //
     /* 216223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 216231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216247 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 216250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216258 */     GIR_RootConstrainSelectedInstOperands,
     /* 216259 */     // GIR_Coverage, 3006,
     /* 216259 */     GIR_EraseRootFromParent_Done,
     /* 216260 */   // Label 4303: @216260
     /* 216260 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(216302), // Rule ID 3008 //
     /* 216265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 216273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 216292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216300 */     GIR_RootConstrainSelectedInstOperands,
     /* 216301 */     // GIR_Coverage, 3008,
     /* 216301 */     GIR_EraseRootFromParent_Done,
     /* 216302 */   // Label 4304: @216302
     /* 216302 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(216344), // Rule ID 3009 //
     /* 216307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 216315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 216334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216342 */     GIR_RootConstrainSelectedInstOperands,
     /* 216343 */     // GIR_Coverage, 3009,
     /* 216343 */     GIR_EraseRootFromParent_Done,
     /* 216344 */   // Label 4305: @216344
     /* 216344 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(216386), // Rule ID 3010 //
     /* 216349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 216357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 216376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216384 */     GIR_RootConstrainSelectedInstOperands,
     /* 216385 */     // GIR_Coverage, 3010,
     /* 216385 */     GIR_EraseRootFromParent_Done,
     /* 216386 */   // Label 4306: @216386
     /* 216386 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(216428), // Rule ID 3011 //
     /* 216391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 216399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 216408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 216418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216426 */     GIR_RootConstrainSelectedInstOperands,
     /* 216427 */     // GIR_Coverage, 3011,
     /* 216427 */     GIR_EraseRootFromParent_Done,
     /* 216428 */   // Label 4307: @216428
     /* 216428 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(216470), // Rule ID 3012 //
     /* 216433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 216441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 216460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216468 */     GIR_RootConstrainSelectedInstOperands,
     /* 216469 */     // GIR_Coverage, 3012,
     /* 216469 */     GIR_EraseRootFromParent_Done,
     /* 216470 */   // Label 4308: @216470
     /* 216470 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(216512), // Rule ID 3013 //
     /* 216475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 216483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 216492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 216502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216510 */     GIR_RootConstrainSelectedInstOperands,
     /* 216511 */     // GIR_Coverage, 3013,
     /* 216511 */     GIR_EraseRootFromParent_Done,
     /* 216512 */   // Label 4309: @216512
     /* 216512 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(216554), // Rule ID 3014 //
     /* 216517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 216525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 216534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 216544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216552 */     GIR_RootConstrainSelectedInstOperands,
     /* 216553 */     // GIR_Coverage, 3014,
     /* 216553 */     GIR_EraseRootFromParent_Done,
     /* 216554 */   // Label 4310: @216554
     /* 216554 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(216596), // Rule ID 3015 //
     /* 216559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 216567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 216576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 216586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216594 */     GIR_RootConstrainSelectedInstOperands,
     /* 216595 */     // GIR_Coverage, 3015,
     /* 216595 */     GIR_EraseRootFromParent_Done,
     /* 216596 */   // Label 4311: @216596
     /* 216596 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(216638), // Rule ID 3032 //
     /* 216601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 216609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216625 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 216628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216636 */     GIR_RootConstrainSelectedInstOperands,
     /* 216637 */     // GIR_Coverage, 3032,
     /* 216637 */     GIR_EraseRootFromParent_Done,
     /* 216638 */   // Label 4312: @216638
     /* 216638 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(216680), // Rule ID 3033 //
     /* 216643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 216651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216667 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 216670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216678 */     GIR_RootConstrainSelectedInstOperands,
     /* 216679 */     // GIR_Coverage, 3033,
     /* 216679 */     GIR_EraseRootFromParent_Done,
     /* 216680 */   // Label 4313: @216680
     /* 216680 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(216722), // Rule ID 3034 //
     /* 216685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 216693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 216712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216720 */     GIR_RootConstrainSelectedInstOperands,
     /* 216721 */     // GIR_Coverage, 3034,
     /* 216721 */     GIR_EraseRootFromParent_Done,
     /* 216722 */   // Label 4314: @216722
     /* 216722 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(216764), // Rule ID 3035 //
     /* 216727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 216735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1258:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 216754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216762 */     GIR_RootConstrainSelectedInstOperands,
     /* 216763 */     // GIR_Coverage, 3035,
     /* 216763 */     GIR_EraseRootFromParent_Done,
     /* 216764 */   // Label 4315: @216764
     /* 216764 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(216806), // Rule ID 3059 //
     /* 216769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 216777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1586:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 216796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216804 */     GIR_RootConstrainSelectedInstOperands,
     /* 216805 */     // GIR_Coverage, 3059,
     /* 216805 */     GIR_EraseRootFromParent_Done,
     /* 216806 */   // Label 4316: @216806
     /* 216806 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(216848), // Rule ID 3061 //
     /* 216811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 216819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1586:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 216838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216846 */     GIR_RootConstrainSelectedInstOperands,
     /* 216847 */     // GIR_Coverage, 3061,
     /* 216847 */     GIR_EraseRootFromParent_Done,
     /* 216848 */   // Label 4317: @216848
     /* 216848 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(216890), // Rule ID 3063 //
     /* 216853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 216861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1586:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 216880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216888 */     GIR_RootConstrainSelectedInstOperands,
     /* 216889 */     // GIR_Coverage, 3063,
     /* 216889 */     GIR_EraseRootFromParent_Done,
     /* 216890 */   // Label 4318: @216890
     /* 216890 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(216932), // Rule ID 3065 //
     /* 216895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 216903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1586:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 216922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216930 */     GIR_RootConstrainSelectedInstOperands,
     /* 216931 */     // GIR_Coverage, 3065,
     /* 216931 */     GIR_EraseRootFromParent_Done,
     /* 216932 */   // Label 4319: @216932
     /* 216932 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(216974), // Rule ID 3067 //
     /* 216937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 216945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1587:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 216964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216972 */     GIR_RootConstrainSelectedInstOperands,
     /* 216973 */     // GIR_Coverage, 3067,
     /* 216973 */     GIR_EraseRootFromParent_Done,
     /* 216974 */   // Label 4320: @216974
     /* 216974 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(217016), // Rule ID 3068 //
     /* 216979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 216982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 216987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217003 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1587:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 217006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 217008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217014 */     GIR_RootConstrainSelectedInstOperands,
     /* 217015 */     // GIR_Coverage, 3068,
     /* 217015 */     GIR_EraseRootFromParent_Done,
     /* 217016 */   // Label 4321: @217016
     /* 217016 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(217058), // Rule ID 3069 //
     /* 217021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 217029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217045 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1587:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 217048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 217050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217056 */     GIR_RootConstrainSelectedInstOperands,
     /* 217057 */     // GIR_Coverage, 3069,
     /* 217057 */     GIR_EraseRootFromParent_Done,
     /* 217058 */   // Label 4322: @217058
     /* 217058 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(217100), // Rule ID 3070 //
     /* 217063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 217071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1150:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 217090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 217092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217098 */     GIR_RootConstrainSelectedInstOperands,
     /* 217099 */     // GIR_Coverage, 3070,
     /* 217099 */     GIR_EraseRootFromParent_Done,
     /* 217100 */   // Label 4323: @217100
     /* 217100 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(217142), // Rule ID 3071 //
     /* 217105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 217113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217129 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1150:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 217132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 217134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217140 */     GIR_RootConstrainSelectedInstOperands,
     /* 217141 */     // GIR_Coverage, 3071,
     /* 217141 */     GIR_EraseRootFromParent_Done,
     /* 217142 */   // Label 4324: @217142
     /* 217142 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(217184), // Rule ID 3081 //
     /* 217147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 217155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1157:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 217174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217182 */     GIR_RootConstrainSelectedInstOperands,
     /* 217183 */     // GIR_Coverage, 3081,
     /* 217183 */     GIR_EraseRootFromParent_Done,
     /* 217184 */   // Label 4325: @217184
     /* 217184 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(217226), // Rule ID 3082 //
     /* 217189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 217197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217213 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1157:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 217216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217224 */     GIR_RootConstrainSelectedInstOperands,
     /* 217225 */     // GIR_Coverage, 3082,
     /* 217225 */     GIR_EraseRootFromParent_Done,
     /* 217226 */   // Label 4326: @217226
     /* 217226 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(217268), // Rule ID 3083 //
     /* 217231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 217239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1157:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 217258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217266 */     GIR_RootConstrainSelectedInstOperands,
     /* 217267 */     // GIR_Coverage, 3083,
     /* 217267 */     GIR_EraseRootFromParent_Done,
     /* 217268 */   // Label 4327: @217268
     /* 217268 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(217310), // Rule ID 3100 //
     /* 217273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 217281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 217290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217297 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1216:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 217297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 217300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217308 */     GIR_RootConstrainSelectedInstOperands,
     /* 217309 */     // GIR_Coverage, 3100,
     /* 217309 */     GIR_EraseRootFromParent_Done,
     /* 217310 */   // Label 4328: @217310
     /* 217310 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(217352), // Rule ID 3101 //
     /* 217315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 217323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 217332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1216:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 217339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 217342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217350 */     GIR_RootConstrainSelectedInstOperands,
     /* 217351 */     // GIR_Coverage, 3101,
     /* 217351 */     GIR_EraseRootFromParent_Done,
     /* 217352 */   // Label 4329: @217352
     /* 217352 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(217394), // Rule ID 3102 //
     /* 217357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 217365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1216:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 217381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 217384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217392 */     GIR_RootConstrainSelectedInstOperands,
     /* 217393 */     // GIR_Coverage, 3102,
     /* 217393 */     GIR_EraseRootFromParent_Done,
     /* 217394 */   // Label 4330: @217394
     /* 217394 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(217436), // Rule ID 3103 //
     /* 217399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 217407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 217416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1216:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 217423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 217426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217434 */     GIR_RootConstrainSelectedInstOperands,
     /* 217435 */     // GIR_Coverage, 3103,
     /* 217435 */     GIR_EraseRootFromParent_Done,
     /* 217436 */   // Label 4331: @217436
     /* 217436 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(217478), // Rule ID 3138 //
     /* 217441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 217449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 217468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217476 */     GIR_RootConstrainSelectedInstOperands,
     /* 217477 */     // GIR_Coverage, 3138,
     /* 217477 */     GIR_EraseRootFromParent_Done,
     /* 217478 */   // Label 4332: @217478
     /* 217478 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(217520), // Rule ID 3140 //
     /* 217483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 217491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217507 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 217510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217518 */     GIR_RootConstrainSelectedInstOperands,
     /* 217519 */     // GIR_Coverage, 3140,
     /* 217519 */     GIR_EraseRootFromParent_Done,
     /* 217520 */   // Label 4333: @217520
     /* 217520 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(217562), // Rule ID 3142 //
     /* 217525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 217533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 217552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217560 */     GIR_RootConstrainSelectedInstOperands,
     /* 217561 */     // GIR_Coverage, 3142,
     /* 217561 */     GIR_EraseRootFromParent_Done,
     /* 217562 */   // Label 4334: @217562
     /* 217562 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(217604), // Rule ID 3144 //
     /* 217567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 217575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217591 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 217594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217602 */     GIR_RootConstrainSelectedInstOperands,
     /* 217603 */     // GIR_Coverage, 3144,
     /* 217603 */     GIR_EraseRootFromParent_Done,
     /* 217604 */   // Label 4335: @217604
     /* 217604 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(217649), // Rule ID 3183 //
     /* 217609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 217617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217633 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1221:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 217636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217647 */     GIR_RootConstrainSelectedInstOperands,
     /* 217648 */     // GIR_Coverage, 3183,
     /* 217648 */     GIR_EraseRootFromParent_Done,
     /* 217649 */   // Label 4336: @217649
     /* 217649 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(217694), // Rule ID 3184 //
     /* 217654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 217662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 217665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217678 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1221:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 217681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217692 */     GIR_RootConstrainSelectedInstOperands,
     /* 217693 */     // GIR_Coverage, 3184,
     /* 217693 */     GIR_EraseRootFromParent_Done,
     /* 217694 */   // Label 4337: @217694
     /* 217694 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(217739), // Rule ID 3185 //
     /* 217699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 217707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 217710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217723 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1221:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 217726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217737 */     GIR_RootConstrainSelectedInstOperands,
     /* 217738 */     // GIR_Coverage, 3185,
     /* 217738 */     GIR_EraseRootFromParent_Done,
     /* 217739 */   // Label 4338: @217739
     /* 217739 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(217784), // Rule ID 3186 //
     /* 217744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 217752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217768 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1223:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 217771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217782 */     GIR_RootConstrainSelectedInstOperands,
     /* 217783 */     // GIR_Coverage, 3186,
     /* 217783 */     GIR_EraseRootFromParent_Done,
     /* 217784 */   // Label 4339: @217784
     /* 217784 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(217829), // Rule ID 3187 //
     /* 217789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 217797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 217800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217813 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1223:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 217816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217827 */     GIR_RootConstrainSelectedInstOperands,
     /* 217828 */     // GIR_Coverage, 3187,
     /* 217828 */     GIR_EraseRootFromParent_Done,
     /* 217829 */   // Label 4340: @217829
     /* 217829 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(217874), // Rule ID 3188 //
     /* 217834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 217842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 217845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217858 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1223:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 217861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217872 */     GIR_RootConstrainSelectedInstOperands,
     /* 217873 */     // GIR_Coverage, 3188,
     /* 217873 */     GIR_EraseRootFromParent_Done,
     /* 217874 */   // Label 4341: @217874
     /* 217874 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(217916), // Rule ID 3243 //
     /* 217879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 217887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 217890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217903 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 217903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 217906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217914 */     GIR_RootConstrainSelectedInstOperands,
     /* 217915 */     // GIR_Coverage, 3243,
     /* 217915 */     GIR_EraseRootFromParent_Done,
     /* 217916 */   // Label 4342: @217916
     /* 217916 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(217958), // Rule ID 3244 //
     /* 217921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 217929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 217932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217945 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 217945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 217948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217956 */     GIR_RootConstrainSelectedInstOperands,
     /* 217957 */     // GIR_Coverage, 3244,
     /* 217957 */     GIR_EraseRootFromParent_Done,
     /* 217958 */   // Label 4343: @217958
     /* 217958 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(218000), // Rule ID 3245 //
     /* 217963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 217971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 217974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217987 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 217987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 217990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217998 */     GIR_RootConstrainSelectedInstOperands,
     /* 217999 */     // GIR_Coverage, 3245,
     /* 217999 */     GIR_EraseRootFromParent_Done,
     /* 218000 */   // Label 4344: @218000
     /* 218000 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(218042), // Rule ID 3297 //
     /* 218005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 218013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218029 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1173:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 218032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218040 */     GIR_RootConstrainSelectedInstOperands,
     /* 218041 */     // GIR_Coverage, 3297,
     /* 218041 */     GIR_EraseRootFromParent_Done,
     /* 218042 */   // Label 4345: @218042
     /* 218042 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(218084), // Rule ID 3298 //
     /* 218047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 218055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218071 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1173:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 218074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218082 */     GIR_RootConstrainSelectedInstOperands,
     /* 218083 */     // GIR_Coverage, 3298,
     /* 218083 */     GIR_EraseRootFromParent_Done,
     /* 218084 */   // Label 4346: @218084
     /* 218084 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(218126), // Rule ID 3299 //
     /* 218089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 218097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218113 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1173:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 218116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218124 */     GIR_RootConstrainSelectedInstOperands,
     /* 218125 */     // GIR_Coverage, 3299,
     /* 218125 */     GIR_EraseRootFromParent_Done,
     /* 218126 */   // Label 4347: @218126
     /* 218126 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(218168), // Rule ID 3300 //
     /* 218131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 218139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218155 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1173:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 218158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218166 */     GIR_RootConstrainSelectedInstOperands,
     /* 218167 */     // GIR_Coverage, 3300,
     /* 218167 */     GIR_EraseRootFromParent_Done,
     /* 218168 */   // Label 4348: @218168
     /* 218168 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(218210), // Rule ID 3309 //
     /* 218173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 218181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218197 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1175:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 218200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218208 */     GIR_RootConstrainSelectedInstOperands,
     /* 218209 */     // GIR_Coverage, 3309,
     /* 218209 */     GIR_EraseRootFromParent_Done,
     /* 218210 */   // Label 4349: @218210
     /* 218210 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(218252), // Rule ID 3310 //
     /* 218215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 218223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218239 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1175:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 218242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218250 */     GIR_RootConstrainSelectedInstOperands,
     /* 218251 */     // GIR_Coverage, 3310,
     /* 218251 */     GIR_EraseRootFromParent_Done,
     /* 218252 */   // Label 4350: @218252
     /* 218252 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(218294), // Rule ID 3311 //
     /* 218257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 218265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218281 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1175:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 218284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218292 */     GIR_RootConstrainSelectedInstOperands,
     /* 218293 */     // GIR_Coverage, 3311,
     /* 218293 */     GIR_EraseRootFromParent_Done,
     /* 218294 */   // Label 4351: @218294
     /* 218294 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(218336), // Rule ID 3350 //
     /* 218299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 218307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218323 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1212:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 218326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218334 */     GIR_RootConstrainSelectedInstOperands,
     /* 218335 */     // GIR_Coverage, 3350,
     /* 218335 */     GIR_EraseRootFromParent_Done,
     /* 218336 */   // Label 4352: @218336
     /* 218336 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(218378), // Rule ID 3351 //
     /* 218341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 218349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218365 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1212:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 218368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218376 */     GIR_RootConstrainSelectedInstOperands,
     /* 218377 */     // GIR_Coverage, 3351,
     /* 218377 */     GIR_EraseRootFromParent_Done,
     /* 218378 */   // Label 4353: @218378
     /* 218378 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(218420), // Rule ID 3352 //
     /* 218383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 218391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1212:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 218410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218418 */     GIR_RootConstrainSelectedInstOperands,
     /* 218419 */     // GIR_Coverage, 3352,
     /* 218419 */     GIR_EraseRootFromParent_Done,
     /* 218420 */   // Label 4354: @218420
     /* 218420 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(218462), // Rule ID 3353 //
     /* 218425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 218433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218449 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1212:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 218452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218460 */     GIR_RootConstrainSelectedInstOperands,
     /* 218461 */     // GIR_Coverage, 3353,
     /* 218461 */     GIR_EraseRootFromParent_Done,
     /* 218462 */   // Label 4355: @218462
     /* 218462 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(218504), // Rule ID 3354 //
     /* 218467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 218475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218491 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1212:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 218494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218502 */     GIR_RootConstrainSelectedInstOperands,
     /* 218503 */     // GIR_Coverage, 3354,
     /* 218503 */     GIR_EraseRootFromParent_Done,
     /* 218504 */   // Label 4356: @218504
     /* 218504 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(218546), // Rule ID 3355 //
     /* 218509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 218517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218533 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1212:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 218536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218544 */     GIR_RootConstrainSelectedInstOperands,
     /* 218545 */     // GIR_Coverage, 3355,
     /* 218545 */     GIR_EraseRootFromParent_Done,
     /* 218546 */   // Label 4357: @218546
     /* 218546 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(218588), // Rule ID 3356 //
     /* 218551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 218559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218575 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1212:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 218578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218586 */     GIR_RootConstrainSelectedInstOperands,
     /* 218587 */     // GIR_Coverage, 3356,
     /* 218587 */     GIR_EraseRootFromParent_Done,
     /* 218588 */   // Label 4358: @218588
     /* 218588 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(218630), // Rule ID 3439 //
     /* 218593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 218601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 218604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 218613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 218617 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1204:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 218617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 218620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218628 */     GIR_RootConstrainSelectedInstOperands,
     /* 218629 */     // GIR_Coverage, 3439,
     /* 218629 */     GIR_EraseRootFromParent_Done,
     /* 218630 */   // Label 4359: @218630
     /* 218630 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(218672), // Rule ID 3440 //
     /* 218635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 218643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 218646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 218655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 218659 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1203:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 218659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 218662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 218664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218670 */     GIR_RootConstrainSelectedInstOperands,
     /* 218671 */     // GIR_Coverage, 3440,
     /* 218671 */     GIR_EraseRootFromParent_Done,
     /* 218672 */   // Label 4360: @218672
     /* 218672 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(218714), // Rule ID 3441 //
     /* 218677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 218685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 218688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 218697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 218701 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1199:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 218701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 218704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218712 */     GIR_RootConstrainSelectedInstOperands,
     /* 218713 */     // GIR_Coverage, 3441,
     /* 218713 */     GIR_EraseRootFromParent_Done,
     /* 218714 */   // Label 4361: @218714
     /* 218714 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(218759), // Rule ID 3443 //
     /* 218719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 218722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 218727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 218730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 218743 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1506:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 218746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 218757 */     GIR_RootConstrainSelectedInstOperands,
     /* 218758 */     // GIR_Coverage, 3443,
     /* 218758 */     GIR_EraseRootFromParent_Done,
     /* 218759 */   // Label 4362: @218759
     /* 218759 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(218804), // Rule ID 3444 //
     /* 218764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 218767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 218772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 218775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 218788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1506:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 218791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 218802 */     GIR_RootConstrainSelectedInstOperands,
     /* 218803 */     // GIR_Coverage, 3444,
     /* 218803 */     GIR_EraseRootFromParent_Done,
     /* 218804 */   // Label 4363: @218804
     /* 218804 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(218846), // Rule ID 3445 //
     /* 218809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 218812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 218817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1451:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 218836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218844 */     GIR_RootConstrainSelectedInstOperands,
     /* 218845 */     // GIR_Coverage, 3445,
     /* 218845 */     GIR_EraseRootFromParent_Done,
     /* 218846 */   // Label 4364: @218846
     /* 218846 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(218888), // Rule ID 3446 //
     /* 218851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 218854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 218859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1451:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 218878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218886 */     GIR_RootConstrainSelectedInstOperands,
     /* 218887 */     // GIR_Coverage, 3446,
     /* 218887 */     GIR_EraseRootFromParent_Done,
     /* 218888 */   // Label 4365: @218888
     /* 218888 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(218930), // Rule ID 3451 //
     /* 218893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 218896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 218901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1657:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 218920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 218922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218928 */     GIR_RootConstrainSelectedInstOperands,
     /* 218929 */     // GIR_Coverage, 3451,
     /* 218929 */     GIR_EraseRootFromParent_Done,
     /* 218930 */   // Label 4366: @218930
     /* 218930 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(218972), // Rule ID 3490 //
     /* 218935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 218938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 218943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218959 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1280:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 218962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218970 */     GIR_RootConstrainSelectedInstOperands,
     /* 218971 */     // GIR_Coverage, 3490,
     /* 218971 */     GIR_EraseRootFromParent_Done,
     /* 218972 */   // Label 4367: @218972
     /* 218972 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(219014), // Rule ID 3492 //
     /* 218977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 218980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 218985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219001 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1280:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 219004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219012 */     GIR_RootConstrainSelectedInstOperands,
     /* 219013 */     // GIR_Coverage, 3492,
     /* 219013 */     GIR_EraseRootFromParent_Done,
     /* 219014 */   // Label 4368: @219014
     /* 219014 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(219056), // Rule ID 3494 //
     /* 219019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 219022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 219027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1280:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 219046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219054 */     GIR_RootConstrainSelectedInstOperands,
     /* 219055 */     // GIR_Coverage, 3494,
     /* 219055 */     GIR_EraseRootFromParent_Done,
     /* 219056 */   // Label 4369: @219056
     /* 219056 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(219098), // Rule ID 3496 //
     /* 219061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 219064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 219069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219085 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1618:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 219088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219096 */     GIR_RootConstrainSelectedInstOperands,
     /* 219097 */     // GIR_Coverage, 3496,
     /* 219097 */     GIR_EraseRootFromParent_Done,
     /* 219098 */   // Label 4370: @219098
     /* 219098 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(219140), // Rule ID 3611 //
     /* 219103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 219106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 219111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 219130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219138 */     GIR_RootConstrainSelectedInstOperands,
     /* 219139 */     // GIR_Coverage, 3611,
     /* 219139 */     GIR_EraseRootFromParent_Done,
     /* 219140 */   // Label 4371: @219140
     /* 219140 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(219182), // Rule ID 3613 //
     /* 219145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 219148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 219153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 219172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219180 */     GIR_RootConstrainSelectedInstOperands,
     /* 219181 */     // GIR_Coverage, 3613,
     /* 219181 */     GIR_EraseRootFromParent_Done,
     /* 219182 */   // Label 4372: @219182
     /* 219182 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(219224), // Rule ID 3615 //
     /* 219187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 219190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 219195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 219214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219222 */     GIR_RootConstrainSelectedInstOperands,
     /* 219223 */     // GIR_Coverage, 3615,
     /* 219223 */     GIR_EraseRootFromParent_Done,
     /* 219224 */   // Label 4373: @219224
     /* 219224 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(219266), // Rule ID 3617 //
     /* 219229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 219232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 219237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219253 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 219256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219264 */     GIR_RootConstrainSelectedInstOperands,
     /* 219265 */     // GIR_Coverage, 3617,
     /* 219265 */     GIR_EraseRootFromParent_Done,
     /* 219266 */   // Label 4374: @219266
     /* 219266 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(219308), // Rule ID 7389 //
     /* 219271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 219279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1811:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 219298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219306 */     GIR_RootConstrainSelectedInstOperands,
     /* 219307 */     // GIR_Coverage, 7389,
     /* 219307 */     GIR_EraseRootFromParent_Done,
     /* 219308 */   // Label 4375: @219308
     /* 219308 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(219350), // Rule ID 7391 //
     /* 219313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 219321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 219340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219348 */     GIR_RootConstrainSelectedInstOperands,
     /* 219349 */     // GIR_Coverage, 7391,
     /* 219349 */     GIR_EraseRootFromParent_Done,
     /* 219350 */   // Label 4376: @219350
     /* 219350 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(219392), // Rule ID 7393 //
     /* 219355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 219363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 219382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219390 */     GIR_RootConstrainSelectedInstOperands,
     /* 219391 */     // GIR_Coverage, 7393,
     /* 219391 */     GIR_EraseRootFromParent_Done,
     /* 219392 */   // Label 4377: @219392
     /* 219392 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(219434), // Rule ID 7395 //
     /* 219397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 219405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 219424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219432 */     GIR_RootConstrainSelectedInstOperands,
     /* 219433 */     // GIR_Coverage, 7395,
     /* 219433 */     GIR_EraseRootFromParent_Done,
     /* 219434 */   // Label 4378: @219434
     /* 219434 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(219476), // Rule ID 7413 //
     /* 219439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 219447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219463 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1196:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 219466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219474 */     GIR_RootConstrainSelectedInstOperands,
     /* 219475 */     // GIR_Coverage, 7413,
     /* 219475 */     GIR_EraseRootFromParent_Done,
     /* 219476 */   // Label 4379: @219476
     /* 219476 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(219518), // Rule ID 7414 //
     /* 219481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 219489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219505 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1196:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 219508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219516 */     GIR_RootConstrainSelectedInstOperands,
     /* 219517 */     // GIR_Coverage, 7414,
     /* 219517 */     GIR_EraseRootFromParent_Done,
     /* 219518 */   // Label 4380: @219518
     /* 219518 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(219560), // Rule ID 7415 //
     /* 219523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 219531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1196:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 219550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219558 */     GIR_RootConstrainSelectedInstOperands,
     /* 219559 */     // GIR_Coverage, 7415,
     /* 219559 */     GIR_EraseRootFromParent_Done,
     /* 219560 */   // Label 4381: @219560
     /* 219560 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(219602), // Rule ID 7416 //
     /* 219565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 219573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1196:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 219592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219600 */     GIR_RootConstrainSelectedInstOperands,
     /* 219601 */     // GIR_Coverage, 7416,
     /* 219601 */     GIR_EraseRootFromParent_Done,
     /* 219602 */   // Label 4382: @219602
     /* 219602 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(219644), // Rule ID 7529 //
     /* 219607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 219615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219631 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1658:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 219634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219642 */     GIR_RootConstrainSelectedInstOperands,
     /* 219643 */     // GIR_Coverage, 7529,
     /* 219643 */     GIR_EraseRootFromParent_Done,
     /* 219644 */   // Label 4383: @219644
     /* 219644 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(219686), // Rule ID 7530 //
     /* 219649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 219657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1658:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 219676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219684 */     GIR_RootConstrainSelectedInstOperands,
     /* 219685 */     // GIR_Coverage, 7530,
     /* 219685 */     GIR_EraseRootFromParent_Done,
     /* 219686 */   // Label 4384: @219686
     /* 219686 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(219728), // Rule ID 7531 //
     /* 219691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 219699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1658:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 219718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219726 */     GIR_RootConstrainSelectedInstOperands,
     /* 219727 */     // GIR_Coverage, 7531,
     /* 219727 */     GIR_EraseRootFromParent_Done,
     /* 219728 */   // Label 4385: @219728
     /* 219728 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(219770), // Rule ID 7532 //
     /* 219733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 219741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1658:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 219760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219768 */     GIR_RootConstrainSelectedInstOperands,
     /* 219769 */     // GIR_Coverage, 7532,
     /* 219769 */     GIR_EraseRootFromParent_Done,
     /* 219770 */   // Label 4386: @219770
     /* 219770 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(219812), // Rule ID 7533 //
     /* 219775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 219783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219799 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1896:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 219802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219810 */     GIR_RootConstrainSelectedInstOperands,
     /* 219811 */     // GIR_Coverage, 7533,
     /* 219811 */     GIR_EraseRootFromParent_Done,
     /* 219812 */   // Label 4387: @219812
     /* 219812 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(219854), // Rule ID 7534 //
     /* 219817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 219825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1896:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 219844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219852 */     GIR_RootConstrainSelectedInstOperands,
     /* 219853 */     // GIR_Coverage, 7534,
     /* 219853 */     GIR_EraseRootFromParent_Done,
     /* 219854 */   // Label 4388: @219854
     /* 219854 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(219896), // Rule ID 7535 //
     /* 219859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 219867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1896:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 219886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219894 */     GIR_RootConstrainSelectedInstOperands,
     /* 219895 */     // GIR_Coverage, 7535,
     /* 219895 */     GIR_EraseRootFromParent_Done,
     /* 219896 */   // Label 4389: @219896
     /* 219896 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(219938), // Rule ID 7536 //
     /* 219901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 219909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1896:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 219928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219936 */     GIR_RootConstrainSelectedInstOperands,
     /* 219937 */     // GIR_Coverage, 7536,
     /* 219937 */     GIR_EraseRootFromParent_Done,
     /* 219938 */   // Label 4390: @219938
     /* 219938 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(219980), // Rule ID 7545 //
     /* 219943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 219951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 219970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219978 */     GIR_RootConstrainSelectedInstOperands,
     /* 219979 */     // GIR_Coverage, 7545,
     /* 219979 */     GIR_EraseRootFromParent_Done,
     /* 219980 */   // Label 4391: @219980
     /* 219980 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(220022), // Rule ID 7546 //
     /* 219985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 219993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1859:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 220012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220020 */     GIR_RootConstrainSelectedInstOperands,
     /* 220021 */     // GIR_Coverage, 7546,
     /* 220021 */     GIR_EraseRootFromParent_Done,
     /* 220022 */   // Label 4392: @220022
     /* 220022 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(220064), // Rule ID 7547 //
     /* 220027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 220035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 220054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220062 */     GIR_RootConstrainSelectedInstOperands,
     /* 220063 */     // GIR_Coverage, 7547,
     /* 220063 */     GIR_EraseRootFromParent_Done,
     /* 220064 */   // Label 4393: @220064
     /* 220064 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(220106), // Rule ID 7548 //
     /* 220069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 220077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 220096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220104 */     GIR_RootConstrainSelectedInstOperands,
     /* 220105 */     // GIR_Coverage, 7548,
     /* 220105 */     GIR_EraseRootFromParent_Done,
     /* 220106 */   // Label 4394: @220106
     /* 220106 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(220148), // Rule ID 7549 //
     /* 220111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 220119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 220138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220146 */     GIR_RootConstrainSelectedInstOperands,
     /* 220147 */     // GIR_Coverage, 7549,
     /* 220147 */     GIR_EraseRootFromParent_Done,
     /* 220148 */   // Label 4395: @220148
     /* 220148 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(220190), // Rule ID 7550 //
     /* 220153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 220161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1861:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 220180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220188 */     GIR_RootConstrainSelectedInstOperands,
     /* 220189 */     // GIR_Coverage, 7550,
     /* 220189 */     GIR_EraseRootFromParent_Done,
     /* 220190 */   // Label 4396: @220190
     /* 220190 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(220232), // Rule ID 7635 //
     /* 220195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 220203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 220219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 220222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220230 */     GIR_RootConstrainSelectedInstOperands,
     /* 220231 */     // GIR_Coverage, 7635,
     /* 220231 */     GIR_EraseRootFromParent_Done,
     /* 220232 */   // Label 4397: @220232
     /* 220232 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(220274), // Rule ID 7636 //
     /* 220237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 220245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220261 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 220261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 220264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220272 */     GIR_RootConstrainSelectedInstOperands,
     /* 220273 */     // GIR_Coverage, 7636,
     /* 220273 */     GIR_EraseRootFromParent_Done,
     /* 220274 */   // Label 4398: @220274
     /* 220274 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(220316), // Rule ID 7637 //
     /* 220279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 220287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220303 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 220303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 220306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220314 */     GIR_RootConstrainSelectedInstOperands,
     /* 220315 */     // GIR_Coverage, 7637,
     /* 220315 */     GIR_EraseRootFromParent_Done,
     /* 220316 */   // Label 4399: @220316
     /* 220316 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(220358), // Rule ID 7638 //
     /* 220321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 220329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 220345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 220348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220356 */     GIR_RootConstrainSelectedInstOperands,
     /* 220357 */     // GIR_Coverage, 7638,
     /* 220357 */     GIR_EraseRootFromParent_Done,
     /* 220358 */   // Label 4400: @220358
     /* 220358 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(220400), // Rule ID 7647 //
     /* 220363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 220371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220387 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1522:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 220387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 220390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220398 */     GIR_RootConstrainSelectedInstOperands,
     /* 220399 */     // GIR_Coverage, 7647,
     /* 220399 */     GIR_EraseRootFromParent_Done,
     /* 220400 */   // Label 4401: @220400
     /* 220400 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(220442), // Rule ID 7648 //
     /* 220405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 220413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220429 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1522:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 220429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 220432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220440 */     GIR_RootConstrainSelectedInstOperands,
     /* 220441 */     // GIR_Coverage, 7648,
     /* 220441 */     GIR_EraseRootFromParent_Done,
     /* 220442 */   // Label 4402: @220442
     /* 220442 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(220484), // Rule ID 7649 //
     /* 220447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 220455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1522:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 220471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 220474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220482 */     GIR_RootConstrainSelectedInstOperands,
     /* 220483 */     // GIR_Coverage, 7649,
     /* 220483 */     GIR_EraseRootFromParent_Done,
     /* 220484 */   // Label 4403: @220484
     /* 220484 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(220526), // Rule ID 7650 //
     /* 220489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 220497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220513 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1522:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 220513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 220516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220524 */     GIR_RootConstrainSelectedInstOperands,
     /* 220525 */     // GIR_Coverage, 7650,
     /* 220525 */     GIR_EraseRootFromParent_Done,
     /* 220526 */   // Label 4404: @220526
     /* 220526 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(220568), // Rule ID 7729 //
     /* 220531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 220539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1589:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 220558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220566 */     GIR_RootConstrainSelectedInstOperands,
     /* 220567 */     // GIR_Coverage, 7729,
     /* 220567 */     GIR_EraseRootFromParent_Done,
     /* 220568 */   // Label 4405: @220568
     /* 220568 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(220610), // Rule ID 7730 //
     /* 220573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 220581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1589:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 220600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220608 */     GIR_RootConstrainSelectedInstOperands,
     /* 220609 */     // GIR_Coverage, 7730,
     /* 220609 */     GIR_EraseRootFromParent_Done,
     /* 220610 */   // Label 4406: @220610
     /* 220610 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(220652), // Rule ID 7731 //
     /* 220615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 220623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1589:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 220642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220650 */     GIR_RootConstrainSelectedInstOperands,
     /* 220651 */     // GIR_Coverage, 7731,
     /* 220651 */     GIR_EraseRootFromParent_Done,
     /* 220652 */   // Label 4407: @220652
     /* 220652 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(220694), // Rule ID 7732 //
     /* 220657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 220665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1589:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 220684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220692 */     GIR_RootConstrainSelectedInstOperands,
     /* 220693 */     // GIR_Coverage, 7732,
     /* 220693 */     GIR_EraseRootFromParent_Done,
     /* 220694 */   // Label 4408: @220694
     /* 220694 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(220736), // Rule ID 7733 //
     /* 220699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 220707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 220726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220734 */     GIR_RootConstrainSelectedInstOperands,
     /* 220735 */     // GIR_Coverage, 7733,
     /* 220735 */     GIR_EraseRootFromParent_Done,
     /* 220736 */   // Label 4409: @220736
     /* 220736 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(220778), // Rule ID 7734 //
     /* 220741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 220749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 220768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220776 */     GIR_RootConstrainSelectedInstOperands,
     /* 220777 */     // GIR_Coverage, 7734,
     /* 220777 */     GIR_EraseRootFromParent_Done,
     /* 220778 */   // Label 4410: @220778
     /* 220778 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(220820), // Rule ID 7735 //
     /* 220783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 220791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 220810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220818 */     GIR_RootConstrainSelectedInstOperands,
     /* 220819 */     // GIR_Coverage, 7735,
     /* 220819 */     GIR_EraseRootFromParent_Done,
     /* 220820 */   // Label 4411: @220820
     /* 220820 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(220862), // Rule ID 7736 //
     /* 220825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 220833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1839:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 220852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220860 */     GIR_RootConstrainSelectedInstOperands,
     /* 220861 */     // GIR_Coverage, 7736,
     /* 220861 */     GIR_EraseRootFromParent_Done,
     /* 220862 */   // Label 4412: @220862
     /* 220862 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(220904), // Rule ID 7932 //
     /* 220867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220891 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 220891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 220894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220902 */     GIR_RootConstrainSelectedInstOperands,
     /* 220903 */     // GIR_Coverage, 7932,
     /* 220903 */     GIR_EraseRootFromParent_Done,
     /* 220904 */   // Label 4413: @220904
     /* 220904 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(220946), // Rule ID 7934 //
     /* 220909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220933 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 220933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 220936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220944 */     GIR_RootConstrainSelectedInstOperands,
     /* 220945 */     // GIR_Coverage, 7934,
     /* 220945 */     GIR_EraseRootFromParent_Done,
     /* 220946 */   // Label 4414: @220946
     /* 220946 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(220988), // Rule ID 7936 //
     /* 220951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220975 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 220975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 220978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220986 */     GIR_RootConstrainSelectedInstOperands,
     /* 220987 */     // GIR_Coverage, 7936,
     /* 220987 */     GIR_EraseRootFromParent_Done,
     /* 220988 */   // Label 4415: @220988
     /* 220988 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(221030), // Rule ID 7944 //
     /* 220993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221017 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 221020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221028 */     GIR_RootConstrainSelectedInstOperands,
     /* 221029 */     // GIR_Coverage, 7944,
     /* 221029 */     GIR_EraseRootFromParent_Done,
     /* 221030 */   // Label 4416: @221030
     /* 221030 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(221072), // Rule ID 7946 //
     /* 221035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221059 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 221062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221070 */     GIR_RootConstrainSelectedInstOperands,
     /* 221071 */     // GIR_Coverage, 7946,
     /* 221071 */     GIR_EraseRootFromParent_Done,
     /* 221072 */   // Label 4417: @221072
     /* 221072 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(221114), // Rule ID 7948 //
     /* 221077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221101 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 221104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221112 */     GIR_RootConstrainSelectedInstOperands,
     /* 221113 */     // GIR_Coverage, 7948,
     /* 221113 */     GIR_EraseRootFromParent_Done,
     /* 221114 */   // Label 4418: @221114
     /* 221114 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(221156), // Rule ID 7986 //
     /* 221119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 221127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221143 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 221146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221154 */     GIR_RootConstrainSelectedInstOperands,
     /* 221155 */     // GIR_Coverage, 7986,
     /* 221155 */     GIR_EraseRootFromParent_Done,
     /* 221156 */   // Label 4419: @221156
     /* 221156 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(221198), // Rule ID 7987 //
     /* 221161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 221169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221185 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 221188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221196 */     GIR_RootConstrainSelectedInstOperands,
     /* 221197 */     // GIR_Coverage, 7987,
     /* 221197 */     GIR_EraseRootFromParent_Done,
     /* 221198 */   // Label 4420: @221198
     /* 221198 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(221240), // Rule ID 7988 //
     /* 221203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 221211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221227 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 221230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221238 */     GIR_RootConstrainSelectedInstOperands,
     /* 221239 */     // GIR_Coverage, 7988,
     /* 221239 */     GIR_EraseRootFromParent_Done,
     /* 221240 */   // Label 4421: @221240
     /* 221240 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(221282), // Rule ID 7989 //
     /* 221245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 221253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221269 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 221272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221280 */     GIR_RootConstrainSelectedInstOperands,
     /* 221281 */     // GIR_Coverage, 7989,
     /* 221281 */     GIR_EraseRootFromParent_Done,
     /* 221282 */   // Label 4422: @221282
     /* 221282 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(221324), // Rule ID 7990 //
     /* 221287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 221295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221311 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1386:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 221314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221322 */     GIR_RootConstrainSelectedInstOperands,
     /* 221323 */     // GIR_Coverage, 7990,
     /* 221323 */     GIR_EraseRootFromParent_Done,
     /* 221324 */   // Label 4423: @221324
     /* 221324 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(221366), // Rule ID 7991 //
     /* 221329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 221337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221353 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1386:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 221356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221364 */     GIR_RootConstrainSelectedInstOperands,
     /* 221365 */     // GIR_Coverage, 7991,
     /* 221365 */     GIR_EraseRootFromParent_Done,
     /* 221366 */   // Label 4424: @221366
     /* 221366 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(221408), // Rule ID 7992 //
     /* 221371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 221379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221395 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 221398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221406 */     GIR_RootConstrainSelectedInstOperands,
     /* 221407 */     // GIR_Coverage, 7992,
     /* 221407 */     GIR_EraseRootFromParent_Done,
     /* 221408 */   // Label 4425: @221408
     /* 221408 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(221450), // Rule ID 7993 //
     /* 221413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 221421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221437 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 221440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221448 */     GIR_RootConstrainSelectedInstOperands,
     /* 221449 */     // GIR_Coverage, 7993,
     /* 221449 */     GIR_EraseRootFromParent_Done,
     /* 221450 */   // Label 4426: @221450
     /* 221450 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(221492), // Rule ID 7994 //
     /* 221455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 221463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221479 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1325:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 221482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221490 */     GIR_RootConstrainSelectedInstOperands,
     /* 221491 */     // GIR_Coverage, 7994,
     /* 221491 */     GIR_EraseRootFromParent_Done,
     /* 221492 */   // Label 4427: @221492
     /* 221492 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(221534), // Rule ID 7995 //
     /* 221497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 221505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221521 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 221524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221532 */     GIR_RootConstrainSelectedInstOperands,
     /* 221533 */     // GIR_Coverage, 7995,
     /* 221533 */     GIR_EraseRootFromParent_Done,
     /* 221534 */   // Label 4428: @221534
     /* 221534 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(221576), // Rule ID 7996 //
     /* 221539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 221547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221563 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 221566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221574 */     GIR_RootConstrainSelectedInstOperands,
     /* 221575 */     // GIR_Coverage, 7996,
     /* 221575 */     GIR_EraseRootFromParent_Done,
     /* 221576 */   // Label 4429: @221576
     /* 221576 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(221618), // Rule ID 7997 //
     /* 221581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 221589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221605 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1323:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 221608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221616 */     GIR_RootConstrainSelectedInstOperands,
     /* 221617 */     // GIR_Coverage, 7997,
     /* 221617 */     GIR_EraseRootFromParent_Done,
     /* 221618 */   // Label 4430: @221618
     /* 221618 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(221660), // Rule ID 8034 //
     /* 221623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 221631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221647 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 221650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221658 */     GIR_RootConstrainSelectedInstOperands,
     /* 221659 */     // GIR_Coverage, 8034,
     /* 221659 */     GIR_EraseRootFromParent_Done,
     /* 221660 */   // Label 4431: @221660
     /* 221660 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(221702), // Rule ID 8036 //
     /* 221665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 221673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 221676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 221682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 221685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221689 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 221689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 221692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221700 */     GIR_RootConstrainSelectedInstOperands,
     /* 221701 */     // GIR_Coverage, 8036,
     /* 221701 */     GIR_EraseRootFromParent_Done,
     /* 221702 */   // Label 4432: @221702
     /* 221702 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(221744), // Rule ID 8038 //
     /* 221707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 221715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 221718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 221724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 221727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221731 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 221731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 221734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221742 */     GIR_RootConstrainSelectedInstOperands,
     /* 221743 */     // GIR_Coverage, 8038,
     /* 221743 */     GIR_EraseRootFromParent_Done,
     /* 221744 */   // Label 4433: @221744
     /* 221744 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(221786), // Rule ID 8040 //
     /* 221749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 221757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221773 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 221776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221784 */     GIR_RootConstrainSelectedInstOperands,
     /* 221785 */     // GIR_Coverage, 8040,
     /* 221785 */     GIR_EraseRootFromParent_Done,
     /* 221786 */   // Label 4434: @221786
     /* 221786 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(221828), // Rule ID 8042 //
     /* 221791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 221799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 221802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 221808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 221811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221815 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 221815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 221818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221826 */     GIR_RootConstrainSelectedInstOperands,
     /* 221827 */     // GIR_Coverage, 8042,
     /* 221827 */     GIR_EraseRootFromParent_Done,
     /* 221828 */   // Label 4435: @221828
     /* 221828 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(221870), // Rule ID 8044 //
     /* 221833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 221841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221857 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 221860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221868 */     GIR_RootConstrainSelectedInstOperands,
     /* 221869 */     // GIR_Coverage, 8044,
     /* 221869 */     GIR_EraseRootFromParent_Done,
     /* 221870 */   // Label 4436: @221870
     /* 221870 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(221912), // Rule ID 8046 //
     /* 221875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 221883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221899 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 221902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221910 */     GIR_RootConstrainSelectedInstOperands,
     /* 221911 */     // GIR_Coverage, 8046,
     /* 221911 */     GIR_EraseRootFromParent_Done,
     /* 221912 */   // Label 4437: @221912
     /* 221912 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(221954), // Rule ID 8047 //
     /* 221917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 221925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 221928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 221934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 221937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221941 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1387:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 221941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 221944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221952 */     GIR_RootConstrainSelectedInstOperands,
     /* 221953 */     // GIR_Coverage, 8047,
     /* 221953 */     GIR_EraseRootFromParent_Done,
     /* 221954 */   // Label 4438: @221954
     /* 221954 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(221996), // Rule ID 8048 //
     /* 221959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 221967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 221970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 221976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 221979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221983 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 221983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 221986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221994 */     GIR_RootConstrainSelectedInstOperands,
     /* 221995 */     // GIR_Coverage, 8048,
     /* 221995 */     GIR_EraseRootFromParent_Done,
     /* 221996 */   // Label 4439: @221996
     /* 221996 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(222038), // Rule ID 8049 //
     /* 222001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 222009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222025 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 222028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222036 */     GIR_RootConstrainSelectedInstOperands,
     /* 222037 */     // GIR_Coverage, 8049,
     /* 222037 */     GIR_EraseRootFromParent_Done,
     /* 222038 */   // Label 4440: @222038
     /* 222038 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(222080), // Rule ID 8050 //
     /* 222043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 222051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 222054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 222060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 222063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222067 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 222067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 222070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222078 */     GIR_RootConstrainSelectedInstOperands,
     /* 222079 */     // GIR_Coverage, 8050,
     /* 222079 */     GIR_EraseRootFromParent_Done,
     /* 222080 */   // Label 4441: @222080
     /* 222080 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(222122), // Rule ID 8051 //
     /* 222085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 222093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222109 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 222112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222120 */     GIR_RootConstrainSelectedInstOperands,
     /* 222121 */     // GIR_Coverage, 8051,
     /* 222121 */     GIR_EraseRootFromParent_Done,
     /* 222122 */   // Label 4442: @222122
     /* 222122 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(222164), // Rule ID 8304 //
     /* 222127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 222135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222151 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1205:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 222154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222162 */     GIR_RootConstrainSelectedInstOperands,
     /* 222163 */     // GIR_Coverage, 8304,
     /* 222163 */     GIR_EraseRootFromParent_Done,
     /* 222164 */   // Label 4443: @222164
     /* 222164 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(222206), // Rule ID 8306 //
     /* 222169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 222177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222193 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1201:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 222196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222204 */     GIR_RootConstrainSelectedInstOperands,
     /* 222205 */     // GIR_Coverage, 8306,
     /* 222205 */     GIR_EraseRootFromParent_Done,
     /* 222206 */   // Label 4444: @222206
     /* 222206 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(222248), // Rule ID 8307 //
     /* 222211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 222219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1198:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 222238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222246 */     GIR_RootConstrainSelectedInstOperands,
     /* 222247 */     // GIR_Coverage, 8307,
     /* 222247 */     GIR_EraseRootFromParent_Done,
     /* 222248 */   // Label 4445: @222248
     /* 222248 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(222290), // Rule ID 8308 //
     /* 222253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 222261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 222270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 222273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222277 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1198:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 222277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 222280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222288 */     GIR_RootConstrainSelectedInstOperands,
     /* 222289 */     // GIR_Coverage, 8308,
     /* 222289 */     GIR_EraseRootFromParent_Done,
     /* 222290 */   // Label 4446: @222290
     /* 222290 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(222332), // Rule ID 8309 //
     /* 222295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 222303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 222312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 222315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222319 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1198:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 222319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 222322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222330 */     GIR_RootConstrainSelectedInstOperands,
     /* 222331 */     // GIR_Coverage, 8309,
     /* 222331 */     GIR_EraseRootFromParent_Done,
     /* 222332 */   // Label 4447: @222332
     /* 222332 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(222374), // Rule ID 8310 //
     /* 222337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 222345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 222354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 222357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222361 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1198:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 222361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 222364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222372 */     GIR_RootConstrainSelectedInstOperands,
     /* 222373 */     // GIR_Coverage, 8310,
     /* 222373 */     GIR_EraseRootFromParent_Done,
     /* 222374 */   // Label 4448: @222374
     /* 222374 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(222416), // Rule ID 8311 //
     /* 222379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 222387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 222390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 222393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 222396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 222399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1198:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 222403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 222406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222414 */     GIR_RootConstrainSelectedInstOperands,
     /* 222415 */     // GIR_Coverage, 8311,
     /* 222415 */     GIR_EraseRootFromParent_Done,
     /* 222416 */   // Label 4449: @222416
     /* 222416 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(222458), // Rule ID 8332 //
     /* 222421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 222429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222445 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1256:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 222448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222456 */     GIR_RootConstrainSelectedInstOperands,
     /* 222457 */     // GIR_Coverage, 8332,
     /* 222457 */     GIR_EraseRootFromParent_Done,
     /* 222458 */   // Label 4450: @222458
     /* 222458 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(222500), // Rule ID 8333 //
     /* 222463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 222471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 222480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 222483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222487 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1256:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 222487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 222490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222498 */     GIR_RootConstrainSelectedInstOperands,
     /* 222499 */     // GIR_Coverage, 8333,
     /* 222499 */     GIR_EraseRootFromParent_Done,
     /* 222500 */   // Label 4451: @222500
     /* 222500 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(222542), // Rule ID 8334 //
     /* 222505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 222513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 222522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 222525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222529 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1256:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 222529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 222532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222540 */     GIR_RootConstrainSelectedInstOperands,
     /* 222541 */     // GIR_Coverage, 8334,
     /* 222541 */     GIR_EraseRootFromParent_Done,
     /* 222542 */   // Label 4452: @222542
     /* 222542 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(222584), // Rule ID 8335 //
     /* 222547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 222555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 222564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 222567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222571 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1256:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 222571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 222574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222582 */     GIR_RootConstrainSelectedInstOperands,
     /* 222583 */     // GIR_Coverage, 8335,
     /* 222583 */     GIR_EraseRootFromParent_Done,
     /* 222584 */   // Label 4453: @222584
     /* 222584 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(222626), // Rule ID 8336 //
     /* 222589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 222597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 222600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 222603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 222606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 222609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222613 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1256:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 222613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 222616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222624 */     GIR_RootConstrainSelectedInstOperands,
     /* 222625 */     // GIR_Coverage, 8336,
     /* 222625 */     GIR_EraseRootFromParent_Done,
     /* 222626 */   // Label 4454: @222626
     /* 222626 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(222668), // Rule ID 8352 //
     /* 222631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 222639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222655 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1527:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 222658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222666 */     GIR_RootConstrainSelectedInstOperands,
     /* 222667 */     // GIR_Coverage, 8352,
     /* 222667 */     GIR_EraseRootFromParent_Done,
     /* 222668 */   // Label 4455: @222668
     /* 222668 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(222710), // Rule ID 8353 //
     /* 222673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 222681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 222690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 222693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222697 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1527:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 222697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 222700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222708 */     GIR_RootConstrainSelectedInstOperands,
     /* 222709 */     // GIR_Coverage, 8353,
     /* 222709 */     GIR_EraseRootFromParent_Done,
     /* 222710 */   // Label 4456: @222710
     /* 222710 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(222752), // Rule ID 8354 //
     /* 222715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 222723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 222732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 222735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222739 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1527:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 222739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 222742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222750 */     GIR_RootConstrainSelectedInstOperands,
     /* 222751 */     // GIR_Coverage, 8354,
     /* 222751 */     GIR_EraseRootFromParent_Done,
     /* 222752 */   // Label 4457: @222752
     /* 222752 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(222794), // Rule ID 8355 //
     /* 222757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 222765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 222774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 222777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222781 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1527:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 222781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 222784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222792 */     GIR_RootConstrainSelectedInstOperands,
     /* 222793 */     // GIR_Coverage, 8355,
     /* 222793 */     GIR_EraseRootFromParent_Done,
     /* 222794 */   // Label 4458: @222794
     /* 222794 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(222836), // Rule ID 8356 //
     /* 222799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 222807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 222810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 222813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 222816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 222819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222823 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1527:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 222823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 222826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222834 */     GIR_RootConstrainSelectedInstOperands,
     /* 222835 */     // GIR_Coverage, 8356,
     /* 222835 */     GIR_EraseRootFromParent_Done,
     /* 222836 */   // Label 4459: @222836
     /* 222836 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(222878), // Rule ID 8357 //
     /* 222841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 222849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1523:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 222868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222876 */     GIR_RootConstrainSelectedInstOperands,
     /* 222877 */     // GIR_Coverage, 8357,
     /* 222877 */     GIR_EraseRootFromParent_Done,
     /* 222878 */   // Label 4460: @222878
     /* 222878 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(222920), // Rule ID 8358 //
     /* 222883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 222891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 222900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 222903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222907 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1523:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 222907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 222910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222918 */     GIR_RootConstrainSelectedInstOperands,
     /* 222919 */     // GIR_Coverage, 8358,
     /* 222919 */     GIR_EraseRootFromParent_Done,
     /* 222920 */   // Label 4461: @222920
     /* 222920 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(222962), // Rule ID 8359 //
     /* 222925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 222933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 222942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 222945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222949 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1523:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 222949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 222952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222960 */     GIR_RootConstrainSelectedInstOperands,
     /* 222961 */     // GIR_Coverage, 8359,
     /* 222961 */     GIR_EraseRootFromParent_Done,
     /* 222962 */   // Label 4462: @222962
     /* 222962 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(223004), // Rule ID 8360 //
     /* 222967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 222975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 222984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 222987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 222991 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1523:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 222991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 222994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223002 */     GIR_RootConstrainSelectedInstOperands,
     /* 223003 */     // GIR_Coverage, 8360,
     /* 223003 */     GIR_EraseRootFromParent_Done,
     /* 223004 */   // Label 4463: @223004
     /* 223004 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(223046), // Rule ID 8361 //
     /* 223009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 223017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 223020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 223023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 223026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 223029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223033 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1523:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 223033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 223036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223044 */     GIR_RootConstrainSelectedInstOperands,
     /* 223045 */     // GIR_Coverage, 8361,
     /* 223045 */     GIR_EraseRootFromParent_Done,
     /* 223046 */   // Label 4464: @223046
     /* 223046 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(223088), // Rule ID 8362 //
     /* 223051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 223059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 223071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223075 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1521:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 223075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 223078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223086 */     GIR_RootConstrainSelectedInstOperands,
     /* 223087 */     // GIR_Coverage, 8362,
     /* 223087 */     GIR_EraseRootFromParent_Done,
     /* 223088 */   // Label 4465: @223088
     /* 223088 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(223130), // Rule ID 8363 //
     /* 223093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 223101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 223113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223117 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1521:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 223117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 223120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223128 */     GIR_RootConstrainSelectedInstOperands,
     /* 223129 */     // GIR_Coverage, 8363,
     /* 223129 */     GIR_EraseRootFromParent_Done,
     /* 223130 */   // Label 4466: @223130
     /* 223130 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(223172), // Rule ID 8364 //
     /* 223135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 223143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 223155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223159 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1521:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 223159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 223162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223170 */     GIR_RootConstrainSelectedInstOperands,
     /* 223171 */     // GIR_Coverage, 8364,
     /* 223171 */     GIR_EraseRootFromParent_Done,
     /* 223172 */   // Label 4467: @223172
     /* 223172 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(223214), // Rule ID 8365 //
     /* 223177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 223185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 223188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 223197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223201 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1521:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 223201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 223204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223212 */     GIR_RootConstrainSelectedInstOperands,
     /* 223213 */     // GIR_Coverage, 8365,
     /* 223213 */     GIR_EraseRootFromParent_Done,
     /* 223214 */   // Label 4468: @223214
     /* 223214 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(223256), // Rule ID 8366 //
     /* 223219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 223227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 223230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 223233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 223236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 223239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223243 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1521:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 223243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 223246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223254 */     GIR_RootConstrainSelectedInstOperands,
     /* 223255 */     // GIR_Coverage, 8366,
     /* 223255 */     GIR_EraseRootFromParent_Done,
     /* 223256 */   // Label 4469: @223256
     /* 223256 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(223298), // Rule ID 8367 //
     /* 223261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 223269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 223281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223285 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1517:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 223285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 223288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223296 */     GIR_RootConstrainSelectedInstOperands,
     /* 223297 */     // GIR_Coverage, 8367,
     /* 223297 */     GIR_EraseRootFromParent_Done,
     /* 223298 */   // Label 4470: @223298
     /* 223298 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(223340), // Rule ID 8368 //
     /* 223303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 223311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 223323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223327 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1517:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 223327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 223330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223338 */     GIR_RootConstrainSelectedInstOperands,
     /* 223339 */     // GIR_Coverage, 8368,
     /* 223339 */     GIR_EraseRootFromParent_Done,
     /* 223340 */   // Label 4471: @223340
     /* 223340 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(223382), // Rule ID 8369 //
     /* 223345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 223353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 223365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223369 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1517:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 223369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 223372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223380 */     GIR_RootConstrainSelectedInstOperands,
     /* 223381 */     // GIR_Coverage, 8369,
     /* 223381 */     GIR_EraseRootFromParent_Done,
     /* 223382 */   // Label 4472: @223382
     /* 223382 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(223424), // Rule ID 8370 //
     /* 223387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 223395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 223398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 223407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223411 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1517:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 223411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 223414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223422 */     GIR_RootConstrainSelectedInstOperands,
     /* 223423 */     // GIR_Coverage, 8370,
     /* 223423 */     GIR_EraseRootFromParent_Done,
     /* 223424 */   // Label 4473: @223424
     /* 223424 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(223466), // Rule ID 8371 //
     /* 223429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 223437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 223440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 223443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 223446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 223449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 223453 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1517:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 223453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 223456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223464 */     GIR_RootConstrainSelectedInstOperands,
     /* 223465 */     // GIR_Coverage, 8371,
     /* 223465 */     GIR_EraseRootFromParent_Done,
     /* 223466 */   // Label 4474: @223466
     /* 223466 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(223508), // Rule ID 8379 //
     /* 223471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 223479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223495 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1214:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 223498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223506 */     GIR_RootConstrainSelectedInstOperands,
     /* 223507 */     // GIR_Coverage, 8379,
     /* 223507 */     GIR_EraseRootFromParent_Done,
     /* 223508 */   // Label 4475: @223508
     /* 223508 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(223550), // Rule ID 8380 //
     /* 223513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 223521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223537 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 223540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223548 */     GIR_RootConstrainSelectedInstOperands,
     /* 223549 */     // GIR_Coverage, 8380,
     /* 223549 */     GIR_EraseRootFromParent_Done,
     /* 223550 */   // Label 4476: @223550
     /* 223550 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(223592), // Rule ID 8381 //
     /* 223555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 223563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223579 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 223582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223590 */     GIR_RootConstrainSelectedInstOperands,
     /* 223591 */     // GIR_Coverage, 8381,
     /* 223591 */     GIR_EraseRootFromParent_Done,
     /* 223592 */   // Label 4477: @223592
     /* 223592 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(223634), // Rule ID 8382 //
     /* 223597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 223605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223621 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 223624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223632 */     GIR_RootConstrainSelectedInstOperands,
     /* 223633 */     // GIR_Coverage, 8382,
     /* 223633 */     GIR_EraseRootFromParent_Done,
     /* 223634 */   // Label 4478: @223634
     /* 223634 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(223676), // Rule ID 8383 //
     /* 223639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 223647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223663 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 223666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223674 */     GIR_RootConstrainSelectedInstOperands,
     /* 223675 */     // GIR_Coverage, 8383,
     /* 223675 */     GIR_EraseRootFromParent_Done,
     /* 223676 */   // Label 4479: @223676
     /* 223676 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(223718), // Rule ID 8384 //
     /* 223681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 223689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223705 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 223708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223716 */     GIR_RootConstrainSelectedInstOperands,
     /* 223717 */     // GIR_Coverage, 8384,
     /* 223717 */     GIR_EraseRootFromParent_Done,
     /* 223718 */   // Label 4480: @223718
     /* 223718 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(223760), // Rule ID 8385 //
     /* 223723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 223731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223747 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 223750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223758 */     GIR_RootConstrainSelectedInstOperands,
     /* 223759 */     // GIR_Coverage, 8385,
     /* 223759 */     GIR_EraseRootFromParent_Done,
     /* 223760 */   // Label 4481: @223760
     /* 223760 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(223805), // Rule ID 9081 //
     /* 223765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 223773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223789 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1235:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 223792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223803 */     GIR_RootConstrainSelectedInstOperands,
     /* 223804 */     // GIR_Coverage, 9081,
     /* 223804 */     GIR_EraseRootFromParent_Done,
     /* 223805 */   // Label 4482: @223805
     /* 223805 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(223850), // Rule ID 9082 //
     /* 223810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 223818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223834 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1235:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 223837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223848 */     GIR_RootConstrainSelectedInstOperands,
     /* 223849 */     // GIR_Coverage, 9082,
     /* 223849 */     GIR_EraseRootFromParent_Done,
     /* 223850 */   // Label 4483: @223850
     /* 223850 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(223895), // Rule ID 9083 //
     /* 223855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 223863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 223866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223879 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1235:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 223882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223893 */     GIR_RootConstrainSelectedInstOperands,
     /* 223894 */     // GIR_Coverage, 9083,
     /* 223894 */     GIR_EraseRootFromParent_Done,
     /* 223895 */   // Label 4484: @223895
     /* 223895 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(223940), // Rule ID 9084 //
     /* 223900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 223908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1225:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 223927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223938 */     GIR_RootConstrainSelectedInstOperands,
     /* 223939 */     // GIR_Coverage, 9084,
     /* 223939 */     GIR_EraseRootFromParent_Done,
     /* 223940 */   // Label 4485: @223940
     /* 223940 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(223985), // Rule ID 9085 //
     /* 223945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 223953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223969 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1225:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 223972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223983 */     GIR_RootConstrainSelectedInstOperands,
     /* 223984 */     // GIR_Coverage, 9085,
     /* 223984 */     GIR_EraseRootFromParent_Done,
     /* 223985 */   // Label 4486: @223985
     /* 223985 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(224030), // Rule ID 9086 //
     /* 223990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 223998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 224001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224014 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1225:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 224017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224028 */     GIR_RootConstrainSelectedInstOperands,
     /* 224029 */     // GIR_Coverage, 9086,
     /* 224029 */     GIR_EraseRootFromParent_Done,
     /* 224030 */   // Label 4487: @224030
     /* 224030 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(224075), // Rule ID 9087 //
     /* 224035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 224043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224059 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1233:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 224062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224073 */     GIR_RootConstrainSelectedInstOperands,
     /* 224074 */     // GIR_Coverage, 9087,
     /* 224074 */     GIR_EraseRootFromParent_Done,
     /* 224075 */   // Label 4488: @224075
     /* 224075 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(224120), // Rule ID 9088 //
     /* 224080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 224088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224104 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1233:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 224107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224118 */     GIR_RootConstrainSelectedInstOperands,
     /* 224119 */     // GIR_Coverage, 9088,
     /* 224119 */     GIR_EraseRootFromParent_Done,
     /* 224120 */   // Label 4489: @224120
     /* 224120 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(224165), // Rule ID 9089 //
     /* 224125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 224133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 224136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224149 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1233:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 224152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224163 */     GIR_RootConstrainSelectedInstOperands,
     /* 224164 */     // GIR_Coverage, 9089,
     /* 224164 */     GIR_EraseRootFromParent_Done,
     /* 224165 */   // Label 4490: @224165
     /* 224165 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(224210), // Rule ID 9090 //
     /* 224170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 224178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1230:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 224197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224208 */     GIR_RootConstrainSelectedInstOperands,
     /* 224209 */     // GIR_Coverage, 9090,
     /* 224209 */     GIR_EraseRootFromParent_Done,
     /* 224210 */   // Label 4491: @224210
     /* 224210 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(224255), // Rule ID 9091 //
     /* 224215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 224223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224239 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1230:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 224242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224253 */     GIR_RootConstrainSelectedInstOperands,
     /* 224254 */     // GIR_Coverage, 9091,
     /* 224254 */     GIR_EraseRootFromParent_Done,
     /* 224255 */   // Label 4492: @224255
     /* 224255 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(224300), // Rule ID 9092 //
     /* 224260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 224268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 224271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1230:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 224287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224298 */     GIR_RootConstrainSelectedInstOperands,
     /* 224299 */     // GIR_Coverage, 9092,
     /* 224299 */     GIR_EraseRootFromParent_Done,
     /* 224300 */   // Label 4493: @224300
     /* 224300 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(224345), // Rule ID 9093 //
     /* 224305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 224313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224329 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1229:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 224332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224343 */     GIR_RootConstrainSelectedInstOperands,
     /* 224344 */     // GIR_Coverage, 9093,
     /* 224344 */     GIR_EraseRootFromParent_Done,
     /* 224345 */   // Label 4494: @224345
     /* 224345 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(224390), // Rule ID 9094 //
     /* 224350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 224358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224374 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1229:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 224377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224388 */     GIR_RootConstrainSelectedInstOperands,
     /* 224389 */     // GIR_Coverage, 9094,
     /* 224389 */     GIR_EraseRootFromParent_Done,
     /* 224390 */   // Label 4495: @224390
     /* 224390 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(224435), // Rule ID 9095 //
     /* 224395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 224403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 224406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224419 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1229:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 224422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224433 */     GIR_RootConstrainSelectedInstOperands,
     /* 224434 */     // GIR_Coverage, 9095,
     /* 224434 */     GIR_EraseRootFromParent_Done,
     /* 224435 */   // Label 4496: @224435
     /* 224435 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(224480), // Rule ID 9096 //
     /* 224440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 224448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1227:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 224467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224478 */     GIR_RootConstrainSelectedInstOperands,
     /* 224479 */     // GIR_Coverage, 9096,
     /* 224479 */     GIR_EraseRootFromParent_Done,
     /* 224480 */   // Label 4497: @224480
     /* 224480 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(224525), // Rule ID 9097 //
     /* 224485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 224493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224509 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1227:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 224512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224523 */     GIR_RootConstrainSelectedInstOperands,
     /* 224524 */     // GIR_Coverage, 9097,
     /* 224524 */     GIR_EraseRootFromParent_Done,
     /* 224525 */   // Label 4498: @224525
     /* 224525 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(224570), // Rule ID 9098 //
     /* 224530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 224538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 224541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224554 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1227:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 224557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224568 */     GIR_RootConstrainSelectedInstOperands,
     /* 224569 */     // GIR_Coverage, 9098,
     /* 224569 */     GIR_EraseRootFromParent_Done,
     /* 224570 */   // Label 4499: @224570
     /* 224570 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(224615), // Rule ID 9099 //
     /* 224575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 224583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224599 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1231:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 224602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224613 */     GIR_RootConstrainSelectedInstOperands,
     /* 224614 */     // GIR_Coverage, 9099,
     /* 224614 */     GIR_EraseRootFromParent_Done,
     /* 224615 */   // Label 4500: @224615
     /* 224615 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(224660), // Rule ID 9100 //
     /* 224620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 224628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1231:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 224647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224658 */     GIR_RootConstrainSelectedInstOperands,
     /* 224659 */     // GIR_Coverage, 9100,
     /* 224659 */     GIR_EraseRootFromParent_Done,
     /* 224660 */   // Label 4501: @224660
     /* 224660 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(224705), // Rule ID 9101 //
     /* 224665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 224673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 224676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224689 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1231:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 224692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224703 */     GIR_RootConstrainSelectedInstOperands,
     /* 224704 */     // GIR_Coverage, 9101,
     /* 224704 */     GIR_EraseRootFromParent_Done,
     /* 224705 */   // Label 4502: @224705
     /* 224705 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(224750), // Rule ID 9102 //
     /* 224710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 224718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224734 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1232:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 224737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224748 */     GIR_RootConstrainSelectedInstOperands,
     /* 224749 */     // GIR_Coverage, 9102,
     /* 224749 */     GIR_EraseRootFromParent_Done,
     /* 224750 */   // Label 4503: @224750
     /* 224750 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(224795), // Rule ID 9103 //
     /* 224755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 224763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1232:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 224782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224793 */     GIR_RootConstrainSelectedInstOperands,
     /* 224794 */     // GIR_Coverage, 9103,
     /* 224794 */     GIR_EraseRootFromParent_Done,
     /* 224795 */   // Label 4504: @224795
     /* 224795 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(224840), // Rule ID 9104 //
     /* 224800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 224808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 224811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1232:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 224827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 224838 */     GIR_RootConstrainSelectedInstOperands,
     /* 224839 */     // GIR_Coverage, 9104,
     /* 224839 */     GIR_EraseRootFromParent_Done,
     /* 224840 */   // Label 4505: @224840
     /* 224840 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(224882), // Rule ID 9501 //
     /* 224845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 224853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 224856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224869 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1268:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 224872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224880 */     GIR_RootConstrainSelectedInstOperands,
     /* 224881 */     // GIR_Coverage, 9501,
     /* 224881 */     GIR_EraseRootFromParent_Done,
     /* 224882 */   // Label 4506: @224882
     /* 224882 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(224924), // Rule ID 9502 //
     /* 224887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 224895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 224898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224911 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1268:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 224914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224922 */     GIR_RootConstrainSelectedInstOperands,
     /* 224923 */     // GIR_Coverage, 9502,
     /* 224923 */     GIR_EraseRootFromParent_Done,
     /* 224924 */   // Label 4507: @224924
     /* 224924 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(224966), // Rule ID 9503 //
     /* 224929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 224937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 224940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224953 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1268:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 224956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224964 */     GIR_RootConstrainSelectedInstOperands,
     /* 224965 */     // GIR_Coverage, 9503,
     /* 224965 */     GIR_EraseRootFromParent_Done,
     /* 224966 */   // Label 4508: @224966
     /* 224966 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(225008), // Rule ID 10041 //
     /* 224971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 224979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224995 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1499:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 224998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225006 */     GIR_RootConstrainSelectedInstOperands,
     /* 225007 */     // GIR_Coverage, 10041,
     /* 225007 */     GIR_EraseRootFromParent_Done,
     /* 225008 */   // Label 4509: @225008
     /* 225008 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(225050), // Rule ID 10042 //
     /* 225013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 225021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225037 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1499:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 225040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225048 */     GIR_RootConstrainSelectedInstOperands,
     /* 225049 */     // GIR_Coverage, 10042,
     /* 225049 */     GIR_EraseRootFromParent_Done,
     /* 225050 */   // Label 4510: @225050
     /* 225050 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(225092), // Rule ID 10043 //
     /* 225055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 225063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225079 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1499:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 225082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225090 */     GIR_RootConstrainSelectedInstOperands,
     /* 225091 */     // GIR_Coverage, 10043,
     /* 225091 */     GIR_EraseRootFromParent_Done,
     /* 225092 */   // Label 4511: @225092
     /* 225092 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(225134), // Rule ID 10044 //
     /* 225097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 225105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1499:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 225124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225132 */     GIR_RootConstrainSelectedInstOperands,
     /* 225133 */     // GIR_Coverage, 10044,
     /* 225133 */     GIR_EraseRootFromParent_Done,
     /* 225134 */   // Label 4512: @225134
     /* 225134 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(225176), // Rule ID 10045 //
     /* 225139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 225147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225163 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1496:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 225166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225174 */     GIR_RootConstrainSelectedInstOperands,
     /* 225175 */     // GIR_Coverage, 10045,
     /* 225175 */     GIR_EraseRootFromParent_Done,
     /* 225176 */   // Label 4513: @225176
     /* 225176 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(225218), // Rule ID 10046 //
     /* 225181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 225189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1496:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 225208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225216 */     GIR_RootConstrainSelectedInstOperands,
     /* 225217 */     // GIR_Coverage, 10046,
     /* 225217 */     GIR_EraseRootFromParent_Done,
     /* 225218 */   // Label 4514: @225218
     /* 225218 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(225260), // Rule ID 10047 //
     /* 225223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 225231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 225250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225258 */     GIR_RootConstrainSelectedInstOperands,
     /* 225259 */     // GIR_Coverage, 10047,
     /* 225259 */     GIR_EraseRootFromParent_Done,
     /* 225260 */   // Label 4515: @225260
     /* 225260 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(225302), // Rule ID 10048 //
     /* 225265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 225273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 225292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225300 */     GIR_RootConstrainSelectedInstOperands,
     /* 225301 */     // GIR_Coverage, 10048,
     /* 225301 */     GIR_EraseRootFromParent_Done,
     /* 225302 */   // Label 4516: @225302
     /* 225302 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(225344), // Rule ID 10061 //
     /* 225307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 225315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1501:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 225334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225342 */     GIR_RootConstrainSelectedInstOperands,
     /* 225343 */     // GIR_Coverage, 10061,
     /* 225343 */     GIR_EraseRootFromParent_Done,
     /* 225344 */   // Label 4517: @225344
     /* 225344 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(225386), // Rule ID 10062 //
     /* 225349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 225357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225373 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1501:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 225376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225384 */     GIR_RootConstrainSelectedInstOperands,
     /* 225385 */     // GIR_Coverage, 10062,
     /* 225385 */     GIR_EraseRootFromParent_Done,
     /* 225386 */   // Label 4518: @225386
     /* 225386 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(225428), // Rule ID 10063 //
     /* 225391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 225399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1501:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 225418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225426 */     GIR_RootConstrainSelectedInstOperands,
     /* 225427 */     // GIR_Coverage, 10063,
     /* 225427 */     GIR_EraseRootFromParent_Done,
     /* 225428 */   // Label 4519: @225428
     /* 225428 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(225470), // Rule ID 10064 //
     /* 225433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 225441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1498:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 225460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225468 */     GIR_RootConstrainSelectedInstOperands,
     /* 225469 */     // GIR_Coverage, 10064,
     /* 225469 */     GIR_EraseRootFromParent_Done,
     /* 225470 */   // Label 4520: @225470
     /* 225470 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(225512), // Rule ID 10065 //
     /* 225475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 225483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1498:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 225502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225510 */     GIR_RootConstrainSelectedInstOperands,
     /* 225511 */     // GIR_Coverage, 10065,
     /* 225511 */     GIR_EraseRootFromParent_Done,
     /* 225512 */   // Label 4521: @225512
     /* 225512 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(225554), // Rule ID 10066 //
     /* 225517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 225525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1498:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 225544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225552 */     GIR_RootConstrainSelectedInstOperands,
     /* 225553 */     // GIR_Coverage, 10066,
     /* 225553 */     GIR_EraseRootFromParent_Done,
     /* 225554 */   // Label 4522: @225554
     /* 225554 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(225596), // Rule ID 10093 //
     /* 225559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 225567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225583 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1293:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 225586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225594 */     GIR_RootConstrainSelectedInstOperands,
     /* 225595 */     // GIR_Coverage, 10093,
     /* 225595 */     GIR_EraseRootFromParent_Done,
     /* 225596 */   // Label 4523: @225596
     /* 225596 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(225638), // Rule ID 10097 //
     /* 225601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 225609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225625 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1296:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 225628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225636 */     GIR_RootConstrainSelectedInstOperands,
     /* 225637 */     // GIR_Coverage, 10097,
     /* 225637 */     GIR_EraseRootFromParent_Done,
     /* 225638 */   // Label 4524: @225638
     /* 225638 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(225680), // Rule ID 10101 //
     /* 225643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 225651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225667 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1295:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 225670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225678 */     GIR_RootConstrainSelectedInstOperands,
     /* 225679 */     // GIR_Coverage, 10101,
     /* 225679 */     GIR_EraseRootFromParent_Done,
     /* 225680 */   // Label 4525: @225680
     /* 225680 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(225722), // Rule ID 10105 //
     /* 225685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 225693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225709 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1297:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 225712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225720 */     GIR_RootConstrainSelectedInstOperands,
     /* 225721 */     // GIR_Coverage, 10105,
     /* 225721 */     GIR_EraseRootFromParent_Done,
     /* 225722 */   // Label 4526: @225722
     /* 225722 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(225764), // Rule ID 10109 //
     /* 225727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 225735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225751 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1609:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 225754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225762 */     GIR_RootConstrainSelectedInstOperands,
     /* 225763 */     // GIR_Coverage, 10109,
     /* 225763 */     GIR_EraseRootFromParent_Done,
     /* 225764 */   // Label 4527: @225764
     /* 225764 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(225806), // Rule ID 10110 //
     /* 225769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 225777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225793 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1856:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 225796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225804 */     GIR_RootConstrainSelectedInstOperands,
     /* 225805 */     // GIR_Coverage, 10110,
     /* 225805 */     GIR_EraseRootFromParent_Done,
     /* 225806 */   // Label 4528: @225806
     /* 225806 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(225848), // Rule ID 10111 //
     /* 225811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 225819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225835 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1853:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 225838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225846 */     GIR_RootConstrainSelectedInstOperands,
     /* 225847 */     // GIR_Coverage, 10111,
     /* 225847 */     GIR_EraseRootFromParent_Done,
     /* 225848 */   // Label 4529: @225848
     /* 225848 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(225890), // Rule ID 10115 //
     /* 225853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 225861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225877 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1608:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 225880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225888 */     GIR_RootConstrainSelectedInstOperands,
     /* 225889 */     // GIR_Coverage, 10115,
     /* 225889 */     GIR_EraseRootFromParent_Done,
     /* 225890 */   // Label 4530: @225890
     /* 225890 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(225932), // Rule ID 10119 //
     /* 225895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 225903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225919 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1606:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 225922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225930 */     GIR_RootConstrainSelectedInstOperands,
     /* 225931 */     // GIR_Coverage, 10119,
     /* 225931 */     GIR_EraseRootFromParent_Done,
     /* 225932 */   // Label 4531: @225932
     /* 225932 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(225974), // Rule ID 10123 //
     /* 225937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 225945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225961 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1607:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 225964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225972 */     GIR_RootConstrainSelectedInstOperands,
     /* 225973 */     // GIR_Coverage, 10123,
     /* 225973 */     GIR_EraseRootFromParent_Done,
     /* 225974 */   // Label 4532: @225974
     /* 225974 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(226016), // Rule ID 10127 //
     /* 225979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 225987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226003 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1855:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 226006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226014 */     GIR_RootConstrainSelectedInstOperands,
     /* 226015 */     // GIR_Coverage, 10127,
     /* 226015 */     GIR_EraseRootFromParent_Done,
     /* 226016 */   // Label 4533: @226016
     /* 226016 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(226058), // Rule ID 10131 //
     /* 226021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 226029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226045 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1854:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 226048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226056 */     GIR_RootConstrainSelectedInstOperands,
     /* 226057 */     // GIR_Coverage, 10131,
     /* 226057 */     GIR_EraseRootFromParent_Done,
     /* 226058 */   // Label 4534: @226058
     /* 226058 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(226100), // Rule ID 10141 //
     /* 226063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 226071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1311:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 226090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226098 */     GIR_RootConstrainSelectedInstOperands,
     /* 226099 */     // GIR_Coverage, 10141,
     /* 226099 */     GIR_EraseRootFromParent_Done,
     /* 226100 */   // Label 4535: @226100
     /* 226100 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(226142), // Rule ID 10142 //
     /* 226105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 226113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1318:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 226132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226140 */     GIR_RootConstrainSelectedInstOperands,
     /* 226141 */     // GIR_Coverage, 10142,
     /* 226141 */     GIR_EraseRootFromParent_Done,
     /* 226142 */   // Label 4536: @226142
     /* 226142 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(226184), // Rule ID 10143 //
     /* 226147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 226155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226171 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1313:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 226174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226182 */     GIR_RootConstrainSelectedInstOperands,
     /* 226183 */     // GIR_Coverage, 10143,
     /* 226183 */     GIR_EraseRootFromParent_Done,
     /* 226184 */   // Label 4537: @226184
     /* 226184 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(226226), // Rule ID 10147 //
     /* 226189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 226197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226213 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 226216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226224 */     GIR_RootConstrainSelectedInstOperands,
     /* 226225 */     // GIR_Coverage, 10147,
     /* 226225 */     GIR_EraseRootFromParent_Done,
     /* 226226 */   // Label 4538: @226226
     /* 226226 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(226268), // Rule ID 10151 //
     /* 226231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 226239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226255 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1312:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 226258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226266 */     GIR_RootConstrainSelectedInstOperands,
     /* 226267 */     // GIR_Coverage, 10151,
     /* 226267 */     GIR_EraseRootFromParent_Done,
     /* 226268 */   // Label 4539: @226268
     /* 226268 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(226310), // Rule ID 10155 //
     /* 226273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 226281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 226300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226308 */     GIR_RootConstrainSelectedInstOperands,
     /* 226309 */     // GIR_Coverage, 10155,
     /* 226309 */     GIR_EraseRootFromParent_Done,
     /* 226310 */   // Label 4540: @226310
     /* 226310 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(226352), // Rule ID 10159 //
     /* 226315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 226323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226339 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1319:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 226342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226350 */     GIR_RootConstrainSelectedInstOperands,
     /* 226351 */     // GIR_Coverage, 10159,
     /* 226351 */     GIR_EraseRootFromParent_Done,
     /* 226352 */   // Label 4541: @226352
     /* 226352 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(226394), // Rule ID 10163 //
     /* 226357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 226365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 226384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226392 */     GIR_RootConstrainSelectedInstOperands,
     /* 226393 */     // GIR_Coverage, 10163,
     /* 226393 */     GIR_EraseRootFromParent_Done,
     /* 226394 */   // Label 4542: @226394
     /* 226394 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(226436), // Rule ID 11140 //
     /* 226399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 226402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 226407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1895:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 226426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226434 */     GIR_RootConstrainSelectedInstOperands,
     /* 226435 */     // GIR_Coverage, 11140,
     /* 226435 */     GIR_EraseRootFromParent_Done,
     /* 226436 */   // Label 4543: @226436
     /* 226436 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(226478), // Rule ID 11141 //
     /* 226441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 226444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 226449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1966:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 226468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226476 */     GIR_RootConstrainSelectedInstOperands,
     /* 226477 */     // GIR_Coverage, 11141,
     /* 226477 */     GIR_EraseRootFromParent_Done,
     /* 226478 */   // Label 4544: @226478
     /* 226478 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(226520), // Rule ID 11143 //
     /* 226483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 226486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 226491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226507 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 226510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226518 */     GIR_RootConstrainSelectedInstOperands,
     /* 226519 */     // GIR_Coverage, 11143,
     /* 226519 */     GIR_EraseRootFromParent_Done,
     /* 226520 */   // Label 4545: @226520
     /* 226520 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(226562), // Rule ID 11144 //
     /* 226525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 226528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 226533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226549 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 226552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226560 */     GIR_RootConstrainSelectedInstOperands,
     /* 226561 */     // GIR_Coverage, 11144,
     /* 226561 */     GIR_EraseRootFromParent_Done,
     /* 226562 */   // Label 4546: @226562
     /* 226562 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(226604), // Rule ID 11198 //
     /* 226567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 226575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226591 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1730:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 226594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226602 */     GIR_RootConstrainSelectedInstOperands,
     /* 226603 */     // GIR_Coverage, 11198,
     /* 226603 */     GIR_EraseRootFromParent_Done,
     /* 226604 */   // Label 4547: @226604
     /* 226604 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(226646), // Rule ID 11199 //
     /* 226609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 226617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226633 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1730:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 226636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226644 */     GIR_RootConstrainSelectedInstOperands,
     /* 226645 */     // GIR_Coverage, 11199,
     /* 226645 */     GIR_EraseRootFromParent_Done,
     /* 226646 */   // Label 4548: @226646
     /* 226646 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(226688), // Rule ID 11200 //
     /* 226651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 226659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226675 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 226678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226686 */     GIR_RootConstrainSelectedInstOperands,
     /* 226687 */     // GIR_Coverage, 11200,
     /* 226687 */     GIR_EraseRootFromParent_Done,
     /* 226688 */   // Label 4549: @226688
     /* 226688 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(226730), // Rule ID 11201 //
     /* 226693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 226701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226717 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 226720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226728 */     GIR_RootConstrainSelectedInstOperands,
     /* 226729 */     // GIR_Coverage, 11201,
     /* 226729 */     GIR_EraseRootFromParent_Done,
     /* 226730 */   // Label 4550: @226730
     /* 226730 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(226772), // Rule ID 11254 //
     /* 226735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 226743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226759 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1651:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 226762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226770 */     GIR_RootConstrainSelectedInstOperands,
     /* 226771 */     // GIR_Coverage, 11254,
     /* 226771 */     GIR_EraseRootFromParent_Done,
     /* 226772 */   // Label 4551: @226772
     /* 226772 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(226814), // Rule ID 11255 //
     /* 226777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 226785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1651:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 226804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226812 */     GIR_RootConstrainSelectedInstOperands,
     /* 226813 */     // GIR_Coverage, 11255,
     /* 226813 */     GIR_EraseRootFromParent_Done,
     /* 226814 */   // Label 4552: @226814
     /* 226814 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(226856), // Rule ID 11256 //
     /* 226819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 226827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1651:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 226846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226854 */     GIR_RootConstrainSelectedInstOperands,
     /* 226855 */     // GIR_Coverage, 11256,
     /* 226855 */     GIR_EraseRootFromParent_Done,
     /* 226856 */   // Label 4553: @226856
     /* 226856 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(226898), // Rule ID 11257 //
     /* 226861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 226869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226885 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1887:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 226888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226896 */     GIR_RootConstrainSelectedInstOperands,
     /* 226897 */     // GIR_Coverage, 11257,
     /* 226897 */     GIR_EraseRootFromParent_Done,
     /* 226898 */   // Label 4554: @226898
     /* 226898 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(226940), // Rule ID 11258 //
     /* 226903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 226911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1887:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 226930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226938 */     GIR_RootConstrainSelectedInstOperands,
     /* 226939 */     // GIR_Coverage, 11258,
     /* 226939 */     GIR_EraseRootFromParent_Done,
     /* 226940 */   // Label 4555: @226940
     /* 226940 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(226982), // Rule ID 11259 //
     /* 226945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 226953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1887:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 226972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226980 */     GIR_RootConstrainSelectedInstOperands,
     /* 226981 */     // GIR_Coverage, 11259,
     /* 226981 */     GIR_EraseRootFromParent_Done,
     /* 226982 */   // Label 4556: @226982
     /* 226982 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(227024), // Rule ID 11260 //
     /* 226987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 226995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227011 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1889:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 227014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227022 */     GIR_RootConstrainSelectedInstOperands,
     /* 227023 */     // GIR_Coverage, 11260,
     /* 227023 */     GIR_EraseRootFromParent_Done,
     /* 227024 */   // Label 4557: @227024
     /* 227024 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(227066), // Rule ID 11261 //
     /* 227029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 227037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227053 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1889:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 227056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227064 */     GIR_RootConstrainSelectedInstOperands,
     /* 227065 */     // GIR_Coverage, 11261,
     /* 227065 */     GIR_EraseRootFromParent_Done,
     /* 227066 */   // Label 4558: @227066
     /* 227066 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(227108), // Rule ID 11262 //
     /* 227071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 227079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227095 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1889:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 227098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227106 */     GIR_RootConstrainSelectedInstOperands,
     /* 227107 */     // GIR_Coverage, 11262,
     /* 227107 */     GIR_EraseRootFromParent_Done,
     /* 227108 */   // Label 4559: @227108
     /* 227108 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(227150), // Rule ID 11263 //
     /* 227113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 227121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227137 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1653:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 227140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227148 */     GIR_RootConstrainSelectedInstOperands,
     /* 227149 */     // GIR_Coverage, 11263,
     /* 227149 */     GIR_EraseRootFromParent_Done,
     /* 227150 */   // Label 4560: @227150
     /* 227150 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(227192), // Rule ID 11264 //
     /* 227155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 227163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227179 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1653:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 227182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227190 */     GIR_RootConstrainSelectedInstOperands,
     /* 227191 */     // GIR_Coverage, 11264,
     /* 227191 */     GIR_EraseRootFromParent_Done,
     /* 227192 */   // Label 4561: @227192
     /* 227192 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(227234), // Rule ID 11265 //
     /* 227197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 227205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1653:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 227224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227232 */     GIR_RootConstrainSelectedInstOperands,
     /* 227233 */     // GIR_Coverage, 11265,
     /* 227233 */     GIR_EraseRootFromParent_Done,
     /* 227234 */   // Label 4562: @227234
     /* 227234 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(227276), // Rule ID 11266 //
     /* 227239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 227247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227263 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1655:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 227266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227274 */     GIR_RootConstrainSelectedInstOperands,
     /* 227275 */     // GIR_Coverage, 11266,
     /* 227275 */     GIR_EraseRootFromParent_Done,
     /* 227276 */   // Label 4563: @227276
     /* 227276 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(227318), // Rule ID 11267 //
     /* 227281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 227289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1655:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 227308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227316 */     GIR_RootConstrainSelectedInstOperands,
     /* 227317 */     // GIR_Coverage, 11267,
     /* 227317 */     GIR_EraseRootFromParent_Done,
     /* 227318 */   // Label 4564: @227318
     /* 227318 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(227360), // Rule ID 11268 //
     /* 227323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 227331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227347 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1655:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 227350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227358 */     GIR_RootConstrainSelectedInstOperands,
     /* 227359 */     // GIR_Coverage, 11268,
     /* 227359 */     GIR_EraseRootFromParent_Done,
     /* 227360 */   // Label 4565: @227360
     /* 227360 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(227402), // Rule ID 11269 //
     /* 227365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 227373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1891:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 227392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227400 */     GIR_RootConstrainSelectedInstOperands,
     /* 227401 */     // GIR_Coverage, 11269,
     /* 227401 */     GIR_EraseRootFromParent_Done,
     /* 227402 */   // Label 4566: @227402
     /* 227402 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(227444), // Rule ID 11270 //
     /* 227407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 227415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1891:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 227434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227442 */     GIR_RootConstrainSelectedInstOperands,
     /* 227443 */     // GIR_Coverage, 11270,
     /* 227443 */     GIR_EraseRootFromParent_Done,
     /* 227444 */   // Label 4567: @227444
     /* 227444 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(227486), // Rule ID 11271 //
     /* 227449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 227457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1891:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 227476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227484 */     GIR_RootConstrainSelectedInstOperands,
     /* 227485 */     // GIR_Coverage, 11271,
     /* 227485 */     GIR_EraseRootFromParent_Done,
     /* 227486 */   // Label 4568: @227486
     /* 227486 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(227528), // Rule ID 11272 //
     /* 227491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 227499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1893:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 227518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227526 */     GIR_RootConstrainSelectedInstOperands,
     /* 227527 */     // GIR_Coverage, 11272,
     /* 227527 */     GIR_EraseRootFromParent_Done,
     /* 227528 */   // Label 4569: @227528
     /* 227528 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(227570), // Rule ID 11273 //
     /* 227533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 227541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1893:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 227560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227568 */     GIR_RootConstrainSelectedInstOperands,
     /* 227569 */     // GIR_Coverage, 11273,
     /* 227569 */     GIR_EraseRootFromParent_Done,
     /* 227570 */   // Label 4570: @227570
     /* 227570 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(227612), // Rule ID 11274 //
     /* 227575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 227583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227599 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1893:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 227602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227610 */     GIR_RootConstrainSelectedInstOperands,
     /* 227611 */     // GIR_Coverage, 11274,
     /* 227611 */     GIR_EraseRootFromParent_Done,
     /* 227612 */   // Label 4571: @227612
     /* 227612 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(227654), // Rule ID 11283 //
     /* 227617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 227625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227641 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 227644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227652 */     GIR_RootConstrainSelectedInstOperands,
     /* 227653 */     // GIR_Coverage, 11283,
     /* 227653 */     GIR_EraseRootFromParent_Done,
     /* 227654 */   // Label 4572: @227654
     /* 227654 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(227696), // Rule ID 11284 //
     /* 227659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 227667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227683 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 227686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227694 */     GIR_RootConstrainSelectedInstOperands,
     /* 227695 */     // GIR_Coverage, 11284,
     /* 227695 */     GIR_EraseRootFromParent_Done,
     /* 227696 */   // Label 4573: @227696
     /* 227696 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(227738), // Rule ID 11285 //
     /* 227701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 227709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 227728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227736 */     GIR_RootConstrainSelectedInstOperands,
     /* 227737 */     // GIR_Coverage, 11285,
     /* 227737 */     GIR_EraseRootFromParent_Done,
     /* 227738 */   // Label 4574: @227738
     /* 227738 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(227780), // Rule ID 11286 //
     /* 227743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 227751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227767 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1694:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 227770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227778 */     GIR_RootConstrainSelectedInstOperands,
     /* 227779 */     // GIR_Coverage, 11286,
     /* 227779 */     GIR_EraseRootFromParent_Done,
     /* 227780 */   // Label 4575: @227780
     /* 227780 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(227822), // Rule ID 11287 //
     /* 227785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 227793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 227812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227820 */     GIR_RootConstrainSelectedInstOperands,
     /* 227821 */     // GIR_Coverage, 11287,
     /* 227821 */     GIR_EraseRootFromParent_Done,
     /* 227822 */   // Label 4576: @227822
     /* 227822 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(227864), // Rule ID 11288 //
     /* 227827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 227835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 227854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227862 */     GIR_RootConstrainSelectedInstOperands,
     /* 227863 */     // GIR_Coverage, 11288,
     /* 227863 */     GIR_EraseRootFromParent_Done,
     /* 227864 */   // Label 4577: @227864
     /* 227864 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(227906), // Rule ID 11289 //
     /* 227869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 227877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 227896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227904 */     GIR_RootConstrainSelectedInstOperands,
     /* 227905 */     // GIR_Coverage, 11289,
     /* 227905 */     GIR_EraseRootFromParent_Done,
     /* 227906 */   // Label 4578: @227906
     /* 227906 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(227948), // Rule ID 11290 //
     /* 227911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 227919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227935 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 227938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227946 */     GIR_RootConstrainSelectedInstOperands,
     /* 227947 */     // GIR_Coverage, 11290,
     /* 227947 */     GIR_EraseRootFromParent_Done,
     /* 227948 */   // Label 4579: @227948
     /* 227948 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(227990), // Rule ID 11291 //
     /* 227953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 227961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 227980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227988 */     GIR_RootConstrainSelectedInstOperands,
     /* 227989 */     // GIR_Coverage, 11291,
     /* 227989 */     GIR_EraseRootFromParent_Done,
     /* 227990 */   // Label 4580: @227990
     /* 227990 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(228032), // Rule ID 11292 //
     /* 227995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 228003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 228022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228030 */     GIR_RootConstrainSelectedInstOperands,
     /* 228031 */     // GIR_Coverage, 11292,
     /* 228031 */     GIR_EraseRootFromParent_Done,
     /* 228032 */   // Label 4581: @228032
     /* 228032 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(228074), // Rule ID 11293 //
     /* 228037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 228045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 228064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228072 */     GIR_RootConstrainSelectedInstOperands,
     /* 228073 */     // GIR_Coverage, 11293,
     /* 228073 */     GIR_EraseRootFromParent_Done,
     /* 228074 */   // Label 4582: @228074
     /* 228074 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(228116), // Rule ID 11294 //
     /* 228079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 228087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228103 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 228106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228114 */     GIR_RootConstrainSelectedInstOperands,
     /* 228115 */     // GIR_Coverage, 11294,
     /* 228115 */     GIR_EraseRootFromParent_Done,
     /* 228116 */   // Label 4583: @228116
     /* 228116 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(228158), // Rule ID 11295 //
     /* 228121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 228129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228145 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 228148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228156 */     GIR_RootConstrainSelectedInstOperands,
     /* 228157 */     // GIR_Coverage, 11295,
     /* 228157 */     GIR_EraseRootFromParent_Done,
     /* 228158 */   // Label 4584: @228158
     /* 228158 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(228200), // Rule ID 11296 //
     /* 228163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 228171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228187 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 228190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228198 */     GIR_RootConstrainSelectedInstOperands,
     /* 228199 */     // GIR_Coverage, 11296,
     /* 228199 */     GIR_EraseRootFromParent_Done,
     /* 228200 */   // Label 4585: @228200
     /* 228200 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(228242), // Rule ID 11297 //
     /* 228205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 228213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228229 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 228232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228240 */     GIR_RootConstrainSelectedInstOperands,
     /* 228241 */     // GIR_Coverage, 11297,
     /* 228241 */     GIR_EraseRootFromParent_Done,
     /* 228242 */   // Label 4586: @228242
     /* 228242 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(228284), // Rule ID 11298 //
     /* 228247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 228255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228271 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1698:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 228274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228282 */     GIR_RootConstrainSelectedInstOperands,
     /* 228283 */     // GIR_Coverage, 11298,
     /* 228283 */     GIR_EraseRootFromParent_Done,
     /* 228284 */   // Label 4587: @228284
     /* 228284 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(228326), // Rule ID 11299 //
     /* 228289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 228297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228313 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 228316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228324 */     GIR_RootConstrainSelectedInstOperands,
     /* 228325 */     // GIR_Coverage, 11299,
     /* 228325 */     GIR_EraseRootFromParent_Done,
     /* 228326 */   // Label 4588: @228326
     /* 228326 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(228368), // Rule ID 11300 //
     /* 228331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 228339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1698:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 228358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228366 */     GIR_RootConstrainSelectedInstOperands,
     /* 228367 */     // GIR_Coverage, 11300,
     /* 228367 */     GIR_EraseRootFromParent_Done,
     /* 228368 */   // Label 4589: @228368
     /* 228368 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(228410), // Rule ID 11301 //
     /* 228373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 228381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228397 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 228400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228408 */     GIR_RootConstrainSelectedInstOperands,
     /* 228409 */     // GIR_Coverage, 11301,
     /* 228409 */     GIR_EraseRootFromParent_Done,
     /* 228410 */   // Label 4590: @228410
     /* 228410 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(228452), // Rule ID 11303 //
     /* 228415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 228423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228439 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 228442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228450 */     GIR_RootConstrainSelectedInstOperands,
     /* 228451 */     // GIR_Coverage, 11303,
     /* 228451 */     GIR_EraseRootFromParent_Done,
     /* 228452 */   // Label 4591: @228452
     /* 228452 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(228494), // Rule ID 11305 //
     /* 228457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 228465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 228484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228492 */     GIR_RootConstrainSelectedInstOperands,
     /* 228493 */     // GIR_Coverage, 11305,
     /* 228493 */     GIR_EraseRootFromParent_Done,
     /* 228494 */   // Label 4592: @228494
     /* 228494 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(228536), // Rule ID 11307 //
     /* 228499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 228507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 228526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228534 */     GIR_RootConstrainSelectedInstOperands,
     /* 228535 */     // GIR_Coverage, 11307,
     /* 228535 */     GIR_EraseRootFromParent_Done,
     /* 228536 */   // Label 4593: @228536
     /* 228536 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(228578), // Rule ID 11309 //
     /* 228541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 228549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228565 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 228568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228576 */     GIR_RootConstrainSelectedInstOperands,
     /* 228577 */     // GIR_Coverage, 11309,
     /* 228577 */     GIR_EraseRootFromParent_Done,
     /* 228578 */   // Label 4594: @228578
     /* 228578 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(228620), // Rule ID 11310 //
     /* 228583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 228591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228607 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 228610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228618 */     GIR_RootConstrainSelectedInstOperands,
     /* 228619 */     // GIR_Coverage, 11310,
     /* 228619 */     GIR_EraseRootFromParent_Done,
     /* 228620 */   // Label 4595: @228620
     /* 228620 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(228662), // Rule ID 11311 //
     /* 228625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 228633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228649 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 228652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228660 */     GIR_RootConstrainSelectedInstOperands,
     /* 228661 */     // GIR_Coverage, 11311,
     /* 228661 */     GIR_EraseRootFromParent_Done,
     /* 228662 */   // Label 4596: @228662
     /* 228662 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(228704), // Rule ID 11312 //
     /* 228667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 228675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 228694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228702 */     GIR_RootConstrainSelectedInstOperands,
     /* 228703 */     // GIR_Coverage, 11312,
     /* 228703 */     GIR_EraseRootFromParent_Done,
     /* 228704 */   // Label 4597: @228704
     /* 228704 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(228746), // Rule ID 11313 //
     /* 228709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 228717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1867:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 228736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228744 */     GIR_RootConstrainSelectedInstOperands,
     /* 228745 */     // GIR_Coverage, 11313,
     /* 228745 */     GIR_EraseRootFromParent_Done,
     /* 228746 */   // Label 4598: @228746
     /* 228746 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(228788), // Rule ID 11314 //
     /* 228751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 228759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228775 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 228778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228786 */     GIR_RootConstrainSelectedInstOperands,
     /* 228787 */     // GIR_Coverage, 11314,
     /* 228787 */     GIR_EraseRootFromParent_Done,
     /* 228788 */   // Label 4599: @228788
     /* 228788 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(228830), // Rule ID 11315 //
     /* 228793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 228801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 228820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228828 */     GIR_RootConstrainSelectedInstOperands,
     /* 228829 */     // GIR_Coverage, 11315,
     /* 228829 */     GIR_EraseRootFromParent_Done,
     /* 228830 */   // Label 4600: @228830
     /* 228830 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(228872), // Rule ID 11316 //
     /* 228835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 228843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 228862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228870 */     GIR_RootConstrainSelectedInstOperands,
     /* 228871 */     // GIR_Coverage, 11316,
     /* 228871 */     GIR_EraseRootFromParent_Done,
     /* 228872 */   // Label 4601: @228872
     /* 228872 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(228914), // Rule ID 11317 //
     /* 228877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 228885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228901 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1761:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 228904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228912 */     GIR_RootConstrainSelectedInstOperands,
     /* 228913 */     // GIR_Coverage, 11317,
     /* 228913 */     GIR_EraseRootFromParent_Done,
     /* 228914 */   // Label 4602: @228914
     /* 228914 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(228956), // Rule ID 11319 //
     /* 228919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 228927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1761:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 228946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228954 */     GIR_RootConstrainSelectedInstOperands,
     /* 228955 */     // GIR_Coverage, 11319,
     /* 228955 */     GIR_EraseRootFromParent_Done,
     /* 228956 */   // Label 4603: @228956
     /* 228956 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(228998), // Rule ID 11321 //
     /* 228961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 228969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 228988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228996 */     GIR_RootConstrainSelectedInstOperands,
     /* 228997 */     // GIR_Coverage, 11321,
     /* 228997 */     GIR_EraseRootFromParent_Done,
     /* 228998 */   // Label 4604: @228998
     /* 228998 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(229040), // Rule ID 11323 //
     /* 229003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 229011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229027 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1761:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 229030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229038 */     GIR_RootConstrainSelectedInstOperands,
     /* 229039 */     // GIR_Coverage, 11323,
     /* 229039 */     GIR_EraseRootFromParent_Done,
     /* 229040 */   // Label 4605: @229040
     /* 229040 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(229082), // Rule ID 11325 //
     /* 229045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 229053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1953:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 229072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229080 */     GIR_RootConstrainSelectedInstOperands,
     /* 229081 */     // GIR_Coverage, 11325,
     /* 229081 */     GIR_EraseRootFromParent_Done,
     /* 229082 */   // Label 4606: @229082
     /* 229082 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(229124), // Rule ID 11327 //
     /* 229087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 229095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1953:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 229114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229122 */     GIR_RootConstrainSelectedInstOperands,
     /* 229123 */     // GIR_Coverage, 11327,
     /* 229123 */     GIR_EraseRootFromParent_Done,
     /* 229124 */   // Label 4607: @229124
     /* 229124 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(229166), // Rule ID 11329 //
     /* 229129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 229137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 229156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229164 */     GIR_RootConstrainSelectedInstOperands,
     /* 229165 */     // GIR_Coverage, 11329,
     /* 229165 */     GIR_EraseRootFromParent_Done,
     /* 229166 */   // Label 4608: @229166
     /* 229166 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(229208), // Rule ID 11331 //
     /* 229171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 229179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 229198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229206 */     GIR_RootConstrainSelectedInstOperands,
     /* 229207 */     // GIR_Coverage, 11331,
     /* 229207 */     GIR_EraseRootFromParent_Done,
     /* 229208 */   // Label 4609: @229208
     /* 229208 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(229250), // Rule ID 11333 //
     /* 229213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 229221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229237 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1627:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 229240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229248 */     GIR_RootConstrainSelectedInstOperands,
     /* 229249 */     // GIR_Coverage, 11333,
     /* 229249 */     GIR_EraseRootFromParent_Done,
     /* 229250 */   // Label 4610: @229250
     /* 229250 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(229292), // Rule ID 11334 //
     /* 229255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 229263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1627:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 229282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229290 */     GIR_RootConstrainSelectedInstOperands,
     /* 229291 */     // GIR_Coverage, 11334,
     /* 229291 */     GIR_EraseRootFromParent_Done,
     /* 229292 */   // Label 4611: @229292
     /* 229292 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(229334), // Rule ID 11335 //
     /* 229297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 229305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229321 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1627:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 229324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229332 */     GIR_RootConstrainSelectedInstOperands,
     /* 229333 */     // GIR_Coverage, 11335,
     /* 229333 */     GIR_EraseRootFromParent_Done,
     /* 229334 */   // Label 4612: @229334
     /* 229334 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(229376), // Rule ID 11336 //
     /* 229339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 229347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1627:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 229366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229374 */     GIR_RootConstrainSelectedInstOperands,
     /* 229375 */     // GIR_Coverage, 11336,
     /* 229375 */     GIR_EraseRootFromParent_Done,
     /* 229376 */   // Label 4613: @229376
     /* 229376 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(229418), // Rule ID 11337 //
     /* 229381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 229389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229405 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1868:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 229408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229416 */     GIR_RootConstrainSelectedInstOperands,
     /* 229417 */     // GIR_Coverage, 11337,
     /* 229417 */     GIR_EraseRootFromParent_Done,
     /* 229418 */   // Label 4614: @229418
     /* 229418 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(229460), // Rule ID 11338 //
     /* 229423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 229431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229447 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 229450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229458 */     GIR_RootConstrainSelectedInstOperands,
     /* 229459 */     // GIR_Coverage, 11338,
     /* 229459 */     GIR_EraseRootFromParent_Done,
     /* 229460 */   // Label 4615: @229460
     /* 229460 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(229502), // Rule ID 11339 //
     /* 229465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 229473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 229492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229500 */     GIR_RootConstrainSelectedInstOperands,
     /* 229501 */     // GIR_Coverage, 11339,
     /* 229501 */     GIR_EraseRootFromParent_Done,
     /* 229502 */   // Label 4616: @229502
     /* 229502 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(229544), // Rule ID 11340 //
     /* 229507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 229515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 229534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229542 */     GIR_RootConstrainSelectedInstOperands,
     /* 229543 */     // GIR_Coverage, 11340,
     /* 229543 */     GIR_EraseRootFromParent_Done,
     /* 229544 */   // Label 4617: @229544
     /* 229544 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(229586), // Rule ID 11341 //
     /* 229549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 229557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 229576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229584 */     GIR_RootConstrainSelectedInstOperands,
     /* 229585 */     // GIR_Coverage, 11341,
     /* 229585 */     GIR_EraseRootFromParent_Done,
     /* 229586 */   // Label 4618: @229586
     /* 229586 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(229628), // Rule ID 11342 //
     /* 229591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 229599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229615 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 229618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229626 */     GIR_RootConstrainSelectedInstOperands,
     /* 229627 */     // GIR_Coverage, 11342,
     /* 229627 */     GIR_EraseRootFromParent_Done,
     /* 229628 */   // Label 4619: @229628
     /* 229628 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(229670), // Rule ID 11343 //
     /* 229633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 229641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1843:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 229660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229668 */     GIR_RootConstrainSelectedInstOperands,
     /* 229669 */     // GIR_Coverage, 11343,
     /* 229669 */     GIR_EraseRootFromParent_Done,
     /* 229670 */   // Label 4620: @229670
     /* 229670 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(229712), // Rule ID 11344 //
     /* 229675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 229683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 229702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229710 */     GIR_RootConstrainSelectedInstOperands,
     /* 229711 */     // GIR_Coverage, 11344,
     /* 229711 */     GIR_EraseRootFromParent_Done,
     /* 229712 */   // Label 4621: @229712
     /* 229712 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(229754), // Rule ID 11345 //
     /* 229717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 229725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1158:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 229744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229752 */     GIR_RootConstrainSelectedInstOperands,
     /* 229753 */     // GIR_Coverage, 11345,
     /* 229753 */     GIR_EraseRootFromParent_Done,
     /* 229754 */   // Label 4622: @229754
     /* 229754 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(229796), // Rule ID 11346 //
     /* 229759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 229767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1158:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 229786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229794 */     GIR_RootConstrainSelectedInstOperands,
     /* 229795 */     // GIR_Coverage, 11346,
     /* 229795 */     GIR_EraseRootFromParent_Done,
     /* 229796 */   // Label 4623: @229796
     /* 229796 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(229838), // Rule ID 11347 //
     /* 229801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 229809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229825 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1158:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 229828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229836 */     GIR_RootConstrainSelectedInstOperands,
     /* 229837 */     // GIR_Coverage, 11347,
     /* 229837 */     GIR_EraseRootFromParent_Done,
     /* 229838 */   // Label 4624: @229838
     /* 229838 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(229880), // Rule ID 11348 //
     /* 229843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 229851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1637:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 229870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229878 */     GIR_RootConstrainSelectedInstOperands,
     /* 229879 */     // GIR_Coverage, 11348,
     /* 229879 */     GIR_EraseRootFromParent_Done,
     /* 229880 */   // Label 4625: @229880
     /* 229880 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(229922), // Rule ID 11349 //
     /* 229885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 229893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1637:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 229912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229920 */     GIR_RootConstrainSelectedInstOperands,
     /* 229921 */     // GIR_Coverage, 11349,
     /* 229921 */     GIR_EraseRootFromParent_Done,
     /* 229922 */   // Label 4626: @229922
     /* 229922 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(229964), // Rule ID 11350 //
     /* 229927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 229935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1637:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 229954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229962 */     GIR_RootConstrainSelectedInstOperands,
     /* 229963 */     // GIR_Coverage, 11350,
     /* 229963 */     GIR_EraseRootFromParent_Done,
     /* 229964 */   // Label 4627: @229964
     /* 229964 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(230006), // Rule ID 11351 //
     /* 229969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 229977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1637:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 229996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230004 */     GIR_RootConstrainSelectedInstOperands,
     /* 230005 */     // GIR_Coverage, 11351,
     /* 230005 */     GIR_EraseRootFromParent_Done,
     /* 230006 */   // Label 4628: @230006
     /* 230006 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(230048), // Rule ID 11352 //
     /* 230011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 230019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1875:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 230038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230046 */     GIR_RootConstrainSelectedInstOperands,
     /* 230047 */     // GIR_Coverage, 11352,
     /* 230047 */     GIR_EraseRootFromParent_Done,
     /* 230048 */   // Label 4629: @230048
     /* 230048 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(230090), // Rule ID 11353 //
     /* 230053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 230061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 230080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230088 */     GIR_RootConstrainSelectedInstOperands,
     /* 230089 */     // GIR_Coverage, 11353,
     /* 230089 */     GIR_EraseRootFromParent_Done,
     /* 230090 */   // Label 4630: @230090
     /* 230090 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(230132), // Rule ID 11354 //
     /* 230095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 230103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 230122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230130 */     GIR_RootConstrainSelectedInstOperands,
     /* 230131 */     // GIR_Coverage, 11354,
     /* 230131 */     GIR_EraseRootFromParent_Done,
     /* 230132 */   // Label 4631: @230132
     /* 230132 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(230174), // Rule ID 11355 //
     /* 230137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 230145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 230164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230172 */     GIR_RootConstrainSelectedInstOperands,
     /* 230173 */     // GIR_Coverage, 11355,
     /* 230173 */     GIR_EraseRootFromParent_Done,
     /* 230174 */   // Label 4632: @230174
     /* 230174 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(230216), // Rule ID 11356 //
     /* 230179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 230187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230203 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1646:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 230206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230214 */     GIR_RootConstrainSelectedInstOperands,
     /* 230215 */     // GIR_Coverage, 11356,
     /* 230215 */     GIR_EraseRootFromParent_Done,
     /* 230216 */   // Label 4633: @230216
     /* 230216 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(230258), // Rule ID 11357 //
     /* 230221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 230229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1646:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 230248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230256 */     GIR_RootConstrainSelectedInstOperands,
     /* 230257 */     // GIR_Coverage, 11357,
     /* 230257 */     GIR_EraseRootFromParent_Done,
     /* 230258 */   // Label 4634: @230258
     /* 230258 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(230300), // Rule ID 11358 //
     /* 230263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 230271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1646:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 230290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230298 */     GIR_RootConstrainSelectedInstOperands,
     /* 230299 */     // GIR_Coverage, 11358,
     /* 230299 */     GIR_EraseRootFromParent_Done,
     /* 230300 */   // Label 4635: @230300
     /* 230300 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(230342), // Rule ID 11359 //
     /* 230305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 230313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1646:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 230332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230340 */     GIR_RootConstrainSelectedInstOperands,
     /* 230341 */     // GIR_Coverage, 11359,
     /* 230341 */     GIR_EraseRootFromParent_Done,
     /* 230342 */   // Label 4636: @230342
     /* 230342 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(230384), // Rule ID 11360 //
     /* 230347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 230355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1884:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 230374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230382 */     GIR_RootConstrainSelectedInstOperands,
     /* 230383 */     // GIR_Coverage, 11360,
     /* 230383 */     GIR_EraseRootFromParent_Done,
     /* 230384 */   // Label 4637: @230384
     /* 230384 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(230426), // Rule ID 11361 //
     /* 230389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 230397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230413 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1884:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 230416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230424 */     GIR_RootConstrainSelectedInstOperands,
     /* 230425 */     // GIR_Coverage, 11361,
     /* 230425 */     GIR_EraseRootFromParent_Done,
     /* 230426 */   // Label 4638: @230426
     /* 230426 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(230468), // Rule ID 11362 //
     /* 230431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 230439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230455 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1884:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 230458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230466 */     GIR_RootConstrainSelectedInstOperands,
     /* 230467 */     // GIR_Coverage, 11362,
     /* 230467 */     GIR_EraseRootFromParent_Done,
     /* 230468 */   // Label 4639: @230468
     /* 230468 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(230510), // Rule ID 11363 //
     /* 230473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 230481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1884:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 230500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230508 */     GIR_RootConstrainSelectedInstOperands,
     /* 230509 */     // GIR_Coverage, 11363,
     /* 230509 */     GIR_EraseRootFromParent_Done,
     /* 230510 */   // Label 4640: @230510
     /* 230510 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(230552), // Rule ID 11364 //
     /* 230515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 230523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 230542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230550 */     GIR_RootConstrainSelectedInstOperands,
     /* 230551 */     // GIR_Coverage, 11364,
     /* 230551 */     GIR_EraseRootFromParent_Done,
     /* 230552 */   // Label 4641: @230552
     /* 230552 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(230594), // Rule ID 11375 //
     /* 230557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230581 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 230584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230592 */     GIR_RootConstrainSelectedInstOperands,
     /* 230593 */     // GIR_Coverage, 11375,
     /* 230593 */     GIR_EraseRootFromParent_Done,
     /* 230594 */   // Label 4642: @230594
     /* 230594 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(230636), // Rule ID 11376 //
     /* 230599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230623 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 230626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230634 */     GIR_RootConstrainSelectedInstOperands,
     /* 230635 */     // GIR_Coverage, 11376,
     /* 230635 */     GIR_EraseRootFromParent_Done,
     /* 230636 */   // Label 4643: @230636
     /* 230636 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(230678), // Rule ID 11377 //
     /* 230641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 230668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230676 */     GIR_RootConstrainSelectedInstOperands,
     /* 230677 */     // GIR_Coverage, 11377,
     /* 230677 */     GIR_EraseRootFromParent_Done,
     /* 230678 */   // Label 4644: @230678
     /* 230678 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(230720), // Rule ID 11378 //
     /* 230683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1725:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 230710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230718 */     GIR_RootConstrainSelectedInstOperands,
     /* 230719 */     // GIR_Coverage, 11378,
     /* 230719 */     GIR_EraseRootFromParent_Done,
     /* 230720 */   // Label 4645: @230720
     /* 230720 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(230762), // Rule ID 11387 //
     /* 230725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 230733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230749 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1666:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 230752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230760 */     GIR_RootConstrainSelectedInstOperands,
     /* 230761 */     // GIR_Coverage, 11387,
     /* 230761 */     GIR_EraseRootFromParent_Done,
     /* 230762 */   // Label 4646: @230762
     /* 230762 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(230804), // Rule ID 11388 //
     /* 230767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 230775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1666:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 230794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230802 */     GIR_RootConstrainSelectedInstOperands,
     /* 230803 */     // GIR_Coverage, 11388,
     /* 230803 */     GIR_EraseRootFromParent_Done,
     /* 230804 */   // Label 4647: @230804
     /* 230804 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(230846), // Rule ID 11389 //
     /* 230809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 230817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 230836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230844 */     GIR_RootConstrainSelectedInstOperands,
     /* 230845 */     // GIR_Coverage, 11389,
     /* 230845 */     GIR_EraseRootFromParent_Done,
     /* 230846 */   // Label 4648: @230846
     /* 230846 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(230888), // Rule ID 11390 //
     /* 230851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 230859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1666:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 230878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230886 */     GIR_RootConstrainSelectedInstOperands,
     /* 230887 */     // GIR_Coverage, 11390,
     /* 230887 */     GIR_EraseRootFromParent_Done,
     /* 230888 */   // Label 4649: @230888
     /* 230888 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(230930), // Rule ID 11391 //
     /* 230893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 230901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1902:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 230920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230928 */     GIR_RootConstrainSelectedInstOperands,
     /* 230929 */     // GIR_Coverage, 11391,
     /* 230929 */     GIR_EraseRootFromParent_Done,
     /* 230930 */   // Label 4650: @230930
     /* 230930 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(230972), // Rule ID 11392 //
     /* 230935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 230943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1902:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 230962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230970 */     GIR_RootConstrainSelectedInstOperands,
     /* 230971 */     // GIR_Coverage, 11392,
     /* 230971 */     GIR_EraseRootFromParent_Done,
     /* 230972 */   // Label 4651: @230972
     /* 230972 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(231014), // Rule ID 11393 //
     /* 230977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 230985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1902:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 231004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231012 */     GIR_RootConstrainSelectedInstOperands,
     /* 231013 */     // GIR_Coverage, 11393,
     /* 231013 */     GIR_EraseRootFromParent_Done,
     /* 231014 */   // Label 4652: @231014
     /* 231014 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(231056), // Rule ID 11394 //
     /* 231019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 231027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1902:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 231046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231054 */     GIR_RootConstrainSelectedInstOperands,
     /* 231055 */     // GIR_Coverage, 11394,
     /* 231055 */     GIR_EraseRootFromParent_Done,
     /* 231056 */   // Label 4653: @231056
     /* 231056 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(231098), // Rule ID 11395 //
     /* 231061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 231069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1753:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 231088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231096 */     GIR_RootConstrainSelectedInstOperands,
     /* 231097 */     // GIR_Coverage, 11395,
     /* 231097 */     GIR_EraseRootFromParent_Done,
     /* 231098 */   // Label 4654: @231098
     /* 231098 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(231140), // Rule ID 11396 //
     /* 231103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 231111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231127 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 231130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231138 */     GIR_RootConstrainSelectedInstOperands,
     /* 231139 */     // GIR_Coverage, 11396,
     /* 231139 */     GIR_EraseRootFromParent_Done,
     /* 231140 */   // Label 4655: @231140
     /* 231140 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(231182), // Rule ID 11397 //
     /* 231145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 231153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 231172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231180 */     GIR_RootConstrainSelectedInstOperands,
     /* 231181 */     // GIR_Coverage, 11397,
     /* 231181 */     GIR_EraseRootFromParent_Done,
     /* 231182 */   // Label 4656: @231182
     /* 231182 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(231224), // Rule ID 11398 //
     /* 231187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 231195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 231214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231222 */     GIR_RootConstrainSelectedInstOperands,
     /* 231223 */     // GIR_Coverage, 11398,
     /* 231223 */     GIR_EraseRootFromParent_Done,
     /* 231224 */   // Label 4657: @231224
     /* 231224 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(231266), // Rule ID 11399 //
     /* 231229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 231237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231253 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1946:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 231256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231264 */     GIR_RootConstrainSelectedInstOperands,
     /* 231265 */     // GIR_Coverage, 11399,
     /* 231265 */     GIR_EraseRootFromParent_Done,
     /* 231266 */   // Label 4658: @231266
     /* 231266 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(231308), // Rule ID 11400 //
     /* 231271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 231279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231295 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 231298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231306 */     GIR_RootConstrainSelectedInstOperands,
     /* 231307 */     // GIR_Coverage, 11400,
     /* 231307 */     GIR_EraseRootFromParent_Done,
     /* 231308 */   // Label 4659: @231308
     /* 231308 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(231350), // Rule ID 11401 //
     /* 231313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 231321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 231340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231348 */     GIR_RootConstrainSelectedInstOperands,
     /* 231349 */     // GIR_Coverage, 11401,
     /* 231349 */     GIR_EraseRootFromParent_Done,
     /* 231350 */   // Label 4660: @231350
     /* 231350 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(231392), // Rule ID 11402 //
     /* 231355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 231363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 231382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231390 */     GIR_RootConstrainSelectedInstOperands,
     /* 231391 */     // GIR_Coverage, 11402,
     /* 231391 */     GIR_EraseRootFromParent_Done,
     /* 231392 */   // Label 4661: @231392
     /* 231392 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(231434), // Rule ID 11403 //
     /* 231397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 231405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1817:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 231424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231432 */     GIR_RootConstrainSelectedInstOperands,
     /* 231433 */     // GIR_Coverage, 11403,
     /* 231433 */     GIR_EraseRootFromParent_Done,
     /* 231434 */   // Label 4662: @231434
     /* 231434 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(231476), // Rule ID 11404 //
     /* 231439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 231447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 231466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231474 */     GIR_RootConstrainSelectedInstOperands,
     /* 231475 */     // GIR_Coverage, 11404,
     /* 231475 */     GIR_EraseRootFromParent_Done,
     /* 231476 */   // Label 4663: @231476
     /* 231476 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(231518), // Rule ID 11405 //
     /* 231481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 231489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1817:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 231508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231516 */     GIR_RootConstrainSelectedInstOperands,
     /* 231517 */     // GIR_Coverage, 11405,
     /* 231517 */     GIR_EraseRootFromParent_Done,
     /* 231518 */   // Label 4664: @231518
     /* 231518 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(231560), // Rule ID 11406 //
     /* 231523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 231531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231547 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 231550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231558 */     GIR_RootConstrainSelectedInstOperands,
     /* 231559 */     // GIR_Coverage, 11406,
     /* 231559 */     GIR_EraseRootFromParent_Done,
     /* 231560 */   // Label 4665: @231560
     /* 231560 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(231602), // Rule ID 11407 //
     /* 231565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 231573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231589 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1967:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 231592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231600 */     GIR_RootConstrainSelectedInstOperands,
     /* 231601 */     // GIR_Coverage, 11407,
     /* 231601 */     GIR_EraseRootFromParent_Done,
     /* 231602 */   // Label 4666: @231602
     /* 231602 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(231644), // Rule ID 11408 //
     /* 231607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 231615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 231634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231642 */     GIR_RootConstrainSelectedInstOperands,
     /* 231643 */     // GIR_Coverage, 11408,
     /* 231643 */     GIR_EraseRootFromParent_Done,
     /* 231644 */   // Label 4667: @231644
     /* 231644 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(231686), // Rule ID 11409 //
     /* 231649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 231657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 231676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231684 */     GIR_RootConstrainSelectedInstOperands,
     /* 231685 */     // GIR_Coverage, 11409,
     /* 231685 */     GIR_EraseRootFromParent_Done,
     /* 231686 */   // Label 4668: @231686
     /* 231686 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(231728), // Rule ID 11410 //
     /* 231691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 231699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231715 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 231718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231726 */     GIR_RootConstrainSelectedInstOperands,
     /* 231727 */     // GIR_Coverage, 11410,
     /* 231727 */     GIR_EraseRootFromParent_Done,
     /* 231728 */   // Label 4669: @231728
     /* 231728 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(231770), // Rule ID 11411 //
     /* 231733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 231741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1756:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 231760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231768 */     GIR_RootConstrainSelectedInstOperands,
     /* 231769 */     // GIR_Coverage, 11411,
     /* 231769 */     GIR_EraseRootFromParent_Done,
     /* 231770 */   // Label 4670: @231770
     /* 231770 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(231812), // Rule ID 11412 //
     /* 231775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 231783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 231802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231810 */     GIR_RootConstrainSelectedInstOperands,
     /* 231811 */     // GIR_Coverage, 11412,
     /* 231811 */     GIR_EraseRootFromParent_Done,
     /* 231812 */   // Label 4671: @231812
     /* 231812 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(231854), // Rule ID 11413 //
     /* 231817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 231825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 231844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231852 */     GIR_RootConstrainSelectedInstOperands,
     /* 231853 */     // GIR_Coverage, 11413,
     /* 231853 */     GIR_EraseRootFromParent_Done,
     /* 231854 */   // Label 4672: @231854
     /* 231854 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(231896), // Rule ID 11414 //
     /* 231859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 231867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231883 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 231886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231894 */     GIR_RootConstrainSelectedInstOperands,
     /* 231895 */     // GIR_Coverage, 11414,
     /* 231895 */     GIR_EraseRootFromParent_Done,
     /* 231896 */   // Label 4673: @231896
     /* 231896 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(231938), // Rule ID 11415 //
     /* 231901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 231909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231925 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1949:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 231928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231936 */     GIR_RootConstrainSelectedInstOperands,
     /* 231937 */     // GIR_Coverage, 11415,
     /* 231937 */     GIR_EraseRootFromParent_Done,
     /* 231938 */   // Label 4674: @231938
     /* 231938 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(231980), // Rule ID 11416 //
     /* 231943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 231951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231967 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1949:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 231970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231978 */     GIR_RootConstrainSelectedInstOperands,
     /* 231979 */     // GIR_Coverage, 11416,
     /* 231979 */     GIR_EraseRootFromParent_Done,
     /* 231980 */   // Label 4675: @231980
     /* 231980 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(232022), // Rule ID 11417 //
     /* 231985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 231993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1949:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 232012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232020 */     GIR_RootConstrainSelectedInstOperands,
     /* 232021 */     // GIR_Coverage, 11417,
     /* 232021 */     GIR_EraseRootFromParent_Done,
     /* 232022 */   // Label 4676: @232022
     /* 232022 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(232064), // Rule ID 11418 //
     /* 232027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 232035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1949:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 232054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232062 */     GIR_RootConstrainSelectedInstOperands,
     /* 232063 */     // GIR_Coverage, 11418,
     /* 232063 */     GIR_EraseRootFromParent_Done,
     /* 232064 */   // Label 4677: @232064
     /* 232064 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(232106), // Rule ID 11419 //
     /* 232069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 232077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1763:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 232096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232104 */     GIR_RootConstrainSelectedInstOperands,
     /* 232105 */     // GIR_Coverage, 11419,
     /* 232105 */     GIR_EraseRootFromParent_Done,
     /* 232106 */   // Label 4678: @232106
     /* 232106 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(232148), // Rule ID 11420 //
     /* 232111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 232119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232135 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1763:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 232138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232146 */     GIR_RootConstrainSelectedInstOperands,
     /* 232147 */     // GIR_Coverage, 11420,
     /* 232147 */     GIR_EraseRootFromParent_Done,
     /* 232148 */   // Label 4679: @232148
     /* 232148 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(232190), // Rule ID 11421 //
     /* 232153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 232161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1763:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 232180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232188 */     GIR_RootConstrainSelectedInstOperands,
     /* 232189 */     // GIR_Coverage, 11421,
     /* 232189 */     GIR_EraseRootFromParent_Done,
     /* 232190 */   // Label 4680: @232190
     /* 232190 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(232232), // Rule ID 11422 //
     /* 232195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 232203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1763:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 232222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232230 */     GIR_RootConstrainSelectedInstOperands,
     /* 232231 */     // GIR_Coverage, 11422,
     /* 232231 */     GIR_EraseRootFromParent_Done,
     /* 232232 */   // Label 4681: @232232
     /* 232232 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(232274), // Rule ID 11423 //
     /* 232237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 232245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232261 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1954:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 232264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232272 */     GIR_RootConstrainSelectedInstOperands,
     /* 232273 */     // GIR_Coverage, 11423,
     /* 232273 */     GIR_EraseRootFromParent_Done,
     /* 232274 */   // Label 4682: @232274
     /* 232274 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(232316), // Rule ID 11424 //
     /* 232279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 232287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232303 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1954:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 232306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232314 */     GIR_RootConstrainSelectedInstOperands,
     /* 232315 */     // GIR_Coverage, 11424,
     /* 232315 */     GIR_EraseRootFromParent_Done,
     /* 232316 */   // Label 4683: @232316
     /* 232316 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(232358), // Rule ID 11425 //
     /* 232321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 232329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1954:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 232348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232356 */     GIR_RootConstrainSelectedInstOperands,
     /* 232357 */     // GIR_Coverage, 11425,
     /* 232357 */     GIR_EraseRootFromParent_Done,
     /* 232358 */   // Label 4684: @232358
     /* 232358 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(232400), // Rule ID 11426 //
     /* 232363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 232371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1954:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 232390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232398 */     GIR_RootConstrainSelectedInstOperands,
     /* 232399 */     // GIR_Coverage, 11426,
     /* 232399 */     GIR_EraseRootFromParent_Done,
     /* 232400 */   // Label 4685: @232400
     /* 232400 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(232442), // Rule ID 11427 //
     /* 232405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 232413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232429 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1747:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 232432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232440 */     GIR_RootConstrainSelectedInstOperands,
     /* 232441 */     // GIR_Coverage, 11427,
     /* 232441 */     GIR_EraseRootFromParent_Done,
     /* 232442 */   // Label 4686: @232442
     /* 232442 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(232484), // Rule ID 11428 //
     /* 232447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 232455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 232474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232482 */     GIR_RootConstrainSelectedInstOperands,
     /* 232483 */     // GIR_Coverage, 11428,
     /* 232483 */     GIR_EraseRootFromParent_Done,
     /* 232484 */   // Label 4687: @232484
     /* 232484 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(232526), // Rule ID 11429 //
     /* 232489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 232497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 232516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232524 */     GIR_RootConstrainSelectedInstOperands,
     /* 232525 */     // GIR_Coverage, 11429,
     /* 232525 */     GIR_EraseRootFromParent_Done,
     /* 232526 */   // Label 4688: @232526
     /* 232526 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(232568), // Rule ID 11430 //
     /* 232531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 232539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 232558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232566 */     GIR_RootConstrainSelectedInstOperands,
     /* 232567 */     // GIR_Coverage, 11430,
     /* 232567 */     GIR_EraseRootFromParent_Done,
     /* 232568 */   // Label 4689: @232568
     /* 232568 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(232610), // Rule ID 11431 //
     /* 232573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 232581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232597 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 232600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232608 */     GIR_RootConstrainSelectedInstOperands,
     /* 232609 */     // GIR_Coverage, 11431,
     /* 232609 */     GIR_EraseRootFromParent_Done,
     /* 232610 */   // Label 4690: @232610
     /* 232610 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(232652), // Rule ID 11432 //
     /* 232615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 232623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 232642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232650 */     GIR_RootConstrainSelectedInstOperands,
     /* 232651 */     // GIR_Coverage, 11432,
     /* 232651 */     GIR_EraseRootFromParent_Done,
     /* 232652 */   // Label 4691: @232652
     /* 232652 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(232694), // Rule ID 11433 //
     /* 232657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 232665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 232684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232692 */     GIR_RootConstrainSelectedInstOperands,
     /* 232693 */     // GIR_Coverage, 11433,
     /* 232693 */     GIR_EraseRootFromParent_Done,
     /* 232694 */   // Label 4692: @232694
     /* 232694 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(232736), // Rule ID 11434 //
     /* 232699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 232707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232723 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 232726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232734 */     GIR_RootConstrainSelectedInstOperands,
     /* 232735 */     // GIR_Coverage, 11434,
     /* 232735 */     GIR_EraseRootFromParent_Done,
     /* 232736 */   // Label 4693: @232736
     /* 232736 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(232778), // Rule ID 11435 //
     /* 232741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 232749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1734:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 232768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232776 */     GIR_RootConstrainSelectedInstOperands,
     /* 232777 */     // GIR_Coverage, 11435,
     /* 232777 */     GIR_EraseRootFromParent_Done,
     /* 232778 */   // Label 4694: @232778
     /* 232778 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(232820), // Rule ID 11436 //
     /* 232783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 232791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1734:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 232810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232818 */     GIR_RootConstrainSelectedInstOperands,
     /* 232819 */     // GIR_Coverage, 11436,
     /* 232819 */     GIR_EraseRootFromParent_Done,
     /* 232820 */   // Label 4695: @232820
     /* 232820 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(232862), // Rule ID 11437 //
     /* 232825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 232833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 232852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232860 */     GIR_RootConstrainSelectedInstOperands,
     /* 232861 */     // GIR_Coverage, 11437,
     /* 232861 */     GIR_EraseRootFromParent_Done,
     /* 232862 */   // Label 4696: @232862
     /* 232862 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(232904), // Rule ID 11438 //
     /* 232867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 232875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1734:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 232894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232902 */     GIR_RootConstrainSelectedInstOperands,
     /* 232903 */     // GIR_Coverage, 11438,
     /* 232903 */     GIR_EraseRootFromParent_Done,
     /* 232904 */   // Label 4697: @232904
     /* 232904 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(232946), // Rule ID 11439 //
     /* 232909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 232917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232933 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1936:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 232936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232944 */     GIR_RootConstrainSelectedInstOperands,
     /* 232945 */     // GIR_Coverage, 11439,
     /* 232945 */     GIR_EraseRootFromParent_Done,
     /* 232946 */   // Label 4698: @232946
     /* 232946 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(232988), // Rule ID 11440 //
     /* 232951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 232959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 232978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232986 */     GIR_RootConstrainSelectedInstOperands,
     /* 232987 */     // GIR_Coverage, 11440,
     /* 232987 */     GIR_EraseRootFromParent_Done,
     /* 232988 */   // Label 4699: @232988
     /* 232988 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(233030), // Rule ID 11441 //
     /* 232993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 233001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 233020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233028 */     GIR_RootConstrainSelectedInstOperands,
     /* 233029 */     // GIR_Coverage, 11441,
     /* 233029 */     GIR_EraseRootFromParent_Done,
     /* 233030 */   // Label 4700: @233030
     /* 233030 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(233072), // Rule ID 11442 //
     /* 233035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 233043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 233062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233070 */     GIR_RootConstrainSelectedInstOperands,
     /* 233071 */     // GIR_Coverage, 11442,
     /* 233071 */     GIR_EraseRootFromParent_Done,
     /* 233072 */   // Label 4701: @233072
     /* 233072 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(233114), // Rule ID 11605 //
     /* 233077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 233085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 233104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233112 */     GIR_RootConstrainSelectedInstOperands,
     /* 233113 */     // GIR_Coverage, 11605,
     /* 233113 */     GIR_EraseRootFromParent_Done,
     /* 233114 */   // Label 4702: @233114
     /* 233114 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(233156), // Rule ID 11607 //
     /* 233119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 233127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 233146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233154 */     GIR_RootConstrainSelectedInstOperands,
     /* 233155 */     // GIR_Coverage, 11607,
     /* 233155 */     GIR_EraseRootFromParent_Done,
     /* 233156 */   // Label 4703: @233156
     /* 233156 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(233198), // Rule ID 11609 //
     /* 233161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 233169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 233188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233196 */     GIR_RootConstrainSelectedInstOperands,
     /* 233197 */     // GIR_Coverage, 11609,
     /* 233197 */     GIR_EraseRootFromParent_Done,
     /* 233198 */   // Label 4704: @233198
     /* 233198 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(233240), // Rule ID 11611 //
     /* 233203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 233211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 233230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233238 */     GIR_RootConstrainSelectedInstOperands,
     /* 233239 */     // GIR_Coverage, 11611,
     /* 233239 */     GIR_EraseRootFromParent_Done,
     /* 233240 */   // Label 4705: @233240
     /* 233240 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(233282), // Rule ID 11613 //
     /* 233245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 233253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1588:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 233272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233280 */     GIR_RootConstrainSelectedInstOperands,
     /* 233281 */     // GIR_Coverage, 11613,
     /* 233281 */     GIR_EraseRootFromParent_Done,
     /* 233282 */   // Label 4706: @233282
     /* 233282 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(233324), // Rule ID 11614 //
     /* 233287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 233295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1588:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 233314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233322 */     GIR_RootConstrainSelectedInstOperands,
     /* 233323 */     // GIR_Coverage, 11614,
     /* 233323 */     GIR_EraseRootFromParent_Done,
     /* 233324 */   // Label 4707: @233324
     /* 233324 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(233366), // Rule ID 11615 //
     /* 233329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 233337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233353 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1588:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 233356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233364 */     GIR_RootConstrainSelectedInstOperands,
     /* 233365 */     // GIR_Coverage, 11615,
     /* 233365 */     GIR_EraseRootFromParent_Done,
     /* 233366 */   // Label 4708: @233366
     /* 233366 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(233408), // Rule ID 11616 //
     /* 233371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 233379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 233398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233406 */     GIR_RootConstrainSelectedInstOperands,
     /* 233407 */     // GIR_Coverage, 11616,
     /* 233407 */     GIR_EraseRootFromParent_Done,
     /* 233408 */   // Label 4709: @233408
     /* 233408 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(233450), // Rule ID 11617 //
     /* 233413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 233421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233437 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 233440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233448 */     GIR_RootConstrainSelectedInstOperands,
     /* 233449 */     // GIR_Coverage, 11617,
     /* 233449 */     GIR_EraseRootFromParent_Done,
     /* 233450 */   // Label 4710: @233450
     /* 233450 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(233492), // Rule ID 11618 //
     /* 233455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 233463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233479 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 233482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233490 */     GIR_RootConstrainSelectedInstOperands,
     /* 233491 */     // GIR_Coverage, 11618,
     /* 233491 */     GIR_EraseRootFromParent_Done,
     /* 233492 */   // Label 4711: @233492
     /* 233492 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(233534), // Rule ID 11619 //
     /* 233497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 233505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 233524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233532 */     GIR_RootConstrainSelectedInstOperands,
     /* 233533 */     // GIR_Coverage, 11619,
     /* 233533 */     GIR_EraseRootFromParent_Done,
     /* 233534 */   // Label 4712: @233534
     /* 233534 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(233576), // Rule ID 11620 //
     /* 233539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 233547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 233566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233574 */     GIR_RootConstrainSelectedInstOperands,
     /* 233575 */     // GIR_Coverage, 11620,
     /* 233575 */     GIR_EraseRootFromParent_Done,
     /* 233576 */   // Label 4713: @233576
     /* 233576 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(233618), // Rule ID 11621 //
     /* 233581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 233589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1838:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 233608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233616 */     GIR_RootConstrainSelectedInstOperands,
     /* 233617 */     // GIR_Coverage, 11621,
     /* 233617 */     GIR_EraseRootFromParent_Done,
     /* 233618 */   // Label 4714: @233618
     /* 233618 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(233660), // Rule ID 11622 //
     /* 233623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 233631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1151:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 233650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233658 */     GIR_RootConstrainSelectedInstOperands,
     /* 233659 */     // GIR_Coverage, 11622,
     /* 233659 */     GIR_EraseRootFromParent_Done,
     /* 233660 */   // Label 4715: @233660
     /* 233660 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(233702), // Rule ID 11623 //
     /* 233665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 233673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1151:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 233692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233700 */     GIR_RootConstrainSelectedInstOperands,
     /* 233701 */     // GIR_Coverage, 11623,
     /* 233701 */     GIR_EraseRootFromParent_Done,
     /* 233702 */   // Label 4716: @233702
     /* 233702 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(233744), // Rule ID 11624 //
     /* 233707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 233715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 233734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233742 */     GIR_RootConstrainSelectedInstOperands,
     /* 233743 */     // GIR_Coverage, 11624,
     /* 233743 */     GIR_EraseRootFromParent_Done,
     /* 233744 */   // Label 4717: @233744
     /* 233744 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(233786), // Rule ID 11625 //
     /* 233749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 233757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233773 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 233776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233784 */     GIR_RootConstrainSelectedInstOperands,
     /* 233785 */     // GIR_Coverage, 11625,
     /* 233785 */     GIR_EraseRootFromParent_Done,
     /* 233786 */   // Label 4718: @233786
     /* 233786 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(233828), // Rule ID 11626 //
     /* 233791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 233799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233815 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 233818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233826 */     GIR_RootConstrainSelectedInstOperands,
     /* 233827 */     // GIR_Coverage, 11626,
     /* 233827 */     GIR_EraseRootFromParent_Done,
     /* 233828 */   // Label 4719: @233828
     /* 233828 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(233870), // Rule ID 11627 //
     /* 233833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 233841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233857 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 233860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233868 */     GIR_RootConstrainSelectedInstOperands,
     /* 233869 */     // GIR_Coverage, 11627,
     /* 233869 */     GIR_EraseRootFromParent_Done,
     /* 233870 */   // Label 4720: @233870
     /* 233870 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(233912), // Rule ID 11682 //
     /* 233875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 233883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233899 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1569:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 233902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233910 */     GIR_RootConstrainSelectedInstOperands,
     /* 233911 */     // GIR_Coverage, 11682,
     /* 233911 */     GIR_EraseRootFromParent_Done,
     /* 233912 */   // Label 4721: @233912
     /* 233912 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(233954), // Rule ID 11683 //
     /* 233917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 233925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1569:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 233944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233952 */     GIR_RootConstrainSelectedInstOperands,
     /* 233953 */     // GIR_Coverage, 11683,
     /* 233953 */     GIR_EraseRootFromParent_Done,
     /* 233954 */   // Label 4722: @233954
     /* 233954 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(233996), // Rule ID 11684 //
     /* 233959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 233967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1569:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 233986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233994 */     GIR_RootConstrainSelectedInstOperands,
     /* 233995 */     // GIR_Coverage, 11684,
     /* 233995 */     GIR_EraseRootFromParent_Done,
     /* 233996 */   // Label 4723: @233996
     /* 233996 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(234038), // Rule ID 11685 //
     /* 234001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 234009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234025 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 234028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234036 */     GIR_RootConstrainSelectedInstOperands,
     /* 234037 */     // GIR_Coverage, 11685,
     /* 234037 */     GIR_EraseRootFromParent_Done,
     /* 234038 */   // Label 4724: @234038
     /* 234038 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(234080), // Rule ID 11686 //
     /* 234043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 234051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234067 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 234070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234078 */     GIR_RootConstrainSelectedInstOperands,
     /* 234079 */     // GIR_Coverage, 11686,
     /* 234079 */     GIR_EraseRootFromParent_Done,
     /* 234080 */   // Label 4725: @234080
     /* 234080 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(234122), // Rule ID 11687 //
     /* 234085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 234093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234109 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 234112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234120 */     GIR_RootConstrainSelectedInstOperands,
     /* 234121 */     // GIR_Coverage, 11687,
     /* 234121 */     GIR_EraseRootFromParent_Done,
     /* 234122 */   // Label 4726: @234122
     /* 234122 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(234164), // Rule ID 11688 //
     /* 234127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 234135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234151 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1585:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 234154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234162 */     GIR_RootConstrainSelectedInstOperands,
     /* 234163 */     // GIR_Coverage, 11688,
     /* 234163 */     GIR_EraseRootFromParent_Done,
     /* 234164 */   // Label 4727: @234164
     /* 234164 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(234206), // Rule ID 11689 //
     /* 234169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 234177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1585:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 234196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234204 */     GIR_RootConstrainSelectedInstOperands,
     /* 234205 */     // GIR_Coverage, 11689,
     /* 234205 */     GIR_EraseRootFromParent_Done,
     /* 234206 */   // Label 4728: @234206
     /* 234206 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(234248), // Rule ID 11690 //
     /* 234211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 234219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1585:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 234238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234246 */     GIR_RootConstrainSelectedInstOperands,
     /* 234247 */     // GIR_Coverage, 11690,
     /* 234247 */     GIR_EraseRootFromParent_Done,
     /* 234248 */   // Label 4729: @234248
     /* 234248 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(234293), // Rule ID 11703 //
     /* 234253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 234256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 234261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234277 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1520:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 234280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 234291 */     GIR_RootConstrainSelectedInstOperands,
     /* 234292 */     // GIR_Coverage, 11703,
     /* 234292 */     GIR_EraseRootFromParent_Done,
     /* 234293 */   // Label 4730: @234293
     /* 234293 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(234338), // Rule ID 11704 //
     /* 234298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 234301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 234306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 234309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234322 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1520:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 234325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 234336 */     GIR_RootConstrainSelectedInstOperands,
     /* 234337 */     // GIR_Coverage, 11704,
     /* 234337 */     GIR_EraseRootFromParent_Done,
     /* 234338 */   // Label 4731: @234338
     /* 234338 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(234380), // Rule ID 11705 //
     /* 234343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 234351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234367 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 234370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234378 */     GIR_RootConstrainSelectedInstOperands,
     /* 234379 */     // GIR_Coverage, 11705,
     /* 234379 */     GIR_EraseRootFromParent_Done,
     /* 234380 */   // Label 4732: @234380
     /* 234380 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(234422), // Rule ID 11706 //
     /* 234385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 234393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1260:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 234412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234420 */     GIR_RootConstrainSelectedInstOperands,
     /* 234421 */     // GIR_Coverage, 11706,
     /* 234421 */     GIR_EraseRootFromParent_Done,
     /* 234422 */   // Label 4733: @234422
     /* 234422 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(234464), // Rule ID 11707 //
     /* 234427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 234435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1260:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 234454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234462 */     GIR_RootConstrainSelectedInstOperands,
     /* 234463 */     // GIR_Coverage, 11707,
     /* 234463 */     GIR_EraseRootFromParent_Done,
     /* 234464 */   // Label 4734: @234464
     /* 234464 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(234506), // Rule ID 11708 //
     /* 234469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 234477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1260:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 234496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234504 */     GIR_RootConstrainSelectedInstOperands,
     /* 234505 */     // GIR_Coverage, 11708,
     /* 234505 */     GIR_EraseRootFromParent_Done,
     /* 234506 */   // Label 4735: @234506
     /* 234506 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(234548), // Rule ID 11724 //
     /* 234511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 234519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234535 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1343:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 234538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234546 */     GIR_RootConstrainSelectedInstOperands,
     /* 234547 */     // GIR_Coverage, 11724,
     /* 234547 */     GIR_EraseRootFromParent_Done,
     /* 234548 */   // Label 4736: @234548
     /* 234548 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(234590), // Rule ID 11725 //
     /* 234553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 234561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1343:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 234580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234588 */     GIR_RootConstrainSelectedInstOperands,
     /* 234589 */     // GIR_Coverage, 11725,
     /* 234589 */     GIR_EraseRootFromParent_Done,
     /* 234590 */   // Label 4737: @234590
     /* 234590 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(234632), // Rule ID 11726 //
     /* 234595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 234603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1343:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 234622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234630 */     GIR_RootConstrainSelectedInstOperands,
     /* 234631 */     // GIR_Coverage, 11726,
     /* 234631 */     GIR_EraseRootFromParent_Done,
     /* 234632 */   // Label 4738: @234632
     /* 234632 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(234674), // Rule ID 11727 //
     /* 234637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 234645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234661 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 234664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234672 */     GIR_RootConstrainSelectedInstOperands,
     /* 234673 */     // GIR_Coverage, 11727,
     /* 234673 */     GIR_EraseRootFromParent_Done,
     /* 234674 */   // Label 4739: @234674
     /* 234674 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(234716), // Rule ID 11728 //
     /* 234679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 234687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234703 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 234706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234714 */     GIR_RootConstrainSelectedInstOperands,
     /* 234715 */     // GIR_Coverage, 11728,
     /* 234715 */     GIR_EraseRootFromParent_Done,
     /* 234716 */   // Label 4740: @234716
     /* 234716 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(234758), // Rule ID 11729 //
     /* 234721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 234729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234745 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 234748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234756 */     GIR_RootConstrainSelectedInstOperands,
     /* 234757 */     // GIR_Coverage, 11729,
     /* 234757 */     GIR_EraseRootFromParent_Done,
     /* 234758 */   // Label 4741: @234758
     /* 234758 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(234800), // Rule ID 11730 //
     /* 234763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 234771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234787 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1346:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 234790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234798 */     GIR_RootConstrainSelectedInstOperands,
     /* 234799 */     // GIR_Coverage, 11730,
     /* 234799 */     GIR_EraseRootFromParent_Done,
     /* 234800 */   // Label 4742: @234800
     /* 234800 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(234842), // Rule ID 11731 //
     /* 234805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 234813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234829 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1346:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 234832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234840 */     GIR_RootConstrainSelectedInstOperands,
     /* 234841 */     // GIR_Coverage, 11731,
     /* 234841 */     GIR_EraseRootFromParent_Done,
     /* 234842 */   // Label 4743: @234842
     /* 234842 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(234884), // Rule ID 11732 //
     /* 234847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 234855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234871 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1346:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 234874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234882 */     GIR_RootConstrainSelectedInstOperands,
     /* 234883 */     // GIR_Coverage, 11732,
     /* 234883 */     GIR_EraseRootFromParent_Done,
     /* 234884 */   // Label 4744: @234884
     /* 234884 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(234926), // Rule ID 11733 //
     /* 234889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 234897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234913 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 234916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234924 */     GIR_RootConstrainSelectedInstOperands,
     /* 234925 */     // GIR_Coverage, 11733,
     /* 234925 */     GIR_EraseRootFromParent_Done,
     /* 234926 */   // Label 4745: @234926
     /* 234926 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(234968), // Rule ID 11734 //
     /* 234931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 234939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234955 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 234958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234966 */     GIR_RootConstrainSelectedInstOperands,
     /* 234967 */     // GIR_Coverage, 11734,
     /* 234967 */     GIR_EraseRootFromParent_Done,
     /* 234968 */   // Label 4746: @234968
     /* 234968 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(235010), // Rule ID 11735 //
     /* 234973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 234981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234997 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 235000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235008 */     GIR_RootConstrainSelectedInstOperands,
     /* 235009 */     // GIR_Coverage, 11735,
     /* 235009 */     GIR_EraseRootFromParent_Done,
     /* 235010 */   // Label 4747: @235010
     /* 235010 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(235052), // Rule ID 11740 //
     /* 235015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 235023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235039 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 235039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 235042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235050 */     GIR_RootConstrainSelectedInstOperands,
     /* 235051 */     // GIR_Coverage, 11740,
     /* 235051 */     GIR_EraseRootFromParent_Done,
     /* 235052 */   // Label 4748: @235052
     /* 235052 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(235094), // Rule ID 11741 //
     /* 235057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 235065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235081 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 235081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 235084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235092 */     GIR_RootConstrainSelectedInstOperands,
     /* 235093 */     // GIR_Coverage, 11741,
     /* 235093 */     GIR_EraseRootFromParent_Done,
     /* 235094 */   // Label 4749: @235094
     /* 235094 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(235136), // Rule ID 11742 //
     /* 235099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 235107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235123 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1377:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 235123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 235126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235134 */     GIR_RootConstrainSelectedInstOperands,
     /* 235135 */     // GIR_Coverage, 11742,
     /* 235135 */     GIR_EraseRootFromParent_Done,
     /* 235136 */   // Label 4750: @235136
     /* 235136 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(235178), // Rule ID 11743 //
     /* 235141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 235149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235165 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 235165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 235168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235176 */     GIR_RootConstrainSelectedInstOperands,
     /* 235177 */     // GIR_Coverage, 11743,
     /* 235177 */     GIR_EraseRootFromParent_Done,
     /* 235178 */   // Label 4751: @235178
     /* 235178 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(235220), // Rule ID 11744 //
     /* 235183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 235191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235207 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1177:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 235210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235218 */     GIR_RootConstrainSelectedInstOperands,
     /* 235219 */     // GIR_Coverage, 11744,
     /* 235219 */     GIR_EraseRootFromParent_Done,
     /* 235220 */   // Label 4752: @235220
     /* 235220 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(235262), // Rule ID 11746 //
     /* 235225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 235233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1177:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 235252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235260 */     GIR_RootConstrainSelectedInstOperands,
     /* 235261 */     // GIR_Coverage, 11746,
     /* 235261 */     GIR_EraseRootFromParent_Done,
     /* 235262 */   // Label 4753: @235262
     /* 235262 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(235304), // Rule ID 11748 //
     /* 235267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 235275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235291 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1177:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 235294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235302 */     GIR_RootConstrainSelectedInstOperands,
     /* 235303 */     // GIR_Coverage, 11748,
     /* 235303 */     GIR_EraseRootFromParent_Done,
     /* 235304 */   // Label 4754: @235304
     /* 235304 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(235346), // Rule ID 11750 //
     /* 235309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 235317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1177:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 235336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235344 */     GIR_RootConstrainSelectedInstOperands,
     /* 235345 */     // GIR_Coverage, 11750,
     /* 235345 */     GIR_EraseRootFromParent_Done,
     /* 235346 */   // Label 4755: @235346
     /* 235346 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(235388), // Rule ID 11752 //
     /* 235351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 235359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235375 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1206:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 235378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235386 */     GIR_RootConstrainSelectedInstOperands,
     /* 235387 */     // GIR_Coverage, 11752,
     /* 235387 */     GIR_EraseRootFromParent_Done,
     /* 235388 */   // Label 4756: @235388
     /* 235388 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(235430), // Rule ID 11754 //
     /* 235393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 235401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235417 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1206:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 235420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235428 */     GIR_RootConstrainSelectedInstOperands,
     /* 235429 */     // GIR_Coverage, 11754,
     /* 235429 */     GIR_EraseRootFromParent_Done,
     /* 235430 */   // Label 4757: @235430
     /* 235430 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(235472), // Rule ID 11756 //
     /* 235435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 235443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1206:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 235462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235470 */     GIR_RootConstrainSelectedInstOperands,
     /* 235471 */     // GIR_Coverage, 11756,
     /* 235471 */     GIR_EraseRootFromParent_Done,
     /* 235472 */   // Label 4758: @235472
     /* 235472 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(235514), // Rule ID 11758 //
     /* 235477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 235485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235501 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1206:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 235504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235512 */     GIR_RootConstrainSelectedInstOperands,
     /* 235513 */     // GIR_Coverage, 11758,
     /* 235513 */     GIR_EraseRootFromParent_Done,
     /* 235514 */   // Label 4759: @235514
     /* 235514 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(235556), // Rule ID 11760 //
     /* 235519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 235527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1207:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 235546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235554 */     GIR_RootConstrainSelectedInstOperands,
     /* 235555 */     // GIR_Coverage, 11760,
     /* 235555 */     GIR_EraseRootFromParent_Done,
     /* 235556 */   // Label 4760: @235556
     /* 235556 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(235598), // Rule ID 11761 //
     /* 235561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 235569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1207:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 235588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235596 */     GIR_RootConstrainSelectedInstOperands,
     /* 235597 */     // GIR_Coverage, 11761,
     /* 235597 */     GIR_EraseRootFromParent_Done,
     /* 235598 */   // Label 4761: @235598
     /* 235598 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(235640), // Rule ID 11762 //
     /* 235603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 235611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1207:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 235630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235638 */     GIR_RootConstrainSelectedInstOperands,
     /* 235639 */     // GIR_Coverage, 11762,
     /* 235639 */     GIR_EraseRootFromParent_Done,
     /* 235640 */   // Label 4762: @235640
     /* 235640 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(235682), // Rule ID 11763 //
     /* 235645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 235653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1207:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 235672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235680 */     GIR_RootConstrainSelectedInstOperands,
     /* 235681 */     // GIR_Coverage, 11763,
     /* 235681 */     GIR_EraseRootFromParent_Done,
     /* 235682 */   // Label 4763: @235682
     /* 235682 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(235724), // Rule ID 11764 //
     /* 235687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 235695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1208:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 235714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235722 */     GIR_RootConstrainSelectedInstOperands,
     /* 235723 */     // GIR_Coverage, 11764,
     /* 235723 */     GIR_EraseRootFromParent_Done,
     /* 235724 */   // Label 4764: @235724
     /* 235724 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(235766), // Rule ID 11765 //
     /* 235729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 235737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235753 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1208:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 235756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235764 */     GIR_RootConstrainSelectedInstOperands,
     /* 235765 */     // GIR_Coverage, 11765,
     /* 235765 */     GIR_EraseRootFromParent_Done,
     /* 235766 */   // Label 4765: @235766
     /* 235766 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(235808), // Rule ID 11766 //
     /* 235771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 235779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1208:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 235798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235806 */     GIR_RootConstrainSelectedInstOperands,
     /* 235807 */     // GIR_Coverage, 11766,
     /* 235807 */     GIR_EraseRootFromParent_Done,
     /* 235808 */   // Label 4766: @235808
     /* 235808 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(235850), // Rule ID 11767 //
     /* 235813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 235821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235837 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1208:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 235840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235848 */     GIR_RootConstrainSelectedInstOperands,
     /* 235849 */     // GIR_Coverage, 11767,
     /* 235849 */     GIR_EraseRootFromParent_Done,
     /* 235850 */   // Label 4767: @235850
     /* 235850 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(235892), // Rule ID 11768 //
     /* 235855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 235863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1518:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 235882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235890 */     GIR_RootConstrainSelectedInstOperands,
     /* 235891 */     // GIR_Coverage, 11768,
     /* 235891 */     GIR_EraseRootFromParent_Done,
     /* 235892 */   // Label 4768: @235892
     /* 235892 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(235934), // Rule ID 11770 //
     /* 235897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 235905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1518:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 235924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235932 */     GIR_RootConstrainSelectedInstOperands,
     /* 235933 */     // GIR_Coverage, 11770,
     /* 235933 */     GIR_EraseRootFromParent_Done,
     /* 235934 */   // Label 4769: @235934
     /* 235934 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(235976), // Rule ID 11772 //
     /* 235939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 235947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1518:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 235966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235974 */     GIR_RootConstrainSelectedInstOperands,
     /* 235975 */     // GIR_Coverage, 11772,
     /* 235975 */     GIR_EraseRootFromParent_Done,
     /* 235976 */   // Label 4770: @235976
     /* 235976 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(236018), // Rule ID 11774 //
     /* 235981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 235989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236005 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1518:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 236008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236016 */     GIR_RootConstrainSelectedInstOperands,
     /* 236017 */     // GIR_Coverage, 11774,
     /* 236017 */     GIR_EraseRootFromParent_Done,
     /* 236018 */   // Label 4771: @236018
     /* 236018 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(236060), // Rule ID 11863 //
     /* 236023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 236026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 236031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236047 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 236050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236058 */     GIR_RootConstrainSelectedInstOperands,
     /* 236059 */     // GIR_Coverage, 11863,
     /* 236059 */     GIR_EraseRootFromParent_Done,
     /* 236060 */   // Label 4772: @236060
     /* 236060 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(236102), // Rule ID 11865 //
     /* 236065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 236068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 236073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 236092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236100 */     GIR_RootConstrainSelectedInstOperands,
     /* 236101 */     // GIR_Coverage, 11865,
     /* 236101 */     GIR_EraseRootFromParent_Done,
     /* 236102 */   // Label 4773: @236102
     /* 236102 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(236144), // Rule ID 11867 //
     /* 236107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 236110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 236115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 236134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236142 */     GIR_RootConstrainSelectedInstOperands,
     /* 236143 */     // GIR_Coverage, 11867,
     /* 236143 */     GIR_EraseRootFromParent_Done,
     /* 236144 */   // Label 4774: @236144
     /* 236144 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(236186), // Rule ID 11869 //
     /* 236149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 236152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 236157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236173 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 236176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236184 */     GIR_RootConstrainSelectedInstOperands,
     /* 236185 */     // GIR_Coverage, 11869,
     /* 236185 */     GIR_EraseRootFromParent_Done,
     /* 236186 */   // Label 4775: @236186
     /* 236186 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(236228), // Rule ID 11871 //
     /* 236191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 236194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 236199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236215 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1327:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 236218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236226 */     GIR_RootConstrainSelectedInstOperands,
     /* 236227 */     // GIR_Coverage, 11871,
     /* 236227 */     GIR_EraseRootFromParent_Done,
     /* 236228 */   // Label 4776: @236228
     /* 236228 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(236270), // Rule ID 11873 //
     /* 236233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 236236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 236241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236257 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 236260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236268 */     GIR_RootConstrainSelectedInstOperands,
     /* 236269 */     // GIR_Coverage, 11873,
     /* 236269 */     GIR_EraseRootFromParent_Done,
     /* 236270 */   // Label 4777: @236270
     /* 236270 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(236312), // Rule ID 12036 //
     /* 236275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 236278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 236283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236299 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 236302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236310 */     GIR_RootConstrainSelectedInstOperands,
     /* 236311 */     // GIR_Coverage, 12036,
     /* 236311 */     GIR_EraseRootFromParent_Done,
     /* 236312 */   // Label 4778: @236312
     /* 236312 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(236354), // Rule ID 12037 //
     /* 236317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 236320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 236325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236341 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 236344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236352 */     GIR_RootConstrainSelectedInstOperands,
     /* 236353 */     // GIR_Coverage, 12037,
     /* 236353 */     GIR_EraseRootFromParent_Done,
     /* 236354 */   // Label 4779: @236354
     /* 236354 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(236396), // Rule ID 12038 //
     /* 236359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 236362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 236367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 236386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236394 */     GIR_RootConstrainSelectedInstOperands,
     /* 236395 */     // GIR_Coverage, 12038,
     /* 236395 */     GIR_EraseRootFromParent_Done,
     /* 236396 */   // Label 4780: @236396
     /* 236396 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(236438), // Rule ID 12039 //
     /* 236401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 236404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 236409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236425 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 236428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236436 */     GIR_RootConstrainSelectedInstOperands,
     /* 236437 */     // GIR_Coverage, 12039,
     /* 236437 */     GIR_EraseRootFromParent_Done,
     /* 236438 */   // Label 4781: @236438
     /* 236438 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(236480), // Rule ID 12040 //
     /* 236443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 236446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 236451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236467 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1825:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 236470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236478 */     GIR_RootConstrainSelectedInstOperands,
     /* 236479 */     // GIR_Coverage, 12040,
     /* 236479 */     GIR_EraseRootFromParent_Done,
     /* 236480 */   // Label 4782: @236480
     /* 236480 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(236522), // Rule ID 12041 //
     /* 236485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 236488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 236493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236509 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1825:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 236512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236520 */     GIR_RootConstrainSelectedInstOperands,
     /* 236521 */     // GIR_Coverage, 12041,
     /* 236521 */     GIR_EraseRootFromParent_Done,
     /* 236522 */   // Label 4783: @236522
     /* 236522 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(236564), // Rule ID 12042 //
     /* 236527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 236530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 236535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236551 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1825:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 236554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236562 */     GIR_RootConstrainSelectedInstOperands,
     /* 236563 */     // GIR_Coverage, 12042,
     /* 236563 */     GIR_EraseRootFromParent_Done,
     /* 236564 */   // Label 4784: @236564
     /* 236564 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(236606), // Rule ID 12387 //
     /* 236569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 236577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236593 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1277:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 236596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236604 */     GIR_RootConstrainSelectedInstOperands,
     /* 236605 */     // GIR_Coverage, 12387,
     /* 236605 */     GIR_EraseRootFromParent_Done,
     /* 236606 */   // Label 4785: @236606
     /* 236606 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(236648), // Rule ID 12388 //
     /* 236611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 236619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236635 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1277:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 236638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236646 */     GIR_RootConstrainSelectedInstOperands,
     /* 236647 */     // GIR_Coverage, 12388,
     /* 236647 */     GIR_EraseRootFromParent_Done,
     /* 236648 */   // Label 4786: @236648
     /* 236648 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(236690), // Rule ID 12389 //
     /* 236653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 236661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236677 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1277:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 236680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236688 */     GIR_RootConstrainSelectedInstOperands,
     /* 236689 */     // GIR_Coverage, 12389,
     /* 236689 */     GIR_EraseRootFromParent_Done,
     /* 236690 */   // Label 4787: @236690
     /* 236690 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(236732), // Rule ID 12390 //
     /* 236695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 236703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236719 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1275:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 236722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236730 */     GIR_RootConstrainSelectedInstOperands,
     /* 236731 */     // GIR_Coverage, 12390,
     /* 236731 */     GIR_EraseRootFromParent_Done,
     /* 236732 */   // Label 4788: @236732
     /* 236732 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(236774), // Rule ID 12391 //
     /* 236737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 236745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236761 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1275:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 236764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236772 */     GIR_RootConstrainSelectedInstOperands,
     /* 236773 */     // GIR_Coverage, 12391,
     /* 236773 */     GIR_EraseRootFromParent_Done,
     /* 236774 */   // Label 4789: @236774
     /* 236774 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(236816), // Rule ID 12392 //
     /* 236779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 236787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236803 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1275:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 236806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236814 */     GIR_RootConstrainSelectedInstOperands,
     /* 236815 */     // GIR_Coverage, 12392,
     /* 236815 */     GIR_EraseRootFromParent_Done,
     /* 236816 */   // Label 4790: @236816
     /* 236816 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(236858), // Rule ID 12393 //
     /* 236821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 236829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236845 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 236848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236856 */     GIR_RootConstrainSelectedInstOperands,
     /* 236857 */     // GIR_Coverage, 12393,
     /* 236857 */     GIR_EraseRootFromParent_Done,
     /* 236858 */   // Label 4791: @236858
     /* 236858 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(236900), // Rule ID 12396 //
     /* 236863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 236871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 236874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 236880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 236883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236887 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 236887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 236890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236898 */     GIR_RootConstrainSelectedInstOperands,
     /* 236899 */     // GIR_Coverage, 12396,
     /* 236899 */     GIR_EraseRootFromParent_Done,
     /* 236900 */   // Label 4792: @236900
     /* 236900 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(236942), // Rule ID 12399 //
     /* 236905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 236913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 236916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 236922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 236925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236929 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 236929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 236932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236940 */     GIR_RootConstrainSelectedInstOperands,
     /* 236941 */     // GIR_Coverage, 12399,
     /* 236941 */     GIR_EraseRootFromParent_Done,
     /* 236942 */   // Label 4793: @236942
     /* 236942 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(236984), // Rule ID 12402 //
     /* 236947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 236955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236971 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 236974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236982 */     GIR_RootConstrainSelectedInstOperands,
     /* 236983 */     // GIR_Coverage, 12402,
     /* 236983 */     GIR_EraseRootFromParent_Done,
     /* 236984 */   // Label 4794: @236984
     /* 236984 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(237026), // Rule ID 12405 //
     /* 236989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 236992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 236997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 237000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 237006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 237009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237013 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 237013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 237016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237024 */     GIR_RootConstrainSelectedInstOperands,
     /* 237025 */     // GIR_Coverage, 12405,
     /* 237025 */     GIR_EraseRootFromParent_Done,
     /* 237026 */   // Label 4795: @237026
     /* 237026 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(237068), // Rule ID 12408 //
     /* 237031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 237034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 237039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237055 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 237058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237066 */     GIR_RootConstrainSelectedInstOperands,
     /* 237067 */     // GIR_Coverage, 12408,
     /* 237067 */     GIR_EraseRootFromParent_Done,
     /* 237068 */   // Label 4796: @237068
     /* 237068 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(237110), // Rule ID 12411 //
     /* 237073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 237076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 237081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237097 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1278:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 237100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237108 */     GIR_RootConstrainSelectedInstOperands,
     /* 237109 */     // GIR_Coverage, 12411,
     /* 237109 */     GIR_EraseRootFromParent_Done,
     /* 237110 */   // Label 4797: @237110
     /* 237110 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(237152), // Rule ID 12414 //
     /* 237115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 237118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 237123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 237126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 237132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 237135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237139 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 237139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 237142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237150 */     GIR_RootConstrainSelectedInstOperands,
     /* 237151 */     // GIR_Coverage, 12414,
     /* 237151 */     GIR_EraseRootFromParent_Done,
     /* 237152 */   // Label 4798: @237152
     /* 237152 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(237194), // Rule ID 12417 //
     /* 237157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 237160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 237165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 237168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 237174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 237177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237181 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 237181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 237184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237192 */     GIR_RootConstrainSelectedInstOperands,
     /* 237193 */     // GIR_Coverage, 12417,
     /* 237193 */     GIR_EraseRootFromParent_Done,
     /* 237194 */   // Label 4799: @237194
     /* 237194 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(237236), // Rule ID 12420 //
     /* 237199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 237202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 237207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237223 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 237226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237234 */     GIR_RootConstrainSelectedInstOperands,
     /* 237235 */     // GIR_Coverage, 12420,
     /* 237235 */     GIR_EraseRootFromParent_Done,
     /* 237236 */   // Label 4800: @237236
     /* 237236 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(237278), // Rule ID 12423 //
     /* 237241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 237244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 237249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 237252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 237258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 237261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237265 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 237265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 237268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237276 */     GIR_RootConstrainSelectedInstOperands,
     /* 237277 */     // GIR_Coverage, 12423,
     /* 237277 */     GIR_EraseRootFromParent_Done,
     /* 237278 */   // Label 4801: @237278
     /* 237278 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(237320), // Rule ID 12426 //
     /* 237283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 237286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 237291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237307 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 237310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237318 */     GIR_RootConstrainSelectedInstOperands,
     /* 237319 */     // GIR_Coverage, 12426,
     /* 237319 */     GIR_EraseRootFromParent_Done,
     /* 237320 */   // Label 4802: @237320
     /* 237320 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(237463), // Rule ID 5529 //
     /* 237325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 237328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 237333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 237336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 237339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 237342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237346 */     // MIs[0] idx
     /* 237346 */     // No operand predicates
     /* 237346 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237346 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 237349 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 237353 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 237360 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 237363 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 237367 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237372 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 237375 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 237379 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 237382 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237387 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237392 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 237400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 237404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 237411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 237414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 237418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237423 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 237426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 237430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 237433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 237451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 237453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 237456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 237459 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 237461 */     GIR_RootConstrainSelectedInstOperands,
     /* 237462 */     // GIR_Coverage, 5529,
     /* 237462 */     GIR_EraseRootFromParent_Done,
     /* 237463 */   // Label 4803: @237463
     /* 237463 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(237554), // Rule ID 5530 //
     /* 237468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 237471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 237476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 237479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 237482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 237485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237489 */     // MIs[0] idx
     /* 237489 */     // No operand predicates
     /* 237489 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 237492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 237496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 237503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 237506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 237510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 237518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 237522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 237525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 237543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 237545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 237548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 237550 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 237552 */     GIR_RootConstrainSelectedInstOperands,
     /* 237553 */     // GIR_Coverage, 5530,
     /* 237553 */     GIR_EraseRootFromParent_Done,
     /* 237554 */   // Label 4804: @237554
     /* 237554 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(237645), // Rule ID 5531 //
     /* 237559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 237562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 237567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 237570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 237573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 237576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237580 */     // MIs[0] idx
     /* 237580 */     // No operand predicates
     /* 237580 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 237583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 237587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 237594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 237597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 237601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 237609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 237613 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 237616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 237634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 237636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 237638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 237641 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 237643 */     GIR_RootConstrainSelectedInstOperands,
     /* 237644 */     // GIR_Coverage, 5531,
     /* 237644 */     GIR_EraseRootFromParent_Done,
     /* 237645 */   // Label 4805: @237645
     /* 237645 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(237684), // Rule ID 5532 //
     /* 237650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 237653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 237658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 237661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 237664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 237667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237671 */     // MIs[0] idx
     /* 237671 */     // No operand predicates
     /* 237671 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 237674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 237676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 237678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 237680 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 237682 */     GIR_RootConstrainSelectedInstOperands,
     /* 237683 */     // GIR_Coverage, 5532,
     /* 237683 */     GIR_EraseRootFromParent_Done,
     /* 237684 */   // Label 4806: @237684
     /* 237684 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(237827), // Rule ID 5533 //
     /* 237689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 237692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 237697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 237700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 237703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 237706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237710 */     // MIs[0] idx
     /* 237710 */     // No operand predicates
     /* 237710 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237710 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 237713 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 237717 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 237724 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 237727 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 237731 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237736 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 237739 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 237743 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 237746 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237751 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237756 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 237764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 237768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 237775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 237778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 237782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 237790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 237794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 237797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 237815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 237817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 237820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 237823 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 237825 */     GIR_RootConstrainSelectedInstOperands,
     /* 237826 */     // GIR_Coverage, 5533,
     /* 237826 */     GIR_EraseRootFromParent_Done,
     /* 237827 */   // Label 4807: @237827
     /* 237827 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(237918), // Rule ID 5534 //
     /* 237832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 237835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 237840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 237843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 237846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 237849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237853 */     // MIs[0] idx
     /* 237853 */     // No operand predicates
     /* 237853 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 237856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 237860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 237867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 237870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 237874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 237882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 237886 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 237889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 237907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 237909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 237912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 237914 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 237916 */     GIR_RootConstrainSelectedInstOperands,
     /* 237917 */     // GIR_Coverage, 5534,
     /* 237917 */     GIR_EraseRootFromParent_Done,
     /* 237918 */   // Label 4808: @237918
     /* 237918 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(238009), // Rule ID 5535 //
     /* 237923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 237926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 237931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 237934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 237937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 237940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237944 */     // MIs[0] idx
     /* 237944 */     // No operand predicates
     /* 237944 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 237947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 237951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 237958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 237961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 237965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 237973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 237977 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 237980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 237998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 238000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 238002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238005 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 238007 */     GIR_RootConstrainSelectedInstOperands,
     /* 238008 */     // GIR_Coverage, 5535,
     /* 238008 */     GIR_EraseRootFromParent_Done,
     /* 238009 */   // Label 4809: @238009
     /* 238009 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(238048), // Rule ID 5536 //
     /* 238014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 238017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 238022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 238025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 238028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 238031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238035 */     // MIs[0] idx
     /* 238035 */     // No operand predicates
     /* 238035 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 238035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 238038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 238040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 238042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 238044 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 238046 */     GIR_RootConstrainSelectedInstOperands,
     /* 238047 */     // GIR_Coverage, 5536,
     /* 238047 */     GIR_EraseRootFromParent_Done,
     /* 238048 */   // Label 4810: @238048
     /* 238048 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(238191), // Rule ID 5537 //
     /* 238053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 238056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 238061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 238064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 238067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 238070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238074 */     // MIs[0] idx
     /* 238074 */     // No operand predicates
     /* 238074 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 238074 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 238077 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 238081 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 238088 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 238091 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 238095 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238100 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 238103 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 238107 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 238110 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238115 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238120 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 238125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 238128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 238132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 238139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 238142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 238146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 238154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 238158 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 238161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 238176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 238179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 238181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 238187 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 238189 */     GIR_RootConstrainSelectedInstOperands,
     /* 238190 */     // GIR_Coverage, 5537,
     /* 238190 */     GIR_EraseRootFromParent_Done,
     /* 238191 */   // Label 4811: @238191
     /* 238191 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(238282), // Rule ID 5538 //
     /* 238196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 238199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 238204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 238207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 238210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 238213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238217 */     // MIs[0] idx
     /* 238217 */     // No operand predicates
     /* 238217 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 238217 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 238220 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 238224 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 238231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 238234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 238238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 238246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 238250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 238253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 238268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 238271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 238273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 238278 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 238280 */     GIR_RootConstrainSelectedInstOperands,
     /* 238281 */     // GIR_Coverage, 5538,
     /* 238281 */     GIR_EraseRootFromParent_Done,
     /* 238282 */   // Label 4812: @238282
     /* 238282 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(238373), // Rule ID 5539 //
     /* 238287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 238290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 238295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 238298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 238301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 238304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238308 */     // MIs[0] idx
     /* 238308 */     // No operand predicates
     /* 238308 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 238308 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 238311 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 238315 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 238322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 238325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 238329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238334 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 238337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 238341 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 238344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 238359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 238362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 238364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 238366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238369 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 238371 */     GIR_RootConstrainSelectedInstOperands,
     /* 238372 */     // GIR_Coverage, 5539,
     /* 238372 */     GIR_EraseRootFromParent_Done,
     /* 238373 */   // Label 4813: @238373
     /* 238373 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(238412), // Rule ID 5540 //
     /* 238378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 238381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 238386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 238389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 238392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 238395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238399 */     // MIs[0] idx
     /* 238399 */     // No operand predicates
     /* 238399 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 238399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 238402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 238404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 238406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 238408 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 238410 */     GIR_RootConstrainSelectedInstOperands,
     /* 238411 */     // GIR_Coverage, 5540,
     /* 238411 */     GIR_EraseRootFromParent_Done,
     /* 238412 */   // Label 4814: @238412
     /* 238412 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(238451), // Rule ID 5541 //
     /* 238417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 238420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 238425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 238428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 238431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 238434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238438 */     // MIs[0] idx
     /* 238438 */     // No operand predicates
     /* 238438 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 238438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 238441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 238443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 238445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 238447 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 238449 */     GIR_RootConstrainSelectedInstOperands,
     /* 238450 */     // GIR_Coverage, 5541,
     /* 238450 */     GIR_EraseRootFromParent_Done,
     /* 238451 */   // Label 4815: @238451
     /* 238451 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(238542), // Rule ID 5542 //
     /* 238456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 238459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 238464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 238467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 238470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 238473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238477 */     // MIs[0] idx
     /* 238477 */     // No operand predicates
     /* 238477 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 238477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 238480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 238484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 238491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 238494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 238498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 238506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 238510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 238513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 238528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 238531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 238533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 238535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238538 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 238540 */     GIR_RootConstrainSelectedInstOperands,
     /* 238541 */     // GIR_Coverage, 5542,
     /* 238541 */     GIR_EraseRootFromParent_Done,
     /* 238542 */   // Label 4816: @238542
     /* 238542 */   GIM_Reject,
     /* 238543 */ // Label 3940: @238543
     /* 238543 */ GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(245654),
     /* 238548 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 238551 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(238598), // Rule ID 2956 //
     /* 238556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 238564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 238579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238583 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1509:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 238583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 238586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238594 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238596 */     GIR_RootConstrainSelectedInstOperands,
     /* 238597 */     // GIR_Coverage, 2956,
     /* 238597 */     GIR_EraseRootFromParent_Done,
     /* 238598 */   // Label 4818: @238598
     /* 238598 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(238645), // Rule ID 2958 //
     /* 238603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 238611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 238626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1509:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 238630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 238633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238641 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238643 */     GIR_RootConstrainSelectedInstOperands,
     /* 238644 */     // GIR_Coverage, 2958,
     /* 238644 */     GIR_EraseRootFromParent_Done,
     /* 238645 */   // Label 4819: @238645
     /* 238645 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(238692), // Rule ID 2960 //
     /* 238650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 238658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 238673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1509:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 238677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 238680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238688 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238690 */     GIR_RootConstrainSelectedInstOperands,
     /* 238691 */     // GIR_Coverage, 2960,
     /* 238691 */     GIR_EraseRootFromParent_Done,
     /* 238692 */   // Label 4820: @238692
     /* 238692 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(238739), // Rule ID 2962 //
     /* 238697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 238705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 238720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1509:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 238724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 238727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238737 */     GIR_RootConstrainSelectedInstOperands,
     /* 238738 */     // GIR_Coverage, 2962,
     /* 238738 */     GIR_EraseRootFromParent_Done,
     /* 238739 */   // Label 4821: @238739
     /* 238739 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(238786), // Rule ID 7485 //
     /* 238744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 238752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 238767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1512:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 238771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 238774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238782 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238784 */     GIR_RootConstrainSelectedInstOperands,
     /* 238785 */     // GIR_Coverage, 7485,
     /* 238785 */     GIR_EraseRootFromParent_Done,
     /* 238786 */   // Label 4822: @238786
     /* 238786 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(238833), // Rule ID 7487 //
     /* 238791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 238799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 238814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1512:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 238818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 238821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238829 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238831 */     GIR_RootConstrainSelectedInstOperands,
     /* 238832 */     // GIR_Coverage, 7487,
     /* 238832 */     GIR_EraseRootFromParent_Done,
     /* 238833 */   // Label 4823: @238833
     /* 238833 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(238880), // Rule ID 7489 //
     /* 238838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 238846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 238861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1512:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 238865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 238868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238876 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238878 */     GIR_RootConstrainSelectedInstOperands,
     /* 238879 */     // GIR_Coverage, 7489,
     /* 238879 */     GIR_EraseRootFromParent_Done,
     /* 238880 */   // Label 4824: @238880
     /* 238880 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(238927), // Rule ID 7491 //
     /* 238885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 238893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 238908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1512:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 238912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 238915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238923 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238925 */     GIR_RootConstrainSelectedInstOperands,
     /* 238926 */     // GIR_Coverage, 7491,
     /* 238926 */     GIR_EraseRootFromParent_Done,
     /* 238927 */   // Label 4825: @238927
     /* 238927 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(239007), // Rule ID 5649 //
     /* 238932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 238937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 238940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 238943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 238946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 238949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 238952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 238964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 238968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 238972 */     // MIs[1] Operand 1
     /* 238972 */     // No operand predicates
     /* 238972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 238976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 238980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 238984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 238988 */     // MIs[2] Operand 1
     /* 238988 */     // No operand predicates
     /* 238988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 238990 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 238990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 238993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 238995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 238997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 239000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 239002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 239005 */     GIR_RootConstrainSelectedInstOperands,
     /* 239006 */     // GIR_Coverage, 5649,
     /* 239006 */     GIR_EraseRootFromParent_Done,
     /* 239007 */   // Label 4826: @239007
     /* 239007 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(239087), // Rule ID 5650 //
     /* 239012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 239017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 239020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 239023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 239026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 239029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 239032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 239044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 239048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 239052 */     // MIs[1] Operand 1
     /* 239052 */     // No operand predicates
     /* 239052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 239060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 239064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 239068 */     // MIs[2] Operand 1
     /* 239068 */     // No operand predicates
     /* 239068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 239070 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 239070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 239073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 239075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 239077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 239080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 239082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 239085 */     GIR_RootConstrainSelectedInstOperands,
     /* 239086 */     // GIR_Coverage, 5650,
     /* 239086 */     GIR_EraseRootFromParent_Done,
     /* 239087 */   // Label 4827: @239087
     /* 239087 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(239167), // Rule ID 5651 //
     /* 239092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 239097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 239100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 239103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 239106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 239109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 239112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 239124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 239128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 239132 */     // MIs[1] Operand 1
     /* 239132 */     // No operand predicates
     /* 239132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 239140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 239144 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 239148 */     // MIs[2] Operand 1
     /* 239148 */     // No operand predicates
     /* 239148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 239150 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 239150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 239153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 239155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 239157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 239160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 239162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 239165 */     GIR_RootConstrainSelectedInstOperands,
     /* 239166 */     // GIR_Coverage, 5651,
     /* 239166 */     GIR_EraseRootFromParent_Done,
     /* 239167 */   // Label 4828: @239167
     /* 239167 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(239247), // Rule ID 5652 //
     /* 239172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 239177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 239180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 239183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 239186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 239189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 239192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 239204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 239208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 239212 */     // MIs[1] Operand 1
     /* 239212 */     // No operand predicates
     /* 239212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 239220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 239224 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 239228 */     // MIs[2] Operand 1
     /* 239228 */     // No operand predicates
     /* 239228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 239230 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 239230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 239233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 239235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 239237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 239240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 239242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 239245 */     GIR_RootConstrainSelectedInstOperands,
     /* 239246 */     // GIR_Coverage, 5652,
     /* 239246 */     GIR_EraseRootFromParent_Done,
     /* 239247 */   // Label 4829: @239247
     /* 239247 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(239311), // Rule ID 3802 //
     /* 239252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 239255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 239260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 239263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 239266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 239269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 239272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239288 */     // MIs[0] imm
     /* 239288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 239296 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 239296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 239299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 239301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 239303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 239305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 239307 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 239309 */     GIR_RootConstrainSelectedInstOperands,
     /* 239310 */     // GIR_Coverage, 3802,
     /* 239310 */     GIR_EraseRootFromParent_Done,
     /* 239311 */   // Label 4830: @239311
     /* 239311 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(239375), // Rule ID 3803 //
     /* 239316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 239319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 239324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 239327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 239330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 239333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 239336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239352 */     // MIs[0] imm
     /* 239352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 239360 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 239360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 239363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 239365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 239367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 239369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 239371 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 239373 */     GIR_RootConstrainSelectedInstOperands,
     /* 239374 */     // GIR_Coverage, 3803,
     /* 239374 */     GIR_EraseRootFromParent_Done,
     /* 239375 */   // Label 4831: @239375
     /* 239375 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(239439), // Rule ID 3804 //
     /* 239380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 239383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 239388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 239391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 239394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 239397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 239400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239416 */     // MIs[0] imm
     /* 239416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 239424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 239424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 239427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 239429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 239431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 239433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 239435 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 239437 */     GIR_RootConstrainSelectedInstOperands,
     /* 239438 */     // GIR_Coverage, 3804,
     /* 239438 */     GIR_EraseRootFromParent_Done,
     /* 239439 */   // Label 4832: @239439
     /* 239439 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(239503), // Rule ID 3805 //
     /* 239444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 239447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 239452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 239455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 239458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 239461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 239464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 239480 */     // MIs[0] imm
     /* 239480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 239488 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 239488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 239491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 239493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 239495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 239497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 239499 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 239501 */     GIR_RootConstrainSelectedInstOperands,
     /* 239502 */     // GIR_Coverage, 3805,
     /* 239502 */     GIR_EraseRootFromParent_Done,
     /* 239503 */   // Label 4833: @239503
     /* 239503 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(239555), // Rule ID 2841 //
     /* 239508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 239516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239532 */     // MIs[0] idx
     /* 239532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239540 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1368:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 239540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 239543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239551 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 239553 */     GIR_RootConstrainSelectedInstOperands,
     /* 239554 */     // GIR_Coverage, 2841,
     /* 239554 */     GIR_EraseRootFromParent_Done,
     /* 239555 */   // Label 4834: @239555
     /* 239555 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(239607), // Rule ID 2842 //
     /* 239560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 239568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239584 */     // MIs[0] idx
     /* 239584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239592 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1368:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 239592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 239595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239603 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 239605 */     GIR_RootConstrainSelectedInstOperands,
     /* 239606 */     // GIR_Coverage, 2842,
     /* 239606 */     GIR_EraseRootFromParent_Done,
     /* 239607 */   // Label 4835: @239607
     /* 239607 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(239659), // Rule ID 2843 //
     /* 239612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 239620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239636 */     // MIs[0] idx
     /* 239636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 239644 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1368:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 239644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 239647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239655 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 239657 */     GIR_RootConstrainSelectedInstOperands,
     /* 239658 */     // GIR_Coverage, 2843,
     /* 239658 */     GIR_EraseRootFromParent_Done,
     /* 239659 */   // Label 4836: @239659
     /* 239659 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(239711), // Rule ID 2971 //
     /* 239664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 239672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239688 */     // MIs[0] Op4
     /* 239688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239691 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1508:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 239699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239707 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239709 */     GIR_RootConstrainSelectedInstOperands,
     /* 239710 */     // GIR_Coverage, 2971,
     /* 239710 */     GIR_EraseRootFromParent_Done,
     /* 239711 */   // Label 4837: @239711
     /* 239711 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(239763), // Rule ID 2972 //
     /* 239716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 239724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239740 */     // MIs[0] Op4
     /* 239740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1508:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 239751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239759 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239761 */     GIR_RootConstrainSelectedInstOperands,
     /* 239762 */     // GIR_Coverage, 2972,
     /* 239762 */     GIR_EraseRootFromParent_Done,
     /* 239763 */   // Label 4838: @239763
     /* 239763 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(239815), // Rule ID 2973 //
     /* 239768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 239776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239792 */     // MIs[0] Op4
     /* 239792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 239800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1508:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 239800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 239803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239811 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239813 */     GIR_RootConstrainSelectedInstOperands,
     /* 239814 */     // GIR_Coverage, 2973,
     /* 239814 */     GIR_EraseRootFromParent_Done,
     /* 239815 */   // Label 4839: @239815
     /* 239815 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(239867), // Rule ID 2974 //
     /* 239820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 239828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239844 */     // MIs[0] Op4
     /* 239844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1650:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 239855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239863 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239865 */     GIR_RootConstrainSelectedInstOperands,
     /* 239866 */     // GIR_Coverage, 2974,
     /* 239866 */     GIR_EraseRootFromParent_Done,
     /* 239867 */   // Label 4840: @239867
     /* 239867 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(239919), // Rule ID 2975 //
     /* 239872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 239880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239896 */     // MIs[0] Op4
     /* 239896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1650:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 239907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239915 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239917 */     GIR_RootConstrainSelectedInstOperands,
     /* 239918 */     // GIR_Coverage, 2975,
     /* 239918 */     GIR_EraseRootFromParent_Done,
     /* 239919 */   // Label 4841: @239919
     /* 239919 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(239971), // Rule ID 2978 //
     /* 239924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 239932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239948 */     // MIs[0] Op4
     /* 239948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 239959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239967 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239969 */     GIR_RootConstrainSelectedInstOperands,
     /* 239970 */     // GIR_Coverage, 2978,
     /* 239970 */     GIR_EraseRootFromParent_Done,
     /* 239971 */   // Label 4842: @239971
     /* 239971 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(240023), // Rule ID 2979 //
     /* 239976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 239984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240000 */     // MIs[0] Op4
     /* 240000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 240008 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 240008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 240011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240019 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240021 */     GIR_RootConstrainSelectedInstOperands,
     /* 240022 */     // GIR_Coverage, 2979,
     /* 240022 */     GIR_EraseRootFromParent_Done,
     /* 240023 */   // Label 4843: @240023
     /* 240023 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(240075), // Rule ID 3453 //
     /* 240028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 240031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 240036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240052 */     // MIs[0] Op4
     /* 240052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1963:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 240063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240071 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240073 */     GIR_RootConstrainSelectedInstOperands,
     /* 240074 */     // GIR_Coverage, 3453,
     /* 240074 */     GIR_EraseRootFromParent_Done,
     /* 240075 */   // Label 4844: @240075
     /* 240075 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(240127), // Rule ID 3497 //
     /* 240080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 240088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240104 */     // MIs[0] Op4
     /* 240104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 240115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240123 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240125 */     GIR_RootConstrainSelectedInstOperands,
     /* 240126 */     // GIR_Coverage, 3497,
     /* 240126 */     GIR_EraseRootFromParent_Done,
     /* 240127 */   // Label 4845: @240127
     /* 240127 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(240179), // Rule ID 7555 //
     /* 240132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 240140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240156 */     // MIs[0] Op4
     /* 240156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 240167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240175 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240177 */     GIR_RootConstrainSelectedInstOperands,
     /* 240178 */     // GIR_Coverage, 7555,
     /* 240178 */     GIR_EraseRootFromParent_Done,
     /* 240179 */   // Label 4846: @240179
     /* 240179 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(240231), // Rule ID 7556 //
     /* 240184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 240192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240208 */     // MIs[0] Op4
     /* 240208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 240216 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 240216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 240219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240227 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240229 */     GIR_RootConstrainSelectedInstOperands,
     /* 240230 */     // GIR_Coverage, 7556,
     /* 240230 */     GIR_EraseRootFromParent_Done,
     /* 240231 */   // Label 4847: @240231
     /* 240231 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(240283), // Rule ID 8196 //
     /* 240236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 240244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240260 */     // MIs[0] idx
     /* 240260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 240268 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1375:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 240268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 240271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240279 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 240281 */     GIR_RootConstrainSelectedInstOperands,
     /* 240282 */     // GIR_Coverage, 8196,
     /* 240282 */     GIR_EraseRootFromParent_Done,
     /* 240283 */   // Label 4848: @240283
     /* 240283 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(240335), // Rule ID 8197 //
     /* 240288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 240296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240312 */     // MIs[0] idx
     /* 240312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240320 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1375:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 240323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240331 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 240333 */     GIR_RootConstrainSelectedInstOperands,
     /* 240334 */     // GIR_Coverage, 8197,
     /* 240334 */     GIR_EraseRootFromParent_Done,
     /* 240335 */   // Label 4849: @240335
     /* 240335 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(240387), // Rule ID 8198 //
     /* 240340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 240348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240364 */     // MIs[0] idx
     /* 240364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 240372 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1375:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 240372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 240375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240383 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 240385 */     GIR_RootConstrainSelectedInstOperands,
     /* 240386 */     // GIR_Coverage, 8198,
     /* 240386 */     GIR_EraseRootFromParent_Done,
     /* 240387 */   // Label 4850: @240387
     /* 240387 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(240439), // Rule ID 11142 //
     /* 240392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 240395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 240400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240416 */     // MIs[0] Op4
     /* 240416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 240427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240435 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240437 */     GIR_RootConstrainSelectedInstOperands,
     /* 240438 */     // GIR_Coverage, 11142,
     /* 240438 */     GIR_EraseRootFromParent_Done,
     /* 240439 */   // Label 4851: @240439
     /* 240439 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(240491), // Rule ID 11189 //
     /* 240444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 240452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240468 */     // MIs[0] Op4
     /* 240468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 240476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1511:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 240476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 240479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240487 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240489 */     GIR_RootConstrainSelectedInstOperands,
     /* 240490 */     // GIR_Coverage, 11189,
     /* 240490 */     GIR_EraseRootFromParent_Done,
     /* 240491 */   // Label 4852: @240491
     /* 240491 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(240543), // Rule ID 11190 //
     /* 240496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 240504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240520 */     // MIs[0] Op4
     /* 240520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1511:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 240531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240541 */     GIR_RootConstrainSelectedInstOperands,
     /* 240542 */     // GIR_Coverage, 11190,
     /* 240542 */     GIR_EraseRootFromParent_Done,
     /* 240543 */   // Label 4853: @240543
     /* 240543 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(240595), // Rule ID 11191 //
     /* 240548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 240556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240572 */     // MIs[0] Op4
     /* 240572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 240580 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1511:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 240580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 240583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240591 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240593 */     GIR_RootConstrainSelectedInstOperands,
     /* 240594 */     // GIR_Coverage, 11191,
     /* 240594 */     GIR_EraseRootFromParent_Done,
     /* 240595 */   // Label 4854: @240595
     /* 240595 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(240647), // Rule ID 11192 //
     /* 240600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 240608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240624 */     // MIs[0] Op4
     /* 240624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 240632 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 240632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 240635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240643 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240645 */     GIR_RootConstrainSelectedInstOperands,
     /* 240646 */     // GIR_Coverage, 11192,
     /* 240646 */     GIR_EraseRootFromParent_Done,
     /* 240647 */   // Label 4855: @240647
     /* 240647 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(240699), // Rule ID 11193 //
     /* 240652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 240660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240676 */     // MIs[0] Op4
     /* 240676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 240687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240695 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240697 */     GIR_RootConstrainSelectedInstOperands,
     /* 240698 */     // GIR_Coverage, 11193,
     /* 240698 */     GIR_EraseRootFromParent_Done,
     /* 240699 */   // Label 4856: @240699
     /* 240699 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(240751), // Rule ID 11194 //
     /* 240704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 240712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240728 */     // MIs[0] Op4
     /* 240728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 240736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1729:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 240736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 240739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240747 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240749 */     GIR_RootConstrainSelectedInstOperands,
     /* 240750 */     // GIR_Coverage, 11194,
     /* 240750 */     GIR_EraseRootFromParent_Done,
     /* 240751 */   // Label 4857: @240751
     /* 240751 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(240803), // Rule ID 11195 //
     /* 240756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 240764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240780 */     // MIs[0] Op4
     /* 240780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 240788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 240788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 240791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240799 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240801 */     GIR_RootConstrainSelectedInstOperands,
     /* 240802 */     // GIR_Coverage, 11195,
     /* 240802 */     GIR_EraseRootFromParent_Done,
     /* 240803 */   // Label 4858: @240803
     /* 240803 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(240855), // Rule ID 11196 //
     /* 240808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 240816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240832 */     // MIs[0] Op4
     /* 240832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 240843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240853 */     GIR_RootConstrainSelectedInstOperands,
     /* 240854 */     // GIR_Coverage, 11196,
     /* 240854 */     GIR_EraseRootFromParent_Done,
     /* 240855 */   // Label 4859: @240855
     /* 240855 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(240907), // Rule ID 11197 //
     /* 240860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 240868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240884 */     // MIs[0] Op4
     /* 240884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 240892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 240892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 240895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240903 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240905 */     GIR_RootConstrainSelectedInstOperands,
     /* 240906 */     // GIR_Coverage, 11197,
     /* 240906 */     GIR_EraseRootFromParent_Done,
     /* 240907 */   // Label 4860: @240907
     /* 240907 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(240959), // Rule ID 11240 //
     /* 240912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 240920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240936 */     // MIs[0] Op4
     /* 240936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 240944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1652:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 240944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 240947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240955 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240957 */     GIR_RootConstrainSelectedInstOperands,
     /* 240958 */     // GIR_Coverage, 11240,
     /* 240958 */     GIR_EraseRootFromParent_Done,
     /* 240959 */   // Label 4861: @240959
     /* 240959 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(241011), // Rule ID 11241 //
     /* 240964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 240972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240988 */     // MIs[0] Op4
     /* 240988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1652:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 240999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241007 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241009 */     GIR_RootConstrainSelectedInstOperands,
     /* 241010 */     // GIR_Coverage, 11241,
     /* 241010 */     GIR_EraseRootFromParent_Done,
     /* 241011 */   // Label 4862: @241011
     /* 241011 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(241063), // Rule ID 11242 //
     /* 241016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 241024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241040 */     // MIs[0] Op4
     /* 241040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1888:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 241051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241059 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241061 */     GIR_RootConstrainSelectedInstOperands,
     /* 241062 */     // GIR_Coverage, 11242,
     /* 241062 */     GIR_EraseRootFromParent_Done,
     /* 241063 */   // Label 4863: @241063
     /* 241063 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(241115), // Rule ID 11243 //
     /* 241068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 241076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241092 */     // MIs[0] Op4
     /* 241092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1888:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 241103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241111 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241113 */     GIR_RootConstrainSelectedInstOperands,
     /* 241114 */     // GIR_Coverage, 11243,
     /* 241114 */     GIR_EraseRootFromParent_Done,
     /* 241115 */   // Label 4864: @241115
     /* 241115 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(241167), // Rule ID 11244 //
     /* 241120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 241128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241144 */     // MIs[0] Op4
     /* 241144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1890:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 241155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241163 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241165 */     GIR_RootConstrainSelectedInstOperands,
     /* 241166 */     // GIR_Coverage, 11244,
     /* 241166 */     GIR_EraseRootFromParent_Done,
     /* 241167 */   // Label 4865: @241167
     /* 241167 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(241219), // Rule ID 11245 //
     /* 241172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 241180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241196 */     // MIs[0] Op4
     /* 241196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1890:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 241207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241215 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241217 */     GIR_RootConstrainSelectedInstOperands,
     /* 241218 */     // GIR_Coverage, 11245,
     /* 241218 */     GIR_EraseRootFromParent_Done,
     /* 241219 */   // Label 4866: @241219
     /* 241219 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(241271), // Rule ID 11246 //
     /* 241224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 241232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241248 */     // MIs[0] Op4
     /* 241248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1654:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 241259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241267 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241269 */     GIR_RootConstrainSelectedInstOperands,
     /* 241270 */     // GIR_Coverage, 11246,
     /* 241270 */     GIR_EraseRootFromParent_Done,
     /* 241271 */   // Label 4867: @241271
     /* 241271 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(241323), // Rule ID 11247 //
     /* 241276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 241284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241300 */     // MIs[0] Op4
     /* 241300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1654:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 241311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241319 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241321 */     GIR_RootConstrainSelectedInstOperands,
     /* 241322 */     // GIR_Coverage, 11247,
     /* 241322 */     GIR_EraseRootFromParent_Done,
     /* 241323 */   // Label 4868: @241323
     /* 241323 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(241375), // Rule ID 11248 //
     /* 241328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 241336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241352 */     // MIs[0] Op4
     /* 241352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1656:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 241363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241371 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241373 */     GIR_RootConstrainSelectedInstOperands,
     /* 241374 */     // GIR_Coverage, 11248,
     /* 241374 */     GIR_EraseRootFromParent_Done,
     /* 241375 */   // Label 4869: @241375
     /* 241375 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(241427), // Rule ID 11249 //
     /* 241380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 241388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241404 */     // MIs[0] Op4
     /* 241404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1656:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 241415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241423 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241425 */     GIR_RootConstrainSelectedInstOperands,
     /* 241426 */     // GIR_Coverage, 11249,
     /* 241426 */     GIR_EraseRootFromParent_Done,
     /* 241427 */   // Label 4870: @241427
     /* 241427 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(241479), // Rule ID 11250 //
     /* 241432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 241440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241456 */     // MIs[0] Op4
     /* 241456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1892:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 241467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241477 */     GIR_RootConstrainSelectedInstOperands,
     /* 241478 */     // GIR_Coverage, 11250,
     /* 241478 */     GIR_EraseRootFromParent_Done,
     /* 241479 */   // Label 4871: @241479
     /* 241479 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(241531), // Rule ID 11251 //
     /* 241484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 241492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241508 */     // MIs[0] Op4
     /* 241508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1892:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 241519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241527 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241529 */     GIR_RootConstrainSelectedInstOperands,
     /* 241530 */     // GIR_Coverage, 11251,
     /* 241530 */     GIR_EraseRootFromParent_Done,
     /* 241531 */   // Label 4872: @241531
     /* 241531 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(241583), // Rule ID 11252 //
     /* 241536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 241544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241560 */     // MIs[0] Op4
     /* 241560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1894:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 241571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241579 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241581 */     GIR_RootConstrainSelectedInstOperands,
     /* 241582 */     // GIR_Coverage, 11252,
     /* 241582 */     GIR_EraseRootFromParent_Done,
     /* 241583 */   // Label 4873: @241583
     /* 241583 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(241635), // Rule ID 11253 //
     /* 241588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 241596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241612 */     // MIs[0] Op4
     /* 241612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1894:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 241623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241631 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241633 */     GIR_RootConstrainSelectedInstOperands,
     /* 241634 */     // GIR_Coverage, 11253,
     /* 241634 */     GIR_EraseRootFromParent_Done,
     /* 241635 */   // Label 4874: @241635
     /* 241635 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(241687), // Rule ID 11275 //
     /* 241640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 241648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241664 */     // MIs[0] Op4
     /* 241664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 241675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241683 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241685 */     GIR_RootConstrainSelectedInstOperands,
     /* 241686 */     // GIR_Coverage, 11275,
     /* 241686 */     GIR_EraseRootFromParent_Done,
     /* 241687 */   // Label 4875: @241687
     /* 241687 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(241739), // Rule ID 11276 //
     /* 241692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 241700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241716 */     // MIs[0] Op4
     /* 241716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 241727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241737 */     GIR_RootConstrainSelectedInstOperands,
     /* 241738 */     // GIR_Coverage, 11276,
     /* 241738 */     GIR_EraseRootFromParent_Done,
     /* 241739 */   // Label 4876: @241739
     /* 241739 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(241791), // Rule ID 11277 //
     /* 241744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 241752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241768 */     // MIs[0] Op4
     /* 241768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 241779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241789 */     GIR_RootConstrainSelectedInstOperands,
     /* 241790 */     // GIR_Coverage, 11277,
     /* 241790 */     GIR_EraseRootFromParent_Done,
     /* 241791 */   // Label 4877: @241791
     /* 241791 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(241843), // Rule ID 11278 //
     /* 241796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 241804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241820 */     // MIs[0] Op4
     /* 241820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 241831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241839 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241841 */     GIR_RootConstrainSelectedInstOperands,
     /* 241842 */     // GIR_Coverage, 11278,
     /* 241842 */     GIR_EraseRootFromParent_Done,
     /* 241843 */   // Label 4878: @241843
     /* 241843 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(241895), // Rule ID 11279 //
     /* 241848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 241856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241872 */     // MIs[0] Op4
     /* 241872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 241883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241891 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241893 */     GIR_RootConstrainSelectedInstOperands,
     /* 241894 */     // GIR_Coverage, 11279,
     /* 241894 */     GIR_EraseRootFromParent_Done,
     /* 241895 */   // Label 4879: @241895
     /* 241895 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(241947), // Rule ID 11280 //
     /* 241900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 241908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241924 */     // MIs[0] Op4
     /* 241924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 241932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 241932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 241935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241943 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241945 */     GIR_RootConstrainSelectedInstOperands,
     /* 241946 */     // GIR_Coverage, 11280,
     /* 241946 */     GIR_EraseRootFromParent_Done,
     /* 241947 */   // Label 4880: @241947
     /* 241947 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(241999), // Rule ID 11281 //
     /* 241952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 241955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 241960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241976 */     // MIs[0] Op4
     /* 241976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 241984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1700:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 241984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 241987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241995 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241997 */     GIR_RootConstrainSelectedInstOperands,
     /* 241998 */     // GIR_Coverage, 11281,
     /* 241998 */     GIR_EraseRootFromParent_Done,
     /* 241999 */   // Label 4881: @241999
     /* 241999 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(242051), // Rule ID 11282 //
     /* 242004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 242012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242028 */     // MIs[0] Op4
     /* 242028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1700:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 242039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242047 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242049 */     GIR_RootConstrainSelectedInstOperands,
     /* 242050 */     // GIR_Coverage, 11282,
     /* 242050 */     GIR_EraseRootFromParent_Done,
     /* 242051 */   // Label 4882: @242051
     /* 242051 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(242103), // Rule ID 11736 //
     /* 242056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 242064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242080 */     // MIs[0] Op4
     /* 242080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 242088 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 242088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 242091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242101 */     GIR_RootConstrainSelectedInstOperands,
     /* 242102 */     // GIR_Coverage, 11736,
     /* 242102 */     GIR_EraseRootFromParent_Done,
     /* 242103 */   // Label 4883: @242103
     /* 242103 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(242155), // Rule ID 11737 //
     /* 242108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 242116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242132 */     // MIs[0] Op4
     /* 242132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 242140 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 242140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 242143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242151 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242153 */     GIR_RootConstrainSelectedInstOperands,
     /* 242154 */     // GIR_Coverage, 11737,
     /* 242154 */     GIR_EraseRootFromParent_Done,
     /* 242155 */   // Label 4884: @242155
     /* 242155 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(242207), // Rule ID 11738 //
     /* 242160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 242168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242184 */     // MIs[0] Op4
     /* 242184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 242192 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1378:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 242192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 242195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242203 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242205 */     GIR_RootConstrainSelectedInstOperands,
     /* 242206 */     // GIR_Coverage, 11738,
     /* 242206 */     GIR_EraseRootFromParent_Done,
     /* 242207 */   // Label 4885: @242207
     /* 242207 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(242259), // Rule ID 11739 //
     /* 242212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 242220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242236 */     // MIs[0] Op4
     /* 242236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 242244 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1380:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 242244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 242247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242255 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242257 */     GIR_RootConstrainSelectedInstOperands,
     /* 242258 */     // GIR_Coverage, 11739,
     /* 242258 */     GIR_EraseRootFromParent_Done,
     /* 242259 */   // Label 4886: @242259
     /* 242259 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(242311), // Rule ID 11872 //
     /* 242264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 242272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242288 */     // MIs[0] Op4
     /* 242288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242296 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1326:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 242299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242307 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242309 */     GIR_RootConstrainSelectedInstOperands,
     /* 242310 */     // GIR_Coverage, 11872,
     /* 242310 */     GIR_EraseRootFromParent_Done,
     /* 242311 */   // Label 4887: @242311
     /* 242311 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(242363), // Rule ID 11874 //
     /* 242316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 242324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242340 */     // MIs[0] Op4
     /* 242340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 242351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242361 */     GIR_RootConstrainSelectedInstOperands,
     /* 242362 */     // GIR_Coverage, 11874,
     /* 242362 */     GIR_EraseRootFromParent_Done,
     /* 242363 */   // Label 4888: @242363
     /* 242363 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(242410), // Rule ID 2820 //
     /* 242368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 242376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242395 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 242398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242406 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242408 */     GIR_RootConstrainSelectedInstOperands,
     /* 242409 */     // GIR_Coverage, 2820,
     /* 242409 */     GIR_EraseRootFromParent_Done,
     /* 242410 */   // Label 4889: @242410
     /* 242410 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(242457), // Rule ID 2823 //
     /* 242415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 242423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242442 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 242445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242453 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242455 */     GIR_RootConstrainSelectedInstOperands,
     /* 242456 */     // GIR_Coverage, 2823,
     /* 242456 */     GIR_EraseRootFromParent_Done,
     /* 242457 */   // Label 4890: @242457
     /* 242457 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(242504), // Rule ID 2826 //
     /* 242462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 242470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242489 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 242492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242500 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242502 */     GIR_RootConstrainSelectedInstOperands,
     /* 242503 */     // GIR_Coverage, 2826,
     /* 242503 */     GIR_EraseRootFromParent_Done,
     /* 242504 */   // Label 4891: @242504
     /* 242504 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(242551), // Rule ID 2829 //
     /* 242509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 242517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242536 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 242539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242547 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242549 */     GIR_RootConstrainSelectedInstOperands,
     /* 242550 */     // GIR_Coverage, 2829,
     /* 242550 */     GIR_EraseRootFromParent_Done,
     /* 242551 */   // Label 4892: @242551
     /* 242551 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(242598), // Rule ID 2832 //
     /* 242556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 242564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 242579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242583 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 242583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 242586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242594 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242596 */     GIR_RootConstrainSelectedInstOperands,
     /* 242597 */     // GIR_Coverage, 2832,
     /* 242597 */     GIR_EraseRootFromParent_Done,
     /* 242598 */   // Label 4893: @242598
     /* 242598 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(242645), // Rule ID 2835 //
     /* 242603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 242611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242630 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 242633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242641 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242643 */     GIR_RootConstrainSelectedInstOperands,
     /* 242644 */     // GIR_Coverage, 2835,
     /* 242644 */     GIR_EraseRootFromParent_Done,
     /* 242645 */   // Label 4894: @242645
     /* 242645 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(242692), // Rule ID 2838 //
     /* 242650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 242658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242677 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 242680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242688 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242690 */     GIR_RootConstrainSelectedInstOperands,
     /* 242691 */     // GIR_Coverage, 2838,
     /* 242691 */     GIR_EraseRootFromParent_Done,
     /* 242692 */   // Label 4895: @242692
     /* 242692 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(242739), // Rule ID 2839 //
     /* 242697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 242705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242724 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 242727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242737 */     GIR_RootConstrainSelectedInstOperands,
     /* 242738 */     // GIR_Coverage, 2839,
     /* 242738 */     GIR_EraseRootFromParent_Done,
     /* 242739 */   // Label 4896: @242739
     /* 242739 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(242786), // Rule ID 2840 //
     /* 242744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 242752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242771 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1330:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 242774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242782 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242784 */     GIR_RootConstrainSelectedInstOperands,
     /* 242785 */     // GIR_Coverage, 2840,
     /* 242785 */     GIR_EraseRootFromParent_Done,
     /* 242786 */   // Label 4897: @242786
     /* 242786 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(242833), // Rule ID 2936 //
     /* 242791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 242799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1505:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 242821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242829 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242831 */     GIR_RootConstrainSelectedInstOperands,
     /* 242832 */     // GIR_Coverage, 2936,
     /* 242832 */     GIR_EraseRootFromParent_Done,
     /* 242833 */   // Label 4898: @242833
     /* 242833 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(242880), // Rule ID 2939 //
     /* 242838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 242846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1505:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 242868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242876 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242878 */     GIR_RootConstrainSelectedInstOperands,
     /* 242879 */     // GIR_Coverage, 2939,
     /* 242879 */     GIR_EraseRootFromParent_Done,
     /* 242880 */   // Label 4899: @242880
     /* 242880 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(242927), // Rule ID 2942 //
     /* 242885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 242893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1505:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 242915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242923 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242925 */     GIR_RootConstrainSelectedInstOperands,
     /* 242926 */     // GIR_Coverage, 2942,
     /* 242926 */     GIR_EraseRootFromParent_Done,
     /* 242927 */   // Label 4900: @242927
     /* 242927 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(242974), // Rule ID 2945 //
     /* 242932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 242940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1505:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 242962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242970 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242972 */     GIR_RootConstrainSelectedInstOperands,
     /* 242973 */     // GIR_Coverage, 2945,
     /* 242973 */     GIR_EraseRootFromParent_Done,
     /* 242974 */   // Label 4901: @242974
     /* 242974 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(243021), // Rule ID 2948 //
     /* 242979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 242987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 243002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1507:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 243006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 243009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243017 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243019 */     GIR_RootConstrainSelectedInstOperands,
     /* 243020 */     // GIR_Coverage, 2948,
     /* 243020 */     GIR_EraseRootFromParent_Done,
     /* 243021 */   // Label 4902: @243021
     /* 243021 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(243068), // Rule ID 2950 //
     /* 243026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 243034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243053 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1507:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 243053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 243056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243064 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243066 */     GIR_RootConstrainSelectedInstOperands,
     /* 243067 */     // GIR_Coverage, 2950,
     /* 243067 */     GIR_EraseRootFromParent_Done,
     /* 243068 */   // Label 4903: @243068
     /* 243068 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(243115), // Rule ID 2952 //
     /* 243073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 243081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1507:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 243100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 243103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243111 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243113 */     GIR_RootConstrainSelectedInstOperands,
     /* 243114 */     // GIR_Coverage, 2952,
     /* 243114 */     GIR_EraseRootFromParent_Done,
     /* 243115 */   // Label 4904: @243115
     /* 243115 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(243162), // Rule ID 2954 //
     /* 243120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 243128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243147 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1507:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 243147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 243150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243158 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243160 */     GIR_RootConstrainSelectedInstOperands,
     /* 243161 */     // GIR_Coverage, 2954,
     /* 243161 */     GIR_EraseRootFromParent_Done,
     /* 243162 */   // Label 4905: @243162
     /* 243162 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(243209), // Rule ID 7465 //
     /* 243167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 243175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 243190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243194 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1513:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 243194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 243197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243205 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243207 */     GIR_RootConstrainSelectedInstOperands,
     /* 243208 */     // GIR_Coverage, 7465,
     /* 243208 */     GIR_EraseRootFromParent_Done,
     /* 243209 */   // Label 4906: @243209
     /* 243209 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(243256), // Rule ID 7468 //
     /* 243214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 243222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1513:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 243241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 243244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243252 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243254 */     GIR_RootConstrainSelectedInstOperands,
     /* 243255 */     // GIR_Coverage, 7468,
     /* 243255 */     GIR_EraseRootFromParent_Done,
     /* 243256 */   // Label 4907: @243256
     /* 243256 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(243303), // Rule ID 7471 //
     /* 243261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 243269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1513:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 243288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 243291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243299 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243301 */     GIR_RootConstrainSelectedInstOperands,
     /* 243302 */     // GIR_Coverage, 7471,
     /* 243302 */     GIR_EraseRootFromParent_Done,
     /* 243303 */   // Label 4908: @243303
     /* 243303 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(243350), // Rule ID 7474 //
     /* 243308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 243316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243335 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1513:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 243335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 243338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243346 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243348 */     GIR_RootConstrainSelectedInstOperands,
     /* 243349 */     // GIR_Coverage, 7474,
     /* 243349 */     GIR_EraseRootFromParent_Done,
     /* 243350 */   // Label 4909: @243350
     /* 243350 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(243397), // Rule ID 7477 //
     /* 243355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 243363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 243378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1510:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 243382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 243385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243393 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243395 */     GIR_RootConstrainSelectedInstOperands,
     /* 243396 */     // GIR_Coverage, 7477,
     /* 243396 */     GIR_EraseRootFromParent_Done,
     /* 243397 */   // Label 4910: @243397
     /* 243397 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(243444), // Rule ID 7479 //
     /* 243402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 243410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243429 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1510:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 243429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 243432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243440 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243442 */     GIR_RootConstrainSelectedInstOperands,
     /* 243443 */     // GIR_Coverage, 7479,
     /* 243443 */     GIR_EraseRootFromParent_Done,
     /* 243444 */   // Label 4911: @243444
     /* 243444 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(243491), // Rule ID 7481 //
     /* 243449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 243457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1510:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 243476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 243479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243487 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243489 */     GIR_RootConstrainSelectedInstOperands,
     /* 243490 */     // GIR_Coverage, 7481,
     /* 243490 */     GIR_EraseRootFromParent_Done,
     /* 243491 */   // Label 4912: @243491
     /* 243491 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(243538), // Rule ID 7483 //
     /* 243496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 243504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1510:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 243523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 243526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243534 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243536 */     GIR_RootConstrainSelectedInstOperands,
     /* 243537 */     // GIR_Coverage, 7483,
     /* 243537 */     GIR_EraseRootFromParent_Done,
     /* 243538 */   // Label 4913: @243538
     /* 243538 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(243585), // Rule ID 8109 //
     /* 243543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 243551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243570 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 243570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 243573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243581 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243583 */     GIR_RootConstrainSelectedInstOperands,
     /* 243584 */     // GIR_Coverage, 8109,
     /* 243584 */     GIR_EraseRootFromParent_Done,
     /* 243585 */   // Label 4914: @243585
     /* 243585 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(243632), // Rule ID 8112 //
     /* 243590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 243598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 243601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 243607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 243610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 243613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243617 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 243617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 243620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243628 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243630 */     GIR_RootConstrainSelectedInstOperands,
     /* 243631 */     // GIR_Coverage, 8112,
     /* 243631 */     GIR_EraseRootFromParent_Done,
     /* 243632 */   // Label 4915: @243632
     /* 243632 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(243679), // Rule ID 8115 //
     /* 243637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 243645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 243648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 243654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 243657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 243660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243664 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 243664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 243667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243675 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243677 */     GIR_RootConstrainSelectedInstOperands,
     /* 243678 */     // GIR_Coverage, 8115,
     /* 243678 */     GIR_EraseRootFromParent_Done,
     /* 243679 */   // Label 4916: @243679
     /* 243679 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(243726), // Rule ID 8118 //
     /* 243684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 243692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243711 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 243711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 243714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243722 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243724 */     GIR_RootConstrainSelectedInstOperands,
     /* 243725 */     // GIR_Coverage, 8118,
     /* 243725 */     GIR_EraseRootFromParent_Done,
     /* 243726 */   // Label 4917: @243726
     /* 243726 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(243773), // Rule ID 8121 //
     /* 243731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 243739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 243742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 243748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 243751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 243754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243758 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 243758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 243761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243769 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243771 */     GIR_RootConstrainSelectedInstOperands,
     /* 243772 */     // GIR_Coverage, 8121,
     /* 243772 */     GIR_EraseRootFromParent_Done,
     /* 243773 */   // Label 4918: @243773
     /* 243773 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(243820), // Rule ID 8124 //
     /* 243778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 243786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243805 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 243805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 243808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243816 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243818 */     GIR_RootConstrainSelectedInstOperands,
     /* 243819 */     // GIR_Coverage, 8124,
     /* 243819 */     GIR_EraseRootFromParent_Done,
     /* 243820 */   // Label 4919: @243820
     /* 243820 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(243867), // Rule ID 8127 //
     /* 243825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 243833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243852 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1390:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 243852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 243855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243863 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243865 */     GIR_RootConstrainSelectedInstOperands,
     /* 243866 */     // GIR_Coverage, 8127,
     /* 243866 */     GIR_EraseRootFromParent_Done,
     /* 243867 */   // Label 4920: @243867
     /* 243867 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(243914), // Rule ID 8128 //
     /* 243872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 243880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 243883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 243889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 243892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 243895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243899 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1390:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 243899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 243902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243910 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243912 */     GIR_RootConstrainSelectedInstOperands,
     /* 243913 */     // GIR_Coverage, 8128,
     /* 243913 */     GIR_EraseRootFromParent_Done,
     /* 243914 */   // Label 4921: @243914
     /* 243914 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(243961), // Rule ID 8129 //
     /* 243919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 243927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 243930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 243936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 243939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 243942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243946 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 243946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 243949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243957 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243959 */     GIR_RootConstrainSelectedInstOperands,
     /* 243960 */     // GIR_Coverage, 8129,
     /* 243960 */     GIR_EraseRootFromParent_Done,
     /* 243961 */   // Label 4922: @243961
     /* 243961 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(244008), // Rule ID 8130 //
     /* 243966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 243974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243993 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1390:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 243993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 243996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244004 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244006 */     GIR_RootConstrainSelectedInstOperands,
     /* 244007 */     // GIR_Coverage, 8130,
     /* 244007 */     GIR_EraseRootFromParent_Done,
     /* 244008 */   // Label 4923: @244008
     /* 244008 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(244055), // Rule ID 8131 //
     /* 244013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 244021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 244024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 244030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 244033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 244036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244040 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 244040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 244043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244051 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244053 */     GIR_RootConstrainSelectedInstOperands,
     /* 244054 */     // GIR_Coverage, 8131,
     /* 244054 */     GIR_EraseRootFromParent_Done,
     /* 244055 */   // Label 4924: @244055
     /* 244055 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(244102), // Rule ID 8132 //
     /* 244060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 244068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244087 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 244087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 244090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244098 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244100 */     GIR_RootConstrainSelectedInstOperands,
     /* 244101 */     // GIR_Coverage, 8132,
     /* 244101 */     GIR_EraseRootFromParent_Done,
     /* 244102 */   // Label 4925: @244102
     /* 244102 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(244149), // Rule ID 8133 //
     /* 244107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 244115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244134 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1392:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 244134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 244137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244145 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244147 */     GIR_RootConstrainSelectedInstOperands,
     /* 244148 */     // GIR_Coverage, 8133,
     /* 244148 */     GIR_EraseRootFromParent_Done,
     /* 244149 */   // Label 4926: @244149
     /* 244149 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(244196), // Rule ID 8134 //
     /* 244154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 244162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 244165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 244171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 244174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 244177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244181 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1392:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 244181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 244184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244192 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244194 */     GIR_RootConstrainSelectedInstOperands,
     /* 244195 */     // GIR_Coverage, 8134,
     /* 244195 */     GIR_EraseRootFromParent_Done,
     /* 244196 */   // Label 4927: @244196
     /* 244196 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(244243), // Rule ID 8135 //
     /* 244201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 244209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 244212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 244218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 244221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 244224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244228 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 244228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 244231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244239 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244241 */     GIR_RootConstrainSelectedInstOperands,
     /* 244242 */     // GIR_Coverage, 8135,
     /* 244242 */     GIR_EraseRootFromParent_Done,
     /* 244243 */   // Label 4928: @244243
     /* 244243 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(244290), // Rule ID 8136 //
     /* 244248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 244256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244275 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1392:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 244275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 244278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244286 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244288 */     GIR_RootConstrainSelectedInstOperands,
     /* 244289 */     // GIR_Coverage, 8136,
     /* 244289 */     GIR_EraseRootFromParent_Done,
     /* 244290 */   // Label 4929: @244290
     /* 244290 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(244337), // Rule ID 8137 //
     /* 244295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 244303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 244306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 244312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 244315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 244318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244322 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 244322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 244325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244333 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244335 */     GIR_RootConstrainSelectedInstOperands,
     /* 244336 */     // GIR_Coverage, 8137,
     /* 244336 */     GIR_EraseRootFromParent_Done,
     /* 244337 */   // Label 4930: @244337
     /* 244337 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(244384), // Rule ID 8138 //
     /* 244342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 244350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244369 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 244369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 244372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244380 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244382 */     GIR_RootConstrainSelectedInstOperands,
     /* 244383 */     // GIR_Coverage, 8138,
     /* 244383 */     GIR_EraseRootFromParent_Done,
     /* 244384 */   // Label 4931: @244384
     /* 244384 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(244431), // Rule ID 8139 //
     /* 244389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 244397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244416 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1382:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 244416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 244419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244427 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244429 */     GIR_RootConstrainSelectedInstOperands,
     /* 244430 */     // GIR_Coverage, 8139,
     /* 244430 */     GIR_EraseRootFromParent_Done,
     /* 244431 */   // Label 4932: @244431
     /* 244431 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(244478), // Rule ID 8140 //
     /* 244436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 244444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244463 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 244463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 244466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244474 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244476 */     GIR_RootConstrainSelectedInstOperands,
     /* 244477 */     // GIR_Coverage, 8140,
     /* 244477 */     GIR_EraseRootFromParent_Done,
     /* 244478 */   // Label 4933: @244478
     /* 244478 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(244525), // Rule ID 8141 //
     /* 244483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 244491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244510 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 244510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 244513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244521 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244523 */     GIR_RootConstrainSelectedInstOperands,
     /* 244524 */     // GIR_Coverage, 8141,
     /* 244524 */     GIR_EraseRootFromParent_Done,
     /* 244525 */   // Label 4934: @244525
     /* 244525 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(244572), // Rule ID 8142 //
     /* 244530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 244538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244557 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1389:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 244557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 244560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244568 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244570 */     GIR_RootConstrainSelectedInstOperands,
     /* 244571 */     // GIR_Coverage, 8142,
     /* 244571 */     GIR_EraseRootFromParent_Done,
     /* 244572 */   // Label 4935: @244572
     /* 244572 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(244619), // Rule ID 8143 //
     /* 244577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 244585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244604 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 244604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 244607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244615 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244617 */     GIR_RootConstrainSelectedInstOperands,
     /* 244618 */     // GIR_Coverage, 8143,
     /* 244618 */     GIR_EraseRootFromParent_Done,
     /* 244619 */   // Label 4936: @244619
     /* 244619 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(244666), // Rule ID 8144 //
     /* 244624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 244632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244651 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1389:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 244651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 244654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244662 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244664 */     GIR_RootConstrainSelectedInstOperands,
     /* 244665 */     // GIR_Coverage, 8144,
     /* 244665 */     GIR_EraseRootFromParent_Done,
     /* 244666 */   // Label 4937: @244666
     /* 244666 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(244713), // Rule ID 8145 //
     /* 244671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 244679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244698 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1394:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 244698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 244701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244709 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244711 */     GIR_RootConstrainSelectedInstOperands,
     /* 244712 */     // GIR_Coverage, 8145,
     /* 244712 */     GIR_EraseRootFromParent_Done,
     /* 244713 */   // Label 4938: @244713
     /* 244713 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(244760), // Rule ID 8146 //
     /* 244718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 244726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244745 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1394:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 244745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 244748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244756 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244758 */     GIR_RootConstrainSelectedInstOperands,
     /* 244759 */     // GIR_Coverage, 8146,
     /* 244759 */     GIR_EraseRootFromParent_Done,
     /* 244760 */   // Label 4939: @244760
     /* 244760 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(244807), // Rule ID 8147 //
     /* 244765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 244773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 244788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244792 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1394:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 244792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 244795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244803 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244805 */     GIR_RootConstrainSelectedInstOperands,
     /* 244806 */     // GIR_Coverage, 8147,
     /* 244806 */     GIR_EraseRootFromParent_Done,
     /* 244807 */   // Label 4940: @244807
     /* 244807 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(244854), // Rule ID 8148 //
     /* 244812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 244820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 244835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244839 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 244839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 244842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244850 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244852 */     GIR_RootConstrainSelectedInstOperands,
     /* 244853 */     // GIR_Coverage, 8148,
     /* 244853 */     GIR_EraseRootFromParent_Done,
     /* 244854 */   // Label 4941: @244854
     /* 244854 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(244901), // Rule ID 8151 //
     /* 244859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 244867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 244870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 244876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 244879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 244882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244886 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 244886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 244889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244897 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244899 */     GIR_RootConstrainSelectedInstOperands,
     /* 244900 */     // GIR_Coverage, 8151,
     /* 244900 */     GIR_EraseRootFromParent_Done,
     /* 244901 */   // Label 4942: @244901
     /* 244901 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(244948), // Rule ID 8154 //
     /* 244906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 244914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 244917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 244923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 244926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 244929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244933 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 244933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 244936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244944 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244946 */     GIR_RootConstrainSelectedInstOperands,
     /* 244947 */     // GIR_Coverage, 8154,
     /* 244947 */     GIR_EraseRootFromParent_Done,
     /* 244948 */   // Label 4943: @244948
     /* 244948 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(244995), // Rule ID 8157 //
     /* 244953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 244961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 244976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244980 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 244980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 244983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244991 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244993 */     GIR_RootConstrainSelectedInstOperands,
     /* 244994 */     // GIR_Coverage, 8157,
     /* 244994 */     GIR_EraseRootFromParent_Done,
     /* 244995 */   // Label 4944: @244995
     /* 244995 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(245042), // Rule ID 8160 //
     /* 245000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 245008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 245011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 245017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 245020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 245023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245027 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 245027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 245030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245038 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245040 */     GIR_RootConstrainSelectedInstOperands,
     /* 245041 */     // GIR_Coverage, 8160,
     /* 245041 */     GIR_EraseRootFromParent_Done,
     /* 245042 */   // Label 4945: @245042
     /* 245042 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(245089), // Rule ID 8163 //
     /* 245047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 245055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 245070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 245074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 245077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245085 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245087 */     GIR_RootConstrainSelectedInstOperands,
     /* 245088 */     // GIR_Coverage, 8163,
     /* 245088 */     GIR_EraseRootFromParent_Done,
     /* 245089 */   // Label 4946: @245089
     /* 245089 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(245136), // Rule ID 8166 //
     /* 245094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 245102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245121 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1391:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 245121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 245124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245132 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245134 */     GIR_RootConstrainSelectedInstOperands,
     /* 245135 */     // GIR_Coverage, 8166,
     /* 245135 */     GIR_EraseRootFromParent_Done,
     /* 245136 */   // Label 4947: @245136
     /* 245136 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(245183), // Rule ID 8169 //
     /* 245141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 245149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 245152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 245158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 245161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 245164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245168 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1391:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 245168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 245171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245179 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245181 */     GIR_RootConstrainSelectedInstOperands,
     /* 245182 */     // GIR_Coverage, 8169,
     /* 245182 */     GIR_EraseRootFromParent_Done,
     /* 245183 */   // Label 4948: @245183
     /* 245183 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(245230), // Rule ID 8172 //
     /* 245188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 245196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 245199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 245205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 245208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 245211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245215 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 245215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 245218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245226 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245228 */     GIR_RootConstrainSelectedInstOperands,
     /* 245229 */     // GIR_Coverage, 8172,
     /* 245229 */     GIR_EraseRootFromParent_Done,
     /* 245230 */   // Label 4949: @245230
     /* 245230 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(245277), // Rule ID 8175 //
     /* 245235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 245243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 245258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245262 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1391:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 245262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 245265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245273 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245275 */     GIR_RootConstrainSelectedInstOperands,
     /* 245276 */     // GIR_Coverage, 8175,
     /* 245276 */     GIR_EraseRootFromParent_Done,
     /* 245277 */   // Label 4950: @245277
     /* 245277 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(245324), // Rule ID 8178 //
     /* 245282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 245290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 245293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 245299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 245302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 245305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245309 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 245309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 245312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245320 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245322 */     GIR_RootConstrainSelectedInstOperands,
     /* 245323 */     // GIR_Coverage, 8178,
     /* 245323 */     GIR_EraseRootFromParent_Done,
     /* 245324 */   // Label 4951: @245324
     /* 245324 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(245371), // Rule ID 8181 //
     /* 245329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 245337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 245352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245356 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 245356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 245359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245367 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245369 */     GIR_RootConstrainSelectedInstOperands,
     /* 245370 */     // GIR_Coverage, 8181,
     /* 245370 */     GIR_EraseRootFromParent_Done,
     /* 245371 */   // Label 4952: @245371
     /* 245371 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(245418), // Rule ID 8184 //
     /* 245376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 245384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245403 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1393:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 245403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 245406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245414 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245416 */     GIR_RootConstrainSelectedInstOperands,
     /* 245417 */     // GIR_Coverage, 8184,
     /* 245417 */     GIR_EraseRootFromParent_Done,
     /* 245418 */   // Label 4953: @245418
     /* 245418 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(245465), // Rule ID 8186 //
     /* 245423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 245431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 245434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 245440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 245443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 245446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245450 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1393:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 245450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 245453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245461 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245463 */     GIR_RootConstrainSelectedInstOperands,
     /* 245464 */     // GIR_Coverage, 8186,
     /* 245464 */     GIR_EraseRootFromParent_Done,
     /* 245465 */   // Label 4954: @245465
     /* 245465 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(245512), // Rule ID 8188 //
     /* 245470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 245478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 245481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 245487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 245490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 245493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245497 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 245497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 245500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245508 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245510 */     GIR_RootConstrainSelectedInstOperands,
     /* 245511 */     // GIR_Coverage, 8188,
     /* 245511 */     GIR_EraseRootFromParent_Done,
     /* 245512 */   // Label 4955: @245512
     /* 245512 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(245559), // Rule ID 8190 //
     /* 245517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 245525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 245540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1393:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 245544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 245547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245555 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245557 */     GIR_RootConstrainSelectedInstOperands,
     /* 245558 */     // GIR_Coverage, 8190,
     /* 245558 */     GIR_EraseRootFromParent_Done,
     /* 245559 */   // Label 4956: @245559
     /* 245559 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(245606), // Rule ID 8192 //
     /* 245564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 245572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 245575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 245581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 245584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 245587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245591 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 245591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 245594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245602 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245604 */     GIR_RootConstrainSelectedInstOperands,
     /* 245605 */     // GIR_Coverage, 8192,
     /* 245605 */     GIR_EraseRootFromParent_Done,
     /* 245606 */   // Label 4957: @245606
     /* 245606 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(245653), // Rule ID 8194 //
     /* 245611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 245619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 245634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245638 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 245638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 245641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245649 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245651 */     GIR_RootConstrainSelectedInstOperands,
     /* 245652 */     // GIR_Coverage, 8194,
     /* 245652 */     GIR_EraseRootFromParent_Done,
     /* 245653 */   // Label 4958: @245653
     /* 245653 */   GIM_Reject,
     /* 245654 */ // Label 4817: @245654
     /* 245654 */ GIM_Reject,
     /* 245655 */ // Label 36: @245655
     /* 245655 */ GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(245733),
     /* 245660 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 245663 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(245685), // Rule ID 78 //
     /* 245668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 245671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 245676 */     // (intrinsic_void 2072:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 245676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 245679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245683 */     GIR_RootConstrainSelectedInstOperands,
     /* 245684 */     // GIR_Coverage, 78,
     /* 245684 */     GIR_EraseRootFromParent_Done,
     /* 245685 */   // Label 4960: @245685
     /* 245685 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(245710), // Rule ID 2377 //
     /* 245690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 245693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 245698 */     // (intrinsic_void 1622:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 245698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 245701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 245704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245708 */     GIR_RootConstrainSelectedInstOperands,
     /* 245709 */     // GIR_Coverage, 2377,
     /* 245709 */     GIR_EraseRootFromParent_Done,
     /* 245710 */   // Label 4961: @245710
     /* 245710 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(245732), // Rule ID 7049 //
     /* 245715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 245720 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 245720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 245723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 245726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245730 */     GIR_RootConstrainSelectedInstOperands,
     /* 245731 */     // GIR_Coverage, 7049,
     /* 245731 */     GIR_EraseRootFromParent_Done,
     /* 245732 */   // Label 4962: @245732
     /* 245732 */   GIM_Reject,
     /* 245733 */ // Label 4959: @245733
     /* 245733 */ GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(246333),
     /* 245738 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 245741 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(245773), // Rule ID 79 //
     /* 245746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 245749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 245754 */     // MIs[0] imm
     /* 245754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 245762 */     // (intrinsic_void 2071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 245762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 245765 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 245767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245771 */     GIR_RootConstrainSelectedInstOperands,
     /* 245772 */     // GIR_Coverage, 79,
     /* 245772 */     GIR_EraseRootFromParent_Done,
     /* 245773 */   // Label 4964: @245773
     /* 245773 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(245798), // Rule ID 227 //
     /* 245778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 245783 */     // MIs[0] imm
     /* 245783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 245791 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 245791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 245794 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 245796 */     GIR_RootConstrainSelectedInstOperands,
     /* 245797 */     // GIR_Coverage, 227,
     /* 245797 */     GIR_EraseRootFromParent_Done,
     /* 245798 */   // Label 4965: @245798
     /* 245798 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(245823), // Rule ID 228 //
     /* 245803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 245808 */     // MIs[0] imm
     /* 245808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 245816 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 245816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 245819 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 245821 */     GIR_RootConstrainSelectedInstOperands,
     /* 245822 */     // GIR_Coverage, 228,
     /* 245822 */     GIR_EraseRootFromParent_Done,
     /* 245823 */   // Label 4966: @245823
     /* 245823 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(245855), // Rule ID 3603 //
     /* 245828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 245831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 245836 */     // MIs[0] imm
     /* 245836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 245844 */     // (intrinsic_void 1128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 245844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 245847 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 245849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245853 */     GIR_RootConstrainSelectedInstOperands,
     /* 245854 */     // GIR_Coverage, 3603,
     /* 245854 */     GIR_EraseRootFromParent_Done,
     /* 245855 */   // Label 4967: @245855
     /* 245855 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(245895), // Rule ID 16 //
     /* 245860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 245865 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 245868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 245872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 245880 */     // MIs[1] Operand 1
     /* 245880 */     // No operand predicates
     /* 245880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245882 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 245882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 245885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 245888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245893 */     GIR_RootConstrainSelectedInstOperands,
     /* 245894 */     // GIR_Coverage, 16,
     /* 245894 */     GIR_EraseRootFromParent_Done,
     /* 245895 */   // Label 4968: @245895
     /* 245895 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(245935), // Rule ID 17 //
     /* 245900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 245905 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 245908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 245912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 245920 */     // MIs[1] Operand 1
     /* 245920 */     // No operand predicates
     /* 245920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245922 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 245922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 245925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 245928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245933 */     GIR_RootConstrainSelectedInstOperands,
     /* 245934 */     // GIR_Coverage, 17,
     /* 245934 */     GIR_EraseRootFromParent_Done,
     /* 245935 */   // Label 4969: @245935
     /* 245935 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(245975), // Rule ID 18 //
     /* 245940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 245945 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 245948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 245952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 245960 */     // MIs[1] Operand 1
     /* 245960 */     // No operand predicates
     /* 245960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245962 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 245962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 245965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 245968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245973 */     GIR_RootConstrainSelectedInstOperands,
     /* 245974 */     // GIR_Coverage, 18,
     /* 245974 */     GIR_EraseRootFromParent_Done,
     /* 245975 */   // Label 4970: @245975
     /* 245975 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(246015), // Rule ID 19 //
     /* 245980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 245985 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 245988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 245992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 246000 */     // MIs[1] Operand 1
     /* 246000 */     // No operand predicates
     /* 246000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246002 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 246002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 246005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 246008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246013 */     GIR_RootConstrainSelectedInstOperands,
     /* 246014 */     // GIR_Coverage, 19,
     /* 246014 */     GIR_EraseRootFromParent_Done,
     /* 246015 */   // Label 4971: @246015
     /* 246015 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(246039), // Rule ID 72 //
     /* 246020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 246025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246032 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 246032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 246035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246037 */     GIR_RootConstrainSelectedInstOperands,
     /* 246038 */     // GIR_Coverage, 72,
     /* 246038 */     GIR_EraseRootFromParent_Done,
     /* 246039 */   // Label 4972: @246039
     /* 246039 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(246063), // Rule ID 74 //
     /* 246044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 246049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246056 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 246056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 246059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246061 */     GIR_RootConstrainSelectedInstOperands,
     /* 246062 */     // GIR_Coverage, 74,
     /* 246062 */     GIR_EraseRootFromParent_Done,
     /* 246063 */   // Label 4973: @246063
     /* 246063 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(246094), // Rule ID 77 //
     /* 246068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 246071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 246076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246083 */     // (intrinsic_w_chain:{ *:[i64] } 2073:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 246083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 246086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 246088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246092 */     GIR_RootConstrainSelectedInstOperands,
     /* 246093 */     // GIR_Coverage, 77,
     /* 246093 */     GIR_EraseRootFromParent_Done,
     /* 246094 */   // Label 4974: @246094
     /* 246094 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(246121), // Rule ID 80 //
     /* 246099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 246102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 246107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246114 */     // (intrinsic_w_chain:{ *:[i64] } 2074:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 246114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 246117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 246119 */     GIR_RootConstrainSelectedInstOperands,
     /* 246120 */     // GIR_Coverage, 80,
     /* 246120 */     GIR_EraseRootFromParent_Done,
     /* 246121 */   // Label 4975: @246121
     /* 246121 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(246152), // Rule ID 2376 //
     /* 246126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 246129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 246134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246141 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1572:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 246141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 246144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246150 */     GIR_RootConstrainSelectedInstOperands,
     /* 246151 */     // GIR_Coverage, 2376,
     /* 246151 */     GIR_EraseRootFromParent_Done,
     /* 246152 */   // Label 4976: @246152
     /* 246152 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(246192), // Rule ID 12581 //
     /* 246157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 246160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 246165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246172 */     // (intrinsic_w_chain:{ *:[i64] } 881:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 246172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 246175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 246177 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 246187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246190 */     GIR_RootConstrainSelectedInstOperands,
     /* 246191 */     // GIR_Coverage, 12581,
     /* 246191 */     GIR_EraseRootFromParent_Done,
     /* 246192 */   // Label 4977: @246192
     /* 246192 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(246226), // Rule ID 2378 //
     /* 246197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 246200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 246205 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 246208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246212 */     // (intrinsic_void 2052:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 246212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 246215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 246217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 246220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246224 */     GIR_RootConstrainSelectedInstOperands,
     /* 246225 */     // GIR_Coverage, 2378,
     /* 246225 */     GIR_EraseRootFromParent_Done,
     /* 246226 */   // Label 4978: @246226
     /* 246226 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(246249), // Rule ID 73 //
     /* 246231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 246236 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 246239 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 246239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 246242 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 246244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 246247 */     GIR_RootConstrainSelectedInstOperands,
     /* 246248 */     // GIR_Coverage, 73,
     /* 246248 */     GIR_EraseRootFromParent_Done,
     /* 246249 */   // Label 4979: @246249
     /* 246249 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(246272), // Rule ID 75 //
     /* 246254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 246259 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 246262 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 246262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 246265 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 246267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 246270 */     GIR_RootConstrainSelectedInstOperands,
     /* 246271 */     // GIR_Coverage, 75,
     /* 246271 */     GIR_EraseRootFromParent_Done,
     /* 246272 */   // Label 4980: @246272
     /* 246272 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(246299), // Rule ID 76 //
     /* 246277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 246282 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 246285 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 246285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 246288 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 246290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 246293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246297 */     GIR_RootConstrainSelectedInstOperands,
     /* 246298 */     // GIR_Coverage, 76,
     /* 246298 */     GIR_EraseRootFromParent_Done,
     /* 246299 */   // Label 4981: @246299
     /* 246299 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(246332), // Rule ID 12580 //
     /* 246304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 246307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 246312 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 246315 */     // (intrinsic_void 940:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 246315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 246318 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 246328 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 246330 */     GIR_RootConstrainSelectedInstOperands,
     /* 246331 */     // GIR_Coverage, 12580,
     /* 246331 */     GIR_EraseRootFromParent_Done,
     /* 246332 */   // Label 4982: @246332
     /* 246332 */   GIM_Reject,
     /* 246333 */ // Label 4963: @246333
     /* 246333 */ GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(247304),
     /* 246338 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 246341 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(246417), // Rule ID 7015 //
     /* 246346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 246351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246358 */     // MIs[0] addr
     /* 246358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 246370 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 246370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 246377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 246386 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 246392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 246395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 246406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246416 */     // GIR_Coverage, 7015,
     /* 246416 */     GIR_EraseRootFromParent_Done,
     /* 246417 */   // Label 4984: @246417
     /* 246417 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(246493), // Rule ID 7016 //
     /* 246422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 246427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246434 */     // MIs[0] addr
     /* 246434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 246446 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 246446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 246453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 246462 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 246468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 246471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 246482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246492 */     // GIR_Coverage, 7016,
     /* 246492 */     GIR_EraseRootFromParent_Done,
     /* 246493 */   // Label 4985: @246493
     /* 246493 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(246569), // Rule ID 7017 //
     /* 246498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 246503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246510 */     // MIs[0] addr
     /* 246510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 246522 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 246522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 246529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 246538 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 246544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 246547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 246558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246568 */     // GIR_Coverage, 7017,
     /* 246568 */     GIR_EraseRootFromParent_Done,
     /* 246569 */   // Label 4986: @246569
     /* 246569 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(246611), // Rule ID 7018 //
     /* 246574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 246579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246586 */     // MIs[0] addr
     /* 246586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 246598 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 246598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 246601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 246603 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 246605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246609 */     GIR_RootConstrainSelectedInstOperands,
     /* 246610 */     // GIR_Coverage, 7018,
     /* 246610 */     GIR_EraseRootFromParent_Done,
     /* 246611 */   // Label 4987: @246611
     /* 246611 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(246687), // Rule ID 7022 //
     /* 246616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 246621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246628 */     // MIs[0] addr
     /* 246628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 246640 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 246640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 246647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 246656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 246662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 246665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 246676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246686 */     // GIR_Coverage, 7022,
     /* 246686 */     GIR_EraseRootFromParent_Done,
     /* 246687 */   // Label 4988: @246687
     /* 246687 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(246763), // Rule ID 7023 //
     /* 246692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 246697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246704 */     // MIs[0] addr
     /* 246704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 246716 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 246716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 246723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 246732 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 246738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 246741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 246752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246762 */     // GIR_Coverage, 7023,
     /* 246762 */     GIR_EraseRootFromParent_Done,
     /* 246763 */   // Label 4989: @246763
     /* 246763 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(246839), // Rule ID 7024 //
     /* 246768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 246773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246780 */     // MIs[0] addr
     /* 246780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 246792 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 246792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 246799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 246808 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 246814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 246817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 246828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 246833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246838 */     // GIR_Coverage, 7024,
     /* 246838 */     GIR_EraseRootFromParent_Done,
     /* 246839 */   // Label 4990: @246839
     /* 246839 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(246881), // Rule ID 7025 //
     /* 246844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 246849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246856 */     // MIs[0] addr
     /* 246856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 246868 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 246868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 246871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 246873 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 246875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246879 */     GIR_RootConstrainSelectedInstOperands,
     /* 246880 */     // GIR_Coverage, 7025,
     /* 246880 */     GIR_EraseRootFromParent_Done,
     /* 246881 */   // Label 4991: @246881
     /* 246881 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(246921), // Rule ID 20 //
     /* 246886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 246889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 246894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246908 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 246908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 246911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 246913 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 246915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246919 */     GIR_RootConstrainSelectedInstOperands,
     /* 246920 */     // GIR_Coverage, 20,
     /* 246920 */     GIR_EraseRootFromParent_Done,
     /* 246921 */   // Label 4992: @246921
     /* 246921 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(246961), // Rule ID 2375 //
     /* 246926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 246929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 246934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246948 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1573:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 246948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 246951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 246955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246959 */     GIR_RootConstrainSelectedInstOperands,
     /* 246960 */     // GIR_Coverage, 2375,
     /* 246960 */     GIR_EraseRootFromParent_Done,
     /* 246961 */   // Label 4993: @246961
     /* 246961 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(247001), // Rule ID 2486 //
     /* 246966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 246969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 246974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 246977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 246980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 246984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 246988 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 246988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 246991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 246993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 246995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246999 */     GIR_RootConstrainSelectedInstOperands,
     /* 247000 */     // GIR_Coverage, 2486,
     /* 247000 */     GIR_EraseRootFromParent_Done,
     /* 247001 */   // Label 4994: @247001
     /* 247001 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(247041), // Rule ID 2487 //
     /* 247006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 247014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 247017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 247020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247028 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 247028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 247031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247039 */     GIR_RootConstrainSelectedInstOperands,
     /* 247040 */     // GIR_Coverage, 2487,
     /* 247040 */     GIR_EraseRootFromParent_Done,
     /* 247041 */   // Label 4995: @247041
     /* 247041 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(247081), // Rule ID 6904 //
     /* 247046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 247054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 247057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 247060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247068 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 247068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 247071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247079 */     GIR_RootConstrainSelectedInstOperands,
     /* 247080 */     // GIR_Coverage, 6904,
     /* 247080 */     GIR_EraseRootFromParent_Done,
     /* 247081 */   // Label 4996: @247081
     /* 247081 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(247121), // Rule ID 6905 //
     /* 247086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 247094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 247097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 247100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247108 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 247108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 247111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247119 */     GIR_RootConstrainSelectedInstOperands,
     /* 247120 */     // GIR_Coverage, 6905,
     /* 247120 */     GIR_EraseRootFromParent_Done,
     /* 247121 */   // Label 4997: @247121
     /* 247121 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(247157), // Rule ID 3568 //
     /* 247126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 247129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 247134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 247140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247144 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1397:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 247144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 247147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247155 */     GIR_RootConstrainSelectedInstOperands,
     /* 247156 */     // GIR_Coverage, 3568,
     /* 247156 */     GIR_EraseRootFromParent_Done,
     /* 247157 */   // Label 4998: @247157
     /* 247157 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(247195), // Rule ID 3954 //
     /* 247162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 247165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 247170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 247173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247180 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 247180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 247183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 247191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 247193 */     GIR_RootConstrainSelectedInstOperands,
     /* 247194 */     // GIR_Coverage, 3954,
     /* 247194 */     GIR_EraseRootFromParent_Done,
     /* 247195 */   // Label 4999: @247195
     /* 247195 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(247231), // Rule ID 12383 //
     /* 247200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 247203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 247208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 247214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247218 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 247218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 247221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247229 */     GIR_RootConstrainSelectedInstOperands,
     /* 247230 */     // GIR_Coverage, 12383,
     /* 247230 */     GIR_EraseRootFromParent_Done,
     /* 247231 */   // Label 5000: @247231
     /* 247231 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(247267), // Rule ID 12384 //
     /* 247236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 247239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 247244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 247250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247254 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1403:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 247254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 247257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247265 */     GIR_RootConstrainSelectedInstOperands,
     /* 247266 */     // GIR_Coverage, 12384,
     /* 247266 */     GIR_EraseRootFromParent_Done,
     /* 247267 */   // Label 5001: @247267
     /* 247267 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(247303), // Rule ID 12385 //
     /* 247272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 247275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 247280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 247286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247290 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1404:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 247290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 247293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247301 */     GIR_RootConstrainSelectedInstOperands,
     /* 247302 */     // GIR_Coverage, 12385,
     /* 247302 */     GIR_EraseRootFromParent_Done,
     /* 247303 */   // Label 5002: @247303
     /* 247303 */   GIM_Reject,
     /* 247304 */ // Label 4983: @247304
     /* 247304 */ GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(250212),
     /* 247309 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 247312 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(247409), // Rule ID 7033 //
     /* 247317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 247322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 247336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 247340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 247344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 247348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 247352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 247356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 247360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247365 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 247376 */     // MIs[0] addr
     /* 247376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 247388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 247390 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 247390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 247393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 247399 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 247407 */     GIR_RootConstrainSelectedInstOperands,
     /* 247408 */     // GIR_Coverage, 7033,
     /* 247408 */     GIR_EraseRootFromParent_Done,
     /* 247409 */   // Label 5004: @247409
     /* 247409 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(247506), // Rule ID 7034 //
     /* 247414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 247419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 247433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 247437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 247441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 247445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 247449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 247453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 247457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247462 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 247473 */     // MIs[0] addr
     /* 247473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 247485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 247487 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 247487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 247490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 247496 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 247504 */     GIR_RootConstrainSelectedInstOperands,
     /* 247505 */     // GIR_Coverage, 7034,
     /* 247505 */     GIR_EraseRootFromParent_Done,
     /* 247506 */   // Label 5005: @247506
     /* 247506 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(247603), // Rule ID 7043 //
     /* 247511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 247516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 247530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 247534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 247538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 247542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 247546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 247550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 247554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247559 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 247570 */     // MIs[0] addr
     /* 247570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 247582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 247584 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 247584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 247587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 247593 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 247601 */     GIR_RootConstrainSelectedInstOperands,
     /* 247602 */     // GIR_Coverage, 7043,
     /* 247602 */     GIR_EraseRootFromParent_Done,
     /* 247603 */   // Label 5006: @247603
     /* 247603 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(247700), // Rule ID 7044 //
     /* 247608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 247613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 247627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 247631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 247635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 247639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 247643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 247647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 247651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247656 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 247667 */     // MIs[0] addr
     /* 247667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 247679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 247681 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 247681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 247684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 247690 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 247698 */     GIR_RootConstrainSelectedInstOperands,
     /* 247699 */     // GIR_Coverage, 7044,
     /* 247699 */     GIR_EraseRootFromParent_Done,
     /* 247700 */   // Label 5007: @247700
     /* 247700 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(247811), // Rule ID 7036 //
     /* 247705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 247710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 247724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 247728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 247732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 247736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247741 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 247752 */     // MIs[0] addr
     /* 247752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247760 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 247764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 247766 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 247766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 247769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247778 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 247784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 247797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247802 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 247809 */     GIR_RootConstrainSelectedInstOperands,
     /* 247810 */     // GIR_Coverage, 7036,
     /* 247810 */     GIR_EraseRootFromParent_Done,
     /* 247811 */   // Label 5008: @247811
     /* 247811 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(247922), // Rule ID 7037 //
     /* 247816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 247821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 247835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 247839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 247843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 247847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247852 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 247863 */     // MIs[0] addr
     /* 247863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 247875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 247877 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 247877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 247880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 247895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 247908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247913 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 247920 */     GIR_RootConstrainSelectedInstOperands,
     /* 247921 */     // GIR_Coverage, 7037,
     /* 247921 */     GIR_EraseRootFromParent_Done,
     /* 247922 */   // Label 5009: @247922
     /* 247922 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(248033), // Rule ID 7038 //
     /* 247927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 247932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 247946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 247950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 247954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 247958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247963 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 247974 */     // MIs[0] addr
     /* 247974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 247986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 247988 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 247988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 247991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248000 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 248006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 248019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 248021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 248024 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 248026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248031 */     GIR_RootConstrainSelectedInstOperands,
     /* 248032 */     // GIR_Coverage, 7038,
     /* 248032 */     GIR_EraseRootFromParent_Done,
     /* 248033 */   // Label 5010: @248033
     /* 248033 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(248144), // Rule ID 7046 //
     /* 248038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 248043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 248049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 248057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 248061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 248065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 248069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248074 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 248085 */     // MIs[0] addr
     /* 248085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 248089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 248097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248099 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 248099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 248102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248111 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 248117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 248130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 248132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 248135 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 248137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248142 */     GIR_RootConstrainSelectedInstOperands,
     /* 248143 */     // GIR_Coverage, 7046,
     /* 248143 */     GIR_EraseRootFromParent_Done,
     /* 248144 */   // Label 5011: @248144
     /* 248144 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(248255), // Rule ID 7047 //
     /* 248149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 248154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 248160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 248168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 248172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 248176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 248180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248185 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 248196 */     // MIs[0] addr
     /* 248196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 248200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 248208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248210 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 248210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 248213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248222 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 248228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 248241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 248243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 248246 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 248248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248253 */     GIR_RootConstrainSelectedInstOperands,
     /* 248254 */     // GIR_Coverage, 7047,
     /* 248254 */     GIR_EraseRootFromParent_Done,
     /* 248255 */   // Label 5012: @248255
     /* 248255 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(248366), // Rule ID 7048 //
     /* 248260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 248265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 248271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 248279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 248283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 248287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 248291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248296 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 248307 */     // MIs[0] addr
     /* 248307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 248311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 248319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248321 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 248321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 248324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248333 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 248339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 248352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 248354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 248357 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 248359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248364 */     GIR_RootConstrainSelectedInstOperands,
     /* 248365 */     // GIR_Coverage, 7048,
     /* 248365 */     GIR_EraseRootFromParent_Done,
     /* 248366 */   // Label 5013: @248366
     /* 248366 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(248417), // Rule ID 70 //
     /* 248371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 248376 */     // MIs[0] ptr
     /* 248376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 248380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 248384 */     // MIs[0] accessinfo
     /* 248384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248387 */     // MIs[0] fixed_shadow
     /* 248387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 248390 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 248390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 248393 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 248395 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 248397 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 248399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 248402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 248405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 248408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 248411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248415 */     GIR_RootConstrainSelectedInstOperands,
     /* 248416 */     // GIR_Coverage, 70,
     /* 248416 */     GIR_EraseRootFromParent_Done,
     /* 248417 */   // Label 5014: @248417
     /* 248417 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(248468), // Rule ID 71 //
     /* 248422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 248427 */     // MIs[0] ptr
     /* 248427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 248431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 248435 */     // MIs[0] accessinfo
     /* 248435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248438 */     // MIs[0] fixed_shadow
     /* 248438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 248441 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 248441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 248444 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 248446 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 248448 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 248450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 248453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 248456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 248459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 248462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248466 */     GIR_RootConstrainSelectedInstOperands,
     /* 248467 */     // GIR_Coverage, 71,
     /* 248467 */     GIR_EraseRootFromParent_Done,
     /* 248468 */   // Label 5015: @248468
     /* 248468 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(248537), // Rule ID 7035 //
     /* 248473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 248478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 248484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 248492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 248496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 248500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248505 */     // MIs[0] addr
     /* 248505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 248509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 248517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248519 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 248519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 248522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 248524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 248528 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 248530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248535 */     GIR_RootConstrainSelectedInstOperands,
     /* 248536 */     // GIR_Coverage, 7035,
     /* 248536 */     GIR_EraseRootFromParent_Done,
     /* 248537 */   // Label 5016: @248537
     /* 248537 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(248606), // Rule ID 7045 //
     /* 248542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 248547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 248553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 248561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 248565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 248569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 248574 */     // MIs[0] addr
     /* 248574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 248578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 248586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248588 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 248588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 248591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 248593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 248597 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 248599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248604 */     GIR_RootConstrainSelectedInstOperands,
     /* 248605 */     // GIR_Coverage, 7045,
     /* 248605 */     GIR_EraseRootFromParent_Done,
     /* 248606 */   // Label 5017: @248606
     /* 248606 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(248660), // Rule ID 8748 //
     /* 248611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 248619 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 248622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248626 */     // MIs[0] base
     /* 248626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248634 */     // MIs[0] prfop
     /* 248634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 248637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248642 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 248642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 248645 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 248647 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 248649 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 248651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248658 */     GIR_RootConstrainSelectedInstOperands,
     /* 248659 */     // GIR_Coverage, 8748,
     /* 248659 */     GIR_EraseRootFromParent_Done,
     /* 248660 */   // Label 5018: @248660
     /* 248660 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(248714), // Rule ID 8751 //
     /* 248665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 248673 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 248676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248680 */     // MIs[0] base
     /* 248680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248688 */     // MIs[0] prfop
     /* 248688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 248691 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248696 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 248696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 248699 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 248701 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 248703 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 248705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248712 */     GIR_RootConstrainSelectedInstOperands,
     /* 248713 */     // GIR_Coverage, 8751,
     /* 248713 */     GIR_EraseRootFromParent_Done,
     /* 248714 */   // Label 5019: @248714
     /* 248714 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(248768), // Rule ID 8754 //
     /* 248719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 248727 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248734 */     // MIs[0] base
     /* 248734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248742 */     // MIs[0] prfop
     /* 248742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 248745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248750 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 248750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 248753 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 248755 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 248757 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 248759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248766 */     GIR_RootConstrainSelectedInstOperands,
     /* 248767 */     // GIR_Coverage, 8754,
     /* 248767 */     GIR_EraseRootFromParent_Done,
     /* 248768 */   // Label 5020: @248768
     /* 248768 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(248822), // Rule ID 8757 //
     /* 248773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 248781 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248788 */     // MIs[0] base
     /* 248788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248796 */     // MIs[0] prfop
     /* 248796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 248799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248804 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 248804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 248807 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 248809 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 248811 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 248813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248820 */     GIR_RootConstrainSelectedInstOperands,
     /* 248821 */     // GIR_Coverage, 8757,
     /* 248821 */     GIR_EraseRootFromParent_Done,
     /* 248822 */   // Label 5021: @248822
     /* 248822 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(248876), // Rule ID 15 //
     /* 248827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 248832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 248835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 248841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 248849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248853 */     // MIs[1] Operand 1
     /* 248853 */     // No operand predicates
     /* 248853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248859 */     // (intrinsic_w_chain:{ *:[i64] } 1138:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 248859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 248862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 248864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 248867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 248869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248874 */     GIR_RootConstrainSelectedInstOperands,
     /* 248875 */     // GIR_Coverage, 15,
     /* 248875 */     GIR_EraseRootFromParent_Done,
     /* 248876 */   // Label 5022: @248876
     /* 248876 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(248944), // Rule ID 68 //
     /* 248881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 248886 */     // MIs[0] Operand 1
     /* 248886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 248890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 248894 */     // MIs[0] ptr
     /* 248894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 248902 */     // MIs[0] accessinfo
     /* 248902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 248905 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 248905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248909 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 248919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 248922 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 248924 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 248926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 248929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 248932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 248935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 248938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248942 */     GIR_RootConstrainSelectedInstOperands,
     /* 248943 */     // GIR_Coverage, 68,
     /* 248943 */     GIR_EraseRootFromParent_Done,
     /* 248944 */   // Label 5023: @248944
     /* 248944 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(249012), // Rule ID 69 //
     /* 248949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 248954 */     // MIs[0] Operand 1
     /* 248954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 248958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 248962 */     // MIs[0] ptr
     /* 248962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 248970 */     // MIs[0] accessinfo
     /* 248970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 248973 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 248973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248977 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 248987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 248990 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 248992 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 248994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 248997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 249000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 249003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 249006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249010 */     GIR_RootConstrainSelectedInstOperands,
     /* 249011 */     // GIR_Coverage, 69,
     /* 249011 */     GIR_EraseRootFromParent_Done,
     /* 249012 */   // Label 5024: @249012
     /* 249012 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(249092), // Rule ID 7029 //
     /* 249017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 249022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249036 */     // MIs[0] addr
     /* 249036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 249048 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 249048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249060 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 249066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 249079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249084 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 249086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249090 */     GIR_RootConstrainSelectedInstOperands,
     /* 249091 */     // GIR_Coverage, 7029,
     /* 249091 */     GIR_EraseRootFromParent_Done,
     /* 249092 */   // Label 5025: @249092
     /* 249092 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(249172), // Rule ID 7030 //
     /* 249097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 249102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249116 */     // MIs[0] addr
     /* 249116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 249128 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 249128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249140 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 249146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 249159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249164 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 249166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249170 */     GIR_RootConstrainSelectedInstOperands,
     /* 249171 */     // GIR_Coverage, 7030,
     /* 249171 */     GIR_EraseRootFromParent_Done,
     /* 249172 */   // Label 5026: @249172
     /* 249172 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(249252), // Rule ID 7031 //
     /* 249177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 249182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249196 */     // MIs[0] addr
     /* 249196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 249208 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 249208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249220 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 249226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 249239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249244 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 249246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249250 */     GIR_RootConstrainSelectedInstOperands,
     /* 249251 */     // GIR_Coverage, 7031,
     /* 249251 */     GIR_EraseRootFromParent_Done,
     /* 249252 */   // Label 5027: @249252
     /* 249252 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(249303), // Rule ID 7032 //
     /* 249257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 249262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249276 */     // MIs[0] addr
     /* 249276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 249288 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 249288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 249291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249293 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 249295 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 249297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249301 */     GIR_RootConstrainSelectedInstOperands,
     /* 249302 */     // GIR_Coverage, 7032,
     /* 249302 */     GIR_EraseRootFromParent_Done,
     /* 249303 */   // Label 5028: @249303
     /* 249303 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(249383), // Rule ID 7039 //
     /* 249308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 249313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249327 */     // MIs[0] addr
     /* 249327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 249339 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 249339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249351 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 249357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 249370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249375 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 249377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249381 */     GIR_RootConstrainSelectedInstOperands,
     /* 249382 */     // GIR_Coverage, 7039,
     /* 249382 */     GIR_EraseRootFromParent_Done,
     /* 249383 */   // Label 5029: @249383
     /* 249383 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(249463), // Rule ID 7040 //
     /* 249388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 249393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249407 */     // MIs[0] addr
     /* 249407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 249419 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 249419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249431 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 249437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 249450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249455 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 249457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249461 */     GIR_RootConstrainSelectedInstOperands,
     /* 249462 */     // GIR_Coverage, 7040,
     /* 249462 */     GIR_EraseRootFromParent_Done,
     /* 249463 */   // Label 5030: @249463
     /* 249463 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(249543), // Rule ID 7041 //
     /* 249468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 249473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249487 */     // MIs[0] addr
     /* 249487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 249499 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 249499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249511 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 249517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 249530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249535 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 249537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249541 */     GIR_RootConstrainSelectedInstOperands,
     /* 249542 */     // GIR_Coverage, 7041,
     /* 249542 */     GIR_EraseRootFromParent_Done,
     /* 249543 */   // Label 5031: @249543
     /* 249543 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(249594), // Rule ID 7042 //
     /* 249548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 249553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249567 */     // MIs[0] addr
     /* 249567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 249579 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 249579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 249582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249584 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 249586 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 249588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249592 */     GIR_RootConstrainSelectedInstOperands,
     /* 249593 */     // GIR_Coverage, 7042,
     /* 249593 */     GIR_EraseRootFromParent_Done,
     /* 249594 */   // Label 5032: @249594
     /* 249594 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(249643), // Rule ID 2479 //
     /* 249599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 249607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 249610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 249613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 249616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249628 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 249628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 249631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 249633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 249637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249641 */     GIR_RootConstrainSelectedInstOperands,
     /* 249642 */     // GIR_Coverage, 2479,
     /* 249642 */     GIR_EraseRootFromParent_Done,
     /* 249643 */   // Label 5033: @249643
     /* 249643 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(249692), // Rule ID 2480 //
     /* 249648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 249656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 249659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 249665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249677 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 249677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 249680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 249682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 249686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249690 */     GIR_RootConstrainSelectedInstOperands,
     /* 249691 */     // GIR_Coverage, 2480,
     /* 249691 */     GIR_EraseRootFromParent_Done,
     /* 249692 */   // Label 5034: @249692
     /* 249692 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(249741), // Rule ID 2481 //
     /* 249697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 249705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 249708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 249714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249726 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 249726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 249729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 249731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 249735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249739 */     GIR_RootConstrainSelectedInstOperands,
     /* 249740 */     // GIR_Coverage, 2481,
     /* 249740 */     GIR_EraseRootFromParent_Done,
     /* 249741 */   // Label 5035: @249741
     /* 249741 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(249794), // Rule ID 8634 //
     /* 249746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 249754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 249760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249768 */     // MIs[0] base
     /* 249768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249776 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1473:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 249776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 249779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 249781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 249783 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 249785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249792 */     GIR_RootConstrainSelectedInstOperands,
     /* 249793 */     // GIR_Coverage, 8634,
     /* 249793 */     GIR_EraseRootFromParent_Done,
     /* 249794 */   // Label 5036: @249794
     /* 249794 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(249847), // Rule ID 8637 //
     /* 249799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 249807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 249813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249821 */     // MIs[0] base
     /* 249821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249829 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 249829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 249832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 249834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 249836 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 249838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249845 */     GIR_RootConstrainSelectedInstOperands,
     /* 249846 */     // GIR_Coverage, 8637,
     /* 249846 */     GIR_EraseRootFromParent_Done,
     /* 249847 */   // Label 5037: @249847
     /* 249847 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(249900), // Rule ID 8646 //
     /* 249852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 249860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 249866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249874 */     // MIs[0] base
     /* 249874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249882 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1472:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 249882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 249885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 249887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 249889 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 249891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249898 */     GIR_RootConstrainSelectedInstOperands,
     /* 249899 */     // GIR_Coverage, 8646,
     /* 249899 */     GIR_EraseRootFromParent_Done,
     /* 249900 */   // Label 5038: @249900
     /* 249900 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(249953), // Rule ID 8649 //
     /* 249905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 249913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 249919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249927 */     // MIs[0] base
     /* 249927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 249931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249935 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 249935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 249938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 249940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 249942 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 249944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249951 */     GIR_RootConstrainSelectedInstOperands,
     /* 249952 */     // GIR_Coverage, 8649,
     /* 249952 */     GIR_EraseRootFromParent_Done,
     /* 249953 */   // Label 5039: @249953
     /* 249953 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(249999), // Rule ID 137 //
     /* 249958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 249961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 249966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 249972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249976 */     // MIs[0] Rn
     /* 249976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249988 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 249988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 249991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 249993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 249997 */     GIR_RootConstrainSelectedInstOperands,
     /* 249998 */     // GIR_Coverage, 137,
     /* 249998 */     GIR_EraseRootFromParent_Done,
     /* 249999 */   // Label 5040: @249999
     /* 249999 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(250052), // Rule ID 8640 //
     /* 250004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 250012 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 250015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 250018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250026 */     // MIs[0] base
     /* 250026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250034 */     // (intrinsic_void 1793:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 250034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 250037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 250039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 250041 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 250043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250050 */     GIR_RootConstrainSelectedInstOperands,
     /* 250051 */     // GIR_Coverage, 8640,
     /* 250051 */     GIR_EraseRootFromParent_Done,
     /* 250052 */   // Label 5041: @250052
     /* 250052 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(250105), // Rule ID 8643 //
     /* 250057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 250065 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 250068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 250071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250079 */     // MIs[0] base
     /* 250079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250087 */     // (intrinsic_void 1793:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 250087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 250090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 250092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 250094 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 250096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250103 */     GIR_RootConstrainSelectedInstOperands,
     /* 250104 */     // GIR_Coverage, 8643,
     /* 250104 */     GIR_EraseRootFromParent_Done,
     /* 250105 */   // Label 5042: @250105
     /* 250105 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(250158), // Rule ID 8652 //
     /* 250110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 250118 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 250121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 250124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250132 */     // MIs[0] base
     /* 250132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250140 */     // (intrinsic_void 1789:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 250140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 250143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 250145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 250147 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 250149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250156 */     GIR_RootConstrainSelectedInstOperands,
     /* 250157 */     // GIR_Coverage, 8652,
     /* 250157 */     GIR_EraseRootFromParent_Done,
     /* 250158 */   // Label 5043: @250158
     /* 250158 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(250211), // Rule ID 8655 //
     /* 250163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 250171 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 250174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 250177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250185 */     // MIs[0] base
     /* 250185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250193 */     // (intrinsic_void 1789:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 250193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 250196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 250198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 250200 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 250202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250209 */     GIR_RootConstrainSelectedInstOperands,
     /* 250210 */     // GIR_Coverage, 8655,
     /* 250210 */     GIR_EraseRootFromParent_Done,
     /* 250211 */   // Label 5044: @250211
     /* 250211 */   GIM_Reject,
     /* 250212 */ // Label 5003: @250212
     /* 250212 */ GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(252917),
     /* 250217 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 250220 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(250291), // Rule ID 3404 //
     /* 250225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 250233 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 250236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 250242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 250254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 250262 */     // MIs[1] Operand 1
     /* 250262 */     // No operand predicates
     /* 250262 */     // MIs[0] prfop
     /* 250262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 250270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250272 */     // (intrinsic_void 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 250272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 250275 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 250277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 250279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 250281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 250284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250289 */     GIR_RootConstrainSelectedInstOperands,
     /* 250290 */     // GIR_Coverage, 3404,
     /* 250290 */     GIR_EraseRootFromParent_Done,
     /* 250291 */   // Label 5046: @250291
     /* 250291 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(250362), // Rule ID 3417 //
     /* 250296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 250304 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 250307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 250313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 250325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 250333 */     // MIs[1] Operand 1
     /* 250333 */     // No operand predicates
     /* 250333 */     // MIs[0] prfop
     /* 250333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 250341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250343 */     // (intrinsic_void 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 250343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 250346 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 250348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 250350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 250352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 250355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250360 */     GIR_RootConstrainSelectedInstOperands,
     /* 250361 */     // GIR_Coverage, 3417,
     /* 250361 */     GIR_EraseRootFromParent_Done,
     /* 250362 */   // Label 5047: @250362
     /* 250362 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(250421), // Rule ID 3592 //
     /* 250367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 250370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 250375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 250381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250384 */     // MIs[0] tile
     /* 250384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 250387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 250392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250404 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 250404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 250407 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 250409 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 250411 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 250413 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 250415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250419 */     GIR_RootConstrainSelectedInstOperands,
     /* 250420 */     // GIR_Coverage, 3592,
     /* 250420 */     GIR_EraseRootFromParent_Done,
     /* 250421 */   // Label 5048: @250421
     /* 250421 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(250480), // Rule ID 3593 //
     /* 250426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 250429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 250434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 250440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250443 */     // MIs[0] tile
     /* 250443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 250446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 250451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250463 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 250463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 250466 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 250468 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 250470 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 250472 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 250474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250478 */     GIR_RootConstrainSelectedInstOperands,
     /* 250479 */     // GIR_Coverage, 3593,
     /* 250479 */     GIR_EraseRootFromParent_Done,
     /* 250480 */   // Label 5049: @250480
     /* 250480 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(250539), // Rule ID 12443 //
     /* 250485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 250488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 250493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 250499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250502 */     // MIs[0] tile
     /* 250502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 250505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 250510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250522 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 250522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 250525 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 250527 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 250529 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 250531 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 250533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250537 */     GIR_RootConstrainSelectedInstOperands,
     /* 250538 */     // GIR_Coverage, 12443,
     /* 250538 */     GIR_EraseRootFromParent_Done,
     /* 250539 */   // Label 5050: @250539
     /* 250539 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(250598), // Rule ID 12444 //
     /* 250544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 250547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 250552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 250558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250561 */     // MIs[0] tile
     /* 250561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 250564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 250569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250581 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 250581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 250584 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 250586 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 250588 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 250590 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 250592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250596 */     GIR_RootConstrainSelectedInstOperands,
     /* 250597 */     // GIR_Coverage, 12444,
     /* 250597 */     GIR_EraseRootFromParent_Done,
     /* 250598 */   // Label 5051: @250598
     /* 250598 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(250658), // Rule ID 3402 //
     /* 250603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 250611 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 250614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250621 */     // MIs[0] Rn
     /* 250621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250633 */     // MIs[0] prfop
     /* 250633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 250641 */     // (intrinsic_void 1544:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 250641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 250644 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 250646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 250648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 250652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250656 */     GIR_RootConstrainSelectedInstOperands,
     /* 250657 */     // GIR_Coverage, 3402,
     /* 250657 */     GIR_EraseRootFromParent_Done,
     /* 250658 */   // Label 5052: @250658
     /* 250658 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(250718), // Rule ID 3403 //
     /* 250663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 250671 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 250674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250681 */     // MIs[0] Rn
     /* 250681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250693 */     // MIs[0] prfop
     /* 250693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 250701 */     // (intrinsic_void 1543:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 250701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 250704 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 250706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 250708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 250712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250716 */     GIR_RootConstrainSelectedInstOperands,
     /* 250717 */     // GIR_Coverage, 3403,
     /* 250717 */     GIR_EraseRootFromParent_Done,
     /* 250718 */   // Label 5053: @250718
     /* 250718 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(250778), // Rule ID 3414 //
     /* 250723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 250731 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 250734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250741 */     // MIs[0] Rn
     /* 250741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250753 */     // MIs[0] prfop
     /* 250753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250756 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 250761 */     // (intrinsic_void 1544:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 250761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 250764 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 250766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 250768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 250772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250776 */     GIR_RootConstrainSelectedInstOperands,
     /* 250777 */     // GIR_Coverage, 3414,
     /* 250777 */     GIR_EraseRootFromParent_Done,
     /* 250778 */   // Label 5054: @250778
     /* 250778 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(250838), // Rule ID 3415 //
     /* 250783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 250791 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 250794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250801 */     // MIs[0] Rn
     /* 250801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250813 */     // MIs[0] prfop
     /* 250813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 250821 */     // (intrinsic_void 1543:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 250821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 250824 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 250826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 250828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 250832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250836 */     GIR_RootConstrainSelectedInstOperands,
     /* 250837 */     // GIR_Coverage, 3415,
     /* 250837 */     GIR_EraseRootFromParent_Done,
     /* 250838 */   // Label 5055: @250838
     /* 250838 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(250898), // Rule ID 3416 //
     /* 250843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 250851 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 250854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250861 */     // MIs[0] Rn
     /* 250861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250873 */     // MIs[0] prfop
     /* 250873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 250881 */     // (intrinsic_void 1541:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 250881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 250884 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 250886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 250888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 250892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250896 */     GIR_RootConstrainSelectedInstOperands,
     /* 250897 */     // GIR_Coverage, 3416,
     /* 250897 */     GIR_EraseRootFromParent_Done,
     /* 250898 */   // Label 5056: @250898
     /* 250898 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(250958), // Rule ID 8760 //
     /* 250903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 250911 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 250914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250921 */     // MIs[0] Rn
     /* 250921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250933 */     // MIs[0] prfop
     /* 250933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 250941 */     // (intrinsic_void 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 250941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 250944 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 250946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 250948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 250952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250956 */     GIR_RootConstrainSelectedInstOperands,
     /* 250957 */     // GIR_Coverage, 8760,
     /* 250957 */     GIR_EraseRootFromParent_Done,
     /* 250958 */   // Label 5057: @250958
     /* 250958 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(251018), // Rule ID 8761 //
     /* 250963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 250971 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 250974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 250981 */     // MIs[0] Rn
     /* 250981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250993 */     // MIs[0] prfop
     /* 250993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 250996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251001 */     // (intrinsic_void 1551:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 251001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 251004 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251016 */     GIR_RootConstrainSelectedInstOperands,
     /* 251017 */     // GIR_Coverage, 8761,
     /* 251017 */     GIR_EraseRootFromParent_Done,
     /* 251018 */   // Label 5058: @251018
     /* 251018 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(251078), // Rule ID 8762 //
     /* 251023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 251031 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 251034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251041 */     // MIs[0] Rn
     /* 251041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251053 */     // MIs[0] prfop
     /* 251053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251061 */     // (intrinsic_void 1556:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 251061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 251064 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251076 */     GIR_RootConstrainSelectedInstOperands,
     /* 251077 */     // GIR_Coverage, 8762,
     /* 251077 */     GIR_EraseRootFromParent_Done,
     /* 251078 */   // Label 5059: @251078
     /* 251078 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(251138), // Rule ID 8763 //
     /* 251083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 251091 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 251094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251101 */     // MIs[0] Rn
     /* 251101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251113 */     // MIs[0] prfop
     /* 251113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251121 */     // (intrinsic_void 1555:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 251121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 251124 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251136 */     GIR_RootConstrainSelectedInstOperands,
     /* 251137 */     // GIR_Coverage, 8763,
     /* 251137 */     GIR_EraseRootFromParent_Done,
     /* 251138 */   // Label 5060: @251138
     /* 251138 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(251198), // Rule ID 8764 //
     /* 251143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 251151 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 251154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251161 */     // MIs[0] Rn
     /* 251161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251173 */     // MIs[0] prfop
     /* 251173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251181 */     // (intrinsic_void 1548:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 251181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 251184 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251196 */     GIR_RootConstrainSelectedInstOperands,
     /* 251197 */     // GIR_Coverage, 8764,
     /* 251197 */     GIR_EraseRootFromParent_Done,
     /* 251198 */   // Label 5061: @251198
     /* 251198 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(251258), // Rule ID 8765 //
     /* 251203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 251211 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 251214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251221 */     // MIs[0] Rn
     /* 251221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251233 */     // MIs[0] prfop
     /* 251233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251241 */     // (intrinsic_void 1547:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 251241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 251244 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251256 */     GIR_RootConstrainSelectedInstOperands,
     /* 251257 */     // GIR_Coverage, 8765,
     /* 251257 */     GIR_EraseRootFromParent_Done,
     /* 251258 */   // Label 5062: @251258
     /* 251258 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(251318), // Rule ID 8766 //
     /* 251263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 251271 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251281 */     // MIs[0] Rn
     /* 251281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251293 */     // MIs[0] prfop
     /* 251293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251301 */     // (intrinsic_void 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 251301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 251304 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251316 */     GIR_RootConstrainSelectedInstOperands,
     /* 251317 */     // GIR_Coverage, 8766,
     /* 251317 */     GIR_EraseRootFromParent_Done,
     /* 251318 */   // Label 5063: @251318
     /* 251318 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(251378), // Rule ID 8767 //
     /* 251323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 251331 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251341 */     // MIs[0] Rn
     /* 251341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251353 */     // MIs[0] prfop
     /* 251353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251361 */     // (intrinsic_void 1551:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 251361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 251364 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251376 */     GIR_RootConstrainSelectedInstOperands,
     /* 251377 */     // GIR_Coverage, 8767,
     /* 251377 */     GIR_EraseRootFromParent_Done,
     /* 251378 */   // Label 5064: @251378
     /* 251378 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(251438), // Rule ID 8768 //
     /* 251383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 251391 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251401 */     // MIs[0] Rn
     /* 251401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251413 */     // MIs[0] prfop
     /* 251413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251421 */     // (intrinsic_void 1556:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 251421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 251424 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251436 */     GIR_RootConstrainSelectedInstOperands,
     /* 251437 */     // GIR_Coverage, 8768,
     /* 251437 */     GIR_EraseRootFromParent_Done,
     /* 251438 */   // Label 5065: @251438
     /* 251438 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(251498), // Rule ID 8769 //
     /* 251443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 251451 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251461 */     // MIs[0] Rn
     /* 251461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251473 */     // MIs[0] prfop
     /* 251473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251481 */     // (intrinsic_void 1555:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 251481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 251484 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251496 */     GIR_RootConstrainSelectedInstOperands,
     /* 251497 */     // GIR_Coverage, 8769,
     /* 251497 */     GIR_EraseRootFromParent_Done,
     /* 251498 */   // Label 5066: @251498
     /* 251498 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(251558), // Rule ID 8770 //
     /* 251503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 251511 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251521 */     // MIs[0] Rn
     /* 251521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251533 */     // MIs[0] prfop
     /* 251533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251541 */     // (intrinsic_void 1548:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 251541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 251544 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251556 */     GIR_RootConstrainSelectedInstOperands,
     /* 251557 */     // GIR_Coverage, 8770,
     /* 251557 */     GIR_EraseRootFromParent_Done,
     /* 251558 */   // Label 5067: @251558
     /* 251558 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(251618), // Rule ID 8771 //
     /* 251563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 251571 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251581 */     // MIs[0] Rn
     /* 251581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251593 */     // MIs[0] prfop
     /* 251593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251596 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251601 */     // (intrinsic_void 1547:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 251601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 251604 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251616 */     GIR_RootConstrainSelectedInstOperands,
     /* 251617 */     // GIR_Coverage, 8771,
     /* 251617 */     GIR_EraseRootFromParent_Done,
     /* 251618 */   // Label 5068: @251618
     /* 251618 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(251678), // Rule ID 8772 //
     /* 251623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 251631 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251641 */     // MIs[0] Rn
     /* 251641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251653 */     // MIs[0] prfop
     /* 251653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251661 */     // (intrinsic_void 1549:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 251661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 251664 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251676 */     GIR_RootConstrainSelectedInstOperands,
     /* 251677 */     // GIR_Coverage, 8772,
     /* 251677 */     GIR_EraseRootFromParent_Done,
     /* 251678 */   // Label 5069: @251678
     /* 251678 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(251738), // Rule ID 8773 //
     /* 251683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 251691 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251701 */     // MIs[0] Rn
     /* 251701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251713 */     // MIs[0] prfop
     /* 251713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251716 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251721 */     // (intrinsic_void 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 251721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 251724 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251736 */     GIR_RootConstrainSelectedInstOperands,
     /* 251737 */     // GIR_Coverage, 8773,
     /* 251737 */     GIR_EraseRootFromParent_Done,
     /* 251738 */   // Label 5070: @251738
     /* 251738 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(251798), // Rule ID 8774 //
     /* 251743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 251751 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 251754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251761 */     // MIs[0] Rn
     /* 251761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251773 */     // MIs[0] prfop
     /* 251773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 251776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 251781 */     // (intrinsic_void 1545:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 251781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 251784 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 251786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 251788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251796 */     GIR_RootConstrainSelectedInstOperands,
     /* 251797 */     // GIR_Coverage, 8774,
     /* 251797 */     GIR_EraseRootFromParent_Done,
     /* 251798 */   // Label 5071: @251798
     /* 251798 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(251856), // Rule ID 2365 //
     /* 251803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 251811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 251817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251839 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 251839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 251842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251854 */     GIR_RootConstrainSelectedInstOperands,
     /* 251855 */     // GIR_Coverage, 2365,
     /* 251855 */     GIR_EraseRootFromParent_Done,
     /* 251856 */   // Label 5072: @251856
     /* 251856 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(251914), // Rule ID 2366 //
     /* 251861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 251869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 251875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251897 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 251897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 251900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251912 */     GIR_RootConstrainSelectedInstOperands,
     /* 251913 */     // GIR_Coverage, 2366,
     /* 251913 */     GIR_EraseRootFromParent_Done,
     /* 251914 */   // Label 5073: @251914
     /* 251914 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(251972), // Rule ID 2367 //
     /* 251919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 251927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 251930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 251933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251955 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 251955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 251958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251970 */     GIR_RootConstrainSelectedInstOperands,
     /* 251971 */     // GIR_Coverage, 2367,
     /* 251971 */     GIR_EraseRootFromParent_Done,
     /* 251972 */   // Label 5074: @251972
     /* 251972 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(252030), // Rule ID 2368 //
     /* 251977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 251985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 251988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 251991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252013 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 252013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 252016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 252020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252028 */     GIR_RootConstrainSelectedInstOperands,
     /* 252029 */     // GIR_Coverage, 2368,
     /* 252029 */     GIR_EraseRootFromParent_Done,
     /* 252030 */   // Label 5075: @252030
     /* 252030 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(252088), // Rule ID 2369 //
     /* 252035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 252038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 252043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 252049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 252052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 252055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252071 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 252071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 252074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 252078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252086 */     GIR_RootConstrainSelectedInstOperands,
     /* 252087 */     // GIR_Coverage, 2369,
     /* 252087 */     GIR_EraseRootFromParent_Done,
     /* 252088 */   // Label 5076: @252088
     /* 252088 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(252146), // Rule ID 2370 //
     /* 252093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 252096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 252101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 252107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 252110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 252113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252129 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 252129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 252132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 252136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252144 */     GIR_RootConstrainSelectedInstOperands,
     /* 252145 */     // GIR_Coverage, 2370,
     /* 252145 */     GIR_EraseRootFromParent_Done,
     /* 252146 */   // Label 5077: @252146
     /* 252146 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(252204), // Rule ID 2371 //
     /* 252151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 252154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 252159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 252162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 252165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 252168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 252171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252187 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 252187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 252190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 252194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252202 */     GIR_RootConstrainSelectedInstOperands,
     /* 252203 */     // GIR_Coverage, 2371,
     /* 252203 */     GIR_EraseRootFromParent_Done,
     /* 252204 */   // Label 5078: @252204
     /* 252204 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(252262), // Rule ID 2372 //
     /* 252209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 252212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 252217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 252220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 252223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 252226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 252229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252245 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 252245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 252248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 252252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252260 */     GIR_RootConstrainSelectedInstOperands,
     /* 252261 */     // GIR_Coverage, 2372,
     /* 252261 */     GIR_EraseRootFromParent_Done,
     /* 252262 */   // Label 5079: @252262
     /* 252262 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(252320), // Rule ID 2373 //
     /* 252267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 252270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 252275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 252278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 252281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 252284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 252287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 252303 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 252303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 252306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 252310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252318 */     GIR_RootConstrainSelectedInstOperands,
     /* 252319 */     // GIR_Coverage, 2373,
     /* 252319 */     GIR_EraseRootFromParent_Done,
     /* 252320 */   // Label 5080: @252320
     /* 252320 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(252378), // Rule ID 2374 //
     /* 252325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 252328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 252333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 252339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 252342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 252345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252361 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 252361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 252364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 252368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252376 */     GIR_RootConstrainSelectedInstOperands,
     /* 252377 */     // GIR_Coverage, 2374,
     /* 252377 */     GIR_EraseRootFromParent_Done,
     /* 252378 */   // Label 5081: @252378
     /* 252378 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(252436), // Rule ID 2482 //
     /* 252383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 252386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 252391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 252394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 252397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 252400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252419 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 252419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 252422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252424 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 252426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252434 */     GIR_RootConstrainSelectedInstOperands,
     /* 252435 */     // GIR_Coverage, 2482,
     /* 252435 */     GIR_EraseRootFromParent_Done,
     /* 252436 */   // Label 5082: @252436
     /* 252436 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(252492), // Rule ID 12917 //
     /* 252441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 252446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 252455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252467 */     // MIs[0] addr
     /* 252467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 252471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252475 */     // (intrinsic_w_chain:{ *:[i32] } 1144:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 252475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 252478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252480 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 252482 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 252484 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 252486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252490 */     GIR_RootConstrainSelectedInstOperands,
     /* 252491 */     // GIR_Coverage, 12917,
     /* 252491 */     GIR_EraseRootFromParent_Done,
     /* 252492 */   // Label 5083: @252492
     /* 252492 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(252548), // Rule ID 12918 //
     /* 252497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 252502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 252511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252523 */     // MIs[0] addr
     /* 252523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 252527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252531 */     // (intrinsic_w_chain:{ *:[i32] } 1146:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 252531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 252534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252536 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 252538 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 252540 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 252542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252546 */     GIR_RootConstrainSelectedInstOperands,
     /* 252547 */     // GIR_Coverage, 12918,
     /* 252547 */     GIR_EraseRootFromParent_Done,
     /* 252548 */   // Label 5084: @252548
     /* 252548 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(252594), // Rule ID 3450 //
     /* 252553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 252556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 252561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252577 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1409:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 252580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252592 */     GIR_RootConstrainSelectedInstOperands,
     /* 252593 */     // GIR_Coverage, 3450,
     /* 252593 */     GIR_EraseRootFromParent_Done,
     /* 252594 */   // Label 5085: @252594
     /* 252594 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(252640), // Rule ID 3572 //
     /* 252599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 252602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 252607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252623 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 252626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252638 */     GIR_RootConstrainSelectedInstOperands,
     /* 252639 */     // GIR_Coverage, 3572,
     /* 252639 */     GIR_EraseRootFromParent_Done,
     /* 252640 */   // Label 5086: @252640
     /* 252640 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(252686), // Rule ID 12430 //
     /* 252645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 252648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 252653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252669 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1421:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 252672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252684 */     GIR_RootConstrainSelectedInstOperands,
     /* 252685 */     // GIR_Coverage, 12430,
     /* 252685 */     GIR_EraseRootFromParent_Done,
     /* 252686 */   // Label 5087: @252686
     /* 252686 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(252732), // Rule ID 12434 //
     /* 252691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 252694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 252699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252715 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1413:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 252718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252730 */     GIR_RootConstrainSelectedInstOperands,
     /* 252731 */     // GIR_Coverage, 12434,
     /* 252731 */     GIR_EraseRootFromParent_Done,
     /* 252732 */   // Label 5088: @252732
     /* 252732 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(252778), // Rule ID 12435 //
     /* 252737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 252740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 252745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252761 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1415:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 252764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252776 */     GIR_RootConstrainSelectedInstOperands,
     /* 252777 */     // GIR_Coverage, 12435,
     /* 252777 */     GIR_EraseRootFromParent_Done,
     /* 252778 */   // Label 5089: @252778
     /* 252778 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(252824), // Rule ID 12436 //
     /* 252783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 252786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 252791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252807 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 252810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252822 */     GIR_RootConstrainSelectedInstOperands,
     /* 252823 */     // GIR_Coverage, 12436,
     /* 252823 */     GIR_EraseRootFromParent_Done,
     /* 252824 */   // Label 5090: @252824
     /* 252824 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(252870), // Rule ID 12437 //
     /* 252829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 252832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 252837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252853 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 252856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252868 */     GIR_RootConstrainSelectedInstOperands,
     /* 252869 */     // GIR_Coverage, 12437,
     /* 252869 */     GIR_EraseRootFromParent_Done,
     /* 252870 */   // Label 5091: @252870
     /* 252870 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(252916), // Rule ID 12438 //
     /* 252875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 252878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 252883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252899 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1409:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 252902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252914 */     GIR_RootConstrainSelectedInstOperands,
     /* 252915 */     // GIR_Coverage, 12438,
     /* 252915 */     GIR_EraseRootFromParent_Done,
     /* 252916 */   // Label 5092: @252916
     /* 252916 */   GIM_Reject,
     /* 252917 */ // Label 5045: @252917
     /* 252917 */ GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(255910),
     /* 252922 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 252925 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(252993), // Rule ID 2509 //
     /* 252930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 252933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 252938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 252941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 252944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 252947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 252950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 252962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 252966 */     // MIs[0] Idx
     /* 252966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 252969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 252974 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 252974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 252977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 252979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 252981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 252985 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 252987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252991 */     GIR_RootConstrainSelectedInstOperands,
     /* 252992 */     // GIR_Coverage, 2509,
     /* 252992 */     GIR_EraseRootFromParent_Done,
     /* 252993 */   // Label 5094: @252993
     /* 252993 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(253061), // Rule ID 2510 //
     /* 252998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 253001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 253006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 253012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 253015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 253034 */     // MIs[0] Idx
     /* 253034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 253042 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 253045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253053 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253059 */     GIR_RootConstrainSelectedInstOperands,
     /* 253060 */     // GIR_Coverage, 2510,
     /* 253060 */     GIR_EraseRootFromParent_Done,
     /* 253061 */   // Label 5095: @253061
     /* 253061 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(253129), // Rule ID 2511 //
     /* 253066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 253069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 253074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 253077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 253083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253102 */     // MIs[0] Idx
     /* 253102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 253110 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 253113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253121 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253127 */     GIR_RootConstrainSelectedInstOperands,
     /* 253128 */     // GIR_Coverage, 2511,
     /* 253128 */     GIR_EraseRootFromParent_Done,
     /* 253129 */   // Label 5096: @253129
     /* 253129 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(253197), // Rule ID 2512 //
     /* 253134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 253137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 253142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 253148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 253151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253170 */     // MIs[0] Idx
     /* 253170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 253178 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 253181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253189 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253195 */     GIR_RootConstrainSelectedInstOperands,
     /* 253196 */     // GIR_Coverage, 2512,
     /* 253196 */     GIR_EraseRootFromParent_Done,
     /* 253197 */   // Label 5097: @253197
     /* 253197 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(253265), // Rule ID 2513 //
     /* 253202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 253205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 253210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 253213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 253216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 253219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 253238 */     // MIs[0] Idx
     /* 253238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 253246 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 253249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253263 */     GIR_RootConstrainSelectedInstOperands,
     /* 253264 */     // GIR_Coverage, 2513,
     /* 253264 */     GIR_EraseRootFromParent_Done,
     /* 253265 */   // Label 5098: @253265
     /* 253265 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(253333), // Rule ID 2514 //
     /* 253270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 253273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 253278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 253281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 253284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 253287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 253306 */     // MIs[0] Idx
     /* 253306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 253314 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 253317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253325 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253331 */     GIR_RootConstrainSelectedInstOperands,
     /* 253332 */     // GIR_Coverage, 2514,
     /* 253332 */     GIR_EraseRootFromParent_Done,
     /* 253333 */   // Label 5099: @253333
     /* 253333 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(253401), // Rule ID 6906 //
     /* 253338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 253341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 253346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 253349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 253352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 253355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 253374 */     // MIs[0] Idx
     /* 253374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 253382 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 253385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253393 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253399 */     GIR_RootConstrainSelectedInstOperands,
     /* 253400 */     // GIR_Coverage, 6906,
     /* 253400 */     GIR_EraseRootFromParent_Done,
     /* 253401 */   // Label 5100: @253401
     /* 253401 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(253469), // Rule ID 6907 //
     /* 253406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 253409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 253414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 253420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 253423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 253442 */     // MIs[0] Idx
     /* 253442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 253450 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 253453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253461 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253467 */     GIR_RootConstrainSelectedInstOperands,
     /* 253468 */     // GIR_Coverage, 6907,
     /* 253468 */     GIR_EraseRootFromParent_Done,
     /* 253469 */   // Label 5101: @253469
     /* 253469 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(253537), // Rule ID 6908 //
     /* 253474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 253477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 253482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 253488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 253491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 253510 */     // MIs[0] Idx
     /* 253510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 253518 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 253521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253529 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253535 */     GIR_RootConstrainSelectedInstOperands,
     /* 253536 */     // GIR_Coverage, 6908,
     /* 253536 */     GIR_EraseRootFromParent_Done,
     /* 253537 */   // Label 5102: @253537
     /* 253537 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(253605), // Rule ID 6909 //
     /* 253542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 253545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 253550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 253556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 253559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 253562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 253578 */     // MIs[0] Idx
     /* 253578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 253581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 253586 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 253586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 253589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 253593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 253597 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 253599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253603 */     GIR_RootConstrainSelectedInstOperands,
     /* 253604 */     // GIR_Coverage, 6909,
     /* 253604 */     GIR_EraseRootFromParent_Done,
     /* 253605 */   // Label 5103: @253605
     /* 253605 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(253665), // Rule ID 3584 //
     /* 253610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 253613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 253618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 253624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 253630 */     // MIs[0] tile
     /* 253630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253646 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 253646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 253649 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253657 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253663 */     GIR_RootConstrainSelectedInstOperands,
     /* 253664 */     // GIR_Coverage, 3584,
     /* 253664 */     GIR_EraseRootFromParent_Done,
     /* 253665 */   // Label 5104: @253665
     /* 253665 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(253725), // Rule ID 3585 //
     /* 253670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 253673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 253678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 253684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 253690 */     // MIs[0] tile
     /* 253690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253706 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 253709 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253717 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253723 */     GIR_RootConstrainSelectedInstOperands,
     /* 253724 */     // GIR_Coverage, 3585,
     /* 253724 */     GIR_EraseRootFromParent_Done,
     /* 253725 */   // Label 5105: @253725
     /* 253725 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(253785), // Rule ID 3586 //
     /* 253730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 253733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 253738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 253744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 253750 */     // MIs[0] tile
     /* 253750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253766 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 253766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 253769 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253777 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253783 */     GIR_RootConstrainSelectedInstOperands,
     /* 253784 */     // GIR_Coverage, 3586,
     /* 253784 */     GIR_EraseRootFromParent_Done,
     /* 253785 */   // Label 5106: @253785
     /* 253785 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(253845), // Rule ID 3587 //
     /* 253790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 253793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 253798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 253804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 253810 */     // MIs[0] tile
     /* 253810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253826 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 253829 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253837 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253843 */     GIR_RootConstrainSelectedInstOperands,
     /* 253844 */     // GIR_Coverage, 3587,
     /* 253844 */     GIR_EraseRootFromParent_Done,
     /* 253845 */   // Label 5107: @253845
     /* 253845 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(253905), // Rule ID 3588 //
     /* 253850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 253853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 253858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 253870 */     // MIs[0] tile
     /* 253870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253886 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 253889 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253897 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253903 */     GIR_RootConstrainSelectedInstOperands,
     /* 253904 */     // GIR_Coverage, 3588,
     /* 253904 */     GIR_EraseRootFromParent_Done,
     /* 253905 */   // Label 5108: @253905
     /* 253905 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(253965), // Rule ID 3589 //
     /* 253910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 253913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 253918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 253924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 253930 */     // MIs[0] tile
     /* 253930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253946 */     // (intrinsic_void 989:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 253949 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253957 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253963 */     GIR_RootConstrainSelectedInstOperands,
     /* 253964 */     // GIR_Coverage, 3589,
     /* 253964 */     GIR_EraseRootFromParent_Done,
     /* 253965 */   // Label 5109: @253965
     /* 253965 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(254025), // Rule ID 3590 //
     /* 253970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 253973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 253978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 253990 */     // MIs[0] tile
     /* 253990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254006 */     // (intrinsic_void 989:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 254009 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254017 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254023 */     GIR_RootConstrainSelectedInstOperands,
     /* 254024 */     // GIR_Coverage, 3590,
     /* 254024 */     GIR_EraseRootFromParent_Done,
     /* 254025 */   // Label 5110: @254025
     /* 254025 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(254085), // Rule ID 3591 //
     /* 254030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 254038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 254044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 254050 */     // MIs[0] tile
     /* 254050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254053 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254066 */     // (intrinsic_void 904:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 254066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 254069 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254077 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254083 */     GIR_RootConstrainSelectedInstOperands,
     /* 254084 */     // GIR_Coverage, 3591,
     /* 254084 */     GIR_EraseRootFromParent_Done,
     /* 254085 */   // Label 5111: @254085
     /* 254085 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(254145), // Rule ID 3673 //
     /* 254090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 254093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 254098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 254104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 254110 */     // MIs[0] tile
     /* 254110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254126 */     // (intrinsic_void 990:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 254129 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254137 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254143 */     GIR_RootConstrainSelectedInstOperands,
     /* 254144 */     // GIR_Coverage, 3673,
     /* 254144 */     GIR_EraseRootFromParent_Done,
     /* 254145 */   // Label 5112: @254145
     /* 254145 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(254205), // Rule ID 3674 //
     /* 254150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 254153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 254158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 254164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 254170 */     // MIs[0] tile
     /* 254170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254186 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 254186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 254189 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254197 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254203 */     GIR_RootConstrainSelectedInstOperands,
     /* 254204 */     // GIR_Coverage, 3674,
     /* 254204 */     GIR_EraseRootFromParent_Done,
     /* 254205 */   // Label 5113: @254205
     /* 254205 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(254265), // Rule ID 12445 //
     /* 254210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 254218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 254224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 254230 */     // MIs[0] tile
     /* 254230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254246 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 254246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 254249 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254263 */     GIR_RootConstrainSelectedInstOperands,
     /* 254264 */     // GIR_Coverage, 12445,
     /* 254264 */     GIR_EraseRootFromParent_Done,
     /* 254265 */   // Label 5114: @254265
     /* 254265 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(254325), // Rule ID 12446 //
     /* 254270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 254273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 254278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 254284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 254290 */     // MIs[0] tile
     /* 254290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254306 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 254306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 254309 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254317 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254323 */     GIR_RootConstrainSelectedInstOperands,
     /* 254324 */     // GIR_Coverage, 12446,
     /* 254324 */     GIR_EraseRootFromParent_Done,
     /* 254325 */   // Label 5115: @254325
     /* 254325 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(254385), // Rule ID 12447 //
     /* 254330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 254338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 254344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 254350 */     // MIs[0] tile
     /* 254350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254366 */     // (intrinsic_void 907:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 254366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 254369 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254377 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254383 */     GIR_RootConstrainSelectedInstOperands,
     /* 254384 */     // GIR_Coverage, 12447,
     /* 254384 */     GIR_EraseRootFromParent_Done,
     /* 254385 */   // Label 5116: @254385
     /* 254385 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(254445), // Rule ID 12448 //
     /* 254390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 254398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 254404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 254410 */     // MIs[0] tile
     /* 254410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254426 */     // (intrinsic_void 991:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 254429 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254437 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254443 */     GIR_RootConstrainSelectedInstOperands,
     /* 254444 */     // GIR_Coverage, 12448,
     /* 254444 */     GIR_EraseRootFromParent_Done,
     /* 254445 */   // Label 5117: @254445
     /* 254445 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(254505), // Rule ID 12449 //
     /* 254450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 254458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 254464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 254470 */     // MIs[0] tile
     /* 254470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254486 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 254489 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254497 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254503 */     GIR_RootConstrainSelectedInstOperands,
     /* 254504 */     // GIR_Coverage, 12449,
     /* 254504 */     GIR_EraseRootFromParent_Done,
     /* 254505 */   // Label 5118: @254505
     /* 254505 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(254565), // Rule ID 12450 //
     /* 254510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 254518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 254524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 254530 */     // MIs[0] tile
     /* 254530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254546 */     // (intrinsic_void 1092:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 254549 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254557 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254563 */     GIR_RootConstrainSelectedInstOperands,
     /* 254564 */     // GIR_Coverage, 12450,
     /* 254564 */     GIR_EraseRootFromParent_Done,
     /* 254565 */   // Label 5119: @254565
     /* 254565 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(254625), // Rule ID 12451 //
     /* 254570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 254578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 254584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 254590 */     // MIs[0] tile
     /* 254590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254606 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 254609 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254617 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254623 */     GIR_RootConstrainSelectedInstOperands,
     /* 254624 */     // GIR_Coverage, 12451,
     /* 254624 */     GIR_EraseRootFromParent_Done,
     /* 254625 */   // Label 5120: @254625
     /* 254625 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(254685), // Rule ID 12452 //
     /* 254630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 254638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 254644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 254650 */     // MIs[0] tile
     /* 254650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254666 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 254669 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254677 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254683 */     GIR_RootConstrainSelectedInstOperands,
     /* 254684 */     // GIR_Coverage, 12452,
     /* 254684 */     GIR_EraseRootFromParent_Done,
     /* 254685 */   // Label 5121: @254685
     /* 254685 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(254745), // Rule ID 12453 //
     /* 254690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 254698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 254704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 254710 */     // MIs[0] tile
     /* 254710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254726 */     // (intrinsic_void 1108:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 254729 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254737 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254743 */     GIR_RootConstrainSelectedInstOperands,
     /* 254744 */     // GIR_Coverage, 12453,
     /* 254744 */     GIR_EraseRootFromParent_Done,
     /* 254745 */   // Label 5122: @254745
     /* 254745 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(254805), // Rule ID 12454 //
     /* 254750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 254758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 254764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 254770 */     // MIs[0] tile
     /* 254770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254786 */     // (intrinsic_void 1109:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 254786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 254789 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254797 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254803 */     GIR_RootConstrainSelectedInstOperands,
     /* 254804 */     // GIR_Coverage, 12454,
     /* 254804 */     GIR_EraseRootFromParent_Done,
     /* 254805 */   // Label 5123: @254805
     /* 254805 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(254865), // Rule ID 12455 //
     /* 254810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 254813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 254818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 254824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 254830 */     // MIs[0] tile
     /* 254830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254846 */     // (intrinsic_void 991:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 254849 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254857 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254863 */     GIR_RootConstrainSelectedInstOperands,
     /* 254864 */     // GIR_Coverage, 12455,
     /* 254864 */     GIR_EraseRootFromParent_Done,
     /* 254865 */   // Label 5124: @254865
     /* 254865 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(254925), // Rule ID 12456 //
     /* 254870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 254873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 254878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 254884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 254890 */     // MIs[0] tile
     /* 254890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254906 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 254909 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254917 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254923 */     GIR_RootConstrainSelectedInstOperands,
     /* 254924 */     // GIR_Coverage, 12456,
     /* 254924 */     GIR_EraseRootFromParent_Done,
     /* 254925 */   // Label 5125: @254925
     /* 254925 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(254985), // Rule ID 12457 //
     /* 254930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 254933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 254938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 254944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 254950 */     // MIs[0] tile
     /* 254950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254966 */     // (intrinsic_void 1092:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 254969 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 254973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 254975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 254977 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 254979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254983 */     GIR_RootConstrainSelectedInstOperands,
     /* 254984 */     // GIR_Coverage, 12457,
     /* 254984 */     GIR_EraseRootFromParent_Done,
     /* 254985 */   // Label 5126: @254985
     /* 254985 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(255045), // Rule ID 12458 //
     /* 254990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 254993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 254998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 255004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 255010 */     // MIs[0] tile
     /* 255010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255026 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 255029 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255037 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255043 */     GIR_RootConstrainSelectedInstOperands,
     /* 255044 */     // GIR_Coverage, 12458,
     /* 255044 */     GIR_EraseRootFromParent_Done,
     /* 255045 */   // Label 5127: @255045
     /* 255045 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(255105), // Rule ID 12459 //
     /* 255050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 255058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 255064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 255070 */     // MIs[0] tile
     /* 255070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255086 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 255089 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255097 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255103 */     GIR_RootConstrainSelectedInstOperands,
     /* 255104 */     // GIR_Coverage, 12459,
     /* 255104 */     GIR_EraseRootFromParent_Done,
     /* 255105 */   // Label 5128: @255105
     /* 255105 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(255165), // Rule ID 12460 //
     /* 255110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 255118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 255124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 255130 */     // MIs[0] tile
     /* 255130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255146 */     // (intrinsic_void 1108:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 255149 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255157 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255163 */     GIR_RootConstrainSelectedInstOperands,
     /* 255164 */     // GIR_Coverage, 12460,
     /* 255164 */     GIR_EraseRootFromParent_Done,
     /* 255165 */   // Label 5129: @255165
     /* 255165 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(255225), // Rule ID 12461 //
     /* 255170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 255178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 255184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 255190 */     // MIs[0] tile
     /* 255190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255206 */     // (intrinsic_void 1109:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 255209 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255217 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255223 */     GIR_RootConstrainSelectedInstOperands,
     /* 255224 */     // GIR_Coverage, 12461,
     /* 255224 */     GIR_EraseRootFromParent_Done,
     /* 255225 */   // Label 5130: @255225
     /* 255225 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(255285), // Rule ID 12758 //
     /* 255230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 255233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 255238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 255244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 255250 */     // MIs[0] tile
     /* 255250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255266 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 255266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 255269 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255277 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255283 */     GIR_RootConstrainSelectedInstOperands,
     /* 255284 */     // GIR_Coverage, 12758,
     /* 255284 */     GIR_EraseRootFromParent_Done,
     /* 255285 */   // Label 5131: @255285
     /* 255285 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(255345), // Rule ID 12759 //
     /* 255290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 255293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 255298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 255304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 255310 */     // MIs[0] tile
     /* 255310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255326 */     // (intrinsic_void 992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 255329 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255337 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255343 */     GIR_RootConstrainSelectedInstOperands,
     /* 255344 */     // GIR_Coverage, 12759,
     /* 255344 */     GIR_EraseRootFromParent_Done,
     /* 255345 */   // Label 5132: @255345
     /* 255345 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(255405), // Rule ID 12760 //
     /* 255350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 255353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 255358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 255364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 255370 */     // MIs[0] tile
     /* 255370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255373 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255386 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 255389 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255397 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255403 */     GIR_RootConstrainSelectedInstOperands,
     /* 255404 */     // GIR_Coverage, 12760,
     /* 255404 */     GIR_EraseRootFromParent_Done,
     /* 255405 */   // Label 5133: @255405
     /* 255405 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(255465), // Rule ID 12761 //
     /* 255410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 255413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 255418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 255424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 255430 */     // MIs[0] tile
     /* 255430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255446 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 255446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 255449 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255457 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255463 */     GIR_RootConstrainSelectedInstOperands,
     /* 255464 */     // GIR_Coverage, 12761,
     /* 255464 */     GIR_EraseRootFromParent_Done,
     /* 255465 */   // Label 5134: @255465
     /* 255465 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(255525), // Rule ID 12872 //
     /* 255470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 255473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 255478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 255484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 255490 */     // MIs[0] tile
     /* 255490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 255498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255506 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 255506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 255509 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 255513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 255515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 255517 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 255519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255523 */     GIR_RootConstrainSelectedInstOperands,
     /* 255524 */     // GIR_Coverage, 12872,
     /* 255524 */     GIR_EraseRootFromParent_Done,
     /* 255525 */   // Label 5135: @255525
     /* 255525 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(255573), // Rule ID 3571 //
     /* 255530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 255533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 255538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255554 */     // MIs[0] Op4
     /* 255554 */     // No operand predicates
     /* 255554 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1412:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 255554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 255557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255565 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 255567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255571 */     GIR_RootConstrainSelectedInstOperands,
     /* 255572 */     // GIR_Coverage, 3571,
     /* 255572 */     GIR_EraseRootFromParent_Done,
     /* 255573 */   // Label 5136: @255573
     /* 255573 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(255621), // Rule ID 3573 //
     /* 255578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 255581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 255586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255602 */     // MIs[0] Op4
     /* 255602 */     // No operand predicates
     /* 255602 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1414:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 255602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 255605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255613 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 255615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255619 */     GIR_RootConstrainSelectedInstOperands,
     /* 255620 */     // GIR_Coverage, 3573,
     /* 255620 */     GIR_EraseRootFromParent_Done,
     /* 255621 */   // Label 5137: @255621
     /* 255621 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(255669), // Rule ID 3574 //
     /* 255626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 255629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 255634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255650 */     // MIs[0] Op4
     /* 255650 */     // No operand predicates
     /* 255650 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1410:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 255650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 255653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255661 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 255663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255667 */     GIR_RootConstrainSelectedInstOperands,
     /* 255668 */     // GIR_Coverage, 3574,
     /* 255668 */     GIR_EraseRootFromParent_Done,
     /* 255669 */   // Label 5138: @255669
     /* 255669 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(255717), // Rule ID 3575 //
     /* 255674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 255677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 255682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255698 */     // MIs[0] Op4
     /* 255698 */     // No operand predicates
     /* 255698 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 255698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 255701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255709 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 255711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255715 */     GIR_RootConstrainSelectedInstOperands,
     /* 255716 */     // GIR_Coverage, 3575,
     /* 255716 */     GIR_EraseRootFromParent_Done,
     /* 255717 */   // Label 5139: @255717
     /* 255717 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(255765), // Rule ID 12429 //
     /* 255722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 255725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 255730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255746 */     // MIs[0] Op4
     /* 255746 */     // No operand predicates
     /* 255746 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 255746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 255749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255757 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 255759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255763 */     GIR_RootConstrainSelectedInstOperands,
     /* 255764 */     // GIR_Coverage, 12429,
     /* 255764 */     GIR_EraseRootFromParent_Done,
     /* 255765 */   // Label 5140: @255765
     /* 255765 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(255813), // Rule ID 12431 //
     /* 255770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 255773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 255778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255794 */     // MIs[0] Op4
     /* 255794 */     // No operand predicates
     /* 255794 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1416:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 255794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 255797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255805 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 255807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255811 */     GIR_RootConstrainSelectedInstOperands,
     /* 255812 */     // GIR_Coverage, 12431,
     /* 255812 */     GIR_EraseRootFromParent_Done,
     /* 255813 */   // Label 5141: @255813
     /* 255813 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(255861), // Rule ID 12432 //
     /* 255818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 255821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 255826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255842 */     // MIs[0] Op4
     /* 255842 */     // No operand predicates
     /* 255842 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1418:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 255842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 255845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255853 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 255855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255859 */     GIR_RootConstrainSelectedInstOperands,
     /* 255860 */     // GIR_Coverage, 12432,
     /* 255860 */     GIR_EraseRootFromParent_Done,
     /* 255861 */   // Label 5142: @255861
     /* 255861 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(255909), // Rule ID 12433 //
     /* 255866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 255869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 255874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255890 */     // MIs[0] Op4
     /* 255890 */     // No operand predicates
     /* 255890 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 255890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 255893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255901 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 255903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255907 */     GIR_RootConstrainSelectedInstOperands,
     /* 255908 */     // GIR_Coverage, 12433,
     /* 255908 */     GIR_EraseRootFromParent_Done,
     /* 255909 */   // Label 5143: @255909
     /* 255909 */   GIM_Reject,
     /* 255910 */ // Label 5093: @255910
     /* 255910 */ GIM_Reject,
     /* 255911 */ // Label 37: @255911
     /* 255911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5148*/ GIMT_Encode4(256200),
     /* 255922 */ /*GILLT_s64*//*Label 5144*/ GIMT_Encode4(255954), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 255934 */ /*GILLT_v2s64*//*Label 5145*/ GIMT_Encode4(256014), GIMT_Encode4(0),
     /* 255942 */ /*GILLT_v4s32*//*Label 5146*/ GIMT_Encode4(256076), GIMT_Encode4(0),
     /* 255950 */ /*GILLT_v8s16*//*Label 5147*/ GIMT_Encode4(256138),
     /* 255954 */ // Label 5144: @255954
     /* 255954 */ GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(256013), // Rule ID 6418 //
     /* 255959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 255962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 255966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255970 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 255970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 255973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255992 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 255994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 255997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 256002 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 256007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256012 */   // GIR_Coverage, 6418,
     /* 256012 */   GIR_EraseRootFromParent_Done,
     /* 256013 */ // Label 5149: @256013
     /* 256013 */ GIM_Reject,
     /* 256014 */ // Label 5145: @256014
     /* 256014 */ GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(256075),
     /* 256019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 256022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256026 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(256053), // Rule ID 6290 //
     /* 256031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 256038 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 256038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 256041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 256048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256051 */     GIR_RootConstrainSelectedInstOperands,
     /* 256052 */     // GIR_Coverage, 6290,
     /* 256052 */     GIR_EraseRootFromParent_Done,
     /* 256053 */   // Label 5151: @256053
     /* 256053 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(256074), // Rule ID 6283 //
     /* 256058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256062 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 256062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 256065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 256069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256072 */     GIR_RootConstrainSelectedInstOperands,
     /* 256073 */     // GIR_Coverage, 6283,
     /* 256073 */     GIR_EraseRootFromParent_Done,
     /* 256074 */   // Label 5152: @256074
     /* 256074 */   GIM_Reject,
     /* 256075 */ // Label 5150: @256075
     /* 256075 */ GIM_Reject,
     /* 256076 */ // Label 5146: @256076
     /* 256076 */ GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(256137),
     /* 256081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 256084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256088 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(256115), // Rule ID 6287 //
     /* 256093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 256100 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 256100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 256103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 256110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256113 */     GIR_RootConstrainSelectedInstOperands,
     /* 256114 */     // GIR_Coverage, 6287,
     /* 256114 */     GIR_EraseRootFromParent_Done,
     /* 256115 */   // Label 5154: @256115
     /* 256115 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(256136), // Rule ID 6280 //
     /* 256120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256124 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 256124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 256127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 256131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256134 */     GIR_RootConstrainSelectedInstOperands,
     /* 256135 */     // GIR_Coverage, 6280,
     /* 256135 */     GIR_EraseRootFromParent_Done,
     /* 256136 */   // Label 5155: @256136
     /* 256136 */   GIM_Reject,
     /* 256137 */ // Label 5153: @256137
     /* 256137 */ GIM_Reject,
     /* 256138 */ // Label 5147: @256138
     /* 256138 */ GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(256199),
     /* 256143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 256146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256150 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(256177), // Rule ID 6284 //
     /* 256155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 256162 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 256162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 256165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 256172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256175 */     GIR_RootConstrainSelectedInstOperands,
     /* 256176 */     // GIR_Coverage, 6284,
     /* 256176 */     GIR_EraseRootFromParent_Done,
     /* 256177 */   // Label 5157: @256177
     /* 256177 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(256198), // Rule ID 6277 //
     /* 256182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256186 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 256186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 256189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 256193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256196 */     GIR_RootConstrainSelectedInstOperands,
     /* 256197 */     // GIR_Coverage, 6277,
     /* 256197 */     GIR_EraseRootFromParent_Done,
     /* 256198 */   // Label 5158: @256198
     /* 256198 */   GIM_Reject,
     /* 256199 */ // Label 5156: @256199
     /* 256199 */ GIM_Reject,
     /* 256200 */ // Label 5148: @256200
     /* 256200 */ GIM_Reject,
     /* 256201 */ // Label 38: @256201
     /* 256201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5163*/ GIMT_Encode4(257637),
     /* 256212 */ /*GILLT_s32*//*Label 5159*/ GIMT_Encode4(256244), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 256224 */ /*GILLT_v2s32*//*Label 5160*/ GIMT_Encode4(256283), GIMT_Encode4(0),
     /* 256232 */ /*GILLT_v4s16*//*Label 5161*/ GIMT_Encode4(256639), GIMT_Encode4(0),
     /* 256240 */ /*GILLT_v8s8*//*Label 5162*/ GIMT_Encode4(257138),
     /* 256244 */ // Label 5159: @256244
     /* 256244 */ GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(256282), // Rule ID 6439 //
     /* 256249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 256252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 256256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256260 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 256260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 256263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256265 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 256271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 256276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256281 */   // GIR_Coverage, 6439,
     /* 256281 */   GIR_EraseRootFromParent_Done,
     /* 256282 */ // Label 5164: @256282
     /* 256282 */ GIM_Reject,
     /* 256283 */ // Label 5160: @256283
     /* 256283 */ GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(256638),
     /* 256288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256295 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(256373), // Rule ID 5377 //
     /* 256300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 256308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 256316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 256320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 256328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 256337 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 256343 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 256345 */     // MIs[1] Operand 2
     /* 256345 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 256356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 256358 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 256358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 256361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 256367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 256371 */     GIR_RootConstrainSelectedInstOperands,
     /* 256372 */     // GIR_Coverage, 5377,
     /* 256372 */     GIR_EraseRootFromParent_Done,
     /* 256373 */   // Label 5166: @256373
     /* 256373 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(256444), // Rule ID 5373 //
     /* 256378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 256386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 256394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 256398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 256406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256416 */     // MIs[1] Operand 2
     /* 256416 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 256427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 256429 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 256429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 256432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 256438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 256442 */     GIR_RootConstrainSelectedInstOperands,
     /* 256443 */     // GIR_Coverage, 5373,
     /* 256443 */     GIR_EraseRootFromParent_Done,
     /* 256444 */   // Label 5167: @256444
     /* 256444 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(256515), // Rule ID 5375 //
     /* 256449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 256457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 256465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 256469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 256477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256487 */     // MIs[1] Operand 2
     /* 256487 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 256498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 256500 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 256500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 256503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 256509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 256513 */     GIR_RootConstrainSelectedInstOperands,
     /* 256514 */     // GIR_Coverage, 5375,
     /* 256514 */     GIR_EraseRootFromParent_Done,
     /* 256515 */   // Label 5168: @256515
     /* 256515 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(256568), // Rule ID 2153 //
     /* 256520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 256523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 256531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256540 */     // MIs[1] imm
     /* 256540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 256544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 256548 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 256552 */     // MIs[2] Operand 1
     /* 256552 */     // No operand predicates
     /* 256552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 256554 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 256554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 256557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 256563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 256566 */     GIR_RootConstrainSelectedInstOperands,
     /* 256567 */     // GIR_Coverage, 2153,
     /* 256567 */     GIR_EraseRootFromParent_Done,
     /* 256568 */   // Label 5169: @256568
     /* 256568 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(256618), // Rule ID 6265 //
     /* 256573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 256581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256590 */     // MIs[1] imm
     /* 256590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 256594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 256598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 256602 */     // MIs[2] Operand 1
     /* 256602 */     // No operand predicates
     /* 256602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 256604 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 256604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 256607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 256613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 256616 */     GIR_RootConstrainSelectedInstOperands,
     /* 256617 */     // GIR_Coverage, 6265,
     /* 256617 */     GIR_EraseRootFromParent_Done,
     /* 256618 */   // Label 5170: @256618
     /* 256618 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(256637), // Rule ID 1092 //
     /* 256623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 256626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256630 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 256630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 256635 */     GIR_RootConstrainSelectedInstOperands,
     /* 256636 */     // GIR_Coverage, 1092,
     /* 256636 */     GIR_Done,
     /* 256637 */   // Label 5171: @256637
     /* 256637 */   GIM_Reject,
     /* 256638 */ // Label 5165: @256638
     /* 256638 */ GIM_Reject,
     /* 256639 */ // Label 5161: @256639
     /* 256639 */ GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(257137),
     /* 256644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256651 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(256729), // Rule ID 5371 //
     /* 256656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 256664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 256672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 256676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 256693 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 256699 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 256701 */     // MIs[1] Operand 2
     /* 256701 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 256712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 256714 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 256714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 256717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 256723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 256727 */     GIR_RootConstrainSelectedInstOperands,
     /* 256728 */     // GIR_Coverage, 5371,
     /* 256728 */     GIR_EraseRootFromParent_Done,
     /* 256729 */   // Label 5173: @256729
     /* 256729 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(256800), // Rule ID 5367 //
     /* 256734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 256742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 256750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 256754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256772 */     // MIs[1] Operand 2
     /* 256772 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 256783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 256785 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 256785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 256788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 256794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 256798 */     GIR_RootConstrainSelectedInstOperands,
     /* 256799 */     // GIR_Coverage, 5367,
     /* 256799 */     GIR_EraseRootFromParent_Done,
     /* 256800 */   // Label 5174: @256800
     /* 256800 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(256871), // Rule ID 5369 //
     /* 256805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 256813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 256821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 256825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256843 */     // MIs[1] Operand 2
     /* 256843 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 256854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 256856 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 256856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 256859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 256865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 256869 */     GIR_RootConstrainSelectedInstOperands,
     /* 256870 */     // GIR_Coverage, 5369,
     /* 256870 */     GIR_EraseRootFromParent_Done,
     /* 256871 */   // Label 5175: @256871
     /* 256871 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(256963), // Rule ID 5493 //
     /* 256876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 256884 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 256891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 256895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 256899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 256903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 256916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 256920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 256924 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 256931 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 256931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 256938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256943 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 256947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 256951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 256953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 256956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256961 */     GIR_RootConstrainSelectedInstOperands,
     /* 256962 */     // GIR_Coverage, 5493,
     /* 256962 */     GIR_EraseRootFromParent_Done,
     /* 256963 */   // Label 5176: @256963
     /* 256963 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(257016), // Rule ID 2152 //
     /* 256968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 256971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 256979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256988 */     // MIs[1] imm
     /* 256988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 256992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 256996 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 257000 */     // MIs[2] Operand 1
     /* 257000 */     // No operand predicates
     /* 257000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257002 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 257002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 257005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 257014 */     GIR_RootConstrainSelectedInstOperands,
     /* 257015 */     // GIR_Coverage, 2152,
     /* 257015 */     GIR_EraseRootFromParent_Done,
     /* 257016 */   // Label 5177: @257016
     /* 257016 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(257066), // Rule ID 6264 //
     /* 257021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 257029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 257033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257038 */     // MIs[1] imm
     /* 257038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257046 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 257050 */     // MIs[2] Operand 1
     /* 257050 */     // No operand predicates
     /* 257050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257052 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 257052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 257055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 257064 */     GIR_RootConstrainSelectedInstOperands,
     /* 257065 */     // GIR_Coverage, 6264,
     /* 257065 */     GIR_EraseRootFromParent_Done,
     /* 257066 */   // Label 5178: @257066
     /* 257066 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(257117), // Rule ID 5521 //
     /* 257071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 257079 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 257082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 257086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257102 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 257102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 257105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 257111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 257115 */     GIR_RootConstrainSelectedInstOperands,
     /* 257116 */     // GIR_Coverage, 5521,
     /* 257116 */     GIR_EraseRootFromParent_Done,
     /* 257117 */   // Label 5179: @257117
     /* 257117 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(257136), // Rule ID 1091 //
     /* 257122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257129 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 257129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 257134 */     GIR_RootConstrainSelectedInstOperands,
     /* 257135 */     // GIR_Coverage, 1091,
     /* 257135 */     GIR_Done,
     /* 257136 */   // Label 5180: @257136
     /* 257136 */   GIM_Reject,
     /* 257137 */ // Label 5172: @257137
     /* 257137 */ GIM_Reject,
     /* 257138 */ // Label 5162: @257138
     /* 257138 */ GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(257636),
     /* 257143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257150 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(257228), // Rule ID 5365 //
     /* 257155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 257163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 257171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 257175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 257192 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 257198 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 257200 */     // MIs[1] Operand 2
     /* 257200 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 257211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 257213 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 257213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 257216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 257222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 257226 */     GIR_RootConstrainSelectedInstOperands,
     /* 257227 */     // GIR_Coverage, 5365,
     /* 257227 */     GIR_EraseRootFromParent_Done,
     /* 257228 */   // Label 5182: @257228
     /* 257228 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(257299), // Rule ID 5361 //
     /* 257233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 257241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 257249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 257253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257271 */     // MIs[1] Operand 2
     /* 257271 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 257282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257284 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 257284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 257287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 257293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 257297 */     GIR_RootConstrainSelectedInstOperands,
     /* 257298 */     // GIR_Coverage, 5361,
     /* 257298 */     GIR_EraseRootFromParent_Done,
     /* 257299 */   // Label 5183: @257299
     /* 257299 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(257370), // Rule ID 5363 //
     /* 257304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 257312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 257320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 257324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257342 */     // MIs[1] Operand 2
     /* 257342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 257353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257355 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 257355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 257358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 257364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 257368 */     GIR_RootConstrainSelectedInstOperands,
     /* 257369 */     // GIR_Coverage, 5363,
     /* 257369 */     GIR_EraseRootFromParent_Done,
     /* 257370 */   // Label 5184: @257370
     /* 257370 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(257462), // Rule ID 5466 //
     /* 257375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 257383 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 257386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 257390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 257398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 257402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 257406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 257415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 257419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 257423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 257430 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 257430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 257437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 257446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 257450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 257452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 257455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257460 */     GIR_RootConstrainSelectedInstOperands,
     /* 257461 */     // GIR_Coverage, 5466,
     /* 257461 */     GIR_EraseRootFromParent_Done,
     /* 257462 */   // Label 5185: @257462
     /* 257462 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(257515), // Rule ID 2151 //
     /* 257467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 257478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257487 */     // MIs[1] imm
     /* 257487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257495 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 257499 */     // MIs[2] Operand 1
     /* 257499 */     // No operand predicates
     /* 257499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257501 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 257501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 257504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 257513 */     GIR_RootConstrainSelectedInstOperands,
     /* 257514 */     // GIR_Coverage, 2151,
     /* 257514 */     GIR_EraseRootFromParent_Done,
     /* 257515 */   // Label 5186: @257515
     /* 257515 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(257565), // Rule ID 6263 //
     /* 257520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 257528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257537 */     // MIs[1] imm
     /* 257537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257545 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 257549 */     // MIs[2] Operand 1
     /* 257549 */     // No operand predicates
     /* 257549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257551 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 257551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 257554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 257563 */     GIR_RootConstrainSelectedInstOperands,
     /* 257564 */     // GIR_Coverage, 6263,
     /* 257564 */     GIR_EraseRootFromParent_Done,
     /* 257565 */   // Label 5187: @257565
     /* 257565 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(257616), // Rule ID 5520 //
     /* 257570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 257578 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 257581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 257585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257601 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 257601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 257604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 257610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 257614 */     GIR_RootConstrainSelectedInstOperands,
     /* 257615 */     // GIR_Coverage, 5520,
     /* 257615 */     GIR_EraseRootFromParent_Done,
     /* 257616 */   // Label 5188: @257616
     /* 257616 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(257635), // Rule ID 1090 //
     /* 257621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257628 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 257628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 257633 */     GIR_RootConstrainSelectedInstOperands,
     /* 257634 */     // GIR_Coverage, 1090,
     /* 257634 */     GIR_Done,
     /* 257635 */   // Label 5189: @257635
     /* 257635 */   GIM_Reject,
     /* 257636 */ // Label 5181: @257636
     /* 257636 */ GIM_Reject,
     /* 257637 */ // Label 5163: @257637
     /* 257637 */ GIM_Reject,
     /* 257638 */ // Label 39: @257638
     /* 257638 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5192*/ GIMT_Encode4(257757),
     /* 257649 */ /*GILLT_s32*//*Label 5190*/ GIMT_Encode4(257657),
     /* 257653 */ /*GILLT_s64*//*Label 5191*/ GIMT_Encode4(257677),
     /* 257657 */ // Label 5190: @257657
     /* 257657 */ GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(257676), // Rule ID 81 //
     /* 257662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257666 */   // MIs[0] Operand 1
     /* 257666 */   // No operand predicates
     /* 257666 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 257666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 257669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257671 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 257674 */   GIR_RootConstrainSelectedInstOperands,
     /* 257675 */   // GIR_Coverage, 81,
     /* 257675 */   GIR_EraseRootFromParent_Done,
     /* 257676 */ // Label 5193: @257676
     /* 257676 */ GIM_Reject,
     /* 257677 */ // Label 5191: @257677
     /* 257677 */ GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(257737), // Rule ID 3858 //
     /* 257682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 257685 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 257689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 257693 */   // MIs[0] Operand 1
     /* 257693 */   // No operand predicates
     /* 257693 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 257693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 257696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 257700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257705 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 257710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 257712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 257715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 257726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 257731 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257736 */   // GIR_Coverage, 3858,
     /* 257736 */   GIR_EraseRootFromParent_Done,
     /* 257737 */ // Label 5194: @257737
     /* 257737 */ GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(257756), // Rule ID 82 //
     /* 257742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257746 */   // MIs[0] Operand 1
     /* 257746 */   // No operand predicates
     /* 257746 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 257746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 257749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257751 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 257754 */   GIR_RootConstrainSelectedInstOperands,
     /* 257755 */   // GIR_Coverage, 82,
     /* 257755 */   GIR_EraseRootFromParent_Done,
     /* 257756 */ // Label 5195: @257756
     /* 257756 */ GIM_Reject,
     /* 257757 */ // Label 5192: @257757
     /* 257757 */ GIM_Reject,
     /* 257758 */ // Label 40: @257758
     /* 257758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5199*/ GIMT_Encode4(257998),
     /* 257769 */ /*GILLT_s16*//*Label 5196*/ GIMT_Encode4(257781),
     /* 257773 */ /*GILLT_s32*//*Label 5197*/ GIMT_Encode4(257833),
     /* 257777 */ /*GILLT_s64*//*Label 5198*/ GIMT_Encode4(257946),
     /* 257781 */ // Label 5196: @257781
     /* 257781 */ GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(257804), // Rule ID 506 //
     /* 257786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 257789 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 257793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 257797 */   // MIs[0] Operand 1
     /* 257797 */   // No operand predicates
     /* 257797 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 257797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 257800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257802 */   GIR_RootConstrainSelectedInstOperands,
     /* 257803 */   // GIR_Coverage, 506,
     /* 257803 */   GIR_EraseRootFromParent_Done,
     /* 257804 */ // Label 5200: @257804
     /* 257804 */ GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(257832), // Rule ID 688 //
     /* 257809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 257812 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 257816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 257820 */   // MIs[0] Operand 1
     /* 257820 */   // No operand predicates
     /* 257820 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 257820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 257823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257825 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 257830 */   GIR_RootConstrainSelectedInstOperands,
     /* 257831 */   // GIR_Coverage, 688,
     /* 257831 */   GIR_EraseRootFromParent_Done,
     /* 257832 */ // Label 5201: @257832
     /* 257832 */ GIM_Reject,
     /* 257833 */ // Label 5197: @257833
     /* 257833 */ GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(257856), // Rule ID 507 //
     /* 257838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 257841 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 257845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 257849 */   // MIs[0] Operand 1
     /* 257849 */   // No operand predicates
     /* 257849 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 257849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 257852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257854 */   GIR_RootConstrainSelectedInstOperands,
     /* 257855 */   // GIR_Coverage, 507,
     /* 257855 */   GIR_EraseRootFromParent_Done,
     /* 257856 */ // Label 5202: @257856
     /* 257856 */ GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(257884), // Rule ID 689 //
     /* 257861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 257864 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 257868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 257872 */   // MIs[0] Operand 1
     /* 257872 */   // No operand predicates
     /* 257872 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 257872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 257875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257877 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 257882 */   GIR_RootConstrainSelectedInstOperands,
     /* 257883 */   // GIR_Coverage, 689,
     /* 257883 */   GIR_EraseRootFromParent_Done,
     /* 257884 */ // Label 5203: @257884
     /* 257884 */ GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(257945), // Rule ID 5944 //
     /* 257889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257892 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 257896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 257900 */   // MIs[0] Operand 1
     /* 257900 */   // No operand predicates
     /* 257900 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 257900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 257903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 257907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257912 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 257917 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 257920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 257922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 257925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257927 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 257934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 257939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257944 */   // GIR_Coverage, 5944,
     /* 257944 */   GIR_EraseRootFromParent_Done,
     /* 257945 */ // Label 5204: @257945
     /* 257945 */ GIM_Reject,
     /* 257946 */ // Label 5198: @257946
     /* 257946 */ GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(257969), // Rule ID 508 //
     /* 257951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 257954 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 257958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257962 */   // MIs[0] Operand 1
     /* 257962 */   // No operand predicates
     /* 257962 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 257962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 257965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257967 */   GIR_RootConstrainSelectedInstOperands,
     /* 257968 */   // GIR_Coverage, 508,
     /* 257968 */   GIR_EraseRootFromParent_Done,
     /* 257969 */ // Label 5205: @257969
     /* 257969 */ GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(257997), // Rule ID 690 //
     /* 257974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 257977 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 257981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257985 */   // MIs[0] Operand 1
     /* 257985 */   // No operand predicates
     /* 257985 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 257985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 257988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257990 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 257995 */   GIR_RootConstrainSelectedInstOperands,
     /* 257996 */   // GIR_Coverage, 690,
     /* 257996 */   GIR_EraseRootFromParent_Done,
     /* 257997 */ // Label 5206: @257997
     /* 257997 */ GIM_Reject,
     /* 257998 */ // Label 5199: @257998
     /* 257998 */ GIM_Reject,
     /* 257999 */ // Label 41: @257999
     /* 257999 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5212*/ GIMT_Encode4(259896),
     /* 258010 */ /*GILLT_s32*//*Label 5207*/ GIMT_Encode4(258046),
     /* 258014 */ /*GILLT_s64*//*Label 5208*/ GIMT_Encode4(259487), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 258026 */ /*GILLT_v2s64*//*Label 5209*/ GIMT_Encode4(259710), GIMT_Encode4(0),
     /* 258034 */ /*GILLT_v4s32*//*Label 5210*/ GIMT_Encode4(259772), GIMT_Encode4(0),
     /* 258042 */ /*GILLT_v8s16*//*Label 5211*/ GIMT_Encode4(259834),
     /* 258046 */ // Label 5207: @258046
     /* 258046 */ GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(258166), // Rule ID 12919 //
     /* 258051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 258054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258058 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258062 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 258066 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 258069 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 258074 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 258078 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 258085 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 258085 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 258088 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 258092 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258097 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 258101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 258103 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 258106 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258110 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258129 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258132 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 258135 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 258138 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 258153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 258156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258164 */   GIR_RootConstrainSelectedInstOperands,
     /* 258165 */   // GIR_Coverage, 12919,
     /* 258165 */   GIR_EraseRootFromParent_Done,
     /* 258166 */ // Label 5213: @258166
     /* 258166 */ GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(258286), // Rule ID 12921 //
     /* 258171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 258174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258178 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 258186 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 258189 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 258194 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258198 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 258205 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 258205 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 258208 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 258212 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258217 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 258221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 258223 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 258226 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258230 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258240 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258244 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258249 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258252 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 258255 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 258258 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258263 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258268 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 258273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 258276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258278 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258284 */   GIR_RootConstrainSelectedInstOperands,
     /* 258285 */   // GIR_Coverage, 12921,
     /* 258285 */   GIR_EraseRootFromParent_Done,
     /* 258286 */ // Label 5214: @258286
     /* 258286 */ GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(258406), // Rule ID 12923 //
     /* 258291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 258294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258298 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 258306 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 258309 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 258314 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258318 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 258325 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 258325 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 258328 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 258332 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258337 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 258341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 258343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 258346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258369 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258372 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 258375 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 258378 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258388 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 258393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 258396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258404 */   GIR_RootConstrainSelectedInstOperands,
     /* 258405 */   // GIR_Coverage, 12923,
     /* 258405 */   GIR_EraseRootFromParent_Done,
     /* 258406 */ // Label 5215: @258406
     /* 258406 */ GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(258526), // Rule ID 12925 //
     /* 258411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 258414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258418 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258422 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 258426 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 258429 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 258434 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258438 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 258445 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 258445 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 258448 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 258452 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258457 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 258461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 258463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 258466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258489 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258492 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 258495 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 258498 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258503 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 258513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 258516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258524 */   GIR_RootConstrainSelectedInstOperands,
     /* 258525 */   // GIR_Coverage, 12925,
     /* 258525 */   GIR_EraseRootFromParent_Done,
     /* 258526 */ // Label 5216: @258526
     /* 258526 */ GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(258646), // Rule ID 12941 //
     /* 258531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 258534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258538 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258542 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 258546 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 258549 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 258554 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 258558 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 258565 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 258565 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 258568 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 258572 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258577 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 258581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 258583 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 258586 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258590 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258609 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258612 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 258615 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 258618 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258623 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 258633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 258636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258644 */   GIR_RootConstrainSelectedInstOperands,
     /* 258645 */   // GIR_Coverage, 12941,
     /* 258645 */   GIR_EraseRootFromParent_Done,
     /* 258646 */ // Label 5217: @258646
     /* 258646 */ GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(258766), // Rule ID 12943 //
     /* 258651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 258654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258658 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 258666 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 258669 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 258674 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258678 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258683 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 258685 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 258685 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 258688 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 258692 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258697 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 258701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 258703 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 258706 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258710 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258729 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258732 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 258735 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 258738 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258743 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258748 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 258753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 258756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258764 */   GIR_RootConstrainSelectedInstOperands,
     /* 258765 */   // GIR_Coverage, 12943,
     /* 258765 */   GIR_EraseRootFromParent_Done,
     /* 258766 */ // Label 5218: @258766
     /* 258766 */ GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(258886), // Rule ID 12945 //
     /* 258771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 258774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258778 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 258786 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 258789 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 258794 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258798 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 258805 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 258805 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 258808 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 258812 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258817 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 258821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 258823 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 258826 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258830 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258849 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258852 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 258855 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 258858 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258863 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258868 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 258873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 258876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258884 */   GIR_RootConstrainSelectedInstOperands,
     /* 258885 */   // GIR_Coverage, 12945,
     /* 258885 */   GIR_EraseRootFromParent_Done,
     /* 258886 */ // Label 5219: @258886
     /* 258886 */ GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(259006), // Rule ID 12947 //
     /* 258891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 258894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258898 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 258906 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 258909 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 258914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258918 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 258925 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 258925 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 258928 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 258932 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258937 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 258941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 258943 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 258946 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258950 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258972 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 258975 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 258978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 258993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 258996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259004 */   GIR_RootConstrainSelectedInstOperands,
     /* 259005 */   // GIR_Coverage, 12947,
     /* 259005 */   GIR_EraseRootFromParent_Done,
     /* 259006 */ // Label 5220: @259006
     /* 259006 */ GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(259126), // Rule ID 12951 //
     /* 259011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259018 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259026 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259029 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 259034 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259045 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 259045 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 259048 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 259052 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259057 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259063 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259066 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259070 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 259080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259089 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259092 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 259095 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 259098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 259116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259124 */   GIR_RootConstrainSelectedInstOperands,
     /* 259125 */   // GIR_Coverage, 12951,
     /* 259125 */   GIR_EraseRootFromParent_Done,
     /* 259126 */ // Label 5221: @259126
     /* 259126 */ GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(259246), // Rule ID 12953 //
     /* 259131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259138 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259142 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259146 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259149 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 259154 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259158 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259165 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 259165 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 259168 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 259172 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259177 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259183 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259186 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259190 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 259200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259209 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259212 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 259215 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 259218 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 259236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259244 */   GIR_RootConstrainSelectedInstOperands,
     /* 259245 */   // GIR_Coverage, 12953,
     /* 259245 */   GIR_EraseRootFromParent_Done,
     /* 259246 */ // Label 5222: @259246
     /* 259246 */ GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(259366), // Rule ID 12955 //
     /* 259251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259258 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259266 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259269 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 259274 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259278 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259283 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259285 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 259285 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 259288 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 259292 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259297 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259303 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259306 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259310 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259317 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 259320 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259324 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259329 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259332 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 259335 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 259338 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259343 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 259353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 259356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259364 */   GIR_RootConstrainSelectedInstOperands,
     /* 259365 */   // GIR_Coverage, 12955,
     /* 259365 */   GIR_EraseRootFromParent_Done,
     /* 259366 */ // Label 5223: @259366
     /* 259366 */ GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(259486), // Rule ID 12957 //
     /* 259371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259378 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259386 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259389 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 259394 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259398 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259405 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 259405 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 259408 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 259412 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259417 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259423 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259426 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259430 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 259440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259449 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259452 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 259455 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 259458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 259473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 259476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259484 */   GIR_RootConstrainSelectedInstOperands,
     /* 259485 */   // GIR_Coverage, 12957,
     /* 259485 */   GIR_EraseRootFromParent_Done,
     /* 259486 */ // Label 5224: @259486
     /* 259486 */ GIM_Reject,
     /* 259487 */ // Label 5208: @259487
     /* 259487 */ GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(259709),
     /* 259492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 259495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 259499 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(259553), // Rule ID 5598 //
     /* 259504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 259512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 259516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 259520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 259529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259537 */     // MIs[2] Operand 1
     /* 259537 */     // No operand predicates
     /* 259537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259539 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 259539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 259542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 259548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 259551 */     GIR_RootConstrainSelectedInstOperands,
     /* 259552 */     // GIR_Coverage, 5598,
     /* 259552 */     GIR_EraseRootFromParent_Done,
     /* 259553 */   // Label 5226: @259553
     /* 259553 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(259632), // Rule ID 11117 //
     /* 259558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 259561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 259569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 259573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 259577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 259581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259585 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259589 */     // MIs[2] Operand 1
     /* 259589 */     // No operand predicates
     /* 259589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259591 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 259591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 259594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259603 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 259609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 259622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 259630 */     GIR_RootConstrainSelectedInstOperands,
     /* 259631 */     // GIR_Coverage, 11117,
     /* 259631 */     GIR_EraseRootFromParent_Done,
     /* 259632 */   // Label 5227: @259632
     /* 259632 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(259708), // Rule ID 6420 //
     /* 259637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259641 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 259641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 259644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 259658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 259674 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 259677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 259682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 259687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 259695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 259706 */     GIR_RootConstrainSelectedInstOperands,
     /* 259707 */     // GIR_Coverage, 6420,
     /* 259707 */     GIR_EraseRootFromParent_Done,
     /* 259708 */   // Label 5228: @259708
     /* 259708 */   GIM_Reject,
     /* 259709 */ // Label 5225: @259709
     /* 259709 */ GIM_Reject,
     /* 259710 */ // Label 5209: @259710
     /* 259710 */ GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(259771),
     /* 259715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 259718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259722 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(259749), // Rule ID 6292 //
     /* 259727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 259734 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 259734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 259737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 259744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259747 */     GIR_RootConstrainSelectedInstOperands,
     /* 259748 */     // GIR_Coverage, 6292,
     /* 259748 */     GIR_EraseRootFromParent_Done,
     /* 259749 */   // Label 5230: @259749
     /* 259749 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(259770), // Rule ID 6281 //
     /* 259754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259758 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 259758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 259761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 259765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259768 */     GIR_RootConstrainSelectedInstOperands,
     /* 259769 */     // GIR_Coverage, 6281,
     /* 259769 */     GIR_EraseRootFromParent_Done,
     /* 259770 */   // Label 5231: @259770
     /* 259770 */   GIM_Reject,
     /* 259771 */ // Label 5229: @259771
     /* 259771 */ GIM_Reject,
     /* 259772 */ // Label 5210: @259772
     /* 259772 */ GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(259833),
     /* 259777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 259780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259784 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(259811), // Rule ID 6289 //
     /* 259789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 259796 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 259796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 259799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 259806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259809 */     GIR_RootConstrainSelectedInstOperands,
     /* 259810 */     // GIR_Coverage, 6289,
     /* 259810 */     GIR_EraseRootFromParent_Done,
     /* 259811 */   // Label 5233: @259811
     /* 259811 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(259832), // Rule ID 6278 //
     /* 259816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259820 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 259820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 259823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 259827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259830 */     GIR_RootConstrainSelectedInstOperands,
     /* 259831 */     // GIR_Coverage, 6278,
     /* 259831 */     GIR_EraseRootFromParent_Done,
     /* 259832 */   // Label 5234: @259832
     /* 259832 */   GIM_Reject,
     /* 259833 */ // Label 5232: @259833
     /* 259833 */ GIM_Reject,
     /* 259834 */ // Label 5211: @259834
     /* 259834 */ GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(259895),
     /* 259839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 259842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259846 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(259873), // Rule ID 6286 //
     /* 259851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 259858 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 259858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 259861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 259868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259871 */     GIR_RootConstrainSelectedInstOperands,
     /* 259872 */     // GIR_Coverage, 6286,
     /* 259872 */     GIR_EraseRootFromParent_Done,
     /* 259873 */   // Label 5236: @259873
     /* 259873 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(259894), // Rule ID 6275 //
     /* 259878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259882 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 259882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 259885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 259889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259892 */     GIR_RootConstrainSelectedInstOperands,
     /* 259893 */     // GIR_Coverage, 6275,
     /* 259893 */     GIR_EraseRootFromParent_Done,
     /* 259894 */   // Label 5237: @259894
     /* 259894 */   GIM_Reject,
     /* 259895 */ // Label 5235: @259895
     /* 259895 */ GIM_Reject,
     /* 259896 */ // Label 5212: @259896
     /* 259896 */ GIM_Reject,
     /* 259897 */ // Label 42: @259897
     /* 259897 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5243*/ GIMT_Encode4(261550),
     /* 259908 */ /*GILLT_s32*//*Label 5238*/ GIMT_Encode4(259988),
     /* 259912 */ /*GILLT_s64*//*Label 5239*/ GIMT_Encode4(260482), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 259964 */ /*GILLT_nxv2s64*//*Label 5240*/ GIMT_Encode4(261124), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 259976 */ /*GILLT_nxv4s32*//*Label 5241*/ GIMT_Encode4(261333), GIMT_Encode4(0),
     /* 259984 */ /*GILLT_nxv8s16*//*Label 5242*/ GIMT_Encode4(261477),
     /* 259988 */ // Label 5238: @259988
     /* 259988 */ GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(260481),
     /* 259993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 259996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260000 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(260065), // Rule ID 5593 //
     /* 260005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 260017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 260021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260034 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 260038 */     // MIs[2] Operand 1
     /* 260038 */     // No operand predicates
     /* 260038 */     // MIs[0] Operand 2
     /* 260038 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 260049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260051 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 260051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 260054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 260063 */     GIR_RootConstrainSelectedInstOperands,
     /* 260064 */     // GIR_Coverage, 5593,
     /* 260064 */     GIR_EraseRootFromParent_Done,
     /* 260065 */   // Label 5245: @260065
     /* 260065 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(260130), // Rule ID 5595 //
     /* 260070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 260082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 260086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 260103 */     // MIs[2] Operand 1
     /* 260103 */     // No operand predicates
     /* 260103 */     // MIs[0] Operand 2
     /* 260103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 260114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260116 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 260116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 260119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 260128 */     GIR_RootConstrainSelectedInstOperands,
     /* 260129 */     // GIR_Coverage, 5595,
     /* 260129 */     GIR_EraseRootFromParent_Done,
     /* 260130 */   // Label 5246: @260130
     /* 260130 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(260195), // Rule ID 5597 //
     /* 260135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 260147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 260151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260164 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 260168 */     // MIs[2] Operand 1
     /* 260168 */     // No operand predicates
     /* 260168 */     // MIs[0] Operand 2
     /* 260168 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 260179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260181 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 260181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 260184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 260193 */     GIR_RootConstrainSelectedInstOperands,
     /* 260194 */     // GIR_Coverage, 5597,
     /* 260194 */     GIR_EraseRootFromParent_Done,
     /* 260195 */   // Label 5247: @260195
     /* 260195 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(260285), // Rule ID 11113 //
     /* 260200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 260215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 260219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260227 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 260231 */     // MIs[2] Operand 1
     /* 260231 */     // No operand predicates
     /* 260231 */     // MIs[0] Operand 2
     /* 260231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 260242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260244 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 260244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 260247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260256 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 260262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 260275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 260283 */     GIR_RootConstrainSelectedInstOperands,
     /* 260284 */     // GIR_Coverage, 11113,
     /* 260284 */     GIR_EraseRootFromParent_Done,
     /* 260285 */   // Label 5248: @260285
     /* 260285 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(260375), // Rule ID 11115 //
     /* 260290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 260305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 260309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 260321 */     // MIs[2] Operand 1
     /* 260321 */     // No operand predicates
     /* 260321 */     // MIs[0] Operand 2
     /* 260321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 260332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260334 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 260334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 260337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 260352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 260365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 260373 */     GIR_RootConstrainSelectedInstOperands,
     /* 260374 */     // GIR_Coverage, 11115,
     /* 260374 */     GIR_EraseRootFromParent_Done,
     /* 260375 */   // Label 5249: @260375
     /* 260375 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(260410), // Rule ID 6425 //
     /* 260380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260384 */     // MIs[0] Operand 2
     /* 260384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 260395 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 260395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 260398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 260402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 260408 */     GIR_RootConstrainSelectedInstOperands,
     /* 260409 */     // GIR_Coverage, 6425,
     /* 260409 */     GIR_EraseRootFromParent_Done,
     /* 260410 */   // Label 5250: @260410
     /* 260410 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(260445), // Rule ID 6426 //
     /* 260415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260419 */     // MIs[0] Operand 2
     /* 260419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 260430 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 260430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 260433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260435 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 260437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 260443 */     GIR_RootConstrainSelectedInstOperands,
     /* 260444 */     // GIR_Coverage, 6426,
     /* 260444 */     GIR_EraseRootFromParent_Done,
     /* 260445 */   // Label 5251: @260445
     /* 260445 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(260480), // Rule ID 6427 //
     /* 260450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260454 */     // MIs[0] Operand 2
     /* 260454 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 260465 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 260465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 260468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 260472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260478 */     GIR_RootConstrainSelectedInstOperands,
     /* 260479 */     // GIR_Coverage, 6427,
     /* 260479 */     GIR_EraseRootFromParent_Done,
     /* 260480 */   // Label 5252: @260480
     /* 260480 */   GIM_Reject,
     /* 260481 */ // Label 5244: @260481
     /* 260481 */ GIM_Reject,
     /* 260482 */ // Label 5239: @260482
     /* 260482 */ GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(261123),
     /* 260487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 260490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 260494 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(260571), // Rule ID 5599 //
     /* 260499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 260507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 260511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 260523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 260527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 260536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260540 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 260544 */     // MIs[3] Operand 1
     /* 260544 */     // No operand predicates
     /* 260544 */     // MIs[0] Operand 2
     /* 260544 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 260555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 260557 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 260557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 260560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 260569 */     GIR_RootConstrainSelectedInstOperands,
     /* 260570 */     // GIR_Coverage, 5599,
     /* 260570 */     GIR_EraseRootFromParent_Done,
     /* 260571 */   // Label 5254: @260571
     /* 260571 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(260648), // Rule ID 5600 //
     /* 260576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 260584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 260588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 260600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 260604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 260613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260617 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 260621 */     // MIs[3] Operand 1
     /* 260621 */     // No operand predicates
     /* 260621 */     // MIs[0] Operand 2
     /* 260621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 260632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 260634 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 260634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 260637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 260646 */     GIR_RootConstrainSelectedInstOperands,
     /* 260647 */     // GIR_Coverage, 5600,
     /* 260647 */     GIR_EraseRootFromParent_Done,
     /* 260648 */   // Label 5255: @260648
     /* 260648 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(260750), // Rule ID 11114 //
     /* 260653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 260664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 260668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 260680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 260684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 260688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260692 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 260696 */     // MIs[3] Operand 1
     /* 260696 */     // No operand predicates
     /* 260696 */     // MIs[0] Operand 2
     /* 260696 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 260707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 260709 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 260709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 260712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260721 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 260727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 260740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 260748 */     GIR_RootConstrainSelectedInstOperands,
     /* 260749 */     // GIR_Coverage, 11114,
     /* 260749 */     GIR_EraseRootFromParent_Done,
     /* 260750 */   // Label 5256: @260750
     /* 260750 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(260852), // Rule ID 11116 //
     /* 260755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 260766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 260770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 260782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 260786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 260790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260794 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 260798 */     // MIs[3] Operand 1
     /* 260798 */     // No operand predicates
     /* 260798 */     // MIs[0] Operand 2
     /* 260798 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 260809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 260811 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 260811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 260814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260823 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 260829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 260842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 260850 */     GIR_RootConstrainSelectedInstOperands,
     /* 260851 */     // GIR_Coverage, 11116,
     /* 260851 */     GIR_EraseRootFromParent_Done,
     /* 260852 */   // Label 5257: @260852
     /* 260852 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(260917), // Rule ID 5594 //
     /* 260857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 260869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 260873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260886 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 260890 */     // MIs[2] Operand 1
     /* 260890 */     // No operand predicates
     /* 260890 */     // MIs[0] Operand 2
     /* 260890 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 260901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260903 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 260903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 260906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 260915 */     GIR_RootConstrainSelectedInstOperands,
     /* 260916 */     // GIR_Coverage, 5594,
     /* 260916 */     GIR_EraseRootFromParent_Done,
     /* 260917 */   // Label 5258: @260917
     /* 260917 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(260982), // Rule ID 5596 //
     /* 260922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 260930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 260934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 260938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 260955 */     // MIs[2] Operand 1
     /* 260955 */     // No operand predicates
     /* 260955 */     // MIs[0] Operand 2
     /* 260955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 260966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260968 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 260968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 260971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 260980 */     GIR_RootConstrainSelectedInstOperands,
     /* 260981 */     // GIR_Coverage, 5596,
     /* 260981 */     GIR_EraseRootFromParent_Done,
     /* 260982 */   // Label 5259: @260982
     /* 260982 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(261017), // Rule ID 6421 //
     /* 260987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 260991 */     // MIs[0] Operand 2
     /* 260991 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 261002 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 261002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 261005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 261009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 261015 */     GIR_RootConstrainSelectedInstOperands,
     /* 261016 */     // GIR_Coverage, 6421,
     /* 261016 */     GIR_EraseRootFromParent_Done,
     /* 261017 */   // Label 5260: @261017
     /* 261017 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(261052), // Rule ID 6422 //
     /* 261022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 261026 */     // MIs[0] Operand 2
     /* 261026 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 261037 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 261037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 261040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261042 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 261044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 261050 */     GIR_RootConstrainSelectedInstOperands,
     /* 261051 */     // GIR_Coverage, 6422,
     /* 261051 */     GIR_EraseRootFromParent_Done,
     /* 261052 */   // Label 5261: @261052
     /* 261052 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(261087), // Rule ID 6423 //
     /* 261057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 261061 */     // MIs[0] Operand 2
     /* 261061 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 261072 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 261072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 261075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 261079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 261085 */     GIR_RootConstrainSelectedInstOperands,
     /* 261086 */     // GIR_Coverage, 6423,
     /* 261086 */     GIR_EraseRootFromParent_Done,
     /* 261087 */   // Label 5262: @261087
     /* 261087 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(261122), // Rule ID 6424 //
     /* 261092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 261096 */     // MIs[0] Operand 2
     /* 261096 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 261107 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 261107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 261110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 261114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261120 */     GIR_RootConstrainSelectedInstOperands,
     /* 261121 */     // GIR_Coverage, 6424,
     /* 261121 */     GIR_EraseRootFromParent_Done,
     /* 261122 */   // Label 5263: @261122
     /* 261122 */   GIM_Reject,
     /* 261123 */ // Label 5253: @261123
     /* 261123 */ GIM_Reject,
     /* 261124 */ // Label 5240: @261124
     /* 261124 */ GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(261332),
     /* 261129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 261132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261136 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(261201), // Rule ID 10397 //
     /* 261141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261144 */     // MIs[0] Operand 2
     /* 261144 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 261155 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 261155 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 261158 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 261162 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261167 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 261170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 261172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 261175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 261189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 261197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 261199 */     GIR_RootConstrainSelectedInstOperands,
     /* 261200 */     // GIR_Coverage, 10397,
     /* 261200 */     GIR_EraseRootFromParent_Done,
     /* 261201 */   // Label 5265: @261201
     /* 261201 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(261266), // Rule ID 10398 //
     /* 261206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261209 */     // MIs[0] Operand 2
     /* 261209 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 261220 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 261220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 261223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 261227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261232 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 261235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 261237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 261240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 261254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 261262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 261264 */     GIR_RootConstrainSelectedInstOperands,
     /* 261265 */     // GIR_Coverage, 10398,
     /* 261265 */     GIR_EraseRootFromParent_Done,
     /* 261266 */   // Label 5266: @261266
     /* 261266 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(261331), // Rule ID 10399 //
     /* 261271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261274 */     // MIs[0] Operand 2
     /* 261274 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 261285 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 261285 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 261288 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 261292 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261297 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 261300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 261302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 261305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 261319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 261327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 261329 */     GIR_RootConstrainSelectedInstOperands,
     /* 261330 */     // GIR_Coverage, 10399,
     /* 261330 */     GIR_EraseRootFromParent_Done,
     /* 261331 */   // Label 5267: @261331
     /* 261331 */   GIM_Reject,
     /* 261332 */ // Label 5264: @261332
     /* 261332 */ GIM_Reject,
     /* 261333 */ // Label 5241: @261333
     /* 261333 */ GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(261476),
     /* 261338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 261341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261345 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(261410), // Rule ID 10400 //
     /* 261350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261353 */     // MIs[0] Operand 2
     /* 261353 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 261364 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 261364 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 261367 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 261371 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261376 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 261379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 261381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 261384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 261398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 261406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 261408 */     GIR_RootConstrainSelectedInstOperands,
     /* 261409 */     // GIR_Coverage, 10400,
     /* 261409 */     GIR_EraseRootFromParent_Done,
     /* 261410 */   // Label 5269: @261410
     /* 261410 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(261475), // Rule ID 10401 //
     /* 261415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261418 */     // MIs[0] Operand 2
     /* 261418 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 261429 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 261429 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 261432 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 261436 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261441 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 261444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 261446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 261449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 261463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 261471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 261473 */     GIR_RootConstrainSelectedInstOperands,
     /* 261474 */     // GIR_Coverage, 10401,
     /* 261474 */     GIR_EraseRootFromParent_Done,
     /* 261475 */   // Label 5270: @261475
     /* 261475 */   GIM_Reject,
     /* 261476 */ // Label 5268: @261476
     /* 261476 */ GIM_Reject,
     /* 261477 */ // Label 5242: @261477
     /* 261477 */ GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(261549), // Rule ID 10402 //
     /* 261482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 261488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261492 */   // MIs[0] Operand 2
     /* 261492 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 261503 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 261503 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 261506 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 261510 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261515 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 261518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 261520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 261523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 261537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 261545 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 261547 */   GIR_RootConstrainSelectedInstOperands,
     /* 261548 */   // GIR_Coverage, 10402,
     /* 261548 */   GIR_EraseRootFromParent_Done,
     /* 261549 */ // Label 5271: @261549
     /* 261549 */ GIM_Reject,
     /* 261550 */ // Label 5243: @261550
     /* 261550 */ GIM_Reject,
     /* 261551 */ // Label 43: @261551
     /* 261551 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5276*/ GIMT_Encode4(264329),
     /* 261562 */ /*GILLT_s32*//*Label 5272*/ GIMT_Encode4(261598), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261578 */ /*GILLT_v2s64*//*Label 5273*/ GIMT_Encode4(263399), GIMT_Encode4(0),
     /* 261586 */ /*GILLT_v4s32*//*Label 5274*/ GIMT_Encode4(263709), GIMT_Encode4(0),
     /* 261594 */ /*GILLT_v8s16*//*Label 5275*/ GIMT_Encode4(264019),
     /* 261598 */ // Label 5272: @261598
     /* 261598 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(261748), // Rule ID 12928 //
     /* 261603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 261606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261610 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261618 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261621 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 261626 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261630 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261637 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 261637 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 261640 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 261644 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261649 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 261655 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 261658 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261662 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 261669 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 261672 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 261676 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261681 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 261684 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 261687 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 261690 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261695 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261700 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 261705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 261708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261717 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 261724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 261729 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261747 */   // GIR_Coverage, 12928,
     /* 261747 */   GIR_EraseRootFromParent_Done,
     /* 261748 */ // Label 5277: @261748
     /* 261748 */ GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(261898), // Rule ID 12930 //
     /* 261753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 261756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261760 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261768 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261771 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 261776 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 261780 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261787 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 261787 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 261790 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 261794 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261799 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 261805 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 261808 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261812 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 261819 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 261822 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 261826 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261831 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 261834 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 261837 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 261840 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261845 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261850 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 261855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 261858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261867 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 261874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 261879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261892 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261897 */   // GIR_Coverage, 12930,
     /* 261897 */   GIR_EraseRootFromParent_Done,
     /* 261898 */ // Label 5278: @261898
     /* 261898 */ GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(262048), // Rule ID 12932 //
     /* 261903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 261906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261910 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261918 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261921 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 261926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261937 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 261937 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 261940 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 261944 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261949 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 261955 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 261958 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261962 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 261969 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 261972 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 261976 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261981 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 261984 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 261987 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 261990 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261995 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262000 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262017 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262024 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262029 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262047 */   // GIR_Coverage, 12932,
     /* 262047 */   GIR_EraseRootFromParent_Done,
     /* 262048 */ // Label 5279: @262048
     /* 262048 */ GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(262198), // Rule ID 12934 //
     /* 262053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262060 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262064 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262068 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262071 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 262076 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262080 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262085 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262087 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 262087 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 262090 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 262094 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262099 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 262105 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 262108 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262112 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262119 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262122 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262126 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262131 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 262134 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 262137 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 262140 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262145 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262150 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262167 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262174 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262179 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262197 */   // GIR_Coverage, 12934,
     /* 262197 */   GIR_EraseRootFromParent_Done,
     /* 262198 */ // Label 5280: @262198
     /* 262198 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(262348), // Rule ID 12961 //
     /* 262203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262210 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262214 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262218 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262221 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 262226 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262230 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262237 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 262237 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 262240 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 262244 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262249 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 262255 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 262258 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262262 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262269 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262272 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262276 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262281 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 262284 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 262287 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 262290 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262295 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262300 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262317 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262347 */   // GIR_Coverage, 12961,
     /* 262347 */   GIR_EraseRootFromParent_Done,
     /* 262348 */ // Label 5281: @262348
     /* 262348 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(262498), // Rule ID 12963 //
     /* 262353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262360 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262368 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262371 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 262376 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 262380 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262387 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 262387 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 262390 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 262394 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262399 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 262405 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 262408 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262412 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262419 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262422 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262426 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262431 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 262434 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 262437 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 262440 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262445 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262450 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262467 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262479 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262497 */   // GIR_Coverage, 12963,
     /* 262497 */   GIR_EraseRootFromParent_Done,
     /* 262498 */ // Label 5282: @262498
     /* 262498 */ GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(262648), // Rule ID 12965 //
     /* 262503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262510 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262518 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262521 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 262526 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262530 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262537 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 262537 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 262540 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 262544 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262549 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 262555 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 262558 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262562 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262569 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262572 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262576 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262581 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 262584 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 262587 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 262590 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262595 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262600 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262617 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262624 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262629 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262647 */   // GIR_Coverage, 12965,
     /* 262647 */   GIR_EraseRootFromParent_Done,
     /* 262648 */ // Label 5283: @262648
     /* 262648 */ GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(262798), // Rule ID 12967 //
     /* 262653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262660 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262668 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262671 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 262676 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262680 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262687 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 262687 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 262690 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 262694 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262699 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 262705 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 262708 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262712 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262719 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262722 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262726 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262731 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 262734 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 262737 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 262740 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262745 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262750 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262767 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262797 */   // GIR_Coverage, 12967,
     /* 262797 */   GIR_EraseRootFromParent_Done,
     /* 262798 */ // Label 5284: @262798
     /* 262798 */ GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(262948), // Rule ID 12971 //
     /* 262803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262810 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262818 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262821 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 262826 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262830 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262835 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262837 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 262837 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 262840 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 262844 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262849 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 262855 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 262858 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262862 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262869 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262872 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262876 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262881 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 262884 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 262887 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 262890 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262895 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262900 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262917 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262924 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262929 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262947 */   // GIR_Coverage, 12971,
     /* 262947 */   GIR_EraseRootFromParent_Done,
     /* 262948 */ // Label 5285: @262948
     /* 262948 */ GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(263098), // Rule ID 12973 //
     /* 262953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262960 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262968 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262971 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 262976 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 262980 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262987 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 262987 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 262990 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 262994 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262999 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 263005 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 263008 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263012 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263019 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263022 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263026 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263031 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 263034 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 263037 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 263040 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263045 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263050 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263055 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 263058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263062 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263067 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 263074 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263079 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263092 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263097 */   // GIR_Coverage, 12973,
     /* 263097 */   GIR_EraseRootFromParent_Done,
     /* 263098 */ // Label 5286: @263098
     /* 263098 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(263248), // Rule ID 12975 //
     /* 263103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263110 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263118 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263121 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 263126 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263130 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263137 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 263137 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 263140 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 263144 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263149 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 263155 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 263158 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263162 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263169 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263172 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263176 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263181 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 263184 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 263187 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 263190 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263195 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263200 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 263208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263217 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 263224 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263229 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263242 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263247 */   // GIR_Coverage, 12975,
     /* 263247 */   GIR_EraseRootFromParent_Done,
     /* 263248 */ // Label 5287: @263248
     /* 263248 */ GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(263398), // Rule ID 12977 //
     /* 263253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263260 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263268 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263271 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 263276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263280 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263287 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 263287 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 263290 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 263294 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263299 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 263305 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 263308 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263312 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263331 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 263334 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 263337 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 263340 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263345 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263350 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 263358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263367 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 263374 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263397 */   // GIR_Coverage, 12977,
     /* 263397 */   GIR_EraseRootFromParent_Done,
     /* 263398 */ // Label 5288: @263398
     /* 263398 */ GIM_Reject,
     /* 263399 */ // Label 5273: @263399
     /* 263399 */ GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(263708),
     /* 263404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 263407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263411 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(263476), // Rule ID 702 //
     /* 263416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263427 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 263430 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 263435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 263439 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 263443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 263452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 263459 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 263459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 263462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 263474 */     GIR_RootConstrainSelectedInstOperands,
     /* 263475 */     // GIR_Coverage, 702,
     /* 263475 */     GIR_EraseRootFromParent_Done,
     /* 263476 */   // Label 5290: @263476
     /* 263476 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(263541), // Rule ID 1704 //
     /* 263481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263492 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 263495 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 263500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 263504 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 263508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 263517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 263524 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 263524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 263527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 263539 */     GIR_RootConstrainSelectedInstOperands,
     /* 263540 */     // GIR_Coverage, 1704,
     /* 263540 */     GIR_EraseRootFromParent_Done,
     /* 263541 */   // Label 5291: @263541
     /* 263541 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(263600), // Rule ID 700 //
     /* 263546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263557 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 263560 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 263565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 263569 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 263573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263585 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 263585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 263588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 263598 */     GIR_RootConstrainSelectedInstOperands,
     /* 263599 */     // GIR_Coverage, 700,
     /* 263599 */     GIR_EraseRootFromParent_Done,
     /* 263600 */   // Label 5292: @263600
     /* 263600 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(263659), // Rule ID 1702 //
     /* 263605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263616 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 263619 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 263624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 263628 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 263632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263644 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 263644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 263647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 263657 */     GIR_RootConstrainSelectedInstOperands,
     /* 263658 */     // GIR_Coverage, 1702,
     /* 263658 */     GIR_EraseRootFromParent_Done,
     /* 263659 */   // Label 5293: @263659
     /* 263659 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(263686), // Rule ID 6291 //
     /* 263664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 263671 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 263671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 263674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263684 */     GIR_RootConstrainSelectedInstOperands,
     /* 263685 */     // GIR_Coverage, 6291,
     /* 263685 */     GIR_EraseRootFromParent_Done,
     /* 263686 */   // Label 5294: @263686
     /* 263686 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(263707), // Rule ID 6282 //
     /* 263691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263695 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 263695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 263698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263705 */     GIR_RootConstrainSelectedInstOperands,
     /* 263706 */     // GIR_Coverage, 6282,
     /* 263706 */     GIR_EraseRootFromParent_Done,
     /* 263707 */   // Label 5295: @263707
     /* 263707 */   GIM_Reject,
     /* 263708 */ // Label 5289: @263708
     /* 263708 */ GIM_Reject,
     /* 263709 */ // Label 5274: @263709
     /* 263709 */ GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264018),
     /* 263714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 263717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263721 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(263786), // Rule ID 698 //
     /* 263726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263737 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 263740 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 263745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263749 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 263762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 263769 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 263769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 263772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 263784 */     GIR_RootConstrainSelectedInstOperands,
     /* 263785 */     // GIR_Coverage, 698,
     /* 263785 */     GIR_EraseRootFromParent_Done,
     /* 263786 */   // Label 5297: @263786
     /* 263786 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(263851), // Rule ID 1700 //
     /* 263791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263802 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 263805 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 263810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263814 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 263827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 263834 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 263834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 263837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 263849 */     GIR_RootConstrainSelectedInstOperands,
     /* 263850 */     // GIR_Coverage, 1700,
     /* 263850 */     GIR_EraseRootFromParent_Done,
     /* 263851 */   // Label 5298: @263851
     /* 263851 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(263910), // Rule ID 696 //
     /* 263856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263867 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 263870 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 263875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263895 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 263895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 263898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 263908 */     GIR_RootConstrainSelectedInstOperands,
     /* 263909 */     // GIR_Coverage, 696,
     /* 263909 */     GIR_EraseRootFromParent_Done,
     /* 263910 */   // Label 5299: @263910
     /* 263910 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(263969), // Rule ID 1698 //
     /* 263915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263926 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 263929 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 263934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263938 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263954 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 263954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 263957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 263967 */     GIR_RootConstrainSelectedInstOperands,
     /* 263968 */     // GIR_Coverage, 1698,
     /* 263968 */     GIR_EraseRootFromParent_Done,
     /* 263969 */   // Label 5300: @263969
     /* 263969 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(263996), // Rule ID 6288 //
     /* 263974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 263981 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 263981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 263984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263994 */     GIR_RootConstrainSelectedInstOperands,
     /* 263995 */     // GIR_Coverage, 6288,
     /* 263995 */     GIR_EraseRootFromParent_Done,
     /* 263996 */   // Label 5301: @263996
     /* 263996 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(264017), // Rule ID 6279 //
     /* 264001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264005 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 264005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 264008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264015 */     GIR_RootConstrainSelectedInstOperands,
     /* 264016 */     // GIR_Coverage, 6279,
     /* 264016 */     GIR_EraseRootFromParent_Done,
     /* 264017 */   // Label 5302: @264017
     /* 264017 */   GIM_Reject,
     /* 264018 */ // Label 5296: @264018
     /* 264018 */ GIM_Reject,
     /* 264019 */ // Label 5275: @264019
     /* 264019 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(264328),
     /* 264024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 264027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264031 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(264096), // Rule ID 694 //
     /* 264036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264047 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 264050 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 264055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 264059 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 264063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 264072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 264079 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 264079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 264082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 264094 */     GIR_RootConstrainSelectedInstOperands,
     /* 264095 */     // GIR_Coverage, 694,
     /* 264095 */     GIR_EraseRootFromParent_Done,
     /* 264096 */   // Label 5304: @264096
     /* 264096 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(264161), // Rule ID 1696 //
     /* 264101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 264115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 264120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 264124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 264128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 264137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 264144 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 264144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 264147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 264159 */     GIR_RootConstrainSelectedInstOperands,
     /* 264160 */     // GIR_Coverage, 1696,
     /* 264160 */     GIR_EraseRootFromParent_Done,
     /* 264161 */   // Label 5305: @264161
     /* 264161 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(264220), // Rule ID 692 //
     /* 264166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264177 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 264180 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 264185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 264189 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 264193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264205 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 264205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 264208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 264218 */     GIR_RootConstrainSelectedInstOperands,
     /* 264219 */     // GIR_Coverage, 692,
     /* 264219 */     GIR_EraseRootFromParent_Done,
     /* 264220 */   // Label 5306: @264220
     /* 264220 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(264279), // Rule ID 1694 //
     /* 264225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264236 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 264239 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 264244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 264248 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 264252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264264 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 264264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 264267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 264277 */     GIR_RootConstrainSelectedInstOperands,
     /* 264278 */     // GIR_Coverage, 1694,
     /* 264278 */     GIR_EraseRootFromParent_Done,
     /* 264279 */   // Label 5307: @264279
     /* 264279 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(264306), // Rule ID 6285 //
     /* 264284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 264291 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 264291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 264294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264304 */     GIR_RootConstrainSelectedInstOperands,
     /* 264305 */     // GIR_Coverage, 6285,
     /* 264305 */     GIR_EraseRootFromParent_Done,
     /* 264306 */   // Label 5308: @264306
     /* 264306 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(264327), // Rule ID 6276 //
     /* 264311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264315 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 264315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 264318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264325 */     GIR_RootConstrainSelectedInstOperands,
     /* 264326 */     // GIR_Coverage, 6276,
     /* 264326 */     GIR_EraseRootFromParent_Done,
     /* 264327 */   // Label 5309: @264327
     /* 264327 */   GIM_Reject,
     /* 264328 */ // Label 5303: @264328
     /* 264328 */ GIM_Reject,
     /* 264329 */ // Label 5276: @264329
     /* 264329 */ GIM_Reject,
     /* 264330 */ // Label 44: @264330
     /* 264330 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5315*/ GIMT_Encode4(265109),
     /* 264341 */ /*GILLT_s32*//*Label 5310*/ GIMT_Encode4(264377),
     /* 264345 */ /*GILLT_s64*//*Label 5311*/ GIMT_Encode4(264509), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 264357 */ /*GILLT_v2s64*//*Label 5312*/ GIMT_Encode4(264682), GIMT_Encode4(0),
     /* 264365 */ /*GILLT_v4s32*//*Label 5313*/ GIMT_Encode4(264827), GIMT_Encode4(0),
     /* 264373 */ /*GILLT_v8s16*//*Label 5314*/ GIMT_Encode4(264968),
     /* 264377 */ // Label 5310: @264377
     /* 264377 */ GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(264508),
     /* 264382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264396 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(264433), // Rule ID 3888 //
     /* 264401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 264409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264420 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 264423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264431 */     GIR_RootConstrainSelectedInstOperands,
     /* 264432 */     // GIR_Coverage, 3888,
     /* 264432 */     GIR_EraseRootFromParent_Done,
     /* 264433 */   // Label 5317: @264433
     /* 264433 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(264470), // Rule ID 3889 //
     /* 264438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264457 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 264460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264468 */     GIR_RootConstrainSelectedInstOperands,
     /* 264469 */     // GIR_Coverage, 3889,
     /* 264469 */     GIR_EraseRootFromParent_Done,
     /* 264470 */   // Label 5318: @264470
     /* 264470 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(264507), // Rule ID 3887 //
     /* 264475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264494 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 264497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264505 */     GIR_RootConstrainSelectedInstOperands,
     /* 264506 */     // GIR_Coverage, 3887,
     /* 264506 */     GIR_EraseRootFromParent_Done,
     /* 264507 */   // Label 5319: @264507
     /* 264507 */   GIM_Reject,
     /* 264508 */ // Label 5316: @264508
     /* 264508 */ GIM_Reject,
     /* 264509 */ // Label 5311: @264509
     /* 264509 */ GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(264681),
     /* 264514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264528 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(264596), // Rule ID 3890 //
     /* 264533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264552 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264564 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 264587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264594 */     GIR_RootConstrainSelectedInstOperands,
     /* 264595 */     // GIR_Coverage, 3890,
     /* 264595 */     GIR_EraseRootFromParent_Done,
     /* 264596 */   // Label 5321: @264596
     /* 264596 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(264664), // Rule ID 3891 //
     /* 264601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264620 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264632 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 264655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264662 */     GIR_RootConstrainSelectedInstOperands,
     /* 264663 */     // GIR_Coverage, 3891,
     /* 264663 */     GIR_EraseRootFromParent_Done,
     /* 264664 */   // Label 5322: @264664
     /* 264664 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(264680), // Rule ID 120 //
     /* 264669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264673 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 264673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 264678 */     GIR_RootConstrainSelectedInstOperands,
     /* 264679 */     // GIR_Coverage, 120,
     /* 264679 */     GIR_Done,
     /* 264680 */   // Label 5323: @264680
     /* 264680 */   GIM_Reject,
     /* 264681 */ // Label 5320: @264681
     /* 264681 */ GIM_Reject,
     /* 264682 */ // Label 5312: @264682
     /* 264682 */ GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(264826),
     /* 264687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 264690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 264693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264697 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(264761), // Rule ID 6274 //
     /* 264702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 264723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 264727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 264731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 264735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264739 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 264743 */     // MIs[3] Operand 1
     /* 264743 */     // No operand predicates
     /* 264743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264745 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 264745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 264748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264754 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 264759 */     GIR_RootConstrainSelectedInstOperands,
     /* 264760 */     // GIR_Coverage, 6274,
     /* 264760 */     GIR_EraseRootFromParent_Done,
     /* 264761 */   // Label 5325: @264761
     /* 264761 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(264825), // Rule ID 6271 //
     /* 264766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 264787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 264791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 264795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 264799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264803 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 264807 */     // MIs[3] Operand 1
     /* 264807 */     // No operand predicates
     /* 264807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264809 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 264809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 264812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264818 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 264823 */     GIR_RootConstrainSelectedInstOperands,
     /* 264824 */     // GIR_Coverage, 6271,
     /* 264824 */     GIR_EraseRootFromParent_Done,
     /* 264825 */   // Label 5326: @264825
     /* 264825 */   GIM_Reject,
     /* 264826 */ // Label 5324: @264826
     /* 264826 */ GIM_Reject,
     /* 264827 */ // Label 5313: @264827
     /* 264827 */ GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(264967),
     /* 264832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 264838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264842 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(264904), // Rule ID 6273 //
     /* 264847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 264868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 264872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 264876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 264880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264884 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 264888 */     // MIs[3] Operand 1
     /* 264888 */     // No operand predicates
     /* 264888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264890 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 264890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 264893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 264902 */     GIR_RootConstrainSelectedInstOperands,
     /* 264903 */     // GIR_Coverage, 6273,
     /* 264903 */     GIR_EraseRootFromParent_Done,
     /* 264904 */   // Label 5328: @264904
     /* 264904 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(264966), // Rule ID 6270 //
     /* 264909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 264930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 264934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 264938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 264942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264946 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 264950 */     // MIs[3] Operand 1
     /* 264950 */     // No operand predicates
     /* 264950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264952 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 264952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 264955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 264964 */     GIR_RootConstrainSelectedInstOperands,
     /* 264965 */     // GIR_Coverage, 6270,
     /* 264965 */     GIR_EraseRootFromParent_Done,
     /* 264966 */   // Label 5329: @264966
     /* 264966 */   GIM_Reject,
     /* 264967 */ // Label 5327: @264967
     /* 264967 */ GIM_Reject,
     /* 264968 */ // Label 5314: @264968
     /* 264968 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(265108),
     /* 264973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264983 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(265045), // Rule ID 6272 //
     /* 264988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 265000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 265009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 265013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 265017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 265021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 265029 */     // MIs[3] Operand 1
     /* 265029 */     // No operand predicates
     /* 265029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265031 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 265031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 265034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 265043 */     GIR_RootConstrainSelectedInstOperands,
     /* 265044 */     // GIR_Coverage, 6272,
     /* 265044 */     GIR_EraseRootFromParent_Done,
     /* 265045 */   // Label 5331: @265045
     /* 265045 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(265107), // Rule ID 6269 //
     /* 265050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 265058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 265062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 265071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 265075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 265079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 265083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265087 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 265091 */     // MIs[3] Operand 1
     /* 265091 */     // No operand predicates
     /* 265091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265093 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 265093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 265096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 265105 */     GIR_RootConstrainSelectedInstOperands,
     /* 265106 */     // GIR_Coverage, 6269,
     /* 265106 */     GIR_EraseRootFromParent_Done,
     /* 265107 */   // Label 5332: @265107
     /* 265107 */   GIM_Reject,
     /* 265108 */ // Label 5330: @265108
     /* 265108 */ GIM_Reject,
     /* 265109 */ // Label 5315: @265109
     /* 265109 */ GIM_Reject,
     /* 265110 */ // Label 45: @265110
     /* 265110 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5335*/ GIMT_Encode4(265502),
     /* 265121 */ /*GILLT_s32*//*Label 5333*/ GIMT_Encode4(265129),
     /* 265125 */ /*GILLT_s64*//*Label 5334*/ GIMT_Encode4(265295),
     /* 265129 */ // Label 5333: @265129
     /* 265129 */ GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(265294),
     /* 265134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265148 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(265182), // Rule ID 3977 //
     /* 265153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 265165 */     // MIs[1] Operand 1
     /* 265165 */     // No operand predicates
     /* 265165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265167 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 265167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 265170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 265177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 265180 */     GIR_RootConstrainSelectedInstOperands,
     /* 265181 */     // GIR_Coverage, 3977,
     /* 265181 */     GIR_EraseRootFromParent_Done,
     /* 265182 */   // Label 5337: @265182
     /* 265182 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(265219), // Rule ID 3894 //
     /* 265187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265206 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 265206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 265209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265217 */     GIR_RootConstrainSelectedInstOperands,
     /* 265218 */     // GIR_Coverage, 3894,
     /* 265218 */     GIR_EraseRootFromParent_Done,
     /* 265219 */   // Label 5338: @265219
     /* 265219 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(265256), // Rule ID 3895 //
     /* 265224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 265232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265243 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 265243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 265246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265254 */     GIR_RootConstrainSelectedInstOperands,
     /* 265255 */     // GIR_Coverage, 3895,
     /* 265255 */     GIR_EraseRootFromParent_Done,
     /* 265256 */   // Label 5339: @265256
     /* 265256 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(265293), // Rule ID 3893 //
     /* 265261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 265269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265280 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 265280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 265283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265291 */     GIR_RootConstrainSelectedInstOperands,
     /* 265292 */     // GIR_Coverage, 3893,
     /* 265292 */     GIR_EraseRootFromParent_Done,
     /* 265293 */   // Label 5340: @265293
     /* 265293 */   GIM_Reject,
     /* 265294 */ // Label 5336: @265294
     /* 265294 */ GIM_Reject,
     /* 265295 */ // Label 5334: @265295
     /* 265295 */ GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(265501),
     /* 265300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 265303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265314 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(265348), // Rule ID 3978 //
     /* 265319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 265331 */     // MIs[1] Operand 1
     /* 265331 */     // No operand predicates
     /* 265331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265333 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 265333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 265336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 265343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 265346 */     GIR_RootConstrainSelectedInstOperands,
     /* 265347 */     // GIR_Coverage, 3978,
     /* 265347 */     GIR_EraseRootFromParent_Done,
     /* 265348 */   // Label 5342: @265348
     /* 265348 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(265416), // Rule ID 3896 //
     /* 265353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 265361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265372 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 265372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 265375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 265387 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265391 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 265394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 265407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265414 */     GIR_RootConstrainSelectedInstOperands,
     /* 265415 */     // GIR_Coverage, 3896,
     /* 265415 */     GIR_EraseRootFromParent_Done,
     /* 265416 */   // Label 5343: @265416
     /* 265416 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(265484), // Rule ID 3897 //
     /* 265421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 265429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265440 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 265440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 265443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 265455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 265462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 265475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265482 */     GIR_RootConstrainSelectedInstOperands,
     /* 265483 */     // GIR_Coverage, 3897,
     /* 265483 */     GIR_EraseRootFromParent_Done,
     /* 265484 */   // Label 5344: @265484
     /* 265484 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(265500), // Rule ID 121 //
     /* 265489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265493 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 265493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 265498 */     GIR_RootConstrainSelectedInstOperands,
     /* 265499 */     // GIR_Coverage, 121,
     /* 265499 */     GIR_Done,
     /* 265500 */   // Label 5345: @265500
     /* 265500 */   GIM_Reject,
     /* 265501 */ // Label 5341: @265501
     /* 265501 */ GIM_Reject,
     /* 265502 */ // Label 5335: @265502
     /* 265502 */ GIM_Reject,
     /* 265503 */ // Label 46: @265503
     /* 265503 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5348*/ GIMT_Encode4(266278),
     /* 265514 */ /*GILLT_s32*//*Label 5346*/ GIMT_Encode4(265522),
     /* 265518 */ /*GILLT_s64*//*Label 5347*/ GIMT_Encode4(265828),
     /* 265522 */ // Label 5346: @265522
     /* 265522 */ GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(265827),
     /* 265527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265537 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(265601), // Rule ID 6434 //
     /* 265542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 265550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265559 */     // MIs[1] Operand 2
     /* 265559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 265570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 265574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265578 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 265582 */     // MIs[2] Operand 1
     /* 265582 */     // No operand predicates
     /* 265582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265584 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 265584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 265596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265599 */     GIR_RootConstrainSelectedInstOperands,
     /* 265600 */     // GIR_Coverage, 6434,
     /* 265600 */     GIR_EraseRootFromParent_Done,
     /* 265601 */   // Label 5350: @265601
     /* 265601 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(265665), // Rule ID 6436 //
     /* 265606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 265614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265623 */     // MIs[1] Operand 2
     /* 265623 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 265634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 265638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 265646 */     // MIs[2] Operand 1
     /* 265646 */     // No operand predicates
     /* 265646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265648 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 265648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 265660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265663 */     GIR_RootConstrainSelectedInstOperands,
     /* 265664 */     // GIR_Coverage, 6436,
     /* 265664 */     GIR_EraseRootFromParent_Done,
     /* 265665 */   // Label 5351: @265665
     /* 265665 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(265703), // Rule ID 3975 //
     /* 265670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 265686 */     // MIs[1] Operand 1
     /* 265686 */     // No operand predicates
     /* 265686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265688 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 265688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 265698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 265701 */     GIR_RootConstrainSelectedInstOperands,
     /* 265702 */     // GIR_Coverage, 3975,
     /* 265702 */     GIR_EraseRootFromParent_Done,
     /* 265703 */   // Label 5352: @265703
     /* 265703 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(265744), // Rule ID 2426 //
     /* 265708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265731 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 265731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 265734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265742 */     GIR_RootConstrainSelectedInstOperands,
     /* 265743 */     // GIR_Coverage, 2426,
     /* 265743 */     GIR_EraseRootFromParent_Done,
     /* 265744 */   // Label 5353: @265744
     /* 265744 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(265785), // Rule ID 2427 //
     /* 265749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 265761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265772 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 265772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 265775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265783 */     GIR_RootConstrainSelectedInstOperands,
     /* 265784 */     // GIR_Coverage, 2427,
     /* 265784 */     GIR_EraseRootFromParent_Done,
     /* 265785 */   // Label 5354: @265785
     /* 265785 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(265826), // Rule ID 2425 //
     /* 265790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 265802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265813 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 265813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 265816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 265824 */     GIR_RootConstrainSelectedInstOperands,
     /* 265825 */     // GIR_Coverage, 2425,
     /* 265825 */     GIR_EraseRootFromParent_Done,
     /* 265826 */   // Label 5355: @265826
     /* 265826 */   GIM_Reject,
     /* 265827 */ // Label 5349: @265827
     /* 265827 */ GIM_Reject,
     /* 265828 */ // Label 5347: @265828
     /* 265828 */ GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(266277),
     /* 265833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 265836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265843 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(265907), // Rule ID 6435 //
     /* 265848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 265856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 265860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265865 */     // MIs[1] Operand 2
     /* 265865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 265876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 265880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 265888 */     // MIs[2] Operand 1
     /* 265888 */     // No operand predicates
     /* 265888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265890 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 265890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 265902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265905 */     GIR_RootConstrainSelectedInstOperands,
     /* 265906 */     // GIR_Coverage, 6435,
     /* 265906 */     GIR_EraseRootFromParent_Done,
     /* 265907 */   // Label 5357: @265907
     /* 265907 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(265971), // Rule ID 6437 //
     /* 265912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 265920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 265924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265929 */     // MIs[1] Operand 2
     /* 265929 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 265940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 265944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265948 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 265952 */     // MIs[2] Operand 1
     /* 265952 */     // No operand predicates
     /* 265952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265954 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 265954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 265966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265969 */     GIR_RootConstrainSelectedInstOperands,
     /* 265970 */     // GIR_Coverage, 6437,
     /* 265970 */     GIR_EraseRootFromParent_Done,
     /* 265971 */   // Label 5358: @265971
     /* 265971 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(266074), // Rule ID 6438 //
     /* 265976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 265984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 265997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266001 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 266005 */     // MIs[2] Operand 1
     /* 266005 */     // No operand predicates
     /* 266005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266007 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 266007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 266010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 266024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266033 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 266036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266040 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 266043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 266069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 266072 */     GIR_RootConstrainSelectedInstOperands,
     /* 266073 */     // GIR_Coverage, 6438,
     /* 266073 */     GIR_EraseRootFromParent_Done,
     /* 266074 */   // Label 5359: @266074
     /* 266074 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(266112), // Rule ID 3976 //
     /* 266079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 266095 */     // MIs[1] Operand 1
     /* 266095 */     // No operand predicates
     /* 266095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266097 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 266097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 266107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 266110 */     GIR_RootConstrainSelectedInstOperands,
     /* 266111 */     // GIR_Coverage, 3976,
     /* 266111 */     GIR_EraseRootFromParent_Done,
     /* 266112 */   // Label 5360: @266112
     /* 266112 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(266184), // Rule ID 2428 //
     /* 266117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 266129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266140 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 266140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 266143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 266155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 266159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 266162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 266175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266182 */     GIR_RootConstrainSelectedInstOperands,
     /* 266183 */     // GIR_Coverage, 2428,
     /* 266183 */     GIR_EraseRootFromParent_Done,
     /* 266184 */   // Label 5361: @266184
     /* 266184 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(266256), // Rule ID 2429 //
     /* 266189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266212 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 266212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 266215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266224 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 266227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 266231 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 266234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 266247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266254 */     GIR_RootConstrainSelectedInstOperands,
     /* 266255 */     // GIR_Coverage, 2429,
     /* 266255 */     GIR_EraseRootFromParent_Done,
     /* 266256 */   // Label 5362: @266256
     /* 266256 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(266276), // Rule ID 119 //
     /* 266261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266269 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 266269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 266274 */     GIR_RootConstrainSelectedInstOperands,
     /* 266275 */     // GIR_Coverage, 119,
     /* 266275 */     GIR_Done,
     /* 266276 */   // Label 5363: @266276
     /* 266276 */   GIM_Reject,
     /* 266277 */ // Label 5356: @266277
     /* 266277 */ GIM_Reject,
     /* 266278 */ // Label 5348: @266278
     /* 266278 */ GIM_Reject,
     /* 266279 */ // Label 47: @266279
     /* 266279 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5366*/ GIMT_Encode4(266408),
     /* 266290 */ /*GILLT_s32*//*Label 5364*/ GIMT_Encode4(266298),
     /* 266294 */ /*GILLT_s64*//*Label 5365*/ GIMT_Encode4(266353),
     /* 266298 */ // Label 5364: @266298
     /* 266298 */ GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(266352), // Rule ID 188 //
     /* 266303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 266309 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 266312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266332 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 266336 */   // MIs[1] Operand 1
     /* 266336 */   // No operand predicates
     /* 266336 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266338 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 266338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 266341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266343 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266345 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 266347 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 266350 */   GIR_RootConstrainSelectedInstOperands,
     /* 266351 */   // GIR_Coverage, 188,
     /* 266351 */   GIR_EraseRootFromParent_Done,
     /* 266352 */ // Label 5367: @266352
     /* 266352 */ GIM_Reject,
     /* 266353 */ // Label 5365: @266353
     /* 266353 */ GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(266407), // Rule ID 189 //
     /* 266358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 266367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266387 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 266391 */   // MIs[1] Operand 1
     /* 266391 */   // No operand predicates
     /* 266391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266393 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 266393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 266396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266398 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266400 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 266402 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 266405 */   GIR_RootConstrainSelectedInstOperands,
     /* 266406 */   // GIR_Coverage, 189,
     /* 266406 */   GIR_EraseRootFromParent_Done,
     /* 266407 */ // Label 5368: @266407
     /* 266407 */ GIM_Reject,
     /* 266408 */ // Label 5366: @266408
     /* 266408 */ GIM_Reject,
     /* 266409 */ // Label 48: @266409
     /* 266409 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5371*/ GIMT_Encode4(266901),
     /* 266420 */ /*GILLT_s32*//*Label 5369*/ GIMT_Encode4(266428),
     /* 266424 */ /*GILLT_s64*//*Label 5370*/ GIMT_Encode4(266644),
     /* 266428 */ // Label 5369: @266428
     /* 266428 */ GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(266643),
     /* 266433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266443 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(266482), // Rule ID 184 //
     /* 266448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 266456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 266469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266471 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 266471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 266474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266480 */     GIR_RootConstrainSelectedInstOperands,
     /* 266481 */     // GIR_Coverage, 184,
     /* 266481 */     GIR_EraseRootFromParent_Done,
     /* 266482 */   // Label 5373: @266482
     /* 266482 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(266519), // Rule ID 3971 //
     /* 266487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 266503 */     // MIs[1] Operand 1
     /* 266503 */     // No operand predicates
     /* 266503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266505 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 266505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 266508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 266517 */     GIR_RootConstrainSelectedInstOperands,
     /* 266518 */     // GIR_Coverage, 3971,
     /* 266518 */     GIR_EraseRootFromParent_Done,
     /* 266519 */   // Label 5374: @266519
     /* 266519 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(266560), // Rule ID 3900 //
     /* 266524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 266536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266547 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 266547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 266550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 266558 */     GIR_RootConstrainSelectedInstOperands,
     /* 266559 */     // GIR_Coverage, 3900,
     /* 266559 */     GIR_EraseRootFromParent_Done,
     /* 266560 */   // Label 5375: @266560
     /* 266560 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(266601), // Rule ID 3901 //
     /* 266565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 266577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266588 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 266588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 266591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 266599 */     GIR_RootConstrainSelectedInstOperands,
     /* 266600 */     // GIR_Coverage, 3901,
     /* 266600 */     GIR_EraseRootFromParent_Done,
     /* 266601 */   // Label 5376: @266601
     /* 266601 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(266642), // Rule ID 3899 //
     /* 266606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266629 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 266629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 266632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 266640 */     GIR_RootConstrainSelectedInstOperands,
     /* 266641 */     // GIR_Coverage, 3899,
     /* 266641 */     GIR_EraseRootFromParent_Done,
     /* 266642 */   // Label 5377: @266642
     /* 266642 */   GIM_Reject,
     /* 266643 */ // Label 5372: @266643
     /* 266643 */ GIM_Reject,
     /* 266644 */ // Label 5370: @266644
     /* 266644 */ GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(266900),
     /* 266649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266659 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(266698), // Rule ID 187 //
     /* 266664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 266672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 266685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266687 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 266687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 266690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266696 */     GIR_RootConstrainSelectedInstOperands,
     /* 266697 */     // GIR_Coverage, 187,
     /* 266697 */     GIR_EraseRootFromParent_Done,
     /* 266698 */   // Label 5379: @266698
     /* 266698 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(266735), // Rule ID 3972 //
     /* 266703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 266719 */     // MIs[1] Operand 1
     /* 266719 */     // No operand predicates
     /* 266719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266721 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 266721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 266724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 266733 */     GIR_RootConstrainSelectedInstOperands,
     /* 266734 */     // GIR_Coverage, 3972,
     /* 266734 */     GIR_EraseRootFromParent_Done,
     /* 266735 */   // Label 5380: @266735
     /* 266735 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(266807), // Rule ID 3902 //
     /* 266740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 266752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266763 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 266763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 266766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 266778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 266782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 266785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 266798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266805 */     GIR_RootConstrainSelectedInstOperands,
     /* 266806 */     // GIR_Coverage, 3902,
     /* 266806 */     GIR_EraseRootFromParent_Done,
     /* 266807 */   // Label 5381: @266807
     /* 266807 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(266879), // Rule ID 3903 //
     /* 266812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266835 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 266835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 266838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266847 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 266850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 266854 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 266857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 266870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 266874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266877 */     GIR_RootConstrainSelectedInstOperands,
     /* 266878 */     // GIR_Coverage, 3903,
     /* 266878 */     GIR_EraseRootFromParent_Done,
     /* 266879 */   // Label 5382: @266879
     /* 266879 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(266899), // Rule ID 122 //
     /* 266884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266892 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 266892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 266897 */     GIR_RootConstrainSelectedInstOperands,
     /* 266898 */     // GIR_Coverage, 122,
     /* 266898 */     GIR_Done,
     /* 266899 */   // Label 5383: @266899
     /* 266899 */   GIM_Reject,
     /* 266900 */ // Label 5378: @266900
     /* 266900 */ GIM_Reject,
     /* 266901 */ // Label 5371: @266901
     /* 266901 */ GIM_Reject,
     /* 266902 */ // Label 49: @266902
     /* 266902 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 5391*/ GIMT_Encode4(271477),
     /* 266913 */ /*GILLT_v2s32*//*Label 5384*/ GIMT_Encode4(266941),
     /* 266917 */ /*GILLT_v2s64*//*Label 5385*/ GIMT_Encode4(267589),
     /* 266921 */ /*GILLT_v4s16*//*Label 5386*/ GIMT_Encode4(268237),
     /* 266925 */ /*GILLT_v4s32*//*Label 5387*/ GIMT_Encode4(268885),
     /* 266929 */ /*GILLT_v8s8*//*Label 5388*/ GIMT_Encode4(269533),
     /* 266933 */ /*GILLT_v8s16*//*Label 5389*/ GIMT_Encode4(270181),
     /* 266937 */ /*GILLT_v16s8*//*Label 5390*/ GIMT_Encode4(270829),
     /* 266941 */ // Label 5384: @266941
     /* 266941 */ GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(267588),
     /* 266946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 266952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266956 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(266993), // Rule ID 5124 //
     /* 266961 */     // MIs[0] Operand 1
     /* 266961 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266970 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266976 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266984 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 266984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 266987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266991 */     GIR_RootConstrainSelectedInstOperands,
     /* 266992 */     // GIR_Coverage, 5124,
     /* 266992 */     GIR_EraseRootFromParent_Done,
     /* 266993 */   // Label 5393: @266993
     /* 266993 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(267030), // Rule ID 5131 //
     /* 266998 */     // MIs[0] Operand 1
     /* 266998 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267007 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267013 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267021 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 267024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267028 */     GIR_RootConstrainSelectedInstOperands,
     /* 267029 */     // GIR_Coverage, 5131,
     /* 267029 */     GIR_EraseRootFromParent_Done,
     /* 267030 */   // Label 5394: @267030
     /* 267030 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(267067), // Rule ID 5138 //
     /* 267035 */     // MIs[0] Operand 1
     /* 267035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267044 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267050 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267058 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 267061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267065 */     GIR_RootConstrainSelectedInstOperands,
     /* 267066 */     // GIR_Coverage, 5138,
     /* 267066 */     GIR_EraseRootFromParent_Done,
     /* 267067 */   // Label 5395: @267067
     /* 267067 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(267104), // Rule ID 5145 //
     /* 267072 */     // MIs[0] Operand 1
     /* 267072 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267087 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267095 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 267098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267102 */     GIR_RootConstrainSelectedInstOperands,
     /* 267103 */     // GIR_Coverage, 5145,
     /* 267103 */     GIR_EraseRootFromParent_Done,
     /* 267104 */   // Label 5396: @267104
     /* 267104 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(267141), // Rule ID 5152 //
     /* 267109 */     // MIs[0] Operand 1
     /* 267109 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267118 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267124 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267132 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 267135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267139 */     GIR_RootConstrainSelectedInstOperands,
     /* 267140 */     // GIR_Coverage, 5152,
     /* 267140 */     GIR_EraseRootFromParent_Done,
     /* 267141 */   // Label 5397: @267141
     /* 267141 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(267178), // Rule ID 5089 //
     /* 267146 */     // MIs[0] Operand 1
     /* 267146 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267169 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 267172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267176 */     GIR_RootConstrainSelectedInstOperands,
     /* 267177 */     // GIR_Coverage, 5089,
     /* 267177 */     GIR_EraseRootFromParent_Done,
     /* 267178 */   // Label 5398: @267178
     /* 267178 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(267215), // Rule ID 5096 //
     /* 267183 */     // MIs[0] Operand 1
     /* 267183 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267196 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267202 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267206 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 267209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267213 */     GIR_RootConstrainSelectedInstOperands,
     /* 267214 */     // GIR_Coverage, 5096,
     /* 267214 */     GIR_EraseRootFromParent_Done,
     /* 267215 */   // Label 5399: @267215
     /* 267215 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(267252), // Rule ID 5103 //
     /* 267220 */     // MIs[0] Operand 1
     /* 267220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267239 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267243 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 267246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267250 */     GIR_RootConstrainSelectedInstOperands,
     /* 267251 */     // GIR_Coverage, 5103,
     /* 267251 */     GIR_EraseRootFromParent_Done,
     /* 267252 */   // Label 5400: @267252
     /* 267252 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(267289), // Rule ID 5110 //
     /* 267257 */     // MIs[0] Operand 1
     /* 267257 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267270 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267276 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267280 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 267283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267287 */     GIR_RootConstrainSelectedInstOperands,
     /* 267288 */     // GIR_Coverage, 5110,
     /* 267288 */     GIR_EraseRootFromParent_Done,
     /* 267289 */   // Label 5401: @267289
     /* 267289 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(267326), // Rule ID 5117 //
     /* 267294 */     // MIs[0] Operand 1
     /* 267294 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267307 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267313 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267317 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 267317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 267320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267324 */     GIR_RootConstrainSelectedInstOperands,
     /* 267325 */     // GIR_Coverage, 5117,
     /* 267325 */     GIR_EraseRootFromParent_Done,
     /* 267326 */   // Label 5402: @267326
     /* 267326 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(267355), // Rule ID 5026 //
     /* 267331 */     // MIs[0] Operand 1
     /* 267331 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267344 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 267344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 267347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267353 */     GIR_RootConstrainSelectedInstOperands,
     /* 267354 */     // GIR_Coverage, 5026,
     /* 267354 */     GIR_EraseRootFromParent_Done,
     /* 267355 */   // Label 5403: @267355
     /* 267355 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(267384), // Rule ID 5033 //
     /* 267360 */     // MIs[0] Operand 1
     /* 267360 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267373 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 267373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 267376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267382 */     GIR_RootConstrainSelectedInstOperands,
     /* 267383 */     // GIR_Coverage, 5033,
     /* 267383 */     GIR_EraseRootFromParent_Done,
     /* 267384 */   // Label 5404: @267384
     /* 267384 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(267413), // Rule ID 5040 //
     /* 267389 */     // MIs[0] Operand 1
     /* 267389 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267402 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 267402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 267405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267411 */     GIR_RootConstrainSelectedInstOperands,
     /* 267412 */     // GIR_Coverage, 5040,
     /* 267412 */     GIR_EraseRootFromParent_Done,
     /* 267413 */   // Label 5405: @267413
     /* 267413 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(267442), // Rule ID 5047 //
     /* 267418 */     // MIs[0] Operand 1
     /* 267418 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 267423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267431 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 267431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 267434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267440 */     GIR_RootConstrainSelectedInstOperands,
     /* 267441 */     // GIR_Coverage, 5047,
     /* 267441 */     GIR_EraseRootFromParent_Done,
     /* 267442 */   // Label 5406: @267442
     /* 267442 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(267471), // Rule ID 5054 //
     /* 267447 */     // MIs[0] Operand 1
     /* 267447 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 267452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267460 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 267460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 267463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267469 */     GIR_RootConstrainSelectedInstOperands,
     /* 267470 */     // GIR_Coverage, 5054,
     /* 267470 */     GIR_EraseRootFromParent_Done,
     /* 267471 */   // Label 5407: @267471
     /* 267471 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(267500), // Rule ID 5061 //
     /* 267476 */     // MIs[0] Operand 1
     /* 267476 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267489 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 267489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 267492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267498 */     GIR_RootConstrainSelectedInstOperands,
     /* 267499 */     // GIR_Coverage, 5061,
     /* 267499 */     GIR_EraseRootFromParent_Done,
     /* 267500 */   // Label 5408: @267500
     /* 267500 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(267529), // Rule ID 5068 //
     /* 267505 */     // MIs[0] Operand 1
     /* 267505 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267518 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 267518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 267521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267527 */     GIR_RootConstrainSelectedInstOperands,
     /* 267528 */     // GIR_Coverage, 5068,
     /* 267528 */     GIR_EraseRootFromParent_Done,
     /* 267529 */   // Label 5409: @267529
     /* 267529 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(267558), // Rule ID 5075 //
     /* 267534 */     // MIs[0] Operand 1
     /* 267534 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 267539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267547 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 267547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 267550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267556 */     GIR_RootConstrainSelectedInstOperands,
     /* 267557 */     // GIR_Coverage, 5075,
     /* 267557 */     GIR_EraseRootFromParent_Done,
     /* 267558 */   // Label 5410: @267558
     /* 267558 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(267587), // Rule ID 5082 //
     /* 267563 */     // MIs[0] Operand 1
     /* 267563 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 267568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267576 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 267576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 267579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267585 */     GIR_RootConstrainSelectedInstOperands,
     /* 267586 */     // GIR_Coverage, 5082,
     /* 267586 */     GIR_EraseRootFromParent_Done,
     /* 267587 */   // Label 5411: @267587
     /* 267587 */   GIM_Reject,
     /* 267588 */ // Label 5392: @267588
     /* 267588 */ GIM_Reject,
     /* 267589 */ // Label 5385: @267589
     /* 267589 */ GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(268236),
     /* 267594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 267597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 267600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267604 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(267641), // Rule ID 5126 //
     /* 267609 */     // MIs[0] Operand 1
     /* 267609 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267618 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267624 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267632 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 267635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267639 */     GIR_RootConstrainSelectedInstOperands,
     /* 267640 */     // GIR_Coverage, 5126,
     /* 267640 */     GIR_EraseRootFromParent_Done,
     /* 267641 */   // Label 5413: @267641
     /* 267641 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(267678), // Rule ID 5133 //
     /* 267646 */     // MIs[0] Operand 1
     /* 267646 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267661 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267669 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 267672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267676 */     GIR_RootConstrainSelectedInstOperands,
     /* 267677 */     // GIR_Coverage, 5133,
     /* 267677 */     GIR_EraseRootFromParent_Done,
     /* 267678 */   // Label 5414: @267678
     /* 267678 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(267715), // Rule ID 5140 //
     /* 267683 */     // MIs[0] Operand 1
     /* 267683 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267692 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267698 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267706 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 267709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267713 */     GIR_RootConstrainSelectedInstOperands,
     /* 267714 */     // GIR_Coverage, 5140,
     /* 267714 */     GIR_EraseRootFromParent_Done,
     /* 267715 */   // Label 5415: @267715
     /* 267715 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(267752), // Rule ID 5147 //
     /* 267720 */     // MIs[0] Operand 1
     /* 267720 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267729 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267735 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267743 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 267746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267750 */     GIR_RootConstrainSelectedInstOperands,
     /* 267751 */     // GIR_Coverage, 5147,
     /* 267751 */     GIR_EraseRootFromParent_Done,
     /* 267752 */   // Label 5416: @267752
     /* 267752 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(267789), // Rule ID 5154 //
     /* 267757 */     // MIs[0] Operand 1
     /* 267757 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267766 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267772 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267780 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 267783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267787 */     GIR_RootConstrainSelectedInstOperands,
     /* 267788 */     // GIR_Coverage, 5154,
     /* 267788 */     GIR_EraseRootFromParent_Done,
     /* 267789 */   // Label 5417: @267789
     /* 267789 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(267826), // Rule ID 5091 //
     /* 267794 */     // MIs[0] Operand 1
     /* 267794 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267817 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 267820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267824 */     GIR_RootConstrainSelectedInstOperands,
     /* 267825 */     // GIR_Coverage, 5091,
     /* 267825 */     GIR_EraseRootFromParent_Done,
     /* 267826 */   // Label 5418: @267826
     /* 267826 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(267863), // Rule ID 5098 //
     /* 267831 */     // MIs[0] Operand 1
     /* 267831 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267844 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267850 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267854 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 267857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267861 */     GIR_RootConstrainSelectedInstOperands,
     /* 267862 */     // GIR_Coverage, 5098,
     /* 267862 */     GIR_EraseRootFromParent_Done,
     /* 267863 */   // Label 5419: @267863
     /* 267863 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(267900), // Rule ID 5105 //
     /* 267868 */     // MIs[0] Operand 1
     /* 267868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267891 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 267894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267898 */     GIR_RootConstrainSelectedInstOperands,
     /* 267899 */     // GIR_Coverage, 5105,
     /* 267899 */     GIR_EraseRootFromParent_Done,
     /* 267900 */   // Label 5420: @267900
     /* 267900 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(267937), // Rule ID 5112 //
     /* 267905 */     // MIs[0] Operand 1
     /* 267905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267918 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267924 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267928 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 267931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267935 */     GIR_RootConstrainSelectedInstOperands,
     /* 267936 */     // GIR_Coverage, 5112,
     /* 267936 */     GIR_EraseRootFromParent_Done,
     /* 267937 */   // Label 5421: @267937
     /* 267937 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(267974), // Rule ID 5119 //
     /* 267942 */     // MIs[0] Operand 1
     /* 267942 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267955 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267961 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267965 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 267965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 267968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267972 */     GIR_RootConstrainSelectedInstOperands,
     /* 267973 */     // GIR_Coverage, 5119,
     /* 267973 */     GIR_EraseRootFromParent_Done,
     /* 267974 */   // Label 5422: @267974
     /* 267974 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(268003), // Rule ID 5028 //
     /* 267979 */     // MIs[0] Operand 1
     /* 267979 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267992 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 267992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 267995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268001 */     GIR_RootConstrainSelectedInstOperands,
     /* 268002 */     // GIR_Coverage, 5028,
     /* 268002 */     GIR_EraseRootFromParent_Done,
     /* 268003 */   // Label 5423: @268003
     /* 268003 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(268032), // Rule ID 5035 //
     /* 268008 */     // MIs[0] Operand 1
     /* 268008 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268021 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 268021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 268024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268030 */     GIR_RootConstrainSelectedInstOperands,
     /* 268031 */     // GIR_Coverage, 5035,
     /* 268031 */     GIR_EraseRootFromParent_Done,
     /* 268032 */   // Label 5424: @268032
     /* 268032 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(268061), // Rule ID 5042 //
     /* 268037 */     // MIs[0] Operand 1
     /* 268037 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268050 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 268050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 268053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268059 */     GIR_RootConstrainSelectedInstOperands,
     /* 268060 */     // GIR_Coverage, 5042,
     /* 268060 */     GIR_EraseRootFromParent_Done,
     /* 268061 */   // Label 5425: @268061
     /* 268061 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(268090), // Rule ID 5049 //
     /* 268066 */     // MIs[0] Operand 1
     /* 268066 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 268071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268079 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 268079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 268082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268088 */     GIR_RootConstrainSelectedInstOperands,
     /* 268089 */     // GIR_Coverage, 5049,
     /* 268089 */     GIR_EraseRootFromParent_Done,
     /* 268090 */   // Label 5426: @268090
     /* 268090 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(268119), // Rule ID 5056 //
     /* 268095 */     // MIs[0] Operand 1
     /* 268095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 268100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268108 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 268108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 268111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268117 */     GIR_RootConstrainSelectedInstOperands,
     /* 268118 */     // GIR_Coverage, 5056,
     /* 268118 */     GIR_EraseRootFromParent_Done,
     /* 268119 */   // Label 5427: @268119
     /* 268119 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(268148), // Rule ID 5063 //
     /* 268124 */     // MIs[0] Operand 1
     /* 268124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268137 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 268137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 268140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268146 */     GIR_RootConstrainSelectedInstOperands,
     /* 268147 */     // GIR_Coverage, 5063,
     /* 268147 */     GIR_EraseRootFromParent_Done,
     /* 268148 */   // Label 5428: @268148
     /* 268148 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(268177), // Rule ID 5070 //
     /* 268153 */     // MIs[0] Operand 1
     /* 268153 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268166 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 268166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 268169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268175 */     GIR_RootConstrainSelectedInstOperands,
     /* 268176 */     // GIR_Coverage, 5070,
     /* 268176 */     GIR_EraseRootFromParent_Done,
     /* 268177 */   // Label 5429: @268177
     /* 268177 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(268206), // Rule ID 5077 //
     /* 268182 */     // MIs[0] Operand 1
     /* 268182 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 268187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268195 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 268195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 268198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268204 */     GIR_RootConstrainSelectedInstOperands,
     /* 268205 */     // GIR_Coverage, 5077,
     /* 268205 */     GIR_EraseRootFromParent_Done,
     /* 268206 */   // Label 5430: @268206
     /* 268206 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(268235), // Rule ID 5084 //
     /* 268211 */     // MIs[0] Operand 1
     /* 268211 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 268216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268224 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 268224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 268227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268233 */     GIR_RootConstrainSelectedInstOperands,
     /* 268234 */     // GIR_Coverage, 5084,
     /* 268234 */     GIR_EraseRootFromParent_Done,
     /* 268235 */   // Label 5431: @268235
     /* 268235 */   GIM_Reject,
     /* 268236 */ // Label 5412: @268236
     /* 268236 */ GIM_Reject,
     /* 268237 */ // Label 5386: @268237
     /* 268237 */ GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(268884),
     /* 268242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268245 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268252 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(268289), // Rule ID 5122 //
     /* 268257 */     // MIs[0] Operand 1
     /* 268257 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268266 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268272 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268280 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 268283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268287 */     GIR_RootConstrainSelectedInstOperands,
     /* 268288 */     // GIR_Coverage, 5122,
     /* 268288 */     GIR_EraseRootFromParent_Done,
     /* 268289 */   // Label 5433: @268289
     /* 268289 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(268326), // Rule ID 5129 //
     /* 268294 */     // MIs[0] Operand 1
     /* 268294 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268303 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268309 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268317 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 268320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268324 */     GIR_RootConstrainSelectedInstOperands,
     /* 268325 */     // GIR_Coverage, 5129,
     /* 268325 */     GIR_EraseRootFromParent_Done,
     /* 268326 */   // Label 5434: @268326
     /* 268326 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(268363), // Rule ID 5136 //
     /* 268331 */     // MIs[0] Operand 1
     /* 268331 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268340 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268346 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268354 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 268357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268361 */     GIR_RootConstrainSelectedInstOperands,
     /* 268362 */     // GIR_Coverage, 5136,
     /* 268362 */     GIR_EraseRootFromParent_Done,
     /* 268363 */   // Label 5435: @268363
     /* 268363 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(268400), // Rule ID 5143 //
     /* 268368 */     // MIs[0] Operand 1
     /* 268368 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268383 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268391 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 268394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268398 */     GIR_RootConstrainSelectedInstOperands,
     /* 268399 */     // GIR_Coverage, 5143,
     /* 268399 */     GIR_EraseRootFromParent_Done,
     /* 268400 */   // Label 5436: @268400
     /* 268400 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(268437), // Rule ID 5150 //
     /* 268405 */     // MIs[0] Operand 1
     /* 268405 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268414 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268420 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268428 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 268431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268435 */     GIR_RootConstrainSelectedInstOperands,
     /* 268436 */     // GIR_Coverage, 5150,
     /* 268436 */     GIR_EraseRootFromParent_Done,
     /* 268437 */   // Label 5437: @268437
     /* 268437 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(268474), // Rule ID 5087 //
     /* 268442 */     // MIs[0] Operand 1
     /* 268442 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268455 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268461 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268465 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 268468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268472 */     GIR_RootConstrainSelectedInstOperands,
     /* 268473 */     // GIR_Coverage, 5087,
     /* 268473 */     GIR_EraseRootFromParent_Done,
     /* 268474 */   // Label 5438: @268474
     /* 268474 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(268511), // Rule ID 5094 //
     /* 268479 */     // MIs[0] Operand 1
     /* 268479 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268492 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268498 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268502 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 268505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268509 */     GIR_RootConstrainSelectedInstOperands,
     /* 268510 */     // GIR_Coverage, 5094,
     /* 268510 */     GIR_EraseRootFromParent_Done,
     /* 268511 */   // Label 5439: @268511
     /* 268511 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(268548), // Rule ID 5101 //
     /* 268516 */     // MIs[0] Operand 1
     /* 268516 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268529 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268535 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268539 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 268542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268546 */     GIR_RootConstrainSelectedInstOperands,
     /* 268547 */     // GIR_Coverage, 5101,
     /* 268547 */     GIR_EraseRootFromParent_Done,
     /* 268548 */   // Label 5440: @268548
     /* 268548 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(268585), // Rule ID 5108 //
     /* 268553 */     // MIs[0] Operand 1
     /* 268553 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268576 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 268579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268583 */     GIR_RootConstrainSelectedInstOperands,
     /* 268584 */     // GIR_Coverage, 5108,
     /* 268584 */     GIR_EraseRootFromParent_Done,
     /* 268585 */   // Label 5441: @268585
     /* 268585 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(268622), // Rule ID 5115 //
     /* 268590 */     // MIs[0] Operand 1
     /* 268590 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268603 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268609 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268613 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 268613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 268616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268620 */     GIR_RootConstrainSelectedInstOperands,
     /* 268621 */     // GIR_Coverage, 5115,
     /* 268621 */     GIR_EraseRootFromParent_Done,
     /* 268622 */   // Label 5442: @268622
     /* 268622 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(268651), // Rule ID 5024 //
     /* 268627 */     // MIs[0] Operand 1
     /* 268627 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268640 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 268643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268649 */     GIR_RootConstrainSelectedInstOperands,
     /* 268650 */     // GIR_Coverage, 5024,
     /* 268650 */     GIR_EraseRootFromParent_Done,
     /* 268651 */   // Label 5443: @268651
     /* 268651 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(268680), // Rule ID 5031 //
     /* 268656 */     // MIs[0] Operand 1
     /* 268656 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268669 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 268672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268678 */     GIR_RootConstrainSelectedInstOperands,
     /* 268679 */     // GIR_Coverage, 5031,
     /* 268679 */     GIR_EraseRootFromParent_Done,
     /* 268680 */   // Label 5444: @268680
     /* 268680 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(268709), // Rule ID 5038 //
     /* 268685 */     // MIs[0] Operand 1
     /* 268685 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268698 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 268701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268707 */     GIR_RootConstrainSelectedInstOperands,
     /* 268708 */     // GIR_Coverage, 5038,
     /* 268708 */     GIR_EraseRootFromParent_Done,
     /* 268709 */   // Label 5445: @268709
     /* 268709 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(268738), // Rule ID 5045 //
     /* 268714 */     // MIs[0] Operand 1
     /* 268714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 268719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268727 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 268730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268736 */     GIR_RootConstrainSelectedInstOperands,
     /* 268737 */     // GIR_Coverage, 5045,
     /* 268737 */     GIR_EraseRootFromParent_Done,
     /* 268738 */   // Label 5446: @268738
     /* 268738 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(268767), // Rule ID 5052 //
     /* 268743 */     // MIs[0] Operand 1
     /* 268743 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 268748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268756 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 268759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268765 */     GIR_RootConstrainSelectedInstOperands,
     /* 268766 */     // GIR_Coverage, 5052,
     /* 268766 */     GIR_EraseRootFromParent_Done,
     /* 268767 */   // Label 5447: @268767
     /* 268767 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(268796), // Rule ID 5059 //
     /* 268772 */     // MIs[0] Operand 1
     /* 268772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268785 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 268785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 268788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268794 */     GIR_RootConstrainSelectedInstOperands,
     /* 268795 */     // GIR_Coverage, 5059,
     /* 268795 */     GIR_EraseRootFromParent_Done,
     /* 268796 */   // Label 5448: @268796
     /* 268796 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(268825), // Rule ID 5066 //
     /* 268801 */     // MIs[0] Operand 1
     /* 268801 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268814 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 268814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 268817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268823 */     GIR_RootConstrainSelectedInstOperands,
     /* 268824 */     // GIR_Coverage, 5066,
     /* 268824 */     GIR_EraseRootFromParent_Done,
     /* 268825 */   // Label 5449: @268825
     /* 268825 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(268854), // Rule ID 5073 //
     /* 268830 */     // MIs[0] Operand 1
     /* 268830 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 268835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268843 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 268843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 268846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268852 */     GIR_RootConstrainSelectedInstOperands,
     /* 268853 */     // GIR_Coverage, 5073,
     /* 268853 */     GIR_EraseRootFromParent_Done,
     /* 268854 */   // Label 5450: @268854
     /* 268854 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(268883), // Rule ID 5080 //
     /* 268859 */     // MIs[0] Operand 1
     /* 268859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 268864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268872 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 268872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 268875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268881 */     GIR_RootConstrainSelectedInstOperands,
     /* 268882 */     // GIR_Coverage, 5080,
     /* 268882 */     GIR_EraseRootFromParent_Done,
     /* 268883 */   // Label 5451: @268883
     /* 268883 */   GIM_Reject,
     /* 268884 */ // Label 5432: @268884
     /* 268884 */ GIM_Reject,
     /* 268885 */ // Label 5387: @268885
     /* 268885 */ GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(269532),
     /* 268890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268900 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(268937), // Rule ID 5125 //
     /* 268905 */     // MIs[0] Operand 1
     /* 268905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268914 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268920 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268928 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 268928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 268931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268935 */     GIR_RootConstrainSelectedInstOperands,
     /* 268936 */     // GIR_Coverage, 5125,
     /* 268936 */     GIR_EraseRootFromParent_Done,
     /* 268937 */   // Label 5453: @268937
     /* 268937 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(268974), // Rule ID 5132 //
     /* 268942 */     // MIs[0] Operand 1
     /* 268942 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268951 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268957 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268965 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 268965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 268968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268972 */     GIR_RootConstrainSelectedInstOperands,
     /* 268973 */     // GIR_Coverage, 5132,
     /* 268973 */     GIR_EraseRootFromParent_Done,
     /* 268974 */   // Label 5454: @268974
     /* 268974 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(269011), // Rule ID 5139 //
     /* 268979 */     // MIs[0] Operand 1
     /* 268979 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268988 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268994 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269002 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 269002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 269005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 269009 */     GIR_RootConstrainSelectedInstOperands,
     /* 269010 */     // GIR_Coverage, 5139,
     /* 269010 */     GIR_EraseRootFromParent_Done,
     /* 269011 */   // Label 5455: @269011
     /* 269011 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(269048), // Rule ID 5146 //
     /* 269016 */     // MIs[0] Operand 1
     /* 269016 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 269021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269039 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 269039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 269042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 269046 */     GIR_RootConstrainSelectedInstOperands,
     /* 269047 */     // GIR_Coverage, 5146,
     /* 269047 */     GIR_EraseRootFromParent_Done,
     /* 269048 */   // Label 5456: @269048
     /* 269048 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(269085), // Rule ID 5153 //
     /* 269053 */     // MIs[0] Operand 1
     /* 269053 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 269058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269062 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269068 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269076 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 269076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 269079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 269083 */     GIR_RootConstrainSelectedInstOperands,
     /* 269084 */     // GIR_Coverage, 5153,
     /* 269084 */     GIR_EraseRootFromParent_Done,
     /* 269085 */   // Label 5457: @269085
     /* 269085 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(269122), // Rule ID 5090 //
     /* 269090 */     // MIs[0] Operand 1
     /* 269090 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 269095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269103 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269109 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269113 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 269113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 269116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269120 */     GIR_RootConstrainSelectedInstOperands,
     /* 269121 */     // GIR_Coverage, 5090,
     /* 269121 */     GIR_EraseRootFromParent_Done,
     /* 269122 */   // Label 5458: @269122
     /* 269122 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(269159), // Rule ID 5097 //
     /* 269127 */     // MIs[0] Operand 1
     /* 269127 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 269132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269140 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269146 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269150 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 269150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 269153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269157 */     GIR_RootConstrainSelectedInstOperands,
     /* 269158 */     // GIR_Coverage, 5097,
     /* 269158 */     GIR_EraseRootFromParent_Done,
     /* 269159 */   // Label 5459: @269159
     /* 269159 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(269196), // Rule ID 5104 //
     /* 269164 */     // MIs[0] Operand 1
     /* 269164 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 269169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269187 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 269187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 269190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269194 */     GIR_RootConstrainSelectedInstOperands,
     /* 269195 */     // GIR_Coverage, 5104,
     /* 269195 */     GIR_EraseRootFromParent_Done,
     /* 269196 */   // Label 5460: @269196
     /* 269196 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(269233), // Rule ID 5111 //
     /* 269201 */     // MIs[0] Operand 1
     /* 269201 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 269206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269214 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269220 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269224 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 269224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 269227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269231 */     GIR_RootConstrainSelectedInstOperands,
     /* 269232 */     // GIR_Coverage, 5111,
     /* 269232 */     GIR_EraseRootFromParent_Done,
     /* 269233 */   // Label 5461: @269233
     /* 269233 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(269270), // Rule ID 5118 //
     /* 269238 */     // MIs[0] Operand 1
     /* 269238 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 269243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269251 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269257 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269261 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 269261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 269264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269268 */     GIR_RootConstrainSelectedInstOperands,
     /* 269269 */     // GIR_Coverage, 5118,
     /* 269269 */     GIR_EraseRootFromParent_Done,
     /* 269270 */   // Label 5462: @269270
     /* 269270 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(269299), // Rule ID 5027 //
     /* 269275 */     // MIs[0] Operand 1
     /* 269275 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 269280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269288 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 269288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 269291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269297 */     GIR_RootConstrainSelectedInstOperands,
     /* 269298 */     // GIR_Coverage, 5027,
     /* 269298 */     GIR_EraseRootFromParent_Done,
     /* 269299 */   // Label 5463: @269299
     /* 269299 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(269328), // Rule ID 5034 //
     /* 269304 */     // MIs[0] Operand 1
     /* 269304 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 269309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269317 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 269317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 269320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269326 */     GIR_RootConstrainSelectedInstOperands,
     /* 269327 */     // GIR_Coverage, 5034,
     /* 269327 */     GIR_EraseRootFromParent_Done,
     /* 269328 */   // Label 5464: @269328
     /* 269328 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(269357), // Rule ID 5041 //
     /* 269333 */     // MIs[0] Operand 1
     /* 269333 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 269338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269346 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 269346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 269349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269355 */     GIR_RootConstrainSelectedInstOperands,
     /* 269356 */     // GIR_Coverage, 5041,
     /* 269356 */     GIR_EraseRootFromParent_Done,
     /* 269357 */   // Label 5465: @269357
     /* 269357 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(269386), // Rule ID 5048 //
     /* 269362 */     // MIs[0] Operand 1
     /* 269362 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 269367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269375 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 269375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 269378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269384 */     GIR_RootConstrainSelectedInstOperands,
     /* 269385 */     // GIR_Coverage, 5048,
     /* 269385 */     GIR_EraseRootFromParent_Done,
     /* 269386 */   // Label 5466: @269386
     /* 269386 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(269415), // Rule ID 5055 //
     /* 269391 */     // MIs[0] Operand 1
     /* 269391 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 269396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269404 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 269404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 269407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269413 */     GIR_RootConstrainSelectedInstOperands,
     /* 269414 */     // GIR_Coverage, 5055,
     /* 269414 */     GIR_EraseRootFromParent_Done,
     /* 269415 */   // Label 5467: @269415
     /* 269415 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(269444), // Rule ID 5062 //
     /* 269420 */     // MIs[0] Operand 1
     /* 269420 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 269425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269433 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 269433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 269436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269442 */     GIR_RootConstrainSelectedInstOperands,
     /* 269443 */     // GIR_Coverage, 5062,
     /* 269443 */     GIR_EraseRootFromParent_Done,
     /* 269444 */   // Label 5468: @269444
     /* 269444 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(269473), // Rule ID 5069 //
     /* 269449 */     // MIs[0] Operand 1
     /* 269449 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 269454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269462 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 269462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 269465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269471 */     GIR_RootConstrainSelectedInstOperands,
     /* 269472 */     // GIR_Coverage, 5069,
     /* 269472 */     GIR_EraseRootFromParent_Done,
     /* 269473 */   // Label 5469: @269473
     /* 269473 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(269502), // Rule ID 5076 //
     /* 269478 */     // MIs[0] Operand 1
     /* 269478 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 269483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269491 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 269491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 269494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269500 */     GIR_RootConstrainSelectedInstOperands,
     /* 269501 */     // GIR_Coverage, 5076,
     /* 269501 */     GIR_EraseRootFromParent_Done,
     /* 269502 */   // Label 5470: @269502
     /* 269502 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(269531), // Rule ID 5083 //
     /* 269507 */     // MIs[0] Operand 1
     /* 269507 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 269512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269520 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 269520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 269523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269529 */     GIR_RootConstrainSelectedInstOperands,
     /* 269530 */     // GIR_Coverage, 5083,
     /* 269530 */     GIR_EraseRootFromParent_Done,
     /* 269531 */   // Label 5471: @269531
     /* 269531 */   GIM_Reject,
     /* 269532 */ // Label 5452: @269532
     /* 269532 */ GIM_Reject,
     /* 269533 */ // Label 5388: @269533
     /* 269533 */ GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(270180),
     /* 269538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269541 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269548 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(269585), // Rule ID 5120 //
     /* 269553 */     // MIs[0] Operand 1
     /* 269553 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 269558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269576 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 269579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 269583 */     GIR_RootConstrainSelectedInstOperands,
     /* 269584 */     // GIR_Coverage, 5120,
     /* 269584 */     GIR_EraseRootFromParent_Done,
     /* 269585 */   // Label 5473: @269585
     /* 269585 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(269622), // Rule ID 5127 //
     /* 269590 */     // MIs[0] Operand 1
     /* 269590 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 269595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269613 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 269616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 269620 */     GIR_RootConstrainSelectedInstOperands,
     /* 269621 */     // GIR_Coverage, 5127,
     /* 269621 */     GIR_EraseRootFromParent_Done,
     /* 269622 */   // Label 5474: @269622
     /* 269622 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(269659), // Rule ID 5134 //
     /* 269627 */     // MIs[0] Operand 1
     /* 269627 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 269632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269650 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 269653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 269657 */     GIR_RootConstrainSelectedInstOperands,
     /* 269658 */     // GIR_Coverage, 5134,
     /* 269658 */     GIR_EraseRootFromParent_Done,
     /* 269659 */   // Label 5475: @269659
     /* 269659 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(269696), // Rule ID 5141 //
     /* 269664 */     // MIs[0] Operand 1
     /* 269664 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 269669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269673 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269679 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269687 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 269690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 269694 */     GIR_RootConstrainSelectedInstOperands,
     /* 269695 */     // GIR_Coverage, 5141,
     /* 269695 */     GIR_EraseRootFromParent_Done,
     /* 269696 */   // Label 5476: @269696
     /* 269696 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(269733), // Rule ID 5148 //
     /* 269701 */     // MIs[0] Operand 1
     /* 269701 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 269706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269710 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269716 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269724 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 269727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 269731 */     GIR_RootConstrainSelectedInstOperands,
     /* 269732 */     // GIR_Coverage, 5148,
     /* 269732 */     GIR_EraseRootFromParent_Done,
     /* 269733 */   // Label 5477: @269733
     /* 269733 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(269770), // Rule ID 5085 //
     /* 269738 */     // MIs[0] Operand 1
     /* 269738 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 269743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269751 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269757 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269761 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 269764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269768 */     GIR_RootConstrainSelectedInstOperands,
     /* 269769 */     // GIR_Coverage, 5085,
     /* 269769 */     GIR_EraseRootFromParent_Done,
     /* 269770 */   // Label 5478: @269770
     /* 269770 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(269807), // Rule ID 5092 //
     /* 269775 */     // MIs[0] Operand 1
     /* 269775 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 269780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269788 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269794 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269798 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 269801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269805 */     GIR_RootConstrainSelectedInstOperands,
     /* 269806 */     // GIR_Coverage, 5092,
     /* 269806 */     GIR_EraseRootFromParent_Done,
     /* 269807 */   // Label 5479: @269807
     /* 269807 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(269844), // Rule ID 5099 //
     /* 269812 */     // MIs[0] Operand 1
     /* 269812 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 269817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269825 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269831 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269835 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 269838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269842 */     GIR_RootConstrainSelectedInstOperands,
     /* 269843 */     // GIR_Coverage, 5099,
     /* 269843 */     GIR_EraseRootFromParent_Done,
     /* 269844 */   // Label 5480: @269844
     /* 269844 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(269881), // Rule ID 5106 //
     /* 269849 */     // MIs[0] Operand 1
     /* 269849 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 269854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269862 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269868 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269872 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 269875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269879 */     GIR_RootConstrainSelectedInstOperands,
     /* 269880 */     // GIR_Coverage, 5106,
     /* 269880 */     GIR_EraseRootFromParent_Done,
     /* 269881 */   // Label 5481: @269881
     /* 269881 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(269918), // Rule ID 5113 //
     /* 269886 */     // MIs[0] Operand 1
     /* 269886 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 269891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269899 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269905 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269909 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 269909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 269912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269916 */     GIR_RootConstrainSelectedInstOperands,
     /* 269917 */     // GIR_Coverage, 5113,
     /* 269917 */     GIR_EraseRootFromParent_Done,
     /* 269918 */   // Label 5482: @269918
     /* 269918 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(269947), // Rule ID 5022 //
     /* 269923 */     // MIs[0] Operand 1
     /* 269923 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 269928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269936 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 269939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269945 */     GIR_RootConstrainSelectedInstOperands,
     /* 269946 */     // GIR_Coverage, 5022,
     /* 269946 */     GIR_EraseRootFromParent_Done,
     /* 269947 */   // Label 5483: @269947
     /* 269947 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(269976), // Rule ID 5029 //
     /* 269952 */     // MIs[0] Operand 1
     /* 269952 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 269957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269965 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 269968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269974 */     GIR_RootConstrainSelectedInstOperands,
     /* 269975 */     // GIR_Coverage, 5029,
     /* 269975 */     GIR_EraseRootFromParent_Done,
     /* 269976 */   // Label 5484: @269976
     /* 269976 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(270005), // Rule ID 5036 //
     /* 269981 */     // MIs[0] Operand 1
     /* 269981 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 269986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269994 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 269997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270003 */     GIR_RootConstrainSelectedInstOperands,
     /* 270004 */     // GIR_Coverage, 5036,
     /* 270004 */     GIR_EraseRootFromParent_Done,
     /* 270005 */   // Label 5485: @270005
     /* 270005 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(270034), // Rule ID 5043 //
     /* 270010 */     // MIs[0] Operand 1
     /* 270010 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 270015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270023 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 270023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 270026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270032 */     GIR_RootConstrainSelectedInstOperands,
     /* 270033 */     // GIR_Coverage, 5043,
     /* 270033 */     GIR_EraseRootFromParent_Done,
     /* 270034 */   // Label 5486: @270034
     /* 270034 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(270063), // Rule ID 5050 //
     /* 270039 */     // MIs[0] Operand 1
     /* 270039 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 270044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270052 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 270052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 270055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270061 */     GIR_RootConstrainSelectedInstOperands,
     /* 270062 */     // GIR_Coverage, 5050,
     /* 270062 */     GIR_EraseRootFromParent_Done,
     /* 270063 */   // Label 5487: @270063
     /* 270063 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(270092), // Rule ID 5057 //
     /* 270068 */     // MIs[0] Operand 1
     /* 270068 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 270073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270081 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 270081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 270084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270090 */     GIR_RootConstrainSelectedInstOperands,
     /* 270091 */     // GIR_Coverage, 5057,
     /* 270091 */     GIR_EraseRootFromParent_Done,
     /* 270092 */   // Label 5488: @270092
     /* 270092 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(270121), // Rule ID 5064 //
     /* 270097 */     // MIs[0] Operand 1
     /* 270097 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 270102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270110 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 270110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 270113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270119 */     GIR_RootConstrainSelectedInstOperands,
     /* 270120 */     // GIR_Coverage, 5064,
     /* 270120 */     GIR_EraseRootFromParent_Done,
     /* 270121 */   // Label 5489: @270121
     /* 270121 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(270150), // Rule ID 5071 //
     /* 270126 */     // MIs[0] Operand 1
     /* 270126 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 270131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270139 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 270139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 270142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270148 */     GIR_RootConstrainSelectedInstOperands,
     /* 270149 */     // GIR_Coverage, 5071,
     /* 270149 */     GIR_EraseRootFromParent_Done,
     /* 270150 */   // Label 5490: @270150
     /* 270150 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(270179), // Rule ID 5078 //
     /* 270155 */     // MIs[0] Operand 1
     /* 270155 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 270160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270168 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 270168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 270171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270177 */     GIR_RootConstrainSelectedInstOperands,
     /* 270178 */     // GIR_Coverage, 5078,
     /* 270178 */     GIR_EraseRootFromParent_Done,
     /* 270179 */   // Label 5491: @270179
     /* 270179 */   GIM_Reject,
     /* 270180 */ // Label 5472: @270180
     /* 270180 */ GIM_Reject,
     /* 270181 */ // Label 5389: @270181
     /* 270181 */ GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(270828),
     /* 270186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270189 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 270192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270196 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(270233), // Rule ID 5123 //
     /* 270201 */     // MIs[0] Operand 1
     /* 270201 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 270206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270210 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270216 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270224 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 270227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270231 */     GIR_RootConstrainSelectedInstOperands,
     /* 270232 */     // GIR_Coverage, 5123,
     /* 270232 */     GIR_EraseRootFromParent_Done,
     /* 270233 */   // Label 5493: @270233
     /* 270233 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(270270), // Rule ID 5130 //
     /* 270238 */     // MIs[0] Operand 1
     /* 270238 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 270243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270247 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270253 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270261 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 270264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270268 */     GIR_RootConstrainSelectedInstOperands,
     /* 270269 */     // GIR_Coverage, 5130,
     /* 270269 */     GIR_EraseRootFromParent_Done,
     /* 270270 */   // Label 5494: @270270
     /* 270270 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(270307), // Rule ID 5137 //
     /* 270275 */     // MIs[0] Operand 1
     /* 270275 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 270280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270284 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270290 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270298 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 270301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270305 */     GIR_RootConstrainSelectedInstOperands,
     /* 270306 */     // GIR_Coverage, 5137,
     /* 270306 */     GIR_EraseRootFromParent_Done,
     /* 270307 */   // Label 5495: @270307
     /* 270307 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(270344), // Rule ID 5144 //
     /* 270312 */     // MIs[0] Operand 1
     /* 270312 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 270317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270321 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270327 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270335 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 270338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270342 */     GIR_RootConstrainSelectedInstOperands,
     /* 270343 */     // GIR_Coverage, 5144,
     /* 270343 */     GIR_EraseRootFromParent_Done,
     /* 270344 */   // Label 5496: @270344
     /* 270344 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(270381), // Rule ID 5151 //
     /* 270349 */     // MIs[0] Operand 1
     /* 270349 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 270354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270358 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270364 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270372 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 270375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270379 */     GIR_RootConstrainSelectedInstOperands,
     /* 270380 */     // GIR_Coverage, 5151,
     /* 270380 */     GIR_EraseRootFromParent_Done,
     /* 270381 */   // Label 5497: @270381
     /* 270381 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(270418), // Rule ID 5088 //
     /* 270386 */     // MIs[0] Operand 1
     /* 270386 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 270391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270399 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270405 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270409 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 270412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270416 */     GIR_RootConstrainSelectedInstOperands,
     /* 270417 */     // GIR_Coverage, 5088,
     /* 270417 */     GIR_EraseRootFromParent_Done,
     /* 270418 */   // Label 5498: @270418
     /* 270418 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(270455), // Rule ID 5095 //
     /* 270423 */     // MIs[0] Operand 1
     /* 270423 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 270428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270436 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270442 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270446 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 270449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270453 */     GIR_RootConstrainSelectedInstOperands,
     /* 270454 */     // GIR_Coverage, 5095,
     /* 270454 */     GIR_EraseRootFromParent_Done,
     /* 270455 */   // Label 5499: @270455
     /* 270455 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(270492), // Rule ID 5102 //
     /* 270460 */     // MIs[0] Operand 1
     /* 270460 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 270465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270473 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270479 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270483 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 270486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270490 */     GIR_RootConstrainSelectedInstOperands,
     /* 270491 */     // GIR_Coverage, 5102,
     /* 270491 */     GIR_EraseRootFromParent_Done,
     /* 270492 */   // Label 5500: @270492
     /* 270492 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(270529), // Rule ID 5109 //
     /* 270497 */     // MIs[0] Operand 1
     /* 270497 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 270502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270510 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270516 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270520 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 270523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270527 */     GIR_RootConstrainSelectedInstOperands,
     /* 270528 */     // GIR_Coverage, 5109,
     /* 270528 */     GIR_EraseRootFromParent_Done,
     /* 270529 */   // Label 5501: @270529
     /* 270529 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(270566), // Rule ID 5116 //
     /* 270534 */     // MIs[0] Operand 1
     /* 270534 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 270539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270547 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270553 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270557 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 270557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 270560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270564 */     GIR_RootConstrainSelectedInstOperands,
     /* 270565 */     // GIR_Coverage, 5116,
     /* 270565 */     GIR_EraseRootFromParent_Done,
     /* 270566 */   // Label 5502: @270566
     /* 270566 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(270595), // Rule ID 5025 //
     /* 270571 */     // MIs[0] Operand 1
     /* 270571 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 270576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270584 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 270584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 270587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270593 */     GIR_RootConstrainSelectedInstOperands,
     /* 270594 */     // GIR_Coverage, 5025,
     /* 270594 */     GIR_EraseRootFromParent_Done,
     /* 270595 */   // Label 5503: @270595
     /* 270595 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(270624), // Rule ID 5032 //
     /* 270600 */     // MIs[0] Operand 1
     /* 270600 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 270605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270613 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 270613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 270616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270622 */     GIR_RootConstrainSelectedInstOperands,
     /* 270623 */     // GIR_Coverage, 5032,
     /* 270623 */     GIR_EraseRootFromParent_Done,
     /* 270624 */   // Label 5504: @270624
     /* 270624 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(270653), // Rule ID 5039 //
     /* 270629 */     // MIs[0] Operand 1
     /* 270629 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 270634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270642 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 270642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 270645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270651 */     GIR_RootConstrainSelectedInstOperands,
     /* 270652 */     // GIR_Coverage, 5039,
     /* 270652 */     GIR_EraseRootFromParent_Done,
     /* 270653 */   // Label 5505: @270653
     /* 270653 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(270682), // Rule ID 5046 //
     /* 270658 */     // MIs[0] Operand 1
     /* 270658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 270663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270671 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 270671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 270674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270680 */     GIR_RootConstrainSelectedInstOperands,
     /* 270681 */     // GIR_Coverage, 5046,
     /* 270681 */     GIR_EraseRootFromParent_Done,
     /* 270682 */   // Label 5506: @270682
     /* 270682 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(270711), // Rule ID 5053 //
     /* 270687 */     // MIs[0] Operand 1
     /* 270687 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 270692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270700 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 270700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 270703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270709 */     GIR_RootConstrainSelectedInstOperands,
     /* 270710 */     // GIR_Coverage, 5053,
     /* 270710 */     GIR_EraseRootFromParent_Done,
     /* 270711 */   // Label 5507: @270711
     /* 270711 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(270740), // Rule ID 5060 //
     /* 270716 */     // MIs[0] Operand 1
     /* 270716 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 270721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270729 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 270729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 270732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270738 */     GIR_RootConstrainSelectedInstOperands,
     /* 270739 */     // GIR_Coverage, 5060,
     /* 270739 */     GIR_EraseRootFromParent_Done,
     /* 270740 */   // Label 5508: @270740
     /* 270740 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(270769), // Rule ID 5067 //
     /* 270745 */     // MIs[0] Operand 1
     /* 270745 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 270750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270758 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 270758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 270761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270767 */     GIR_RootConstrainSelectedInstOperands,
     /* 270768 */     // GIR_Coverage, 5067,
     /* 270768 */     GIR_EraseRootFromParent_Done,
     /* 270769 */   // Label 5509: @270769
     /* 270769 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(270798), // Rule ID 5074 //
     /* 270774 */     // MIs[0] Operand 1
     /* 270774 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 270779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270787 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 270787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 270790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270796 */     GIR_RootConstrainSelectedInstOperands,
     /* 270797 */     // GIR_Coverage, 5074,
     /* 270797 */     GIR_EraseRootFromParent_Done,
     /* 270798 */   // Label 5510: @270798
     /* 270798 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(270827), // Rule ID 5081 //
     /* 270803 */     // MIs[0] Operand 1
     /* 270803 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 270808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270816 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 270816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 270819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270825 */     GIR_RootConstrainSelectedInstOperands,
     /* 270826 */     // GIR_Coverage, 5081,
     /* 270826 */     GIR_EraseRootFromParent_Done,
     /* 270827 */   // Label 5511: @270827
     /* 270827 */   GIM_Reject,
     /* 270828 */ // Label 5492: @270828
     /* 270828 */ GIM_Reject,
     /* 270829 */ // Label 5390: @270829
     /* 270829 */ GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(271476),
     /* 270834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270837 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 270840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270844 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(270881), // Rule ID 5121 //
     /* 270849 */     // MIs[0] Operand 1
     /* 270849 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 270854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270858 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270864 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270872 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 270872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 270875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270879 */     GIR_RootConstrainSelectedInstOperands,
     /* 270880 */     // GIR_Coverage, 5121,
     /* 270880 */     GIR_EraseRootFromParent_Done,
     /* 270881 */   // Label 5513: @270881
     /* 270881 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(270918), // Rule ID 5128 //
     /* 270886 */     // MIs[0] Operand 1
     /* 270886 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 270891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270895 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270901 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270909 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 270909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 270912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270916 */     GIR_RootConstrainSelectedInstOperands,
     /* 270917 */     // GIR_Coverage, 5128,
     /* 270917 */     GIR_EraseRootFromParent_Done,
     /* 270918 */   // Label 5514: @270918
     /* 270918 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(270955), // Rule ID 5135 //
     /* 270923 */     // MIs[0] Operand 1
     /* 270923 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 270928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270932 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270938 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270946 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 270946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 270949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270953 */     GIR_RootConstrainSelectedInstOperands,
     /* 270954 */     // GIR_Coverage, 5135,
     /* 270954 */     GIR_EraseRootFromParent_Done,
     /* 270955 */   // Label 5515: @270955
     /* 270955 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(270992), // Rule ID 5142 //
     /* 270960 */     // MIs[0] Operand 1
     /* 270960 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 270965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270969 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270975 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270983 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 270983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 270986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270990 */     GIR_RootConstrainSelectedInstOperands,
     /* 270991 */     // GIR_Coverage, 5142,
     /* 270991 */     GIR_EraseRootFromParent_Done,
     /* 270992 */   // Label 5516: @270992
     /* 270992 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(271029), // Rule ID 5149 //
     /* 270997 */     // MIs[0] Operand 1
     /* 270997 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 271002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271006 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271012 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271020 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 271020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 271023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271027 */     GIR_RootConstrainSelectedInstOperands,
     /* 271028 */     // GIR_Coverage, 5149,
     /* 271028 */     GIR_EraseRootFromParent_Done,
     /* 271029 */   // Label 5517: @271029
     /* 271029 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(271066), // Rule ID 5086 //
     /* 271034 */     // MIs[0] Operand 1
     /* 271034 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271047 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271053 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271057 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 271057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 271060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271064 */     GIR_RootConstrainSelectedInstOperands,
     /* 271065 */     // GIR_Coverage, 5086,
     /* 271065 */     GIR_EraseRootFromParent_Done,
     /* 271066 */   // Label 5518: @271066
     /* 271066 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(271103), // Rule ID 5093 //
     /* 271071 */     // MIs[0] Operand 1
     /* 271071 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271084 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271090 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271094 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 271094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 271097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271101 */     GIR_RootConstrainSelectedInstOperands,
     /* 271102 */     // GIR_Coverage, 5093,
     /* 271102 */     GIR_EraseRootFromParent_Done,
     /* 271103 */   // Label 5519: @271103
     /* 271103 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(271140), // Rule ID 5100 //
     /* 271108 */     // MIs[0] Operand 1
     /* 271108 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271121 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271127 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271131 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 271131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 271134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271138 */     GIR_RootConstrainSelectedInstOperands,
     /* 271139 */     // GIR_Coverage, 5100,
     /* 271139 */     GIR_EraseRootFromParent_Done,
     /* 271140 */   // Label 5520: @271140
     /* 271140 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(271177), // Rule ID 5107 //
     /* 271145 */     // MIs[0] Operand 1
     /* 271145 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 271150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271158 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271164 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271168 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 271168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 271171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271175 */     GIR_RootConstrainSelectedInstOperands,
     /* 271176 */     // GIR_Coverage, 5107,
     /* 271176 */     GIR_EraseRootFromParent_Done,
     /* 271177 */   // Label 5521: @271177
     /* 271177 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(271214), // Rule ID 5114 //
     /* 271182 */     // MIs[0] Operand 1
     /* 271182 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 271187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271195 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271201 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271205 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 271205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 271208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271212 */     GIR_RootConstrainSelectedInstOperands,
     /* 271213 */     // GIR_Coverage, 5114,
     /* 271213 */     GIR_EraseRootFromParent_Done,
     /* 271214 */   // Label 5522: @271214
     /* 271214 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(271243), // Rule ID 5023 //
     /* 271219 */     // MIs[0] Operand 1
     /* 271219 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271232 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 271235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271241 */     GIR_RootConstrainSelectedInstOperands,
     /* 271242 */     // GIR_Coverage, 5023,
     /* 271242 */     GIR_EraseRootFromParent_Done,
     /* 271243 */   // Label 5523: @271243
     /* 271243 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(271272), // Rule ID 5030 //
     /* 271248 */     // MIs[0] Operand 1
     /* 271248 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271261 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 271264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271270 */     GIR_RootConstrainSelectedInstOperands,
     /* 271271 */     // GIR_Coverage, 5030,
     /* 271271 */     GIR_EraseRootFromParent_Done,
     /* 271272 */   // Label 5524: @271272
     /* 271272 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(271301), // Rule ID 5037 //
     /* 271277 */     // MIs[0] Operand 1
     /* 271277 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271290 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 271293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271299 */     GIR_RootConstrainSelectedInstOperands,
     /* 271300 */     // GIR_Coverage, 5037,
     /* 271300 */     GIR_EraseRootFromParent_Done,
     /* 271301 */   // Label 5525: @271301
     /* 271301 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(271330), // Rule ID 5044 //
     /* 271306 */     // MIs[0] Operand 1
     /* 271306 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 271311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271319 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 271322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271328 */     GIR_RootConstrainSelectedInstOperands,
     /* 271329 */     // GIR_Coverage, 5044,
     /* 271329 */     GIR_EraseRootFromParent_Done,
     /* 271330 */   // Label 5526: @271330
     /* 271330 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(271359), // Rule ID 5051 //
     /* 271335 */     // MIs[0] Operand 1
     /* 271335 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 271340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271348 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 271351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271357 */     GIR_RootConstrainSelectedInstOperands,
     /* 271358 */     // GIR_Coverage, 5051,
     /* 271358 */     GIR_EraseRootFromParent_Done,
     /* 271359 */   // Label 5527: @271359
     /* 271359 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(271388), // Rule ID 5058 //
     /* 271364 */     // MIs[0] Operand 1
     /* 271364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 271369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271377 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 271377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 271380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271386 */     GIR_RootConstrainSelectedInstOperands,
     /* 271387 */     // GIR_Coverage, 5058,
     /* 271387 */     GIR_EraseRootFromParent_Done,
     /* 271388 */   // Label 5528: @271388
     /* 271388 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(271417), // Rule ID 5065 //
     /* 271393 */     // MIs[0] Operand 1
     /* 271393 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 271398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271406 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 271406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 271409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271415 */     GIR_RootConstrainSelectedInstOperands,
     /* 271416 */     // GIR_Coverage, 5065,
     /* 271416 */     GIR_EraseRootFromParent_Done,
     /* 271417 */   // Label 5529: @271417
     /* 271417 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(271446), // Rule ID 5072 //
     /* 271422 */     // MIs[0] Operand 1
     /* 271422 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 271427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271435 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 271435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 271438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271444 */     GIR_RootConstrainSelectedInstOperands,
     /* 271445 */     // GIR_Coverage, 5072,
     /* 271445 */     GIR_EraseRootFromParent_Done,
     /* 271446 */   // Label 5530: @271446
     /* 271446 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(271475), // Rule ID 5079 //
     /* 271451 */     // MIs[0] Operand 1
     /* 271451 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 271456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271464 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 271464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 271467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271473 */     GIR_RootConstrainSelectedInstOperands,
     /* 271474 */     // GIR_Coverage, 5079,
     /* 271474 */     GIR_EraseRootFromParent_Done,
     /* 271475 */   // Label 5531: @271475
     /* 271475 */   GIM_Reject,
     /* 271476 */ // Label 5512: @271476
     /* 271476 */ GIM_Reject,
     /* 271477 */ // Label 5391: @271477
     /* 271477 */ GIM_Reject,
     /* 271478 */ // Label 50: @271478
     /* 271478 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5544*/ GIMT_Encode4(272522),
     /* 271489 */ /*GILLT_nxv1s1*//*Label 5532*/ GIMT_Encode4(271537),
     /* 271493 */ /*GILLT_nxv2s1*//*Label 5533*/ GIMT_Encode4(271566),
     /* 271497 */ /*GILLT_nxv2s16*//*Label 5534*/ GIMT_Encode4(271595),
     /* 271501 */ /*GILLT_nxv2s32*//*Label 5535*/ GIMT_Encode4(271680),
     /* 271505 */ /*GILLT_nxv2s64*//*Label 5536*/ GIMT_Encode4(271765),
     /* 271509 */ /*GILLT_nxv4s1*//*Label 5537*/ GIMT_Encode4(271931),
     /* 271513 */ /*GILLT_nxv4s16*//*Label 5538*/ GIMT_Encode4(271960),
     /* 271517 */ /*GILLT_nxv4s32*//*Label 5539*/ GIMT_Encode4(272045),
     /* 271521 */ /*GILLT_nxv8s1*//*Label 5540*/ GIMT_Encode4(272211),
     /* 271525 */ /*GILLT_nxv8s16*//*Label 5541*/ GIMT_Encode4(272240),
     /* 271529 */ /*GILLT_nxv16s1*//*Label 5542*/ GIMT_Encode4(272406),
     /* 271533 */ /*GILLT_nxv16s8*//*Label 5543*/ GIMT_Encode4(272435),
     /* 271537 */ // Label 5532: @271537
     /* 271537 */ GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(271565), // Rule ID 8346 //
     /* 271542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 271548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271551 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 271554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 271558 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 271558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 271563 */   GIR_RootConstrainSelectedInstOperands,
     /* 271564 */   // GIR_Coverage, 8346,
     /* 271564 */   GIR_Done,
     /* 271565 */ // Label 5545: @271565
     /* 271565 */ GIM_Reject,
     /* 271566 */ // Label 5533: @271566
     /* 271566 */ GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(271594), // Rule ID 8345 //
     /* 271571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 271580 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 271583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 271587 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 271587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 271592 */   GIR_RootConstrainSelectedInstOperands,
     /* 271593 */   // GIR_Coverage, 8345,
     /* 271593 */   GIR_Done,
     /* 271594 */ // Label 5546: @271594
     /* 271594 */ GIM_Reject,
     /* 271595 */ // Label 5534: @271595
     /* 271595 */ GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(271679),
     /* 271600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 271606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 271609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271613 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(271663), // Rule ID 3152 //
     /* 271618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 271629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 271633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 271637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 271641 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 271645 */     // MIs[2] Operand 1
     /* 271645 */     // No operand predicates
     /* 271645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271647 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 271647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 271650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 271652 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 271654 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 271656 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 271661 */     GIR_RootConstrainSelectedInstOperands,
     /* 271662 */     // GIR_Coverage, 3152,
     /* 271662 */     GIR_EraseRootFromParent_Done,
     /* 271663 */   // Label 5548: @271663
     /* 271663 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(271678), // Rule ID 2732 //
     /* 271668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271671 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 271671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 271676 */     GIR_RootConstrainSelectedInstOperands,
     /* 271677 */     // GIR_Coverage, 2732,
     /* 271677 */     GIR_Done,
     /* 271678 */   // Label 5549: @271678
     /* 271678 */   GIM_Reject,
     /* 271679 */ // Label 5547: @271679
     /* 271679 */ GIM_Reject,
     /* 271680 */ // Label 5535: @271680
     /* 271680 */ GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(271764),
     /* 271685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 271691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 271694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271698 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(271748), // Rule ID 3154 //
     /* 271703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 271714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 271722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 271726 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 271730 */     // MIs[2] Operand 1
     /* 271730 */     // No operand predicates
     /* 271730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271732 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 271732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 271735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 271737 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 271739 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 271741 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 271746 */     GIR_RootConstrainSelectedInstOperands,
     /* 271747 */     // GIR_Coverage, 3154,
     /* 271747 */     GIR_EraseRootFromParent_Done,
     /* 271748 */   // Label 5551: @271748
     /* 271748 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(271763), // Rule ID 2733 //
     /* 271753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271756 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 271756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 271761 */     GIR_RootConstrainSelectedInstOperands,
     /* 271762 */     // GIR_Coverage, 2733,
     /* 271762 */     GIR_Done,
     /* 271763 */   // Label 5552: @271763
     /* 271763 */   GIM_Reject,
     /* 271764 */ // Label 5550: @271764
     /* 271764 */ GIM_Reject,
     /* 271765 */ // Label 5536: @271765
     /* 271765 */ GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(271930),
     /* 271770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271776 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(271833), // Rule ID 3155 //
     /* 271781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 271799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 271807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 271811 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 271815 */     // MIs[2] Operand 1
     /* 271815 */     // No operand predicates
     /* 271815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271817 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 271817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 271820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 271822 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 271824 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 271826 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 271831 */     GIR_RootConstrainSelectedInstOperands,
     /* 271832 */     // GIR_Coverage, 3155,
     /* 271832 */     GIR_EraseRootFromParent_Done,
     /* 271833 */   // Label 5554: @271833
     /* 271833 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(271885), // Rule ID 7396 //
     /* 271838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 271853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271861 */     // MIs[0] Op2
     /* 271861 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 271866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271868 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 271868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 271871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 271873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 271875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 271879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 271883 */     GIR_RootConstrainSelectedInstOperands,
     /* 271884 */     // GIR_Coverage, 7396,
     /* 271884 */     GIR_EraseRootFromParent_Done,
     /* 271885 */   // Label 5555: @271885
     /* 271885 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(271907), // Rule ID 2728 //
     /* 271890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271900 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 271900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 271905 */     GIR_RootConstrainSelectedInstOperands,
     /* 271906 */     // GIR_Coverage, 2728,
     /* 271906 */     GIR_Done,
     /* 271907 */   // Label 5556: @271907
     /* 271907 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(271929), // Rule ID 2734 //
     /* 271912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271922 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 271922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 271927 */     GIR_RootConstrainSelectedInstOperands,
     /* 271928 */     // GIR_Coverage, 2734,
     /* 271928 */     GIR_Done,
     /* 271929 */   // Label 5557: @271929
     /* 271929 */   GIM_Reject,
     /* 271930 */ // Label 5553: @271930
     /* 271930 */ GIM_Reject,
     /* 271931 */ // Label 5537: @271931
     /* 271931 */ GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(271959), // Rule ID 8344 //
     /* 271936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 271945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 271948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 271952 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 271952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 271957 */   GIR_RootConstrainSelectedInstOperands,
     /* 271958 */   // GIR_Coverage, 8344,
     /* 271958 */   GIR_Done,
     /* 271959 */ // Label 5558: @271959
     /* 271959 */ GIM_Reject,
     /* 271960 */ // Label 5538: @271960
     /* 271960 */ GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(272044),
     /* 271965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 271971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 271974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271978 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(272028), // Rule ID 3151 //
     /* 271983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 271994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 271998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 272002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 272006 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 272010 */     // MIs[2] Operand 1
     /* 272010 */     // No operand predicates
     /* 272010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272012 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 272012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 272015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 272017 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 272019 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 272021 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 272026 */     GIR_RootConstrainSelectedInstOperands,
     /* 272027 */     // GIR_Coverage, 3151,
     /* 272027 */     GIR_EraseRootFromParent_Done,
     /* 272028 */   // Label 5560: @272028
     /* 272028 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(272043), // Rule ID 2730 //
     /* 272033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272036 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 272036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 272041 */     GIR_RootConstrainSelectedInstOperands,
     /* 272042 */     // GIR_Coverage, 2730,
     /* 272042 */     GIR_Done,
     /* 272043 */   // Label 5561: @272043
     /* 272043 */   GIM_Reject,
     /* 272044 */ // Label 5559: @272044
     /* 272044 */ GIM_Reject,
     /* 272045 */ // Label 5539: @272045
     /* 272045 */ GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(272210),
     /* 272050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272056 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(272113), // Rule ID 3153 //
     /* 272061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 272079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 272087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 272091 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 272095 */     // MIs[2] Operand 1
     /* 272095 */     // No operand predicates
     /* 272095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272097 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 272097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 272100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 272102 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 272104 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 272106 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 272111 */     GIR_RootConstrainSelectedInstOperands,
     /* 272112 */     // GIR_Coverage, 3153,
     /* 272112 */     GIR_EraseRootFromParent_Done,
     /* 272113 */   // Label 5563: @272113
     /* 272113 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(272165), // Rule ID 7394 //
     /* 272118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 272133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 272137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272141 */     // MIs[0] Op2
     /* 272141 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 272146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272148 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 272148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 272151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 272153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 272155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 272159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 272163 */     GIR_RootConstrainSelectedInstOperands,
     /* 272164 */     // GIR_Coverage, 7394,
     /* 272164 */     GIR_EraseRootFromParent_Done,
     /* 272165 */   // Label 5564: @272165
     /* 272165 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(272187), // Rule ID 2727 //
     /* 272170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272180 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 272180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 272185 */     GIR_RootConstrainSelectedInstOperands,
     /* 272186 */     // GIR_Coverage, 2727,
     /* 272186 */     GIR_Done,
     /* 272187 */   // Label 5565: @272187
     /* 272187 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(272209), // Rule ID 2731 //
     /* 272192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272202 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 272202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 272207 */     GIR_RootConstrainSelectedInstOperands,
     /* 272208 */     // GIR_Coverage, 2731,
     /* 272208 */     GIR_Done,
     /* 272209 */   // Label 5566: @272209
     /* 272209 */   GIM_Reject,
     /* 272210 */ // Label 5562: @272210
     /* 272210 */ GIM_Reject,
     /* 272211 */ // Label 5540: @272211
     /* 272211 */ GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(272239), // Rule ID 8343 //
     /* 272216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 272222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 272225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 272228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 272232 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 272232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 272237 */   GIR_RootConstrainSelectedInstOperands,
     /* 272238 */   // GIR_Coverage, 8343,
     /* 272238 */   GIR_Done,
     /* 272239 */ // Label 5567: @272239
     /* 272239 */ GIM_Reject,
     /* 272240 */ // Label 5541: @272240
     /* 272240 */ GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(272405),
     /* 272245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 272248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272251 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(272308), // Rule ID 3150 //
     /* 272256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 272262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 272274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 272278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 272282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 272286 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 272290 */     // MIs[2] Operand 1
     /* 272290 */     // No operand predicates
     /* 272290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272292 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 272292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 272295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 272297 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 272299 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 272301 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 272306 */     GIR_RootConstrainSelectedInstOperands,
     /* 272307 */     // GIR_Coverage, 3150,
     /* 272307 */     GIR_EraseRootFromParent_Done,
     /* 272308 */   // Label 5569: @272308
     /* 272308 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(272360), // Rule ID 7392 //
     /* 272313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 272328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 272332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272336 */     // MIs[0] Op2
     /* 272336 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 272341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272343 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 272343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 272346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 272348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 272350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 272354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 272358 */     GIR_RootConstrainSelectedInstOperands,
     /* 272359 */     // GIR_Coverage, 7392,
     /* 272359 */     GIR_EraseRootFromParent_Done,
     /* 272360 */   // Label 5570: @272360
     /* 272360 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(272382), // Rule ID 2726 //
     /* 272365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 272371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272375 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 272375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 272380 */     GIR_RootConstrainSelectedInstOperands,
     /* 272381 */     // GIR_Coverage, 2726,
     /* 272381 */     GIR_Done,
     /* 272382 */   // Label 5571: @272382
     /* 272382 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(272404), // Rule ID 2729 //
     /* 272387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 272393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272397 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 272397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 272402 */     GIR_RootConstrainSelectedInstOperands,
     /* 272403 */     // GIR_Coverage, 2729,
     /* 272403 */     GIR_Done,
     /* 272404 */   // Label 5572: @272404
     /* 272404 */   GIM_Reject,
     /* 272405 */ // Label 5568: @272405
     /* 272405 */ GIM_Reject,
     /* 272406 */ // Label 5542: @272406
     /* 272406 */ GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(272434), // Rule ID 8342 //
     /* 272411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 272417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 272420 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 272423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 272427 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 272427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 272432 */   GIR_RootConstrainSelectedInstOperands,
     /* 272433 */   // GIR_Coverage, 8342,
     /* 272433 */   GIR_Done,
     /* 272434 */ // Label 5573: @272434
     /* 272434 */ GIM_Reject,
     /* 272435 */ // Label 5543: @272435
     /* 272435 */ GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(272521),
     /* 272440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 272443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 272446 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(272498), // Rule ID 7390 //
     /* 272451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 272466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 272470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 272474 */     // MIs[0] Op2
     /* 272474 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 272479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272481 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 272484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 272486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 272488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 272492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 272496 */     GIR_RootConstrainSelectedInstOperands,
     /* 272497 */     // GIR_Coverage, 7390,
     /* 272497 */     GIR_EraseRootFromParent_Done,
     /* 272498 */   // Label 5575: @272498
     /* 272498 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(272520), // Rule ID 2725 //
     /* 272503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272513 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 272518 */     GIR_RootConstrainSelectedInstOperands,
     /* 272519 */     // GIR_Coverage, 2725,
     /* 272519 */     GIR_Done,
     /* 272520 */   // Label 5576: @272520
     /* 272520 */   GIM_Reject,
     /* 272521 */ // Label 5574: @272521
     /* 272521 */ GIM_Reject,
     /* 272522 */ // Label 5544: @272522
     /* 272522 */ GIM_Reject,
     /* 272523 */ // Label 51: @272523
     /* 272523 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5581*/ GIMT_Encode4(273006),
     /* 272534 */ /*GILLT_s64*//*Label 5577*/ GIMT_Encode4(272570), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272554 */ /*GILLT_v4s32*//*Label 5578*/ GIMT_Encode4(272601), GIMT_Encode4(0),
     /* 272562 */ /*GILLT_v8s16*//*Label 5579*/ GIMT_Encode4(272736),
     /* 272566 */ /*GILLT_v16s8*//*Label 5580*/ GIMT_Encode4(272871),
     /* 272570 */ // Label 5577: @272570
     /* 272570 */ GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(272600), // Rule ID 128 //
     /* 272575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 272578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272593 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 272593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 272598 */   GIR_RootConstrainSelectedInstOperands,
     /* 272599 */   // GIR_Coverage, 128,
     /* 272599 */   GIR_Done,
     /* 272600 */ // Label 5582: @272600
     /* 272600 */ GIM_Reject,
     /* 272601 */ // Label 5578: @272601
     /* 272601 */ GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(272735), // Rule ID 6448 //
     /* 272606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272624 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 272624 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 272627 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 272631 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272636 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 272640 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 272644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 272646 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 272649 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272653 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272658 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 272664 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272669 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272674 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 272677 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272681 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272686 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272692 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272697 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 272705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 272709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272714 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 272717 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 272720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 272722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 272725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 272733 */   GIR_RootConstrainSelectedInstOperands,
     /* 272734 */   // GIR_Coverage, 6448,
     /* 272734 */   GIR_EraseRootFromParent_Done,
     /* 272735 */ // Label 5583: @272735
     /* 272735 */ GIM_Reject,
     /* 272736 */ // Label 5579: @272736
     /* 272736 */ GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(272870), // Rule ID 6447 //
     /* 272741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272759 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 272759 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 272762 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 272766 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272771 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 272775 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 272779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 272781 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 272784 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272788 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272793 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 272799 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272804 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272809 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 272812 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272816 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272821 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272827 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272832 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 272840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 272844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272849 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 272852 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 272855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 272857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 272860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 272868 */   GIR_RootConstrainSelectedInstOperands,
     /* 272869 */   // GIR_Coverage, 6447,
     /* 272869 */   GIR_EraseRootFromParent_Done,
     /* 272870 */ // Label 5584: @272870
     /* 272870 */ GIM_Reject,
     /* 272871 */ // Label 5580: @272871
     /* 272871 */ GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(273005), // Rule ID 6446 //
     /* 272876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 272879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 272882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272894 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 272894 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 272897 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 272901 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272906 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 272910 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 272914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 272916 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 272919 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272923 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272928 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 272934 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272939 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272944 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 272947 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272951 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272956 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272962 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272967 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 272975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 272979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272984 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 272987 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 272990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 272992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 272995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 273003 */   GIR_RootConstrainSelectedInstOperands,
     /* 273004 */   // GIR_Coverage, 6446,
     /* 273004 */   GIR_EraseRootFromParent_Done,
     /* 273005 */ // Label 5585: @273005
     /* 273005 */ GIM_Reject,
     /* 273006 */ // Label 5581: @273006
     /* 273006 */ GIM_Reject,
     /* 273007 */ // Label 52: @273007
     /* 273007 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5590*/ GIMT_Encode4(273490),
     /* 273018 */ /*GILLT_s64*//*Label 5586*/ GIMT_Encode4(273054), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 273038 */ /*GILLT_v4s32*//*Label 5587*/ GIMT_Encode4(273085), GIMT_Encode4(0),
     /* 273046 */ /*GILLT_v8s16*//*Label 5588*/ GIMT_Encode4(273220),
     /* 273050 */ /*GILLT_v16s8*//*Label 5589*/ GIMT_Encode4(273355),
     /* 273054 */ // Label 5586: @273054
     /* 273054 */ GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(273084), // Rule ID 127 //
     /* 273059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 273062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273077 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 273077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 273082 */   GIR_RootConstrainSelectedInstOperands,
     /* 273083 */   // GIR_Coverage, 127,
     /* 273083 */   GIR_Done,
     /* 273084 */ // Label 5591: @273084
     /* 273084 */ GIM_Reject,
     /* 273085 */ // Label 5587: @273085
     /* 273085 */ GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(273219), // Rule ID 6445 //
     /* 273090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273108 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 273108 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 273111 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 273115 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273120 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 273124 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 273128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 273130 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 273133 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273137 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273142 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 273148 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 273161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273170 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 273176 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273181 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 273189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 273193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273198 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 273201 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 273204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 273206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 273209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 273217 */   GIR_RootConstrainSelectedInstOperands,
     /* 273218 */   // GIR_Coverage, 6445,
     /* 273218 */   GIR_EraseRootFromParent_Done,
     /* 273219 */ // Label 5592: @273219
     /* 273219 */ GIM_Reject,
     /* 273220 */ // Label 5588: @273220
     /* 273220 */ GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(273354), // Rule ID 6444 //
     /* 273225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 273228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273243 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 273243 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 273246 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 273250 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273255 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 273259 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 273263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 273265 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 273268 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273272 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273277 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 273283 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273288 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273293 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 273296 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273300 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273305 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 273311 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 273324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 273328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 273336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 273339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 273341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 273344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 273352 */   GIR_RootConstrainSelectedInstOperands,
     /* 273353 */   // GIR_Coverage, 6444,
     /* 273353 */   GIR_EraseRootFromParent_Done,
     /* 273354 */ // Label 5593: @273354
     /* 273354 */ GIM_Reject,
     /* 273355 */ // Label 5589: @273355
     /* 273355 */ GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(273489), // Rule ID 6443 //
     /* 273360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 273363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 273366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273378 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 273378 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 273381 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 273385 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273390 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 273394 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 273398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 273400 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 273403 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273407 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273412 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 273418 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273423 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273428 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 273431 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273435 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273440 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 273446 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273451 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 273459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 273463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273468 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 273471 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 273474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 273476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 273479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 273487 */   GIR_RootConstrainSelectedInstOperands,
     /* 273488 */   // GIR_Coverage, 6443,
     /* 273488 */   GIR_EraseRootFromParent_Done,
     /* 273489 */ // Label 5594: @273489
     /* 273489 */ GIM_Reject,
     /* 273490 */ // Label 5590: @273490
     /* 273490 */ GIM_Reject,
     /* 273491 */ // Label 53: @273491
     /* 273491 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5606*/ GIMT_Encode4(273920),
     /* 273502 */ /*GILLT_v2s32*//*Label 5595*/ GIMT_Encode4(273578),
     /* 273506 */ /*GILLT_v2s64*//*Label 5596*/ GIMT_Encode4(273612),
     /* 273510 */ /*GILLT_v4s16*//*Label 5597*/ GIMT_Encode4(273646),
     /* 273514 */ /*GILLT_v4s32*//*Label 5598*/ GIMT_Encode4(273680),
     /* 273518 */ /*GILLT_v8s8*//*Label 5599*/ GIMT_Encode4(273714),
     /* 273522 */ /*GILLT_v8s16*//*Label 5600*/ GIMT_Encode4(273748),
     /* 273526 */ /*GILLT_v16s8*//*Label 5601*/ GIMT_Encode4(273782), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 273546 */ /*GILLT_nxv2s64*//*Label 5602*/ GIMT_Encode4(273816), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 273558 */ /*GILLT_nxv4s32*//*Label 5603*/ GIMT_Encode4(273842), GIMT_Encode4(0),
     /* 273566 */ /*GILLT_nxv8s16*//*Label 5604*/ GIMT_Encode4(273868), GIMT_Encode4(0),
     /* 273574 */ /*GILLT_nxv16s8*//*Label 5605*/ GIMT_Encode4(273894),
     /* 273578 */ // Label 5595: @273578
     /* 273578 */ GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(273611), // Rule ID 4971 //
     /* 273583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 273589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273604 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 273604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 273609 */   GIR_RootConstrainSelectedInstOperands,
     /* 273610 */   // GIR_Coverage, 4971,
     /* 273610 */   GIR_Done,
     /* 273611 */ // Label 5607: @273611
     /* 273611 */ GIM_Reject,
     /* 273612 */ // Label 5596: @273612
     /* 273612 */ GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(273645), // Rule ID 4975 //
     /* 273617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273638 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 273638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 273643 */   GIR_RootConstrainSelectedInstOperands,
     /* 273644 */   // GIR_Coverage, 4975,
     /* 273644 */   GIR_Done,
     /* 273645 */ // Label 5608: @273645
     /* 273645 */ GIM_Reject,
     /* 273646 */ // Label 5597: @273646
     /* 273646 */ GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(273679), // Rule ID 4970 //
     /* 273651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 273657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273672 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 273672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 273677 */   GIR_RootConstrainSelectedInstOperands,
     /* 273678 */   // GIR_Coverage, 4970,
     /* 273678 */   GIR_Done,
     /* 273679 */ // Label 5609: @273679
     /* 273679 */ GIM_Reject,
     /* 273680 */ // Label 5598: @273680
     /* 273680 */ GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(273713), // Rule ID 4974 //
     /* 273685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273706 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 273706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 273711 */   GIR_RootConstrainSelectedInstOperands,
     /* 273712 */   // GIR_Coverage, 4974,
     /* 273712 */   GIR_Done,
     /* 273713 */ // Label 5610: @273713
     /* 273713 */ GIM_Reject,
     /* 273714 */ // Label 5599: @273714
     /* 273714 */ GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(273747), // Rule ID 4969 //
     /* 273719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 273725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 273728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273740 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 273740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 273745 */   GIR_RootConstrainSelectedInstOperands,
     /* 273746 */   // GIR_Coverage, 4969,
     /* 273746 */   GIR_Done,
     /* 273747 */ // Label 5611: @273747
     /* 273747 */ GIM_Reject,
     /* 273748 */ // Label 5600: @273748
     /* 273748 */ GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(273781), // Rule ID 4973 //
     /* 273753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 273759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273774 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 273774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 273779 */   GIR_RootConstrainSelectedInstOperands,
     /* 273780 */   // GIR_Coverage, 4973,
     /* 273780 */   GIR_Done,
     /* 273781 */ // Label 5612: @273781
     /* 273781 */ GIM_Reject,
     /* 273782 */ // Label 5601: @273782
     /* 273782 */ GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(273815), // Rule ID 4972 //
     /* 273787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 273793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 273796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273808 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 273808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 273813 */   GIR_RootConstrainSelectedInstOperands,
     /* 273814 */   // GIR_Coverage, 4972,
     /* 273814 */   GIR_Done,
     /* 273815 */ // Label 5613: @273815
     /* 273815 */ GIM_Reject,
     /* 273816 */ // Label 5602: @273816
     /* 273816 */ GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(273841), // Rule ID 7348 //
     /* 273821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 273827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 273830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273834 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 273834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 273839 */   GIR_RootConstrainSelectedInstOperands,
     /* 273840 */   // GIR_Coverage, 7348,
     /* 273840 */   GIR_Done,
     /* 273841 */ // Label 5614: @273841
     /* 273841 */ GIM_Reject,
     /* 273842 */ // Label 5603: @273842
     /* 273842 */ GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(273867), // Rule ID 7347 //
     /* 273847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 273853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 273856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273860 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 273860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 273865 */   GIR_RootConstrainSelectedInstOperands,
     /* 273866 */   // GIR_Coverage, 7347,
     /* 273866 */   GIR_Done,
     /* 273867 */ // Label 5615: @273867
     /* 273867 */ GIM_Reject,
     /* 273868 */ // Label 5604: @273868
     /* 273868 */ GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(273893), // Rule ID 7346 //
     /* 273873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 273879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 273882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273886 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 273886 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 273891 */   GIR_RootConstrainSelectedInstOperands,
     /* 273892 */   // GIR_Coverage, 7346,
     /* 273892 */   GIR_Done,
     /* 273893 */ // Label 5616: @273893
     /* 273893 */ GIM_Reject,
     /* 273894 */ // Label 5605: @273894
     /* 273894 */ GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(273919), // Rule ID 7345 //
     /* 273899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 273905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 273908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273912 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 273912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 273917 */   GIR_RootConstrainSelectedInstOperands,
     /* 273918 */   // GIR_Coverage, 7345,
     /* 273918 */   GIR_Done,
     /* 273919 */ // Label 5617: @273919
     /* 273919 */ GIM_Reject,
     /* 273920 */ // Label 5606: @273920
     /* 273920 */ GIM_Reject,
     /* 273921 */ // Label 54: @273921
     /* 273921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5629*/ GIMT_Encode4(274350),
     /* 273932 */ /*GILLT_v2s32*//*Label 5618*/ GIMT_Encode4(274008),
     /* 273936 */ /*GILLT_v2s64*//*Label 5619*/ GIMT_Encode4(274042),
     /* 273940 */ /*GILLT_v4s16*//*Label 5620*/ GIMT_Encode4(274076),
     /* 273944 */ /*GILLT_v4s32*//*Label 5621*/ GIMT_Encode4(274110),
     /* 273948 */ /*GILLT_v8s8*//*Label 5622*/ GIMT_Encode4(274144),
     /* 273952 */ /*GILLT_v8s16*//*Label 5623*/ GIMT_Encode4(274178),
     /* 273956 */ /*GILLT_v16s8*//*Label 5624*/ GIMT_Encode4(274212), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 273976 */ /*GILLT_nxv2s64*//*Label 5625*/ GIMT_Encode4(274246), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 273988 */ /*GILLT_nxv4s32*//*Label 5626*/ GIMT_Encode4(274272), GIMT_Encode4(0),
     /* 273996 */ /*GILLT_nxv8s16*//*Label 5627*/ GIMT_Encode4(274298), GIMT_Encode4(0),
     /* 274004 */ /*GILLT_nxv16s8*//*Label 5628*/ GIMT_Encode4(274324),
     /* 274008 */ // Label 5618: @274008
     /* 274008 */ GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(274041), // Rule ID 2468 //
     /* 274013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 274019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274034 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 274034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 274039 */   GIR_RootConstrainSelectedInstOperands,
     /* 274040 */   // GIR_Coverage, 2468,
     /* 274040 */   GIR_Done,
     /* 274041 */ // Label 5630: @274041
     /* 274041 */ GIM_Reject,
     /* 274042 */ // Label 5619: @274042
     /* 274042 */ GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(274075), // Rule ID 2472 //
     /* 274047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 274053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 274056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274068 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 274068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 274073 */   GIR_RootConstrainSelectedInstOperands,
     /* 274074 */   // GIR_Coverage, 2472,
     /* 274074 */   GIR_Done,
     /* 274075 */ // Label 5631: @274075
     /* 274075 */ GIM_Reject,
     /* 274076 */ // Label 5620: @274076
     /* 274076 */ GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(274109), // Rule ID 2467 //
     /* 274081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 274087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274102 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 274102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 274107 */   GIR_RootConstrainSelectedInstOperands,
     /* 274108 */   // GIR_Coverage, 2467,
     /* 274108 */   GIR_Done,
     /* 274109 */ // Label 5632: @274109
     /* 274109 */ GIM_Reject,
     /* 274110 */ // Label 5621: @274110
     /* 274110 */ GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(274143), // Rule ID 2471 //
     /* 274115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 274121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274136 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 274136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 274141 */   GIR_RootConstrainSelectedInstOperands,
     /* 274142 */   // GIR_Coverage, 2471,
     /* 274142 */   GIR_Done,
     /* 274143 */ // Label 5633: @274143
     /* 274143 */ GIM_Reject,
     /* 274144 */ // Label 5622: @274144
     /* 274144 */ GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(274177), // Rule ID 2466 //
     /* 274149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 274155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 274158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274170 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 274170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 274175 */   GIR_RootConstrainSelectedInstOperands,
     /* 274176 */   // GIR_Coverage, 2466,
     /* 274176 */   GIR_Done,
     /* 274177 */ // Label 5634: @274177
     /* 274177 */ GIM_Reject,
     /* 274178 */ // Label 5623: @274178
     /* 274178 */ GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(274211), // Rule ID 2470 //
     /* 274183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274204 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 274204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 274209 */   GIR_RootConstrainSelectedInstOperands,
     /* 274210 */   // GIR_Coverage, 2470,
     /* 274210 */   GIR_Done,
     /* 274211 */ // Label 5635: @274211
     /* 274211 */ GIM_Reject,
     /* 274212 */ // Label 5624: @274212
     /* 274212 */ GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(274245), // Rule ID 2469 //
     /* 274217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 274223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 274226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274238 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 274238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 274243 */   GIR_RootConstrainSelectedInstOperands,
     /* 274244 */   // GIR_Coverage, 2469,
     /* 274244 */   GIR_Done,
     /* 274245 */ // Label 5636: @274245
     /* 274245 */ GIM_Reject,
     /* 274246 */ // Label 5625: @274246
     /* 274246 */ GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(274271), // Rule ID 7344 //
     /* 274251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 274257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 274260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274264 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 274264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 274269 */   GIR_RootConstrainSelectedInstOperands,
     /* 274270 */   // GIR_Coverage, 7344,
     /* 274270 */   GIR_Done,
     /* 274271 */ // Label 5637: @274271
     /* 274271 */ GIM_Reject,
     /* 274272 */ // Label 5626: @274272
     /* 274272 */ GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(274297), // Rule ID 7343 //
     /* 274277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 274283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274290 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 274290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 274295 */   GIR_RootConstrainSelectedInstOperands,
     /* 274296 */   // GIR_Coverage, 7343,
     /* 274296 */   GIR_Done,
     /* 274297 */ // Label 5638: @274297
     /* 274297 */ GIM_Reject,
     /* 274298 */ // Label 5627: @274298
     /* 274298 */ GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(274323), // Rule ID 7342 //
     /* 274303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 274309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274316 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 274316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 274321 */   GIR_RootConstrainSelectedInstOperands,
     /* 274322 */   // GIR_Coverage, 7342,
     /* 274322 */   GIR_Done,
     /* 274323 */ // Label 5639: @274323
     /* 274323 */ GIM_Reject,
     /* 274324 */ // Label 5628: @274324
     /* 274324 */ GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(274349), // Rule ID 7341 //
     /* 274329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 274335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 274338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274342 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 274342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 274347 */   GIR_RootConstrainSelectedInstOperands,
     /* 274348 */   // GIR_Coverage, 7341,
     /* 274348 */   GIR_Done,
     /* 274349 */ // Label 5640: @274349
     /* 274349 */ GIM_Reject,
     /* 274350 */ // Label 5629: @274350
     /* 274350 */ GIM_Reject,
     /* 274351 */ // Label 55: @274351
     /* 274351 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5652*/ GIMT_Encode4(274780),
     /* 274362 */ /*GILLT_v2s32*//*Label 5641*/ GIMT_Encode4(274438),
     /* 274366 */ /*GILLT_v2s64*//*Label 5642*/ GIMT_Encode4(274472),
     /* 274370 */ /*GILLT_v4s16*//*Label 5643*/ GIMT_Encode4(274506),
     /* 274374 */ /*GILLT_v4s32*//*Label 5644*/ GIMT_Encode4(274540),
     /* 274378 */ /*GILLT_v8s8*//*Label 5645*/ GIMT_Encode4(274574),
     /* 274382 */ /*GILLT_v8s16*//*Label 5646*/ GIMT_Encode4(274608),
     /* 274386 */ /*GILLT_v16s8*//*Label 5647*/ GIMT_Encode4(274642), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274406 */ /*GILLT_nxv2s64*//*Label 5648*/ GIMT_Encode4(274676), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274418 */ /*GILLT_nxv4s32*//*Label 5649*/ GIMT_Encode4(274702), GIMT_Encode4(0),
     /* 274426 */ /*GILLT_nxv8s16*//*Label 5650*/ GIMT_Encode4(274728), GIMT_Encode4(0),
     /* 274434 */ /*GILLT_nxv16s8*//*Label 5651*/ GIMT_Encode4(274754),
     /* 274438 */ // Label 5641: @274438
     /* 274438 */ GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(274471), // Rule ID 4985 //
     /* 274443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 274449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274464 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 274464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 274469 */   GIR_RootConstrainSelectedInstOperands,
     /* 274470 */   // GIR_Coverage, 4985,
     /* 274470 */   GIR_Done,
     /* 274471 */ // Label 5653: @274471
     /* 274471 */ GIM_Reject,
     /* 274472 */ // Label 5642: @274472
     /* 274472 */ GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(274505), // Rule ID 4989 //
     /* 274477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 274483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 274486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274498 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 274498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 274503 */   GIR_RootConstrainSelectedInstOperands,
     /* 274504 */   // GIR_Coverage, 4989,
     /* 274504 */   GIR_Done,
     /* 274505 */ // Label 5654: @274505
     /* 274505 */ GIM_Reject,
     /* 274506 */ // Label 5643: @274506
     /* 274506 */ GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(274539), // Rule ID 4984 //
     /* 274511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 274517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274532 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 274532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 274537 */   GIR_RootConstrainSelectedInstOperands,
     /* 274538 */   // GIR_Coverage, 4984,
     /* 274538 */   GIR_Done,
     /* 274539 */ // Label 5655: @274539
     /* 274539 */ GIM_Reject,
     /* 274540 */ // Label 5644: @274540
     /* 274540 */ GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(274573), // Rule ID 4988 //
     /* 274545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 274551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274566 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 274566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 274571 */   GIR_RootConstrainSelectedInstOperands,
     /* 274572 */   // GIR_Coverage, 4988,
     /* 274572 */   GIR_Done,
     /* 274573 */ // Label 5656: @274573
     /* 274573 */ GIM_Reject,
     /* 274574 */ // Label 5645: @274574
     /* 274574 */ GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(274607), // Rule ID 4983 //
     /* 274579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 274585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 274588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274600 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 274600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 274605 */   GIR_RootConstrainSelectedInstOperands,
     /* 274606 */   // GIR_Coverage, 4983,
     /* 274606 */   GIR_Done,
     /* 274607 */ // Label 5657: @274607
     /* 274607 */ GIM_Reject,
     /* 274608 */ // Label 5646: @274608
     /* 274608 */ GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(274641), // Rule ID 4987 //
     /* 274613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274634 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 274634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 274639 */   GIR_RootConstrainSelectedInstOperands,
     /* 274640 */   // GIR_Coverage, 4987,
     /* 274640 */   GIR_Done,
     /* 274641 */ // Label 5658: @274641
     /* 274641 */ GIM_Reject,
     /* 274642 */ // Label 5647: @274642
     /* 274642 */ GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(274675), // Rule ID 4986 //
     /* 274647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 274653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 274656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274668 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 274668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 274673 */   GIR_RootConstrainSelectedInstOperands,
     /* 274674 */   // GIR_Coverage, 4986,
     /* 274674 */   GIR_Done,
     /* 274675 */ // Label 5659: @274675
     /* 274675 */ GIM_Reject,
     /* 274676 */ // Label 5648: @274676
     /* 274676 */ GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(274701), // Rule ID 7356 //
     /* 274681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 274687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 274690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274694 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 274694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 274699 */   GIR_RootConstrainSelectedInstOperands,
     /* 274700 */   // GIR_Coverage, 7356,
     /* 274700 */   GIR_Done,
     /* 274701 */ // Label 5660: @274701
     /* 274701 */ GIM_Reject,
     /* 274702 */ // Label 5649: @274702
     /* 274702 */ GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(274727), // Rule ID 7355 //
     /* 274707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 274713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274720 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 274720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 274725 */   GIR_RootConstrainSelectedInstOperands,
     /* 274726 */   // GIR_Coverage, 7355,
     /* 274726 */   GIR_Done,
     /* 274727 */ // Label 5661: @274727
     /* 274727 */ GIM_Reject,
     /* 274728 */ // Label 5650: @274728
     /* 274728 */ GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(274753), // Rule ID 7354 //
     /* 274733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 274739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274746 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 274746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 274751 */   GIR_RootConstrainSelectedInstOperands,
     /* 274752 */   // GIR_Coverage, 7354,
     /* 274752 */   GIR_Done,
     /* 274753 */ // Label 5662: @274753
     /* 274753 */ GIM_Reject,
     /* 274754 */ // Label 5651: @274754
     /* 274754 */ GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(274779), // Rule ID 7353 //
     /* 274759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 274765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 274768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274772 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 274772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 274777 */   GIR_RootConstrainSelectedInstOperands,
     /* 274778 */   // GIR_Coverage, 7353,
     /* 274778 */   GIR_Done,
     /* 274779 */ // Label 5663: @274779
     /* 274779 */ GIM_Reject,
     /* 274780 */ // Label 5652: @274780
     /* 274780 */ GIM_Reject,
     /* 274781 */ // Label 56: @274781
     /* 274781 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5675*/ GIMT_Encode4(275210),
     /* 274792 */ /*GILLT_v2s32*//*Label 5664*/ GIMT_Encode4(274868),
     /* 274796 */ /*GILLT_v2s64*//*Label 5665*/ GIMT_Encode4(274902),
     /* 274800 */ /*GILLT_v4s16*//*Label 5666*/ GIMT_Encode4(274936),
     /* 274804 */ /*GILLT_v4s32*//*Label 5667*/ GIMT_Encode4(274970),
     /* 274808 */ /*GILLT_v8s8*//*Label 5668*/ GIMT_Encode4(275004),
     /* 274812 */ /*GILLT_v8s16*//*Label 5669*/ GIMT_Encode4(275038),
     /* 274816 */ /*GILLT_v16s8*//*Label 5670*/ GIMT_Encode4(275072), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274836 */ /*GILLT_nxv2s64*//*Label 5671*/ GIMT_Encode4(275106), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274848 */ /*GILLT_nxv4s32*//*Label 5672*/ GIMT_Encode4(275132), GIMT_Encode4(0),
     /* 274856 */ /*GILLT_nxv8s16*//*Label 5673*/ GIMT_Encode4(275158), GIMT_Encode4(0),
     /* 274864 */ /*GILLT_nxv16s8*//*Label 5674*/ GIMT_Encode4(275184),
     /* 274868 */ // Label 5664: @274868
     /* 274868 */ GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(274901), // Rule ID 4978 //
     /* 274873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 274879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274894 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 274894 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 274899 */   GIR_RootConstrainSelectedInstOperands,
     /* 274900 */   // GIR_Coverage, 4978,
     /* 274900 */   GIR_Done,
     /* 274901 */ // Label 5676: @274901
     /* 274901 */ GIM_Reject,
     /* 274902 */ // Label 5665: @274902
     /* 274902 */ GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(274935), // Rule ID 4982 //
     /* 274907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 274913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 274916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274928 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 274928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 274933 */   GIR_RootConstrainSelectedInstOperands,
     /* 274934 */   // GIR_Coverage, 4982,
     /* 274934 */   GIR_Done,
     /* 274935 */ // Label 5677: @274935
     /* 274935 */ GIM_Reject,
     /* 274936 */ // Label 5666: @274936
     /* 274936 */ GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(274969), // Rule ID 4977 //
     /* 274941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 274947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274962 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 274962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 274967 */   GIR_RootConstrainSelectedInstOperands,
     /* 274968 */   // GIR_Coverage, 4977,
     /* 274968 */   GIR_Done,
     /* 274969 */ // Label 5678: @274969
     /* 274969 */ GIM_Reject,
     /* 274970 */ // Label 5667: @274970
     /* 274970 */ GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(275003), // Rule ID 4981 //
     /* 274975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 274981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274996 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 274996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 275001 */   GIR_RootConstrainSelectedInstOperands,
     /* 275002 */   // GIR_Coverage, 4981,
     /* 275002 */   GIR_Done,
     /* 275003 */ // Label 5679: @275003
     /* 275003 */ GIM_Reject,
     /* 275004 */ // Label 5668: @275004
     /* 275004 */ GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(275037), // Rule ID 4976 //
     /* 275009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 275015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 275018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275030 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 275030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 275035 */   GIR_RootConstrainSelectedInstOperands,
     /* 275036 */   // GIR_Coverage, 4976,
     /* 275036 */   GIR_Done,
     /* 275037 */ // Label 5680: @275037
     /* 275037 */ GIM_Reject,
     /* 275038 */ // Label 5669: @275038
     /* 275038 */ GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(275071), // Rule ID 4980 //
     /* 275043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275064 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 275064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 275069 */   GIR_RootConstrainSelectedInstOperands,
     /* 275070 */   // GIR_Coverage, 4980,
     /* 275070 */   GIR_Done,
     /* 275071 */ // Label 5681: @275071
     /* 275071 */ GIM_Reject,
     /* 275072 */ // Label 5670: @275072
     /* 275072 */ GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(275105), // Rule ID 4979 //
     /* 275077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 275083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 275086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275098 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 275098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 275103 */   GIR_RootConstrainSelectedInstOperands,
     /* 275104 */   // GIR_Coverage, 4979,
     /* 275104 */   GIR_Done,
     /* 275105 */ // Label 5682: @275105
     /* 275105 */ GIM_Reject,
     /* 275106 */ // Label 5671: @275106
     /* 275106 */ GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(275131), // Rule ID 7352 //
     /* 275111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 275117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 275120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275124 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 275124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 275129 */   GIR_RootConstrainSelectedInstOperands,
     /* 275130 */   // GIR_Coverage, 7352,
     /* 275130 */   GIR_Done,
     /* 275131 */ // Label 5683: @275131
     /* 275131 */ GIM_Reject,
     /* 275132 */ // Label 5672: @275132
     /* 275132 */ GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(275157), // Rule ID 7351 //
     /* 275137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 275143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275150 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 275150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 275155 */   GIR_RootConstrainSelectedInstOperands,
     /* 275156 */   // GIR_Coverage, 7351,
     /* 275156 */   GIR_Done,
     /* 275157 */ // Label 5684: @275157
     /* 275157 */ GIM_Reject,
     /* 275158 */ // Label 5673: @275158
     /* 275158 */ GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(275183), // Rule ID 7350 //
     /* 275163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 275169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 275172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275176 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 275176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 275181 */   GIR_RootConstrainSelectedInstOperands,
     /* 275182 */   // GIR_Coverage, 7350,
     /* 275182 */   GIR_Done,
     /* 275183 */ // Label 5685: @275183
     /* 275183 */ GIM_Reject,
     /* 275184 */ // Label 5674: @275184
     /* 275184 */ GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(275209), // Rule ID 7349 //
     /* 275189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 275195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 275198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275202 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 275202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 275207 */   GIR_RootConstrainSelectedInstOperands,
     /* 275208 */   // GIR_Coverage, 7349,
     /* 275208 */   GIR_Done,
     /* 275209 */ // Label 5686: @275209
     /* 275209 */ GIM_Reject,
     /* 275210 */ // Label 5675: @275210
     /* 275210 */ GIM_Reject,
     /* 275211 */ // Label 57: @275211
     /* 275211 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5698*/ GIMT_Encode4(277008),
     /* 275222 */ /*GILLT_s16*//*Label 5687*/ GIMT_Encode4(275306),
     /* 275226 */ /*GILLT_s32*//*Label 5688*/ GIMT_Encode4(275532),
     /* 275230 */ /*GILLT_s64*//*Label 5689*/ GIMT_Encode4(275886), GIMT_Encode4(0),
     /* 275238 */ /*GILLT_v2s32*//*Label 5690*/ GIMT_Encode4(276058),
     /* 275242 */ /*GILLT_v2s64*//*Label 5691*/ GIMT_Encode4(276096),
     /* 275246 */ /*GILLT_v4s16*//*Label 5692*/ GIMT_Encode4(276272),
     /* 275250 */ /*GILLT_v4s32*//*Label 5693*/ GIMT_Encode4(276310), GIMT_Encode4(0),
     /* 275258 */ /*GILLT_v8s16*//*Label 5694*/ GIMT_Encode4(276486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 275282 */ /*GILLT_nxv2s64*//*Label 5695*/ GIMT_Encode4(276930), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 275294 */ /*GILLT_nxv4s32*//*Label 5696*/ GIMT_Encode4(276956), GIMT_Encode4(0),
     /* 275302 */ /*GILLT_nxv8s16*//*Label 5697*/ GIMT_Encode4(276982),
     /* 275306 */ // Label 5687: @275306
     /* 275306 */ GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(275531),
     /* 275311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 275314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 275317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275321 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(275412), // Rule ID 6836 //
     /* 275326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275347 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275363 */     // MIs[2] Rn
     /* 275363 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 275368 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 275372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275374 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 275374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 275377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275386 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 275392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 275405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275410 */     GIR_RootConstrainSelectedInstOperands,
     /* 275411 */     // GIR_Coverage, 6836,
     /* 275411 */     GIR_EraseRootFromParent_Done,
     /* 275412 */   // Label 5700: @275412
     /* 275412 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(275503), // Rule ID 13733 //
     /* 275417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275438 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 275442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275454 */     // MIs[2] Rn
     /* 275454 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 275459 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 275463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275465 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 275465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 275468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275477 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 275483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 275496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275501 */     GIR_RootConstrainSelectedInstOperands,
     /* 275502 */     // GIR_Coverage, 13733,
     /* 275502 */     GIR_EraseRootFromParent_Done,
     /* 275503 */   // Label 5701: @275503
     /* 275503 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(275530), // Rule ID 584 //
     /* 275508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275519 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 275519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 275524 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 275528 */     GIR_RootConstrainSelectedInstOperands,
     /* 275529 */     // GIR_Coverage, 584,
     /* 275529 */     GIR_Done,
     /* 275530 */   // Label 5702: @275530
     /* 275530 */   GIM_Reject,
     /* 275531 */ // Label 5699: @275531
     /* 275531 */ GIM_Reject,
     /* 275532 */ // Label 5688: @275532
     /* 275532 */ GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(275885),
     /* 275537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 275540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 275543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275547 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(275638), // Rule ID 6834 //
     /* 275552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275589 */     // MIs[2] Rn
     /* 275589 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 275594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 275598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275600 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 275600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 275603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275612 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 275618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 275631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275636 */     GIR_RootConstrainSelectedInstOperands,
     /* 275637 */     // GIR_Coverage, 6834,
     /* 275637 */     GIR_EraseRootFromParent_Done,
     /* 275638 */   // Label 5704: @275638
     /* 275638 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(275702), // Rule ID 12904 //
     /* 275643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 275655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275680 */     // MIs[2] Rn
     /* 275680 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 275685 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 275689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275691 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 275691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 275694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 275700 */     GIR_RootConstrainSelectedInstOperands,
     /* 275701 */     // GIR_Coverage, 12904,
     /* 275701 */     GIR_EraseRootFromParent_Done,
     /* 275702 */   // Label 5705: @275702
     /* 275702 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(275793), // Rule ID 13731 //
     /* 275707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275728 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 275732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275744 */     // MIs[2] Rn
     /* 275744 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 275749 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 275753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275755 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 275755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 275758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275767 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 275773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 275786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275791 */     GIR_RootConstrainSelectedInstOperands,
     /* 275792 */     // GIR_Coverage, 13731,
     /* 275792 */     GIR_EraseRootFromParent_Done,
     /* 275793 */   // Label 5706: @275793
     /* 275793 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(275857), // Rule ID 15406 //
     /* 275798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 275810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275819 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 275823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275835 */     // MIs[2] Rn
     /* 275835 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 275840 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 275844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275846 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 275846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 275849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 275855 */     GIR_RootConstrainSelectedInstOperands,
     /* 275856 */     // GIR_Coverage, 15406,
     /* 275856 */     GIR_EraseRootFromParent_Done,
     /* 275857 */   // Label 5707: @275857
     /* 275857 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(275884), // Rule ID 586 //
     /* 275862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 275865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275873 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 275873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 275878 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 275882 */     GIR_RootConstrainSelectedInstOperands,
     /* 275883 */     // GIR_Coverage, 586,
     /* 275883 */     GIR_Done,
     /* 275884 */   // Label 5708: @275884
     /* 275884 */   GIM_Reject,
     /* 275885 */ // Label 5703: @275885
     /* 275885 */ GIM_Reject,
     /* 275886 */ // Label 5689: @275886
     /* 275886 */ GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(276057),
     /* 275891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 275894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 275897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275901 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(275965), // Rule ID 6832 //
     /* 275906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 275918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275927 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275943 */     // MIs[2] Rn
     /* 275943 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 275948 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 275952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275954 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 275954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 275957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 275963 */     GIR_RootConstrainSelectedInstOperands,
     /* 275964 */     // GIR_Coverage, 6832,
     /* 275964 */     GIR_EraseRootFromParent_Done,
     /* 275965 */   // Label 5710: @275965
     /* 275965 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(276029), // Rule ID 13729 //
     /* 275970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 275982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 275995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 276007 */     // MIs[2] Rn
     /* 276007 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 276012 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 276016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276018 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 276018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 276021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276027 */     GIR_RootConstrainSelectedInstOperands,
     /* 276028 */     // GIR_Coverage, 13729,
     /* 276028 */     GIR_EraseRootFromParent_Done,
     /* 276029 */   // Label 5711: @276029
     /* 276029 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(276056), // Rule ID 588 //
     /* 276034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 276037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276045 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 276045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 276050 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276054 */     GIR_RootConstrainSelectedInstOperands,
     /* 276055 */     // GIR_Coverage, 588,
     /* 276055 */     GIR_Done,
     /* 276056 */   // Label 5712: @276056
     /* 276056 */   GIM_Reject,
     /* 276057 */ // Label 5709: @276057
     /* 276057 */ GIM_Reject,
     /* 276058 */ // Label 5690: @276058
     /* 276058 */ GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(276095), // Rule ID 1196 //
     /* 276063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 276069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 276072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276084 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 276084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 276089 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276093 */   GIR_RootConstrainSelectedInstOperands,
     /* 276094 */   // GIR_Coverage, 1196,
     /* 276094 */   GIR_Done,
     /* 276095 */ // Label 5713: @276095
     /* 276095 */ GIM_Reject,
     /* 276096 */ // Label 5691: @276096
     /* 276096 */ GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(276271),
     /* 276101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276111 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(276177), // Rule ID 6854 //
     /* 276116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 276124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 276150 */     // MIs[2] Rn
     /* 276150 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 276155 */     // MIs[2] Rm
     /* 276155 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276162 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 276162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 276165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 276175 */     GIR_RootConstrainSelectedInstOperands,
     /* 276176 */     // GIR_Coverage, 6854,
     /* 276176 */     GIR_EraseRootFromParent_Done,
     /* 276177 */   // Label 5715: @276177
     /* 276177 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(276243), // Rule ID 13741 //
     /* 276182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 276190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 276216 */     // MIs[2] Rn
     /* 276216 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 276221 */     // MIs[2] Rm
     /* 276221 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276228 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 276228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 276231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 276241 */     GIR_RootConstrainSelectedInstOperands,
     /* 276242 */     // GIR_Coverage, 13741,
     /* 276242 */     GIR_EraseRootFromParent_Done,
     /* 276243 */   // Label 5716: @276243
     /* 276243 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(276270), // Rule ID 1200 //
     /* 276248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276259 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 276259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 276264 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276268 */     GIR_RootConstrainSelectedInstOperands,
     /* 276269 */     // GIR_Coverage, 1200,
     /* 276269 */     GIR_Done,
     /* 276270 */   // Label 5717: @276270
     /* 276270 */   GIM_Reject,
     /* 276271 */ // Label 5714: @276271
     /* 276271 */ GIM_Reject,
     /* 276272 */ // Label 5692: @276272
     /* 276272 */ GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(276309), // Rule ID 1192 //
     /* 276277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 276280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 276283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 276286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276298 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 276298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 276303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276307 */   GIR_RootConstrainSelectedInstOperands,
     /* 276308 */   // GIR_Coverage, 1192,
     /* 276308 */   GIR_Done,
     /* 276309 */ // Label 5718: @276309
     /* 276309 */ GIM_Reject,
     /* 276310 */ // Label 5693: @276310
     /* 276310 */ GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(276485),
     /* 276315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276325 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(276391), // Rule ID 6855 //
     /* 276330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 276338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 276364 */     // MIs[2] Rn
     /* 276364 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 276369 */     // MIs[2] Rm
     /* 276369 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276376 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 276376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 276379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 276389 */     GIR_RootConstrainSelectedInstOperands,
     /* 276390 */     // GIR_Coverage, 6855,
     /* 276390 */     GIR_EraseRootFromParent_Done,
     /* 276391 */   // Label 5720: @276391
     /* 276391 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(276457), // Rule ID 13742 //
     /* 276396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 276404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 276430 */     // MIs[2] Rn
     /* 276430 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 276435 */     // MIs[2] Rm
     /* 276435 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276442 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 276442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 276445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 276455 */     GIR_RootConstrainSelectedInstOperands,
     /* 276456 */     // GIR_Coverage, 13742,
     /* 276456 */     GIR_EraseRootFromParent_Done,
     /* 276457 */   // Label 5721: @276457
     /* 276457 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(276484), // Rule ID 1198 //
     /* 276462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276473 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 276473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 276478 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276482 */     GIR_RootConstrainSelectedInstOperands,
     /* 276483 */     // GIR_Coverage, 1198,
     /* 276483 */     GIR_Done,
     /* 276484 */   // Label 5722: @276484
     /* 276484 */   GIM_Reject,
     /* 276485 */ // Label 5719: @276485
     /* 276485 */ GIM_Reject,
     /* 276486 */ // Label 5694: @276486
     /* 276486 */ GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(276929),
     /* 276491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 276494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276501 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(276570), // Rule ID 6856 //
     /* 276506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 276509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 276517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 276521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 276543 */     // MIs[2] Rn
     /* 276543 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 276548 */     // MIs[2] Rm
     /* 276548 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276555 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 276555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 276558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 276568 */     GIR_RootConstrainSelectedInstOperands,
     /* 276569 */     // GIR_Coverage, 6856,
     /* 276569 */     GIR_EraseRootFromParent_Done,
     /* 276570 */   // Label 5724: @276570
     /* 276570 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(276639), // Rule ID 13743 //
     /* 276575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 276578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 276586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 276590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 276612 */     // MIs[2] Rn
     /* 276612 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 276617 */     // MIs[2] Rm
     /* 276617 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276624 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 276624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 276627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 276637 */     GIR_RootConstrainSelectedInstOperands,
     /* 276638 */     // GIR_Coverage, 13743,
     /* 276638 */     GIR_EraseRootFromParent_Done,
     /* 276639 */   // Label 5725: @276639
     /* 276639 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(276666), // Rule ID 1194 //
     /* 276644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 276647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276655 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 276655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 276660 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276664 */     GIR_RootConstrainSelectedInstOperands,
     /* 276665 */     // GIR_Coverage, 1194,
     /* 276665 */     GIR_Done,
     /* 276666 */   // Label 5726: @276666
     /* 276666 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(276928), // Rule ID 6925 //
     /* 276671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 276674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276682 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 276682 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 276685 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 276689 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276694 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 276698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 276700 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 276703 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 276707 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276712 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 276716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 276718 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 276721 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 276725 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276730 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 276733 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 276736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 276738 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 276741 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276745 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276750 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276756 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276761 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276766 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 276769 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 276773 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276778 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 276781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 276783 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 276786 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276790 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276795 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276801 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276806 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276811 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 276814 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 276818 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276823 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 276826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 276828 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 276831 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 276835 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276840 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 276843 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 276846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 276848 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 276851 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 276855 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276860 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 276863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 276865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 276868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 276872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 276879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 276882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 276886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276891 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 276894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 276897 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 276900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 276918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 276926 */     GIR_RootConstrainSelectedInstOperands,
     /* 276927 */     // GIR_Coverage, 6925,
     /* 276927 */     GIR_EraseRootFromParent_Done,
     /* 276928 */   // Label 5727: @276928
     /* 276928 */   GIM_Reject,
     /* 276929 */ // Label 5723: @276929
     /* 276929 */ GIM_Reject,
     /* 276930 */ // Label 5695: @276930
     /* 276930 */ GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(276955), // Rule ID 2815 //
     /* 276935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 276941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 276944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276948 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 276948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 276953 */   GIR_RootConstrainSelectedInstOperands,
     /* 276954 */   // GIR_Coverage, 2815,
     /* 276954 */   GIR_Done,
     /* 276955 */ // Label 5728: @276955
     /* 276955 */ GIM_Reject,
     /* 276956 */ // Label 5696: @276956
     /* 276956 */ GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(276981), // Rule ID 2813 //
     /* 276961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 276967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276974 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 276974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 276979 */   GIR_RootConstrainSelectedInstOperands,
     /* 276980 */   // GIR_Coverage, 2813,
     /* 276980 */   GIR_Done,
     /* 276981 */ // Label 5729: @276981
     /* 276981 */ GIM_Reject,
     /* 276982 */ // Label 5697: @276982
     /* 276982 */ GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(277007), // Rule ID 2811 //
     /* 276987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 276993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277000 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 277000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 277005 */   GIR_RootConstrainSelectedInstOperands,
     /* 277006 */   // GIR_Coverage, 2811,
     /* 277006 */   GIR_Done,
     /* 277007 */ // Label 5730: @277007
     /* 277007 */ GIM_Reject,
     /* 277008 */ // Label 5698: @277008
     /* 277008 */ GIM_Reject,
     /* 277009 */ // Label 58: @277009
     /* 277009 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5742*/ GIMT_Encode4(277746),
     /* 277020 */ /*GILLT_s16*//*Label 5731*/ GIMT_Encode4(277104),
     /* 277024 */ /*GILLT_s32*//*Label 5732*/ GIMT_Encode4(277142),
     /* 277028 */ /*GILLT_s64*//*Label 5733*/ GIMT_Encode4(277180), GIMT_Encode4(0),
     /* 277036 */ /*GILLT_v2s32*//*Label 5734*/ GIMT_Encode4(277218),
     /* 277040 */ /*GILLT_v2s64*//*Label 5735*/ GIMT_Encode4(277256),
     /* 277044 */ /*GILLT_v4s16*//*Label 5736*/ GIMT_Encode4(277294),
     /* 277048 */ /*GILLT_v4s32*//*Label 5737*/ GIMT_Encode4(277332), GIMT_Encode4(0),
     /* 277056 */ /*GILLT_v8s16*//*Label 5738*/ GIMT_Encode4(277370), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277080 */ /*GILLT_nxv2s64*//*Label 5739*/ GIMT_Encode4(277668), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277092 */ /*GILLT_nxv4s32*//*Label 5740*/ GIMT_Encode4(277694), GIMT_Encode4(0),
     /* 277100 */ /*GILLT_nxv8s16*//*Label 5741*/ GIMT_Encode4(277720),
     /* 277104 */ // Label 5731: @277104
     /* 277104 */ GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(277141), // Rule ID 632 //
     /* 277109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 277112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 277118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277126 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277130 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 277130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 277135 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277139 */   GIR_RootConstrainSelectedInstOperands,
     /* 277140 */   // GIR_Coverage, 632,
     /* 277140 */   GIR_Done,
     /* 277141 */ // Label 5743: @277141
     /* 277141 */ GIM_Reject,
     /* 277142 */ // Label 5732: @277142
     /* 277142 */ GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(277179), // Rule ID 634 //
     /* 277147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 277156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277168 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 277168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 277173 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277177 */   GIR_RootConstrainSelectedInstOperands,
     /* 277178 */   // GIR_Coverage, 634,
     /* 277178 */   GIR_Done,
     /* 277179 */ // Label 5744: @277179
     /* 277179 */ GIM_Reject,
     /* 277180 */ // Label 5733: @277180
     /* 277180 */ GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(277217), // Rule ID 636 //
     /* 277185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 277191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 277194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277206 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 277206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 277211 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277215 */   GIR_RootConstrainSelectedInstOperands,
     /* 277216 */   // GIR_Coverage, 636,
     /* 277216 */   GIR_Done,
     /* 277217 */ // Label 5745: @277217
     /* 277217 */ GIM_Reject,
     /* 277218 */ // Label 5734: @277218
     /* 277218 */ GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(277255), // Rule ID 1336 //
     /* 277223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 277232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277244 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 277244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 277249 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277253 */   GIR_RootConstrainSelectedInstOperands,
     /* 277254 */   // GIR_Coverage, 1336,
     /* 277254 */   GIR_Done,
     /* 277255 */ // Label 5746: @277255
     /* 277255 */ GIM_Reject,
     /* 277256 */ // Label 5735: @277256
     /* 277256 */ GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(277293), // Rule ID 1340 //
     /* 277261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277282 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 277282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 277287 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277291 */   GIR_RootConstrainSelectedInstOperands,
     /* 277292 */   // GIR_Coverage, 1340,
     /* 277292 */   GIR_Done,
     /* 277293 */ // Label 5747: @277293
     /* 277293 */ GIM_Reject,
     /* 277294 */ // Label 5736: @277294
     /* 277294 */ GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(277331), // Rule ID 1332 //
     /* 277299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277320 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 277320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 277325 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277329 */   GIR_RootConstrainSelectedInstOperands,
     /* 277330 */   // GIR_Coverage, 1332,
     /* 277330 */   GIR_Done,
     /* 277331 */ // Label 5748: @277331
     /* 277331 */ GIM_Reject,
     /* 277332 */ // Label 5737: @277332
     /* 277332 */ GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(277369), // Rule ID 1338 //
     /* 277337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277358 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 277358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 277363 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277367 */   GIR_RootConstrainSelectedInstOperands,
     /* 277368 */   // GIR_Coverage, 1338,
     /* 277368 */   GIR_Done,
     /* 277369 */ // Label 5749: @277369
     /* 277369 */ GIM_Reject,
     /* 277370 */ // Label 5738: @277370
     /* 277370 */ GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(277667),
     /* 277375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277393 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(277412), // Rule ID 1334 //
     /* 277398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277401 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 277401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 277406 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277410 */     GIR_RootConstrainSelectedInstOperands,
     /* 277411 */     // GIR_Coverage, 1334,
     /* 277411 */     GIR_Done,
     /* 277412 */   // Label 5751: @277412
     /* 277412 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(277666), // Rule ID 6931 //
     /* 277417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 277420 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 277420 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 277423 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 277427 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277432 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 277436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 277438 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 277441 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 277445 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277450 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 277454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 277456 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 277459 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 277463 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277468 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 277471 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 277474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 277476 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 277479 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277483 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277488 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 277494 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277499 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277504 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 277507 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 277511 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277516 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 277519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 277521 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 277524 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277528 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277533 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 277539 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277544 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277549 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 277552 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 277556 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277561 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 277564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 277566 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 277569 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 277573 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277578 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 277581 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 277584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 277586 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 277589 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 277593 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277598 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 277601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 277603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 277606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 277620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 277635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 277638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 277656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 277664 */     GIR_RootConstrainSelectedInstOperands,
     /* 277665 */     // GIR_Coverage, 6931,
     /* 277665 */     GIR_EraseRootFromParent_Done,
     /* 277666 */   // Label 5752: @277666
     /* 277666 */   GIM_Reject,
     /* 277667 */ // Label 5750: @277667
     /* 277667 */ GIM_Reject,
     /* 277668 */ // Label 5739: @277668
     /* 277668 */ GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(277693), // Rule ID 8095 //
     /* 277673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 277676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 277679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 277682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277686 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 277686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 277691 */   GIR_RootConstrainSelectedInstOperands,
     /* 277692 */   // GIR_Coverage, 8095,
     /* 277692 */   GIR_Done,
     /* 277693 */ // Label 5753: @277693
     /* 277693 */ GIM_Reject,
     /* 277694 */ // Label 5740: @277694
     /* 277694 */ GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(277719), // Rule ID 8093 //
     /* 277699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 277702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 277705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277712 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 277712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 277717 */   GIR_RootConstrainSelectedInstOperands,
     /* 277718 */   // GIR_Coverage, 8093,
     /* 277718 */   GIR_Done,
     /* 277719 */ // Label 5754: @277719
     /* 277719 */ GIM_Reject,
     /* 277720 */ // Label 5741: @277720
     /* 277720 */ GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(277745), // Rule ID 8091 //
     /* 277725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 277728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 277731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 277734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277738 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 277738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 277743 */   GIR_RootConstrainSelectedInstOperands,
     /* 277744 */   // GIR_Coverage, 8091,
     /* 277744 */   GIR_Done,
     /* 277745 */ // Label 5755: @277745
     /* 277745 */ GIM_Reject,
     /* 277746 */ // Label 5742: @277746
     /* 277746 */ GIM_Reject,
     /* 277747 */ // Label 59: @277747
     /* 277747 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5767*/ GIMT_Encode4(281842),
     /* 277758 */ /*GILLT_s16*//*Label 5756*/ GIMT_Encode4(277842),
     /* 277762 */ /*GILLT_s32*//*Label 5757*/ GIMT_Encode4(278484),
     /* 277766 */ /*GILLT_s64*//*Label 5758*/ GIMT_Encode4(279114), GIMT_Encode4(0),
     /* 277774 */ /*GILLT_v2s32*//*Label 5759*/ GIMT_Encode4(279744),
     /* 277778 */ /*GILLT_v2s64*//*Label 5760*/ GIMT_Encode4(280274),
     /* 277782 */ /*GILLT_v4s16*//*Label 5761*/ GIMT_Encode4(280632),
     /* 277786 */ /*GILLT_v4s32*//*Label 5762*/ GIMT_Encode4(280974), GIMT_Encode4(0),
     /* 277794 */ /*GILLT_v8s16*//*Label 5763*/ GIMT_Encode4(281332), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277818 */ /*GILLT_nxv2s64*//*Label 5764*/ GIMT_Encode4(281764), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277830 */ /*GILLT_nxv4s32*//*Label 5765*/ GIMT_Encode4(281790), GIMT_Encode4(0),
     /* 277838 */ /*GILLT_nxv8s16*//*Label 5766*/ GIMT_Encode4(281816),
     /* 277842 */ // Label 5756: @277842
     /* 277842 */ GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(278483),
     /* 277847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 277853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277857 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(277970), // Rule ID 6158 //
     /* 277862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 277873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 277890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 277894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 277898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 277906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277919 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 277923 */     // MIs[3] Operand 1
     /* 277923 */     // No operand predicates
     /* 277923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277925 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 277925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 277928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277937 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 277943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 277956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277968 */     GIR_RootConstrainSelectedInstOperands,
     /* 277969 */     // GIR_Coverage, 6158,
     /* 277969 */     GIR_EraseRootFromParent_Done,
     /* 277970 */   // Label 5769: @277970
     /* 277970 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(278083), // Rule ID 13704 //
     /* 277975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 277986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278007 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278011 */     // MIs[2] Operand 1
     /* 278011 */     // No operand predicates
     /* 278011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 278015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 278027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278032 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 278036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278038 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 278038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278050 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 278056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 278069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278081 */     GIR_RootConstrainSelectedInstOperands,
     /* 278082 */     // GIR_Coverage, 13704,
     /* 278082 */     GIR_EraseRootFromParent_Done,
     /* 278083 */   // Label 5770: @278083
     /* 278083 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(278162), // Rule ID 13641 //
     /* 278088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 278091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278112 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 278116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278122 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 278122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278134 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 278140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 278153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278160 */     GIR_RootConstrainSelectedInstOperands,
     /* 278161 */     // GIR_Coverage, 13641,
     /* 278161 */     GIR_EraseRootFromParent_Done,
     /* 278162 */   // Label 5771: @278162
     /* 278162 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(278241), // Rule ID 4754 //
     /* 278167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 278170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 278199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278201 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 278201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278213 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 278219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 278232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278239 */     GIR_RootConstrainSelectedInstOperands,
     /* 278240 */     // GIR_Coverage, 4754,
     /* 278240 */     GIR_EraseRootFromParent_Done,
     /* 278241 */   // Label 5772: @278241
     /* 278241 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(278304), // Rule ID 13256 //
     /* 278246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278282 */     // MIs[2] Operand 1
     /* 278282 */     // No operand predicates
     /* 278282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278288 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 278291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278302 */     GIR_RootConstrainSelectedInstOperands,
     /* 278303 */     // GIR_Coverage, 13256,
     /* 278303 */     GIR_EraseRootFromParent_Done,
     /* 278304 */   // Label 5773: @278304
     /* 278304 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(278367), // Rule ID 2005 //
     /* 278309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278349 */     // MIs[2] Operand 1
     /* 278349 */     // No operand predicates
     /* 278349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278351 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 278354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278365 */     GIR_RootConstrainSelectedInstOperands,
     /* 278366 */     // GIR_Coverage, 2005,
     /* 278366 */     GIR_EraseRootFromParent_Done,
     /* 278367 */   // Label 5774: @278367
     /* 278367 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(278411), // Rule ID 4759 //
     /* 278372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 278375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 278383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278398 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 278398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 278401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 278407 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 278409 */     GIR_RootConstrainSelectedInstOperands,
     /* 278410 */     // GIR_Coverage, 4759,
     /* 278410 */     GIR_EraseRootFromParent_Done,
     /* 278411 */   // Label 5775: @278411
     /* 278411 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(278455), // Rule ID 13646 //
     /* 278416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 278419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 278431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278442 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 278442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 278445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 278451 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 278453 */     GIR_RootConstrainSelectedInstOperands,
     /* 278454 */     // GIR_Coverage, 13646,
     /* 278454 */     GIR_EraseRootFromParent_Done,
     /* 278455 */   // Label 5776: @278455
     /* 278455 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(278482), // Rule ID 620 //
     /* 278460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 278463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278471 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 278471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 278476 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278480 */     GIR_RootConstrainSelectedInstOperands,
     /* 278481 */     // GIR_Coverage, 620,
     /* 278481 */     GIR_Done,
     /* 278482 */   // Label 5777: @278482
     /* 278482 */   GIM_Reject,
     /* 278483 */ // Label 5768: @278483
     /* 278483 */ GIM_Reject,
     /* 278484 */ // Label 5757: @278484
     /* 278484 */ GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(279113),
     /* 278489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 278492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 278495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278499 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(278612), // Rule ID 6160 //
     /* 278504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278528 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 278532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 278536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 278548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278561 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278565 */     // MIs[3] Operand 1
     /* 278565 */     // No operand predicates
     /* 278565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278567 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 278567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 278570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 278585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 278598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 278607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 278610 */     GIR_RootConstrainSelectedInstOperands,
     /* 278611 */     // GIR_Coverage, 6160,
     /* 278611 */     GIR_EraseRootFromParent_Done,
     /* 278612 */   // Label 5779: @278612
     /* 278612 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(278725), // Rule ID 13706 //
     /* 278617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278649 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278653 */     // MIs[2] Operand 1
     /* 278653 */     // No operand predicates
     /* 278653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 278657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278661 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278665 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 278669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278674 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 278678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278680 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 278680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 278683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278692 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 278698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 278711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278723 */     GIR_RootConstrainSelectedInstOperands,
     /* 278724 */     // GIR_Coverage, 13706,
     /* 278724 */     GIR_EraseRootFromParent_Done,
     /* 278725 */   // Label 5780: @278725
     /* 278725 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(278801), // Rule ID 13643 //
     /* 278730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278751 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 278755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278761 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 278761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 278764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278773 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 278779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 278792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278799 */     GIR_RootConstrainSelectedInstOperands,
     /* 278800 */     // GIR_Coverage, 13643,
     /* 278800 */     GIR_EraseRootFromParent_Done,
     /* 278801 */   // Label 5781: @278801
     /* 278801 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(278877), // Rule ID 4756 //
     /* 278806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278831 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 278835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278837 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 278837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 278840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278849 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 278855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 278868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278875 */     GIR_RootConstrainSelectedInstOperands,
     /* 278876 */     // GIR_Coverage, 4756,
     /* 278876 */     GIR_EraseRootFromParent_Done,
     /* 278877 */   // Label 5782: @278877
     /* 278877 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(278940), // Rule ID 13258 //
     /* 278882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278918 */     // MIs[2] Operand 1
     /* 278918 */     // No operand predicates
     /* 278918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278924 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 278927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278938 */     GIR_RootConstrainSelectedInstOperands,
     /* 278939 */     // GIR_Coverage, 13258,
     /* 278939 */     GIR_EraseRootFromParent_Done,
     /* 278940 */   // Label 5783: @278940
     /* 278940 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(279003), // Rule ID 2007 //
     /* 278945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 278960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278981 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278985 */     // MIs[2] Operand 1
     /* 278985 */     // No operand predicates
     /* 278985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278987 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 278990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279001 */     GIR_RootConstrainSelectedInstOperands,
     /* 279002 */     // GIR_Coverage, 2007,
     /* 279002 */     GIR_EraseRootFromParent_Done,
     /* 279003 */   // Label 5784: @279003
     /* 279003 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(279044), // Rule ID 4760 //
     /* 279008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 279020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279031 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 279031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 279034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 279040 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 279042 */     GIR_RootConstrainSelectedInstOperands,
     /* 279043 */     // GIR_Coverage, 4760,
     /* 279043 */     GIR_EraseRootFromParent_Done,
     /* 279044 */   // Label 5785: @279044
     /* 279044 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(279085), // Rule ID 13647 //
     /* 279049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 279065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279072 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 279072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 279075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 279081 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 279083 */     GIR_RootConstrainSelectedInstOperands,
     /* 279084 */     // GIR_Coverage, 13647,
     /* 279084 */     GIR_EraseRootFromParent_Done,
     /* 279085 */   // Label 5786: @279085
     /* 279085 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(279112), // Rule ID 622 //
     /* 279090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279101 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 279101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 279106 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 279110 */     GIR_RootConstrainSelectedInstOperands,
     /* 279111 */     // GIR_Coverage, 622,
     /* 279111 */     GIR_Done,
     /* 279112 */   // Label 5787: @279112
     /* 279112 */   GIM_Reject,
     /* 279113 */ // Label 5778: @279113
     /* 279113 */ GIM_Reject,
     /* 279114 */ // Label 5758: @279114
     /* 279114 */ GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(279743),
     /* 279119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 279122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 279125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279129 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(279242), // Rule ID 6162 //
     /* 279134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279158 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279191 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 279195 */     // MIs[3] Operand 1
     /* 279195 */     // No operand predicates
     /* 279195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279197 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 279197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279209 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 279215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 279228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 279237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 279240 */     GIR_RootConstrainSelectedInstOperands,
     /* 279241 */     // GIR_Coverage, 6162,
     /* 279241 */     GIR_EraseRootFromParent_Done,
     /* 279242 */   // Label 5789: @279242
     /* 279242 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(279355), // Rule ID 13708 //
     /* 279247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279279 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 279283 */     // MIs[2] Operand 1
     /* 279283 */     // No operand predicates
     /* 279283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 279287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279291 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279295 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279299 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279304 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 279308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279310 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 279310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 279328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 279341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 279350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279353 */     GIR_RootConstrainSelectedInstOperands,
     /* 279354 */     // GIR_Coverage, 13708,
     /* 279354 */     GIR_EraseRootFromParent_Done,
     /* 279355 */   // Label 5790: @279355
     /* 279355 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(279431), // Rule ID 13645 //
     /* 279360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279381 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279391 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 279391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279403 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 279409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 279422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279429 */     GIR_RootConstrainSelectedInstOperands,
     /* 279430 */     // GIR_Coverage, 13645,
     /* 279430 */     GIR_EraseRootFromParent_Done,
     /* 279431 */   // Label 5791: @279431
     /* 279431 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(279507), // Rule ID 4758 //
     /* 279436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279461 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279467 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 279467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279479 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 279485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 279498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279505 */     GIR_RootConstrainSelectedInstOperands,
     /* 279506 */     // GIR_Coverage, 4758,
     /* 279506 */     GIR_EraseRootFromParent_Done,
     /* 279507 */   // Label 5792: @279507
     /* 279507 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(279570), // Rule ID 13260 //
     /* 279512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279544 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 279548 */     // MIs[2] Operand 1
     /* 279548 */     // No operand predicates
     /* 279548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279554 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 279554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 279557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 279565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279568 */     GIR_RootConstrainSelectedInstOperands,
     /* 279569 */     // GIR_Coverage, 13260,
     /* 279569 */     GIR_EraseRootFromParent_Done,
     /* 279570 */   // Label 5793: @279570
     /* 279570 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(279633), // Rule ID 2009 //
     /* 279575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279611 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 279615 */     // MIs[2] Operand 1
     /* 279615 */     // No operand predicates
     /* 279615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279617 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 279617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 279620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 279628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279631 */     GIR_RootConstrainSelectedInstOperands,
     /* 279632 */     // GIR_Coverage, 2009,
     /* 279632 */     GIR_EraseRootFromParent_Done,
     /* 279633 */   // Label 5794: @279633
     /* 279633 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(279674), // Rule ID 4761 //
     /* 279638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 279650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279661 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 279661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 279664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 279670 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 279672 */     GIR_RootConstrainSelectedInstOperands,
     /* 279673 */     // GIR_Coverage, 4761,
     /* 279673 */     GIR_EraseRootFromParent_Done,
     /* 279674 */   // Label 5795: @279674
     /* 279674 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(279715), // Rule ID 13648 //
     /* 279679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 279695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279702 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 279702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 279705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 279711 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 279713 */     GIR_RootConstrainSelectedInstOperands,
     /* 279714 */     // GIR_Coverage, 13648,
     /* 279714 */     GIR_EraseRootFromParent_Done,
     /* 279715 */   // Label 5796: @279715
     /* 279715 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(279742), // Rule ID 624 //
     /* 279720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279731 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 279731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 279736 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 279740 */     GIR_RootConstrainSelectedInstOperands,
     /* 279741 */     // GIR_Coverage, 624,
     /* 279741 */     GIR_Done,
     /* 279742 */   // Label 5797: @279742
     /* 279742 */   GIM_Reject,
     /* 279743 */ // Label 5788: @279743
     /* 279743 */ GIM_Reject,
     /* 279744 */ // Label 5759: @279744
     /* 279744 */ GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(280273),
     /* 279749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 279752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 279755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279759 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(279845), // Rule ID 13249 //
     /* 279764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 279775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 279787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279808 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 279812 */     // MIs[3] Operand 1
     /* 279812 */     // No operand predicates
     /* 279812 */     // MIs[1] Operand 2
     /* 279812 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 279823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279829 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 279829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 279832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 279840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 279843 */     GIR_RootConstrainSelectedInstOperands,
     /* 279844 */     // GIR_Coverage, 13249,
     /* 279844 */     GIR_EraseRootFromParent_Done,
     /* 279845 */   // Label 5799: @279845
     /* 279845 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(279931), // Rule ID 1998 //
     /* 279850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 279865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 279877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279898 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 279902 */     // MIs[3] Operand 1
     /* 279902 */     // No operand predicates
     /* 279902 */     // MIs[1] Operand 2
     /* 279902 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 279913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279915 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 279915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 279918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 279926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 279929 */     GIR_RootConstrainSelectedInstOperands,
     /* 279930 */     // GIR_Coverage, 1998,
     /* 279930 */     GIR_EraseRootFromParent_Done,
     /* 279931 */   // Label 5800: @279931
     /* 279931 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(279994), // Rule ID 13250 //
     /* 279936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 279947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279968 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 279972 */     // MIs[2] Operand 1
     /* 279972 */     // No operand predicates
     /* 279972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279978 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 279978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 279981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 279989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279992 */     GIR_RootConstrainSelectedInstOperands,
     /* 279993 */     // GIR_Coverage, 13250,
     /* 279993 */     GIR_EraseRootFromParent_Done,
     /* 279994 */   // Label 5801: @279994
     /* 279994 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(280057), // Rule ID 1999 //
     /* 279999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 280014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280035 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 280039 */     // MIs[2] Operand 1
     /* 280039 */     // No operand predicates
     /* 280039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280041 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 280041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 280044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280055 */     GIR_RootConstrainSelectedInstOperands,
     /* 280056 */     // GIR_Coverage, 1999,
     /* 280056 */     GIR_EraseRootFromParent_Done,
     /* 280057 */   // Label 5802: @280057
     /* 280057 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(280151), // Rule ID 13710 //
     /* 280062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 280070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 280079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280085 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 280088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 280102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280118 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 280121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 280136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 280139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280149 */     GIR_RootConstrainSelectedInstOperands,
     /* 280150 */     // GIR_Coverage, 13710,
     /* 280150 */     GIR_EraseRootFromParent_Done,
     /* 280151 */   // Label 5803: @280151
     /* 280151 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(280245), // Rule ID 6164 //
     /* 280156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 280168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 280177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280179 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 280182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 280196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 280215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 280230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 280233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280243 */     GIR_RootConstrainSelectedInstOperands,
     /* 280244 */     // GIR_Coverage, 6164,
     /* 280244 */     GIR_EraseRootFromParent_Done,
     /* 280245 */   // Label 5804: @280245
     /* 280245 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(280272), // Rule ID 1316 //
     /* 280250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280261 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 280261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 280266 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 280270 */     GIR_RootConstrainSelectedInstOperands,
     /* 280271 */     // GIR_Coverage, 1316,
     /* 280271 */     GIR_Done,
     /* 280272 */   // Label 5805: @280272
     /* 280272 */   GIM_Reject,
     /* 280273 */ // Label 5798: @280273
     /* 280273 */ GIM_Reject,
     /* 280274 */ // Label 5760: @280274
     /* 280274 */ GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(280631),
     /* 280279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 280285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280289 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(280352), // Rule ID 13254 //
     /* 280294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 280305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280326 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 280330 */     // MIs[2] Operand 1
     /* 280330 */     // No operand predicates
     /* 280330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280336 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 280336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 280339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280350 */     GIR_RootConstrainSelectedInstOperands,
     /* 280351 */     // GIR_Coverage, 13254,
     /* 280351 */     GIR_EraseRootFromParent_Done,
     /* 280352 */   // Label 5807: @280352
     /* 280352 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(280415), // Rule ID 2003 //
     /* 280357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 280372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 280397 */     // MIs[2] Operand 1
     /* 280397 */     // No operand predicates
     /* 280397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280399 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 280399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 280402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280413 */     GIR_RootConstrainSelectedInstOperands,
     /* 280414 */     // GIR_Coverage, 2003,
     /* 280414 */     GIR_EraseRootFromParent_Done,
     /* 280415 */   // Label 5808: @280415
     /* 280415 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(280509), // Rule ID 13714 //
     /* 280420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 280428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 280432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280443 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 280446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 280460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280469 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 280479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 280497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280507 */     GIR_RootConstrainSelectedInstOperands,
     /* 280508 */     // GIR_Coverage, 13714,
     /* 280508 */     GIR_EraseRootFromParent_Done,
     /* 280509 */   // Label 5809: @280509
     /* 280509 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(280603), // Rule ID 6168 //
     /* 280514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 280526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 280530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280537 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 280540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 280554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280563 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 280573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 280591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280601 */     GIR_RootConstrainSelectedInstOperands,
     /* 280602 */     // GIR_Coverage, 6168,
     /* 280602 */     GIR_EraseRootFromParent_Done,
     /* 280603 */   // Label 5810: @280603
     /* 280603 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(280630), // Rule ID 1320 //
     /* 280608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280619 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 280619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 280624 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 280628 */     GIR_RootConstrainSelectedInstOperands,
     /* 280629 */     // GIR_Coverage, 1320,
     /* 280629 */     GIR_Done,
     /* 280630 */   // Label 5811: @280630
     /* 280630 */   GIM_Reject,
     /* 280631 */ // Label 5806: @280631
     /* 280631 */ GIM_Reject,
     /* 280632 */ // Label 5761: @280632
     /* 280632 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(280973),
     /* 280637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 280640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280647 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(280733), // Rule ID 13243 //
     /* 280652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 280663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 280675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280696 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280700 */     // MIs[3] Operand 1
     /* 280700 */     // No operand predicates
     /* 280700 */     // MIs[1] Operand 2
     /* 280700 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 280711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280717 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 280717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 280720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280731 */     GIR_RootConstrainSelectedInstOperands,
     /* 280732 */     // GIR_Coverage, 13243,
     /* 280732 */     GIR_EraseRootFromParent_Done,
     /* 280733 */   // Label 5813: @280733
     /* 280733 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(280819), // Rule ID 1992 //
     /* 280738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 280753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 280765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280790 */     // MIs[3] Operand 1
     /* 280790 */     // No operand predicates
     /* 280790 */     // MIs[1] Operand 2
     /* 280790 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 280801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280803 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 280803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 280806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280817 */     GIR_RootConstrainSelectedInstOperands,
     /* 280818 */     // GIR_Coverage, 1992,
     /* 280818 */     GIR_EraseRootFromParent_Done,
     /* 280819 */   // Label 5814: @280819
     /* 280819 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(280882), // Rule ID 13244 //
     /* 280824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 280835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280856 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280860 */     // MIs[2] Operand 1
     /* 280860 */     // No operand predicates
     /* 280860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280866 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 280866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 280869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280880 */     GIR_RootConstrainSelectedInstOperands,
     /* 280881 */     // GIR_Coverage, 13244,
     /* 280881 */     GIR_EraseRootFromParent_Done,
     /* 280882 */   // Label 5815: @280882
     /* 280882 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(280945), // Rule ID 1993 //
     /* 280887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 280902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280923 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280927 */     // MIs[2] Operand 1
     /* 280927 */     // No operand predicates
     /* 280927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280929 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 280929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 280932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280943 */     GIR_RootConstrainSelectedInstOperands,
     /* 280944 */     // GIR_Coverage, 1993,
     /* 280944 */     GIR_EraseRootFromParent_Done,
     /* 280945 */   // Label 5816: @280945
     /* 280945 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(280972), // Rule ID 1312 //
     /* 280950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280961 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 280961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 280966 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 280970 */     GIR_RootConstrainSelectedInstOperands,
     /* 280971 */     // GIR_Coverage, 1312,
     /* 280971 */     GIR_Done,
     /* 280972 */   // Label 5817: @280972
     /* 280972 */   GIM_Reject,
     /* 280973 */ // Label 5812: @280973
     /* 280973 */ GIM_Reject,
     /* 280974 */ // Label 5762: @280974
     /* 280974 */ GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(281331),
     /* 280979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280989 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(281052), // Rule ID 13252 //
     /* 280994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 281005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 281030 */     // MIs[2] Operand 1
     /* 281030 */     // No operand predicates
     /* 281030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281036 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 281036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 281039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281050 */     GIR_RootConstrainSelectedInstOperands,
     /* 281051 */     // GIR_Coverage, 13252,
     /* 281051 */     GIR_EraseRootFromParent_Done,
     /* 281052 */   // Label 5819: @281052
     /* 281052 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(281115), // Rule ID 2001 //
     /* 281057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 281072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281093 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 281097 */     // MIs[2] Operand 1
     /* 281097 */     // No operand predicates
     /* 281097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281099 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 281099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 281102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281113 */     GIR_RootConstrainSelectedInstOperands,
     /* 281114 */     // GIR_Coverage, 2001,
     /* 281114 */     GIR_EraseRootFromParent_Done,
     /* 281115 */   // Label 5820: @281115
     /* 281115 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(281209), // Rule ID 13712 //
     /* 281120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 281128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281143 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 281146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 281160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281169 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281176 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 281179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 281197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281207 */     GIR_RootConstrainSelectedInstOperands,
     /* 281208 */     // GIR_Coverage, 13712,
     /* 281208 */     GIR_EraseRootFromParent_Done,
     /* 281209 */   // Label 5821: @281209
     /* 281209 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(281303), // Rule ID 6166 //
     /* 281214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 281226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281237 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281237 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 281240 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281244 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 281254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 281273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 281291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281301 */     GIR_RootConstrainSelectedInstOperands,
     /* 281302 */     // GIR_Coverage, 6166,
     /* 281302 */     GIR_EraseRootFromParent_Done,
     /* 281303 */   // Label 5822: @281303
     /* 281303 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(281330), // Rule ID 1318 //
     /* 281308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281319 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 281319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 281324 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281328 */     GIR_RootConstrainSelectedInstOperands,
     /* 281329 */     // GIR_Coverage, 1318,
     /* 281329 */     GIR_Done,
     /* 281330 */   // Label 5823: @281330
     /* 281330 */   GIM_Reject,
     /* 281331 */ // Label 5818: @281331
     /* 281331 */ GIM_Reject,
     /* 281332 */ // Label 5763: @281332
     /* 281332 */ GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(281763),
     /* 281337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281347 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(281410), // Rule ID 13246 //
     /* 281352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 281363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281388 */     // MIs[2] Operand 1
     /* 281388 */     // No operand predicates
     /* 281388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281394 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 281394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 281397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281408 */     GIR_RootConstrainSelectedInstOperands,
     /* 281409 */     // GIR_Coverage, 13246,
     /* 281409 */     GIR_EraseRootFromParent_Done,
     /* 281410 */   // Label 5825: @281410
     /* 281410 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(281473), // Rule ID 1995 //
     /* 281415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 281430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281451 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281455 */     // MIs[2] Operand 1
     /* 281455 */     // No operand predicates
     /* 281455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281457 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 281457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 281460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281471 */     GIR_RootConstrainSelectedInstOperands,
     /* 281472 */     // GIR_Coverage, 1995,
     /* 281472 */     GIR_EraseRootFromParent_Done,
     /* 281473 */   // Label 5826: @281473
     /* 281473 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(281500), // Rule ID 1314 //
     /* 281478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281489 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 281489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 281494 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281498 */     GIR_RootConstrainSelectedInstOperands,
     /* 281499 */     // GIR_Coverage, 1314,
     /* 281499 */     GIR_Done,
     /* 281500 */   // Label 5827: @281500
     /* 281500 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(281762), // Rule ID 6929 //
     /* 281505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 281508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281516 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 281516 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 281519 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 281523 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281528 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 281534 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 281537 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 281541 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281546 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 281552 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 281555 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 281559 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281564 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 281567 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 281570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 281572 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 281575 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281579 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281584 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281590 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281595 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281600 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 281603 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 281607 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281612 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 281615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 281617 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 281620 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281624 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281629 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281635 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281640 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281645 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 281648 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 281652 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281657 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 281660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 281662 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 281665 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 281669 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281674 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 281677 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 281680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281682 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 281685 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 281689 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281694 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 281697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281699 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 281702 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281706 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281725 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 281734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 281752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 281760 */     GIR_RootConstrainSelectedInstOperands,
     /* 281761 */     // GIR_Coverage, 6929,
     /* 281761 */     GIR_EraseRootFromParent_Done,
     /* 281762 */   // Label 5828: @281762
     /* 281762 */   GIM_Reject,
     /* 281763 */ // Label 5824: @281763
     /* 281763 */ GIM_Reject,
     /* 281764 */ // Label 5764: @281764
     /* 281764 */ GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(281789), // Rule ID 8101 //
     /* 281769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 281775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 281778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281782 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 281782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 281787 */   GIR_RootConstrainSelectedInstOperands,
     /* 281788 */   // GIR_Coverage, 8101,
     /* 281788 */   GIR_Done,
     /* 281789 */ // Label 5829: @281789
     /* 281789 */ GIM_Reject,
     /* 281790 */ // Label 5765: @281790
     /* 281790 */ GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(281815), // Rule ID 8099 //
     /* 281795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 281804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281808 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 281808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 281813 */   GIR_RootConstrainSelectedInstOperands,
     /* 281814 */   // GIR_Coverage, 8099,
     /* 281814 */   GIR_Done,
     /* 281815 */ // Label 5830: @281815
     /* 281815 */ GIM_Reject,
     /* 281816 */ // Label 5766: @281816
     /* 281816 */ GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(281841), // Rule ID 8097 //
     /* 281821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 281830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281834 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 281834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 281839 */   GIR_RootConstrainSelectedInstOperands,
     /* 281840 */   // GIR_Coverage, 8097,
     /* 281840 */   GIR_Done,
     /* 281841 */ // Label 5831: @281841
     /* 281841 */ GIM_Reject,
     /* 281842 */ // Label 5767: @281842
     /* 281842 */ GIM_Reject,
     /* 281843 */ // Label 60: @281843
     /* 281843 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5840*/ GIMT_Encode4(298115),
     /* 281854 */ /*GILLT_s16*//*Label 5832*/ GIMT_Encode4(281894),
     /* 281858 */ /*GILLT_s32*//*Label 5833*/ GIMT_Encode4(284898),
     /* 281862 */ /*GILLT_s64*//*Label 5834*/ GIMT_Encode4(288046), GIMT_Encode4(0),
     /* 281870 */ /*GILLT_v2s32*//*Label 5835*/ GIMT_Encode4(291194),
     /* 281874 */ /*GILLT_v2s64*//*Label 5836*/ GIMT_Encode4(292715),
     /* 281878 */ /*GILLT_v4s16*//*Label 5837*/ GIMT_Encode4(294236),
     /* 281882 */ /*GILLT_v4s32*//*Label 5838*/ GIMT_Encode4(295415), GIMT_Encode4(0),
     /* 281890 */ /*GILLT_v8s16*//*Label 5839*/ GIMT_Encode4(296936),
     /* 281894 */ // Label 5832: @281894
     /* 281894 */ GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(284897),
     /* 281899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 281905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 281908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281912 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(282062), // Rule ID 4816 //
     /* 281917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 281949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281966 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 281970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 281974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 281982 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281989 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 281989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 281992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282001 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 282007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282029 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 282035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 282048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 282060 */     GIR_RootConstrainSelectedInstOperands,
     /* 282061 */     // GIR_Coverage, 4816,
     /* 282061 */     GIR_EraseRootFromParent_Done,
     /* 282062 */   // Label 5842: @282062
     /* 282062 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(282209), // Rule ID 4780 //
     /* 282067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282091 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 282107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 282111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282128 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282138 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 282138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 282141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282150 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 282156 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282161 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 282184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 282197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282207 */     GIR_RootConstrainSelectedInstOperands,
     /* 282208 */     // GIR_Coverage, 4780,
     /* 282208 */     GIR_EraseRootFromParent_Done,
     /* 282209 */   // Label 5843: @282209
     /* 282209 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(282356), // Rule ID 13654 //
     /* 282214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282250 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282270 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282275 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282285 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 282285 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 282288 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282292 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282297 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 282303 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282325 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 282331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 282344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282354 */     GIR_RootConstrainSelectedInstOperands,
     /* 282355 */     // GIR_Coverage, 13654,
     /* 282355 */     GIR_EraseRootFromParent_Done,
     /* 282356 */   // Label 5844: @282356
     /* 282356 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(282487), // Rule ID 5996 //
     /* 282361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282385 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 282401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 282405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282409 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282413 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282417 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 282422 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 282426 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282430 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282434 */     // MIs[4] Operand 1
     /* 282434 */     // No operand predicates
     /* 282434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282438 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282440 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 282458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 282471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 282482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 282485 */     GIR_RootConstrainSelectedInstOperands,
     /* 282486 */     // GIR_Coverage, 5996,
     /* 282486 */     GIR_EraseRootFromParent_Done,
     /* 282487 */   // Label 5845: @282487
     /* 282487 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(282618), // Rule ID 6028 //
     /* 282492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 282516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282524 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282528 */     // MIs[2] Operand 1
     /* 282528 */     // No operand predicates
     /* 282528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 282540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 282544 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282548 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282552 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 282556 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282561 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 282565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282569 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282571 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282583 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 282589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 282602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282616 */     GIR_RootConstrainSelectedInstOperands,
     /* 282617 */     // GIR_Coverage, 6028,
     /* 282617 */     GIR_EraseRootFromParent_Done,
     /* 282618 */   // Label 5846: @282618
     /* 282618 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(282749), // Rule ID 6092 //
     /* 282623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282659 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282675 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282679 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 282684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 282688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282692 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282696 */     // MIs[4] Operand 1
     /* 282696 */     // No operand predicates
     /* 282696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282700 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282702 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282714 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 282720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 282733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 282744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 282747 */     GIR_RootConstrainSelectedInstOperands,
     /* 282748 */     // GIR_Coverage, 6092,
     /* 282748 */     GIR_EraseRootFromParent_Done,
     /* 282749 */   // Label 5847: @282749
     /* 282749 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(282880), // Rule ID 6060 //
     /* 282754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 282790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282802 */     // MIs[3] Operand 1
     /* 282802 */     // No operand predicates
     /* 282802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 282806 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282810 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282814 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 282818 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282823 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 282827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282833 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282845 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 282851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 282864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 282875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 282878 */     GIR_RootConstrainSelectedInstOperands,
     /* 282879 */     // GIR_Coverage, 6060,
     /* 282879 */     GIR_EraseRootFromParent_Done,
     /* 282880 */   // Label 5848: @282880
     /* 282880 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(283015), // Rule ID 2447 //
     /* 282885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282909 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282944 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 282944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 282947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282956 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 282962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 282990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 283003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283013 */     GIR_RootConstrainSelectedInstOperands,
     /* 283014 */     // GIR_Coverage, 2447,
     /* 283014 */     GIR_EraseRootFromParent_Done,
     /* 283015 */   // Label 5849: @283015
     /* 283015 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(283134), // Rule ID 5964 //
     /* 283020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 283023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283044 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 283069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283077 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283081 */     // MIs[3] Operand 1
     /* 283081 */     // No operand predicates
     /* 283081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283087 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 283087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283099 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 283105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 283118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283132 */     GIR_RootConstrainSelectedInstOperands,
     /* 283133 */     // GIR_Coverage, 5964,
     /* 283133 */     GIR_EraseRootFromParent_Done,
     /* 283134 */   // Label 5850: @283134
     /* 283134 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(283253), // Rule ID 2529 //
     /* 283139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 283142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 283163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283171 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283175 */     // MIs[2] Operand 1
     /* 283175 */     // No operand predicates
     /* 283175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 283179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283183 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 283191 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283196 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 283200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283206 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 283206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283218 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 283224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 283237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283251 */     GIR_RootConstrainSelectedInstOperands,
     /* 283252 */     // GIR_Coverage, 2529,
     /* 283252 */     GIR_EraseRootFromParent_Done,
     /* 283253 */   // Label 5851: @283253
     /* 283253 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(283353), // Rule ID 4778 //
     /* 283258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 283298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283309 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 283309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 283327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 283340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283351 */     GIR_RootConstrainSelectedInstOperands,
     /* 283352 */     // GIR_Coverage, 4778,
     /* 283352 */     GIR_EraseRootFromParent_Done,
     /* 283353 */   // Label 5852: @283353
     /* 283353 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(283453), // Rule ID 4814 //
     /* 283358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 283394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 283402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283409 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 283409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283421 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 283427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 283440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 283447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 283451 */     GIR_RootConstrainSelectedInstOperands,
     /* 283452 */     // GIR_Coverage, 4814,
     /* 283452 */     GIR_EraseRootFromParent_Done,
     /* 283453 */   // Label 5853: @283453
     /* 283453 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(283550), // Rule ID 13650 //
     /* 283458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283508 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 283508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283520 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 283526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 283539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 283543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283548 */     GIR_RootConstrainSelectedInstOperands,
     /* 283549 */     // GIR_Coverage, 13650,
     /* 283549 */     GIR_EraseRootFromParent_Done,
     /* 283550 */   // Label 5854: @283550
     /* 283550 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(283650), // Rule ID 13652 //
     /* 283555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283596 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283606 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 283606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283618 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 283624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 283637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283648 */     GIR_RootConstrainSelectedInstOperands,
     /* 283649 */     // GIR_Coverage, 13652,
     /* 283649 */     GIR_EraseRootFromParent_Done,
     /* 283650 */   // Label 5855: @283650
     /* 283650 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(283750), // Rule ID 4812 //
     /* 283655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283683 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 283691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 283699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283706 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 283706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283718 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 283724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 283737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 283748 */     GIR_RootConstrainSelectedInstOperands,
     /* 283749 */     // GIR_Coverage, 4812,
     /* 283749 */     GIR_EraseRootFromParent_Done,
     /* 283750 */   // Label 5856: @283750
     /* 283750 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(283847), // Rule ID 4776 //
     /* 283755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283795 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283805 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 283805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283817 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 283823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 283836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283845 */     GIR_RootConstrainSelectedInstOperands,
     /* 283846 */     // GIR_Coverage, 4776,
     /* 283846 */     GIR_EraseRootFromParent_Done,
     /* 283847 */   // Label 5857: @283847
     /* 283847 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(283931), // Rule ID 6026 //
     /* 283852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 283855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 283876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283888 */     // MIs[2] Operand 1
     /* 283888 */     // No operand predicates
     /* 283888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 283892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 283900 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283911 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 283911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 283914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 283922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283929 */     GIR_RootConstrainSelectedInstOperands,
     /* 283930 */     // GIR_Coverage, 6026,
     /* 283930 */     GIR_EraseRootFromParent_Done,
     /* 283931 */   // Label 5858: @283931
     /* 283931 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(284012), // Rule ID 6058 //
     /* 283936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 283939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 283972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283980 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283984 */     // MIs[3] Operand 1
     /* 283984 */     // No operand predicates
     /* 283984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283994 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 283994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 283997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284010 */     GIR_RootConstrainSelectedInstOperands,
     /* 284011 */     // GIR_Coverage, 6058,
     /* 284011 */     GIR_EraseRootFromParent_Done,
     /* 284012 */   // Label 5859: @284012
     /* 284012 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(284096), // Rule ID 6090 //
     /* 284017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 284058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284066 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284070 */     // MIs[3] Operand 1
     /* 284070 */     // No operand predicates
     /* 284070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284076 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 284076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 284079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284094 */     GIR_RootConstrainSelectedInstOperands,
     /* 284095 */     // GIR_Coverage, 6090,
     /* 284095 */     GIR_EraseRootFromParent_Done,
     /* 284096 */   // Label 5860: @284096
     /* 284096 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(284177), // Rule ID 5994 //
     /* 284101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 284141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284149 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284153 */     // MIs[3] Operand 1
     /* 284153 */     // No operand predicates
     /* 284153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284159 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 284159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 284162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284175 */     GIR_RootConstrainSelectedInstOperands,
     /* 284176 */     // GIR_Coverage, 5994,
     /* 284176 */     GIR_EraseRootFromParent_Done,
     /* 284177 */   // Label 5861: @284177
     /* 284177 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(284262), // Rule ID 2445 //
     /* 284182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284206 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284220 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284232 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 284238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 284251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284260 */     GIR_RootConstrainSelectedInstOperands,
     /* 284261 */     // GIR_Coverage, 2445,
     /* 284261 */     GIR_EraseRootFromParent_Done,
     /* 284262 */   // Label 5862: @284262
     /* 284262 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(284347), // Rule ID 2443 //
     /* 284267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284295 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284305 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 284305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 284323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 284336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284345 */     GIR_RootConstrainSelectedInstOperands,
     /* 284346 */     // GIR_Coverage, 2443,
     /* 284346 */     GIR_EraseRootFromParent_Done,
     /* 284347 */   // Label 5863: @284347
     /* 284347 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(284416), // Rule ID 2527 //
     /* 284352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 284376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284388 */     // MIs[2] Operand 1
     /* 284388 */     // No operand predicates
     /* 284388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284398 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 284398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 284401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284414 */     GIR_RootConstrainSelectedInstOperands,
     /* 284415 */     // GIR_Coverage, 2527,
     /* 284415 */     GIR_EraseRootFromParent_Done,
     /* 284416 */   // Label 5864: @284416
     /* 284416 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(284485), // Rule ID 5962 //
     /* 284421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 284449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284457 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284461 */     // MIs[2] Operand 1
     /* 284461 */     // No operand predicates
     /* 284461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284467 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 284467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 284470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284483 */     GIR_RootConstrainSelectedInstOperands,
     /* 284484 */     // GIR_Coverage, 5962,
     /* 284484 */     GIR_EraseRootFromParent_Done,
     /* 284485 */   // Label 5865: @284485
     /* 284485 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(284550), // Rule ID 4832 //
     /* 284490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 284518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 284526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284533 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 284536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 284548 */     GIR_RootConstrainSelectedInstOperands,
     /* 284549 */     // GIR_Coverage, 4832,
     /* 284549 */     GIR_EraseRootFromParent_Done,
     /* 284550 */   // Label 5866: @284550
     /* 284550 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(284615), // Rule ID 13670 //
     /* 284555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 284583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 284591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284598 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 284601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 284609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 284613 */     GIR_RootConstrainSelectedInstOperands,
     /* 284614 */     // GIR_Coverage, 13670,
     /* 284614 */     GIR_EraseRootFromParent_Done,
     /* 284615 */   // Label 5867: @284615
     /* 284615 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(284665), // Rule ID 4829 //
     /* 284620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284650 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 284653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284663 */     GIR_RootConstrainSelectedInstOperands,
     /* 284664 */     // GIR_Coverage, 4829,
     /* 284664 */     GIR_EraseRootFromParent_Done,
     /* 284665 */   // Label 5868: @284665
     /* 284665 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(284715), // Rule ID 13096 //
     /* 284670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284700 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 284703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284713 */     GIR_RootConstrainSelectedInstOperands,
     /* 284714 */     // GIR_Coverage, 13096,
     /* 284714 */     GIR_EraseRootFromParent_Done,
     /* 284715 */   // Label 5869: @284715
     /* 284715 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(284765), // Rule ID 644 //
     /* 284720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284750 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 284753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284763 */     GIR_RootConstrainSelectedInstOperands,
     /* 284764 */     // GIR_Coverage, 644,
     /* 284764 */     GIR_EraseRootFromParent_Done,
     /* 284765 */   // Label 5870: @284765
     /* 284765 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(284815), // Rule ID 13667 //
     /* 284770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284800 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 284803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 284811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284813 */     GIR_RootConstrainSelectedInstOperands,
     /* 284814 */     // GIR_Coverage, 13667,
     /* 284814 */     GIR_EraseRootFromParent_Done,
     /* 284815 */   // Label 5871: @284815
     /* 284815 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(284865), // Rule ID 656 //
     /* 284820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 284835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284850 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 284853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 284863 */     GIR_RootConstrainSelectedInstOperands,
     /* 284864 */     // GIR_Coverage, 656,
     /* 284864 */     GIR_EraseRootFromParent_Done,
     /* 284865 */   // Label 5872: @284865
     /* 284865 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(284896), // Rule ID 638 //
     /* 284870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284885 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 284885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 284890 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284894 */     GIR_RootConstrainSelectedInstOperands,
     /* 284895 */     // GIR_Coverage, 638,
     /* 284895 */     GIR_Done,
     /* 284896 */   // Label 5873: @284896
     /* 284896 */   GIM_Reject,
     /* 284897 */ // Label 5841: @284897
     /* 284897 */ GIM_Reject,
     /* 284898 */ // Label 5833: @284898
     /* 284898 */ GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(288045),
     /* 284903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 284909 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 284912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284916 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(285066), // Rule ID 4822 //
     /* 284921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284945 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284970 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 284978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284982 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 284986 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284993 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 284993 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 284996 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285000 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285005 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 285011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285016 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285033 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 285039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 285052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 285064 */     GIR_RootConstrainSelectedInstOperands,
     /* 285065 */     // GIR_Coverage, 4822,
     /* 285065 */     GIR_EraseRootFromParent_Done,
     /* 285066 */   // Label 5875: @285066
     /* 285066 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(285213), // Rule ID 4786 //
     /* 285071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285095 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 285111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 285115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285119 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285123 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285127 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285132 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285142 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 285142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 285145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285154 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 285160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285182 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 285188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285211 */     GIR_RootConstrainSelectedInstOperands,
     /* 285212 */     // GIR_Coverage, 4786,
     /* 285212 */     GIR_EraseRootFromParent_Done,
     /* 285213 */   // Label 5876: @285213
     /* 285213 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(285360), // Rule ID 13660 //
     /* 285218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285254 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285279 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285289 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 285289 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 285292 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285296 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285301 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 285307 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285312 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285329 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 285335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285358 */     GIR_RootConstrainSelectedInstOperands,
     /* 285359 */     // GIR_Coverage, 13660,
     /* 285359 */     GIR_EraseRootFromParent_Done,
     /* 285360 */   // Label 5877: @285360
     /* 285360 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(285491), // Rule ID 6012 //
     /* 285365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285389 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 285405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 285409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285421 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285426 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 285430 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285434 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 285438 */     // MIs[4] Operand 1
     /* 285438 */     // No operand predicates
     /* 285438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285442 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285444 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 285444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285456 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 285462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 285475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 285486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 285489 */     GIR_RootConstrainSelectedInstOperands,
     /* 285490 */     // GIR_Coverage, 6012,
     /* 285490 */     GIR_EraseRootFromParent_Done,
     /* 285491 */   // Label 5878: @285491
     /* 285491 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(285622), // Rule ID 6044 //
     /* 285496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 285532 */     // MIs[2] Operand 1
     /* 285532 */     // No operand predicates
     /* 285532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285540 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 285544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 285548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285552 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285556 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 285560 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285565 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 285569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285575 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 285575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285587 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 285593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 285606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285620 */     GIR_RootConstrainSelectedInstOperands,
     /* 285621 */     // GIR_Coverage, 6044,
     /* 285621 */     GIR_EraseRootFromParent_Done,
     /* 285622 */   // Label 5879: @285622
     /* 285622 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(285753), // Rule ID 6108 //
     /* 285627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285663 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285675 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285679 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285683 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285688 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 285692 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285696 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 285700 */     // MIs[4] Operand 1
     /* 285700 */     // No operand predicates
     /* 285700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285706 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 285706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285718 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 285724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 285737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 285748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 285751 */     GIR_RootConstrainSelectedInstOperands,
     /* 285752 */     // GIR_Coverage, 6108,
     /* 285752 */     GIR_EraseRootFromParent_Done,
     /* 285753 */   // Label 5880: @285753
     /* 285753 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(285884), // Rule ID 6076 //
     /* 285758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 285798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285802 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 285806 */     // MIs[3] Operand 1
     /* 285806 */     // No operand predicates
     /* 285806 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 285810 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285814 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285818 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 285822 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285827 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 285831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285835 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285837 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 285837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285849 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 285855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 285868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 285879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 285882 */     GIR_RootConstrainSelectedInstOperands,
     /* 285883 */     // GIR_Coverage, 6076,
     /* 285883 */     GIR_EraseRootFromParent_Done,
     /* 285884 */   // Label 5881: @285884
     /* 285884 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(286019), // Rule ID 2453 //
     /* 285889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285913 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285938 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285948 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 285948 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 285951 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285955 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285960 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 285966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285988 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 285994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 286007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 286015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286017 */     GIR_RootConstrainSelectedInstOperands,
     /* 286018 */     // GIR_Coverage, 2453,
     /* 286018 */     GIR_EraseRootFromParent_Done,
     /* 286019 */   // Label 5882: @286019
     /* 286019 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(286138), // Rule ID 5980 //
     /* 286024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286048 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286081 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286085 */     // MIs[3] Operand 1
     /* 286085 */     // No operand predicates
     /* 286085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286091 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286103 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 286122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286136 */     GIR_RootConstrainSelectedInstOperands,
     /* 286137 */     // GIR_Coverage, 5980,
     /* 286137 */     GIR_EraseRootFromParent_Done,
     /* 286138 */   // Label 5883: @286138
     /* 286138 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(286257), // Rule ID 2545 //
     /* 286143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286175 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286179 */     // MIs[2] Operand 1
     /* 286179 */     // No operand predicates
     /* 286179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286200 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286210 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286222 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 286241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286255 */     GIR_RootConstrainSelectedInstOperands,
     /* 286256 */     // GIR_Coverage, 2545,
     /* 286256 */     GIR_EraseRootFromParent_Done,
     /* 286257 */   // Label 5884: @286257
     /* 286257 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(286357), // Rule ID 4784 //
     /* 286262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286286 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286313 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 286313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286325 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 286344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286355 */     GIR_RootConstrainSelectedInstOperands,
     /* 286356 */     // GIR_Coverage, 4784,
     /* 286356 */     GIR_EraseRootFromParent_Done,
     /* 286357 */   // Label 5885: @286357
     /* 286357 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(286457), // Rule ID 4820 //
     /* 286362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286386 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 286398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286413 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 286413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286425 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 286444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 286451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 286455 */     GIR_RootConstrainSelectedInstOperands,
     /* 286456 */     // GIR_Coverage, 4820,
     /* 286456 */     GIR_EraseRootFromParent_Done,
     /* 286457 */   // Label 5886: @286457
     /* 286457 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(286554), // Rule ID 13656 //
     /* 286462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286498 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286512 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 286512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286524 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 286543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286552 */     GIR_RootConstrainSelectedInstOperands,
     /* 286553 */     // GIR_Coverage, 13656,
     /* 286553 */     GIR_EraseRootFromParent_Done,
     /* 286554 */   // Label 5887: @286554
     /* 286554 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(286654), // Rule ID 13658 //
     /* 286559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286600 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286610 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 286610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286622 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 286641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286652 */     GIR_RootConstrainSelectedInstOperands,
     /* 286653 */     // GIR_Coverage, 13658,
     /* 286653 */     GIR_EraseRootFromParent_Done,
     /* 286654 */   // Label 5888: @286654
     /* 286654 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(286754), // Rule ID 4818 //
     /* 286659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286687 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 286695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286710 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 286710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286722 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 286741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 286752 */     GIR_RootConstrainSelectedInstOperands,
     /* 286753 */     // GIR_Coverage, 4818,
     /* 286753 */     GIR_EraseRootFromParent_Done,
     /* 286754 */   // Label 5889: @286754
     /* 286754 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(286851), // Rule ID 4782 //
     /* 286759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286799 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286809 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 286809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286821 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 286840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286849 */     GIR_RootConstrainSelectedInstOperands,
     /* 286850 */     // GIR_Coverage, 4782,
     /* 286850 */     GIR_EraseRootFromParent_Done,
     /* 286851 */   // Label 5890: @286851
     /* 286851 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(286929), // Rule ID 6130 //
     /* 286856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 286893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286897 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286901 */     // MIs[3] Operand 1
     /* 286901 */     // No operand predicates
     /* 286901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286911 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 286914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286927 */     GIR_RootConstrainSelectedInstOperands,
     /* 286928 */     // GIR_Coverage, 6130,
     /* 286928 */     GIR_EraseRootFromParent_Done,
     /* 286929 */   // Label 5891: @286929
     /* 286929 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(287013), // Rule ID 6042 //
     /* 286934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286966 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286970 */     // MIs[2] Operand 1
     /* 286970 */     // No operand predicates
     /* 286970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 286982 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286993 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 286996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 287004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287011 */     GIR_RootConstrainSelectedInstOperands,
     /* 287012 */     // GIR_Coverage, 6042,
     /* 287012 */     GIR_EraseRootFromParent_Done,
     /* 287013 */   // Label 5892: @287013
     /* 287013 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(287094), // Rule ID 6074 //
     /* 287018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287062 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287066 */     // MIs[3] Operand 1
     /* 287066 */     // No operand predicates
     /* 287066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287076 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 287079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287092 */     GIR_RootConstrainSelectedInstOperands,
     /* 287093 */     // GIR_Coverage, 6074,
     /* 287093 */     GIR_EraseRootFromParent_Done,
     /* 287094 */   // Label 5893: @287094
     /* 287094 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(287178), // Rule ID 6106 //
     /* 287099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287148 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287152 */     // MIs[3] Operand 1
     /* 287152 */     // No operand predicates
     /* 287152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287158 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 287161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287176 */     GIR_RootConstrainSelectedInstOperands,
     /* 287177 */     // GIR_Coverage, 6106,
     /* 287177 */     GIR_EraseRootFromParent_Done,
     /* 287178 */   // Label 5894: @287178
     /* 287178 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(287256), // Rule ID 6152 //
     /* 287183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 287224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287228 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287232 */     // MIs[3] Operand 1
     /* 287232 */     // No operand predicates
     /* 287232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287238 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 287241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287254 */     GIR_RootConstrainSelectedInstOperands,
     /* 287255 */     // GIR_Coverage, 6152,
     /* 287255 */     GIR_EraseRootFromParent_Done,
     /* 287256 */   // Label 5895: @287256
     /* 287256 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(287337), // Rule ID 6010 //
     /* 287261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287313 */     // MIs[3] Operand 1
     /* 287313 */     // No operand predicates
     /* 287313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287319 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 287322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287335 */     GIR_RootConstrainSelectedInstOperands,
     /* 287336 */     // GIR_Coverage, 6010,
     /* 287336 */     GIR_EraseRootFromParent_Done,
     /* 287337 */   // Label 5896: @287337
     /* 287337 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(287422), // Rule ID 2451 //
     /* 287342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287380 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 287380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287392 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 287398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 287411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287420 */     GIR_RootConstrainSelectedInstOperands,
     /* 287421 */     // GIR_Coverage, 2451,
     /* 287421 */     GIR_EraseRootFromParent_Done,
     /* 287422 */   // Label 5897: @287422
     /* 287422 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(287507), // Rule ID 2449 //
     /* 287427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287455 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287465 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 287465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287477 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 287483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 287496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287505 */     GIR_RootConstrainSelectedInstOperands,
     /* 287506 */     // GIR_Coverage, 2449,
     /* 287506 */     GIR_EraseRootFromParent_Done,
     /* 287507 */   // Label 5898: @287507
     /* 287507 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(287576), // Rule ID 2543 //
     /* 287512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287544 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287548 */     // MIs[2] Operand 1
     /* 287548 */     // No operand predicates
     /* 287548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287558 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 287561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287574 */     GIR_RootConstrainSelectedInstOperands,
     /* 287575 */     // GIR_Coverage, 2543,
     /* 287575 */     GIR_EraseRootFromParent_Done,
     /* 287576 */   // Label 5899: @287576
     /* 287576 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(287645), // Rule ID 5978 //
     /* 287581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287617 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287621 */     // MIs[2] Operand 1
     /* 287621 */     // No operand predicates
     /* 287621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287627 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 287630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287643 */     GIR_RootConstrainSelectedInstOperands,
     /* 287644 */     // GIR_Coverage, 5978,
     /* 287644 */     GIR_EraseRootFromParent_Done,
     /* 287645 */   // Label 5900: @287645
     /* 287645 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(287707), // Rule ID 4833 //
     /* 287650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 287683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287690 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 287690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 287693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287705 */     GIR_RootConstrainSelectedInstOperands,
     /* 287706 */     // GIR_Coverage, 4833,
     /* 287706 */     GIR_EraseRootFromParent_Done,
     /* 287707 */   // Label 5901: @287707
     /* 287707 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(287769), // Rule ID 13671 //
     /* 287712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 287745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287752 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 287752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 287755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 287763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287767 */     GIR_RootConstrainSelectedInstOperands,
     /* 287768 */     // GIR_Coverage, 13671,
     /* 287768 */     GIR_EraseRootFromParent_Done,
     /* 287769 */   // Label 5902: @287769
     /* 287769 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(287816), // Rule ID 4830 //
     /* 287774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287801 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 287801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 287804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287814 */     GIR_RootConstrainSelectedInstOperands,
     /* 287815 */     // GIR_Coverage, 4830,
     /* 287815 */     GIR_EraseRootFromParent_Done,
     /* 287816 */   // Label 5903: @287816
     /* 287816 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(287866), // Rule ID 13098 //
     /* 287821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287851 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 287851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 287854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287864 */     GIR_RootConstrainSelectedInstOperands,
     /* 287865 */     // GIR_Coverage, 13098,
     /* 287865 */     GIR_EraseRootFromParent_Done,
     /* 287866 */   // Label 5904: @287866
     /* 287866 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(287916), // Rule ID 646 //
     /* 287871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287901 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 287901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 287904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287914 */     GIR_RootConstrainSelectedInstOperands,
     /* 287915 */     // GIR_Coverage, 646,
     /* 287915 */     GIR_EraseRootFromParent_Done,
     /* 287916 */   // Label 5905: @287916
     /* 287916 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(287963), // Rule ID 13668 //
     /* 287921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287948 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 287948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 287951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 287959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287961 */     GIR_RootConstrainSelectedInstOperands,
     /* 287962 */     // GIR_Coverage, 13668,
     /* 287962 */     GIR_EraseRootFromParent_Done,
     /* 287963 */   // Label 5906: @287963
     /* 287963 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(288013), // Rule ID 658 //
     /* 287968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287998 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 287998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 288001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 288011 */     GIR_RootConstrainSelectedInstOperands,
     /* 288012 */     // GIR_Coverage, 658,
     /* 288012 */     GIR_EraseRootFromParent_Done,
     /* 288013 */   // Label 5907: @288013
     /* 288013 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(288044), // Rule ID 640 //
     /* 288018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288033 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 288033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 288038 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288042 */     GIR_RootConstrainSelectedInstOperands,
     /* 288043 */     // GIR_Coverage, 640,
     /* 288043 */     GIR_Done,
     /* 288044 */   // Label 5908: @288044
     /* 288044 */   GIM_Reject,
     /* 288045 */ // Label 5874: @288045
     /* 288045 */ GIM_Reject,
     /* 288046 */ // Label 5834: @288046
     /* 288046 */ GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(291193),
     /* 288051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 288060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288064 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(288214), // Rule ID 4828 //
     /* 288069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288118 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 288122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 288126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 288134 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288141 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 288141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 288144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288153 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 288159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288181 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 288200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 288208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 288212 */     GIR_RootConstrainSelectedInstOperands,
     /* 288213 */     // GIR_Coverage, 4828,
     /* 288213 */     GIR_EraseRootFromParent_Done,
     /* 288214 */   // Label 5910: @288214
     /* 288214 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(288361), // Rule ID 4792 //
     /* 288219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288267 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288271 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 288275 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288280 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 288284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288290 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 288290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 288293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288302 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 288308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288313 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288330 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 288357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288359 */     GIR_RootConstrainSelectedInstOperands,
     /* 288360 */     // GIR_Coverage, 4792,
     /* 288360 */     GIR_EraseRootFromParent_Done,
     /* 288361 */   // Label 5911: @288361
     /* 288361 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(288508), // Rule ID 13666 //
     /* 288366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288402 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 288406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 288422 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288427 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 288431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288437 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 288437 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 288440 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288444 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288449 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 288455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288460 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288477 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 288504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288506 */     GIR_RootConstrainSelectedInstOperands,
     /* 288507 */     // GIR_Coverage, 13666,
     /* 288507 */     GIR_EraseRootFromParent_Done,
     /* 288508 */   // Label 5912: @288508
     /* 288508 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(288639), // Rule ID 6016 //
     /* 288513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288537 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288561 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288565 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 288569 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288574 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 288578 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288582 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288586 */     // MIs[4] Operand 1
     /* 288586 */     // No operand predicates
     /* 288586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288590 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 288592 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288604 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 288623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 288634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 288637 */     GIR_RootConstrainSelectedInstOperands,
     /* 288638 */     // GIR_Coverage, 6016,
     /* 288638 */     GIR_EraseRootFromParent_Done,
     /* 288639 */   // Label 5913: @288639
     /* 288639 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(288770), // Rule ID 6048 //
     /* 288644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288680 */     // MIs[2] Operand 1
     /* 288680 */     // No operand predicates
     /* 288680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288688 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 288692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 288696 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288700 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288704 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 288708 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288713 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 288717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288721 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 288723 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 288754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288768 */     GIR_RootConstrainSelectedInstOperands,
     /* 288769 */     // GIR_Coverage, 6048,
     /* 288769 */     GIR_EraseRootFromParent_Done,
     /* 288770 */   // Label 5914: @288770
     /* 288770 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(288901), // Rule ID 6112 //
     /* 288775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288811 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 288815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 288831 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 288840 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288844 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288848 */     // MIs[4] Operand 1
     /* 288848 */     // No operand predicates
     /* 288848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288852 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 288854 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288866 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 288885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 288896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 288899 */     GIR_RootConstrainSelectedInstOperands,
     /* 288900 */     // GIR_Coverage, 6112,
     /* 288900 */     GIR_EraseRootFromParent_Done,
     /* 288901 */   // Label 5915: @288901
     /* 288901 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(289032), // Rule ID 6080 //
     /* 288906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288950 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288954 */     // MIs[3] Operand 1
     /* 288954 */     // No operand predicates
     /* 288954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 288958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288962 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288966 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 288970 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288975 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 288979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288983 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 288985 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288997 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 289016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289030 */     GIR_RootConstrainSelectedInstOperands,
     /* 289031 */     // GIR_Coverage, 6080,
     /* 289031 */     GIR_EraseRootFromParent_Done,
     /* 289032 */   // Label 5916: @289032
     /* 289032 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(289167), // Rule ID 2459 //
     /* 289037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289061 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289086 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289096 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 289096 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 289099 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289103 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289108 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 289114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289136 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 289155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 289163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 289165 */     GIR_RootConstrainSelectedInstOperands,
     /* 289166 */     // GIR_Coverage, 2459,
     /* 289166 */     GIR_EraseRootFromParent_Done,
     /* 289167 */   // Label 5917: @289167
     /* 289167 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(289286), // Rule ID 5984 //
     /* 289172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289229 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289233 */     // MIs[3] Operand 1
     /* 289233 */     // No operand predicates
     /* 289233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289239 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 289239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289251 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 289270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289284 */     GIR_RootConstrainSelectedInstOperands,
     /* 289285 */     // GIR_Coverage, 5984,
     /* 289285 */     GIR_EraseRootFromParent_Done,
     /* 289286 */   // Label 5918: @289286
     /* 289286 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(289405), // Rule ID 2549 //
     /* 289291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289323 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289327 */     // MIs[2] Operand 1
     /* 289327 */     // No operand predicates
     /* 289327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289335 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289339 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289343 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289348 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289358 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 289358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289370 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 289389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289403 */     GIR_RootConstrainSelectedInstOperands,
     /* 289404 */     // GIR_Coverage, 2549,
     /* 289404 */     GIR_EraseRootFromParent_Done,
     /* 289405 */   // Label 5919: @289405
     /* 289405 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(289505), // Rule ID 4790 //
     /* 289410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289434 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 289450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289461 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 289461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289473 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 289492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 289503 */     GIR_RootConstrainSelectedInstOperands,
     /* 289504 */     // GIR_Coverage, 4790,
     /* 289504 */     GIR_EraseRootFromParent_Done,
     /* 289505 */   // Label 5920: @289505
     /* 289505 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(289605), // Rule ID 4826 //
     /* 289510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289534 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 289546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 289554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289561 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 289561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289573 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 289592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 289599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 289603 */     GIR_RootConstrainSelectedInstOperands,
     /* 289604 */     // GIR_Coverage, 4826,
     /* 289604 */     GIR_EraseRootFromParent_Done,
     /* 289605 */   // Label 5921: @289605
     /* 289605 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(289702), // Rule ID 13662 //
     /* 289610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289646 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289660 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 289660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289672 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 289678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 289691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 289700 */     GIR_RootConstrainSelectedInstOperands,
     /* 289701 */     // GIR_Coverage, 13662,
     /* 289701 */     GIR_EraseRootFromParent_Done,
     /* 289702 */   // Label 5922: @289702
     /* 289702 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(289802), // Rule ID 13664 //
     /* 289707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289748 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289758 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 289758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289770 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 289789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 289800 */     GIR_RootConstrainSelectedInstOperands,
     /* 289801 */     // GIR_Coverage, 13664,
     /* 289801 */     GIR_EraseRootFromParent_Done,
     /* 289802 */   // Label 5923: @289802
     /* 289802 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(289902), // Rule ID 4824 //
     /* 289807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289835 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 289843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 289851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289858 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 289858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 289876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 289889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 289900 */     GIR_RootConstrainSelectedInstOperands,
     /* 289901 */     // GIR_Coverage, 4824,
     /* 289901 */     GIR_EraseRootFromParent_Done,
     /* 289902 */   // Label 5924: @289902
     /* 289902 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(289999), // Rule ID 4788 //
     /* 289907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289947 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289957 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 289957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289969 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 289975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 289988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 289997 */     GIR_RootConstrainSelectedInstOperands,
     /* 289998 */     // GIR_Coverage, 4788,
     /* 289998 */     GIR_EraseRootFromParent_Done,
     /* 289999 */   // Label 5925: @289999
     /* 289999 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(290077), // Rule ID 6134 //
     /* 290004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 290041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290045 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290049 */     // MIs[3] Operand 1
     /* 290049 */     // No operand predicates
     /* 290049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290059 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 290062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290075 */     GIR_RootConstrainSelectedInstOperands,
     /* 290076 */     // GIR_Coverage, 6134,
     /* 290076 */     GIR_EraseRootFromParent_Done,
     /* 290077 */   // Label 5926: @290077
     /* 290077 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(290161), // Rule ID 6046 //
     /* 290082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290114 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290118 */     // MIs[2] Operand 1
     /* 290118 */     // No operand predicates
     /* 290118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 290130 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290141 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 290141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 290144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 290152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290159 */     GIR_RootConstrainSelectedInstOperands,
     /* 290160 */     // GIR_Coverage, 6046,
     /* 290160 */     GIR_EraseRootFromParent_Done,
     /* 290161 */   // Label 5927: @290161
     /* 290161 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(290242), // Rule ID 6078 //
     /* 290166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290210 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290214 */     // MIs[3] Operand 1
     /* 290214 */     // No operand predicates
     /* 290214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290224 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 290224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 290227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290240 */     GIR_RootConstrainSelectedInstOperands,
     /* 290241 */     // GIR_Coverage, 6078,
     /* 290241 */     GIR_EraseRootFromParent_Done,
     /* 290242 */   // Label 5928: @290242
     /* 290242 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(290326), // Rule ID 6110 //
     /* 290247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290296 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290300 */     // MIs[3] Operand 1
     /* 290300 */     // No operand predicates
     /* 290300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290306 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 290306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 290309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290324 */     GIR_RootConstrainSelectedInstOperands,
     /* 290325 */     // GIR_Coverage, 6110,
     /* 290325 */     GIR_EraseRootFromParent_Done,
     /* 290326 */   // Label 5929: @290326
     /* 290326 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(290404), // Rule ID 6156 //
     /* 290331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 290372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290376 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290380 */     // MIs[3] Operand 1
     /* 290380 */     // No operand predicates
     /* 290380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290386 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 290389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290402 */     GIR_RootConstrainSelectedInstOperands,
     /* 290403 */     // GIR_Coverage, 6156,
     /* 290403 */     GIR_EraseRootFromParent_Done,
     /* 290404 */   // Label 5930: @290404
     /* 290404 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(290485), // Rule ID 6014 //
     /* 290409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290461 */     // MIs[3] Operand 1
     /* 290461 */     // No operand predicates
     /* 290461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290467 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 290467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 290470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290483 */     GIR_RootConstrainSelectedInstOperands,
     /* 290484 */     // GIR_Coverage, 6014,
     /* 290484 */     GIR_EraseRootFromParent_Done,
     /* 290485 */   // Label 5931: @290485
     /* 290485 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(290570), // Rule ID 2457 //
     /* 290490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290514 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290528 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 290528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290540 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 290546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 290559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 290566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290568 */     GIR_RootConstrainSelectedInstOperands,
     /* 290569 */     // GIR_Coverage, 2457,
     /* 290569 */     GIR_EraseRootFromParent_Done,
     /* 290570 */   // Label 5932: @290570
     /* 290570 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(290655), // Rule ID 2455 //
     /* 290575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290603 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290613 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 290613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290625 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 290631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 290644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290653 */     GIR_RootConstrainSelectedInstOperands,
     /* 290654 */     // GIR_Coverage, 2455,
     /* 290654 */     GIR_EraseRootFromParent_Done,
     /* 290655 */   // Label 5933: @290655
     /* 290655 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(290724), // Rule ID 2547 //
     /* 290660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290696 */     // MIs[2] Operand 1
     /* 290696 */     // No operand predicates
     /* 290696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290706 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 290706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 290709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290722 */     GIR_RootConstrainSelectedInstOperands,
     /* 290723 */     // GIR_Coverage, 2547,
     /* 290723 */     GIR_EraseRootFromParent_Done,
     /* 290724 */   // Label 5934: @290724
     /* 290724 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(290793), // Rule ID 5982 //
     /* 290729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290765 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290769 */     // MIs[2] Operand 1
     /* 290769 */     // No operand predicates
     /* 290769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290775 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 290775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 290778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290791 */     GIR_RootConstrainSelectedInstOperands,
     /* 290792 */     // GIR_Coverage, 5982,
     /* 290792 */     GIR_EraseRootFromParent_Done,
     /* 290793 */   // Label 5935: @290793
     /* 290793 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(290855), // Rule ID 4834 //
     /* 290798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 290823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290838 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 290838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 290841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 290849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 290853 */     GIR_RootConstrainSelectedInstOperands,
     /* 290854 */     // GIR_Coverage, 4834,
     /* 290854 */     GIR_EraseRootFromParent_Done,
     /* 290855 */   // Label 5936: @290855
     /* 290855 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(290917), // Rule ID 13672 //
     /* 290860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 290885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290900 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 290900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 290903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 290911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 290915 */     GIR_RootConstrainSelectedInstOperands,
     /* 290916 */     // GIR_Coverage, 13672,
     /* 290916 */     GIR_EraseRootFromParent_Done,
     /* 290917 */   // Label 5937: @290917
     /* 290917 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(290964), // Rule ID 4831 //
     /* 290922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290949 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 290949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 290952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 290960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290962 */     GIR_RootConstrainSelectedInstOperands,
     /* 290963 */     // GIR_Coverage, 4831,
     /* 290963 */     GIR_EraseRootFromParent_Done,
     /* 290964 */   // Label 5938: @290964
     /* 290964 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(291014), // Rule ID 13100 //
     /* 290969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290999 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 290999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 291002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291012 */     GIR_RootConstrainSelectedInstOperands,
     /* 291013 */     // GIR_Coverage, 13100,
     /* 291013 */     GIR_EraseRootFromParent_Done,
     /* 291014 */   // Label 5939: @291014
     /* 291014 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(291064), // Rule ID 648 //
     /* 291019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291049 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 291049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 291052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291062 */     GIR_RootConstrainSelectedInstOperands,
     /* 291063 */     // GIR_Coverage, 648,
     /* 291063 */     GIR_EraseRootFromParent_Done,
     /* 291064 */   // Label 5940: @291064
     /* 291064 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(291111), // Rule ID 13669 //
     /* 291069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291096 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 291096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 291099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 291107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291109 */     GIR_RootConstrainSelectedInstOperands,
     /* 291110 */     // GIR_Coverage, 13669,
     /* 291110 */     GIR_EraseRootFromParent_Done,
     /* 291111 */   // Label 5941: @291111
     /* 291111 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(291161), // Rule ID 660 //
     /* 291116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291146 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 291146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 291149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 291159 */     GIR_RootConstrainSelectedInstOperands,
     /* 291160 */     // GIR_Coverage, 660,
     /* 291160 */     GIR_EraseRootFromParent_Done,
     /* 291161 */   // Label 5942: @291161
     /* 291161 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(291192), // Rule ID 642 //
     /* 291166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291181 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 291181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 291186 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 291190 */     GIR_RootConstrainSelectedInstOperands,
     /* 291191 */     // GIR_Coverage, 642,
     /* 291191 */     GIR_Done,
     /* 291192 */   // Label 5943: @291192
     /* 291192 */   GIM_Reject,
     /* 291193 */ // Label 5909: @291193
     /* 291193 */ GIM_Reject,
     /* 291194 */ // Label 5835: @291194
     /* 291194 */ GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(292714),
     /* 291199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 291202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 291205 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 291208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291212 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(291290), // Rule ID 6114 //
     /* 291217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 291254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291258 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291262 */     // MIs[3] Operand 1
     /* 291262 */     // No operand predicates
     /* 291262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291272 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 291275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291288 */     GIR_RootConstrainSelectedInstOperands,
     /* 291289 */     // GIR_Coverage, 6114,
     /* 291289 */     GIR_EraseRootFromParent_Done,
     /* 291290 */   // Label 5945: @291290
     /* 291290 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(291374), // Rule ID 6030 //
     /* 291295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291331 */     // MIs[2] Operand 1
     /* 291331 */     // No operand predicates
     /* 291331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291339 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 291343 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291354 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 291357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 291365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291372 */     GIR_RootConstrainSelectedInstOperands,
     /* 291373 */     // GIR_Coverage, 6030,
     /* 291373 */     GIR_EraseRootFromParent_Done,
     /* 291374 */   // Label 5946: @291374
     /* 291374 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(291455), // Rule ID 6062 //
     /* 291379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 291394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291423 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291427 */     // MIs[3] Operand 1
     /* 291427 */     // No operand predicates
     /* 291427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291437 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 291440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291453 */     GIR_RootConstrainSelectedInstOperands,
     /* 291454 */     // GIR_Coverage, 6062,
     /* 291454 */     GIR_EraseRootFromParent_Done,
     /* 291455 */   // Label 5947: @291455
     /* 291455 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(291539), // Rule ID 6094 //
     /* 291460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 291475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291509 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291513 */     // MIs[3] Operand 1
     /* 291513 */     // No operand predicates
     /* 291513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291519 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 291522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291537 */     GIR_RootConstrainSelectedInstOperands,
     /* 291538 */     // GIR_Coverage, 6094,
     /* 291538 */     GIR_EraseRootFromParent_Done,
     /* 291539 */   // Label 5948: @291539
     /* 291539 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(291617), // Rule ID 6136 //
     /* 291544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 291585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291589 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291593 */     // MIs[3] Operand 1
     /* 291593 */     // No operand predicates
     /* 291593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291599 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 291602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291615 */     GIR_RootConstrainSelectedInstOperands,
     /* 291616 */     // GIR_Coverage, 6136,
     /* 291616 */     GIR_EraseRootFromParent_Done,
     /* 291617 */   // Label 5949: @291617
     /* 291617 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(291698), // Rule ID 5998 //
     /* 291622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 291641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291670 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291674 */     // MIs[3] Operand 1
     /* 291674 */     // No operand predicates
     /* 291674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291680 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 291683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291696 */     GIR_RootConstrainSelectedInstOperands,
     /* 291697 */     // GIR_Coverage, 5998,
     /* 291697 */     GIR_EraseRootFromParent_Done,
     /* 291698 */   // Label 5950: @291698
     /* 291698 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(291767), // Rule ID 2531 //
     /* 291703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291739 */     // MIs[2] Operand 1
     /* 291739 */     // No operand predicates
     /* 291739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291749 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 291752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291765 */     GIR_RootConstrainSelectedInstOperands,
     /* 291766 */     // GIR_Coverage, 2531,
     /* 291766 */     GIR_EraseRootFromParent_Done,
     /* 291767 */   // Label 5951: @291767
     /* 291767 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(291836), // Rule ID 5966 //
     /* 291772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 291787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291812 */     // MIs[2] Operand 1
     /* 291812 */     // No operand predicates
     /* 291812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291818 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 291821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291834 */     GIR_RootConstrainSelectedInstOperands,
     /* 291835 */     // GIR_Coverage, 5966,
     /* 291835 */     GIR_EraseRootFromParent_Done,
     /* 291836 */   // Label 5952: @291836
     /* 291836 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(291929), // Rule ID 6118 //
     /* 291841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 291865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291880 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 291902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 291915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291927 */     GIR_RootConstrainSelectedInstOperands,
     /* 291928 */     // GIR_Coverage, 6118,
     /* 291928 */     GIR_EraseRootFromParent_Done,
     /* 291929 */   // Label 5953: @291929
     /* 291929 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(292028), // Rule ID 6032 //
     /* 291934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 291966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291977 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291989 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291996 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 291999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 292012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 292020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292026 */     GIR_RootConstrainSelectedInstOperands,
     /* 292027 */     // GIR_Coverage, 6032,
     /* 292027 */     GIR_EraseRootFromParent_Done,
     /* 292028 */   // Label 5954: @292028
     /* 292028 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(292124), // Rule ID 6064 //
     /* 292033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 292048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 292060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292075 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 292078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292087 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 292097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 292110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292122 */     GIR_RootConstrainSelectedInstOperands,
     /* 292123 */     // GIR_Coverage, 6064,
     /* 292123 */     GIR_EraseRootFromParent_Done,
     /* 292124 */   // Label 5955: @292124
     /* 292124 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(292223), // Rule ID 6096 //
     /* 292129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 292144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 292161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292172 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 292175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292191 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 292194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 292207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292221 */     GIR_RootConstrainSelectedInstOperands,
     /* 292222 */     // GIR_Coverage, 6096,
     /* 292222 */     GIR_EraseRootFromParent_Done,
     /* 292223 */   // Label 5956: @292223
     /* 292223 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(292316), // Rule ID 6140 //
     /* 292228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 292244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 292256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292267 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 292270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292279 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 292289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 292302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292314 */     GIR_RootConstrainSelectedInstOperands,
     /* 292315 */     // GIR_Coverage, 6140,
     /* 292315 */     GIR_EraseRootFromParent_Done,
     /* 292316 */   // Label 5957: @292316
     /* 292316 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(292412), // Rule ID 6000 //
     /* 292321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 292340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 292352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292363 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 292366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292375 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292382 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 292385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 292398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292410 */     GIR_RootConstrainSelectedInstOperands,
     /* 292411 */     // GIR_Coverage, 6000,
     /* 292411 */     GIR_EraseRootFromParent_Done,
     /* 292412 */   // Label 5958: @292412
     /* 292412 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(292496), // Rule ID 2533 //
     /* 292417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 292432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292447 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 292450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 292469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 292482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292494 */     GIR_RootConstrainSelectedInstOperands,
     /* 292495 */     // GIR_Coverage, 2533,
     /* 292495 */     GIR_EraseRootFromParent_Done,
     /* 292496 */   // Label 5959: @292496
     /* 292496 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(292546), // Rule ID 13130 //
     /* 292501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 292516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292531 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 292531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 292534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292544 */     GIR_RootConstrainSelectedInstOperands,
     /* 292545 */     // GIR_Coverage, 13130,
     /* 292545 */     GIR_EraseRootFromParent_Done,
     /* 292546 */   // Label 5960: @292546
     /* 292546 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(292630), // Rule ID 5968 //
     /* 292551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 292570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292581 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 292584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292593 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292600 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 292603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 292616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292628 */     GIR_RootConstrainSelectedInstOperands,
     /* 292629 */     // GIR_Coverage, 5968,
     /* 292629 */     GIR_EraseRootFromParent_Done,
     /* 292630 */   // Label 5961: @292630
     /* 292630 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(292680), // Rule ID 1301 //
     /* 292635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 292654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292665 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 292665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 292668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292678 */     GIR_RootConstrainSelectedInstOperands,
     /* 292679 */     // GIR_Coverage, 1301,
     /* 292679 */     GIR_EraseRootFromParent_Done,
     /* 292680 */   // Label 5962: @292680
     /* 292680 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(292713), // Rule ID 1291 //
     /* 292685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292700 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 292700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 292703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292711 */     GIR_RootConstrainSelectedInstOperands,
     /* 292712 */     // GIR_Coverage, 1291,
     /* 292712 */     GIR_EraseRootFromParent_Done,
     /* 292713 */   // Label 5963: @292713
     /* 292713 */   GIM_Reject,
     /* 292714 */ // Label 5944: @292714
     /* 292714 */ GIM_Reject,
     /* 292715 */ // Label 5836: @292715
     /* 292715 */ GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(294235),
     /* 292720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 292726 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 292729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292733 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(292811), // Rule ID 6126 //
     /* 292738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 292746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 292775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292779 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 292783 */     // MIs[3] Operand 1
     /* 292783 */     // No operand predicates
     /* 292783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292793 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 292796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292809 */     GIR_RootConstrainSelectedInstOperands,
     /* 292810 */     // GIR_Coverage, 6126,
     /* 292810 */     GIR_EraseRootFromParent_Done,
     /* 292811 */   // Label 5965: @292811
     /* 292811 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(292895), // Rule ID 6038 //
     /* 292816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 292827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292848 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 292852 */     // MIs[2] Operand 1
     /* 292852 */     // No operand predicates
     /* 292852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292860 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292864 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292875 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 292878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 292886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292893 */     GIR_RootConstrainSelectedInstOperands,
     /* 292894 */     // GIR_Coverage, 6038,
     /* 292894 */     GIR_EraseRootFromParent_Done,
     /* 292895 */   // Label 5966: @292895
     /* 292895 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(292976), // Rule ID 6070 //
     /* 292900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 292923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292944 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 292948 */     // MIs[3] Operand 1
     /* 292948 */     // No operand predicates
     /* 292948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292958 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 292961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292974 */     GIR_RootConstrainSelectedInstOperands,
     /* 292975 */     // GIR_Coverage, 6070,
     /* 292975 */     GIR_EraseRootFromParent_Done,
     /* 292976 */   // Label 5967: @292976
     /* 292976 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(293060), // Rule ID 6102 //
     /* 292981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 293009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293030 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 293034 */     // MIs[3] Operand 1
     /* 293034 */     // No operand predicates
     /* 293034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293040 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293058 */     GIR_RootConstrainSelectedInstOperands,
     /* 293059 */     // GIR_Coverage, 6102,
     /* 293059 */     GIR_EraseRootFromParent_Done,
     /* 293060 */   // Label 5968: @293060
     /* 293060 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(293138), // Rule ID 6148 //
     /* 293065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 293077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 293106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293110 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 293114 */     // MIs[3] Operand 1
     /* 293114 */     // No operand predicates
     /* 293114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293120 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293136 */     GIR_RootConstrainSelectedInstOperands,
     /* 293137 */     // GIR_Coverage, 6148,
     /* 293137 */     GIR_EraseRootFromParent_Done,
     /* 293138 */   // Label 5969: @293138
     /* 293138 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(293219), // Rule ID 6006 //
     /* 293143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 293170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293191 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 293195 */     // MIs[3] Operand 1
     /* 293195 */     // No operand predicates
     /* 293195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293201 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293217 */     GIR_RootConstrainSelectedInstOperands,
     /* 293218 */     // GIR_Coverage, 6006,
     /* 293218 */     GIR_EraseRootFromParent_Done,
     /* 293219 */   // Label 5970: @293219
     /* 293219 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(293288), // Rule ID 2539 //
     /* 293224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 293235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293256 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 293260 */     // MIs[2] Operand 1
     /* 293260 */     // No operand predicates
     /* 293260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293270 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 293273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293286 */     GIR_RootConstrainSelectedInstOperands,
     /* 293287 */     // GIR_Coverage, 2539,
     /* 293287 */     GIR_EraseRootFromParent_Done,
     /* 293288 */   // Label 5971: @293288
     /* 293288 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(293357), // Rule ID 5974 //
     /* 293293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 293308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293329 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 293333 */     // MIs[2] Operand 1
     /* 293333 */     // No operand predicates
     /* 293333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293339 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 293342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293355 */     GIR_RootConstrainSelectedInstOperands,
     /* 293356 */     // GIR_Coverage, 5974,
     /* 293356 */     GIR_EraseRootFromParent_Done,
     /* 293357 */   // Label 5972: @293357
     /* 293357 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(293450), // Rule ID 6128 //
     /* 293362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 293374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 293386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293401 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293420 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 293423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293448 */     GIR_RootConstrainSelectedInstOperands,
     /* 293449 */     // GIR_Coverage, 6128,
     /* 293449 */     GIR_EraseRootFromParent_Done,
     /* 293450 */   // Label 5973: @293450
     /* 293450 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(293549), // Rule ID 6040 //
     /* 293455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 293470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293498 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293517 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 293520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 293541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293547 */     GIR_RootConstrainSelectedInstOperands,
     /* 293548 */     // GIR_Coverage, 6040,
     /* 293548 */     GIR_EraseRootFromParent_Done,
     /* 293549 */   // Label 5974: @293549
     /* 293549 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(293645), // Rule ID 6072 //
     /* 293554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 293581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293596 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293608 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293615 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 293618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293643 */     GIR_RootConstrainSelectedInstOperands,
     /* 293644 */     // GIR_Coverage, 6072,
     /* 293644 */     GIR_EraseRootFromParent_Done,
     /* 293645 */   // Label 5975: @293645
     /* 293645 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(293744), // Rule ID 6104 //
     /* 293650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 293682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293693 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 293715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293742 */     GIR_RootConstrainSelectedInstOperands,
     /* 293743 */     // GIR_Coverage, 6104,
     /* 293743 */     GIR_EraseRootFromParent_Done,
     /* 293744 */   // Label 5976: @293744
     /* 293744 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(293837), // Rule ID 6150 //
     /* 293749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 293765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 293777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293788 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 293810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293835 */     GIR_RootConstrainSelectedInstOperands,
     /* 293836 */     // GIR_Coverage, 6150,
     /* 293836 */     GIR_EraseRootFromParent_Done,
     /* 293837 */   // Label 5977: @293837
     /* 293837 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(293933), // Rule ID 6008 //
     /* 293842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 293873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293884 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293896 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293903 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 293906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 293919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293931 */     GIR_RootConstrainSelectedInstOperands,
     /* 293932 */     // GIR_Coverage, 6008,
     /* 293932 */     GIR_EraseRootFromParent_Done,
     /* 293933 */   // Label 5978: @293933
     /* 293933 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(294017), // Rule ID 2541 //
     /* 293938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 293953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293968 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293980 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293987 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 293990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 294003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294015 */     GIR_RootConstrainSelectedInstOperands,
     /* 294016 */     // GIR_Coverage, 2541,
     /* 294016 */     GIR_EraseRootFromParent_Done,
     /* 294017 */   // Label 5979: @294017
     /* 294017 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(294067), // Rule ID 13134 //
     /* 294022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294052 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 294052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 294055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294065 */     GIR_RootConstrainSelectedInstOperands,
     /* 294066 */     // GIR_Coverage, 13134,
     /* 294066 */     GIR_EraseRootFromParent_Done,
     /* 294067 */   // Label 5980: @294067
     /* 294067 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(294151), // Rule ID 5976 //
     /* 294072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294102 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 294105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294121 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 294124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 294137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294149 */     GIR_RootConstrainSelectedInstOperands,
     /* 294150 */     // GIR_Coverage, 5976,
     /* 294150 */     GIR_EraseRootFromParent_Done,
     /* 294151 */   // Label 5981: @294151
     /* 294151 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(294201), // Rule ID 1305 //
     /* 294156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294186 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 294186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 294189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294199 */     GIR_RootConstrainSelectedInstOperands,
     /* 294200 */     // GIR_Coverage, 1305,
     /* 294200 */     GIR_EraseRootFromParent_Done,
     /* 294201 */   // Label 5982: @294201
     /* 294201 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(294234), // Rule ID 1295 //
     /* 294206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294221 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 294221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 294224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 294232 */     GIR_RootConstrainSelectedInstOperands,
     /* 294233 */     // GIR_Coverage, 1295,
     /* 294233 */     GIR_EraseRootFromParent_Done,
     /* 294234 */   // Label 5983: @294234
     /* 294234 */   GIM_Reject,
     /* 294235 */ // Label 5964: @294235
     /* 294235 */ GIM_Reject,
     /* 294236 */ // Label 5837: @294236
     /* 294236 */ GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(295414),
     /* 294241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 294244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 294247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 294250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294254 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(294338), // Rule ID 6022 //
     /* 294259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294295 */     // MIs[2] Operand 1
     /* 294295 */     // No operand predicates
     /* 294295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294303 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 294307 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294318 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 294321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294336 */     GIR_RootConstrainSelectedInstOperands,
     /* 294337 */     // GIR_Coverage, 6022,
     /* 294337 */     GIR_EraseRootFromParent_Done,
     /* 294338 */   // Label 5985: @294338
     /* 294338 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(294419), // Rule ID 6054 //
     /* 294343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 294358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294387 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294391 */     // MIs[3] Operand 1
     /* 294391 */     // No operand predicates
     /* 294391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294401 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 294404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294417 */     GIR_RootConstrainSelectedInstOperands,
     /* 294418 */     // GIR_Coverage, 6054,
     /* 294418 */     GIR_EraseRootFromParent_Done,
     /* 294419 */   // Label 5986: @294419
     /* 294419 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(294503), // Rule ID 6086 //
     /* 294424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 294439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294473 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294477 */     // MIs[3] Operand 1
     /* 294477 */     // No operand predicates
     /* 294477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294483 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 294486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294501 */     GIR_RootConstrainSelectedInstOperands,
     /* 294502 */     // GIR_Coverage, 6086,
     /* 294502 */     GIR_EraseRootFromParent_Done,
     /* 294503 */   // Label 5987: @294503
     /* 294503 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(294584), // Rule ID 5990 //
     /* 294508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 294527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294556 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294560 */     // MIs[3] Operand 1
     /* 294560 */     // No operand predicates
     /* 294560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294566 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 294569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294582 */     GIR_RootConstrainSelectedInstOperands,
     /* 294583 */     // GIR_Coverage, 5990,
     /* 294583 */     GIR_EraseRootFromParent_Done,
     /* 294584 */   // Label 5988: @294584
     /* 294584 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(294653), // Rule ID 2523 //
     /* 294589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294621 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294625 */     // MIs[2] Operand 1
     /* 294625 */     // No operand predicates
     /* 294625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294635 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 294638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294651 */     GIR_RootConstrainSelectedInstOperands,
     /* 294652 */     // GIR_Coverage, 2523,
     /* 294652 */     GIR_EraseRootFromParent_Done,
     /* 294653 */   // Label 5989: @294653
     /* 294653 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(294722), // Rule ID 5958 //
     /* 294658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294694 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294698 */     // MIs[2] Operand 1
     /* 294698 */     // No operand predicates
     /* 294698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294704 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 294707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294720 */     GIR_RootConstrainSelectedInstOperands,
     /* 294721 */     // GIR_Coverage, 5958,
     /* 294721 */     GIR_EraseRootFromParent_Done,
     /* 294722 */   // Label 5990: @294722
     /* 294722 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(294821), // Rule ID 6024 //
     /* 294727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 294759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294770 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 294805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 294813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294819 */     GIR_RootConstrainSelectedInstOperands,
     /* 294820 */     // GIR_Coverage, 6024,
     /* 294820 */     GIR_EraseRootFromParent_Done,
     /* 294821 */   // Label 5991: @294821
     /* 294821 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(294917), // Rule ID 6056 //
     /* 294826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 294841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294868 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294880 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 294903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294915 */     GIR_RootConstrainSelectedInstOperands,
     /* 294916 */     // GIR_Coverage, 6056,
     /* 294916 */     GIR_EraseRootFromParent_Done,
     /* 294917 */   // Label 5992: @294917
     /* 294917 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(295016), // Rule ID 6088 //
     /* 294922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 294937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294965 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294977 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294984 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 295000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295014 */     GIR_RootConstrainSelectedInstOperands,
     /* 295015 */     // GIR_Coverage, 6088,
     /* 295015 */     GIR_EraseRootFromParent_Done,
     /* 295016 */   // Label 5993: @295016
     /* 295016 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(295112), // Rule ID 5992 //
     /* 295021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 295040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 295048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 295052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295063 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295075 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295082 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 295098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295110 */     GIR_RootConstrainSelectedInstOperands,
     /* 295111 */     // GIR_Coverage, 5992,
     /* 295111 */     GIR_EraseRootFromParent_Done,
     /* 295112 */   // Label 5994: @295112
     /* 295112 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(295196), // Rule ID 2525 //
     /* 295117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 295128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295147 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295166 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 295182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295194 */     GIR_RootConstrainSelectedInstOperands,
     /* 295195 */     // GIR_Coverage, 2525,
     /* 295195 */     GIR_EraseRootFromParent_Done,
     /* 295196 */   // Label 5995: @295196
     /* 295196 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(295246), // Rule ID 13126 //
     /* 295201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 295216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295231 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 295231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 295234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295244 */     GIR_RootConstrainSelectedInstOperands,
     /* 295245 */     // GIR_Coverage, 13126,
     /* 295245 */     GIR_EraseRootFromParent_Done,
     /* 295246 */   // Label 5996: @295246
     /* 295246 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(295330), // Rule ID 5960 //
     /* 295251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 295266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295281 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295293 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295296 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 295316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295328 */     GIR_RootConstrainSelectedInstOperands,
     /* 295329 */     // GIR_Coverage, 5960,
     /* 295329 */     GIR_EraseRootFromParent_Done,
     /* 295330 */   // Label 5997: @295330
     /* 295330 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(295380), // Rule ID 1297 //
     /* 295335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 295354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295365 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 295365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 295368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295378 */     GIR_RootConstrainSelectedInstOperands,
     /* 295379 */     // GIR_Coverage, 1297,
     /* 295379 */     GIR_EraseRootFromParent_Done,
     /* 295380 */   // Label 5998: @295380
     /* 295380 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(295413), // Rule ID 1287 //
     /* 295385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295400 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 295400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 295403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295411 */     GIR_RootConstrainSelectedInstOperands,
     /* 295412 */     // GIR_Coverage, 1287,
     /* 295412 */     GIR_EraseRootFromParent_Done,
     /* 295413 */   // Label 5999: @295413
     /* 295413 */   GIM_Reject,
     /* 295414 */ // Label 5984: @295414
     /* 295414 */ GIM_Reject,
     /* 295415 */ // Label 5838: @295415
     /* 295415 */ GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(296935),
     /* 295420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 295426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 295429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295433 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(295511), // Rule ID 6120 //
     /* 295438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295479 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295483 */     // MIs[3] Operand 1
     /* 295483 */     // No operand predicates
     /* 295483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295493 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 295496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295509 */     GIR_RootConstrainSelectedInstOperands,
     /* 295510 */     // GIR_Coverage, 6120,
     /* 295510 */     GIR_EraseRootFromParent_Done,
     /* 295511 */   // Label 6001: @295511
     /* 295511 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(295595), // Rule ID 6034 //
     /* 295516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295548 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295552 */     // MIs[2] Operand 1
     /* 295552 */     // No operand predicates
     /* 295552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 295556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295564 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295575 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 295578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 295586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295593 */     GIR_RootConstrainSelectedInstOperands,
     /* 295594 */     // GIR_Coverage, 6034,
     /* 295594 */     GIR_EraseRootFromParent_Done,
     /* 295595 */   // Label 6002: @295595
     /* 295595 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(295676), // Rule ID 6066 //
     /* 295600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295644 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295648 */     // MIs[3] Operand 1
     /* 295648 */     // No operand predicates
     /* 295648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295658 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 295661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295674 */     GIR_RootConstrainSelectedInstOperands,
     /* 295675 */     // GIR_Coverage, 6066,
     /* 295675 */     GIR_EraseRootFromParent_Done,
     /* 295676 */   // Label 6003: @295676
     /* 295676 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(295760), // Rule ID 6098 //
     /* 295681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295734 */     // MIs[3] Operand 1
     /* 295734 */     // No operand predicates
     /* 295734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295740 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 295743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295758 */     GIR_RootConstrainSelectedInstOperands,
     /* 295759 */     // GIR_Coverage, 6098,
     /* 295759 */     GIR_EraseRootFromParent_Done,
     /* 295760 */   // Label 6004: @295760
     /* 295760 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(295838), // Rule ID 6142 //
     /* 295765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295810 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295814 */     // MIs[3] Operand 1
     /* 295814 */     // No operand predicates
     /* 295814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295820 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 295823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295836 */     GIR_RootConstrainSelectedInstOperands,
     /* 295837 */     // GIR_Coverage, 6142,
     /* 295837 */     GIR_EraseRootFromParent_Done,
     /* 295838 */   // Label 6005: @295838
     /* 295838 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(295919), // Rule ID 6002 //
     /* 295843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295891 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295895 */     // MIs[3] Operand 1
     /* 295895 */     // No operand predicates
     /* 295895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295901 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 295904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295917 */     GIR_RootConstrainSelectedInstOperands,
     /* 295918 */     // GIR_Coverage, 6002,
     /* 295918 */     GIR_EraseRootFromParent_Done,
     /* 295919 */   // Label 6006: @295919
     /* 295919 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(295988), // Rule ID 2535 //
     /* 295924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295956 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295960 */     // MIs[2] Operand 1
     /* 295960 */     // No operand predicates
     /* 295960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295970 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 295973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295986 */     GIR_RootConstrainSelectedInstOperands,
     /* 295987 */     // GIR_Coverage, 2535,
     /* 295987 */     GIR_EraseRootFromParent_Done,
     /* 295988 */   // Label 6007: @295988
     /* 295988 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(296057), // Rule ID 5970 //
     /* 295993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 296008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296029 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296033 */     // MIs[2] Operand 1
     /* 296033 */     // No operand predicates
     /* 296033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296039 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 296042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296055 */     GIR_RootConstrainSelectedInstOperands,
     /* 296056 */     // GIR_Coverage, 5970,
     /* 296056 */     GIR_EraseRootFromParent_Done,
     /* 296057 */   // Label 6008: @296057
     /* 296057 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(296150), // Rule ID 6124 //
     /* 296062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 296070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296101 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296113 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296120 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 296136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296148 */     GIR_RootConstrainSelectedInstOperands,
     /* 296149 */     // GIR_Coverage, 6124,
     /* 296149 */     GIR_EraseRootFromParent_Done,
     /* 296150 */   // Label 6009: @296150
     /* 296150 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(296249), // Rule ID 6036 //
     /* 296155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 296166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296198 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296217 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 296233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 296241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296247 */     GIR_RootConstrainSelectedInstOperands,
     /* 296248 */     // GIR_Coverage, 6036,
     /* 296248 */     GIR_EraseRootFromParent_Done,
     /* 296249 */   // Label 6010: @296249
     /* 296249 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(296345), // Rule ID 6068 //
     /* 296254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 296277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296296 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296308 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 296331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296343 */     GIR_RootConstrainSelectedInstOperands,
     /* 296344 */     // GIR_Coverage, 6068,
     /* 296344 */     GIR_EraseRootFromParent_Done,
     /* 296345 */   // Label 6011: @296345
     /* 296345 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(296444), // Rule ID 6100 //
     /* 296350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 296378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296393 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296412 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 296428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296442 */     GIR_RootConstrainSelectedInstOperands,
     /* 296443 */     // GIR_Coverage, 6100,
     /* 296443 */     GIR_EraseRootFromParent_Done,
     /* 296444 */   // Label 6012: @296444
     /* 296444 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(296537), // Rule ID 6146 //
     /* 296449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 296461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296488 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 296523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296535 */     GIR_RootConstrainSelectedInstOperands,
     /* 296536 */     // GIR_Coverage, 6146,
     /* 296536 */     GIR_EraseRootFromParent_Done,
     /* 296537 */   // Label 6013: @296537
     /* 296537 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(296633), // Rule ID 6004 //
     /* 296542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 296569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296584 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296599 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296603 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 296619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296631 */     GIR_RootConstrainSelectedInstOperands,
     /* 296632 */     // GIR_Coverage, 6004,
     /* 296632 */     GIR_EraseRootFromParent_Done,
     /* 296633 */   // Label 6014: @296633
     /* 296633 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(296717), // Rule ID 2537 //
     /* 296638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 296649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296668 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296687 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 296703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296715 */     GIR_RootConstrainSelectedInstOperands,
     /* 296716 */     // GIR_Coverage, 2537,
     /* 296716 */     GIR_EraseRootFromParent_Done,
     /* 296717 */   // Label 6015: @296717
     /* 296717 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(296767), // Rule ID 13132 //
     /* 296722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296752 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 296752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 296755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296765 */     GIR_RootConstrainSelectedInstOperands,
     /* 296766 */     // GIR_Coverage, 13132,
     /* 296766 */     GIR_EraseRootFromParent_Done,
     /* 296767 */   // Label 6016: @296767
     /* 296767 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(296851), // Rule ID 5972 //
     /* 296772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 296787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296802 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 296837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296849 */     GIR_RootConstrainSelectedInstOperands,
     /* 296850 */     // GIR_Coverage, 5972,
     /* 296850 */     GIR_EraseRootFromParent_Done,
     /* 296851 */   // Label 6017: @296851
     /* 296851 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(296901), // Rule ID 1303 //
     /* 296856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296886 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 296886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 296889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296899 */     GIR_RootConstrainSelectedInstOperands,
     /* 296900 */     // GIR_Coverage, 1303,
     /* 296900 */     GIR_EraseRootFromParent_Done,
     /* 296901 */   // Label 6018: @296901
     /* 296901 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(296934), // Rule ID 1293 //
     /* 296906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296921 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 296921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 296924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 296932 */     GIR_RootConstrainSelectedInstOperands,
     /* 296933 */     // GIR_Coverage, 1293,
     /* 296933 */     GIR_EraseRootFromParent_Done,
     /* 296934 */   // Label 6019: @296934
     /* 296934 */   GIM_Reject,
     /* 296935 */ // Label 6000: @296935
     /* 296935 */ GIM_Reject,
     /* 296936 */ // Label 5839: @296936
     /* 296936 */ GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(298114),
     /* 296941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 296947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 296950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296954 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(297038), // Rule ID 6018 //
     /* 296959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 296962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 296970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 296983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 296995 */     // MIs[2] Operand 1
     /* 296995 */     // No operand predicates
     /* 296995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297003 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297007 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297018 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 297018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 297021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 297029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297036 */     GIR_RootConstrainSelectedInstOperands,
     /* 297037 */     // GIR_Coverage, 6018,
     /* 297037 */     GIR_EraseRootFromParent_Done,
     /* 297038 */   // Label 6021: @297038
     /* 297038 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(297119), // Rule ID 6050 //
     /* 297043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 297066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 297079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297087 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 297091 */     // MIs[3] Operand 1
     /* 297091 */     // No operand predicates
     /* 297091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297101 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 297101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 297104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297117 */     GIR_RootConstrainSelectedInstOperands,
     /* 297118 */     // GIR_Coverage, 6050,
     /* 297118 */     GIR_EraseRootFromParent_Done,
     /* 297119 */   // Label 6022: @297119
     /* 297119 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(297203), // Rule ID 6082 //
     /* 297124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 297152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 297165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297173 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 297177 */     // MIs[3] Operand 1
     /* 297177 */     // No operand predicates
     /* 297177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297183 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 297183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 297186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297201 */     GIR_RootConstrainSelectedInstOperands,
     /* 297202 */     // GIR_Coverage, 6082,
     /* 297202 */     GIR_EraseRootFromParent_Done,
     /* 297203 */   // Label 6023: @297203
     /* 297203 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(297284), // Rule ID 5986 //
     /* 297208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 297235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 297248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297256 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 297260 */     // MIs[3] Operand 1
     /* 297260 */     // No operand predicates
     /* 297260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297266 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 297266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 297269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297282 */     GIR_RootConstrainSelectedInstOperands,
     /* 297283 */     // GIR_Coverage, 5986,
     /* 297283 */     GIR_EraseRootFromParent_Done,
     /* 297284 */   // Label 6024: @297284
     /* 297284 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(297353), // Rule ID 2519 //
     /* 297289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 297300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 297313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 297325 */     // MIs[2] Operand 1
     /* 297325 */     // No operand predicates
     /* 297325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297335 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 297335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 297338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297351 */     GIR_RootConstrainSelectedInstOperands,
     /* 297352 */     // GIR_Coverage, 2519,
     /* 297352 */     GIR_EraseRootFromParent_Done,
     /* 297353 */   // Label 6025: @297353
     /* 297353 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(297422), // Rule ID 5954 //
     /* 297358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 297373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 297386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 297398 */     // MIs[2] Operand 1
     /* 297398 */     // No operand predicates
     /* 297398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297404 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 297404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 297407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297420 */     GIR_RootConstrainSelectedInstOperands,
     /* 297421 */     // GIR_Coverage, 5954,
     /* 297421 */     GIR_EraseRootFromParent_Done,
     /* 297422 */   // Label 6026: @297422
     /* 297422 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(297521), // Rule ID 6020 //
     /* 297427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 297438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297470 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 297473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297482 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 297492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 297505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 297513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297519 */     GIR_RootConstrainSelectedInstOperands,
     /* 297520 */     // GIR_Coverage, 6020,
     /* 297520 */     GIR_EraseRootFromParent_Done,
     /* 297521 */   // Label 6027: @297521
     /* 297521 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(297617), // Rule ID 6052 //
     /* 297526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 297549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 297553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297568 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 297571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 297590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 297603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297615 */     GIR_RootConstrainSelectedInstOperands,
     /* 297616 */     // GIR_Coverage, 6052,
     /* 297616 */     GIR_EraseRootFromParent_Done,
     /* 297617 */   // Label 6028: @297617
     /* 297617 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(297716), // Rule ID 6084 //
     /* 297622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 297650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 297654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297665 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 297668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 297687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 297700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297714 */     GIR_RootConstrainSelectedInstOperands,
     /* 297715 */     // GIR_Coverage, 6084,
     /* 297715 */     GIR_EraseRootFromParent_Done,
     /* 297716 */   // Label 6029: @297716
     /* 297716 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(297812), // Rule ID 5988 //
     /* 297721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 297748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 297752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297763 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 297766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 297785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 297798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297810 */     GIR_RootConstrainSelectedInstOperands,
     /* 297811 */     // GIR_Coverage, 5988,
     /* 297811 */     GIR_EraseRootFromParent_Done,
     /* 297812 */   // Label 6030: @297812
     /* 297812 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(297896), // Rule ID 2521 //
     /* 297817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 297828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297847 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 297850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 297869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 297882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297894 */     GIR_RootConstrainSelectedInstOperands,
     /* 297895 */     // GIR_Coverage, 2521,
     /* 297895 */     GIR_EraseRootFromParent_Done,
     /* 297896 */   // Label 6031: @297896
     /* 297896 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(297946), // Rule ID 13128 //
     /* 297901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297931 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 297931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 297934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297944 */     GIR_RootConstrainSelectedInstOperands,
     /* 297945 */     // GIR_Coverage, 13128,
     /* 297945 */     GIR_EraseRootFromParent_Done,
     /* 297946 */   // Label 6032: @297946
     /* 297946 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(298030), // Rule ID 5956 //
     /* 297951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 297954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 297966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 297975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297981 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 297984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298000 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 298003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 298016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298028 */     GIR_RootConstrainSelectedInstOperands,
     /* 298029 */     // GIR_Coverage, 5956,
     /* 298029 */     GIR_EraseRootFromParent_Done,
     /* 298030 */   // Label 6033: @298030
     /* 298030 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(298080), // Rule ID 1299 //
     /* 298035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298065 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 298065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 298068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298078 */     GIR_RootConstrainSelectedInstOperands,
     /* 298079 */     // GIR_Coverage, 1299,
     /* 298079 */     GIR_EraseRootFromParent_Done,
     /* 298080 */   // Label 6034: @298080
     /* 298080 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(298113), // Rule ID 1289 //
     /* 298085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298100 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 298100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 298103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298111 */     GIR_RootConstrainSelectedInstOperands,
     /* 298112 */     // GIR_Coverage, 1289,
     /* 298112 */     GIR_EraseRootFromParent_Done,
     /* 298113 */   // Label 6035: @298113
     /* 298113 */   GIM_Reject,
     /* 298114 */ // Label 6020: @298114
     /* 298114 */ GIM_Reject,
     /* 298115 */ // Label 5840: @298115
     /* 298115 */ GIM_Reject,
     /* 298116 */ // Label 61: @298116
     /* 298116 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6044*/ GIMT_Encode4(298731),
     /* 298127 */ /*GILLT_s16*//*Label 6036*/ GIMT_Encode4(298167),
     /* 298131 */ /*GILLT_s32*//*Label 6037*/ GIMT_Encode4(298205),
     /* 298135 */ /*GILLT_s64*//*Label 6038*/ GIMT_Encode4(298243), GIMT_Encode4(0),
     /* 298143 */ /*GILLT_v2s32*//*Label 6039*/ GIMT_Encode4(298281),
     /* 298147 */ /*GILLT_v2s64*//*Label 6040*/ GIMT_Encode4(298319),
     /* 298151 */ /*GILLT_v4s16*//*Label 6041*/ GIMT_Encode4(298357),
     /* 298155 */ /*GILLT_v4s32*//*Label 6042*/ GIMT_Encode4(298395), GIMT_Encode4(0),
     /* 298163 */ /*GILLT_v8s16*//*Label 6043*/ GIMT_Encode4(298433),
     /* 298167 */ // Label 6036: @298167
     /* 298167 */ GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(298204), // Rule ID 590 //
     /* 298172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 298175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 298178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 298181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 298185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 298189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 298193 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 298193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 298198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298202 */   GIR_RootConstrainSelectedInstOperands,
     /* 298203 */   // GIR_Coverage, 590,
     /* 298203 */   GIR_Done,
     /* 298204 */ // Label 6045: @298204
     /* 298204 */ GIM_Reject,
     /* 298205 */ // Label 6037: @298205
     /* 298205 */ GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(298242), // Rule ID 592 //
     /* 298210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 298216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 298219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298231 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 298231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 298236 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298240 */   GIR_RootConstrainSelectedInstOperands,
     /* 298241 */   // GIR_Coverage, 592,
     /* 298241 */   GIR_Done,
     /* 298242 */ // Label 6046: @298242
     /* 298242 */ GIM_Reject,
     /* 298243 */ // Label 6038: @298243
     /* 298243 */ GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(298280), // Rule ID 594 //
     /* 298248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298269 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 298269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 298274 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298278 */   GIR_RootConstrainSelectedInstOperands,
     /* 298279 */   // GIR_Coverage, 594,
     /* 298279 */   GIR_Done,
     /* 298280 */ // Label 6047: @298280
     /* 298280 */ GIM_Reject,
     /* 298281 */ // Label 6039: @298281
     /* 298281 */ GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(298318), // Rule ID 1221 //
     /* 298286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298307 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 298307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 298312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298316 */   GIR_RootConstrainSelectedInstOperands,
     /* 298317 */   // GIR_Coverage, 1221,
     /* 298317 */   GIR_Done,
     /* 298318 */ // Label 6048: @298318
     /* 298318 */ GIM_Reject,
     /* 298319 */ // Label 6040: @298319
     /* 298319 */ GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(298356), // Rule ID 1225 //
     /* 298324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 298333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298345 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 298345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 298350 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298354 */   GIR_RootConstrainSelectedInstOperands,
     /* 298355 */   // GIR_Coverage, 1225,
     /* 298355 */   GIR_Done,
     /* 298356 */ // Label 6049: @298356
     /* 298356 */ GIM_Reject,
     /* 298357 */ // Label 6041: @298357
     /* 298357 */ GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(298394), // Rule ID 1217 //
     /* 298362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298383 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 298383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 298388 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298392 */   GIR_RootConstrainSelectedInstOperands,
     /* 298393 */   // GIR_Coverage, 1217,
     /* 298393 */   GIR_Done,
     /* 298394 */ // Label 6050: @298394
     /* 298394 */ GIM_Reject,
     /* 298395 */ // Label 6042: @298395
     /* 298395 */ GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(298432), // Rule ID 1223 //
     /* 298400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 298409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298421 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 298421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 298426 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298430 */   GIR_RootConstrainSelectedInstOperands,
     /* 298431 */   // GIR_Coverage, 1223,
     /* 298431 */   GIR_Done,
     /* 298432 */ // Label 6051: @298432
     /* 298432 */ GIM_Reject,
     /* 298433 */ // Label 6043: @298433
     /* 298433 */ GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(298730),
     /* 298438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 298444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298456 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(298475), // Rule ID 1219 //
     /* 298461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298464 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 298464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 298469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 298473 */     GIR_RootConstrainSelectedInstOperands,
     /* 298474 */     // GIR_Coverage, 1219,
     /* 298474 */     GIR_Done,
     /* 298475 */   // Label 6053: @298475
     /* 298475 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(298729), // Rule ID 6927 //
     /* 298480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 298483 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 298483 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 298486 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 298490 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298495 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 298501 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 298504 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 298508 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298513 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 298519 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 298522 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 298526 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298531 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 298534 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 298537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 298539 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 298542 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298546 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298551 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298557 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298562 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298567 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 298570 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 298574 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298579 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 298582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 298584 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 298587 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298591 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298596 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298602 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298607 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298612 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 298615 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 298619 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298624 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 298627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 298629 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 298632 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 298636 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298641 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 298644 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 298647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 298652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 298656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298661 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 298664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 298666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 298669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 298673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 298680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 298687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298692 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298698 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 298701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 298719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 298727 */     GIR_RootConstrainSelectedInstOperands,
     /* 298728 */     // GIR_Coverage, 6927,
     /* 298728 */     GIR_EraseRootFromParent_Done,
     /* 298729 */   // Label 6054: @298729
     /* 298729 */   GIM_Reject,
     /* 298730 */ // Label 6052: @298730
     /* 298730 */ GIM_Reject,
     /* 298731 */ // Label 6044: @298731
     /* 298731 */ GIM_Reject,
     /* 298732 */ // Label 62: @298732
     /* 298732 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6063*/ GIMT_Encode4(302238),
     /* 298743 */ /*GILLT_s16*//*Label 6055*/ GIMT_Encode4(298783),
     /* 298747 */ /*GILLT_s32*//*Label 6056*/ GIMT_Encode4(299951),
     /* 298751 */ /*GILLT_s64*//*Label 6057*/ GIMT_Encode4(300974), GIMT_Encode4(0),
     /* 298759 */ /*GILLT_v2s32*//*Label 6058*/ GIMT_Encode4(301997),
     /* 298763 */ /*GILLT_v2s64*//*Label 6059*/ GIMT_Encode4(302024),
     /* 298767 */ /*GILLT_v4s16*//*Label 6060*/ GIMT_Encode4(302051),
     /* 298771 */ /*GILLT_v4s32*//*Label 6061*/ GIMT_Encode4(302131), GIMT_Encode4(0),
     /* 298779 */ /*GILLT_v8s16*//*Label 6062*/ GIMT_Encode4(302158),
     /* 298783 */ // Label 6055: @298783
     /* 298783 */ GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(299950),
     /* 298788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 298791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 298795 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(298953), // Rule ID 4798 //
     /* 298800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 298803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 298815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 298819 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 298823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298844 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298860 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298864 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298869 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 298878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298880 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 298880 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 298883 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298887 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298892 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 298898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 298903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 298911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298920 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 298926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 298931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 298939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298951 */     GIR_RootConstrainSelectedInstOperands,
     /* 298952 */     // GIR_Coverage, 4798,
     /* 298952 */     GIR_EraseRootFromParent_Done,
     /* 298953 */   // Label 6065: @298953
     /* 298953 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(299111), // Rule ID 4797 //
     /* 298958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 298961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 298973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 298977 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 298981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299002 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299022 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299027 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 299031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299038 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 299038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 299041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299050 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 299056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299078 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 299084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 299097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 299105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299109 */     GIR_RootConstrainSelectedInstOperands,
     /* 299110 */     // GIR_Coverage, 4797,
     /* 299110 */     GIR_EraseRootFromParent_Done,
     /* 299111 */   // Label 6066: @299111
     /* 299111 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(299222), // Rule ID 4796 //
     /* 299116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 299127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 299135 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 299139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299160 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299176 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 299176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299188 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 299194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 299207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299220 */     GIR_RootConstrainSelectedInstOperands,
     /* 299221 */     // GIR_Coverage, 4796,
     /* 299221 */     GIR_EraseRootFromParent_Done,
     /* 299222 */   // Label 6067: @299222
     /* 299222 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(299333), // Rule ID 4794 //
     /* 299227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 299238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 299246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 299250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299276 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299287 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 299287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299299 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 299305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 299318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299331 */     GIR_RootConstrainSelectedInstOperands,
     /* 299332 */     // GIR_Coverage, 4794,
     /* 299332 */     GIR_EraseRootFromParent_Done,
     /* 299333 */   // Label 6068: @299333
     /* 299333 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(299444), // Rule ID 4795 //
     /* 299338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 299349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 299357 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 299361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299382 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299398 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 299398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299410 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 299416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 299429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299442 */     GIR_RootConstrainSelectedInstOperands,
     /* 299443 */     // GIR_Coverage, 4795,
     /* 299443 */     GIR_EraseRootFromParent_Done,
     /* 299444 */   // Label 6069: @299444
     /* 299444 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(299555), // Rule ID 4793 //
     /* 299449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 299460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 299468 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 299472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299498 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299509 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 299509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299521 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 299527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 299540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299553 */     GIR_RootConstrainSelectedInstOperands,
     /* 299554 */     // GIR_Coverage, 4793,
     /* 299554 */     GIR_EraseRootFromParent_Done,
     /* 299555 */   // Label 6070: @299555
     /* 299555 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(299619), // Rule ID 650 //
     /* 299560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 299571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 299579 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 299583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299600 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 299600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 299603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299617 */     GIR_RootConstrainSelectedInstOperands,
     /* 299618 */     // GIR_Coverage, 650,
     /* 299618 */     GIR_EraseRootFromParent_Done,
     /* 299619 */   // Label 6071: @299619
     /* 299619 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(299683), // Rule ID 649 //
     /* 299624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 299635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 299643 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 299647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299664 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 299664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 299667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299681 */     GIR_RootConstrainSelectedInstOperands,
     /* 299682 */     // GIR_Coverage, 649,
     /* 299682 */     GIR_EraseRootFromParent_Done,
     /* 299683 */   // Label 6072: @299683
     /* 299683 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(299734), // Rule ID 626 //
     /* 299688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 299699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 299707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299719 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 299719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 299722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299732 */     GIR_RootConstrainSelectedInstOperands,
     /* 299733 */     // GIR_Coverage, 626,
     /* 299733 */     GIR_EraseRootFromParent_Done,
     /* 299734 */   // Label 6073: @299734
     /* 299734 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(299785), // Rule ID 625 //
     /* 299739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 299750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 299758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299770 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 299770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 299773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299783 */     GIR_RootConstrainSelectedInstOperands,
     /* 299784 */     // GIR_Coverage, 625,
     /* 299784 */     GIR_EraseRootFromParent_Done,
     /* 299785 */   // Label 6074: @299785
     /* 299785 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(299804), // Rule ID 524 //
     /* 299790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 299793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299797 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 299797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 299802 */     GIR_RootConstrainSelectedInstOperands,
     /* 299803 */     // GIR_Coverage, 524,
     /* 299803 */     GIR_Done,
     /* 299804 */   // Label 6075: @299804
     /* 299804 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(299949), // Rule ID 6294 //
     /* 299809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299813 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 299813 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 299816 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 299820 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 299827 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 299830 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 299834 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299839 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 299842 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 299846 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 299849 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299854 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299859 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 299867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299876 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 299879 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299884 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 299887 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 299891 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299896 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 299899 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 299904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 299906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 299909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 299921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299931 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 299938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299948 */     // GIR_Coverage, 6294,
     /* 299948 */     GIR_EraseRootFromParent_Done,
     /* 299949 */   // Label 6076: @299949
     /* 299949 */   GIM_Reject,
     /* 299950 */ // Label 6064: @299950
     /* 299950 */ GIM_Reject,
     /* 299951 */ // Label 6056: @299951
     /* 299951 */ GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(300973),
     /* 299956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299963 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(300121), // Rule ID 4804 //
     /* 299968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 299979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 299987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 299991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300012 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300028 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300032 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300037 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 300041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300048 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 300048 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 300051 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300055 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300060 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 300066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300088 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 300094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 300107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 300119 */     GIR_RootConstrainSelectedInstOperands,
     /* 300120 */     // GIR_Coverage, 4804,
     /* 300120 */     GIR_EraseRootFromParent_Done,
     /* 300121 */   // Label 6078: @300121
     /* 300121 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(300279), // Rule ID 4803 //
     /* 300126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 300137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300145 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 300149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300170 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300182 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300186 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300190 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300195 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 300199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300206 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 300206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 300209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300218 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 300224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300246 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 300252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 300265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 300277 */     GIR_RootConstrainSelectedInstOperands,
     /* 300278 */     // GIR_Coverage, 4803,
     /* 300278 */     GIR_EraseRootFromParent_Done,
     /* 300279 */   // Label 6079: @300279
     /* 300279 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(300390), // Rule ID 4802 //
     /* 300284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 300295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 300307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300328 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300344 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 300344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300356 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 300362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 300375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 300384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 300388 */     GIR_RootConstrainSelectedInstOperands,
     /* 300389 */     // GIR_Coverage, 4802,
     /* 300389 */     GIR_EraseRootFromParent_Done,
     /* 300390 */   // Label 6080: @300390
     /* 300390 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(300501), // Rule ID 4800 //
     /* 300395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 300406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300414 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 300418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300444 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300455 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 300455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300467 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 300473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 300486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 300499 */     GIR_RootConstrainSelectedInstOperands,
     /* 300500 */     // GIR_Coverage, 4800,
     /* 300500 */     GIR_EraseRootFromParent_Done,
     /* 300501 */   // Label 6081: @300501
     /* 300501 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(300612), // Rule ID 4801 //
     /* 300506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 300517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300525 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 300529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300550 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300566 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 300566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300578 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 300584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 300597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 300606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 300610 */     GIR_RootConstrainSelectedInstOperands,
     /* 300611 */     // GIR_Coverage, 4801,
     /* 300611 */     GIR_EraseRootFromParent_Done,
     /* 300612 */   // Label 6082: @300612
     /* 300612 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(300723), // Rule ID 4799 //
     /* 300617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 300628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300636 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 300640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 300653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300666 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 300670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300677 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 300677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 300695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 300708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 300721 */     GIR_RootConstrainSelectedInstOperands,
     /* 300722 */     // GIR_Coverage, 4799,
     /* 300722 */     GIR_EraseRootFromParent_Done,
     /* 300723 */   // Label 6083: @300723
     /* 300723 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(300787), // Rule ID 652 //
     /* 300728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 300739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 300751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300768 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 300768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 300771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 300781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 300785 */     GIR_RootConstrainSelectedInstOperands,
     /* 300786 */     // GIR_Coverage, 652,
     /* 300786 */     GIR_EraseRootFromParent_Done,
     /* 300787 */   // Label 6084: @300787
     /* 300787 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(300851), // Rule ID 651 //
     /* 300792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 300803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300811 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 300815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300832 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 300832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 300835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 300845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 300849 */     GIR_RootConstrainSelectedInstOperands,
     /* 300850 */     // GIR_Coverage, 651,
     /* 300850 */     GIR_EraseRootFromParent_Done,
     /* 300851 */   // Label 6085: @300851
     /* 300851 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(300902), // Rule ID 628 //
     /* 300856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 300867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300887 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 300887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 300890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 300900 */     GIR_RootConstrainSelectedInstOperands,
     /* 300901 */     // GIR_Coverage, 628,
     /* 300901 */     GIR_EraseRootFromParent_Done,
     /* 300902 */   // Label 6086: @300902
     /* 300902 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(300953), // Rule ID 627 //
     /* 300907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 300918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 300926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300938 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 300938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 300941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 300951 */     GIR_RootConstrainSelectedInstOperands,
     /* 300952 */     // GIR_Coverage, 627,
     /* 300952 */     GIR_EraseRootFromParent_Done,
     /* 300953 */   // Label 6087: @300953
     /* 300953 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(300972), // Rule ID 525 //
     /* 300958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300965 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 300965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 300970 */     GIR_RootConstrainSelectedInstOperands,
     /* 300971 */     // GIR_Coverage, 525,
     /* 300971 */     GIR_Done,
     /* 300972 */   // Label 6088: @300972
     /* 300972 */   GIM_Reject,
     /* 300973 */ // Label 6077: @300973
     /* 300973 */ GIM_Reject,
     /* 300974 */ // Label 6057: @300974
     /* 300974 */ GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(301996),
     /* 300979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300986 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(301144), // Rule ID 4810 //
     /* 300991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 301002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301010 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 301014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301035 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 301043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 301055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301060 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 301064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301071 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 301071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 301074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301083 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 301089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301111 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 301138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 301142 */     GIR_RootConstrainSelectedInstOperands,
     /* 301143 */     // GIR_Coverage, 4810,
     /* 301143 */     GIR_EraseRootFromParent_Done,
     /* 301144 */   // Label 6090: @301144
     /* 301144 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(301302), // Rule ID 4809 //
     /* 301149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 301160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301168 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 301172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 301201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 301213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301218 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 301222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301229 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 301229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 301232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301241 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 301247 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301269 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 301296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 301300 */     GIR_RootConstrainSelectedInstOperands,
     /* 301301 */     // GIR_Coverage, 4809,
     /* 301301 */     GIR_EraseRootFromParent_Done,
     /* 301302 */   // Label 6091: @301302
     /* 301302 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(301413), // Rule ID 4808 //
     /* 301307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 301318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301326 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 301330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301351 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301367 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301379 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 301407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 301411 */     GIR_RootConstrainSelectedInstOperands,
     /* 301412 */     // GIR_Coverage, 4808,
     /* 301412 */     GIR_EraseRootFromParent_Done,
     /* 301413 */   // Label 6092: @301413
     /* 301413 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(301524), // Rule ID 4806 //
     /* 301418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 301429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301437 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 301441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301467 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301478 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 301478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301490 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 301496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 301522 */     GIR_RootConstrainSelectedInstOperands,
     /* 301523 */     // GIR_Coverage, 4806,
     /* 301523 */     GIR_EraseRootFromParent_Done,
     /* 301524 */   // Label 6093: @301524
     /* 301524 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(301635), // Rule ID 4807 //
     /* 301529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 301540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301548 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 301552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301573 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301589 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301601 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 301629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 301633 */     GIR_RootConstrainSelectedInstOperands,
     /* 301634 */     // GIR_Coverage, 4807,
     /* 301634 */     GIR_EraseRootFromParent_Done,
     /* 301635 */   // Label 6094: @301635
     /* 301635 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(301746), // Rule ID 4805 //
     /* 301640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 301651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 301663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301700 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 301700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301712 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 301718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 301744 */     GIR_RootConstrainSelectedInstOperands,
     /* 301745 */     // GIR_Coverage, 4805,
     /* 301745 */     GIR_EraseRootFromParent_Done,
     /* 301746 */   // Label 6095: @301746
     /* 301746 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(301810), // Rule ID 654 //
     /* 301751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 301762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301770 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 301774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301791 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 301804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 301808 */     GIR_RootConstrainSelectedInstOperands,
     /* 301809 */     // GIR_Coverage, 654,
     /* 301809 */     GIR_EraseRootFromParent_Done,
     /* 301810 */   // Label 6096: @301810
     /* 301810 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(301874), // Rule ID 653 //
     /* 301815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 301826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301834 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 301838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301855 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 301855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 301858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 301868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 301872 */     GIR_RootConstrainSelectedInstOperands,
     /* 301873 */     // GIR_Coverage, 653,
     /* 301873 */     GIR_EraseRootFromParent_Done,
     /* 301874 */   // Label 6097: @301874
     /* 301874 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(301925), // Rule ID 630 //
     /* 301879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 301890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301910 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 301910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 301913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 301923 */     GIR_RootConstrainSelectedInstOperands,
     /* 301924 */     // GIR_Coverage, 630,
     /* 301924 */     GIR_EraseRootFromParent_Done,
     /* 301925 */   // Label 6098: @301925
     /* 301925 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(301976), // Rule ID 629 //
     /* 301930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 301941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301961 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 301961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 301964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 301974 */     GIR_RootConstrainSelectedInstOperands,
     /* 301975 */     // GIR_Coverage, 629,
     /* 301975 */     GIR_EraseRootFromParent_Done,
     /* 301976 */   // Label 6099: @301976
     /* 301976 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(301995), // Rule ID 526 //
     /* 301981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301988 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 301988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 301993 */     GIR_RootConstrainSelectedInstOperands,
     /* 301994 */     // GIR_Coverage, 526,
     /* 301994 */     GIR_Done,
     /* 301995 */   // Label 6100: @301995
     /* 301995 */   GIM_Reject,
     /* 301996 */ // Label 6089: @301996
     /* 301996 */ GIM_Reject,
     /* 301997 */ // Label 6058: @301997
     /* 301997 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(302023), // Rule ID 853 //
     /* 302002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302016 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 302016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 302021 */   GIR_RootConstrainSelectedInstOperands,
     /* 302022 */   // GIR_Coverage, 853,
     /* 302022 */   GIR_Done,
     /* 302023 */ // Label 6101: @302023
     /* 302023 */ GIM_Reject,
     /* 302024 */ // Label 6059: @302024
     /* 302024 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(302050), // Rule ID 855 //
     /* 302029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302043 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 302043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 302048 */   GIR_RootConstrainSelectedInstOperands,
     /* 302049 */   // GIR_Coverage, 855,
     /* 302049 */   GIR_Done,
     /* 302050 */ // Label 6102: @302050
     /* 302050 */ GIM_Reject,
     /* 302051 */ // Label 6060: @302051
     /* 302051 */ GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(302130),
     /* 302056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302067 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(302082), // Rule ID 851 //
     /* 302072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302075 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 302075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 302080 */     GIR_RootConstrainSelectedInstOperands,
     /* 302081 */     // GIR_Coverage, 851,
     /* 302081 */     GIR_Done,
     /* 302082 */   // Label 6104: @302082
     /* 302082 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(302129), // Rule ID 6297 //
     /* 302087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302090 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 302090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 302097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302102 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 302112 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 302115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 302120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302127 */     GIR_RootConstrainSelectedInstOperands,
     /* 302128 */     // GIR_Coverage, 6297,
     /* 302128 */     GIR_EraseRootFromParent_Done,
     /* 302129 */   // Label 6105: @302129
     /* 302129 */   GIM_Reject,
     /* 302130 */ // Label 6103: @302130
     /* 302130 */ GIM_Reject,
     /* 302131 */ // Label 6061: @302131
     /* 302131 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(302157), // Rule ID 854 //
     /* 302136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302150 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 302150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 302155 */   GIR_RootConstrainSelectedInstOperands,
     /* 302156 */   // GIR_Coverage, 854,
     /* 302156 */   GIR_Done,
     /* 302157 */ // Label 6106: @302157
     /* 302157 */ GIM_Reject,
     /* 302158 */ // Label 6062: @302158
     /* 302158 */ GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(302237),
     /* 302163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302174 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(302189), // Rule ID 852 //
     /* 302179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302182 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 302182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 302187 */     GIR_RootConstrainSelectedInstOperands,
     /* 302188 */     // GIR_Coverage, 852,
     /* 302188 */     GIR_Done,
     /* 302189 */   // Label 6108: @302189
     /* 302189 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(302236), // Rule ID 6298 //
     /* 302194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302197 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 302197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 302204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302209 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 302219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 302222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 302227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302234 */     GIR_RootConstrainSelectedInstOperands,
     /* 302235 */     // GIR_Coverage, 6298,
     /* 302235 */     GIR_EraseRootFromParent_Done,
     /* 302236 */   // Label 6109: @302236
     /* 302236 */   GIM_Reject,
     /* 302237 */ // Label 6107: @302237
     /* 302237 */ GIM_Reject,
     /* 302238 */ // Label 6063: @302238
     /* 302238 */ GIM_Reject,
     /* 302239 */ // Label 63: @302239
     /* 302239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6114*/ GIMT_Encode4(302486),
     /* 302250 */ /*GILLT_s32*//*Label 6110*/ GIMT_Encode4(302278),
     /* 302254 */ /*GILLT_s64*//*Label 6111*/ GIMT_Encode4(302309), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 302266 */ /*GILLT_v2s64*//*Label 6112*/ GIMT_Encode4(302370), GIMT_Encode4(0),
     /* 302274 */ /*GILLT_v4s32*//*Label 6113*/ GIMT_Encode4(302428),
     /* 302278 */ // Label 6110: @302278
     /* 302278 */ GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(302308), // Rule ID 516 //
     /* 302283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302297 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 302297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 302302 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302306 */   GIR_RootConstrainSelectedInstOperands,
     /* 302307 */   // GIR_Coverage, 516,
     /* 302307 */   GIR_Done,
     /* 302308 */ // Label 6115: @302308
     /* 302308 */ GIM_Reject,
     /* 302309 */ // Label 6111: @302309
     /* 302309 */ GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(302339), // Rule ID 514 //
     /* 302314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302328 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 302328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 302333 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302337 */   GIR_RootConstrainSelectedInstOperands,
     /* 302338 */   // GIR_Coverage, 514,
     /* 302338 */   GIR_Done,
     /* 302339 */ // Label 6116: @302339
     /* 302339 */ GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(302369), // Rule ID 518 //
     /* 302344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302358 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 302358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 302363 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302367 */   GIR_RootConstrainSelectedInstOperands,
     /* 302368 */   // GIR_Coverage, 518,
     /* 302368 */   GIR_Done,
     /* 302369 */ // Label 6117: @302369
     /* 302369 */ GIM_Reject,
     /* 302370 */ // Label 6112: @302370
     /* 302370 */ GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(302427),
     /* 302375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302382 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(302406), // Rule ID 4853 //
     /* 302387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 302394 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 302394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 302397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302404 */     GIR_RootConstrainSelectedInstOperands,
     /* 302405 */     // GIR_Coverage, 4853,
     /* 302405 */     GIR_EraseRootFromParent_Done,
     /* 302406 */   // Label 6119: @302406
     /* 302406 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(302426), // Rule ID 4851 //
     /* 302411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302415 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 302415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 302420 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302424 */     GIR_RootConstrainSelectedInstOperands,
     /* 302425 */     // GIR_Coverage, 4851,
     /* 302425 */     GIR_Done,
     /* 302426 */   // Label 6120: @302426
     /* 302426 */   GIM_Reject,
     /* 302427 */ // Label 6118: @302427
     /* 302427 */ GIM_Reject,
     /* 302428 */ // Label 6113: @302428
     /* 302428 */ GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(302485),
     /* 302433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302440 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(302464), // Rule ID 4857 //
     /* 302445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 302452 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 302452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 302455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302462 */     GIR_RootConstrainSelectedInstOperands,
     /* 302463 */     // GIR_Coverage, 4857,
     /* 302463 */     GIR_EraseRootFromParent_Done,
     /* 302464 */   // Label 6122: @302464
     /* 302464 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(302484), // Rule ID 4855 //
     /* 302469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302473 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 302473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 302478 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302482 */     GIR_RootConstrainSelectedInstOperands,
     /* 302483 */     // GIR_Coverage, 4855,
     /* 302483 */     GIR_Done,
     /* 302484 */   // Label 6123: @302484
     /* 302484 */   GIM_Reject,
     /* 302485 */ // Label 6121: @302485
     /* 302485 */ GIM_Reject,
     /* 302486 */ // Label 6114: @302486
     /* 302486 */ GIM_Reject,
     /* 302487 */ // Label 64: @302487
     /* 302487 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6128*/ GIMT_Encode4(302674),
     /* 302498 */ /*GILLT_s16*//*Label 6124*/ GIMT_Encode4(302526),
     /* 302502 */ /*GILLT_s32*//*Label 6125*/ GIMT_Encode4(302587), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 302514 */ /*GILLT_v2s32*//*Label 6126*/ GIMT_Encode4(302618), GIMT_Encode4(0),
     /* 302522 */ /*GILLT_v4s16*//*Label 6127*/ GIMT_Encode4(302646),
     /* 302526 */ // Label 6124: @302526
     /* 302526 */ GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(302556), // Rule ID 510 //
     /* 302531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302545 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 302545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 302550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302554 */   GIR_RootConstrainSelectedInstOperands,
     /* 302555 */   // GIR_Coverage, 510,
     /* 302555 */   GIR_Done,
     /* 302556 */ // Label 6129: @302556
     /* 302556 */ GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(302586), // Rule ID 520 //
     /* 302561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302575 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 302575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 302580 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302584 */   GIR_RootConstrainSelectedInstOperands,
     /* 302585 */   // GIR_Coverage, 520,
     /* 302585 */   GIR_Done,
     /* 302586 */ // Label 6130: @302586
     /* 302586 */ GIM_Reject,
     /* 302587 */ // Label 6125: @302587
     /* 302587 */ GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(302617), // Rule ID 512 //
     /* 302592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302606 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 302606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 302611 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302615 */   GIR_RootConstrainSelectedInstOperands,
     /* 302616 */   // GIR_Coverage, 512,
     /* 302616 */   GIR_Done,
     /* 302617 */ // Label 6131: @302617
     /* 302617 */ GIM_Reject,
     /* 302618 */ // Label 6126: @302618
     /* 302618 */ GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(302645), // Rule ID 4861 //
     /* 302623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302634 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 302634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 302639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302643 */   GIR_RootConstrainSelectedInstOperands,
     /* 302644 */   // GIR_Coverage, 4861,
     /* 302644 */   GIR_Done,
     /* 302645 */ // Label 6132: @302645
     /* 302645 */ GIM_Reject,
     /* 302646 */ // Label 6127: @302646
     /* 302646 */ GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(302673), // Rule ID 4863 //
     /* 302651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302662 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 302662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 302667 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302671 */   GIR_RootConstrainSelectedInstOperands,
     /* 302672 */   // GIR_Coverage, 4863,
     /* 302672 */   GIR_Done,
     /* 302673 */ // Label 6133: @302673
     /* 302673 */ GIM_Reject,
     /* 302674 */ // Label 6128: @302674
     /* 302674 */ GIM_Reject,
     /* 302675 */ // Label 65: @302675
     /* 302675 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6141*/ GIMT_Encode4(303737),
     /* 302686 */ /*GILLT_s32*//*Label 6134*/ GIMT_Encode4(302722),
     /* 302690 */ /*GILLT_s64*//*Label 6135*/ GIMT_Encode4(303109), GIMT_Encode4(0),
     /* 302698 */ /*GILLT_v2s32*//*Label 6136*/ GIMT_Encode4(303496),
     /* 302702 */ /*GILLT_v2s64*//*Label 6137*/ GIMT_Encode4(303570),
     /* 302706 */ /*GILLT_v4s16*//*Label 6138*/ GIMT_Encode4(303644),
     /* 302710 */ /*GILLT_v4s32*//*Label 6139*/ GIMT_Encode4(303675), GIMT_Encode4(0),
     /* 302718 */ /*GILLT_v8s16*//*Label 6140*/ GIMT_Encode4(303706),
     /* 302722 */ // Label 6134: @302722
     /* 302722 */ GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(302759), // Rule ID 4600 //
     /* 302727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 302742 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302746 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302748 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 302748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 302751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302753 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302757 */   GIR_RootConstrainSelectedInstOperands,
     /* 302758 */   // GIR_Coverage, 4600,
     /* 302758 */   GIR_EraseRootFromParent_Done,
     /* 302759 */ // Label 6142: @302759
     /* 302759 */ GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(302796), // Rule ID 4602 //
     /* 302764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 302779 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302785 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 302785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 302788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302790 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302794 */   GIR_RootConstrainSelectedInstOperands,
     /* 302795 */   // GIR_Coverage, 4602,
     /* 302795 */   GIR_EraseRootFromParent_Done,
     /* 302796 */ // Label 6143: @302796
     /* 302796 */ GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(302833), // Rule ID 4620 //
     /* 302801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 302816 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302820 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302822 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 302822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 302825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302827 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302831 */   GIR_RootConstrainSelectedInstOperands,
     /* 302832 */   // GIR_Coverage, 4620,
     /* 302832 */   GIR_EraseRootFromParent_Done,
     /* 302833 */ // Label 6144: @302833
     /* 302833 */ GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(302870), // Rule ID 4622 //
     /* 302838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302845 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 302853 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302857 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302859 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 302859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 302862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302864 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302868 */   GIR_RootConstrainSelectedInstOperands,
     /* 302869 */   // GIR_Coverage, 4622,
     /* 302869 */   GIR_EraseRootFromParent_Done,
     /* 302870 */ // Label 6145: @302870
     /* 302870 */ GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(302907), // Rule ID 4660 //
     /* 302875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302882 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302886 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 302890 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302896 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 302896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 302899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302901 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302905 */   GIR_RootConstrainSelectedInstOperands,
     /* 302906 */   // GIR_Coverage, 4660,
     /* 302906 */   GIR_EraseRootFromParent_Done,
     /* 302907 */ // Label 6146: @302907
     /* 302907 */ GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(302944), // Rule ID 4662 //
     /* 302912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 302927 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302933 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 302933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 302936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302938 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302942 */   GIR_RootConstrainSelectedInstOperands,
     /* 302943 */   // GIR_Coverage, 4662,
     /* 302943 */   GIR_EraseRootFromParent_Done,
     /* 302944 */ // Label 6147: @302944
     /* 302944 */ GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(302981), // Rule ID 4640 //
     /* 302949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 302964 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302970 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 302970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 302973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302975 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302979 */   GIR_RootConstrainSelectedInstOperands,
     /* 302980 */   // GIR_Coverage, 4640,
     /* 302980 */   GIR_EraseRootFromParent_Done,
     /* 302981 */ // Label 6148: @302981
     /* 302981 */ GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(303018), // Rule ID 4642 //
     /* 302986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302993 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302997 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 303001 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303007 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 303007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 303010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303012 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303016 */   GIR_RootConstrainSelectedInstOperands,
     /* 303017 */   // GIR_Coverage, 4642,
     /* 303017 */   GIR_EraseRootFromParent_Done,
     /* 303018 */ // Label 6149: @303018
     /* 303018 */ GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(303048), // Rule ID 395 //
     /* 303023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303037 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 303037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 303042 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303046 */   GIR_RootConstrainSelectedInstOperands,
     /* 303047 */   // GIR_Coverage, 395,
     /* 303047 */   GIR_Done,
     /* 303048 */ // Label 6150: @303048
     /* 303048 */ GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(303078), // Rule ID 399 //
     /* 303053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303067 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 303067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 303072 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303076 */   GIR_RootConstrainSelectedInstOperands,
     /* 303077 */   // GIR_Coverage, 399,
     /* 303077 */   GIR_Done,
     /* 303078 */ // Label 6151: @303078
     /* 303078 */ GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(303108), // Rule ID 403 //
     /* 303083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303097 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 303097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 303102 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303106 */   GIR_RootConstrainSelectedInstOperands,
     /* 303107 */   // GIR_Coverage, 403,
     /* 303107 */   GIR_Done,
     /* 303108 */ // Label 6152: @303108
     /* 303108 */ GIM_Reject,
     /* 303109 */ // Label 6135: @303109
     /* 303109 */ GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(303146), // Rule ID 4601 //
     /* 303114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303121 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 303129 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303133 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303135 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 303135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 303138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303140 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303144 */   GIR_RootConstrainSelectedInstOperands,
     /* 303145 */   // GIR_Coverage, 4601,
     /* 303145 */   GIR_EraseRootFromParent_Done,
     /* 303146 */ // Label 6153: @303146
     /* 303146 */ GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(303183), // Rule ID 4603 //
     /* 303151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303158 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303162 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 303166 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303172 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 303172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 303175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303177 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303181 */   GIR_RootConstrainSelectedInstOperands,
     /* 303182 */   // GIR_Coverage, 4603,
     /* 303182 */   GIR_EraseRootFromParent_Done,
     /* 303183 */ // Label 6154: @303183
     /* 303183 */ GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(303220), // Rule ID 4621 //
     /* 303188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 303203 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303209 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 303209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 303212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303214 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303218 */   GIR_RootConstrainSelectedInstOperands,
     /* 303219 */   // GIR_Coverage, 4621,
     /* 303219 */   GIR_EraseRootFromParent_Done,
     /* 303220 */ // Label 6155: @303220
     /* 303220 */ GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(303257), // Rule ID 4623 //
     /* 303225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 303240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303246 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 303246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 303249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303251 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303255 */   GIR_RootConstrainSelectedInstOperands,
     /* 303256 */   // GIR_Coverage, 4623,
     /* 303256 */   GIR_EraseRootFromParent_Done,
     /* 303257 */ // Label 6156: @303257
     /* 303257 */ GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(303294), // Rule ID 4661 //
     /* 303262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303269 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 303277 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303283 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 303283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 303286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303292 */   GIR_RootConstrainSelectedInstOperands,
     /* 303293 */   // GIR_Coverage, 4661,
     /* 303293 */   GIR_EraseRootFromParent_Done,
     /* 303294 */ // Label 6157: @303294
     /* 303294 */ GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(303331), // Rule ID 4663 //
     /* 303299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 303314 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303320 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 303320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 303323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303325 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303329 */   GIR_RootConstrainSelectedInstOperands,
     /* 303330 */   // GIR_Coverage, 4663,
     /* 303330 */   GIR_EraseRootFromParent_Done,
     /* 303331 */ // Label 6158: @303331
     /* 303331 */ GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(303368), // Rule ID 4641 //
     /* 303336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 303351 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303355 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303357 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 303357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 303360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303362 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303366 */   GIR_RootConstrainSelectedInstOperands,
     /* 303367 */   // GIR_Coverage, 4641,
     /* 303367 */   GIR_EraseRootFromParent_Done,
     /* 303368 */ // Label 6159: @303368
     /* 303368 */ GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(303405), // Rule ID 4643 //
     /* 303373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303380 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303384 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 303388 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303394 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 303394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 303397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303399 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303403 */   GIR_RootConstrainSelectedInstOperands,
     /* 303404 */   // GIR_Coverage, 4643,
     /* 303404 */   GIR_EraseRootFromParent_Done,
     /* 303405 */ // Label 6160: @303405
     /* 303405 */ GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(303435), // Rule ID 397 //
     /* 303410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303424 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 303424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 303429 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303433 */   GIR_RootConstrainSelectedInstOperands,
     /* 303434 */   // GIR_Coverage, 397,
     /* 303434 */   GIR_Done,
     /* 303435 */ // Label 6161: @303435
     /* 303435 */ GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(303465), // Rule ID 401 //
     /* 303440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303454 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 303454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 303459 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303463 */   GIR_RootConstrainSelectedInstOperands,
     /* 303464 */   // GIR_Coverage, 401,
     /* 303464 */   GIR_Done,
     /* 303465 */ // Label 6162: @303465
     /* 303465 */ GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(303495), // Rule ID 405 //
     /* 303470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 303480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303484 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 303484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 303489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303493 */   GIR_RootConstrainSelectedInstOperands,
     /* 303494 */   // GIR_Coverage, 405,
     /* 303494 */   GIR_Done,
     /* 303495 */ // Label 6163: @303495
     /* 303495 */ GIM_Reject,
     /* 303496 */ // Label 6136: @303496
     /* 303496 */ GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(303526), // Rule ID 836 //
     /* 303501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303515 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 303515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 303520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303524 */   GIR_RootConstrainSelectedInstOperands,
     /* 303525 */   // GIR_Coverage, 836,
     /* 303525 */   GIR_Done,
     /* 303526 */ // Label 6164: @303526
     /* 303526 */ GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(303569), // Rule ID 12911 //
     /* 303531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303541 */   // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 303541 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303544 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 303548 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303553 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 303562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303567 */   GIR_RootConstrainSelectedInstOperands,
     /* 303568 */   // GIR_Coverage, 12911,
     /* 303568 */   GIR_EraseRootFromParent_Done,
     /* 303569 */ // Label 6165: @303569
     /* 303569 */ GIM_Reject,
     /* 303570 */ // Label 6137: @303570
     /* 303570 */ GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(303600), // Rule ID 840 //
     /* 303575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303589 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 303589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 303594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303598 */   GIR_RootConstrainSelectedInstOperands,
     /* 303599 */   // GIR_Coverage, 840,
     /* 303599 */   GIR_Done,
     /* 303600 */ // Label 6166: @303600
     /* 303600 */ GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(303643), // Rule ID 12909 //
     /* 303605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303615 */   // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 303615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 303622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303627 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 303636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303641 */   GIR_RootConstrainSelectedInstOperands,
     /* 303642 */   // GIR_Coverage, 12909,
     /* 303642 */   GIR_EraseRootFromParent_Done,
     /* 303643 */ // Label 6167: @303643
     /* 303643 */ GIM_Reject,
     /* 303644 */ // Label 6138: @303644
     /* 303644 */ GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(303674), // Rule ID 832 //
     /* 303649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303663 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 303663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 303668 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303672 */   GIR_RootConstrainSelectedInstOperands,
     /* 303673 */   // GIR_Coverage, 832,
     /* 303673 */   GIR_Done,
     /* 303674 */ // Label 6168: @303674
     /* 303674 */ GIM_Reject,
     /* 303675 */ // Label 6139: @303675
     /* 303675 */ GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(303705), // Rule ID 838 //
     /* 303680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303694 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 303694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 303699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303703 */   GIR_RootConstrainSelectedInstOperands,
     /* 303704 */   // GIR_Coverage, 838,
     /* 303704 */   GIR_Done,
     /* 303705 */ // Label 6169: @303705
     /* 303705 */ GIM_Reject,
     /* 303706 */ // Label 6140: @303706
     /* 303706 */ GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(303736), // Rule ID 834 //
     /* 303711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303725 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 303725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 303730 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303734 */   GIR_RootConstrainSelectedInstOperands,
     /* 303735 */   // GIR_Coverage, 834,
     /* 303735 */   GIR_Done,
     /* 303736 */ // Label 6170: @303736
     /* 303736 */ GIM_Reject,
     /* 303737 */ // Label 6141: @303737
     /* 303737 */ GIM_Reject,
     /* 303738 */ // Label 66: @303738
     /* 303738 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6178*/ GIMT_Encode4(304800),
     /* 303749 */ /*GILLT_s32*//*Label 6171*/ GIMT_Encode4(303785),
     /* 303753 */ /*GILLT_s64*//*Label 6172*/ GIMT_Encode4(304172), GIMT_Encode4(0),
     /* 303761 */ /*GILLT_v2s32*//*Label 6173*/ GIMT_Encode4(304559),
     /* 303765 */ /*GILLT_v2s64*//*Label 6174*/ GIMT_Encode4(304633),
     /* 303769 */ /*GILLT_v4s16*//*Label 6175*/ GIMT_Encode4(304707),
     /* 303773 */ /*GILLT_v4s32*//*Label 6176*/ GIMT_Encode4(304738), GIMT_Encode4(0),
     /* 303781 */ /*GILLT_v8s16*//*Label 6177*/ GIMT_Encode4(304769),
     /* 303785 */ // Label 6171: @303785
     /* 303785 */ GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(303822), // Rule ID 4610 //
     /* 303790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 303805 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303811 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 303811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 303814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303816 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303820 */   GIR_RootConstrainSelectedInstOperands,
     /* 303821 */   // GIR_Coverage, 4610,
     /* 303821 */   GIR_EraseRootFromParent_Done,
     /* 303822 */ // Label 6179: @303822
     /* 303822 */ GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(303859), // Rule ID 4612 //
     /* 303827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 303842 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303846 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303848 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 303848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 303851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303853 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303857 */   GIR_RootConstrainSelectedInstOperands,
     /* 303858 */   // GIR_Coverage, 4612,
     /* 303858 */   GIR_EraseRootFromParent_Done,
     /* 303859 */ // Label 6180: @303859
     /* 303859 */ GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(303896), // Rule ID 4630 //
     /* 303864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 303879 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303885 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 303885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 303888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303894 */   GIR_RootConstrainSelectedInstOperands,
     /* 303895 */   // GIR_Coverage, 4630,
     /* 303895 */   GIR_EraseRootFromParent_Done,
     /* 303896 */ // Label 6181: @303896
     /* 303896 */ GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(303933), // Rule ID 4632 //
     /* 303901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 303916 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303922 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 303922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 303925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303927 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303931 */   GIR_RootConstrainSelectedInstOperands,
     /* 303932 */   // GIR_Coverage, 4632,
     /* 303932 */   GIR_EraseRootFromParent_Done,
     /* 303933 */ // Label 6182: @303933
     /* 303933 */ GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(303970), // Rule ID 4670 //
     /* 303938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 303953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303959 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 303959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 303962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303964 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303968 */   GIR_RootConstrainSelectedInstOperands,
     /* 303969 */   // GIR_Coverage, 4670,
     /* 303969 */   GIR_EraseRootFromParent_Done,
     /* 303970 */ // Label 6183: @303970
     /* 303970 */ GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(304007), // Rule ID 4672 //
     /* 303975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303982 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 303990 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303994 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303996 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 303996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 303999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304005 */   GIR_RootConstrainSelectedInstOperands,
     /* 304006 */   // GIR_Coverage, 4672,
     /* 304006 */   GIR_EraseRootFromParent_Done,
     /* 304007 */ // Label 6184: @304007
     /* 304007 */ GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(304044), // Rule ID 4650 //
     /* 304012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 304019 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304023 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 304027 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304033 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 304033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 304036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304038 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304042 */   GIR_RootConstrainSelectedInstOperands,
     /* 304043 */   // GIR_Coverage, 4650,
     /* 304043 */   GIR_EraseRootFromParent_Done,
     /* 304044 */ // Label 6185: @304044
     /* 304044 */ GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(304081), // Rule ID 4652 //
     /* 304049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 304056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 304064 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304070 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 304070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 304073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304075 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304079 */   GIR_RootConstrainSelectedInstOperands,
     /* 304080 */   // GIR_Coverage, 4652,
     /* 304080 */   GIR_EraseRootFromParent_Done,
     /* 304081 */ // Label 6186: @304081
     /* 304081 */ GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(304111), // Rule ID 407 //
     /* 304086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 304096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304100 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 304100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 304105 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304109 */   GIR_RootConstrainSelectedInstOperands,
     /* 304110 */   // GIR_Coverage, 407,
     /* 304110 */   GIR_Done,
     /* 304111 */ // Label 6187: @304111
     /* 304111 */ GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(304141), // Rule ID 411 //
     /* 304116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 304126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304130 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 304130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 304135 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304139 */   GIR_RootConstrainSelectedInstOperands,
     /* 304140 */   // GIR_Coverage, 411,
     /* 304140 */   GIR_Done,
     /* 304141 */ // Label 6188: @304141
     /* 304141 */ GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(304171), // Rule ID 415 //
     /* 304146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 304156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304160 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 304160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 304165 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304169 */   GIR_RootConstrainSelectedInstOperands,
     /* 304170 */   // GIR_Coverage, 415,
     /* 304170 */   GIR_Done,
     /* 304171 */ // Label 6189: @304171
     /* 304171 */ GIM_Reject,
     /* 304172 */ // Label 6172: @304172
     /* 304172 */ GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(304209), // Rule ID 4611 //
     /* 304177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304184 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 304192 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304198 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 304198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 304201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304203 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304207 */   GIR_RootConstrainSelectedInstOperands,
     /* 304208 */   // GIR_Coverage, 4611,
     /* 304208 */   GIR_EraseRootFromParent_Done,
     /* 304209 */ // Label 6190: @304209
     /* 304209 */ GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(304246), // Rule ID 4613 //
     /* 304214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 304229 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304235 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 304235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 304238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304240 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304244 */   GIR_RootConstrainSelectedInstOperands,
     /* 304245 */   // GIR_Coverage, 4613,
     /* 304245 */   GIR_EraseRootFromParent_Done,
     /* 304246 */ // Label 6191: @304246
     /* 304246 */ GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(304283), // Rule ID 4631 //
     /* 304251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 304266 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304272 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 304272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 304275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304277 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304281 */   GIR_RootConstrainSelectedInstOperands,
     /* 304282 */   // GIR_Coverage, 4631,
     /* 304282 */   GIR_EraseRootFromParent_Done,
     /* 304283 */ // Label 6192: @304283
     /* 304283 */ GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(304320), // Rule ID 4633 //
     /* 304288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 304303 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304309 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 304309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 304312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304314 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304318 */   GIR_RootConstrainSelectedInstOperands,
     /* 304319 */   // GIR_Coverage, 4633,
     /* 304319 */   GIR_EraseRootFromParent_Done,
     /* 304320 */ // Label 6193: @304320
     /* 304320 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(304357), // Rule ID 4671 //
     /* 304325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 304340 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304346 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 304346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 304349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304351 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304355 */   GIR_RootConstrainSelectedInstOperands,
     /* 304356 */   // GIR_Coverage, 4671,
     /* 304356 */   GIR_EraseRootFromParent_Done,
     /* 304357 */ // Label 6194: @304357
     /* 304357 */ GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(304394), // Rule ID 4673 //
     /* 304362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 304377 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304383 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 304383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 304386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304388 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304392 */   GIR_RootConstrainSelectedInstOperands,
     /* 304393 */   // GIR_Coverage, 4673,
     /* 304393 */   GIR_EraseRootFromParent_Done,
     /* 304394 */ // Label 6195: @304394
     /* 304394 */ GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(304431), // Rule ID 4651 //
     /* 304399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304406 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 304414 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304418 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304420 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 304420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 304423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304425 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304429 */   GIR_RootConstrainSelectedInstOperands,
     /* 304430 */   // GIR_Coverage, 4651,
     /* 304430 */   GIR_EraseRootFromParent_Done,
     /* 304431 */ // Label 6196: @304431
     /* 304431 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(304468), // Rule ID 4653 //
     /* 304436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 304451 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304457 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 304457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 304460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304462 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304466 */   GIR_RootConstrainSelectedInstOperands,
     /* 304467 */   // GIR_Coverage, 4653,
     /* 304467 */   GIR_EraseRootFromParent_Done,
     /* 304468 */ // Label 6197: @304468
     /* 304468 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(304498), // Rule ID 409 //
     /* 304473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304487 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 304487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 304492 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304496 */   GIR_RootConstrainSelectedInstOperands,
     /* 304497 */   // GIR_Coverage, 409,
     /* 304497 */   GIR_Done,
     /* 304498 */ // Label 6198: @304498
     /* 304498 */ GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(304528), // Rule ID 413 //
     /* 304503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304517 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 304517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 304522 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304526 */   GIR_RootConstrainSelectedInstOperands,
     /* 304527 */   // GIR_Coverage, 413,
     /* 304527 */   GIR_Done,
     /* 304528 */ // Label 6199: @304528
     /* 304528 */ GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(304558), // Rule ID 417 //
     /* 304533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304547 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 304547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 304552 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304556 */   GIR_RootConstrainSelectedInstOperands,
     /* 304557 */   // GIR_Coverage, 417,
     /* 304557 */   GIR_Done,
     /* 304558 */ // Label 6200: @304558
     /* 304558 */ GIM_Reject,
     /* 304559 */ // Label 6173: @304559
     /* 304559 */ GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(304589), // Rule ID 846 //
     /* 304564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 304570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304578 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 304578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 304583 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304587 */   GIR_RootConstrainSelectedInstOperands,
     /* 304588 */   // GIR_Coverage, 846,
     /* 304588 */   GIR_Done,
     /* 304589 */ // Label 6201: @304589
     /* 304589 */ GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(304632), // Rule ID 12912 //
     /* 304594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304604 */   // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 304604 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304607 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 304611 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304616 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 304625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304630 */   GIR_RootConstrainSelectedInstOperands,
     /* 304631 */   // GIR_Coverage, 12912,
     /* 304631 */   GIR_EraseRootFromParent_Done,
     /* 304632 */ // Label 6202: @304632
     /* 304632 */ GIM_Reject,
     /* 304633 */ // Label 6174: @304633
     /* 304633 */ GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(304663), // Rule ID 850 //
     /* 304638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304652 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 304652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 304657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304661 */   GIR_RootConstrainSelectedInstOperands,
     /* 304662 */   // GIR_Coverage, 850,
     /* 304662 */   GIR_Done,
     /* 304663 */ // Label 6203: @304663
     /* 304663 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(304706), // Rule ID 12910 //
     /* 304668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 304674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304678 */   // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 304678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 304685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304690 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 304699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304704 */   GIR_RootConstrainSelectedInstOperands,
     /* 304705 */   // GIR_Coverage, 12910,
     /* 304705 */   GIR_EraseRootFromParent_Done,
     /* 304706 */ // Label 6204: @304706
     /* 304706 */ GIM_Reject,
     /* 304707 */ // Label 6175: @304707
     /* 304707 */ GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(304737), // Rule ID 842 //
     /* 304712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304726 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 304726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 304731 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304735 */   GIR_RootConstrainSelectedInstOperands,
     /* 304736 */   // GIR_Coverage, 842,
     /* 304736 */   GIR_Done,
     /* 304737 */ // Label 6205: @304737
     /* 304737 */ GIM_Reject,
     /* 304738 */ // Label 6176: @304738
     /* 304738 */ GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(304768), // Rule ID 848 //
     /* 304743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304757 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 304757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 304762 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304766 */   GIR_RootConstrainSelectedInstOperands,
     /* 304767 */   // GIR_Coverage, 848,
     /* 304767 */   GIR_Done,
     /* 304768 */ // Label 6206: @304768
     /* 304768 */ GIM_Reject,
     /* 304769 */ // Label 6177: @304769
     /* 304769 */ GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(304799), // Rule ID 844 //
     /* 304774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304788 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 304788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 304793 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304797 */   GIR_RootConstrainSelectedInstOperands,
     /* 304798 */   // GIR_Coverage, 844,
     /* 304798 */   GIR_Done,
     /* 304799 */ // Label 6207: @304799
     /* 304799 */ GIM_Reject,
     /* 304800 */ // Label 6178: @304800
     /* 304800 */ GIM_Reject,
     /* 304801 */ // Label 67: @304801
     /* 304801 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6216*/ GIMT_Encode4(309197),
     /* 304812 */ /*GILLT_s16*//*Label 6208*/ GIMT_Encode4(304852),
     /* 304816 */ /*GILLT_s32*//*Label 6209*/ GIMT_Encode4(305133),
     /* 304820 */ /*GILLT_s64*//*Label 6210*/ GIMT_Encode4(307049), GIMT_Encode4(0),
     /* 304828 */ /*GILLT_v2s32*//*Label 6211*/ GIMT_Encode4(308953),
     /* 304832 */ /*GILLT_v2s64*//*Label 6212*/ GIMT_Encode4(309027),
     /* 304836 */ /*GILLT_v4s16*//*Label 6213*/ GIMT_Encode4(309104),
     /* 304840 */ /*GILLT_v4s32*//*Label 6214*/ GIMT_Encode4(309135), GIMT_Encode4(0),
     /* 304848 */ /*GILLT_v8s16*//*Label 6215*/ GIMT_Encode4(309166),
     /* 304852 */ // Label 6208: @304852
     /* 304852 */ GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(304955), // Rule ID 5270 //
     /* 304857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 304860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304867 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304871 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 304875 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304879 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304883 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304887 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304891 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304895 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304900 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304904 */   // MIs[1] Operand 2
     /* 304904 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 304915 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304917 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 304917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304929 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 304935 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304940 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 304948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304953 */   GIR_RootConstrainSelectedInstOperands,
     /* 304954 */   // GIR_Coverage, 5270,
     /* 304954 */   GIR_EraseRootFromParent_Done,
     /* 304955 */ // Label 6217: @304955
     /* 304955 */ GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(305012), // Rule ID 5261 //
     /* 304960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 304963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304970 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 304978 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 304982 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304984 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 304984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 304991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304996 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 305005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305007 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305010 */   GIR_RootConstrainSelectedInstOperands,
     /* 305011 */   // GIR_Coverage, 5261,
     /* 305011 */   GIR_EraseRootFromParent_Done,
     /* 305012 */ // Label 6218: @305012
     /* 305012 */ GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(305042), // Rule ID 443 //
     /* 305017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 305031 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 305031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 305036 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305040 */   GIR_RootConstrainSelectedInstOperands,
     /* 305041 */   // GIR_Coverage, 443,
     /* 305041 */   GIR_Done,
     /* 305042 */ // Label 6219: @305042
     /* 305042 */ GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(305072), // Rule ID 449 //
     /* 305047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 305061 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 305061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 305066 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305070 */   GIR_RootConstrainSelectedInstOperands,
     /* 305071 */   // GIR_Coverage, 449,
     /* 305071 */   GIR_Done,
     /* 305072 */ // Label 6220: @305072
     /* 305072 */ GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(305102), // Rule ID 491 //
     /* 305077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 305080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305091 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 305091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 305096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305100 */   GIR_RootConstrainSelectedInstOperands,
     /* 305101 */   // GIR_Coverage, 491,
     /* 305101 */   GIR_Done,
     /* 305102 */ // Label 6221: @305102
     /* 305102 */ GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(305132), // Rule ID 495 //
     /* 305107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 305110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305121 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 305121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 305126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305130 */   GIR_RootConstrainSelectedInstOperands,
     /* 305131 */   // GIR_Coverage, 495,
     /* 305131 */   GIR_Done,
     /* 305132 */ // Label 6222: @305132
     /* 305132 */ GIM_Reject,
     /* 305133 */ // Label 6209: @305133
     /* 305133 */ GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(305371), // Rule ID 6299 //
     /* 305138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305156 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305159 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 305166 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305172 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 305179 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 305179 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 305182 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 305186 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 305201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 305206 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305213 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305216 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305220 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305227 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305230 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305234 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305239 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305242 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305245 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 305248 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305253 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305258 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 305263 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305266 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 305270 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305275 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305278 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305283 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305286 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305290 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305295 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305302 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305307 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305312 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305315 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305319 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305324 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305327 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305344 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 305351 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305356 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 305364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305369 */   GIR_RootConstrainSelectedInstOperands,
     /* 305370 */   // GIR_Coverage, 6299,
     /* 305370 */   GIR_EraseRootFromParent_Done,
     /* 305371 */ // Label 6223: @305371
     /* 305371 */ GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(305609), // Rule ID 6300 //
     /* 305376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305386 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305390 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305394 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305397 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 305404 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305410 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 305417 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 305417 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 305420 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 305424 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 305439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 305444 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305451 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305454 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305458 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305465 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305468 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305472 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305477 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305480 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305483 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 305486 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305491 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305496 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 305501 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305504 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 305508 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305513 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305516 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305521 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305524 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305528 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305533 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305540 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305545 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305550 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305553 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305557 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305562 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305565 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305582 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 305589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305594 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 305602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305607 */   GIR_RootConstrainSelectedInstOperands,
     /* 305608 */   // GIR_Coverage, 6300,
     /* 305608 */   GIR_EraseRootFromParent_Done,
     /* 305609 */ // Label 6224: @305609
     /* 305609 */ GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(305798), // Rule ID 6303 //
     /* 305614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305624 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305632 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305635 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305642 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305648 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 305655 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 305655 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 305658 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 305662 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 305677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 305682 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305689 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 305692 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305696 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305703 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305706 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305710 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305715 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305718 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305721 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 305724 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305729 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305734 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305739 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305742 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305746 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305751 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305754 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305771 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 305778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305783 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 305791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305796 */   GIR_RootConstrainSelectedInstOperands,
     /* 305797 */   // GIR_Coverage, 6303,
     /* 305797 */   GIR_EraseRootFromParent_Done,
     /* 305798 */ // Label 6225: @305798
     /* 305798 */ GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(305987), // Rule ID 6304 //
     /* 305803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305821 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305824 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305831 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305835 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305837 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 305844 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 305844 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 305847 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 305851 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 305866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 305871 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305878 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 305881 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305885 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305892 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305895 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305899 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305904 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305907 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305910 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 305913 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305918 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305923 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305928 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305931 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305935 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305940 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305943 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305960 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 305967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 305980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305985 */   GIR_RootConstrainSelectedInstOperands,
     /* 305986 */   // GIR_Coverage, 6304,
     /* 305986 */   GIR_EraseRootFromParent_Done,
     /* 305987 */ // Label 6226: @305987
     /* 305987 */ GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(306220), // Rule ID 6301 //
     /* 305992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 306010 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306013 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 306020 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306026 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 306033 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 306033 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 306036 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 306040 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 306055 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 306062 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 306065 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306069 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 306076 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 306079 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306083 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306088 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 306091 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 306094 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 306097 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306102 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306107 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 306112 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 306115 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 306119 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306124 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 306127 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 306130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306132 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 306135 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306139 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306144 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 306151 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306156 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306161 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 306164 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 306168 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306173 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306176 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 306179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306193 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 306200 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306205 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 306213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306218 */   GIR_RootConstrainSelectedInstOperands,
     /* 306219 */   // GIR_Coverage, 6301,
     /* 306219 */   GIR_EraseRootFromParent_Done,
     /* 306220 */ // Label 6227: @306220
     /* 306220 */ GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(306453), // Rule ID 6302 //
     /* 306225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 306228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306235 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 306243 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306246 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 306253 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306257 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306259 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 306266 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 306266 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 306269 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 306273 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 306288 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 306295 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 306298 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306302 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 306309 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 306312 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306316 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306321 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 306324 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 306327 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 306330 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306335 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306340 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 306345 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 306348 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 306352 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306357 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 306360 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 306363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306365 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 306368 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306372 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306377 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 306384 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306389 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306394 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 306397 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 306401 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306406 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306409 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 306412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306426 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 306433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 306446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306451 */   GIR_RootConstrainSelectedInstOperands,
     /* 306452 */   // GIR_Coverage, 6302,
     /* 306452 */   GIR_EraseRootFromParent_Done,
     /* 306453 */ // Label 6228: @306453
     /* 306453 */ GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(306637), // Rule ID 6305 //
     /* 306458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 306461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306468 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 306476 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306479 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 306486 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306490 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306492 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 306499 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 306499 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 306502 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 306506 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 306521 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 306528 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 306531 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306535 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306542 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 306545 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306549 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306554 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 306557 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 306560 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 306563 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306568 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306573 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306578 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 306581 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 306585 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306590 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306593 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 306596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306610 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 306617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 306630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306635 */   GIR_RootConstrainSelectedInstOperands,
     /* 306636 */   // GIR_Coverage, 6305,
     /* 306636 */   GIR_EraseRootFromParent_Done,
     /* 306637 */ // Label 6229: @306637
     /* 306637 */ GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(306821), // Rule ID 6306 //
     /* 306642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 306645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 306660 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306663 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 306670 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306674 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306676 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 306683 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 306683 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 306686 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 306690 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 306705 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 306712 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 306715 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306719 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306726 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 306729 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306733 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306738 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 306741 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 306744 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 306747 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306752 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306757 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306762 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 306765 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 306769 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306774 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306777 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 306780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306794 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 306801 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306806 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 306814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306819 */   GIR_RootConstrainSelectedInstOperands,
     /* 306820 */   // GIR_Coverage, 6306,
     /* 306820 */   GIR_EraseRootFromParent_Done,
     /* 306821 */ // Label 6230: @306821
     /* 306821 */ GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(306901), // Rule ID 5266 //
     /* 306826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306836 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306844 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306848 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306852 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306857 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306861 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306863 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 306863 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306866 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306870 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306875 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306881 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 306894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306899 */   GIR_RootConstrainSelectedInstOperands,
     /* 306900 */   // GIR_Coverage, 5266,
     /* 306900 */   GIR_EraseRootFromParent_Done,
     /* 306901 */ // Label 6231: @306901
     /* 306901 */ GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(306958), // Rule ID 5249 //
     /* 306906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306916 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306920 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 306924 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306930 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 306930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 306937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 306951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306956 */   GIR_RootConstrainSelectedInstOperands,
     /* 306957 */   // GIR_Coverage, 5249,
     /* 306957 */   GIR_EraseRootFromParent_Done,
     /* 306958 */ // Label 6232: @306958
     /* 306958 */ GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(306988), // Rule ID 445 //
     /* 306963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306977 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 306977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 306982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306986 */   GIR_RootConstrainSelectedInstOperands,
     /* 306987 */   // GIR_Coverage, 445,
     /* 306987 */   GIR_Done,
     /* 306988 */ // Label 6233: @306988
     /* 306988 */ GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(307018), // Rule ID 451 //
     /* 306993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307007 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 307007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 307012 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307016 */   GIR_RootConstrainSelectedInstOperands,
     /* 307017 */   // GIR_Coverage, 451,
     /* 307017 */   GIR_Done,
     /* 307018 */ // Label 6234: @307018
     /* 307018 */ GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(307048), // Rule ID 497 //
     /* 307023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 307026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307037 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 307037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 307042 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307046 */   GIR_RootConstrainSelectedInstOperands,
     /* 307047 */   // GIR_Coverage, 497,
     /* 307047 */   GIR_Done,
     /* 307048 */ // Label 6235: @307048
     /* 307048 */ GIM_Reject,
     /* 307049 */ // Label 6210: @307049
     /* 307049 */ GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(307235), // Rule ID 6311 //
     /* 307054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 307057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 307072 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307075 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 307079 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307085 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 307092 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 307092 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 307095 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 307099 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 307119 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307126 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 307129 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307133 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 307140 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 307143 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307147 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307152 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307155 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 307158 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 307161 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307166 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307171 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307176 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 307179 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 307183 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307188 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 307191 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 307194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307208 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 307215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307220 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 307228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307233 */   GIR_RootConstrainSelectedInstOperands,
     /* 307234 */   // GIR_Coverage, 6311,
     /* 307234 */   GIR_EraseRootFromParent_Done,
     /* 307235 */ // Label 6236: @307235
     /* 307235 */ GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(307421), // Rule ID 6312 //
     /* 307240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 307243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 307258 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307261 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 307265 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307269 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307271 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 307278 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 307278 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 307281 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 307285 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 307305 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307312 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 307315 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307319 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 307326 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 307329 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307333 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307338 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307341 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 307344 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 307347 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307352 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307357 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307362 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 307365 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 307369 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307374 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 307377 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 307380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307394 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 307401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 307414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307419 */   GIR_RootConstrainSelectedInstOperands,
     /* 307420 */   // GIR_Coverage, 6312,
     /* 307420 */   GIR_EraseRootFromParent_Done,
     /* 307421 */ // Label 6237: @307421
     /* 307421 */ GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(307659), // Rule ID 6307 //
     /* 307426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 307429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 307444 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307447 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307454 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307458 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307460 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 307467 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 307467 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 307470 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 307474 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 307494 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 307501 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 307504 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307508 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 307515 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 307518 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307522 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307527 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 307530 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 307533 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 307536 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307541 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307546 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307551 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 307554 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 307558 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307563 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 307566 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 307569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 307571 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 307574 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307578 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307583 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 307590 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307595 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307600 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 307603 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 307607 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307612 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 307615 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 307618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307632 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 307639 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307644 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 307652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307657 */   GIR_RootConstrainSelectedInstOperands,
     /* 307658 */   // GIR_Coverage, 6307,
     /* 307658 */   GIR_EraseRootFromParent_Done,
     /* 307659 */ // Label 6238: @307659
     /* 307659 */ GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(307897), // Rule ID 6308 //
     /* 307664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 307667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307674 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307678 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 307682 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307685 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307692 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307698 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 307705 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 307705 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 307708 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 307712 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 307732 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 307739 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 307742 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307746 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 307753 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 307756 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307760 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307765 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 307768 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 307771 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 307774 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307779 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307784 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307789 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 307792 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 307796 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307801 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 307804 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 307807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 307809 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 307812 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307816 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307821 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 307828 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307833 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307838 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 307841 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 307845 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307850 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 307853 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 307856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307870 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 307877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 307890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307895 */   GIR_RootConstrainSelectedInstOperands,
     /* 307896 */   // GIR_Coverage, 6308,
     /* 307896 */   GIR_EraseRootFromParent_Done,
     /* 307897 */ // Label 6239: @307897
     /* 307897 */ GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(308078), // Rule ID 6313 //
     /* 307902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 307905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 307920 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 307927 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307933 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 307940 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 307940 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 307943 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 307947 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307962 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307969 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 307972 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307976 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 307983 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 307986 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307990 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307995 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307998 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 308001 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 308004 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308009 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308014 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308019 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 308022 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 308026 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308031 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 308034 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 308037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308051 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 308058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308063 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 308071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308076 */   GIR_RootConstrainSelectedInstOperands,
     /* 308077 */   // GIR_Coverage, 6313,
     /* 308077 */   GIR_EraseRootFromParent_Done,
     /* 308078 */ // Label 6240: @308078
     /* 308078 */ GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(308259), // Rule ID 6314 //
     /* 308083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 308086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308093 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308101 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308108 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308112 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308114 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 308121 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 308121 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 308124 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 308128 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 308143 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 308150 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 308153 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308157 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 308164 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 308167 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308171 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308176 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 308179 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 308182 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 308185 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308190 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308195 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308200 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 308203 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 308207 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308212 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 308215 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 308218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308232 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 308239 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308244 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 308252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308257 */   GIR_RootConstrainSelectedInstOperands,
     /* 308258 */   // GIR_Coverage, 6314,
     /* 308258 */   GIR_EraseRootFromParent_Done,
     /* 308259 */ // Label 6241: @308259
     /* 308259 */ GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(308492), // Rule ID 6309 //
     /* 308264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 308267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 308282 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308285 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 308292 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308298 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 308305 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 308305 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 308308 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 308312 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 308327 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 308334 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 308337 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308341 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 308348 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 308351 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308355 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308360 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 308363 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 308366 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 308369 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308374 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308379 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308384 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 308387 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 308391 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308396 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 308399 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 308402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 308404 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 308407 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308411 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308416 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 308423 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308428 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308433 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 308436 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 308440 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308445 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 308448 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 308451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308465 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 308472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308477 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 308485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308490 */   GIR_RootConstrainSelectedInstOperands,
     /* 308491 */   // GIR_Coverage, 6309,
     /* 308491 */   GIR_EraseRootFromParent_Done,
     /* 308492 */ // Label 6242: @308492
     /* 308492 */ GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(308725), // Rule ID 6310 //
     /* 308497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 308500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 308515 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308518 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 308525 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308529 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308531 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 308538 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 308538 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 308541 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 308545 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 308560 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 308567 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 308570 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308574 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 308581 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 308584 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308588 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308593 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 308596 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 308599 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 308602 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308607 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308612 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308617 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 308620 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 308624 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308629 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 308632 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 308635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 308637 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 308640 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308644 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308649 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 308656 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308661 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308666 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 308669 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 308673 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308678 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 308681 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 308684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308698 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 308705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308710 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 308718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308723 */   GIR_RootConstrainSelectedInstOperands,
     /* 308724 */   // GIR_Coverage, 6310,
     /* 308724 */   GIR_EraseRootFromParent_Done,
     /* 308725 */ // Label 6243: @308725
     /* 308725 */ GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(308805), // Rule ID 5268 //
     /* 308730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308748 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308752 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308756 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308761 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308765 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308767 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 308767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308779 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 308785 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308790 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 308798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308803 */   GIR_RootConstrainSelectedInstOperands,
     /* 308804 */   // GIR_Coverage, 5268,
     /* 308804 */   GIR_EraseRootFromParent_Done,
     /* 308805 */ // Label 6244: @308805
     /* 308805 */ GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(308862), // Rule ID 5245 //
     /* 308810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308820 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 308828 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308834 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 308834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 308841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308846 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 308855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308860 */   GIR_RootConstrainSelectedInstOperands,
     /* 308861 */   // GIR_Coverage, 5245,
     /* 308861 */   GIR_EraseRootFromParent_Done,
     /* 308862 */ // Label 6245: @308862
     /* 308862 */ GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(308892), // Rule ID 447 //
     /* 308867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 308881 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 308881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 308886 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308890 */   GIR_RootConstrainSelectedInstOperands,
     /* 308891 */   // GIR_Coverage, 447,
     /* 308891 */   GIR_Done,
     /* 308892 */ // Label 6246: @308892
     /* 308892 */ GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(308922), // Rule ID 453 //
     /* 308897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308911 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 308911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 308916 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308920 */   GIR_RootConstrainSelectedInstOperands,
     /* 308921 */   // GIR_Coverage, 453,
     /* 308921 */   GIR_Done,
     /* 308922 */ // Label 6247: @308922
     /* 308922 */ GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(308952), // Rule ID 493 //
     /* 308927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 308930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308941 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 308941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 308946 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308950 */   GIR_RootConstrainSelectedInstOperands,
     /* 308951 */   // GIR_Coverage, 493,
     /* 308951 */   GIR_Done,
     /* 308952 */ // Label 6248: @308952
     /* 308952 */ GIM_Reject,
     /* 308953 */ // Label 6211: @308953
     /* 308953 */ GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(308983), // Rule ID 1010 //
     /* 308958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 308964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308972 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 308972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 308977 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308981 */   GIR_RootConstrainSelectedInstOperands,
     /* 308982 */   // GIR_Coverage, 1010,
     /* 308982 */   GIR_Done,
     /* 308983 */ // Label 6249: @308983
     /* 308983 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(309026), // Rule ID 12907 //
     /* 308988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308998 */   // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 308998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 309005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309010 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 309019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309024 */   GIR_RootConstrainSelectedInstOperands,
     /* 309025 */   // GIR_Coverage, 12907,
     /* 309025 */   GIR_EraseRootFromParent_Done,
     /* 309026 */ // Label 6250: @309026
     /* 309026 */ GIM_Reject,
     /* 309027 */ // Label 6212: @309027
     /* 309027 */ GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(309057), // Rule ID 1014 //
     /* 309032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309046 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 309046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 309051 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309055 */   GIR_RootConstrainSelectedInstOperands,
     /* 309056 */   // GIR_Coverage, 1014,
     /* 309056 */   GIR_Done,
     /* 309057 */ // Label 6251: @309057
     /* 309057 */ GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(309103), // Rule ID 12905 //
     /* 309062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 309068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309072 */   // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 309072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 309079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309084 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309088 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 309096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309101 */   GIR_RootConstrainSelectedInstOperands,
     /* 309102 */   // GIR_Coverage, 12905,
     /* 309102 */   GIR_EraseRootFromParent_Done,
     /* 309103 */ // Label 6252: @309103
     /* 309103 */ GIM_Reject,
     /* 309104 */ // Label 6213: @309104
     /* 309104 */ GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(309134), // Rule ID 1006 //
     /* 309109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 309115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309123 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 309123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 309128 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309132 */   GIR_RootConstrainSelectedInstOperands,
     /* 309133 */   // GIR_Coverage, 1006,
     /* 309133 */   GIR_Done,
     /* 309134 */ // Label 6253: @309134
     /* 309134 */ GIM_Reject,
     /* 309135 */ // Label 6214: @309135
     /* 309135 */ GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(309165), // Rule ID 1012 //
     /* 309140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309154 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 309154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 309159 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309163 */   GIR_RootConstrainSelectedInstOperands,
     /* 309164 */   // GIR_Coverage, 1012,
     /* 309164 */   GIR_Done,
     /* 309165 */ // Label 6254: @309165
     /* 309165 */ GIM_Reject,
     /* 309166 */ // Label 6215: @309166
     /* 309166 */ GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(309196), // Rule ID 1008 //
     /* 309171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309185 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 309185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 309190 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309194 */   GIR_RootConstrainSelectedInstOperands,
     /* 309195 */   // GIR_Coverage, 1008,
     /* 309195 */   GIR_Done,
     /* 309196 */ // Label 6255: @309196
     /* 309196 */ GIM_Reject,
     /* 309197 */ // Label 6216: @309197
     /* 309197 */ GIM_Reject,
     /* 309198 */ // Label 68: @309198
     /* 309198 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6264*/ GIMT_Encode4(312972),
     /* 309209 */ /*GILLT_s16*//*Label 6256*/ GIMT_Encode4(309249),
     /* 309213 */ /*GILLT_s32*//*Label 6257*/ GIMT_Encode4(309534),
     /* 309217 */ /*GILLT_s64*//*Label 6258*/ GIMT_Encode4(310862), GIMT_Encode4(0),
     /* 309225 */ /*GILLT_v2s32*//*Label 6259*/ GIMT_Encode4(312728),
     /* 309229 */ /*GILLT_v2s64*//*Label 6260*/ GIMT_Encode4(312802),
     /* 309233 */ /*GILLT_v4s16*//*Label 6261*/ GIMT_Encode4(312879),
     /* 309237 */ /*GILLT_v4s32*//*Label 6262*/ GIMT_Encode4(312910), GIMT_Encode4(0),
     /* 309245 */ /*GILLT_v8s16*//*Label 6263*/ GIMT_Encode4(312941),
     /* 309249 */ // Label 6256: @309249
     /* 309249 */ GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(309356), // Rule ID 5271 //
     /* 309254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 309257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 309272 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309280 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309284 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309288 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309292 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309296 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309301 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309305 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 309316 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309318 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 309318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309330 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309336 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309341 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 309349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309354 */   GIR_RootConstrainSelectedInstOperands,
     /* 309355 */   // GIR_Coverage, 5271,
     /* 309355 */   GIR_EraseRootFromParent_Done,
     /* 309356 */ // Label 6265: @309356
     /* 309356 */ GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(309413), // Rule ID 5265 //
     /* 309361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 309364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 309379 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309385 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 309385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 309392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 309406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309411 */   GIR_RootConstrainSelectedInstOperands,
     /* 309412 */   // GIR_Coverage, 5265,
     /* 309412 */   GIR_EraseRootFromParent_Done,
     /* 309413 */ // Label 6266: @309413
     /* 309413 */ GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(309443), // Rule ID 467 //
     /* 309418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 309432 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 309432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 309437 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309441 */   GIR_RootConstrainSelectedInstOperands,
     /* 309442 */   // GIR_Coverage, 467,
     /* 309442 */   GIR_Done,
     /* 309443 */ // Label 6267: @309443
     /* 309443 */ GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(309473), // Rule ID 473 //
     /* 309448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 309462 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 309462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 309467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309471 */   GIR_RootConstrainSelectedInstOperands,
     /* 309472 */   // GIR_Coverage, 473,
     /* 309472 */   GIR_Done,
     /* 309473 */ // Label 6268: @309473
     /* 309473 */ GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(309503), // Rule ID 499 //
     /* 309478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 309481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309492 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 309492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 309497 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309501 */   GIR_RootConstrainSelectedInstOperands,
     /* 309502 */   // GIR_Coverage, 499,
     /* 309502 */   GIR_Done,
     /* 309503 */ // Label 6269: @309503
     /* 309503 */ GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(309533), // Rule ID 503 //
     /* 309508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 309511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309522 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 309522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 309527 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309531 */   GIR_RootConstrainSelectedInstOperands,
     /* 309532 */   // GIR_Coverage, 503,
     /* 309532 */   GIR_Done,
     /* 309533 */ // Label 6270: @309533
     /* 309533 */ GIM_Reject,
     /* 309534 */ // Label 6257: @309534
     /* 309534 */ GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(309674), // Rule ID 5272 //
     /* 309539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309557 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309560 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309567 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309573 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 309580 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 309580 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 309583 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 309587 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 309607 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309614 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 309617 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309621 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309640 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309643 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309646 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309649 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 309667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309672 */   GIR_RootConstrainSelectedInstOperands,
     /* 309673 */   // GIR_Coverage, 5272,
     /* 309673 */   GIR_EraseRootFromParent_Done,
     /* 309674 */ // Label 6271: @309674
     /* 309674 */ GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(309814), // Rule ID 5273 //
     /* 309679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309697 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309700 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309707 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309713 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 309720 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 309720 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 309723 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 309727 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 309747 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309754 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 309757 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309761 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309780 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309783 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309786 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309799 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 309807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309812 */   GIR_RootConstrainSelectedInstOperands,
     /* 309813 */   // GIR_Coverage, 5273,
     /* 309813 */   GIR_EraseRootFromParent_Done,
     /* 309814 */ // Label 6272: @309814
     /* 309814 */ GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(309954), // Rule ID 5276 //
     /* 309819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309837 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309840 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309847 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309853 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 309860 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 309860 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309863 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 309867 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 309887 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309894 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 309897 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309901 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309920 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309923 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309926 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 309929 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309934 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 309947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309952 */   GIR_RootConstrainSelectedInstOperands,
     /* 309953 */   // GIR_Coverage, 5276,
     /* 309953 */   GIR_EraseRootFromParent_Done,
     /* 309954 */ // Label 6273: @309954
     /* 309954 */ GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(310094), // Rule ID 5277 //
     /* 309959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309969 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309977 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309980 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309987 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309993 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 310000 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 310000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 310003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 310007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 310022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 310027 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 310034 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310037 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310041 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310060 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310063 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 310066 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 310069 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310074 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310079 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 310087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310092 */   GIR_RootConstrainSelectedInstOperands,
     /* 310093 */   // GIR_Coverage, 5277,
     /* 310093 */   GIR_EraseRootFromParent_Done,
     /* 310094 */ // Label 6274: @310094
     /* 310094 */ GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(310229), // Rule ID 5274 //
     /* 310099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310109 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 310117 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310120 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 310127 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310133 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 310140 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 310140 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 310143 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 310147 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 310162 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 310169 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310172 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310176 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310195 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310198 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 310201 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 310204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310209 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310214 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 310219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 310222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310227 */   GIR_RootConstrainSelectedInstOperands,
     /* 310228 */   // GIR_Coverage, 5274,
     /* 310228 */   GIR_EraseRootFromParent_Done,
     /* 310229 */ // Label 6275: @310229
     /* 310229 */ GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(310364), // Rule ID 5275 //
     /* 310234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 310252 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310255 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 310262 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310266 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310268 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 310275 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 310275 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 310278 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 310282 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 310297 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 310304 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310307 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310311 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310330 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 310336 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 310339 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310344 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 310354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 310357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310362 */   GIR_RootConstrainSelectedInstOperands,
     /* 310363 */   // GIR_Coverage, 5275,
     /* 310363 */   GIR_EraseRootFromParent_Done,
     /* 310364 */ // Label 6276: @310364
     /* 310364 */ GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(310499), // Rule ID 5278 //
     /* 310369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 310387 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310390 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 310397 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310401 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310403 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 310410 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 310410 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 310413 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 310417 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 310432 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 310439 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310442 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310446 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310465 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310468 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 310471 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 310474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310479 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310484 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 310492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310497 */   GIR_RootConstrainSelectedInstOperands,
     /* 310498 */   // GIR_Coverage, 5278,
     /* 310498 */   GIR_EraseRootFromParent_Done,
     /* 310499 */ // Label 6277: @310499
     /* 310499 */ GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(310634), // Rule ID 5279 //
     /* 310504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 310522 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310525 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 310532 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310536 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310538 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 310545 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 310545 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 310548 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 310552 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 310567 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 310574 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310577 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310581 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310600 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310603 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 310606 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 310609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310614 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310619 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 310627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310632 */   GIR_RootConstrainSelectedInstOperands,
     /* 310633 */   // GIR_Coverage, 5279,
     /* 310633 */   GIR_EraseRootFromParent_Done,
     /* 310634 */ // Label 6278: @310634
     /* 310634 */ GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(310714), // Rule ID 5267 //
     /* 310639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310657 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310661 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310665 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310670 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310674 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310676 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 310676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310688 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 310694 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 310707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310712 */   GIR_RootConstrainSelectedInstOperands,
     /* 310713 */   // GIR_Coverage, 5267,
     /* 310713 */   GIR_EraseRootFromParent_Done,
     /* 310714 */ // Label 6279: @310714
     /* 310714 */ GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(310771), // Rule ID 5257 //
     /* 310719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310729 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 310737 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310741 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310743 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 310743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 310750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310755 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 310764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310769 */   GIR_RootConstrainSelectedInstOperands,
     /* 310770 */   // GIR_Coverage, 5257,
     /* 310770 */   GIR_EraseRootFromParent_Done,
     /* 310771 */ // Label 6280: @310771
     /* 310771 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(310801), // Rule ID 469 //
     /* 310776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310790 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 310790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 310795 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310799 */   GIR_RootConstrainSelectedInstOperands,
     /* 310800 */   // GIR_Coverage, 469,
     /* 310800 */   GIR_Done,
     /* 310801 */ // Label 6281: @310801
     /* 310801 */ GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(310831), // Rule ID 475 //
     /* 310806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310820 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 310820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 310825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310829 */   GIR_RootConstrainSelectedInstOperands,
     /* 310830 */   // GIR_Coverage, 475,
     /* 310830 */   GIR_Done,
     /* 310831 */ // Label 6282: @310831
     /* 310831 */ GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(310861), // Rule ID 505 //
     /* 310836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 310839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310850 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 310850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 310855 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310859 */   GIR_RootConstrainSelectedInstOperands,
     /* 310860 */   // GIR_Coverage, 505,
     /* 310860 */   GIR_Done,
     /* 310861 */ // Label 6283: @310861
     /* 310861 */ GIM_Reject,
     /* 310862 */ // Label 6258: @310862
     /* 310862 */ GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(310999), // Rule ID 5288 //
     /* 310867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310877 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310881 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 310885 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310888 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 310892 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310898 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 310905 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 310905 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 310908 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 310912 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 310927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 310932 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 310939 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 310942 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310946 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310965 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310968 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 310971 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 310974 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 310992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310997 */   GIR_RootConstrainSelectedInstOperands,
     /* 310998 */   // GIR_Coverage, 5288,
     /* 310998 */   GIR_EraseRootFromParent_Done,
     /* 310999 */ // Label 6284: @310999
     /* 310999 */ GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(311136), // Rule ID 5289 //
     /* 311004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 311007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311014 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311018 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 311022 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 311029 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311033 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311035 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 311042 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 311042 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 311045 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 311049 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 311069 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 311076 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311079 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311083 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311102 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 311105 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 311108 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 311111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 311129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311134 */   GIR_RootConstrainSelectedInstOperands,
     /* 311135 */   // GIR_Coverage, 5289,
     /* 311135 */   GIR_EraseRootFromParent_Done,
     /* 311136 */ // Label 6285: @311136
     /* 311136 */ GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(311276), // Rule ID 5280 //
     /* 311141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 311144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 311159 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311162 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 311169 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311173 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311175 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 311182 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 311182 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 311185 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 311189 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 311209 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 311216 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311219 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311223 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311242 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 311245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 311248 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 311251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311256 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311261 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 311266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 311269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311274 */   GIR_RootConstrainSelectedInstOperands,
     /* 311275 */   // GIR_Coverage, 5280,
     /* 311275 */   GIR_EraseRootFromParent_Done,
     /* 311276 */ // Label 6286: @311276
     /* 311276 */ GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(311416), // Rule ID 5281 //
     /* 311281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 311284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311291 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 311299 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311302 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 311309 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311313 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311315 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 311322 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 311322 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 311325 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 311329 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 311349 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 311356 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311359 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311363 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311382 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 311385 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 311388 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 311391 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311396 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 311406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 311409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311414 */   GIR_RootConstrainSelectedInstOperands,
     /* 311415 */   // GIR_Coverage, 5281,
     /* 311415 */   GIR_EraseRootFromParent_Done,
     /* 311416 */ // Label 6287: @311416
     /* 311416 */ GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(311556), // Rule ID 5284 //
     /* 311421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 311424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 311439 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311442 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 311449 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311455 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 311462 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 311462 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 311465 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 311469 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 311489 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 311496 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311499 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311503 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311522 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 311525 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 311528 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 311531 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311536 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311541 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 311549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311554 */   GIR_RootConstrainSelectedInstOperands,
     /* 311555 */   // GIR_Coverage, 5284,
     /* 311555 */   GIR_EraseRootFromParent_Done,
     /* 311556 */ // Label 6288: @311556
     /* 311556 */ GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(311696), // Rule ID 5285 //
     /* 311561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 311564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 311579 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311582 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 311589 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311595 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 311602 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 311602 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 311605 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 311609 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 311629 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 311636 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311639 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311643 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311662 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 311665 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 311668 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 311671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311681 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 311689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311694 */   GIR_RootConstrainSelectedInstOperands,
     /* 311695 */   // GIR_Coverage, 5285,
     /* 311695 */   GIR_EraseRootFromParent_Done,
     /* 311696 */ // Label 6289: @311696
     /* 311696 */ GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(311828), // Rule ID 5290 //
     /* 311701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 311704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 311719 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311722 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 311726 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311730 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311732 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 311739 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 311739 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 311742 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 311746 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 311761 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 311768 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311771 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311775 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311794 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 311797 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 311800 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 311803 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311808 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 311821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311826 */   GIR_RootConstrainSelectedInstOperands,
     /* 311827 */   // GIR_Coverage, 5290,
     /* 311827 */   GIR_EraseRootFromParent_Done,
     /* 311828 */ // Label 6290: @311828
     /* 311828 */ GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(311960), // Rule ID 5291 //
     /* 311833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 311836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 311851 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311854 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 311858 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311864 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 311871 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 311871 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 311874 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 311878 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 311893 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 311900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 311903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311926 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 311929 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 311932 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 311935 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311940 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 311953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311958 */   GIR_RootConstrainSelectedInstOperands,
     /* 311959 */   // GIR_Coverage, 5291,
     /* 311959 */   GIR_EraseRootFromParent_Done,
     /* 311960 */ // Label 6291: @311960
     /* 311960 */ GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(312095), // Rule ID 5282 //
     /* 311965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 311968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311975 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 311983 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311986 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 311993 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311999 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 312006 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 312006 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 312009 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 312013 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 312028 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 312033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 312035 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 312038 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 312042 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 312049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 312056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312061 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 312064 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 312067 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 312070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312075 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312080 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 312085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 312088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312093 */   GIR_RootConstrainSelectedInstOperands,
     /* 312094 */   // GIR_Coverage, 5282,
     /* 312094 */   GIR_EraseRootFromParent_Done,
     /* 312095 */ // Label 6292: @312095
     /* 312095 */ GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(312230), // Rule ID 5283 //
     /* 312100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 312103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 312118 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 312121 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 312128 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 312132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312134 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 312141 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 312141 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 312144 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 312148 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 312163 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 312168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 312170 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 312173 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 312177 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 312184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 312191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312196 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 312199 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 312202 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 312205 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312210 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 312220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 312223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312228 */   GIR_RootConstrainSelectedInstOperands,
     /* 312229 */   // GIR_Coverage, 5283,
     /* 312229 */   GIR_EraseRootFromParent_Done,
     /* 312230 */ // Label 6293: @312230
     /* 312230 */ GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(312365), // Rule ID 5286 //
     /* 312235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 312238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312245 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 312253 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 312256 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 312263 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 312267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312269 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 312276 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 312276 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 312279 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 312283 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 312298 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 312303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 312305 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 312308 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 312312 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 312319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 312326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312331 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 312334 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 312337 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 312340 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312350 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 312358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312363 */   GIR_RootConstrainSelectedInstOperands,
     /* 312364 */   // GIR_Coverage, 5286,
     /* 312364 */   GIR_EraseRootFromParent_Done,
     /* 312365 */ // Label 6294: @312365
     /* 312365 */ GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(312500), // Rule ID 5287 //
     /* 312370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 312373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312380 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312384 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 312388 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 312391 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 312398 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 312402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312404 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 312411 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 312411 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 312414 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 312418 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 312433 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 312438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 312440 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 312443 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 312447 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 312454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 312461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312466 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 312469 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 312472 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 312475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 312493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312498 */   GIR_RootConstrainSelectedInstOperands,
     /* 312499 */   // GIR_Coverage, 5287,
     /* 312499 */   GIR_EraseRootFromParent_Done,
     /* 312500 */ // Label 6295: @312500
     /* 312500 */ GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(312580), // Rule ID 5269 //
     /* 312505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 312508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312523 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312527 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312531 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312536 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312542 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 312542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312554 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 312560 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312565 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 312573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312578 */   GIR_RootConstrainSelectedInstOperands,
     /* 312579 */   // GIR_Coverage, 5269,
     /* 312579 */   GIR_EraseRootFromParent_Done,
     /* 312580 */ // Label 6296: @312580
     /* 312580 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(312637), // Rule ID 5253 //
     /* 312585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 312588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 312603 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312609 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 312609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 312616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 312630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312635 */   GIR_RootConstrainSelectedInstOperands,
     /* 312636 */   // GIR_Coverage, 5253,
     /* 312636 */   GIR_EraseRootFromParent_Done,
     /* 312637 */ // Label 6297: @312637
     /* 312637 */ GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(312667), // Rule ID 471 //
     /* 312642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312656 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 312656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 312661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312665 */   GIR_RootConstrainSelectedInstOperands,
     /* 312666 */   // GIR_Coverage, 471,
     /* 312666 */   GIR_Done,
     /* 312667 */ // Label 6298: @312667
     /* 312667 */ GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(312697), // Rule ID 477 //
     /* 312672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312686 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 312686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 312691 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312695 */   GIR_RootConstrainSelectedInstOperands,
     /* 312696 */   // GIR_Coverage, 477,
     /* 312696 */   GIR_Done,
     /* 312697 */ // Label 6299: @312697
     /* 312697 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(312727), // Rule ID 501 //
     /* 312702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 312705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312716 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 312716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 312721 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312725 */   GIR_RootConstrainSelectedInstOperands,
     /* 312726 */   // GIR_Coverage, 501,
     /* 312726 */   GIR_Done,
     /* 312727 */ // Label 6300: @312727
     /* 312727 */ GIM_Reject,
     /* 312728 */ // Label 6259: @312728
     /* 312728 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(312758), // Rule ID 1071 //
     /* 312733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312747 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 312747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 312752 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312756 */   GIR_RootConstrainSelectedInstOperands,
     /* 312757 */   // GIR_Coverage, 1071,
     /* 312757 */   GIR_Done,
     /* 312758 */ // Label 6301: @312758
     /* 312758 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(312801), // Rule ID 12908 //
     /* 312763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312773 */   // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 312773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 312780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312785 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 312789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 312794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312799 */   GIR_RootConstrainSelectedInstOperands,
     /* 312800 */   // GIR_Coverage, 12908,
     /* 312800 */   GIR_EraseRootFromParent_Done,
     /* 312801 */ // Label 6302: @312801
     /* 312801 */ GIM_Reject,
     /* 312802 */ // Label 6260: @312802
     /* 312802 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(312832), // Rule ID 1075 //
     /* 312807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312821 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 312821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 312826 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312830 */   GIR_RootConstrainSelectedInstOperands,
     /* 312831 */   // GIR_Coverage, 1075,
     /* 312831 */   GIR_Done,
     /* 312832 */ // Label 6303: @312832
     /* 312832 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(312878), // Rule ID 12906 //
     /* 312837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312847 */   // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 312847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 312854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312859 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 312863 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 312866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 312871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312876 */   GIR_RootConstrainSelectedInstOperands,
     /* 312877 */   // GIR_Coverage, 12906,
     /* 312877 */   GIR_EraseRootFromParent_Done,
     /* 312878 */ // Label 6304: @312878
     /* 312878 */ GIM_Reject,
     /* 312879 */ // Label 6261: @312879
     /* 312879 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(312909), // Rule ID 1067 //
     /* 312884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312898 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 312898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 312903 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312907 */   GIR_RootConstrainSelectedInstOperands,
     /* 312908 */   // GIR_Coverage, 1067,
     /* 312908 */   GIR_Done,
     /* 312909 */ // Label 6305: @312909
     /* 312909 */ GIM_Reject,
     /* 312910 */ // Label 6262: @312910
     /* 312910 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(312940), // Rule ID 1073 //
     /* 312915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312929 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 312929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 312934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312938 */   GIR_RootConstrainSelectedInstOperands,
     /* 312939 */   // GIR_Coverage, 1073,
     /* 312939 */   GIR_Done,
     /* 312940 */ // Label 6306: @312940
     /* 312940 */ GIM_Reject,
     /* 312941 */ // Label 6263: @312941
     /* 312941 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(312971), // Rule ID 1069 //
     /* 312946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312960 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 312960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 312965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312969 */   GIR_RootConstrainSelectedInstOperands,
     /* 312970 */   // GIR_Coverage, 1069,
     /* 312970 */   GIR_Done,
     /* 312971 */ // Label 6307: @312971
     /* 312971 */ GIM_Reject,
     /* 312972 */ // Label 6264: @312972
     /* 312972 */ GIM_Reject,
     /* 312973 */ // Label 69: @312973
     /* 312973 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6315*/ GIMT_Encode4(313292),
     /* 312984 */ /*GILLT_s32*//*Label 6308*/ GIMT_Encode4(313020),
     /* 312988 */ /*GILLT_s64*//*Label 6309*/ GIMT_Encode4(313093), GIMT_Encode4(0),
     /* 312996 */ /*GILLT_v2s32*//*Label 6310*/ GIMT_Encode4(313166),
     /* 313000 */ /*GILLT_v2s64*//*Label 6311*/ GIMT_Encode4(313190),
     /* 313004 */ /*GILLT_v4s16*//*Label 6312*/ GIMT_Encode4(313214),
     /* 313008 */ /*GILLT_v4s32*//*Label 6313*/ GIMT_Encode4(313241), GIMT_Encode4(0),
     /* 313016 */ /*GILLT_v8s16*//*Label 6314*/ GIMT_Encode4(313265),
     /* 313020 */ // Label 6308: @313020
     /* 313020 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(313046), // Rule ID 4534 //
     /* 313025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313035 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 313035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 313040 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313044 */   GIR_RootConstrainSelectedInstOperands,
     /* 313045 */   // GIR_Coverage, 4534,
     /* 313045 */   GIR_Done,
     /* 313046 */ // Label 6316: @313046
     /* 313046 */ GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(313069), // Rule ID 4536 //
     /* 313051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313058 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 313063 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313067 */   GIR_RootConstrainSelectedInstOperands,
     /* 313068 */   // GIR_Coverage, 4536,
     /* 313068 */   GIR_Done,
     /* 313069 */ // Label 6317: @313069
     /* 313069 */ GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(313092), // Rule ID 4538 //
     /* 313074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313081 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 313086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313090 */   GIR_RootConstrainSelectedInstOperands,
     /* 313091 */   // GIR_Coverage, 4538,
     /* 313091 */   GIR_Done,
     /* 313092 */ // Label 6318: @313092
     /* 313092 */ GIM_Reject,
     /* 313093 */ // Label 6309: @313093
     /* 313093 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(313119), // Rule ID 4535 //
     /* 313098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313108 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 313108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 313113 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313117 */   GIR_RootConstrainSelectedInstOperands,
     /* 313118 */   // GIR_Coverage, 4535,
     /* 313118 */   GIR_Done,
     /* 313119 */ // Label 6319: @313119
     /* 313119 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(313142), // Rule ID 4537 //
     /* 313124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313131 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 313136 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313140 */   GIR_RootConstrainSelectedInstOperands,
     /* 313141 */   // GIR_Coverage, 4537,
     /* 313141 */   GIR_Done,
     /* 313142 */ // Label 6320: @313142
     /* 313142 */ GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(313165), // Rule ID 4539 //
     /* 313147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313154 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 313159 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313163 */   GIR_RootConstrainSelectedInstOperands,
     /* 313164 */   // GIR_Coverage, 4539,
     /* 313164 */   GIR_Done,
     /* 313165 */ // Label 6321: @313165
     /* 313165 */ GIM_Reject,
     /* 313166 */ // Label 6310: @313166
     /* 313166 */ GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(313189), // Rule ID 4875 //
     /* 313171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313178 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 313178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 313183 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313187 */   GIR_RootConstrainSelectedInstOperands,
     /* 313188 */   // GIR_Coverage, 4875,
     /* 313188 */   GIR_Done,
     /* 313189 */ // Label 6322: @313189
     /* 313189 */ GIM_Reject,
     /* 313190 */ // Label 6311: @313190
     /* 313190 */ GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(313213), // Rule ID 4877 //
     /* 313195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313202 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 313202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 313207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313211 */   GIR_RootConstrainSelectedInstOperands,
     /* 313212 */   // GIR_Coverage, 4877,
     /* 313212 */   GIR_Done,
     /* 313213 */ // Label 6323: @313213
     /* 313213 */ GIM_Reject,
     /* 313214 */ // Label 6312: @313214
     /* 313214 */ GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(313240), // Rule ID 4870 //
     /* 313219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313229 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 313229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 313234 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313238 */   GIR_RootConstrainSelectedInstOperands,
     /* 313239 */   // GIR_Coverage, 4870,
     /* 313239 */   GIR_Done,
     /* 313240 */ // Label 6324: @313240
     /* 313240 */ GIM_Reject,
     /* 313241 */ // Label 6313: @313241
     /* 313241 */ GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(313264), // Rule ID 4876 //
     /* 313246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313253 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 313253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 313258 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313262 */   GIR_RootConstrainSelectedInstOperands,
     /* 313263 */   // GIR_Coverage, 4876,
     /* 313263 */   GIR_Done,
     /* 313264 */ // Label 6325: @313264
     /* 313264 */ GIM_Reject,
     /* 313265 */ // Label 6314: @313265
     /* 313265 */ GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(313291), // Rule ID 4871 //
     /* 313270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313280 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 313280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 313285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313289 */   GIR_RootConstrainSelectedInstOperands,
     /* 313290 */   // GIR_Coverage, 4871,
     /* 313290 */   GIR_Done,
     /* 313291 */ // Label 6326: @313291
     /* 313291 */ GIM_Reject,
     /* 313292 */ // Label 6315: @313292
     /* 313292 */ GIM_Reject,
     /* 313293 */ // Label 70: @313293
     /* 313293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6334*/ GIMT_Encode4(313612),
     /* 313304 */ /*GILLT_s32*//*Label 6327*/ GIMT_Encode4(313340),
     /* 313308 */ /*GILLT_s64*//*Label 6328*/ GIMT_Encode4(313413), GIMT_Encode4(0),
     /* 313316 */ /*GILLT_v2s32*//*Label 6329*/ GIMT_Encode4(313486),
     /* 313320 */ /*GILLT_v2s64*//*Label 6330*/ GIMT_Encode4(313510),
     /* 313324 */ /*GILLT_v4s16*//*Label 6331*/ GIMT_Encode4(313534),
     /* 313328 */ /*GILLT_v4s32*//*Label 6332*/ GIMT_Encode4(313561), GIMT_Encode4(0),
     /* 313336 */ /*GILLT_v8s16*//*Label 6333*/ GIMT_Encode4(313585),
     /* 313340 */ // Label 6327: @313340
     /* 313340 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(313366), // Rule ID 4558 //
     /* 313345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313355 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 313355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 313360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313364 */   GIR_RootConstrainSelectedInstOperands,
     /* 313365 */   // GIR_Coverage, 4558,
     /* 313365 */   GIR_Done,
     /* 313366 */ // Label 6335: @313366
     /* 313366 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(313389), // Rule ID 4560 //
     /* 313371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313378 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 313383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313387 */   GIR_RootConstrainSelectedInstOperands,
     /* 313388 */   // GIR_Coverage, 4560,
     /* 313388 */   GIR_Done,
     /* 313389 */ // Label 6336: @313389
     /* 313389 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(313412), // Rule ID 4562 //
     /* 313394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313401 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 313406 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313410 */   GIR_RootConstrainSelectedInstOperands,
     /* 313411 */   // GIR_Coverage, 4562,
     /* 313411 */   GIR_Done,
     /* 313412 */ // Label 6337: @313412
     /* 313412 */ GIM_Reject,
     /* 313413 */ // Label 6328: @313413
     /* 313413 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(313439), // Rule ID 4559 //
     /* 313418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313428 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 313428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 313433 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313437 */   GIR_RootConstrainSelectedInstOperands,
     /* 313438 */   // GIR_Coverage, 4559,
     /* 313438 */   GIR_Done,
     /* 313439 */ // Label 6338: @313439
     /* 313439 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(313462), // Rule ID 4561 //
     /* 313444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313451 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 313456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313460 */   GIR_RootConstrainSelectedInstOperands,
     /* 313461 */   // GIR_Coverage, 4561,
     /* 313461 */   GIR_Done,
     /* 313462 */ // Label 6339: @313462
     /* 313462 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(313485), // Rule ID 4563 //
     /* 313467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313474 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 313479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313483 */   GIR_RootConstrainSelectedInstOperands,
     /* 313484 */   // GIR_Coverage, 4563,
     /* 313484 */   GIR_Done,
     /* 313485 */ // Label 6340: @313485
     /* 313485 */ GIM_Reject,
     /* 313486 */ // Label 6329: @313486
     /* 313486 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(313509), // Rule ID 4885 //
     /* 313491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313498 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 313498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 313503 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313507 */   GIR_RootConstrainSelectedInstOperands,
     /* 313508 */   // GIR_Coverage, 4885,
     /* 313508 */   GIR_Done,
     /* 313509 */ // Label 6341: @313509
     /* 313509 */ GIM_Reject,
     /* 313510 */ // Label 6330: @313510
     /* 313510 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(313533), // Rule ID 4887 //
     /* 313515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313522 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 313522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 313527 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313531 */   GIR_RootConstrainSelectedInstOperands,
     /* 313532 */   // GIR_Coverage, 4887,
     /* 313532 */   GIR_Done,
     /* 313533 */ // Label 6342: @313533
     /* 313533 */ GIM_Reject,
     /* 313534 */ // Label 6331: @313534
     /* 313534 */ GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(313560), // Rule ID 4880 //
     /* 313539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313549 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 313549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 313554 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313558 */   GIR_RootConstrainSelectedInstOperands,
     /* 313559 */   // GIR_Coverage, 4880,
     /* 313559 */   GIR_Done,
     /* 313560 */ // Label 6343: @313560
     /* 313560 */ GIM_Reject,
     /* 313561 */ // Label 6332: @313561
     /* 313561 */ GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(313584), // Rule ID 4886 //
     /* 313566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313573 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 313573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 313578 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313582 */   GIR_RootConstrainSelectedInstOperands,
     /* 313583 */   // GIR_Coverage, 4886,
     /* 313583 */   GIR_Done,
     /* 313584 */ // Label 6344: @313584
     /* 313584 */ GIM_Reject,
     /* 313585 */ // Label 6333: @313585
     /* 313585 */ GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(313611), // Rule ID 4881 //
     /* 313590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313600 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 313600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 313605 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313609 */   GIR_RootConstrainSelectedInstOperands,
     /* 313610 */   // GIR_Coverage, 4881,
     /* 313610 */   GIR_Done,
     /* 313611 */ // Label 6345: @313611
     /* 313611 */ GIM_Reject,
     /* 313612 */ // Label 6334: @313612
     /* 313612 */ GIM_Reject,
     /* 313613 */ // Label 71: @313613
     /* 313613 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6354*/ GIMT_Encode4(314469),
     /* 313624 */ /*GILLT_s16*//*Label 6346*/ GIMT_Encode4(313664),
     /* 313628 */ /*GILLT_s32*//*Label 6347*/ GIMT_Encode4(313883),
     /* 313632 */ /*GILLT_s64*//*Label 6348*/ GIMT_Encode4(313957), GIMT_Encode4(0),
     /* 313640 */ /*GILLT_v2s32*//*Label 6349*/ GIMT_Encode4(314031),
     /* 313644 */ /*GILLT_v2s64*//*Label 6350*/ GIMT_Encode4(314105),
     /* 313648 */ /*GILLT_v4s16*//*Label 6351*/ GIMT_Encode4(314179),
     /* 313652 */ /*GILLT_v4s32*//*Label 6352*/ GIMT_Encode4(314287), GIMT_Encode4(0),
     /* 313660 */ /*GILLT_v8s16*//*Label 6353*/ GIMT_Encode4(314361),
     /* 313664 */ // Label 6346: @313664
     /* 313664 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(313882),
     /* 313669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313676 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(313717), // Rule ID 5156 //
     /* 313681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 313692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313702 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 313702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 313705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 313715 */     GIR_RootConstrainSelectedInstOperands,
     /* 313716 */     // GIR_Coverage, 5156,
     /* 313716 */     GIR_EraseRootFromParent_Done,
     /* 313717 */   // Label 6356: @313717
     /* 313717 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(313736), // Rule ID 521 //
     /* 313722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313729 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 313729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 313734 */     GIR_RootConstrainSelectedInstOperands,
     /* 313735 */     // GIR_Coverage, 521,
     /* 313735 */     GIR_Done,
     /* 313736 */   // Label 6357: @313736
     /* 313736 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(313881), // Rule ID 6293 //
     /* 313741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313745 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 313745 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 313748 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313752 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 313759 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 313762 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313766 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313771 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313774 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 313778 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 313781 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313786 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313791 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313796 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 313799 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313803 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313808 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 313811 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313816 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313819 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 313823 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313828 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313831 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 313836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 313853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313863 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 313870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313880 */     // GIR_Coverage, 6293,
     /* 313880 */     GIR_EraseRootFromParent_Done,
     /* 313881 */   // Label 6358: @313881
     /* 313881 */   GIM_Reject,
     /* 313882 */ // Label 6355: @313882
     /* 313882 */ GIM_Reject,
     /* 313883 */ // Label 6347: @313883
     /* 313883 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(313956),
     /* 313888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313895 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(313936), // Rule ID 5157 //
     /* 313900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 313911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 313919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313921 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 313921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 313924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 313934 */     GIR_RootConstrainSelectedInstOperands,
     /* 313935 */     // GIR_Coverage, 5157,
     /* 313935 */     GIR_EraseRootFromParent_Done,
     /* 313936 */   // Label 6360: @313936
     /* 313936 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(313955), // Rule ID 522 //
     /* 313941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313948 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 313948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 313953 */     GIR_RootConstrainSelectedInstOperands,
     /* 313954 */     // GIR_Coverage, 522,
     /* 313954 */     GIR_Done,
     /* 313955 */   // Label 6361: @313955
     /* 313955 */   GIM_Reject,
     /* 313956 */ // Label 6359: @313956
     /* 313956 */ GIM_Reject,
     /* 313957 */ // Label 6348: @313957
     /* 313957 */ GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(314030),
     /* 313962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313969 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(314010), // Rule ID 5158 //
     /* 313974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 313985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313995 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 313995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 313998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 314008 */     GIR_RootConstrainSelectedInstOperands,
     /* 314009 */     // GIR_Coverage, 5158,
     /* 314009 */     GIR_EraseRootFromParent_Done,
     /* 314010 */   // Label 6363: @314010
     /* 314010 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(314029), // Rule ID 523 //
     /* 314015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314022 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 314022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 314027 */     GIR_RootConstrainSelectedInstOperands,
     /* 314028 */     // GIR_Coverage, 523,
     /* 314028 */     GIR_Done,
     /* 314029 */   // Label 6364: @314029
     /* 314029 */   GIM_Reject,
     /* 314030 */ // Label 6362: @314030
     /* 314030 */ GIM_Reject,
     /* 314031 */ // Label 6349: @314031
     /* 314031 */ GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(314104),
     /* 314036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314043 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(314084), // Rule ID 4949 //
     /* 314048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 314059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 314067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314069 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 314069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 314072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 314082 */     GIR_RootConstrainSelectedInstOperands,
     /* 314083 */     // GIR_Coverage, 4949,
     /* 314083 */     GIR_EraseRootFromParent_Done,
     /* 314084 */   // Label 6366: @314084
     /* 314084 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(314103), // Rule ID 761 //
     /* 314089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314096 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 314096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 314101 */     GIR_RootConstrainSelectedInstOperands,
     /* 314102 */     // GIR_Coverage, 761,
     /* 314102 */     GIR_Done,
     /* 314103 */   // Label 6367: @314103
     /* 314103 */   GIM_Reject,
     /* 314104 */ // Label 6365: @314104
     /* 314104 */ GIM_Reject,
     /* 314105 */ // Label 6350: @314105
     /* 314105 */ GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(314178),
     /* 314110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314117 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(314158), // Rule ID 4951 //
     /* 314122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 314133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 314141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314143 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 314143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 314146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 314156 */     GIR_RootConstrainSelectedInstOperands,
     /* 314157 */     // GIR_Coverage, 4951,
     /* 314157 */     GIR_EraseRootFromParent_Done,
     /* 314158 */   // Label 6369: @314158
     /* 314158 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(314177), // Rule ID 763 //
     /* 314163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314170 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 314170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 314175 */     GIR_RootConstrainSelectedInstOperands,
     /* 314176 */     // GIR_Coverage, 763,
     /* 314176 */     GIR_Done,
     /* 314177 */   // Label 6370: @314177
     /* 314177 */   GIM_Reject,
     /* 314178 */ // Label 6368: @314178
     /* 314178 */ GIM_Reject,
     /* 314179 */ // Label 6351: @314179
     /* 314179 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(314286),
     /* 314184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314191 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(314232), // Rule ID 4952 //
     /* 314196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 314207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 314215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314217 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 314217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 314220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 314230 */     GIR_RootConstrainSelectedInstOperands,
     /* 314231 */     // GIR_Coverage, 4952,
     /* 314231 */     GIR_EraseRootFromParent_Done,
     /* 314232 */   // Label 6372: @314232
     /* 314232 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(314251), // Rule ID 759 //
     /* 314237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314244 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 314244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 314249 */     GIR_RootConstrainSelectedInstOperands,
     /* 314250 */     // GIR_Coverage, 759,
     /* 314250 */     GIR_Done,
     /* 314251 */   // Label 6373: @314251
     /* 314251 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(314285), // Rule ID 6295 //
     /* 314256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314263 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 314263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 314266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314270 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 314280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 314283 */     GIR_RootConstrainSelectedInstOperands,
     /* 314284 */     // GIR_Coverage, 6295,
     /* 314284 */     GIR_EraseRootFromParent_Done,
     /* 314285 */   // Label 6374: @314285
     /* 314285 */   GIM_Reject,
     /* 314286 */ // Label 6371: @314286
     /* 314286 */ GIM_Reject,
     /* 314287 */ // Label 6352: @314287
     /* 314287 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(314360),
     /* 314292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314299 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(314340), // Rule ID 4950 //
     /* 314304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 314315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 314323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314325 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 314325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 314328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 314338 */     GIR_RootConstrainSelectedInstOperands,
     /* 314339 */     // GIR_Coverage, 4950,
     /* 314339 */     GIR_EraseRootFromParent_Done,
     /* 314340 */   // Label 6376: @314340
     /* 314340 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(314359), // Rule ID 762 //
     /* 314345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314352 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 314352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 314357 */     GIR_RootConstrainSelectedInstOperands,
     /* 314358 */     // GIR_Coverage, 762,
     /* 314358 */     GIR_Done,
     /* 314359 */   // Label 6377: @314359
     /* 314359 */   GIM_Reject,
     /* 314360 */ // Label 6375: @314360
     /* 314360 */ GIM_Reject,
     /* 314361 */ // Label 6353: @314361
     /* 314361 */ GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(314468),
     /* 314366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314373 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(314414), // Rule ID 4953 //
     /* 314378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 314389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 314397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314399 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 314399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 314402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 314412 */     GIR_RootConstrainSelectedInstOperands,
     /* 314413 */     // GIR_Coverage, 4953,
     /* 314413 */     GIR_EraseRootFromParent_Done,
     /* 314414 */   // Label 6379: @314414
     /* 314414 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(314433), // Rule ID 760 //
     /* 314419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314426 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 314426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 314431 */     GIR_RootConstrainSelectedInstOperands,
     /* 314432 */     // GIR_Coverage, 760,
     /* 314432 */     GIR_Done,
     /* 314433 */   // Label 6380: @314433
     /* 314433 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(314467), // Rule ID 6296 //
     /* 314438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314445 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 314445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 314448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314452 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 314462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 314465 */     GIR_RootConstrainSelectedInstOperands,
     /* 314466 */     // GIR_Coverage, 6296,
     /* 314466 */     GIR_EraseRootFromParent_Done,
     /* 314467 */   // Label 6381: @314467
     /* 314467 */   GIM_Reject,
     /* 314468 */ // Label 6378: @314468
     /* 314468 */ GIM_Reject,
     /* 314469 */ // Label 6354: @314469
     /* 314469 */ GIM_Reject,
     /* 314470 */ // Label 72: @314470
     /* 314470 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6390*/ GIMT_Encode4(314751),
     /* 314481 */ /*GILLT_s16*//*Label 6382*/ GIMT_Encode4(314521),
     /* 314485 */ /*GILLT_s32*//*Label 6383*/ GIMT_Encode4(314548),
     /* 314489 */ /*GILLT_s64*//*Label 6384*/ GIMT_Encode4(314572), GIMT_Encode4(0),
     /* 314497 */ /*GILLT_v2s32*//*Label 6385*/ GIMT_Encode4(314596),
     /* 314501 */ /*GILLT_v2s64*//*Label 6386*/ GIMT_Encode4(314627),
     /* 314505 */ /*GILLT_v4s16*//*Label 6387*/ GIMT_Encode4(314658),
     /* 314509 */ /*GILLT_v4s32*//*Label 6388*/ GIMT_Encode4(314689), GIMT_Encode4(0),
     /* 314517 */ /*GILLT_v8s16*//*Label 6389*/ GIMT_Encode4(314720),
     /* 314521 */ // Label 6382: @314521
     /* 314521 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(314547), // Rule ID 4774 //
     /* 314526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314536 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 314536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 314539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314541 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 314543 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 314545 */   GIR_RootConstrainSelectedInstOperands,
     /* 314546 */   // GIR_Coverage, 4774,
     /* 314546 */   GIR_EraseRootFromParent_Done,
     /* 314547 */ // Label 6391: @314547
     /* 314547 */ GIM_Reject,
     /* 314548 */ // Label 6383: @314548
     /* 314548 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(314571), // Rule ID 4771 //
     /* 314553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314560 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 314560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 314563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314565 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 314567 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 314569 */   GIR_RootConstrainSelectedInstOperands,
     /* 314570 */   // GIR_Coverage, 4771,
     /* 314570 */   GIR_EraseRootFromParent_Done,
     /* 314571 */ // Label 6392: @314571
     /* 314571 */ GIM_Reject,
     /* 314572 */ // Label 6384: @314572
     /* 314572 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(314595), // Rule ID 4768 //
     /* 314577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314584 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 314584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 314587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314589 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 314591 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 314593 */   GIR_RootConstrainSelectedInstOperands,
     /* 314594 */   // GIR_Coverage, 4768,
     /* 314594 */   GIR_EraseRootFromParent_Done,
     /* 314595 */ // Label 6393: @314595
     /* 314595 */ GIM_Reject,
     /* 314596 */ // Label 6385: @314596
     /* 314596 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(314626), // Rule ID 4962 //
     /* 314601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314615 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 314615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 314618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314620 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314624 */   GIR_RootConstrainSelectedInstOperands,
     /* 314625 */   // GIR_Coverage, 4962,
     /* 314625 */   GIR_EraseRootFromParent_Done,
     /* 314626 */ // Label 6394: @314626
     /* 314626 */ GIM_Reject,
     /* 314627 */ // Label 6386: @314627
     /* 314627 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(314657), // Rule ID 4956 //
     /* 314632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314646 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 314646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 314649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314651 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314653 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314655 */   GIR_RootConstrainSelectedInstOperands,
     /* 314656 */   // GIR_Coverage, 4956,
     /* 314656 */   GIR_EraseRootFromParent_Done,
     /* 314657 */ // Label 6395: @314657
     /* 314657 */ GIM_Reject,
     /* 314658 */ // Label 6387: @314658
     /* 314658 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(314688), // Rule ID 4968 //
     /* 314663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314677 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 314677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 314680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314682 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314684 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314686 */   GIR_RootConstrainSelectedInstOperands,
     /* 314687 */   // GIR_Coverage, 4968,
     /* 314687 */   GIR_EraseRootFromParent_Done,
     /* 314688 */ // Label 6396: @314688
     /* 314688 */ GIM_Reject,
     /* 314689 */ // Label 6388: @314689
     /* 314689 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(314719), // Rule ID 4959 //
     /* 314694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314708 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 314708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 314711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314713 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314715 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314717 */   GIR_RootConstrainSelectedInstOperands,
     /* 314718 */   // GIR_Coverage, 4959,
     /* 314718 */   GIR_EraseRootFromParent_Done,
     /* 314719 */ // Label 6397: @314719
     /* 314719 */ GIM_Reject,
     /* 314720 */ // Label 6389: @314720
     /* 314720 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(314750), // Rule ID 4965 //
     /* 314725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314739 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 314739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 314742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314744 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314746 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314748 */   GIR_RootConstrainSelectedInstOperands,
     /* 314749 */   // GIR_Coverage, 4965,
     /* 314749 */   GIR_EraseRootFromParent_Done,
     /* 314750 */ // Label 6398: @314750
     /* 314750 */ GIM_Reject,
     /* 314751 */ // Label 6390: @314751
     /* 314751 */ GIM_Reject,
     /* 314752 */ // Label 73: @314752
     /* 314752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6407*/ GIMT_Encode4(315129),
     /* 314763 */ /*GILLT_s16*//*Label 6399*/ GIMT_Encode4(314803),
     /* 314767 */ /*GILLT_s32*//*Label 6400*/ GIMT_Encode4(314841),
     /* 314771 */ /*GILLT_s64*//*Label 6401*/ GIMT_Encode4(314879), GIMT_Encode4(0),
     /* 314779 */ /*GILLT_v2s32*//*Label 6402*/ GIMT_Encode4(314939),
     /* 314783 */ /*GILLT_v2s64*//*Label 6403*/ GIMT_Encode4(314977),
     /* 314787 */ /*GILLT_v4s16*//*Label 6404*/ GIMT_Encode4(315015),
     /* 314791 */ /*GILLT_v4s32*//*Label 6405*/ GIMT_Encode4(315053), GIMT_Encode4(0),
     /* 314799 */ /*GILLT_v8s16*//*Label 6406*/ GIMT_Encode4(315091),
     /* 314803 */ // Label 6399: @314803
     /* 314803 */ GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(314840), // Rule ID 608 //
     /* 314808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 314817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314829 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 314829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 314834 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314838 */   GIR_RootConstrainSelectedInstOperands,
     /* 314839 */   // GIR_Coverage, 608,
     /* 314839 */   GIR_Done,
     /* 314840 */ // Label 6408: @314840
     /* 314840 */ GIM_Reject,
     /* 314841 */ // Label 6400: @314841
     /* 314841 */ GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(314878), // Rule ID 610 //
     /* 314846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 314855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314867 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 314867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 314872 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314876 */   GIR_RootConstrainSelectedInstOperands,
     /* 314877 */   // GIR_Coverage, 610,
     /* 314877 */   GIR_Done,
     /* 314878 */ // Label 6409: @314878
     /* 314878 */ GIM_Reject,
     /* 314879 */ // Label 6401: @314879
     /* 314879 */ GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(314938),
     /* 314884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314902 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(314921), // Rule ID 612 //
     /* 314907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314910 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 314910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 314915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314919 */     GIR_RootConstrainSelectedInstOperands,
     /* 314920 */     // GIR_Coverage, 612,
     /* 314920 */     GIR_Done,
     /* 314921 */   // Label 6411: @314921
     /* 314921 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(314937), // Rule ID 4765 //
     /* 314926 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 314926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 314931 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314935 */     GIR_RootConstrainSelectedInstOperands,
     /* 314936 */     // GIR_Coverage, 4765,
     /* 314936 */     GIR_Done,
     /* 314937 */   // Label 6412: @314937
     /* 314937 */   GIM_Reject,
     /* 314938 */ // Label 6410: @314938
     /* 314938 */ GIM_Reject,
     /* 314939 */ // Label 6402: @314939
     /* 314939 */ GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(314976), // Rule ID 1266 //
     /* 314944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 314953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314965 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 314970 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314974 */   GIR_RootConstrainSelectedInstOperands,
     /* 314975 */   // GIR_Coverage, 1266,
     /* 314975 */   GIR_Done,
     /* 314976 */ // Label 6413: @314976
     /* 314976 */ GIM_Reject,
     /* 314977 */ // Label 6403: @314977
     /* 314977 */ GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(315014), // Rule ID 1270 //
     /* 314982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 314991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315003 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 315003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 315008 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315012 */   GIR_RootConstrainSelectedInstOperands,
     /* 315013 */   // GIR_Coverage, 1270,
     /* 315013 */   GIR_Done,
     /* 315014 */ // Label 6414: @315014
     /* 315014 */ GIM_Reject,
     /* 315015 */ // Label 6404: @315015
     /* 315015 */ GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(315052), // Rule ID 1262 //
     /* 315020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315041 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 315041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 315046 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315050 */   GIR_RootConstrainSelectedInstOperands,
     /* 315051 */   // GIR_Coverage, 1262,
     /* 315051 */   GIR_Done,
     /* 315052 */ // Label 6415: @315052
     /* 315052 */ GIM_Reject,
     /* 315053 */ // Label 6405: @315053
     /* 315053 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(315090), // Rule ID 1268 //
     /* 315058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315079 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 315079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 315084 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315088 */   GIR_RootConstrainSelectedInstOperands,
     /* 315089 */   // GIR_Coverage, 1268,
     /* 315089 */   GIR_Done,
     /* 315090 */ // Label 6416: @315090
     /* 315090 */ GIM_Reject,
     /* 315091 */ // Label 6406: @315091
     /* 315091 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(315128), // Rule ID 1264 //
     /* 315096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315117 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 315117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 315122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315126 */   GIR_RootConstrainSelectedInstOperands,
     /* 315127 */   // GIR_Coverage, 1264,
     /* 315127 */   GIR_Done,
     /* 315128 */ // Label 6417: @315128
     /* 315128 */ GIM_Reject,
     /* 315129 */ // Label 6407: @315129
     /* 315129 */ GIM_Reject,
     /* 315130 */ // Label 74: @315130
     /* 315130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6426*/ GIMT_Encode4(315507),
     /* 315141 */ /*GILLT_s16*//*Label 6418*/ GIMT_Encode4(315181),
     /* 315145 */ /*GILLT_s32*//*Label 6419*/ GIMT_Encode4(315219),
     /* 315149 */ /*GILLT_s64*//*Label 6420*/ GIMT_Encode4(315257), GIMT_Encode4(0),
     /* 315157 */ /*GILLT_v2s32*//*Label 6421*/ GIMT_Encode4(315317),
     /* 315161 */ /*GILLT_v2s64*//*Label 6422*/ GIMT_Encode4(315355),
     /* 315165 */ /*GILLT_v4s16*//*Label 6423*/ GIMT_Encode4(315393),
     /* 315169 */ /*GILLT_v4s32*//*Label 6424*/ GIMT_Encode4(315431), GIMT_Encode4(0),
     /* 315177 */ /*GILLT_v8s16*//*Label 6425*/ GIMT_Encode4(315469),
     /* 315181 */ // Label 6418: @315181
     /* 315181 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(315218), // Rule ID 596 //
     /* 315186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 315189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 315192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 315195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315207 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 315207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 315212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315216 */   GIR_RootConstrainSelectedInstOperands,
     /* 315217 */   // GIR_Coverage, 596,
     /* 315217 */   GIR_Done,
     /* 315218 */ // Label 6427: @315218
     /* 315218 */ GIM_Reject,
     /* 315219 */ // Label 6419: @315219
     /* 315219 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(315256), // Rule ID 598 //
     /* 315224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315245 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 315245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 315250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315254 */   GIR_RootConstrainSelectedInstOperands,
     /* 315255 */   // GIR_Coverage, 598,
     /* 315255 */   GIR_Done,
     /* 315256 */ // Label 6428: @315256
     /* 315256 */ GIM_Reject,
     /* 315257 */ // Label 6420: @315257
     /* 315257 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(315316),
     /* 315262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315280 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(315299), // Rule ID 600 //
     /* 315285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315288 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 315288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 315293 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315297 */     GIR_RootConstrainSelectedInstOperands,
     /* 315298 */     // GIR_Coverage, 600,
     /* 315298 */     GIR_Done,
     /* 315299 */   // Label 6430: @315299
     /* 315299 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(315315), // Rule ID 4764 //
     /* 315304 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 315304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 315309 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315313 */     GIR_RootConstrainSelectedInstOperands,
     /* 315314 */     // GIR_Coverage, 4764,
     /* 315314 */     GIR_Done,
     /* 315315 */   // Label 6431: @315315
     /* 315315 */   GIM_Reject,
     /* 315316 */ // Label 6429: @315316
     /* 315316 */ GIM_Reject,
     /* 315317 */ // Label 6421: @315317
     /* 315317 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(315354), // Rule ID 1236 //
     /* 315322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 315331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315343 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 315343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 315348 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315352 */   GIR_RootConstrainSelectedInstOperands,
     /* 315353 */   // GIR_Coverage, 1236,
     /* 315353 */   GIR_Done,
     /* 315354 */ // Label 6432: @315354
     /* 315354 */ GIM_Reject,
     /* 315355 */ // Label 6422: @315355
     /* 315355 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(315392), // Rule ID 1240 //
     /* 315360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 315369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315381 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 315381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 315386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315390 */   GIR_RootConstrainSelectedInstOperands,
     /* 315391 */   // GIR_Coverage, 1240,
     /* 315391 */   GIR_Done,
     /* 315392 */ // Label 6433: @315392
     /* 315392 */ GIM_Reject,
     /* 315393 */ // Label 6423: @315393
     /* 315393 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(315430), // Rule ID 1232 //
     /* 315398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315419 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 315419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 315424 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315428 */   GIR_RootConstrainSelectedInstOperands,
     /* 315429 */   // GIR_Coverage, 1232,
     /* 315429 */   GIR_Done,
     /* 315430 */ // Label 6434: @315430
     /* 315430 */ GIM_Reject,
     /* 315431 */ // Label 6424: @315431
     /* 315431 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(315468), // Rule ID 1238 //
     /* 315436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315457 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 315457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 315462 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315466 */   GIR_RootConstrainSelectedInstOperands,
     /* 315467 */   // GIR_Coverage, 1238,
     /* 315467 */   GIR_Done,
     /* 315468 */ // Label 6435: @315468
     /* 315468 */ GIM_Reject,
     /* 315469 */ // Label 6425: @315469
     /* 315469 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(315506), // Rule ID 1234 //
     /* 315474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315495 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 315495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 315500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315504 */   GIR_RootConstrainSelectedInstOperands,
     /* 315505 */   // GIR_Coverage, 1234,
     /* 315505 */   GIR_Done,
     /* 315506 */ // Label 6436: @315506
     /* 315506 */ GIM_Reject,
     /* 315507 */ // Label 6426: @315507
     /* 315507 */ GIM_Reject,
     /* 315508 */ // Label 75: @315508
     /* 315508 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6445*/ GIMT_Encode4(315857),
     /* 315519 */ /*GILLT_s16*//*Label 6437*/ GIMT_Encode4(315559),
     /* 315523 */ /*GILLT_s32*//*Label 6438*/ GIMT_Encode4(315597),
     /* 315527 */ /*GILLT_s64*//*Label 6439*/ GIMT_Encode4(315632), GIMT_Encode4(0),
     /* 315535 */ /*GILLT_v2s32*//*Label 6440*/ GIMT_Encode4(315667),
     /* 315539 */ /*GILLT_v2s64*//*Label 6441*/ GIMT_Encode4(315705),
     /* 315543 */ /*GILLT_v4s16*//*Label 6442*/ GIMT_Encode4(315743),
     /* 315547 */ /*GILLT_v4s32*//*Label 6443*/ GIMT_Encode4(315781), GIMT_Encode4(0),
     /* 315555 */ /*GILLT_v8s16*//*Label 6444*/ GIMT_Encode4(315819),
     /* 315559 */ // Label 6437: @315559
     /* 315559 */ GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(315596), // Rule ID 4772 //
     /* 315564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 315567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 315570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 315573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315585 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 315585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 315590 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315594 */   GIR_RootConstrainSelectedInstOperands,
     /* 315595 */   // GIR_Coverage, 4772,
     /* 315595 */   GIR_Done,
     /* 315596 */ // Label 6446: @315596
     /* 315596 */ GIM_Reject,
     /* 315597 */ // Label 6438: @315597
     /* 315597 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(315631), // Rule ID 4769 //
     /* 315602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315620 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 315620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 315625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315629 */   GIR_RootConstrainSelectedInstOperands,
     /* 315630 */   // GIR_Coverage, 4769,
     /* 315630 */   GIR_Done,
     /* 315631 */ // Label 6447: @315631
     /* 315631 */ GIM_Reject,
     /* 315632 */ // Label 6439: @315632
     /* 315632 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(315666), // Rule ID 4766 //
     /* 315637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315655 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 315655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 315660 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315664 */   GIR_RootConstrainSelectedInstOperands,
     /* 315665 */   // GIR_Coverage, 4766,
     /* 315665 */   GIR_Done,
     /* 315666 */ // Label 6448: @315666
     /* 315666 */ GIM_Reject,
     /* 315667 */ // Label 6440: @315667
     /* 315667 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(315704), // Rule ID 4960 //
     /* 315672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 315681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315693 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 315693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 315698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315702 */   GIR_RootConstrainSelectedInstOperands,
     /* 315703 */   // GIR_Coverage, 4960,
     /* 315703 */   GIR_Done,
     /* 315704 */ // Label 6449: @315704
     /* 315704 */ GIM_Reject,
     /* 315705 */ // Label 6441: @315705
     /* 315705 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(315742), // Rule ID 4954 //
     /* 315710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 315719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315731 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 315731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 315736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315740 */   GIR_RootConstrainSelectedInstOperands,
     /* 315741 */   // GIR_Coverage, 4954,
     /* 315741 */   GIR_Done,
     /* 315742 */ // Label 6450: @315742
     /* 315742 */ GIM_Reject,
     /* 315743 */ // Label 6442: @315743
     /* 315743 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(315780), // Rule ID 4966 //
     /* 315748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315769 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 315769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 315774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315778 */   GIR_RootConstrainSelectedInstOperands,
     /* 315779 */   // GIR_Coverage, 4966,
     /* 315779 */   GIR_Done,
     /* 315780 */ // Label 6451: @315780
     /* 315780 */ GIM_Reject,
     /* 315781 */ // Label 6443: @315781
     /* 315781 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(315818), // Rule ID 4957 //
     /* 315786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315807 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 315807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 315812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315816 */   GIR_RootConstrainSelectedInstOperands,
     /* 315817 */   // GIR_Coverage, 4957,
     /* 315817 */   GIR_Done,
     /* 315818 */ // Label 6452: @315818
     /* 315818 */ GIM_Reject,
     /* 315819 */ // Label 6444: @315819
     /* 315819 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(315856), // Rule ID 4963 //
     /* 315824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315845 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 315845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 315850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315854 */   GIR_RootConstrainSelectedInstOperands,
     /* 315855 */   // GIR_Coverage, 4963,
     /* 315855 */   GIR_Done,
     /* 315856 */ // Label 6453: @315856
     /* 315856 */ GIM_Reject,
     /* 315857 */ // Label 6445: @315857
     /* 315857 */ GIM_Reject,
     /* 315858 */ // Label 76: @315858
     /* 315858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6462*/ GIMT_Encode4(316207),
     /* 315869 */ /*GILLT_s16*//*Label 6454*/ GIMT_Encode4(315909),
     /* 315873 */ /*GILLT_s32*//*Label 6455*/ GIMT_Encode4(315947),
     /* 315877 */ /*GILLT_s64*//*Label 6456*/ GIMT_Encode4(315982), GIMT_Encode4(0),
     /* 315885 */ /*GILLT_v2s32*//*Label 6457*/ GIMT_Encode4(316017),
     /* 315889 */ /*GILLT_v2s64*//*Label 6458*/ GIMT_Encode4(316055),
     /* 315893 */ /*GILLT_v4s16*//*Label 6459*/ GIMT_Encode4(316093),
     /* 315897 */ /*GILLT_v4s32*//*Label 6460*/ GIMT_Encode4(316131), GIMT_Encode4(0),
     /* 315905 */ /*GILLT_v8s16*//*Label 6461*/ GIMT_Encode4(316169),
     /* 315909 */ // Label 6454: @315909
     /* 315909 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(315946), // Rule ID 4773 //
     /* 315914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 315917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 315920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 315923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315935 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 315935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 315940 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315944 */   GIR_RootConstrainSelectedInstOperands,
     /* 315945 */   // GIR_Coverage, 4773,
     /* 315945 */   GIR_Done,
     /* 315946 */ // Label 6463: @315946
     /* 315946 */ GIM_Reject,
     /* 315947 */ // Label 6455: @315947
     /* 315947 */ GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(315981), // Rule ID 4770 //
     /* 315952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315970 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 315970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 315975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315979 */   GIR_RootConstrainSelectedInstOperands,
     /* 315980 */   // GIR_Coverage, 4770,
     /* 315980 */   GIR_Done,
     /* 315981 */ // Label 6464: @315981
     /* 315981 */ GIM_Reject,
     /* 315982 */ // Label 6456: @315982
     /* 315982 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(316016), // Rule ID 4767 //
     /* 315987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316005 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 316005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 316010 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316014 */   GIR_RootConstrainSelectedInstOperands,
     /* 316015 */   // GIR_Coverage, 4767,
     /* 316015 */   GIR_Done,
     /* 316016 */ // Label 6465: @316016
     /* 316016 */ GIM_Reject,
     /* 316017 */ // Label 6457: @316017
     /* 316017 */ GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(316054), // Rule ID 4961 //
     /* 316022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 316031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316043 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 316043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 316048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316052 */   GIR_RootConstrainSelectedInstOperands,
     /* 316053 */   // GIR_Coverage, 4961,
     /* 316053 */   GIR_Done,
     /* 316054 */ // Label 6466: @316054
     /* 316054 */ GIM_Reject,
     /* 316055 */ // Label 6458: @316055
     /* 316055 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(316092), // Rule ID 4955 //
     /* 316060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 316069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316081 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 316081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 316086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316090 */   GIR_RootConstrainSelectedInstOperands,
     /* 316091 */   // GIR_Coverage, 4955,
     /* 316091 */   GIR_Done,
     /* 316092 */ // Label 6467: @316092
     /* 316092 */ GIM_Reject,
     /* 316093 */ // Label 6459: @316093
     /* 316093 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(316130), // Rule ID 4967 //
     /* 316098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 316107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316119 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 316119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 316124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316128 */   GIR_RootConstrainSelectedInstOperands,
     /* 316129 */   // GIR_Coverage, 4967,
     /* 316129 */   GIR_Done,
     /* 316130 */ // Label 6468: @316130
     /* 316130 */ GIM_Reject,
     /* 316131 */ // Label 6460: @316131
     /* 316131 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(316168), // Rule ID 4958 //
     /* 316136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316157 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 316157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 316162 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316166 */   GIR_RootConstrainSelectedInstOperands,
     /* 316167 */   // GIR_Coverage, 4958,
     /* 316167 */   GIR_Done,
     /* 316168 */ // Label 6469: @316168
     /* 316168 */ GIM_Reject,
     /* 316169 */ // Label 6461: @316169
     /* 316169 */ GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(316206), // Rule ID 4964 //
     /* 316174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 316183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316195 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 316195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 316200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316204 */   GIR_RootConstrainSelectedInstOperands,
     /* 316205 */   // GIR_Coverage, 4964,
     /* 316205 */   GIR_Done,
     /* 316206 */ // Label 6470: @316206
     /* 316206 */ GIM_Reject,
     /* 316207 */ // Label 6462: @316207
     /* 316207 */ GIM_Reject,
     /* 316208 */ // Label 77: @316208
     /* 316208 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6479*/ GIMT_Encode4(316910),
     /* 316219 */ /*GILLT_s16*//*Label 6471*/ GIMT_Encode4(316259),
     /* 316223 */ /*GILLT_s32*//*Label 6472*/ GIMT_Encode4(316297),
     /* 316227 */ /*GILLT_s64*//*Label 6473*/ GIMT_Encode4(316335), GIMT_Encode4(0),
     /* 316235 */ /*GILLT_v2s32*//*Label 6474*/ GIMT_Encode4(316395),
     /* 316239 */ /*GILLT_v2s64*//*Label 6475*/ GIMT_Encode4(316498),
     /* 316243 */ /*GILLT_v4s16*//*Label 6476*/ GIMT_Encode4(316601),
     /* 316247 */ /*GILLT_v4s32*//*Label 6477*/ GIMT_Encode4(316704), GIMT_Encode4(0),
     /* 316255 */ /*GILLT_v8s16*//*Label 6478*/ GIMT_Encode4(316807),
     /* 316259 */ // Label 6471: @316259
     /* 316259 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(316296), // Rule ID 614 //
     /* 316264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 316267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 316270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 316273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316285 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 316285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 316290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316294 */   GIR_RootConstrainSelectedInstOperands,
     /* 316295 */   // GIR_Coverage, 614,
     /* 316295 */   GIR_Done,
     /* 316296 */ // Label 6480: @316296
     /* 316296 */ GIM_Reject,
     /* 316297 */ // Label 6472: @316297
     /* 316297 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(316334), // Rule ID 616 //
     /* 316302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 316311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316323 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 316323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 316328 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316332 */   GIR_RootConstrainSelectedInstOperands,
     /* 316333 */   // GIR_Coverage, 616,
     /* 316333 */   GIR_Done,
     /* 316334 */ // Label 6481: @316334
     /* 316334 */ GIM_Reject,
     /* 316335 */ // Label 6473: @316335
     /* 316335 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(316394),
     /* 316340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 316346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316358 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(316377), // Rule ID 618 //
     /* 316363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316366 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 316366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 316371 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316375 */     GIR_RootConstrainSelectedInstOperands,
     /* 316376 */     // GIR_Coverage, 618,
     /* 316376 */     GIR_Done,
     /* 316377 */   // Label 6483: @316377
     /* 316377 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(316393), // Rule ID 4763 //
     /* 316382 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 316382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 316387 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316391 */     GIR_RootConstrainSelectedInstOperands,
     /* 316392 */     // GIR_Coverage, 4763,
     /* 316392 */     GIR_Done,
     /* 316393 */   // Label 6484: @316393
     /* 316393 */   GIM_Reject,
     /* 316394 */ // Label 6482: @316394
     /* 316394 */ GIM_Reject,
     /* 316395 */ // Label 6474: @316395
     /* 316395 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(316497),
     /* 316400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 316406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316410 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(316469), // Rule ID 2357 //
     /* 316415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 316418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316454 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 316454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 316457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316467 */     GIR_RootConstrainSelectedInstOperands,
     /* 316468 */     // GIR_Coverage, 2357,
     /* 316468 */     GIR_EraseRootFromParent_Done,
     /* 316469 */   // Label 6486: @316469
     /* 316469 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(316496), // Rule ID 1281 //
     /* 316474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316485 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 316485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 316490 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316494 */     GIR_RootConstrainSelectedInstOperands,
     /* 316495 */     // GIR_Coverage, 1281,
     /* 316495 */     GIR_Done,
     /* 316496 */   // Label 6487: @316496
     /* 316496 */   GIM_Reject,
     /* 316497 */ // Label 6485: @316497
     /* 316497 */ GIM_Reject,
     /* 316498 */ // Label 6475: @316498
     /* 316498 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(316600),
     /* 316503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 316509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316513 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(316572), // Rule ID 2363 //
     /* 316518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 316521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316557 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 316557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 316560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316570 */     GIR_RootConstrainSelectedInstOperands,
     /* 316571 */     // GIR_Coverage, 2363,
     /* 316571 */     GIR_EraseRootFromParent_Done,
     /* 316572 */   // Label 6489: @316572
     /* 316572 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(316599), // Rule ID 1285 //
     /* 316577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316588 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 316588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 316593 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316597 */     GIR_RootConstrainSelectedInstOperands,
     /* 316598 */     // GIR_Coverage, 1285,
     /* 316598 */     GIR_Done,
     /* 316599 */   // Label 6490: @316599
     /* 316599 */   GIM_Reject,
     /* 316600 */ // Label 6488: @316600
     /* 316600 */ GIM_Reject,
     /* 316601 */ // Label 6476: @316601
     /* 316601 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(316703),
     /* 316606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 316612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316616 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(316675), // Rule ID 2351 //
     /* 316621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 316624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316660 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 316660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 316663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316673 */     GIR_RootConstrainSelectedInstOperands,
     /* 316674 */     // GIR_Coverage, 2351,
     /* 316674 */     GIR_EraseRootFromParent_Done,
     /* 316675 */   // Label 6492: @316675
     /* 316675 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(316702), // Rule ID 1277 //
     /* 316680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316691 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 316691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 316696 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316700 */     GIR_RootConstrainSelectedInstOperands,
     /* 316701 */     // GIR_Coverage, 1277,
     /* 316701 */     GIR_Done,
     /* 316702 */   // Label 6493: @316702
     /* 316702 */   GIM_Reject,
     /* 316703 */ // Label 6491: @316703
     /* 316703 */ GIM_Reject,
     /* 316704 */ // Label 6477: @316704
     /* 316704 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(316806),
     /* 316709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316719 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(316778), // Rule ID 2360 //
     /* 316724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 316727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316763 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 316763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 316766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316776 */     GIR_RootConstrainSelectedInstOperands,
     /* 316777 */     // GIR_Coverage, 2360,
     /* 316777 */     GIR_EraseRootFromParent_Done,
     /* 316778 */   // Label 6495: @316778
     /* 316778 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(316805), // Rule ID 1283 //
     /* 316783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316794 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 316794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 316799 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316803 */     GIR_RootConstrainSelectedInstOperands,
     /* 316804 */     // GIR_Coverage, 1283,
     /* 316804 */     GIR_Done,
     /* 316805 */   // Label 6496: @316805
     /* 316805 */   GIM_Reject,
     /* 316806 */ // Label 6494: @316806
     /* 316806 */ GIM_Reject,
     /* 316807 */ // Label 6478: @316807
     /* 316807 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(316909),
     /* 316812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 316818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316822 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(316881), // Rule ID 2354 //
     /* 316827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 316830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 316855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316866 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 316866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 316869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316879 */     GIR_RootConstrainSelectedInstOperands,
     /* 316880 */     // GIR_Coverage, 2354,
     /* 316880 */     GIR_EraseRootFromParent_Done,
     /* 316881 */   // Label 6498: @316881
     /* 316881 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(316908), // Rule ID 1279 //
     /* 316886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316897 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 316897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 316902 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316906 */     GIR_RootConstrainSelectedInstOperands,
     /* 316907 */     // GIR_Coverage, 1279,
     /* 316907 */     GIR_Done,
     /* 316908 */   // Label 6499: @316908
     /* 316908 */   GIM_Reject,
     /* 316909 */ // Label 6497: @316909
     /* 316909 */ GIM_Reject,
     /* 316910 */ // Label 6479: @316910
     /* 316910 */ GIM_Reject,
     /* 316911 */ // Label 78: @316911
     /* 316911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6508*/ GIMT_Encode4(317613),
     /* 316922 */ /*GILLT_s16*//*Label 6500*/ GIMT_Encode4(316962),
     /* 316926 */ /*GILLT_s32*//*Label 6501*/ GIMT_Encode4(317000),
     /* 316930 */ /*GILLT_s64*//*Label 6502*/ GIMT_Encode4(317038), GIMT_Encode4(0),
     /* 316938 */ /*GILLT_v2s32*//*Label 6503*/ GIMT_Encode4(317098),
     /* 316942 */ /*GILLT_v2s64*//*Label 6504*/ GIMT_Encode4(317201),
     /* 316946 */ /*GILLT_v4s16*//*Label 6505*/ GIMT_Encode4(317304),
     /* 316950 */ /*GILLT_v4s32*//*Label 6506*/ GIMT_Encode4(317407), GIMT_Encode4(0),
     /* 316958 */ /*GILLT_v8s16*//*Label 6507*/ GIMT_Encode4(317510),
     /* 316962 */ // Label 6500: @316962
     /* 316962 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(316999), // Rule ID 602 //
     /* 316967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 316970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 316973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 316976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316988 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 316988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 316993 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316997 */   GIR_RootConstrainSelectedInstOperands,
     /* 316998 */   // GIR_Coverage, 602,
     /* 316998 */   GIR_Done,
     /* 316999 */ // Label 6509: @316999
     /* 316999 */ GIM_Reject,
     /* 317000 */ // Label 6501: @317000
     /* 317000 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(317037), // Rule ID 604 //
     /* 317005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 317014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317026 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 317026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 317031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317035 */   GIR_RootConstrainSelectedInstOperands,
     /* 317036 */   // GIR_Coverage, 604,
     /* 317036 */   GIR_Done,
     /* 317037 */ // Label 6510: @317037
     /* 317037 */ GIM_Reject,
     /* 317038 */ // Label 6502: @317038
     /* 317038 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(317097),
     /* 317043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 317049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317061 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(317080), // Rule ID 606 //
     /* 317066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317069 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 317069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 317074 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317078 */     GIR_RootConstrainSelectedInstOperands,
     /* 317079 */     // GIR_Coverage, 606,
     /* 317079 */     GIR_Done,
     /* 317080 */   // Label 6512: @317080
     /* 317080 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(317096), // Rule ID 4762 //
     /* 317085 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 317085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 317090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317094 */     GIR_RootConstrainSelectedInstOperands,
     /* 317095 */     // GIR_Coverage, 4762,
     /* 317095 */     GIR_Done,
     /* 317096 */   // Label 6513: @317096
     /* 317096 */   GIM_Reject,
     /* 317097 */ // Label 6511: @317097
     /* 317097 */ GIM_Reject,
     /* 317098 */ // Label 6503: @317098
     /* 317098 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(317200),
     /* 317103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 317109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317113 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(317172), // Rule ID 2342 //
     /* 317118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 317121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317157 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 317157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 317160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317170 */     GIR_RootConstrainSelectedInstOperands,
     /* 317171 */     // GIR_Coverage, 2342,
     /* 317171 */     GIR_EraseRootFromParent_Done,
     /* 317172 */   // Label 6515: @317172
     /* 317172 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(317199), // Rule ID 1251 //
     /* 317177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317188 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 317188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 317193 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317197 */     GIR_RootConstrainSelectedInstOperands,
     /* 317198 */     // GIR_Coverage, 1251,
     /* 317198 */     GIR_Done,
     /* 317199 */   // Label 6516: @317199
     /* 317199 */   GIM_Reject,
     /* 317200 */ // Label 6514: @317200
     /* 317200 */ GIM_Reject,
     /* 317201 */ // Label 6504: @317201
     /* 317201 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(317303),
     /* 317206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 317212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317216 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(317275), // Rule ID 2348 //
     /* 317221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 317224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317260 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 317260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 317263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317273 */     GIR_RootConstrainSelectedInstOperands,
     /* 317274 */     // GIR_Coverage, 2348,
     /* 317274 */     GIR_EraseRootFromParent_Done,
     /* 317275 */   // Label 6518: @317275
     /* 317275 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(317302), // Rule ID 1255 //
     /* 317280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317291 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 317291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 317296 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317300 */     GIR_RootConstrainSelectedInstOperands,
     /* 317301 */     // GIR_Coverage, 1255,
     /* 317301 */     GIR_Done,
     /* 317302 */   // Label 6519: @317302
     /* 317302 */   GIM_Reject,
     /* 317303 */ // Label 6517: @317303
     /* 317303 */ GIM_Reject,
     /* 317304 */ // Label 6505: @317304
     /* 317304 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(317406),
     /* 317309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 317315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317319 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(317378), // Rule ID 2336 //
     /* 317324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 317327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317363 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 317363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 317366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317376 */     GIR_RootConstrainSelectedInstOperands,
     /* 317377 */     // GIR_Coverage, 2336,
     /* 317377 */     GIR_EraseRootFromParent_Done,
     /* 317378 */   // Label 6521: @317378
     /* 317378 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(317405), // Rule ID 1247 //
     /* 317383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 317386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317394 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 317394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 317399 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317403 */     GIR_RootConstrainSelectedInstOperands,
     /* 317404 */     // GIR_Coverage, 1247,
     /* 317404 */     GIR_Done,
     /* 317405 */   // Label 6522: @317405
     /* 317405 */   GIM_Reject,
     /* 317406 */ // Label 6520: @317406
     /* 317406 */ GIM_Reject,
     /* 317407 */ // Label 6506: @317407
     /* 317407 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(317509),
     /* 317412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 317418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317422 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(317481), // Rule ID 2345 //
     /* 317427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 317430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317466 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 317466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 317469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317479 */     GIR_RootConstrainSelectedInstOperands,
     /* 317480 */     // GIR_Coverage, 2345,
     /* 317480 */     GIR_EraseRootFromParent_Done,
     /* 317481 */   // Label 6524: @317481
     /* 317481 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(317508), // Rule ID 1253 //
     /* 317486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317497 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 317497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 317502 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317506 */     GIR_RootConstrainSelectedInstOperands,
     /* 317507 */     // GIR_Coverage, 1253,
     /* 317507 */     GIR_Done,
     /* 317508 */   // Label 6525: @317508
     /* 317508 */   GIM_Reject,
     /* 317509 */ // Label 6523: @317509
     /* 317509 */ GIM_Reject,
     /* 317510 */ // Label 6507: @317510
     /* 317510 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(317612),
     /* 317515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 317521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317525 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(317584), // Rule ID 2339 //
     /* 317530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 317533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 317558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317569 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 317569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 317572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317582 */     GIR_RootConstrainSelectedInstOperands,
     /* 317583 */     // GIR_Coverage, 2339,
     /* 317583 */     GIR_EraseRootFromParent_Done,
     /* 317584 */   // Label 6527: @317584
     /* 317584 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(317611), // Rule ID 1249 //
     /* 317589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 317592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317600 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 317600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 317605 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317609 */     GIR_RootConstrainSelectedInstOperands,
     /* 317610 */     // GIR_Coverage, 1249,
     /* 317610 */     GIR_Done,
     /* 317611 */   // Label 6528: @317611
     /* 317611 */   GIM_Reject,
     /* 317612 */ // Label 6526: @317612
     /* 317612 */ GIM_Reject,
     /* 317613 */ // Label 6508: @317613
     /* 317613 */ GIM_Reject,
     /* 317614 */ // Label 79: @317614
     /* 317614 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6537*/ GIMT_Encode4(318017),
     /* 317625 */ /*GILLT_s32*//*Label 6529*/ GIMT_Encode4(317665),
     /* 317629 */ /*GILLT_s64*//*Label 6530*/ GIMT_Encode4(317739), GIMT_Encode4(0),
     /* 317637 */ /*GILLT_v2s32*//*Label 6531*/ GIMT_Encode4(317813), GIMT_Encode4(0),
     /* 317645 */ /*GILLT_v4s16*//*Label 6532*/ GIMT_Encode4(317847),
     /* 317649 */ /*GILLT_v4s32*//*Label 6533*/ GIMT_Encode4(317881),
     /* 317653 */ /*GILLT_v8s8*//*Label 6534*/ GIMT_Encode4(317915),
     /* 317657 */ /*GILLT_v8s16*//*Label 6535*/ GIMT_Encode4(317949),
     /* 317661 */ /*GILLT_v16s8*//*Label 6536*/ GIMT_Encode4(317983),
     /* 317665 */ // Label 6529: @317665
     /* 317665 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(317738),
     /* 317670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 317676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317684 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(317718), // Rule ID 2319 //
     /* 317689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 317692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 317704 */     // MIs[1] Operand 1
     /* 317704 */     // No operand predicates
     /* 317704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317706 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 317706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 317709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 317716 */     GIR_RootConstrainSelectedInstOperands,
     /* 317717 */     // GIR_Coverage, 2319,
     /* 317717 */     GIR_EraseRootFromParent_Done,
     /* 317718 */   // Label 6539: @317718
     /* 317718 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(317737), // Rule ID 2318 //
     /* 317723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 317726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317730 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 317730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 317735 */     GIR_RootConstrainSelectedInstOperands,
     /* 317736 */     // GIR_Coverage, 2318,
     /* 317736 */     GIR_Done,
     /* 317737 */   // Label 6540: @317737
     /* 317737 */   GIM_Reject,
     /* 317738 */ // Label 6538: @317738
     /* 317738 */ GIM_Reject,
     /* 317739 */ // Label 6530: @317739
     /* 317739 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(317812),
     /* 317744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 317750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317758 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(317792), // Rule ID 2321 //
     /* 317763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 317766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 317778 */     // MIs[1] Operand 1
     /* 317778 */     // No operand predicates
     /* 317778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317780 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 317780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 317783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 317790 */     GIR_RootConstrainSelectedInstOperands,
     /* 317791 */     // GIR_Coverage, 2321,
     /* 317791 */     GIR_EraseRootFromParent_Done,
     /* 317792 */   // Label 6542: @317792
     /* 317792 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(317811), // Rule ID 2320 //
     /* 317797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 317800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317804 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 317804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 317809 */     GIR_RootConstrainSelectedInstOperands,
     /* 317810 */     // GIR_Coverage, 2320,
     /* 317810 */     GIR_Done,
     /* 317811 */   // Label 6543: @317811
     /* 317811 */   GIM_Reject,
     /* 317812 */ // Label 6541: @317812
     /* 317812 */ GIM_Reject,
     /* 317813 */ // Label 6531: @317813
     /* 317813 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(317846), // Rule ID 1407 //
     /* 317818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 317827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317839 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 317839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 317844 */   GIR_RootConstrainSelectedInstOperands,
     /* 317845 */   // GIR_Coverage, 1407,
     /* 317845 */   GIR_Done,
     /* 317846 */ // Label 6544: @317846
     /* 317846 */ GIM_Reject,
     /* 317847 */ // Label 6532: @317847
     /* 317847 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(317880), // Rule ID 1405 //
     /* 317852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 317861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317873 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 317873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 317878 */   GIR_RootConstrainSelectedInstOperands,
     /* 317879 */   // GIR_Coverage, 1405,
     /* 317879 */   GIR_Done,
     /* 317880 */ // Label 6545: @317880
     /* 317880 */ GIM_Reject,
     /* 317881 */ // Label 6533: @317881
     /* 317881 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(317914), // Rule ID 1408 //
     /* 317886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 317895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317907 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 317907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 317912 */   GIR_RootConstrainSelectedInstOperands,
     /* 317913 */   // GIR_Coverage, 1408,
     /* 317913 */   GIR_Done,
     /* 317914 */ // Label 6546: @317914
     /* 317914 */ GIM_Reject,
     /* 317915 */ // Label 6534: @317915
     /* 317915 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(317948), // Rule ID 1403 //
     /* 317920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 317929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317941 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 317941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 317946 */   GIR_RootConstrainSelectedInstOperands,
     /* 317947 */   // GIR_Coverage, 1403,
     /* 317947 */   GIR_Done,
     /* 317948 */ // Label 6547: @317948
     /* 317948 */ GIM_Reject,
     /* 317949 */ // Label 6535: @317949
     /* 317949 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(317982), // Rule ID 1406 //
     /* 317954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 317963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317975 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 317975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 317980 */   GIR_RootConstrainSelectedInstOperands,
     /* 317981 */   // GIR_Coverage, 1406,
     /* 317981 */   GIR_Done,
     /* 317982 */ // Label 6548: @317982
     /* 317982 */ GIM_Reject,
     /* 317983 */ // Label 6536: @317983
     /* 317983 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(318016), // Rule ID 1404 //
     /* 317988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 317994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 317997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318009 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 318009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 318014 */   GIR_RootConstrainSelectedInstOperands,
     /* 318015 */   // GIR_Coverage, 1404,
     /* 318015 */   GIR_Done,
     /* 318016 */ // Label 6549: @318016
     /* 318016 */ GIM_Reject,
     /* 318017 */ // Label 6537: @318017
     /* 318017 */ GIM_Reject,
     /* 318018 */ // Label 80: @318018
     /* 318018 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6558*/ GIMT_Encode4(318421),
     /* 318029 */ /*GILLT_s32*//*Label 6550*/ GIMT_Encode4(318069),
     /* 318033 */ /*GILLT_s64*//*Label 6551*/ GIMT_Encode4(318143), GIMT_Encode4(0),
     /* 318041 */ /*GILLT_v2s32*//*Label 6552*/ GIMT_Encode4(318217), GIMT_Encode4(0),
     /* 318049 */ /*GILLT_v4s16*//*Label 6553*/ GIMT_Encode4(318251),
     /* 318053 */ /*GILLT_v4s32*//*Label 6554*/ GIMT_Encode4(318285),
     /* 318057 */ /*GILLT_v8s8*//*Label 6555*/ GIMT_Encode4(318319),
     /* 318061 */ /*GILLT_v8s16*//*Label 6556*/ GIMT_Encode4(318353),
     /* 318065 */ /*GILLT_v16s8*//*Label 6557*/ GIMT_Encode4(318387),
     /* 318069 */ // Label 6550: @318069
     /* 318069 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(318142),
     /* 318074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 318080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318088 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(318122), // Rule ID 2315 //
     /* 318093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 318108 */     // MIs[1] Operand 1
     /* 318108 */     // No operand predicates
     /* 318108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318110 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 318110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 318113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 318120 */     GIR_RootConstrainSelectedInstOperands,
     /* 318121 */     // GIR_Coverage, 2315,
     /* 318121 */     GIR_EraseRootFromParent_Done,
     /* 318122 */   // Label 6560: @318122
     /* 318122 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(318141), // Rule ID 2314 //
     /* 318127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318134 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 318134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 318139 */     GIR_RootConstrainSelectedInstOperands,
     /* 318140 */     // GIR_Coverage, 2314,
     /* 318140 */     GIR_Done,
     /* 318141 */   // Label 6561: @318141
     /* 318141 */   GIM_Reject,
     /* 318142 */ // Label 6559: @318142
     /* 318142 */ GIM_Reject,
     /* 318143 */ // Label 6551: @318143
     /* 318143 */ GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(318216),
     /* 318148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 318154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318162 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(318196), // Rule ID 2317 //
     /* 318167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 318182 */     // MIs[1] Operand 1
     /* 318182 */     // No operand predicates
     /* 318182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318184 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 318184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 318187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 318194 */     GIR_RootConstrainSelectedInstOperands,
     /* 318195 */     // GIR_Coverage, 2317,
     /* 318195 */     GIR_EraseRootFromParent_Done,
     /* 318196 */   // Label 6563: @318196
     /* 318196 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(318215), // Rule ID 2316 //
     /* 318201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318208 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 318208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 318213 */     GIR_RootConstrainSelectedInstOperands,
     /* 318214 */     // GIR_Coverage, 2316,
     /* 318214 */     GIR_Done,
     /* 318215 */   // Label 6564: @318215
     /* 318215 */   GIM_Reject,
     /* 318216 */ // Label 6562: @318216
     /* 318216 */ GIM_Reject,
     /* 318217 */ // Label 6552: @318217
     /* 318217 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(318250), // Rule ID 1395 //
     /* 318222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 318231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318243 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 318243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 318248 */   GIR_RootConstrainSelectedInstOperands,
     /* 318249 */   // GIR_Coverage, 1395,
     /* 318249 */   GIR_Done,
     /* 318250 */ // Label 6565: @318250
     /* 318250 */ GIM_Reject,
     /* 318251 */ // Label 6553: @318251
     /* 318251 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(318284), // Rule ID 1393 //
     /* 318256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 318262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 318265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318277 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 318277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 318282 */   GIR_RootConstrainSelectedInstOperands,
     /* 318283 */   // GIR_Coverage, 1393,
     /* 318283 */   GIR_Done,
     /* 318284 */ // Label 6566: @318284
     /* 318284 */ GIM_Reject,
     /* 318285 */ // Label 6554: @318285
     /* 318285 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(318318), // Rule ID 1396 //
     /* 318290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 318299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318311 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 318311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 318316 */   GIR_RootConstrainSelectedInstOperands,
     /* 318317 */   // GIR_Coverage, 1396,
     /* 318317 */   GIR_Done,
     /* 318318 */ // Label 6567: @318318
     /* 318318 */ GIM_Reject,
     /* 318319 */ // Label 6555: @318319
     /* 318319 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(318352), // Rule ID 1391 //
     /* 318324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 318330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 318333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318345 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 318345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 318350 */   GIR_RootConstrainSelectedInstOperands,
     /* 318351 */   // GIR_Coverage, 1391,
     /* 318351 */   GIR_Done,
     /* 318352 */ // Label 6568: @318352
     /* 318352 */ GIM_Reject,
     /* 318353 */ // Label 6556: @318353
     /* 318353 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(318386), // Rule ID 1394 //
     /* 318358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 318367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318379 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 318379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 318384 */   GIR_RootConstrainSelectedInstOperands,
     /* 318385 */   // GIR_Coverage, 1394,
     /* 318385 */   GIR_Done,
     /* 318386 */ // Label 6569: @318386
     /* 318386 */ GIM_Reject,
     /* 318387 */ // Label 6557: @318387
     /* 318387 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(318420), // Rule ID 1392 //
     /* 318392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 318398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 318401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318413 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 318413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 318418 */   GIR_RootConstrainSelectedInstOperands,
     /* 318419 */   // GIR_Coverage, 1392,
     /* 318419 */   GIR_Done,
     /* 318420 */ // Label 6570: @318420
     /* 318420 */ GIM_Reject,
     /* 318421 */ // Label 6558: @318421
     /* 318421 */ GIM_Reject,
     /* 318422 */ // Label 81: @318422
     /* 318422 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6579*/ GIMT_Encode4(318825),
     /* 318433 */ /*GILLT_s32*//*Label 6571*/ GIMT_Encode4(318473),
     /* 318437 */ /*GILLT_s64*//*Label 6572*/ GIMT_Encode4(318547), GIMT_Encode4(0),
     /* 318445 */ /*GILLT_v2s32*//*Label 6573*/ GIMT_Encode4(318621), GIMT_Encode4(0),
     /* 318453 */ /*GILLT_v4s16*//*Label 6574*/ GIMT_Encode4(318655),
     /* 318457 */ /*GILLT_v4s32*//*Label 6575*/ GIMT_Encode4(318689),
     /* 318461 */ /*GILLT_v8s8*//*Label 6576*/ GIMT_Encode4(318723),
     /* 318465 */ /*GILLT_v8s16*//*Label 6577*/ GIMT_Encode4(318757),
     /* 318469 */ /*GILLT_v16s8*//*Label 6578*/ GIMT_Encode4(318791),
     /* 318473 */ // Label 6571: @318473
     /* 318473 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(318546),
     /* 318478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 318484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318492 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(318526), // Rule ID 2327 //
     /* 318497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 318512 */     // MIs[1] Operand 1
     /* 318512 */     // No operand predicates
     /* 318512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318514 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 318514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 318517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 318524 */     GIR_RootConstrainSelectedInstOperands,
     /* 318525 */     // GIR_Coverage, 2327,
     /* 318525 */     GIR_EraseRootFromParent_Done,
     /* 318526 */   // Label 6581: @318526
     /* 318526 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(318545), // Rule ID 2326 //
     /* 318531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318538 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 318538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 318543 */     GIR_RootConstrainSelectedInstOperands,
     /* 318544 */     // GIR_Coverage, 2326,
     /* 318544 */     GIR_Done,
     /* 318545 */   // Label 6582: @318545
     /* 318545 */   GIM_Reject,
     /* 318546 */ // Label 6580: @318546
     /* 318546 */ GIM_Reject,
     /* 318547 */ // Label 6572: @318547
     /* 318547 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(318620),
     /* 318552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 318558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318566 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(318600), // Rule ID 2329 //
     /* 318571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 318586 */     // MIs[1] Operand 1
     /* 318586 */     // No operand predicates
     /* 318586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318588 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 318588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 318591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 318598 */     GIR_RootConstrainSelectedInstOperands,
     /* 318599 */     // GIR_Coverage, 2329,
     /* 318599 */     GIR_EraseRootFromParent_Done,
     /* 318600 */   // Label 6584: @318600
     /* 318600 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(318619), // Rule ID 2328 //
     /* 318605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318612 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 318612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 318617 */     GIR_RootConstrainSelectedInstOperands,
     /* 318618 */     // GIR_Coverage, 2328,
     /* 318618 */     GIR_Done,
     /* 318619 */   // Label 6585: @318619
     /* 318619 */   GIM_Reject,
     /* 318620 */ // Label 6583: @318620
     /* 318620 */ GIM_Reject,
     /* 318621 */ // Label 6573: @318621
     /* 318621 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(318654), // Rule ID 1530 //
     /* 318626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 318635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318647 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 318647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 318652 */   GIR_RootConstrainSelectedInstOperands,
     /* 318653 */   // GIR_Coverage, 1530,
     /* 318653 */   GIR_Done,
     /* 318654 */ // Label 6586: @318654
     /* 318654 */ GIM_Reject,
     /* 318655 */ // Label 6574: @318655
     /* 318655 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(318688), // Rule ID 1528 //
     /* 318660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 318666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 318669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318681 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 318681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 318686 */   GIR_RootConstrainSelectedInstOperands,
     /* 318687 */   // GIR_Coverage, 1528,
     /* 318687 */   GIR_Done,
     /* 318688 */ // Label 6587: @318688
     /* 318688 */ GIM_Reject,
     /* 318689 */ // Label 6575: @318689
     /* 318689 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(318722), // Rule ID 1531 //
     /* 318694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 318703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318715 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 318715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 318720 */   GIR_RootConstrainSelectedInstOperands,
     /* 318721 */   // GIR_Coverage, 1531,
     /* 318721 */   GIR_Done,
     /* 318722 */ // Label 6588: @318722
     /* 318722 */ GIM_Reject,
     /* 318723 */ // Label 6576: @318723
     /* 318723 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(318756), // Rule ID 1526 //
     /* 318728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 318734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 318737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318749 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 318749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 318754 */   GIR_RootConstrainSelectedInstOperands,
     /* 318755 */   // GIR_Coverage, 1526,
     /* 318755 */   GIR_Done,
     /* 318756 */ // Label 6589: @318756
     /* 318756 */ GIM_Reject,
     /* 318757 */ // Label 6577: @318757
     /* 318757 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(318790), // Rule ID 1529 //
     /* 318762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 318771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318783 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 318783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 318788 */   GIR_RootConstrainSelectedInstOperands,
     /* 318789 */   // GIR_Coverage, 1529,
     /* 318789 */   GIR_Done,
     /* 318790 */ // Label 6590: @318790
     /* 318790 */ GIM_Reject,
     /* 318791 */ // Label 6578: @318791
     /* 318791 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(318824), // Rule ID 1527 //
     /* 318796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 318802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 318805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318817 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 318817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 318822 */   GIR_RootConstrainSelectedInstOperands,
     /* 318823 */   // GIR_Coverage, 1527,
     /* 318823 */   GIR_Done,
     /* 318824 */ // Label 6591: @318824
     /* 318824 */ GIM_Reject,
     /* 318825 */ // Label 6579: @318825
     /* 318825 */ GIM_Reject,
     /* 318826 */ // Label 82: @318826
     /* 318826 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6600*/ GIMT_Encode4(319229),
     /* 318837 */ /*GILLT_s32*//*Label 6592*/ GIMT_Encode4(318877),
     /* 318841 */ /*GILLT_s64*//*Label 6593*/ GIMT_Encode4(318951), GIMT_Encode4(0),
     /* 318849 */ /*GILLT_v2s32*//*Label 6594*/ GIMT_Encode4(319025), GIMT_Encode4(0),
     /* 318857 */ /*GILLT_v4s16*//*Label 6595*/ GIMT_Encode4(319059),
     /* 318861 */ /*GILLT_v4s32*//*Label 6596*/ GIMT_Encode4(319093),
     /* 318865 */ /*GILLT_v8s8*//*Label 6597*/ GIMT_Encode4(319127),
     /* 318869 */ /*GILLT_v8s16*//*Label 6598*/ GIMT_Encode4(319161),
     /* 318873 */ /*GILLT_v16s8*//*Label 6599*/ GIMT_Encode4(319195),
     /* 318877 */ // Label 6592: @318877
     /* 318877 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(318950),
     /* 318882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 318888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318896 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(318930), // Rule ID 2323 //
     /* 318901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 318916 */     // MIs[1] Operand 1
     /* 318916 */     // No operand predicates
     /* 318916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318918 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 318918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 318921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 318928 */     GIR_RootConstrainSelectedInstOperands,
     /* 318929 */     // GIR_Coverage, 2323,
     /* 318929 */     GIR_EraseRootFromParent_Done,
     /* 318930 */   // Label 6602: @318930
     /* 318930 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(318949), // Rule ID 2322 //
     /* 318935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318942 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 318942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 318947 */     GIR_RootConstrainSelectedInstOperands,
     /* 318948 */     // GIR_Coverage, 2322,
     /* 318948 */     GIR_Done,
     /* 318949 */   // Label 6603: @318949
     /* 318949 */   GIM_Reject,
     /* 318950 */ // Label 6601: @318950
     /* 318950 */ GIM_Reject,
     /* 318951 */ // Label 6593: @318951
     /* 318951 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(319024),
     /* 318956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 318962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318970 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(319004), // Rule ID 2325 //
     /* 318975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 318978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 318990 */     // MIs[1] Operand 1
     /* 318990 */     // No operand predicates
     /* 318990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318992 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 318992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 318995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 319002 */     GIR_RootConstrainSelectedInstOperands,
     /* 319003 */     // GIR_Coverage, 2325,
     /* 319003 */     GIR_EraseRootFromParent_Done,
     /* 319004 */   // Label 6605: @319004
     /* 319004 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(319023), // Rule ID 2324 //
     /* 319009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 319012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 319016 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 319016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 319021 */     GIR_RootConstrainSelectedInstOperands,
     /* 319022 */     // GIR_Coverage, 2324,
     /* 319022 */     GIR_Done,
     /* 319023 */   // Label 6606: @319023
     /* 319023 */   GIM_Reject,
     /* 319024 */ // Label 6604: @319024
     /* 319024 */ GIM_Reject,
     /* 319025 */ // Label 6594: @319025
     /* 319025 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(319058), // Rule ID 1518 //
     /* 319030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 319039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319051 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 319051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 319056 */   GIR_RootConstrainSelectedInstOperands,
     /* 319057 */   // GIR_Coverage, 1518,
     /* 319057 */   GIR_Done,
     /* 319058 */ // Label 6607: @319058
     /* 319058 */ GIM_Reject,
     /* 319059 */ // Label 6595: @319059
     /* 319059 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(319092), // Rule ID 1516 //
     /* 319064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 319073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319085 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 319085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 319090 */   GIR_RootConstrainSelectedInstOperands,
     /* 319091 */   // GIR_Coverage, 1516,
     /* 319091 */   GIR_Done,
     /* 319092 */ // Label 6608: @319092
     /* 319092 */ GIM_Reject,
     /* 319093 */ // Label 6596: @319093
     /* 319093 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(319126), // Rule ID 1519 //
     /* 319098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 319107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319119 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 319119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 319124 */   GIR_RootConstrainSelectedInstOperands,
     /* 319125 */   // GIR_Coverage, 1519,
     /* 319125 */   GIR_Done,
     /* 319126 */ // Label 6609: @319126
     /* 319126 */ GIM_Reject,
     /* 319127 */ // Label 6597: @319127
     /* 319127 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(319160), // Rule ID 1514 //
     /* 319132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 319138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 319141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319153 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 319153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 319158 */   GIR_RootConstrainSelectedInstOperands,
     /* 319159 */   // GIR_Coverage, 1514,
     /* 319159 */   GIR_Done,
     /* 319160 */ // Label 6610: @319160
     /* 319160 */ GIM_Reject,
     /* 319161 */ // Label 6598: @319161
     /* 319161 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(319194), // Rule ID 1517 //
     /* 319166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 319175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319187 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 319187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 319192 */   GIR_RootConstrainSelectedInstOperands,
     /* 319193 */   // GIR_Coverage, 1517,
     /* 319193 */   GIR_Done,
     /* 319194 */ // Label 6611: @319194
     /* 319194 */ GIM_Reject,
     /* 319195 */ // Label 6599: @319195
     /* 319195 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(319228), // Rule ID 1515 //
     /* 319200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 319206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 319209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319221 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 319221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 319226 */   GIR_RootConstrainSelectedInstOperands,
     /* 319227 */   // GIR_Coverage, 1515,
     /* 319227 */   GIR_Done,
     /* 319228 */ // Label 6612: @319228
     /* 319228 */ GIM_Reject,
     /* 319229 */ // Label 6600: @319229
     /* 319229 */ GIM_Reject,
     /* 319230 */ // Label 83: @319230
     /* 319230 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6622*/ GIMT_Encode4(320044),
     /* 319241 */ /*GILLT_s32*//*Label 6613*/ GIMT_Encode4(319281),
     /* 319245 */ /*GILLT_s64*//*Label 6614*/ GIMT_Encode4(319308), GIMT_Encode4(0),
     /* 319253 */ /*GILLT_v2s32*//*Label 6615*/ GIMT_Encode4(319387),
     /* 319257 */ /*GILLT_v2s64*//*Label 6616*/ GIMT_Encode4(319414),
     /* 319261 */ /*GILLT_v4s16*//*Label 6617*/ GIMT_Encode4(319597),
     /* 319265 */ /*GILLT_v4s32*//*Label 6618*/ GIMT_Encode4(319624),
     /* 319269 */ /*GILLT_v8s8*//*Label 6619*/ GIMT_Encode4(319807),
     /* 319273 */ /*GILLT_v8s16*//*Label 6620*/ GIMT_Encode4(319834),
     /* 319277 */ /*GILLT_v16s8*//*Label 6621*/ GIMT_Encode4(320017),
     /* 319281 */ // Label 6613: @319281
     /* 319281 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(319307), // Rule ID 2308 //
     /* 319286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 319289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 319296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 319300 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 319300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 319305 */   GIR_RootConstrainSelectedInstOperands,
     /* 319306 */   // GIR_Coverage, 2308,
     /* 319306 */   GIR_Done,
     /* 319307 */ // Label 6623: @319307
     /* 319307 */ GIM_Reject,
     /* 319308 */ // Label 6614: @319308
     /* 319308 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(319386),
     /* 319313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319316 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(319339), // Rule ID 1645 //
     /* 319321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319332 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 319332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 319337 */     GIR_RootConstrainSelectedInstOperands,
     /* 319338 */     // GIR_Coverage, 1645,
     /* 319338 */     GIR_Done,
     /* 319339 */   // Label 6625: @319339
     /* 319339 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(319362), // Rule ID 2309 //
     /* 319344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 319347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 319351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 319355 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 319355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 319360 */     GIR_RootConstrainSelectedInstOperands,
     /* 319361 */     // GIR_Coverage, 2309,
     /* 319361 */     GIR_Done,
     /* 319362 */   // Label 6626: @319362
     /* 319362 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(319385), // Rule ID 2505 //
     /* 319367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 319370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319378 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 319378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 319383 */     GIR_RootConstrainSelectedInstOperands,
     /* 319384 */     // GIR_Coverage, 2505,
     /* 319384 */     GIR_Done,
     /* 319385 */   // Label 6627: @319385
     /* 319385 */   GIM_Reject,
     /* 319386 */ // Label 6624: @319386
     /* 319386 */ GIM_Reject,
     /* 319387 */ // Label 6615: @319387
     /* 319387 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(319413), // Rule ID 707 //
     /* 319392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319406 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 319406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 319411 */   GIR_RootConstrainSelectedInstOperands,
     /* 319412 */   // GIR_Coverage, 707,
     /* 319412 */   GIR_Done,
     /* 319413 */ // Label 6628: @319413
     /* 319413 */ GIM_Reject,
     /* 319414 */ // Label 6616: @319414
     /* 319414 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(319596),
     /* 319419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319426 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(319504), // Rule ID 4840 //
     /* 319431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 319439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 319447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319467 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 319480 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 319487 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 319487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 319490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 319497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 319502 */     GIR_RootConstrainSelectedInstOperands,
     /* 319503 */     // GIR_Coverage, 4840,
     /* 319503 */     GIR_EraseRootFromParent_Done,
     /* 319504 */   // Label 6630: @319504
     /* 319504 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(319576), // Rule ID 4839 //
     /* 319509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 319517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 319525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319550 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319554 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319561 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 319561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 319564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 319570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 319574 */     GIR_RootConstrainSelectedInstOperands,
     /* 319575 */     // GIR_Coverage, 4839,
     /* 319575 */     GIR_EraseRootFromParent_Done,
     /* 319576 */   // Label 6631: @319576
     /* 319576 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(319595), // Rule ID 709 //
     /* 319581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319588 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 319588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 319593 */     GIR_RootConstrainSelectedInstOperands,
     /* 319594 */     // GIR_Coverage, 709,
     /* 319594 */     GIR_Done,
     /* 319595 */   // Label 6632: @319595
     /* 319595 */   GIM_Reject,
     /* 319596 */ // Label 6629: @319596
     /* 319596 */ GIM_Reject,
     /* 319597 */ // Label 6617: @319597
     /* 319597 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(319623), // Rule ID 705 //
     /* 319602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319616 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 319616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 319621 */   GIR_RootConstrainSelectedInstOperands,
     /* 319622 */   // GIR_Coverage, 705,
     /* 319622 */   GIR_Done,
     /* 319623 */ // Label 6633: @319623
     /* 319623 */ GIM_Reject,
     /* 319624 */ // Label 6618: @319624
     /* 319624 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(319806),
     /* 319629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319636 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(319714), // Rule ID 4838 //
     /* 319641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 319649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 319657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 319690 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 319697 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 319697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 319700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 319707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 319712 */     GIR_RootConstrainSelectedInstOperands,
     /* 319713 */     // GIR_Coverage, 4838,
     /* 319713 */     GIR_EraseRootFromParent_Done,
     /* 319714 */   // Label 6635: @319714
     /* 319714 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(319786), // Rule ID 4837 //
     /* 319719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 319727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 319735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319764 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319771 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 319771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 319774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 319780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 319784 */     GIR_RootConstrainSelectedInstOperands,
     /* 319785 */     // GIR_Coverage, 4837,
     /* 319785 */     GIR_EraseRootFromParent_Done,
     /* 319786 */   // Label 6636: @319786
     /* 319786 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(319805), // Rule ID 708 //
     /* 319791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319798 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 319798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 319803 */     GIR_RootConstrainSelectedInstOperands,
     /* 319804 */     // GIR_Coverage, 708,
     /* 319804 */     GIR_Done,
     /* 319805 */   // Label 6637: @319805
     /* 319805 */   GIM_Reject,
     /* 319806 */ // Label 6634: @319806
     /* 319806 */ GIM_Reject,
     /* 319807 */ // Label 6619: @319807
     /* 319807 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(319833), // Rule ID 703 //
     /* 319812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 319818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319826 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 319826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 319831 */   GIR_RootConstrainSelectedInstOperands,
     /* 319832 */   // GIR_Coverage, 703,
     /* 319832 */   GIR_Done,
     /* 319833 */ // Label 6638: @319833
     /* 319833 */ GIM_Reject,
     /* 319834 */ // Label 6620: @319834
     /* 319834 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(320016),
     /* 319839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319846 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(319924), // Rule ID 4836 //
     /* 319851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 319859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 319867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 319879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 319891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 319900 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 319907 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 319907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 319910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 319917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 319922 */     GIR_RootConstrainSelectedInstOperands,
     /* 319923 */     // GIR_Coverage, 4836,
     /* 319923 */     GIR_EraseRootFromParent_Done,
     /* 319924 */   // Label 6640: @319924
     /* 319924 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(319996), // Rule ID 4835 //
     /* 319929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 319937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 319945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 319957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 319970 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 319974 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319981 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 319981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 319984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 319990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 319994 */     GIR_RootConstrainSelectedInstOperands,
     /* 319995 */     // GIR_Coverage, 4835,
     /* 319995 */     GIR_EraseRootFromParent_Done,
     /* 319996 */   // Label 6641: @319996
     /* 319996 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(320015), // Rule ID 706 //
     /* 320001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320008 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 320008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 320013 */     GIR_RootConstrainSelectedInstOperands,
     /* 320014 */     // GIR_Coverage, 706,
     /* 320014 */     GIR_Done,
     /* 320015 */   // Label 6642: @320015
     /* 320015 */   GIM_Reject,
     /* 320016 */ // Label 6639: @320016
     /* 320016 */ GIM_Reject,
     /* 320017 */ // Label 6621: @320017
     /* 320017 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(320043), // Rule ID 704 //
     /* 320022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 320028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320036 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 320036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 320041 */   GIR_RootConstrainSelectedInstOperands,
     /* 320042 */   // GIR_Coverage, 704,
     /* 320042 */   GIR_Done,
     /* 320043 */ // Label 6643: @320043
     /* 320043 */ GIM_Reject,
     /* 320044 */ // Label 6622: @320044
     /* 320044 */ GIM_Reject,
     /* 320045 */ // Label 84: @320045
     /* 320045 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6646*/ GIMT_Encode4(320210),
     /* 320056 */ /*GILLT_s32*//*Label 6644*/ GIMT_Encode4(320064),
     /* 320060 */ /*GILLT_s64*//*Label 6645*/ GIMT_Encode4(320137),
     /* 320064 */ // Label 6644: @320064
     /* 320064 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(320090), // Rule ID 4681 //
     /* 320069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320079 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 320079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 320084 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320088 */   GIR_RootConstrainSelectedInstOperands,
     /* 320089 */   // GIR_Coverage, 4681,
     /* 320089 */   GIR_Done,
     /* 320090 */ // Label 6647: @320090
     /* 320090 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(320113), // Rule ID 4687 //
     /* 320095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320102 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 320102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 320107 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320111 */   GIR_RootConstrainSelectedInstOperands,
     /* 320112 */   // GIR_Coverage, 4687,
     /* 320112 */   GIR_Done,
     /* 320113 */ // Label 6648: @320113
     /* 320113 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(320136), // Rule ID 4689 //
     /* 320118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320125 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 320125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 320130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320134 */   GIR_RootConstrainSelectedInstOperands,
     /* 320135 */   // GIR_Coverage, 4689,
     /* 320135 */   GIR_Done,
     /* 320136 */ // Label 6649: @320136
     /* 320136 */ GIM_Reject,
     /* 320137 */ // Label 6645: @320137
     /* 320137 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(320163), // Rule ID 4683 //
     /* 320142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320152 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 320152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 320157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320161 */   GIR_RootConstrainSelectedInstOperands,
     /* 320162 */   // GIR_Coverage, 4683,
     /* 320162 */   GIR_Done,
     /* 320163 */ // Label 6650: @320163
     /* 320163 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(320186), // Rule ID 4691 //
     /* 320168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320175 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 320175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 320180 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320184 */   GIR_RootConstrainSelectedInstOperands,
     /* 320185 */   // GIR_Coverage, 4691,
     /* 320185 */   GIR_Done,
     /* 320186 */ // Label 6651: @320186
     /* 320186 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(320209), // Rule ID 4693 //
     /* 320191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320198 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 320198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 320203 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320207 */   GIR_RootConstrainSelectedInstOperands,
     /* 320208 */   // GIR_Coverage, 4693,
     /* 320208 */   GIR_Done,
     /* 320209 */ // Label 6652: @320209
     /* 320209 */ GIM_Reject,
     /* 320210 */ // Label 6646: @320210
     /* 320210 */ GIM_Reject,
     /* 320211 */ // Label 85: @320211
     /* 320211 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(320309),
     /* 320216 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 320219 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6657*/ GIMT_Encode4(320308),
     /* 320230 */   /*GILLT_s16*//*Label 6654*/ GIMT_Encode4(320242),
     /* 320234 */   /*GILLT_s32*//*Label 6655*/ GIMT_Encode4(320266),
     /* 320238 */   /*GILLT_s64*//*Label 6656*/ GIMT_Encode4(320287),
     /* 320242 */   // Label 6654: @320242
     /* 320242 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(320265), // Rule ID 4685 //
     /* 320247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320254 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 320254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 320259 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320263 */     GIR_RootConstrainSelectedInstOperands,
     /* 320264 */     // GIR_Coverage, 4685,
     /* 320264 */     GIR_Done,
     /* 320265 */   // Label 6658: @320265
     /* 320265 */   GIM_Reject,
     /* 320266 */   // Label 6655: @320266
     /* 320266 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(320286), // Rule ID 4695 //
     /* 320271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320275 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 320275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 320280 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320284 */     GIR_RootConstrainSelectedInstOperands,
     /* 320285 */     // GIR_Coverage, 4695,
     /* 320285 */     GIR_Done,
     /* 320286 */   // Label 6659: @320286
     /* 320286 */   GIM_Reject,
     /* 320287 */   // Label 6656: @320287
     /* 320287 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(320307), // Rule ID 4697 //
     /* 320292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320296 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 320296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 320301 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320305 */     GIR_RootConstrainSelectedInstOperands,
     /* 320306 */     // GIR_Coverage, 4697,
     /* 320306 */     GIR_Done,
     /* 320307 */   // Label 6660: @320307
     /* 320307 */   GIM_Reject,
     /* 320308 */   // Label 6657: @320308
     /* 320308 */   GIM_Reject,
     /* 320309 */ // Label 6653: @320309
     /* 320309 */ GIM_Reject,
     /* 320310 */ // Label 86: @320310
     /* 320310 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(320325), // Rule ID 225 //
     /* 320315 */   // MIs[0] addr
     /* 320315 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 320318 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 320318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 320323 */   GIR_RootConstrainSelectedInstOperands,
     /* 320324 */   // GIR_Coverage, 225,
     /* 320324 */   GIR_Done,
     /* 320325 */ // Label 6661: @320325
     /* 320325 */ GIM_Reject,
     /* 320326 */ // Label 87: @320326
     /* 320326 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6673*/ GIMT_Encode4(325337),
     /* 320337 */ /*GILLT_s64*//*Label 6662*/ GIMT_Encode4(320409), GIMT_Encode4(0),
     /* 320345 */ /*GILLT_v2s32*//*Label 6663*/ GIMT_Encode4(320691), GIMT_Encode4(0),
     /* 320353 */ /*GILLT_v4s16*//*Label 6664*/ GIMT_Encode4(320973), GIMT_Encode4(0),
     /* 320361 */ /*GILLT_v8s8*//*Label 6665*/ GIMT_Encode4(321255), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 320373 */ /*GILLT_nxv1s1*//*Label 6666*/ GIMT_Encode4(321435),
     /* 320377 */ /*GILLT_nxv2s1*//*Label 6667*/ GIMT_Encode4(323698),
     /* 320381 */ /*GILLT_nxv2s16*//*Label 6668*/ GIMT_Encode4(324553),
     /* 320385 */ /*GILLT_nxv2s32*//*Label 6669*/ GIMT_Encode4(324840), GIMT_Encode4(0),
     /* 320393 */ /*GILLT_nxv4s1*//*Label 6670*/ GIMT_Encode4(324910),
     /* 320397 */ /*GILLT_nxv4s16*//*Label 6671*/ GIMT_Encode4(325197), GIMT_Encode4(0),
     /* 320405 */ /*GILLT_nxv8s1*//*Label 6672*/ GIMT_Encode4(325267),
     /* 320409 */ // Label 6662: @320409
     /* 320409 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(320690),
     /* 320414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320425 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(320489), // Rule ID 5406 //
     /* 320430 */     // MIs[0] Operand 2
     /* 320430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 320441 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 320441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 320448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 320464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320471 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 320478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320488 */     // GIR_Coverage, 5406,
     /* 320488 */     GIR_EraseRootFromParent_Done,
     /* 320489 */   // Label 6675: @320489
     /* 320489 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(320553), // Rule ID 5411 //
     /* 320494 */     // MIs[0] Operand 2
     /* 320494 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 320505 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 320505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 320512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320517 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320525 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 320528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 320542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320552 */     // GIR_Coverage, 5411,
     /* 320552 */     GIR_EraseRootFromParent_Done,
     /* 320553 */   // Label 6676: @320553
     /* 320553 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(320591), // Rule ID 6810 //
     /* 320558 */     // MIs[0] Operand 2
     /* 320558 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 320569 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 320569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320574 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320590 */     // GIR_Coverage, 6810,
     /* 320590 */     GIR_EraseRootFromParent_Done,
     /* 320591 */   // Label 6677: @320591
     /* 320591 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(320629), // Rule ID 6811 //
     /* 320596 */     // MIs[0] Operand 2
     /* 320596 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 320607 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 320607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320612 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320628 */     // GIR_Coverage, 6811,
     /* 320628 */     GIR_EraseRootFromParent_Done,
     /* 320629 */   // Label 6678: @320629
     /* 320629 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(320689), // Rule ID 6815 //
     /* 320634 */     // MIs[0] Operand 2
     /* 320634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 320645 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 320645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 320652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320661 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320671 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 320678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320688 */     // GIR_Coverage, 6815,
     /* 320688 */     GIR_EraseRootFromParent_Done,
     /* 320689 */   // Label 6679: @320689
     /* 320689 */   GIM_Reject,
     /* 320690 */ // Label 6674: @320690
     /* 320690 */ GIM_Reject,
     /* 320691 */ // Label 6663: @320691
     /* 320691 */ GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(320972),
     /* 320696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320707 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(320771), // Rule ID 5396 //
     /* 320712 */     // MIs[0] Operand 2
     /* 320712 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 320723 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 320723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 320730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 320746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 320760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320770 */     // GIR_Coverage, 5396,
     /* 320770 */     GIR_EraseRootFromParent_Done,
     /* 320771 */   // Label 6681: @320771
     /* 320771 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(320835), // Rule ID 5401 //
     /* 320776 */     // MIs[0] Operand 2
     /* 320776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 320787 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 320787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 320794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 320810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320817 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 320824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320834 */     // GIR_Coverage, 5401,
     /* 320834 */     GIR_EraseRootFromParent_Done,
     /* 320835 */   // Label 6682: @320835
     /* 320835 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(320873), // Rule ID 6807 //
     /* 320840 */     // MIs[0] Operand 2
     /* 320840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 320851 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 320851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320856 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320872 */     // GIR_Coverage, 6807,
     /* 320872 */     GIR_EraseRootFromParent_Done,
     /* 320873 */   // Label 6683: @320873
     /* 320873 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(320911), // Rule ID 6809 //
     /* 320878 */     // MIs[0] Operand 2
     /* 320878 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 320889 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 320889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320894 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320910 */     // GIR_Coverage, 6809,
     /* 320910 */     GIR_EraseRootFromParent_Done,
     /* 320911 */   // Label 6684: @320911
     /* 320911 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(320971), // Rule ID 6814 //
     /* 320916 */     // MIs[0] Operand 2
     /* 320916 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 320927 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 320927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 320934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 320943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 320960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320970 */     // GIR_Coverage, 6814,
     /* 320970 */     GIR_EraseRootFromParent_Done,
     /* 320971 */   // Label 6685: @320971
     /* 320971 */   GIM_Reject,
     /* 320972 */ // Label 6680: @320972
     /* 320972 */ GIM_Reject,
     /* 320973 */ // Label 6664: @320973
     /* 320973 */ GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(321254),
     /* 320978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320989 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(321053), // Rule ID 5386 //
     /* 320994 */     // MIs[0] Operand 2
     /* 320994 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321005 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 321005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 321012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321025 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 321028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321035 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 321042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321052 */     // GIR_Coverage, 5386,
     /* 321052 */     GIR_EraseRootFromParent_Done,
     /* 321053 */   // Label 6687: @321053
     /* 321053 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(321117), // Rule ID 5391 //
     /* 321058 */     // MIs[0] Operand 2
     /* 321058 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321069 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 321069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 321076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321081 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 321092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321099 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 321106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321116 */     // GIR_Coverage, 5391,
     /* 321116 */     GIR_EraseRootFromParent_Done,
     /* 321117 */   // Label 6688: @321117
     /* 321117 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(321155), // Rule ID 6805 //
     /* 321122 */     // MIs[0] Operand 2
     /* 321122 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321133 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 321133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321138 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 321144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321154 */     // GIR_Coverage, 6805,
     /* 321154 */     GIR_EraseRootFromParent_Done,
     /* 321155 */   // Label 6689: @321155
     /* 321155 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(321193), // Rule ID 6808 //
     /* 321160 */     // MIs[0] Operand 2
     /* 321160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321171 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 321171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321176 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 321182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321192 */     // GIR_Coverage, 6808,
     /* 321192 */     GIR_EraseRootFromParent_Done,
     /* 321193 */   // Label 6690: @321193
     /* 321193 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(321253), // Rule ID 6813 //
     /* 321198 */     // MIs[0] Operand 2
     /* 321198 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 321209 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 321209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 321216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321225 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 321228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321235 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 321242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321252 */     // GIR_Coverage, 6813,
     /* 321252 */     GIR_EraseRootFromParent_Done,
     /* 321253 */   // Label 6691: @321253
     /* 321253 */   GIM_Reject,
     /* 321254 */ // Label 6686: @321254
     /* 321254 */ GIM_Reject,
     /* 321255 */ // Label 6665: @321255
     /* 321255 */ GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(321434),
     /* 321260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 321263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321271 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(321335), // Rule ID 5381 //
     /* 321276 */     // MIs[0] Operand 2
     /* 321276 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 321287 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 321287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 321294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 321310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 321324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321334 */     // GIR_Coverage, 5381,
     /* 321334 */     GIR_EraseRootFromParent_Done,
     /* 321335 */   // Label 6693: @321335
     /* 321335 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(321373), // Rule ID 6806 //
     /* 321340 */     // MIs[0] Operand 2
     /* 321340 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321351 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 321351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321356 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 321362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321372 */     // GIR_Coverage, 6806,
     /* 321372 */     GIR_EraseRootFromParent_Done,
     /* 321373 */   // Label 6694: @321373
     /* 321373 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(321433), // Rule ID 6812 //
     /* 321378 */     // MIs[0] Operand 2
     /* 321378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 321389 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 321389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 321396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 321408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321415 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 321422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321432 */     // GIR_Coverage, 6812,
     /* 321432 */     GIR_EraseRootFromParent_Done,
     /* 321433 */   // Label 6695: @321433
     /* 321433 */   GIM_Reject,
     /* 321434 */ // Label 6692: @321434
     /* 321434 */ GIM_Reject,
     /* 321435 */ // Label 6666: @321435
     /* 321435 */ GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(321470), // Rule ID 8868 //
     /* 321440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 321446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321450 */   // MIs[0] Operand 2
     /* 321450 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321461 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 321461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321466 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 321468 */   GIR_RootConstrainSelectedInstOperands,
     /* 321469 */   // GIR_Coverage, 8868,
     /* 321469 */   GIR_EraseRootFromParent_Done,
     /* 321470 */ // Label 6696: @321470
     /* 321470 */ GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(321505), // Rule ID 8869 //
     /* 321475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 321481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321485 */   // MIs[0] Operand 2
     /* 321485 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 321496 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 321496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321501 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 321503 */   GIR_RootConstrainSelectedInstOperands,
     /* 321504 */   // GIR_Coverage, 8869,
     /* 321504 */   GIR_EraseRootFromParent_Done,
     /* 321505 */ // Label 6697: @321505
     /* 321505 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(321559), // Rule ID 8876 //
     /* 321510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 321516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321520 */   // MIs[0] Operand 2
     /* 321520 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321531 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 321531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321543 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321557 */   GIR_RootConstrainSelectedInstOperands,
     /* 321558 */   // GIR_Coverage, 8876,
     /* 321558 */   GIR_EraseRootFromParent_Done,
     /* 321559 */ // Label 6698: @321559
     /* 321559 */ GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(321613), // Rule ID 8877 //
     /* 321564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 321570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321574 */   // MIs[0] Operand 2
     /* 321574 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 321585 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 321585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321597 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321611 */   GIR_RootConstrainSelectedInstOperands,
     /* 321612 */   // GIR_Coverage, 8877,
     /* 321612 */   GIR_EraseRootFromParent_Done,
     /* 321613 */ // Label 6699: @321613
     /* 321613 */ GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(321667), // Rule ID 8878 //
     /* 321618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 321624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321628 */   // MIs[0] Operand 2
     /* 321628 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321639 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 321639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321651 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321665 */   GIR_RootConstrainSelectedInstOperands,
     /* 321666 */   // GIR_Coverage, 8878,
     /* 321666 */   GIR_EraseRootFromParent_Done,
     /* 321667 */ // Label 6700: @321667
     /* 321667 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(321721), // Rule ID 8879 //
     /* 321672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 321678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321682 */   // MIs[0] Operand 2
     /* 321682 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 321693 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 321693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321705 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321719 */   GIR_RootConstrainSelectedInstOperands,
     /* 321720 */   // GIR_Coverage, 8879,
     /* 321720 */   GIR_EraseRootFromParent_Done,
     /* 321721 */ // Label 6701: @321721
     /* 321721 */ GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(321792), // Rule ID 8888 //
     /* 321726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321736 */   // MIs[0] Operand 2
     /* 321736 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321747 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 321747 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321750 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321754 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321759 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321777 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321790 */   GIR_RootConstrainSelectedInstOperands,
     /* 321791 */   // GIR_Coverage, 8888,
     /* 321791 */   GIR_EraseRootFromParent_Done,
     /* 321792 */ // Label 6702: @321792
     /* 321792 */ GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(321863), // Rule ID 8889 //
     /* 321797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321807 */   // MIs[0] Operand 2
     /* 321807 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 321818 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 321818 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321821 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321825 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321830 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321848 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321861 */   GIR_RootConstrainSelectedInstOperands,
     /* 321862 */   // GIR_Coverage, 8889,
     /* 321862 */   GIR_EraseRootFromParent_Done,
     /* 321863 */ // Label 6703: @321863
     /* 321863 */ GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(321934), // Rule ID 8890 //
     /* 321868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321878 */   // MIs[0] Operand 2
     /* 321878 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321889 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 321889 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321892 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321896 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321901 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321919 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321932 */   GIR_RootConstrainSelectedInstOperands,
     /* 321933 */   // GIR_Coverage, 8890,
     /* 321933 */   GIR_EraseRootFromParent_Done,
     /* 321934 */ // Label 6704: @321934
     /* 321934 */ GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(322005), // Rule ID 8891 //
     /* 321939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321949 */   // MIs[0] Operand 2
     /* 321949 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 321960 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 321960 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321963 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321967 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321972 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321990 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322003 */   GIR_RootConstrainSelectedInstOperands,
     /* 322004 */   // GIR_Coverage, 8891,
     /* 322004 */   GIR_EraseRootFromParent_Done,
     /* 322005 */ // Label 6705: @322005
     /* 322005 */ GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(322076), // Rule ID 8892 //
     /* 322010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322020 */   // MIs[0] Operand 2
     /* 322020 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322031 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 322031 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322034 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322038 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322043 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322061 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322074 */   GIR_RootConstrainSelectedInstOperands,
     /* 322075 */   // GIR_Coverage, 8892,
     /* 322075 */   GIR_EraseRootFromParent_Done,
     /* 322076 */ // Label 6706: @322076
     /* 322076 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(322147), // Rule ID 8893 //
     /* 322081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322091 */   // MIs[0] Operand 2
     /* 322091 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 322102 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 322102 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322105 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322109 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322114 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322132 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322145 */   GIR_RootConstrainSelectedInstOperands,
     /* 322146 */   // GIR_Coverage, 8893,
     /* 322146 */   GIR_EraseRootFromParent_Done,
     /* 322147 */ // Label 6707: @322147
     /* 322147 */ GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(322218), // Rule ID 8894 //
     /* 322152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322162 */   // MIs[0] Operand 2
     /* 322162 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 322173 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 322173 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322176 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322180 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322185 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322203 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322216 */   GIR_RootConstrainSelectedInstOperands,
     /* 322217 */   // GIR_Coverage, 8894,
     /* 322217 */   GIR_EraseRootFromParent_Done,
     /* 322218 */ // Label 6708: @322218
     /* 322218 */ GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(322289), // Rule ID 8895 //
     /* 322223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322233 */   // MIs[0] Operand 2
     /* 322233 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 322244 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 322244 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322247 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322251 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322256 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322274 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322287 */   GIR_RootConstrainSelectedInstOperands,
     /* 322288 */   // GIR_Coverage, 8895,
     /* 322288 */   GIR_EraseRootFromParent_Done,
     /* 322289 */ // Label 6709: @322289
     /* 322289 */ GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(322377), // Rule ID 8904 //
     /* 322294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322304 */   // MIs[0] Operand 2
     /* 322304 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322315 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 322315 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 322318 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322322 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322327 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322333 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322336 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322340 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322345 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322362 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322375 */   GIR_RootConstrainSelectedInstOperands,
     /* 322376 */   // GIR_Coverage, 8904,
     /* 322376 */   GIR_EraseRootFromParent_Done,
     /* 322377 */ // Label 6710: @322377
     /* 322377 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(322465), // Rule ID 8905 //
     /* 322382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322392 */   // MIs[0] Operand 2
     /* 322392 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 322403 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 322403 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 322406 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322410 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322415 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322421 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322424 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322428 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322433 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322450 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322463 */   GIR_RootConstrainSelectedInstOperands,
     /* 322464 */   // GIR_Coverage, 8905,
     /* 322464 */   GIR_EraseRootFromParent_Done,
     /* 322465 */ // Label 6711: @322465
     /* 322465 */ GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(322553), // Rule ID 8906 //
     /* 322470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322480 */   // MIs[0] Operand 2
     /* 322480 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 322491 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 322491 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 322494 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322498 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322503 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322509 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322512 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322516 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322521 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322538 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322548 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322551 */   GIR_RootConstrainSelectedInstOperands,
     /* 322552 */   // GIR_Coverage, 8906,
     /* 322552 */   GIR_EraseRootFromParent_Done,
     /* 322553 */ // Label 6712: @322553
     /* 322553 */ GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(322641), // Rule ID 8907 //
     /* 322558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322568 */   // MIs[0] Operand 2
     /* 322568 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 322579 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 322579 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 322582 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322586 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322591 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322597 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322600 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322604 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322609 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322626 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322639 */   GIR_RootConstrainSelectedInstOperands,
     /* 322640 */   // GIR_Coverage, 8907,
     /* 322640 */   GIR_EraseRootFromParent_Done,
     /* 322641 */ // Label 6713: @322641
     /* 322641 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(322729), // Rule ID 8908 //
     /* 322646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322656 */   // MIs[0] Operand 2
     /* 322656 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322667 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 322667 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 322670 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322674 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322679 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322685 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322688 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322692 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322697 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322714 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322727 */   GIR_RootConstrainSelectedInstOperands,
     /* 322728 */   // GIR_Coverage, 8908,
     /* 322728 */   GIR_EraseRootFromParent_Done,
     /* 322729 */ // Label 6714: @322729
     /* 322729 */ GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(322817), // Rule ID 8909 //
     /* 322734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322744 */   // MIs[0] Operand 2
     /* 322744 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 322755 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 322755 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 322758 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322762 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322767 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322773 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322776 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322780 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322785 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322802 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322815 */   GIR_RootConstrainSelectedInstOperands,
     /* 322816 */   // GIR_Coverage, 8909,
     /* 322816 */   GIR_EraseRootFromParent_Done,
     /* 322817 */ // Label 6715: @322817
     /* 322817 */ GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(322905), // Rule ID 8910 //
     /* 322822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322832 */   // MIs[0] Operand 2
     /* 322832 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 322843 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 322843 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 322846 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322850 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322855 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322861 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322864 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322868 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322873 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322890 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322903 */   GIR_RootConstrainSelectedInstOperands,
     /* 322904 */   // GIR_Coverage, 8910,
     /* 322904 */   GIR_EraseRootFromParent_Done,
     /* 322905 */ // Label 6716: @322905
     /* 322905 */ GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(322993), // Rule ID 8911 //
     /* 322910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322920 */   // MIs[0] Operand 2
     /* 322920 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 322931 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 322931 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 322934 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322938 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322943 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 322949 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322952 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322956 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322961 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322978 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322991 */   GIR_RootConstrainSelectedInstOperands,
     /* 322992 */   // GIR_Coverage, 8911,
     /* 322992 */   GIR_EraseRootFromParent_Done,
     /* 322993 */ // Label 6717: @322993
     /* 322993 */ GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(323081), // Rule ID 8912 //
     /* 322998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323008 */   // MIs[0] Operand 2
     /* 323008 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 323019 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 323019 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 323022 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323026 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323031 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323037 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 323040 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323044 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323049 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323066 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323079 */   GIR_RootConstrainSelectedInstOperands,
     /* 323080 */   // GIR_Coverage, 8912,
     /* 323080 */   GIR_EraseRootFromParent_Done,
     /* 323081 */ // Label 6718: @323081
     /* 323081 */ GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(323169), // Rule ID 8913 //
     /* 323086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323096 */   // MIs[0] Operand 2
     /* 323096 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 323107 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 323107 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 323110 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323114 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323119 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323125 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 323128 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323132 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323137 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323142 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323145 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323149 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323154 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323164 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323167 */   GIR_RootConstrainSelectedInstOperands,
     /* 323168 */   // GIR_Coverage, 8913,
     /* 323168 */   GIR_EraseRootFromParent_Done,
     /* 323169 */ // Label 6719: @323169
     /* 323169 */ GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(323257), // Rule ID 8914 //
     /* 323174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323184 */   // MIs[0] Operand 2
     /* 323184 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 323195 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 323195 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 323198 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323202 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323207 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323213 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 323216 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323220 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323225 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323242 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323255 */   GIR_RootConstrainSelectedInstOperands,
     /* 323256 */   // GIR_Coverage, 8914,
     /* 323256 */   GIR_EraseRootFromParent_Done,
     /* 323257 */ // Label 6720: @323257
     /* 323257 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(323345), // Rule ID 8915 //
     /* 323262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323272 */   // MIs[0] Operand 2
     /* 323272 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 323283 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 323283 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 323286 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323290 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323295 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323301 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 323304 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323308 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323313 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323330 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323343 */   GIR_RootConstrainSelectedInstOperands,
     /* 323344 */   // GIR_Coverage, 8915,
     /* 323344 */   GIR_EraseRootFromParent_Done,
     /* 323345 */ // Label 6721: @323345
     /* 323345 */ GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(323433), // Rule ID 8916 //
     /* 323350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323360 */   // MIs[0] Operand 2
     /* 323360 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 323371 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 323371 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 323374 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323378 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323383 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323389 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 323392 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323396 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323401 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323418 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323431 */   GIR_RootConstrainSelectedInstOperands,
     /* 323432 */   // GIR_Coverage, 8916,
     /* 323432 */   GIR_EraseRootFromParent_Done,
     /* 323433 */ // Label 6722: @323433
     /* 323433 */ GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(323521), // Rule ID 8917 //
     /* 323438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323448 */   // MIs[0] Operand 2
     /* 323448 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 323459 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 323459 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 323462 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323466 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323471 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323477 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 323480 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323484 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323489 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323506 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323519 */   GIR_RootConstrainSelectedInstOperands,
     /* 323520 */   // GIR_Coverage, 8917,
     /* 323520 */   GIR_EraseRootFromParent_Done,
     /* 323521 */ // Label 6723: @323521
     /* 323521 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(323609), // Rule ID 8918 //
     /* 323526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323536 */   // MIs[0] Operand 2
     /* 323536 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 323547 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 323547 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 323550 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323554 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323559 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 323568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323577 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323594 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323607 */   GIR_RootConstrainSelectedInstOperands,
     /* 323608 */   // GIR_Coverage, 8918,
     /* 323608 */   GIR_EraseRootFromParent_Done,
     /* 323609 */ // Label 6724: @323609
     /* 323609 */ GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(323697), // Rule ID 8919 //
     /* 323614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323624 */   // MIs[0] Operand 2
     /* 323624 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 323635 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 323635 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 323638 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323642 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323647 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 323653 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 323656 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323660 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323665 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323673 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323677 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323682 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323695 */   GIR_RootConstrainSelectedInstOperands,
     /* 323696 */   // GIR_Coverage, 8919,
     /* 323696 */   GIR_EraseRootFromParent_Done,
     /* 323697 */ // Label 6725: @323697
     /* 323697 */ GIM_Reject,
     /* 323698 */ // Label 6667: @323698
     /* 323698 */ GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(323733), // Rule ID 8870 //
     /* 323703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 323709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323713 */   // MIs[0] Operand 2
     /* 323713 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 323724 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 323724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323729 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 323731 */   GIR_RootConstrainSelectedInstOperands,
     /* 323732 */   // GIR_Coverage, 8870,
     /* 323732 */   GIR_EraseRootFromParent_Done,
     /* 323733 */ // Label 6726: @323733
     /* 323733 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(323768), // Rule ID 8871 //
     /* 323738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 323744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323748 */   // MIs[0] Operand 2
     /* 323748 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 323759 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 323759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323764 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 323766 */   GIR_RootConstrainSelectedInstOperands,
     /* 323767 */   // GIR_Coverage, 8871,
     /* 323767 */   GIR_EraseRootFromParent_Done,
     /* 323768 */ // Label 6727: @323768
     /* 323768 */ GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(323822), // Rule ID 8880 //
     /* 323773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 323779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323783 */   // MIs[0] Operand 2
     /* 323783 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 323794 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 323794 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323797 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323801 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323806 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323820 */   GIR_RootConstrainSelectedInstOperands,
     /* 323821 */   // GIR_Coverage, 8880,
     /* 323821 */   GIR_EraseRootFromParent_Done,
     /* 323822 */ // Label 6728: @323822
     /* 323822 */ GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(323876), // Rule ID 8881 //
     /* 323827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 323833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323837 */   // MIs[0] Operand 2
     /* 323837 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 323848 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 323848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323860 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323874 */   GIR_RootConstrainSelectedInstOperands,
     /* 323875 */   // GIR_Coverage, 8881,
     /* 323875 */   GIR_EraseRootFromParent_Done,
     /* 323876 */ // Label 6729: @323876
     /* 323876 */ GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(323930), // Rule ID 8882 //
     /* 323881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 323887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323891 */   // MIs[0] Operand 2
     /* 323891 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 323902 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 323902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323914 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 323923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323928 */   GIR_RootConstrainSelectedInstOperands,
     /* 323929 */   // GIR_Coverage, 8882,
     /* 323929 */   GIR_EraseRootFromParent_Done,
     /* 323930 */ // Label 6730: @323930
     /* 323930 */ GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(323984), // Rule ID 8883 //
     /* 323935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 323941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323945 */   // MIs[0] Operand 2
     /* 323945 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 323956 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 323956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 323959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323968 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 323972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 323977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 323979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323982 */   GIR_RootConstrainSelectedInstOperands,
     /* 323983 */   // GIR_Coverage, 8883,
     /* 323983 */   GIR_EraseRootFromParent_Done,
     /* 323984 */ // Label 6731: @323984
     /* 323984 */ GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(324055), // Rule ID 8896 //
     /* 323989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 323992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 323995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 323999 */   // MIs[0] Operand 2
     /* 323999 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324010 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 324010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 324013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324022 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 324026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 324031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324040 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324053 */   GIR_RootConstrainSelectedInstOperands,
     /* 324054 */   // GIR_Coverage, 8896,
     /* 324054 */   GIR_EraseRootFromParent_Done,
     /* 324055 */ // Label 6732: @324055
     /* 324055 */ GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(324126), // Rule ID 8897 //
     /* 324060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 324066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324070 */   // MIs[0] Operand 2
     /* 324070 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 324081 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 324081 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 324084 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324088 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324093 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 324097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 324102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324111 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324124 */   GIR_RootConstrainSelectedInstOperands,
     /* 324125 */   // GIR_Coverage, 8897,
     /* 324125 */   GIR_EraseRootFromParent_Done,
     /* 324126 */ // Label 6733: @324126
     /* 324126 */ GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(324197), // Rule ID 8898 //
     /* 324131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 324137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324141 */   // MIs[0] Operand 2
     /* 324141 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 324152 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 324152 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 324155 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324159 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324164 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 324168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 324173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324182 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324195 */   GIR_RootConstrainSelectedInstOperands,
     /* 324196 */   // GIR_Coverage, 8898,
     /* 324196 */   GIR_EraseRootFromParent_Done,
     /* 324197 */ // Label 6734: @324197
     /* 324197 */ GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(324268), // Rule ID 8899 //
     /* 324202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 324208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324212 */   // MIs[0] Operand 2
     /* 324212 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 324223 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 324223 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 324226 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324230 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324235 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 324239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 324244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324253 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324266 */   GIR_RootConstrainSelectedInstOperands,
     /* 324267 */   // GIR_Coverage, 8899,
     /* 324267 */   GIR_EraseRootFromParent_Done,
     /* 324268 */ // Label 6735: @324268
     /* 324268 */ GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(324339), // Rule ID 8900 //
     /* 324273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 324279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324283 */   // MIs[0] Operand 2
     /* 324283 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 324294 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 324294 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 324297 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324301 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324306 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 324310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 324315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324324 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324337 */   GIR_RootConstrainSelectedInstOperands,
     /* 324338 */   // GIR_Coverage, 8900,
     /* 324338 */   GIR_EraseRootFromParent_Done,
     /* 324339 */ // Label 6736: @324339
     /* 324339 */ GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(324410), // Rule ID 8901 //
     /* 324344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 324350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324354 */   // MIs[0] Operand 2
     /* 324354 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 324365 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 324365 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 324368 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324372 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324377 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 324381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 324386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324395 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324408 */   GIR_RootConstrainSelectedInstOperands,
     /* 324409 */   // GIR_Coverage, 8901,
     /* 324409 */   GIR_EraseRootFromParent_Done,
     /* 324410 */ // Label 6737: @324410
     /* 324410 */ GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(324481), // Rule ID 8902 //
     /* 324415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 324421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324425 */   // MIs[0] Operand 2
     /* 324425 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 324436 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 324436 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 324439 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324443 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324448 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 324452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 324457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324466 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324479 */   GIR_RootConstrainSelectedInstOperands,
     /* 324480 */   // GIR_Coverage, 8902,
     /* 324480 */   GIR_EraseRootFromParent_Done,
     /* 324481 */ // Label 6738: @324481
     /* 324481 */ GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(324552), // Rule ID 8903 //
     /* 324486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 324492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324496 */   // MIs[0] Operand 2
     /* 324496 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 324507 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 324507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 324510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324519 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 324523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 324528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324550 */   GIR_RootConstrainSelectedInstOperands,
     /* 324551 */   // GIR_Coverage, 8903,
     /* 324551 */   GIR_EraseRootFromParent_Done,
     /* 324552 */ // Label 6739: @324552
     /* 324552 */ GIM_Reject,
     /* 324553 */ // Label 6668: @324553
     /* 324553 */ GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(324588), // Rule ID 8920 //
     /* 324558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 324564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 324568 */   // MIs[0] Operand 2
     /* 324568 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324579 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 324579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 324582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 324584 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 324586 */   GIR_RootConstrainSelectedInstOperands,
     /* 324587 */   // GIR_Coverage, 8920,
     /* 324587 */   GIR_EraseRootFromParent_Done,
     /* 324588 */ // Label 6740: @324588
     /* 324588 */ GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(324623), // Rule ID 8921 //
     /* 324593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 324599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 324603 */   // MIs[0] Operand 2
     /* 324603 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 324614 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 324614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 324617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 324619 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 324621 */   GIR_RootConstrainSelectedInstOperands,
     /* 324622 */   // GIR_Coverage, 8921,
     /* 324622 */   GIR_EraseRootFromParent_Done,
     /* 324623 */ // Label 6741: @324623
     /* 324623 */ GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(324677), // Rule ID 8926 //
     /* 324628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 324634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 324638 */   // MIs[0] Operand 2
     /* 324638 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324649 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 324649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 324652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 324656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324661 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 324665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 324670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 324672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324675 */   GIR_RootConstrainSelectedInstOperands,
     /* 324676 */   // GIR_Coverage, 8926,
     /* 324676 */   GIR_EraseRootFromParent_Done,
     /* 324677 */ // Label 6742: @324677
     /* 324677 */ GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(324731), // Rule ID 8927 //
     /* 324682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 324688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 324692 */   // MIs[0] Operand 2
     /* 324692 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 324703 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 324703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 324706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 324710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 324719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 324724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 324726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324729 */   GIR_RootConstrainSelectedInstOperands,
     /* 324730 */   // GIR_Coverage, 8927,
     /* 324730 */   GIR_EraseRootFromParent_Done,
     /* 324731 */ // Label 6743: @324731
     /* 324731 */ GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(324785), // Rule ID 8928 //
     /* 324736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 324742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 324746 */   // MIs[0] Operand 2
     /* 324746 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 324757 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 324757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 324760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 324764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324769 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 324773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 324778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 324780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324783 */   GIR_RootConstrainSelectedInstOperands,
     /* 324784 */   // GIR_Coverage, 8928,
     /* 324784 */   GIR_EraseRootFromParent_Done,
     /* 324785 */ // Label 6744: @324785
     /* 324785 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(324839), // Rule ID 8929 //
     /* 324790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 324796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 324800 */   // MIs[0] Operand 2
     /* 324800 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 324811 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 324811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 324814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 324818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 324827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 324832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 324834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324837 */   GIR_RootConstrainSelectedInstOperands,
     /* 324838 */   // GIR_Coverage, 8929,
     /* 324838 */   GIR_EraseRootFromParent_Done,
     /* 324839 */ // Label 6745: @324839
     /* 324839 */ GIM_Reject,
     /* 324840 */ // Label 6669: @324840
     /* 324840 */ GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(324909),
     /* 324845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 324848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 324852 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(324880), // Rule ID 8924 //
     /* 324857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324860 */     // MIs[0] Operand 2
     /* 324860 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324871 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 324871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 324874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 324876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 324878 */     GIR_RootConstrainSelectedInstOperands,
     /* 324879 */     // GIR_Coverage, 8924,
     /* 324879 */     GIR_EraseRootFromParent_Done,
     /* 324880 */   // Label 6747: @324880
     /* 324880 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(324908), // Rule ID 8925 //
     /* 324885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324888 */     // MIs[0] Operand 2
     /* 324888 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 324899 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 324899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 324902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 324904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 324906 */     GIR_RootConstrainSelectedInstOperands,
     /* 324907 */     // GIR_Coverage, 8925,
     /* 324907 */     GIR_EraseRootFromParent_Done,
     /* 324908 */   // Label 6748: @324908
     /* 324908 */   GIM_Reject,
     /* 324909 */ // Label 6746: @324909
     /* 324909 */ GIM_Reject,
     /* 324910 */ // Label 6670: @324910
     /* 324910 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(324945), // Rule ID 8872 //
     /* 324915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 324921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324925 */   // MIs[0] Operand 2
     /* 324925 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324936 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 324936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 324939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324941 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 324943 */   GIR_RootConstrainSelectedInstOperands,
     /* 324944 */   // GIR_Coverage, 8872,
     /* 324944 */   GIR_EraseRootFromParent_Done,
     /* 324945 */ // Label 6749: @324945
     /* 324945 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(324980), // Rule ID 8873 //
     /* 324950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 324956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324960 */   // MIs[0] Operand 2
     /* 324960 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 324971 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 324971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 324974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 324976 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 324978 */   GIR_RootConstrainSelectedInstOperands,
     /* 324979 */   // GIR_Coverage, 8873,
     /* 324979 */   GIR_EraseRootFromParent_Done,
     /* 324980 */ // Label 6750: @324980
     /* 324980 */ GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(325034), // Rule ID 8884 //
     /* 324985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 324988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 324991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 324995 */   // MIs[0] Operand 2
     /* 324995 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325006 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 325006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 325009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325018 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 325022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325032 */   GIR_RootConstrainSelectedInstOperands,
     /* 325033 */   // GIR_Coverage, 8884,
     /* 325033 */   GIR_EraseRootFromParent_Done,
     /* 325034 */ // Label 6751: @325034
     /* 325034 */ GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(325088), // Rule ID 8885 //
     /* 325039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 325045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325049 */   // MIs[0] Operand 2
     /* 325049 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 325060 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 325060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 325063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325072 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 325076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325086 */   GIR_RootConstrainSelectedInstOperands,
     /* 325087 */   // GIR_Coverage, 8885,
     /* 325087 */   GIR_EraseRootFromParent_Done,
     /* 325088 */ // Label 6752: @325088
     /* 325088 */ GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(325142), // Rule ID 8886 //
     /* 325093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 325099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325103 */   // MIs[0] Operand 2
     /* 325103 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 325114 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 325114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 325117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325126 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 325130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325140 */   GIR_RootConstrainSelectedInstOperands,
     /* 325141 */   // GIR_Coverage, 8886,
     /* 325141 */   GIR_EraseRootFromParent_Done,
     /* 325142 */ // Label 6753: @325142
     /* 325142 */ GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(325196), // Rule ID 8887 //
     /* 325147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 325153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325157 */   // MIs[0] Operand 2
     /* 325157 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 325168 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 325168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 325171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325180 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 325184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325194 */   GIR_RootConstrainSelectedInstOperands,
     /* 325195 */   // GIR_Coverage, 8887,
     /* 325195 */   GIR_EraseRootFromParent_Done,
     /* 325196 */ // Label 6754: @325196
     /* 325196 */ GIM_Reject,
     /* 325197 */ // Label 6671: @325197
     /* 325197 */ GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(325266),
     /* 325202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 325205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 325209 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(325237), // Rule ID 8922 //
     /* 325214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325217 */     // MIs[0] Operand 2
     /* 325217 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325228 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 325228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 325231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 325233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 325235 */     GIR_RootConstrainSelectedInstOperands,
     /* 325236 */     // GIR_Coverage, 8922,
     /* 325236 */     GIR_EraseRootFromParent_Done,
     /* 325237 */   // Label 6756: @325237
     /* 325237 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(325265), // Rule ID 8923 //
     /* 325242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325245 */     // MIs[0] Operand 2
     /* 325245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 325256 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 325256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 325259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 325261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 325263 */     GIR_RootConstrainSelectedInstOperands,
     /* 325264 */     // GIR_Coverage, 8923,
     /* 325264 */     GIR_EraseRootFromParent_Done,
     /* 325265 */   // Label 6757: @325265
     /* 325265 */   GIM_Reject,
     /* 325266 */ // Label 6755: @325266
     /* 325266 */ GIM_Reject,
     /* 325267 */ // Label 6672: @325267
     /* 325267 */ GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(325336),
     /* 325272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 325275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325279 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(325307), // Rule ID 8874 //
     /* 325284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325287 */     // MIs[0] Operand 2
     /* 325287 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325298 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 325298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 325305 */     GIR_RootConstrainSelectedInstOperands,
     /* 325306 */     // GIR_Coverage, 8874,
     /* 325306 */     GIR_EraseRootFromParent_Done,
     /* 325307 */   // Label 6759: @325307
     /* 325307 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(325335), // Rule ID 8875 //
     /* 325312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325315 */     // MIs[0] Operand 2
     /* 325315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 325326 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 325326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 325333 */     GIR_RootConstrainSelectedInstOperands,
     /* 325334 */     // GIR_Coverage, 8875,
     /* 325334 */     GIR_EraseRootFromParent_Done,
     /* 325335 */   // Label 6760: @325335
     /* 325335 */   GIM_Reject,
     /* 325336 */ // Label 6758: @325336
     /* 325336 */ GIM_Reject,
     /* 325337 */ // Label 6673: @325337
     /* 325337 */ GIM_Reject,
     /* 325338 */ // Label 88: @325338
     /* 325338 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6776*/ GIMT_Encode4(352734),
     /* 325349 */ /*GILLT_s64*//*Label 6761*/ GIMT_Encode4(325433), GIMT_Encode4(0),
     /* 325357 */ /*GILLT_v2s32*//*Label 6762*/ GIMT_Encode4(326143),
     /* 325361 */ /*GILLT_v2s64*//*Label 6763*/ GIMT_Encode4(329674),
     /* 325365 */ /*GILLT_v4s16*//*Label 6764*/ GIMT_Encode4(332503),
     /* 325369 */ /*GILLT_v4s32*//*Label 6765*/ GIMT_Encode4(336143),
     /* 325373 */ /*GILLT_v8s8*//*Label 6766*/ GIMT_Encode4(338807),
     /* 325377 */ /*GILLT_v8s16*//*Label 6767*/ GIMT_Encode4(340651),
     /* 325381 */ /*GILLT_v16s8*//*Label 6768*/ GIMT_Encode4(343626), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 325393 */ /*GILLT_nxv2s16*//*Label 6769*/ GIMT_Encode4(345206),
     /* 325397 */ /*GILLT_nxv2s32*//*Label 6770*/ GIMT_Encode4(345331),
     /* 325401 */ /*GILLT_nxv2s64*//*Label 6771*/ GIMT_Encode4(345456), GIMT_Encode4(0),
     /* 325409 */ /*GILLT_nxv4s16*//*Label 6772*/ GIMT_Encode4(347370),
     /* 325413 */ /*GILLT_nxv4s32*//*Label 6773*/ GIMT_Encode4(347522), GIMT_Encode4(0),
     /* 325421 */ /*GILLT_nxv8s16*//*Label 6774*/ GIMT_Encode4(349490), GIMT_Encode4(0),
     /* 325429 */ /*GILLT_nxv16s8*//*Label 6775*/ GIMT_Encode4(351684),
     /* 325433 */ // Label 6761: @325433
     /* 325433 */ GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(326142),
     /* 325438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 325447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325451 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(325581), // Rule ID 5669 //
     /* 325456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325489 */     // MIs[2] Operand 1
     /* 325489 */     // No operand predicates
     /* 325489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325497 */     // MIs[3] Operand 1
     /* 325497 */     // No operand predicates
     /* 325497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325499 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325511 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325514 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325518 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 325538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325563 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325580 */     // GIR_Coverage, 5669,
     /* 325580 */     GIR_EraseRootFromParent_Done,
     /* 325581 */   // Label 6778: @325581
     /* 325581 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(325742), // Rule ID 5670 //
     /* 325586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 325602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325619 */     // MIs[2] Operand 1
     /* 325619 */     // No operand predicates
     /* 325619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325627 */     // MIs[3] Operand 1
     /* 325627 */     // No operand predicates
     /* 325627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325629 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325629 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 325632 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325636 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325641 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 325644 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325648 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 325651 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325656 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325673 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325676 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325680 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 325700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 325714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325724 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325741 */     // GIR_Coverage, 5670,
     /* 325741 */     GIR_EraseRootFromParent_Done,
     /* 325742 */   // Label 6779: @325742
     /* 325742 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(325872), // Rule ID 5693 //
     /* 325747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325780 */     // MIs[2] Operand 1
     /* 325780 */     // No operand predicates
     /* 325780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325788 */     // MIs[3] Operand 1
     /* 325788 */     // No operand predicates
     /* 325788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325790 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325802 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 325829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325834 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325854 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325871 */     // GIR_Coverage, 5693,
     /* 325871 */     GIR_EraseRootFromParent_Done,
     /* 325872 */   // Label 6780: @325872
     /* 325872 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(326033), // Rule ID 5694 //
     /* 325877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 325893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325910 */     // MIs[2] Operand 1
     /* 325910 */     // No operand predicates
     /* 325910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325918 */     // MIs[3] Operand 1
     /* 325918 */     // No operand predicates
     /* 325918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325920 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325920 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 325923 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325927 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325932 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 325935 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325939 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 325942 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325947 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325964 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325971 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 325991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325996 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 326002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 326005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 326008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326015 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326032 */     // GIR_Coverage, 5694,
     /* 326032 */     GIR_EraseRootFromParent_Done,
     /* 326033 */   // Label 6781: @326033
     /* 326033 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(326069), // Rule ID 6586 //
     /* 326038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326056 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 326056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 326063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326068 */     // GIR_Coverage, 6586,
     /* 326068 */     GIR_EraseRootFromParent_Done,
     /* 326069 */   // Label 6782: @326069
     /* 326069 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(326105), // Rule ID 6588 //
     /* 326074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326092 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 326092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 326099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326104 */     // GIR_Coverage, 6588,
     /* 326104 */     GIR_EraseRootFromParent_Done,
     /* 326105 */   // Label 6783: @326105
     /* 326105 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(326141), // Rule ID 6590 //
     /* 326110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326128 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 326128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326131 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 326133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 326135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326140 */     // GIR_Coverage, 6590,
     /* 326140 */     GIR_EraseRootFromParent_Done,
     /* 326141 */   // Label 6784: @326141
     /* 326141 */   GIM_Reject,
     /* 326142 */ // Label 6777: @326142
     /* 326142 */ GIM_Reject,
     /* 326143 */ // Label 6762: @326143
     /* 326143 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(329673),
     /* 326148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 326157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326161 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(326270), // Rule ID 4225 //
     /* 326166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326170 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 326176 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 326178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326186 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326193 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 326210 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 326210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 326217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326237 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326269 */     // GIR_Coverage, 4225,
     /* 326269 */     GIR_EraseRootFromParent_Done,
     /* 326270 */   // Label 6786: @326270
     /* 326270 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(326379), // Rule ID 4226 //
     /* 326275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326279 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 326285 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 326287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326295 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326302 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 326319 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 326319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 326326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326346 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326378 */     // GIR_Coverage, 4226,
     /* 326378 */     GIR_EraseRootFromParent_Done,
     /* 326379 */   // Label 6787: @326379
     /* 326379 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(326488), // Rule ID 4333 //
     /* 326384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326388 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 326394 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 326396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326404 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326411 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 326428 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 326428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 326435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326487 */     // GIR_Coverage, 4333,
     /* 326487 */     GIR_EraseRootFromParent_Done,
     /* 326488 */   // Label 6788: @326488
     /* 326488 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(326597), // Rule ID 4334 //
     /* 326493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326497 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 326503 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 326505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326513 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326520 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 326537 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 326537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 326544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326564 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326596 */     // GIR_Coverage, 4334,
     /* 326596 */     GIR_EraseRootFromParent_Done,
     /* 326597 */   // Label 6789: @326597
     /* 326597 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(326702), // Rule ID 4231 //
     /* 326602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326618 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326621 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326625 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 326642 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 326642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 326649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326669 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326701 */     // GIR_Coverage, 4231,
     /* 326701 */     GIR_EraseRootFromParent_Done,
     /* 326702 */   // Label 6790: @326702
     /* 326702 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(326807), // Rule ID 4233 //
     /* 326707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326723 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326730 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 326747 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 326747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 326754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326806 */     // GIR_Coverage, 4233,
     /* 326806 */     GIR_EraseRootFromParent_Done,
     /* 326807 */   // Label 6791: @326807
     /* 326807 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(326912), // Rule ID 4339 //
     /* 326812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326828 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326835 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 326852 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 326852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 326859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326879 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326911 */     // GIR_Coverage, 4339,
     /* 326911 */     GIR_EraseRootFromParent_Done,
     /* 326912 */   // Label 6792: @326912
     /* 326912 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(327017), // Rule ID 4341 //
     /* 326917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326933 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326940 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 326957 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 326957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 326964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326984 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327016 */     // GIR_Coverage, 4341,
     /* 327016 */     GIR_EraseRootFromParent_Done,
     /* 327017 */   // Label 6793: @327017
     /* 327017 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(327121), // Rule ID 4223 //
     /* 327022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327026 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327032 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327042 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327049 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 327066 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 327066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 327073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327088 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327120 */     // GIR_Coverage, 4223,
     /* 327120 */     GIR_EraseRootFromParent_Done,
     /* 327121 */   // Label 6794: @327121
     /* 327121 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(327225), // Rule ID 4224 //
     /* 327126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327146 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327153 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 327170 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 327170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 327177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327192 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327224 */     // GIR_Coverage, 4224,
     /* 327224 */     GIR_EraseRootFromParent_Done,
     /* 327225 */   // Label 6795: @327225
     /* 327225 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(327329), // Rule ID 4331 //
     /* 327230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327234 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327240 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327250 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327257 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 327274 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 327274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 327281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327296 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327328 */     // GIR_Coverage, 4331,
     /* 327328 */     GIR_EraseRootFromParent_Done,
     /* 327329 */   // Label 6796: @327329
     /* 327329 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(327433), // Rule ID 4332 //
     /* 327334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327338 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327344 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327354 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327361 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 327378 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 327378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 327385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327400 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327432 */     // GIR_Coverage, 4332,
     /* 327432 */     GIR_EraseRootFromParent_Done,
     /* 327433 */   // Label 6797: @327433
     /* 327433 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(327533), // Rule ID 4227 //
     /* 327438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327454 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327461 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 327478 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 327478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 327485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327500 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327532 */     // GIR_Coverage, 4227,
     /* 327532 */     GIR_EraseRootFromParent_Done,
     /* 327533 */   // Label 6798: @327533
     /* 327533 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(327633), // Rule ID 4229 //
     /* 327538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327554 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327561 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 327578 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 327578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 327585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327632 */     // GIR_Coverage, 4229,
     /* 327632 */     GIR_EraseRootFromParent_Done,
     /* 327633 */   // Label 6799: @327633
     /* 327633 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(327733), // Rule ID 4335 //
     /* 327638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327654 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327661 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 327678 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 327678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 327685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327700 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327732 */     // GIR_Coverage, 4335,
     /* 327732 */     GIR_EraseRootFromParent_Done,
     /* 327733 */   // Label 6800: @327733
     /* 327733 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(327833), // Rule ID 4337 //
     /* 327738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327754 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327761 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 327778 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 327778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 327785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327800 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 327822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327832 */     // GIR_Coverage, 4337,
     /* 327832 */     GIR_EraseRootFromParent_Done,
     /* 327833 */   // Label 6801: @327833
     /* 327833 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(327953), // Rule ID 6365 //
     /* 327838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327857 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327860 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327864 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 327871 */     // MIs[2] Rn
     /* 327871 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 327875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 327880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327886 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 327886 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 327889 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 327893 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 327903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 327907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327912 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327915 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 327918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 327922 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 327942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327952 */     // GIR_Coverage, 6365,
     /* 327952 */     GIR_EraseRootFromParent_Done,
     /* 327953 */   // Label 6802: @327953
     /* 327953 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(328073), // Rule ID 6367 //
     /* 327958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327977 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327980 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327984 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 327991 */     // MIs[2] Rn
     /* 327991 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 327995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 328000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328006 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 328006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 328009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 328013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 328027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 328038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 328042 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328055 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328072 */     // GIR_Coverage, 6367,
     /* 328072 */     GIR_EraseRootFromParent_Done,
     /* 328073 */   // Label 6803: @328073
     /* 328073 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(328203), // Rule ID 5663 //
     /* 328078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328111 */     // MIs[2] Operand 1
     /* 328111 */     // No operand predicates
     /* 328111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328119 */     // MIs[3] Operand 1
     /* 328119 */     // No operand predicates
     /* 328119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328121 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 328121 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 328124 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328128 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328133 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 328136 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 328140 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 328143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 328160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328165 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 328171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 328178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328185 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328202 */     // GIR_Coverage, 5663,
     /* 328202 */     GIR_EraseRootFromParent_Done,
     /* 328203 */   // Label 6804: @328203
     /* 328203 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(328364), // Rule ID 5664 //
     /* 328208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328241 */     // MIs[2] Operand 1
     /* 328241 */     // No operand predicates
     /* 328241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328249 */     // MIs[3] Operand 1
     /* 328249 */     // No operand predicates
     /* 328249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328251 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 328251 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 328254 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328258 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328263 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 328266 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328270 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 328273 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328278 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 328286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328295 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 328298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 328302 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 328305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328310 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 328322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328327 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 328333 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 328336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 328339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328346 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328363 */     // GIR_Coverage, 5664,
     /* 328363 */     GIR_EraseRootFromParent_Done,
     /* 328364 */   // Label 6805: @328364
     /* 328364 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(328494), // Rule ID 5687 //
     /* 328369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328402 */     // MIs[2] Operand 1
     /* 328402 */     // No operand predicates
     /* 328402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328410 */     // MIs[3] Operand 1
     /* 328410 */     // No operand predicates
     /* 328410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328412 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 328412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 328415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328424 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 328427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 328431 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 328434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 328451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328456 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 328462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 328469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328476 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328493 */     // GIR_Coverage, 5687,
     /* 328493 */     GIR_EraseRootFromParent_Done,
     /* 328494 */   // Label 6806: @328494
     /* 328494 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(328655), // Rule ID 5688 //
     /* 328499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328532 */     // MIs[2] Operand 1
     /* 328532 */     // No operand predicates
     /* 328532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328540 */     // MIs[3] Operand 1
     /* 328540 */     // No operand predicates
     /* 328540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328542 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 328542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 328545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328554 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 328557 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328561 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 328564 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328569 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328574 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 328577 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328581 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328586 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 328589 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 328593 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 328596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 328613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 328624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 328627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 328630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328637 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328654 */     // GIR_Coverage, 5688,
     /* 328654 */     GIR_EraseRootFromParent_Done,
     /* 328655 */   // Label 6807: @328655
     /* 328655 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(328721), // Rule ID 5618 //
     /* 328660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328678 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 328678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 328681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 328685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 328695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 328702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 328705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328720 */     // GIR_Coverage, 5618,
     /* 328720 */     GIR_EraseRootFromParent_Done,
     /* 328721 */   // Label 6808: @328721
     /* 328721 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(328787), // Rule ID 5630 //
     /* 328726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328744 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 328744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 328747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 328751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 328761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 328768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 328771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328786 */     // GIR_Coverage, 5630,
     /* 328786 */     GIR_EraseRootFromParent_Done,
     /* 328787 */   // Label 6809: @328787
     /* 328787 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(328922), // Rule ID 5638 //
     /* 328792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 328804 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 328808 */     // MIs[1] Operand 1
     /* 328808 */     // No operand predicates
     /* 328808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 328812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 328820 */     // MIs[2] Operand 1
     /* 328820 */     // No operand predicates
     /* 328820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328822 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328822 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 328825 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 328829 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 328836 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 328839 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 328843 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328848 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 328851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328855 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 328858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 328880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 328891 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 328897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328904 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328921 */     // GIR_Coverage, 5638,
     /* 328921 */     GIR_EraseRootFromParent_Done,
     /* 328922 */   // Label 6810: @328922
     /* 328922 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(329054), // Rule ID 6373 //
     /* 328927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 328946 */     // MIs[1] Rn
     /* 328946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 328950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 328955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 328959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328963 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 328967 */     // MIs[2] Operand 1
     /* 328967 */     // No operand predicates
     /* 328967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328969 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 328969 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 328972 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328976 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328981 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 328984 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 328988 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 328991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 329008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329013 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 329019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329023 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329036 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329053 */     // GIR_Coverage, 6373,
     /* 329053 */     GIR_EraseRootFromParent_Done,
     /* 329054 */   // Label 6811: @329054
     /* 329054 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(329186), // Rule ID 6374 //
     /* 329059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 329078 */     // MIs[1] Rn
     /* 329078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 329099 */     // MIs[2] Operand 1
     /* 329099 */     // No operand predicates
     /* 329099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329101 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 329101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 329104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329113 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 329116 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 329120 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 329123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 329140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 329151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329155 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329168 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329185 */     // GIR_Coverage, 6374,
     /* 329185 */     GIR_EraseRootFromParent_Done,
     /* 329186 */   // Label 6812: @329186
     /* 329186 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(329369), // Rule ID 5696 //
     /* 329191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 329199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329216 */     // MIs[2] Operand 1
     /* 329216 */     // No operand predicates
     /* 329216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329218 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329218 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 329221 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329225 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 329232 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 329235 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329239 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329244 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 329247 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 329251 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 329254 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329259 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329264 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329269 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 329272 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329276 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 329283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 329286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329295 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 329298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 329302 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 329305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329310 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 329327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 329338 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 329341 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 329344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329351 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329368 */     // GIR_Coverage, 5696,
     /* 329368 */     GIR_EraseRootFromParent_Done,
     /* 329369 */   // Label 6813: @329369
     /* 329369 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(329547), // Rule ID 5641 //
     /* 329374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 329386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 329394 */     // MIs[1] Operand 1
     /* 329394 */     // No operand predicates
     /* 329394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329396 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329396 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 329399 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329403 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 329410 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 329413 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329417 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329422 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 329425 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 329429 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 329432 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329437 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329442 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329447 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 329450 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329454 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 329461 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 329464 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329468 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329473 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 329476 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329480 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 329483 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 329505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329510 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 329516 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 329519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 329522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329546 */     // GIR_Coverage, 5641,
     /* 329546 */     GIR_EraseRootFromParent_Done,
     /* 329547 */   // Label 6814: @329547
     /* 329547 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(329672), // Rule ID 5644 //
     /* 329552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 329564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 329572 */     // MIs[1] Operand 1
     /* 329572 */     // No operand predicates
     /* 329572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329574 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 329574 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 329577 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329581 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 329588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 329591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329600 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 329603 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329607 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 329610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329620 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 329632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329637 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 329643 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 329647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329654 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329671 */     // GIR_Coverage, 5644,
     /* 329671 */     GIR_EraseRootFromParent_Done,
     /* 329672 */   // Label 6815: @329672
     /* 329672 */   GIM_Reject,
     /* 329673 */ // Label 6785: @329673
     /* 329673 */ GIM_Reject,
     /* 329674 */ // Label 6763: @329674
     /* 329674 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(332502),
     /* 329679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 329685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329692 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(329801), // Rule ID 4249 //
     /* 329697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329701 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329707 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329717 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329724 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 329741 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 329741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 329748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329768 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 329790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329800 */     // GIR_Coverage, 4249,
     /* 329800 */     GIR_EraseRootFromParent_Done,
     /* 329801 */   // Label 6817: @329801
     /* 329801 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(329910), // Rule ID 4250 //
     /* 329806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329810 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329816 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329826 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329833 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 329850 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 329850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 329857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329877 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 329899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329909 */     // GIR_Coverage, 4250,
     /* 329909 */     GIR_EraseRootFromParent_Done,
     /* 329910 */   // Label 6818: @329910
     /* 329910 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(330019), // Rule ID 4357 //
     /* 329915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329919 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329925 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329935 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329942 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 329959 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 329959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 329966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329986 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330018 */     // GIR_Coverage, 4357,
     /* 330018 */     GIR_EraseRootFromParent_Done,
     /* 330019 */   // Label 6819: @330019
     /* 330019 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(330128), // Rule ID 4358 //
     /* 330024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330028 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330044 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330051 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 330068 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 330068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 330075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330095 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330127 */     // GIR_Coverage, 4358,
     /* 330127 */     GIR_EraseRootFromParent_Done,
     /* 330128 */   // Label 6820: @330128
     /* 330128 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(330233), // Rule ID 4255 //
     /* 330133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330149 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330156 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 330173 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 330173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 330180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330200 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330232 */     // GIR_Coverage, 4255,
     /* 330232 */     GIR_EraseRootFromParent_Done,
     /* 330233 */   // Label 6821: @330233
     /* 330233 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(330338), // Rule ID 4257 //
     /* 330238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330254 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330257 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330261 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 330278 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 330278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 330285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330305 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330337 */     // GIR_Coverage, 4257,
     /* 330337 */     GIR_EraseRootFromParent_Done,
     /* 330338 */   // Label 6822: @330338
     /* 330338 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(330443), // Rule ID 4363 //
     /* 330343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330359 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330362 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330366 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 330383 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 330383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 330390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330410 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330442 */     // GIR_Coverage, 4363,
     /* 330442 */     GIR_EraseRootFromParent_Done,
     /* 330443 */   // Label 6823: @330443
     /* 330443 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(330548), // Rule ID 4365 //
     /* 330448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330464 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330471 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 330488 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 330488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 330495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330515 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330547 */     // GIR_Coverage, 4365,
     /* 330547 */     GIR_EraseRootFromParent_Done,
     /* 330548 */   // Label 6824: @330548
     /* 330548 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(330652), // Rule ID 4247 //
     /* 330553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330557 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330563 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330573 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330580 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 330597 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 330597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 330604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330619 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330651 */     // GIR_Coverage, 4247,
     /* 330651 */     GIR_EraseRootFromParent_Done,
     /* 330652 */   // Label 6825: @330652
     /* 330652 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(330756), // Rule ID 4248 //
     /* 330657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330661 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330667 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330677 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330680 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330684 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 330701 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 330701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 330708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330723 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330755 */     // GIR_Coverage, 4248,
     /* 330755 */     GIR_EraseRootFromParent_Done,
     /* 330756 */   // Label 6826: @330756
     /* 330756 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(330860), // Rule ID 4355 //
     /* 330761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330765 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330771 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330781 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330788 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 330805 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 330805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 330812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330827 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330859 */     // GIR_Coverage, 4355,
     /* 330859 */     GIR_EraseRootFromParent_Done,
     /* 330860 */   // Label 6827: @330860
     /* 330860 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(330964), // Rule ID 4356 //
     /* 330865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330869 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330875 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330885 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330892 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 330909 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 330909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 330916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330931 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 330953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330963 */     // GIR_Coverage, 4356,
     /* 330963 */     GIR_EraseRootFromParent_Done,
     /* 330964 */   // Label 6828: @330964
     /* 330964 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(331064), // Rule ID 4251 //
     /* 330969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330985 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330992 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 331009 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 331009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 331012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 331016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331031 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 331053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331063 */     // GIR_Coverage, 4251,
     /* 331063 */     GIR_EraseRootFromParent_Done,
     /* 331064 */   // Label 6829: @331064
     /* 331064 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(331164), // Rule ID 4253 //
     /* 331069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331085 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331092 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 331109 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 331109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 331112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 331116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331131 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 331153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331163 */     // GIR_Coverage, 4253,
     /* 331163 */     GIR_EraseRootFromParent_Done,
     /* 331164 */   // Label 6830: @331164
     /* 331164 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(331264), // Rule ID 4359 //
     /* 331169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331185 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331188 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331192 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 331209 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 331209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 331212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 331216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331231 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 331253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331263 */     // GIR_Coverage, 4359,
     /* 331263 */     GIR_EraseRootFromParent_Done,
     /* 331264 */   // Label 6831: @331264
     /* 331264 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(331364), // Rule ID 4361 //
     /* 331269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331285 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331288 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331292 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 331309 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 331309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 331312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 331316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331331 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 331353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331363 */     // GIR_Coverage, 4361,
     /* 331363 */     GIR_EraseRootFromParent_Done,
     /* 331364 */   // Label 6832: @331364
     /* 331364 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(331442), // Rule ID 1934 //
     /* 331369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331405 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 331409 */     // MIs[2] Operand 1
     /* 331409 */     // No operand predicates
     /* 331409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331417 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 331421 */     // MIs[3] Operand 1
     /* 331421 */     // No operand predicates
     /* 331421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331423 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 331423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 331426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 331430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 331433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 331440 */     GIR_RootConstrainSelectedInstOperands,
     /* 331441 */     // GIR_Coverage, 1934,
     /* 331441 */     GIR_EraseRootFromParent_Done,
     /* 331442 */   // Label 6833: @331442
     /* 331442 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(331533), // Rule ID 7321 //
     /* 331447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 331450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 331462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331474 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 331477 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 331484 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 331487 */     // MIs[2] Rn
     /* 331487 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 331491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 331496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331504 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 331508 */     // MIs[3] Operand 1
     /* 331508 */     // No operand predicates
     /* 331508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331510 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15707>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 331510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 331513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 331517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 331520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 331524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 331531 */     GIR_RootConstrainSelectedInstOperands,
     /* 331532 */     // GIR_Coverage, 7321,
     /* 331532 */     GIR_EraseRootFromParent_Done,
     /* 331533 */   // Label 6834: @331533
     /* 331533 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(331600), // Rule ID 5667 //
     /* 331538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331571 */     // MIs[2] Operand 1
     /* 331571 */     // No operand predicates
     /* 331571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331579 */     // MIs[3] Operand 1
     /* 331579 */     // No operand predicates
     /* 331579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331581 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 331581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 331584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 331588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 331591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 331598 */     GIR_RootConstrainSelectedInstOperands,
     /* 331599 */     // GIR_Coverage, 5667,
     /* 331599 */     GIR_EraseRootFromParent_Done,
     /* 331600 */   // Label 6835: @331600
     /* 331600 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(331698), // Rule ID 5668 //
     /* 331605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331638 */     // MIs[2] Operand 1
     /* 331638 */     // No operand predicates
     /* 331638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331646 */     // MIs[3] Operand 1
     /* 331646 */     // No operand predicates
     /* 331646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331648 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 331648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331660 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 331663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 331670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 331683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331685 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 331687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 331690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 331696 */     GIR_RootConstrainSelectedInstOperands,
     /* 331697 */     // GIR_Coverage, 5668,
     /* 331697 */     GIR_EraseRootFromParent_Done,
     /* 331698 */   // Label 6836: @331698
     /* 331698 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(331765), // Rule ID 5691 //
     /* 331703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331736 */     // MIs[2] Operand 1
     /* 331736 */     // No operand predicates
     /* 331736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331744 */     // MIs[3] Operand 1
     /* 331744 */     // No operand predicates
     /* 331744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331746 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 331746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 331749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 331753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 331756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 331763 */     GIR_RootConstrainSelectedInstOperands,
     /* 331764 */     // GIR_Coverage, 5691,
     /* 331764 */     GIR_EraseRootFromParent_Done,
     /* 331765 */   // Label 6837: @331765
     /* 331765 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(331863), // Rule ID 5692 //
     /* 331770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331803 */     // MIs[2] Operand 1
     /* 331803 */     // No operand predicates
     /* 331803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331811 */     // MIs[3] Operand 1
     /* 331811 */     // No operand predicates
     /* 331811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331813 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 331813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 331828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 331835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 331848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331850 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 331852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 331855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 331861 */     GIR_RootConstrainSelectedInstOperands,
     /* 331862 */     // GIR_Coverage, 5692,
     /* 331862 */     GIR_EraseRootFromParent_Done,
     /* 331863 */   // Label 6838: @331863
     /* 331863 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(331929), // Rule ID 5622 //
     /* 331868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331886 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 331886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 331889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 331903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 331910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 331913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331928 */     // GIR_Coverage, 5622,
     /* 331928 */     GIR_EraseRootFromParent_Done,
     /* 331929 */   // Label 6839: @331929
     /* 331929 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(331995), // Rule ID 5632 //
     /* 331934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331952 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 331952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 331955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 331969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 331976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 331979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331994 */     // GIR_Coverage, 5632,
     /* 331994 */     GIR_EraseRootFromParent_Done,
     /* 331995 */   // Label 6840: @331995
     /* 331995 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(332073), // Rule ID 7320 //
     /* 332000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 332003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332015 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 332018 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 332025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 332028 */     // MIs[1] Rn
     /* 332028 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 332032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 332049 */     // MIs[2] Operand 1
     /* 332049 */     // No operand predicates
     /* 332049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332051 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15707>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 332051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 332054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 332058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 332061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332071 */     GIR_RootConstrainSelectedInstOperands,
     /* 332072 */     // GIR_Coverage, 7320,
     /* 332072 */     GIR_EraseRootFromParent_Done,
     /* 332073 */   // Label 6841: @332073
     /* 332073 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(332142), // Rule ID 6356 //
     /* 332078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 332097 */     // MIs[1] Rn
     /* 332097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 332101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332114 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 332118 */     // MIs[2] Operand 1
     /* 332118 */     // No operand predicates
     /* 332118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332120 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 332120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 332123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 332127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 332130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332140 */     GIR_RootConstrainSelectedInstOperands,
     /* 332141 */     // GIR_Coverage, 6356,
     /* 332141 */     GIR_EraseRootFromParent_Done,
     /* 332142 */   // Label 6842: @332142
     /* 332142 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(332211), // Rule ID 6357 //
     /* 332147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332162 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 332166 */     // MIs[1] Rn
     /* 332166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 332170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 332187 */     // MIs[2] Operand 1
     /* 332187 */     // No operand predicates
     /* 332187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332189 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 332189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 332192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 332196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 332199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332209 */     GIR_RootConstrainSelectedInstOperands,
     /* 332210 */     // GIR_Coverage, 6357,
     /* 332210 */     GIR_EraseRootFromParent_Done,
     /* 332211 */   // Label 6843: @332211
     /* 332211 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(332260), // Rule ID 5639 //
     /* 332216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 332224 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 332228 */     // MIs[1] Operand 1
     /* 332228 */     // No operand predicates
     /* 332228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332236 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 332240 */     // MIs[2] Operand 1
     /* 332240 */     // No operand predicates
     /* 332240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332242 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 332242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 332245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 332249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 332252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 332258 */     GIR_RootConstrainSelectedInstOperands,
     /* 332259 */     // GIR_Coverage, 5639,
     /* 332259 */     GIR_EraseRootFromParent_Done,
     /* 332260 */   // Label 6844: @332260
     /* 332260 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(332361), // Rule ID 5697 //
     /* 332265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 332273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332290 */     // MIs[2] Operand 1
     /* 332290 */     // No operand predicates
     /* 332290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332292 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 332292 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332295 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332299 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 332325 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 332328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 332346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 332350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 332353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332359 */     GIR_RootConstrainSelectedInstOperands,
     /* 332360 */     // GIR_Coverage, 5697,
     /* 332360 */     GIR_EraseRootFromParent_Done,
     /* 332361 */   // Label 6845: @332361
     /* 332361 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(332405), // Rule ID 1930 //
     /* 332366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 332381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 332389 */     // MIs[1] Operand 1
     /* 332389 */     // No operand predicates
     /* 332389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332391 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 332391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 332394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 332398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 332401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 332403 */     GIR_RootConstrainSelectedInstOperands,
     /* 332404 */     // GIR_Coverage, 1930,
     /* 332404 */     GIR_EraseRootFromParent_Done,
     /* 332405 */   // Label 6846: @332405
     /* 332405 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(332501), // Rule ID 5643 //
     /* 332410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 332422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 332430 */     // MIs[1] Operand 1
     /* 332430 */     // No operand predicates
     /* 332430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332432 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 332432 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 332435 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332439 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 332449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332458 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 332465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 332468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 332486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 332490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 332493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332499 */     GIR_RootConstrainSelectedInstOperands,
     /* 332500 */     // GIR_Coverage, 5643,
     /* 332500 */     GIR_EraseRootFromParent_Done,
     /* 332501 */   // Label 6847: @332501
     /* 332501 */   GIM_Reject,
     /* 332502 */ // Label 6816: @332502
     /* 332502 */ GIM_Reject,
     /* 332503 */ // Label 6764: @332503
     /* 332503 */ GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(336142),
     /* 332508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332511 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(332637), // Rule ID 4189 //
     /* 332516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332530 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 332536 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 332538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 332542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332546 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332549 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 332553 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332560 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 332564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 332577 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 332577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 332584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 332604 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332636 */     // GIR_Coverage, 4189,
     /* 332636 */     GIR_EraseRootFromParent_Done,
     /* 332637 */   // Label 6849: @332637
     /* 332637 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(332763), // Rule ID 4190 //
     /* 332642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 332662 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 332664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 332668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332672 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332675 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 332679 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332686 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 332690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 332703 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 332703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 332710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 332730 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332762 */     // GIR_Coverage, 4190,
     /* 332762 */     GIR_EraseRootFromParent_Done,
     /* 332763 */   // Label 6850: @332763
     /* 332763 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(332882), // Rule ID 4297 //
     /* 332768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332782 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 332788 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 332790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 332794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332798 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 332805 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 332809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332815 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 332822 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 332822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 332829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 332849 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332881 */     // GIR_Coverage, 4297,
     /* 332881 */     GIR_EraseRootFromParent_Done,
     /* 332882 */   // Label 6851: @332882
     /* 332882 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(333001), // Rule ID 4298 //
     /* 332887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332901 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 332907 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 332909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 332913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332917 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 332924 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 332928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 332941 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 332941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 332948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 332968 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333000 */     // GIR_Coverage, 4298,
     /* 333000 */     GIR_EraseRootFromParent_Done,
     /* 333001 */   // Label 6852: @333001
     /* 333001 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(333123), // Rule ID 4195 //
     /* 333006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333032 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333035 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333039 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333046 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 333063 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 333063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 333070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333090 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 333112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333122 */     // GIR_Coverage, 4195,
     /* 333122 */     GIR_EraseRootFromParent_Done,
     /* 333123 */   // Label 6853: @333123
     /* 333123 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(333245), // Rule ID 4197 //
     /* 333128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333154 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333157 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333161 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333168 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 333185 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 333185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 333192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333212 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 333234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333244 */     // GIR_Coverage, 4197,
     /* 333244 */     GIR_EraseRootFromParent_Done,
     /* 333245 */   // Label 6854: @333245
     /* 333245 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(333360), // Rule ID 4303 //
     /* 333250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 333253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333276 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333283 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 333300 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 333300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 333307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333327 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 333349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333359 */     // GIR_Coverage, 4303,
     /* 333359 */     GIR_EraseRootFromParent_Done,
     /* 333360 */   // Label 6855: @333360
     /* 333360 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(333475), // Rule ID 4305 //
     /* 333365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 333368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333391 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333398 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 333415 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 333415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 333422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333442 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 333464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333474 */     // GIR_Coverage, 4305,
     /* 333474 */     GIR_EraseRootFromParent_Done,
     /* 333475 */   // Label 6856: @333475
     /* 333475 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(333596), // Rule ID 4187 //
     /* 333480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333494 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333500 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333510 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333513 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333517 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 333541 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 333541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 333548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333563 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 333585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333595 */     // GIR_Coverage, 4187,
     /* 333595 */     GIR_EraseRootFromParent_Done,
     /* 333596 */   // Label 6857: @333596
     /* 333596 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(333717), // Rule ID 4188 //
     /* 333601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333631 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333634 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333638 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333645 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 333662 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 333662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 333669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333684 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 333706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333716 */     // GIR_Coverage, 4188,
     /* 333716 */     GIR_EraseRootFromParent_Done,
     /* 333717 */   // Label 6858: @333717
     /* 333717 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(333831), // Rule ID 4295 //
     /* 333722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 333725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333736 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333742 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333752 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333759 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 333776 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 333776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 333783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333798 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 333820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333830 */     // GIR_Coverage, 4295,
     /* 333830 */     GIR_EraseRootFromParent_Done,
     /* 333831 */   // Label 6859: @333831
     /* 333831 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(333945), // Rule ID 4296 //
     /* 333836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 333839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333850 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333856 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333866 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333869 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333873 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 333890 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 333890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 333897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333912 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 333934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333944 */     // GIR_Coverage, 4296,
     /* 333944 */     GIR_EraseRootFromParent_Done,
     /* 333945 */   // Label 6860: @333945
     /* 333945 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(334062), // Rule ID 4191 //
     /* 333950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333976 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333979 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333983 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333990 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 334007 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 334007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 334010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 334014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334029 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 334051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334061 */     // GIR_Coverage, 4191,
     /* 334061 */     GIR_EraseRootFromParent_Done,
     /* 334062 */   // Label 6861: @334062
     /* 334062 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(334179), // Rule ID 4193 //
     /* 334067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 334070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334093 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334096 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334100 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334107 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 334124 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 334124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 334127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 334131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334146 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 334168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334178 */     // GIR_Coverage, 4193,
     /* 334178 */     GIR_EraseRootFromParent_Done,
     /* 334179 */   // Label 6862: @334179
     /* 334179 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(334289), // Rule ID 4299 //
     /* 334184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 334187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334210 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334217 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334227 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 334234 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 334234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 334237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 334241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334256 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 334278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334288 */     // GIR_Coverage, 4299,
     /* 334288 */     GIR_EraseRootFromParent_Done,
     /* 334289 */   // Label 6863: @334289
     /* 334289 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(334399), // Rule ID 4301 //
     /* 334294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 334297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334320 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334327 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 334344 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 334344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 334347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 334351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334366 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 334388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334398 */     // GIR_Coverage, 4301,
     /* 334398 */     GIR_EraseRootFromParent_Done,
     /* 334399 */   // Label 6864: @334399
     /* 334399 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(334529), // Rule ID 6369 //
     /* 334404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 334407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 334410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334433 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334436 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334440 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 334447 */     // MIs[2] Rn
     /* 334447 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 334451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 334456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334462 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 334462 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 334465 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334469 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 334483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 334494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 334498 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334511 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334528 */     // GIR_Coverage, 6369,
     /* 334528 */     GIR_EraseRootFromParent_Done,
     /* 334529 */   // Label 6865: @334529
     /* 334529 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(334669), // Rule ID 5657 //
     /* 334534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 334537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 334560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334577 */     // MIs[2] Operand 1
     /* 334577 */     // No operand predicates
     /* 334577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334585 */     // MIs[3] Operand 1
     /* 334585 */     // No operand predicates
     /* 334585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334587 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 334587 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334590 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334594 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334599 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334602 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334606 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334609 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334614 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 334626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334631 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334668 */     // GIR_Coverage, 5657,
     /* 334668 */     GIR_EraseRootFromParent_Done,
     /* 334669 */   // Label 6866: @334669
     /* 334669 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(334840), // Rule ID 5658 //
     /* 334674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 334677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 334700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334717 */     // MIs[2] Operand 1
     /* 334717 */     // No operand predicates
     /* 334717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334725 */     // MIs[3] Operand 1
     /* 334725 */     // No operand predicates
     /* 334725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334727 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 334727 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 334730 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334734 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334739 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 334742 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334746 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 334749 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334754 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334759 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334762 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334766 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334771 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334774 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334778 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334781 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334786 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 334798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334803 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 334812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334822 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334839 */     // GIR_Coverage, 5658,
     /* 334839 */     GIR_EraseRootFromParent_Done,
     /* 334840 */   // Label 6867: @334840
     /* 334840 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(334980), // Rule ID 5681 //
     /* 334845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 334848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 334871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334888 */     // MIs[2] Operand 1
     /* 334888 */     // No operand predicates
     /* 334888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334896 */     // MIs[3] Operand 1
     /* 334896 */     // No operand predicates
     /* 334896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334898 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 334898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334910 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334913 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334917 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334920 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334925 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 334937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334942 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334962 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334979 */     // GIR_Coverage, 5681,
     /* 334979 */     GIR_EraseRootFromParent_Done,
     /* 334980 */   // Label 6868: @334980
     /* 334980 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(335151), // Rule ID 5682 //
     /* 334985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 334988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 335011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335028 */     // MIs[2] Operand 1
     /* 335028 */     // No operand predicates
     /* 335028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335036 */     // MIs[3] Operand 1
     /* 335036 */     // No operand predicates
     /* 335036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335038 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 335038 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 335041 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335045 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335050 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 335053 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335057 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 335060 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335065 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335082 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335085 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 335089 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335097 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 335109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335114 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 335120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 335123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 335126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335133 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335150 */     // GIR_Coverage, 5682,
     /* 335150 */     GIR_EraseRootFromParent_Done,
     /* 335151 */   // Label 6869: @335151
     /* 335151 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(335230), // Rule ID 5612 //
     /* 335156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 335159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335184 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 335184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 335200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335229 */     // GIR_Coverage, 5612,
     /* 335229 */     GIR_EraseRootFromParent_Done,
     /* 335230 */   // Label 6870: @335230
     /* 335230 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(335306), // Rule ID 5614 //
     /* 335235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 335238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335263 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 335263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 335266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 335290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335305 */     // GIR_Coverage, 5614,
     /* 335305 */     GIR_EraseRootFromParent_Done,
     /* 335306 */   // Label 6871: @335306
     /* 335306 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(335382), // Rule ID 5624 //
     /* 335311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 335314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335339 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 335339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 335342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 335366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335381 */     // GIR_Coverage, 5624,
     /* 335381 */     GIR_EraseRootFromParent_Done,
     /* 335382 */   // Label 6872: @335382
     /* 335382 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(335527), // Rule ID 5636 //
     /* 335387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 335390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 335409 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 335413 */     // MIs[1] Operand 1
     /* 335413 */     // No operand predicates
     /* 335413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335421 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 335425 */     // MIs[2] Operand 1
     /* 335425 */     // No operand predicates
     /* 335425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335427 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 335427 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 335430 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335434 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 335441 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 335444 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335448 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335453 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335456 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 335460 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335463 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 335485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 335496 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 335502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335526 */     // GIR_Coverage, 5636,
     /* 335526 */     GIR_EraseRootFromParent_Done,
     /* 335527 */   // Label 6873: @335527
     /* 335527 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(335676), // Rule ID 6372 //
     /* 335532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 335535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335557 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335561 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335568 */     // MIs[1] Rn
     /* 335568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 335572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335585 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 335589 */     // MIs[2] Operand 1
     /* 335589 */     // No operand predicates
     /* 335589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335591 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 335591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335603 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335606 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 335610 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335618 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 335630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 335641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335645 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335658 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335675 */     // GIR_Coverage, 6372,
     /* 335675 */     GIR_EraseRootFromParent_Done,
     /* 335676 */   // Label 6874: @335676
     /* 335676 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(335818), // Rule ID 6375 //
     /* 335681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 335684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335710 */     // MIs[1] Rn
     /* 335710 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 335714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335727 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 335731 */     // MIs[2] Operand 1
     /* 335731 */     // No operand predicates
     /* 335731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335733 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 335733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335745 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335748 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 335752 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335755 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 335772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 335783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335787 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335800 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335817 */     // GIR_Coverage, 6375,
     /* 335817 */     GIR_EraseRootFromParent_Done,
     /* 335818 */   // Label 6875: @335818
     /* 335818 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(336006), // Rule ID 5634 //
     /* 335823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 335826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 335845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335853 */     // MIs[1] Operand 1
     /* 335853 */     // No operand predicates
     /* 335853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335855 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 335855 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 335858 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335862 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335869 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 335872 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335876 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335881 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335884 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 335888 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 335891 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335896 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335901 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335906 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 335909 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335913 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 335920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 335923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335932 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 335939 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335942 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 335964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335969 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 335975 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 335978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335988 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336005 */     // GIR_Coverage, 5634,
     /* 336005 */     GIR_EraseRootFromParent_Done,
     /* 336006 */   // Label 6876: @336006
     /* 336006 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(336141), // Rule ID 5645 //
     /* 336011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 336029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 336033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 336041 */     // MIs[1] Operand 1
     /* 336041 */     // No operand predicates
     /* 336041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336043 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 336043 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 336046 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336050 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336057 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 336060 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336064 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336069 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336072 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 336076 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336079 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 336101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 336112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 336116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336123 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336140 */     // GIR_Coverage, 5645,
     /* 336140 */     GIR_EraseRootFromParent_Done,
     /* 336141 */   // Label 6877: @336141
     /* 336141 */   GIM_Reject,
     /* 336142 */ // Label 6848: @336142
     /* 336142 */ GIM_Reject,
     /* 336143 */ // Label 6765: @336143
     /* 336143 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(338806),
     /* 336148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336161 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(336270), // Rule ID 4213 //
     /* 336166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336170 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336176 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336186 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336193 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 336210 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 336217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336237 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336269 */     // GIR_Coverage, 4213,
     /* 336269 */     GIR_EraseRootFromParent_Done,
     /* 336270 */   // Label 6879: @336270
     /* 336270 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(336379), // Rule ID 4214 //
     /* 336275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336279 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336285 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336295 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336302 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336319 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336346 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336378 */     // GIR_Coverage, 4214,
     /* 336378 */     GIR_EraseRootFromParent_Done,
     /* 336379 */   // Label 6880: @336379
     /* 336379 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(336488), // Rule ID 4321 //
     /* 336384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336388 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336394 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336404 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336411 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 336428 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 336435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336487 */     // GIR_Coverage, 4321,
     /* 336487 */     GIR_EraseRootFromParent_Done,
     /* 336488 */   // Label 6881: @336488
     /* 336488 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(336597), // Rule ID 4322 //
     /* 336493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336497 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336503 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336513 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336520 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336537 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336564 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336596 */     // GIR_Coverage, 4322,
     /* 336596 */     GIR_EraseRootFromParent_Done,
     /* 336597 */   // Label 6882: @336597
     /* 336597 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(336702), // Rule ID 4219 //
     /* 336602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336618 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336621 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336625 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 336642 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 336649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336669 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336701 */     // GIR_Coverage, 4219,
     /* 336701 */     GIR_EraseRootFromParent_Done,
     /* 336702 */   // Label 6883: @336702
     /* 336702 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(336807), // Rule ID 4221 //
     /* 336707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336723 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336730 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336747 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336806 */     // GIR_Coverage, 4221,
     /* 336806 */     GIR_EraseRootFromParent_Done,
     /* 336807 */   // Label 6884: @336807
     /* 336807 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(336912), // Rule ID 4327 //
     /* 336812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336828 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336835 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 336852 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 336859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336879 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336911 */     // GIR_Coverage, 4327,
     /* 336911 */     GIR_EraseRootFromParent_Done,
     /* 336912 */   // Label 6885: @336912
     /* 336912 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(337017), // Rule ID 4329 //
     /* 336917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336933 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336940 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336957 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336984 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337016 */     // GIR_Coverage, 4329,
     /* 337016 */     GIR_EraseRootFromParent_Done,
     /* 337017 */   // Label 6886: @337017
     /* 337017 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(337121), // Rule ID 4211 //
     /* 337022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337026 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337032 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337042 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337049 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 337066 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 337066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 337073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337088 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337120 */     // GIR_Coverage, 4211,
     /* 337120 */     GIR_EraseRootFromParent_Done,
     /* 337121 */   // Label 6887: @337121
     /* 337121 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(337225), // Rule ID 4212 //
     /* 337126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337146 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337153 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 337170 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 337170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 337177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337192 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337224 */     // GIR_Coverage, 4212,
     /* 337224 */     GIR_EraseRootFromParent_Done,
     /* 337225 */   // Label 6888: @337225
     /* 337225 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(337329), // Rule ID 4319 //
     /* 337230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337234 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337240 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337250 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337257 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 337274 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 337274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 337281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337296 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337328 */     // GIR_Coverage, 4319,
     /* 337328 */     GIR_EraseRootFromParent_Done,
     /* 337329 */   // Label 6889: @337329
     /* 337329 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(337433), // Rule ID 4320 //
     /* 337334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337338 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337344 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337354 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337361 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 337378 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 337378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 337385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337400 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337432 */     // GIR_Coverage, 4320,
     /* 337432 */     GIR_EraseRootFromParent_Done,
     /* 337433 */   // Label 6890: @337433
     /* 337433 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(337533), // Rule ID 4215 //
     /* 337438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337454 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337461 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 337478 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 337478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 337485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337500 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337532 */     // GIR_Coverage, 4215,
     /* 337532 */     GIR_EraseRootFromParent_Done,
     /* 337533 */   // Label 6891: @337533
     /* 337533 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(337633), // Rule ID 4217 //
     /* 337538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337554 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337561 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 337578 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 337578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 337585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337632 */     // GIR_Coverage, 4217,
     /* 337632 */     GIR_EraseRootFromParent_Done,
     /* 337633 */   // Label 6892: @337633
     /* 337633 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(337733), // Rule ID 4323 //
     /* 337638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337654 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337661 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 337678 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 337678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 337685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337700 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337732 */     // GIR_Coverage, 4323,
     /* 337732 */     GIR_EraseRootFromParent_Done,
     /* 337733 */   // Label 6893: @337733
     /* 337733 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(337833), // Rule ID 4325 //
     /* 337738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337754 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337761 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 337778 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 337778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 337785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337800 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337832 */     // GIR_Coverage, 4325,
     /* 337832 */     GIR_EraseRootFromParent_Done,
     /* 337833 */   // Label 6894: @337833
     /* 337833 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(337911), // Rule ID 1933 //
     /* 337838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337878 */     // MIs[2] Operand 1
     /* 337878 */     // No operand predicates
     /* 337878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337890 */     // MIs[3] Operand 1
     /* 337890 */     // No operand predicates
     /* 337890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337892 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 337892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 337899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 337902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 337909 */     GIR_RootConstrainSelectedInstOperands,
     /* 337910 */     // GIR_Coverage, 1933,
     /* 337910 */     GIR_EraseRootFromParent_Done,
     /* 337911 */   // Label 6895: @337911
     /* 337911 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(337978), // Rule ID 5661 //
     /* 337916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337949 */     // MIs[2] Operand 1
     /* 337949 */     // No operand predicates
     /* 337949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337957 */     // MIs[3] Operand 1
     /* 337957 */     // No operand predicates
     /* 337957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337959 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 337959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 337966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 337969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 337976 */     GIR_RootConstrainSelectedInstOperands,
     /* 337977 */     // GIR_Coverage, 5661,
     /* 337977 */     GIR_EraseRootFromParent_Done,
     /* 337978 */   // Label 6896: @337978
     /* 337978 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(338076), // Rule ID 5662 //
     /* 337983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 337999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 338012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338016 */     // MIs[2] Operand 1
     /* 338016 */     // No operand predicates
     /* 338016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 338020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338024 */     // MIs[3] Operand 1
     /* 338024 */     // No operand predicates
     /* 338024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338026 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 338026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338038 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 338041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 338048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338063 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 338065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 338068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 338074 */     GIR_RootConstrainSelectedInstOperands,
     /* 338075 */     // GIR_Coverage, 5662,
     /* 338075 */     GIR_EraseRootFromParent_Done,
     /* 338076 */   // Label 6897: @338076
     /* 338076 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(338143), // Rule ID 5685 //
     /* 338081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 338097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 338110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338114 */     // MIs[2] Operand 1
     /* 338114 */     // No operand predicates
     /* 338114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 338118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338122 */     // MIs[3] Operand 1
     /* 338122 */     // No operand predicates
     /* 338122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338124 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 338124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338129 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 338131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 338134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 338141 */     GIR_RootConstrainSelectedInstOperands,
     /* 338142 */     // GIR_Coverage, 5685,
     /* 338142 */     GIR_EraseRootFromParent_Done,
     /* 338143 */   // Label 6898: @338143
     /* 338143 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(338241), // Rule ID 5686 //
     /* 338148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 338164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 338177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338181 */     // MIs[2] Operand 1
     /* 338181 */     // No operand predicates
     /* 338181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 338185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338189 */     // MIs[3] Operand 1
     /* 338189 */     // No operand predicates
     /* 338189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338191 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 338191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338203 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 338206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 338213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 338230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 338233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 338239 */     GIR_RootConstrainSelectedInstOperands,
     /* 338240 */     // GIR_Coverage, 5686,
     /* 338240 */     GIR_EraseRootFromParent_Done,
     /* 338241 */   // Label 6899: @338241
     /* 338241 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(338307), // Rule ID 5620 //
     /* 338246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338264 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 338264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 338267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 338288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338306 */     // GIR_Coverage, 5620,
     /* 338306 */     GIR_EraseRootFromParent_Done,
     /* 338307 */   // Label 6900: @338307
     /* 338307 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(338373), // Rule ID 5628 //
     /* 338312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338330 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 338330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 338333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 338354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338372 */     // GIR_Coverage, 5628,
     /* 338372 */     GIR_EraseRootFromParent_Done,
     /* 338373 */   // Label 6901: @338373
     /* 338373 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(338426), // Rule ID 5637 //
     /* 338378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 338390 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 338394 */     // MIs[1] Operand 1
     /* 338394 */     // No operand predicates
     /* 338394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 338398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338402 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338406 */     // MIs[2] Operand 1
     /* 338406 */     // No operand predicates
     /* 338406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338408 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 338408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 338411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 338415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 338418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 338424 */     GIR_RootConstrainSelectedInstOperands,
     /* 338425 */     // GIR_Coverage, 5637,
     /* 338425 */     GIR_EraseRootFromParent_Done,
     /* 338426 */   // Label 6902: @338426
     /* 338426 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(338495), // Rule ID 6354 //
     /* 338431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338443 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338446 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338450 */     // MIs[1] Rn
     /* 338450 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 338454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 338459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 338463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338471 */     // MIs[2] Operand 1
     /* 338471 */     // No operand predicates
     /* 338471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338473 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 338473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 338476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 338480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 338483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338493 */     GIR_RootConstrainSelectedInstOperands,
     /* 338494 */     // GIR_Coverage, 6354,
     /* 338494 */     GIR_EraseRootFromParent_Done,
     /* 338495 */   // Label 6903: @338495
     /* 338495 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(338564), // Rule ID 6355 //
     /* 338500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338519 */     // MIs[1] Rn
     /* 338519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 338523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 338528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 338532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338536 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338540 */     // MIs[2] Operand 1
     /* 338540 */     // No operand predicates
     /* 338540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338542 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 338542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 338545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 338549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 338552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338562 */     GIR_RootConstrainSelectedInstOperands,
     /* 338563 */     // GIR_Coverage, 6355,
     /* 338563 */     GIR_EraseRootFromParent_Done,
     /* 338564 */   // Label 6904: @338564
     /* 338564 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(338665), // Rule ID 5695 //
     /* 338569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 338577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 338581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 338590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338594 */     // MIs[2] Operand 1
     /* 338594 */     // No operand predicates
     /* 338594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338596 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 338596 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 338599 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338603 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 338629 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338652 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 338654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 338657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338663 */     GIR_RootConstrainSelectedInstOperands,
     /* 338664 */     // GIR_Coverage, 5695,
     /* 338664 */     GIR_EraseRootFromParent_Done,
     /* 338665 */   // Label 6905: @338665
     /* 338665 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(338709), // Rule ID 1929 //
     /* 338670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 338673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 338681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 338685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338693 */     // MIs[1] Operand 1
     /* 338693 */     // No operand predicates
     /* 338693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338695 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 338695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 338698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 338702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 338705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 338707 */     GIR_RootConstrainSelectedInstOperands,
     /* 338708 */     // GIR_Coverage, 1929,
     /* 338708 */     GIR_EraseRootFromParent_Done,
     /* 338709 */   // Label 6906: @338709
     /* 338709 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(338805), // Rule ID 5642 //
     /* 338714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 338726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338734 */     // MIs[1] Operand 1
     /* 338734 */     // No operand predicates
     /* 338734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338736 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 338736 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 338739 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338743 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 338753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 338769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 338794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 338797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338803 */     GIR_RootConstrainSelectedInstOperands,
     /* 338804 */     // GIR_Coverage, 5642,
     /* 338804 */     GIR_EraseRootFromParent_Done,
     /* 338805 */   // Label 6907: @338805
     /* 338805 */   GIM_Reject,
     /* 338806 */ // Label 6878: @338806
     /* 338806 */ GIM_Reject,
     /* 338807 */ // Label 6766: @338807
     /* 338807 */ GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(340650),
     /* 338812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 338815 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(338941), // Rule ID 4153 //
     /* 338820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338834 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338840 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338850 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338853 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338857 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338864 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 338881 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 338881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 338884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 338888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338908 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 338930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338940 */     // GIR_Coverage, 4153,
     /* 338940 */     GIR_EraseRootFromParent_Done,
     /* 338941 */   // Label 6909: @338941
     /* 338941 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(339067), // Rule ID 4154 //
     /* 338946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338960 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338966 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338976 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338979 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338983 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338990 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 339007 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 339007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 339010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 339014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339034 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 339056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339066 */     // GIR_Coverage, 4154,
     /* 339066 */     GIR_EraseRootFromParent_Done,
     /* 339067 */   // Label 6910: @339067
     /* 339067 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(339189), // Rule ID 4159 //
     /* 339072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339098 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339101 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339105 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 339129 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 339129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 339132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 339136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339156 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 339178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339188 */     // GIR_Coverage, 4159,
     /* 339188 */     GIR_EraseRootFromParent_Done,
     /* 339189 */   // Label 6911: @339189
     /* 339189 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(339311), // Rule ID 4161 //
     /* 339194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339220 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339223 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339227 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339234 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 339251 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 339251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 339254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 339258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339278 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 339300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339310 */     // GIR_Coverage, 4161,
     /* 339310 */     GIR_EraseRootFromParent_Done,
     /* 339311 */   // Label 6912: @339311
     /* 339311 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(339432), // Rule ID 4151 //
     /* 339316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339330 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339336 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339346 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339349 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339353 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339360 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 339377 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 339377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 339380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 339384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339399 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 339421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339431 */     // GIR_Coverage, 4151,
     /* 339431 */     GIR_EraseRootFromParent_Done,
     /* 339432 */   // Label 6913: @339432
     /* 339432 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(339553), // Rule ID 4152 //
     /* 339437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339457 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339467 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339470 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339474 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339481 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 339498 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 339498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 339501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 339505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 339542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339552 */     // GIR_Coverage, 4152,
     /* 339552 */     GIR_EraseRootFromParent_Done,
     /* 339553 */   // Label 6914: @339553
     /* 339553 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(339670), // Rule ID 4155 //
     /* 339558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339584 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339587 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339591 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339598 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339608 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 339615 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 339615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 339618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 339622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339637 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 339659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339669 */     // GIR_Coverage, 4155,
     /* 339669 */     GIR_EraseRootFromParent_Done,
     /* 339670 */   // Label 6915: @339670
     /* 339670 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(339787), // Rule ID 4157 //
     /* 339675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339701 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339704 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339708 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339715 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 339732 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 339732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 339735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 339739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339754 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 339776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339786 */     // GIR_Coverage, 4157,
     /* 339786 */     GIR_EraseRootFromParent_Done,
     /* 339787 */   // Label 6916: @339787
     /* 339787 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(339927), // Rule ID 5675 //
     /* 339792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 339818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339835 */     // MIs[2] Operand 1
     /* 339835 */     // No operand predicates
     /* 339835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339843 */     // MIs[3] Operand 1
     /* 339843 */     // No operand predicates
     /* 339843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339845 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339845 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339848 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339852 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339857 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339860 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339864 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 339884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339926 */     // GIR_Coverage, 5675,
     /* 339926 */     GIR_EraseRootFromParent_Done,
     /* 339927 */   // Label 6917: @339927
     /* 339927 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(340098), // Rule ID 5676 //
     /* 339932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 339958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339975 */     // MIs[2] Operand 1
     /* 339975 */     // No operand predicates
     /* 339975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339983 */     // MIs[3] Operand 1
     /* 339983 */     // No operand predicates
     /* 339983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339985 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339985 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 339988 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339992 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339997 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 340000 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340004 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 340007 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340012 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340017 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340020 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340024 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340029 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 340032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 340036 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 340056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340061 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 340067 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 340073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340080 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340097 */     // GIR_Coverage, 5676,
     /* 340097 */     GIR_EraseRootFromParent_Done,
     /* 340098 */   // Label 6918: @340098
     /* 340098 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(340177), // Rule ID 5607 //
     /* 340103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340131 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 340131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 340147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340176 */     // GIR_Coverage, 5607,
     /* 340176 */     GIR_EraseRootFromParent_Done,
     /* 340177 */   // Label 6919: @340177
     /* 340177 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(340326), // Rule ID 6371 //
     /* 340182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340207 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340211 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340218 */     // MIs[1] Rn
     /* 340218 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 340239 */     // MIs[2] Operand 1
     /* 340239 */     // No operand predicates
     /* 340239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340241 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 340241 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340244 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340248 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340253 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 340256 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 340260 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 340280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340285 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 340291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340295 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340308 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340325 */     // GIR_Coverage, 6371,
     /* 340325 */     GIR_EraseRootFromParent_Done,
     /* 340326 */   // Label 6920: @340326
     /* 340326 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(340461), // Rule ID 5646 //
     /* 340331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 340361 */     // MIs[1] Operand 1
     /* 340361 */     // No operand predicates
     /* 340361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340363 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 340363 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 340366 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340370 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 340380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340389 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340392 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340396 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340399 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340404 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 340421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340426 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 340432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340443 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340460 */     // GIR_Coverage, 5646,
     /* 340460 */     GIR_EraseRootFromParent_Done,
     /* 340461 */   // Label 6921: @340461
     /* 340461 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(340649), // Rule ID 5647 //
     /* 340466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 340469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 340496 */     // MIs[1] Operand 1
     /* 340496 */     // No operand predicates
     /* 340496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340498 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 340498 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 340501 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340505 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340512 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 340515 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340519 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340524 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340527 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340531 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 340534 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340539 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340544 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340549 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 340552 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340556 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 340566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340575 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340582 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340595 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 340607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340612 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 340618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 340621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340648 */     // GIR_Coverage, 5647,
     /* 340648 */     GIR_EraseRootFromParent_Done,
     /* 340649 */   // Label 6922: @340649
     /* 340649 */   GIM_Reject,
     /* 340650 */ // Label 6908: @340650
     /* 340650 */ GIM_Reject,
     /* 340651 */ // Label 6767: @340651
     /* 340651 */ GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(343625),
     /* 340656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340659 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(340785), // Rule ID 4177 //
     /* 340664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340678 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340684 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340694 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340697 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340701 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340708 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340725 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340752 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340784 */     // GIR_Coverage, 4177,
     /* 340784 */     GIR_EraseRootFromParent_Done,
     /* 340785 */   // Label 6924: @340785
     /* 340785 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(340911), // Rule ID 4178 //
     /* 340790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340804 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340810 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340820 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340823 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340827 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340834 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 340851 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 340858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340878 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340910 */     // GIR_Coverage, 4178,
     /* 340910 */     GIR_EraseRootFromParent_Done,
     /* 340911 */   // Label 6925: @340911
     /* 340911 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(341030), // Rule ID 4285 //
     /* 340916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340930 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340936 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340946 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340953 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340970 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340997 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341029 */     // GIR_Coverage, 4285,
     /* 341029 */     GIR_EraseRootFromParent_Done,
     /* 341030 */   // Label 6926: @341030
     /* 341030 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(341149), // Rule ID 4286 //
     /* 341035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341049 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341055 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341065 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341072 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341089 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341148 */     // GIR_Coverage, 4286,
     /* 341148 */     GIR_EraseRootFromParent_Done,
     /* 341149 */   // Label 6927: @341149
     /* 341149 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(341271), // Rule ID 4183 //
     /* 341154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341180 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341183 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341187 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341194 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341211 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341238 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341270 */     // GIR_Coverage, 4183,
     /* 341270 */     GIR_EraseRootFromParent_Done,
     /* 341271 */   // Label 6928: @341271
     /* 341271 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(341393), // Rule ID 4185 //
     /* 341276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341302 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341305 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341309 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341316 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341333 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341392 */     // GIR_Coverage, 4185,
     /* 341392 */     GIR_EraseRootFromParent_Done,
     /* 341393 */   // Label 6929: @341393
     /* 341393 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(341508), // Rule ID 4291 //
     /* 341398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341424 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341431 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341448 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341475 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341507 */     // GIR_Coverage, 4291,
     /* 341507 */     GIR_EraseRootFromParent_Done,
     /* 341508 */   // Label 6930: @341508
     /* 341508 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(341623), // Rule ID 4293 //
     /* 341513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341539 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341542 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341546 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341563 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341590 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341622 */     // GIR_Coverage, 4293,
     /* 341622 */     GIR_EraseRootFromParent_Done,
     /* 341623 */   // Label 6931: @341623
     /* 341623 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(341744), // Rule ID 4175 //
     /* 341628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341642 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341648 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341658 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341661 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341665 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341672 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341689 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 341689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341711 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341743 */     // GIR_Coverage, 4175,
     /* 341743 */     GIR_EraseRootFromParent_Done,
     /* 341744 */   // Label 6932: @341744
     /* 341744 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(341865), // Rule ID 4176 //
     /* 341749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341763 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341769 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341779 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341782 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341786 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341793 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 341810 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 341810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 341817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341832 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341864 */     // GIR_Coverage, 4176,
     /* 341864 */     GIR_EraseRootFromParent_Done,
     /* 341865 */   // Label 6933: @341865
     /* 341865 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(341979), // Rule ID 4283 //
     /* 341870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341884 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341890 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341900 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341907 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341924 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 341924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341946 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341978 */     // GIR_Coverage, 4283,
     /* 341978 */     GIR_EraseRootFromParent_Done,
     /* 341979 */   // Label 6934: @341979
     /* 341979 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(342093), // Rule ID 4284 //
     /* 341984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341998 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342004 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342014 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342021 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342038 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342060 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342092 */     // GIR_Coverage, 4284,
     /* 342092 */     GIR_EraseRootFromParent_Done,
     /* 342093 */   // Label 6935: @342093
     /* 342093 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(342210), // Rule ID 4179 //
     /* 342098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342124 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342127 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342131 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342138 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342155 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342177 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342209 */     // GIR_Coverage, 4179,
     /* 342209 */     GIR_EraseRootFromParent_Done,
     /* 342210 */   // Label 6936: @342210
     /* 342210 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(342327), // Rule ID 4181 //
     /* 342215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342241 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342244 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342248 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342255 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342272 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342326 */     // GIR_Coverage, 4181,
     /* 342326 */     GIR_EraseRootFromParent_Done,
     /* 342327 */   // Label 6937: @342327
     /* 342327 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(342437), // Rule ID 4287 //
     /* 342332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342358 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342365 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342382 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342404 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342436 */     // GIR_Coverage, 4287,
     /* 342436 */     GIR_EraseRootFromParent_Done,
     /* 342437 */   // Label 6938: @342437
     /* 342437 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(342547), // Rule ID 4289 //
     /* 342442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342468 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342475 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342492 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342514 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342546 */     // GIR_Coverage, 4289,
     /* 342546 */     GIR_EraseRootFromParent_Done,
     /* 342547 */   // Label 6939: @342547
     /* 342547 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(342635), // Rule ID 1932 //
     /* 342552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 342602 */     // MIs[2] Operand 1
     /* 342602 */     // No operand predicates
     /* 342602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342610 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 342614 */     // MIs[3] Operand 1
     /* 342614 */     // No operand predicates
     /* 342614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342616 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 342616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 342626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 342633 */     GIR_RootConstrainSelectedInstOperands,
     /* 342634 */     // GIR_Coverage, 1932,
     /* 342634 */     GIR_EraseRootFromParent_Done,
     /* 342635 */   // Label 6940: @342635
     /* 342635 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(342712), // Rule ID 5655 //
     /* 342640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342683 */     // MIs[2] Operand 1
     /* 342683 */     // No operand predicates
     /* 342683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342691 */     // MIs[3] Operand 1
     /* 342691 */     // No operand predicates
     /* 342691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342693 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 342693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342710 */     GIR_RootConstrainSelectedInstOperands,
     /* 342711 */     // GIR_Coverage, 5655,
     /* 342711 */     GIR_EraseRootFromParent_Done,
     /* 342712 */   // Label 6941: @342712
     /* 342712 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(342820), // Rule ID 5656 //
     /* 342717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342760 */     // MIs[2] Operand 1
     /* 342760 */     // No operand predicates
     /* 342760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342768 */     // MIs[3] Operand 1
     /* 342768 */     // No operand predicates
     /* 342768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342770 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 342770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 342785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 342792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342818 */     GIR_RootConstrainSelectedInstOperands,
     /* 342819 */     // GIR_Coverage, 5656,
     /* 342819 */     GIR_EraseRootFromParent_Done,
     /* 342820 */   // Label 6942: @342820
     /* 342820 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(342897), // Rule ID 5679 //
     /* 342825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342868 */     // MIs[2] Operand 1
     /* 342868 */     // No operand predicates
     /* 342868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342876 */     // MIs[3] Operand 1
     /* 342876 */     // No operand predicates
     /* 342876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342878 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 342878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342895 */     GIR_RootConstrainSelectedInstOperands,
     /* 342896 */     // GIR_Coverage, 5679,
     /* 342896 */     GIR_EraseRootFromParent_Done,
     /* 342897 */   // Label 6943: @342897
     /* 342897 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(343005), // Rule ID 5680 //
     /* 342902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342945 */     // MIs[2] Operand 1
     /* 342945 */     // No operand predicates
     /* 342945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342953 */     // MIs[3] Operand 1
     /* 342953 */     // No operand predicates
     /* 342953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342955 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 342955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 342970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342974 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 342977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 343003 */     GIR_RootConstrainSelectedInstOperands,
     /* 343004 */     // GIR_Coverage, 5680,
     /* 343004 */     GIR_EraseRootFromParent_Done,
     /* 343005 */   // Label 6944: @343005
     /* 343005 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(343084), // Rule ID 5610 //
     /* 343010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 343032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343038 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 343038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 343041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 343054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 343073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343083 */     // GIR_Coverage, 5610,
     /* 343083 */     GIR_EraseRootFromParent_Done,
     /* 343084 */   // Label 6945: @343084
     /* 343084 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(343160), // Rule ID 5616 //
     /* 343089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343117 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 343120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343159 */     // GIR_Coverage, 5616,
     /* 343159 */     GIR_EraseRootFromParent_Done,
     /* 343160 */   // Label 6946: @343160
     /* 343160 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(343236), // Rule ID 5626 //
     /* 343165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343193 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 343196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343235 */     // GIR_Coverage, 5626,
     /* 343235 */     GIR_EraseRootFromParent_Done,
     /* 343236 */   // Label 6947: @343236
     /* 343236 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(343299), // Rule ID 5635 //
     /* 343241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 343263 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 343267 */     // MIs[1] Operand 1
     /* 343267 */     // No operand predicates
     /* 343267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343275 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343279 */     // MIs[2] Operand 1
     /* 343279 */     // No operand predicates
     /* 343279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343281 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 343281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 343284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 343291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 343297 */     GIR_RootConstrainSelectedInstOperands,
     /* 343298 */     // GIR_Coverage, 5635,
     /* 343298 */     GIR_EraseRootFromParent_Done,
     /* 343299 */   // Label 6948: @343299
     /* 343299 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(343385), // Rule ID 6353 //
     /* 343304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343329 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343333 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 343340 */     // MIs[1] Rn
     /* 343340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343361 */     // MIs[2] Operand 1
     /* 343361 */     // No operand predicates
     /* 343361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343363 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 343363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 343366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 343373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343383 */     GIR_RootConstrainSelectedInstOperands,
     /* 343384 */     // GIR_Coverage, 6353,
     /* 343384 */     GIR_EraseRootFromParent_Done,
     /* 343385 */   // Label 6949: @343385
     /* 343385 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(343464), // Rule ID 6358 //
     /* 343390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343419 */     // MIs[1] Rn
     /* 343419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343436 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343440 */     // MIs[2] Operand 1
     /* 343440 */     // No operand predicates
     /* 343440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343442 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 343442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 343445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 343452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343462 */     GIR_RootConstrainSelectedInstOperands,
     /* 343463 */     // GIR_Coverage, 6358,
     /* 343463 */     GIR_EraseRootFromParent_Done,
     /* 343464 */   // Label 6950: @343464
     /* 343464 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(343518), // Rule ID 1928 //
     /* 343469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 343490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 343494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343502 */     // MIs[1] Operand 1
     /* 343502 */     // No operand predicates
     /* 343502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343504 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 343504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 343507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 343511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 343514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343516 */     GIR_RootConstrainSelectedInstOperands,
     /* 343517 */     // GIR_Coverage, 1928,
     /* 343517 */     GIR_EraseRootFromParent_Done,
     /* 343518 */   // Label 6951: @343518
     /* 343518 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(343624), // Rule ID 5640 //
     /* 343523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 343545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343553 */     // MIs[1] Operand 1
     /* 343553 */     // No operand predicates
     /* 343553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343555 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 343555 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 343558 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343562 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 343569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 343572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 343588 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 343591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 343616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343622 */     GIR_RootConstrainSelectedInstOperands,
     /* 343623 */     // GIR_Coverage, 5640,
     /* 343623 */     GIR_EraseRootFromParent_Done,
     /* 343624 */   // Label 6952: @343624
     /* 343624 */   GIM_Reject,
     /* 343625 */ // Label 6923: @343625
     /* 343625 */ GIM_Reject,
     /* 343626 */ // Label 6768: @343626
     /* 343626 */ GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(345205),
     /* 343631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 343634 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(343760), // Rule ID 4141 //
     /* 343639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343653 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343659 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343669 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343672 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343676 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343683 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 343700 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 343700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 343707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343727 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343759 */     // GIR_Coverage, 4141,
     /* 343759 */     GIR_EraseRootFromParent_Done,
     /* 343760 */   // Label 6954: @343760
     /* 343760 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(343886), // Rule ID 4142 //
     /* 343765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343779 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343785 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343795 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343798 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343802 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343809 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 343826 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 343826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 343833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343853 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343885 */     // GIR_Coverage, 4142,
     /* 343885 */     GIR_EraseRootFromParent_Done,
     /* 343886 */   // Label 6955: @343886
     /* 343886 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(344008), // Rule ID 4147 //
     /* 343891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343917 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343920 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343924 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343931 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 343948 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 343948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 343955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343975 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344007 */     // GIR_Coverage, 4147,
     /* 344007 */     GIR_EraseRootFromParent_Done,
     /* 344008 */   // Label 6956: @344008
     /* 344008 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(344130), // Rule ID 4149 //
     /* 344013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344039 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344042 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344046 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 344053 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 344070 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 344070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 344073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 344077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344097 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 344119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344129 */     // GIR_Coverage, 4149,
     /* 344129 */     GIR_EraseRootFromParent_Done,
     /* 344130 */   // Label 6957: @344130
     /* 344130 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(344251), // Rule ID 4139 //
     /* 344135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344149 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344155 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344165 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344168 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344172 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 344179 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 344196 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 344196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 344199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 344203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344218 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 344240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344250 */     // GIR_Coverage, 4139,
     /* 344250 */     GIR_EraseRootFromParent_Done,
     /* 344251 */   // Label 6958: @344251
     /* 344251 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(344372), // Rule ID 4140 //
     /* 344256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344270 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344276 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344286 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344289 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344293 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 344300 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 344317 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 344317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 344320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 344324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344339 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 344361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344371 */     // GIR_Coverage, 4140,
     /* 344371 */     GIR_EraseRootFromParent_Done,
     /* 344372 */   // Label 6959: @344372
     /* 344372 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(344489), // Rule ID 4143 //
     /* 344377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344406 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344410 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 344417 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 344434 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 344434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 344437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 344441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344456 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 344478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344488 */     // GIR_Coverage, 4143,
     /* 344488 */     GIR_EraseRootFromParent_Done,
     /* 344489 */   // Label 6960: @344489
     /* 344489 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(344606), // Rule ID 4145 //
     /* 344494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344520 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344523 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344527 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 344534 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 344551 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 344551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 344554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 344558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 344595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344605 */     // GIR_Coverage, 4145,
     /* 344605 */     GIR_EraseRootFromParent_Done,
     /* 344606 */   // Label 6961: @344606
     /* 344606 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(344694), // Rule ID 1931 //
     /* 344611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 344636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 344640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 344644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 344653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344657 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 344661 */     // MIs[2] Operand 1
     /* 344661 */     // No operand predicates
     /* 344661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 344665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344669 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 344673 */     // MIs[3] Operand 1
     /* 344673 */     // No operand predicates
     /* 344673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344675 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 344675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 344678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 344682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 344685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 344692 */     GIR_RootConstrainSelectedInstOperands,
     /* 344693 */     // GIR_Coverage, 1931,
     /* 344693 */     GIR_EraseRootFromParent_Done,
     /* 344694 */   // Label 6962: @344694
     /* 344694 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(344771), // Rule ID 5673 //
     /* 344699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 344721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 344725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 344729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 344738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344742 */     // MIs[2] Operand 1
     /* 344742 */     // No operand predicates
     /* 344742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 344746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344750 */     // MIs[3] Operand 1
     /* 344750 */     // No operand predicates
     /* 344750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344752 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 344752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 344755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 344759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 344762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 344769 */     GIR_RootConstrainSelectedInstOperands,
     /* 344770 */     // GIR_Coverage, 5673,
     /* 344770 */     GIR_EraseRootFromParent_Done,
     /* 344771 */   // Label 6963: @344771
     /* 344771 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(344879), // Rule ID 5674 //
     /* 344776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 344798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 344802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 344806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 344815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344819 */     // MIs[2] Operand 1
     /* 344819 */     // No operand predicates
     /* 344819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 344823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344827 */     // MIs[3] Operand 1
     /* 344827 */     // No operand predicates
     /* 344827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344829 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 344829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 344844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344848 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 344851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 344864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344866 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 344868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 344871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 344877 */     GIR_RootConstrainSelectedInstOperands,
     /* 344878 */     // GIR_Coverage, 5674,
     /* 344878 */     GIR_EraseRootFromParent_Done,
     /* 344879 */   // Label 6964: @344879
     /* 344879 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(344958), // Rule ID 5605 //
     /* 344884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344912 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 344912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 344928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344957 */     // GIR_Coverage, 5605,
     /* 344957 */     GIR_EraseRootFromParent_Done,
     /* 344958 */   // Label 6965: @344958
     /* 344958 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(345044), // Rule ID 6352 //
     /* 344963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344988 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 344992 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 344999 */     // MIs[1] Rn
     /* 344999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 345003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 345008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 345012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 345020 */     // MIs[2] Operand 1
     /* 345020 */     // No operand predicates
     /* 345020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345022 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 345022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 345025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 345029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 345032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345042 */     GIR_RootConstrainSelectedInstOperands,
     /* 345043 */     // GIR_Coverage, 6352,
     /* 345043 */     GIR_EraseRootFromParent_Done,
     /* 345044 */   // Label 6966: @345044
     /* 345044 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(345098), // Rule ID 1927 //
     /* 345049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 345074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 345082 */     // MIs[1] Operand 1
     /* 345082 */     // No operand predicates
     /* 345082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345084 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 345084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 345087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 345091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 345094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 345096 */     GIR_RootConstrainSelectedInstOperands,
     /* 345097 */     // GIR_Coverage, 1927,
     /* 345097 */     GIR_EraseRootFromParent_Done,
     /* 345098 */   // Label 6967: @345098
     /* 345098 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(345204), // Rule ID 5648 //
     /* 345103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 345106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 345121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 345125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 345133 */     // MIs[1] Operand 1
     /* 345133 */     // No operand predicates
     /* 345133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345135 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 345135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 345138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 345142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 345149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 345152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 345156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345161 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 345168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 345171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 345186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 345189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345202 */     GIR_RootConstrainSelectedInstOperands,
     /* 345203 */     // GIR_Coverage, 5648,
     /* 345203 */     GIR_EraseRootFromParent_Done,
     /* 345204 */   // Label 6968: @345204
     /* 345204 */   GIM_Reject,
     /* 345205 */ // Label 6953: @345205
     /* 345205 */ GIM_Reject,
     /* 345206 */ // Label 6769: @345206
     /* 345206 */ GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(345330), // Rule ID 11077 //
     /* 345211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 345214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 345217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345231 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345235 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 345235 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 345238 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 345242 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345247 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 345251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 345253 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 345256 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 345260 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345265 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 345268 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 345271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 345273 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 345276 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 345280 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345285 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 345288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 345290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 345293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 345297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345302 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345305 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 345308 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 345311 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 345314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 345319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 345321 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 345323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345326 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 345328 */   GIR_RootConstrainSelectedInstOperands,
     /* 345329 */   // GIR_Coverage, 11077,
     /* 345329 */   GIR_EraseRootFromParent_Done,
     /* 345330 */ // Label 6969: @345330
     /* 345330 */ GIM_Reject,
     /* 345331 */ // Label 6770: @345331
     /* 345331 */ GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(345455), // Rule ID 11080 //
     /* 345336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 345339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 345342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345345 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345356 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345360 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 345360 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 345363 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 345367 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345372 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 345376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 345378 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 345381 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 345385 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345390 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 345393 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 345396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 345398 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 345401 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 345405 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345410 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 345413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 345415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 345418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 345422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345427 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345430 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 345433 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 345436 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 345439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 345444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 345446 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 345448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345451 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 345453 */   GIR_RootConstrainSelectedInstOperands,
     /* 345454 */   // GIR_Coverage, 11080,
     /* 345454 */   GIR_EraseRootFromParent_Done,
     /* 345455 */ // Label 6970: @345455
     /* 345455 */ GIM_Reject,
     /* 345456 */ // Label 6771: @345456
     /* 345456 */ GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(347369),
     /* 345461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 345464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345474 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(345583), // Rule ID 4273 //
     /* 345479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345483 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345489 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345499 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345506 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 345523 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 345523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 345526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 345530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345550 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 345572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345582 */     // GIR_Coverage, 4273,
     /* 345582 */     GIR_EraseRootFromParent_Done,
     /* 345583 */   // Label 6972: @345583
     /* 345583 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(345692), // Rule ID 4274 //
     /* 345588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345592 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345598 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345608 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345615 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 345632 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 345632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 345635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 345639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345659 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 345681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345691 */     // GIR_Coverage, 4274,
     /* 345691 */     GIR_EraseRootFromParent_Done,
     /* 345692 */   // Label 6973: @345692
     /* 345692 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(345801), // Rule ID 4381 //
     /* 345697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345701 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345707 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345717 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345724 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 345741 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 345741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 345744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 345748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345768 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 345790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345800 */     // GIR_Coverage, 4381,
     /* 345800 */     GIR_EraseRootFromParent_Done,
     /* 345801 */   // Label 6974: @345801
     /* 345801 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(345910), // Rule ID 4382 //
     /* 345806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345810 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345816 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345826 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345833 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 345850 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 345850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 345853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 345857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345877 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 345899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345909 */     // GIR_Coverage, 4382,
     /* 345909 */     GIR_EraseRootFromParent_Done,
     /* 345910 */   // Label 6975: @345910
     /* 345910 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(346015), // Rule ID 4279 //
     /* 345915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345931 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345938 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 345955 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 345955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 345958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 345962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345982 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346014 */     // GIR_Coverage, 4279,
     /* 346014 */     GIR_EraseRootFromParent_Done,
     /* 346015 */   // Label 6976: @346015
     /* 346015 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(346120), // Rule ID 4281 //
     /* 346020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346036 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346043 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 346060 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 346060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 346067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346087 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346119 */     // GIR_Coverage, 4281,
     /* 346119 */     GIR_EraseRootFromParent_Done,
     /* 346120 */   // Label 6977: @346120
     /* 346120 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(346225), // Rule ID 4387 //
     /* 346125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346141 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346148 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 346165 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 346165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 346172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346192 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346224 */     // GIR_Coverage, 4387,
     /* 346224 */     GIR_EraseRootFromParent_Done,
     /* 346225 */   // Label 6978: @346225
     /* 346225 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(346330), // Rule ID 4389 //
     /* 346230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346246 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346253 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 346270 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 346270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 346277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346297 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346329 */     // GIR_Coverage, 4389,
     /* 346329 */     GIR_EraseRootFromParent_Done,
     /* 346330 */   // Label 6979: @346330
     /* 346330 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(346434), // Rule ID 4271 //
     /* 346335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346339 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346345 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346355 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346362 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 346379 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 346379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 346386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346401 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346433 */     // GIR_Coverage, 4271,
     /* 346433 */     GIR_EraseRootFromParent_Done,
     /* 346434 */   // Label 6980: @346434
     /* 346434 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(346538), // Rule ID 4272 //
     /* 346439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346443 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346449 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346459 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346466 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 346483 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 346483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 346490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346505 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346537 */     // GIR_Coverage, 4272,
     /* 346537 */     GIR_EraseRootFromParent_Done,
     /* 346538 */   // Label 6981: @346538
     /* 346538 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(346642), // Rule ID 4379 //
     /* 346543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346547 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346553 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346563 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346566 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346570 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 346587 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 346587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 346594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346609 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346641 */     // GIR_Coverage, 4379,
     /* 346641 */     GIR_EraseRootFromParent_Done,
     /* 346642 */   // Label 6982: @346642
     /* 346642 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(346746), // Rule ID 4380 //
     /* 346647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346667 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346674 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 346691 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 346691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 346698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346713 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346745 */     // GIR_Coverage, 4380,
     /* 346745 */     GIR_EraseRootFromParent_Done,
     /* 346746 */   // Label 6983: @346746
     /* 346746 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(346846), // Rule ID 4275 //
     /* 346751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346767 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346774 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 346791 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 346791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 346798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346813 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346845 */     // GIR_Coverage, 4275,
     /* 346845 */     GIR_EraseRootFromParent_Done,
     /* 346846 */   // Label 6984: @346846
     /* 346846 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(346946), // Rule ID 4277 //
     /* 346851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346867 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346870 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346874 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 346891 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 346891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 346898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346913 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 346935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346945 */     // GIR_Coverage, 4277,
     /* 346945 */     GIR_EraseRootFromParent_Done,
     /* 346946 */   // Label 6985: @346946
     /* 346946 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(347046), // Rule ID 4383 //
     /* 346951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346967 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346974 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 346991 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 346991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 346994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 346998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347013 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 347035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347045 */     // GIR_Coverage, 4383,
     /* 347045 */     GIR_EraseRootFromParent_Done,
     /* 347046 */   // Label 6986: @347046
     /* 347046 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(347146), // Rule ID 4385 //
     /* 347051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347067 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347074 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 347091 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 347091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 347094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 347098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347113 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 347135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347145 */     // GIR_Coverage, 4385,
     /* 347145 */     GIR_EraseRootFromParent_Done,
     /* 347146 */   // Label 6987: @347146
     /* 347146 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(347257), // Rule ID 11076 //
     /* 347151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 347154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347162 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 347162 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 347165 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 347169 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347174 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 347178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 347180 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 347183 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 347187 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347192 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 347195 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 347198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347200 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 347203 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 347207 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347212 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 347215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 347217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 347220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 347224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347232 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 347235 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 347238 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 347241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 347246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 347248 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 347250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 347255 */     GIR_RootConstrainSelectedInstOperands,
     /* 347256 */     // GIR_Coverage, 11076,
     /* 347256 */     GIR_EraseRootFromParent_Done,
     /* 347257 */   // Label 6988: @347257
     /* 347257 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(347368), // Rule ID 11082 //
     /* 347262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 347265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347273 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 347273 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 347276 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 347280 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347285 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 347289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 347291 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 347294 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 347298 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347303 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 347306 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 347309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 347314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 347318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347323 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 347326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 347328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 347331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 347335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347340 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347343 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 347346 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 347349 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 347352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 347357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 347359 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 347361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347364 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 347366 */     GIR_RootConstrainSelectedInstOperands,
     /* 347367 */     // GIR_Coverage, 11082,
     /* 347367 */     GIR_EraseRootFromParent_Done,
     /* 347368 */   // Label 6989: @347368
     /* 347368 */   GIM_Reject,
     /* 347369 */ // Label 6971: @347369
     /* 347369 */ GIM_Reject,
     /* 347370 */ // Label 6772: @347370
     /* 347370 */ GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(347521), // Rule ID 11078 //
     /* 347375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 347378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 347381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347399 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 347399 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 347402 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347406 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347411 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 347417 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347422 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347427 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 347430 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 347434 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347439 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 347442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 347444 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 347447 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 347451 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347456 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 347459 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 347462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 347464 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 347467 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 347471 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347476 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 347479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 347481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 347484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 347488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347493 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 347499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 347502 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 347505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 347510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 347512 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 347514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347517 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 347519 */   GIR_RootConstrainSelectedInstOperands,
     /* 347520 */   // GIR_Coverage, 11078,
     /* 347520 */   GIR_EraseRootFromParent_Done,
     /* 347521 */ // Label 6990: @347521
     /* 347521 */ GIM_Reject,
     /* 347522 */ // Label 6773: @347522
     /* 347522 */ GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(349489),
     /* 347527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 347530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347533 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347540 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(347649), // Rule ID 4237 //
     /* 347545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347549 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347555 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347565 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347572 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 347589 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 347596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347616 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347648 */     // GIR_Coverage, 4237,
     /* 347648 */     GIR_EraseRootFromParent_Done,
     /* 347649 */   // Label 6992: @347649
     /* 347649 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(347758), // Rule ID 4238 //
     /* 347654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347658 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347664 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347674 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347677 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347681 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 347698 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 347705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347757 */     // GIR_Coverage, 4238,
     /* 347757 */     GIR_EraseRootFromParent_Done,
     /* 347758 */   // Label 6993: @347758
     /* 347758 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(347867), // Rule ID 4345 //
     /* 347763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347767 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347773 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347783 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347790 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 347807 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 347814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347834 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347866 */     // GIR_Coverage, 4345,
     /* 347866 */     GIR_EraseRootFromParent_Done,
     /* 347867 */   // Label 6994: @347867
     /* 347867 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(347976), // Rule ID 4346 //
     /* 347872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347892 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347899 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 347916 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 347923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347943 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347975 */     // GIR_Coverage, 4346,
     /* 347975 */     GIR_EraseRootFromParent_Done,
     /* 347976 */   // Label 6995: @347976
     /* 347976 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(348081), // Rule ID 4243 //
     /* 347981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347997 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348004 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 348021 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 348028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348048 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348080 */     // GIR_Coverage, 4243,
     /* 348080 */     GIR_EraseRootFromParent_Done,
     /* 348081 */   // Label 6996: @348081
     /* 348081 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(348186), // Rule ID 4245 //
     /* 348086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348102 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348109 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 348126 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 348133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348153 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348185 */     // GIR_Coverage, 4245,
     /* 348185 */     GIR_EraseRootFromParent_Done,
     /* 348186 */   // Label 6997: @348186
     /* 348186 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(348291), // Rule ID 4351 //
     /* 348191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348207 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348214 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 348231 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 348238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348258 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348290 */     // GIR_Coverage, 4351,
     /* 348290 */     GIR_EraseRootFromParent_Done,
     /* 348291 */   // Label 6998: @348291
     /* 348291 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(348396), // Rule ID 4353 //
     /* 348296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348312 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348319 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 348336 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 348336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 348343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348363 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348395 */     // GIR_Coverage, 4353,
     /* 348395 */     GIR_EraseRootFromParent_Done,
     /* 348396 */   // Label 6999: @348396
     /* 348396 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(348500), // Rule ID 4235 //
     /* 348401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348405 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348411 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348421 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348424 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348428 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 348445 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 348445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 348452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348467 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348499 */     // GIR_Coverage, 4235,
     /* 348499 */     GIR_EraseRootFromParent_Done,
     /* 348500 */   // Label 7000: @348500
     /* 348500 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(348604), // Rule ID 4236 //
     /* 348505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348509 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348515 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348525 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348528 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348532 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 348549 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 348549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 348556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348571 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348603 */     // GIR_Coverage, 4236,
     /* 348603 */     GIR_EraseRootFromParent_Done,
     /* 348604 */   // Label 7001: @348604
     /* 348604 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(348708), // Rule ID 4343 //
     /* 348609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348613 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348619 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348629 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348636 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 348653 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 348653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 348660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348675 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348707 */     // GIR_Coverage, 4343,
     /* 348707 */     GIR_EraseRootFromParent_Done,
     /* 348708 */   // Label 7002: @348708
     /* 348708 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(348812), // Rule ID 4344 //
     /* 348713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348717 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348733 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348736 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348740 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 348757 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 348757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 348764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348779 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348811 */     // GIR_Coverage, 4344,
     /* 348811 */     GIR_EraseRootFromParent_Done,
     /* 348812 */   // Label 7003: @348812
     /* 348812 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(348912), // Rule ID 4239 //
     /* 348817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348833 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348840 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 348857 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 348857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 348864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348879 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348911 */     // GIR_Coverage, 4239,
     /* 348911 */     GIR_EraseRootFromParent_Done,
     /* 348912 */   // Label 7004: @348912
     /* 348912 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(349012), // Rule ID 4241 //
     /* 348917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348933 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348940 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 348957 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 348957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 348964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348979 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349011 */     // GIR_Coverage, 4241,
     /* 349011 */     GIR_EraseRootFromParent_Done,
     /* 349012 */   // Label 7005: @349012
     /* 349012 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(349112), // Rule ID 4347 //
     /* 349017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349033 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349040 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 349057 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 349057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 349064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349079 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349111 */     // GIR_Coverage, 4347,
     /* 349111 */     GIR_EraseRootFromParent_Done,
     /* 349112 */   // Label 7006: @349112
     /* 349112 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(349212), // Rule ID 4349 //
     /* 349117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349133 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349140 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 349157 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 349157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 349164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349179 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349211 */     // GIR_Coverage, 4349,
     /* 349211 */     GIR_EraseRootFromParent_Done,
     /* 349212 */   // Label 7007: @349212
     /* 349212 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(349350), // Rule ID 11075 //
     /* 349217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349228 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 349228 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 349231 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349235 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349240 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 349246 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349251 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349256 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 349259 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 349263 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349268 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 349271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 349273 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 349276 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 349280 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349285 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 349288 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 349291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 349300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349305 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 349308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 349317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349322 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349325 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 349328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349331 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 349334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 349339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 349341 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 349343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349346 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 349348 */     GIR_RootConstrainSelectedInstOperands,
     /* 349349 */     // GIR_Coverage, 11075,
     /* 349349 */     GIR_EraseRootFromParent_Done,
     /* 349350 */   // Label 7008: @349350
     /* 349350 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(349488), // Rule ID 11081 //
     /* 349355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349366 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 349366 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 349369 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349373 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349378 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 349384 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349389 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349394 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 349397 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 349401 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349406 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 349409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 349411 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 349414 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 349418 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349423 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 349426 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 349429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 349438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349443 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 349446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 349455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349460 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 349466 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349469 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 349472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 349477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 349479 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 349481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349484 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 349486 */     GIR_RootConstrainSelectedInstOperands,
     /* 349487 */     // GIR_Coverage, 11081,
     /* 349487 */     GIR_EraseRootFromParent_Done,
     /* 349488 */   // Label 7009: @349488
     /* 349488 */   GIM_Reject,
     /* 349489 */ // Label 6991: @349489
     /* 349489 */ GIM_Reject,
     /* 349490 */ // Label 6774: @349490
     /* 349490 */ GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(351683),
     /* 349495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 349498 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(349624), // Rule ID 4201 //
     /* 349503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349517 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349523 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349533 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349536 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349540 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349547 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349557 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349564 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349591 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349623 */     // GIR_Coverage, 4201,
     /* 349623 */     GIR_EraseRootFromParent_Done,
     /* 349624 */   // Label 7011: @349624
     /* 349624 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(349750), // Rule ID 4202 //
     /* 349629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349643 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349649 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349659 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349662 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349666 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349673 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349690 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349717 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349749 */     // GIR_Coverage, 4202,
     /* 349749 */     GIR_EraseRootFromParent_Done,
     /* 349750 */   // Label 7012: @349750
     /* 349750 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(349869), // Rule ID 4309 //
     /* 349755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349769 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349775 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349785 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349792 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349809 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349836 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349868 */     // GIR_Coverage, 4309,
     /* 349868 */     GIR_EraseRootFromParent_Done,
     /* 349869 */   // Label 7013: @349869
     /* 349869 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(349988), // Rule ID 4310 //
     /* 349874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349888 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349894 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349904 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349911 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349928 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349987 */     // GIR_Coverage, 4310,
     /* 349987 */     GIR_EraseRootFromParent_Done,
     /* 349988 */   // Label 7014: @349988
     /* 349988 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(350110), // Rule ID 4207 //
     /* 349993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350019 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350022 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350026 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350033 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350043 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 350050 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 350050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 350057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350077 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350109 */     // GIR_Coverage, 4207,
     /* 350109 */     GIR_EraseRootFromParent_Done,
     /* 350110 */   // Label 7015: @350110
     /* 350110 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(350232), // Rule ID 4209 //
     /* 350115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350141 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350144 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350148 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 350172 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 350172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 350179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350199 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350231 */     // GIR_Coverage, 4209,
     /* 350231 */     GIR_EraseRootFromParent_Done,
     /* 350232 */   // Label 7016: @350232
     /* 350232 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(350347), // Rule ID 4315 //
     /* 350237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350263 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350270 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 350287 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 350287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 350294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350346 */     // GIR_Coverage, 4315,
     /* 350346 */     GIR_EraseRootFromParent_Done,
     /* 350347 */   // Label 7017: @350347
     /* 350347 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(350462), // Rule ID 4317 //
     /* 350352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350378 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350385 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 350402 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 350402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 350409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350429 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350461 */     // GIR_Coverage, 4317,
     /* 350461 */     GIR_EraseRootFromParent_Done,
     /* 350462 */   // Label 7018: @350462
     /* 350462 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(350583), // Rule ID 4199 //
     /* 350467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350481 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350487 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350497 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350500 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350504 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350511 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350528 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350550 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350582 */     // GIR_Coverage, 4199,
     /* 350582 */     GIR_EraseRootFromParent_Done,
     /* 350583 */   // Label 7019: @350583
     /* 350583 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(350704), // Rule ID 4200 //
     /* 350588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350602 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350608 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350618 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350621 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350625 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350632 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350649 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350671 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350703 */     // GIR_Coverage, 4200,
     /* 350703 */     GIR_EraseRootFromParent_Done,
     /* 350704 */   // Label 7020: @350704
     /* 350704 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(350818), // Rule ID 4307 //
     /* 350709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350723 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350739 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350742 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350746 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350763 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350817 */     // GIR_Coverage, 4307,
     /* 350817 */     GIR_EraseRootFromParent_Done,
     /* 350818 */   // Label 7021: @350818
     /* 350818 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(350932), // Rule ID 4308 //
     /* 350823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350837 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350843 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350853 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350860 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350877 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350899 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350931 */     // GIR_Coverage, 4308,
     /* 350931 */     GIR_EraseRootFromParent_Done,
     /* 350932 */   // Label 7022: @350932
     /* 350932 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(351049), // Rule ID 4203 //
     /* 350937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350963 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350966 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350970 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350977 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350994 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 351001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351016 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351048 */     // GIR_Coverage, 4203,
     /* 351048 */     GIR_EraseRootFromParent_Done,
     /* 351049 */   // Label 7023: @351049
     /* 351049 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(351166), // Rule ID 4205 //
     /* 351054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351080 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351083 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351087 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 351094 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 351111 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 351111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 351118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351133 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351165 */     // GIR_Coverage, 4205,
     /* 351165 */     GIR_EraseRootFromParent_Done,
     /* 351166 */   // Label 7024: @351166
     /* 351166 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(351276), // Rule ID 4311 //
     /* 351171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351197 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351200 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351204 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 351221 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 351221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 351228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351243 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351275 */     // GIR_Coverage, 4311,
     /* 351275 */     GIR_EraseRootFromParent_Done,
     /* 351276 */   // Label 7025: @351276
     /* 351276 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(351386), // Rule ID 4313 //
     /* 351281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351307 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351314 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 351331 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 351331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 351338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351353 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351385 */     // GIR_Coverage, 4313,
     /* 351385 */     GIR_EraseRootFromParent_Done,
     /* 351386 */   // Label 7026: @351386
     /* 351386 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(351534), // Rule ID 11074 //
     /* 351391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351412 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 351412 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 351415 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351419 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351424 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 351430 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351435 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351440 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 351443 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 351447 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351452 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 351455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 351457 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 351460 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 351464 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351469 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 351472 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 351475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 351484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351489 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 351492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 351501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351506 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351509 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 351512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 351515 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 351523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351525 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 351532 */     GIR_RootConstrainSelectedInstOperands,
     /* 351533 */     // GIR_Coverage, 11074,
     /* 351533 */     GIR_EraseRootFromParent_Done,
     /* 351534 */   // Label 7027: @351534
     /* 351534 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(351682), // Rule ID 11079 //
     /* 351539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351560 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 351560 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 351563 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351567 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351572 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 351578 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351583 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351588 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 351591 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 351595 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351600 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 351603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 351605 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 351608 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 351612 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351617 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 351620 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 351623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351625 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351628 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 351632 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351637 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 351640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 351649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351654 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 351660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 351663 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 351671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351673 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 351680 */     GIR_RootConstrainSelectedInstOperands,
     /* 351681 */     // GIR_Coverage, 11079,
     /* 351681 */     GIR_EraseRootFromParent_Done,
     /* 351682 */   // Label 7028: @351682
     /* 351682 */   GIM_Reject,
     /* 351683 */ // Label 7010: @351683
     /* 351683 */ GIM_Reject,
     /* 351684 */ // Label 6775: @351684
     /* 351684 */ GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(352733),
     /* 351689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 351692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351702 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(351818), // Rule ID 4165 //
     /* 351707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351727 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351730 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351734 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351741 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 351758 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 351765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351817 */     // GIR_Coverage, 4165,
     /* 351817 */     GIR_EraseRootFromParent_Done,
     /* 351818 */   // Label 7030: @351818
     /* 351818 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(351934), // Rule ID 4166 //
     /* 351823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351827 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351833 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351843 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351846 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351850 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351857 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 351874 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 351881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351901 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351933 */     // GIR_Coverage, 4166,
     /* 351933 */     GIR_EraseRootFromParent_Done,
     /* 351934 */   // Label 7031: @351934
     /* 351934 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(352046), // Rule ID 4171 //
     /* 351939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351955 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351958 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351962 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351969 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 351986 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 351993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352013 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352045 */     // GIR_Coverage, 4171,
     /* 352045 */     GIR_EraseRootFromParent_Done,
     /* 352046 */   // Label 7032: @352046
     /* 352046 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(352158), // Rule ID 4173 //
     /* 352051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352067 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352070 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352074 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352081 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 352098 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 352105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352157 */     // GIR_Coverage, 4173,
     /* 352157 */     GIR_EraseRootFromParent_Done,
     /* 352158 */   // Label 7033: @352158
     /* 352158 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(352269), // Rule ID 4163 //
     /* 352163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352167 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352173 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352183 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352186 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352190 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352197 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 352214 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 352214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 352221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352236 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352268 */     // GIR_Coverage, 4163,
     /* 352268 */     GIR_EraseRootFromParent_Done,
     /* 352269 */   // Label 7034: @352269
     /* 352269 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(352380), // Rule ID 4164 //
     /* 352274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352278 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352284 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352294 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352297 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352301 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352308 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 352325 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 352325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 352332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352347 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352379 */     // GIR_Coverage, 4164,
     /* 352379 */     GIR_EraseRootFromParent_Done,
     /* 352380 */   // Label 7035: @352380
     /* 352380 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(352487), // Rule ID 4167 //
     /* 352385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352401 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352404 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352408 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352415 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 352432 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 352432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 352439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352454 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352486 */     // GIR_Coverage, 4167,
     /* 352486 */     GIR_EraseRootFromParent_Done,
     /* 352487 */   // Label 7036: @352487
     /* 352487 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(352594), // Rule ID 4169 //
     /* 352492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352508 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352511 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352515 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352522 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 352539 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 352539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 352546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352561 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352593 */     // GIR_Coverage, 4169,
     /* 352593 */     GIR_EraseRootFromParent_Done,
     /* 352594 */   // Label 7037: @352594
     /* 352594 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(352732), // Rule ID 11073 //
     /* 352599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352610 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 352610 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 352613 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352617 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352622 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 352628 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352633 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352638 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 352641 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 352645 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352650 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 352653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 352655 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 352658 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 352662 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352667 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 352670 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 352673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 352682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352687 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 352690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 352699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352707 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 352710 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 352713 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 352721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352723 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352728 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 352730 */     GIR_RootConstrainSelectedInstOperands,
     /* 352731 */     // GIR_Coverage, 11073,
     /* 352731 */     GIR_EraseRootFromParent_Done,
     /* 352732 */   // Label 7038: @352732
     /* 352732 */   GIM_Reject,
     /* 352733 */ // Label 7029: @352733
     /* 352733 */ GIM_Reject,
     /* 352734 */ // Label 6776: @352734
     /* 352734 */ GIM_Reject,
     /* 352735 */ // Label 89: @352735
     /* 352735 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7042*/ GIMT_Encode4(355652),
     /* 352746 */ /*GILLT_s16*//*Label 7039*/ GIMT_Encode4(352758),
     /* 352750 */ /*GILLT_s32*//*Label 7040*/ GIMT_Encode4(353392),
     /* 352754 */ /*GILLT_s64*//*Label 7041*/ GIMT_Encode4(354985),
     /* 352758 */ // Label 7039: @352758
     /* 352758 */ GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(352802), // Rule ID 11122 //
     /* 352763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352776 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352780 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 352780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352785 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 352791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352796 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352801 */   // GIR_Coverage, 11122,
     /* 352801 */   GIR_EraseRootFromParent_Done,
     /* 352802 */ // Label 7043: @352802
     /* 352802 */ GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(352846), // Rule ID 11123 //
     /* 352807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352820 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352824 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 352824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352829 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 352835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352845 */   // GIR_Coverage, 11123,
     /* 352845 */   GIR_EraseRootFromParent_Done,
     /* 352846 */ // Label 7044: @352846
     /* 352846 */ GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(352890), // Rule ID 11124 //
     /* 352851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 352857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352864 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352868 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 352868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352873 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 352879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352884 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352889 */   // GIR_Coverage, 11124,
     /* 352889 */   GIR_EraseRootFromParent_Done,
     /* 352890 */ // Label 7045: @352890
     /* 352890 */ GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(352935), // Rule ID 5704 //
     /* 352895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 352898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352909 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352913 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 352913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352918 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 352924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352934 */   // GIR_Coverage, 5704,
     /* 352934 */   GIR_EraseRootFromParent_Done,
     /* 352935 */ // Label 7046: @352935
     /* 352935 */ GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(352980), // Rule ID 5707 //
     /* 352940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 352943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352962 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352966 */   // MIs[1] Operand 1
     /* 352966 */   // No operand predicates
     /* 352966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352968 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 352968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 352971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352973 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352975 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352978 */   GIR_RootConstrainSelectedInstOperands,
     /* 352979 */   // GIR_Coverage, 5707,
     /* 352979 */   GIR_EraseRootFromParent_Done,
     /* 352980 */ // Label 7047: @352980
     /* 352980 */ GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(353056), // Rule ID 11097 //
     /* 352985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353006 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 353010 */   // MIs[1] Operand 1
     /* 353010 */   // No operand predicates
     /* 353010 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353012 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 353012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353024 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 353028 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 353031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353038 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 353045 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353050 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353055 */   // GIR_Coverage, 11097,
     /* 353055 */   GIR_EraseRootFromParent_Done,
     /* 353056 */ // Label 7048: @353056
     /* 353056 */ GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(353132), // Rule ID 11098 //
     /* 353061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 353067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353082 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353086 */   // MIs[1] Operand 1
     /* 353086 */   // No operand predicates
     /* 353086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353088 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 353088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353100 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 353104 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 353107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353114 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 353121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353131 */   // GIR_Coverage, 11098,
     /* 353131 */   GIR_EraseRootFromParent_Done,
     /* 353132 */ // Label 7049: @353132
     /* 353132 */ GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(353208), // Rule ID 11099 //
     /* 353137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 353143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353158 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353162 */   // MIs[1] Operand 1
     /* 353162 */   // No operand predicates
     /* 353162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353164 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 353164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353176 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 353180 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 353183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353190 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 353197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353207 */   // GIR_Coverage, 11099,
     /* 353207 */   GIR_EraseRootFromParent_Done,
     /* 353208 */ // Label 7050: @353208
     /* 353208 */ GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(353269), // Rule ID 11087 //
     /* 353213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353230 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 353230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 353237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353242 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 353248 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 353252 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 353260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 353262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353265 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353267 */   GIR_RootConstrainSelectedInstOperands,
     /* 353268 */   // GIR_Coverage, 11087,
     /* 353268 */   GIR_EraseRootFromParent_Done,
     /* 353269 */ // Label 7051: @353269
     /* 353269 */ GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(353330), // Rule ID 11088 //
     /* 353274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 353280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353291 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 353291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 353298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353303 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 353309 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 353313 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 353321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 353323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353326 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353328 */   GIR_RootConstrainSelectedInstOperands,
     /* 353329 */   // GIR_Coverage, 11088,
     /* 353329 */   GIR_EraseRootFromParent_Done,
     /* 353330 */ // Label 7052: @353330
     /* 353330 */ GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(353391), // Rule ID 11089 //
     /* 353335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 353341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353352 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 353352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 353359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353364 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 353370 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 353374 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 353382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 353384 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353387 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353389 */   GIR_RootConstrainSelectedInstOperands,
     /* 353390 */   // GIR_Coverage, 11089,
     /* 353390 */   GIR_EraseRootFromParent_Done,
     /* 353391 */ // Label 7053: @353391
     /* 353391 */ GIM_Reject,
     /* 353392 */ // Label 7040: @353392
     /* 353392 */ GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(353437), // Rule ID 6879 //
     /* 353397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 353400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353411 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 353415 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 353415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353420 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 353426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353436 */   // GIR_Coverage, 6879,
     /* 353436 */   GIR_EraseRootFromParent_Done,
     /* 353437 */ // Label 7054: @353437
     /* 353437 */ GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(353482), // Rule ID 6880 //
     /* 353442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 353445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353456 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 353460 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 353460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353465 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 353471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353481 */   // GIR_Coverage, 6880,
     /* 353481 */   GIR_EraseRootFromParent_Done,
     /* 353482 */ // Label 7055: @353482
     /* 353482 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(353526), // Rule ID 11118 //
     /* 353487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 353493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353500 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 353504 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 353504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353509 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 353515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353525 */   // GIR_Coverage, 11118,
     /* 353525 */   GIR_EraseRootFromParent_Done,
     /* 353526 */ // Label 7056: @353526
     /* 353526 */ GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(353570), // Rule ID 11119 //
     /* 353531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353544 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 353548 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 353548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353553 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 353559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353564 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353569 */   // GIR_Coverage, 11119,
     /* 353569 */   GIR_EraseRootFromParent_Done,
     /* 353570 */ // Label 7057: @353570
     /* 353570 */ GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(353614), // Rule ID 11120 //
     /* 353575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353588 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 353592 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 353592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353597 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 353603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353613 */   // GIR_Coverage, 11120,
     /* 353613 */   GIR_EraseRootFromParent_Done,
     /* 353614 */ // Label 7058: @353614
     /* 353614 */ GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(353658), // Rule ID 11125 //
     /* 353619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353632 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 353636 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 353636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353641 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 353647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353657 */   // GIR_Coverage, 11125,
     /* 353657 */   GIR_EraseRootFromParent_Done,
     /* 353658 */ // Label 7059: @353658
     /* 353658 */ GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(353702), // Rule ID 11126 //
     /* 353663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 353669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353676 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 353680 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 353680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353685 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 353691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353701 */   // GIR_Coverage, 11126,
     /* 353701 */   GIR_EraseRootFromParent_Done,
     /* 353702 */ // Label 7060: @353702
     /* 353702 */ GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(353747), // Rule ID 5703 //
     /* 353707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 353710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353721 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 353725 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 353725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353730 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 353736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353746 */   // GIR_Coverage, 5703,
     /* 353746 */   GIR_EraseRootFromParent_Done,
     /* 353747 */ // Label 7061: @353747
     /* 353747 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(353820), // Rule ID 11103 //
     /* 353752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 353758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353773 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353777 */   // MIs[1] Operand 1
     /* 353777 */   // No operand predicates
     /* 353777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353779 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 353779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 353782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353791 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 353797 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353802 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 353810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 353812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353815 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 353818 */   GIR_RootConstrainSelectedInstOperands,
     /* 353819 */   // GIR_Coverage, 11103,
     /* 353819 */   GIR_EraseRootFromParent_Done,
     /* 353820 */ // Label 7062: @353820
     /* 353820 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(353893), // Rule ID 11104 //
     /* 353825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353846 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 353850 */   // MIs[1] Operand 1
     /* 353850 */   // No operand predicates
     /* 353850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353852 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 353852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 353855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353864 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 353870 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353875 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 353883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 353885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353888 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 353891 */   GIR_RootConstrainSelectedInstOperands,
     /* 353892 */   // GIR_Coverage, 11104,
     /* 353892 */   GIR_EraseRootFromParent_Done,
     /* 353893 */ // Label 7063: @353893
     /* 353893 */ GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(353966), // Rule ID 11105 //
     /* 353898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353919 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 353923 */   // MIs[1] Operand 1
     /* 353923 */   // No operand predicates
     /* 353923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353925 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 353925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 353928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353937 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 353943 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353948 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 353956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 353958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353961 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 353964 */   GIR_RootConstrainSelectedInstOperands,
     /* 353965 */   // GIR_Coverage, 11105,
     /* 353965 */   GIR_EraseRootFromParent_Done,
     /* 353966 */ // Label 7064: @353966
     /* 353966 */ GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(354014), // Rule ID 1919 //
     /* 353971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 353974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 353977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353996 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 354000 */   // MIs[1] Operand 1
     /* 354000 */   // No operand predicates
     /* 354000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354002 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 354002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 354005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354007 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354009 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 354012 */   GIR_RootConstrainSelectedInstOperands,
     /* 354013 */   // GIR_Coverage, 1919,
     /* 354013 */   GIR_EraseRootFromParent_Done,
     /* 354014 */ // Label 7065: @354014
     /* 354014 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(354062), // Rule ID 1920 //
     /* 354019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 354022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 354025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354044 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 354048 */   // MIs[1] Operand 1
     /* 354048 */   // No operand predicates
     /* 354048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354050 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 354050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 354053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354055 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354057 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 354060 */   GIR_RootConstrainSelectedInstOperands,
     /* 354061 */   // GIR_Coverage, 1920,
     /* 354061 */   GIR_EraseRootFromParent_Done,
     /* 354062 */ // Label 7066: @354062
     /* 354062 */ GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(354110), // Rule ID 1921 //
     /* 354067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 354070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 354073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354092 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 354096 */   // MIs[1] Operand 1
     /* 354096 */   // No operand predicates
     /* 354096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354098 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 354098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 354101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354103 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354105 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 354108 */   GIR_RootConstrainSelectedInstOperands,
     /* 354109 */   // GIR_Coverage, 1921,
     /* 354109 */   GIR_EraseRootFromParent_Done,
     /* 354110 */ // Label 7067: @354110
     /* 354110 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(354158), // Rule ID 1923 //
     /* 354115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 354121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354140 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 354144 */   // MIs[1] Operand 1
     /* 354144 */   // No operand predicates
     /* 354144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354146 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 354146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 354149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354151 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354153 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 354156 */   GIR_RootConstrainSelectedInstOperands,
     /* 354157 */   // GIR_Coverage, 1923,
     /* 354157 */   GIR_EraseRootFromParent_Done,
     /* 354158 */ // Label 7068: @354158
     /* 354158 */ GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(354206), // Rule ID 1924 //
     /* 354163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 354169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354180 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354184 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354188 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354192 */   // MIs[1] Operand 1
     /* 354192 */   // No operand predicates
     /* 354192 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354194 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 354194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 354197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354199 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354201 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 354204 */   GIR_RootConstrainSelectedInstOperands,
     /* 354205 */   // GIR_Coverage, 1924,
     /* 354205 */   GIR_EraseRootFromParent_Done,
     /* 354206 */ // Label 7069: @354206
     /* 354206 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(354254), // Rule ID 1925 //
     /* 354211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 354217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354236 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 354240 */   // MIs[1] Operand 1
     /* 354240 */   // No operand predicates
     /* 354240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354242 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 354242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 354245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354247 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354249 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 354252 */   GIR_RootConstrainSelectedInstOperands,
     /* 354253 */   // GIR_Coverage, 1925,
     /* 354253 */   GIR_EraseRootFromParent_Done,
     /* 354254 */ // Label 7070: @354254
     /* 354254 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(354299), // Rule ID 5706 //
     /* 354259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 354262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354281 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 354285 */   // MIs[1] Operand 1
     /* 354285 */   // No operand predicates
     /* 354285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354287 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 354287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 354290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354292 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354294 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 354297 */   GIR_RootConstrainSelectedInstOperands,
     /* 354298 */   // GIR_Coverage, 5706,
     /* 354298 */   GIR_EraseRootFromParent_Done,
     /* 354299 */ // Label 7071: @354299
     /* 354299 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(354375), // Rule ID 11093 //
     /* 354304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 354310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354325 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 354329 */   // MIs[1] Operand 1
     /* 354329 */   // No operand predicates
     /* 354329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354331 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 354331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 354338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354343 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 354347 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 354350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354357 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 354364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354374 */   // GIR_Coverage, 11093,
     /* 354374 */   GIR_EraseRootFromParent_Done,
     /* 354375 */ // Label 7072: @354375
     /* 354375 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(354451), // Rule ID 11094 //
     /* 354380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354393 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354401 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 354405 */   // MIs[1] Operand 1
     /* 354405 */   // No operand predicates
     /* 354405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354407 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 354407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 354423 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 354426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354433 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 354440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354450 */   // GIR_Coverage, 11094,
     /* 354450 */   GIR_EraseRootFromParent_Done,
     /* 354451 */ // Label 7073: @354451
     /* 354451 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(354527), // Rule ID 11095 //
     /* 354456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 354462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354477 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 354481 */   // MIs[1] Operand 1
     /* 354481 */   // No operand predicates
     /* 354481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354483 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 354483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 354490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354495 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 354499 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 354502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354509 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 354516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354526 */   // GIR_Coverage, 11095,
     /* 354526 */   GIR_EraseRootFromParent_Done,
     /* 354527 */ // Label 7074: @354527
     /* 354527 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(354603), // Rule ID 11100 //
     /* 354532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 354538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354553 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 354557 */   // MIs[1] Operand 1
     /* 354557 */   // No operand predicates
     /* 354557 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354559 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 354559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 354566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354571 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 354575 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 354578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354585 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 354592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354602 */   // GIR_Coverage, 11100,
     /* 354602 */   GIR_EraseRootFromParent_Done,
     /* 354603 */ // Label 7075: @354603
     /* 354603 */ GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(354679), // Rule ID 11101 //
     /* 354608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 354614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354629 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 354633 */   // MIs[1] Operand 1
     /* 354633 */   // No operand predicates
     /* 354633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354635 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 354635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 354642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354647 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 354651 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 354654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354661 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 354668 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354673 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354678 */   // GIR_Coverage, 11101,
     /* 354678 */   GIR_EraseRootFromParent_Done,
     /* 354679 */ // Label 7076: @354679
     /* 354679 */ GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(354740), // Rule ID 11083 //
     /* 354684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 354690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354701 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 354701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 354708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354713 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 354719 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 354723 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 354731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354736 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354738 */   GIR_RootConstrainSelectedInstOperands,
     /* 354739 */   // GIR_Coverage, 11083,
     /* 354739 */   GIR_EraseRootFromParent_Done,
     /* 354740 */ // Label 7077: @354740
     /* 354740 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(354801), // Rule ID 11084 //
     /* 354745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354762 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 354762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 354769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354774 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 354780 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 354784 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 354792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354797 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354799 */   GIR_RootConstrainSelectedInstOperands,
     /* 354800 */   // GIR_Coverage, 11084,
     /* 354800 */   GIR_EraseRootFromParent_Done,
     /* 354801 */ // Label 7078: @354801
     /* 354801 */ GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(354862), // Rule ID 11085 //
     /* 354806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 354812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354823 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 354823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 354830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354835 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 354841 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 354845 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 354853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354858 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354860 */   GIR_RootConstrainSelectedInstOperands,
     /* 354861 */   // GIR_Coverage, 11085,
     /* 354861 */   GIR_EraseRootFromParent_Done,
     /* 354862 */ // Label 7079: @354862
     /* 354862 */ GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(354923), // Rule ID 11090 //
     /* 354867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 354873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354884 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 354884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 354891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354896 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 354902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 354906 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 354914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 354916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354919 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354921 */   GIR_RootConstrainSelectedInstOperands,
     /* 354922 */   // GIR_Coverage, 11090,
     /* 354922 */   GIR_EraseRootFromParent_Done,
     /* 354923 */ // Label 7080: @354923
     /* 354923 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(354984), // Rule ID 11091 //
     /* 354928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 354934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354945 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 354945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 354952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354957 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 354963 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 354967 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 354975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 354977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354980 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354982 */   GIR_RootConstrainSelectedInstOperands,
     /* 354983 */   // GIR_Coverage, 11091,
     /* 354983 */   GIR_EraseRootFromParent_Done,
     /* 354984 */ // Label 7081: @354984
     /* 354984 */ GIM_Reject,
     /* 354985 */ // Label 7041: @354985
     /* 354985 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(355030), // Rule ID 6878 //
     /* 354990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 354993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355004 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 355008 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 355008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355013 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 355019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355029 */   // GIR_Coverage, 6878,
     /* 355029 */   GIR_EraseRootFromParent_Done,
     /* 355030 */ // Label 7082: @355030
     /* 355030 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(355074), // Rule ID 11121 //
     /* 355035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 355041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355048 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 355052 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 355052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355057 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 355063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355073 */   // GIR_Coverage, 11121,
     /* 355073 */   GIR_EraseRootFromParent_Done,
     /* 355074 */ // Label 7083: @355074
     /* 355074 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(355118), // Rule ID 11127 //
     /* 355079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 355085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355092 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 355096 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 355096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355101 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 355107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355112 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355117 */   // GIR_Coverage, 11127,
     /* 355117 */   GIR_EraseRootFromParent_Done,
     /* 355118 */ // Label 7084: @355118
     /* 355118 */ GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(355163), // Rule ID 5702 //
     /* 355123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355137 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 355141 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 355141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355146 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 355152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355162 */   // GIR_Coverage, 5702,
     /* 355162 */   GIR_EraseRootFromParent_Done,
     /* 355163 */ // Label 7085: @355163
     /* 355163 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(355236), // Rule ID 11106 //
     /* 355168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 355174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355189 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 355193 */   // MIs[1] Operand 1
     /* 355193 */   // No operand predicates
     /* 355193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355195 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 355195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 355198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355207 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 355213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355218 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 355226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355231 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 355234 */   GIR_RootConstrainSelectedInstOperands,
     /* 355235 */   // GIR_Coverage, 11106,
     /* 355235 */   GIR_EraseRootFromParent_Done,
     /* 355236 */ // Label 7086: @355236
     /* 355236 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(355284), // Rule ID 1922 //
     /* 355241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 355244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355266 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 355270 */   // MIs[1] Operand 1
     /* 355270 */   // No operand predicates
     /* 355270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355272 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 355272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 355275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355277 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355279 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 355282 */   GIR_RootConstrainSelectedInstOperands,
     /* 355283 */   // GIR_Coverage, 1922,
     /* 355283 */   GIR_EraseRootFromParent_Done,
     /* 355284 */ // Label 7087: @355284
     /* 355284 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(355332), // Rule ID 1926 //
     /* 355289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355314 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 355318 */   // MIs[1] Operand 1
     /* 355318 */   // No operand predicates
     /* 355318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355320 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 355320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 355323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355325 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355327 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 355330 */   GIR_RootConstrainSelectedInstOperands,
     /* 355331 */   // GIR_Coverage, 1926,
     /* 355331 */   GIR_EraseRootFromParent_Done,
     /* 355332 */ // Label 7088: @355332
     /* 355332 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(355377), // Rule ID 5705 //
     /* 355337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355359 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 355363 */   // MIs[1] Operand 1
     /* 355363 */   // No operand predicates
     /* 355363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355365 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 355365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 355368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355370 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355372 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 355375 */   GIR_RootConstrainSelectedInstOperands,
     /* 355376 */   // GIR_Coverage, 5705,
     /* 355376 */   GIR_EraseRootFromParent_Done,
     /* 355377 */ // Label 7089: @355377
     /* 355377 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(355453), // Rule ID 11096 //
     /* 355382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 355388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355395 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355403 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 355407 */   // MIs[1] Operand 1
     /* 355407 */   // No operand predicates
     /* 355407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355409 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 355409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 355412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 355416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355421 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 355425 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 355428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355435 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355452 */   // GIR_Coverage, 11096,
     /* 355452 */   GIR_EraseRootFromParent_Done,
     /* 355453 */ // Label 7090: @355453
     /* 355453 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(355529), // Rule ID 11102 //
     /* 355458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 355464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355479 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 355483 */   // MIs[1] Operand 1
     /* 355483 */   // No operand predicates
     /* 355483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355485 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 355485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 355488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 355492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 355501 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 355504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355511 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355528 */   // GIR_Coverage, 11102,
     /* 355528 */   GIR_EraseRootFromParent_Done,
     /* 355529 */ // Label 7091: @355529
     /* 355529 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(355590), // Rule ID 11086 //
     /* 355534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 355540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355551 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 355551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 355558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355563 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 355569 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 355573 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 355581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355586 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355588 */   GIR_RootConstrainSelectedInstOperands,
     /* 355589 */   // GIR_Coverage, 11086,
     /* 355589 */   GIR_EraseRootFromParent_Done,
     /* 355590 */ // Label 7092: @355590
     /* 355590 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(355651), // Rule ID 11092 //
     /* 355595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 355601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355612 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 355612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 355619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355624 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 355630 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 355634 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 355642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 355644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355647 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355649 */   GIR_RootConstrainSelectedInstOperands,
     /* 355650 */   // GIR_Coverage, 11092,
     /* 355650 */   GIR_EraseRootFromParent_Done,
     /* 355651 */ // Label 7093: @355651
     /* 355651 */ GIM_Reject,
     /* 355652 */ // Label 7042: @355652
     /* 355652 */ GIM_Reject,
     /* 355653 */ // Label 90: @355653
     /* 355653 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7101*/ GIMT_Encode4(357358),
     /* 355664 */ /*GILLT_nxv2s16*//*Label 7094*/ GIMT_Encode4(355704),
     /* 355668 */ /*GILLT_nxv2s32*//*Label 7095*/ GIMT_Encode4(355999),
     /* 355672 */ /*GILLT_nxv2s64*//*Label 7096*/ GIMT_Encode4(356237), GIMT_Encode4(0),
     /* 355680 */ /*GILLT_nxv4s16*//*Label 7097*/ GIMT_Encode4(356494),
     /* 355684 */ /*GILLT_nxv4s32*//*Label 7098*/ GIMT_Encode4(356732), GIMT_Encode4(0),
     /* 355692 */ /*GILLT_nxv8s16*//*Label 7099*/ GIMT_Encode4(356989), GIMT_Encode4(0),
     /* 355700 */ /*GILLT_nxv16s8*//*Label 7100*/ GIMT_Encode4(357268),
     /* 355704 */ // Label 7094: @355704
     /* 355704 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(355998),
     /* 355709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 355712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355716 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(355773), // Rule ID 2666 //
     /* 355721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 355736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 355757 */     // MIs[2] Operand 1
     /* 355757 */     // No operand predicates
     /* 355757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355759 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 355759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 355762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 355768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 355771 */     GIR_RootConstrainSelectedInstOperands,
     /* 355772 */     // GIR_Coverage, 2666,
     /* 355772 */     GIR_EraseRootFromParent_Done,
     /* 355773 */   // Label 7103: @355773
     /* 355773 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(355830), // Rule ID 2668 //
     /* 355778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 355793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 355814 */     // MIs[2] Operand 1
     /* 355814 */     // No operand predicates
     /* 355814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355816 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 355816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 355819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 355825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 355828 */     GIR_RootConstrainSelectedInstOperands,
     /* 355829 */     // GIR_Coverage, 2668,
     /* 355829 */     GIR_EraseRootFromParent_Done,
     /* 355830 */   // Label 7104: @355830
     /* 355830 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(355887), // Rule ID 8238 //
     /* 355835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 355850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355867 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 355871 */     // MIs[2] Operand 1
     /* 355871 */     // No operand predicates
     /* 355871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355873 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 355873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 355876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 355882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 355885 */     GIR_RootConstrainSelectedInstOperands,
     /* 355886 */     // GIR_Coverage, 8238,
     /* 355886 */     GIR_EraseRootFromParent_Done,
     /* 355887 */   // Label 7105: @355887
     /* 355887 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(355921), // Rule ID 8281 //
     /* 355892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 355903 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 355907 */     // MIs[1] Operand 1
     /* 355907 */     // No operand predicates
     /* 355907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355909 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 355909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 355912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355914 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 355919 */     GIR_RootConstrainSelectedInstOperands,
     /* 355920 */     // GIR_Coverage, 8281,
     /* 355920 */     GIR_EraseRootFromParent_Done,
     /* 355921 */   // Label 7106: @355921
     /* 355921 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(355997), // Rule ID 8259 //
     /* 355926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355933 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 355933 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 355936 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355940 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 355950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355959 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355966 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 355969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 355987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355995 */     GIR_RootConstrainSelectedInstOperands,
     /* 355996 */     // GIR_Coverage, 8259,
     /* 355996 */     GIR_EraseRootFromParent_Done,
     /* 355997 */   // Label 7107: @355997
     /* 355997 */   GIM_Reject,
     /* 355998 */ // Label 7102: @355998
     /* 355998 */ GIM_Reject,
     /* 355999 */ // Label 7095: @355999
     /* 355999 */ GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(356236),
     /* 356004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356011 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(356068), // Rule ID 8247 //
     /* 356016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 356031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356048 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 356052 */     // MIs[2] Operand 1
     /* 356052 */     // No operand predicates
     /* 356052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356054 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 356054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 356057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 356063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 356066 */     GIR_RootConstrainSelectedInstOperands,
     /* 356067 */     // GIR_Coverage, 8247,
     /* 356067 */     GIR_EraseRootFromParent_Done,
     /* 356068 */   // Label 7109: @356068
     /* 356068 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(356125), // Rule ID 8256 //
     /* 356073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 356088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356105 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 356109 */     // MIs[2] Operand 1
     /* 356109 */     // No operand predicates
     /* 356109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356111 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 356111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 356114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 356120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 356123 */     GIR_RootConstrainSelectedInstOperands,
     /* 356124 */     // GIR_Coverage, 8256,
     /* 356124 */     GIR_EraseRootFromParent_Done,
     /* 356125 */   // Label 7110: @356125
     /* 356125 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(356159), // Rule ID 8283 //
     /* 356130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 356141 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 356145 */     // MIs[1] Operand 1
     /* 356145 */     // No operand predicates
     /* 356145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356147 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 356147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 356150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356152 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 356157 */     GIR_RootConstrainSelectedInstOperands,
     /* 356158 */     // GIR_Coverage, 8283,
     /* 356158 */     GIR_EraseRootFromParent_Done,
     /* 356159 */   // Label 7111: @356159
     /* 356159 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(356235), // Rule ID 8261 //
     /* 356164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356171 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 356171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 356174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 356188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356197 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 356207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 356225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356233 */     GIR_RootConstrainSelectedInstOperands,
     /* 356234 */     // GIR_Coverage, 8261,
     /* 356234 */     GIR_EraseRootFromParent_Done,
     /* 356235 */   // Label 7112: @356235
     /* 356235 */   GIM_Reject,
     /* 356236 */ // Label 7108: @356236
     /* 356236 */ GIM_Reject,
     /* 356237 */ // Label 7096: @356237
     /* 356237 */ GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(356493),
     /* 356242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356249 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(356306), // Rule ID 2663 //
     /* 356254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 356269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356286 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 356290 */     // MIs[2] Operand 1
     /* 356290 */     // No operand predicates
     /* 356290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356292 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 356292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 356295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 356301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 356304 */     GIR_RootConstrainSelectedInstOperands,
     /* 356305 */     // GIR_Coverage, 2663,
     /* 356305 */     GIR_EraseRootFromParent_Done,
     /* 356306 */   // Label 7114: @356306
     /* 356306 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(356363), // Rule ID 8253 //
     /* 356311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 356326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356343 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 356347 */     // MIs[2] Operand 1
     /* 356347 */     // No operand predicates
     /* 356347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356349 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 356349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 356352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 356358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 356361 */     GIR_RootConstrainSelectedInstOperands,
     /* 356362 */     // GIR_Coverage, 8253,
     /* 356362 */     GIR_EraseRootFromParent_Done,
     /* 356363 */   // Label 7115: @356363
     /* 356363 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(356397), // Rule ID 8284 //
     /* 356368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 356379 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 356383 */     // MIs[1] Operand 1
     /* 356383 */     // No operand predicates
     /* 356383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356385 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 356385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 356388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356390 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 356395 */     GIR_RootConstrainSelectedInstOperands,
     /* 356396 */     // GIR_Coverage, 8284,
     /* 356396 */     GIR_EraseRootFromParent_Done,
     /* 356397 */   // Label 7116: @356397
     /* 356397 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(356416), // Rule ID 2382 //
     /* 356402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356409 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 356409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 356414 */     GIR_RootConstrainSelectedInstOperands,
     /* 356415 */     // GIR_Coverage, 2382,
     /* 356415 */     GIR_Done,
     /* 356416 */   // Label 7117: @356416
     /* 356416 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(356492), // Rule ID 8262 //
     /* 356421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356428 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 356428 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 356431 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356435 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 356445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356454 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 356464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 356482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356490 */     GIR_RootConstrainSelectedInstOperands,
     /* 356491 */     // GIR_Coverage, 8262,
     /* 356491 */     GIR_EraseRootFromParent_Done,
     /* 356492 */   // Label 7118: @356492
     /* 356492 */   GIM_Reject,
     /* 356493 */ // Label 7113: @356493
     /* 356493 */ GIM_Reject,
     /* 356494 */ // Label 7097: @356494
     /* 356494 */ GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(356731),
     /* 356499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 356502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356506 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(356563), // Rule ID 2667 //
     /* 356511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 356526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356543 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 356547 */     // MIs[2] Operand 1
     /* 356547 */     // No operand predicates
     /* 356547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356549 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 356549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 356552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 356558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 356561 */     GIR_RootConstrainSelectedInstOperands,
     /* 356562 */     // GIR_Coverage, 2667,
     /* 356562 */     GIR_EraseRootFromParent_Done,
     /* 356563 */   // Label 7120: @356563
     /* 356563 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(356620), // Rule ID 8241 //
     /* 356568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 356583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356600 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 356604 */     // MIs[2] Operand 1
     /* 356604 */     // No operand predicates
     /* 356604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356606 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 356606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 356609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 356615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 356618 */     GIR_RootConstrainSelectedInstOperands,
     /* 356619 */     // GIR_Coverage, 8241,
     /* 356619 */     GIR_EraseRootFromParent_Done,
     /* 356620 */   // Label 7121: @356620
     /* 356620 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(356654), // Rule ID 8280 //
     /* 356625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 356636 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 356640 */     // MIs[1] Operand 1
     /* 356640 */     // No operand predicates
     /* 356640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356642 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 356642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 356645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356647 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 356652 */     GIR_RootConstrainSelectedInstOperands,
     /* 356653 */     // GIR_Coverage, 8280,
     /* 356653 */     GIR_EraseRootFromParent_Done,
     /* 356654 */   // Label 7122: @356654
     /* 356654 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(356730), // Rule ID 8258 //
     /* 356659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356666 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 356666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 356669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 356683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356692 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 356702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 356720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356728 */     GIR_RootConstrainSelectedInstOperands,
     /* 356729 */     // GIR_Coverage, 8258,
     /* 356729 */     GIR_EraseRootFromParent_Done,
     /* 356730 */   // Label 7123: @356730
     /* 356730 */   GIM_Reject,
     /* 356731 */ // Label 7119: @356731
     /* 356731 */ GIM_Reject,
     /* 356732 */ // Label 7098: @356732
     /* 356732 */ GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(356988),
     /* 356737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356744 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(356801), // Rule ID 2660 //
     /* 356749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 356764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 356785 */     // MIs[2] Operand 1
     /* 356785 */     // No operand predicates
     /* 356785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356787 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 356787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 356790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 356796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 356799 */     GIR_RootConstrainSelectedInstOperands,
     /* 356800 */     // GIR_Coverage, 2660,
     /* 356800 */     GIR_EraseRootFromParent_Done,
     /* 356801 */   // Label 7125: @356801
     /* 356801 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(356858), // Rule ID 8250 //
     /* 356806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 356821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 356842 */     // MIs[2] Operand 1
     /* 356842 */     // No operand predicates
     /* 356842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356844 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 356844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 356847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 356853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 356856 */     GIR_RootConstrainSelectedInstOperands,
     /* 356857 */     // GIR_Coverage, 8250,
     /* 356857 */     GIR_EraseRootFromParent_Done,
     /* 356858 */   // Label 7126: @356858
     /* 356858 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(356892), // Rule ID 8282 //
     /* 356863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 356874 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 356878 */     // MIs[1] Operand 1
     /* 356878 */     // No operand predicates
     /* 356878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356880 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 356880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 356883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356885 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 356890 */     GIR_RootConstrainSelectedInstOperands,
     /* 356891 */     // GIR_Coverage, 8282,
     /* 356891 */     GIR_EraseRootFromParent_Done,
     /* 356892 */   // Label 7127: @356892
     /* 356892 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(356911), // Rule ID 2381 //
     /* 356897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 356904 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 356904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 356909 */     GIR_RootConstrainSelectedInstOperands,
     /* 356910 */     // GIR_Coverage, 2381,
     /* 356910 */     GIR_Done,
     /* 356911 */   // Label 7128: @356911
     /* 356911 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(356987), // Rule ID 8260 //
     /* 356916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356923 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 356923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 356926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 356940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356949 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 356959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 356977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356985 */     GIR_RootConstrainSelectedInstOperands,
     /* 356986 */     // GIR_Coverage, 8260,
     /* 356986 */     GIR_EraseRootFromParent_Done,
     /* 356987 */   // Label 7129: @356987
     /* 356987 */   GIM_Reject,
     /* 356988 */ // Label 7124: @356988
     /* 356988 */ GIM_Reject,
     /* 356989 */ // Label 7099: @356989
     /* 356989 */ GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(357053), // Rule ID 2657 //
     /* 356994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357004 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357012 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 357016 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357020 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357025 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357029 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357033 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 357037 */   // MIs[2] Operand 1
     /* 357037 */   // No operand predicates
     /* 357037 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357039 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 357039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 357042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357044 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 357048 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 357051 */   GIR_RootConstrainSelectedInstOperands,
     /* 357052 */   // GIR_Coverage, 2657,
     /* 357052 */   GIR_EraseRootFromParent_Done,
     /* 357053 */ // Label 7130: @357053
     /* 357053 */ GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(357117), // Rule ID 8244 //
     /* 357058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357068 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357076 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 357080 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357084 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357089 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357093 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357097 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 357101 */   // MIs[2] Operand 1
     /* 357101 */   // No operand predicates
     /* 357101 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357103 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 357103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 357106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357108 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 357112 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 357115 */   GIR_RootConstrainSelectedInstOperands,
     /* 357116 */   // GIR_Coverage, 8244,
     /* 357116 */   GIR_EraseRootFromParent_Done,
     /* 357117 */ // Label 7131: @357117
     /* 357117 */ GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(357158), // Rule ID 8279 //
     /* 357122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 357140 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 357144 */   // MIs[1] Operand 1
     /* 357144 */   // No operand predicates
     /* 357144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357146 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 357146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 357149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357151 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 357156 */   GIR_RootConstrainSelectedInstOperands,
     /* 357157 */   // GIR_Coverage, 8279,
     /* 357157 */   GIR_EraseRootFromParent_Done,
     /* 357158 */ // Label 7132: @357158
     /* 357158 */ GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(357184), // Rule ID 2380 //
     /* 357163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 357177 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 357177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 357182 */   GIR_RootConstrainSelectedInstOperands,
     /* 357183 */   // GIR_Coverage, 2380,
     /* 357183 */   GIR_Done,
     /* 357184 */ // Label 7133: @357184
     /* 357184 */ GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(357267), // Rule ID 8257 //
     /* 357189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357203 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 357203 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 357206 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357210 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 357220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357229 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357232 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 357236 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 357239 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357244 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357249 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 357257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357265 */   GIR_RootConstrainSelectedInstOperands,
     /* 357266 */   // GIR_Coverage, 8257,
     /* 357266 */   GIR_EraseRootFromParent_Done,
     /* 357267 */ // Label 7134: @357267
     /* 357267 */ GIM_Reject,
     /* 357268 */ // Label 7100: @357268
     /* 357268 */ GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(357357),
     /* 357273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357280 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(357337), // Rule ID 2654 //
     /* 357285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 357300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 357321 */     // MIs[2] Operand 1
     /* 357321 */     // No operand predicates
     /* 357321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357323 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 357323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 357326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 357332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 357335 */     GIR_RootConstrainSelectedInstOperands,
     /* 357336 */     // GIR_Coverage, 2654,
     /* 357336 */     GIR_EraseRootFromParent_Done,
     /* 357337 */   // Label 7136: @357337
     /* 357337 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(357356), // Rule ID 2379 //
     /* 357342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 357349 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 357349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 357354 */     GIR_RootConstrainSelectedInstOperands,
     /* 357355 */     // GIR_Coverage, 2379,
     /* 357355 */     GIR_Done,
     /* 357356 */   // Label 7137: @357356
     /* 357356 */   GIM_Reject,
     /* 357357 */ // Label 7135: @357357
     /* 357357 */ GIM_Reject,
     /* 357358 */ // Label 7101: @357358
     /* 357358 */ GIM_Reject,
     /* 357359 */ // Label 91: @357359
     /* 357359 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7140*/ GIMT_Encode4(357510),
     /* 357370 */ /*GILLT_s32*//*Label 7138*/ GIMT_Encode4(357378),
     /* 357374 */ /*GILLT_s64*//*Label 7139*/ GIMT_Encode4(357444),
     /* 357378 */ // Label 7138: @357378
     /* 357378 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(357443),
     /* 357383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357394 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(357409), // Rule ID 2312 //
     /* 357399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 357402 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 357402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 357407 */     GIR_RootConstrainSelectedInstOperands,
     /* 357408 */     // GIR_Coverage, 2312,
     /* 357408 */     GIR_Done,
     /* 357409 */   // Label 7142: @357409
     /* 357409 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(357442), // Rule ID 3958 //
     /* 357414 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 357414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 357421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 357435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 357437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357440 */     GIR_RootConstrainSelectedInstOperands,
     /* 357441 */     // GIR_Coverage, 3958,
     /* 357441 */     GIR_EraseRootFromParent_Done,
     /* 357442 */   // Label 7143: @357442
     /* 357442 */   GIM_Reject,
     /* 357443 */ // Label 7141: @357443
     /* 357443 */ GIM_Reject,
     /* 357444 */ // Label 7139: @357444
     /* 357444 */ GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(357509),
     /* 357449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 357452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357460 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(357475), // Rule ID 2313 //
     /* 357465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 357468 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 357468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 357473 */     GIR_RootConstrainSelectedInstOperands,
     /* 357474 */     // GIR_Coverage, 2313,
     /* 357474 */     GIR_Done,
     /* 357475 */   // Label 7145: @357475
     /* 357475 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(357508), // Rule ID 3959 //
     /* 357480 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 357480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 357487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 357501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 357503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357506 */     GIR_RootConstrainSelectedInstOperands,
     /* 357507 */     // GIR_Coverage, 3959,
     /* 357507 */     GIR_EraseRootFromParent_Done,
     /* 357508 */   // Label 7146: @357508
     /* 357508 */   GIM_Reject,
     /* 357509 */ // Label 7144: @357509
     /* 357509 */ GIM_Reject,
     /* 357510 */ // Label 7140: @357510
     /* 357510 */ GIM_Reject,
     /* 357511 */ // Label 92: @357511
     /* 357511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7155*/ GIMT_Encode4(358184),
     /* 357522 */ /*GILLT_s32*//*Label 7147*/ GIMT_Encode4(357562),
     /* 357526 */ /*GILLT_s64*//*Label 7148*/ GIMT_Encode4(357792), GIMT_Encode4(0),
     /* 357534 */ /*GILLT_v2s32*//*Label 7149*/ GIMT_Encode4(358022), GIMT_Encode4(0),
     /* 357542 */ /*GILLT_v4s16*//*Label 7150*/ GIMT_Encode4(358049),
     /* 357546 */ /*GILLT_v4s32*//*Label 7151*/ GIMT_Encode4(358076),
     /* 357550 */ /*GILLT_v8s8*//*Label 7152*/ GIMT_Encode4(358103),
     /* 357554 */ /*GILLT_v8s16*//*Label 7153*/ GIMT_Encode4(358130),
     /* 357558 */ /*GILLT_v16s8*//*Label 7154*/ GIMT_Encode4(358157),
     /* 357562 */ // Label 7147: @357562
     /* 357562 */ GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(357791),
     /* 357567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357574 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(357674), // Rule ID 3960 //
     /* 357579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 357587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 357591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 357595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 357603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 357607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 357611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 357615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 357619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 357623 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 357627 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 357631 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 357635 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 357639 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357644 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 357648 */     // MIs[3] Rn
     /* 357648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 357653 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 357657 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 357661 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 357663 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 357663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 357666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 357668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 357672 */     GIR_RootConstrainSelectedInstOperands,
     /* 357673 */     // GIR_Coverage, 3960,
     /* 357673 */     GIR_EraseRootFromParent_Done,
     /* 357674 */   // Label 7157: @357674
     /* 357674 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(357774), // Rule ID 13591 //
     /* 357679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 357687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 357691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 357695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 357703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 357707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 357711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 357715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 357719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 357723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 357727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 357736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 357740 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 357744 */     // MIs[4] Rn
     /* 357744 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 357749 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 357753 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 357757 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 357761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 357763 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 357763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 357766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 357768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 357772 */     GIR_RootConstrainSelectedInstOperands,
     /* 357773 */     // GIR_Coverage, 13591,
     /* 357773 */     GIR_EraseRootFromParent_Done,
     /* 357774 */   // Label 7158: @357774
     /* 357774 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(357790), // Rule ID 180 //
     /* 357779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357783 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 357783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 357788 */     GIR_RootConstrainSelectedInstOperands,
     /* 357789 */     // GIR_Coverage, 180,
     /* 357789 */     GIR_Done,
     /* 357790 */   // Label 7159: @357790
     /* 357790 */   GIM_Reject,
     /* 357791 */ // Label 7156: @357791
     /* 357791 */ GIM_Reject,
     /* 357792 */ // Label 7148: @357792
     /* 357792 */ GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(358021),
     /* 357797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 357800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357804 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(357904), // Rule ID 3961 //
     /* 357809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 357817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 357821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 357833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 357837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 357841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 357845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 357849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 357853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 357857 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 357861 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 357865 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 357869 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357874 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 357878 */     // MIs[3] Rn
     /* 357878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 357883 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 357887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 357891 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 357893 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 357893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 357896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 357898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 357902 */     GIR_RootConstrainSelectedInstOperands,
     /* 357903 */     // GIR_Coverage, 3961,
     /* 357903 */     GIR_EraseRootFromParent_Done,
     /* 357904 */   // Label 7161: @357904
     /* 357904 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(358004), // Rule ID 13592 //
     /* 357909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 357917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 357921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 357933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 357937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 357941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 357945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 357949 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 357953 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 357957 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 357966 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 357970 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 357974 */     // MIs[4] Rn
     /* 357974 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 357979 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 357983 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 357987 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 357991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 357993 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 357993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 357996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 357998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 358002 */     GIR_RootConstrainSelectedInstOperands,
     /* 358003 */     // GIR_Coverage, 13592,
     /* 358003 */     GIR_EraseRootFromParent_Done,
     /* 358004 */   // Label 7162: @358004
     /* 358004 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(358020), // Rule ID 181 //
     /* 358009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358013 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 358013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 358018 */     GIR_RootConstrainSelectedInstOperands,
     /* 358019 */     // GIR_Coverage, 181,
     /* 358019 */     GIR_Done,
     /* 358020 */   // Label 7163: @358020
     /* 358020 */   GIM_Reject,
     /* 358021 */ // Label 7160: @358021
     /* 358021 */ GIM_Reject,
     /* 358022 */ // Label 7149: @358022
     /* 358022 */ GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(358048), // Rule ID 720 //
     /* 358027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358041 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 358041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 358046 */   GIR_RootConstrainSelectedInstOperands,
     /* 358047 */   // GIR_Coverage, 720,
     /* 358047 */   GIR_Done,
     /* 358048 */ // Label 7164: @358048
     /* 358048 */ GIM_Reject,
     /* 358049 */ // Label 7150: @358049
     /* 358049 */ GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(358075), // Rule ID 718 //
     /* 358054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 358060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358068 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 358068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 358073 */   GIR_RootConstrainSelectedInstOperands,
     /* 358074 */   // GIR_Coverage, 718,
     /* 358074 */   GIR_Done,
     /* 358075 */ // Label 7165: @358075
     /* 358075 */ GIM_Reject,
     /* 358076 */ // Label 7151: @358076
     /* 358076 */ GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(358102), // Rule ID 721 //
     /* 358081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358095 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 358095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 358100 */   GIR_RootConstrainSelectedInstOperands,
     /* 358101 */   // GIR_Coverage, 721,
     /* 358101 */   GIR_Done,
     /* 358102 */ // Label 7166: @358102
     /* 358102 */ GIM_Reject,
     /* 358103 */ // Label 7152: @358103
     /* 358103 */ GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(358129), // Rule ID 716 //
     /* 358108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 358114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358122 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 358122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 358127 */   GIR_RootConstrainSelectedInstOperands,
     /* 358128 */   // GIR_Coverage, 716,
     /* 358128 */   GIR_Done,
     /* 358129 */ // Label 7167: @358129
     /* 358129 */ GIM_Reject,
     /* 358130 */ // Label 7153: @358130
     /* 358130 */ GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(358156), // Rule ID 719 //
     /* 358135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358149 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 358149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 358154 */   GIR_RootConstrainSelectedInstOperands,
     /* 358155 */   // GIR_Coverage, 719,
     /* 358155 */   GIR_Done,
     /* 358156 */ // Label 7168: @358156
     /* 358156 */ GIM_Reject,
     /* 358157 */ // Label 7154: @358157
     /* 358157 */ GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(358183), // Rule ID 717 //
     /* 358162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 358168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358176 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 358176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 358181 */   GIR_RootConstrainSelectedInstOperands,
     /* 358182 */   // GIR_Coverage, 717,
     /* 358182 */   GIR_Done,
     /* 358183 */ // Label 7169: @358183
     /* 358183 */ GIM_Reject,
     /* 358184 */ // Label 7155: @358184
     /* 358184 */ GIM_Reject,
     /* 358185 */ // Label 93: @358185
     /* 358185 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7174*/ GIMT_Encode4(358344),
     /* 358196 */ /*GILLT_s32*//*Label 7170*/ GIMT_Encode4(358236),
     /* 358200 */ /*GILLT_s64*//*Label 7171*/ GIMT_Encode4(358263), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 358224 */ /*GILLT_v8s8*//*Label 7172*/ GIMT_Encode4(358290), GIMT_Encode4(0),
     /* 358232 */ /*GILLT_v16s8*//*Label 7173*/ GIMT_Encode4(358317),
     /* 358236 */ // Label 7170: @358236
     /* 358236 */ GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(358262), // Rule ID 2310 //
     /* 358241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 358244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 358247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358255 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 358255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 358260 */   GIR_RootConstrainSelectedInstOperands,
     /* 358261 */   // GIR_Coverage, 2310,
     /* 358261 */   GIR_Done,
     /* 358262 */ // Label 7175: @358262
     /* 358262 */ GIM_Reject,
     /* 358263 */ // Label 7171: @358263
     /* 358263 */ GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(358289), // Rule ID 2311 //
     /* 358268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 358271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 358274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358282 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 358282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 358287 */   GIR_RootConstrainSelectedInstOperands,
     /* 358288 */   // GIR_Coverage, 2311,
     /* 358288 */   GIR_Done,
     /* 358289 */ // Label 7176: @358289
     /* 358289 */ GIM_Reject,
     /* 358290 */ // Label 7172: @358290
     /* 358290 */ GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(358316), // Rule ID 757 //
     /* 358295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 358301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358309 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 358309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 358314 */   GIR_RootConstrainSelectedInstOperands,
     /* 358315 */   // GIR_Coverage, 757,
     /* 358315 */   GIR_Done,
     /* 358316 */ // Label 7177: @358316
     /* 358316 */ GIM_Reject,
     /* 358317 */ // Label 7173: @358317
     /* 358317 */ GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(358343), // Rule ID 758 //
     /* 358322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 358328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358336 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 358336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 358341 */   GIR_RootConstrainSelectedInstOperands,
     /* 358342 */   // GIR_Coverage, 758,
     /* 358342 */   GIR_Done,
     /* 358343 */ // Label 7178: @358343
     /* 358343 */ GIM_Reject,
     /* 358344 */ // Label 7174: @358344
     /* 358344 */ GIM_Reject,
     /* 358345 */ // Label 94: @358345
     /* 358345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7186*/ GIMT_Encode4(358658),
     /* 358356 */ /*GILLT_s32*//*Label 7179*/ GIMT_Encode4(358392),
     /* 358360 */ /*GILLT_s64*//*Label 7180*/ GIMT_Encode4(358465), GIMT_Encode4(0),
     /* 358368 */ /*GILLT_v2s32*//*Label 7181*/ GIMT_Encode4(358538),
     /* 358372 */ /*GILLT_v2s64*//*Label 7182*/ GIMT_Encode4(358562),
     /* 358376 */ /*GILLT_v4s16*//*Label 7183*/ GIMT_Encode4(358586),
     /* 358380 */ /*GILLT_v4s32*//*Label 7184*/ GIMT_Encode4(358610), GIMT_Encode4(0),
     /* 358388 */ /*GILLT_v8s16*//*Label 7185*/ GIMT_Encode4(358634),
     /* 358392 */ // Label 7179: @358392
     /* 358392 */ GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(358464),
     /* 358397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 358400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358404 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(358447), // Rule ID 3964 //
     /* 358409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 358417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 358421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 358434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358436 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 358436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 358439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358445 */     GIR_RootConstrainSelectedInstOperands,
     /* 358446 */     // GIR_Coverage, 3964,
     /* 358446 */     GIR_EraseRootFromParent_Done,
     /* 358447 */   // Label 7188: @358447
     /* 358447 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(358463), // Rule ID 185 //
     /* 358452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358456 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 358456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 358461 */     GIR_RootConstrainSelectedInstOperands,
     /* 358462 */     // GIR_Coverage, 185,
     /* 358462 */     GIR_Done,
     /* 358463 */   // Label 7189: @358463
     /* 358463 */   GIM_Reject,
     /* 358464 */ // Label 7187: @358464
     /* 358464 */ GIM_Reject,
     /* 358465 */ // Label 7180: @358465
     /* 358465 */ GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(358537),
     /* 358470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 358473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358477 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(358520), // Rule ID 3965 //
     /* 358482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 358490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 358494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 358507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358509 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 358509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 358512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358518 */     GIR_RootConstrainSelectedInstOperands,
     /* 358519 */     // GIR_Coverage, 3965,
     /* 358519 */     GIR_EraseRootFromParent_Done,
     /* 358520 */   // Label 7191: @358520
     /* 358520 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(358536), // Rule ID 186 //
     /* 358525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358529 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 358529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 358534 */     GIR_RootConstrainSelectedInstOperands,
     /* 358535 */     // GIR_Coverage, 186,
     /* 358535 */     GIR_Done,
     /* 358536 */   // Label 7192: @358536
     /* 358536 */   GIM_Reject,
     /* 358537 */ // Label 7190: @358537
     /* 358537 */ GIM_Reject,
     /* 358538 */ // Label 7181: @358538
     /* 358538 */ GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(358561), // Rule ID 4939 //
     /* 358543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358554 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 358554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 358559 */   GIR_RootConstrainSelectedInstOperands,
     /* 358560 */   // GIR_Coverage, 4939,
     /* 358560 */   GIR_Done,
     /* 358561 */ // Label 7193: @358561
     /* 358561 */ GIM_Reject,
     /* 358562 */ // Label 7182: @358562
     /* 358562 */ GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(358585), // Rule ID 4941 //
     /* 358567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358578 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 358578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 358583 */   GIR_RootConstrainSelectedInstOperands,
     /* 358584 */   // GIR_Coverage, 4941,
     /* 358584 */   GIR_Done,
     /* 358585 */ // Label 7194: @358585
     /* 358585 */ GIM_Reject,
     /* 358586 */ // Label 7183: @358586
     /* 358586 */ GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(358609), // Rule ID 4937 //
     /* 358591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 358594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358602 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 358602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 358607 */   GIR_RootConstrainSelectedInstOperands,
     /* 358608 */   // GIR_Coverage, 4937,
     /* 358608 */   GIR_Done,
     /* 358609 */ // Label 7195: @358609
     /* 358609 */ GIM_Reject,
     /* 358610 */ // Label 7184: @358610
     /* 358610 */ GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(358633), // Rule ID 4940 //
     /* 358615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358626 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 358626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 358631 */   GIR_RootConstrainSelectedInstOperands,
     /* 358632 */   // GIR_Coverage, 4940,
     /* 358632 */   GIR_Done,
     /* 358633 */ // Label 7196: @358633
     /* 358633 */ GIM_Reject,
     /* 358634 */ // Label 7185: @358634
     /* 358634 */ GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(358657), // Rule ID 4938 //
     /* 358639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358650 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 358650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 358655 */   GIR_RootConstrainSelectedInstOperands,
     /* 358656 */   // GIR_Coverage, 4938,
     /* 358656 */   GIR_Done,
     /* 358657 */ // Label 7197: @358657
     /* 358657 */ GIM_Reject,
     /* 358658 */ // Label 7186: @358658
     /* 358658 */ GIM_Reject,
     /* 358659 */ // Label 95: @358659
     /* 358659 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7202*/ GIMT_Encode4(358812),
     /* 358670 */ /*GILLT_s32*//*Label 7198*/ GIMT_Encode4(358710),
     /* 358674 */ /*GILLT_s64*//*Label 7199*/ GIMT_Encode4(358734), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 358698 */ /*GILLT_v8s8*//*Label 7200*/ GIMT_Encode4(358758), GIMT_Encode4(0),
     /* 358706 */ /*GILLT_v16s8*//*Label 7201*/ GIMT_Encode4(358785),
     /* 358710 */ // Label 7198: @358710
     /* 358710 */ GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(358733), // Rule ID 182 //
     /* 358715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 358718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358726 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 358726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 358731 */   GIR_RootConstrainSelectedInstOperands,
     /* 358732 */   // GIR_Coverage, 182,
     /* 358732 */   GIR_Done,
     /* 358733 */ // Label 7203: @358733
     /* 358733 */ GIM_Reject,
     /* 358734 */ // Label 7199: @358734
     /* 358734 */ GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(358757), // Rule ID 183 //
     /* 358739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 358742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358750 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 358750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 358755 */   GIR_RootConstrainSelectedInstOperands,
     /* 358756 */   // GIR_Coverage, 183,
     /* 358756 */   GIR_Done,
     /* 358757 */ // Label 7204: @358757
     /* 358757 */ GIM_Reject,
     /* 358758 */ // Label 7200: @358758
     /* 358758 */ GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(358784), // Rule ID 967 //
     /* 358763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 358769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358777 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 358777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 358782 */   GIR_RootConstrainSelectedInstOperands,
     /* 358783 */   // GIR_Coverage, 967,
     /* 358783 */   GIR_Done,
     /* 358784 */ // Label 7205: @358784
     /* 358784 */ GIM_Reject,
     /* 358785 */ // Label 7201: @358785
     /* 358785 */ GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(358811), // Rule ID 968 //
     /* 358790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 358796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358804 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 358804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 358809 */   GIR_RootConstrainSelectedInstOperands,
     /* 358810 */   // GIR_Coverage, 968,
     /* 358810 */   GIR_Done,
     /* 358811 */ // Label 7206: @358811
     /* 358811 */ GIM_Reject,
     /* 358812 */ // Label 7202: @358812
     /* 358812 */ GIM_Reject,
     /* 358813 */ // Label 96: @358813
     /* 358813 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7215*/ GIMT_Encode4(359303),
     /* 358824 */ /*GILLT_s16*//*Label 7207*/ GIMT_Encode4(358864),
     /* 358828 */ /*GILLT_s32*//*Label 7208*/ GIMT_Encode4(358895),
     /* 358832 */ /*GILLT_s64*//*Label 7209*/ GIMT_Encode4(358926), GIMT_Encode4(0),
     /* 358840 */ /*GILLT_v2s32*//*Label 7210*/ GIMT_Encode4(358957),
     /* 358844 */ /*GILLT_v2s64*//*Label 7211*/ GIMT_Encode4(358988),
     /* 358848 */ /*GILLT_v4s16*//*Label 7212*/ GIMT_Encode4(359019),
     /* 358852 */ /*GILLT_v4s32*//*Label 7213*/ GIMT_Encode4(359050), GIMT_Encode4(0),
     /* 358860 */ /*GILLT_v8s16*//*Label 7214*/ GIMT_Encode4(359081),
     /* 358864 */ // Label 7207: @358864
     /* 358864 */ GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(358894), // Rule ID 552 //
     /* 358869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 358872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 358875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358883 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 358883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 358888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358892 */   GIR_RootConstrainSelectedInstOperands,
     /* 358893 */   // GIR_Coverage, 552,
     /* 358893 */   GIR_Done,
     /* 358894 */ // Label 7216: @358894
     /* 358894 */ GIM_Reject,
     /* 358895 */ // Label 7208: @358895
     /* 358895 */ GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(358925), // Rule ID 554 //
     /* 358900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 358903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 358906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358914 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 358914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 358919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358923 */   GIR_RootConstrainSelectedInstOperands,
     /* 358924 */   // GIR_Coverage, 554,
     /* 358924 */   GIR_Done,
     /* 358925 */ // Label 7217: @358925
     /* 358925 */ GIM_Reject,
     /* 358926 */ // Label 7209: @358926
     /* 358926 */ GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(358956), // Rule ID 556 //
     /* 358931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 358934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 358937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358945 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 358945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 358950 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358954 */   GIR_RootConstrainSelectedInstOperands,
     /* 358955 */   // GIR_Coverage, 556,
     /* 358955 */   GIR_Done,
     /* 358956 */ // Label 7218: @358956
     /* 358956 */ GIM_Reject,
     /* 358957 */ // Label 7210: @358957
     /* 358957 */ GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(358987), // Rule ID 906 //
     /* 358962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358976 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 358976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 358981 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358985 */   GIR_RootConstrainSelectedInstOperands,
     /* 358986 */   // GIR_Coverage, 906,
     /* 358986 */   GIR_Done,
     /* 358987 */ // Label 7219: @358987
     /* 358987 */ GIM_Reject,
     /* 358988 */ // Label 7211: @358988
     /* 358988 */ GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(359018), // Rule ID 910 //
     /* 358993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359007 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 359007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 359012 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359016 */   GIR_RootConstrainSelectedInstOperands,
     /* 359017 */   // GIR_Coverage, 910,
     /* 359017 */   GIR_Done,
     /* 359018 */ // Label 7220: @359018
     /* 359018 */ GIM_Reject,
     /* 359019 */ // Label 7212: @359019
     /* 359019 */ GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(359049), // Rule ID 902 //
     /* 359024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 359030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359038 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 359038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 359043 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359047 */   GIR_RootConstrainSelectedInstOperands,
     /* 359048 */   // GIR_Coverage, 902,
     /* 359048 */   GIR_Done,
     /* 359049 */ // Label 7221: @359049
     /* 359049 */ GIM_Reject,
     /* 359050 */ // Label 7213: @359050
     /* 359050 */ GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(359080), // Rule ID 908 //
     /* 359055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 359061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359069 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 359069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 359074 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359078 */   GIR_RootConstrainSelectedInstOperands,
     /* 359079 */   // GIR_Coverage, 908,
     /* 359079 */   GIR_Done,
     /* 359080 */ // Label 7222: @359080
     /* 359080 */ GIM_Reject,
     /* 359081 */ // Label 7214: @359081
     /* 359081 */ GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(359302),
     /* 359086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 359089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359097 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(359116), // Rule ID 904 //
     /* 359102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359105 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 359105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 359110 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359114 */     GIR_RootConstrainSelectedInstOperands,
     /* 359115 */     // GIR_Coverage, 904,
     /* 359115 */     GIR_Done,
     /* 359116 */   // Label 7224: @359116
     /* 359116 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(359301), // Rule ID 6911 //
     /* 359121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 359124 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 359124 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 359127 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359131 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359136 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 359142 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 359145 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 359149 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359154 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 359157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 359159 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 359162 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359166 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359171 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359177 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359182 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359187 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 359190 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359194 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359199 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 359202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359204 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 359207 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 359211 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359216 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359221 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 359224 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 359228 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359233 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 359236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359264 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359267 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 359291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 359299 */     GIR_RootConstrainSelectedInstOperands,
     /* 359300 */     // GIR_Coverage, 6911,
     /* 359300 */     GIR_EraseRootFromParent_Done,
     /* 359301 */   // Label 7225: @359301
     /* 359301 */   GIM_Reject,
     /* 359302 */ // Label 7223: @359302
     /* 359302 */ GIM_Reject,
     /* 359303 */ // Label 7215: @359303
     /* 359303 */ GIM_Reject,
     /* 359304 */ // Label 97: @359304
     /* 359304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7234*/ GIMT_Encode4(359603),
     /* 359315 */ /*GILLT_s16*//*Label 7226*/ GIMT_Encode4(359355),
     /* 359319 */ /*GILLT_s32*//*Label 7227*/ GIMT_Encode4(359386),
     /* 359323 */ /*GILLT_s64*//*Label 7228*/ GIMT_Encode4(359417), GIMT_Encode4(0),
     /* 359331 */ /*GILLT_v2s32*//*Label 7229*/ GIMT_Encode4(359448),
     /* 359335 */ /*GILLT_v2s64*//*Label 7230*/ GIMT_Encode4(359479),
     /* 359339 */ /*GILLT_v4s16*//*Label 7231*/ GIMT_Encode4(359510),
     /* 359343 */ /*GILLT_v4s32*//*Label 7232*/ GIMT_Encode4(359541), GIMT_Encode4(0),
     /* 359351 */ /*GILLT_v8s16*//*Label 7233*/ GIMT_Encode4(359572),
     /* 359355 */ // Label 7226: @359355
     /* 359355 */ GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(359385), // Rule ID 570 //
     /* 359360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 359363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 359366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359374 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 359374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 359379 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359383 */   GIR_RootConstrainSelectedInstOperands,
     /* 359384 */   // GIR_Coverage, 570,
     /* 359384 */   GIR_Done,
     /* 359385 */ // Label 7235: @359385
     /* 359385 */ GIM_Reject,
     /* 359386 */ // Label 7227: @359386
     /* 359386 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(359416), // Rule ID 572 //
     /* 359391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 359397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359405 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 359405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 359410 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359414 */   GIR_RootConstrainSelectedInstOperands,
     /* 359415 */   // GIR_Coverage, 572,
     /* 359415 */   GIR_Done,
     /* 359416 */ // Label 7236: @359416
     /* 359416 */ GIM_Reject,
     /* 359417 */ // Label 7228: @359417
     /* 359417 */ GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(359447), // Rule ID 574 //
     /* 359422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 359428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359436 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 359436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 359441 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359445 */   GIR_RootConstrainSelectedInstOperands,
     /* 359446 */   // GIR_Coverage, 574,
     /* 359446 */   GIR_Done,
     /* 359447 */ // Label 7237: @359447
     /* 359447 */ GIM_Reject,
     /* 359448 */ // Label 7229: @359448
     /* 359448 */ GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(359478), // Rule ID 953 //
     /* 359453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 359459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359467 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 359467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 359472 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359476 */   GIR_RootConstrainSelectedInstOperands,
     /* 359477 */   // GIR_Coverage, 953,
     /* 359477 */   GIR_Done,
     /* 359478 */ // Label 7238: @359478
     /* 359478 */ GIM_Reject,
     /* 359479 */ // Label 7230: @359479
     /* 359479 */ GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(359509), // Rule ID 957 //
     /* 359484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359498 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 359498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 359503 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359507 */   GIR_RootConstrainSelectedInstOperands,
     /* 359508 */   // GIR_Coverage, 957,
     /* 359508 */   GIR_Done,
     /* 359509 */ // Label 7239: @359509
     /* 359509 */ GIM_Reject,
     /* 359510 */ // Label 7231: @359510
     /* 359510 */ GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(359540), // Rule ID 949 //
     /* 359515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 359521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359529 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 359529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 359534 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359538 */   GIR_RootConstrainSelectedInstOperands,
     /* 359539 */   // GIR_Coverage, 949,
     /* 359539 */   GIR_Done,
     /* 359540 */ // Label 7240: @359540
     /* 359540 */ GIM_Reject,
     /* 359541 */ // Label 7232: @359541
     /* 359541 */ GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(359571), // Rule ID 955 //
     /* 359546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 359552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359560 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 359560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 359565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359569 */   GIR_RootConstrainSelectedInstOperands,
     /* 359570 */   // GIR_Coverage, 955,
     /* 359570 */   GIR_Done,
     /* 359571 */ // Label 7241: @359571
     /* 359571 */ GIM_Reject,
     /* 359572 */ // Label 7233: @359572
     /* 359572 */ GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(359602), // Rule ID 951 //
     /* 359577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 359583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359591 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 359591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 359596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359600 */   GIR_RootConstrainSelectedInstOperands,
     /* 359601 */   // GIR_Coverage, 951,
     /* 359601 */   GIR_Done,
     /* 359602 */ // Label 7242: @359602
     /* 359602 */ GIM_Reject,
     /* 359603 */ // Label 7234: @359603
     /* 359603 */ GIM_Reject,
     /* 359604 */ // Label 98: @359604
     /* 359604 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7251*/ GIMT_Encode4(360094),
     /* 359615 */ /*GILLT_s16*//*Label 7243*/ GIMT_Encode4(359655),
     /* 359619 */ /*GILLT_s32*//*Label 7244*/ GIMT_Encode4(359686),
     /* 359623 */ /*GILLT_s64*//*Label 7245*/ GIMT_Encode4(359717), GIMT_Encode4(0),
     /* 359631 */ /*GILLT_v2s32*//*Label 7246*/ GIMT_Encode4(359748),
     /* 359635 */ /*GILLT_v2s64*//*Label 7247*/ GIMT_Encode4(359779),
     /* 359639 */ /*GILLT_v4s16*//*Label 7248*/ GIMT_Encode4(359810),
     /* 359643 */ /*GILLT_v4s32*//*Label 7249*/ GIMT_Encode4(359841), GIMT_Encode4(0),
     /* 359651 */ /*GILLT_v8s16*//*Label 7250*/ GIMT_Encode4(359872),
     /* 359655 */ // Label 7243: @359655
     /* 359655 */ GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(359685), // Rule ID 540 //
     /* 359660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 359663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 359666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359674 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 359674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 359679 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359683 */   GIR_RootConstrainSelectedInstOperands,
     /* 359684 */   // GIR_Coverage, 540,
     /* 359684 */   GIR_Done,
     /* 359685 */ // Label 7252: @359685
     /* 359685 */ GIM_Reject,
     /* 359686 */ // Label 7244: @359686
     /* 359686 */ GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(359716), // Rule ID 542 //
     /* 359691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 359697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359705 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 359705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 359710 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359714 */   GIR_RootConstrainSelectedInstOperands,
     /* 359715 */   // GIR_Coverage, 542,
     /* 359715 */   GIR_Done,
     /* 359716 */ // Label 7253: @359716
     /* 359716 */ GIM_Reject,
     /* 359717 */ // Label 7245: @359717
     /* 359717 */ GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(359747), // Rule ID 544 //
     /* 359722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 359728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359736 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 359736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 359741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359745 */   GIR_RootConstrainSelectedInstOperands,
     /* 359746 */   // GIR_Coverage, 544,
     /* 359746 */   GIR_Done,
     /* 359747 */ // Label 7254: @359747
     /* 359747 */ GIM_Reject,
     /* 359748 */ // Label 7246: @359748
     /* 359748 */ GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(359778), // Rule ID 886 //
     /* 359753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 359759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359767 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 359767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 359772 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359776 */   GIR_RootConstrainSelectedInstOperands,
     /* 359777 */   // GIR_Coverage, 886,
     /* 359777 */   GIR_Done,
     /* 359778 */ // Label 7255: @359778
     /* 359778 */ GIM_Reject,
     /* 359779 */ // Label 7247: @359779
     /* 359779 */ GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(359809), // Rule ID 890 //
     /* 359784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359798 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 359798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 359803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359807 */   GIR_RootConstrainSelectedInstOperands,
     /* 359808 */   // GIR_Coverage, 890,
     /* 359808 */   GIR_Done,
     /* 359809 */ // Label 7256: @359809
     /* 359809 */ GIM_Reject,
     /* 359810 */ // Label 7248: @359810
     /* 359810 */ GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(359840), // Rule ID 882 //
     /* 359815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 359821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359829 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 359829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 359834 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359838 */   GIR_RootConstrainSelectedInstOperands,
     /* 359839 */   // GIR_Coverage, 882,
     /* 359839 */   GIR_Done,
     /* 359840 */ // Label 7257: @359840
     /* 359840 */ GIM_Reject,
     /* 359841 */ // Label 7249: @359841
     /* 359841 */ GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(359871), // Rule ID 888 //
     /* 359846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 359852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359860 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 359860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 359865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359869 */   GIR_RootConstrainSelectedInstOperands,
     /* 359870 */   // GIR_Coverage, 888,
     /* 359870 */   GIR_Done,
     /* 359871 */ // Label 7258: @359871
     /* 359871 */ GIM_Reject,
     /* 359872 */ // Label 7250: @359872
     /* 359872 */ GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(360093),
     /* 359877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 359880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359888 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(359907), // Rule ID 884 //
     /* 359893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359896 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 359896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 359901 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359905 */     GIR_RootConstrainSelectedInstOperands,
     /* 359906 */     // GIR_Coverage, 884,
     /* 359906 */     GIR_Done,
     /* 359907 */   // Label 7260: @359907
     /* 359907 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(360092), // Rule ID 6913 //
     /* 359912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 359915 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 359915 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 359918 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359922 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359927 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 359933 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 359936 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 359940 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359945 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 359948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 359950 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 359953 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359957 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359962 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359968 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359973 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359978 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 359981 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359985 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359990 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 359993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359995 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 359998 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 360002 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360007 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360012 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 360015 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 360019 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360024 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 360027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360029 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 360032 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360036 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 360046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360058 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360061 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 360082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 360090 */     GIR_RootConstrainSelectedInstOperands,
     /* 360091 */     // GIR_Coverage, 6913,
     /* 360091 */     GIR_EraseRootFromParent_Done,
     /* 360092 */   // Label 7261: @360092
     /* 360092 */   GIM_Reject,
     /* 360093 */ // Label 7259: @360093
     /* 360093 */ GIM_Reject,
     /* 360094 */ // Label 7251: @360094
     /* 360094 */ GIM_Reject,
     /* 360095 */ // Label 99: @360095
     /* 360095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7270*/ GIMT_Encode4(360585),
     /* 360106 */ /*GILLT_s16*//*Label 7262*/ GIMT_Encode4(360146),
     /* 360110 */ /*GILLT_s32*//*Label 7263*/ GIMT_Encode4(360177),
     /* 360114 */ /*GILLT_s64*//*Label 7264*/ GIMT_Encode4(360208), GIMT_Encode4(0),
     /* 360122 */ /*GILLT_v2s32*//*Label 7265*/ GIMT_Encode4(360239),
     /* 360126 */ /*GILLT_v2s64*//*Label 7266*/ GIMT_Encode4(360270),
     /* 360130 */ /*GILLT_v4s16*//*Label 7267*/ GIMT_Encode4(360301),
     /* 360134 */ /*GILLT_v4s32*//*Label 7268*/ GIMT_Encode4(360332), GIMT_Encode4(0),
     /* 360142 */ /*GILLT_v8s16*//*Label 7269*/ GIMT_Encode4(360363),
     /* 360146 */ // Label 7262: @360146
     /* 360146 */ GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(360176), // Rule ID 558 //
     /* 360151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 360157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360165 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 360165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 360170 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360174 */   GIR_RootConstrainSelectedInstOperands,
     /* 360175 */   // GIR_Coverage, 558,
     /* 360175 */   GIR_Done,
     /* 360176 */ // Label 7271: @360176
     /* 360176 */ GIM_Reject,
     /* 360177 */ // Label 7263: @360177
     /* 360177 */ GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(360207), // Rule ID 560 //
     /* 360182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 360185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 360188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360196 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 360196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 360201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360205 */   GIR_RootConstrainSelectedInstOperands,
     /* 360206 */   // GIR_Coverage, 560,
     /* 360206 */   GIR_Done,
     /* 360207 */ // Label 7272: @360207
     /* 360207 */ GIM_Reject,
     /* 360208 */ // Label 7264: @360208
     /* 360208 */ GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(360238), // Rule ID 562 //
     /* 360213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 360216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 360219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360227 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 360227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 360232 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360236 */   GIR_RootConstrainSelectedInstOperands,
     /* 360237 */   // GIR_Coverage, 562,
     /* 360237 */   GIR_Done,
     /* 360238 */ // Label 7273: @360238
     /* 360238 */ GIM_Reject,
     /* 360239 */ // Label 7265: @360239
     /* 360239 */ GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(360269), // Rule ID 916 //
     /* 360244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 360250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360258 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 360258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 360263 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360267 */   GIR_RootConstrainSelectedInstOperands,
     /* 360268 */   // GIR_Coverage, 916,
     /* 360268 */   GIR_Done,
     /* 360269 */ // Label 7274: @360269
     /* 360269 */ GIM_Reject,
     /* 360270 */ // Label 7266: @360270
     /* 360270 */ GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(360300), // Rule ID 920 //
     /* 360275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 360281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360289 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 360289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 360294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360298 */   GIR_RootConstrainSelectedInstOperands,
     /* 360299 */   // GIR_Coverage, 920,
     /* 360299 */   GIR_Done,
     /* 360300 */ // Label 7275: @360300
     /* 360300 */ GIM_Reject,
     /* 360301 */ // Label 7267: @360301
     /* 360301 */ GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(360331), // Rule ID 912 //
     /* 360306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 360312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360320 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 360320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 360325 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360329 */   GIR_RootConstrainSelectedInstOperands,
     /* 360330 */   // GIR_Coverage, 912,
     /* 360330 */   GIR_Done,
     /* 360331 */ // Label 7276: @360331
     /* 360331 */ GIM_Reject,
     /* 360332 */ // Label 7268: @360332
     /* 360332 */ GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(360362), // Rule ID 918 //
     /* 360337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360351 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 360351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 360356 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360360 */   GIR_RootConstrainSelectedInstOperands,
     /* 360361 */   // GIR_Coverage, 918,
     /* 360361 */   GIR_Done,
     /* 360362 */ // Label 7277: @360362
     /* 360362 */ GIM_Reject,
     /* 360363 */ // Label 7269: @360363
     /* 360363 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(360584),
     /* 360368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360379 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(360398), // Rule ID 914 //
     /* 360384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360387 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 360387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 360392 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360396 */     GIR_RootConstrainSelectedInstOperands,
     /* 360397 */     // GIR_Coverage, 914,
     /* 360397 */     GIR_Done,
     /* 360398 */   // Label 7279: @360398
     /* 360398 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(360583), // Rule ID 6921 //
     /* 360403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 360406 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 360406 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 360409 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 360413 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360418 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 360422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 360424 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 360427 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 360431 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360436 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 360439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 360441 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 360444 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360448 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360453 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 360459 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360464 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360469 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 360472 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 360476 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360481 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 360484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 360486 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 360489 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 360493 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360498 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360503 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 360506 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 360510 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360515 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 360518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360520 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 360523 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360527 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 360537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360549 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360552 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 360573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 360581 */     GIR_RootConstrainSelectedInstOperands,
     /* 360582 */     // GIR_Coverage, 6921,
     /* 360582 */     GIR_EraseRootFromParent_Done,
     /* 360583 */   // Label 7280: @360583
     /* 360583 */   GIM_Reject,
     /* 360584 */ // Label 7278: @360584
     /* 360584 */ GIM_Reject,
     /* 360585 */ // Label 7270: @360585
     /* 360585 */ GIM_Reject,
     /* 360586 */ // Label 100: @360586
     /* 360586 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7289*/ GIMT_Encode4(361076),
     /* 360597 */ /*GILLT_s16*//*Label 7281*/ GIMT_Encode4(360637),
     /* 360601 */ /*GILLT_s32*//*Label 7282*/ GIMT_Encode4(360668),
     /* 360605 */ /*GILLT_s64*//*Label 7283*/ GIMT_Encode4(360699), GIMT_Encode4(0),
     /* 360613 */ /*GILLT_v2s32*//*Label 7284*/ GIMT_Encode4(360730),
     /* 360617 */ /*GILLT_v2s64*//*Label 7285*/ GIMT_Encode4(360761),
     /* 360621 */ /*GILLT_v4s16*//*Label 7286*/ GIMT_Encode4(360792),
     /* 360625 */ /*GILLT_v4s32*//*Label 7287*/ GIMT_Encode4(360823), GIMT_Encode4(0),
     /* 360633 */ /*GILLT_v8s16*//*Label 7288*/ GIMT_Encode4(360854),
     /* 360637 */ // Label 7281: @360637
     /* 360637 */ GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(360667), // Rule ID 534 //
     /* 360642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 360648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360656 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 360656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 360661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360665 */   GIR_RootConstrainSelectedInstOperands,
     /* 360666 */   // GIR_Coverage, 534,
     /* 360666 */   GIR_Done,
     /* 360667 */ // Label 7290: @360667
     /* 360667 */ GIM_Reject,
     /* 360668 */ // Label 7282: @360668
     /* 360668 */ GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(360698), // Rule ID 536 //
     /* 360673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 360676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 360679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360687 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 360687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 360692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360696 */   GIR_RootConstrainSelectedInstOperands,
     /* 360697 */   // GIR_Coverage, 536,
     /* 360697 */   GIR_Done,
     /* 360698 */ // Label 7291: @360698
     /* 360698 */ GIM_Reject,
     /* 360699 */ // Label 7283: @360699
     /* 360699 */ GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(360729), // Rule ID 538 //
     /* 360704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 360707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 360710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360718 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 360718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 360723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360727 */   GIR_RootConstrainSelectedInstOperands,
     /* 360728 */   // GIR_Coverage, 538,
     /* 360728 */   GIR_Done,
     /* 360729 */ // Label 7292: @360729
     /* 360729 */ GIM_Reject,
     /* 360730 */ // Label 7284: @360730
     /* 360730 */ GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(360760), // Rule ID 876 //
     /* 360735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 360741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360749 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 360749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 360754 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360758 */   GIR_RootConstrainSelectedInstOperands,
     /* 360759 */   // GIR_Coverage, 876,
     /* 360759 */   GIR_Done,
     /* 360760 */ // Label 7293: @360760
     /* 360760 */ GIM_Reject,
     /* 360761 */ // Label 7285: @360761
     /* 360761 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(360791), // Rule ID 880 //
     /* 360766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 360772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360780 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 360780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 360785 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360789 */   GIR_RootConstrainSelectedInstOperands,
     /* 360790 */   // GIR_Coverage, 880,
     /* 360790 */   GIR_Done,
     /* 360791 */ // Label 7294: @360791
     /* 360791 */ GIM_Reject,
     /* 360792 */ // Label 7286: @360792
     /* 360792 */ GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(360822), // Rule ID 872 //
     /* 360797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 360803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360811 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 360811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 360816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360820 */   GIR_RootConstrainSelectedInstOperands,
     /* 360821 */   // GIR_Coverage, 872,
     /* 360821 */   GIR_Done,
     /* 360822 */ // Label 7295: @360822
     /* 360822 */ GIM_Reject,
     /* 360823 */ // Label 7287: @360823
     /* 360823 */ GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(360853), // Rule ID 878 //
     /* 360828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360842 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 360842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 360847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360851 */   GIR_RootConstrainSelectedInstOperands,
     /* 360852 */   // GIR_Coverage, 878,
     /* 360852 */   GIR_Done,
     /* 360853 */ // Label 7296: @360853
     /* 360853 */ GIM_Reject,
     /* 360854 */ // Label 7288: @360854
     /* 360854 */ GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(361075),
     /* 360859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360870 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(360889), // Rule ID 874 //
     /* 360875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360878 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 360878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 360883 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360887 */     GIR_RootConstrainSelectedInstOperands,
     /* 360888 */     // GIR_Coverage, 874,
     /* 360888 */     GIR_Done,
     /* 360889 */   // Label 7298: @360889
     /* 360889 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(361074), // Rule ID 6915 //
     /* 360894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 360897 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 360897 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 360900 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 360904 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360909 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 360913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 360915 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 360918 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 360922 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360927 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 360930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 360932 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 360935 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360939 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360944 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 360950 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360955 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360960 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 360963 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 360967 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360972 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 360975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 360977 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 360980 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 360984 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360989 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360994 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 360997 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 361001 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361006 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 361009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 361011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 361014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361040 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 361043 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 361046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 361064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 361072 */     GIR_RootConstrainSelectedInstOperands,
     /* 361073 */     // GIR_Coverage, 6915,
     /* 361073 */     GIR_EraseRootFromParent_Done,
     /* 361074 */   // Label 7299: @361074
     /* 361074 */   GIM_Reject,
     /* 361075 */ // Label 7297: @361075
     /* 361075 */ GIM_Reject,
     /* 361076 */ // Label 7289: @361076
     /* 361076 */ GIM_Reject,
     /* 361077 */ // Label 101: @361077
     /* 361077 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7308*/ GIMT_Encode4(362202),
     /* 361088 */ /*GILLT_s16*//*Label 7300*/ GIMT_Encode4(361128),
     /* 361092 */ /*GILLT_s32*//*Label 7301*/ GIMT_Encode4(361354),
     /* 361096 */ /*GILLT_s64*//*Label 7302*/ GIMT_Encode4(361580), GIMT_Encode4(0),
     /* 361104 */ /*GILLT_v2s32*//*Label 7303*/ GIMT_Encode4(361752),
     /* 361108 */ /*GILLT_v2s64*//*Label 7304*/ GIMT_Encode4(361790),
     /* 361112 */ /*GILLT_v4s16*//*Label 7305*/ GIMT_Encode4(361828),
     /* 361116 */ /*GILLT_v4s32*//*Label 7306*/ GIMT_Encode4(361866), GIMT_Encode4(0),
     /* 361124 */ /*GILLT_v8s16*//*Label 7307*/ GIMT_Encode4(361904),
     /* 361128 */ // Label 7300: @361128
     /* 361128 */ GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(361353),
     /* 361133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 361136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361143 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(361234), // Rule ID 6835 //
     /* 361148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361169 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361185 */     // MIs[2] Rn
     /* 361185 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 361190 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 361194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361196 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 361196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361208 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 361227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361232 */     GIR_RootConstrainSelectedInstOperands,
     /* 361233 */     // GIR_Coverage, 6835,
     /* 361233 */     GIR_EraseRootFromParent_Done,
     /* 361234 */   // Label 7310: @361234
     /* 361234 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(361325), // Rule ID 13732 //
     /* 361239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 361264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361276 */     // MIs[2] Rn
     /* 361276 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 361281 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 361285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361287 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 361287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361299 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 361318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361323 */     GIR_RootConstrainSelectedInstOperands,
     /* 361324 */     // GIR_Coverage, 13732,
     /* 361324 */     GIR_EraseRootFromParent_Done,
     /* 361325 */   // Label 7311: @361325
     /* 361325 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(361352), // Rule ID 583 //
     /* 361330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 361333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361341 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 361341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 361346 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361350 */     GIR_RootConstrainSelectedInstOperands,
     /* 361351 */     // GIR_Coverage, 583,
     /* 361351 */     GIR_Done,
     /* 361352 */   // Label 7312: @361352
     /* 361352 */   GIM_Reject,
     /* 361353 */ // Label 7309: @361353
     /* 361353 */ GIM_Reject,
     /* 361354 */ // Label 7301: @361354
     /* 361354 */ GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(361579),
     /* 361359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 361362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361369 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(361460), // Rule ID 6833 //
     /* 361374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361395 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361411 */     // MIs[2] Rn
     /* 361411 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 361416 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 361420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361422 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 361422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361434 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 361453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361458 */     GIR_RootConstrainSelectedInstOperands,
     /* 361459 */     // GIR_Coverage, 6833,
     /* 361459 */     GIR_EraseRootFromParent_Done,
     /* 361460 */   // Label 7314: @361460
     /* 361460 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(361551), // Rule ID 13730 //
     /* 361465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361486 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 361490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361502 */     // MIs[2] Rn
     /* 361502 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 361507 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 361511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361513 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 361513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361525 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 361544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361549 */     GIR_RootConstrainSelectedInstOperands,
     /* 361550 */     // GIR_Coverage, 13730,
     /* 361550 */     GIR_EraseRootFromParent_Done,
     /* 361551 */   // Label 7315: @361551
     /* 361551 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(361578), // Rule ID 585 //
     /* 361556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 361559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361567 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 361567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 361572 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361576 */     GIR_RootConstrainSelectedInstOperands,
     /* 361577 */     // GIR_Coverage, 585,
     /* 361577 */     GIR_Done,
     /* 361578 */   // Label 7316: @361578
     /* 361578 */   GIM_Reject,
     /* 361579 */ // Label 7313: @361579
     /* 361579 */ GIM_Reject,
     /* 361580 */ // Label 7302: @361580
     /* 361580 */ GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(361751),
     /* 361585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 361588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361595 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(361659), // Rule ID 6831 //
     /* 361600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361621 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361637 */     // MIs[2] Rn
     /* 361637 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 361642 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 361646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361648 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 361648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 361651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361657 */     GIR_RootConstrainSelectedInstOperands,
     /* 361658 */     // GIR_Coverage, 6831,
     /* 361658 */     GIR_EraseRootFromParent_Done,
     /* 361659 */   // Label 7318: @361659
     /* 361659 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(361723), // Rule ID 13728 //
     /* 361664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 361689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361701 */     // MIs[2] Rn
     /* 361701 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 361706 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 361710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361712 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 361712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 361715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361721 */     GIR_RootConstrainSelectedInstOperands,
     /* 361722 */     // GIR_Coverage, 13728,
     /* 361722 */     GIR_EraseRootFromParent_Done,
     /* 361723 */   // Label 7319: @361723
     /* 361723 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(361750), // Rule ID 587 //
     /* 361728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 361731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361739 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 361739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 361744 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361748 */     GIR_RootConstrainSelectedInstOperands,
     /* 361749 */     // GIR_Coverage, 587,
     /* 361749 */     GIR_Done,
     /* 361750 */   // Label 7320: @361750
     /* 361750 */   GIM_Reject,
     /* 361751 */ // Label 7317: @361751
     /* 361751 */ GIM_Reject,
     /* 361752 */ // Label 7303: @361752
     /* 361752 */ GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(361789), // Rule ID 1195 //
     /* 361757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 361763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 361766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361778 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 361778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 361783 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361787 */   GIR_RootConstrainSelectedInstOperands,
     /* 361788 */   // GIR_Coverage, 1195,
     /* 361788 */   GIR_Done,
     /* 361789 */ // Label 7321: @361789
     /* 361789 */ GIM_Reject,
     /* 361790 */ // Label 7304: @361790
     /* 361790 */ GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(361827), // Rule ID 1199 //
     /* 361795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 361804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361816 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 361816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 361821 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361825 */   GIR_RootConstrainSelectedInstOperands,
     /* 361826 */   // GIR_Coverage, 1199,
     /* 361826 */   GIR_Done,
     /* 361827 */ // Label 7322: @361827
     /* 361827 */ GIM_Reject,
     /* 361828 */ // Label 7305: @361828
     /* 361828 */ GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(361865), // Rule ID 1191 //
     /* 361833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 361836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 361839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 361842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361854 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 361854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 361859 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361863 */   GIR_RootConstrainSelectedInstOperands,
     /* 361864 */   // GIR_Coverage, 1191,
     /* 361864 */   GIR_Done,
     /* 361865 */ // Label 7323: @361865
     /* 361865 */ GIM_Reject,
     /* 361866 */ // Label 7306: @361866
     /* 361866 */ GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(361903), // Rule ID 1197 //
     /* 361871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 361880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361892 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 361892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 361897 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361901 */   GIR_RootConstrainSelectedInstOperands,
     /* 361902 */   // GIR_Coverage, 1197,
     /* 361902 */   GIR_Done,
     /* 361903 */ // Label 7324: @361903
     /* 361903 */ GIM_Reject,
     /* 361904 */ // Label 7307: @361904
     /* 361904 */ GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(362201),
     /* 361909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 361915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361927 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(361946), // Rule ID 1193 //
     /* 361932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 361935 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 361935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 361940 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361944 */     GIR_RootConstrainSelectedInstOperands,
     /* 361945 */     // GIR_Coverage, 1193,
     /* 361945 */     GIR_Done,
     /* 361946 */   // Label 7326: @361946
     /* 361946 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(362200), // Rule ID 6924 //
     /* 361951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 361954 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 361954 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 361957 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 361961 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361966 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 361970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 361972 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 361975 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 361979 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361984 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 361988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 361990 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 361993 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 361997 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362002 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 362005 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 362008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 362010 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 362013 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362017 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362022 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 362028 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362033 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362038 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 362041 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 362045 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362050 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 362053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 362055 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 362058 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362062 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362067 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 362073 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362078 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362083 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 362086 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 362090 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362095 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 362098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 362100 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 362103 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 362107 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362112 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 362115 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 362118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 362120 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 362123 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 362127 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362132 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 362135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362166 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362169 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 362190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 362198 */     GIR_RootConstrainSelectedInstOperands,
     /* 362199 */     // GIR_Coverage, 6924,
     /* 362199 */     GIR_EraseRootFromParent_Done,
     /* 362200 */   // Label 7327: @362200
     /* 362200 */   GIM_Reject,
     /* 362201 */ // Label 7325: @362201
     /* 362201 */ GIM_Reject,
     /* 362202 */ // Label 7308: @362202
     /* 362202 */ GIM_Reject,
     /* 362203 */ // Label 102: @362203
     /* 362203 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7336*/ GIMT_Encode4(362818),
     /* 362214 */ /*GILLT_s16*//*Label 7328*/ GIMT_Encode4(362254),
     /* 362218 */ /*GILLT_s32*//*Label 7329*/ GIMT_Encode4(362292),
     /* 362222 */ /*GILLT_s64*//*Label 7330*/ GIMT_Encode4(362330), GIMT_Encode4(0),
     /* 362230 */ /*GILLT_v2s32*//*Label 7331*/ GIMT_Encode4(362368),
     /* 362234 */ /*GILLT_v2s64*//*Label 7332*/ GIMT_Encode4(362406),
     /* 362238 */ /*GILLT_v4s16*//*Label 7333*/ GIMT_Encode4(362444),
     /* 362242 */ /*GILLT_v4s32*//*Label 7334*/ GIMT_Encode4(362482), GIMT_Encode4(0),
     /* 362250 */ /*GILLT_v8s16*//*Label 7335*/ GIMT_Encode4(362520),
     /* 362254 */ // Label 7328: @362254
     /* 362254 */ GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(362291), // Rule ID 631 //
     /* 362259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 362262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 362265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362280 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 362280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 362285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362289 */   GIR_RootConstrainSelectedInstOperands,
     /* 362290 */   // GIR_Coverage, 631,
     /* 362290 */   GIR_Done,
     /* 362291 */ // Label 7337: @362291
     /* 362291 */ GIM_Reject,
     /* 362292 */ // Label 7329: @362292
     /* 362292 */ GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(362329), // Rule ID 633 //
     /* 362297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 362300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 362303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362318 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 362318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 362323 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362327 */   GIR_RootConstrainSelectedInstOperands,
     /* 362328 */   // GIR_Coverage, 633,
     /* 362328 */   GIR_Done,
     /* 362329 */ // Label 7338: @362329
     /* 362329 */ GIM_Reject,
     /* 362330 */ // Label 7330: @362330
     /* 362330 */ GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(362367), // Rule ID 635 //
     /* 362335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 362338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 362341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362356 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 362356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 362361 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362365 */   GIR_RootConstrainSelectedInstOperands,
     /* 362366 */   // GIR_Coverage, 635,
     /* 362366 */   GIR_Done,
     /* 362367 */ // Label 7339: @362367
     /* 362367 */ GIM_Reject,
     /* 362368 */ // Label 7331: @362368
     /* 362368 */ GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(362405), // Rule ID 1335 //
     /* 362373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 362379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 362382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362394 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 362394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 362399 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362403 */   GIR_RootConstrainSelectedInstOperands,
     /* 362404 */   // GIR_Coverage, 1335,
     /* 362404 */   GIR_Done,
     /* 362405 */ // Label 7340: @362405
     /* 362405 */ GIM_Reject,
     /* 362406 */ // Label 7332: @362406
     /* 362406 */ GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(362443), // Rule ID 1339 //
     /* 362411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 362420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362432 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 362432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 362437 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362441 */   GIR_RootConstrainSelectedInstOperands,
     /* 362442 */   // GIR_Coverage, 1339,
     /* 362442 */   GIR_Done,
     /* 362443 */ // Label 7341: @362443
     /* 362443 */ GIM_Reject,
     /* 362444 */ // Label 7333: @362444
     /* 362444 */ GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(362481), // Rule ID 1331 //
     /* 362449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 362458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362470 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 362470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 362475 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362479 */   GIR_RootConstrainSelectedInstOperands,
     /* 362480 */   // GIR_Coverage, 1331,
     /* 362480 */   GIR_Done,
     /* 362481 */ // Label 7342: @362481
     /* 362481 */ GIM_Reject,
     /* 362482 */ // Label 7334: @362482
     /* 362482 */ GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(362519), // Rule ID 1337 //
     /* 362487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 362496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362508 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 362508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 362513 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362517 */   GIR_RootConstrainSelectedInstOperands,
     /* 362518 */   // GIR_Coverage, 1337,
     /* 362518 */   GIR_Done,
     /* 362519 */ // Label 7343: @362519
     /* 362519 */ GIM_Reject,
     /* 362520 */ // Label 7335: @362520
     /* 362520 */ GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(362817),
     /* 362525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 362531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362543 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(362562), // Rule ID 1333 //
     /* 362548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362551 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 362551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 362556 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362560 */     GIR_RootConstrainSelectedInstOperands,
     /* 362561 */     // GIR_Coverage, 1333,
     /* 362561 */     GIR_Done,
     /* 362562 */   // Label 7345: @362562
     /* 362562 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(362816), // Rule ID 6930 //
     /* 362567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 362570 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 362570 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 362573 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 362577 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362582 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 362586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 362588 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 362591 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 362595 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362600 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 362604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 362606 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 362609 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 362613 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362618 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 362621 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 362624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 362626 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 362629 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362633 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362638 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 362644 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362649 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362654 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 362657 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 362661 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362666 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 362669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 362671 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 362674 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362678 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362683 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 362689 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362694 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362699 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 362702 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 362706 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362711 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 362714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 362716 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 362719 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 362723 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362728 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 362731 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 362734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 362736 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 362739 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 362743 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362748 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 362751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362753 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362756 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362760 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362779 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362782 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362785 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 362806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 362814 */     GIR_RootConstrainSelectedInstOperands,
     /* 362815 */     // GIR_Coverage, 6930,
     /* 362815 */     GIR_EraseRootFromParent_Done,
     /* 362816 */   // Label 7346: @362816
     /* 362816 */   GIM_Reject,
     /* 362817 */ // Label 7344: @362817
     /* 362817 */ GIM_Reject,
     /* 362818 */ // Label 7336: @362818
     /* 362818 */ GIM_Reject,
     /* 362819 */ // Label 103: @362819
     /* 362819 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7355*/ GIMT_Encode4(366540),
     /* 362830 */ /*GILLT_s16*//*Label 7347*/ GIMT_Encode4(362870),
     /* 362834 */ /*GILLT_s32*//*Label 7348*/ GIMT_Encode4(363424),
     /* 362838 */ /*GILLT_s64*//*Label 7349*/ GIMT_Encode4(363972), GIMT_Encode4(0),
     /* 362846 */ /*GILLT_v2s32*//*Label 7350*/ GIMT_Encode4(364520),
     /* 362850 */ /*GILLT_v2s64*//*Label 7351*/ GIMT_Encode4(365050),
     /* 362854 */ /*GILLT_v4s16*//*Label 7352*/ GIMT_Encode4(365408),
     /* 362858 */ /*GILLT_v4s32*//*Label 7353*/ GIMT_Encode4(365750), GIMT_Encode4(0),
     /* 362866 */ /*GILLT_v8s16*//*Label 7354*/ GIMT_Encode4(366108),
     /* 362870 */ // Label 7347: @362870
     /* 362870 */ GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(363423),
     /* 362875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 362878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362885 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(362998), // Rule ID 6157 //
     /* 362890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362914 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 362918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362947 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362951 */     // MIs[3] Operand 1
     /* 362951 */     // No operand predicates
     /* 362951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362953 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 362953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362965 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 362971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 362984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 362993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 362996 */     GIR_RootConstrainSelectedInstOperands,
     /* 362997 */     // GIR_Coverage, 6157,
     /* 362997 */     GIR_EraseRootFromParent_Done,
     /* 362998 */   // Label 7357: @362998
     /* 362998 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(363111), // Rule ID 13703 //
     /* 363003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363035 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363039 */     // MIs[2] Operand 1
     /* 363039 */     // No operand predicates
     /* 363039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 363055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363060 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 363064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363066 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 363066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363078 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 363084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 363097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363109 */     GIR_RootConstrainSelectedInstOperands,
     /* 363110 */     // GIR_Coverage, 13703,
     /* 363110 */     GIR_EraseRootFromParent_Done,
     /* 363111 */   // Label 7358: @363111
     /* 363111 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(363190), // Rule ID 13640 //
     /* 363116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 363119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363140 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 363144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363150 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 363150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363162 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 363168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 363181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363188 */     GIR_RootConstrainSelectedInstOperands,
     /* 363189 */     // GIR_Coverage, 13640,
     /* 363189 */     GIR_EraseRootFromParent_Done,
     /* 363190 */   // Label 7359: @363190
     /* 363190 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(363269), // Rule ID 4753 //
     /* 363195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 363198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 363227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363229 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 363229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363241 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 363247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 363260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363267 */     GIR_RootConstrainSelectedInstOperands,
     /* 363268 */     // GIR_Coverage, 4753,
     /* 363268 */     GIR_EraseRootFromParent_Done,
     /* 363269 */   // Label 7360: @363269
     /* 363269 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(363332), // Rule ID 13255 //
     /* 363274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363310 */     // MIs[2] Operand 1
     /* 363310 */     // No operand predicates
     /* 363310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363316 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 363319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363330 */     GIR_RootConstrainSelectedInstOperands,
     /* 363331 */     // GIR_Coverage, 13255,
     /* 363331 */     GIR_EraseRootFromParent_Done,
     /* 363332 */   // Label 7361: @363332
     /* 363332 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(363395), // Rule ID 2004 //
     /* 363337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363377 */     // MIs[2] Operand 1
     /* 363377 */     // No operand predicates
     /* 363377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363379 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 363382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363393 */     GIR_RootConstrainSelectedInstOperands,
     /* 363394 */     // GIR_Coverage, 2004,
     /* 363394 */     GIR_EraseRootFromParent_Done,
     /* 363395 */   // Label 7362: @363395
     /* 363395 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(363422), // Rule ID 619 //
     /* 363400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 363403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363411 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 363411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 363416 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363420 */     GIR_RootConstrainSelectedInstOperands,
     /* 363421 */     // GIR_Coverage, 619,
     /* 363421 */     GIR_Done,
     /* 363422 */   // Label 7363: @363422
     /* 363422 */   GIM_Reject,
     /* 363423 */ // Label 7356: @363423
     /* 363423 */ GIM_Reject,
     /* 363424 */ // Label 7348: @363424
     /* 363424 */ GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(363971),
     /* 363429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 363432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363439 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(363552), // Rule ID 6159 //
     /* 363444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363468 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 363472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 363488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363501 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363505 */     // MIs[3] Operand 1
     /* 363505 */     // No operand predicates
     /* 363505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363507 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 363507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363519 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 363525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 363538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 363547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 363550 */     GIR_RootConstrainSelectedInstOperands,
     /* 363551 */     // GIR_Coverage, 6159,
     /* 363551 */     GIR_EraseRootFromParent_Done,
     /* 363552 */   // Label 7365: @363552
     /* 363552 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(363665), // Rule ID 13705 //
     /* 363557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363593 */     // MIs[2] Operand 1
     /* 363593 */     // No operand predicates
     /* 363593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363601 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363605 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 363609 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363614 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 363618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363620 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 363620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363632 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 363638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 363651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363663 */     GIR_RootConstrainSelectedInstOperands,
     /* 363664 */     // GIR_Coverage, 13705,
     /* 363664 */     GIR_EraseRootFromParent_Done,
     /* 363665 */   // Label 7366: @363665
     /* 363665 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(363741), // Rule ID 13642 //
     /* 363670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363691 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 363695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363701 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 363701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363713 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 363719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 363732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363739 */     GIR_RootConstrainSelectedInstOperands,
     /* 363740 */     // GIR_Coverage, 13642,
     /* 363740 */     GIR_EraseRootFromParent_Done,
     /* 363741 */   // Label 7367: @363741
     /* 363741 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(363817), // Rule ID 4755 //
     /* 363746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 363775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363777 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 363777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363789 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 363795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 363808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363815 */     GIR_RootConstrainSelectedInstOperands,
     /* 363816 */     // GIR_Coverage, 4755,
     /* 363816 */     GIR_EraseRootFromParent_Done,
     /* 363817 */   // Label 7368: @363817
     /* 363817 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(363880), // Rule ID 13257 //
     /* 363822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363858 */     // MIs[2] Operand 1
     /* 363858 */     // No operand predicates
     /* 363858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363864 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 363867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363878 */     GIR_RootConstrainSelectedInstOperands,
     /* 363879 */     // GIR_Coverage, 13257,
     /* 363879 */     GIR_EraseRootFromParent_Done,
     /* 363880 */   // Label 7369: @363880
     /* 363880 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(363943), // Rule ID 2006 //
     /* 363885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363921 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363925 */     // MIs[2] Operand 1
     /* 363925 */     // No operand predicates
     /* 363925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363927 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 363930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363941 */     GIR_RootConstrainSelectedInstOperands,
     /* 363942 */     // GIR_Coverage, 2006,
     /* 363942 */     GIR_EraseRootFromParent_Done,
     /* 363943 */   // Label 7370: @363943
     /* 363943 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(363970), // Rule ID 621 //
     /* 363948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363959 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 363959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 363964 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363968 */     GIR_RootConstrainSelectedInstOperands,
     /* 363969 */     // GIR_Coverage, 621,
     /* 363969 */     GIR_Done,
     /* 363970 */   // Label 7371: @363970
     /* 363970 */   GIM_Reject,
     /* 363971 */ // Label 7364: @363971
     /* 363971 */ GIM_Reject,
     /* 363972 */ // Label 7349: @363972
     /* 363972 */ GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(364519),
     /* 363977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 363980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363987 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(364100), // Rule ID 6161 //
     /* 363992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364016 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364049 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364053 */     // MIs[3] Operand 1
     /* 364053 */     // No operand predicates
     /* 364053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364055 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 364055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 364058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364067 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 364073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 364086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 364095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 364098 */     GIR_RootConstrainSelectedInstOperands,
     /* 364099 */     // GIR_Coverage, 6161,
     /* 364099 */     GIR_EraseRootFromParent_Done,
     /* 364100 */   // Label 7373: @364100
     /* 364100 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(364213), // Rule ID 13707 //
     /* 364105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364141 */     // MIs[2] Operand 1
     /* 364141 */     // No operand predicates
     /* 364141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364153 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 364157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364162 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 364166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364168 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 364168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 364171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364180 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 364186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 364199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 364208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 364211 */     GIR_RootConstrainSelectedInstOperands,
     /* 364212 */     // GIR_Coverage, 13707,
     /* 364212 */     GIR_EraseRootFromParent_Done,
     /* 364213 */   // Label 7374: @364213
     /* 364213 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(364289), // Rule ID 13644 //
     /* 364218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364239 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364249 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 364249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 364252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364261 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 364267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 364280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364287 */     GIR_RootConstrainSelectedInstOperands,
     /* 364288 */     // GIR_Coverage, 13644,
     /* 364288 */     GIR_EraseRootFromParent_Done,
     /* 364289 */   // Label 7375: @364289
     /* 364289 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(364365), // Rule ID 4757 //
     /* 364294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364325 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 364325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 364328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364337 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 364343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 364356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364363 */     GIR_RootConstrainSelectedInstOperands,
     /* 364364 */     // GIR_Coverage, 4757,
     /* 364364 */     GIR_EraseRootFromParent_Done,
     /* 364365 */   // Label 7376: @364365
     /* 364365 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(364428), // Rule ID 13259 //
     /* 364370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364402 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364406 */     // MIs[2] Operand 1
     /* 364406 */     // No operand predicates
     /* 364406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364412 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 364412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 364415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 364423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 364426 */     GIR_RootConstrainSelectedInstOperands,
     /* 364427 */     // GIR_Coverage, 13259,
     /* 364427 */     GIR_EraseRootFromParent_Done,
     /* 364428 */   // Label 7377: @364428
     /* 364428 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(364491), // Rule ID 2008 //
     /* 364433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364469 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364473 */     // MIs[2] Operand 1
     /* 364473 */     // No operand predicates
     /* 364473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364475 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 364475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 364478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 364486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 364489 */     GIR_RootConstrainSelectedInstOperands,
     /* 364490 */     // GIR_Coverage, 2008,
     /* 364490 */     GIR_EraseRootFromParent_Done,
     /* 364491 */   // Label 7378: @364491
     /* 364491 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(364518), // Rule ID 623 //
     /* 364496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 364499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364507 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 364507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 364512 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364516 */     GIR_RootConstrainSelectedInstOperands,
     /* 364517 */     // GIR_Coverage, 623,
     /* 364517 */     GIR_Done,
     /* 364518 */   // Label 7379: @364518
     /* 364518 */   GIM_Reject,
     /* 364519 */ // Label 7372: @364519
     /* 364519 */ GIM_Reject,
     /* 364520 */ // Label 7350: @364520
     /* 364520 */ GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(365049),
     /* 364525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 364528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 364531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364535 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(364621), // Rule ID 13247 //
     /* 364540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 364551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 364563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364584 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 364588 */     // MIs[3] Operand 1
     /* 364588 */     // No operand predicates
     /* 364588 */     // MIs[1] Operand 2
     /* 364588 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 364599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364605 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 364605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 364608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 364616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 364619 */     GIR_RootConstrainSelectedInstOperands,
     /* 364620 */     // GIR_Coverage, 13247,
     /* 364620 */     GIR_EraseRootFromParent_Done,
     /* 364621 */   // Label 7381: @364621
     /* 364621 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(364707), // Rule ID 1996 //
     /* 364626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 364641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 364653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 364678 */     // MIs[3] Operand 1
     /* 364678 */     // No operand predicates
     /* 364678 */     // MIs[1] Operand 2
     /* 364678 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 364689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364691 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 364691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 364694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 364702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 364705 */     GIR_RootConstrainSelectedInstOperands,
     /* 364706 */     // GIR_Coverage, 1996,
     /* 364706 */     GIR_EraseRootFromParent_Done,
     /* 364707 */   // Label 7382: @364707
     /* 364707 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(364770), // Rule ID 13248 //
     /* 364712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 364723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 364748 */     // MIs[2] Operand 1
     /* 364748 */     // No operand predicates
     /* 364748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364754 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 364754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 364757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 364765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 364768 */     GIR_RootConstrainSelectedInstOperands,
     /* 364769 */     // GIR_Coverage, 13248,
     /* 364769 */     GIR_EraseRootFromParent_Done,
     /* 364770 */   // Label 7383: @364770
     /* 364770 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(364833), // Rule ID 1997 //
     /* 364775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 364790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 364815 */     // MIs[2] Operand 1
     /* 364815 */     // No operand predicates
     /* 364815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364817 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 364817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 364820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 364828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 364831 */     GIR_RootConstrainSelectedInstOperands,
     /* 364832 */     // GIR_Coverage, 1997,
     /* 364832 */     GIR_EraseRootFromParent_Done,
     /* 364833 */   // Label 7384: @364833
     /* 364833 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(364927), // Rule ID 13709 //
     /* 364838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 364846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364861 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364861 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 364864 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364868 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 364878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 364894 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 364897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 364915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364925 */     GIR_RootConstrainSelectedInstOperands,
     /* 364926 */     // GIR_Coverage, 13709,
     /* 364926 */     GIR_EraseRootFromParent_Done,
     /* 364927 */   // Label 7385: @364927
     /* 364927 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(365021), // Rule ID 6163 //
     /* 364932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 364944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364955 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 364958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 364972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 364988 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 364991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 365009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365019 */     GIR_RootConstrainSelectedInstOperands,
     /* 365020 */     // GIR_Coverage, 6163,
     /* 365020 */     GIR_EraseRootFromParent_Done,
     /* 365021 */   // Label 7386: @365021
     /* 365021 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(365048), // Rule ID 1315 //
     /* 365026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365037 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 365037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 365042 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365046 */     GIR_RootConstrainSelectedInstOperands,
     /* 365047 */     // GIR_Coverage, 1315,
     /* 365047 */     GIR_Done,
     /* 365048 */   // Label 7387: @365048
     /* 365048 */   GIM_Reject,
     /* 365049 */ // Label 7380: @365049
     /* 365049 */ GIM_Reject,
     /* 365050 */ // Label 7351: @365050
     /* 365050 */ GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(365407),
     /* 365055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 365058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 365061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365065 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(365128), // Rule ID 13253 //
     /* 365070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 365081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 365085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365102 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 365106 */     // MIs[2] Operand 1
     /* 365106 */     // No operand predicates
     /* 365106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365112 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 365112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 365115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365126 */     GIR_RootConstrainSelectedInstOperands,
     /* 365127 */     // GIR_Coverage, 13253,
     /* 365127 */     GIR_EraseRootFromParent_Done,
     /* 365128 */   // Label 7389: @365128
     /* 365128 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(365191), // Rule ID 2002 //
     /* 365133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 365148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 365152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365169 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 365173 */     // MIs[2] Operand 1
     /* 365173 */     // No operand predicates
     /* 365173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365175 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 365175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 365178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365189 */     GIR_RootConstrainSelectedInstOperands,
     /* 365190 */     // GIR_Coverage, 2002,
     /* 365190 */     GIR_EraseRootFromParent_Done,
     /* 365191 */   // Label 7390: @365191
     /* 365191 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(365285), // Rule ID 13713 //
     /* 365196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 365204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 365208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365219 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 365222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 365273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365283 */     GIR_RootConstrainSelectedInstOperands,
     /* 365284 */     // GIR_Coverage, 13713,
     /* 365284 */     GIR_EraseRootFromParent_Done,
     /* 365285 */   // Label 7391: @365285
     /* 365285 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(365379), // Rule ID 6167 //
     /* 365290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 365302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 365306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365313 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 365316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365339 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 365367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365377 */     GIR_RootConstrainSelectedInstOperands,
     /* 365378 */     // GIR_Coverage, 6167,
     /* 365378 */     GIR_EraseRootFromParent_Done,
     /* 365379 */   // Label 7392: @365379
     /* 365379 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(365406), // Rule ID 1319 //
     /* 365384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365395 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 365395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 365400 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365404 */     GIR_RootConstrainSelectedInstOperands,
     /* 365405 */     // GIR_Coverage, 1319,
     /* 365405 */     GIR_Done,
     /* 365406 */   // Label 7393: @365406
     /* 365406 */   GIM_Reject,
     /* 365407 */ // Label 7388: @365407
     /* 365407 */ GIM_Reject,
     /* 365408 */ // Label 7352: @365408
     /* 365408 */ GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(365749),
     /* 365413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 365416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 365419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365423 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(365509), // Rule ID 13241 //
     /* 365428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 365439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 365451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365472 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365476 */     // MIs[3] Operand 1
     /* 365476 */     // No operand predicates
     /* 365476 */     // MIs[1] Operand 2
     /* 365476 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 365487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365493 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 365493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 365496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365507 */     GIR_RootConstrainSelectedInstOperands,
     /* 365508 */     // GIR_Coverage, 13241,
     /* 365508 */     GIR_EraseRootFromParent_Done,
     /* 365509 */   // Label 7395: @365509
     /* 365509 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(365595), // Rule ID 1990 //
     /* 365514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 365529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 365541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365562 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365566 */     // MIs[3] Operand 1
     /* 365566 */     // No operand predicates
     /* 365566 */     // MIs[1] Operand 2
     /* 365566 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 365577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365579 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 365579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 365582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365593 */     GIR_RootConstrainSelectedInstOperands,
     /* 365594 */     // GIR_Coverage, 1990,
     /* 365594 */     GIR_EraseRootFromParent_Done,
     /* 365595 */   // Label 7396: @365595
     /* 365595 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(365658), // Rule ID 13242 //
     /* 365600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 365611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365632 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365636 */     // MIs[2] Operand 1
     /* 365636 */     // No operand predicates
     /* 365636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365642 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 365642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 365645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365656 */     GIR_RootConstrainSelectedInstOperands,
     /* 365657 */     // GIR_Coverage, 13242,
     /* 365657 */     GIR_EraseRootFromParent_Done,
     /* 365658 */   // Label 7397: @365658
     /* 365658 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(365721), // Rule ID 1991 //
     /* 365663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 365678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365703 */     // MIs[2] Operand 1
     /* 365703 */     // No operand predicates
     /* 365703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365705 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 365705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 365708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365719 */     GIR_RootConstrainSelectedInstOperands,
     /* 365720 */     // GIR_Coverage, 1991,
     /* 365720 */     GIR_EraseRootFromParent_Done,
     /* 365721 */   // Label 7398: @365721
     /* 365721 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(365748), // Rule ID 1311 //
     /* 365726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365737 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 365737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 365742 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365746 */     GIR_RootConstrainSelectedInstOperands,
     /* 365747 */     // GIR_Coverage, 1311,
     /* 365747 */     GIR_Done,
     /* 365748 */   // Label 7399: @365748
     /* 365748 */   GIM_Reject,
     /* 365749 */ // Label 7394: @365749
     /* 365749 */ GIM_Reject,
     /* 365750 */ // Label 7353: @365750
     /* 365750 */ GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(366107),
     /* 365755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 365761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365765 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(365828), // Rule ID 13251 //
     /* 365770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 365781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365802 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365806 */     // MIs[2] Operand 1
     /* 365806 */     // No operand predicates
     /* 365806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365812 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 365812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 365815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365826 */     GIR_RootConstrainSelectedInstOperands,
     /* 365827 */     // GIR_Coverage, 13251,
     /* 365827 */     GIR_EraseRootFromParent_Done,
     /* 365828 */   // Label 7401: @365828
     /* 365828 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(365891), // Rule ID 2000 //
     /* 365833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 365848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365869 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365873 */     // MIs[2] Operand 1
     /* 365873 */     // No operand predicates
     /* 365873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365875 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 365875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 365878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365889 */     GIR_RootConstrainSelectedInstOperands,
     /* 365890 */     // GIR_Coverage, 2000,
     /* 365890 */     GIR_EraseRootFromParent_Done,
     /* 365891 */   // Label 7402: @365891
     /* 365891 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(365985), // Rule ID 13711 //
     /* 365896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 365904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365919 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 365922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 365955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 365973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365983 */     GIR_RootConstrainSelectedInstOperands,
     /* 365984 */     // GIR_Coverage, 13711,
     /* 365984 */     GIR_EraseRootFromParent_Done,
     /* 365985 */   // Label 7403: @365985
     /* 365985 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(366079), // Rule ID 6165 //
     /* 365990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 366002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366013 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366013 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 366016 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366020 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366046 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 366049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 366067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366077 */     GIR_RootConstrainSelectedInstOperands,
     /* 366078 */     // GIR_Coverage, 6165,
     /* 366078 */     GIR_EraseRootFromParent_Done,
     /* 366079 */   // Label 7404: @366079
     /* 366079 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(366106), // Rule ID 1317 //
     /* 366084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366095 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 366095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 366100 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366104 */     GIR_RootConstrainSelectedInstOperands,
     /* 366105 */     // GIR_Coverage, 1317,
     /* 366105 */     GIR_Done,
     /* 366106 */   // Label 7405: @366106
     /* 366106 */   GIM_Reject,
     /* 366107 */ // Label 7400: @366107
     /* 366107 */ GIM_Reject,
     /* 366108 */ // Label 7354: @366108
     /* 366108 */ GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(366539),
     /* 366113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 366119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366123 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(366186), // Rule ID 13245 //
     /* 366128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 366139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366164 */     // MIs[2] Operand 1
     /* 366164 */     // No operand predicates
     /* 366164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366170 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 366170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 366173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366184 */     GIR_RootConstrainSelectedInstOperands,
     /* 366185 */     // GIR_Coverage, 13245,
     /* 366185 */     GIR_EraseRootFromParent_Done,
     /* 366186 */   // Label 7407: @366186
     /* 366186 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(366249), // Rule ID 1994 //
     /* 366191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 366206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366227 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366231 */     // MIs[2] Operand 1
     /* 366231 */     // No operand predicates
     /* 366231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366233 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 366233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 366236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366247 */     GIR_RootConstrainSelectedInstOperands,
     /* 366248 */     // GIR_Coverage, 1994,
     /* 366248 */     GIR_EraseRootFromParent_Done,
     /* 366249 */   // Label 7408: @366249
     /* 366249 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(366276), // Rule ID 1313 //
     /* 366254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366265 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 366265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 366270 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366274 */     GIR_RootConstrainSelectedInstOperands,
     /* 366275 */     // GIR_Coverage, 1313,
     /* 366275 */     GIR_Done,
     /* 366276 */   // Label 7409: @366276
     /* 366276 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(366538), // Rule ID 6928 //
     /* 366281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 366284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366292 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 366292 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 366295 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 366299 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366304 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 366310 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 366313 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 366317 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366322 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 366328 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 366331 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 366335 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366340 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 366343 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 366346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 366348 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 366351 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366355 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366360 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 366366 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366371 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366376 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 366379 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 366383 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366388 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 366391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 366393 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 366396 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366400 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366405 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 366411 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366416 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366421 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 366424 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 366428 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366433 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 366436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 366438 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 366441 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 366445 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366450 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 366453 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 366456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 366458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 366461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 366465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366470 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 366473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 366475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 366478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366501 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 366507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 366510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 366528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 366536 */     GIR_RootConstrainSelectedInstOperands,
     /* 366537 */     // GIR_Coverage, 6928,
     /* 366537 */     GIR_EraseRootFromParent_Done,
     /* 366538 */   // Label 7410: @366538
     /* 366538 */   GIM_Reject,
     /* 366539 */ // Label 7406: @366539
     /* 366539 */ GIM_Reject,
     /* 366540 */ // Label 7355: @366540
     /* 366540 */ GIM_Reject,
     /* 366541 */ // Label 104: @366541
     /* 366541 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7419*/ GIMT_Encode4(367156),
     /* 366552 */ /*GILLT_s16*//*Label 7411*/ GIMT_Encode4(366592),
     /* 366556 */ /*GILLT_s32*//*Label 7412*/ GIMT_Encode4(366630),
     /* 366560 */ /*GILLT_s64*//*Label 7413*/ GIMT_Encode4(366668), GIMT_Encode4(0),
     /* 366568 */ /*GILLT_v2s32*//*Label 7414*/ GIMT_Encode4(366706),
     /* 366572 */ /*GILLT_v2s64*//*Label 7415*/ GIMT_Encode4(366744),
     /* 366576 */ /*GILLT_v4s16*//*Label 7416*/ GIMT_Encode4(366782),
     /* 366580 */ /*GILLT_v4s32*//*Label 7417*/ GIMT_Encode4(366820), GIMT_Encode4(0),
     /* 366588 */ /*GILLT_v8s16*//*Label 7418*/ GIMT_Encode4(366858),
     /* 366592 */ // Label 7411: @366592
     /* 366592 */ GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(366629), // Rule ID 589 //
     /* 366597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 366606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366618 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 366618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 366623 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366627 */   GIR_RootConstrainSelectedInstOperands,
     /* 366628 */   // GIR_Coverage, 589,
     /* 366628 */   GIR_Done,
     /* 366629 */ // Label 7420: @366629
     /* 366629 */ GIM_Reject,
     /* 366630 */ // Label 7412: @366630
     /* 366630 */ GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(366667), // Rule ID 591 //
     /* 366635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 366638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366656 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 366656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 366661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366665 */   GIR_RootConstrainSelectedInstOperands,
     /* 366666 */   // GIR_Coverage, 591,
     /* 366666 */   GIR_Done,
     /* 366667 */ // Label 7421: @366667
     /* 366667 */ GIM_Reject,
     /* 366668 */ // Label 7413: @366668
     /* 366668 */ GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(366705), // Rule ID 593 //
     /* 366673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 366676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 366679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366694 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 366694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 366699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366703 */   GIR_RootConstrainSelectedInstOperands,
     /* 366704 */   // GIR_Coverage, 593,
     /* 366704 */   GIR_Done,
     /* 366705 */ // Label 7422: @366705
     /* 366705 */ GIM_Reject,
     /* 366706 */ // Label 7414: @366706
     /* 366706 */ GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(366743), // Rule ID 1220 //
     /* 366711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 366720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366732 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 366732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 366737 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366741 */   GIR_RootConstrainSelectedInstOperands,
     /* 366742 */   // GIR_Coverage, 1220,
     /* 366742 */   GIR_Done,
     /* 366743 */ // Label 7423: @366743
     /* 366743 */ GIM_Reject,
     /* 366744 */ // Label 7415: @366744
     /* 366744 */ GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(366781), // Rule ID 1224 //
     /* 366749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 366755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 366758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366770 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 366770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 366775 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366779 */   GIR_RootConstrainSelectedInstOperands,
     /* 366780 */   // GIR_Coverage, 1224,
     /* 366780 */   GIR_Done,
     /* 366781 */ // Label 7424: @366781
     /* 366781 */ GIM_Reject,
     /* 366782 */ // Label 7416: @366782
     /* 366782 */ GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(366819), // Rule ID 1216 //
     /* 366787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 366793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 366796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366808 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 366808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 366813 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366817 */   GIR_RootConstrainSelectedInstOperands,
     /* 366818 */   // GIR_Coverage, 1216,
     /* 366818 */   GIR_Done,
     /* 366819 */ // Label 7425: @366819
     /* 366819 */ GIM_Reject,
     /* 366820 */ // Label 7417: @366820
     /* 366820 */ GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(366857), // Rule ID 1222 //
     /* 366825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 366834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366846 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 366846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 366851 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366855 */   GIR_RootConstrainSelectedInstOperands,
     /* 366856 */   // GIR_Coverage, 1222,
     /* 366856 */   GIR_Done,
     /* 366857 */ // Label 7426: @366857
     /* 366857 */ GIM_Reject,
     /* 366858 */ // Label 7418: @366858
     /* 366858 */ GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(367155),
     /* 366863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 366869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366881 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(366900), // Rule ID 1218 //
     /* 366886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366889 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 366889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 366894 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366898 */     GIR_RootConstrainSelectedInstOperands,
     /* 366899 */     // GIR_Coverage, 1218,
     /* 366899 */     GIR_Done,
     /* 366900 */   // Label 7428: @366900
     /* 366900 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(367154), // Rule ID 6926 //
     /* 366905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 366908 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 366908 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 366911 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 366915 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366920 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 366926 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 366929 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 366933 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366938 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 366944 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 366947 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 366951 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366956 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 366959 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 366962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 366964 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 366967 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366971 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366976 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 366982 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366987 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366992 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 366995 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 366999 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367004 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 367007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 367009 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 367012 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367016 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367021 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 367027 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367032 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367037 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 367040 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 367044 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367049 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 367052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 367054 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 367057 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 367061 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367066 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 367069 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 367072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 367074 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 367077 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 367081 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367086 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 367089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 367091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 367094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 367123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 367126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 367144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 367152 */     GIR_RootConstrainSelectedInstOperands,
     /* 367153 */     // GIR_Coverage, 6926,
     /* 367153 */     GIR_EraseRootFromParent_Done,
     /* 367154 */   // Label 7429: @367154
     /* 367154 */   GIM_Reject,
     /* 367155 */ // Label 7427: @367155
     /* 367155 */ GIM_Reject,
     /* 367156 */ // Label 7419: @367156
     /* 367156 */ GIM_Reject,
     /* 367157 */ // Label 105: @367157
     /* 367157 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7438*/ GIMT_Encode4(382763),
     /* 367168 */ /*GILLT_s16*//*Label 7430*/ GIMT_Encode4(367208),
     /* 367172 */ /*GILLT_s32*//*Label 7431*/ GIMT_Encode4(369982),
     /* 367176 */ /*GILLT_s64*//*Label 7432*/ GIMT_Encode4(372912), GIMT_Encode4(0),
     /* 367184 */ /*GILLT_v2s32*//*Label 7433*/ GIMT_Encode4(375842),
     /* 367188 */ /*GILLT_v2s64*//*Label 7434*/ GIMT_Encode4(377363),
     /* 367192 */ /*GILLT_v4s16*//*Label 7435*/ GIMT_Encode4(378884),
     /* 367196 */ /*GILLT_v4s32*//*Label 7436*/ GIMT_Encode4(380063), GIMT_Encode4(0),
     /* 367204 */ /*GILLT_v8s16*//*Label 7437*/ GIMT_Encode4(381584),
     /* 367208 */ // Label 7430: @367208
     /* 367208 */ GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(369981),
     /* 367213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 367216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 367219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 367222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367226 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(367376), // Rule ID 4815 //
     /* 367231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367255 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367280 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 367296 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367303 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 367303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 367306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367315 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 367321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367343 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 367349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 367362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 367374 */     GIR_RootConstrainSelectedInstOperands,
     /* 367375 */     // GIR_Coverage, 4815,
     /* 367375 */     GIR_EraseRootFromParent_Done,
     /* 367376 */   // Label 7440: @367376
     /* 367376 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(367523), // Rule ID 4779 //
     /* 367381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 367421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367429 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367433 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367437 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367442 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367452 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 367452 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 367455 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367459 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367464 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 367470 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367475 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367492 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 367498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 367511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367521 */     GIR_RootConstrainSelectedInstOperands,
     /* 367522 */     // GIR_Coverage, 4779,
     /* 367522 */     GIR_EraseRootFromParent_Done,
     /* 367523 */   // Label 7441: @367523
     /* 367523 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(367670), // Rule ID 13653 //
     /* 367528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 367543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367564 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367576 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367584 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367589 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367599 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 367599 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 367602 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367606 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367611 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 367617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367639 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 367645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 367658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367668 */     GIR_RootConstrainSelectedInstOperands,
     /* 367669 */     // GIR_Coverage, 13653,
     /* 367669 */     GIR_EraseRootFromParent_Done,
     /* 367670 */   // Label 7442: @367670
     /* 367670 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(367801), // Rule ID 5995 //
     /* 367675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367699 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 367715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367723 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367727 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367731 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 367736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367744 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367748 */     // MIs[4] Operand 1
     /* 367748 */     // No operand predicates
     /* 367748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367752 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367754 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 367754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367766 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 367772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 367785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 367796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 367799 */     GIR_RootConstrainSelectedInstOperands,
     /* 367800 */     // GIR_Coverage, 5995,
     /* 367800 */     GIR_EraseRootFromParent_Done,
     /* 367801 */   // Label 7443: @367801
     /* 367801 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(367932), // Rule ID 6027 //
     /* 367806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 367830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367842 */     // MIs[2] Operand 1
     /* 367842 */     // No operand predicates
     /* 367842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367850 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 367854 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 367858 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367862 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367866 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367870 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367875 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 367879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367883 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367885 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 367885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367897 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 367903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 367916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367930 */     GIR_RootConstrainSelectedInstOperands,
     /* 367931 */     // GIR_Coverage, 6027,
     /* 367931 */     GIR_EraseRootFromParent_Done,
     /* 367932 */   // Label 7444: @367932
     /* 367932 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(368063), // Rule ID 6091 //
     /* 367937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 367952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367973 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367989 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 367998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 368002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368006 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 368010 */     // MIs[4] Operand 1
     /* 368010 */     // No operand predicates
     /* 368010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368014 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 368016 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 368016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368028 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 368034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 368047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 368058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 368061 */     GIR_RootConstrainSelectedInstOperands,
     /* 368062 */     // GIR_Coverage, 6091,
     /* 368062 */     GIR_EraseRootFromParent_Done,
     /* 368063 */   // Label 7445: @368063
     /* 368063 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(368194), // Rule ID 6059 //
     /* 368068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 368083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 368104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368112 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 368116 */     // MIs[3] Operand 1
     /* 368116 */     // No operand predicates
     /* 368116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 368120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368124 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368128 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 368132 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368137 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 368141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368145 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 368147 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 368147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368159 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 368165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 368178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368192 */     GIR_RootConstrainSelectedInstOperands,
     /* 368193 */     // GIR_Coverage, 6059,
     /* 368193 */     GIR_EraseRootFromParent_Done,
     /* 368194 */   // Label 7446: @368194
     /* 368194 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(368329), // Rule ID 2446 //
     /* 368199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368248 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368258 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 368258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 368261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368270 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 368276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368298 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 368304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 368317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 368325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368327 */     GIR_RootConstrainSelectedInstOperands,
     /* 368328 */     // GIR_Coverage, 2446,
     /* 368328 */     GIR_EraseRootFromParent_Done,
     /* 368329 */   // Label 7447: @368329
     /* 368329 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(368448), // Rule ID 5963 //
     /* 368334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368358 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 368383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368391 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 368395 */     // MIs[3] Operand 1
     /* 368395 */     // No operand predicates
     /* 368395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368401 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 368401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368413 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 368419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 368432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368446 */     GIR_RootConstrainSelectedInstOperands,
     /* 368447 */     // GIR_Coverage, 5963,
     /* 368447 */     GIR_EraseRootFromParent_Done,
     /* 368448 */   // Label 7448: @368448
     /* 368448 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(368567), // Rule ID 2528 //
     /* 368453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 368477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 368489 */     // MIs[2] Operand 1
     /* 368489 */     // No operand predicates
     /* 368489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368497 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368501 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 368505 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368510 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 368514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368520 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 368520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368532 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 368538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 368551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368565 */     GIR_RootConstrainSelectedInstOperands,
     /* 368566 */     // GIR_Coverage, 2528,
     /* 368566 */     GIR_EraseRootFromParent_Done,
     /* 368567 */   // Label 7449: @368567
     /* 368567 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(368667), // Rule ID 4777 //
     /* 368572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 368612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368623 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 368623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368635 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 368641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 368654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368665 */     GIR_RootConstrainSelectedInstOperands,
     /* 368666 */     // GIR_Coverage, 4777,
     /* 368666 */     GIR_EraseRootFromParent_Done,
     /* 368667 */   // Label 7450: @368667
     /* 368667 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(368767), // Rule ID 4813 //
     /* 368672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368696 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 368716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368723 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 368723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 368741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 368754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 368761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 368765 */     GIR_RootConstrainSelectedInstOperands,
     /* 368766 */     // GIR_Coverage, 4813,
     /* 368766 */     GIR_EraseRootFromParent_Done,
     /* 368767 */   // Label 7451: @368767
     /* 368767 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(368864), // Rule ID 13649 //
     /* 368772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 368787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368822 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 368822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368834 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 368840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 368853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368862 */     GIR_RootConstrainSelectedInstOperands,
     /* 368863 */     // GIR_Coverage, 13649,
     /* 368863 */     GIR_EraseRootFromParent_Done,
     /* 368864 */   // Label 7452: @368864
     /* 368864 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(368964), // Rule ID 13651 //
     /* 368869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 368884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368910 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368920 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 368920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 368923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368932 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 368938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 368951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368962 */     GIR_RootConstrainSelectedInstOperands,
     /* 368963 */     // GIR_Coverage, 13651,
     /* 368963 */     GIR_EraseRootFromParent_Done,
     /* 368964 */   // Label 7453: @368964
     /* 368964 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(369064), // Rule ID 4811 //
     /* 368969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368997 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 369013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369020 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 369020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 369038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 369051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 369062 */     GIR_RootConstrainSelectedInstOperands,
     /* 369063 */     // GIR_Coverage, 4811,
     /* 369063 */     GIR_EraseRootFromParent_Done,
     /* 369064 */   // Label 7454: @369064
     /* 369064 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(369161), // Rule ID 4775 //
     /* 369069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 369088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369109 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 369113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369119 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 369119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 369137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 369150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369159 */     GIR_RootConstrainSelectedInstOperands,
     /* 369160 */     // GIR_Coverage, 4775,
     /* 369160 */     GIR_EraseRootFromParent_Done,
     /* 369161 */   // Label 7455: @369161
     /* 369161 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(369245), // Rule ID 6025 //
     /* 369166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369202 */     // MIs[2] Operand 1
     /* 369202 */     // No operand predicates
     /* 369202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 369214 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369225 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 369225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 369228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 369236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369243 */     GIR_RootConstrainSelectedInstOperands,
     /* 369244 */     // GIR_Coverage, 6025,
     /* 369244 */     GIR_EraseRootFromParent_Done,
     /* 369245 */   // Label 7456: @369245
     /* 369245 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(369326), // Rule ID 6057 //
     /* 369250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 369265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369294 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369298 */     // MIs[3] Operand 1
     /* 369298 */     // No operand predicates
     /* 369298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369308 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 369308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 369311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369324 */     GIR_RootConstrainSelectedInstOperands,
     /* 369325 */     // GIR_Coverage, 6057,
     /* 369325 */     GIR_EraseRootFromParent_Done,
     /* 369326 */   // Label 7457: @369326
     /* 369326 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(369410), // Rule ID 6089 //
     /* 369331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 369346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369380 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369384 */     // MIs[3] Operand 1
     /* 369384 */     // No operand predicates
     /* 369384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369390 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 369390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 369393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369408 */     GIR_RootConstrainSelectedInstOperands,
     /* 369409 */     // GIR_Coverage, 6089,
     /* 369409 */     GIR_EraseRootFromParent_Done,
     /* 369410 */   // Label 7458: @369410
     /* 369410 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(369491), // Rule ID 5993 //
     /* 369415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 369434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369463 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369467 */     // MIs[3] Operand 1
     /* 369467 */     // No operand predicates
     /* 369467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369473 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 369473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 369476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369489 */     GIR_RootConstrainSelectedInstOperands,
     /* 369490 */     // GIR_Coverage, 5993,
     /* 369490 */     GIR_EraseRootFromParent_Done,
     /* 369491 */   // Label 7459: @369491
     /* 369491 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(369576), // Rule ID 2444 //
     /* 369496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369534 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 369534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369546 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 369552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 369565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 369572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369574 */     GIR_RootConstrainSelectedInstOperands,
     /* 369575 */     // GIR_Coverage, 2444,
     /* 369575 */     GIR_EraseRootFromParent_Done,
     /* 369576 */   // Label 7460: @369576
     /* 369576 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(369661), // Rule ID 2442 //
     /* 369581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369609 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369619 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 369619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369631 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 369637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 369650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369659 */     GIR_RootConstrainSelectedInstOperands,
     /* 369660 */     // GIR_Coverage, 2442,
     /* 369660 */     GIR_EraseRootFromParent_Done,
     /* 369661 */   // Label 7461: @369661
     /* 369661 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(369730), // Rule ID 2526 //
     /* 369666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369698 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369702 */     // MIs[2] Operand 1
     /* 369702 */     // No operand predicates
     /* 369702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369712 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 369712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 369715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369728 */     GIR_RootConstrainSelectedInstOperands,
     /* 369729 */     // GIR_Coverage, 2526,
     /* 369729 */     GIR_EraseRootFromParent_Done,
     /* 369730 */   // Label 7462: @369730
     /* 369730 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(369799), // Rule ID 5961 //
     /* 369735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369775 */     // MIs[2] Operand 1
     /* 369775 */     // No operand predicates
     /* 369775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369781 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 369781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 369784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369797 */     GIR_RootConstrainSelectedInstOperands,
     /* 369798 */     // GIR_Coverage, 5961,
     /* 369798 */     GIR_EraseRootFromParent_Done,
     /* 369799 */   // Label 7463: @369799
     /* 369799 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(369849), // Rule ID 13095 //
     /* 369804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 369819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369834 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 369834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 369837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369847 */     GIR_RootConstrainSelectedInstOperands,
     /* 369848 */     // GIR_Coverage, 13095,
     /* 369848 */     GIR_EraseRootFromParent_Done,
     /* 369849 */   // Label 7464: @369849
     /* 369849 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(369899), // Rule ID 643 //
     /* 369854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 369873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369884 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 369884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 369887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369897 */     GIR_RootConstrainSelectedInstOperands,
     /* 369898 */     // GIR_Coverage, 643,
     /* 369898 */     GIR_EraseRootFromParent_Done,
     /* 369899 */   // Label 7465: @369899
     /* 369899 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(369949), // Rule ID 655 //
     /* 369904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 369927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369934 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 369934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 369937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 369943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 369947 */     GIR_RootConstrainSelectedInstOperands,
     /* 369948 */     // GIR_Coverage, 655,
     /* 369948 */     GIR_EraseRootFromParent_Done,
     /* 369949 */   // Label 7466: @369949
     /* 369949 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(369980), // Rule ID 637 //
     /* 369954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369969 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 369969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 369974 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369978 */     GIR_RootConstrainSelectedInstOperands,
     /* 369979 */     // GIR_Coverage, 637,
     /* 369979 */     GIR_Done,
     /* 369980 */   // Label 7467: @369980
     /* 369980 */   GIM_Reject,
     /* 369981 */ // Label 7439: @369981
     /* 369981 */ GIM_Reject,
     /* 369982 */ // Label 7431: @369982
     /* 369982 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(372911),
     /* 369987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 369996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370000 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(370150), // Rule ID 4821 //
     /* 370005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370029 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370054 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 370070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370077 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 370077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 370080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370089 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 370095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370117 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 370123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 370136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 370148 */     GIR_RootConstrainSelectedInstOperands,
     /* 370149 */     // GIR_Coverage, 4821,
     /* 370149 */     GIR_EraseRootFromParent_Done,
     /* 370150 */   // Label 7469: @370150
     /* 370150 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(370297), // Rule ID 4785 //
     /* 370155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370179 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370207 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370211 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370216 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 370220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370226 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 370226 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 370229 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370233 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370238 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 370244 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370249 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370266 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 370272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 370285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370295 */     GIR_RootConstrainSelectedInstOperands,
     /* 370296 */     // GIR_Coverage, 4785,
     /* 370296 */     GIR_EraseRootFromParent_Done,
     /* 370297 */   // Label 7470: @370297
     /* 370297 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(370444), // Rule ID 13659 //
     /* 370302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370338 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370354 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370358 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370363 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 370367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370373 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 370373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 370376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370385 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 370391 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370396 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370413 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 370419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 370432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370442 */     GIR_RootConstrainSelectedInstOperands,
     /* 370443 */     // GIR_Coverage, 13659,
     /* 370443 */     GIR_EraseRootFromParent_Done,
     /* 370444 */   // Label 7471: @370444
     /* 370444 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(370575), // Rule ID 6011 //
     /* 370449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370473 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370497 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370501 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370505 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370510 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 370514 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370518 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 370522 */     // MIs[4] Operand 1
     /* 370522 */     // No operand predicates
     /* 370522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370526 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370528 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 370528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370540 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 370546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 370559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 370570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 370573 */     GIR_RootConstrainSelectedInstOperands,
     /* 370574 */     // GIR_Coverage, 6011,
     /* 370574 */     GIR_EraseRootFromParent_Done,
     /* 370575 */   // Label 7472: @370575
     /* 370575 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(370706), // Rule ID 6043 //
     /* 370580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370612 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 370616 */     // MIs[2] Operand 1
     /* 370616 */     // No operand predicates
     /* 370616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370624 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 370628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 370632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370636 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370640 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 370644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370649 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 370653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370657 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370659 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 370659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370671 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 370677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 370690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370704 */     GIR_RootConstrainSelectedInstOperands,
     /* 370705 */     // GIR_Coverage, 6043,
     /* 370705 */     GIR_EraseRootFromParent_Done,
     /* 370706 */   // Label 7473: @370706
     /* 370706 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(370837), // Rule ID 6107 //
     /* 370711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370747 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 370776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370780 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 370784 */     // MIs[4] Operand 1
     /* 370784 */     // No operand predicates
     /* 370784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370788 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370790 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 370790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370802 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 370808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 370821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 370832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 370835 */     GIR_RootConstrainSelectedInstOperands,
     /* 370836 */     // GIR_Coverage, 6107,
     /* 370836 */     GIR_EraseRootFromParent_Done,
     /* 370837 */   // Label 7474: @370837
     /* 370837 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(370968), // Rule ID 6075 //
     /* 370842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 370882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 370890 */     // MIs[3] Operand 1
     /* 370890 */     // No operand predicates
     /* 370890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 370894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370898 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370902 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 370906 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370911 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 370915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370919 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370921 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 370921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 370939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 370952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 370963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 370966 */     GIR_RootConstrainSelectedInstOperands,
     /* 370967 */     // GIR_Coverage, 6075,
     /* 370967 */     GIR_EraseRootFromParent_Done,
     /* 370968 */   // Label 7475: @370968
     /* 370968 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(371103), // Rule ID 2452 //
     /* 370973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370997 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371022 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371032 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 371032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 371035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371044 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 371050 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371055 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 371078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 371091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371101 */     GIR_RootConstrainSelectedInstOperands,
     /* 371102 */     // GIR_Coverage, 2452,
     /* 371102 */     GIR_EraseRootFromParent_Done,
     /* 371103 */   // Label 7476: @371103
     /* 371103 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(371222), // Rule ID 5979 //
     /* 371108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371132 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371165 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 371169 */     // MIs[3] Operand 1
     /* 371169 */     // No operand predicates
     /* 371169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371175 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 371175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371187 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 371193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 371206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371220 */     GIR_RootConstrainSelectedInstOperands,
     /* 371221 */     // GIR_Coverage, 5979,
     /* 371221 */     GIR_EraseRootFromParent_Done,
     /* 371222 */   // Label 7477: @371222
     /* 371222 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(371341), // Rule ID 2544 //
     /* 371227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371259 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 371263 */     // MIs[2] Operand 1
     /* 371263 */     // No operand predicates
     /* 371263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371271 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371275 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371279 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371284 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 371288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371294 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 371294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 371312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 371325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371339 */     GIR_RootConstrainSelectedInstOperands,
     /* 371340 */     // GIR_Coverage, 2544,
     /* 371340 */     GIR_EraseRootFromParent_Done,
     /* 371341 */   // Label 7478: @371341
     /* 371341 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(371441), // Rule ID 4783 //
     /* 371346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371370 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371397 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 371397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371409 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 371415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 371428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371439 */     GIR_RootConstrainSelectedInstOperands,
     /* 371440 */     // GIR_Coverage, 4783,
     /* 371440 */     GIR_EraseRootFromParent_Done,
     /* 371441 */   // Label 7479: @371441
     /* 371441 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(371541), // Rule ID 4819 //
     /* 371446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371497 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 371497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371509 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 371515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 371528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 371535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 371539 */     GIR_RootConstrainSelectedInstOperands,
     /* 371540 */     // GIR_Coverage, 4819,
     /* 371540 */     GIR_EraseRootFromParent_Done,
     /* 371541 */   // Label 7480: @371541
     /* 371541 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(371638), // Rule ID 13655 //
     /* 371546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371582 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371596 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 371596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371608 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 371614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 371627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 371631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371636 */     GIR_RootConstrainSelectedInstOperands,
     /* 371637 */     // GIR_Coverage, 13655,
     /* 371637 */     GIR_EraseRootFromParent_Done,
     /* 371638 */   // Label 7481: @371638
     /* 371638 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(371738), // Rule ID 13657 //
     /* 371643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371694 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 371694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371706 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 371712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 371725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371736 */     GIR_RootConstrainSelectedInstOperands,
     /* 371737 */     // GIR_Coverage, 13657,
     /* 371737 */     GIR_EraseRootFromParent_Done,
     /* 371738 */   // Label 7482: @371738
     /* 371738 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(371838), // Rule ID 4817 //
     /* 371743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371794 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 371794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371806 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 371812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 371825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 371836 */     GIR_RootConstrainSelectedInstOperands,
     /* 371837 */     // GIR_Coverage, 4817,
     /* 371837 */     GIR_EraseRootFromParent_Done,
     /* 371838 */   // Label 7483: @371838
     /* 371838 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(371935), // Rule ID 4781 //
     /* 371843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371883 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371893 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 371893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371905 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 371911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 371924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371933 */     GIR_RootConstrainSelectedInstOperands,
     /* 371934 */     // GIR_Coverage, 4781,
     /* 371934 */     GIR_EraseRootFromParent_Done,
     /* 371935 */   // Label 7484: @371935
     /* 371935 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(372013), // Rule ID 6129 //
     /* 371940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 371977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371981 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 371985 */     // MIs[3] Operand 1
     /* 371985 */     // No operand predicates
     /* 371985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371995 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 371995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 371998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372011 */     GIR_RootConstrainSelectedInstOperands,
     /* 372012 */     // GIR_Coverage, 6129,
     /* 372012 */     GIR_EraseRootFromParent_Done,
     /* 372013 */   // Label 7485: @372013
     /* 372013 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(372097), // Rule ID 6041 //
     /* 372018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372050 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372054 */     // MIs[2] Operand 1
     /* 372054 */     // No operand predicates
     /* 372054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 372066 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372077 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 372080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 372088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372095 */     GIR_RootConstrainSelectedInstOperands,
     /* 372096 */     // GIR_Coverage, 6041,
     /* 372096 */     GIR_EraseRootFromParent_Done,
     /* 372097 */   // Label 7486: @372097
     /* 372097 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(372178), // Rule ID 6073 //
     /* 372102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372146 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372150 */     // MIs[3] Operand 1
     /* 372150 */     // No operand predicates
     /* 372150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372160 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 372163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372176 */     GIR_RootConstrainSelectedInstOperands,
     /* 372177 */     // GIR_Coverage, 6073,
     /* 372177 */     GIR_EraseRootFromParent_Done,
     /* 372178 */   // Label 7487: @372178
     /* 372178 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(372262), // Rule ID 6105 //
     /* 372183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372232 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372236 */     // MIs[3] Operand 1
     /* 372236 */     // No operand predicates
     /* 372236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372242 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 372245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372260 */     GIR_RootConstrainSelectedInstOperands,
     /* 372261 */     // GIR_Coverage, 6105,
     /* 372261 */     GIR_EraseRootFromParent_Done,
     /* 372262 */   // Label 7488: @372262
     /* 372262 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(372340), // Rule ID 6151 //
     /* 372267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 372308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372312 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372316 */     // MIs[3] Operand 1
     /* 372316 */     // No operand predicates
     /* 372316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372322 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 372325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372338 */     GIR_RootConstrainSelectedInstOperands,
     /* 372339 */     // GIR_Coverage, 6151,
     /* 372339 */     GIR_EraseRootFromParent_Done,
     /* 372340 */   // Label 7489: @372340
     /* 372340 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(372421), // Rule ID 6009 //
     /* 372345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372393 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372397 */     // MIs[3] Operand 1
     /* 372397 */     // No operand predicates
     /* 372397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372403 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 372406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372419 */     GIR_RootConstrainSelectedInstOperands,
     /* 372420 */     // GIR_Coverage, 6009,
     /* 372420 */     GIR_EraseRootFromParent_Done,
     /* 372421 */   // Label 7490: @372421
     /* 372421 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(372506), // Rule ID 2450 //
     /* 372426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372450 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372464 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 372464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372476 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 372482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 372495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 372502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372504 */     GIR_RootConstrainSelectedInstOperands,
     /* 372505 */     // GIR_Coverage, 2450,
     /* 372505 */     GIR_EraseRootFromParent_Done,
     /* 372506 */   // Label 7491: @372506
     /* 372506 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(372591), // Rule ID 2448 //
     /* 372511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372539 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372549 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 372549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372561 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 372567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 372580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372589 */     GIR_RootConstrainSelectedInstOperands,
     /* 372590 */     // GIR_Coverage, 2448,
     /* 372590 */     GIR_EraseRootFromParent_Done,
     /* 372591 */   // Label 7492: @372591
     /* 372591 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(372660), // Rule ID 2542 //
     /* 372596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372632 */     // MIs[2] Operand 1
     /* 372632 */     // No operand predicates
     /* 372632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372642 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 372645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372658 */     GIR_RootConstrainSelectedInstOperands,
     /* 372659 */     // GIR_Coverage, 2542,
     /* 372659 */     GIR_EraseRootFromParent_Done,
     /* 372660 */   // Label 7493: @372660
     /* 372660 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(372729), // Rule ID 5977 //
     /* 372665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372701 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372705 */     // MIs[2] Operand 1
     /* 372705 */     // No operand predicates
     /* 372705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372711 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 372714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372727 */     GIR_RootConstrainSelectedInstOperands,
     /* 372728 */     // GIR_Coverage, 5977,
     /* 372728 */     GIR_EraseRootFromParent_Done,
     /* 372729 */   // Label 7494: @372729
     /* 372729 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(372779), // Rule ID 13097 //
     /* 372734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372764 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 372764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 372767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372777 */     GIR_RootConstrainSelectedInstOperands,
     /* 372778 */     // GIR_Coverage, 13097,
     /* 372778 */     GIR_EraseRootFromParent_Done,
     /* 372779 */   // Label 7495: @372779
     /* 372779 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(372829), // Rule ID 645 //
     /* 372784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372814 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 372814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 372817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372827 */     GIR_RootConstrainSelectedInstOperands,
     /* 372828 */     // GIR_Coverage, 645,
     /* 372828 */     GIR_EraseRootFromParent_Done,
     /* 372829 */   // Label 7496: @372829
     /* 372829 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(372879), // Rule ID 657 //
     /* 372834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372864 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 372864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 372867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 372873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 372877 */     GIR_RootConstrainSelectedInstOperands,
     /* 372878 */     // GIR_Coverage, 657,
     /* 372878 */     GIR_EraseRootFromParent_Done,
     /* 372879 */   // Label 7497: @372879
     /* 372879 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(372910), // Rule ID 639 //
     /* 372884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372899 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 372899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 372904 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372908 */     GIR_RootConstrainSelectedInstOperands,
     /* 372909 */     // GIR_Coverage, 639,
     /* 372909 */     GIR_Done,
     /* 372910 */   // Label 7498: @372910
     /* 372910 */   GIM_Reject,
     /* 372911 */ // Label 7468: @372911
     /* 372911 */ GIM_Reject,
     /* 372912 */ // Label 7432: @372912
     /* 372912 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(375841),
     /* 372917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 372923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372930 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(373080), // Rule ID 4827 //
     /* 372935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372959 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372984 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 372988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 373000 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373007 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 373007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 373010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373019 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373030 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373047 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 373066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 373074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 373078 */     GIR_RootConstrainSelectedInstOperands,
     /* 373079 */     // GIR_Coverage, 4827,
     /* 373079 */     GIR_EraseRootFromParent_Done,
     /* 373080 */   // Label 7500: @373080
     /* 373080 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(373227), // Rule ID 4791 //
     /* 373085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373109 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 373125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 373129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 373141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373146 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 373150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373156 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 373156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 373159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373168 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373196 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 373215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 373223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373225 */     GIR_RootConstrainSelectedInstOperands,
     /* 373226 */     // GIR_Coverage, 4791,
     /* 373226 */     GIR_EraseRootFromParent_Done,
     /* 373227 */   // Label 7501: @373227
     /* 373227 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(373374), // Rule ID 13665 //
     /* 373232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373268 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373280 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373284 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 373288 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373293 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 373297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373303 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 373303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 373306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373315 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373343 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 373362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 373370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373372 */     GIR_RootConstrainSelectedInstOperands,
     /* 373373 */     // GIR_Coverage, 13665,
     /* 373373 */     GIR_EraseRootFromParent_Done,
     /* 373374 */   // Label 7502: @373374
     /* 373374 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(373505), // Rule ID 6015 //
     /* 373379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373403 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 373419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 373423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373427 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373431 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 373435 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 373444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373448 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373452 */     // MIs[4] Operand 1
     /* 373452 */     // No operand predicates
     /* 373452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 373458 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373470 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 373489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 373500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 373503 */     GIR_RootConstrainSelectedInstOperands,
     /* 373504 */     // GIR_Coverage, 6015,
     /* 373504 */     GIR_EraseRootFromParent_Done,
     /* 373505 */   // Label 7503: @373505
     /* 373505 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(373636), // Rule ID 6047 //
     /* 373510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373542 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373546 */     // MIs[2] Operand 1
     /* 373546 */     // No operand predicates
     /* 373546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 373558 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 373562 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373566 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373570 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 373574 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373579 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 373583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373587 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 373589 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373601 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 373620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373634 */     GIR_RootConstrainSelectedInstOperands,
     /* 373635 */     // GIR_Coverage, 6047,
     /* 373635 */     GIR_EraseRootFromParent_Done,
     /* 373636 */   // Label 7504: @373636
     /* 373636 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(373767), // Rule ID 6111 //
     /* 373641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373677 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373689 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373693 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 373697 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373702 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 373706 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373710 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373714 */     // MIs[4] Operand 1
     /* 373714 */     // No operand predicates
     /* 373714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373718 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 373720 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373732 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 373751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 373762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 373765 */     GIR_RootConstrainSelectedInstOperands,
     /* 373766 */     // GIR_Coverage, 6111,
     /* 373766 */     GIR_EraseRootFromParent_Done,
     /* 373767 */   // Label 7505: @373767
     /* 373767 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(373898), // Rule ID 6079 //
     /* 373772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373816 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373820 */     // MIs[3] Operand 1
     /* 373820 */     // No operand predicates
     /* 373820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 373824 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373828 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373832 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 373836 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373841 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 373845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373849 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 373851 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373863 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 373882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373896 */     GIR_RootConstrainSelectedInstOperands,
     /* 373897 */     // GIR_Coverage, 6079,
     /* 373897 */     GIR_EraseRootFromParent_Done,
     /* 373898 */   // Label 7506: @373898
     /* 373898 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(374033), // Rule ID 2458 //
     /* 373903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373927 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373952 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373962 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 373962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 373965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373974 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374002 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 374021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 374029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374031 */     GIR_RootConstrainSelectedInstOperands,
     /* 374032 */     // GIR_Coverage, 2458,
     /* 374032 */     GIR_EraseRootFromParent_Done,
     /* 374033 */   // Label 7507: @374033
     /* 374033 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(374152), // Rule ID 5983 //
     /* 374038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374062 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374095 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374099 */     // MIs[3] Operand 1
     /* 374099 */     // No operand predicates
     /* 374099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374105 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 374105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374117 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 374136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374150 */     GIR_RootConstrainSelectedInstOperands,
     /* 374151 */     // GIR_Coverage, 5983,
     /* 374151 */     GIR_EraseRootFromParent_Done,
     /* 374152 */   // Label 7508: @374152
     /* 374152 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(374271), // Rule ID 2548 //
     /* 374157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374193 */     // MIs[2] Operand 1
     /* 374193 */     // No operand predicates
     /* 374193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374201 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374205 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 374209 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374214 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 374218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374224 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 374224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374236 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 374255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374269 */     GIR_RootConstrainSelectedInstOperands,
     /* 374270 */     // GIR_Coverage, 2548,
     /* 374270 */     GIR_EraseRootFromParent_Done,
     /* 374271 */   // Label 7509: @374271
     /* 374271 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(374371), // Rule ID 4789 //
     /* 374276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374300 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 374316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374327 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 374327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374339 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 374358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374369 */     GIR_RootConstrainSelectedInstOperands,
     /* 374370 */     // GIR_Coverage, 4789,
     /* 374370 */     GIR_EraseRootFromParent_Done,
     /* 374371 */   // Label 7510: @374371
     /* 374371 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(374471), // Rule ID 4825 //
     /* 374376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374400 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 374412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 374420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374427 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 374427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374439 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 374458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 374465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 374469 */     GIR_RootConstrainSelectedInstOperands,
     /* 374470 */     // GIR_Coverage, 4825,
     /* 374470 */     GIR_EraseRootFromParent_Done,
     /* 374471 */   // Label 7511: @374471
     /* 374471 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(374568), // Rule ID 13661 //
     /* 374476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 374491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374512 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 374516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374526 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 374526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374538 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 374544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 374557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374566 */     GIR_RootConstrainSelectedInstOperands,
     /* 374567 */     // GIR_Coverage, 13661,
     /* 374567 */     GIR_EraseRootFromParent_Done,
     /* 374568 */   // Label 7512: @374568
     /* 374568 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(374668), // Rule ID 13663 //
     /* 374573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 374588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374614 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 374618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374624 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 374624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374636 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 374655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374666 */     GIR_RootConstrainSelectedInstOperands,
     /* 374667 */     // GIR_Coverage, 13663,
     /* 374667 */     GIR_EraseRootFromParent_Done,
     /* 374668 */   // Label 7513: @374668
     /* 374668 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(374768), // Rule ID 4823 //
     /* 374673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374701 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 374709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 374717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374724 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 374724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374736 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 374742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 374755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 374766 */     GIR_RootConstrainSelectedInstOperands,
     /* 374767 */     // GIR_Coverage, 4823,
     /* 374767 */     GIR_EraseRootFromParent_Done,
     /* 374768 */   // Label 7514: @374768
     /* 374768 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(374865), // Rule ID 4787 //
     /* 374773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 374792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374813 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 374817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374823 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 374823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374835 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 374841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 374854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374863 */     GIR_RootConstrainSelectedInstOperands,
     /* 374864 */     // GIR_Coverage, 4787,
     /* 374864 */     GIR_EraseRootFromParent_Done,
     /* 374865 */   // Label 7515: @374865
     /* 374865 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(374943), // Rule ID 6133 //
     /* 374870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 374907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374911 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374915 */     // MIs[3] Operand 1
     /* 374915 */     // No operand predicates
     /* 374915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374925 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 374928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374941 */     GIR_RootConstrainSelectedInstOperands,
     /* 374942 */     // GIR_Coverage, 6133,
     /* 374942 */     GIR_EraseRootFromParent_Done,
     /* 374943 */   // Label 7516: @374943
     /* 374943 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(375027), // Rule ID 6045 //
     /* 374948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374980 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374984 */     // MIs[2] Operand 1
     /* 374984 */     // No operand predicates
     /* 374984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 374996 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375007 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 375007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 375010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 375018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375025 */     GIR_RootConstrainSelectedInstOperands,
     /* 375026 */     // GIR_Coverage, 6045,
     /* 375026 */     GIR_EraseRootFromParent_Done,
     /* 375027 */   // Label 7517: @375027
     /* 375027 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(375108), // Rule ID 6077 //
     /* 375032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375076 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375080 */     // MIs[3] Operand 1
     /* 375080 */     // No operand predicates
     /* 375080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375090 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 375090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 375093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375106 */     GIR_RootConstrainSelectedInstOperands,
     /* 375107 */     // GIR_Coverage, 6077,
     /* 375107 */     GIR_EraseRootFromParent_Done,
     /* 375108 */   // Label 7518: @375108
     /* 375108 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(375192), // Rule ID 6109 //
     /* 375113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375162 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375166 */     // MIs[3] Operand 1
     /* 375166 */     // No operand predicates
     /* 375166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375172 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 375172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 375175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375190 */     GIR_RootConstrainSelectedInstOperands,
     /* 375191 */     // GIR_Coverage, 6109,
     /* 375191 */     GIR_EraseRootFromParent_Done,
     /* 375192 */   // Label 7519: @375192
     /* 375192 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(375270), // Rule ID 6155 //
     /* 375197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 375238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375242 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375246 */     // MIs[3] Operand 1
     /* 375246 */     // No operand predicates
     /* 375246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375252 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 375255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375268 */     GIR_RootConstrainSelectedInstOperands,
     /* 375269 */     // GIR_Coverage, 6155,
     /* 375269 */     GIR_EraseRootFromParent_Done,
     /* 375270 */   // Label 7520: @375270
     /* 375270 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(375351), // Rule ID 6013 //
     /* 375275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375323 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375327 */     // MIs[3] Operand 1
     /* 375327 */     // No operand predicates
     /* 375327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375333 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 375333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 375336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375349 */     GIR_RootConstrainSelectedInstOperands,
     /* 375350 */     // GIR_Coverage, 6013,
     /* 375350 */     GIR_EraseRootFromParent_Done,
     /* 375351 */   // Label 7521: @375351
     /* 375351 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(375436), // Rule ID 2456 //
     /* 375356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375380 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375394 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 375394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 375397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375406 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 375425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 375432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375434 */     GIR_RootConstrainSelectedInstOperands,
     /* 375435 */     // GIR_Coverage, 2456,
     /* 375435 */     GIR_EraseRootFromParent_Done,
     /* 375436 */   // Label 7522: @375436
     /* 375436 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(375521), // Rule ID 2454 //
     /* 375441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375469 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375479 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 375479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 375482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375491 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 375497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 375510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375519 */     GIR_RootConstrainSelectedInstOperands,
     /* 375520 */     // GIR_Coverage, 2454,
     /* 375520 */     GIR_EraseRootFromParent_Done,
     /* 375521 */   // Label 7523: @375521
     /* 375521 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(375590), // Rule ID 2546 //
     /* 375526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375558 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375562 */     // MIs[2] Operand 1
     /* 375562 */     // No operand predicates
     /* 375562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375572 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 375572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 375575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375588 */     GIR_RootConstrainSelectedInstOperands,
     /* 375589 */     // GIR_Coverage, 2546,
     /* 375589 */     GIR_EraseRootFromParent_Done,
     /* 375590 */   // Label 7524: @375590
     /* 375590 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(375659), // Rule ID 5981 //
     /* 375595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375631 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375635 */     // MIs[2] Operand 1
     /* 375635 */     // No operand predicates
     /* 375635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375641 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 375641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 375644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375657 */     GIR_RootConstrainSelectedInstOperands,
     /* 375658 */     // GIR_Coverage, 5981,
     /* 375658 */     GIR_EraseRootFromParent_Done,
     /* 375659 */   // Label 7525: @375659
     /* 375659 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(375709), // Rule ID 13099 //
     /* 375664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375694 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 375694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 375697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375707 */     GIR_RootConstrainSelectedInstOperands,
     /* 375708 */     // GIR_Coverage, 13099,
     /* 375708 */     GIR_EraseRootFromParent_Done,
     /* 375709 */   // Label 7526: @375709
     /* 375709 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(375759), // Rule ID 647 //
     /* 375714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375744 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 375744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 375747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375757 */     GIR_RootConstrainSelectedInstOperands,
     /* 375758 */     // GIR_Coverage, 647,
     /* 375758 */     GIR_EraseRootFromParent_Done,
     /* 375759 */   // Label 7527: @375759
     /* 375759 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(375809), // Rule ID 659 //
     /* 375764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 375779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375794 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 375794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 375797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 375803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 375807 */     GIR_RootConstrainSelectedInstOperands,
     /* 375808 */     // GIR_Coverage, 659,
     /* 375808 */     GIR_EraseRootFromParent_Done,
     /* 375809 */   // Label 7528: @375809
     /* 375809 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(375840), // Rule ID 641 //
     /* 375814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375829 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 375829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 375834 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375838 */     GIR_RootConstrainSelectedInstOperands,
     /* 375839 */     // GIR_Coverage, 641,
     /* 375839 */     GIR_Done,
     /* 375840 */   // Label 7529: @375840
     /* 375840 */   GIM_Reject,
     /* 375841 */ // Label 7499: @375841
     /* 375841 */ GIM_Reject,
     /* 375842 */ // Label 7433: @375842
     /* 375842 */ GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(377362),
     /* 375847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 375850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 375853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 375856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375860 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(375938), // Rule ID 6113 //
     /* 375865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 375873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 375902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375910 */     // MIs[3] Operand 1
     /* 375910 */     // No operand predicates
     /* 375910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375920 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 375923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375936 */     GIR_RootConstrainSelectedInstOperands,
     /* 375937 */     // GIR_Coverage, 6113,
     /* 375937 */     GIR_EraseRootFromParent_Done,
     /* 375938 */   // Label 7531: @375938
     /* 375938 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(376022), // Rule ID 6029 //
     /* 375943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 375954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375975 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375979 */     // MIs[2] Operand 1
     /* 375979 */     // No operand predicates
     /* 375979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375987 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 375991 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376002 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 376013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376020 */     GIR_RootConstrainSelectedInstOperands,
     /* 376021 */     // GIR_Coverage, 6029,
     /* 376021 */     GIR_EraseRootFromParent_Done,
     /* 376022 */   // Label 7532: @376022
     /* 376022 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(376103), // Rule ID 6061 //
     /* 376027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376071 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376075 */     // MIs[3] Operand 1
     /* 376075 */     // No operand predicates
     /* 376075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376085 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376101 */     GIR_RootConstrainSelectedInstOperands,
     /* 376102 */     // GIR_Coverage, 6061,
     /* 376102 */     GIR_EraseRootFromParent_Done,
     /* 376103 */   // Label 7533: @376103
     /* 376103 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(376187), // Rule ID 6093 //
     /* 376108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376157 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376161 */     // MIs[3] Operand 1
     /* 376161 */     // No operand predicates
     /* 376161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376167 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376185 */     GIR_RootConstrainSelectedInstOperands,
     /* 376186 */     // GIR_Coverage, 6093,
     /* 376186 */     GIR_EraseRootFromParent_Done,
     /* 376187 */   // Label 7534: @376187
     /* 376187 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(376265), // Rule ID 6135 //
     /* 376192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 376233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376241 */     // MIs[3] Operand 1
     /* 376241 */     // No operand predicates
     /* 376241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376247 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376263 */     GIR_RootConstrainSelectedInstOperands,
     /* 376264 */     // GIR_Coverage, 6135,
     /* 376264 */     GIR_EraseRootFromParent_Done,
     /* 376265 */   // Label 7535: @376265
     /* 376265 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(376346), // Rule ID 5997 //
     /* 376270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376318 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376322 */     // MIs[3] Operand 1
     /* 376322 */     // No operand predicates
     /* 376322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376328 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376344 */     GIR_RootConstrainSelectedInstOperands,
     /* 376345 */     // GIR_Coverage, 5997,
     /* 376345 */     GIR_EraseRootFromParent_Done,
     /* 376346 */   // Label 7536: @376346
     /* 376346 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(376415), // Rule ID 2530 //
     /* 376351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376383 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376387 */     // MIs[2] Operand 1
     /* 376387 */     // No operand predicates
     /* 376387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376397 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 376400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376413 */     GIR_RootConstrainSelectedInstOperands,
     /* 376414 */     // GIR_Coverage, 2530,
     /* 376414 */     GIR_EraseRootFromParent_Done,
     /* 376415 */   // Label 7537: @376415
     /* 376415 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(376484), // Rule ID 5965 //
     /* 376420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376456 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376460 */     // MIs[2] Operand 1
     /* 376460 */     // No operand predicates
     /* 376460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376466 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 376469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376482 */     GIR_RootConstrainSelectedInstOperands,
     /* 376483 */     // GIR_Coverage, 5965,
     /* 376483 */     GIR_EraseRootFromParent_Done,
     /* 376484 */   // Label 7538: @376484
     /* 376484 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(376577), // Rule ID 6117 //
     /* 376489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376528 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 376550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376575 */     GIR_RootConstrainSelectedInstOperands,
     /* 376576 */     // GIR_Coverage, 6117,
     /* 376576 */     GIR_EraseRootFromParent_Done,
     /* 376577 */   // Label 7539: @376577
     /* 376577 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(376676), // Rule ID 6031 //
     /* 376582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376625 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376637 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376644 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 376647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 376668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376674 */     GIR_RootConstrainSelectedInstOperands,
     /* 376675 */     // GIR_Coverage, 6031,
     /* 376675 */     GIR_EraseRootFromParent_Done,
     /* 376676 */   // Label 7540: @376676
     /* 376676 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(376772), // Rule ID 6063 //
     /* 376681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376723 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376735 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376742 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 376745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376770 */     GIR_RootConstrainSelectedInstOperands,
     /* 376771 */     // GIR_Coverage, 6063,
     /* 376771 */     GIR_EraseRootFromParent_Done,
     /* 376772 */   // Label 7541: @376772
     /* 376772 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(376871), // Rule ID 6095 //
     /* 376777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376820 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376839 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 376842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376869 */     GIR_RootConstrainSelectedInstOperands,
     /* 376870 */     // GIR_Coverage, 6095,
     /* 376870 */     GIR_EraseRootFromParent_Done,
     /* 376871 */   // Label 7542: @376871
     /* 376871 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(376964), // Rule ID 6139 //
     /* 376876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376915 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 376937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 376950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376962 */     GIR_RootConstrainSelectedInstOperands,
     /* 376963 */     // GIR_Coverage, 6139,
     /* 376963 */     GIR_EraseRootFromParent_Done,
     /* 376964 */   // Label 7543: @376964
     /* 376964 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(377060), // Rule ID 5999 //
     /* 376969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377011 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 377014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377030 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 377033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 377046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377058 */     GIR_RootConstrainSelectedInstOperands,
     /* 377059 */     // GIR_Coverage, 5999,
     /* 377059 */     GIR_EraseRootFromParent_Done,
     /* 377060 */   // Label 7544: @377060
     /* 377060 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(377144), // Rule ID 2532 //
     /* 377065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377095 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 377098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 377117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 377130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377142 */     GIR_RootConstrainSelectedInstOperands,
     /* 377143 */     // GIR_Coverage, 2532,
     /* 377143 */     GIR_EraseRootFromParent_Done,
     /* 377144 */   // Label 7545: @377144
     /* 377144 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(377194), // Rule ID 13129 //
     /* 377149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 377164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377179 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 377179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 377182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377192 */     GIR_RootConstrainSelectedInstOperands,
     /* 377193 */     // GIR_Coverage, 13129,
     /* 377193 */     GIR_EraseRootFromParent_Done,
     /* 377194 */   // Label 7546: @377194
     /* 377194 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(377278), // Rule ID 5967 //
     /* 377199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377229 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 377232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377241 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377248 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 377251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 377264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377276 */     GIR_RootConstrainSelectedInstOperands,
     /* 377277 */     // GIR_Coverage, 5967,
     /* 377277 */     GIR_EraseRootFromParent_Done,
     /* 377278 */   // Label 7547: @377278
     /* 377278 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(377328), // Rule ID 1300 //
     /* 377283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 377302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377313 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 377313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 377316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377326 */     GIR_RootConstrainSelectedInstOperands,
     /* 377327 */     // GIR_Coverage, 1300,
     /* 377327 */     GIR_EraseRootFromParent_Done,
     /* 377328 */   // Label 7548: @377328
     /* 377328 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(377361), // Rule ID 1290 //
     /* 377333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377348 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 377348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 377351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 377359 */     GIR_RootConstrainSelectedInstOperands,
     /* 377360 */     // GIR_Coverage, 1290,
     /* 377360 */     GIR_EraseRootFromParent_Done,
     /* 377361 */   // Label 7549: @377361
     /* 377361 */   GIM_Reject,
     /* 377362 */ // Label 7530: @377362
     /* 377362 */ GIM_Reject,
     /* 377363 */ // Label 7434: @377363
     /* 377363 */ GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(378883),
     /* 377368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 377374 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 377377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377381 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(377459), // Rule ID 6125 //
     /* 377386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 377423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377427 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377431 */     // MIs[3] Operand 1
     /* 377431 */     // No operand predicates
     /* 377431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377441 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 377444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377457 */     GIR_RootConstrainSelectedInstOperands,
     /* 377458 */     // GIR_Coverage, 6125,
     /* 377458 */     GIR_EraseRootFromParent_Done,
     /* 377459 */   // Label 7551: @377459
     /* 377459 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(377543), // Rule ID 6037 //
     /* 377464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377496 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377500 */     // MIs[2] Operand 1
     /* 377500 */     // No operand predicates
     /* 377500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377523 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 377526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 377534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377541 */     GIR_RootConstrainSelectedInstOperands,
     /* 377542 */     // GIR_Coverage, 6037,
     /* 377542 */     GIR_EraseRootFromParent_Done,
     /* 377543 */   // Label 7552: @377543
     /* 377543 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(377624), // Rule ID 6069 //
     /* 377548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377592 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377596 */     // MIs[3] Operand 1
     /* 377596 */     // No operand predicates
     /* 377596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377606 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 377609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377622 */     GIR_RootConstrainSelectedInstOperands,
     /* 377623 */     // GIR_Coverage, 6069,
     /* 377623 */     GIR_EraseRootFromParent_Done,
     /* 377624 */   // Label 7553: @377624
     /* 377624 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(377708), // Rule ID 6101 //
     /* 377629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377678 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377682 */     // MIs[3] Operand 1
     /* 377682 */     // No operand predicates
     /* 377682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377688 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 377691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377706 */     GIR_RootConstrainSelectedInstOperands,
     /* 377707 */     // GIR_Coverage, 6101,
     /* 377707 */     GIR_EraseRootFromParent_Done,
     /* 377708 */   // Label 7554: @377708
     /* 377708 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(377786), // Rule ID 6147 //
     /* 377713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 377754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377758 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377762 */     // MIs[3] Operand 1
     /* 377762 */     // No operand predicates
     /* 377762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377768 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 377771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377784 */     GIR_RootConstrainSelectedInstOperands,
     /* 377785 */     // GIR_Coverage, 6147,
     /* 377785 */     GIR_EraseRootFromParent_Done,
     /* 377786 */   // Label 7555: @377786
     /* 377786 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(377867), // Rule ID 6005 //
     /* 377791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377839 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377843 */     // MIs[3] Operand 1
     /* 377843 */     // No operand predicates
     /* 377843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377849 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 377852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377865 */     GIR_RootConstrainSelectedInstOperands,
     /* 377866 */     // GIR_Coverage, 6005,
     /* 377866 */     GIR_EraseRootFromParent_Done,
     /* 377867 */   // Label 7556: @377867
     /* 377867 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(377936), // Rule ID 2538 //
     /* 377872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377908 */     // MIs[2] Operand 1
     /* 377908 */     // No operand predicates
     /* 377908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377918 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 377921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377934 */     GIR_RootConstrainSelectedInstOperands,
     /* 377935 */     // GIR_Coverage, 2538,
     /* 377935 */     GIR_EraseRootFromParent_Done,
     /* 377936 */   // Label 7557: @377936
     /* 377936 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(378005), // Rule ID 5973 //
     /* 377941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377981 */     // MIs[2] Operand 1
     /* 377981 */     // No operand predicates
     /* 377981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377987 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 377990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378003 */     GIR_RootConstrainSelectedInstOperands,
     /* 378004 */     // GIR_Coverage, 5973,
     /* 378004 */     GIR_EraseRootFromParent_Done,
     /* 378005 */   // Label 7558: @378005
     /* 378005 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(378098), // Rule ID 6127 //
     /* 378010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 378034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378049 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378061 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378068 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 378084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378096 */     GIR_RootConstrainSelectedInstOperands,
     /* 378097 */     // GIR_Coverage, 6127,
     /* 378097 */     GIR_EraseRootFromParent_Done,
     /* 378098 */   // Label 7559: @378098
     /* 378098 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(378197), // Rule ID 6039 //
     /* 378103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378146 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378158 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378165 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 378181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 378189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378195 */     GIR_RootConstrainSelectedInstOperands,
     /* 378196 */     // GIR_Coverage, 6039,
     /* 378196 */     GIR_EraseRootFromParent_Done,
     /* 378197 */   // Label 7560: @378197
     /* 378197 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(378293), // Rule ID 6071 //
     /* 378202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 378229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378244 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378263 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 378279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378291 */     GIR_RootConstrainSelectedInstOperands,
     /* 378292 */     // GIR_Coverage, 6071,
     /* 378292 */     GIR_EraseRootFromParent_Done,
     /* 378293 */   // Label 7561: @378293
     /* 378293 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(378392), // Rule ID 6103 //
     /* 378298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 378330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378341 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 378376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378390 */     GIR_RootConstrainSelectedInstOperands,
     /* 378391 */     // GIR_Coverage, 6103,
     /* 378391 */     GIR_EraseRootFromParent_Done,
     /* 378392 */   // Label 7562: @378392
     /* 378392 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(378485), // Rule ID 6149 //
     /* 378397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 378425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378436 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378451 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378455 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 378471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378483 */     GIR_RootConstrainSelectedInstOperands,
     /* 378484 */     // GIR_Coverage, 6149,
     /* 378484 */     GIR_EraseRootFromParent_Done,
     /* 378485 */   // Label 7563: @378485
     /* 378485 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(378581), // Rule ID 6007 //
     /* 378490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 378521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378532 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378544 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 378567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378579 */     GIR_RootConstrainSelectedInstOperands,
     /* 378580 */     // GIR_Coverage, 6007,
     /* 378580 */     GIR_EraseRootFromParent_Done,
     /* 378581 */   // Label 7564: @378581
     /* 378581 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(378665), // Rule ID 2540 //
     /* 378586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378616 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378628 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 378651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378663 */     GIR_RootConstrainSelectedInstOperands,
     /* 378664 */     // GIR_Coverage, 2540,
     /* 378664 */     GIR_EraseRootFromParent_Done,
     /* 378665 */   // Label 7565: @378665
     /* 378665 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(378715), // Rule ID 13133 //
     /* 378670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378700 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 378700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 378703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378713 */     GIR_RootConstrainSelectedInstOperands,
     /* 378714 */     // GIR_Coverage, 13133,
     /* 378714 */     GIR_EraseRootFromParent_Done,
     /* 378715 */   // Label 7566: @378715
     /* 378715 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(378799), // Rule ID 5975 //
     /* 378720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378750 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 378785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378797 */     GIR_RootConstrainSelectedInstOperands,
     /* 378798 */     // GIR_Coverage, 5975,
     /* 378798 */     GIR_EraseRootFromParent_Done,
     /* 378799 */   // Label 7567: @378799
     /* 378799 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(378849), // Rule ID 1304 //
     /* 378804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378834 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 378834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 378837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378847 */     GIR_RootConstrainSelectedInstOperands,
     /* 378848 */     // GIR_Coverage, 1304,
     /* 378848 */     GIR_EraseRootFromParent_Done,
     /* 378849 */   // Label 7568: @378849
     /* 378849 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(378882), // Rule ID 1294 //
     /* 378854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378869 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 378869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 378872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 378880 */     GIR_RootConstrainSelectedInstOperands,
     /* 378881 */     // GIR_Coverage, 1294,
     /* 378881 */     GIR_EraseRootFromParent_Done,
     /* 378882 */   // Label 7569: @378882
     /* 378882 */   GIM_Reject,
     /* 378883 */ // Label 7550: @378883
     /* 378883 */ GIM_Reject,
     /* 378884 */ // Label 7435: @378884
     /* 378884 */ GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(380062),
     /* 378889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 378892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 378895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 378898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378902 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(378986), // Rule ID 6021 //
     /* 378907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378939 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378943 */     // MIs[2] Operand 1
     /* 378943 */     // No operand predicates
     /* 378943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378951 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 378955 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378966 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 378969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 378977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378984 */     GIR_RootConstrainSelectedInstOperands,
     /* 378985 */     // GIR_Coverage, 6021,
     /* 378985 */     GIR_EraseRootFromParent_Done,
     /* 378986 */   // Label 7571: @378986
     /* 378986 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(379067), // Rule ID 6053 //
     /* 378991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379035 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379039 */     // MIs[3] Operand 1
     /* 379039 */     // No operand predicates
     /* 379039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379049 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 379052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379065 */     GIR_RootConstrainSelectedInstOperands,
     /* 379066 */     // GIR_Coverage, 6053,
     /* 379066 */     GIR_EraseRootFromParent_Done,
     /* 379067 */   // Label 7572: @379067
     /* 379067 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(379151), // Rule ID 6085 //
     /* 379072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379121 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379125 */     // MIs[3] Operand 1
     /* 379125 */     // No operand predicates
     /* 379125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379131 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 379134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379149 */     GIR_RootConstrainSelectedInstOperands,
     /* 379150 */     // GIR_Coverage, 6085,
     /* 379150 */     GIR_EraseRootFromParent_Done,
     /* 379151 */   // Label 7573: @379151
     /* 379151 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(379232), // Rule ID 5989 //
     /* 379156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379204 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379208 */     // MIs[3] Operand 1
     /* 379208 */     // No operand predicates
     /* 379208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379214 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 379217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379230 */     GIR_RootConstrainSelectedInstOperands,
     /* 379231 */     // GIR_Coverage, 5989,
     /* 379231 */     GIR_EraseRootFromParent_Done,
     /* 379232 */   // Label 7574: @379232
     /* 379232 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(379301), // Rule ID 2522 //
     /* 379237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379269 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379273 */     // MIs[2] Operand 1
     /* 379273 */     // No operand predicates
     /* 379273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379283 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 379286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379299 */     GIR_RootConstrainSelectedInstOperands,
     /* 379300 */     // GIR_Coverage, 2522,
     /* 379300 */     GIR_EraseRootFromParent_Done,
     /* 379301 */   // Label 7575: @379301
     /* 379301 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(379370), // Rule ID 5957 //
     /* 379306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379346 */     // MIs[2] Operand 1
     /* 379346 */     // No operand predicates
     /* 379346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379352 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 379355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379368 */     GIR_RootConstrainSelectedInstOperands,
     /* 379369 */     // GIR_Coverage, 5957,
     /* 379369 */     GIR_EraseRootFromParent_Done,
     /* 379370 */   // Label 7576: @379370
     /* 379370 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(379469), // Rule ID 6023 //
     /* 379375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379418 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379437 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 379453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 379461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379467 */     GIR_RootConstrainSelectedInstOperands,
     /* 379468 */     // GIR_Coverage, 6023,
     /* 379468 */     GIR_EraseRootFromParent_Done,
     /* 379469 */   // Label 7577: @379469
     /* 379469 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(379565), // Rule ID 6055 //
     /* 379474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379516 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379528 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379535 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 379551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379563 */     GIR_RootConstrainSelectedInstOperands,
     /* 379564 */     // GIR_Coverage, 6055,
     /* 379564 */     GIR_EraseRootFromParent_Done,
     /* 379565 */   // Label 7578: @379565
     /* 379565 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(379664), // Rule ID 6087 //
     /* 379570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379613 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379632 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 379648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379662 */     GIR_RootConstrainSelectedInstOperands,
     /* 379663 */     // GIR_Coverage, 6087,
     /* 379663 */     GIR_EraseRootFromParent_Done,
     /* 379664 */   // Label 7579: @379664
     /* 379664 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(379760), // Rule ID 5991 //
     /* 379669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379711 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379723 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379730 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 379746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379758 */     GIR_RootConstrainSelectedInstOperands,
     /* 379759 */     // GIR_Coverage, 5991,
     /* 379759 */     GIR_EraseRootFromParent_Done,
     /* 379760 */   // Label 7580: @379760
     /* 379760 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(379844), // Rule ID 2524 //
     /* 379765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379795 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 379830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379842 */     GIR_RootConstrainSelectedInstOperands,
     /* 379843 */     // GIR_Coverage, 2524,
     /* 379843 */     GIR_EraseRootFromParent_Done,
     /* 379844 */   // Label 7581: @379844
     /* 379844 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(379894), // Rule ID 13125 //
     /* 379849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 379864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379879 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 379879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 379882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379892 */     GIR_RootConstrainSelectedInstOperands,
     /* 379893 */     // GIR_Coverage, 13125,
     /* 379893 */     GIR_EraseRootFromParent_Done,
     /* 379894 */   // Label 7582: @379894
     /* 379894 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(379978), // Rule ID 5959 //
     /* 379899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379929 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379941 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379948 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 379964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379976 */     GIR_RootConstrainSelectedInstOperands,
     /* 379977 */     // GIR_Coverage, 5959,
     /* 379977 */     GIR_EraseRootFromParent_Done,
     /* 379978 */   // Label 7583: @379978
     /* 379978 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(380028), // Rule ID 1296 //
     /* 379983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380013 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 380013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 380016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380026 */     GIR_RootConstrainSelectedInstOperands,
     /* 380027 */     // GIR_Coverage, 1296,
     /* 380027 */     GIR_EraseRootFromParent_Done,
     /* 380028 */   // Label 7584: @380028
     /* 380028 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(380061), // Rule ID 1286 //
     /* 380033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380048 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 380048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 380051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 380059 */     GIR_RootConstrainSelectedInstOperands,
     /* 380060 */     // GIR_Coverage, 1286,
     /* 380060 */     GIR_EraseRootFromParent_Done,
     /* 380061 */   // Label 7585: @380061
     /* 380061 */   GIM_Reject,
     /* 380062 */ // Label 7570: @380062
     /* 380062 */ GIM_Reject,
     /* 380063 */ // Label 7436: @380063
     /* 380063 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(381583),
     /* 380068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 380074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 380077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380081 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(380159), // Rule ID 6119 //
     /* 380086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 380123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380127 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380131 */     // MIs[3] Operand 1
     /* 380131 */     // No operand predicates
     /* 380131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380141 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380157 */     GIR_RootConstrainSelectedInstOperands,
     /* 380158 */     // GIR_Coverage, 6119,
     /* 380158 */     GIR_EraseRootFromParent_Done,
     /* 380159 */   // Label 7587: @380159
     /* 380159 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(380243), // Rule ID 6033 //
     /* 380164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380196 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380200 */     // MIs[2] Operand 1
     /* 380200 */     // No operand predicates
     /* 380200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380208 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380212 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380223 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 380234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380241 */     GIR_RootConstrainSelectedInstOperands,
     /* 380242 */     // GIR_Coverage, 6033,
     /* 380242 */     GIR_EraseRootFromParent_Done,
     /* 380243 */   // Label 7588: @380243
     /* 380243 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(380324), // Rule ID 6065 //
     /* 380248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380292 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380296 */     // MIs[3] Operand 1
     /* 380296 */     // No operand predicates
     /* 380296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380306 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380322 */     GIR_RootConstrainSelectedInstOperands,
     /* 380323 */     // GIR_Coverage, 6065,
     /* 380323 */     GIR_EraseRootFromParent_Done,
     /* 380324 */   // Label 7589: @380324
     /* 380324 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(380408), // Rule ID 6097 //
     /* 380329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380378 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380382 */     // MIs[3] Operand 1
     /* 380382 */     // No operand predicates
     /* 380382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380388 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 380399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380406 */     GIR_RootConstrainSelectedInstOperands,
     /* 380407 */     // GIR_Coverage, 6097,
     /* 380407 */     GIR_EraseRootFromParent_Done,
     /* 380408 */   // Label 7590: @380408
     /* 380408 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(380486), // Rule ID 6141 //
     /* 380413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 380454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380458 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380462 */     // MIs[3] Operand 1
     /* 380462 */     // No operand predicates
     /* 380462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380468 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380484 */     GIR_RootConstrainSelectedInstOperands,
     /* 380485 */     // GIR_Coverage, 6141,
     /* 380485 */     GIR_EraseRootFromParent_Done,
     /* 380486 */   // Label 7591: @380486
     /* 380486 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(380567), // Rule ID 6001 //
     /* 380491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380539 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380543 */     // MIs[3] Operand 1
     /* 380543 */     // No operand predicates
     /* 380543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380549 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380565 */     GIR_RootConstrainSelectedInstOperands,
     /* 380566 */     // GIR_Coverage, 6001,
     /* 380566 */     GIR_EraseRootFromParent_Done,
     /* 380567 */   // Label 7592: @380567
     /* 380567 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(380636), // Rule ID 2534 //
     /* 380572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380604 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380608 */     // MIs[2] Operand 1
     /* 380608 */     // No operand predicates
     /* 380608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380618 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 380621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380634 */     GIR_RootConstrainSelectedInstOperands,
     /* 380635 */     // GIR_Coverage, 2534,
     /* 380635 */     GIR_EraseRootFromParent_Done,
     /* 380636 */   // Label 7593: @380636
     /* 380636 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(380705), // Rule ID 5969 //
     /* 380641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380677 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380681 */     // MIs[2] Operand 1
     /* 380681 */     // No operand predicates
     /* 380681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380687 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 380690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380694 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380703 */     GIR_RootConstrainSelectedInstOperands,
     /* 380704 */     // GIR_Coverage, 5969,
     /* 380704 */     GIR_EraseRootFromParent_Done,
     /* 380705 */   // Label 7594: @380705
     /* 380705 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(380798), // Rule ID 6123 //
     /* 380710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 380718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380749 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 380749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380761 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 380764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380768 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 380771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380796 */     GIR_RootConstrainSelectedInstOperands,
     /* 380797 */     // GIR_Coverage, 6123,
     /* 380797 */     GIR_EraseRootFromParent_Done,
     /* 380798 */   // Label 7595: @380798
     /* 380798 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(380897), // Rule ID 6035 //
     /* 380803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 380814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380846 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 380846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380858 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 380861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380865 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 380868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 380889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380895 */     GIR_RootConstrainSelectedInstOperands,
     /* 380896 */     // GIR_Coverage, 6035,
     /* 380896 */     GIR_EraseRootFromParent_Done,
     /* 380897 */   // Label 7596: @380897
     /* 380897 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(380993), // Rule ID 6067 //
     /* 380902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 380925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380944 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 380944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 380959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380963 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 380966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 380979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380991 */     GIR_RootConstrainSelectedInstOperands,
     /* 380992 */     // GIR_Coverage, 6067,
     /* 380992 */     GIR_EraseRootFromParent_Done,
     /* 380993 */   // Label 7597: @380993
     /* 380993 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(381092), // Rule ID 6099 //
     /* 380998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 381026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381041 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381053 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 381076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381090 */     GIR_RootConstrainSelectedInstOperands,
     /* 381091 */     // GIR_Coverage, 6099,
     /* 381091 */     GIR_EraseRootFromParent_Done,
     /* 381092 */   // Label 7598: @381092
     /* 381092 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(381185), // Rule ID 6145 //
     /* 381097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 381109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381136 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 381171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381183 */     GIR_RootConstrainSelectedInstOperands,
     /* 381184 */     // GIR_Coverage, 6145,
     /* 381184 */     GIR_EraseRootFromParent_Done,
     /* 381185 */   // Label 7599: @381185
     /* 381185 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(381281), // Rule ID 6003 //
     /* 381190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 381217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381232 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 381267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381279 */     GIR_RootConstrainSelectedInstOperands,
     /* 381280 */     // GIR_Coverage, 6003,
     /* 381280 */     GIR_EraseRootFromParent_Done,
     /* 381281 */   // Label 7600: @381281
     /* 381281 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(381365), // Rule ID 2536 //
     /* 381286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 381297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381316 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 381351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381363 */     GIR_RootConstrainSelectedInstOperands,
     /* 381364 */     // GIR_Coverage, 2536,
     /* 381364 */     GIR_EraseRootFromParent_Done,
     /* 381365 */   // Label 7601: @381365
     /* 381365 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(381415), // Rule ID 13131 //
     /* 381370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381400 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 381400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 381403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381413 */     GIR_RootConstrainSelectedInstOperands,
     /* 381414 */     // GIR_Coverage, 13131,
     /* 381414 */     GIR_EraseRootFromParent_Done,
     /* 381415 */   // Label 7602: @381415
     /* 381415 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(381499), // Rule ID 5971 //
     /* 381420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 381435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381450 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381469 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 381485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381497 */     GIR_RootConstrainSelectedInstOperands,
     /* 381498 */     // GIR_Coverage, 5971,
     /* 381498 */     GIR_EraseRootFromParent_Done,
     /* 381499 */   // Label 7603: @381499
     /* 381499 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(381549), // Rule ID 1302 //
     /* 381504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381534 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 381534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 381537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381547 */     GIR_RootConstrainSelectedInstOperands,
     /* 381548 */     // GIR_Coverage, 1302,
     /* 381548 */     GIR_EraseRootFromParent_Done,
     /* 381549 */   // Label 7604: @381549
     /* 381549 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(381582), // Rule ID 1292 //
     /* 381554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381569 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 381569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 381572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 381580 */     GIR_RootConstrainSelectedInstOperands,
     /* 381581 */     // GIR_Coverage, 1292,
     /* 381581 */     GIR_EraseRootFromParent_Done,
     /* 381582 */   // Label 7605: @381582
     /* 381582 */   GIM_Reject,
     /* 381583 */ // Label 7586: @381583
     /* 381583 */ GIM_Reject,
     /* 381584 */ // Label 7437: @381584
     /* 381584 */ GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(382762),
     /* 381589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 381595 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 381598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381602 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(381686), // Rule ID 6017 //
     /* 381607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 381618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381643 */     // MIs[2] Operand 1
     /* 381643 */     // No operand predicates
     /* 381643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381655 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381666 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 381669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 381677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381684 */     GIR_RootConstrainSelectedInstOperands,
     /* 381685 */     // GIR_Coverage, 6017,
     /* 381685 */     GIR_EraseRootFromParent_Done,
     /* 381686 */   // Label 7607: @381686
     /* 381686 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(381767), // Rule ID 6049 //
     /* 381691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 381714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381739 */     // MIs[3] Operand 1
     /* 381739 */     // No operand predicates
     /* 381739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381749 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 381752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381765 */     GIR_RootConstrainSelectedInstOperands,
     /* 381766 */     // GIR_Coverage, 6049,
     /* 381766 */     GIR_EraseRootFromParent_Done,
     /* 381767 */   // Label 7608: @381767
     /* 381767 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(381851), // Rule ID 6081 //
     /* 381772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 381800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381821 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381825 */     // MIs[3] Operand 1
     /* 381825 */     // No operand predicates
     /* 381825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381831 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 381834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381849 */     GIR_RootConstrainSelectedInstOperands,
     /* 381850 */     // GIR_Coverage, 6081,
     /* 381850 */     GIR_EraseRootFromParent_Done,
     /* 381851 */   // Label 7609: @381851
     /* 381851 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(381932), // Rule ID 5985 //
     /* 381856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 381883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381904 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381908 */     // MIs[3] Operand 1
     /* 381908 */     // No operand predicates
     /* 381908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381914 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 381917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381930 */     GIR_RootConstrainSelectedInstOperands,
     /* 381931 */     // GIR_Coverage, 5985,
     /* 381931 */     GIR_EraseRootFromParent_Done,
     /* 381932 */   // Label 7610: @381932
     /* 381932 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(382001), // Rule ID 2518 //
     /* 381937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 381948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381969 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381973 */     // MIs[2] Operand 1
     /* 381973 */     // No operand predicates
     /* 381973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381983 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 381986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381999 */     GIR_RootConstrainSelectedInstOperands,
     /* 382000 */     // GIR_Coverage, 2518,
     /* 382000 */     GIR_EraseRootFromParent_Done,
     /* 382001 */   // Label 7611: @382001
     /* 382001 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(382070), // Rule ID 5953 //
     /* 382006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 382021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 382034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382042 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 382046 */     // MIs[2] Operand 1
     /* 382046 */     // No operand predicates
     /* 382046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382052 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 382052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 382055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382068 */     GIR_RootConstrainSelectedInstOperands,
     /* 382069 */     // GIR_Coverage, 5953,
     /* 382069 */     GIR_EraseRootFromParent_Done,
     /* 382070 */   // Label 7612: @382070
     /* 382070 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(382169), // Rule ID 6019 //
     /* 382075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 382086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382118 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 382121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382137 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 382140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 382153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 382161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382167 */     GIR_RootConstrainSelectedInstOperands,
     /* 382168 */     // GIR_Coverage, 6019,
     /* 382168 */     GIR_EraseRootFromParent_Done,
     /* 382169 */   // Label 7613: @382169
     /* 382169 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(382265), // Rule ID 6051 //
     /* 382174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 382197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382216 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 382219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382228 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382235 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 382238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 382251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382263 */     GIR_RootConstrainSelectedInstOperands,
     /* 382264 */     // GIR_Coverage, 6051,
     /* 382264 */     GIR_EraseRootFromParent_Done,
     /* 382265 */   // Label 7614: @382265
     /* 382265 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(382364), // Rule ID 6083 //
     /* 382270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 382298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382313 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 382316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382325 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 382335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 382348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382362 */     GIR_RootConstrainSelectedInstOperands,
     /* 382363 */     // GIR_Coverage, 6083,
     /* 382363 */     GIR_EraseRootFromParent_Done,
     /* 382364 */   // Label 7615: @382364
     /* 382364 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(382460), // Rule ID 5987 //
     /* 382369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 382396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382411 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 382414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382423 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 382433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 382446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382458 */     GIR_RootConstrainSelectedInstOperands,
     /* 382459 */     // GIR_Coverage, 5987,
     /* 382459 */     GIR_EraseRootFromParent_Done,
     /* 382460 */   // Label 7616: @382460
     /* 382460 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(382544), // Rule ID 2520 //
     /* 382465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 382476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382495 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 382498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382514 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 382517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 382530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382542 */     GIR_RootConstrainSelectedInstOperands,
     /* 382543 */     // GIR_Coverage, 2520,
     /* 382543 */     GIR_EraseRootFromParent_Done,
     /* 382544 */   // Label 7617: @382544
     /* 382544 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(382594), // Rule ID 13127 //
     /* 382549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382579 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 382579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 382582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382592 */     GIR_RootConstrainSelectedInstOperands,
     /* 382593 */     // GIR_Coverage, 13127,
     /* 382593 */     GIR_EraseRootFromParent_Done,
     /* 382594 */   // Label 7618: @382594
     /* 382594 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(382678), // Rule ID 5955 //
     /* 382599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 382614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382629 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 382632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382648 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 382651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 382661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 382664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382676 */     GIR_RootConstrainSelectedInstOperands,
     /* 382677 */     // GIR_Coverage, 5955,
     /* 382677 */     GIR_EraseRootFromParent_Done,
     /* 382678 */   // Label 7619: @382678
     /* 382678 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(382728), // Rule ID 1298 //
     /* 382683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382713 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 382713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 382716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382726 */     GIR_RootConstrainSelectedInstOperands,
     /* 382727 */     // GIR_Coverage, 1298,
     /* 382727 */     GIR_EraseRootFromParent_Done,
     /* 382728 */   // Label 7620: @382728
     /* 382728 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(382761), // Rule ID 1288 //
     /* 382733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382748 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 382748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 382751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 382759 */     GIR_RootConstrainSelectedInstOperands,
     /* 382760 */     // GIR_Coverage, 1288,
     /* 382760 */     GIR_EraseRootFromParent_Done,
     /* 382761 */   // Label 7621: @382761
     /* 382761 */   GIM_Reject,
     /* 382762 */ // Label 7606: @382762
     /* 382762 */ GIM_Reject,
     /* 382763 */ // Label 7438: @382763
     /* 382763 */ GIM_Reject,
     /* 382764 */ // Label 106: @382764
     /* 382764 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7630*/ GIMT_Encode4(383063),
     /* 382775 */ /*GILLT_s16*//*Label 7622*/ GIMT_Encode4(382815),
     /* 382779 */ /*GILLT_s32*//*Label 7623*/ GIMT_Encode4(382846),
     /* 382783 */ /*GILLT_s64*//*Label 7624*/ GIMT_Encode4(382877), GIMT_Encode4(0),
     /* 382791 */ /*GILLT_v2s32*//*Label 7625*/ GIMT_Encode4(382908),
     /* 382795 */ /*GILLT_v2s64*//*Label 7626*/ GIMT_Encode4(382939),
     /* 382799 */ /*GILLT_v4s16*//*Label 7627*/ GIMT_Encode4(382970),
     /* 382803 */ /*GILLT_v4s32*//*Label 7628*/ GIMT_Encode4(383001), GIMT_Encode4(0),
     /* 382811 */ /*GILLT_v8s16*//*Label 7629*/ GIMT_Encode4(383032),
     /* 382815 */ // Label 7622: @382815
     /* 382815 */ GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(382845), // Rule ID 569 //
     /* 382820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 382826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382834 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 382834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 382839 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382843 */   GIR_RootConstrainSelectedInstOperands,
     /* 382844 */   // GIR_Coverage, 569,
     /* 382844 */   GIR_Done,
     /* 382845 */ // Label 7631: @382845
     /* 382845 */ GIM_Reject,
     /* 382846 */ // Label 7623: @382846
     /* 382846 */ GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(382876), // Rule ID 571 //
     /* 382851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 382857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382865 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 382865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 382870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382874 */   GIR_RootConstrainSelectedInstOperands,
     /* 382875 */   // GIR_Coverage, 571,
     /* 382875 */   GIR_Done,
     /* 382876 */ // Label 7632: @382876
     /* 382876 */ GIM_Reject,
     /* 382877 */ // Label 7624: @382877
     /* 382877 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(382907), // Rule ID 573 //
     /* 382882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 382888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382896 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 382896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 382901 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382905 */   GIR_RootConstrainSelectedInstOperands,
     /* 382906 */   // GIR_Coverage, 573,
     /* 382906 */   GIR_Done,
     /* 382907 */ // Label 7633: @382907
     /* 382907 */ GIM_Reject,
     /* 382908 */ // Label 7625: @382908
     /* 382908 */ GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(382938), // Rule ID 952 //
     /* 382913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382927 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 382927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 382932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382936 */   GIR_RootConstrainSelectedInstOperands,
     /* 382937 */   // GIR_Coverage, 952,
     /* 382937 */   GIR_Done,
     /* 382938 */ // Label 7634: @382938
     /* 382938 */ GIM_Reject,
     /* 382939 */ // Label 7626: @382939
     /* 382939 */ GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(382969), // Rule ID 956 //
     /* 382944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382958 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 382958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 382963 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382967 */   GIR_RootConstrainSelectedInstOperands,
     /* 382968 */   // GIR_Coverage, 956,
     /* 382968 */   GIR_Done,
     /* 382969 */ // Label 7635: @382969
     /* 382969 */ GIM_Reject,
     /* 382970 */ // Label 7627: @382970
     /* 382970 */ GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(383000), // Rule ID 948 //
     /* 382975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 382978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382989 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 382989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 382994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382998 */   GIR_RootConstrainSelectedInstOperands,
     /* 382999 */   // GIR_Coverage, 948,
     /* 382999 */   GIR_Done,
     /* 383000 */ // Label 7636: @383000
     /* 383000 */ GIM_Reject,
     /* 383001 */ // Label 7628: @383001
     /* 383001 */ GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(383031), // Rule ID 954 //
     /* 383006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383020 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 383020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 383025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383029 */   GIR_RootConstrainSelectedInstOperands,
     /* 383030 */   // GIR_Coverage, 954,
     /* 383030 */   GIR_Done,
     /* 383031 */ // Label 7637: @383031
     /* 383031 */ GIM_Reject,
     /* 383032 */ // Label 7629: @383032
     /* 383032 */ GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(383062), // Rule ID 950 //
     /* 383037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383051 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 383051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 383056 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383060 */   GIR_RootConstrainSelectedInstOperands,
     /* 383061 */   // GIR_Coverage, 950,
     /* 383061 */   GIR_Done,
     /* 383062 */ // Label 7638: @383062
     /* 383062 */ GIM_Reject,
     /* 383063 */ // Label 7630: @383063
     /* 383063 */ GIM_Reject,
     /* 383064 */ // Label 107: @383064
     /* 383064 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(383077), // Rule ID 6440 //
     /* 383069 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 383069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 383072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383075 */   GIR_RootConstrainSelectedInstOperands,
     /* 383076 */   // GIR_Coverage, 6440,
     /* 383076 */   GIR_EraseRootFromParent_Done,
     /* 383077 */ // Label 7639: @383077
     /* 383077 */ GIM_Reject,
     /* 383078 */ // Label 108: @383078
     /* 383078 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(383098), // Rule ID 6441 //
     /* 383083 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 383083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 383086 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 383096 */   GIR_RootConstrainSelectedInstOperands,
     /* 383097 */   // GIR_Coverage, 6441,
     /* 383097 */   GIR_EraseRootFromParent_Done,
     /* 383098 */ // Label 7640: @383098
     /* 383098 */ GIM_Reject,
     /* 383099 */ // Label 109: @383099
     /* 383099 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(383123), // Rule ID 6442 //
     /* 383104 */   // MIs[0] kind
     /* 383104 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 383107 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 383112 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 383112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 383115 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 383121 */   GIR_RootConstrainSelectedInstOperands,
     /* 383122 */   // GIR_Coverage, 6442,
     /* 383122 */   GIR_EraseRootFromParent_Done,
     /* 383123 */ // Label 7641: @383123
     /* 383123 */ GIM_Reject,
     /* 383124 */ // Label 110: @383124
     /* 383124 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7645*/ GIMT_Encode4(383433),
     /* 383135 */ /*GILLT_s16*//*Label 7642*/ GIMT_Encode4(383147),
     /* 383139 */ /*GILLT_s32*//*Label 7643*/ GIMT_Encode4(383300),
     /* 383143 */ /*GILLT_s64*//*Label 7644*/ GIMT_Encode4(383405),
     /* 383147 */ // Label 7642: @383147
     /* 383147 */ GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(383248), // Rule ID 5547 //
     /* 383152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383166 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 383166 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 383169 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 383173 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383178 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383182 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383188 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 383191 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 383195 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383200 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 383203 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383221 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 383228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 383241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383246 */   GIR_RootConstrainSelectedInstOperands,
     /* 383247 */   // GIR_Coverage, 5547,
     /* 383247 */   GIR_EraseRootFromParent_Done,
     /* 383248 */ // Label 7646: @383248
     /* 383248 */ GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(383299), // Rule ID 5548 //
     /* 383253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 383256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383267 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 383267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 383274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383279 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383283 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 383292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383297 */   GIR_RootConstrainSelectedInstOperands,
     /* 383298 */   // GIR_Coverage, 5548,
     /* 383298 */   GIR_EraseRootFromParent_Done,
     /* 383299 */ // Label 7647: @383299
     /* 383299 */ GIM_Reject,
     /* 383300 */ // Label 7643: @383300
     /* 383300 */ GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(383377), // Rule ID 5549 //
     /* 383305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383316 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 383316 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 383319 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 383323 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383328 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383332 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383350 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 383357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 383370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383375 */   GIR_RootConstrainSelectedInstOperands,
     /* 383376 */   // GIR_Coverage, 5549,
     /* 383376 */   GIR_EraseRootFromParent_Done,
     /* 383377 */ // Label 7648: @383377
     /* 383377 */ GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(383404), // Rule ID 5550 //
     /* 383382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383393 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 383393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 383398 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383402 */   GIR_RootConstrainSelectedInstOperands,
     /* 383403 */   // GIR_Coverage, 5550,
     /* 383403 */   GIR_Done,
     /* 383404 */ // Label 7649: @383404
     /* 383404 */ GIM_Reject,
     /* 383405 */ // Label 7644: @383405
     /* 383405 */ GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(383432), // Rule ID 5551 //
     /* 383410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383421 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 383421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 383426 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383430 */   GIR_RootConstrainSelectedInstOperands,
     /* 383431 */   // GIR_Coverage, 5551,
     /* 383431 */   GIR_Done,
     /* 383432 */ // Label 7650: @383432
     /* 383432 */ GIM_Reject,
     /* 383433 */ // Label 7645: @383433
     /* 383433 */ GIM_Reject,
     /* 383434 */ // Label 111: @383434
     /* 383434 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7654*/ GIMT_Encode4(383604),
     /* 383445 */ /*GILLT_s16*//*Label 7651*/ GIMT_Encode4(383457),
     /* 383449 */ /*GILLT_s32*//*Label 7652*/ GIMT_Encode4(383518),
     /* 383453 */ /*GILLT_s64*//*Label 7653*/ GIMT_Encode4(383576),
     /* 383457 */ // Label 7651: @383457
     /* 383457 */ GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(383487), // Rule ID 1935 //
     /* 383462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383476 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 383476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 383481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383485 */   GIR_RootConstrainSelectedInstOperands,
     /* 383486 */   // GIR_Coverage, 1935,
     /* 383486 */   GIR_Done,
     /* 383487 */ // Label 7655: @383487
     /* 383487 */ GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(383517), // Rule ID 1937 //
     /* 383492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383506 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 383506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 383511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383515 */   GIR_RootConstrainSelectedInstOperands,
     /* 383516 */   // GIR_Coverage, 1937,
     /* 383516 */   GIR_Done,
     /* 383517 */ // Label 7656: @383517
     /* 383517 */ GIM_Reject,
     /* 383518 */ // Label 7652: @383518
     /* 383518 */ GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(383548), // Rule ID 1939 //
     /* 383523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383537 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 383537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 383542 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383546 */   GIR_RootConstrainSelectedInstOperands,
     /* 383547 */   // GIR_Coverage, 1939,
     /* 383547 */   GIR_Done,
     /* 383548 */ // Label 7657: @383548
     /* 383548 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(383575), // Rule ID 5557 //
     /* 383553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383564 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 383564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 383569 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383573 */   GIR_RootConstrainSelectedInstOperands,
     /* 383574 */   // GIR_Coverage, 5557,
     /* 383574 */   GIR_Done,
     /* 383575 */ // Label 7658: @383575
     /* 383575 */ GIM_Reject,
     /* 383576 */ // Label 7653: @383576
     /* 383576 */ GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(383603), // Rule ID 5559 //
     /* 383581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383592 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 383592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 383597 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383601 */   GIR_RootConstrainSelectedInstOperands,
     /* 383602 */   // GIR_Coverage, 5559,
     /* 383602 */   GIR_Done,
     /* 383603 */ // Label 7659: @383603
     /* 383603 */ GIM_Reject,
     /* 383604 */ // Label 7654: @383604
     /* 383604 */ GIM_Reject,
     /* 383605 */ // Label 112: @383605
     /* 383605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7663*/ GIMT_Encode4(383775),
     /* 383616 */ /*GILLT_s16*//*Label 7660*/ GIMT_Encode4(383628),
     /* 383620 */ /*GILLT_s32*//*Label 7661*/ GIMT_Encode4(383689),
     /* 383624 */ /*GILLT_s64*//*Label 7662*/ GIMT_Encode4(383747),
     /* 383628 */ // Label 7660: @383628
     /* 383628 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(383658), // Rule ID 1947 //
     /* 383633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383647 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 383647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 383652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383656 */   GIR_RootConstrainSelectedInstOperands,
     /* 383657 */   // GIR_Coverage, 1947,
     /* 383657 */   GIR_Done,
     /* 383658 */ // Label 7664: @383658
     /* 383658 */ GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(383688), // Rule ID 1949 //
     /* 383663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383677 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 383677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 383682 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383686 */   GIR_RootConstrainSelectedInstOperands,
     /* 383687 */   // GIR_Coverage, 1949,
     /* 383687 */   GIR_Done,
     /* 383688 */ // Label 7665: @383688
     /* 383688 */ GIM_Reject,
     /* 383689 */ // Label 7661: @383689
     /* 383689 */ GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(383719), // Rule ID 1951 //
     /* 383694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383708 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 383708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 383713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383717 */   GIR_RootConstrainSelectedInstOperands,
     /* 383718 */   // GIR_Coverage, 1951,
     /* 383718 */   GIR_Done,
     /* 383719 */ // Label 7666: @383719
     /* 383719 */ GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(383746), // Rule ID 5565 //
     /* 383724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383735 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 383735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 383740 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383744 */   GIR_RootConstrainSelectedInstOperands,
     /* 383745 */   // GIR_Coverage, 5565,
     /* 383745 */   GIR_Done,
     /* 383746 */ // Label 7667: @383746
     /* 383746 */ GIM_Reject,
     /* 383747 */ // Label 7662: @383747
     /* 383747 */ GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(383774), // Rule ID 5567 //
     /* 383752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383763 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 383763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 383768 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383772 */   GIR_RootConstrainSelectedInstOperands,
     /* 383773 */   // GIR_Coverage, 5567,
     /* 383773 */   GIR_Done,
     /* 383774 */ // Label 7668: @383774
     /* 383774 */ GIM_Reject,
     /* 383775 */ // Label 7663: @383775
     /* 383775 */ GIM_Reject,
     /* 383776 */ // Label 113: @383776
     /* 383776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7672*/ GIMT_Encode4(383946),
     /* 383787 */ /*GILLT_s16*//*Label 7669*/ GIMT_Encode4(383799),
     /* 383791 */ /*GILLT_s32*//*Label 7670*/ GIMT_Encode4(383860),
     /* 383795 */ /*GILLT_s64*//*Label 7671*/ GIMT_Encode4(383918),
     /* 383799 */ // Label 7669: @383799
     /* 383799 */ GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(383829), // Rule ID 1941 //
     /* 383804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383818 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 383818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 383823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383827 */   GIR_RootConstrainSelectedInstOperands,
     /* 383828 */   // GIR_Coverage, 1941,
     /* 383828 */   GIR_Done,
     /* 383829 */ // Label 7673: @383829
     /* 383829 */ GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(383859), // Rule ID 1943 //
     /* 383834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383848 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 383848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 383853 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383857 */   GIR_RootConstrainSelectedInstOperands,
     /* 383858 */   // GIR_Coverage, 1943,
     /* 383858 */   GIR_Done,
     /* 383859 */ // Label 7674: @383859
     /* 383859 */ GIM_Reject,
     /* 383860 */ // Label 7670: @383860
     /* 383860 */ GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(383890), // Rule ID 1945 //
     /* 383865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383879 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 383879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 383884 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383888 */   GIR_RootConstrainSelectedInstOperands,
     /* 383889 */   // GIR_Coverage, 1945,
     /* 383889 */   GIR_Done,
     /* 383890 */ // Label 7675: @383890
     /* 383890 */ GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(383917), // Rule ID 5561 //
     /* 383895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383906 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 383906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 383911 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383915 */   GIR_RootConstrainSelectedInstOperands,
     /* 383916 */   // GIR_Coverage, 5561,
     /* 383916 */   GIR_Done,
     /* 383917 */ // Label 7676: @383917
     /* 383917 */ GIM_Reject,
     /* 383918 */ // Label 7671: @383918
     /* 383918 */ GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(383945), // Rule ID 5563 //
     /* 383923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383934 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 383934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 383939 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383943 */   GIR_RootConstrainSelectedInstOperands,
     /* 383944 */   // GIR_Coverage, 5563,
     /* 383944 */   GIR_Done,
     /* 383945 */ // Label 7677: @383945
     /* 383945 */ GIM_Reject,
     /* 383946 */ // Label 7672: @383946
     /* 383946 */ GIM_Reject,
     /* 383947 */ // Label 114: @383947
     /* 383947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7681*/ GIMT_Encode4(384117),
     /* 383958 */ /*GILLT_s16*//*Label 7678*/ GIMT_Encode4(383970),
     /* 383962 */ /*GILLT_s32*//*Label 7679*/ GIMT_Encode4(384031),
     /* 383966 */ /*GILLT_s64*//*Label 7680*/ GIMT_Encode4(384089),
     /* 383970 */ // Label 7678: @383970
     /* 383970 */ GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(384000), // Rule ID 1953 //
     /* 383975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383989 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 383989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 383994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 383998 */   GIR_RootConstrainSelectedInstOperands,
     /* 383999 */   // GIR_Coverage, 1953,
     /* 383999 */   GIR_Done,
     /* 384000 */ // Label 7682: @384000
     /* 384000 */ GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(384030), // Rule ID 1955 //
     /* 384005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 384008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384019 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 384019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 384024 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 384028 */   GIR_RootConstrainSelectedInstOperands,
     /* 384029 */   // GIR_Coverage, 1955,
     /* 384029 */   GIR_Done,
     /* 384030 */ // Label 7683: @384030
     /* 384030 */ GIM_Reject,
     /* 384031 */ // Label 7679: @384031
     /* 384031 */ GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(384061), // Rule ID 1957 //
     /* 384036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384050 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 384050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 384055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 384059 */   GIR_RootConstrainSelectedInstOperands,
     /* 384060 */   // GIR_Coverage, 1957,
     /* 384060 */   GIR_Done,
     /* 384061 */ // Label 7684: @384061
     /* 384061 */ GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(384088), // Rule ID 5569 //
     /* 384066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384077 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 384077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 384082 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 384086 */   GIR_RootConstrainSelectedInstOperands,
     /* 384087 */   // GIR_Coverage, 5569,
     /* 384087 */   GIR_Done,
     /* 384088 */ // Label 7685: @384088
     /* 384088 */ GIM_Reject,
     /* 384089 */ // Label 7680: @384089
     /* 384089 */ GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(384116), // Rule ID 5571 //
     /* 384094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384105 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 384105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 384110 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 384114 */   GIR_RootConstrainSelectedInstOperands,
     /* 384115 */   // GIR_Coverage, 5571,
     /* 384115 */   GIR_Done,
     /* 384116 */ // Label 7686: @384116
     /* 384116 */ GIM_Reject,
     /* 384117 */ // Label 7681: @384117
     /* 384117 */ GIM_Reject,
     /* 384118 */ // Label 115: @384118
     /* 384118 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7691*/ GIMT_Encode4(385246),
     /* 384129 */ /*GILLT_s8*//*Label 7687*/ GIMT_Encode4(384145),
     /* 384133 */ /*GILLT_s16*//*Label 7688*/ GIMT_Encode4(384192),
     /* 384137 */ /*GILLT_s32*//*Label 7689*/ GIMT_Encode4(384607),
     /* 384141 */ /*GILLT_s64*//*Label 7690*/ GIMT_Encode4(385060),
     /* 384145 */ // Label 7687: @384145
     /* 384145 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(384168), // Rule ID 5816 //
     /* 384150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 384153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384161 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 384161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 384166 */   GIR_RootConstrainSelectedInstOperands,
     /* 384167 */   // GIR_Coverage, 5816,
     /* 384167 */   GIR_Done,
     /* 384168 */ // Label 7692: @384168
     /* 384168 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(384191), // Rule ID 5817 //
     /* 384173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 384176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384184 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 384184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 384189 */   GIR_RootConstrainSelectedInstOperands,
     /* 384190 */   // GIR_Coverage, 5817,
     /* 384190 */   GIR_Done,
     /* 384191 */ // Label 7693: @384191
     /* 384191 */ GIM_Reject,
     /* 384192 */ // Label 7688: @384192
     /* 384192 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(384242), // Rule ID 5763 //
     /* 384197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384204 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384208 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 384212 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 384215 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 384220 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 384224 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384231 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 384231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 384234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384236 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 384240 */   GIR_RootConstrainSelectedInstOperands,
     /* 384241 */   // GIR_Coverage, 5763,
     /* 384241 */   GIR_EraseRootFromParent_Done,
     /* 384242 */ // Label 7694: @384242
     /* 384242 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(384292), // Rule ID 5765 //
     /* 384247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 384262 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 384265 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 384270 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 384274 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384281 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 384281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 384284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384286 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 384290 */   GIR_RootConstrainSelectedInstOperands,
     /* 384291 */   // GIR_Coverage, 5765,
     /* 384291 */   GIR_EraseRootFromParent_Done,
     /* 384292 */ // Label 7695: @384292
     /* 384292 */ GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(384342), // Rule ID 5773 //
     /* 384297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384304 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 384312 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 384315 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 384320 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 384324 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384331 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 384331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 384334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384336 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 384340 */   GIR_RootConstrainSelectedInstOperands,
     /* 384341 */   // GIR_Coverage, 5773,
     /* 384341 */   GIR_EraseRootFromParent_Done,
     /* 384342 */ // Label 7696: @384342
     /* 384342 */ GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(384392), // Rule ID 5775 //
     /* 384347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 384362 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 384365 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 384370 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 384374 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384379 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384381 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 384381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 384384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384386 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 384390 */   GIR_RootConstrainSelectedInstOperands,
     /* 384391 */   // GIR_Coverage, 5775,
     /* 384391 */   GIR_EraseRootFromParent_Done,
     /* 384392 */ // Label 7697: @384392
     /* 384392 */ GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(384434), // Rule ID 5772 //
     /* 384397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384404 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 384412 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 384416 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384421 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384423 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 384423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 384426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384428 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384432 */   GIR_RootConstrainSelectedInstOperands,
     /* 384433 */   // GIR_Coverage, 5772,
     /* 384433 */   GIR_EraseRootFromParent_Done,
     /* 384434 */ // Label 7698: @384434
     /* 384434 */ GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(384476), // Rule ID 5774 //
     /* 384439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 384454 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 384458 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384463 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384465 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 384465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 384468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384470 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384474 */   GIR_RootConstrainSelectedInstOperands,
     /* 384475 */   // GIR_Coverage, 5774,
     /* 384475 */   GIR_EraseRootFromParent_Done,
     /* 384476 */ // Label 7699: @384476
     /* 384476 */ GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(384518), // Rule ID 5762 //
     /* 384481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 384496 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 384500 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384507 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 384507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 384510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384512 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384516 */   GIR_RootConstrainSelectedInstOperands,
     /* 384517 */   // GIR_Coverage, 5762,
     /* 384517 */   GIR_EraseRootFromParent_Done,
     /* 384518 */ // Label 7700: @384518
     /* 384518 */ GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(384560), // Rule ID 5764 //
     /* 384523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384530 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384534 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 384538 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 384542 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384549 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 384549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 384552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384554 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384558 */   GIR_RootConstrainSelectedInstOperands,
     /* 384559 */   // GIR_Coverage, 5764,
     /* 384559 */   GIR_EraseRootFromParent_Done,
     /* 384560 */ // Label 7701: @384560
     /* 384560 */ GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(384583), // Rule ID 5818 //
     /* 384565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384576 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 384576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 384581 */   GIR_RootConstrainSelectedInstOperands,
     /* 384582 */   // GIR_Coverage, 5818,
     /* 384582 */   GIR_Done,
     /* 384583 */ // Label 7702: @384583
     /* 384583 */ GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(384606), // Rule ID 5819 //
     /* 384588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384599 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 384599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 384604 */   GIR_RootConstrainSelectedInstOperands,
     /* 384605 */   // GIR_Coverage, 5819,
     /* 384605 */   GIR_Done,
     /* 384606 */ // Label 7703: @384606
     /* 384606 */ GIM_Reject,
     /* 384607 */ // Label 7689: @384607
     /* 384607 */ GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(384657), // Rule ID 5767 //
     /* 384612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 384627 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 384630 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 384635 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 384639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384646 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 384646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 384649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384651 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 384655 */   GIR_RootConstrainSelectedInstOperands,
     /* 384656 */   // GIR_Coverage, 5767,
     /* 384656 */   GIR_EraseRootFromParent_Done,
     /* 384657 */ // Label 7704: @384657
     /* 384657 */ GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(384707), // Rule ID 5769 //
     /* 384662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384669 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 384677 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 384680 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 384685 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 384689 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384696 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 384696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 384699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384701 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 384705 */   GIR_RootConstrainSelectedInstOperands,
     /* 384706 */   // GIR_Coverage, 5769,
     /* 384706 */   GIR_EraseRootFromParent_Done,
     /* 384707 */ // Label 7705: @384707
     /* 384707 */ GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(384757), // Rule ID 5777 //
     /* 384712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 384727 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 384730 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 384735 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 384739 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384746 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 384746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 384749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384751 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 384755 */   GIR_RootConstrainSelectedInstOperands,
     /* 384756 */   // GIR_Coverage, 5777,
     /* 384756 */   GIR_EraseRootFromParent_Done,
     /* 384757 */ // Label 7706: @384757
     /* 384757 */ GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(384807), // Rule ID 5779 //
     /* 384762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384769 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 384777 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 384780 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 384785 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 384789 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384796 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 384796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 384799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384801 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 384805 */   GIR_RootConstrainSelectedInstOperands,
     /* 384806 */   // GIR_Coverage, 5779,
     /* 384806 */   GIR_EraseRootFromParent_Done,
     /* 384807 */ // Label 7707: @384807
     /* 384807 */ GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(384849), // Rule ID 5776 //
     /* 384812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 384827 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384831 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384838 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 384838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 384841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384843 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384847 */   GIR_RootConstrainSelectedInstOperands,
     /* 384848 */   // GIR_Coverage, 5776,
     /* 384848 */   GIR_EraseRootFromParent_Done,
     /* 384849 */ // Label 7708: @384849
     /* 384849 */ GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(384891), // Rule ID 5778 //
     /* 384854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384861 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384865 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 384869 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384873 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384880 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 384880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 384883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384885 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384889 */   GIR_RootConstrainSelectedInstOperands,
     /* 384890 */   // GIR_Coverage, 5778,
     /* 384890 */   GIR_EraseRootFromParent_Done,
     /* 384891 */ // Label 7709: @384891
     /* 384891 */ GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(384933), // Rule ID 5766 //
     /* 384896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384903 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384907 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 384911 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384915 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384922 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 384922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 384925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384927 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384931 */   GIR_RootConstrainSelectedInstOperands,
     /* 384932 */   // GIR_Coverage, 5766,
     /* 384932 */   GIR_EraseRootFromParent_Done,
     /* 384933 */ // Label 7710: @384933
     /* 384933 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(384975), // Rule ID 5768 //
     /* 384938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 384953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384957 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384964 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 384964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 384967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384969 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384973 */   GIR_RootConstrainSelectedInstOperands,
     /* 384974 */   // GIR_Coverage, 5768,
     /* 384974 */   GIR_EraseRootFromParent_Done,
     /* 384975 */ // Label 7711: @384975
     /* 384975 */ GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(385036), // Rule ID 5820 //
     /* 384980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384991 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 384991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 384998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385003 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385007 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385018 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 385025 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385035 */   // GIR_Coverage, 5820,
     /* 385035 */   GIR_EraseRootFromParent_Done,
     /* 385036 */ // Label 7712: @385036
     /* 385036 */ GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(385059), // Rule ID 5821 //
     /* 385041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385052 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 385052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 385057 */   GIR_RootConstrainSelectedInstOperands,
     /* 385058 */   // GIR_Coverage, 5821,
     /* 385058 */   GIR_Done,
     /* 385059 */ // Label 7713: @385059
     /* 385059 */ GIM_Reject,
     /* 385060 */ // Label 7690: @385060
     /* 385060 */ GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(385245),
     /* 385065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385072 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(385115), // Rule ID 5771 //
     /* 385077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 385085 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 385088 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 385093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 385097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385104 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 385104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 385107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 385113 */     GIR_RootConstrainSelectedInstOperands,
     /* 385114 */     // GIR_Coverage, 5771,
     /* 385114 */     GIR_EraseRootFromParent_Done,
     /* 385115 */   // Label 7715: @385115
     /* 385115 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(385158), // Rule ID 5781 //
     /* 385120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 385128 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 385131 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 385136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 385140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385147 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 385147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 385150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 385156 */     GIR_RootConstrainSelectedInstOperands,
     /* 385157 */     // GIR_Coverage, 5781,
     /* 385157 */     GIR_EraseRootFromParent_Done,
     /* 385158 */   // Label 7716: @385158
     /* 385158 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(385193), // Rule ID 5780 //
     /* 385163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 385171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385182 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 385182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 385185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385191 */     GIR_RootConstrainSelectedInstOperands,
     /* 385192 */     // GIR_Coverage, 5780,
     /* 385192 */     GIR_EraseRootFromParent_Done,
     /* 385193 */   // Label 7717: @385193
     /* 385193 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(385228), // Rule ID 5770 //
     /* 385198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 385206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385217 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 385217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 385220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385226 */     GIR_RootConstrainSelectedInstOperands,
     /* 385227 */     // GIR_Coverage, 5770,
     /* 385227 */     GIR_EraseRootFromParent_Done,
     /* 385228 */   // Label 7718: @385228
     /* 385228 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(385244), // Rule ID 5822 //
     /* 385233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385237 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 385237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 385242 */     GIR_RootConstrainSelectedInstOperands,
     /* 385243 */     // GIR_Coverage, 5822,
     /* 385243 */     GIR_Done,
     /* 385244 */   // Label 7719: @385244
     /* 385244 */   GIM_Reject,
     /* 385245 */ // Label 7714: @385245
     /* 385245 */ GIM_Reject,
     /* 385246 */ // Label 7691: @385246
     /* 385246 */ GIM_Reject,
     /* 385247 */ // Label 116: @385247
     /* 385247 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7723*/ GIMT_Encode4(385449),
     /* 385258 */ /*GILLT_s8*//*Label 7720*/ GIMT_Encode4(385270),
     /* 385262 */ /*GILLT_s16*//*Label 7721*/ GIMT_Encode4(385317),
     /* 385266 */ /*GILLT_s32*//*Label 7722*/ GIMT_Encode4(385364),
     /* 385270 */ // Label 7720: @385270
     /* 385270 */ GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(385293), // Rule ID 5913 //
     /* 385275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 385278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385286 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 385286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 385291 */   GIR_RootConstrainSelectedInstOperands,
     /* 385292 */   // GIR_Coverage, 5913,
     /* 385292 */   GIR_Done,
     /* 385293 */ // Label 7724: @385293
     /* 385293 */ GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(385316), // Rule ID 5914 //
     /* 385298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 385301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385309 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 385309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 385314 */   GIR_RootConstrainSelectedInstOperands,
     /* 385315 */   // GIR_Coverage, 5914,
     /* 385315 */   GIR_Done,
     /* 385316 */ // Label 7725: @385316
     /* 385316 */ GIM_Reject,
     /* 385317 */ // Label 7721: @385317
     /* 385317 */ GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(385340), // Rule ID 5915 //
     /* 385322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 385325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385333 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 385333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 385338 */   GIR_RootConstrainSelectedInstOperands,
     /* 385339 */   // GIR_Coverage, 5915,
     /* 385339 */   GIR_Done,
     /* 385340 */ // Label 7726: @385340
     /* 385340 */ GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(385363), // Rule ID 5916 //
     /* 385345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385356 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 385356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 385361 */   GIR_RootConstrainSelectedInstOperands,
     /* 385362 */   // GIR_Coverage, 5916,
     /* 385362 */   GIR_Done,
     /* 385363 */ // Label 7727: @385363
     /* 385363 */ GIM_Reject,
     /* 385364 */ // Label 7722: @385364
     /* 385364 */ GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(385387), // Rule ID 5917 //
     /* 385369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385380 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 385380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 385385 */   GIR_RootConstrainSelectedInstOperands,
     /* 385386 */   // GIR_Coverage, 5917,
     /* 385386 */   GIR_Done,
     /* 385387 */ // Label 7728: @385387
     /* 385387 */ GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(385448), // Rule ID 5918 //
     /* 385392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385403 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 385403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 385410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385430 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 385437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385447 */   // GIR_Coverage, 5918,
     /* 385447 */   GIR_EraseRootFromParent_Done,
     /* 385448 */ // Label 7729: @385448
     /* 385448 */ GIM_Reject,
     /* 385449 */ // Label 7723: @385449
     /* 385449 */ GIM_Reject,
     /* 385450 */ // Label 117: @385450
     /* 385450 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7733*/ GIMT_Encode4(385652),
     /* 385461 */ /*GILLT_s8*//*Label 7730*/ GIMT_Encode4(385473),
     /* 385465 */ /*GILLT_s16*//*Label 7731*/ GIMT_Encode4(385520),
     /* 385469 */ /*GILLT_s32*//*Label 7732*/ GIMT_Encode4(385567),
     /* 385473 */ // Label 7730: @385473
     /* 385473 */ GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(385496), // Rule ID 5907 //
     /* 385478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 385481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385489 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 385489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 385494 */   GIR_RootConstrainSelectedInstOperands,
     /* 385495 */   // GIR_Coverage, 5907,
     /* 385495 */   GIR_Done,
     /* 385496 */ // Label 7734: @385496
     /* 385496 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(385519), // Rule ID 5908 //
     /* 385501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 385504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385512 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 385512 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 385517 */   GIR_RootConstrainSelectedInstOperands,
     /* 385518 */   // GIR_Coverage, 5908,
     /* 385518 */   GIR_Done,
     /* 385519 */ // Label 7735: @385519
     /* 385519 */ GIM_Reject,
     /* 385520 */ // Label 7731: @385520
     /* 385520 */ GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(385543), // Rule ID 5909 //
     /* 385525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 385528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385536 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 385536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 385541 */   GIR_RootConstrainSelectedInstOperands,
     /* 385542 */   // GIR_Coverage, 5909,
     /* 385542 */   GIR_Done,
     /* 385543 */ // Label 7736: @385543
     /* 385543 */ GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(385566), // Rule ID 5910 //
     /* 385548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385559 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 385559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 385564 */   GIR_RootConstrainSelectedInstOperands,
     /* 385565 */   // GIR_Coverage, 5910,
     /* 385565 */   GIR_Done,
     /* 385566 */ // Label 7737: @385566
     /* 385566 */ GIM_Reject,
     /* 385567 */ // Label 7732: @385567
     /* 385567 */ GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(385590), // Rule ID 5911 //
     /* 385572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385583 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 385583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 385588 */   GIR_RootConstrainSelectedInstOperands,
     /* 385589 */   // GIR_Coverage, 5911,
     /* 385589 */   GIR_Done,
     /* 385590 */ // Label 7738: @385590
     /* 385590 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(385651), // Rule ID 5912 //
     /* 385595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385606 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 385606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 385613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385618 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385622 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385633 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 385640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385650 */   // GIR_Coverage, 5912,
     /* 385650 */   GIR_EraseRootFromParent_Done,
     /* 385651 */ // Label 7739: @385651
     /* 385651 */ GIM_Reject,
     /* 385652 */ // Label 7733: @385652
     /* 385652 */ GIM_Reject,
     /* 385653 */ // Label 118: @385653
     /* 385653 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7743*/ GIMT_Encode4(385855),
     /* 385664 */ /*GILLT_s8*//*Label 7740*/ GIMT_Encode4(385676),
     /* 385668 */ /*GILLT_s16*//*Label 7741*/ GIMT_Encode4(385723),
     /* 385672 */ /*GILLT_s32*//*Label 7742*/ GIMT_Encode4(385770),
     /* 385676 */ // Label 7740: @385676
     /* 385676 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(385699), // Rule ID 5901 //
     /* 385681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 385684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385692 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 385692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 385697 */   GIR_RootConstrainSelectedInstOperands,
     /* 385698 */   // GIR_Coverage, 5901,
     /* 385698 */   GIR_Done,
     /* 385699 */ // Label 7744: @385699
     /* 385699 */ GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(385722), // Rule ID 5902 //
     /* 385704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 385707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385715 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 385715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 385720 */   GIR_RootConstrainSelectedInstOperands,
     /* 385721 */   // GIR_Coverage, 5902,
     /* 385721 */   GIR_Done,
     /* 385722 */ // Label 7745: @385722
     /* 385722 */ GIM_Reject,
     /* 385723 */ // Label 7741: @385723
     /* 385723 */ GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(385746), // Rule ID 5903 //
     /* 385728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 385731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385739 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 385739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 385744 */   GIR_RootConstrainSelectedInstOperands,
     /* 385745 */   // GIR_Coverage, 5903,
     /* 385745 */   GIR_Done,
     /* 385746 */ // Label 7746: @385746
     /* 385746 */ GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(385769), // Rule ID 5904 //
     /* 385751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385762 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 385762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 385767 */   GIR_RootConstrainSelectedInstOperands,
     /* 385768 */   // GIR_Coverage, 5904,
     /* 385768 */   GIR_Done,
     /* 385769 */ // Label 7747: @385769
     /* 385769 */ GIM_Reject,
     /* 385770 */ // Label 7742: @385770
     /* 385770 */ GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(385793), // Rule ID 5905 //
     /* 385775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385786 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 385786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 385791 */   GIR_RootConstrainSelectedInstOperands,
     /* 385792 */   // GIR_Coverage, 5905,
     /* 385792 */   GIR_Done,
     /* 385793 */ // Label 7748: @385793
     /* 385793 */ GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(385854), // Rule ID 5906 //
     /* 385798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385809 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 385809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 385816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385825 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385836 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 385843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385853 */   // GIR_Coverage, 5906,
     /* 385853 */   GIR_EraseRootFromParent_Done,
     /* 385854 */ // Label 7749: @385854
     /* 385854 */ GIM_Reject,
     /* 385855 */ // Label 7743: @385855
     /* 385855 */ GIM_Reject,
     /* 385856 */ // Label 119: @385856
     /* 385856 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7753*/ GIMT_Encode4(386058),
     /* 385867 */ /*GILLT_s8*//*Label 7750*/ GIMT_Encode4(385879),
     /* 385871 */ /*GILLT_s16*//*Label 7751*/ GIMT_Encode4(385926),
     /* 385875 */ /*GILLT_s32*//*Label 7752*/ GIMT_Encode4(385973),
     /* 385879 */ // Label 7750: @385879
     /* 385879 */ GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(385902), // Rule ID 5895 //
     /* 385884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 385887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385895 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 385895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 385900 */   GIR_RootConstrainSelectedInstOperands,
     /* 385901 */   // GIR_Coverage, 5895,
     /* 385901 */   GIR_Done,
     /* 385902 */ // Label 7754: @385902
     /* 385902 */ GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(385925), // Rule ID 5896 //
     /* 385907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 385910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385918 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 385918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 385923 */   GIR_RootConstrainSelectedInstOperands,
     /* 385924 */   // GIR_Coverage, 5896,
     /* 385924 */   GIR_Done,
     /* 385925 */ // Label 7755: @385925
     /* 385925 */ GIM_Reject,
     /* 385926 */ // Label 7751: @385926
     /* 385926 */ GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(385949), // Rule ID 5897 //
     /* 385931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 385934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385942 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 385942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 385947 */   GIR_RootConstrainSelectedInstOperands,
     /* 385948 */   // GIR_Coverage, 5897,
     /* 385948 */   GIR_Done,
     /* 385949 */ // Label 7756: @385949
     /* 385949 */ GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(385972), // Rule ID 5898 //
     /* 385954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385965 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 385965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 385970 */   GIR_RootConstrainSelectedInstOperands,
     /* 385971 */   // GIR_Coverage, 5898,
     /* 385971 */   GIR_Done,
     /* 385972 */ // Label 7757: @385972
     /* 385972 */ GIM_Reject,
     /* 385973 */ // Label 7752: @385973
     /* 385973 */ GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(385996), // Rule ID 5899 //
     /* 385978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385989 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 385989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 385994 */   GIR_RootConstrainSelectedInstOperands,
     /* 385995 */   // GIR_Coverage, 5899,
     /* 385995 */   GIR_Done,
     /* 385996 */ // Label 7758: @385996
     /* 385996 */ GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(386057), // Rule ID 5900 //
     /* 386001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386012 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 386012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 386019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386024 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 386028 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 386032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386039 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386056 */   // GIR_Coverage, 5900,
     /* 386056 */   GIR_EraseRootFromParent_Done,
     /* 386057 */ // Label 7759: @386057
     /* 386057 */ GIM_Reject,
     /* 386058 */ // Label 7753: @386058
     /* 386058 */ GIM_Reject,
     /* 386059 */ // Label 120: @386059
     /* 386059 */ GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(386198),
     /* 386064 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 386067 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 386071 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(386105), // Rule ID 257 //
     /* 386076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 386083 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 386083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 386086 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 386088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386103 */     GIR_RootConstrainSelectedInstOperands,
     /* 386104 */     // GIR_Coverage, 257,
     /* 386104 */     GIR_EraseRootFromParent_Done,
     /* 386105 */   // Label 7761: @386105
     /* 386105 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(386139), // Rule ID 258 //
     /* 386110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 386117 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 386117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 386120 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 386122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386137 */     GIR_RootConstrainSelectedInstOperands,
     /* 386138 */     // GIR_Coverage, 258,
     /* 386138 */     GIR_EraseRootFromParent_Done,
     /* 386139 */   // Label 7762: @386139
     /* 386139 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(386168), // Rule ID 273 //
     /* 386144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 386151 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 386151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 386154 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 386156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386166 */     GIR_RootConstrainSelectedInstOperands,
     /* 386167 */     // GIR_Coverage, 273,
     /* 386167 */     GIR_EraseRootFromParent_Done,
     /* 386168 */   // Label 7763: @386168
     /* 386168 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(386197), // Rule ID 294 //
     /* 386173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 386180 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 386180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 386183 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 386185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386195 */     GIR_RootConstrainSelectedInstOperands,
     /* 386196 */     // GIR_Coverage, 294,
     /* 386196 */     GIR_EraseRootFromParent_Done,
     /* 386197 */   // Label 7764: @386197
     /* 386197 */   GIM_Reject,
     /* 386198 */ // Label 7760: @386198
     /* 386198 */ GIM_Reject,
     /* 386199 */ // Label 121: @386199
     /* 386199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7777*/ GIMT_Encode4(386738),
     /* 386210 */ /*GILLT_s64*//*Label 7765*/ GIMT_Encode4(386294), GIMT_Encode4(0),
     /* 386218 */ /*GILLT_v2s32*//*Label 7766*/ GIMT_Encode4(386332),
     /* 386222 */ /*GILLT_v2s64*//*Label 7767*/ GIMT_Encode4(386370),
     /* 386226 */ /*GILLT_v4s16*//*Label 7768*/ GIMT_Encode4(386408),
     /* 386230 */ /*GILLT_v4s32*//*Label 7769*/ GIMT_Encode4(386446),
     /* 386234 */ /*GILLT_v8s8*//*Label 7770*/ GIMT_Encode4(386484),
     /* 386238 */ /*GILLT_v8s16*//*Label 7771*/ GIMT_Encode4(386522),
     /* 386242 */ /*GILLT_v16s8*//*Label 7772*/ GIMT_Encode4(386560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 386262 */ /*GILLT_nxv2s64*//*Label 7773*/ GIMT_Encode4(386598), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 386274 */ /*GILLT_nxv4s32*//*Label 7774*/ GIMT_Encode4(386633), GIMT_Encode4(0),
     /* 386282 */ /*GILLT_nxv8s16*//*Label 7775*/ GIMT_Encode4(386668), GIMT_Encode4(0),
     /* 386290 */ /*GILLT_nxv16s8*//*Label 7776*/ GIMT_Encode4(386703),
     /* 386294 */ // Label 7765: @386294
     /* 386294 */ GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(386331), // Rule ID 5017 //
     /* 386299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 386302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386320 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386324 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 386324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 386329 */   GIR_RootConstrainSelectedInstOperands,
     /* 386330 */   // GIR_Coverage, 5017,
     /* 386330 */   GIR_Done,
     /* 386331 */ // Label 7778: @386331
     /* 386331 */ GIM_Reject,
     /* 386332 */ // Label 7766: @386332
     /* 386332 */ GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(386369), // Rule ID 5016 //
     /* 386337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 386343 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 386346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386358 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386362 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 386362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 386367 */   GIR_RootConstrainSelectedInstOperands,
     /* 386368 */   // GIR_Coverage, 5016,
     /* 386368 */   GIR_Done,
     /* 386369 */ // Label 7779: @386369
     /* 386369 */ GIM_Reject,
     /* 386370 */ // Label 7767: @386370
     /* 386370 */ GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(386407), // Rule ID 5021 //
     /* 386375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 386381 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 386384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386396 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386400 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 386400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 386405 */   GIR_RootConstrainSelectedInstOperands,
     /* 386406 */   // GIR_Coverage, 5021,
     /* 386406 */   GIR_Done,
     /* 386407 */ // Label 7780: @386407
     /* 386407 */ GIM_Reject,
     /* 386408 */ // Label 7768: @386408
     /* 386408 */ GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(386445), // Rule ID 5015 //
     /* 386413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 386416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 386419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 386422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386438 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 386438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 386443 */   GIR_RootConstrainSelectedInstOperands,
     /* 386444 */   // GIR_Coverage, 5015,
     /* 386444 */   GIR_Done,
     /* 386445 */ // Label 7781: @386445
     /* 386445 */ GIM_Reject,
     /* 386446 */ // Label 7769: @386446
     /* 386446 */ GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(386483), // Rule ID 5020 //
     /* 386451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 386457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 386460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386476 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 386476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 386481 */   GIR_RootConstrainSelectedInstOperands,
     /* 386482 */   // GIR_Coverage, 5020,
     /* 386482 */   GIR_Done,
     /* 386483 */ // Label 7782: @386483
     /* 386483 */ GIM_Reject,
     /* 386484 */ // Label 7770: @386484
     /* 386484 */ GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(386521), // Rule ID 5014 //
     /* 386489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 386492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 386495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 386498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386510 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386514 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 386514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 386519 */   GIR_RootConstrainSelectedInstOperands,
     /* 386520 */   // GIR_Coverage, 5014,
     /* 386520 */   GIR_Done,
     /* 386521 */ // Label 7783: @386521
     /* 386521 */ GIM_Reject,
     /* 386522 */ // Label 7771: @386522
     /* 386522 */ GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(386559), // Rule ID 5019 //
     /* 386527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 386533 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 386536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386548 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386552 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 386552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 386557 */   GIR_RootConstrainSelectedInstOperands,
     /* 386558 */   // GIR_Coverage, 5019,
     /* 386558 */   GIR_Done,
     /* 386559 */ // Label 7784: @386559
     /* 386559 */ GIM_Reject,
     /* 386560 */ // Label 7772: @386560
     /* 386560 */ GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(386597), // Rule ID 5018 //
     /* 386565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 386571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 386574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386590 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 386590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 386595 */   GIR_RootConstrainSelectedInstOperands,
     /* 386596 */   // GIR_Coverage, 5018,
     /* 386596 */   GIR_Done,
     /* 386597 */ // Label 7785: @386597
     /* 386597 */ GIM_Reject,
     /* 386598 */ // Label 7773: @386598
     /* 386598 */ GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(386632), // Rule ID 11759 //
     /* 386603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 386606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 386609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 386612 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 386615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386619 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 386619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 386622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 386624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 386626 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 386628 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 386630 */   GIR_RootConstrainSelectedInstOperands,
     /* 386631 */   // GIR_Coverage, 11759,
     /* 386631 */   GIR_EraseRootFromParent_Done,
     /* 386632 */ // Label 7786: @386632
     /* 386632 */ GIM_Reject,
     /* 386633 */ // Label 7774: @386633
     /* 386633 */ GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(386667), // Rule ID 11757 //
     /* 386638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 386641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 386647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 386650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386654 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 386654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 386657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 386659 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 386661 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 386663 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 386665 */   GIR_RootConstrainSelectedInstOperands,
     /* 386666 */   // GIR_Coverage, 11757,
     /* 386666 */   GIR_EraseRootFromParent_Done,
     /* 386667 */ // Label 7787: @386667
     /* 386667 */ GIM_Reject,
     /* 386668 */ // Label 7775: @386668
     /* 386668 */ GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(386702), // Rule ID 11755 //
     /* 386673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 386676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 386682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 386685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386689 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 386689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 386692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 386694 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 386696 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 386698 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 386700 */   GIR_RootConstrainSelectedInstOperands,
     /* 386701 */   // GIR_Coverage, 11755,
     /* 386701 */   GIR_EraseRootFromParent_Done,
     /* 386702 */ // Label 7788: @386702
     /* 386702 */ GIM_Reject,
     /* 386703 */ // Label 7776: @386703
     /* 386703 */ GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(386737), // Rule ID 11753 //
     /* 386708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 386711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 386717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 386720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386724 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 386724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 386727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 386729 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 386731 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 386733 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 386735 */   GIR_RootConstrainSelectedInstOperands,
     /* 386736 */   // GIR_Coverage, 11753,
     /* 386736 */   GIR_EraseRootFromParent_Done,
     /* 386737 */ // Label 7789: @386737
     /* 386737 */ GIM_Reject,
     /* 386738 */ // Label 7777: @386738
     /* 386738 */ GIM_Reject,
     /* 386739 */ // Label 122: @386739
     /* 386739 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7798*/ GIMT_Encode4(388561),
     /* 386750 */ /*GILLT_s64*//*Label 7790*/ GIMT_Encode4(386786), GIMT_Encode4(0),
     /* 386758 */ /*GILLT_v2s32*//*Label 7791*/ GIMT_Encode4(386981),
     /* 386762 */ /*GILLT_v2s64*//*Label 7792*/ GIMT_Encode4(387228),
     /* 386766 */ /*GILLT_v4s16*//*Label 7793*/ GIMT_Encode4(387475),
     /* 386770 */ /*GILLT_v4s32*//*Label 7794*/ GIMT_Encode4(387751),
     /* 386774 */ /*GILLT_v8s8*//*Label 7795*/ GIMT_Encode4(387998),
     /* 386778 */ /*GILLT_v8s16*//*Label 7796*/ GIMT_Encode4(388143),
     /* 386782 */ /*GILLT_v16s8*//*Label 7797*/ GIMT_Encode4(388419),
     /* 386786 */ // Label 7790: @386786
     /* 386786 */ GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(386980),
     /* 386791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 386794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386798 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(386845), // Rule ID 6338 //
     /* 386803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386818 */     // MIs[1] Rn
     /* 386818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386829 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 386832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386843 */     GIR_RootConstrainSelectedInstOperands,
     /* 386844 */     // GIR_Coverage, 6338,
     /* 386844 */     GIR_EraseRootFromParent_Done,
     /* 386845 */   // Label 7800: @386845
     /* 386845 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(386892), // Rule ID 6349 //
     /* 386850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386858 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386865 */     // MIs[1] Rn
     /* 386865 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386876 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 386879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386890 */     GIR_RootConstrainSelectedInstOperands,
     /* 386891 */     // GIR_Coverage, 6349,
     /* 386891 */     GIR_EraseRootFromParent_Done,
     /* 386892 */   // Label 7801: @386892
     /* 386892 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(386939), // Rule ID 12998 //
     /* 386897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386912 */     // MIs[1] Rn
     /* 386912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386923 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 386926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386937 */     GIR_RootConstrainSelectedInstOperands,
     /* 386938 */     // GIR_Coverage, 12998,
     /* 386938 */     GIR_EraseRootFromParent_Done,
     /* 386939 */   // Label 7802: @386939
     /* 386939 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(386959), // Rule ID 5573 //
     /* 386944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386948 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 386948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386958 */     // GIR_Coverage, 5573,
     /* 386958 */     GIR_Done,
     /* 386959 */   // Label 7803: @386959
     /* 386959 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(386979), // Rule ID 5574 //
     /* 386964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386968 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 386968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386978 */     // GIR_Coverage, 5574,
     /* 386978 */     GIR_Done,
     /* 386979 */   // Label 7804: @386979
     /* 386979 */   GIM_Reject,
     /* 386980 */ // Label 7799: @386980
     /* 386980 */ GIM_Reject,
     /* 386981 */ // Label 7791: @386981
     /* 386981 */ GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(387227),
     /* 386986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 386989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386993 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(387040), // Rule ID 6335 //
     /* 386998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387013 */     // MIs[1] Rn
     /* 387013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387024 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 387027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387038 */     GIR_RootConstrainSelectedInstOperands,
     /* 387039 */     // GIR_Coverage, 6335,
     /* 387039 */     GIR_EraseRootFromParent_Done,
     /* 387040 */   // Label 7806: @387040
     /* 387040 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(387087), // Rule ID 6346 //
     /* 387045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387060 */     // MIs[1] Rn
     /* 387060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387071 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 387074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387085 */     GIR_RootConstrainSelectedInstOperands,
     /* 387086 */     // GIR_Coverage, 6346,
     /* 387086 */     GIR_EraseRootFromParent_Done,
     /* 387087 */   // Label 7807: @387087
     /* 387087 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(387134), // Rule ID 12995 //
     /* 387092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387107 */     // MIs[1] Rn
     /* 387107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387118 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 387121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387132 */     GIR_RootConstrainSelectedInstOperands,
     /* 387133 */     // GIR_Coverage, 12995,
     /* 387133 */     GIR_EraseRootFromParent_Done,
     /* 387134 */   // Label 7808: @387134
     /* 387134 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(387153), // Rule ID 1909 //
     /* 387139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387146 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 387146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 387151 */     GIR_RootConstrainSelectedInstOperands,
     /* 387152 */     // GIR_Coverage, 1909,
     /* 387152 */     GIR_Done,
     /* 387153 */   // Label 7809: @387153
     /* 387153 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(387226), // Rule ID 5575 //
     /* 387158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387162 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387162 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 387165 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 387169 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 387176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 387179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 387183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387188 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 387191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 387198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 387216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387224 */     GIR_RootConstrainSelectedInstOperands,
     /* 387225 */     // GIR_Coverage, 5575,
     /* 387225 */     GIR_EraseRootFromParent_Done,
     /* 387226 */   // Label 7810: @387226
     /* 387226 */   GIM_Reject,
     /* 387227 */ // Label 7805: @387227
     /* 387227 */ GIM_Reject,
     /* 387228 */ // Label 7792: @387228
     /* 387228 */ GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(387474),
     /* 387233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 387236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387240 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(387287), // Rule ID 6337 //
     /* 387245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387260 */     // MIs[1] Rn
     /* 387260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387271 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 387274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387285 */     GIR_RootConstrainSelectedInstOperands,
     /* 387286 */     // GIR_Coverage, 6337,
     /* 387286 */     GIR_EraseRootFromParent_Done,
     /* 387287 */   // Label 7812: @387287
     /* 387287 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(387334), // Rule ID 6348 //
     /* 387292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387307 */     // MIs[1] Rn
     /* 387307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387318 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 387321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387332 */     GIR_RootConstrainSelectedInstOperands,
     /* 387333 */     // GIR_Coverage, 6348,
     /* 387333 */     GIR_EraseRootFromParent_Done,
     /* 387334 */   // Label 7813: @387334
     /* 387334 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(387381), // Rule ID 12997 //
     /* 387339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387347 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387350 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387354 */     // MIs[1] Rn
     /* 387354 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387365 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 387368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387379 */     GIR_RootConstrainSelectedInstOperands,
     /* 387380 */     // GIR_Coverage, 12997,
     /* 387380 */     GIR_EraseRootFromParent_Done,
     /* 387381 */   // Label 7814: @387381
     /* 387381 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(387400), // Rule ID 1911 //
     /* 387386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387393 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 387393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 387398 */     GIR_RootConstrainSelectedInstOperands,
     /* 387399 */     // GIR_Coverage, 1911,
     /* 387399 */     GIR_Done,
     /* 387400 */   // Label 7815: @387400
     /* 387400 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(387473), // Rule ID 5577 //
     /* 387405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387409 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 387412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 387416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 387423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 387426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 387430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387435 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 387438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387442 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 387463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387471 */     GIR_RootConstrainSelectedInstOperands,
     /* 387472 */     // GIR_Coverage, 5577,
     /* 387472 */     GIR_EraseRootFromParent_Done,
     /* 387473 */   // Label 7816: @387473
     /* 387473 */   GIM_Reject,
     /* 387474 */ // Label 7811: @387474
     /* 387474 */ GIM_Reject,
     /* 387475 */ // Label 7793: @387475
     /* 387475 */ GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(387536), // Rule ID 6333 //
     /* 387480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 387483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387495 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387498 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387502 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 387509 */   // MIs[1] Rn
     /* 387509 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387513 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387518 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387520 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 387523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387525 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387529 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387534 */   GIR_RootConstrainSelectedInstOperands,
     /* 387535 */   // GIR_Coverage, 6333,
     /* 387535 */   GIR_EraseRootFromParent_Done,
     /* 387536 */ // Label 7817: @387536
     /* 387536 */ GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(387590), // Rule ID 6350 //
     /* 387541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 387544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387556 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387563 */   // MIs[1] Rn
     /* 387563 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387567 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387574 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 387577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387579 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387588 */   GIR_RootConstrainSelectedInstOperands,
     /* 387589 */   // GIR_Coverage, 6350,
     /* 387589 */   GIR_EraseRootFromParent_Done,
     /* 387590 */ // Label 7818: @387590
     /* 387590 */ GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(387644), // Rule ID 12993 //
     /* 387595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 387598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387602 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387610 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387613 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387617 */   // MIs[1] Rn
     /* 387617 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387621 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387628 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 387631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387633 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387642 */   GIR_RootConstrainSelectedInstOperands,
     /* 387643 */   // GIR_Coverage, 12993,
     /* 387643 */   GIR_EraseRootFromParent_Done,
     /* 387644 */ // Label 7819: @387644
     /* 387644 */ GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(387670), // Rule ID 1907 //
     /* 387649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 387655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387663 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 387663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 387668 */   GIR_RootConstrainSelectedInstOperands,
     /* 387669 */   // GIR_Coverage, 1907,
     /* 387669 */   GIR_Done,
     /* 387670 */ // Label 7820: @387670
     /* 387670 */ GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(387750), // Rule ID 5578 //
     /* 387675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 387678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387686 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387686 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 387689 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 387693 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 387700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 387703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 387707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387712 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 387715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387719 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 387722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 387740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387748 */   GIR_RootConstrainSelectedInstOperands,
     /* 387749 */   // GIR_Coverage, 5578,
     /* 387749 */   GIR_EraseRootFromParent_Done,
     /* 387750 */ // Label 7821: @387750
     /* 387750 */ GIM_Reject,
     /* 387751 */ // Label 7794: @387751
     /* 387751 */ GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(387997),
     /* 387756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 387759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387763 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(387810), // Rule ID 6336 //
     /* 387768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387783 */     // MIs[1] Rn
     /* 387783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387794 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 387797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387808 */     GIR_RootConstrainSelectedInstOperands,
     /* 387809 */     // GIR_Coverage, 6336,
     /* 387809 */     GIR_EraseRootFromParent_Done,
     /* 387810 */   // Label 7823: @387810
     /* 387810 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(387857), // Rule ID 6347 //
     /* 387815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387830 */     // MIs[1] Rn
     /* 387830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387841 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 387844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387855 */     GIR_RootConstrainSelectedInstOperands,
     /* 387856 */     // GIR_Coverage, 6347,
     /* 387856 */     GIR_EraseRootFromParent_Done,
     /* 387857 */   // Label 7824: @387857
     /* 387857 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(387904), // Rule ID 12996 //
     /* 387862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387870 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 387877 */     // MIs[1] Rn
     /* 387877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 387881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 387886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387888 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 387888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 387891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 387893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 387902 */     GIR_RootConstrainSelectedInstOperands,
     /* 387903 */     // GIR_Coverage, 12996,
     /* 387903 */     GIR_EraseRootFromParent_Done,
     /* 387904 */   // Label 7825: @387904
     /* 387904 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(387923), // Rule ID 1910 //
     /* 387909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387916 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 387916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 387921 */     GIR_RootConstrainSelectedInstOperands,
     /* 387922 */     // GIR_Coverage, 1910,
     /* 387922 */     GIR_Done,
     /* 387923 */   // Label 7826: @387923
     /* 387923 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(387996), // Rule ID 5576 //
     /* 387928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387932 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 387935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 387939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 387946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 387949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 387953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 387961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 387968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 387986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387994 */     GIR_RootConstrainSelectedInstOperands,
     /* 387995 */     // GIR_Coverage, 5576,
     /* 387995 */     GIR_EraseRootFromParent_Done,
     /* 387996 */   // Label 7827: @387996
     /* 387996 */   GIM_Reject,
     /* 387997 */ // Label 7822: @387997
     /* 387997 */ GIM_Reject,
     /* 387998 */ // Label 7795: @387998
     /* 387998 */ GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(388055), // Rule ID 12991 //
     /* 388003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 388006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388018 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388025 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 388029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388031 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 388038 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 388041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 388048 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388053 */   GIR_RootConstrainSelectedInstOperands,
     /* 388054 */   // GIR_Coverage, 12991,
     /* 388054 */   GIR_EraseRootFromParent_Done,
     /* 388055 */ // Label 7828: @388055
     /* 388055 */ GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(388116), // Rule ID 6331 //
     /* 388060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388075 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388078 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388082 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 388089 */   // MIs[1] Rn
     /* 388089 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 388093 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388098 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388100 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 388103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388105 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388114 */   GIR_RootConstrainSelectedInstOperands,
     /* 388115 */   // GIR_Coverage, 6331,
     /* 388115 */   GIR_EraseRootFromParent_Done,
     /* 388116 */ // Label 7829: @388116
     /* 388116 */ GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(388142), // Rule ID 1905 //
     /* 388121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388135 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 388135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 388140 */   GIR_RootConstrainSelectedInstOperands,
     /* 388141 */   // GIR_Coverage, 1905,
     /* 388141 */   GIR_Done,
     /* 388142 */ // Label 7830: @388142
     /* 388142 */ GIM_Reject,
     /* 388143 */ // Label 7796: @388143
     /* 388143 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(388204), // Rule ID 6334 //
     /* 388148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388163 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388166 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388170 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 388177 */   // MIs[1] Rn
     /* 388177 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 388181 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388188 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 388191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388193 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388197 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388202 */   GIR_RootConstrainSelectedInstOperands,
     /* 388203 */   // GIR_Coverage, 6334,
     /* 388203 */   GIR_EraseRootFromParent_Done,
     /* 388204 */ // Label 7831: @388204
     /* 388204 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(388258), // Rule ID 6351 //
     /* 388209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 388212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388216 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388220 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388224 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388227 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388231 */   // MIs[1] Rn
     /* 388231 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 388235 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388242 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 388245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388247 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388251 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388256 */   GIR_RootConstrainSelectedInstOperands,
     /* 388257 */   // GIR_Coverage, 6351,
     /* 388257 */   GIR_EraseRootFromParent_Done,
     /* 388258 */ // Label 7832: @388258
     /* 388258 */ GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(388312), // Rule ID 12994 //
     /* 388263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 388266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388270 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388278 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388281 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388285 */   // MIs[1] Rn
     /* 388285 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 388289 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388296 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 388299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388301 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388310 */   GIR_RootConstrainSelectedInstOperands,
     /* 388311 */   // GIR_Coverage, 12994,
     /* 388311 */   GIR_EraseRootFromParent_Done,
     /* 388312 */ // Label 7833: @388312
     /* 388312 */ GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(388338), // Rule ID 1908 //
     /* 388317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388331 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 388331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 388336 */   GIR_RootConstrainSelectedInstOperands,
     /* 388337 */   // GIR_Coverage, 1908,
     /* 388337 */   GIR_Done,
     /* 388338 */ // Label 7834: @388338
     /* 388338 */ GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(388418), // Rule ID 5579 //
     /* 388343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 388346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388354 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388354 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 388357 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 388361 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 388368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 388371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 388375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388380 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 388383 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 388387 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388390 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388400 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 388408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388416 */   GIR_RootConstrainSelectedInstOperands,
     /* 388417 */   // GIR_Coverage, 5579,
     /* 388417 */   GIR_EraseRootFromParent_Done,
     /* 388418 */ // Label 7835: @388418
     /* 388418 */ GIM_Reject,
     /* 388419 */ // Label 7797: @388419
     /* 388419 */ GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(388480), // Rule ID 6332 //
     /* 388424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388439 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388442 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388446 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 388453 */   // MIs[1] Rn
     /* 388453 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 388457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388464 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 388467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388469 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388478 */   GIR_RootConstrainSelectedInstOperands,
     /* 388479 */   // GIR_Coverage, 6332,
     /* 388479 */   GIR_EraseRootFromParent_Done,
     /* 388480 */ // Label 7836: @388480
     /* 388480 */ GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(388534), // Rule ID 12992 //
     /* 388485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 388488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388492 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388500 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388507 */   // MIs[1] Rn
     /* 388507 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 388511 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388516 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388518 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 388521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388523 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388527 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388532 */   GIR_RootConstrainSelectedInstOperands,
     /* 388533 */   // GIR_Coverage, 12992,
     /* 388533 */   GIR_EraseRootFromParent_Done,
     /* 388534 */ // Label 7837: @388534
     /* 388534 */ GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(388560), // Rule ID 1906 //
     /* 388539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388553 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 388553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 388558 */   GIR_RootConstrainSelectedInstOperands,
     /* 388559 */   // GIR_Coverage, 1906,
     /* 388559 */   GIR_Done,
     /* 388560 */ // Label 7838: @388560
     /* 388560 */ GIM_Reject,
     /* 388561 */ // Label 7798: @388561
     /* 388561 */ GIM_Reject,
     /* 388562 */ // Label 123: @388562
     /* 388562 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 7841*/ GIMT_Encode4(388816),
     /* 388573 */ /*GILLT_v4s16*//*Label 7839*/ GIMT_Encode4(388589), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 388585 */ /*GILLT_v8s16*//*Label 7840*/ GIMT_Encode4(388675),
     /* 388589 */ // Label 7839: @388589
     /* 388589 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(388674),
     /* 388594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388608 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(388642), // Rule ID 1915 //
     /* 388613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388628 */     // MIs[1] Operand 1
     /* 388628 */     // No operand predicates
     /* 388628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388630 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 388633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388640 */     GIR_RootConstrainSelectedInstOperands,
     /* 388641 */     // GIR_Coverage, 1915,
     /* 388641 */     GIR_EraseRootFromParent_Done,
     /* 388642 */   // Label 7843: @388642
     /* 388642 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(388673), // Rule ID 5580 //
     /* 388647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388659 */     // MIs[1] Operand 1
     /* 388659 */     // No operand predicates
     /* 388659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388661 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 388661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 388664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388671 */     GIR_RootConstrainSelectedInstOperands,
     /* 388672 */     // GIR_Coverage, 5580,
     /* 388672 */     GIR_EraseRootFromParent_Done,
     /* 388673 */   // Label 7844: @388673
     /* 388673 */   GIM_Reject,
     /* 388674 */ // Label 7842: @388674
     /* 388674 */ GIM_Reject,
     /* 388675 */ // Label 7840: @388675
     /* 388675 */ GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(388815),
     /* 388680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388690 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(388741), // Rule ID 6342 //
     /* 388695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388710 */     // MIs[1] Rn
     /* 388710 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 388714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388725 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 388728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388739 */     GIR_RootConstrainSelectedInstOperands,
     /* 388740 */     // GIR_Coverage, 6342,
     /* 388740 */     GIR_EraseRootFromParent_Done,
     /* 388741 */   // Label 7846: @388741
     /* 388741 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(388779), // Rule ID 1916 //
     /* 388746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388765 */     // MIs[1] Operand 1
     /* 388765 */     // No operand predicates
     /* 388765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388767 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 388770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388777 */     GIR_RootConstrainSelectedInstOperands,
     /* 388778 */     // GIR_Coverage, 1916,
     /* 388778 */     GIR_EraseRootFromParent_Done,
     /* 388779 */   // Label 7847: @388779
     /* 388779 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(388814), // Rule ID 5581 //
     /* 388784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388800 */     // MIs[1] Operand 1
     /* 388800 */     // No operand predicates
     /* 388800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388802 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 388802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 388805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388812 */     GIR_RootConstrainSelectedInstOperands,
     /* 388813 */     // GIR_Coverage, 5581,
     /* 388813 */     GIR_EraseRootFromParent_Done,
     /* 388814 */   // Label 7848: @388814
     /* 388814 */   GIM_Reject,
     /* 388815 */ // Label 7845: @388815
     /* 388815 */ GIM_Reject,
     /* 388816 */ // Label 7841: @388816
     /* 388816 */ GIM_Reject,
     /* 388817 */ // Label 124: @388817
     /* 388817 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 7851*/ GIMT_Encode4(389071),
     /* 388828 */ /*GILLT_v2s32*//*Label 7849*/ GIMT_Encode4(388844), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 388840 */ /*GILLT_v4s32*//*Label 7850*/ GIMT_Encode4(388930),
     /* 388844 */ // Label 7849: @388844
     /* 388844 */ GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(388929),
     /* 388849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388863 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(388897), // Rule ID 1913 //
     /* 388868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388883 */     // MIs[1] Operand 1
     /* 388883 */     // No operand predicates
     /* 388883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388885 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 388888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388895 */     GIR_RootConstrainSelectedInstOperands,
     /* 388896 */     // GIR_Coverage, 1913,
     /* 388896 */     GIR_EraseRootFromParent_Done,
     /* 388897 */   // Label 7853: @388897
     /* 388897 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(388928), // Rule ID 5582 //
     /* 388902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388914 */     // MIs[1] Operand 1
     /* 388914 */     // No operand predicates
     /* 388914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388916 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 388916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 388919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388926 */     GIR_RootConstrainSelectedInstOperands,
     /* 388927 */     // GIR_Coverage, 5582,
     /* 388927 */     GIR_EraseRootFromParent_Done,
     /* 388928 */   // Label 7854: @388928
     /* 388928 */   GIM_Reject,
     /* 388929 */ // Label 7852: @388929
     /* 388929 */ GIM_Reject,
     /* 388930 */ // Label 7850: @388930
     /* 388930 */ GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(389070),
     /* 388935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388945 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(388996), // Rule ID 6344 //
     /* 388950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 388958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 388961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 388965 */     // MIs[1] Rn
     /* 388965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 388969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388980 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 388983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 388985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 388994 */     GIR_RootConstrainSelectedInstOperands,
     /* 388995 */     // GIR_Coverage, 6344,
     /* 388995 */     GIR_EraseRootFromParent_Done,
     /* 388996 */   // Label 7856: @388996
     /* 388996 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(389034), // Rule ID 1914 //
     /* 389001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389020 */     // MIs[1] Operand 1
     /* 389020 */     // No operand predicates
     /* 389020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389022 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 389025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389032 */     GIR_RootConstrainSelectedInstOperands,
     /* 389033 */     // GIR_Coverage, 1914,
     /* 389033 */     GIR_EraseRootFromParent_Done,
     /* 389034 */   // Label 7857: @389034
     /* 389034 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(389069), // Rule ID 5583 //
     /* 389039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389055 */     // MIs[1] Operand 1
     /* 389055 */     // No operand predicates
     /* 389055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389057 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 389057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 389060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 389067 */     GIR_RootConstrainSelectedInstOperands,
     /* 389068 */     // GIR_Coverage, 5583,
     /* 389068 */     GIR_EraseRootFromParent_Done,
     /* 389069 */   // Label 7858: @389069
     /* 389069 */   GIM_Reject,
     /* 389070 */ // Label 7855: @389070
     /* 389070 */ GIM_Reject,
     /* 389071 */ // Label 7851: @389071
     /* 389071 */ GIM_Reject,
     /* 389072 */ // Label 125: @389072
     /* 389072 */ GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(389217),
     /* 389077 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 389080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389090 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(389141), // Rule ID 6345 //
     /* 389095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 389103 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 389106 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 389110 */     // MIs[1] Rn
     /* 389110 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 389114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 389119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389125 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 389125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 389128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 389130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 389139 */     GIR_RootConstrainSelectedInstOperands,
     /* 389140 */     // GIR_Coverage, 6345,
     /* 389140 */     GIR_EraseRootFromParent_Done,
     /* 389141 */   // Label 7860: @389141
     /* 389141 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(389216),
     /* 389146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389150 */     GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(389184), // Rule ID 1912 //
     /* 389155 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389158 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389162 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389166 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389170 */       // MIs[1] Operand 1
     /* 389170 */       // No operand predicates
     /* 389170 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389172 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389172 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 389175 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389177 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389179 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389182 */       GIR_RootConstrainSelectedInstOperands,
     /* 389183 */       // GIR_Coverage, 1912,
     /* 389183 */       GIR_EraseRootFromParent_Done,
     /* 389184 */     // Label 7862: @389184
     /* 389184 */     GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(389215), // Rule ID 5584 //
     /* 389189 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389193 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389197 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389201 */       // MIs[1] Operand 1
     /* 389201 */       // No operand predicates
     /* 389201 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389203 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 389203 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 389206 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389208 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389210 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 389213 */       GIR_RootConstrainSelectedInstOperands,
     /* 389214 */       // GIR_Coverage, 5584,
     /* 389214 */       GIR_EraseRootFromParent_Done,
     /* 389215 */     // Label 7863: @389215
     /* 389215 */     GIM_Reject,
     /* 389216 */   // Label 7861: @389216
     /* 389216 */   GIM_Reject,
     /* 389217 */ // Label 7859: @389217
     /* 389217 */ GIM_Reject,
     /* 389218 */ // Label 126: @389218
     /* 389218 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 7866*/ GIMT_Encode4(389396),
     /* 389229 */ /*GILLT_v8s8*//*Label 7864*/ GIMT_Encode4(389241), GIMT_Encode4(0),
     /* 389237 */ /*GILLT_v16s8*//*Label 7865*/ GIMT_Encode4(389290),
     /* 389241 */ // Label 7864: @389241
     /* 389241 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(389289), // Rule ID 1917 //
     /* 389246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389263 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389267 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389271 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 389275 */   // MIs[1] Operand 1
     /* 389275 */   // No operand predicates
     /* 389275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389277 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 389280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389282 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389284 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389287 */   GIR_RootConstrainSelectedInstOperands,
     /* 389288 */   // GIR_Coverage, 1917,
     /* 389288 */   GIR_EraseRootFromParent_Done,
     /* 389289 */ // Label 7867: @389289
     /* 389289 */ GIM_Reject,
     /* 389290 */ // Label 7865: @389290
     /* 389290 */ GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(389395),
     /* 389295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389305 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(389356), // Rule ID 6340 //
     /* 389310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 389318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 389321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 389325 */     // MIs[1] Rn
     /* 389325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 389329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 389334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389340 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 389340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 389343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 389345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 389354 */     GIR_RootConstrainSelectedInstOperands,
     /* 389355 */     // GIR_Coverage, 6340,
     /* 389355 */     GIR_EraseRootFromParent_Done,
     /* 389356 */   // Label 7869: @389356
     /* 389356 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(389394), // Rule ID 1918 //
     /* 389361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 389380 */     // MIs[1] Operand 1
     /* 389380 */     // No operand predicates
     /* 389380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389382 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 389385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389392 */     GIR_RootConstrainSelectedInstOperands,
     /* 389393 */     // GIR_Coverage, 1918,
     /* 389393 */     GIR_EraseRootFromParent_Done,
     /* 389394 */   // Label 7870: @389394
     /* 389394 */   GIM_Reject,
     /* 389395 */ // Label 7868: @389395
     /* 389395 */ GIM_Reject,
     /* 389396 */ // Label 7866: @389396
     /* 389396 */ GIM_Reject,
     /* 389397 */ // Label 127: @389397
     /* 389397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7880*/ GIMT_Encode4(391046),
     /* 389408 */ /*GILLT_s64*//*Label 7871*/ GIMT_Encode4(389492), GIMT_Encode4(0),
     /* 389416 */ /*GILLT_v2s32*//*Label 7872*/ GIMT_Encode4(389813),
     /* 389420 */ /*GILLT_v2s64*//*Label 7873*/ GIMT_Encode4(390134),
     /* 389424 */ /*GILLT_v4s16*//*Label 7874*/ GIMT_Encode4(390217),
     /* 389428 */ /*GILLT_v4s32*//*Label 7875*/ GIMT_Encode4(390538),
     /* 389432 */ /*GILLT_v8s8*//*Label 7876*/ GIMT_Encode4(390621),
     /* 389436 */ /*GILLT_v8s16*//*Label 7877*/ GIMT_Encode4(390830),
     /* 389440 */ /*GILLT_v16s8*//*Label 7878*/ GIMT_Encode4(390913), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 389488 */ /*GILLT_nxv16s8*//*Label 7879*/ GIMT_Encode4(390999),
     /* 389492 */ // Label 7871: @389492
     /* 389492 */ GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(389812),
     /* 389497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389507 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(389622), // Rule ID 5407 //
     /* 389512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 389520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389529 */     // MIs[1] Operand 2
     /* 389529 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 389540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 389548 */     // MIs[2] Rn
     /* 389548 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389553 */     // MIs[2] Operand 2
     /* 389553 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 389564 */     // MIs[0] imm
     /* 389564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 389568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389572 */     // MIs[3] Operand 1
     /* 389572 */     // No operand predicates
     /* 389572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389574 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 389574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 389581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 389597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 389611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389621 */     // GIR_Coverage, 5407,
     /* 389621 */     GIR_EraseRootFromParent_Done,
     /* 389622 */   // Label 7882: @389622
     /* 389622 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(389737), // Rule ID 5412 //
     /* 389627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 389635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389644 */     // MIs[1] Operand 2
     /* 389644 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 389655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 389663 */     // MIs[2] Rn
     /* 389663 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389668 */     // MIs[2] Operand 2
     /* 389668 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 389679 */     // MIs[0] imm
     /* 389679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 389683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389687 */     // MIs[3] Operand 1
     /* 389687 */     // No operand predicates
     /* 389687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389689 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 389689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 389696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 389712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389719 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 389726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389736 */     // GIR_Coverage, 5412,
     /* 389736 */     GIR_EraseRootFromParent_Done,
     /* 389737 */   // Label 7883: @389737
     /* 389737 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(389774), // Rule ID 5404 //
     /* 389742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389750 */     // MIs[0] imm
     /* 389750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 389754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389758 */     // MIs[1] Operand 1
     /* 389758 */     // No operand predicates
     /* 389758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389760 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 389760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 389763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 389769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 389772 */     GIR_RootConstrainSelectedInstOperands,
     /* 389773 */     // GIR_Coverage, 5404,
     /* 389773 */     GIR_EraseRootFromParent_Done,
     /* 389774 */   // Label 7884: @389774
     /* 389774 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(389811), // Rule ID 5409 //
     /* 389779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389787 */     // MIs[0] imm
     /* 389787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 389791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389795 */     // MIs[1] Operand 1
     /* 389795 */     // No operand predicates
     /* 389795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389797 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 389797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 389800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 389806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 389809 */     GIR_RootConstrainSelectedInstOperands,
     /* 389810 */     // GIR_Coverage, 5409,
     /* 389810 */     GIR_EraseRootFromParent_Done,
     /* 389811 */   // Label 7885: @389811
     /* 389811 */   GIM_Reject,
     /* 389812 */ // Label 7881: @389812
     /* 389812 */ GIM_Reject,
     /* 389813 */ // Label 7872: @389813
     /* 389813 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(390133),
     /* 389818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 389824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389828 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(389943), // Rule ID 5397 //
     /* 389833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 389841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389850 */     // MIs[1] Operand 2
     /* 389850 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 389861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 389869 */     // MIs[2] Rn
     /* 389869 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389874 */     // MIs[2] Operand 2
     /* 389874 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 389885 */     // MIs[0] imm
     /* 389885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 389889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389893 */     // MIs[3] Operand 1
     /* 389893 */     // No operand predicates
     /* 389893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389895 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 389895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 389902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 389918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 389932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389942 */     // GIR_Coverage, 5397,
     /* 389942 */     GIR_EraseRootFromParent_Done,
     /* 389943 */   // Label 7887: @389943
     /* 389943 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(390058), // Rule ID 5402 //
     /* 389948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 389956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389965 */     // MIs[1] Operand 2
     /* 389965 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 389976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 389984 */     // MIs[2] Rn
     /* 389984 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389989 */     // MIs[2] Operand 2
     /* 389989 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 390000 */     // MIs[0] imm
     /* 390000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 390004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390008 */     // MIs[3] Operand 1
     /* 390008 */     // No operand predicates
     /* 390008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390010 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 390010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 390033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 390047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390057 */     // GIR_Coverage, 5402,
     /* 390057 */     GIR_EraseRootFromParent_Done,
     /* 390058 */   // Label 7888: @390058
     /* 390058 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(390095), // Rule ID 5394 //
     /* 390063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390071 */     // MIs[0] imm
     /* 390071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390079 */     // MIs[1] Operand 1
     /* 390079 */     // No operand predicates
     /* 390079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390081 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 390084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390093 */     GIR_RootConstrainSelectedInstOperands,
     /* 390094 */     // GIR_Coverage, 5394,
     /* 390094 */     GIR_EraseRootFromParent_Done,
     /* 390095 */   // Label 7889: @390095
     /* 390095 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(390132), // Rule ID 5399 //
     /* 390100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390108 */     // MIs[0] imm
     /* 390108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390116 */     // MIs[1] Operand 1
     /* 390116 */     // No operand predicates
     /* 390116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390118 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 390121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390130 */     GIR_RootConstrainSelectedInstOperands,
     /* 390131 */     // GIR_Coverage, 5399,
     /* 390131 */     GIR_EraseRootFromParent_Done,
     /* 390132 */   // Label 7890: @390132
     /* 390132 */   GIM_Reject,
     /* 390133 */ // Label 7886: @390133
     /* 390133 */ GIM_Reject,
     /* 390134 */ // Label 7873: @390134
     /* 390134 */ GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(390216),
     /* 390139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 390145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390157 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(390186), // Rule ID 5405 //
     /* 390162 */     // MIs[0] imm
     /* 390162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390170 */     // MIs[1] Operand 1
     /* 390170 */     // No operand predicates
     /* 390170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390172 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390184 */     GIR_RootConstrainSelectedInstOperands,
     /* 390185 */     // GIR_Coverage, 5405,
     /* 390185 */     GIR_EraseRootFromParent_Done,
     /* 390186 */   // Label 7892: @390186
     /* 390186 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(390215), // Rule ID 5410 //
     /* 390191 */     // MIs[0] imm
     /* 390191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390199 */     // MIs[1] Operand 1
     /* 390199 */     // No operand predicates
     /* 390199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390201 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390213 */     GIR_RootConstrainSelectedInstOperands,
     /* 390214 */     // GIR_Coverage, 5410,
     /* 390214 */     GIR_EraseRootFromParent_Done,
     /* 390215 */   // Label 7893: @390215
     /* 390215 */   GIM_Reject,
     /* 390216 */ // Label 7891: @390216
     /* 390216 */ GIM_Reject,
     /* 390217 */ // Label 7874: @390217
     /* 390217 */ GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(390537),
     /* 390222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 390228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390232 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(390347), // Rule ID 5387 //
     /* 390237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 390245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390254 */     // MIs[1] Operand 2
     /* 390254 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 390265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 390273 */     // MIs[2] Rn
     /* 390273 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390278 */     // MIs[2] Operand 2
     /* 390278 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 390289 */     // MIs[0] imm
     /* 390289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 390293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390297 */     // MIs[3] Operand 1
     /* 390297 */     // No operand predicates
     /* 390297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390299 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 390299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 390322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390329 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 390336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390346 */     // GIR_Coverage, 5387,
     /* 390346 */     GIR_EraseRootFromParent_Done,
     /* 390347 */   // Label 7895: @390347
     /* 390347 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(390462), // Rule ID 5392 //
     /* 390352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 390360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390369 */     // MIs[1] Operand 2
     /* 390369 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 390380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 390388 */     // MIs[2] Rn
     /* 390388 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390393 */     // MIs[2] Operand 2
     /* 390393 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 390404 */     // MIs[0] imm
     /* 390404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 390408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390412 */     // MIs[3] Operand 1
     /* 390412 */     // No operand predicates
     /* 390412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390414 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 390414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 390437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390444 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 390451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390461 */     // GIR_Coverage, 5392,
     /* 390461 */     GIR_EraseRootFromParent_Done,
     /* 390462 */   // Label 7896: @390462
     /* 390462 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(390499), // Rule ID 5384 //
     /* 390467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390475 */     // MIs[0] imm
     /* 390475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390483 */     // MIs[1] Operand 1
     /* 390483 */     // No operand predicates
     /* 390483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390485 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 390488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390497 */     GIR_RootConstrainSelectedInstOperands,
     /* 390498 */     // GIR_Coverage, 5384,
     /* 390498 */     GIR_EraseRootFromParent_Done,
     /* 390499 */   // Label 7897: @390499
     /* 390499 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(390536), // Rule ID 5389 //
     /* 390504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390512 */     // MIs[0] imm
     /* 390512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390520 */     // MIs[1] Operand 1
     /* 390520 */     // No operand predicates
     /* 390520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390522 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 390525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390534 */     GIR_RootConstrainSelectedInstOperands,
     /* 390535 */     // GIR_Coverage, 5389,
     /* 390535 */     GIR_EraseRootFromParent_Done,
     /* 390536 */   // Label 7898: @390536
     /* 390536 */   GIM_Reject,
     /* 390537 */ // Label 7894: @390537
     /* 390537 */ GIM_Reject,
     /* 390538 */ // Label 7875: @390538
     /* 390538 */ GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(390620),
     /* 390543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 390549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390561 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(390590), // Rule ID 5395 //
     /* 390566 */     // MIs[0] imm
     /* 390566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390574 */     // MIs[1] Operand 1
     /* 390574 */     // No operand predicates
     /* 390574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390576 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390588 */     GIR_RootConstrainSelectedInstOperands,
     /* 390589 */     // GIR_Coverage, 5395,
     /* 390589 */     GIR_EraseRootFromParent_Done,
     /* 390590 */   // Label 7900: @390590
     /* 390590 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(390619), // Rule ID 5400 //
     /* 390595 */     // MIs[0] imm
     /* 390595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390603 */     // MIs[1] Operand 1
     /* 390603 */     // No operand predicates
     /* 390603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390605 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390617 */     GIR_RootConstrainSelectedInstOperands,
     /* 390618 */     // GIR_Coverage, 5400,
     /* 390618 */     GIR_EraseRootFromParent_Done,
     /* 390619 */   // Label 7901: @390619
     /* 390619 */   GIM_Reject,
     /* 390620 */ // Label 7899: @390620
     /* 390620 */ GIM_Reject,
     /* 390621 */ // Label 7876: @390621
     /* 390621 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(390829),
     /* 390626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 390629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 390632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390636 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(390751), // Rule ID 5382 //
     /* 390641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 390649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 390653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390658 */     // MIs[1] Operand 2
     /* 390658 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 390669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 390677 */     // MIs[2] Rn
     /* 390677 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390682 */     // MIs[2] Operand 2
     /* 390682 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 390693 */     // MIs[0] imm
     /* 390693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 390697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390701 */     // MIs[3] Operand 1
     /* 390701 */     // No operand predicates
     /* 390701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390703 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 390703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 390726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 390740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390750 */     // GIR_Coverage, 5382,
     /* 390750 */     GIR_EraseRootFromParent_Done,
     /* 390751 */   // Label 7903: @390751
     /* 390751 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(390791), // Rule ID 1861 //
     /* 390756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390767 */     // MIs[0] imm
     /* 390767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390775 */     // MIs[1] Operand 1
     /* 390775 */     // No operand predicates
     /* 390775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390777 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 390780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390789 */     GIR_RootConstrainSelectedInstOperands,
     /* 390790 */     // GIR_Coverage, 1861,
     /* 390790 */     GIR_EraseRootFromParent_Done,
     /* 390791 */   // Label 7904: @390791
     /* 390791 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(390828), // Rule ID 5379 //
     /* 390796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390804 */     // MIs[0] imm
     /* 390804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390812 */     // MIs[1] Operand 1
     /* 390812 */     // No operand predicates
     /* 390812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390814 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 390817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390826 */     GIR_RootConstrainSelectedInstOperands,
     /* 390827 */     // GIR_Coverage, 5379,
     /* 390827 */     GIR_EraseRootFromParent_Done,
     /* 390828 */   // Label 7905: @390828
     /* 390828 */   GIM_Reject,
     /* 390829 */ // Label 7902: @390829
     /* 390829 */ GIM_Reject,
     /* 390830 */ // Label 7877: @390830
     /* 390830 */ GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(390912),
     /* 390835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 390841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390853 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(390882), // Rule ID 5385 //
     /* 390858 */     // MIs[0] imm
     /* 390858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390866 */     // MIs[1] Operand 1
     /* 390866 */     // No operand predicates
     /* 390866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390868 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390880 */     GIR_RootConstrainSelectedInstOperands,
     /* 390881 */     // GIR_Coverage, 5385,
     /* 390881 */     GIR_EraseRootFromParent_Done,
     /* 390882 */   // Label 7907: @390882
     /* 390882 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(390911), // Rule ID 5390 //
     /* 390887 */     // MIs[0] imm
     /* 390887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390895 */     // MIs[1] Operand 1
     /* 390895 */     // No operand predicates
     /* 390895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390897 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390909 */     GIR_RootConstrainSelectedInstOperands,
     /* 390910 */     // GIR_Coverage, 5390,
     /* 390910 */     GIR_EraseRootFromParent_Done,
     /* 390911 */   // Label 7908: @390911
     /* 390911 */   GIM_Reject,
     /* 390912 */ // Label 7906: @390912
     /* 390912 */ GIM_Reject,
     /* 390913 */ // Label 7878: @390913
     /* 390913 */ GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(390998),
     /* 390918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 390921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 390924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390936 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(390968), // Rule ID 1862 //
     /* 390941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390944 */     // MIs[0] imm
     /* 390944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390952 */     // MIs[1] Operand 1
     /* 390952 */     // No operand predicates
     /* 390952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390954 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390966 */     GIR_RootConstrainSelectedInstOperands,
     /* 390967 */     // GIR_Coverage, 1862,
     /* 390967 */     GIR_EraseRootFromParent_Done,
     /* 390968 */   // Label 7910: @390968
     /* 390968 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(390997), // Rule ID 5380 //
     /* 390973 */     // MIs[0] imm
     /* 390973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 390977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390981 */     // MIs[1] Operand 1
     /* 390981 */     // No operand predicates
     /* 390981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390983 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 390983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 390986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 390992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 390995 */     GIR_RootConstrainSelectedInstOperands,
     /* 390996 */     // GIR_Coverage, 5380,
     /* 390996 */     GIR_EraseRootFromParent_Done,
     /* 390997 */   // Label 7911: @390997
     /* 390997 */   GIM_Reject,
     /* 390998 */ // Label 7909: @390998
     /* 390998 */ GIM_Reject,
     /* 390999 */ // Label 7879: @390999
     /* 390999 */ GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(391045), // Rule ID 2724 //
     /* 391004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 391010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 391013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391017 */   // MIs[0] Op3
     /* 391017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 391021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391025 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 391029 */   // MIs[1] Operand 1
     /* 391029 */   // No operand predicates
     /* 391029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391031 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 391031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 391034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 391036 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 391038 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 391040 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 391043 */   GIR_RootConstrainSelectedInstOperands,
     /* 391044 */   // GIR_Coverage, 2724,
     /* 391044 */   GIR_EraseRootFromParent_Done,
     /* 391045 */ // Label 7912: @391045
     /* 391045 */ GIM_Reject,
     /* 391046 */ // Label 7880: @391046
     /* 391046 */ GIM_Reject,
     /* 391047 */ // Label 128: @391047
     /* 391047 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7920*/ GIMT_Encode4(391385),
     /* 391058 */ /*GILLT_s32*//*Label 7913*/ GIMT_Encode4(391094),
     /* 391062 */ /*GILLT_s64*//*Label 7914*/ GIMT_Encode4(391132), GIMT_Encode4(0),
     /* 391070 */ /*GILLT_v2s32*//*Label 7915*/ GIMT_Encode4(391195),
     /* 391074 */ /*GILLT_v2s64*//*Label 7916*/ GIMT_Encode4(391233),
     /* 391078 */ /*GILLT_v4s16*//*Label 7917*/ GIMT_Encode4(391271),
     /* 391082 */ /*GILLT_v4s32*//*Label 7918*/ GIMT_Encode4(391309), GIMT_Encode4(0),
     /* 391090 */ /*GILLT_v8s16*//*Label 7919*/ GIMT_Encode4(391347),
     /* 391094 */ // Label 7913: @391094
     /* 391094 */ GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(391131), // Rule ID 1615 //
     /* 391099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 391108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391120 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 391120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 391125 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391129 */   GIR_RootConstrainSelectedInstOperands,
     /* 391130 */   // GIR_Coverage, 1615,
     /* 391130 */   GIR_Done,
     /* 391131 */ // Label 7921: @391131
     /* 391131 */ GIM_Reject,
     /* 391132 */ // Label 7914: @391132
     /* 391132 */ GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(391194),
     /* 391137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 391143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391155 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(391174), // Rule ID 1614 //
     /* 391160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391163 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 391163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 391168 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391172 */     GIR_RootConstrainSelectedInstOperands,
     /* 391173 */     // GIR_Coverage, 1614,
     /* 391173 */     GIR_Done,
     /* 391174 */   // Label 7923: @391174
     /* 391174 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(391193), // Rule ID 5160 //
     /* 391179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391182 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 391182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 391187 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391191 */     GIR_RootConstrainSelectedInstOperands,
     /* 391192 */     // GIR_Coverage, 5160,
     /* 391192 */     GIR_Done,
     /* 391193 */   // Label 7924: @391193
     /* 391193 */   GIM_Reject,
     /* 391194 */ // Label 7922: @391194
     /* 391194 */ GIM_Reject,
     /* 391195 */ // Label 7915: @391195
     /* 391195 */ GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(391232), // Rule ID 1203 //
     /* 391200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 391209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391221 */   // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 391221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 391226 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391230 */   GIR_RootConstrainSelectedInstOperands,
     /* 391231 */   // GIR_Coverage, 1203,
     /* 391231 */   GIR_Done,
     /* 391232 */ // Label 7925: @391232
     /* 391232 */ GIM_Reject,
     /* 391233 */ // Label 7916: @391233
     /* 391233 */ GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(391270), // Rule ID 1205 //
     /* 391238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 391247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391259 */   // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 391259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 391264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391268 */   GIR_RootConstrainSelectedInstOperands,
     /* 391269 */   // GIR_Coverage, 1205,
     /* 391269 */   GIR_Done,
     /* 391270 */ // Label 7926: @391270
     /* 391270 */ GIM_Reject,
     /* 391271 */ // Label 7917: @391271
     /* 391271 */ GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(391308), // Rule ID 1201 //
     /* 391276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 391285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391297 */   // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 391297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 391302 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391306 */   GIR_RootConstrainSelectedInstOperands,
     /* 391307 */   // GIR_Coverage, 1201,
     /* 391307 */   GIR_Done,
     /* 391308 */ // Label 7927: @391308
     /* 391308 */ GIM_Reject,
     /* 391309 */ // Label 7918: @391309
     /* 391309 */ GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(391346), // Rule ID 1204 //
     /* 391314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 391323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391335 */   // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 391335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 391340 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391344 */   GIR_RootConstrainSelectedInstOperands,
     /* 391345 */   // GIR_Coverage, 1204,
     /* 391345 */   GIR_Done,
     /* 391346 */ // Label 7928: @391346
     /* 391346 */ GIM_Reject,
     /* 391347 */ // Label 7919: @391347
     /* 391347 */ GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(391384), // Rule ID 1202 //
     /* 391352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 391361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391373 */   // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 391373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 391378 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391382 */   GIR_RootConstrainSelectedInstOperands,
     /* 391383 */   // GIR_Coverage, 1202,
     /* 391383 */   GIR_Done,
     /* 391384 */ // Label 7929: @391384
     /* 391384 */ GIM_Reject,
     /* 391385 */ // Label 7920: @391385
     /* 391385 */ GIM_Reject,
     /* 391386 */ // Label 129: @391386
     /* 391386 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7936*/ GIMT_Encode4(391615),
     /* 391397 */ /*GILLT_s64*//*Label 7930*/ GIMT_Encode4(391429), GIMT_Encode4(0),
     /* 391405 */ /*GILLT_v2s32*//*Label 7931*/ GIMT_Encode4(391460),
     /* 391409 */ /*GILLT_v2s64*//*Label 7932*/ GIMT_Encode4(391491),
     /* 391413 */ /*GILLT_v4s16*//*Label 7933*/ GIMT_Encode4(391522),
     /* 391417 */ /*GILLT_v4s32*//*Label 7934*/ GIMT_Encode4(391553), GIMT_Encode4(0),
     /* 391425 */ /*GILLT_v8s16*//*Label 7935*/ GIMT_Encode4(391584),
     /* 391429 */ // Label 7930: @391429
     /* 391429 */ GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(391459), // Rule ID 2504 //
     /* 391434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391448 */   // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 391448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 391453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391457 */   GIR_RootConstrainSelectedInstOperands,
     /* 391458 */   // GIR_Coverage, 2504,
     /* 391458 */   GIR_Done,
     /* 391459 */ // Label 7937: @391459
     /* 391459 */ GIM_Reject,
     /* 391460 */ // Label 7931: @391460
     /* 391460 */ GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(391490), // Rule ID 766 //
     /* 391465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391479 */   // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 391479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 391484 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391488 */   GIR_RootConstrainSelectedInstOperands,
     /* 391489 */   // GIR_Coverage, 766,
     /* 391489 */   GIR_Done,
     /* 391490 */ // Label 7938: @391490
     /* 391490 */ GIM_Reject,
     /* 391491 */ // Label 7932: @391491
     /* 391491 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(391521), // Rule ID 768 //
     /* 391496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391510 */   // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 391510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 391515 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391519 */   GIR_RootConstrainSelectedInstOperands,
     /* 391520 */   // GIR_Coverage, 768,
     /* 391520 */   GIR_Done,
     /* 391521 */ // Label 7939: @391521
     /* 391521 */ GIM_Reject,
     /* 391522 */ // Label 7933: @391522
     /* 391522 */ GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(391552), // Rule ID 764 //
     /* 391527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391541 */   // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 391541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 391546 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391550 */   GIR_RootConstrainSelectedInstOperands,
     /* 391551 */   // GIR_Coverage, 764,
     /* 391551 */   GIR_Done,
     /* 391552 */ // Label 7940: @391552
     /* 391552 */ GIM_Reject,
     /* 391553 */ // Label 7934: @391553
     /* 391553 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(391583), // Rule ID 767 //
     /* 391558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391572 */   // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 391572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 391577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391581 */   GIR_RootConstrainSelectedInstOperands,
     /* 391582 */   // GIR_Coverage, 767,
     /* 391582 */   GIR_Done,
     /* 391583 */ // Label 7941: @391583
     /* 391583 */ GIM_Reject,
     /* 391584 */ // Label 7935: @391584
     /* 391584 */ GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(391614), // Rule ID 765 //
     /* 391589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391603 */   // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 391603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 391608 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391612 */   GIR_RootConstrainSelectedInstOperands,
     /* 391613 */   // GIR_Coverage, 765,
     /* 391613 */   GIR_Done,
     /* 391614 */ // Label 7942: @391614
     /* 391614 */ GIM_Reject,
     /* 391615 */ // Label 7936: @391615
     /* 391615 */ GIM_Reject,
     /* 391616 */ // Label 130: @391616
     /* 391616 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7950*/ GIMT_Encode4(392279),
     /* 391627 */ /*GILLT_s32*//*Label 7943*/ GIMT_Encode4(391663),
     /* 391631 */ /*GILLT_s64*//*Label 7944*/ GIMT_Encode4(391701), GIMT_Encode4(0),
     /* 391639 */ /*GILLT_v2s32*//*Label 7945*/ GIMT_Encode4(391764),
     /* 391643 */ /*GILLT_v2s64*//*Label 7946*/ GIMT_Encode4(391867),
     /* 391647 */ /*GILLT_v4s16*//*Label 7947*/ GIMT_Encode4(391970),
     /* 391651 */ /*GILLT_v4s32*//*Label 7948*/ GIMT_Encode4(392073), GIMT_Encode4(0),
     /* 391659 */ /*GILLT_v8s16*//*Label 7949*/ GIMT_Encode4(392176),
     /* 391663 */ // Label 7943: @391663
     /* 391663 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(391700), // Rule ID 1617 //
     /* 391668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 391677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391689 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 391689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 391694 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391698 */   GIR_RootConstrainSelectedInstOperands,
     /* 391699 */   // GIR_Coverage, 1617,
     /* 391699 */   GIR_Done,
     /* 391700 */ // Label 7951: @391700
     /* 391700 */ GIM_Reject,
     /* 391701 */ // Label 7944: @391701
     /* 391701 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(391763),
     /* 391706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 391712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391724 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(391743), // Rule ID 1616 //
     /* 391729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391732 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 391732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 391737 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391741 */     GIR_RootConstrainSelectedInstOperands,
     /* 391742 */     // GIR_Coverage, 1616,
     /* 391742 */     GIR_Done,
     /* 391743 */   // Label 7953: @391743
     /* 391743 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(391762), // Rule ID 5161 //
     /* 391748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391751 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 391751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 391756 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391760 */     GIR_RootConstrainSelectedInstOperands,
     /* 391761 */     // GIR_Coverage, 5161,
     /* 391761 */     GIR_Done,
     /* 391762 */   // Label 7954: @391762
     /* 391762 */   GIM_Reject,
     /* 391763 */ // Label 7952: @391763
     /* 391763 */ GIM_Reject,
     /* 391764 */ // Label 7945: @391764
     /* 391764 */ GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(391866),
     /* 391769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 391775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391779 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(391838), // Rule ID 1165 //
     /* 391784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 391795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 391812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391823 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 391823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 391826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391836 */     GIR_RootConstrainSelectedInstOperands,
     /* 391837 */     // GIR_Coverage, 1165,
     /* 391837 */     GIR_EraseRootFromParent_Done,
     /* 391838 */   // Label 7956: @391838
     /* 391838 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(391865), // Rule ID 1208 //
     /* 391843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391854 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 391854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 391859 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391863 */     GIR_RootConstrainSelectedInstOperands,
     /* 391864 */     // GIR_Coverage, 1208,
     /* 391864 */     GIR_Done,
     /* 391865 */   // Label 7957: @391865
     /* 391865 */   GIM_Reject,
     /* 391866 */ // Label 7955: @391866
     /* 391866 */ GIM_Reject,
     /* 391867 */ // Label 7946: @391867
     /* 391867 */ GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(391969),
     /* 391872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 391878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391882 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(391941), // Rule ID 1169 //
     /* 391887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 391898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 391915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391926 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 391926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 391929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391939 */     GIR_RootConstrainSelectedInstOperands,
     /* 391940 */     // GIR_Coverage, 1169,
     /* 391940 */     GIR_EraseRootFromParent_Done,
     /* 391941 */   // Label 7959: @391941
     /* 391941 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(391968), // Rule ID 1210 //
     /* 391946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391957 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 391957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 391962 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391966 */     GIR_RootConstrainSelectedInstOperands,
     /* 391967 */     // GIR_Coverage, 1210,
     /* 391967 */     GIR_Done,
     /* 391968 */   // Label 7960: @391968
     /* 391968 */   GIM_Reject,
     /* 391969 */ // Label 7958: @391969
     /* 391969 */ GIM_Reject,
     /* 391970 */ // Label 7947: @391970
     /* 391970 */ GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(392072),
     /* 391975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 391981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391985 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(392044), // Rule ID 1161 //
     /* 391990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392029 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 392029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 392032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392042 */     GIR_RootConstrainSelectedInstOperands,
     /* 392043 */     // GIR_Coverage, 1161,
     /* 392043 */     GIR_EraseRootFromParent_Done,
     /* 392044 */   // Label 7962: @392044
     /* 392044 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(392071), // Rule ID 1206 //
     /* 392049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392060 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 392060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 392065 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392069 */     GIR_RootConstrainSelectedInstOperands,
     /* 392070 */     // GIR_Coverage, 1206,
     /* 392070 */     GIR_Done,
     /* 392071 */   // Label 7963: @392071
     /* 392071 */   GIM_Reject,
     /* 392072 */ // Label 7961: @392072
     /* 392072 */ GIM_Reject,
     /* 392073 */ // Label 7948: @392073
     /* 392073 */ GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(392175),
     /* 392078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 392084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392088 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(392147), // Rule ID 1167 //
     /* 392093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392132 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 392132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 392135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392145 */     GIR_RootConstrainSelectedInstOperands,
     /* 392146 */     // GIR_Coverage, 1167,
     /* 392146 */     GIR_EraseRootFromParent_Done,
     /* 392147 */   // Label 7965: @392147
     /* 392147 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(392174), // Rule ID 1209 //
     /* 392152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392163 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 392163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 392168 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392172 */     GIR_RootConstrainSelectedInstOperands,
     /* 392173 */     // GIR_Coverage, 1209,
     /* 392173 */     GIR_Done,
     /* 392174 */   // Label 7966: @392174
     /* 392174 */   GIM_Reject,
     /* 392175 */ // Label 7964: @392175
     /* 392175 */ GIM_Reject,
     /* 392176 */ // Label 7949: @392176
     /* 392176 */ GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(392278),
     /* 392181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 392187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392191 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(392250), // Rule ID 1163 //
     /* 392196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392235 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 392235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 392238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392248 */     GIR_RootConstrainSelectedInstOperands,
     /* 392249 */     // GIR_Coverage, 1163,
     /* 392249 */     GIR_EraseRootFromParent_Done,
     /* 392250 */   // Label 7968: @392250
     /* 392250 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(392277), // Rule ID 1207 //
     /* 392255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392266 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 392266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 392271 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392275 */     GIR_RootConstrainSelectedInstOperands,
     /* 392276 */     // GIR_Coverage, 1207,
     /* 392276 */     GIR_Done,
     /* 392277 */   // Label 7969: @392277
     /* 392277 */   GIM_Reject,
     /* 392278 */ // Label 7967: @392278
     /* 392278 */ GIM_Reject,
     /* 392279 */ // Label 7950: @392279
     /* 392279 */ GIM_Reject,
     /* 392280 */ // Label 131: @392280
     /* 392280 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7976*/ GIMT_Encode4(392509),
     /* 392291 */ /*GILLT_s64*//*Label 7970*/ GIMT_Encode4(392323), GIMT_Encode4(0),
     /* 392299 */ /*GILLT_v2s32*//*Label 7971*/ GIMT_Encode4(392354),
     /* 392303 */ /*GILLT_v2s64*//*Label 7972*/ GIMT_Encode4(392385),
     /* 392307 */ /*GILLT_v4s16*//*Label 7973*/ GIMT_Encode4(392416),
     /* 392311 */ /*GILLT_v4s32*//*Label 7974*/ GIMT_Encode4(392447), GIMT_Encode4(0),
     /* 392319 */ /*GILLT_v8s16*//*Label 7975*/ GIMT_Encode4(392478),
     /* 392323 */ // Label 7970: @392323
     /* 392323 */ GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(392353), // Rule ID 5191 //
     /* 392328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392342 */   // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 392342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 392347 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392351 */   GIR_RootConstrainSelectedInstOperands,
     /* 392352 */   // GIR_Coverage, 5191,
     /* 392352 */   GIR_Done,
     /* 392353 */ // Label 7977: @392353
     /* 392353 */ GIM_Reject,
     /* 392354 */ // Label 7971: @392354
     /* 392354 */ GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(392384), // Rule ID 771 //
     /* 392359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392373 */   // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 392373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 392378 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392382 */   GIR_RootConstrainSelectedInstOperands,
     /* 392383 */   // GIR_Coverage, 771,
     /* 392383 */   GIR_Done,
     /* 392384 */ // Label 7978: @392384
     /* 392384 */ GIM_Reject,
     /* 392385 */ // Label 7972: @392385
     /* 392385 */ GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(392415), // Rule ID 773 //
     /* 392390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392404 */   // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 392404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 392409 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392413 */   GIR_RootConstrainSelectedInstOperands,
     /* 392414 */   // GIR_Coverage, 773,
     /* 392414 */   GIR_Done,
     /* 392415 */ // Label 7979: @392415
     /* 392415 */ GIM_Reject,
     /* 392416 */ // Label 7973: @392416
     /* 392416 */ GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(392446), // Rule ID 769 //
     /* 392421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392435 */   // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 392435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 392440 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392444 */   GIR_RootConstrainSelectedInstOperands,
     /* 392445 */   // GIR_Coverage, 769,
     /* 392445 */   GIR_Done,
     /* 392446 */ // Label 7980: @392446
     /* 392446 */ GIM_Reject,
     /* 392447 */ // Label 7974: @392447
     /* 392447 */ GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(392477), // Rule ID 772 //
     /* 392452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392466 */   // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 392466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 392471 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392475 */   GIR_RootConstrainSelectedInstOperands,
     /* 392476 */   // GIR_Coverage, 772,
     /* 392476 */   GIR_Done,
     /* 392477 */ // Label 7981: @392477
     /* 392477 */ GIM_Reject,
     /* 392478 */ // Label 7975: @392478
     /* 392478 */ GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(392508), // Rule ID 770 //
     /* 392483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392497 */   // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 392497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 392502 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392506 */   GIR_RootConstrainSelectedInstOperands,
     /* 392507 */   // GIR_Coverage, 770,
     /* 392507 */   GIR_Done,
     /* 392508 */ // Label 7982: @392508
     /* 392508 */ GIM_Reject,
     /* 392509 */ // Label 7976: @392509
     /* 392509 */ GIM_Reject,
     /* 392510 */ // Label 132: @392510
     /* 392510 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7990*/ GIMT_Encode4(393173),
     /* 392521 */ /*GILLT_s32*//*Label 7983*/ GIMT_Encode4(392557),
     /* 392525 */ /*GILLT_s64*//*Label 7984*/ GIMT_Encode4(392595), GIMT_Encode4(0),
     /* 392533 */ /*GILLT_v2s32*//*Label 7985*/ GIMT_Encode4(392658),
     /* 392537 */ /*GILLT_v2s64*//*Label 7986*/ GIMT_Encode4(392761),
     /* 392541 */ /*GILLT_v4s16*//*Label 7987*/ GIMT_Encode4(392864),
     /* 392545 */ /*GILLT_v4s32*//*Label 7988*/ GIMT_Encode4(392967), GIMT_Encode4(0),
     /* 392553 */ /*GILLT_v8s16*//*Label 7989*/ GIMT_Encode4(393070),
     /* 392557 */ // Label 7983: @392557
     /* 392557 */ GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(392594), // Rule ID 1619 //
     /* 392562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 392571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392583 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 392583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 392588 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392592 */   GIR_RootConstrainSelectedInstOperands,
     /* 392593 */   // GIR_Coverage, 1619,
     /* 392593 */   GIR_Done,
     /* 392594 */ // Label 7991: @392594
     /* 392594 */ GIM_Reject,
     /* 392595 */ // Label 7984: @392595
     /* 392595 */ GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(392657),
     /* 392600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 392606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392618 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(392637), // Rule ID 1618 //
     /* 392623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392626 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 392626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 392631 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392635 */     GIR_RootConstrainSelectedInstOperands,
     /* 392636 */     // GIR_Coverage, 1618,
     /* 392636 */     GIR_Done,
     /* 392637 */   // Label 7993: @392637
     /* 392637 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(392656), // Rule ID 5162 //
     /* 392642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392645 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 392645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 392650 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392654 */     GIR_RootConstrainSelectedInstOperands,
     /* 392655 */     // GIR_Coverage, 5162,
     /* 392655 */     GIR_Done,
     /* 392656 */   // Label 7994: @392656
     /* 392656 */   GIM_Reject,
     /* 392657 */ // Label 7992: @392657
     /* 392657 */ GIM_Reject,
     /* 392658 */ // Label 7985: @392658
     /* 392658 */ GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(392760),
     /* 392663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 392669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392673 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(392732), // Rule ID 1175 //
     /* 392678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392717 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 392717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 392720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392730 */     GIR_RootConstrainSelectedInstOperands,
     /* 392731 */     // GIR_Coverage, 1175,
     /* 392731 */     GIR_EraseRootFromParent_Done,
     /* 392732 */   // Label 7996: @392732
     /* 392732 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(392759), // Rule ID 1213 //
     /* 392737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392748 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 392748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 392753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392757 */     GIR_RootConstrainSelectedInstOperands,
     /* 392758 */     // GIR_Coverage, 1213,
     /* 392758 */     GIR_Done,
     /* 392759 */   // Label 7997: @392759
     /* 392759 */   GIM_Reject,
     /* 392760 */ // Label 7995: @392760
     /* 392760 */ GIM_Reject,
     /* 392761 */ // Label 7986: @392761
     /* 392761 */ GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(392863),
     /* 392766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 392772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392776 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(392835), // Rule ID 1179 //
     /* 392781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392820 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 392820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 392823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392833 */     GIR_RootConstrainSelectedInstOperands,
     /* 392834 */     // GIR_Coverage, 1179,
     /* 392834 */     GIR_EraseRootFromParent_Done,
     /* 392835 */   // Label 7999: @392835
     /* 392835 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(392862), // Rule ID 1215 //
     /* 392840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392851 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 392851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 392856 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392860 */     GIR_RootConstrainSelectedInstOperands,
     /* 392861 */     // GIR_Coverage, 1215,
     /* 392861 */     GIR_Done,
     /* 392862 */   // Label 8000: @392862
     /* 392862 */   GIM_Reject,
     /* 392863 */ // Label 7998: @392863
     /* 392863 */ GIM_Reject,
     /* 392864 */ // Label 7987: @392864
     /* 392864 */ GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(392966),
     /* 392869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 392875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392879 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(392938), // Rule ID 1171 //
     /* 392884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392923 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 392923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 392926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392936 */     GIR_RootConstrainSelectedInstOperands,
     /* 392937 */     // GIR_Coverage, 1171,
     /* 392937 */     GIR_EraseRootFromParent_Done,
     /* 392938 */   // Label 8002: @392938
     /* 392938 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(392965), // Rule ID 1211 //
     /* 392943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392954 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 392954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 392959 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392963 */     GIR_RootConstrainSelectedInstOperands,
     /* 392964 */     // GIR_Coverage, 1211,
     /* 392964 */     GIR_Done,
     /* 392965 */   // Label 8003: @392965
     /* 392965 */   GIM_Reject,
     /* 392966 */ // Label 8001: @392966
     /* 392966 */ GIM_Reject,
     /* 392967 */ // Label 7988: @392967
     /* 392967 */ GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(393069),
     /* 392972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 392978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392982 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(393041), // Rule ID 1177 //
     /* 392987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 392998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 393015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393026 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 393026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 393029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393039 */     GIR_RootConstrainSelectedInstOperands,
     /* 393040 */     // GIR_Coverage, 1177,
     /* 393040 */     GIR_EraseRootFromParent_Done,
     /* 393041 */   // Label 8005: @393041
     /* 393041 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(393068), // Rule ID 1214 //
     /* 393046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393057 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 393057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 393062 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393066 */     GIR_RootConstrainSelectedInstOperands,
     /* 393067 */     // GIR_Coverage, 1214,
     /* 393067 */     GIR_Done,
     /* 393068 */   // Label 8006: @393068
     /* 393068 */   GIM_Reject,
     /* 393069 */ // Label 8004: @393069
     /* 393069 */ GIM_Reject,
     /* 393070 */ // Label 7989: @393070
     /* 393070 */ GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(393172),
     /* 393075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 393081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393085 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(393144), // Rule ID 1173 //
     /* 393090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 393101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 393118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393129 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 393129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 393132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393142 */     GIR_RootConstrainSelectedInstOperands,
     /* 393143 */     // GIR_Coverage, 1173,
     /* 393143 */     GIR_EraseRootFromParent_Done,
     /* 393144 */   // Label 8008: @393144
     /* 393144 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(393171), // Rule ID 1212 //
     /* 393149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393160 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 393160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 393165 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393169 */     GIR_RootConstrainSelectedInstOperands,
     /* 393170 */     // GIR_Coverage, 1212,
     /* 393170 */     GIR_Done,
     /* 393171 */   // Label 8009: @393171
     /* 393171 */   GIM_Reject,
     /* 393172 */ // Label 8007: @393172
     /* 393172 */ GIM_Reject,
     /* 393173 */ // Label 7990: @393173
     /* 393173 */ GIM_Reject,
     /* 393174 */ // Label 133: @393174
     /* 393174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8016*/ GIMT_Encode4(393403),
     /* 393185 */ /*GILLT_s64*//*Label 8010*/ GIMT_Encode4(393217), GIMT_Encode4(0),
     /* 393193 */ /*GILLT_v2s32*//*Label 8011*/ GIMT_Encode4(393248),
     /* 393197 */ /*GILLT_v2s64*//*Label 8012*/ GIMT_Encode4(393279),
     /* 393201 */ /*GILLT_v4s16*//*Label 8013*/ GIMT_Encode4(393310),
     /* 393205 */ /*GILLT_v4s32*//*Label 8014*/ GIMT_Encode4(393341), GIMT_Encode4(0),
     /* 393213 */ /*GILLT_v8s16*//*Label 8015*/ GIMT_Encode4(393372),
     /* 393217 */ // Label 8010: @393217
     /* 393217 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(393247), // Rule ID 5192 //
     /* 393222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393236 */   // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 393236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 393241 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393245 */   GIR_RootConstrainSelectedInstOperands,
     /* 393246 */   // GIR_Coverage, 5192,
     /* 393246 */   GIR_Done,
     /* 393247 */ // Label 8017: @393247
     /* 393247 */ GIM_Reject,
     /* 393248 */ // Label 8011: @393248
     /* 393248 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(393278), // Rule ID 776 //
     /* 393253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393267 */   // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 393267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 393272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393276 */   GIR_RootConstrainSelectedInstOperands,
     /* 393277 */   // GIR_Coverage, 776,
     /* 393277 */   GIR_Done,
     /* 393278 */ // Label 8018: @393278
     /* 393278 */ GIM_Reject,
     /* 393279 */ // Label 8012: @393279
     /* 393279 */ GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(393309), // Rule ID 778 //
     /* 393284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393298 */   // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 393298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 393303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393307 */   GIR_RootConstrainSelectedInstOperands,
     /* 393308 */   // GIR_Coverage, 778,
     /* 393308 */   GIR_Done,
     /* 393309 */ // Label 8019: @393309
     /* 393309 */ GIM_Reject,
     /* 393310 */ // Label 8013: @393310
     /* 393310 */ GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(393340), // Rule ID 774 //
     /* 393315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393329 */   // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 393329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 393334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393338 */   GIR_RootConstrainSelectedInstOperands,
     /* 393339 */   // GIR_Coverage, 774,
     /* 393339 */   GIR_Done,
     /* 393340 */ // Label 8020: @393340
     /* 393340 */ GIM_Reject,
     /* 393341 */ // Label 8014: @393341
     /* 393341 */ GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(393371), // Rule ID 777 //
     /* 393346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393360 */   // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 393360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 393365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393369 */   GIR_RootConstrainSelectedInstOperands,
     /* 393370 */   // GIR_Coverage, 777,
     /* 393370 */   GIR_Done,
     /* 393371 */ // Label 8021: @393371
     /* 393371 */ GIM_Reject,
     /* 393372 */ // Label 8015: @393372
     /* 393372 */ GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(393402), // Rule ID 775 //
     /* 393377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393391 */   // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 393391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 393396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393400 */   GIR_RootConstrainSelectedInstOperands,
     /* 393401 */   // GIR_Coverage, 775,
     /* 393401 */   GIR_Done,
     /* 393402 */ // Label 8022: @393402
     /* 393402 */ GIM_Reject,
     /* 393403 */ // Label 8016: @393403
     /* 393403 */ GIM_Reject,
     /* 393404 */ // Label 134: @393404
     /* 393404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8029*/ GIMT_Encode4(393633),
     /* 393415 */ /*GILLT_s64*//*Label 8023*/ GIMT_Encode4(393447), GIMT_Encode4(0),
     /* 393423 */ /*GILLT_v2s32*//*Label 8024*/ GIMT_Encode4(393478),
     /* 393427 */ /*GILLT_v2s64*//*Label 8025*/ GIMT_Encode4(393509),
     /* 393431 */ /*GILLT_v4s16*//*Label 8026*/ GIMT_Encode4(393540),
     /* 393435 */ /*GILLT_v4s32*//*Label 8027*/ GIMT_Encode4(393571), GIMT_Encode4(0),
     /* 393443 */ /*GILLT_v8s16*//*Label 8028*/ GIMT_Encode4(393602),
     /* 393447 */ // Label 8023: @393447
     /* 393447 */ GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(393477), // Rule ID 5193 //
     /* 393452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393466 */   // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 393466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 393471 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393475 */   GIR_RootConstrainSelectedInstOperands,
     /* 393476 */   // GIR_Coverage, 5193,
     /* 393476 */   GIR_Done,
     /* 393477 */ // Label 8030: @393477
     /* 393477 */ GIM_Reject,
     /* 393478 */ // Label 8024: @393478
     /* 393478 */ GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(393508), // Rule ID 781 //
     /* 393483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393497 */   // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 393497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 393502 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393506 */   GIR_RootConstrainSelectedInstOperands,
     /* 393507 */   // GIR_Coverage, 781,
     /* 393507 */   GIR_Done,
     /* 393508 */ // Label 8031: @393508
     /* 393508 */ GIM_Reject,
     /* 393509 */ // Label 8025: @393509
     /* 393509 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(393539), // Rule ID 783 //
     /* 393514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393528 */   // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 393528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 393533 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393537 */   GIR_RootConstrainSelectedInstOperands,
     /* 393538 */   // GIR_Coverage, 783,
     /* 393538 */   GIR_Done,
     /* 393539 */ // Label 8032: @393539
     /* 393539 */ GIM_Reject,
     /* 393540 */ // Label 8026: @393540
     /* 393540 */ GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(393570), // Rule ID 779 //
     /* 393545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393559 */   // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 393559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 393564 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393568 */   GIR_RootConstrainSelectedInstOperands,
     /* 393569 */   // GIR_Coverage, 779,
     /* 393569 */   GIR_Done,
     /* 393570 */ // Label 8033: @393570
     /* 393570 */ GIM_Reject,
     /* 393571 */ // Label 8027: @393571
     /* 393571 */ GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(393601), // Rule ID 782 //
     /* 393576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393590 */   // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 393590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 393595 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393599 */   GIR_RootConstrainSelectedInstOperands,
     /* 393600 */   // GIR_Coverage, 782,
     /* 393600 */   GIR_Done,
     /* 393601 */ // Label 8034: @393601
     /* 393601 */ GIM_Reject,
     /* 393602 */ // Label 8028: @393602
     /* 393602 */ GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(393632), // Rule ID 780 //
     /* 393607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393621 */   // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 393621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 393626 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393630 */   GIR_RootConstrainSelectedInstOperands,
     /* 393631 */   // GIR_Coverage, 780,
     /* 393631 */   GIR_Done,
     /* 393632 */ // Label 8035: @393632
     /* 393632 */ GIM_Reject,
     /* 393633 */ // Label 8029: @393633
     /* 393633 */ GIM_Reject,
     /* 393634 */ // Label 135: @393634
     /* 393634 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8042*/ GIMT_Encode4(393863),
     /* 393645 */ /*GILLT_s64*//*Label 8036*/ GIMT_Encode4(393677), GIMT_Encode4(0),
     /* 393653 */ /*GILLT_v2s32*//*Label 8037*/ GIMT_Encode4(393708),
     /* 393657 */ /*GILLT_v2s64*//*Label 8038*/ GIMT_Encode4(393739),
     /* 393661 */ /*GILLT_v4s16*//*Label 8039*/ GIMT_Encode4(393770),
     /* 393665 */ /*GILLT_v4s32*//*Label 8040*/ GIMT_Encode4(393801), GIMT_Encode4(0),
     /* 393673 */ /*GILLT_v8s16*//*Label 8041*/ GIMT_Encode4(393832),
     /* 393677 */ // Label 8036: @393677
     /* 393677 */ GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(393707), // Rule ID 5194 //
     /* 393682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393696 */   // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 393696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 393701 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393705 */   GIR_RootConstrainSelectedInstOperands,
     /* 393706 */   // GIR_Coverage, 5194,
     /* 393706 */   GIR_Done,
     /* 393707 */ // Label 8043: @393707
     /* 393707 */ GIM_Reject,
     /* 393708 */ // Label 8037: @393708
     /* 393708 */ GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(393738), // Rule ID 786 //
     /* 393713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393727 */   // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 393727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 393732 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393736 */   GIR_RootConstrainSelectedInstOperands,
     /* 393737 */   // GIR_Coverage, 786,
     /* 393737 */   GIR_Done,
     /* 393738 */ // Label 8044: @393738
     /* 393738 */ GIM_Reject,
     /* 393739 */ // Label 8038: @393739
     /* 393739 */ GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(393769), // Rule ID 788 //
     /* 393744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393758 */   // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 393758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 393763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393767 */   GIR_RootConstrainSelectedInstOperands,
     /* 393768 */   // GIR_Coverage, 788,
     /* 393768 */   GIR_Done,
     /* 393769 */ // Label 8045: @393769
     /* 393769 */ GIM_Reject,
     /* 393770 */ // Label 8039: @393770
     /* 393770 */ GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(393800), // Rule ID 784 //
     /* 393775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393789 */   // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 393789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 393794 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393798 */   GIR_RootConstrainSelectedInstOperands,
     /* 393799 */   // GIR_Coverage, 784,
     /* 393799 */   GIR_Done,
     /* 393800 */ // Label 8046: @393800
     /* 393800 */ GIM_Reject,
     /* 393801 */ // Label 8040: @393801
     /* 393801 */ GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(393831), // Rule ID 787 //
     /* 393806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393820 */   // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 393820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 393825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393829 */   GIR_RootConstrainSelectedInstOperands,
     /* 393830 */   // GIR_Coverage, 787,
     /* 393830 */   GIR_Done,
     /* 393831 */ // Label 8047: @393831
     /* 393831 */ GIM_Reject,
     /* 393832 */ // Label 8041: @393832
     /* 393832 */ GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(393862), // Rule ID 785 //
     /* 393837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393851 */   // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 393851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 393856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393860 */   GIR_RootConstrainSelectedInstOperands,
     /* 393861 */   // GIR_Coverage, 785,
     /* 393861 */   GIR_Done,
     /* 393862 */ // Label 8048: @393862
     /* 393862 */ GIM_Reject,
     /* 393863 */ // Label 8042: @393863
     /* 393863 */ GIM_Reject,
     /* 393864 */ // Label 136: @393864
     /* 393864 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8053*/ GIMT_Encode4(394017),
     /* 393875 */ /*GILLT_s32*//*Label 8049*/ GIMT_Encode4(393915),
     /* 393879 */ /*GILLT_s64*//*Label 8050*/ GIMT_Encode4(393939), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 393903 */ /*GILLT_v8s8*//*Label 8051*/ GIMT_Encode4(393963), GIMT_Encode4(0),
     /* 393911 */ /*GILLT_v16s8*//*Label 8052*/ GIMT_Encode4(393990),
     /* 393915 */ // Label 8049: @393915
     /* 393915 */ GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(393938), // Rule ID 3968 //
     /* 393920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393931 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 393936 */   GIR_RootConstrainSelectedInstOperands,
     /* 393937 */   // GIR_Coverage, 3968,
     /* 393937 */   GIR_Done,
     /* 393938 */ // Label 8054: @393938
     /* 393938 */ GIM_Reject,
     /* 393939 */ // Label 8050: @393939
     /* 393939 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(393962), // Rule ID 3969 //
     /* 393944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393955 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 393960 */   GIR_RootConstrainSelectedInstOperands,
     /* 393961 */   // GIR_Coverage, 3969,
     /* 393961 */   GIR_Done,
     /* 393962 */ // Label 8055: @393962
     /* 393962 */ GIM_Reject,
     /* 393963 */ // Label 8051: @393963
     /* 393963 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(393989), // Rule ID 969 //
     /* 393968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393982 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 393982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 393987 */   GIR_RootConstrainSelectedInstOperands,
     /* 393988 */   // GIR_Coverage, 969,
     /* 393988 */   GIR_Done,
     /* 393989 */ // Label 8056: @393989
     /* 393989 */ GIM_Reject,
     /* 393990 */ // Label 8052: @393990
     /* 393990 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(394016), // Rule ID 970 //
     /* 393995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394009 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 394009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 394014 */   GIR_RootConstrainSelectedInstOperands,
     /* 394015 */   // GIR_Coverage, 970,
     /* 394015 */   GIR_Done,
     /* 394016 */ // Label 8057: @394016
     /* 394016 */ GIM_Reject,
     /* 394017 */ // Label 8053: @394017
     /* 394017 */ GIM_Reject,
     /* 394018 */ // Label 137: @394018
     /* 394018 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8062*/ GIMT_Encode4(394193),
     /* 394029 */ /*GILLT_v4s16*//*Label 8058*/ GIMT_Encode4(394049), GIMT_Encode4(0),
     /* 394037 */ /*GILLT_v8s8*//*Label 8059*/ GIMT_Encode4(394094),
     /* 394041 */ /*GILLT_v8s16*//*Label 8060*/ GIMT_Encode4(394121),
     /* 394045 */ /*GILLT_v16s8*//*Label 8061*/ GIMT_Encode4(394166),
     /* 394049 */ // Label 8058: @394049
     /* 394049 */ GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(394093),
     /* 394054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394065 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(394080), // Rule ID 973 //
     /* 394070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394073 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 394073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 394078 */     GIR_RootConstrainSelectedInstOperands,
     /* 394079 */     // GIR_Coverage, 973,
     /* 394079 */     GIR_Done,
     /* 394080 */   // Label 8064: @394080
     /* 394080 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(394092), // Rule ID 4913 //
     /* 394085 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 394090 */     GIR_RootConstrainSelectedInstOperands,
     /* 394091 */     // GIR_Coverage, 4913,
     /* 394091 */     GIR_Done,
     /* 394092 */   // Label 8065: @394092
     /* 394092 */   GIM_Reject,
     /* 394093 */ // Label 8063: @394093
     /* 394093 */ GIM_Reject,
     /* 394094 */ // Label 8059: @394094
     /* 394094 */ GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(394120), // Rule ID 971 //
     /* 394099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394113 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 394113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 394118 */   GIR_RootConstrainSelectedInstOperands,
     /* 394119 */   // GIR_Coverage, 971,
     /* 394119 */   GIR_Done,
     /* 394120 */ // Label 8066: @394120
     /* 394120 */ GIM_Reject,
     /* 394121 */ // Label 8060: @394121
     /* 394121 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(394165),
     /* 394126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394137 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(394152), // Rule ID 974 //
     /* 394142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394145 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 394145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 394150 */     GIR_RootConstrainSelectedInstOperands,
     /* 394151 */     // GIR_Coverage, 974,
     /* 394151 */     GIR_Done,
     /* 394152 */   // Label 8068: @394152
     /* 394152 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(394164), // Rule ID 4915 //
     /* 394157 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 394162 */     GIR_RootConstrainSelectedInstOperands,
     /* 394163 */     // GIR_Coverage, 4915,
     /* 394163 */     GIR_Done,
     /* 394164 */   // Label 8069: @394164
     /* 394164 */   GIM_Reject,
     /* 394165 */ // Label 8067: @394165
     /* 394165 */ GIM_Reject,
     /* 394166 */ // Label 8061: @394166
     /* 394166 */ GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(394192), // Rule ID 972 //
     /* 394171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394185 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 394185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 394190 */   GIR_RootConstrainSelectedInstOperands,
     /* 394191 */   // GIR_Coverage, 972,
     /* 394191 */   GIR_Done,
     /* 394192 */ // Label 8070: @394192
     /* 394192 */ GIM_Reject,
     /* 394193 */ // Label 8062: @394193
     /* 394193 */ GIM_Reject,
     /* 394194 */ // Label 138: @394194
     /* 394194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8077*/ GIMT_Encode4(394467),
     /* 394205 */ /*GILLT_v2s32*//*Label 8071*/ GIMT_Encode4(394233), GIMT_Encode4(0),
     /* 394213 */ /*GILLT_v4s16*//*Label 8072*/ GIMT_Encode4(394278),
     /* 394217 */ /*GILLT_v4s32*//*Label 8073*/ GIMT_Encode4(394323),
     /* 394221 */ /*GILLT_v8s8*//*Label 8074*/ GIMT_Encode4(394368),
     /* 394225 */ /*GILLT_v8s16*//*Label 8075*/ GIMT_Encode4(394395),
     /* 394229 */ /*GILLT_v16s8*//*Label 8076*/ GIMT_Encode4(394440),
     /* 394233 */ // Label 8071: @394233
     /* 394233 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(394277),
     /* 394238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394249 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(394264), // Rule ID 979 //
     /* 394254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394257 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 394257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 394262 */     GIR_RootConstrainSelectedInstOperands,
     /* 394263 */     // GIR_Coverage, 979,
     /* 394263 */     GIR_Done,
     /* 394264 */   // Label 8079: @394264
     /* 394264 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(394276), // Rule ID 4917 //
     /* 394269 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 394274 */     GIR_RootConstrainSelectedInstOperands,
     /* 394275 */     // GIR_Coverage, 4917,
     /* 394275 */     GIR_Done,
     /* 394276 */   // Label 8080: @394276
     /* 394276 */   GIM_Reject,
     /* 394277 */ // Label 8078: @394277
     /* 394277 */ GIM_Reject,
     /* 394278 */ // Label 8072: @394278
     /* 394278 */ GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(394322),
     /* 394283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394294 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(394309), // Rule ID 977 //
     /* 394299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394302 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 394302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 394307 */     GIR_RootConstrainSelectedInstOperands,
     /* 394308 */     // GIR_Coverage, 977,
     /* 394308 */     GIR_Done,
     /* 394309 */   // Label 8082: @394309
     /* 394309 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(394321), // Rule ID 4914 //
     /* 394314 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 394319 */     GIR_RootConstrainSelectedInstOperands,
     /* 394320 */     // GIR_Coverage, 4914,
     /* 394320 */     GIR_Done,
     /* 394321 */   // Label 8083: @394321
     /* 394321 */   GIM_Reject,
     /* 394322 */ // Label 8081: @394322
     /* 394322 */ GIM_Reject,
     /* 394323 */ // Label 8073: @394323
     /* 394323 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(394367),
     /* 394328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394339 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(394354), // Rule ID 980 //
     /* 394344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394347 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 394352 */     GIR_RootConstrainSelectedInstOperands,
     /* 394353 */     // GIR_Coverage, 980,
     /* 394353 */     GIR_Done,
     /* 394354 */   // Label 8085: @394354
     /* 394354 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(394366), // Rule ID 4918 //
     /* 394359 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 394364 */     GIR_RootConstrainSelectedInstOperands,
     /* 394365 */     // GIR_Coverage, 4918,
     /* 394365 */     GIR_Done,
     /* 394366 */   // Label 8086: @394366
     /* 394366 */   GIM_Reject,
     /* 394367 */ // Label 8084: @394367
     /* 394367 */ GIM_Reject,
     /* 394368 */ // Label 8074: @394368
     /* 394368 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(394394), // Rule ID 975 //
     /* 394373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394387 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 394387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 394392 */   GIR_RootConstrainSelectedInstOperands,
     /* 394393 */   // GIR_Coverage, 975,
     /* 394393 */   GIR_Done,
     /* 394394 */ // Label 8087: @394394
     /* 394394 */ GIM_Reject,
     /* 394395 */ // Label 8075: @394395
     /* 394395 */ GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(394439),
     /* 394400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394411 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(394426), // Rule ID 978 //
     /* 394416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394419 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 394419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 394424 */     GIR_RootConstrainSelectedInstOperands,
     /* 394425 */     // GIR_Coverage, 978,
     /* 394425 */     GIR_Done,
     /* 394426 */   // Label 8089: @394426
     /* 394426 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(394438), // Rule ID 4916 //
     /* 394431 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 394436 */     GIR_RootConstrainSelectedInstOperands,
     /* 394437 */     // GIR_Coverage, 4916,
     /* 394437 */     GIR_Done,
     /* 394438 */   // Label 8090: @394438
     /* 394438 */   GIM_Reject,
     /* 394439 */ // Label 8088: @394439
     /* 394439 */ GIM_Reject,
     /* 394440 */ // Label 8076: @394440
     /* 394440 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(394466), // Rule ID 976 //
     /* 394445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394459 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 394459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 394464 */   GIR_RootConstrainSelectedInstOperands,
     /* 394465 */   // GIR_Coverage, 976,
     /* 394465 */   GIR_Done,
     /* 394466 */ // Label 8091: @394466
     /* 394466 */ GIM_Reject,
     /* 394467 */ // Label 8077: @394467
     /* 394467 */ GIM_Reject,
     /* 394468 */ // Label 139: @394468
     /* 394468 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8098*/ GIMT_Encode4(394673),
     /* 394479 */ /*GILLT_s64*//*Label 8092*/ GIMT_Encode4(394511), GIMT_Encode4(0),
     /* 394487 */ /*GILLT_v2s32*//*Label 8093*/ GIMT_Encode4(394538),
     /* 394491 */ /*GILLT_v2s64*//*Label 8094*/ GIMT_Encode4(394565),
     /* 394495 */ /*GILLT_v4s16*//*Label 8095*/ GIMT_Encode4(394592),
     /* 394499 */ /*GILLT_v4s32*//*Label 8096*/ GIMT_Encode4(394619), GIMT_Encode4(0),
     /* 394507 */ /*GILLT_v8s16*//*Label 8097*/ GIMT_Encode4(394646),
     /* 394511 */ // Label 8092: @394511
     /* 394511 */ GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(394537), // Rule ID 1001 //
     /* 394516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394530 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 394530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 394535 */   GIR_RootConstrainSelectedInstOperands,
     /* 394536 */   // GIR_Coverage, 1001,
     /* 394536 */   GIR_Done,
     /* 394537 */ // Label 8099: @394537
     /* 394537 */ GIM_Reject,
     /* 394538 */ // Label 8093: @394538
     /* 394538 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(394564), // Rule ID 997 //
     /* 394543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394557 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 394562 */   GIR_RootConstrainSelectedInstOperands,
     /* 394563 */   // GIR_Coverage, 997,
     /* 394563 */   GIR_Done,
     /* 394564 */ // Label 8100: @394564
     /* 394564 */ GIM_Reject,
     /* 394565 */ // Label 8094: @394565
     /* 394565 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(394591), // Rule ID 1003 //
     /* 394570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394584 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 394589 */   GIR_RootConstrainSelectedInstOperands,
     /* 394590 */   // GIR_Coverage, 1003,
     /* 394590 */   GIR_Done,
     /* 394591 */ // Label 8101: @394591
     /* 394591 */ GIM_Reject,
     /* 394592 */ // Label 8095: @394592
     /* 394592 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(394618), // Rule ID 993 //
     /* 394597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394611 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 394611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 394616 */   GIR_RootConstrainSelectedInstOperands,
     /* 394617 */   // GIR_Coverage, 993,
     /* 394617 */   GIR_Done,
     /* 394618 */ // Label 8102: @394618
     /* 394618 */ GIM_Reject,
     /* 394619 */ // Label 8096: @394619
     /* 394619 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(394645), // Rule ID 999 //
     /* 394624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394638 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 394638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 394643 */   GIR_RootConstrainSelectedInstOperands,
     /* 394644 */   // GIR_Coverage, 999,
     /* 394644 */   GIR_Done,
     /* 394645 */ // Label 8103: @394645
     /* 394645 */ GIM_Reject,
     /* 394646 */ // Label 8097: @394646
     /* 394646 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(394672), // Rule ID 995 //
     /* 394651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394665 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 394665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 394670 */   GIR_RootConstrainSelectedInstOperands,
     /* 394671 */   // GIR_Coverage, 995,
     /* 394671 */   GIR_Done,
     /* 394672 */ // Label 8104: @394672
     /* 394672 */ GIM_Reject,
     /* 394673 */ // Label 8098: @394673
     /* 394673 */ GIM_Reject,
     /* 394674 */ // Label 140: @394674
     /* 394674 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8107*/ GIMT_Encode4(395072),
     /* 394685 */ /*GILLT_v2s64*//*Label 8105*/ GIMT_Encode4(394697), GIMT_Encode4(0),
     /* 394693 */ /*GILLT_v4s32*//*Label 8106*/ GIMT_Encode4(394835),
     /* 394697 */ // Label 8105: @394697
     /* 394697 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(394756), // Rule ID 5797 //
     /* 394702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394713 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 394713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 394720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394725 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 394745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394755 */   // GIR_Coverage, 5797,
     /* 394755 */   GIR_EraseRootFromParent_Done,
     /* 394756 */ // Label 8108: @394756
     /* 394756 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(394834), // Rule ID 5919 //
     /* 394761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394772 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 394772 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 394775 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 394779 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394784 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 394790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 394793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 394797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 394807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 394815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 394818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394823 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394833 */   // GIR_Coverage, 5919,
     /* 394833 */   GIR_EraseRootFromParent_Done,
     /* 394834 */ // Label 8109: @394834
     /* 394834 */ GIM_Reject,
     /* 394835 */ // Label 8106: @394835
     /* 394835 */ GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(394894), // Rule ID 5793 //
     /* 394840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394851 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 394851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 394854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 394858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394863 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 394883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394893 */   // GIR_Coverage, 5793,
     /* 394893 */   GIR_EraseRootFromParent_Done,
     /* 394894 */ // Label 8110: @394894
     /* 394894 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(394953), // Rule ID 5794 //
     /* 394899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394910 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 394910 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 394913 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 394917 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394922 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 394942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394952 */   // GIR_Coverage, 5794,
     /* 394952 */   GIR_EraseRootFromParent_Done,
     /* 394953 */ // Label 8111: @394953
     /* 394953 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(395012), // Rule ID 5795 //
     /* 394958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394969 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 394969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 394972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 394976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394981 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 395001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395011 */   // GIR_Coverage, 5795,
     /* 395011 */   GIR_EraseRootFromParent_Done,
     /* 395012 */ // Label 8112: @395012
     /* 395012 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(395071), // Rule ID 5796 //
     /* 395017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395028 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 395028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 395031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 395035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395040 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 395060 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395070 */   // GIR_Coverage, 5796,
     /* 395070 */   GIR_EraseRootFromParent_Done,
     /* 395071 */ // Label 8113: @395071
     /* 395071 */ GIM_Reject,
     /* 395072 */ // Label 8107: @395072
     /* 395072 */ GIM_Reject,
     /* 395073 */ // Label 141: @395073
     /* 395073 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8118*/ GIMT_Encode4(395442),
     /* 395084 */ /*GILLT_v2s32*//*Label 8114*/ GIMT_Encode4(395144), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 395096 */ /*GILLT_v4s32*//*Label 8115*/ GIMT_Encode4(395264), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 395128 */ /*GILLT_nxv2s64*//*Label 8116*/ GIMT_Encode4(395384), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 395140 */ /*GILLT_nxv4s32*//*Label 8117*/ GIMT_Encode4(395413),
     /* 395144 */ // Label 8114: @395144
     /* 395144 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(395263),
     /* 395149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 395155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 395158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395170 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(395243), // Rule ID 26 //
     /* 395175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 395178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 395186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 395198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395219 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 395223 */     // MIs[3] Operand 1
     /* 395223 */     // No operand predicates
     /* 395223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395225 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 395225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 395228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 395232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395241 */     GIR_RootConstrainSelectedInstOperands,
     /* 395242 */     // GIR_Coverage, 26,
     /* 395242 */     GIR_EraseRootFromParent_Done,
     /* 395243 */   // Label 8120: @395243
     /* 395243 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(395262), // Rule ID 22 //
     /* 395248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 395251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395255 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 395255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 395260 */     GIR_RootConstrainSelectedInstOperands,
     /* 395261 */     // GIR_Coverage, 22,
     /* 395261 */     GIR_Done,
     /* 395262 */   // Label 8121: @395262
     /* 395262 */   GIM_Reject,
     /* 395263 */ // Label 8119: @395263
     /* 395263 */ GIM_Reject,
     /* 395264 */ // Label 8115: @395264
     /* 395264 */ GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(395383),
     /* 395269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 395275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 395278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395290 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(395363), // Rule ID 27 //
     /* 395295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 395298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 395306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 395318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395339 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 395343 */     // MIs[3] Operand 1
     /* 395343 */     // No operand predicates
     /* 395343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395345 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 395345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 395348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 395352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395361 */     GIR_RootConstrainSelectedInstOperands,
     /* 395362 */     // GIR_Coverage, 27,
     /* 395362 */     GIR_EraseRootFromParent_Done,
     /* 395363 */   // Label 8123: @395363
     /* 395363 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(395382), // Rule ID 23 //
     /* 395368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 395371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395375 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 395375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 395380 */     GIR_RootConstrainSelectedInstOperands,
     /* 395381 */     // GIR_Coverage, 23,
     /* 395381 */     GIR_Done,
     /* 395382 */   // Label 8124: @395382
     /* 395382 */   GIM_Reject,
     /* 395383 */ // Label 8122: @395383
     /* 395383 */ GIM_Reject,
     /* 395384 */ // Label 8116: @395384
     /* 395384 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(395412), // Rule ID 2977 //
     /* 395389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 395395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 395398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 395401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395405 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 395405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 395410 */   GIR_RootConstrainSelectedInstOperands,
     /* 395411 */   // GIR_Coverage, 2977,
     /* 395411 */   GIR_Done,
     /* 395412 */ // Label 8125: @395412
     /* 395412 */ GIM_Reject,
     /* 395413 */ // Label 8117: @395413
     /* 395413 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(395441), // Rule ID 2976 //
     /* 395418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 395424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 395427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 395430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395434 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 395434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 395439 */   GIR_RootConstrainSelectedInstOperands,
     /* 395440 */   // GIR_Coverage, 2976,
     /* 395440 */   GIR_Done,
     /* 395441 */ // Label 8126: @395441
     /* 395441 */ GIM_Reject,
     /* 395442 */ // Label 8118: @395442
     /* 395442 */ GIM_Reject,
     /* 395443 */ // Label 142: @395443
     /* 395443 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8130*/ GIMT_Encode4(395559),
     /* 395454 */ /*GILLT_s16*//*Label 8127*/ GIMT_Encode4(395466),
     /* 395458 */ /*GILLT_s32*//*Label 8128*/ GIMT_Encode4(395497),
     /* 395462 */ /*GILLT_s64*//*Label 8129*/ GIMT_Encode4(395528),
     /* 395466 */ // Label 8127: @395466
     /* 395466 */ GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(395496), // Rule ID 1651 //
     /* 395471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 395474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395485 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 395485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 395490 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395494 */   GIR_RootConstrainSelectedInstOperands,
     /* 395495 */   // GIR_Coverage, 1651,
     /* 395495 */   GIR_Done,
     /* 395496 */ // Label 8131: @395496
     /* 395496 */ GIM_Reject,
     /* 395497 */ // Label 8128: @395497
     /* 395497 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(395527), // Rule ID 1650 //
     /* 395502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 395505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395516 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 395516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 395521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395525 */   GIR_RootConstrainSelectedInstOperands,
     /* 395526 */   // GIR_Coverage, 1650,
     /* 395526 */   GIR_Done,
     /* 395527 */ // Label 8132: @395527
     /* 395527 */ GIM_Reject,
     /* 395528 */ // Label 8129: @395528
     /* 395528 */ GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(395558), // Rule ID 1649 //
     /* 395533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 395536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395547 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 395547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 395552 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395556 */   GIR_RootConstrainSelectedInstOperands,
     /* 395557 */   // GIR_Coverage, 1649,
     /* 395557 */   GIR_Done,
     /* 395558 */ // Label 8133: @395558
     /* 395558 */ GIM_Reject,
     /* 395559 */ // Label 8130: @395559
     /* 395559 */ GIM_Reject,
     /* 395560 */ // Label 143: @395560
     /* 395560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8137*/ GIMT_Encode4(396792),
     /* 395571 */ /*GILLT_v2s64*//*Label 8134*/ GIMT_Encode4(395591), GIMT_Encode4(0),
     /* 395579 */ /*GILLT_v4s32*//*Label 8135*/ GIMT_Encode4(396152), GIMT_Encode4(0),
     /* 395587 */ /*GILLT_v8s16*//*Label 8136*/ GIMT_Encode4(396713),
     /* 395591 */ // Label 8134: @395591
     /* 395591 */ GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(396151),
     /* 395596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395606 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(395698), // Rule ID 2047 //
     /* 395611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 395622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 395634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395655 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 395659 */     // MIs[3] Operand 1
     /* 395659 */     // No operand predicates
     /* 395659 */     // MIs[1] Operand 2
     /* 395659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 395670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 395679 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 395679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 395682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395696 */     GIR_RootConstrainSelectedInstOperands,
     /* 395697 */     // GIR_Coverage, 2047,
     /* 395697 */     GIR_EraseRootFromParent_Done,
     /* 395698 */   // Label 8139: @395698
     /* 395698 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(395790), // Rule ID 13296 //
     /* 395703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 395714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 395726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395747 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 395751 */     // MIs[3] Operand 1
     /* 395751 */     // No operand predicates
     /* 395751 */     // MIs[1] Operand 2
     /* 395751 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 395762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 395771 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 395771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 395774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395788 */     GIR_RootConstrainSelectedInstOperands,
     /* 395789 */     // GIR_Coverage, 13296,
     /* 395789 */     GIR_EraseRootFromParent_Done,
     /* 395790 */   // Label 8140: @395790
     /* 395790 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(395876), // Rule ID 13294 //
     /* 395795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 395806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 395818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395839 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 395843 */     // MIs[3] Operand 1
     /* 395843 */     // No operand predicates
     /* 395843 */     // MIs[1] Operand 2
     /* 395843 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 395854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395860 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 395860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 395863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 395867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395874 */     GIR_RootConstrainSelectedInstOperands,
     /* 395875 */     // GIR_Coverage, 13294,
     /* 395875 */     GIR_EraseRootFromParent_Done,
     /* 395876 */   // Label 8141: @395876
     /* 395876 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(395962), // Rule ID 2045 //
     /* 395881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 395892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 395896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 395904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 395908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395929 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 395933 */     // MIs[3] Operand 1
     /* 395933 */     // No operand predicates
     /* 395933 */     // MIs[1] Operand 2
     /* 395933 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 395944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395946 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 395946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 395949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395960 */     GIR_RootConstrainSelectedInstOperands,
     /* 395961 */     // GIR_Coverage, 2045,
     /* 395961 */     GIR_EraseRootFromParent_Done,
     /* 395962 */   // Label 8142: @395962
     /* 395962 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(396001), // Rule ID 1734 //
     /* 395967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 395977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 395984 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 395984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 395987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 395999 */     GIR_RootConstrainSelectedInstOperands,
     /* 396000 */     // GIR_Coverage, 1734,
     /* 396000 */     GIR_EraseRootFromParent_Done,
     /* 396001 */   // Label 8143: @396001
     /* 396001 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(396064), // Rule ID 13295 //
     /* 396006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 396017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396038 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396042 */     // MIs[2] Operand 1
     /* 396042 */     // No operand predicates
     /* 396042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396048 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 396051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396062 */     GIR_RootConstrainSelectedInstOperands,
     /* 396063 */     // GIR_Coverage, 13295,
     /* 396063 */     GIR_EraseRootFromParent_Done,
     /* 396064 */   // Label 8144: @396064
     /* 396064 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(396127), // Rule ID 2046 //
     /* 396069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 396084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396105 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396109 */     // MIs[2] Operand 1
     /* 396109 */     // No operand predicates
     /* 396109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396111 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 396114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396125 */     GIR_RootConstrainSelectedInstOperands,
     /* 396126 */     // GIR_Coverage, 2046,
     /* 396126 */     GIR_EraseRootFromParent_Done,
     /* 396127 */   // Label 8145: @396127
     /* 396127 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(396150), // Rule ID 1733 //
     /* 396132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396143 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 396143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 396148 */     GIR_RootConstrainSelectedInstOperands,
     /* 396149 */     // GIR_Coverage, 1733,
     /* 396149 */     GIR_Done,
     /* 396150 */   // Label 8146: @396150
     /* 396150 */   GIM_Reject,
     /* 396151 */ // Label 8138: @396151
     /* 396151 */ GIM_Reject,
     /* 396152 */ // Label 8135: @396152
     /* 396152 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(396712),
     /* 396157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396167 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(396259), // Rule ID 2044 //
     /* 396172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 396183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 396195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396216 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396220 */     // MIs[3] Operand 1
     /* 396220 */     // No operand predicates
     /* 396220 */     // MIs[1] Operand 2
     /* 396220 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 396231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 396240 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 396243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 396250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396257 */     GIR_RootConstrainSelectedInstOperands,
     /* 396258 */     // GIR_Coverage, 2044,
     /* 396258 */     GIR_EraseRootFromParent_Done,
     /* 396259 */   // Label 8148: @396259
     /* 396259 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(396351), // Rule ID 13293 //
     /* 396264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 396275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 396287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396308 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396312 */     // MIs[3] Operand 1
     /* 396312 */     // No operand predicates
     /* 396312 */     // MIs[1] Operand 2
     /* 396312 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 396323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 396332 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 396335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 396342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396349 */     GIR_RootConstrainSelectedInstOperands,
     /* 396350 */     // GIR_Coverage, 13293,
     /* 396350 */     GIR_EraseRootFromParent_Done,
     /* 396351 */   // Label 8149: @396351
     /* 396351 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(396437), // Rule ID 13291 //
     /* 396356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 396367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 396379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396400 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396404 */     // MIs[3] Operand 1
     /* 396404 */     // No operand predicates
     /* 396404 */     // MIs[1] Operand 2
     /* 396404 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 396415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396421 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 396424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396435 */     GIR_RootConstrainSelectedInstOperands,
     /* 396436 */     // GIR_Coverage, 13291,
     /* 396436 */     GIR_EraseRootFromParent_Done,
     /* 396437 */   // Label 8150: @396437
     /* 396437 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(396523), // Rule ID 2042 //
     /* 396442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 396457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 396469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396490 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396494 */     // MIs[3] Operand 1
     /* 396494 */     // No operand predicates
     /* 396494 */     // MIs[1] Operand 2
     /* 396494 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 396505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396507 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 396510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396521 */     GIR_RootConstrainSelectedInstOperands,
     /* 396522 */     // GIR_Coverage, 2042,
     /* 396522 */     GIR_EraseRootFromParent_Done,
     /* 396523 */   // Label 8151: @396523
     /* 396523 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(396562), // Rule ID 1732 //
     /* 396528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 396538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 396545 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 396545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 396548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 396555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 396560 */     GIR_RootConstrainSelectedInstOperands,
     /* 396561 */     // GIR_Coverage, 1732,
     /* 396561 */     GIR_EraseRootFromParent_Done,
     /* 396562 */   // Label 8152: @396562
     /* 396562 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(396625), // Rule ID 13292 //
     /* 396567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 396578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396599 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396603 */     // MIs[2] Operand 1
     /* 396603 */     // No operand predicates
     /* 396603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396609 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 396612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396623 */     GIR_RootConstrainSelectedInstOperands,
     /* 396624 */     // GIR_Coverage, 13292,
     /* 396624 */     GIR_EraseRootFromParent_Done,
     /* 396625 */   // Label 8153: @396625
     /* 396625 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(396688), // Rule ID 2043 //
     /* 396630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 396645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396666 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396670 */     // MIs[2] Operand 1
     /* 396670 */     // No operand predicates
     /* 396670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396672 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 396675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396686 */     GIR_RootConstrainSelectedInstOperands,
     /* 396687 */     // GIR_Coverage, 2043,
     /* 396687 */     GIR_EraseRootFromParent_Done,
     /* 396688 */   // Label 8154: @396688
     /* 396688 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(396711), // Rule ID 1731 //
     /* 396693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396704 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 396704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 396709 */     GIR_RootConstrainSelectedInstOperands,
     /* 396710 */     // GIR_Coverage, 1731,
     /* 396710 */     GIR_Done,
     /* 396711 */   // Label 8155: @396711
     /* 396711 */   GIM_Reject,
     /* 396712 */ // Label 8147: @396712
     /* 396712 */ GIM_Reject,
     /* 396713 */ // Label 8136: @396713
     /* 396713 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(396791),
     /* 396718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396728 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(396767), // Rule ID 1730 //
     /* 396733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 396743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 396750 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 396750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 396753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 396760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 396765 */     GIR_RootConstrainSelectedInstOperands,
     /* 396766 */     // GIR_Coverage, 1730,
     /* 396766 */     GIR_EraseRootFromParent_Done,
     /* 396767 */   // Label 8157: @396767
     /* 396767 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(396790), // Rule ID 1729 //
     /* 396772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396783 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 396783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 396788 */     GIR_RootConstrainSelectedInstOperands,
     /* 396789 */     // GIR_Coverage, 1729,
     /* 396789 */     GIR_Done,
     /* 396790 */   // Label 8158: @396790
     /* 396790 */   GIM_Reject,
     /* 396791 */ // Label 8156: @396791
     /* 396791 */ GIM_Reject,
     /* 396792 */ // Label 8137: @396792
     /* 396792 */ GIM_Reject,
     /* 396793 */ // Label 144: @396793
     /* 396793 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8177*/ GIMT_Encode4(397572),
     /* 396804 */ /*GILLT_v2s32*//*Label 8159*/ GIMT_Encode4(396880),
     /* 396808 */ /*GILLT_v2s64*//*Label 8160*/ GIMT_Encode4(396935),
     /* 396812 */ /*GILLT_v4s16*//*Label 8161*/ GIMT_Encode4(396990),
     /* 396816 */ /*GILLT_v4s32*//*Label 8162*/ GIMT_Encode4(397045),
     /* 396820 */ /*GILLT_v8s8*//*Label 8163*/ GIMT_Encode4(397100),
     /* 396824 */ /*GILLT_v8s16*//*Label 8164*/ GIMT_Encode4(397134),
     /* 396828 */ /*GILLT_v16s8*//*Label 8165*/ GIMT_Encode4(397189), GIMT_Encode4(0),
     /* 396836 */ /*GILLT_nxv2s1*//*Label 8166*/ GIMT_Encode4(397223),
     /* 396840 */ /*GILLT_nxv2s16*//*Label 8167*/ GIMT_Encode4(397249),
     /* 396844 */ /*GILLT_nxv2s32*//*Label 8168*/ GIMT_Encode4(397275),
     /* 396848 */ /*GILLT_nxv2s64*//*Label 8169*/ GIMT_Encode4(397301),
     /* 396852 */ /*GILLT_nxv4s1*//*Label 8170*/ GIMT_Encode4(397348),
     /* 396856 */ /*GILLT_nxv4s16*//*Label 8171*/ GIMT_Encode4(397374),
     /* 396860 */ /*GILLT_nxv4s32*//*Label 8172*/ GIMT_Encode4(397400),
     /* 396864 */ /*GILLT_nxv8s1*//*Label 8173*/ GIMT_Encode4(397447),
     /* 396868 */ /*GILLT_nxv8s16*//*Label 8174*/ GIMT_Encode4(397473),
     /* 396872 */ /*GILLT_nxv16s1*//*Label 8175*/ GIMT_Encode4(397520),
     /* 396876 */ /*GILLT_nxv16s8*//*Label 8176*/ GIMT_Encode4(397546),
     /* 396880 */ // Label 8159: @396880
     /* 396880 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(396934),
     /* 396885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 396891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396903 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(396918), // Rule ID 1867 //
     /* 396908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396911 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 396911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 396916 */     GIR_RootConstrainSelectedInstOperands,
     /* 396917 */     // GIR_Coverage, 1867,
     /* 396917 */     GIR_Done,
     /* 396918 */   // Label 8179: @396918
     /* 396918 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(396933), // Rule ID 2496 //
     /* 396923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396926 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 396931 */     GIR_RootConstrainSelectedInstOperands,
     /* 396932 */     // GIR_Coverage, 2496,
     /* 396932 */     GIR_Done,
     /* 396933 */   // Label 8180: @396933
     /* 396933 */   GIM_Reject,
     /* 396934 */ // Label 8178: @396934
     /* 396934 */ GIM_Reject,
     /* 396935 */ // Label 8160: @396935
     /* 396935 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(396989),
     /* 396940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 396946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396958 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(396973), // Rule ID 1869 //
     /* 396963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396966 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 396966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 396971 */     GIR_RootConstrainSelectedInstOperands,
     /* 396972 */     // GIR_Coverage, 1869,
     /* 396972 */     GIR_Done,
     /* 396973 */   // Label 8182: @396973
     /* 396973 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(396988), // Rule ID 2498 //
     /* 396978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396981 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 396981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 396986 */     GIR_RootConstrainSelectedInstOperands,
     /* 396987 */     // GIR_Coverage, 2498,
     /* 396987 */     GIR_Done,
     /* 396988 */   // Label 8183: @396988
     /* 396988 */   GIM_Reject,
     /* 396989 */ // Label 8181: @396989
     /* 396989 */ GIM_Reject,
     /* 396990 */ // Label 8161: @396990
     /* 396990 */ GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(397044),
     /* 396995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 397001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397013 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(397028), // Rule ID 1865 //
     /* 397018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397021 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 397021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 397026 */     GIR_RootConstrainSelectedInstOperands,
     /* 397027 */     // GIR_Coverage, 1865,
     /* 397027 */     GIR_Done,
     /* 397028 */   // Label 8185: @397028
     /* 397028 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(397043), // Rule ID 2494 //
     /* 397033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397036 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 397036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 397041 */     GIR_RootConstrainSelectedInstOperands,
     /* 397042 */     // GIR_Coverage, 2494,
     /* 397042 */     GIR_Done,
     /* 397043 */   // Label 8186: @397043
     /* 397043 */   GIM_Reject,
     /* 397044 */ // Label 8184: @397044
     /* 397044 */ GIM_Reject,
     /* 397045 */ // Label 8162: @397045
     /* 397045 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(397099),
     /* 397050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397068 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(397083), // Rule ID 1868 //
     /* 397073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397076 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 397076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 397081 */     GIR_RootConstrainSelectedInstOperands,
     /* 397082 */     // GIR_Coverage, 1868,
     /* 397082 */     GIR_Done,
     /* 397083 */   // Label 8188: @397083
     /* 397083 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(397098), // Rule ID 2497 //
     /* 397088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397091 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 397091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 397096 */     GIR_RootConstrainSelectedInstOperands,
     /* 397097 */     // GIR_Coverage, 2497,
     /* 397097 */     GIR_Done,
     /* 397098 */   // Label 8189: @397098
     /* 397098 */   GIM_Reject,
     /* 397099 */ // Label 8187: @397099
     /* 397099 */ GIM_Reject,
     /* 397100 */ // Label 8163: @397100
     /* 397100 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(397133), // Rule ID 1863 //
     /* 397105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 397111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 397114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397126 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 397126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 397131 */   GIR_RootConstrainSelectedInstOperands,
     /* 397132 */   // GIR_Coverage, 1863,
     /* 397132 */   GIR_Done,
     /* 397133 */ // Label 8190: @397133
     /* 397133 */ GIM_Reject,
     /* 397134 */ // Label 8164: @397134
     /* 397134 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(397188),
     /* 397139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 397145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397157 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(397172), // Rule ID 1866 //
     /* 397162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397165 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 397165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 397170 */     GIR_RootConstrainSelectedInstOperands,
     /* 397171 */     // GIR_Coverage, 1866,
     /* 397171 */     GIR_Done,
     /* 397172 */   // Label 8192: @397172
     /* 397172 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(397187), // Rule ID 2495 //
     /* 397177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397180 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 397180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 397185 */     GIR_RootConstrainSelectedInstOperands,
     /* 397186 */     // GIR_Coverage, 2495,
     /* 397186 */     GIR_Done,
     /* 397187 */   // Label 8193: @397187
     /* 397187 */   GIM_Reject,
     /* 397188 */ // Label 8191: @397188
     /* 397188 */ GIM_Reject,
     /* 397189 */ // Label 8165: @397189
     /* 397189 */ GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(397222), // Rule ID 1864 //
     /* 397194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 397203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397215 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 397215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 397220 */   GIR_RootConstrainSelectedInstOperands,
     /* 397221 */   // GIR_Coverage, 1864,
     /* 397221 */   GIR_Done,
     /* 397222 */ // Label 8194: @397222
     /* 397222 */ GIM_Reject,
     /* 397223 */ // Label 8166: @397223
     /* 397223 */ GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(397248), // Rule ID 8864 //
     /* 397228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 397234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 397237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 397241 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 397241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 397246 */   GIR_RootConstrainSelectedInstOperands,
     /* 397247 */   // GIR_Coverage, 8864,
     /* 397247 */   GIR_Done,
     /* 397248 */ // Label 8195: @397248
     /* 397248 */ GIM_Reject,
     /* 397249 */ // Label 8167: @397249
     /* 397249 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(397274), // Rule ID 8840 //
     /* 397254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 397260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 397263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397267 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 397267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 397272 */   GIR_RootConstrainSelectedInstOperands,
     /* 397273 */   // GIR_Coverage, 8840,
     /* 397273 */   GIR_Done,
     /* 397274 */ // Label 8196: @397274
     /* 397274 */ GIM_Reject,
     /* 397275 */ // Label 8168: @397275
     /* 397275 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(397300), // Rule ID 8841 //
     /* 397280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 397286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 397289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397293 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 397293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 397298 */   GIR_RootConstrainSelectedInstOperands,
     /* 397299 */   // GIR_Coverage, 8841,
     /* 397299 */   GIR_Done,
     /* 397300 */ // Label 8197: @397300
     /* 397300 */ GIM_Reject,
     /* 397301 */ // Label 8169: @397301
     /* 397301 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(397347),
     /* 397306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 397309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 397312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397316 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(397331), // Rule ID 8836 //
     /* 397321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397324 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 397324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 397329 */     GIR_RootConstrainSelectedInstOperands,
     /* 397330 */     // GIR_Coverage, 8836,
     /* 397330 */     GIR_Done,
     /* 397331 */   // Label 8199: @397331
     /* 397331 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(397346), // Rule ID 8842 //
     /* 397336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397339 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 397339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 397344 */     GIR_RootConstrainSelectedInstOperands,
     /* 397345 */     // GIR_Coverage, 8842,
     /* 397345 */     GIR_Done,
     /* 397346 */   // Label 8200: @397346
     /* 397346 */   GIM_Reject,
     /* 397347 */ // Label 8198: @397347
     /* 397347 */ GIM_Reject,
     /* 397348 */ // Label 8170: @397348
     /* 397348 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(397373), // Rule ID 8863 //
     /* 397353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 397359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 397362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 397366 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 397366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 397371 */   GIR_RootConstrainSelectedInstOperands,
     /* 397372 */   // GIR_Coverage, 8863,
     /* 397372 */   GIR_Done,
     /* 397373 */ // Label 8201: @397373
     /* 397373 */ GIM_Reject,
     /* 397374 */ // Label 8171: @397374
     /* 397374 */ GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(397399), // Rule ID 8838 //
     /* 397379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 397385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 397388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397392 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 397392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 397397 */   GIR_RootConstrainSelectedInstOperands,
     /* 397398 */   // GIR_Coverage, 8838,
     /* 397398 */   GIR_Done,
     /* 397399 */ // Label 8202: @397399
     /* 397399 */ GIM_Reject,
     /* 397400 */ // Label 8172: @397400
     /* 397400 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(397446),
     /* 397405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 397408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 397411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397415 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(397430), // Rule ID 8835 //
     /* 397420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397423 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 397423 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 397428 */     GIR_RootConstrainSelectedInstOperands,
     /* 397429 */     // GIR_Coverage, 8835,
     /* 397429 */     GIR_Done,
     /* 397430 */   // Label 8204: @397430
     /* 397430 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(397445), // Rule ID 8839 //
     /* 397435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397438 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 397438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 397443 */     GIR_RootConstrainSelectedInstOperands,
     /* 397444 */     // GIR_Coverage, 8839,
     /* 397444 */     GIR_Done,
     /* 397445 */   // Label 8205: @397445
     /* 397445 */   GIM_Reject,
     /* 397446 */ // Label 8203: @397446
     /* 397446 */ GIM_Reject,
     /* 397447 */ // Label 8173: @397447
     /* 397447 */ GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(397472), // Rule ID 8862 //
     /* 397452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 397458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 397461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 397465 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 397465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 397470 */   GIR_RootConstrainSelectedInstOperands,
     /* 397471 */   // GIR_Coverage, 8862,
     /* 397471 */   GIR_Done,
     /* 397472 */ // Label 8206: @397472
     /* 397472 */ GIM_Reject,
     /* 397473 */ // Label 8174: @397473
     /* 397473 */ GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(397519),
     /* 397478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 397481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 397484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397488 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(397503), // Rule ID 8834 //
     /* 397493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397496 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 397496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 397501 */     GIR_RootConstrainSelectedInstOperands,
     /* 397502 */     // GIR_Coverage, 8834,
     /* 397502 */     GIR_Done,
     /* 397503 */   // Label 8208: @397503
     /* 397503 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(397518), // Rule ID 8837 //
     /* 397508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397511 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 397511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 397516 */     GIR_RootConstrainSelectedInstOperands,
     /* 397517 */     // GIR_Coverage, 8837,
     /* 397517 */     GIR_Done,
     /* 397518 */   // Label 8209: @397518
     /* 397518 */   GIM_Reject,
     /* 397519 */ // Label 8207: @397519
     /* 397519 */ GIM_Reject,
     /* 397520 */ // Label 8175: @397520
     /* 397520 */ GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(397545), // Rule ID 2405 //
     /* 397525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 397531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 397534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 397538 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 397538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 397543 */   GIR_RootConstrainSelectedInstOperands,
     /* 397544 */   // GIR_Coverage, 2405,
     /* 397544 */   GIR_Done,
     /* 397545 */ // Label 8210: @397545
     /* 397545 */ GIM_Reject,
     /* 397546 */ // Label 8176: @397546
     /* 397546 */ GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(397571), // Rule ID 8833 //
     /* 397551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 397557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 397560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397564 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 397564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 397569 */   GIR_RootConstrainSelectedInstOperands,
     /* 397570 */   // GIR_Coverage, 8833,
     /* 397570 */   GIR_Done,
     /* 397571 */ // Label 8211: @397571
     /* 397571 */ GIM_Reject,
     /* 397572 */ // Label 8177: @397572
     /* 397572 */ GIM_Reject,
     /* 397573 */ // Label 145: @397573
     /* 397573 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8230*/ GIMT_Encode4(398352),
     /* 397584 */ /*GILLT_v2s32*//*Label 8212*/ GIMT_Encode4(397660),
     /* 397588 */ /*GILLT_v2s64*//*Label 8213*/ GIMT_Encode4(397715),
     /* 397592 */ /*GILLT_v4s16*//*Label 8214*/ GIMT_Encode4(397770),
     /* 397596 */ /*GILLT_v4s32*//*Label 8215*/ GIMT_Encode4(397825),
     /* 397600 */ /*GILLT_v8s8*//*Label 8216*/ GIMT_Encode4(397880),
     /* 397604 */ /*GILLT_v8s16*//*Label 8217*/ GIMT_Encode4(397914),
     /* 397608 */ /*GILLT_v16s8*//*Label 8218*/ GIMT_Encode4(397969), GIMT_Encode4(0),
     /* 397616 */ /*GILLT_nxv2s1*//*Label 8219*/ GIMT_Encode4(398003),
     /* 397620 */ /*GILLT_nxv2s16*//*Label 8220*/ GIMT_Encode4(398029),
     /* 397624 */ /*GILLT_nxv2s32*//*Label 8221*/ GIMT_Encode4(398055),
     /* 397628 */ /*GILLT_nxv2s64*//*Label 8222*/ GIMT_Encode4(398081),
     /* 397632 */ /*GILLT_nxv4s1*//*Label 8223*/ GIMT_Encode4(398128),
     /* 397636 */ /*GILLT_nxv4s16*//*Label 8224*/ GIMT_Encode4(398154),
     /* 397640 */ /*GILLT_nxv4s32*//*Label 8225*/ GIMT_Encode4(398180),
     /* 397644 */ /*GILLT_nxv8s1*//*Label 8226*/ GIMT_Encode4(398227),
     /* 397648 */ /*GILLT_nxv8s16*//*Label 8227*/ GIMT_Encode4(398253),
     /* 397652 */ /*GILLT_nxv16s1*//*Label 8228*/ GIMT_Encode4(398300),
     /* 397656 */ /*GILLT_nxv16s8*//*Label 8229*/ GIMT_Encode4(398326),
     /* 397660 */ // Label 8212: @397660
     /* 397660 */ GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(397714),
     /* 397665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397683 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(397698), // Rule ID 1874 //
     /* 397688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397691 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 397691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 397696 */     GIR_RootConstrainSelectedInstOperands,
     /* 397697 */     // GIR_Coverage, 1874,
     /* 397697 */     GIR_Done,
     /* 397698 */   // Label 8232: @397698
     /* 397698 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(397713), // Rule ID 5416 //
     /* 397703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397706 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 397706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 397711 */     GIR_RootConstrainSelectedInstOperands,
     /* 397712 */     // GIR_Coverage, 5416,
     /* 397712 */     GIR_Done,
     /* 397713 */   // Label 8233: @397713
     /* 397713 */   GIM_Reject,
     /* 397714 */ // Label 8231: @397714
     /* 397714 */ GIM_Reject,
     /* 397715 */ // Label 8213: @397715
     /* 397715 */ GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(397769),
     /* 397720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 397726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397738 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(397753), // Rule ID 1876 //
     /* 397743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397746 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 397746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 397751 */     GIR_RootConstrainSelectedInstOperands,
     /* 397752 */     // GIR_Coverage, 1876,
     /* 397752 */     GIR_Done,
     /* 397753 */   // Label 8235: @397753
     /* 397753 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(397768), // Rule ID 5418 //
     /* 397758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397761 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 397761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 397766 */     GIR_RootConstrainSelectedInstOperands,
     /* 397767 */     // GIR_Coverage, 5418,
     /* 397767 */     GIR_Done,
     /* 397768 */   // Label 8236: @397768
     /* 397768 */   GIM_Reject,
     /* 397769 */ // Label 8234: @397769
     /* 397769 */ GIM_Reject,
     /* 397770 */ // Label 8214: @397770
     /* 397770 */ GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(397824),
     /* 397775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 397781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397793 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(397808), // Rule ID 1872 //
     /* 397798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397801 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 397801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 397806 */     GIR_RootConstrainSelectedInstOperands,
     /* 397807 */     // GIR_Coverage, 1872,
     /* 397807 */     GIR_Done,
     /* 397808 */   // Label 8238: @397808
     /* 397808 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(397823), // Rule ID 5414 //
     /* 397813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397816 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 397816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 397821 */     GIR_RootConstrainSelectedInstOperands,
     /* 397822 */     // GIR_Coverage, 5414,
     /* 397822 */     GIR_Done,
     /* 397823 */   // Label 8239: @397823
     /* 397823 */   GIM_Reject,
     /* 397824 */ // Label 8237: @397824
     /* 397824 */ GIM_Reject,
     /* 397825 */ // Label 8215: @397825
     /* 397825 */ GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(397879),
     /* 397830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397848 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(397863), // Rule ID 1875 //
     /* 397853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397856 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 397856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 397861 */     GIR_RootConstrainSelectedInstOperands,
     /* 397862 */     // GIR_Coverage, 1875,
     /* 397862 */     GIR_Done,
     /* 397863 */   // Label 8241: @397863
     /* 397863 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(397878), // Rule ID 5417 //
     /* 397868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397871 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 397871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 397876 */     GIR_RootConstrainSelectedInstOperands,
     /* 397877 */     // GIR_Coverage, 5417,
     /* 397877 */     GIR_Done,
     /* 397878 */   // Label 8242: @397878
     /* 397878 */   GIM_Reject,
     /* 397879 */ // Label 8240: @397879
     /* 397879 */ GIM_Reject,
     /* 397880 */ // Label 8216: @397880
     /* 397880 */ GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(397913), // Rule ID 1870 //
     /* 397885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 397891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 397894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397906 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 397906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 397911 */   GIR_RootConstrainSelectedInstOperands,
     /* 397912 */   // GIR_Coverage, 1870,
     /* 397912 */   GIR_Done,
     /* 397913 */ // Label 8243: @397913
     /* 397913 */ GIM_Reject,
     /* 397914 */ // Label 8217: @397914
     /* 397914 */ GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(397968),
     /* 397919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 397925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397937 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(397952), // Rule ID 1873 //
     /* 397942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397945 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 397945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 397950 */     GIR_RootConstrainSelectedInstOperands,
     /* 397951 */     // GIR_Coverage, 1873,
     /* 397951 */     GIR_Done,
     /* 397952 */   // Label 8245: @397952
     /* 397952 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(397967), // Rule ID 5415 //
     /* 397957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397960 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 397960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 397965 */     GIR_RootConstrainSelectedInstOperands,
     /* 397966 */     // GIR_Coverage, 5415,
     /* 397966 */     GIR_Done,
     /* 397967 */   // Label 8246: @397967
     /* 397967 */   GIM_Reject,
     /* 397968 */ // Label 8244: @397968
     /* 397968 */ GIM_Reject,
     /* 397969 */ // Label 8218: @397969
     /* 397969 */ GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(398002), // Rule ID 1871 //
     /* 397974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 397983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397995 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 397995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 398000 */   GIR_RootConstrainSelectedInstOperands,
     /* 398001 */   // GIR_Coverage, 1871,
     /* 398001 */   GIR_Done,
     /* 398002 */ // Label 8247: @398002
     /* 398002 */ GIM_Reject,
     /* 398003 */ // Label 8219: @398003
     /* 398003 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(398028), // Rule ID 8867 //
     /* 398008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 398014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 398017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398021 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 398021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 398026 */   GIR_RootConstrainSelectedInstOperands,
     /* 398027 */   // GIR_Coverage, 8867,
     /* 398027 */   GIR_Done,
     /* 398028 */ // Label 8248: @398028
     /* 398028 */ GIM_Reject,
     /* 398029 */ // Label 8220: @398029
     /* 398029 */ GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(398054), // Rule ID 8850 //
     /* 398034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 398040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 398043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398047 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 398047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 398052 */   GIR_RootConstrainSelectedInstOperands,
     /* 398053 */   // GIR_Coverage, 8850,
     /* 398053 */   GIR_Done,
     /* 398054 */ // Label 8249: @398054
     /* 398054 */ GIM_Reject,
     /* 398055 */ // Label 8221: @398055
     /* 398055 */ GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(398080), // Rule ID 8851 //
     /* 398060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 398066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 398069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398073 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 398073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 398078 */   GIR_RootConstrainSelectedInstOperands,
     /* 398079 */   // GIR_Coverage, 8851,
     /* 398079 */   GIR_Done,
     /* 398080 */ // Label 8250: @398080
     /* 398080 */ GIM_Reject,
     /* 398081 */ // Label 8222: @398081
     /* 398081 */ GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(398127),
     /* 398086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 398089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 398092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398096 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(398111), // Rule ID 8846 //
     /* 398101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398104 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 398104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 398109 */     GIR_RootConstrainSelectedInstOperands,
     /* 398110 */     // GIR_Coverage, 8846,
     /* 398110 */     GIR_Done,
     /* 398111 */   // Label 8252: @398111
     /* 398111 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(398126), // Rule ID 8852 //
     /* 398116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398119 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 398119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 398124 */     GIR_RootConstrainSelectedInstOperands,
     /* 398125 */     // GIR_Coverage, 8852,
     /* 398125 */     GIR_Done,
     /* 398126 */   // Label 8253: @398126
     /* 398126 */   GIM_Reject,
     /* 398127 */ // Label 8251: @398127
     /* 398127 */ GIM_Reject,
     /* 398128 */ // Label 8223: @398128
     /* 398128 */ GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(398153), // Rule ID 8866 //
     /* 398133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 398139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 398142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398146 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 398146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 398151 */   GIR_RootConstrainSelectedInstOperands,
     /* 398152 */   // GIR_Coverage, 8866,
     /* 398152 */   GIR_Done,
     /* 398153 */ // Label 8254: @398153
     /* 398153 */ GIM_Reject,
     /* 398154 */ // Label 8224: @398154
     /* 398154 */ GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(398179), // Rule ID 8848 //
     /* 398159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 398165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 398168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398172 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 398172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 398177 */   GIR_RootConstrainSelectedInstOperands,
     /* 398178 */   // GIR_Coverage, 8848,
     /* 398178 */   GIR_Done,
     /* 398179 */ // Label 8255: @398179
     /* 398179 */ GIM_Reject,
     /* 398180 */ // Label 8225: @398180
     /* 398180 */ GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(398226),
     /* 398185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 398188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 398191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398195 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(398210), // Rule ID 8845 //
     /* 398200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398203 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 398203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 398208 */     GIR_RootConstrainSelectedInstOperands,
     /* 398209 */     // GIR_Coverage, 8845,
     /* 398209 */     GIR_Done,
     /* 398210 */   // Label 8257: @398210
     /* 398210 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(398225), // Rule ID 8849 //
     /* 398215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398218 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 398218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 398223 */     GIR_RootConstrainSelectedInstOperands,
     /* 398224 */     // GIR_Coverage, 8849,
     /* 398224 */     GIR_Done,
     /* 398225 */   // Label 8258: @398225
     /* 398225 */   GIM_Reject,
     /* 398226 */ // Label 8256: @398226
     /* 398226 */ GIM_Reject,
     /* 398227 */ // Label 8226: @398227
     /* 398227 */ GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(398252), // Rule ID 8865 //
     /* 398232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 398238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 398241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398245 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 398245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 398250 */   GIR_RootConstrainSelectedInstOperands,
     /* 398251 */   // GIR_Coverage, 8865,
     /* 398251 */   GIR_Done,
     /* 398252 */ // Label 8259: @398252
     /* 398252 */ GIM_Reject,
     /* 398253 */ // Label 8227: @398253
     /* 398253 */ GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(398299),
     /* 398258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 398261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 398264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398268 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(398283), // Rule ID 8844 //
     /* 398273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398276 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 398276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 398281 */     GIR_RootConstrainSelectedInstOperands,
     /* 398282 */     // GIR_Coverage, 8844,
     /* 398282 */     GIR_Done,
     /* 398283 */   // Label 8261: @398283
     /* 398283 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(398298), // Rule ID 8847 //
     /* 398288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398291 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 398291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 398296 */     GIR_RootConstrainSelectedInstOperands,
     /* 398297 */     // GIR_Coverage, 8847,
     /* 398297 */     GIR_Done,
     /* 398298 */   // Label 8262: @398298
     /* 398298 */   GIM_Reject,
     /* 398299 */ // Label 8260: @398299
     /* 398299 */ GIM_Reject,
     /* 398300 */ // Label 8228: @398300
     /* 398300 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(398325), // Rule ID 2409 //
     /* 398305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 398311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 398314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398318 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 398318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 398323 */   GIR_RootConstrainSelectedInstOperands,
     /* 398324 */   // GIR_Coverage, 2409,
     /* 398324 */   GIR_Done,
     /* 398325 */ // Label 8263: @398325
     /* 398325 */ GIM_Reject,
     /* 398326 */ // Label 8229: @398326
     /* 398326 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(398351), // Rule ID 8843 //
     /* 398331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 398337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 398340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398344 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 398344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 398349 */   GIR_RootConstrainSelectedInstOperands,
     /* 398350 */   // GIR_Coverage, 8843,
     /* 398350 */   GIR_Done,
     /* 398351 */ // Label 8264: @398351
     /* 398351 */ GIM_Reject,
     /* 398352 */ // Label 8230: @398352
     /* 398352 */ GIM_Reject,
     /* 398353 */ // Label 146: @398353
     /* 398353 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8271*/ GIMT_Encode4(398558),
     /* 398364 */ /*GILLT_s64*//*Label 8265*/ GIMT_Encode4(398396), GIMT_Encode4(0),
     /* 398372 */ /*GILLT_v2s32*//*Label 8266*/ GIMT_Encode4(398423),
     /* 398376 */ /*GILLT_v2s64*//*Label 8267*/ GIMT_Encode4(398450),
     /* 398380 */ /*GILLT_v4s16*//*Label 8268*/ GIMT_Encode4(398477),
     /* 398384 */ /*GILLT_v4s32*//*Label 8269*/ GIMT_Encode4(398504), GIMT_Encode4(0),
     /* 398392 */ /*GILLT_v8s16*//*Label 8270*/ GIMT_Encode4(398531),
     /* 398396 */ // Label 8265: @398396
     /* 398396 */ GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(398422), // Rule ID 1062 //
     /* 398401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398415 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 398415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 398420 */   GIR_RootConstrainSelectedInstOperands,
     /* 398421 */   // GIR_Coverage, 1062,
     /* 398421 */   GIR_Done,
     /* 398422 */ // Label 8272: @398422
     /* 398422 */ GIM_Reject,
     /* 398423 */ // Label 8266: @398423
     /* 398423 */ GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(398449), // Rule ID 1058 //
     /* 398428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398442 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 398447 */   GIR_RootConstrainSelectedInstOperands,
     /* 398448 */   // GIR_Coverage, 1058,
     /* 398448 */   GIR_Done,
     /* 398449 */ // Label 8273: @398449
     /* 398449 */ GIM_Reject,
     /* 398450 */ // Label 8267: @398450
     /* 398450 */ GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(398476), // Rule ID 1064 //
     /* 398455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398469 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 398474 */   GIR_RootConstrainSelectedInstOperands,
     /* 398475 */   // GIR_Coverage, 1064,
     /* 398475 */   GIR_Done,
     /* 398476 */ // Label 8274: @398476
     /* 398476 */ GIM_Reject,
     /* 398477 */ // Label 8268: @398477
     /* 398477 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(398503), // Rule ID 1054 //
     /* 398482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398496 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 398496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 398501 */   GIR_RootConstrainSelectedInstOperands,
     /* 398502 */   // GIR_Coverage, 1054,
     /* 398502 */   GIR_Done,
     /* 398503 */ // Label 8275: @398503
     /* 398503 */ GIM_Reject,
     /* 398504 */ // Label 8269: @398504
     /* 398504 */ GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(398530), // Rule ID 1060 //
     /* 398509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398523 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 398528 */   GIR_RootConstrainSelectedInstOperands,
     /* 398529 */   // GIR_Coverage, 1060,
     /* 398529 */   GIR_Done,
     /* 398530 */ // Label 8276: @398530
     /* 398530 */ GIM_Reject,
     /* 398531 */ // Label 8270: @398531
     /* 398531 */ GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(398557), // Rule ID 1056 //
     /* 398536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398550 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 398550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 398555 */   GIR_RootConstrainSelectedInstOperands,
     /* 398556 */   // GIR_Coverage, 1056,
     /* 398556 */   GIR_Done,
     /* 398557 */ // Label 8277: @398557
     /* 398557 */ GIM_Reject,
     /* 398558 */ // Label 8271: @398558
     /* 398558 */ GIM_Reject,
     /* 398559 */ // Label 147: @398559
     /* 398559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8280*/ GIMT_Encode4(399425),
     /* 398570 */ /*GILLT_v2s64*//*Label 8278*/ GIMT_Encode4(398582), GIMT_Encode4(0),
     /* 398578 */ /*GILLT_v4s32*//*Label 8279*/ GIMT_Encode4(398876),
     /* 398582 */ // Label 8278: @398582
     /* 398582 */ GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(398664), // Rule ID 5783 //
     /* 398587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398594 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398598 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398602 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398605 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398610 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398614 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398621 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 398621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 398628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398633 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 398637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 398642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 398653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398663 */   // GIR_Coverage, 5783,
     /* 398663 */   GIR_EraseRootFromParent_Done,
     /* 398664 */ // Label 8281: @398664
     /* 398664 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(398738), // Rule ID 5782 //
     /* 398669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 398684 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398688 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398695 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 398695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 398702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398707 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 398711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 398716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 398727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398737 */   // GIR_Coverage, 5782,
     /* 398737 */   GIR_EraseRootFromParent_Done,
     /* 398738 */ // Label 8282: @398738
     /* 398738 */ GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(398797), // Rule ID 5792 //
     /* 398743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398754 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 398754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 398761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398766 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 398775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 398786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398796 */   // GIR_Coverage, 5792,
     /* 398796 */   GIR_EraseRootFromParent_Done,
     /* 398797 */ // Label 8283: @398797
     /* 398797 */ GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(398875), // Rule ID 5920 //
     /* 398802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398813 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 398813 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 398816 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 398820 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398825 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 398834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 398856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 398859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398874 */   // GIR_Coverage, 5920,
     /* 398874 */   GIR_EraseRootFromParent_Done,
     /* 398875 */ // Label 8284: @398875
     /* 398875 */ GIM_Reject,
     /* 398876 */ // Label 8279: @398876
     /* 398876 */ GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(398958), // Rule ID 5785 //
     /* 398881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398888 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398892 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398896 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398899 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398904 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 398908 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398913 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398915 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 398915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 398918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 398922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398927 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 398931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 398936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 398947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398957 */   // GIR_Coverage, 5785,
     /* 398957 */   GIR_EraseRootFromParent_Done,
     /* 398958 */ // Label 8285: @398958
     /* 398958 */ GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(399040), // Rule ID 5787 //
     /* 398963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398970 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 398978 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 398981 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 398986 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 398990 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398997 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 398997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 399004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399009 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 399013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 399029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399039 */   // GIR_Coverage, 5787,
     /* 399039 */   GIR_EraseRootFromParent_Done,
     /* 399040 */ // Label 8286: @399040
     /* 399040 */ GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(399114), // Rule ID 5784 //
     /* 399045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 399060 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399064 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399071 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 399071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 399078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399083 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 399087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 399103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399108 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399113 */   // GIR_Coverage, 5784,
     /* 399113 */   GIR_EraseRootFromParent_Done,
     /* 399114 */ // Label 8287: @399114
     /* 399114 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(399188), // Rule ID 5786 //
     /* 399119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 399134 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399138 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399145 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 399145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 399152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399157 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 399161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 399177 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399187 */   // GIR_Coverage, 5786,
     /* 399187 */   GIR_EraseRootFromParent_Done,
     /* 399188 */ // Label 8288: @399188
     /* 399188 */ GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(399247), // Rule ID 5788 //
     /* 399193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399204 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 399204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 399211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399216 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 399236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399246 */   // GIR_Coverage, 5788,
     /* 399246 */   GIR_EraseRootFromParent_Done,
     /* 399247 */ // Label 8289: @399247
     /* 399247 */ GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(399306), // Rule ID 5789 //
     /* 399252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399263 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 399263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 399270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399275 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 399295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399305 */   // GIR_Coverage, 5789,
     /* 399305 */   GIR_EraseRootFromParent_Done,
     /* 399306 */ // Label 8290: @399306
     /* 399306 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(399365), // Rule ID 5790 //
     /* 399311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399322 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 399322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 399329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399334 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 399354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399364 */   // GIR_Coverage, 5790,
     /* 399364 */   GIR_EraseRootFromParent_Done,
     /* 399365 */ // Label 8291: @399365
     /* 399365 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(399424), // Rule ID 5791 //
     /* 399370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399381 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 399381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 399388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399393 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 399413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399423 */   // GIR_Coverage, 5791,
     /* 399423 */   GIR_EraseRootFromParent_Done,
     /* 399424 */ // Label 8292: @399424
     /* 399424 */ GIM_Reject,
     /* 399425 */ // Label 8280: @399425
     /* 399425 */ GIM_Reject,
     /* 399426 */ // Label 148: @399426
     /* 399426 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8297*/ GIMT_Encode4(399795),
     /* 399437 */ /*GILLT_v2s32*//*Label 8293*/ GIMT_Encode4(399497), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399449 */ /*GILLT_v4s32*//*Label 8294*/ GIMT_Encode4(399617), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399481 */ /*GILLT_nxv2s64*//*Label 8295*/ GIMT_Encode4(399737), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399493 */ /*GILLT_nxv4s32*//*Label 8296*/ GIMT_Encode4(399766),
     /* 399497 */ // Label 8293: @399497
     /* 399497 */ GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(399616),
     /* 399502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 399511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399523 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(399596), // Rule ID 28 //
     /* 399528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 399531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 399539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399572 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399576 */     // MIs[3] Operand 1
     /* 399576 */     // No operand predicates
     /* 399576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399578 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 399581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 399585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399594 */     GIR_RootConstrainSelectedInstOperands,
     /* 399595 */     // GIR_Coverage, 28,
     /* 399595 */     GIR_EraseRootFromParent_Done,
     /* 399596 */   // Label 8299: @399596
     /* 399596 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(399615), // Rule ID 24 //
     /* 399601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 399604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399608 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 399608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 399613 */     GIR_RootConstrainSelectedInstOperands,
     /* 399614 */     // GIR_Coverage, 24,
     /* 399614 */     GIR_Done,
     /* 399615 */   // Label 8300: @399615
     /* 399615 */   GIM_Reject,
     /* 399616 */ // Label 8298: @399616
     /* 399616 */ GIM_Reject,
     /* 399617 */ // Label 8294: @399617
     /* 399617 */ GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(399736),
     /* 399622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 399628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 399631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399643 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(399716), // Rule ID 29 //
     /* 399648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 399651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 399659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399692 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399696 */     // MIs[3] Operand 1
     /* 399696 */     // No operand predicates
     /* 399696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399698 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 399701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 399705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399714 */     GIR_RootConstrainSelectedInstOperands,
     /* 399715 */     // GIR_Coverage, 29,
     /* 399715 */     GIR_EraseRootFromParent_Done,
     /* 399716 */   // Label 8302: @399716
     /* 399716 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(399735), // Rule ID 25 //
     /* 399721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 399724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399728 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 399728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 399733 */     GIR_RootConstrainSelectedInstOperands,
     /* 399734 */     // GIR_Coverage, 25,
     /* 399734 */     GIR_Done,
     /* 399735 */   // Label 8303: @399735
     /* 399735 */   GIM_Reject,
     /* 399736 */ // Label 8301: @399736
     /* 399736 */ GIM_Reject,
     /* 399737 */ // Label 8295: @399737
     /* 399737 */ GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(399765), // Rule ID 7554 //
     /* 399742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 399748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 399751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 399754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399758 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 399758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 399763 */   GIR_RootConstrainSelectedInstOperands,
     /* 399764 */   // GIR_Coverage, 7554,
     /* 399764 */   GIR_Done,
     /* 399765 */ // Label 8304: @399765
     /* 399765 */ GIM_Reject,
     /* 399766 */ // Label 8296: @399766
     /* 399766 */ GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(399794), // Rule ID 7553 //
     /* 399771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 399777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 399783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399787 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 399787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 399792 */   GIR_RootConstrainSelectedInstOperands,
     /* 399793 */   // GIR_Coverage, 7553,
     /* 399793 */   GIR_Done,
     /* 399794 */ // Label 8305: @399794
     /* 399794 */ GIM_Reject,
     /* 399795 */ // Label 8297: @399795
     /* 399795 */ GIM_Reject,
     /* 399796 */ // Label 149: @399796
     /* 399796 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8309*/ GIMT_Encode4(399912),
     /* 399807 */ /*GILLT_s16*//*Label 8306*/ GIMT_Encode4(399819),
     /* 399811 */ /*GILLT_s32*//*Label 8307*/ GIMT_Encode4(399850),
     /* 399815 */ /*GILLT_s64*//*Label 8308*/ GIMT_Encode4(399881),
     /* 399819 */ // Label 8306: @399819
     /* 399819 */ GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(399849), // Rule ID 1662 //
     /* 399824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 399827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 399830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399838 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 399838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 399843 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399847 */   GIR_RootConstrainSelectedInstOperands,
     /* 399848 */   // GIR_Coverage, 1662,
     /* 399848 */   GIR_Done,
     /* 399849 */ // Label 8310: @399849
     /* 399849 */ GIM_Reject,
     /* 399850 */ // Label 8307: @399850
     /* 399850 */ GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(399880), // Rule ID 1661 //
     /* 399855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 399858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399869 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 399869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 399874 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399878 */   GIR_RootConstrainSelectedInstOperands,
     /* 399879 */   // GIR_Coverage, 1661,
     /* 399879 */   GIR_Done,
     /* 399880 */ // Label 8311: @399880
     /* 399880 */ GIM_Reject,
     /* 399881 */ // Label 8308: @399881
     /* 399881 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(399911), // Rule ID 1660 //
     /* 399886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 399889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399900 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 399900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 399905 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399909 */   GIR_RootConstrainSelectedInstOperands,
     /* 399910 */   // GIR_Coverage, 1660,
     /* 399910 */   GIR_Done,
     /* 399911 */ // Label 8312: @399911
     /* 399911 */ GIM_Reject,
     /* 399912 */ // Label 8309: @399912
     /* 399912 */ GIM_Reject,
     /* 399913 */ // Label 150: @399913
     /* 399913 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8316*/ GIMT_Encode4(401145),
     /* 399924 */ /*GILLT_v2s64*//*Label 8313*/ GIMT_Encode4(399944), GIMT_Encode4(0),
     /* 399932 */ /*GILLT_v4s32*//*Label 8314*/ GIMT_Encode4(400505), GIMT_Encode4(0),
     /* 399940 */ /*GILLT_v8s16*//*Label 8315*/ GIMT_Encode4(401066),
     /* 399944 */ // Label 8313: @399944
     /* 399944 */ GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(400504),
     /* 399949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399959 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(400051), // Rule ID 2099 //
     /* 399964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400008 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400012 */     // MIs[3] Operand 1
     /* 400012 */     // No operand predicates
     /* 400012 */     // MIs[1] Operand 2
     /* 400012 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 400023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 400032 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 400035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400049 */     GIR_RootConstrainSelectedInstOperands,
     /* 400050 */     // GIR_Coverage, 2099,
     /* 400050 */     GIR_EraseRootFromParent_Done,
     /* 400051 */   // Label 8318: @400051
     /* 400051 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(400143), // Rule ID 13326 //
     /* 400056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400100 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400104 */     // MIs[3] Operand 1
     /* 400104 */     // No operand predicates
     /* 400104 */     // MIs[1] Operand 2
     /* 400104 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 400115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 400124 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 400127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400141 */     GIR_RootConstrainSelectedInstOperands,
     /* 400142 */     // GIR_Coverage, 13326,
     /* 400142 */     GIR_EraseRootFromParent_Done,
     /* 400143 */   // Label 8319: @400143
     /* 400143 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(400229), // Rule ID 13324 //
     /* 400148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400192 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400196 */     // MIs[3] Operand 1
     /* 400196 */     // No operand predicates
     /* 400196 */     // MIs[1] Operand 2
     /* 400196 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400213 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 400216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400227 */     GIR_RootConstrainSelectedInstOperands,
     /* 400228 */     // GIR_Coverage, 13324,
     /* 400228 */     GIR_EraseRootFromParent_Done,
     /* 400229 */   // Label 8320: @400229
     /* 400229 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(400315), // Rule ID 2097 //
     /* 400234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400286 */     // MIs[3] Operand 1
     /* 400286 */     // No operand predicates
     /* 400286 */     // MIs[1] Operand 2
     /* 400286 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400299 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 400302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400313 */     GIR_RootConstrainSelectedInstOperands,
     /* 400314 */     // GIR_Coverage, 2097,
     /* 400314 */     GIR_EraseRootFromParent_Done,
     /* 400315 */   // Label 8321: @400315
     /* 400315 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(400354), // Rule ID 1824 //
     /* 400320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 400330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 400337 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 400337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 400340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 400352 */     GIR_RootConstrainSelectedInstOperands,
     /* 400353 */     // GIR_Coverage, 1824,
     /* 400353 */     GIR_EraseRootFromParent_Done,
     /* 400354 */   // Label 8322: @400354
     /* 400354 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(400417), // Rule ID 13325 //
     /* 400359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400391 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400395 */     // MIs[2] Operand 1
     /* 400395 */     // No operand predicates
     /* 400395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400401 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 400404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400415 */     GIR_RootConstrainSelectedInstOperands,
     /* 400416 */     // GIR_Coverage, 13325,
     /* 400416 */     GIR_EraseRootFromParent_Done,
     /* 400417 */   // Label 8323: @400417
     /* 400417 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(400480), // Rule ID 2098 //
     /* 400422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400458 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400462 */     // MIs[2] Operand 1
     /* 400462 */     // No operand predicates
     /* 400462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400464 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 400467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400478 */     GIR_RootConstrainSelectedInstOperands,
     /* 400479 */     // GIR_Coverage, 2098,
     /* 400479 */     GIR_EraseRootFromParent_Done,
     /* 400480 */   // Label 8324: @400480
     /* 400480 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(400503), // Rule ID 1823 //
     /* 400485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400496 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 400496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 400501 */     GIR_RootConstrainSelectedInstOperands,
     /* 400502 */     // GIR_Coverage, 1823,
     /* 400502 */     GIR_Done,
     /* 400503 */   // Label 8325: @400503
     /* 400503 */   GIM_Reject,
     /* 400504 */ // Label 8317: @400504
     /* 400504 */ GIM_Reject,
     /* 400505 */ // Label 8314: @400505
     /* 400505 */ GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(401065),
     /* 400510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400520 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(400612), // Rule ID 2096 //
     /* 400525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400573 */     // MIs[3] Operand 1
     /* 400573 */     // No operand predicates
     /* 400573 */     // MIs[1] Operand 2
     /* 400573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 400584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 400593 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 400596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400610 */     GIR_RootConstrainSelectedInstOperands,
     /* 400611 */     // GIR_Coverage, 2096,
     /* 400611 */     GIR_EraseRootFromParent_Done,
     /* 400612 */   // Label 8327: @400612
     /* 400612 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(400704), // Rule ID 13323 //
     /* 400617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400661 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400665 */     // MIs[3] Operand 1
     /* 400665 */     // No operand predicates
     /* 400665 */     // MIs[1] Operand 2
     /* 400665 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 400676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 400685 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 400688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400702 */     GIR_RootConstrainSelectedInstOperands,
     /* 400703 */     // GIR_Coverage, 13323,
     /* 400703 */     GIR_EraseRootFromParent_Done,
     /* 400704 */   // Label 8328: @400704
     /* 400704 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(400790), // Rule ID 13321 //
     /* 400709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400753 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400757 */     // MIs[3] Operand 1
     /* 400757 */     // No operand predicates
     /* 400757 */     // MIs[1] Operand 2
     /* 400757 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400774 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 400777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400788 */     GIR_RootConstrainSelectedInstOperands,
     /* 400789 */     // GIR_Coverage, 13321,
     /* 400789 */     GIR_EraseRootFromParent_Done,
     /* 400790 */   // Label 8329: @400790
     /* 400790 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(400876), // Rule ID 2094 //
     /* 400795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400843 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400847 */     // MIs[3] Operand 1
     /* 400847 */     // No operand predicates
     /* 400847 */     // MIs[1] Operand 2
     /* 400847 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400860 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 400863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400874 */     GIR_RootConstrainSelectedInstOperands,
     /* 400875 */     // GIR_Coverage, 2094,
     /* 400875 */     GIR_EraseRootFromParent_Done,
     /* 400876 */   // Label 8330: @400876
     /* 400876 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(400915), // Rule ID 1822 //
     /* 400881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 400891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 400898 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 400898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 400901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 400913 */     GIR_RootConstrainSelectedInstOperands,
     /* 400914 */     // GIR_Coverage, 1822,
     /* 400914 */     GIR_EraseRootFromParent_Done,
     /* 400915 */   // Label 8331: @400915
     /* 400915 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(400978), // Rule ID 13322 //
     /* 400920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400952 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400956 */     // MIs[2] Operand 1
     /* 400956 */     // No operand predicates
     /* 400956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400962 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 400965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400976 */     GIR_RootConstrainSelectedInstOperands,
     /* 400977 */     // GIR_Coverage, 13322,
     /* 400977 */     GIR_EraseRootFromParent_Done,
     /* 400978 */   // Label 8332: @400978
     /* 400978 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(401041), // Rule ID 2095 //
     /* 400983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401023 */     // MIs[2] Operand 1
     /* 401023 */     // No operand predicates
     /* 401023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401025 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 401028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401039 */     GIR_RootConstrainSelectedInstOperands,
     /* 401040 */     // GIR_Coverage, 2095,
     /* 401040 */     GIR_EraseRootFromParent_Done,
     /* 401041 */   // Label 8333: @401041
     /* 401041 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(401064), // Rule ID 1821 //
     /* 401046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401057 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 401057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 401062 */     GIR_RootConstrainSelectedInstOperands,
     /* 401063 */     // GIR_Coverage, 1821,
     /* 401063 */     GIR_Done,
     /* 401064 */   // Label 8334: @401064
     /* 401064 */   GIM_Reject,
     /* 401065 */ // Label 8326: @401065
     /* 401065 */ GIM_Reject,
     /* 401066 */ // Label 8315: @401066
     /* 401066 */ GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(401144),
     /* 401071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 401074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 401077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401081 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(401120), // Rule ID 1820 //
     /* 401086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 401096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 401103 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 401103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 401106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 401113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 401118 */     GIR_RootConstrainSelectedInstOperands,
     /* 401119 */     // GIR_Coverage, 1820,
     /* 401119 */     GIR_EraseRootFromParent_Done,
     /* 401120 */   // Label 8336: @401120
     /* 401120 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(401143), // Rule ID 1819 //
     /* 401125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401136 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 401136 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 401141 */     GIR_RootConstrainSelectedInstOperands,
     /* 401142 */     // GIR_Coverage, 1819,
     /* 401142 */     GIR_Done,
     /* 401143 */   // Label 8337: @401143
     /* 401143 */   GIM_Reject,
     /* 401144 */ // Label 8335: @401144
     /* 401144 */ GIM_Reject,
     /* 401145 */ // Label 8316: @401145
     /* 401145 */ GIM_Reject,
     /* 401146 */ // Label 151: @401146
     /* 401146 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8356*/ GIMT_Encode4(401925),
     /* 401157 */ /*GILLT_v2s32*//*Label 8338*/ GIMT_Encode4(401233),
     /* 401161 */ /*GILLT_v2s64*//*Label 8339*/ GIMT_Encode4(401288),
     /* 401165 */ /*GILLT_v4s16*//*Label 8340*/ GIMT_Encode4(401343),
     /* 401169 */ /*GILLT_v4s32*//*Label 8341*/ GIMT_Encode4(401398),
     /* 401173 */ /*GILLT_v8s8*//*Label 8342*/ GIMT_Encode4(401453),
     /* 401177 */ /*GILLT_v8s16*//*Label 8343*/ GIMT_Encode4(401487),
     /* 401181 */ /*GILLT_v16s8*//*Label 8344*/ GIMT_Encode4(401542), GIMT_Encode4(0),
     /* 401189 */ /*GILLT_nxv2s1*//*Label 8345*/ GIMT_Encode4(401576),
     /* 401193 */ /*GILLT_nxv2s16*//*Label 8346*/ GIMT_Encode4(401602),
     /* 401197 */ /*GILLT_nxv2s32*//*Label 8347*/ GIMT_Encode4(401628),
     /* 401201 */ /*GILLT_nxv2s64*//*Label 8348*/ GIMT_Encode4(401654),
     /* 401205 */ /*GILLT_nxv4s1*//*Label 8349*/ GIMT_Encode4(401701),
     /* 401209 */ /*GILLT_nxv4s16*//*Label 8350*/ GIMT_Encode4(401727),
     /* 401213 */ /*GILLT_nxv4s32*//*Label 8351*/ GIMT_Encode4(401753),
     /* 401217 */ /*GILLT_nxv8s1*//*Label 8352*/ GIMT_Encode4(401800),
     /* 401221 */ /*GILLT_nxv8s16*//*Label 8353*/ GIMT_Encode4(401826),
     /* 401225 */ /*GILLT_nxv16s1*//*Label 8354*/ GIMT_Encode4(401873),
     /* 401229 */ /*GILLT_nxv16s8*//*Label 8355*/ GIMT_Encode4(401899),
     /* 401233 */ // Label 8338: @401233
     /* 401233 */ GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(401287),
     /* 401238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401256 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(401271), // Rule ID 1881 //
     /* 401261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401264 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 401264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 401269 */     GIR_RootConstrainSelectedInstOperands,
     /* 401270 */     // GIR_Coverage, 1881,
     /* 401270 */     GIR_Done,
     /* 401271 */   // Label 8358: @401271
     /* 401271 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(401286), // Rule ID 5421 //
     /* 401276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401279 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 401284 */     GIR_RootConstrainSelectedInstOperands,
     /* 401285 */     // GIR_Coverage, 5421,
     /* 401285 */     GIR_Done,
     /* 401286 */   // Label 8359: @401286
     /* 401286 */   GIM_Reject,
     /* 401287 */ // Label 8357: @401287
     /* 401287 */ GIM_Reject,
     /* 401288 */ // Label 8339: @401288
     /* 401288 */ GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(401342),
     /* 401293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401311 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(401326), // Rule ID 1883 //
     /* 401316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401319 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 401319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 401324 */     GIR_RootConstrainSelectedInstOperands,
     /* 401325 */     // GIR_Coverage, 1883,
     /* 401325 */     GIR_Done,
     /* 401326 */   // Label 8361: @401326
     /* 401326 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(401341), // Rule ID 5423 //
     /* 401331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401334 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 401339 */     GIR_RootConstrainSelectedInstOperands,
     /* 401340 */     // GIR_Coverage, 5423,
     /* 401340 */     GIR_Done,
     /* 401341 */   // Label 8362: @401341
     /* 401341 */   GIM_Reject,
     /* 401342 */ // Label 8360: @401342
     /* 401342 */ GIM_Reject,
     /* 401343 */ // Label 8340: @401343
     /* 401343 */ GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(401397),
     /* 401348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401366 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(401381), // Rule ID 1879 //
     /* 401371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401374 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 401374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 401379 */     GIR_RootConstrainSelectedInstOperands,
     /* 401380 */     // GIR_Coverage, 1879,
     /* 401380 */     GIR_Done,
     /* 401381 */   // Label 8364: @401381
     /* 401381 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(401396), // Rule ID 5419 //
     /* 401386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401389 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 401394 */     GIR_RootConstrainSelectedInstOperands,
     /* 401395 */     // GIR_Coverage, 5419,
     /* 401395 */     GIR_Done,
     /* 401396 */   // Label 8365: @401396
     /* 401396 */   GIM_Reject,
     /* 401397 */ // Label 8363: @401397
     /* 401397 */ GIM_Reject,
     /* 401398 */ // Label 8341: @401398
     /* 401398 */ GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(401452),
     /* 401403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401421 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(401436), // Rule ID 1882 //
     /* 401426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401429 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 401429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 401434 */     GIR_RootConstrainSelectedInstOperands,
     /* 401435 */     // GIR_Coverage, 1882,
     /* 401435 */     GIR_Done,
     /* 401436 */   // Label 8367: @401436
     /* 401436 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(401451), // Rule ID 5422 //
     /* 401441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401444 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 401449 */     GIR_RootConstrainSelectedInstOperands,
     /* 401450 */     // GIR_Coverage, 5422,
     /* 401450 */     GIR_Done,
     /* 401451 */   // Label 8368: @401451
     /* 401451 */   GIM_Reject,
     /* 401452 */ // Label 8366: @401452
     /* 401452 */ GIM_Reject,
     /* 401453 */ // Label 8342: @401453
     /* 401453 */ GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(401486), // Rule ID 1877 //
     /* 401458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 401464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 401467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401479 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 401479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 401484 */   GIR_RootConstrainSelectedInstOperands,
     /* 401485 */   // GIR_Coverage, 1877,
     /* 401485 */   GIR_Done,
     /* 401486 */ // Label 8369: @401486
     /* 401486 */ GIM_Reject,
     /* 401487 */ // Label 8343: @401487
     /* 401487 */ GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(401541),
     /* 401492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401510 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(401525), // Rule ID 1880 //
     /* 401515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401518 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 401518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 401523 */     GIR_RootConstrainSelectedInstOperands,
     /* 401524 */     // GIR_Coverage, 1880,
     /* 401524 */     GIR_Done,
     /* 401525 */   // Label 8371: @401525
     /* 401525 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(401540), // Rule ID 5420 //
     /* 401530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401533 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 401538 */     GIR_RootConstrainSelectedInstOperands,
     /* 401539 */     // GIR_Coverage, 5420,
     /* 401539 */     GIR_Done,
     /* 401540 */   // Label 8372: @401540
     /* 401540 */   GIM_Reject,
     /* 401541 */ // Label 8370: @401541
     /* 401541 */ GIM_Reject,
     /* 401542 */ // Label 8344: @401542
     /* 401542 */ GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(401575), // Rule ID 1878 //
     /* 401547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 401553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 401556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401568 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 401568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 401573 */   GIR_RootConstrainSelectedInstOperands,
     /* 401574 */   // GIR_Coverage, 1878,
     /* 401574 */   GIR_Done,
     /* 401575 */ // Label 8373: @401575
     /* 401575 */ GIM_Reject,
     /* 401576 */ // Label 8345: @401576
     /* 401576 */ GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(401601), // Rule ID 8858 //
     /* 401581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 401587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 401590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401594 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 401594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 401599 */   GIR_RootConstrainSelectedInstOperands,
     /* 401600 */   // GIR_Coverage, 8858,
     /* 401600 */   GIR_Done,
     /* 401601 */ // Label 8374: @401601
     /* 401601 */ GIM_Reject,
     /* 401602 */ // Label 8346: @401602
     /* 401602 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(401627), // Rule ID 8820 //
     /* 401607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 401613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 401616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401620 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 401620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 401625 */   GIR_RootConstrainSelectedInstOperands,
     /* 401626 */   // GIR_Coverage, 8820,
     /* 401626 */   GIR_Done,
     /* 401627 */ // Label 8375: @401627
     /* 401627 */ GIM_Reject,
     /* 401628 */ // Label 8347: @401628
     /* 401628 */ GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(401653), // Rule ID 8821 //
     /* 401633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 401639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 401642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401646 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 401646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 401651 */   GIR_RootConstrainSelectedInstOperands,
     /* 401652 */   // GIR_Coverage, 8821,
     /* 401652 */   GIR_Done,
     /* 401653 */ // Label 8376: @401653
     /* 401653 */ GIM_Reject,
     /* 401654 */ // Label 8348: @401654
     /* 401654 */ GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(401700),
     /* 401659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 401662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 401665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401669 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(401684), // Rule ID 8816 //
     /* 401674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401677 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 401677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 401682 */     GIR_RootConstrainSelectedInstOperands,
     /* 401683 */     // GIR_Coverage, 8816,
     /* 401683 */     GIR_Done,
     /* 401684 */   // Label 8378: @401684
     /* 401684 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(401699), // Rule ID 8822 //
     /* 401689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401692 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 401692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 401697 */     GIR_RootConstrainSelectedInstOperands,
     /* 401698 */     // GIR_Coverage, 8822,
     /* 401698 */     GIR_Done,
     /* 401699 */   // Label 8379: @401699
     /* 401699 */   GIM_Reject,
     /* 401700 */ // Label 8377: @401700
     /* 401700 */ GIM_Reject,
     /* 401701 */ // Label 8349: @401701
     /* 401701 */ GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(401726), // Rule ID 8857 //
     /* 401706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 401712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 401715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401719 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 401719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 401724 */   GIR_RootConstrainSelectedInstOperands,
     /* 401725 */   // GIR_Coverage, 8857,
     /* 401725 */   GIR_Done,
     /* 401726 */ // Label 8380: @401726
     /* 401726 */ GIM_Reject,
     /* 401727 */ // Label 8350: @401727
     /* 401727 */ GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(401752), // Rule ID 8818 //
     /* 401732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 401738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 401741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401745 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 401745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 401750 */   GIR_RootConstrainSelectedInstOperands,
     /* 401751 */   // GIR_Coverage, 8818,
     /* 401751 */   GIR_Done,
     /* 401752 */ // Label 8381: @401752
     /* 401752 */ GIM_Reject,
     /* 401753 */ // Label 8351: @401753
     /* 401753 */ GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(401799),
     /* 401758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 401761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 401764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401768 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(401783), // Rule ID 8815 //
     /* 401773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401776 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 401776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 401781 */     GIR_RootConstrainSelectedInstOperands,
     /* 401782 */     // GIR_Coverage, 8815,
     /* 401782 */     GIR_Done,
     /* 401783 */   // Label 8383: @401783
     /* 401783 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(401798), // Rule ID 8819 //
     /* 401788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401791 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 401791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 401796 */     GIR_RootConstrainSelectedInstOperands,
     /* 401797 */     // GIR_Coverage, 8819,
     /* 401797 */     GIR_Done,
     /* 401798 */   // Label 8384: @401798
     /* 401798 */   GIM_Reject,
     /* 401799 */ // Label 8382: @401799
     /* 401799 */ GIM_Reject,
     /* 401800 */ // Label 8352: @401800
     /* 401800 */ GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(401825), // Rule ID 8856 //
     /* 401805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 401811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 401814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401818 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 401818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 401823 */   GIR_RootConstrainSelectedInstOperands,
     /* 401824 */   // GIR_Coverage, 8856,
     /* 401824 */   GIR_Done,
     /* 401825 */ // Label 8385: @401825
     /* 401825 */ GIM_Reject,
     /* 401826 */ // Label 8353: @401826
     /* 401826 */ GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(401872),
     /* 401831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 401834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 401837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401841 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(401856), // Rule ID 8814 //
     /* 401846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401849 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 401849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 401854 */     GIR_RootConstrainSelectedInstOperands,
     /* 401855 */     // GIR_Coverage, 8814,
     /* 401855 */     GIR_Done,
     /* 401856 */   // Label 8387: @401856
     /* 401856 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(401871), // Rule ID 8817 //
     /* 401861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401864 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 401864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 401869 */     GIR_RootConstrainSelectedInstOperands,
     /* 401870 */     // GIR_Coverage, 8817,
     /* 401870 */     GIR_Done,
     /* 401871 */   // Label 8388: @401871
     /* 401871 */   GIM_Reject,
     /* 401872 */ // Label 8386: @401872
     /* 401872 */ GIM_Reject,
     /* 401873 */ // Label 8354: @401873
     /* 401873 */ GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(401898), // Rule ID 2397 //
     /* 401878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 401884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 401887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401891 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 401891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 401896 */   GIR_RootConstrainSelectedInstOperands,
     /* 401897 */   // GIR_Coverage, 2397,
     /* 401897 */   GIR_Done,
     /* 401898 */ // Label 8389: @401898
     /* 401898 */ GIM_Reject,
     /* 401899 */ // Label 8355: @401899
     /* 401899 */ GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(401924), // Rule ID 8813 //
     /* 401904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 401910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 401913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401917 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 401917 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 401922 */   GIR_RootConstrainSelectedInstOperands,
     /* 401923 */   // GIR_Coverage, 8813,
     /* 401923 */   GIR_Done,
     /* 401924 */ // Label 8390: @401924
     /* 401924 */ GIM_Reject,
     /* 401925 */ // Label 8356: @401925
     /* 401925 */ GIM_Reject,
     /* 401926 */ // Label 152: @401926
     /* 401926 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8409*/ GIMT_Encode4(402705),
     /* 401937 */ /*GILLT_v2s32*//*Label 8391*/ GIMT_Encode4(402013),
     /* 401941 */ /*GILLT_v2s64*//*Label 8392*/ GIMT_Encode4(402068),
     /* 401945 */ /*GILLT_v4s16*//*Label 8393*/ GIMT_Encode4(402123),
     /* 401949 */ /*GILLT_v4s32*//*Label 8394*/ GIMT_Encode4(402178),
     /* 401953 */ /*GILLT_v8s8*//*Label 8395*/ GIMT_Encode4(402233),
     /* 401957 */ /*GILLT_v8s16*//*Label 8396*/ GIMT_Encode4(402267),
     /* 401961 */ /*GILLT_v16s8*//*Label 8397*/ GIMT_Encode4(402322), GIMT_Encode4(0),
     /* 401969 */ /*GILLT_nxv2s1*//*Label 8398*/ GIMT_Encode4(402356),
     /* 401973 */ /*GILLT_nxv2s16*//*Label 8399*/ GIMT_Encode4(402382),
     /* 401977 */ /*GILLT_nxv2s32*//*Label 8400*/ GIMT_Encode4(402408),
     /* 401981 */ /*GILLT_nxv2s64*//*Label 8401*/ GIMT_Encode4(402434),
     /* 401985 */ /*GILLT_nxv4s1*//*Label 8402*/ GIMT_Encode4(402481),
     /* 401989 */ /*GILLT_nxv4s16*//*Label 8403*/ GIMT_Encode4(402507),
     /* 401993 */ /*GILLT_nxv4s32*//*Label 8404*/ GIMT_Encode4(402533),
     /* 401997 */ /*GILLT_nxv8s1*//*Label 8405*/ GIMT_Encode4(402580),
     /* 402001 */ /*GILLT_nxv8s16*//*Label 8406*/ GIMT_Encode4(402606),
     /* 402005 */ /*GILLT_nxv16s1*//*Label 8407*/ GIMT_Encode4(402653),
     /* 402009 */ /*GILLT_nxv16s8*//*Label 8408*/ GIMT_Encode4(402679),
     /* 402013 */ // Label 8391: @402013
     /* 402013 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(402067),
     /* 402018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 402024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402036 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(402051), // Rule ID 1888 //
     /* 402041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402044 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 402044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 402049 */     GIR_RootConstrainSelectedInstOperands,
     /* 402050 */     // GIR_Coverage, 1888,
     /* 402050 */     GIR_Done,
     /* 402051 */   // Label 8411: @402051
     /* 402051 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(402066), // Rule ID 5426 //
     /* 402056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402059 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 402059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 402064 */     GIR_RootConstrainSelectedInstOperands,
     /* 402065 */     // GIR_Coverage, 5426,
     /* 402065 */     GIR_Done,
     /* 402066 */   // Label 8412: @402066
     /* 402066 */   GIM_Reject,
     /* 402067 */ // Label 8410: @402067
     /* 402067 */ GIM_Reject,
     /* 402068 */ // Label 8392: @402068
     /* 402068 */ GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(402122),
     /* 402073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 402079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402091 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(402106), // Rule ID 1890 //
     /* 402096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402099 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 402099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 402104 */     GIR_RootConstrainSelectedInstOperands,
     /* 402105 */     // GIR_Coverage, 1890,
     /* 402105 */     GIR_Done,
     /* 402106 */   // Label 8414: @402106
     /* 402106 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(402121), // Rule ID 5428 //
     /* 402111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402114 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 402114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 402119 */     GIR_RootConstrainSelectedInstOperands,
     /* 402120 */     // GIR_Coverage, 5428,
     /* 402120 */     GIR_Done,
     /* 402121 */   // Label 8415: @402121
     /* 402121 */   GIM_Reject,
     /* 402122 */ // Label 8413: @402122
     /* 402122 */ GIM_Reject,
     /* 402123 */ // Label 8393: @402123
     /* 402123 */ GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(402177),
     /* 402128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 402134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402146 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(402161), // Rule ID 1886 //
     /* 402151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402154 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 402154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 402159 */     GIR_RootConstrainSelectedInstOperands,
     /* 402160 */     // GIR_Coverage, 1886,
     /* 402160 */     GIR_Done,
     /* 402161 */   // Label 8417: @402161
     /* 402161 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(402176), // Rule ID 5424 //
     /* 402166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402169 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 402174 */     GIR_RootConstrainSelectedInstOperands,
     /* 402175 */     // GIR_Coverage, 5424,
     /* 402175 */     GIR_Done,
     /* 402176 */   // Label 8418: @402176
     /* 402176 */   GIM_Reject,
     /* 402177 */ // Label 8416: @402177
     /* 402177 */ GIM_Reject,
     /* 402178 */ // Label 8394: @402178
     /* 402178 */ GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(402232),
     /* 402183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402201 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(402216), // Rule ID 1889 //
     /* 402206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402209 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 402209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 402214 */     GIR_RootConstrainSelectedInstOperands,
     /* 402215 */     // GIR_Coverage, 1889,
     /* 402215 */     GIR_Done,
     /* 402216 */   // Label 8420: @402216
     /* 402216 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(402231), // Rule ID 5427 //
     /* 402221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402224 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 402229 */     GIR_RootConstrainSelectedInstOperands,
     /* 402230 */     // GIR_Coverage, 5427,
     /* 402230 */     GIR_Done,
     /* 402231 */   // Label 8421: @402231
     /* 402231 */   GIM_Reject,
     /* 402232 */ // Label 8419: @402232
     /* 402232 */ GIM_Reject,
     /* 402233 */ // Label 8395: @402233
     /* 402233 */ GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(402266), // Rule ID 1884 //
     /* 402238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 402247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402259 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 402259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 402264 */   GIR_RootConstrainSelectedInstOperands,
     /* 402265 */   // GIR_Coverage, 1884,
     /* 402265 */   GIR_Done,
     /* 402266 */ // Label 8422: @402266
     /* 402266 */ GIM_Reject,
     /* 402267 */ // Label 8396: @402267
     /* 402267 */ GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(402321),
     /* 402272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402290 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(402305), // Rule ID 1887 //
     /* 402295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402298 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 402298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 402303 */     GIR_RootConstrainSelectedInstOperands,
     /* 402304 */     // GIR_Coverage, 1887,
     /* 402304 */     GIR_Done,
     /* 402305 */   // Label 8424: @402305
     /* 402305 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(402320), // Rule ID 5425 //
     /* 402310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402313 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 402318 */     GIR_RootConstrainSelectedInstOperands,
     /* 402319 */     // GIR_Coverage, 5425,
     /* 402319 */     GIR_Done,
     /* 402320 */   // Label 8425: @402320
     /* 402320 */   GIM_Reject,
     /* 402321 */ // Label 8423: @402321
     /* 402321 */ GIM_Reject,
     /* 402322 */ // Label 8397: @402322
     /* 402322 */ GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(402355), // Rule ID 1885 //
     /* 402327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 402336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402348 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 402348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 402353 */   GIR_RootConstrainSelectedInstOperands,
     /* 402354 */   // GIR_Coverage, 1885,
     /* 402354 */   GIR_Done,
     /* 402355 */ // Label 8426: @402355
     /* 402355 */ GIM_Reject,
     /* 402356 */ // Label 8398: @402356
     /* 402356 */ GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(402381), // Rule ID 8861 //
     /* 402361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 402367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 402370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402374 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 402374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 402379 */   GIR_RootConstrainSelectedInstOperands,
     /* 402380 */   // GIR_Coverage, 8861,
     /* 402380 */   GIR_Done,
     /* 402381 */ // Label 8427: @402381
     /* 402381 */ GIM_Reject,
     /* 402382 */ // Label 8399: @402382
     /* 402382 */ GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(402407), // Rule ID 8830 //
     /* 402387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 402393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 402396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402400 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 402400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 402405 */   GIR_RootConstrainSelectedInstOperands,
     /* 402406 */   // GIR_Coverage, 8830,
     /* 402406 */   GIR_Done,
     /* 402407 */ // Label 8428: @402407
     /* 402407 */ GIM_Reject,
     /* 402408 */ // Label 8400: @402408
     /* 402408 */ GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(402433), // Rule ID 8831 //
     /* 402413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 402419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 402422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402426 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 402426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 402431 */   GIR_RootConstrainSelectedInstOperands,
     /* 402432 */   // GIR_Coverage, 8831,
     /* 402432 */   GIR_Done,
     /* 402433 */ // Label 8429: @402433
     /* 402433 */ GIM_Reject,
     /* 402434 */ // Label 8401: @402434
     /* 402434 */ GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(402480),
     /* 402439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 402442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 402445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402449 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(402464), // Rule ID 8826 //
     /* 402454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402457 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 402457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 402462 */     GIR_RootConstrainSelectedInstOperands,
     /* 402463 */     // GIR_Coverage, 8826,
     /* 402463 */     GIR_Done,
     /* 402464 */   // Label 8431: @402464
     /* 402464 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(402479), // Rule ID 8832 //
     /* 402469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402472 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 402472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 402477 */     GIR_RootConstrainSelectedInstOperands,
     /* 402478 */     // GIR_Coverage, 8832,
     /* 402478 */     GIR_Done,
     /* 402479 */   // Label 8432: @402479
     /* 402479 */   GIM_Reject,
     /* 402480 */ // Label 8430: @402480
     /* 402480 */ GIM_Reject,
     /* 402481 */ // Label 8402: @402481
     /* 402481 */ GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(402506), // Rule ID 8860 //
     /* 402486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 402492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 402495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402499 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 402499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 402504 */   GIR_RootConstrainSelectedInstOperands,
     /* 402505 */   // GIR_Coverage, 8860,
     /* 402505 */   GIR_Done,
     /* 402506 */ // Label 8433: @402506
     /* 402506 */ GIM_Reject,
     /* 402507 */ // Label 8403: @402507
     /* 402507 */ GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(402532), // Rule ID 8828 //
     /* 402512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 402518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 402521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402525 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 402525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 402530 */   GIR_RootConstrainSelectedInstOperands,
     /* 402531 */   // GIR_Coverage, 8828,
     /* 402531 */   GIR_Done,
     /* 402532 */ // Label 8434: @402532
     /* 402532 */ GIM_Reject,
     /* 402533 */ // Label 8404: @402533
     /* 402533 */ GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(402579),
     /* 402538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 402541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 402544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402548 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(402563), // Rule ID 8825 //
     /* 402553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402556 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 402556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 402561 */     GIR_RootConstrainSelectedInstOperands,
     /* 402562 */     // GIR_Coverage, 8825,
     /* 402562 */     GIR_Done,
     /* 402563 */   // Label 8436: @402563
     /* 402563 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(402578), // Rule ID 8829 //
     /* 402568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402571 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 402571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 402576 */     GIR_RootConstrainSelectedInstOperands,
     /* 402577 */     // GIR_Coverage, 8829,
     /* 402577 */     GIR_Done,
     /* 402578 */   // Label 8437: @402578
     /* 402578 */   GIM_Reject,
     /* 402579 */ // Label 8435: @402579
     /* 402579 */ GIM_Reject,
     /* 402580 */ // Label 8405: @402580
     /* 402580 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(402605), // Rule ID 8859 //
     /* 402585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 402591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 402594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402598 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 402598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 402603 */   GIR_RootConstrainSelectedInstOperands,
     /* 402604 */   // GIR_Coverage, 8859,
     /* 402604 */   GIR_Done,
     /* 402605 */ // Label 8438: @402605
     /* 402605 */ GIM_Reject,
     /* 402606 */ // Label 8406: @402606
     /* 402606 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(402652),
     /* 402611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 402614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 402617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402621 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(402636), // Rule ID 8824 //
     /* 402626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402629 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 402629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 402634 */     GIR_RootConstrainSelectedInstOperands,
     /* 402635 */     // GIR_Coverage, 8824,
     /* 402635 */     GIR_Done,
     /* 402636 */   // Label 8440: @402636
     /* 402636 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(402651), // Rule ID 8827 //
     /* 402641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402644 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 402644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 402649 */     GIR_RootConstrainSelectedInstOperands,
     /* 402650 */     // GIR_Coverage, 8827,
     /* 402650 */     GIR_Done,
     /* 402651 */   // Label 8441: @402651
     /* 402651 */   GIM_Reject,
     /* 402652 */ // Label 8439: @402652
     /* 402652 */ GIM_Reject,
     /* 402653 */ // Label 8407: @402653
     /* 402653 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(402678), // Rule ID 2401 //
     /* 402658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 402664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 402667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402671 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 402671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 402676 */   GIR_RootConstrainSelectedInstOperands,
     /* 402677 */   // GIR_Coverage, 2401,
     /* 402677 */   GIR_Done,
     /* 402678 */ // Label 8442: @402678
     /* 402678 */ GIM_Reject,
     /* 402679 */ // Label 8408: @402679
     /* 402679 */ GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(402704), // Rule ID 8823 //
     /* 402684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 402690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 402693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402697 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 402697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 402702 */   GIR_RootConstrainSelectedInstOperands,
     /* 402703 */   // GIR_Coverage, 8823,
     /* 402703 */   GIR_Done,
     /* 402704 */ // Label 8443: @402704
     /* 402704 */ GIM_Reject,
     /* 402705 */ // Label 8409: @402705
     /* 402705 */ GIM_Reject,
     /* 402706 */ // Label 153: @402706
     /* 402706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8452*/ GIMT_Encode4(403403),
     /* 402717 */ /*GILLT_s64*//*Label 8444*/ GIMT_Encode4(402753), GIMT_Encode4(0),
     /* 402725 */ /*GILLT_v2s32*//*Label 8445*/ GIMT_Encode4(402864),
     /* 402729 */ /*GILLT_v2s64*//*Label 8446*/ GIMT_Encode4(402941),
     /* 402733 */ /*GILLT_v4s16*//*Label 8447*/ GIMT_Encode4(403018),
     /* 402737 */ /*GILLT_v4s32*//*Label 8448*/ GIMT_Encode4(403095),
     /* 402741 */ /*GILLT_v8s8*//*Label 8449*/ GIMT_Encode4(403172),
     /* 402745 */ /*GILLT_v8s16*//*Label 8450*/ GIMT_Encode4(403249),
     /* 402749 */ /*GILLT_v16s8*//*Label 8451*/ GIMT_Encode4(403326),
     /* 402753 */ // Label 8444: @402753
     /* 402753 */ GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(402863),
     /* 402758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402769 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(402794), // Rule ID 5198 //
     /* 402774 */     // MIs[0] Operand 2
     /* 402774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 402785 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 402785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 402788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402792 */     GIR_RootConstrainSelectedInstOperands,
     /* 402793 */     // GIR_Coverage, 5198,
     /* 402793 */     GIR_EraseRootFromParent_Done,
     /* 402794 */   // Label 8454: @402794
     /* 402794 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(402828), // Rule ID 2111 //
     /* 402799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402802 */     // MIs[0] imm
     /* 402802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 402814 */     // MIs[1] Operand 1
     /* 402814 */     // No operand predicates
     /* 402814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402816 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 402816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 402819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402826 */     GIR_RootConstrainSelectedInstOperands,
     /* 402827 */     // GIR_Coverage, 2111,
     /* 402827 */     GIR_EraseRootFromParent_Done,
     /* 402828 */   // Label 8455: @402828
     /* 402828 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(402862), // Rule ID 6207 //
     /* 402833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402836 */     // MIs[0] imm
     /* 402836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 402848 */     // MIs[1] Operand 1
     /* 402848 */     // No operand predicates
     /* 402848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402850 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 402850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 402853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402860 */     GIR_RootConstrainSelectedInstOperands,
     /* 402861 */     // GIR_Coverage, 6207,
     /* 402861 */     GIR_EraseRootFromParent_Done,
     /* 402862 */   // Label 8456: @402862
     /* 402862 */   GIM_Reject,
     /* 402863 */ // Label 8453: @402863
     /* 402863 */ GIM_Reject,
     /* 402864 */ // Label 8445: @402864
     /* 402864 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(402940),
     /* 402869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402880 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(402905), // Rule ID 4843 //
     /* 402885 */     // MIs[0] Operand 2
     /* 402885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 402896 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 402896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 402899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402903 */     GIR_RootConstrainSelectedInstOperands,
     /* 402904 */     // GIR_Coverage, 4843,
     /* 402904 */     GIR_EraseRootFromParent_Done,
     /* 402905 */   // Label 8458: @402905
     /* 402905 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(402939), // Rule ID 2218 //
     /* 402910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402913 */     // MIs[0] imm
     /* 402913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 402925 */     // MIs[1] Operand 1
     /* 402925 */     // No operand predicates
     /* 402925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402927 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 402927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 402930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402937 */     GIR_RootConstrainSelectedInstOperands,
     /* 402938 */     // GIR_Coverage, 2218,
     /* 402938 */     GIR_EraseRootFromParent_Done,
     /* 402939 */   // Label 8459: @402939
     /* 402939 */   GIM_Reject,
     /* 402940 */ // Label 8457: @402940
     /* 402940 */ GIM_Reject,
     /* 402941 */ // Label 8446: @402941
     /* 402941 */ GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(403017),
     /* 402946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402957 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(402982), // Rule ID 4847 //
     /* 402962 */     // MIs[0] Operand 2
     /* 402962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 402973 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 402973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 402976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402980 */     GIR_RootConstrainSelectedInstOperands,
     /* 402981 */     // GIR_Coverage, 4847,
     /* 402981 */     GIR_EraseRootFromParent_Done,
     /* 402982 */   // Label 8461: @402982
     /* 402982 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(403016), // Rule ID 2220 //
     /* 402987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402990 */     // MIs[0] imm
     /* 402990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 403002 */     // MIs[1] Operand 1
     /* 403002 */     // No operand predicates
     /* 403002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403004 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 403007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403014 */     GIR_RootConstrainSelectedInstOperands,
     /* 403015 */     // GIR_Coverage, 2220,
     /* 403015 */     GIR_EraseRootFromParent_Done,
     /* 403016 */   // Label 8462: @403016
     /* 403016 */   GIM_Reject,
     /* 403017 */ // Label 8460: @403017
     /* 403017 */ GIM_Reject,
     /* 403018 */ // Label 8447: @403018
     /* 403018 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(403094),
     /* 403023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403034 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(403059), // Rule ID 4842 //
     /* 403039 */     // MIs[0] Operand 2
     /* 403039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 403050 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 403050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 403053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403057 */     GIR_RootConstrainSelectedInstOperands,
     /* 403058 */     // GIR_Coverage, 4842,
     /* 403058 */     GIR_EraseRootFromParent_Done,
     /* 403059 */   // Label 8464: @403059
     /* 403059 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(403093), // Rule ID 2216 //
     /* 403064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403067 */     // MIs[0] imm
     /* 403067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 403079 */     // MIs[1] Operand 1
     /* 403079 */     // No operand predicates
     /* 403079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403081 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 403084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403091 */     GIR_RootConstrainSelectedInstOperands,
     /* 403092 */     // GIR_Coverage, 2216,
     /* 403092 */     GIR_EraseRootFromParent_Done,
     /* 403093 */   // Label 8465: @403093
     /* 403093 */   GIM_Reject,
     /* 403094 */ // Label 8463: @403094
     /* 403094 */ GIM_Reject,
     /* 403095 */ // Label 8448: @403095
     /* 403095 */ GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(403171),
     /* 403100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403111 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(403136), // Rule ID 4846 //
     /* 403116 */     // MIs[0] Operand 2
     /* 403116 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 403127 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 403127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 403130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403134 */     GIR_RootConstrainSelectedInstOperands,
     /* 403135 */     // GIR_Coverage, 4846,
     /* 403135 */     GIR_EraseRootFromParent_Done,
     /* 403136 */   // Label 8467: @403136
     /* 403136 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(403170), // Rule ID 2219 //
     /* 403141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403144 */     // MIs[0] imm
     /* 403144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 403156 */     // MIs[1] Operand 1
     /* 403156 */     // No operand predicates
     /* 403156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403158 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 403161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403168 */     GIR_RootConstrainSelectedInstOperands,
     /* 403169 */     // GIR_Coverage, 2219,
     /* 403169 */     GIR_EraseRootFromParent_Done,
     /* 403170 */   // Label 8468: @403170
     /* 403170 */   GIM_Reject,
     /* 403171 */ // Label 8466: @403171
     /* 403171 */ GIM_Reject,
     /* 403172 */ // Label 8449: @403172
     /* 403172 */ GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(403248),
     /* 403177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403188 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(403213), // Rule ID 4841 //
     /* 403193 */     // MIs[0] Operand 2
     /* 403193 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 403204 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 403204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 403207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403211 */     GIR_RootConstrainSelectedInstOperands,
     /* 403212 */     // GIR_Coverage, 4841,
     /* 403212 */     GIR_EraseRootFromParent_Done,
     /* 403213 */   // Label 8470: @403213
     /* 403213 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(403247), // Rule ID 2214 //
     /* 403218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403221 */     // MIs[0] imm
     /* 403221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 403233 */     // MIs[1] Operand 1
     /* 403233 */     // No operand predicates
     /* 403233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403235 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 403238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403245 */     GIR_RootConstrainSelectedInstOperands,
     /* 403246 */     // GIR_Coverage, 2214,
     /* 403246 */     GIR_EraseRootFromParent_Done,
     /* 403247 */   // Label 8471: @403247
     /* 403247 */   GIM_Reject,
     /* 403248 */ // Label 8469: @403248
     /* 403248 */ GIM_Reject,
     /* 403249 */ // Label 8450: @403249
     /* 403249 */ GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(403325),
     /* 403254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403265 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(403290), // Rule ID 4845 //
     /* 403270 */     // MIs[0] Operand 2
     /* 403270 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 403281 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 403281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 403284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403288 */     GIR_RootConstrainSelectedInstOperands,
     /* 403289 */     // GIR_Coverage, 4845,
     /* 403289 */     GIR_EraseRootFromParent_Done,
     /* 403290 */   // Label 8473: @403290
     /* 403290 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(403324), // Rule ID 2217 //
     /* 403295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403298 */     // MIs[0] imm
     /* 403298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 403310 */     // MIs[1] Operand 1
     /* 403310 */     // No operand predicates
     /* 403310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403312 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 403315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403322 */     GIR_RootConstrainSelectedInstOperands,
     /* 403323 */     // GIR_Coverage, 2217,
     /* 403323 */     GIR_EraseRootFromParent_Done,
     /* 403324 */   // Label 8474: @403324
     /* 403324 */   GIM_Reject,
     /* 403325 */ // Label 8472: @403325
     /* 403325 */ GIM_Reject,
     /* 403326 */ // Label 8451: @403326
     /* 403326 */ GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(403402),
     /* 403331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403342 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(403367), // Rule ID 4844 //
     /* 403347 */     // MIs[0] Operand 2
     /* 403347 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 403358 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 403358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 403361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403365 */     GIR_RootConstrainSelectedInstOperands,
     /* 403366 */     // GIR_Coverage, 4844,
     /* 403366 */     GIR_EraseRootFromParent_Done,
     /* 403367 */   // Label 8476: @403367
     /* 403367 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(403401), // Rule ID 2215 //
     /* 403372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403375 */     // MIs[0] imm
     /* 403375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 403387 */     // MIs[1] Operand 1
     /* 403387 */     // No operand predicates
     /* 403387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403389 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 403392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403399 */     GIR_RootConstrainSelectedInstOperands,
     /* 403400 */     // GIR_Coverage, 2215,
     /* 403400 */     GIR_EraseRootFromParent_Done,
     /* 403401 */   // Label 8477: @403401
     /* 403401 */   GIM_Reject,
     /* 403402 */ // Label 8475: @403402
     /* 403402 */ GIM_Reject,
     /* 403403 */ // Label 8452: @403403
     /* 403403 */ GIM_Reject,
     /* 403404 */ // Label 154: @403404
     /* 403404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8486*/ GIMT_Encode4(403859),
     /* 403415 */ /*GILLT_s64*//*Label 8478*/ GIMT_Encode4(403451), GIMT_Encode4(0),
     /* 403423 */ /*GILLT_v2s32*//*Label 8479*/ GIMT_Encode4(403537),
     /* 403427 */ /*GILLT_v2s64*//*Label 8480*/ GIMT_Encode4(403583),
     /* 403431 */ /*GILLT_v4s16*//*Label 8481*/ GIMT_Encode4(403629),
     /* 403435 */ /*GILLT_v4s32*//*Label 8482*/ GIMT_Encode4(403675),
     /* 403439 */ /*GILLT_v8s8*//*Label 8483*/ GIMT_Encode4(403721),
     /* 403443 */ /*GILLT_v8s16*//*Label 8484*/ GIMT_Encode4(403767),
     /* 403447 */ /*GILLT_v16s8*//*Label 8485*/ GIMT_Encode4(403813),
     /* 403451 */ // Label 8478: @403451
     /* 403451 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(403536),
     /* 403456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 403459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403467 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(403501), // Rule ID 2120 //
     /* 403472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403475 */     // MIs[0] imm
     /* 403475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 403487 */     // MIs[1] Operand 1
     /* 403487 */     // No operand predicates
     /* 403487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403489 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 403492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403499 */     GIR_RootConstrainSelectedInstOperands,
     /* 403500 */     // GIR_Coverage, 2120,
     /* 403500 */     GIR_EraseRootFromParent_Done,
     /* 403501 */   // Label 8488: @403501
     /* 403501 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(403535), // Rule ID 6213 //
     /* 403506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403509 */     // MIs[0] imm
     /* 403509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 403521 */     // MIs[1] Operand 1
     /* 403521 */     // No operand predicates
     /* 403521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403523 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 403523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 403526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403533 */     GIR_RootConstrainSelectedInstOperands,
     /* 403534 */     // GIR_Coverage, 6213,
     /* 403534 */     GIR_EraseRootFromParent_Done,
     /* 403535 */   // Label 8489: @403535
     /* 403535 */   GIM_Reject,
     /* 403536 */ // Label 8487: @403536
     /* 403536 */ GIM_Reject,
     /* 403537 */ // Label 8479: @403537
     /* 403537 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(403582), // Rule ID 2277 //
     /* 403542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403556 */   // MIs[0] imm
     /* 403556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403564 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 403568 */   // MIs[1] Operand 1
     /* 403568 */   // No operand predicates
     /* 403568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403570 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 403573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403575 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403577 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403580 */   GIR_RootConstrainSelectedInstOperands,
     /* 403581 */   // GIR_Coverage, 2277,
     /* 403581 */   GIR_EraseRootFromParent_Done,
     /* 403582 */ // Label 8490: @403582
     /* 403582 */ GIM_Reject,
     /* 403583 */ // Label 8480: @403583
     /* 403583 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(403628), // Rule ID 2279 //
     /* 403588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403602 */   // MIs[0] imm
     /* 403602 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403610 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 403614 */   // MIs[1] Operand 1
     /* 403614 */   // No operand predicates
     /* 403614 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403616 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 403619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403621 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403623 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403626 */   GIR_RootConstrainSelectedInstOperands,
     /* 403627 */   // GIR_Coverage, 2279,
     /* 403627 */   GIR_EraseRootFromParent_Done,
     /* 403628 */ // Label 8491: @403628
     /* 403628 */ GIM_Reject,
     /* 403629 */ // Label 8481: @403629
     /* 403629 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(403674), // Rule ID 2275 //
     /* 403634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403648 */   // MIs[0] imm
     /* 403648 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403656 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 403660 */   // MIs[1] Operand 1
     /* 403660 */   // No operand predicates
     /* 403660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403662 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 403665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403669 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403672 */   GIR_RootConstrainSelectedInstOperands,
     /* 403673 */   // GIR_Coverage, 2275,
     /* 403673 */   GIR_EraseRootFromParent_Done,
     /* 403674 */ // Label 8492: @403674
     /* 403674 */ GIM_Reject,
     /* 403675 */ // Label 8482: @403675
     /* 403675 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(403720), // Rule ID 2278 //
     /* 403680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403694 */   // MIs[0] imm
     /* 403694 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403698 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403702 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 403706 */   // MIs[1] Operand 1
     /* 403706 */   // No operand predicates
     /* 403706 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403708 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 403711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403713 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403715 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403718 */   GIR_RootConstrainSelectedInstOperands,
     /* 403719 */   // GIR_Coverage, 2278,
     /* 403719 */   GIR_EraseRootFromParent_Done,
     /* 403720 */ // Label 8493: @403720
     /* 403720 */ GIM_Reject,
     /* 403721 */ // Label 8483: @403721
     /* 403721 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(403766), // Rule ID 2273 //
     /* 403726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403740 */   // MIs[0] imm
     /* 403740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403748 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 403752 */   // MIs[1] Operand 1
     /* 403752 */   // No operand predicates
     /* 403752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403754 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 403757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403759 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403761 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403764 */   GIR_RootConstrainSelectedInstOperands,
     /* 403765 */   // GIR_Coverage, 2273,
     /* 403765 */   GIR_EraseRootFromParent_Done,
     /* 403766 */ // Label 8494: @403766
     /* 403766 */ GIM_Reject,
     /* 403767 */ // Label 8484: @403767
     /* 403767 */ GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(403812), // Rule ID 2276 //
     /* 403772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403786 */   // MIs[0] imm
     /* 403786 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403794 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 403798 */   // MIs[1] Operand 1
     /* 403798 */   // No operand predicates
     /* 403798 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403800 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 403803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403805 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403807 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403810 */   GIR_RootConstrainSelectedInstOperands,
     /* 403811 */   // GIR_Coverage, 2276,
     /* 403811 */   GIR_EraseRootFromParent_Done,
     /* 403812 */ // Label 8495: @403812
     /* 403812 */ GIM_Reject,
     /* 403813 */ // Label 8485: @403813
     /* 403813 */ GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(403858), // Rule ID 2274 //
     /* 403818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403832 */   // MIs[0] imm
     /* 403832 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403836 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403840 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 403844 */   // MIs[1] Operand 1
     /* 403844 */   // No operand predicates
     /* 403844 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403846 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 403846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 403849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403851 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403853 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403856 */   GIR_RootConstrainSelectedInstOperands,
     /* 403857 */   // GIR_Coverage, 2274,
     /* 403857 */   GIR_EraseRootFromParent_Done,
     /* 403858 */ // Label 8496: @403858
     /* 403858 */ GIM_Reject,
     /* 403859 */ // Label 8486: @403859
     /* 403859 */ GIM_Reject,
     /* 403860 */ // Label 155: @403860
     /* 403860 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8515*/ GIMT_Encode4(404639),
     /* 403871 */ /*GILLT_v2s32*//*Label 8497*/ GIMT_Encode4(403947),
     /* 403875 */ /*GILLT_v2s64*//*Label 8498*/ GIMT_Encode4(404002),
     /* 403879 */ /*GILLT_v4s16*//*Label 8499*/ GIMT_Encode4(404057),
     /* 403883 */ /*GILLT_v4s32*//*Label 8500*/ GIMT_Encode4(404112),
     /* 403887 */ /*GILLT_v8s8*//*Label 8501*/ GIMT_Encode4(404167),
     /* 403891 */ /*GILLT_v8s16*//*Label 8502*/ GIMT_Encode4(404201),
     /* 403895 */ /*GILLT_v16s8*//*Label 8503*/ GIMT_Encode4(404256), GIMT_Encode4(0),
     /* 403903 */ /*GILLT_nxv2s1*//*Label 8504*/ GIMT_Encode4(404290),
     /* 403907 */ /*GILLT_nxv2s16*//*Label 8505*/ GIMT_Encode4(404316),
     /* 403911 */ /*GILLT_nxv2s32*//*Label 8506*/ GIMT_Encode4(404342),
     /* 403915 */ /*GILLT_nxv2s64*//*Label 8507*/ GIMT_Encode4(404368),
     /* 403919 */ /*GILLT_nxv4s1*//*Label 8508*/ GIMT_Encode4(404415),
     /* 403923 */ /*GILLT_nxv4s16*//*Label 8509*/ GIMT_Encode4(404441),
     /* 403927 */ /*GILLT_nxv4s32*//*Label 8510*/ GIMT_Encode4(404467),
     /* 403931 */ /*GILLT_nxv8s1*//*Label 8511*/ GIMT_Encode4(404514),
     /* 403935 */ /*GILLT_nxv8s16*//*Label 8512*/ GIMT_Encode4(404540),
     /* 403939 */ /*GILLT_nxv16s1*//*Label 8513*/ GIMT_Encode4(404587),
     /* 403943 */ /*GILLT_nxv16s8*//*Label 8514*/ GIMT_Encode4(404613),
     /* 403947 */ // Label 8497: @403947
     /* 403947 */ GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(404001),
     /* 403952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 403958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403970 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(403985), // Rule ID 1895 //
     /* 403975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403978 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 403978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 403983 */     GIR_RootConstrainSelectedInstOperands,
     /* 403984 */     // GIR_Coverage, 1895,
     /* 403984 */     GIR_Done,
     /* 403985 */   // Label 8517: @403985
     /* 403985 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(404000), // Rule ID 5431 //
     /* 403990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403993 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 403993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 403998 */     GIR_RootConstrainSelectedInstOperands,
     /* 403999 */     // GIR_Coverage, 5431,
     /* 403999 */     GIR_Done,
     /* 404000 */   // Label 8518: @404000
     /* 404000 */   GIM_Reject,
     /* 404001 */ // Label 8516: @404001
     /* 404001 */ GIM_Reject,
     /* 404002 */ // Label 8498: @404002
     /* 404002 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(404056),
     /* 404007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 404010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 404013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404025 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(404040), // Rule ID 1897 //
     /* 404030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404033 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 404033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 404038 */     GIR_RootConstrainSelectedInstOperands,
     /* 404039 */     // GIR_Coverage, 1897,
     /* 404039 */     GIR_Done,
     /* 404040 */   // Label 8520: @404040
     /* 404040 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(404055), // Rule ID 5433 //
     /* 404045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404048 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 404048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 404053 */     GIR_RootConstrainSelectedInstOperands,
     /* 404054 */     // GIR_Coverage, 5433,
     /* 404054 */     GIR_Done,
     /* 404055 */   // Label 8521: @404055
     /* 404055 */   GIM_Reject,
     /* 404056 */ // Label 8519: @404056
     /* 404056 */ GIM_Reject,
     /* 404057 */ // Label 8499: @404057
     /* 404057 */ GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(404111),
     /* 404062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 404068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404080 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(404095), // Rule ID 1893 //
     /* 404085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404088 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 404088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 404093 */     GIR_RootConstrainSelectedInstOperands,
     /* 404094 */     // GIR_Coverage, 1893,
     /* 404094 */     GIR_Done,
     /* 404095 */   // Label 8523: @404095
     /* 404095 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(404110), // Rule ID 5429 //
     /* 404100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404103 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 404103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 404108 */     GIR_RootConstrainSelectedInstOperands,
     /* 404109 */     // GIR_Coverage, 5429,
     /* 404109 */     GIR_Done,
     /* 404110 */   // Label 8524: @404110
     /* 404110 */   GIM_Reject,
     /* 404111 */ // Label 8522: @404111
     /* 404111 */ GIM_Reject,
     /* 404112 */ // Label 8500: @404112
     /* 404112 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(404166),
     /* 404117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 404123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404135 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(404150), // Rule ID 1896 //
     /* 404140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404143 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 404143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 404148 */     GIR_RootConstrainSelectedInstOperands,
     /* 404149 */     // GIR_Coverage, 1896,
     /* 404149 */     GIR_Done,
     /* 404150 */   // Label 8526: @404150
     /* 404150 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(404165), // Rule ID 5432 //
     /* 404155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404158 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 404158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 404163 */     GIR_RootConstrainSelectedInstOperands,
     /* 404164 */     // GIR_Coverage, 5432,
     /* 404164 */     GIR_Done,
     /* 404165 */   // Label 8527: @404165
     /* 404165 */   GIM_Reject,
     /* 404166 */ // Label 8525: @404166
     /* 404166 */ GIM_Reject,
     /* 404167 */ // Label 8501: @404167
     /* 404167 */ GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(404200), // Rule ID 1891 //
     /* 404172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 404178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 404181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404193 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 404193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 404198 */   GIR_RootConstrainSelectedInstOperands,
     /* 404199 */   // GIR_Coverage, 1891,
     /* 404199 */   GIR_Done,
     /* 404200 */ // Label 8528: @404200
     /* 404200 */ GIM_Reject,
     /* 404201 */ // Label 8502: @404201
     /* 404201 */ GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(404255),
     /* 404206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 404212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404224 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(404239), // Rule ID 1894 //
     /* 404229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404232 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 404232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 404237 */     GIR_RootConstrainSelectedInstOperands,
     /* 404238 */     // GIR_Coverage, 1894,
     /* 404238 */     GIR_Done,
     /* 404239 */   // Label 8530: @404239
     /* 404239 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(404254), // Rule ID 5430 //
     /* 404244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404247 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 404247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 404252 */     GIR_RootConstrainSelectedInstOperands,
     /* 404253 */     // GIR_Coverage, 5430,
     /* 404253 */     GIR_Done,
     /* 404254 */   // Label 8531: @404254
     /* 404254 */   GIM_Reject,
     /* 404255 */ // Label 8529: @404255
     /* 404255 */ GIM_Reject,
     /* 404256 */ // Label 8503: @404256
     /* 404256 */ GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(404289), // Rule ID 1892 //
     /* 404261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 404270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404282 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 404282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 404287 */   GIR_RootConstrainSelectedInstOperands,
     /* 404288 */   // GIR_Coverage, 1892,
     /* 404288 */   GIR_Done,
     /* 404289 */ // Label 8532: @404289
     /* 404289 */ GIM_Reject,
     /* 404290 */ // Label 8504: @404290
     /* 404290 */ GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(404315), // Rule ID 3339 //
     /* 404295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 404301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 404304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 404308 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 404308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 404313 */   GIR_RootConstrainSelectedInstOperands,
     /* 404314 */   // GIR_Coverage, 3339,
     /* 404314 */   GIR_Done,
     /* 404315 */ // Label 8533: @404315
     /* 404315 */ GIM_Reject,
     /* 404316 */ // Label 8505: @404316
     /* 404316 */ GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(404341), // Rule ID 2870 //
     /* 404321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 404327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 404330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404334 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 404334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 404339 */   GIR_RootConstrainSelectedInstOperands,
     /* 404340 */   // GIR_Coverage, 2870,
     /* 404340 */   GIR_Done,
     /* 404341 */ // Label 8534: @404341
     /* 404341 */ GIM_Reject,
     /* 404342 */ // Label 8506: @404342
     /* 404342 */ GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(404367), // Rule ID 2871 //
     /* 404347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 404353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 404356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404360 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 404360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 404365 */   GIR_RootConstrainSelectedInstOperands,
     /* 404366 */   // GIR_Coverage, 2871,
     /* 404366 */   GIR_Done,
     /* 404367 */ // Label 8535: @404367
     /* 404367 */ GIM_Reject,
     /* 404368 */ // Label 8507: @404368
     /* 404368 */ GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(404414),
     /* 404373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 404376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 404379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404383 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(404398), // Rule ID 2866 //
     /* 404388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404391 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 404391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 404396 */     GIR_RootConstrainSelectedInstOperands,
     /* 404397 */     // GIR_Coverage, 2866,
     /* 404397 */     GIR_Done,
     /* 404398 */   // Label 8537: @404398
     /* 404398 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(404413), // Rule ID 2872 //
     /* 404403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404406 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 404406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 404411 */     GIR_RootConstrainSelectedInstOperands,
     /* 404412 */     // GIR_Coverage, 2872,
     /* 404412 */     GIR_Done,
     /* 404413 */   // Label 8538: @404413
     /* 404413 */   GIM_Reject,
     /* 404414 */ // Label 8536: @404414
     /* 404414 */ GIM_Reject,
     /* 404415 */ // Label 8508: @404415
     /* 404415 */ GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(404440), // Rule ID 3338 //
     /* 404420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 404426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 404429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 404433 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 404433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 404438 */   GIR_RootConstrainSelectedInstOperands,
     /* 404439 */   // GIR_Coverage, 3338,
     /* 404439 */   GIR_Done,
     /* 404440 */ // Label 8539: @404440
     /* 404440 */ GIM_Reject,
     /* 404441 */ // Label 8509: @404441
     /* 404441 */ GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(404466), // Rule ID 2868 //
     /* 404446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 404452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 404455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404459 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 404459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 404464 */   GIR_RootConstrainSelectedInstOperands,
     /* 404465 */   // GIR_Coverage, 2868,
     /* 404465 */   GIR_Done,
     /* 404466 */ // Label 8540: @404466
     /* 404466 */ GIM_Reject,
     /* 404467 */ // Label 8510: @404467
     /* 404467 */ GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(404513),
     /* 404472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 404475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 404478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404482 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(404497), // Rule ID 2865 //
     /* 404487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404490 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 404490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 404495 */     GIR_RootConstrainSelectedInstOperands,
     /* 404496 */     // GIR_Coverage, 2865,
     /* 404496 */     GIR_Done,
     /* 404497 */   // Label 8542: @404497
     /* 404497 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(404512), // Rule ID 2869 //
     /* 404502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404505 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 404505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 404510 */     GIR_RootConstrainSelectedInstOperands,
     /* 404511 */     // GIR_Coverage, 2869,
     /* 404511 */     GIR_Done,
     /* 404512 */   // Label 8543: @404512
     /* 404512 */   GIM_Reject,
     /* 404513 */ // Label 8541: @404513
     /* 404513 */ GIM_Reject,
     /* 404514 */ // Label 8511: @404514
     /* 404514 */ GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(404539), // Rule ID 3337 //
     /* 404519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 404525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 404528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 404532 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 404532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 404537 */   GIR_RootConstrainSelectedInstOperands,
     /* 404538 */   // GIR_Coverage, 3337,
     /* 404538 */   GIR_Done,
     /* 404539 */ // Label 8544: @404539
     /* 404539 */ GIM_Reject,
     /* 404540 */ // Label 8512: @404540
     /* 404540 */ GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(404586),
     /* 404545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 404548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 404551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404555 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(404570), // Rule ID 2864 //
     /* 404560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404563 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 404563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 404568 */     GIR_RootConstrainSelectedInstOperands,
     /* 404569 */     // GIR_Coverage, 2864,
     /* 404569 */     GIR_Done,
     /* 404570 */   // Label 8546: @404570
     /* 404570 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(404585), // Rule ID 2867 //
     /* 404575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404578 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 404578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 404583 */     GIR_RootConstrainSelectedInstOperands,
     /* 404584 */     // GIR_Coverage, 2867,
     /* 404584 */     GIR_Done,
     /* 404585 */   // Label 8547: @404585
     /* 404585 */   GIM_Reject,
     /* 404586 */ // Label 8545: @404586
     /* 404586 */ GIM_Reject,
     /* 404587 */ // Label 8513: @404587
     /* 404587 */ GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(404612), // Rule ID 2389 //
     /* 404592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 404598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 404601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 404605 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 404605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 404610 */   GIR_RootConstrainSelectedInstOperands,
     /* 404611 */   // GIR_Coverage, 2389,
     /* 404611 */   GIR_Done,
     /* 404612 */ // Label 8548: @404612
     /* 404612 */ GIM_Reject,
     /* 404613 */ // Label 8514: @404613
     /* 404613 */ GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(404638), // Rule ID 2863 //
     /* 404618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 404624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 404627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404631 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 404631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 404636 */   GIR_RootConstrainSelectedInstOperands,
     /* 404637 */   // GIR_Coverage, 2863,
     /* 404637 */   GIR_Done,
     /* 404638 */ // Label 8549: @404638
     /* 404638 */ GIM_Reject,
     /* 404639 */ // Label 8515: @404639
     /* 404639 */ GIM_Reject,
     /* 404640 */ // Label 156: @404640
     /* 404640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8568*/ GIMT_Encode4(405419),
     /* 404651 */ /*GILLT_v2s32*//*Label 8550*/ GIMT_Encode4(404727),
     /* 404655 */ /*GILLT_v2s64*//*Label 8551*/ GIMT_Encode4(404782),
     /* 404659 */ /*GILLT_v4s16*//*Label 8552*/ GIMT_Encode4(404837),
     /* 404663 */ /*GILLT_v4s32*//*Label 8553*/ GIMT_Encode4(404892),
     /* 404667 */ /*GILLT_v8s8*//*Label 8554*/ GIMT_Encode4(404947),
     /* 404671 */ /*GILLT_v8s16*//*Label 8555*/ GIMT_Encode4(404981),
     /* 404675 */ /*GILLT_v16s8*//*Label 8556*/ GIMT_Encode4(405036), GIMT_Encode4(0),
     /* 404683 */ /*GILLT_nxv2s1*//*Label 8557*/ GIMT_Encode4(405070),
     /* 404687 */ /*GILLT_nxv2s16*//*Label 8558*/ GIMT_Encode4(405096),
     /* 404691 */ /*GILLT_nxv2s32*//*Label 8559*/ GIMT_Encode4(405122),
     /* 404695 */ /*GILLT_nxv2s64*//*Label 8560*/ GIMT_Encode4(405148),
     /* 404699 */ /*GILLT_nxv4s1*//*Label 8561*/ GIMT_Encode4(405195),
     /* 404703 */ /*GILLT_nxv4s16*//*Label 8562*/ GIMT_Encode4(405221),
     /* 404707 */ /*GILLT_nxv4s32*//*Label 8563*/ GIMT_Encode4(405247),
     /* 404711 */ /*GILLT_nxv8s1*//*Label 8564*/ GIMT_Encode4(405294),
     /* 404715 */ /*GILLT_nxv8s16*//*Label 8565*/ GIMT_Encode4(405320),
     /* 404719 */ /*GILLT_nxv16s1*//*Label 8566*/ GIMT_Encode4(405367),
     /* 404723 */ /*GILLT_nxv16s8*//*Label 8567*/ GIMT_Encode4(405393),
     /* 404727 */ // Label 8550: @404727
     /* 404727 */ GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(404781),
     /* 404732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 404738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404750 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(404765), // Rule ID 1902 //
     /* 404755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404758 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 404758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 404763 */     GIR_RootConstrainSelectedInstOperands,
     /* 404764 */     // GIR_Coverage, 1902,
     /* 404764 */     GIR_Done,
     /* 404765 */   // Label 8570: @404765
     /* 404765 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(404780), // Rule ID 5436 //
     /* 404770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404773 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 404773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 404778 */     GIR_RootConstrainSelectedInstOperands,
     /* 404779 */     // GIR_Coverage, 5436,
     /* 404779 */     GIR_Done,
     /* 404780 */   // Label 8571: @404780
     /* 404780 */   GIM_Reject,
     /* 404781 */ // Label 8569: @404781
     /* 404781 */ GIM_Reject,
     /* 404782 */ // Label 8551: @404782
     /* 404782 */ GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(404836),
     /* 404787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 404790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 404793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404805 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(404820), // Rule ID 1904 //
     /* 404810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404813 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 404813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 404818 */     GIR_RootConstrainSelectedInstOperands,
     /* 404819 */     // GIR_Coverage, 1904,
     /* 404819 */     GIR_Done,
     /* 404820 */   // Label 8573: @404820
     /* 404820 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(404835), // Rule ID 5438 //
     /* 404825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404828 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 404828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 404833 */     GIR_RootConstrainSelectedInstOperands,
     /* 404834 */     // GIR_Coverage, 5438,
     /* 404834 */     GIR_Done,
     /* 404835 */   // Label 8574: @404835
     /* 404835 */   GIM_Reject,
     /* 404836 */ // Label 8572: @404836
     /* 404836 */ GIM_Reject,
     /* 404837 */ // Label 8552: @404837
     /* 404837 */ GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(404891),
     /* 404842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 404848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404860 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(404875), // Rule ID 1900 //
     /* 404865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404868 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 404868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 404873 */     GIR_RootConstrainSelectedInstOperands,
     /* 404874 */     // GIR_Coverage, 1900,
     /* 404874 */     GIR_Done,
     /* 404875 */   // Label 8576: @404875
     /* 404875 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(404890), // Rule ID 5434 //
     /* 404880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404883 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 404883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 404888 */     GIR_RootConstrainSelectedInstOperands,
     /* 404889 */     // GIR_Coverage, 5434,
     /* 404889 */     GIR_Done,
     /* 404890 */   // Label 8577: @404890
     /* 404890 */   GIM_Reject,
     /* 404891 */ // Label 8575: @404891
     /* 404891 */ GIM_Reject,
     /* 404892 */ // Label 8553: @404892
     /* 404892 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(404946),
     /* 404897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 404903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404915 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(404930), // Rule ID 1903 //
     /* 404920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404923 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 404923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 404928 */     GIR_RootConstrainSelectedInstOperands,
     /* 404929 */     // GIR_Coverage, 1903,
     /* 404929 */     GIR_Done,
     /* 404930 */   // Label 8579: @404930
     /* 404930 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(404945), // Rule ID 5437 //
     /* 404935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404938 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 404938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 404943 */     GIR_RootConstrainSelectedInstOperands,
     /* 404944 */     // GIR_Coverage, 5437,
     /* 404944 */     GIR_Done,
     /* 404945 */   // Label 8580: @404945
     /* 404945 */   GIM_Reject,
     /* 404946 */ // Label 8578: @404946
     /* 404946 */ GIM_Reject,
     /* 404947 */ // Label 8554: @404947
     /* 404947 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(404980), // Rule ID 1898 //
     /* 404952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 404958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 404961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404973 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 404973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 404978 */   GIR_RootConstrainSelectedInstOperands,
     /* 404979 */   // GIR_Coverage, 1898,
     /* 404979 */   GIR_Done,
     /* 404980 */ // Label 8581: @404980
     /* 404980 */ GIM_Reject,
     /* 404981 */ // Label 8555: @404981
     /* 404981 */ GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(405035),
     /* 404986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 404992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405004 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(405019), // Rule ID 1901 //
     /* 405009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405012 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 405012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 405017 */     GIR_RootConstrainSelectedInstOperands,
     /* 405018 */     // GIR_Coverage, 1901,
     /* 405018 */     GIR_Done,
     /* 405019 */   // Label 8583: @405019
     /* 405019 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(405034), // Rule ID 5435 //
     /* 405024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405027 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 405027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 405032 */     GIR_RootConstrainSelectedInstOperands,
     /* 405033 */     // GIR_Coverage, 5435,
     /* 405033 */     GIR_Done,
     /* 405034 */   // Label 8584: @405034
     /* 405034 */   GIM_Reject,
     /* 405035 */ // Label 8582: @405035
     /* 405035 */ GIM_Reject,
     /* 405036 */ // Label 8556: @405036
     /* 405036 */ GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(405069), // Rule ID 1899 //
     /* 405041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 405047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 405050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405062 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 405062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 405067 */   GIR_RootConstrainSelectedInstOperands,
     /* 405068 */   // GIR_Coverage, 1899,
     /* 405068 */   GIR_Done,
     /* 405069 */ // Label 8585: @405069
     /* 405069 */ GIM_Reject,
     /* 405070 */ // Label 8557: @405070
     /* 405070 */ GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(405095), // Rule ID 8855 //
     /* 405075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 405081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 405084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405088 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 405088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 405093 */   GIR_RootConstrainSelectedInstOperands,
     /* 405094 */   // GIR_Coverage, 8855,
     /* 405094 */   GIR_Done,
     /* 405095 */ // Label 8586: @405095
     /* 405095 */ GIM_Reject,
     /* 405096 */ // Label 8558: @405096
     /* 405096 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(405121), // Rule ID 8810 //
     /* 405101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 405107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 405110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405114 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 405114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 405119 */   GIR_RootConstrainSelectedInstOperands,
     /* 405120 */   // GIR_Coverage, 8810,
     /* 405120 */   GIR_Done,
     /* 405121 */ // Label 8587: @405121
     /* 405121 */ GIM_Reject,
     /* 405122 */ // Label 8559: @405122
     /* 405122 */ GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(405147), // Rule ID 8811 //
     /* 405127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 405133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 405136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405140 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 405140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 405145 */   GIR_RootConstrainSelectedInstOperands,
     /* 405146 */   // GIR_Coverage, 8811,
     /* 405146 */   GIR_Done,
     /* 405147 */ // Label 8588: @405147
     /* 405147 */ GIM_Reject,
     /* 405148 */ // Label 8560: @405148
     /* 405148 */ GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(405194),
     /* 405153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 405156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 405159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405163 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(405178), // Rule ID 8806 //
     /* 405168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405171 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 405171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 405176 */     GIR_RootConstrainSelectedInstOperands,
     /* 405177 */     // GIR_Coverage, 8806,
     /* 405177 */     GIR_Done,
     /* 405178 */   // Label 8590: @405178
     /* 405178 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(405193), // Rule ID 8812 //
     /* 405183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405186 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 405186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 405191 */     GIR_RootConstrainSelectedInstOperands,
     /* 405192 */     // GIR_Coverage, 8812,
     /* 405192 */     GIR_Done,
     /* 405193 */   // Label 8591: @405193
     /* 405193 */   GIM_Reject,
     /* 405194 */ // Label 8589: @405194
     /* 405194 */ GIM_Reject,
     /* 405195 */ // Label 8561: @405195
     /* 405195 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(405220), // Rule ID 8854 //
     /* 405200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 405206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 405209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405213 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 405213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 405218 */   GIR_RootConstrainSelectedInstOperands,
     /* 405219 */   // GIR_Coverage, 8854,
     /* 405219 */   GIR_Done,
     /* 405220 */ // Label 8592: @405220
     /* 405220 */ GIM_Reject,
     /* 405221 */ // Label 8562: @405221
     /* 405221 */ GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(405246), // Rule ID 8808 //
     /* 405226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 405232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 405235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405239 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 405239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 405244 */   GIR_RootConstrainSelectedInstOperands,
     /* 405245 */   // GIR_Coverage, 8808,
     /* 405245 */   GIR_Done,
     /* 405246 */ // Label 8593: @405246
     /* 405246 */ GIM_Reject,
     /* 405247 */ // Label 8563: @405247
     /* 405247 */ GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(405293),
     /* 405252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 405255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 405258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405262 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(405277), // Rule ID 8805 //
     /* 405267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405270 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 405270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 405275 */     GIR_RootConstrainSelectedInstOperands,
     /* 405276 */     // GIR_Coverage, 8805,
     /* 405276 */     GIR_Done,
     /* 405277 */   // Label 8595: @405277
     /* 405277 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(405292), // Rule ID 8809 //
     /* 405282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405285 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 405285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 405290 */     GIR_RootConstrainSelectedInstOperands,
     /* 405291 */     // GIR_Coverage, 8809,
     /* 405291 */     GIR_Done,
     /* 405292 */   // Label 8596: @405292
     /* 405292 */   GIM_Reject,
     /* 405293 */ // Label 8594: @405293
     /* 405293 */ GIM_Reject,
     /* 405294 */ // Label 8564: @405294
     /* 405294 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(405319), // Rule ID 8853 //
     /* 405299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 405305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 405308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405312 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 405312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 405317 */   GIR_RootConstrainSelectedInstOperands,
     /* 405318 */   // GIR_Coverage, 8853,
     /* 405318 */   GIR_Done,
     /* 405319 */ // Label 8597: @405319
     /* 405319 */ GIM_Reject,
     /* 405320 */ // Label 8565: @405320
     /* 405320 */ GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(405366),
     /* 405325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 405328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 405331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405335 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(405350), // Rule ID 8804 //
     /* 405340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405343 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 405343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 405348 */     GIR_RootConstrainSelectedInstOperands,
     /* 405349 */     // GIR_Coverage, 8804,
     /* 405349 */     GIR_Done,
     /* 405350 */   // Label 8599: @405350
     /* 405350 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(405365), // Rule ID 8807 //
     /* 405355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405358 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 405358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 405363 */     GIR_RootConstrainSelectedInstOperands,
     /* 405364 */     // GIR_Coverage, 8807,
     /* 405364 */     GIR_Done,
     /* 405365 */   // Label 8600: @405365
     /* 405365 */   GIM_Reject,
     /* 405366 */ // Label 8598: @405366
     /* 405366 */ GIM_Reject,
     /* 405367 */ // Label 8566: @405367
     /* 405367 */ GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(405392), // Rule ID 2393 //
     /* 405372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 405378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 405381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405385 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 405385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 405390 */   GIR_RootConstrainSelectedInstOperands,
     /* 405391 */   // GIR_Coverage, 2393,
     /* 405391 */   GIR_Done,
     /* 405392 */ // Label 8601: @405392
     /* 405392 */ GIM_Reject,
     /* 405393 */ // Label 8567: @405393
     /* 405393 */ GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(405418), // Rule ID 8803 //
     /* 405398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 405404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 405407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405411 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 405411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 405416 */   GIR_RootConstrainSelectedInstOperands,
     /* 405417 */   // GIR_Coverage, 8803,
     /* 405417 */   GIR_Done,
     /* 405418 */ // Label 8602: @405418
     /* 405418 */ GIM_Reject,
     /* 405419 */ // Label 8568: @405419
     /* 405419 */ GIM_Reject,
     /* 405420 */ // Label 157: @405420
     /* 405420 */ GIM_Reject,
     /* 405421 */ }; // Size: 405421 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
